""" Contains all the data models used in inputs/outputs """

from .address import Address
from .address_create import AddressCreate
from .address_create_data import AddressCreateData
from .address_create_data_attributes import AddressCreateDataAttributes
from .address_create_data_attributes_metadata import AddressCreateDataAttributesMetadata
from .address_create_data_relationships import AddressCreateDataRelationships
from .address_create_data_relationships_geocoder import AddressCreateDataRelationshipsGeocoder
from .address_create_data_relationships_geocoder_data import AddressCreateDataRelationshipsGeocoderData
from .address_create_data_relationships_geocoder_data_type import AddressCreateDataRelationshipsGeocoderDataType
from .address_create_data_type import AddressCreateDataType
from .address_data import AddressData
from .address_data_attributes import AddressDataAttributes
from .address_data_attributes_metadata import AddressDataAttributesMetadata
from .address_data_relationships import AddressDataRelationships
from .address_data_relationships_geocoder import AddressDataRelationshipsGeocoder
from .address_data_relationships_geocoder_data import AddressDataRelationshipsGeocoderData
from .address_data_relationships_geocoder_data_type import AddressDataRelationshipsGeocoderDataType
from .address_data_type import AddressDataType
from .address_update import AddressUpdate
from .address_update_data import AddressUpdateData
from .address_update_data_attributes import AddressUpdateDataAttributes
from .address_update_data_attributes_metadata import AddressUpdateDataAttributesMetadata
from .address_update_data_relationships import AddressUpdateDataRelationships
from .address_update_data_relationships_geocoder import AddressUpdateDataRelationshipsGeocoder
from .address_update_data_relationships_geocoder_data import AddressUpdateDataRelationshipsGeocoderData
from .address_update_data_relationships_geocoder_data_type import AddressUpdateDataRelationshipsGeocoderDataType
from .address_update_data_type import AddressUpdateDataType
from .adjustment import Adjustment
from .adjustment_create import AdjustmentCreate
from .adjustment_create_data import AdjustmentCreateData
from .adjustment_create_data_attributes import AdjustmentCreateDataAttributes
from .adjustment_create_data_attributes_metadata import AdjustmentCreateDataAttributesMetadata
from .adjustment_create_data_relationships import AdjustmentCreateDataRelationships
from .adjustment_create_data_type import AdjustmentCreateDataType
from .adjustment_data import AdjustmentData
from .adjustment_data_attributes import AdjustmentDataAttributes
from .adjustment_data_attributes_metadata import AdjustmentDataAttributesMetadata
from .adjustment_data_relationships import AdjustmentDataRelationships
from .adjustment_data_type import AdjustmentDataType
from .adjustment_update import AdjustmentUpdate
from .adjustment_update_data import AdjustmentUpdateData
from .adjustment_update_data_attributes import AdjustmentUpdateDataAttributes
from .adjustment_update_data_attributes_metadata import AdjustmentUpdateDataAttributesMetadata
from .adjustment_update_data_relationships import AdjustmentUpdateDataRelationships
from .adjustment_update_data_type import AdjustmentUpdateDataType
from .adyen_gateway import AdyenGateway
from .adyen_gateway_create import AdyenGatewayCreate
from .adyen_gateway_create_data import AdyenGatewayCreateData
from .adyen_gateway_create_data_attributes import AdyenGatewayCreateDataAttributes
from .adyen_gateway_create_data_attributes_metadata import AdyenGatewayCreateDataAttributesMetadata
from .adyen_gateway_create_data_relationships import AdyenGatewayCreateDataRelationships
from .adyen_gateway_create_data_relationships_adyen_payments import AdyenGatewayCreateDataRelationshipsAdyenPayments
from .adyen_gateway_create_data_relationships_adyen_payments_data import (
    AdyenGatewayCreateDataRelationshipsAdyenPaymentsData,
)
from .adyen_gateway_create_data_relationships_adyen_payments_data_type import (
    AdyenGatewayCreateDataRelationshipsAdyenPaymentsDataType,
)
from .adyen_gateway_create_data_type import AdyenGatewayCreateDataType
from .adyen_gateway_data import AdyenGatewayData
from .adyen_gateway_data_attributes import AdyenGatewayDataAttributes
from .adyen_gateway_data_attributes_metadata import AdyenGatewayDataAttributesMetadata
from .adyen_gateway_data_relationships import AdyenGatewayDataRelationships
from .adyen_gateway_data_relationships_adyen_payments import AdyenGatewayDataRelationshipsAdyenPayments
from .adyen_gateway_data_relationships_adyen_payments_data import AdyenGatewayDataRelationshipsAdyenPaymentsData
from .adyen_gateway_data_relationships_adyen_payments_data_type import (
    AdyenGatewayDataRelationshipsAdyenPaymentsDataType,
)
from .adyen_gateway_data_relationships_payment_methods import AdyenGatewayDataRelationshipsPaymentMethods
from .adyen_gateway_data_relationships_payment_methods_data import AdyenGatewayDataRelationshipsPaymentMethodsData
from .adyen_gateway_data_relationships_payment_methods_data_type import (
    AdyenGatewayDataRelationshipsPaymentMethodsDataType,
)
from .adyen_gateway_data_type import AdyenGatewayDataType
from .adyen_gateway_update import AdyenGatewayUpdate
from .adyen_gateway_update_data import AdyenGatewayUpdateData
from .adyen_gateway_update_data_attributes import AdyenGatewayUpdateDataAttributes
from .adyen_gateway_update_data_attributes_metadata import AdyenGatewayUpdateDataAttributesMetadata
from .adyen_gateway_update_data_relationships import AdyenGatewayUpdateDataRelationships
from .adyen_gateway_update_data_relationships_adyen_payments import AdyenGatewayUpdateDataRelationshipsAdyenPayments
from .adyen_gateway_update_data_relationships_adyen_payments_data import (
    AdyenGatewayUpdateDataRelationshipsAdyenPaymentsData,
)
from .adyen_gateway_update_data_relationships_adyen_payments_data_type import (
    AdyenGatewayUpdateDataRelationshipsAdyenPaymentsDataType,
)
from .adyen_gateway_update_data_type import AdyenGatewayUpdateDataType
from .adyen_payment import AdyenPayment
from .adyen_payment_create import AdyenPaymentCreate
from .adyen_payment_create_data import AdyenPaymentCreateData
from .adyen_payment_create_data_attributes import AdyenPaymentCreateDataAttributes
from .adyen_payment_create_data_attributes_metadata import AdyenPaymentCreateDataAttributesMetadata
from .adyen_payment_create_data_relationships import AdyenPaymentCreateDataRelationships
from .adyen_payment_create_data_relationships_order import AdyenPaymentCreateDataRelationshipsOrder
from .adyen_payment_create_data_relationships_order_data import AdyenPaymentCreateDataRelationshipsOrderData
from .adyen_payment_create_data_relationships_order_data_type import AdyenPaymentCreateDataRelationshipsOrderDataType
from .adyen_payment_create_data_type import AdyenPaymentCreateDataType
from .adyen_payment_data import AdyenPaymentData
from .adyen_payment_data_attributes import AdyenPaymentDataAttributes
from .adyen_payment_data_attributes_metadata import AdyenPaymentDataAttributesMetadata
from .adyen_payment_data_attributes_payment_methods import AdyenPaymentDataAttributesPaymentMethods
from .adyen_payment_data_attributes_payment_request_data import AdyenPaymentDataAttributesPaymentRequestData
from .adyen_payment_data_attributes_payment_request_details import AdyenPaymentDataAttributesPaymentRequestDetails
from .adyen_payment_data_attributes_payment_response import AdyenPaymentDataAttributesPaymentResponse
from .adyen_payment_data_relationships import AdyenPaymentDataRelationships
from .adyen_payment_data_relationships_order import AdyenPaymentDataRelationshipsOrder
from .adyen_payment_data_relationships_order_data import AdyenPaymentDataRelationshipsOrderData
from .adyen_payment_data_relationships_order_data_type import AdyenPaymentDataRelationshipsOrderDataType
from .adyen_payment_data_relationships_payment_gateway import AdyenPaymentDataRelationshipsPaymentGateway
from .adyen_payment_data_relationships_payment_gateway_data import AdyenPaymentDataRelationshipsPaymentGatewayData
from .adyen_payment_data_relationships_payment_gateway_data_type import (
    AdyenPaymentDataRelationshipsPaymentGatewayDataType,
)
from .adyen_payment_data_type import AdyenPaymentDataType
from .adyen_payment_update import AdyenPaymentUpdate
from .adyen_payment_update_data import AdyenPaymentUpdateData
from .adyen_payment_update_data_attributes import AdyenPaymentUpdateDataAttributes
from .adyen_payment_update_data_attributes_metadata import AdyenPaymentUpdateDataAttributesMetadata
from .adyen_payment_update_data_attributes_payment_request_data import (
    AdyenPaymentUpdateDataAttributesPaymentRequestData,
)
from .adyen_payment_update_data_attributes_payment_request_details import (
    AdyenPaymentUpdateDataAttributesPaymentRequestDetails,
)
from .adyen_payment_update_data_attributes_payment_response import AdyenPaymentUpdateDataAttributesPaymentResponse
from .adyen_payment_update_data_relationships import AdyenPaymentUpdateDataRelationships
from .adyen_payment_update_data_relationships_order import AdyenPaymentUpdateDataRelationshipsOrder
from .adyen_payment_update_data_relationships_order_data import AdyenPaymentUpdateDataRelationshipsOrderData
from .adyen_payment_update_data_relationships_order_data_type import AdyenPaymentUpdateDataRelationshipsOrderDataType
from .adyen_payment_update_data_type import AdyenPaymentUpdateDataType
from .application import Application
from .application_data import ApplicationData
from .application_data_attributes import ApplicationDataAttributes
from .application_data_attributes_metadata import ApplicationDataAttributesMetadata
from .application_data_relationships import ApplicationDataRelationships
from .application_data_type import ApplicationDataType
from .attachment import Attachment
from .attachment_create import AttachmentCreate
from .attachment_create_data import AttachmentCreateData
from .attachment_create_data_attributes import AttachmentCreateDataAttributes
from .attachment_create_data_attributes_metadata import AttachmentCreateDataAttributesMetadata
from .attachment_create_data_relationships import AttachmentCreateDataRelationships
from .attachment_create_data_type import AttachmentCreateDataType
from .attachment_data import AttachmentData
from .attachment_data_attributes import AttachmentDataAttributes
from .attachment_data_attributes_metadata import AttachmentDataAttributesMetadata
from .attachment_data_relationships import AttachmentDataRelationships
from .attachment_data_type import AttachmentDataType
from .attachment_update import AttachmentUpdate
from .attachment_update_data import AttachmentUpdateData
from .attachment_update_data_attributes import AttachmentUpdateDataAttributes
from .attachment_update_data_attributes_metadata import AttachmentUpdateDataAttributesMetadata
from .attachment_update_data_relationships import AttachmentUpdateDataRelationships
from .attachment_update_data_type import AttachmentUpdateDataType
from .authorization import Authorization
from .authorization_data import AuthorizationData
from .authorization_data_attributes import AuthorizationDataAttributes
from .authorization_data_attributes_metadata import AuthorizationDataAttributesMetadata
from .authorization_data_relationships import AuthorizationDataRelationships
from .authorization_data_relationships_captures import AuthorizationDataRelationshipsCaptures
from .authorization_data_relationships_captures_data import AuthorizationDataRelationshipsCapturesData
from .authorization_data_relationships_captures_data_type import AuthorizationDataRelationshipsCapturesDataType
from .authorization_data_relationships_order import AuthorizationDataRelationshipsOrder
from .authorization_data_relationships_order_data import AuthorizationDataRelationshipsOrderData
from .authorization_data_relationships_order_data_type import AuthorizationDataRelationshipsOrderDataType
from .authorization_data_relationships_voids import AuthorizationDataRelationshipsVoids
from .authorization_data_relationships_voids_data import AuthorizationDataRelationshipsVoidsData
from .authorization_data_relationships_voids_data_type import AuthorizationDataRelationshipsVoidsDataType
from .authorization_data_type import AuthorizationDataType
from .authorization_update import AuthorizationUpdate
from .authorization_update_data import AuthorizationUpdateData
from .authorization_update_data_attributes import AuthorizationUpdateDataAttributes
from .authorization_update_data_attributes_metadata import AuthorizationUpdateDataAttributesMetadata
from .authorization_update_data_relationships import AuthorizationUpdateDataRelationships
from .authorization_update_data_type import AuthorizationUpdateDataType
from .avalara_account import AvalaraAccount
from .avalara_account_create import AvalaraAccountCreate
from .avalara_account_create_data import AvalaraAccountCreateData
from .avalara_account_create_data_attributes import AvalaraAccountCreateDataAttributes
from .avalara_account_create_data_attributes_metadata import AvalaraAccountCreateDataAttributesMetadata
from .avalara_account_create_data_relationships import AvalaraAccountCreateDataRelationships
from .avalara_account_create_data_relationships_tax_categories import AvalaraAccountCreateDataRelationshipsTaxCategories
from .avalara_account_create_data_relationships_tax_categories_data import (
    AvalaraAccountCreateDataRelationshipsTaxCategoriesData,
)
from .avalara_account_create_data_relationships_tax_categories_data_type import (
    AvalaraAccountCreateDataRelationshipsTaxCategoriesDataType,
)
from .avalara_account_create_data_type import AvalaraAccountCreateDataType
from .avalara_account_data import AvalaraAccountData
from .avalara_account_data_attributes import AvalaraAccountDataAttributes
from .avalara_account_data_attributes_metadata import AvalaraAccountDataAttributesMetadata
from .avalara_account_data_relationships import AvalaraAccountDataRelationships
from .avalara_account_data_relationships_attachments import AvalaraAccountDataRelationshipsAttachments
from .avalara_account_data_relationships_attachments_data import AvalaraAccountDataRelationshipsAttachmentsData
from .avalara_account_data_relationships_attachments_data_type import AvalaraAccountDataRelationshipsAttachmentsDataType
from .avalara_account_data_relationships_markets import AvalaraAccountDataRelationshipsMarkets
from .avalara_account_data_relationships_markets_data import AvalaraAccountDataRelationshipsMarketsData
from .avalara_account_data_relationships_markets_data_type import AvalaraAccountDataRelationshipsMarketsDataType
from .avalara_account_data_relationships_tax_categories import AvalaraAccountDataRelationshipsTaxCategories
from .avalara_account_data_relationships_tax_categories_data import AvalaraAccountDataRelationshipsTaxCategoriesData
from .avalara_account_data_relationships_tax_categories_data_type import (
    AvalaraAccountDataRelationshipsTaxCategoriesDataType,
)
from .avalara_account_data_type import AvalaraAccountDataType
from .avalara_account_update import AvalaraAccountUpdate
from .avalara_account_update_data import AvalaraAccountUpdateData
from .avalara_account_update_data_attributes import AvalaraAccountUpdateDataAttributes
from .avalara_account_update_data_attributes_metadata import AvalaraAccountUpdateDataAttributesMetadata
from .avalara_account_update_data_relationships import AvalaraAccountUpdateDataRelationships
from .avalara_account_update_data_relationships_tax_categories import AvalaraAccountUpdateDataRelationshipsTaxCategories
from .avalara_account_update_data_relationships_tax_categories_data import (
    AvalaraAccountUpdateDataRelationshipsTaxCategoriesData,
)
from .avalara_account_update_data_relationships_tax_categories_data_type import (
    AvalaraAccountUpdateDataRelationshipsTaxCategoriesDataType,
)
from .avalara_account_update_data_type import AvalaraAccountUpdateDataType
from .billing_info_validation_rule import BillingInfoValidationRule
from .billing_info_validation_rule_create import BillingInfoValidationRuleCreate
from .billing_info_validation_rule_create_data import BillingInfoValidationRuleCreateData
from .billing_info_validation_rule_create_data_attributes import BillingInfoValidationRuleCreateDataAttributes
from .billing_info_validation_rule_create_data_attributes_metadata import (
    BillingInfoValidationRuleCreateDataAttributesMetadata,
)
from .billing_info_validation_rule_create_data_relationships import BillingInfoValidationRuleCreateDataRelationships
from .billing_info_validation_rule_create_data_relationships_market import (
    BillingInfoValidationRuleCreateDataRelationshipsMarket,
)
from .billing_info_validation_rule_create_data_relationships_market_data import (
    BillingInfoValidationRuleCreateDataRelationshipsMarketData,
)
from .billing_info_validation_rule_create_data_relationships_market_data_type import (
    BillingInfoValidationRuleCreateDataRelationshipsMarketDataType,
)
from .billing_info_validation_rule_create_data_type import BillingInfoValidationRuleCreateDataType
from .billing_info_validation_rule_data import BillingInfoValidationRuleData
from .billing_info_validation_rule_data_attributes import BillingInfoValidationRuleDataAttributes
from .billing_info_validation_rule_data_attributes_metadata import BillingInfoValidationRuleDataAttributesMetadata
from .billing_info_validation_rule_data_relationships import BillingInfoValidationRuleDataRelationships
from .billing_info_validation_rule_data_relationships_market import BillingInfoValidationRuleDataRelationshipsMarket
from .billing_info_validation_rule_data_relationships_market_data import (
    BillingInfoValidationRuleDataRelationshipsMarketData,
)
from .billing_info_validation_rule_data_relationships_market_data_type import (
    BillingInfoValidationRuleDataRelationshipsMarketDataType,
)
from .billing_info_validation_rule_data_type import BillingInfoValidationRuleDataType
from .billing_info_validation_rule_update import BillingInfoValidationRuleUpdate
from .billing_info_validation_rule_update_data import BillingInfoValidationRuleUpdateData
from .billing_info_validation_rule_update_data_attributes import BillingInfoValidationRuleUpdateDataAttributes
from .billing_info_validation_rule_update_data_attributes_metadata import (
    BillingInfoValidationRuleUpdateDataAttributesMetadata,
)
from .billing_info_validation_rule_update_data_relationships import BillingInfoValidationRuleUpdateDataRelationships
from .billing_info_validation_rule_update_data_relationships_market import (
    BillingInfoValidationRuleUpdateDataRelationshipsMarket,
)
from .billing_info_validation_rule_update_data_relationships_market_data import (
    BillingInfoValidationRuleUpdateDataRelationshipsMarketData,
)
from .billing_info_validation_rule_update_data_relationships_market_data_type import (
    BillingInfoValidationRuleUpdateDataRelationshipsMarketDataType,
)
from .billing_info_validation_rule_update_data_type import BillingInfoValidationRuleUpdateDataType
from .bing_geocoder import BingGeocoder
from .bing_geocoder_create import BingGeocoderCreate
from .bing_geocoder_create_data import BingGeocoderCreateData
from .bing_geocoder_create_data_attributes import BingGeocoderCreateDataAttributes
from .bing_geocoder_create_data_attributes_metadata import BingGeocoderCreateDataAttributesMetadata
from .bing_geocoder_create_data_relationships import BingGeocoderCreateDataRelationships
from .bing_geocoder_create_data_type import BingGeocoderCreateDataType
from .bing_geocoder_data import BingGeocoderData
from .bing_geocoder_data_attributes import BingGeocoderDataAttributes
from .bing_geocoder_data_attributes_metadata import BingGeocoderDataAttributesMetadata
from .bing_geocoder_data_relationships import BingGeocoderDataRelationships
from .bing_geocoder_data_relationships_addresses import BingGeocoderDataRelationshipsAddresses
from .bing_geocoder_data_relationships_addresses_data import BingGeocoderDataRelationshipsAddressesData
from .bing_geocoder_data_relationships_addresses_data_type import BingGeocoderDataRelationshipsAddressesDataType
from .bing_geocoder_data_relationships_attachments import BingGeocoderDataRelationshipsAttachments
from .bing_geocoder_data_relationships_attachments_data import BingGeocoderDataRelationshipsAttachmentsData
from .bing_geocoder_data_relationships_attachments_data_type import BingGeocoderDataRelationshipsAttachmentsDataType
from .bing_geocoder_data_type import BingGeocoderDataType
from .bing_geocoder_update import BingGeocoderUpdate
from .bing_geocoder_update_data import BingGeocoderUpdateData
from .bing_geocoder_update_data_attributes import BingGeocoderUpdateDataAttributes
from .bing_geocoder_update_data_attributes_metadata import BingGeocoderUpdateDataAttributesMetadata
from .bing_geocoder_update_data_relationships import BingGeocoderUpdateDataRelationships
from .bing_geocoder_update_data_type import BingGeocoderUpdateDataType
from .braintree_gateway import BraintreeGateway
from .braintree_gateway_create import BraintreeGatewayCreate
from .braintree_gateway_create_data import BraintreeGatewayCreateData
from .braintree_gateway_create_data_attributes import BraintreeGatewayCreateDataAttributes
from .braintree_gateway_create_data_attributes_metadata import BraintreeGatewayCreateDataAttributesMetadata
from .braintree_gateway_create_data_relationships import BraintreeGatewayCreateDataRelationships
from .braintree_gateway_create_data_relationships_braintree_payments import (
    BraintreeGatewayCreateDataRelationshipsBraintreePayments,
)
from .braintree_gateway_create_data_relationships_braintree_payments_data import (
    BraintreeGatewayCreateDataRelationshipsBraintreePaymentsData,
)
from .braintree_gateway_create_data_relationships_braintree_payments_data_type import (
    BraintreeGatewayCreateDataRelationshipsBraintreePaymentsDataType,
)
from .braintree_gateway_create_data_type import BraintreeGatewayCreateDataType
from .braintree_gateway_data import BraintreeGatewayData
from .braintree_gateway_data_attributes import BraintreeGatewayDataAttributes
from .braintree_gateway_data_attributes_metadata import BraintreeGatewayDataAttributesMetadata
from .braintree_gateway_data_relationships import BraintreeGatewayDataRelationships
from .braintree_gateway_data_relationships_braintree_payments import BraintreeGatewayDataRelationshipsBraintreePayments
from .braintree_gateway_data_relationships_braintree_payments_data import (
    BraintreeGatewayDataRelationshipsBraintreePaymentsData,
)
from .braintree_gateway_data_relationships_braintree_payments_data_type import (
    BraintreeGatewayDataRelationshipsBraintreePaymentsDataType,
)
from .braintree_gateway_data_relationships_payment_methods import BraintreeGatewayDataRelationshipsPaymentMethods
from .braintree_gateway_data_relationships_payment_methods_data import (
    BraintreeGatewayDataRelationshipsPaymentMethodsData,
)
from .braintree_gateway_data_relationships_payment_methods_data_type import (
    BraintreeGatewayDataRelationshipsPaymentMethodsDataType,
)
from .braintree_gateway_data_type import BraintreeGatewayDataType
from .braintree_gateway_update import BraintreeGatewayUpdate
from .braintree_gateway_update_data import BraintreeGatewayUpdateData
from .braintree_gateway_update_data_attributes import BraintreeGatewayUpdateDataAttributes
from .braintree_gateway_update_data_attributes_metadata import BraintreeGatewayUpdateDataAttributesMetadata
from .braintree_gateway_update_data_relationships import BraintreeGatewayUpdateDataRelationships
from .braintree_gateway_update_data_relationships_braintree_payments import (
    BraintreeGatewayUpdateDataRelationshipsBraintreePayments,
)
from .braintree_gateway_update_data_relationships_braintree_payments_data import (
    BraintreeGatewayUpdateDataRelationshipsBraintreePaymentsData,
)
from .braintree_gateway_update_data_relationships_braintree_payments_data_type import (
    BraintreeGatewayUpdateDataRelationshipsBraintreePaymentsDataType,
)
from .braintree_gateway_update_data_type import BraintreeGatewayUpdateDataType
from .braintree_payment import BraintreePayment
from .braintree_payment_create import BraintreePaymentCreate
from .braintree_payment_create_data import BraintreePaymentCreateData
from .braintree_payment_create_data_attributes import BraintreePaymentCreateDataAttributes
from .braintree_payment_create_data_attributes_metadata import BraintreePaymentCreateDataAttributesMetadata
from .braintree_payment_create_data_attributes_options import BraintreePaymentCreateDataAttributesOptions
from .braintree_payment_create_data_relationships import BraintreePaymentCreateDataRelationships
from .braintree_payment_create_data_relationships_order import BraintreePaymentCreateDataRelationshipsOrder
from .braintree_payment_create_data_relationships_order_data import BraintreePaymentCreateDataRelationshipsOrderData
from .braintree_payment_create_data_relationships_order_data_type import (
    BraintreePaymentCreateDataRelationshipsOrderDataType,
)
from .braintree_payment_create_data_type import BraintreePaymentCreateDataType
from .braintree_payment_data import BraintreePaymentData
from .braintree_payment_data_attributes import BraintreePaymentDataAttributes
from .braintree_payment_data_attributes_metadata import BraintreePaymentDataAttributesMetadata
from .braintree_payment_data_attributes_options import BraintreePaymentDataAttributesOptions
from .braintree_payment_data_relationships import BraintreePaymentDataRelationships
from .braintree_payment_data_relationships_order import BraintreePaymentDataRelationshipsOrder
from .braintree_payment_data_relationships_order_data import BraintreePaymentDataRelationshipsOrderData
from .braintree_payment_data_relationships_order_data_type import BraintreePaymentDataRelationshipsOrderDataType
from .braintree_payment_data_relationships_payment_gateway import BraintreePaymentDataRelationshipsPaymentGateway
from .braintree_payment_data_relationships_payment_gateway_data import (
    BraintreePaymentDataRelationshipsPaymentGatewayData,
)
from .braintree_payment_data_relationships_payment_gateway_data_type import (
    BraintreePaymentDataRelationshipsPaymentGatewayDataType,
)
from .braintree_payment_data_type import BraintreePaymentDataType
from .braintree_payment_update import BraintreePaymentUpdate
from .braintree_payment_update_data import BraintreePaymentUpdateData
from .braintree_payment_update_data_attributes import BraintreePaymentUpdateDataAttributes
from .braintree_payment_update_data_attributes_metadata import BraintreePaymentUpdateDataAttributesMetadata
from .braintree_payment_update_data_attributes_options import BraintreePaymentUpdateDataAttributesOptions
from .braintree_payment_update_data_relationships import BraintreePaymentUpdateDataRelationships
from .braintree_payment_update_data_relationships_order import BraintreePaymentUpdateDataRelationshipsOrder
from .braintree_payment_update_data_relationships_order_data import BraintreePaymentUpdateDataRelationshipsOrderData
from .braintree_payment_update_data_relationships_order_data_type import (
    BraintreePaymentUpdateDataRelationshipsOrderDataType,
)
from .braintree_payment_update_data_type import BraintreePaymentUpdateDataType
from .bundle import Bundle
from .bundle_create import BundleCreate
from .bundle_create_data import BundleCreateData
from .bundle_create_data_attributes import BundleCreateDataAttributes
from .bundle_create_data_attributes_metadata import BundleCreateDataAttributesMetadata
from .bundle_create_data_relationships import BundleCreateDataRelationships
from .bundle_create_data_relationships_market import BundleCreateDataRelationshipsMarket
from .bundle_create_data_relationships_market_data import BundleCreateDataRelationshipsMarketData
from .bundle_create_data_relationships_market_data_type import BundleCreateDataRelationshipsMarketDataType
from .bundle_create_data_relationships_sku_list import BundleCreateDataRelationshipsSkuList
from .bundle_create_data_relationships_sku_list_data import BundleCreateDataRelationshipsSkuListData
from .bundle_create_data_relationships_sku_list_data_type import BundleCreateDataRelationshipsSkuListDataType
from .bundle_create_data_type import BundleCreateDataType
from .bundle_data import BundleData
from .bundle_data_attributes import BundleDataAttributes
from .bundle_data_attributes_metadata import BundleDataAttributesMetadata
from .bundle_data_relationships import BundleDataRelationships
from .bundle_data_relationships_attachments import BundleDataRelationshipsAttachments
from .bundle_data_relationships_attachments_data import BundleDataRelationshipsAttachmentsData
from .bundle_data_relationships_attachments_data_type import BundleDataRelationshipsAttachmentsDataType
from .bundle_data_relationships_market import BundleDataRelationshipsMarket
from .bundle_data_relationships_market_data import BundleDataRelationshipsMarketData
from .bundle_data_relationships_market_data_type import BundleDataRelationshipsMarketDataType
from .bundle_data_relationships_sku_list import BundleDataRelationshipsSkuList
from .bundle_data_relationships_sku_list_data import BundleDataRelationshipsSkuListData
from .bundle_data_relationships_sku_list_data_type import BundleDataRelationshipsSkuListDataType
from .bundle_data_relationships_skus import BundleDataRelationshipsSkus
from .bundle_data_relationships_skus_data import BundleDataRelationshipsSkusData
from .bundle_data_relationships_skus_data_type import BundleDataRelationshipsSkusDataType
from .bundle_data_type import BundleDataType
from .bundle_update import BundleUpdate
from .bundle_update_data import BundleUpdateData
from .bundle_update_data_attributes import BundleUpdateDataAttributes
from .bundle_update_data_attributes_metadata import BundleUpdateDataAttributesMetadata
from .bundle_update_data_relationships import BundleUpdateDataRelationships
from .bundle_update_data_type import BundleUpdateDataType
from .capture import Capture
from .capture_data import CaptureData
from .capture_data_attributes import CaptureDataAttributes
from .capture_data_attributes_metadata import CaptureDataAttributesMetadata
from .capture_data_relationships import CaptureDataRelationships
from .capture_data_relationships_order import CaptureDataRelationshipsOrder
from .capture_data_relationships_order_data import CaptureDataRelationshipsOrderData
from .capture_data_relationships_order_data_type import CaptureDataRelationshipsOrderDataType
from .capture_data_relationships_reference_authorization import CaptureDataRelationshipsReferenceAuthorization
from .capture_data_relationships_reference_authorization_data import CaptureDataRelationshipsReferenceAuthorizationData
from .capture_data_relationships_reference_authorization_data_type import (
    CaptureDataRelationshipsReferenceAuthorizationDataType,
)
from .capture_data_relationships_refunds import CaptureDataRelationshipsRefunds
from .capture_data_relationships_refunds_data import CaptureDataRelationshipsRefundsData
from .capture_data_relationships_refunds_data_type import CaptureDataRelationshipsRefundsDataType
from .capture_data_type import CaptureDataType
from .capture_update import CaptureUpdate
from .capture_update_data import CaptureUpdateData
from .capture_update_data_attributes import CaptureUpdateDataAttributes
from .capture_update_data_attributes_metadata import CaptureUpdateDataAttributesMetadata
from .capture_update_data_relationships import CaptureUpdateDataRelationships
from .capture_update_data_type import CaptureUpdateDataType
from .carrier_account import CarrierAccount
from .carrier_account_data import CarrierAccountData
from .carrier_account_data_attributes import CarrierAccountDataAttributes
from .carrier_account_data_attributes_metadata import CarrierAccountDataAttributesMetadata
from .carrier_account_data_relationships import CarrierAccountDataRelationships
from .carrier_account_data_relationships_attachments import CarrierAccountDataRelationshipsAttachments
from .carrier_account_data_relationships_attachments_data import CarrierAccountDataRelationshipsAttachmentsData
from .carrier_account_data_relationships_attachments_data_type import CarrierAccountDataRelationshipsAttachmentsDataType
from .carrier_account_data_relationships_market import CarrierAccountDataRelationshipsMarket
from .carrier_account_data_relationships_market_data import CarrierAccountDataRelationshipsMarketData
from .carrier_account_data_relationships_market_data_type import CarrierAccountDataRelationshipsMarketDataType
from .carrier_account_data_type import CarrierAccountDataType
from .checkout_com_gateway import CheckoutComGateway
from .checkout_com_gateway_create import CheckoutComGatewayCreate
from .checkout_com_gateway_create_data import CheckoutComGatewayCreateData
from .checkout_com_gateway_create_data_attributes import CheckoutComGatewayCreateDataAttributes
from .checkout_com_gateway_create_data_attributes_metadata import CheckoutComGatewayCreateDataAttributesMetadata
from .checkout_com_gateway_create_data_relationships import CheckoutComGatewayCreateDataRelationships
from .checkout_com_gateway_create_data_relationships_checkout_com_payments import (
    CheckoutComGatewayCreateDataRelationshipsCheckoutComPayments,
)
from .checkout_com_gateway_create_data_relationships_checkout_com_payments_data import (
    CheckoutComGatewayCreateDataRelationshipsCheckoutComPaymentsData,
)
from .checkout_com_gateway_create_data_relationships_checkout_com_payments_data_type import (
    CheckoutComGatewayCreateDataRelationshipsCheckoutComPaymentsDataType,
)
from .checkout_com_gateway_create_data_type import CheckoutComGatewayCreateDataType
from .checkout_com_gateway_data import CheckoutComGatewayData
from .checkout_com_gateway_data_attributes import CheckoutComGatewayDataAttributes
from .checkout_com_gateway_data_attributes_metadata import CheckoutComGatewayDataAttributesMetadata
from .checkout_com_gateway_data_relationships import CheckoutComGatewayDataRelationships
from .checkout_com_gateway_data_relationships_checkout_com_payments import (
    CheckoutComGatewayDataRelationshipsCheckoutComPayments,
)
from .checkout_com_gateway_data_relationships_checkout_com_payments_data import (
    CheckoutComGatewayDataRelationshipsCheckoutComPaymentsData,
)
from .checkout_com_gateway_data_relationships_checkout_com_payments_data_type import (
    CheckoutComGatewayDataRelationshipsCheckoutComPaymentsDataType,
)
from .checkout_com_gateway_data_relationships_payment_methods import CheckoutComGatewayDataRelationshipsPaymentMethods
from .checkout_com_gateway_data_relationships_payment_methods_data import (
    CheckoutComGatewayDataRelationshipsPaymentMethodsData,
)
from .checkout_com_gateway_data_relationships_payment_methods_data_type import (
    CheckoutComGatewayDataRelationshipsPaymentMethodsDataType,
)
from .checkout_com_gateway_data_type import CheckoutComGatewayDataType
from .checkout_com_gateway_update import CheckoutComGatewayUpdate
from .checkout_com_gateway_update_data import CheckoutComGatewayUpdateData
from .checkout_com_gateway_update_data_attributes import CheckoutComGatewayUpdateDataAttributes
from .checkout_com_gateway_update_data_attributes_metadata import CheckoutComGatewayUpdateDataAttributesMetadata
from .checkout_com_gateway_update_data_relationships import CheckoutComGatewayUpdateDataRelationships
from .checkout_com_gateway_update_data_relationships_checkout_com_payments import (
    CheckoutComGatewayUpdateDataRelationshipsCheckoutComPayments,
)
from .checkout_com_gateway_update_data_relationships_checkout_com_payments_data import (
    CheckoutComGatewayUpdateDataRelationshipsCheckoutComPaymentsData,
)
from .checkout_com_gateway_update_data_relationships_checkout_com_payments_data_type import (
    CheckoutComGatewayUpdateDataRelationshipsCheckoutComPaymentsDataType,
)
from .checkout_com_gateway_update_data_type import CheckoutComGatewayUpdateDataType
from .checkout_com_payment import CheckoutComPayment
from .checkout_com_payment_create import CheckoutComPaymentCreate
from .checkout_com_payment_create_data import CheckoutComPaymentCreateData
from .checkout_com_payment_create_data_attributes import CheckoutComPaymentCreateDataAttributes
from .checkout_com_payment_create_data_attributes_metadata import CheckoutComPaymentCreateDataAttributesMetadata
from .checkout_com_payment_create_data_relationships import CheckoutComPaymentCreateDataRelationships
from .checkout_com_payment_create_data_relationships_order import CheckoutComPaymentCreateDataRelationshipsOrder
from .checkout_com_payment_create_data_relationships_order_data import (
    CheckoutComPaymentCreateDataRelationshipsOrderData,
)
from .checkout_com_payment_create_data_relationships_order_data_type import (
    CheckoutComPaymentCreateDataRelationshipsOrderDataType,
)
from .checkout_com_payment_create_data_type import CheckoutComPaymentCreateDataType
from .checkout_com_payment_data import CheckoutComPaymentData
from .checkout_com_payment_data_attributes import CheckoutComPaymentDataAttributes
from .checkout_com_payment_data_attributes_metadata import CheckoutComPaymentDataAttributesMetadata
from .checkout_com_payment_data_attributes_payment_response import CheckoutComPaymentDataAttributesPaymentResponse
from .checkout_com_payment_data_relationships import CheckoutComPaymentDataRelationships
from .checkout_com_payment_data_relationships_order import CheckoutComPaymentDataRelationshipsOrder
from .checkout_com_payment_data_relationships_order_data import CheckoutComPaymentDataRelationshipsOrderData
from .checkout_com_payment_data_relationships_order_data_type import CheckoutComPaymentDataRelationshipsOrderDataType
from .checkout_com_payment_data_relationships_payment_gateway import CheckoutComPaymentDataRelationshipsPaymentGateway
from .checkout_com_payment_data_relationships_payment_gateway_data import (
    CheckoutComPaymentDataRelationshipsPaymentGatewayData,
)
from .checkout_com_payment_data_relationships_payment_gateway_data_type import (
    CheckoutComPaymentDataRelationshipsPaymentGatewayDataType,
)
from .checkout_com_payment_data_type import CheckoutComPaymentDataType
from .checkout_com_payment_update import CheckoutComPaymentUpdate
from .checkout_com_payment_update_data import CheckoutComPaymentUpdateData
from .checkout_com_payment_update_data_attributes import CheckoutComPaymentUpdateDataAttributes
from .checkout_com_payment_update_data_attributes_metadata import CheckoutComPaymentUpdateDataAttributesMetadata
from .checkout_com_payment_update_data_relationships import CheckoutComPaymentUpdateDataRelationships
from .checkout_com_payment_update_data_relationships_order import CheckoutComPaymentUpdateDataRelationshipsOrder
from .checkout_com_payment_update_data_relationships_order_data import (
    CheckoutComPaymentUpdateDataRelationshipsOrderData,
)
from .checkout_com_payment_update_data_relationships_order_data_type import (
    CheckoutComPaymentUpdateDataRelationshipsOrderDataType,
)
from .checkout_com_payment_update_data_type import CheckoutComPaymentUpdateDataType
from .cleanup import Cleanup
from .cleanup_create import CleanupCreate
from .cleanup_create_data import CleanupCreateData
from .cleanup_create_data_attributes import CleanupCreateDataAttributes
from .cleanup_create_data_attributes_filters import CleanupCreateDataAttributesFilters
from .cleanup_create_data_attributes_metadata import CleanupCreateDataAttributesMetadata
from .cleanup_create_data_relationships import CleanupCreateDataRelationships
from .cleanup_create_data_type import CleanupCreateDataType
from .cleanup_data import CleanupData
from .cleanup_data_attributes import CleanupDataAttributes
from .cleanup_data_attributes_errors_log import CleanupDataAttributesErrorsLog
from .cleanup_data_attributes_filters import CleanupDataAttributesFilters
from .cleanup_data_attributes_metadata import CleanupDataAttributesMetadata
from .cleanup_data_relationships import CleanupDataRelationships
from .cleanup_data_relationships_events import CleanupDataRelationshipsEvents
from .cleanup_data_relationships_events_data import CleanupDataRelationshipsEventsData
from .cleanup_data_relationships_events_data_type import CleanupDataRelationshipsEventsDataType
from .cleanup_data_type import CleanupDataType
from .coupon import Coupon
from .coupon_codes_promotion_rule import CouponCodesPromotionRule
from .coupon_codes_promotion_rule_create import CouponCodesPromotionRuleCreate
from .coupon_codes_promotion_rule_create_data import CouponCodesPromotionRuleCreateData
from .coupon_codes_promotion_rule_create_data_attributes import CouponCodesPromotionRuleCreateDataAttributes
from .coupon_codes_promotion_rule_create_data_attributes_metadata import (
    CouponCodesPromotionRuleCreateDataAttributesMetadata,
)
from .coupon_codes_promotion_rule_create_data_relationships import CouponCodesPromotionRuleCreateDataRelationships
from .coupon_codes_promotion_rule_create_data_relationships_coupons import (
    CouponCodesPromotionRuleCreateDataRelationshipsCoupons,
)
from .coupon_codes_promotion_rule_create_data_relationships_coupons_data import (
    CouponCodesPromotionRuleCreateDataRelationshipsCouponsData,
)
from .coupon_codes_promotion_rule_create_data_relationships_coupons_data_type import (
    CouponCodesPromotionRuleCreateDataRelationshipsCouponsDataType,
)
from .coupon_codes_promotion_rule_create_data_type import CouponCodesPromotionRuleCreateDataType
from .coupon_codes_promotion_rule_data import CouponCodesPromotionRuleData
from .coupon_codes_promotion_rule_data_attributes import CouponCodesPromotionRuleDataAttributes
from .coupon_codes_promotion_rule_data_attributes_metadata import CouponCodesPromotionRuleDataAttributesMetadata
from .coupon_codes_promotion_rule_data_relationships import CouponCodesPromotionRuleDataRelationships
from .coupon_codes_promotion_rule_data_relationships_coupons import CouponCodesPromotionRuleDataRelationshipsCoupons
from .coupon_codes_promotion_rule_data_relationships_coupons_data import (
    CouponCodesPromotionRuleDataRelationshipsCouponsData,
)
from .coupon_codes_promotion_rule_data_relationships_coupons_data_type import (
    CouponCodesPromotionRuleDataRelationshipsCouponsDataType,
)
from .coupon_codes_promotion_rule_data_type import CouponCodesPromotionRuleDataType
from .coupon_codes_promotion_rule_update import CouponCodesPromotionRuleUpdate
from .coupon_codes_promotion_rule_update_data import CouponCodesPromotionRuleUpdateData
from .coupon_codes_promotion_rule_update_data_attributes import CouponCodesPromotionRuleUpdateDataAttributes
from .coupon_codes_promotion_rule_update_data_attributes_metadata import (
    CouponCodesPromotionRuleUpdateDataAttributesMetadata,
)
from .coupon_codes_promotion_rule_update_data_relationships import CouponCodesPromotionRuleUpdateDataRelationships
from .coupon_codes_promotion_rule_update_data_relationships_coupons import (
    CouponCodesPromotionRuleUpdateDataRelationshipsCoupons,
)
from .coupon_codes_promotion_rule_update_data_relationships_coupons_data import (
    CouponCodesPromotionRuleUpdateDataRelationshipsCouponsData,
)
from .coupon_codes_promotion_rule_update_data_relationships_coupons_data_type import (
    CouponCodesPromotionRuleUpdateDataRelationshipsCouponsDataType,
)
from .coupon_codes_promotion_rule_update_data_type import CouponCodesPromotionRuleUpdateDataType
from .coupon_create import CouponCreate
from .coupon_create_data import CouponCreateData
from .coupon_create_data_attributes import CouponCreateDataAttributes
from .coupon_create_data_attributes_metadata import CouponCreateDataAttributesMetadata
from .coupon_create_data_relationships import CouponCreateDataRelationships
from .coupon_create_data_relationships_promotion_rule import CouponCreateDataRelationshipsPromotionRule
from .coupon_create_data_relationships_promotion_rule_data import CouponCreateDataRelationshipsPromotionRuleData
from .coupon_create_data_relationships_promotion_rule_data_type import (
    CouponCreateDataRelationshipsPromotionRuleDataType,
)
from .coupon_create_data_type import CouponCreateDataType
from .coupon_data import CouponData
from .coupon_data_attributes import CouponDataAttributes
from .coupon_data_attributes_metadata import CouponDataAttributesMetadata
from .coupon_data_relationships import CouponDataRelationships
from .coupon_data_relationships_promotion_rule import CouponDataRelationshipsPromotionRule
from .coupon_data_relationships_promotion_rule_data import CouponDataRelationshipsPromotionRuleData
from .coupon_data_relationships_promotion_rule_data_type import CouponDataRelationshipsPromotionRuleDataType
from .coupon_data_type import CouponDataType
from .coupon_recipient import CouponRecipient
from .coupon_recipient_create import CouponRecipientCreate
from .coupon_recipient_create_data import CouponRecipientCreateData
from .coupon_recipient_create_data_attributes import CouponRecipientCreateDataAttributes
from .coupon_recipient_create_data_attributes_metadata import CouponRecipientCreateDataAttributesMetadata
from .coupon_recipient_create_data_relationships import CouponRecipientCreateDataRelationships
from .coupon_recipient_create_data_relationships_customer import CouponRecipientCreateDataRelationshipsCustomer
from .coupon_recipient_create_data_relationships_customer_data import CouponRecipientCreateDataRelationshipsCustomerData
from .coupon_recipient_create_data_relationships_customer_data_type import (
    CouponRecipientCreateDataRelationshipsCustomerDataType,
)
from .coupon_recipient_create_data_type import CouponRecipientCreateDataType
from .coupon_recipient_data import CouponRecipientData
from .coupon_recipient_data_attributes import CouponRecipientDataAttributes
from .coupon_recipient_data_attributes_metadata import CouponRecipientDataAttributesMetadata
from .coupon_recipient_data_relationships import CouponRecipientDataRelationships
from .coupon_recipient_data_relationships_attachments import CouponRecipientDataRelationshipsAttachments
from .coupon_recipient_data_relationships_attachments_data import CouponRecipientDataRelationshipsAttachmentsData
from .coupon_recipient_data_relationships_attachments_data_type import (
    CouponRecipientDataRelationshipsAttachmentsDataType,
)
from .coupon_recipient_data_relationships_customer import CouponRecipientDataRelationshipsCustomer
from .coupon_recipient_data_relationships_customer_data import CouponRecipientDataRelationshipsCustomerData
from .coupon_recipient_data_relationships_customer_data_type import CouponRecipientDataRelationshipsCustomerDataType
from .coupon_recipient_data_type import CouponRecipientDataType
from .coupon_recipient_update import CouponRecipientUpdate
from .coupon_recipient_update_data import CouponRecipientUpdateData
from .coupon_recipient_update_data_attributes import CouponRecipientUpdateDataAttributes
from .coupon_recipient_update_data_attributes_metadata import CouponRecipientUpdateDataAttributesMetadata
from .coupon_recipient_update_data_relationships import CouponRecipientUpdateDataRelationships
from .coupon_recipient_update_data_relationships_customer import CouponRecipientUpdateDataRelationshipsCustomer
from .coupon_recipient_update_data_relationships_customer_data import CouponRecipientUpdateDataRelationshipsCustomerData
from .coupon_recipient_update_data_relationships_customer_data_type import (
    CouponRecipientUpdateDataRelationshipsCustomerDataType,
)
from .coupon_recipient_update_data_type import CouponRecipientUpdateDataType
from .coupon_update import CouponUpdate
from .coupon_update_data import CouponUpdateData
from .coupon_update_data_attributes import CouponUpdateDataAttributes
from .coupon_update_data_attributes_metadata import CouponUpdateDataAttributesMetadata
from .coupon_update_data_relationships import CouponUpdateDataRelationships
from .coupon_update_data_relationships_promotion_rule import CouponUpdateDataRelationshipsPromotionRule
from .coupon_update_data_relationships_promotion_rule_data import CouponUpdateDataRelationshipsPromotionRuleData
from .coupon_update_data_relationships_promotion_rule_data_type import (
    CouponUpdateDataRelationshipsPromotionRuleDataType,
)
from .coupon_update_data_type import CouponUpdateDataType
from .customer import Customer
from .customer_address import CustomerAddress
from .customer_address_create import CustomerAddressCreate
from .customer_address_create_data import CustomerAddressCreateData
from .customer_address_create_data_attributes import CustomerAddressCreateDataAttributes
from .customer_address_create_data_attributes_metadata import CustomerAddressCreateDataAttributesMetadata
from .customer_address_create_data_relationships import CustomerAddressCreateDataRelationships
from .customer_address_create_data_relationships_address import CustomerAddressCreateDataRelationshipsAddress
from .customer_address_create_data_relationships_address_data import CustomerAddressCreateDataRelationshipsAddressData
from .customer_address_create_data_relationships_address_data_type import (
    CustomerAddressCreateDataRelationshipsAddressDataType,
)
from .customer_address_create_data_relationships_customer import CustomerAddressCreateDataRelationshipsCustomer
from .customer_address_create_data_relationships_customer_data import CustomerAddressCreateDataRelationshipsCustomerData
from .customer_address_create_data_relationships_customer_data_type import (
    CustomerAddressCreateDataRelationshipsCustomerDataType,
)
from .customer_address_create_data_type import CustomerAddressCreateDataType
from .customer_address_data import CustomerAddressData
from .customer_address_data_attributes import CustomerAddressDataAttributes
from .customer_address_data_attributes_metadata import CustomerAddressDataAttributesMetadata
from .customer_address_data_relationships import CustomerAddressDataRelationships
from .customer_address_data_relationships_address import CustomerAddressDataRelationshipsAddress
from .customer_address_data_relationships_address_data import CustomerAddressDataRelationshipsAddressData
from .customer_address_data_relationships_address_data_type import CustomerAddressDataRelationshipsAddressDataType
from .customer_address_data_relationships_customer import CustomerAddressDataRelationshipsCustomer
from .customer_address_data_relationships_customer_data import CustomerAddressDataRelationshipsCustomerData
from .customer_address_data_relationships_customer_data_type import CustomerAddressDataRelationshipsCustomerDataType
from .customer_address_data_relationships_events import CustomerAddressDataRelationshipsEvents
from .customer_address_data_relationships_events_data import CustomerAddressDataRelationshipsEventsData
from .customer_address_data_relationships_events_data_type import CustomerAddressDataRelationshipsEventsDataType
from .customer_address_data_type import CustomerAddressDataType
from .customer_address_update import CustomerAddressUpdate
from .customer_address_update_data import CustomerAddressUpdateData
from .customer_address_update_data_attributes import CustomerAddressUpdateDataAttributes
from .customer_address_update_data_attributes_metadata import CustomerAddressUpdateDataAttributesMetadata
from .customer_address_update_data_relationships import CustomerAddressUpdateDataRelationships
from .customer_address_update_data_relationships_address import CustomerAddressUpdateDataRelationshipsAddress
from .customer_address_update_data_relationships_address_data import CustomerAddressUpdateDataRelationshipsAddressData
from .customer_address_update_data_relationships_address_data_type import (
    CustomerAddressUpdateDataRelationshipsAddressDataType,
)
from .customer_address_update_data_relationships_customer import CustomerAddressUpdateDataRelationshipsCustomer
from .customer_address_update_data_relationships_customer_data import CustomerAddressUpdateDataRelationshipsCustomerData
from .customer_address_update_data_relationships_customer_data_type import (
    CustomerAddressUpdateDataRelationshipsCustomerDataType,
)
from .customer_address_update_data_type import CustomerAddressUpdateDataType
from .customer_create import CustomerCreate
from .customer_create_data import CustomerCreateData
from .customer_create_data_attributes import CustomerCreateDataAttributes
from .customer_create_data_attributes_metadata import CustomerCreateDataAttributesMetadata
from .customer_create_data_relationships import CustomerCreateDataRelationships
from .customer_create_data_relationships_customer_group import CustomerCreateDataRelationshipsCustomerGroup
from .customer_create_data_relationships_customer_group_data import CustomerCreateDataRelationshipsCustomerGroupData
from .customer_create_data_relationships_customer_group_data_type import (
    CustomerCreateDataRelationshipsCustomerGroupDataType,
)
from .customer_create_data_type import CustomerCreateDataType
from .customer_data import CustomerData
from .customer_data_attributes import CustomerDataAttributes
from .customer_data_attributes_metadata import CustomerDataAttributesMetadata
from .customer_data_relationships import CustomerDataRelationships
from .customer_data_relationships_attachments import CustomerDataRelationshipsAttachments
from .customer_data_relationships_attachments_data import CustomerDataRelationshipsAttachmentsData
from .customer_data_relationships_attachments_data_type import CustomerDataRelationshipsAttachmentsDataType
from .customer_data_relationships_customer_addresses import CustomerDataRelationshipsCustomerAddresses
from .customer_data_relationships_customer_addresses_data import CustomerDataRelationshipsCustomerAddressesData
from .customer_data_relationships_customer_addresses_data_type import CustomerDataRelationshipsCustomerAddressesDataType
from .customer_data_relationships_customer_group import CustomerDataRelationshipsCustomerGroup
from .customer_data_relationships_customer_group_data import CustomerDataRelationshipsCustomerGroupData
from .customer_data_relationships_customer_group_data_type import CustomerDataRelationshipsCustomerGroupDataType
from .customer_data_relationships_customer_payment_sources import CustomerDataRelationshipsCustomerPaymentSources
from .customer_data_relationships_customer_payment_sources_data import (
    CustomerDataRelationshipsCustomerPaymentSourcesData,
)
from .customer_data_relationships_customer_payment_sources_data_type import (
    CustomerDataRelationshipsCustomerPaymentSourcesDataType,
)
from .customer_data_relationships_customer_subscriptions import CustomerDataRelationshipsCustomerSubscriptions
from .customer_data_relationships_customer_subscriptions_data import CustomerDataRelationshipsCustomerSubscriptionsData
from .customer_data_relationships_customer_subscriptions_data_type import (
    CustomerDataRelationshipsCustomerSubscriptionsDataType,
)
from .customer_data_relationships_events import CustomerDataRelationshipsEvents
from .customer_data_relationships_events_data import CustomerDataRelationshipsEventsData
from .customer_data_relationships_events_data_type import CustomerDataRelationshipsEventsDataType
from .customer_data_relationships_order_subscriptions import CustomerDataRelationshipsOrderSubscriptions
from .customer_data_relationships_order_subscriptions_data import CustomerDataRelationshipsOrderSubscriptionsData
from .customer_data_relationships_order_subscriptions_data_type import (
    CustomerDataRelationshipsOrderSubscriptionsDataType,
)
from .customer_data_relationships_orders import CustomerDataRelationshipsOrders
from .customer_data_relationships_orders_data import CustomerDataRelationshipsOrdersData
from .customer_data_relationships_orders_data_type import CustomerDataRelationshipsOrdersDataType
from .customer_data_relationships_returns import CustomerDataRelationshipsReturns
from .customer_data_relationships_returns_data import CustomerDataRelationshipsReturnsData
from .customer_data_relationships_returns_data_type import CustomerDataRelationshipsReturnsDataType
from .customer_data_relationships_sku_lists import CustomerDataRelationshipsSkuLists
from .customer_data_relationships_sku_lists_data import CustomerDataRelationshipsSkuListsData
from .customer_data_relationships_sku_lists_data_type import CustomerDataRelationshipsSkuListsDataType
from .customer_data_type import CustomerDataType
from .customer_group import CustomerGroup
from .customer_group_create import CustomerGroupCreate
from .customer_group_create_data import CustomerGroupCreateData
from .customer_group_create_data_attributes import CustomerGroupCreateDataAttributes
from .customer_group_create_data_attributes_metadata import CustomerGroupCreateDataAttributesMetadata
from .customer_group_create_data_relationships import CustomerGroupCreateDataRelationships
from .customer_group_create_data_type import CustomerGroupCreateDataType
from .customer_group_data import CustomerGroupData
from .customer_group_data_attributes import CustomerGroupDataAttributes
from .customer_group_data_attributes_metadata import CustomerGroupDataAttributesMetadata
from .customer_group_data_relationships import CustomerGroupDataRelationships
from .customer_group_data_relationships_attachments import CustomerGroupDataRelationshipsAttachments
from .customer_group_data_relationships_attachments_data import CustomerGroupDataRelationshipsAttachmentsData
from .customer_group_data_relationships_attachments_data_type import CustomerGroupDataRelationshipsAttachmentsDataType
from .customer_group_data_relationships_customers import CustomerGroupDataRelationshipsCustomers
from .customer_group_data_relationships_customers_data import CustomerGroupDataRelationshipsCustomersData
from .customer_group_data_relationships_customers_data_type import CustomerGroupDataRelationshipsCustomersDataType
from .customer_group_data_relationships_markets import CustomerGroupDataRelationshipsMarkets
from .customer_group_data_relationships_markets_data import CustomerGroupDataRelationshipsMarketsData
from .customer_group_data_relationships_markets_data_type import CustomerGroupDataRelationshipsMarketsDataType
from .customer_group_data_type import CustomerGroupDataType
from .customer_group_update import CustomerGroupUpdate
from .customer_group_update_data import CustomerGroupUpdateData
from .customer_group_update_data_attributes import CustomerGroupUpdateDataAttributes
from .customer_group_update_data_attributes_metadata import CustomerGroupUpdateDataAttributesMetadata
from .customer_group_update_data_relationships import CustomerGroupUpdateDataRelationships
from .customer_group_update_data_type import CustomerGroupUpdateDataType
from .customer_password_reset import CustomerPasswordReset
from .customer_password_reset_create import CustomerPasswordResetCreate
from .customer_password_reset_create_data import CustomerPasswordResetCreateData
from .customer_password_reset_create_data_attributes import CustomerPasswordResetCreateDataAttributes
from .customer_password_reset_create_data_attributes_metadata import CustomerPasswordResetCreateDataAttributesMetadata
from .customer_password_reset_create_data_relationships import CustomerPasswordResetCreateDataRelationships
from .customer_password_reset_create_data_type import CustomerPasswordResetCreateDataType
from .customer_password_reset_data import CustomerPasswordResetData
from .customer_password_reset_data_attributes import CustomerPasswordResetDataAttributes
from .customer_password_reset_data_attributes_metadata import CustomerPasswordResetDataAttributesMetadata
from .customer_password_reset_data_relationships import CustomerPasswordResetDataRelationships
from .customer_password_reset_data_relationships_customer import CustomerPasswordResetDataRelationshipsCustomer
from .customer_password_reset_data_relationships_customer_data import CustomerPasswordResetDataRelationshipsCustomerData
from .customer_password_reset_data_relationships_customer_data_type import (
    CustomerPasswordResetDataRelationshipsCustomerDataType,
)
from .customer_password_reset_data_relationships_events import CustomerPasswordResetDataRelationshipsEvents
from .customer_password_reset_data_relationships_events_data import CustomerPasswordResetDataRelationshipsEventsData
from .customer_password_reset_data_relationships_events_data_type import (
    CustomerPasswordResetDataRelationshipsEventsDataType,
)
from .customer_password_reset_data_type import CustomerPasswordResetDataType
from .customer_password_reset_update import CustomerPasswordResetUpdate
from .customer_password_reset_update_data import CustomerPasswordResetUpdateData
from .customer_password_reset_update_data_attributes import CustomerPasswordResetUpdateDataAttributes
from .customer_password_reset_update_data_attributes_metadata import CustomerPasswordResetUpdateDataAttributesMetadata
from .customer_password_reset_update_data_relationships import CustomerPasswordResetUpdateDataRelationships
from .customer_password_reset_update_data_type import CustomerPasswordResetUpdateDataType
from .customer_payment_source import CustomerPaymentSource
from .customer_payment_source_create import CustomerPaymentSourceCreate
from .customer_payment_source_create_data import CustomerPaymentSourceCreateData
from .customer_payment_source_create_data_attributes import CustomerPaymentSourceCreateDataAttributes
from .customer_payment_source_create_data_attributes_metadata import CustomerPaymentSourceCreateDataAttributesMetadata
from .customer_payment_source_create_data_relationships import CustomerPaymentSourceCreateDataRelationships
from .customer_payment_source_create_data_relationships_customer import (
    CustomerPaymentSourceCreateDataRelationshipsCustomer,
)
from .customer_payment_source_create_data_relationships_customer_data import (
    CustomerPaymentSourceCreateDataRelationshipsCustomerData,
)
from .customer_payment_source_create_data_relationships_customer_data_type import (
    CustomerPaymentSourceCreateDataRelationshipsCustomerDataType,
)
from .customer_payment_source_create_data_type import CustomerPaymentSourceCreateDataType
from .customer_payment_source_data import CustomerPaymentSourceData
from .customer_payment_source_data_attributes import CustomerPaymentSourceDataAttributes
from .customer_payment_source_data_attributes_metadata import CustomerPaymentSourceDataAttributesMetadata
from .customer_payment_source_data_relationships import CustomerPaymentSourceDataRelationships
from .customer_payment_source_data_relationships_customer import CustomerPaymentSourceDataRelationshipsCustomer
from .customer_payment_source_data_relationships_customer_data import CustomerPaymentSourceDataRelationshipsCustomerData
from .customer_payment_source_data_relationships_customer_data_type import (
    CustomerPaymentSourceDataRelationshipsCustomerDataType,
)
from .customer_payment_source_data_type import CustomerPaymentSourceDataType
from .customer_payment_source_update import CustomerPaymentSourceUpdate
from .customer_payment_source_update_data import CustomerPaymentSourceUpdateData
from .customer_payment_source_update_data_attributes import CustomerPaymentSourceUpdateDataAttributes
from .customer_payment_source_update_data_attributes_metadata import CustomerPaymentSourceUpdateDataAttributesMetadata
from .customer_payment_source_update_data_relationships import CustomerPaymentSourceUpdateDataRelationships
from .customer_payment_source_update_data_relationships_customer import (
    CustomerPaymentSourceUpdateDataRelationshipsCustomer,
)
from .customer_payment_source_update_data_relationships_customer_data import (
    CustomerPaymentSourceUpdateDataRelationshipsCustomerData,
)
from .customer_payment_source_update_data_relationships_customer_data_type import (
    CustomerPaymentSourceUpdateDataRelationshipsCustomerDataType,
)
from .customer_payment_source_update_data_type import CustomerPaymentSourceUpdateDataType
from .customer_subscription import CustomerSubscription
from .customer_subscription_create import CustomerSubscriptionCreate
from .customer_subscription_create_data import CustomerSubscriptionCreateData
from .customer_subscription_create_data_attributes import CustomerSubscriptionCreateDataAttributes
from .customer_subscription_create_data_attributes_metadata import CustomerSubscriptionCreateDataAttributesMetadata
from .customer_subscription_create_data_relationships import CustomerSubscriptionCreateDataRelationships
from .customer_subscription_create_data_type import CustomerSubscriptionCreateDataType
from .customer_subscription_data import CustomerSubscriptionData
from .customer_subscription_data_attributes import CustomerSubscriptionDataAttributes
from .customer_subscription_data_attributes_metadata import CustomerSubscriptionDataAttributesMetadata
from .customer_subscription_data_relationships import CustomerSubscriptionDataRelationships
from .customer_subscription_data_relationships_customer import CustomerSubscriptionDataRelationshipsCustomer
from .customer_subscription_data_relationships_customer_data import CustomerSubscriptionDataRelationshipsCustomerData
from .customer_subscription_data_relationships_customer_data_type import (
    CustomerSubscriptionDataRelationshipsCustomerDataType,
)
from .customer_subscription_data_relationships_events import CustomerSubscriptionDataRelationshipsEvents
from .customer_subscription_data_relationships_events_data import CustomerSubscriptionDataRelationshipsEventsData
from .customer_subscription_data_relationships_events_data_type import (
    CustomerSubscriptionDataRelationshipsEventsDataType,
)
from .customer_subscription_data_type import CustomerSubscriptionDataType
from .customer_subscription_update import CustomerSubscriptionUpdate
from .customer_subscription_update_data import CustomerSubscriptionUpdateData
from .customer_subscription_update_data_attributes import CustomerSubscriptionUpdateDataAttributes
from .customer_subscription_update_data_attributes_metadata import CustomerSubscriptionUpdateDataAttributesMetadata
from .customer_subscription_update_data_relationships import CustomerSubscriptionUpdateDataRelationships
from .customer_subscription_update_data_type import CustomerSubscriptionUpdateDataType
from .customer_update import CustomerUpdate
from .customer_update_data import CustomerUpdateData
from .customer_update_data_attributes import CustomerUpdateDataAttributes
from .customer_update_data_attributes_metadata import CustomerUpdateDataAttributesMetadata
from .customer_update_data_relationships import CustomerUpdateDataRelationships
from .customer_update_data_relationships_customer_group import CustomerUpdateDataRelationshipsCustomerGroup
from .customer_update_data_relationships_customer_group_data import CustomerUpdateDataRelationshipsCustomerGroupData
from .customer_update_data_relationships_customer_group_data_type import (
    CustomerUpdateDataRelationshipsCustomerGroupDataType,
)
from .customer_update_data_type import CustomerUpdateDataType
from .delivery_lead_time import DeliveryLeadTime
from .delivery_lead_time_create import DeliveryLeadTimeCreate
from .delivery_lead_time_create_data import DeliveryLeadTimeCreateData
from .delivery_lead_time_create_data_attributes import DeliveryLeadTimeCreateDataAttributes
from .delivery_lead_time_create_data_attributes_metadata import DeliveryLeadTimeCreateDataAttributesMetadata
from .delivery_lead_time_create_data_relationships import DeliveryLeadTimeCreateDataRelationships
from .delivery_lead_time_create_data_relationships_shipping_method import (
    DeliveryLeadTimeCreateDataRelationshipsShippingMethod,
)
from .delivery_lead_time_create_data_relationships_shipping_method_data import (
    DeliveryLeadTimeCreateDataRelationshipsShippingMethodData,
)
from .delivery_lead_time_create_data_relationships_shipping_method_data_type import (
    DeliveryLeadTimeCreateDataRelationshipsShippingMethodDataType,
)
from .delivery_lead_time_create_data_relationships_stock_location import (
    DeliveryLeadTimeCreateDataRelationshipsStockLocation,
)
from .delivery_lead_time_create_data_relationships_stock_location_data import (
    DeliveryLeadTimeCreateDataRelationshipsStockLocationData,
)
from .delivery_lead_time_create_data_relationships_stock_location_data_type import (
    DeliveryLeadTimeCreateDataRelationshipsStockLocationDataType,
)
from .delivery_lead_time_create_data_type import DeliveryLeadTimeCreateDataType
from .delivery_lead_time_data import DeliveryLeadTimeData
from .delivery_lead_time_data_attributes import DeliveryLeadTimeDataAttributes
from .delivery_lead_time_data_attributes_metadata import DeliveryLeadTimeDataAttributesMetadata
from .delivery_lead_time_data_relationships import DeliveryLeadTimeDataRelationships
from .delivery_lead_time_data_relationships_attachments import DeliveryLeadTimeDataRelationshipsAttachments
from .delivery_lead_time_data_relationships_attachments_data import DeliveryLeadTimeDataRelationshipsAttachmentsData
from .delivery_lead_time_data_relationships_attachments_data_type import (
    DeliveryLeadTimeDataRelationshipsAttachmentsDataType,
)
from .delivery_lead_time_data_relationships_shipping_method import DeliveryLeadTimeDataRelationshipsShippingMethod
from .delivery_lead_time_data_relationships_shipping_method_data import (
    DeliveryLeadTimeDataRelationshipsShippingMethodData,
)
from .delivery_lead_time_data_relationships_shipping_method_data_type import (
    DeliveryLeadTimeDataRelationshipsShippingMethodDataType,
)
from .delivery_lead_time_data_relationships_stock_location import DeliveryLeadTimeDataRelationshipsStockLocation
from .delivery_lead_time_data_relationships_stock_location_data import (
    DeliveryLeadTimeDataRelationshipsStockLocationData,
)
from .delivery_lead_time_data_relationships_stock_location_data_type import (
    DeliveryLeadTimeDataRelationshipsStockLocationDataType,
)
from .delivery_lead_time_data_type import DeliveryLeadTimeDataType
from .delivery_lead_time_update import DeliveryLeadTimeUpdate
from .delivery_lead_time_update_data import DeliveryLeadTimeUpdateData
from .delivery_lead_time_update_data_attributes import DeliveryLeadTimeUpdateDataAttributes
from .delivery_lead_time_update_data_attributes_metadata import DeliveryLeadTimeUpdateDataAttributesMetadata
from .delivery_lead_time_update_data_relationships import DeliveryLeadTimeUpdateDataRelationships
from .delivery_lead_time_update_data_relationships_shipping_method import (
    DeliveryLeadTimeUpdateDataRelationshipsShippingMethod,
)
from .delivery_lead_time_update_data_relationships_shipping_method_data import (
    DeliveryLeadTimeUpdateDataRelationshipsShippingMethodData,
)
from .delivery_lead_time_update_data_relationships_shipping_method_data_type import (
    DeliveryLeadTimeUpdateDataRelationshipsShippingMethodDataType,
)
from .delivery_lead_time_update_data_relationships_stock_location import (
    DeliveryLeadTimeUpdateDataRelationshipsStockLocation,
)
from .delivery_lead_time_update_data_relationships_stock_location_data import (
    DeliveryLeadTimeUpdateDataRelationshipsStockLocationData,
)
from .delivery_lead_time_update_data_relationships_stock_location_data_type import (
    DeliveryLeadTimeUpdateDataRelationshipsStockLocationDataType,
)
from .delivery_lead_time_update_data_type import DeliveryLeadTimeUpdateDataType
from .event import Event
from .event_callback import EventCallback
from .event_callback_data import EventCallbackData
from .event_callback_data_attributes import EventCallbackDataAttributes
from .event_callback_data_attributes_metadata import EventCallbackDataAttributesMetadata
from .event_callback_data_attributes_payload import EventCallbackDataAttributesPayload
from .event_callback_data_relationships import EventCallbackDataRelationships
from .event_callback_data_relationships_webhook import EventCallbackDataRelationshipsWebhook
from .event_callback_data_relationships_webhook_data import EventCallbackDataRelationshipsWebhookData
from .event_callback_data_relationships_webhook_data_type import EventCallbackDataRelationshipsWebhookDataType
from .event_callback_data_type import EventCallbackDataType
from .event_data import EventData
from .event_data_attributes import EventDataAttributes
from .event_data_attributes_metadata import EventDataAttributesMetadata
from .event_data_relationships import EventDataRelationships
from .event_data_relationships_last_event_callbacks import EventDataRelationshipsLastEventCallbacks
from .event_data_relationships_last_event_callbacks_data import EventDataRelationshipsLastEventCallbacksData
from .event_data_relationships_last_event_callbacks_data_type import EventDataRelationshipsLastEventCallbacksDataType
from .event_data_relationships_webhooks import EventDataRelationshipsWebhooks
from .event_data_relationships_webhooks_data import EventDataRelationshipsWebhooksData
from .event_data_relationships_webhooks_data_type import EventDataRelationshipsWebhooksDataType
from .event_data_type import EventDataType
from .export import Export
from .export_create import ExportCreate
from .export_create_data import ExportCreateData
from .export_create_data_attributes import ExportCreateDataAttributes
from .export_create_data_attributes_filters import ExportCreateDataAttributesFilters
from .export_create_data_attributes_metadata import ExportCreateDataAttributesMetadata
from .export_create_data_relationships import ExportCreateDataRelationships
from .export_create_data_type import ExportCreateDataType
from .export_data import ExportData
from .export_data_attributes import ExportDataAttributes
from .export_data_attributes_filters import ExportDataAttributesFilters
from .export_data_attributes_metadata import ExportDataAttributesMetadata
from .export_data_relationships import ExportDataRelationships
from .export_data_relationships_events import ExportDataRelationshipsEvents
from .export_data_relationships_events_data import ExportDataRelationshipsEventsData
from .export_data_relationships_events_data_type import ExportDataRelationshipsEventsDataType
from .export_data_type import ExportDataType
from .external_gateway import ExternalGateway
from .external_gateway_create import ExternalGatewayCreate
from .external_gateway_create_data import ExternalGatewayCreateData
from .external_gateway_create_data_attributes import ExternalGatewayCreateDataAttributes
from .external_gateway_create_data_attributes_metadata import ExternalGatewayCreateDataAttributesMetadata
from .external_gateway_create_data_relationships import ExternalGatewayCreateDataRelationships
from .external_gateway_create_data_type import ExternalGatewayCreateDataType
from .external_gateway_data import ExternalGatewayData
from .external_gateway_data_attributes import ExternalGatewayDataAttributes
from .external_gateway_data_attributes_metadata import ExternalGatewayDataAttributesMetadata
from .external_gateway_data_relationships import ExternalGatewayDataRelationships
from .external_gateway_data_relationships_external_payments import ExternalGatewayDataRelationshipsExternalPayments
from .external_gateway_data_relationships_external_payments_data import (
    ExternalGatewayDataRelationshipsExternalPaymentsData,
)
from .external_gateway_data_relationships_external_payments_data_type import (
    ExternalGatewayDataRelationshipsExternalPaymentsDataType,
)
from .external_gateway_data_relationships_payment_methods import ExternalGatewayDataRelationshipsPaymentMethods
from .external_gateway_data_relationships_payment_methods_data import ExternalGatewayDataRelationshipsPaymentMethodsData
from .external_gateway_data_relationships_payment_methods_data_type import (
    ExternalGatewayDataRelationshipsPaymentMethodsDataType,
)
from .external_gateway_data_type import ExternalGatewayDataType
from .external_gateway_update import ExternalGatewayUpdate
from .external_gateway_update_data import ExternalGatewayUpdateData
from .external_gateway_update_data_attributes import ExternalGatewayUpdateDataAttributes
from .external_gateway_update_data_attributes_metadata import ExternalGatewayUpdateDataAttributesMetadata
from .external_gateway_update_data_relationships import ExternalGatewayUpdateDataRelationships
from .external_gateway_update_data_type import ExternalGatewayUpdateDataType
from .external_payment import ExternalPayment
from .external_payment_create import ExternalPaymentCreate
from .external_payment_create_data import ExternalPaymentCreateData
from .external_payment_create_data_attributes import ExternalPaymentCreateDataAttributes
from .external_payment_create_data_attributes_metadata import ExternalPaymentCreateDataAttributesMetadata
from .external_payment_create_data_attributes_options import ExternalPaymentCreateDataAttributesOptions
from .external_payment_create_data_relationships import ExternalPaymentCreateDataRelationships
from .external_payment_create_data_relationships_order import ExternalPaymentCreateDataRelationshipsOrder
from .external_payment_create_data_relationships_order_data import ExternalPaymentCreateDataRelationshipsOrderData
from .external_payment_create_data_relationships_order_data_type import (
    ExternalPaymentCreateDataRelationshipsOrderDataType,
)
from .external_payment_create_data_type import ExternalPaymentCreateDataType
from .external_payment_data import ExternalPaymentData
from .external_payment_data_attributes import ExternalPaymentDataAttributes
from .external_payment_data_attributes_metadata import ExternalPaymentDataAttributesMetadata
from .external_payment_data_attributes_options import ExternalPaymentDataAttributesOptions
from .external_payment_data_relationships import ExternalPaymentDataRelationships
from .external_payment_data_relationships_order import ExternalPaymentDataRelationshipsOrder
from .external_payment_data_relationships_order_data import ExternalPaymentDataRelationshipsOrderData
from .external_payment_data_relationships_order_data_type import ExternalPaymentDataRelationshipsOrderDataType
from .external_payment_data_relationships_payment_gateway import ExternalPaymentDataRelationshipsPaymentGateway
from .external_payment_data_relationships_payment_gateway_data import ExternalPaymentDataRelationshipsPaymentGatewayData
from .external_payment_data_relationships_payment_gateway_data_type import (
    ExternalPaymentDataRelationshipsPaymentGatewayDataType,
)
from .external_payment_data_relationships_wallet import ExternalPaymentDataRelationshipsWallet
from .external_payment_data_relationships_wallet_data import ExternalPaymentDataRelationshipsWalletData
from .external_payment_data_relationships_wallet_data_type import ExternalPaymentDataRelationshipsWalletDataType
from .external_payment_data_type import ExternalPaymentDataType
from .external_payment_update import ExternalPaymentUpdate
from .external_payment_update_data import ExternalPaymentUpdateData
from .external_payment_update_data_attributes import ExternalPaymentUpdateDataAttributes
from .external_payment_update_data_attributes_metadata import ExternalPaymentUpdateDataAttributesMetadata
from .external_payment_update_data_attributes_options import ExternalPaymentUpdateDataAttributesOptions
from .external_payment_update_data_relationships import ExternalPaymentUpdateDataRelationships
from .external_payment_update_data_relationships_order import ExternalPaymentUpdateDataRelationshipsOrder
from .external_payment_update_data_relationships_order_data import ExternalPaymentUpdateDataRelationshipsOrderData
from .external_payment_update_data_relationships_order_data_type import (
    ExternalPaymentUpdateDataRelationshipsOrderDataType,
)
from .external_payment_update_data_type import ExternalPaymentUpdateDataType
from .external_promotion import ExternalPromotion
from .external_promotion_create import ExternalPromotionCreate
from .external_promotion_create_data import ExternalPromotionCreateData
from .external_promotion_create_data_attributes import ExternalPromotionCreateDataAttributes
from .external_promotion_create_data_attributes_metadata import ExternalPromotionCreateDataAttributesMetadata
from .external_promotion_create_data_relationships import ExternalPromotionCreateDataRelationships
from .external_promotion_create_data_relationships_coupon_codes_promotion_rule import (
    ExternalPromotionCreateDataRelationshipsCouponCodesPromotionRule,
)
from .external_promotion_create_data_relationships_coupon_codes_promotion_rule_data import (
    ExternalPromotionCreateDataRelationshipsCouponCodesPromotionRuleData,
)
from .external_promotion_create_data_relationships_coupon_codes_promotion_rule_data_type import (
    ExternalPromotionCreateDataRelationshipsCouponCodesPromotionRuleDataType,
)
from .external_promotion_create_data_relationships_market import ExternalPromotionCreateDataRelationshipsMarket
from .external_promotion_create_data_relationships_market_data import ExternalPromotionCreateDataRelationshipsMarketData
from .external_promotion_create_data_relationships_market_data_type import (
    ExternalPromotionCreateDataRelationshipsMarketDataType,
)
from .external_promotion_create_data_relationships_order_amount_promotion_rule import (
    ExternalPromotionCreateDataRelationshipsOrderAmountPromotionRule,
)
from .external_promotion_create_data_relationships_order_amount_promotion_rule_data import (
    ExternalPromotionCreateDataRelationshipsOrderAmountPromotionRuleData,
)
from .external_promotion_create_data_relationships_order_amount_promotion_rule_data_type import (
    ExternalPromotionCreateDataRelationshipsOrderAmountPromotionRuleDataType,
)
from .external_promotion_create_data_relationships_promotion_rules import (
    ExternalPromotionCreateDataRelationshipsPromotionRules,
)
from .external_promotion_create_data_relationships_promotion_rules_data import (
    ExternalPromotionCreateDataRelationshipsPromotionRulesData,
)
from .external_promotion_create_data_relationships_promotion_rules_data_type import (
    ExternalPromotionCreateDataRelationshipsPromotionRulesDataType,
)
from .external_promotion_create_data_relationships_sku_list_promotion_rule import (
    ExternalPromotionCreateDataRelationshipsSkuListPromotionRule,
)
from .external_promotion_create_data_relationships_sku_list_promotion_rule_data import (
    ExternalPromotionCreateDataRelationshipsSkuListPromotionRuleData,
)
from .external_promotion_create_data_relationships_sku_list_promotion_rule_data_type import (
    ExternalPromotionCreateDataRelationshipsSkuListPromotionRuleDataType,
)
from .external_promotion_create_data_type import ExternalPromotionCreateDataType
from .external_promotion_data import ExternalPromotionData
from .external_promotion_data_attributes import ExternalPromotionDataAttributes
from .external_promotion_data_attributes_metadata import ExternalPromotionDataAttributesMetadata
from .external_promotion_data_relationships import ExternalPromotionDataRelationships
from .external_promotion_data_relationships_attachments import ExternalPromotionDataRelationshipsAttachments
from .external_promotion_data_relationships_attachments_data import ExternalPromotionDataRelationshipsAttachmentsData
from .external_promotion_data_relationships_attachments_data_type import (
    ExternalPromotionDataRelationshipsAttachmentsDataType,
)
from .external_promotion_data_relationships_coupon_codes_promotion_rule import (
    ExternalPromotionDataRelationshipsCouponCodesPromotionRule,
)
from .external_promotion_data_relationships_coupon_codes_promotion_rule_data import (
    ExternalPromotionDataRelationshipsCouponCodesPromotionRuleData,
)
from .external_promotion_data_relationships_coupon_codes_promotion_rule_data_type import (
    ExternalPromotionDataRelationshipsCouponCodesPromotionRuleDataType,
)
from .external_promotion_data_relationships_market import ExternalPromotionDataRelationshipsMarket
from .external_promotion_data_relationships_market_data import ExternalPromotionDataRelationshipsMarketData
from .external_promotion_data_relationships_market_data_type import ExternalPromotionDataRelationshipsMarketDataType
from .external_promotion_data_relationships_order_amount_promotion_rule import (
    ExternalPromotionDataRelationshipsOrderAmountPromotionRule,
)
from .external_promotion_data_relationships_order_amount_promotion_rule_data import (
    ExternalPromotionDataRelationshipsOrderAmountPromotionRuleData,
)
from .external_promotion_data_relationships_order_amount_promotion_rule_data_type import (
    ExternalPromotionDataRelationshipsOrderAmountPromotionRuleDataType,
)
from .external_promotion_data_relationships_promotion_rules import ExternalPromotionDataRelationshipsPromotionRules
from .external_promotion_data_relationships_promotion_rules_data import (
    ExternalPromotionDataRelationshipsPromotionRulesData,
)
from .external_promotion_data_relationships_promotion_rules_data_type import (
    ExternalPromotionDataRelationshipsPromotionRulesDataType,
)
from .external_promotion_data_relationships_sku_list_promotion_rule import (
    ExternalPromotionDataRelationshipsSkuListPromotionRule,
)
from .external_promotion_data_relationships_sku_list_promotion_rule_data import (
    ExternalPromotionDataRelationshipsSkuListPromotionRuleData,
)
from .external_promotion_data_relationships_sku_list_promotion_rule_data_type import (
    ExternalPromotionDataRelationshipsSkuListPromotionRuleDataType,
)
from .external_promotion_data_type import ExternalPromotionDataType
from .external_promotion_update import ExternalPromotionUpdate
from .external_promotion_update_data import ExternalPromotionUpdateData
from .external_promotion_update_data_attributes import ExternalPromotionUpdateDataAttributes
from .external_promotion_update_data_attributes_metadata import ExternalPromotionUpdateDataAttributesMetadata
from .external_promotion_update_data_relationships import ExternalPromotionUpdateDataRelationships
from .external_promotion_update_data_relationships_coupon_codes_promotion_rule import (
    ExternalPromotionUpdateDataRelationshipsCouponCodesPromotionRule,
)
from .external_promotion_update_data_relationships_coupon_codes_promotion_rule_data import (
    ExternalPromotionUpdateDataRelationshipsCouponCodesPromotionRuleData,
)
from .external_promotion_update_data_relationships_coupon_codes_promotion_rule_data_type import (
    ExternalPromotionUpdateDataRelationshipsCouponCodesPromotionRuleDataType,
)
from .external_promotion_update_data_relationships_market import ExternalPromotionUpdateDataRelationshipsMarket
from .external_promotion_update_data_relationships_market_data import ExternalPromotionUpdateDataRelationshipsMarketData
from .external_promotion_update_data_relationships_market_data_type import (
    ExternalPromotionUpdateDataRelationshipsMarketDataType,
)
from .external_promotion_update_data_relationships_order_amount_promotion_rule import (
    ExternalPromotionUpdateDataRelationshipsOrderAmountPromotionRule,
)
from .external_promotion_update_data_relationships_order_amount_promotion_rule_data import (
    ExternalPromotionUpdateDataRelationshipsOrderAmountPromotionRuleData,
)
from .external_promotion_update_data_relationships_order_amount_promotion_rule_data_type import (
    ExternalPromotionUpdateDataRelationshipsOrderAmountPromotionRuleDataType,
)
from .external_promotion_update_data_relationships_promotion_rules import (
    ExternalPromotionUpdateDataRelationshipsPromotionRules,
)
from .external_promotion_update_data_relationships_promotion_rules_data import (
    ExternalPromotionUpdateDataRelationshipsPromotionRulesData,
)
from .external_promotion_update_data_relationships_promotion_rules_data_type import (
    ExternalPromotionUpdateDataRelationshipsPromotionRulesDataType,
)
from .external_promotion_update_data_relationships_sku_list_promotion_rule import (
    ExternalPromotionUpdateDataRelationshipsSkuListPromotionRule,
)
from .external_promotion_update_data_relationships_sku_list_promotion_rule_data import (
    ExternalPromotionUpdateDataRelationshipsSkuListPromotionRuleData,
)
from .external_promotion_update_data_relationships_sku_list_promotion_rule_data_type import (
    ExternalPromotionUpdateDataRelationshipsSkuListPromotionRuleDataType,
)
from .external_promotion_update_data_type import ExternalPromotionUpdateDataType
from .external_tax_calculator import ExternalTaxCalculator
from .external_tax_calculator_create import ExternalTaxCalculatorCreate
from .external_tax_calculator_create_data import ExternalTaxCalculatorCreateData
from .external_tax_calculator_create_data_attributes import ExternalTaxCalculatorCreateDataAttributes
from .external_tax_calculator_create_data_attributes_metadata import ExternalTaxCalculatorCreateDataAttributesMetadata
from .external_tax_calculator_create_data_relationships import ExternalTaxCalculatorCreateDataRelationships
from .external_tax_calculator_create_data_type import ExternalTaxCalculatorCreateDataType
from .external_tax_calculator_data import ExternalTaxCalculatorData
from .external_tax_calculator_data_attributes import ExternalTaxCalculatorDataAttributes
from .external_tax_calculator_data_attributes_metadata import ExternalTaxCalculatorDataAttributesMetadata
from .external_tax_calculator_data_relationships import ExternalTaxCalculatorDataRelationships
from .external_tax_calculator_data_relationships_attachments import ExternalTaxCalculatorDataRelationshipsAttachments
from .external_tax_calculator_data_relationships_attachments_data import (
    ExternalTaxCalculatorDataRelationshipsAttachmentsData,
)
from .external_tax_calculator_data_relationships_attachments_data_type import (
    ExternalTaxCalculatorDataRelationshipsAttachmentsDataType,
)
from .external_tax_calculator_data_relationships_markets import ExternalTaxCalculatorDataRelationshipsMarkets
from .external_tax_calculator_data_relationships_markets_data import ExternalTaxCalculatorDataRelationshipsMarketsData
from .external_tax_calculator_data_relationships_markets_data_type import (
    ExternalTaxCalculatorDataRelationshipsMarketsDataType,
)
from .external_tax_calculator_data_type import ExternalTaxCalculatorDataType
from .external_tax_calculator_update import ExternalTaxCalculatorUpdate
from .external_tax_calculator_update_data import ExternalTaxCalculatorUpdateData
from .external_tax_calculator_update_data_attributes import ExternalTaxCalculatorUpdateDataAttributes
from .external_tax_calculator_update_data_attributes_metadata import ExternalTaxCalculatorUpdateDataAttributesMetadata
from .external_tax_calculator_update_data_relationships import ExternalTaxCalculatorUpdateDataRelationships
from .external_tax_calculator_update_data_type import ExternalTaxCalculatorUpdateDataType
from .fixed_amount_promotion import FixedAmountPromotion
from .fixed_amount_promotion_create import FixedAmountPromotionCreate
from .fixed_amount_promotion_create_data import FixedAmountPromotionCreateData
from .fixed_amount_promotion_create_data_attributes import FixedAmountPromotionCreateDataAttributes
from .fixed_amount_promotion_create_data_attributes_metadata import FixedAmountPromotionCreateDataAttributesMetadata
from .fixed_amount_promotion_create_data_relationships import FixedAmountPromotionCreateDataRelationships
from .fixed_amount_promotion_create_data_relationships_coupon_codes_promotion_rule import (
    FixedAmountPromotionCreateDataRelationshipsCouponCodesPromotionRule,
)
from .fixed_amount_promotion_create_data_relationships_coupon_codes_promotion_rule_data import (
    FixedAmountPromotionCreateDataRelationshipsCouponCodesPromotionRuleData,
)
from .fixed_amount_promotion_create_data_relationships_coupon_codes_promotion_rule_data_type import (
    FixedAmountPromotionCreateDataRelationshipsCouponCodesPromotionRuleDataType,
)
from .fixed_amount_promotion_create_data_relationships_market import FixedAmountPromotionCreateDataRelationshipsMarket
from .fixed_amount_promotion_create_data_relationships_market_data import (
    FixedAmountPromotionCreateDataRelationshipsMarketData,
)
from .fixed_amount_promotion_create_data_relationships_market_data_type import (
    FixedAmountPromotionCreateDataRelationshipsMarketDataType,
)
from .fixed_amount_promotion_create_data_relationships_order_amount_promotion_rule import (
    FixedAmountPromotionCreateDataRelationshipsOrderAmountPromotionRule,
)
from .fixed_amount_promotion_create_data_relationships_order_amount_promotion_rule_data import (
    FixedAmountPromotionCreateDataRelationshipsOrderAmountPromotionRuleData,
)
from .fixed_amount_promotion_create_data_relationships_order_amount_promotion_rule_data_type import (
    FixedAmountPromotionCreateDataRelationshipsOrderAmountPromotionRuleDataType,
)
from .fixed_amount_promotion_create_data_relationships_promotion_rules import (
    FixedAmountPromotionCreateDataRelationshipsPromotionRules,
)
from .fixed_amount_promotion_create_data_relationships_promotion_rules_data import (
    FixedAmountPromotionCreateDataRelationshipsPromotionRulesData,
)
from .fixed_amount_promotion_create_data_relationships_promotion_rules_data_type import (
    FixedAmountPromotionCreateDataRelationshipsPromotionRulesDataType,
)
from .fixed_amount_promotion_create_data_relationships_sku_list_promotion_rule import (
    FixedAmountPromotionCreateDataRelationshipsSkuListPromotionRule,
)
from .fixed_amount_promotion_create_data_relationships_sku_list_promotion_rule_data import (
    FixedAmountPromotionCreateDataRelationshipsSkuListPromotionRuleData,
)
from .fixed_amount_promotion_create_data_relationships_sku_list_promotion_rule_data_type import (
    FixedAmountPromotionCreateDataRelationshipsSkuListPromotionRuleDataType,
)
from .fixed_amount_promotion_create_data_type import FixedAmountPromotionCreateDataType
from .fixed_amount_promotion_data import FixedAmountPromotionData
from .fixed_amount_promotion_data_attributes import FixedAmountPromotionDataAttributes
from .fixed_amount_promotion_data_attributes_metadata import FixedAmountPromotionDataAttributesMetadata
from .fixed_amount_promotion_data_relationships import FixedAmountPromotionDataRelationships
from .fixed_amount_promotion_data_relationships_attachments import FixedAmountPromotionDataRelationshipsAttachments
from .fixed_amount_promotion_data_relationships_attachments_data import (
    FixedAmountPromotionDataRelationshipsAttachmentsData,
)
from .fixed_amount_promotion_data_relationships_attachments_data_type import (
    FixedAmountPromotionDataRelationshipsAttachmentsDataType,
)
from .fixed_amount_promotion_data_relationships_coupon_codes_promotion_rule import (
    FixedAmountPromotionDataRelationshipsCouponCodesPromotionRule,
)
from .fixed_amount_promotion_data_relationships_coupon_codes_promotion_rule_data import (
    FixedAmountPromotionDataRelationshipsCouponCodesPromotionRuleData,
)
from .fixed_amount_promotion_data_relationships_coupon_codes_promotion_rule_data_type import (
    FixedAmountPromotionDataRelationshipsCouponCodesPromotionRuleDataType,
)
from .fixed_amount_promotion_data_relationships_market import FixedAmountPromotionDataRelationshipsMarket
from .fixed_amount_promotion_data_relationships_market_data import FixedAmountPromotionDataRelationshipsMarketData
from .fixed_amount_promotion_data_relationships_market_data_type import (
    FixedAmountPromotionDataRelationshipsMarketDataType,
)
from .fixed_amount_promotion_data_relationships_order_amount_promotion_rule import (
    FixedAmountPromotionDataRelationshipsOrderAmountPromotionRule,
)
from .fixed_amount_promotion_data_relationships_order_amount_promotion_rule_data import (
    FixedAmountPromotionDataRelationshipsOrderAmountPromotionRuleData,
)
from .fixed_amount_promotion_data_relationships_order_amount_promotion_rule_data_type import (
    FixedAmountPromotionDataRelationshipsOrderAmountPromotionRuleDataType,
)
from .fixed_amount_promotion_data_relationships_promotion_rules import (
    FixedAmountPromotionDataRelationshipsPromotionRules,
)
from .fixed_amount_promotion_data_relationships_promotion_rules_data import (
    FixedAmountPromotionDataRelationshipsPromotionRulesData,
)
from .fixed_amount_promotion_data_relationships_promotion_rules_data_type import (
    FixedAmountPromotionDataRelationshipsPromotionRulesDataType,
)
from .fixed_amount_promotion_data_relationships_sku_list_promotion_rule import (
    FixedAmountPromotionDataRelationshipsSkuListPromotionRule,
)
from .fixed_amount_promotion_data_relationships_sku_list_promotion_rule_data import (
    FixedAmountPromotionDataRelationshipsSkuListPromotionRuleData,
)
from .fixed_amount_promotion_data_relationships_sku_list_promotion_rule_data_type import (
    FixedAmountPromotionDataRelationshipsSkuListPromotionRuleDataType,
)
from .fixed_amount_promotion_data_type import FixedAmountPromotionDataType
from .fixed_amount_promotion_update import FixedAmountPromotionUpdate
from .fixed_amount_promotion_update_data import FixedAmountPromotionUpdateData
from .fixed_amount_promotion_update_data_attributes import FixedAmountPromotionUpdateDataAttributes
from .fixed_amount_promotion_update_data_attributes_metadata import FixedAmountPromotionUpdateDataAttributesMetadata
from .fixed_amount_promotion_update_data_relationships import FixedAmountPromotionUpdateDataRelationships
from .fixed_amount_promotion_update_data_relationships_coupon_codes_promotion_rule import (
    FixedAmountPromotionUpdateDataRelationshipsCouponCodesPromotionRule,
)
from .fixed_amount_promotion_update_data_relationships_coupon_codes_promotion_rule_data import (
    FixedAmountPromotionUpdateDataRelationshipsCouponCodesPromotionRuleData,
)
from .fixed_amount_promotion_update_data_relationships_coupon_codes_promotion_rule_data_type import (
    FixedAmountPromotionUpdateDataRelationshipsCouponCodesPromotionRuleDataType,
)
from .fixed_amount_promotion_update_data_relationships_market import FixedAmountPromotionUpdateDataRelationshipsMarket
from .fixed_amount_promotion_update_data_relationships_market_data import (
    FixedAmountPromotionUpdateDataRelationshipsMarketData,
)
from .fixed_amount_promotion_update_data_relationships_market_data_type import (
    FixedAmountPromotionUpdateDataRelationshipsMarketDataType,
)
from .fixed_amount_promotion_update_data_relationships_order_amount_promotion_rule import (
    FixedAmountPromotionUpdateDataRelationshipsOrderAmountPromotionRule,
)
from .fixed_amount_promotion_update_data_relationships_order_amount_promotion_rule_data import (
    FixedAmountPromotionUpdateDataRelationshipsOrderAmountPromotionRuleData,
)
from .fixed_amount_promotion_update_data_relationships_order_amount_promotion_rule_data_type import (
    FixedAmountPromotionUpdateDataRelationshipsOrderAmountPromotionRuleDataType,
)
from .fixed_amount_promotion_update_data_relationships_promotion_rules import (
    FixedAmountPromotionUpdateDataRelationshipsPromotionRules,
)
from .fixed_amount_promotion_update_data_relationships_promotion_rules_data import (
    FixedAmountPromotionUpdateDataRelationshipsPromotionRulesData,
)
from .fixed_amount_promotion_update_data_relationships_promotion_rules_data_type import (
    FixedAmountPromotionUpdateDataRelationshipsPromotionRulesDataType,
)
from .fixed_amount_promotion_update_data_relationships_sku_list_promotion_rule import (
    FixedAmountPromotionUpdateDataRelationshipsSkuListPromotionRule,
)
from .fixed_amount_promotion_update_data_relationships_sku_list_promotion_rule_data import (
    FixedAmountPromotionUpdateDataRelationshipsSkuListPromotionRuleData,
)
from .fixed_amount_promotion_update_data_relationships_sku_list_promotion_rule_data_type import (
    FixedAmountPromotionUpdateDataRelationshipsSkuListPromotionRuleDataType,
)
from .fixed_amount_promotion_update_data_type import FixedAmountPromotionUpdateDataType
from .fixed_price_promotion import FixedPricePromotion
from .fixed_price_promotion_create import FixedPricePromotionCreate
from .fixed_price_promotion_create_data import FixedPricePromotionCreateData
from .fixed_price_promotion_create_data_attributes import FixedPricePromotionCreateDataAttributes
from .fixed_price_promotion_create_data_attributes_metadata import FixedPricePromotionCreateDataAttributesMetadata
from .fixed_price_promotion_create_data_relationships import FixedPricePromotionCreateDataRelationships
from .fixed_price_promotion_create_data_relationships_coupon_codes_promotion_rule import (
    FixedPricePromotionCreateDataRelationshipsCouponCodesPromotionRule,
)
from .fixed_price_promotion_create_data_relationships_coupon_codes_promotion_rule_data import (
    FixedPricePromotionCreateDataRelationshipsCouponCodesPromotionRuleData,
)
from .fixed_price_promotion_create_data_relationships_coupon_codes_promotion_rule_data_type import (
    FixedPricePromotionCreateDataRelationshipsCouponCodesPromotionRuleDataType,
)
from .fixed_price_promotion_create_data_relationships_market import FixedPricePromotionCreateDataRelationshipsMarket
from .fixed_price_promotion_create_data_relationships_market_data import (
    FixedPricePromotionCreateDataRelationshipsMarketData,
)
from .fixed_price_promotion_create_data_relationships_market_data_type import (
    FixedPricePromotionCreateDataRelationshipsMarketDataType,
)
from .fixed_price_promotion_create_data_relationships_order_amount_promotion_rule import (
    FixedPricePromotionCreateDataRelationshipsOrderAmountPromotionRule,
)
from .fixed_price_promotion_create_data_relationships_order_amount_promotion_rule_data import (
    FixedPricePromotionCreateDataRelationshipsOrderAmountPromotionRuleData,
)
from .fixed_price_promotion_create_data_relationships_order_amount_promotion_rule_data_type import (
    FixedPricePromotionCreateDataRelationshipsOrderAmountPromotionRuleDataType,
)
from .fixed_price_promotion_create_data_relationships_promotion_rules import (
    FixedPricePromotionCreateDataRelationshipsPromotionRules,
)
from .fixed_price_promotion_create_data_relationships_promotion_rules_data import (
    FixedPricePromotionCreateDataRelationshipsPromotionRulesData,
)
from .fixed_price_promotion_create_data_relationships_promotion_rules_data_type import (
    FixedPricePromotionCreateDataRelationshipsPromotionRulesDataType,
)
from .fixed_price_promotion_create_data_relationships_sku_list import FixedPricePromotionCreateDataRelationshipsSkuList
from .fixed_price_promotion_create_data_relationships_sku_list_data import (
    FixedPricePromotionCreateDataRelationshipsSkuListData,
)
from .fixed_price_promotion_create_data_relationships_sku_list_data_type import (
    FixedPricePromotionCreateDataRelationshipsSkuListDataType,
)
from .fixed_price_promotion_create_data_relationships_sku_list_promotion_rule import (
    FixedPricePromotionCreateDataRelationshipsSkuListPromotionRule,
)
from .fixed_price_promotion_create_data_relationships_sku_list_promotion_rule_data import (
    FixedPricePromotionCreateDataRelationshipsSkuListPromotionRuleData,
)
from .fixed_price_promotion_create_data_relationships_sku_list_promotion_rule_data_type import (
    FixedPricePromotionCreateDataRelationshipsSkuListPromotionRuleDataType,
)
from .fixed_price_promotion_create_data_type import FixedPricePromotionCreateDataType
from .fixed_price_promotion_data import FixedPricePromotionData
from .fixed_price_promotion_data_attributes import FixedPricePromotionDataAttributes
from .fixed_price_promotion_data_attributes_metadata import FixedPricePromotionDataAttributesMetadata
from .fixed_price_promotion_data_relationships import FixedPricePromotionDataRelationships
from .fixed_price_promotion_data_relationships_attachments import FixedPricePromotionDataRelationshipsAttachments
from .fixed_price_promotion_data_relationships_attachments_data import (
    FixedPricePromotionDataRelationshipsAttachmentsData,
)
from .fixed_price_promotion_data_relationships_attachments_data_type import (
    FixedPricePromotionDataRelationshipsAttachmentsDataType,
)
from .fixed_price_promotion_data_relationships_coupon_codes_promotion_rule import (
    FixedPricePromotionDataRelationshipsCouponCodesPromotionRule,
)
from .fixed_price_promotion_data_relationships_coupon_codes_promotion_rule_data import (
    FixedPricePromotionDataRelationshipsCouponCodesPromotionRuleData,
)
from .fixed_price_promotion_data_relationships_coupon_codes_promotion_rule_data_type import (
    FixedPricePromotionDataRelationshipsCouponCodesPromotionRuleDataType,
)
from .fixed_price_promotion_data_relationships_market import FixedPricePromotionDataRelationshipsMarket
from .fixed_price_promotion_data_relationships_market_data import FixedPricePromotionDataRelationshipsMarketData
from .fixed_price_promotion_data_relationships_market_data_type import (
    FixedPricePromotionDataRelationshipsMarketDataType,
)
from .fixed_price_promotion_data_relationships_order_amount_promotion_rule import (
    FixedPricePromotionDataRelationshipsOrderAmountPromotionRule,
)
from .fixed_price_promotion_data_relationships_order_amount_promotion_rule_data import (
    FixedPricePromotionDataRelationshipsOrderAmountPromotionRuleData,
)
from .fixed_price_promotion_data_relationships_order_amount_promotion_rule_data_type import (
    FixedPricePromotionDataRelationshipsOrderAmountPromotionRuleDataType,
)
from .fixed_price_promotion_data_relationships_promotion_rules import FixedPricePromotionDataRelationshipsPromotionRules
from .fixed_price_promotion_data_relationships_promotion_rules_data import (
    FixedPricePromotionDataRelationshipsPromotionRulesData,
)
from .fixed_price_promotion_data_relationships_promotion_rules_data_type import (
    FixedPricePromotionDataRelationshipsPromotionRulesDataType,
)
from .fixed_price_promotion_data_relationships_sku_list import FixedPricePromotionDataRelationshipsSkuList
from .fixed_price_promotion_data_relationships_sku_list_data import FixedPricePromotionDataRelationshipsSkuListData
from .fixed_price_promotion_data_relationships_sku_list_data_type import (
    FixedPricePromotionDataRelationshipsSkuListDataType,
)
from .fixed_price_promotion_data_relationships_sku_list_promotion_rule import (
    FixedPricePromotionDataRelationshipsSkuListPromotionRule,
)
from .fixed_price_promotion_data_relationships_sku_list_promotion_rule_data import (
    FixedPricePromotionDataRelationshipsSkuListPromotionRuleData,
)
from .fixed_price_promotion_data_relationships_sku_list_promotion_rule_data_type import (
    FixedPricePromotionDataRelationshipsSkuListPromotionRuleDataType,
)
from .fixed_price_promotion_data_relationships_skus import FixedPricePromotionDataRelationshipsSkus
from .fixed_price_promotion_data_relationships_skus_data import FixedPricePromotionDataRelationshipsSkusData
from .fixed_price_promotion_data_relationships_skus_data_type import FixedPricePromotionDataRelationshipsSkusDataType
from .fixed_price_promotion_data_type import FixedPricePromotionDataType
from .fixed_price_promotion_update import FixedPricePromotionUpdate
from .fixed_price_promotion_update_data import FixedPricePromotionUpdateData
from .fixed_price_promotion_update_data_attributes import FixedPricePromotionUpdateDataAttributes
from .fixed_price_promotion_update_data_attributes_metadata import FixedPricePromotionUpdateDataAttributesMetadata
from .fixed_price_promotion_update_data_relationships import FixedPricePromotionUpdateDataRelationships
from .fixed_price_promotion_update_data_relationships_coupon_codes_promotion_rule import (
    FixedPricePromotionUpdateDataRelationshipsCouponCodesPromotionRule,
)
from .fixed_price_promotion_update_data_relationships_coupon_codes_promotion_rule_data import (
    FixedPricePromotionUpdateDataRelationshipsCouponCodesPromotionRuleData,
)
from .fixed_price_promotion_update_data_relationships_coupon_codes_promotion_rule_data_type import (
    FixedPricePromotionUpdateDataRelationshipsCouponCodesPromotionRuleDataType,
)
from .fixed_price_promotion_update_data_relationships_market import FixedPricePromotionUpdateDataRelationshipsMarket
from .fixed_price_promotion_update_data_relationships_market_data import (
    FixedPricePromotionUpdateDataRelationshipsMarketData,
)
from .fixed_price_promotion_update_data_relationships_market_data_type import (
    FixedPricePromotionUpdateDataRelationshipsMarketDataType,
)
from .fixed_price_promotion_update_data_relationships_order_amount_promotion_rule import (
    FixedPricePromotionUpdateDataRelationshipsOrderAmountPromotionRule,
)
from .fixed_price_promotion_update_data_relationships_order_amount_promotion_rule_data import (
    FixedPricePromotionUpdateDataRelationshipsOrderAmountPromotionRuleData,
)
from .fixed_price_promotion_update_data_relationships_order_amount_promotion_rule_data_type import (
    FixedPricePromotionUpdateDataRelationshipsOrderAmountPromotionRuleDataType,
)
from .fixed_price_promotion_update_data_relationships_promotion_rules import (
    FixedPricePromotionUpdateDataRelationshipsPromotionRules,
)
from .fixed_price_promotion_update_data_relationships_promotion_rules_data import (
    FixedPricePromotionUpdateDataRelationshipsPromotionRulesData,
)
from .fixed_price_promotion_update_data_relationships_promotion_rules_data_type import (
    FixedPricePromotionUpdateDataRelationshipsPromotionRulesDataType,
)
from .fixed_price_promotion_update_data_relationships_sku_list import FixedPricePromotionUpdateDataRelationshipsSkuList
from .fixed_price_promotion_update_data_relationships_sku_list_data import (
    FixedPricePromotionUpdateDataRelationshipsSkuListData,
)
from .fixed_price_promotion_update_data_relationships_sku_list_data_type import (
    FixedPricePromotionUpdateDataRelationshipsSkuListDataType,
)
from .fixed_price_promotion_update_data_relationships_sku_list_promotion_rule import (
    FixedPricePromotionUpdateDataRelationshipsSkuListPromotionRule,
)
from .fixed_price_promotion_update_data_relationships_sku_list_promotion_rule_data import (
    FixedPricePromotionUpdateDataRelationshipsSkuListPromotionRuleData,
)
from .fixed_price_promotion_update_data_relationships_sku_list_promotion_rule_data_type import (
    FixedPricePromotionUpdateDataRelationshipsSkuListPromotionRuleDataType,
)
from .fixed_price_promotion_update_data_type import FixedPricePromotionUpdateDataType
from .free_gift_promotion import FreeGiftPromotion
from .free_gift_promotion_create import FreeGiftPromotionCreate
from .free_gift_promotion_create_data import FreeGiftPromotionCreateData
from .free_gift_promotion_create_data_attributes import FreeGiftPromotionCreateDataAttributes
from .free_gift_promotion_create_data_attributes_metadata import FreeGiftPromotionCreateDataAttributesMetadata
from .free_gift_promotion_create_data_relationships import FreeGiftPromotionCreateDataRelationships
from .free_gift_promotion_create_data_relationships_coupon_codes_promotion_rule import (
    FreeGiftPromotionCreateDataRelationshipsCouponCodesPromotionRule,
)
from .free_gift_promotion_create_data_relationships_coupon_codes_promotion_rule_data import (
    FreeGiftPromotionCreateDataRelationshipsCouponCodesPromotionRuleData,
)
from .free_gift_promotion_create_data_relationships_coupon_codes_promotion_rule_data_type import (
    FreeGiftPromotionCreateDataRelationshipsCouponCodesPromotionRuleDataType,
)
from .free_gift_promotion_create_data_relationships_market import FreeGiftPromotionCreateDataRelationshipsMarket
from .free_gift_promotion_create_data_relationships_market_data import (
    FreeGiftPromotionCreateDataRelationshipsMarketData,
)
from .free_gift_promotion_create_data_relationships_market_data_type import (
    FreeGiftPromotionCreateDataRelationshipsMarketDataType,
)
from .free_gift_promotion_create_data_relationships_order_amount_promotion_rule import (
    FreeGiftPromotionCreateDataRelationshipsOrderAmountPromotionRule,
)
from .free_gift_promotion_create_data_relationships_order_amount_promotion_rule_data import (
    FreeGiftPromotionCreateDataRelationshipsOrderAmountPromotionRuleData,
)
from .free_gift_promotion_create_data_relationships_order_amount_promotion_rule_data_type import (
    FreeGiftPromotionCreateDataRelationshipsOrderAmountPromotionRuleDataType,
)
from .free_gift_promotion_create_data_relationships_promotion_rules import (
    FreeGiftPromotionCreateDataRelationshipsPromotionRules,
)
from .free_gift_promotion_create_data_relationships_promotion_rules_data import (
    FreeGiftPromotionCreateDataRelationshipsPromotionRulesData,
)
from .free_gift_promotion_create_data_relationships_promotion_rules_data_type import (
    FreeGiftPromotionCreateDataRelationshipsPromotionRulesDataType,
)
from .free_gift_promotion_create_data_relationships_sku_list import FreeGiftPromotionCreateDataRelationshipsSkuList
from .free_gift_promotion_create_data_relationships_sku_list_data import (
    FreeGiftPromotionCreateDataRelationshipsSkuListData,
)
from .free_gift_promotion_create_data_relationships_sku_list_data_type import (
    FreeGiftPromotionCreateDataRelationshipsSkuListDataType,
)
from .free_gift_promotion_create_data_relationships_sku_list_promotion_rule import (
    FreeGiftPromotionCreateDataRelationshipsSkuListPromotionRule,
)
from .free_gift_promotion_create_data_relationships_sku_list_promotion_rule_data import (
    FreeGiftPromotionCreateDataRelationshipsSkuListPromotionRuleData,
)
from .free_gift_promotion_create_data_relationships_sku_list_promotion_rule_data_type import (
    FreeGiftPromotionCreateDataRelationshipsSkuListPromotionRuleDataType,
)
from .free_gift_promotion_create_data_type import FreeGiftPromotionCreateDataType
from .free_gift_promotion_data import FreeGiftPromotionData
from .free_gift_promotion_data_attributes import FreeGiftPromotionDataAttributes
from .free_gift_promotion_data_attributes_metadata import FreeGiftPromotionDataAttributesMetadata
from .free_gift_promotion_data_relationships import FreeGiftPromotionDataRelationships
from .free_gift_promotion_data_relationships_attachments import FreeGiftPromotionDataRelationshipsAttachments
from .free_gift_promotion_data_relationships_attachments_data import FreeGiftPromotionDataRelationshipsAttachmentsData
from .free_gift_promotion_data_relationships_attachments_data_type import (
    FreeGiftPromotionDataRelationshipsAttachmentsDataType,
)
from .free_gift_promotion_data_relationships_coupon_codes_promotion_rule import (
    FreeGiftPromotionDataRelationshipsCouponCodesPromotionRule,
)
from .free_gift_promotion_data_relationships_coupon_codes_promotion_rule_data import (
    FreeGiftPromotionDataRelationshipsCouponCodesPromotionRuleData,
)
from .free_gift_promotion_data_relationships_coupon_codes_promotion_rule_data_type import (
    FreeGiftPromotionDataRelationshipsCouponCodesPromotionRuleDataType,
)
from .free_gift_promotion_data_relationships_market import FreeGiftPromotionDataRelationshipsMarket
from .free_gift_promotion_data_relationships_market_data import FreeGiftPromotionDataRelationshipsMarketData
from .free_gift_promotion_data_relationships_market_data_type import FreeGiftPromotionDataRelationshipsMarketDataType
from .free_gift_promotion_data_relationships_order_amount_promotion_rule import (
    FreeGiftPromotionDataRelationshipsOrderAmountPromotionRule,
)
from .free_gift_promotion_data_relationships_order_amount_promotion_rule_data import (
    FreeGiftPromotionDataRelationshipsOrderAmountPromotionRuleData,
)
from .free_gift_promotion_data_relationships_order_amount_promotion_rule_data_type import (
    FreeGiftPromotionDataRelationshipsOrderAmountPromotionRuleDataType,
)
from .free_gift_promotion_data_relationships_promotion_rules import FreeGiftPromotionDataRelationshipsPromotionRules
from .free_gift_promotion_data_relationships_promotion_rules_data import (
    FreeGiftPromotionDataRelationshipsPromotionRulesData,
)
from .free_gift_promotion_data_relationships_promotion_rules_data_type import (
    FreeGiftPromotionDataRelationshipsPromotionRulesDataType,
)
from .free_gift_promotion_data_relationships_sku_list import FreeGiftPromotionDataRelationshipsSkuList
from .free_gift_promotion_data_relationships_sku_list_data import FreeGiftPromotionDataRelationshipsSkuListData
from .free_gift_promotion_data_relationships_sku_list_data_type import FreeGiftPromotionDataRelationshipsSkuListDataType
from .free_gift_promotion_data_relationships_sku_list_promotion_rule import (
    FreeGiftPromotionDataRelationshipsSkuListPromotionRule,
)
from .free_gift_promotion_data_relationships_sku_list_promotion_rule_data import (
    FreeGiftPromotionDataRelationshipsSkuListPromotionRuleData,
)
from .free_gift_promotion_data_relationships_sku_list_promotion_rule_data_type import (
    FreeGiftPromotionDataRelationshipsSkuListPromotionRuleDataType,
)
from .free_gift_promotion_data_relationships_skus import FreeGiftPromotionDataRelationshipsSkus
from .free_gift_promotion_data_relationships_skus_data import FreeGiftPromotionDataRelationshipsSkusData
from .free_gift_promotion_data_relationships_skus_data_type import FreeGiftPromotionDataRelationshipsSkusDataType
from .free_gift_promotion_data_type import FreeGiftPromotionDataType
from .free_gift_promotion_update import FreeGiftPromotionUpdate
from .free_gift_promotion_update_data import FreeGiftPromotionUpdateData
from .free_gift_promotion_update_data_attributes import FreeGiftPromotionUpdateDataAttributes
from .free_gift_promotion_update_data_attributes_metadata import FreeGiftPromotionUpdateDataAttributesMetadata
from .free_gift_promotion_update_data_relationships import FreeGiftPromotionUpdateDataRelationships
from .free_gift_promotion_update_data_relationships_coupon_codes_promotion_rule import (
    FreeGiftPromotionUpdateDataRelationshipsCouponCodesPromotionRule,
)
from .free_gift_promotion_update_data_relationships_coupon_codes_promotion_rule_data import (
    FreeGiftPromotionUpdateDataRelationshipsCouponCodesPromotionRuleData,
)
from .free_gift_promotion_update_data_relationships_coupon_codes_promotion_rule_data_type import (
    FreeGiftPromotionUpdateDataRelationshipsCouponCodesPromotionRuleDataType,
)
from .free_gift_promotion_update_data_relationships_market import FreeGiftPromotionUpdateDataRelationshipsMarket
from .free_gift_promotion_update_data_relationships_market_data import (
    FreeGiftPromotionUpdateDataRelationshipsMarketData,
)
from .free_gift_promotion_update_data_relationships_market_data_type import (
    FreeGiftPromotionUpdateDataRelationshipsMarketDataType,
)
from .free_gift_promotion_update_data_relationships_order_amount_promotion_rule import (
    FreeGiftPromotionUpdateDataRelationshipsOrderAmountPromotionRule,
)
from .free_gift_promotion_update_data_relationships_order_amount_promotion_rule_data import (
    FreeGiftPromotionUpdateDataRelationshipsOrderAmountPromotionRuleData,
)
from .free_gift_promotion_update_data_relationships_order_amount_promotion_rule_data_type import (
    FreeGiftPromotionUpdateDataRelationshipsOrderAmountPromotionRuleDataType,
)
from .free_gift_promotion_update_data_relationships_promotion_rules import (
    FreeGiftPromotionUpdateDataRelationshipsPromotionRules,
)
from .free_gift_promotion_update_data_relationships_promotion_rules_data import (
    FreeGiftPromotionUpdateDataRelationshipsPromotionRulesData,
)
from .free_gift_promotion_update_data_relationships_promotion_rules_data_type import (
    FreeGiftPromotionUpdateDataRelationshipsPromotionRulesDataType,
)
from .free_gift_promotion_update_data_relationships_sku_list import FreeGiftPromotionUpdateDataRelationshipsSkuList
from .free_gift_promotion_update_data_relationships_sku_list_data import (
    FreeGiftPromotionUpdateDataRelationshipsSkuListData,
)
from .free_gift_promotion_update_data_relationships_sku_list_data_type import (
    FreeGiftPromotionUpdateDataRelationshipsSkuListDataType,
)
from .free_gift_promotion_update_data_relationships_sku_list_promotion_rule import (
    FreeGiftPromotionUpdateDataRelationshipsSkuListPromotionRule,
)
from .free_gift_promotion_update_data_relationships_sku_list_promotion_rule_data import (
    FreeGiftPromotionUpdateDataRelationshipsSkuListPromotionRuleData,
)
from .free_gift_promotion_update_data_relationships_sku_list_promotion_rule_data_type import (
    FreeGiftPromotionUpdateDataRelationshipsSkuListPromotionRuleDataType,
)
from .free_gift_promotion_update_data_type import FreeGiftPromotionUpdateDataType
from .free_shipping_promotion import FreeShippingPromotion
from .free_shipping_promotion_create import FreeShippingPromotionCreate
from .free_shipping_promotion_create_data import FreeShippingPromotionCreateData
from .free_shipping_promotion_create_data_attributes import FreeShippingPromotionCreateDataAttributes
from .free_shipping_promotion_create_data_attributes_metadata import FreeShippingPromotionCreateDataAttributesMetadata
from .free_shipping_promotion_create_data_relationships import FreeShippingPromotionCreateDataRelationships
from .free_shipping_promotion_create_data_relationships_coupon_codes_promotion_rule import (
    FreeShippingPromotionCreateDataRelationshipsCouponCodesPromotionRule,
)
from .free_shipping_promotion_create_data_relationships_coupon_codes_promotion_rule_data import (
    FreeShippingPromotionCreateDataRelationshipsCouponCodesPromotionRuleData,
)
from .free_shipping_promotion_create_data_relationships_coupon_codes_promotion_rule_data_type import (
    FreeShippingPromotionCreateDataRelationshipsCouponCodesPromotionRuleDataType,
)
from .free_shipping_promotion_create_data_relationships_market import FreeShippingPromotionCreateDataRelationshipsMarket
from .free_shipping_promotion_create_data_relationships_market_data import (
    FreeShippingPromotionCreateDataRelationshipsMarketData,
)
from .free_shipping_promotion_create_data_relationships_market_data_type import (
    FreeShippingPromotionCreateDataRelationshipsMarketDataType,
)
from .free_shipping_promotion_create_data_relationships_order_amount_promotion_rule import (
    FreeShippingPromotionCreateDataRelationshipsOrderAmountPromotionRule,
)
from .free_shipping_promotion_create_data_relationships_order_amount_promotion_rule_data import (
    FreeShippingPromotionCreateDataRelationshipsOrderAmountPromotionRuleData,
)
from .free_shipping_promotion_create_data_relationships_order_amount_promotion_rule_data_type import (
    FreeShippingPromotionCreateDataRelationshipsOrderAmountPromotionRuleDataType,
)
from .free_shipping_promotion_create_data_relationships_promotion_rules import (
    FreeShippingPromotionCreateDataRelationshipsPromotionRules,
)
from .free_shipping_promotion_create_data_relationships_promotion_rules_data import (
    FreeShippingPromotionCreateDataRelationshipsPromotionRulesData,
)
from .free_shipping_promotion_create_data_relationships_promotion_rules_data_type import (
    FreeShippingPromotionCreateDataRelationshipsPromotionRulesDataType,
)
from .free_shipping_promotion_create_data_relationships_sku_list_promotion_rule import (
    FreeShippingPromotionCreateDataRelationshipsSkuListPromotionRule,
)
from .free_shipping_promotion_create_data_relationships_sku_list_promotion_rule_data import (
    FreeShippingPromotionCreateDataRelationshipsSkuListPromotionRuleData,
)
from .free_shipping_promotion_create_data_relationships_sku_list_promotion_rule_data_type import (
    FreeShippingPromotionCreateDataRelationshipsSkuListPromotionRuleDataType,
)
from .free_shipping_promotion_create_data_type import FreeShippingPromotionCreateDataType
from .free_shipping_promotion_data import FreeShippingPromotionData
from .free_shipping_promotion_data_attributes import FreeShippingPromotionDataAttributes
from .free_shipping_promotion_data_attributes_metadata import FreeShippingPromotionDataAttributesMetadata
from .free_shipping_promotion_data_relationships import FreeShippingPromotionDataRelationships
from .free_shipping_promotion_data_relationships_attachments import FreeShippingPromotionDataRelationshipsAttachments
from .free_shipping_promotion_data_relationships_attachments_data import (
    FreeShippingPromotionDataRelationshipsAttachmentsData,
)
from .free_shipping_promotion_data_relationships_attachments_data_type import (
    FreeShippingPromotionDataRelationshipsAttachmentsDataType,
)
from .free_shipping_promotion_data_relationships_coupon_codes_promotion_rule import (
    FreeShippingPromotionDataRelationshipsCouponCodesPromotionRule,
)
from .free_shipping_promotion_data_relationships_coupon_codes_promotion_rule_data import (
    FreeShippingPromotionDataRelationshipsCouponCodesPromotionRuleData,
)
from .free_shipping_promotion_data_relationships_coupon_codes_promotion_rule_data_type import (
    FreeShippingPromotionDataRelationshipsCouponCodesPromotionRuleDataType,
)
from .free_shipping_promotion_data_relationships_market import FreeShippingPromotionDataRelationshipsMarket
from .free_shipping_promotion_data_relationships_market_data import FreeShippingPromotionDataRelationshipsMarketData
from .free_shipping_promotion_data_relationships_market_data_type import (
    FreeShippingPromotionDataRelationshipsMarketDataType,
)
from .free_shipping_promotion_data_relationships_order_amount_promotion_rule import (
    FreeShippingPromotionDataRelationshipsOrderAmountPromotionRule,
)
from .free_shipping_promotion_data_relationships_order_amount_promotion_rule_data import (
    FreeShippingPromotionDataRelationshipsOrderAmountPromotionRuleData,
)
from .free_shipping_promotion_data_relationships_order_amount_promotion_rule_data_type import (
    FreeShippingPromotionDataRelationshipsOrderAmountPromotionRuleDataType,
)
from .free_shipping_promotion_data_relationships_promotion_rules import (
    FreeShippingPromotionDataRelationshipsPromotionRules,
)
from .free_shipping_promotion_data_relationships_promotion_rules_data import (
    FreeShippingPromotionDataRelationshipsPromotionRulesData,
)
from .free_shipping_promotion_data_relationships_promotion_rules_data_type import (
    FreeShippingPromotionDataRelationshipsPromotionRulesDataType,
)
from .free_shipping_promotion_data_relationships_sku_list_promotion_rule import (
    FreeShippingPromotionDataRelationshipsSkuListPromotionRule,
)
from .free_shipping_promotion_data_relationships_sku_list_promotion_rule_data import (
    FreeShippingPromotionDataRelationshipsSkuListPromotionRuleData,
)
from .free_shipping_promotion_data_relationships_sku_list_promotion_rule_data_type import (
    FreeShippingPromotionDataRelationshipsSkuListPromotionRuleDataType,
)
from .free_shipping_promotion_data_type import FreeShippingPromotionDataType
from .free_shipping_promotion_update import FreeShippingPromotionUpdate
from .free_shipping_promotion_update_data import FreeShippingPromotionUpdateData
from .free_shipping_promotion_update_data_attributes import FreeShippingPromotionUpdateDataAttributes
from .free_shipping_promotion_update_data_attributes_metadata import FreeShippingPromotionUpdateDataAttributesMetadata
from .free_shipping_promotion_update_data_relationships import FreeShippingPromotionUpdateDataRelationships
from .free_shipping_promotion_update_data_relationships_coupon_codes_promotion_rule import (
    FreeShippingPromotionUpdateDataRelationshipsCouponCodesPromotionRule,
)
from .free_shipping_promotion_update_data_relationships_coupon_codes_promotion_rule_data import (
    FreeShippingPromotionUpdateDataRelationshipsCouponCodesPromotionRuleData,
)
from .free_shipping_promotion_update_data_relationships_coupon_codes_promotion_rule_data_type import (
    FreeShippingPromotionUpdateDataRelationshipsCouponCodesPromotionRuleDataType,
)
from .free_shipping_promotion_update_data_relationships_market import FreeShippingPromotionUpdateDataRelationshipsMarket
from .free_shipping_promotion_update_data_relationships_market_data import (
    FreeShippingPromotionUpdateDataRelationshipsMarketData,
)
from .free_shipping_promotion_update_data_relationships_market_data_type import (
    FreeShippingPromotionUpdateDataRelationshipsMarketDataType,
)
from .free_shipping_promotion_update_data_relationships_order_amount_promotion_rule import (
    FreeShippingPromotionUpdateDataRelationshipsOrderAmountPromotionRule,
)
from .free_shipping_promotion_update_data_relationships_order_amount_promotion_rule_data import (
    FreeShippingPromotionUpdateDataRelationshipsOrderAmountPromotionRuleData,
)
from .free_shipping_promotion_update_data_relationships_order_amount_promotion_rule_data_type import (
    FreeShippingPromotionUpdateDataRelationshipsOrderAmountPromotionRuleDataType,
)
from .free_shipping_promotion_update_data_relationships_promotion_rules import (
    FreeShippingPromotionUpdateDataRelationshipsPromotionRules,
)
from .free_shipping_promotion_update_data_relationships_promotion_rules_data import (
    FreeShippingPromotionUpdateDataRelationshipsPromotionRulesData,
)
from .free_shipping_promotion_update_data_relationships_promotion_rules_data_type import (
    FreeShippingPromotionUpdateDataRelationshipsPromotionRulesDataType,
)
from .free_shipping_promotion_update_data_relationships_sku_list_promotion_rule import (
    FreeShippingPromotionUpdateDataRelationshipsSkuListPromotionRule,
)
from .free_shipping_promotion_update_data_relationships_sku_list_promotion_rule_data import (
    FreeShippingPromotionUpdateDataRelationshipsSkuListPromotionRuleData,
)
from .free_shipping_promotion_update_data_relationships_sku_list_promotion_rule_data_type import (
    FreeShippingPromotionUpdateDataRelationshipsSkuListPromotionRuleDataType,
)
from .free_shipping_promotion_update_data_type import FreeShippingPromotionUpdateDataType
from .ge_taddresses_response_200 import GETaddressesResponse200
from .ge_taddresses_response_200_data_item import GETaddressesResponse200DataItem
from .ge_taddresses_response_200_data_item_attributes import GETaddressesResponse200DataItemAttributes
from .ge_taddresses_response_200_data_item_attributes_metadata import GETaddressesResponse200DataItemAttributesMetadata
from .ge_taddresses_response_200_data_item_links import GETaddressesResponse200DataItemLinks
from .ge_taddresses_response_200_data_item_relationships import GETaddressesResponse200DataItemRelationships
from .ge_taddresses_response_200_data_item_relationships_geocoder import (
    GETaddressesResponse200DataItemRelationshipsGeocoder,
)
from .ge_taddresses_response_200_data_item_relationships_geocoder_data import (
    GETaddressesResponse200DataItemRelationshipsGeocoderData,
)
from .ge_taddresses_response_200_data_item_relationships_geocoder_data_type import (
    GETaddressesResponse200DataItemRelationshipsGeocoderDataType,
)
from .ge_taddresses_response_200_data_item_relationships_geocoder_links import (
    GETaddressesResponse200DataItemRelationshipsGeocoderLinks,
)
from .ge_taddresses_response_200_data_item_type import GETaddressesResponse200DataItemType
from .ge_taddressesaddress_id_response_200 import GETaddressesaddressIdResponse200
from .ge_taddressesaddress_id_response_200_data import GETaddressesaddressIdResponse200Data
from .ge_taddressesaddress_id_response_200_data_attributes import GETaddressesaddressIdResponse200DataAttributes
from .ge_taddressesaddress_id_response_200_data_attributes_metadata import (
    GETaddressesaddressIdResponse200DataAttributesMetadata,
)
from .ge_taddressesaddress_id_response_200_data_links import GETaddressesaddressIdResponse200DataLinks
from .ge_taddressesaddress_id_response_200_data_relationships import GETaddressesaddressIdResponse200DataRelationships
from .ge_taddressesaddress_id_response_200_data_relationships_geocoder import (
    GETaddressesaddressIdResponse200DataRelationshipsGeocoder,
)
from .ge_taddressesaddress_id_response_200_data_relationships_geocoder_data import (
    GETaddressesaddressIdResponse200DataRelationshipsGeocoderData,
)
from .ge_taddressesaddress_id_response_200_data_relationships_geocoder_data_type import (
    GETaddressesaddressIdResponse200DataRelationshipsGeocoderDataType,
)
from .ge_taddressesaddress_id_response_200_data_relationships_geocoder_links import (
    GETaddressesaddressIdResponse200DataRelationshipsGeocoderLinks,
)
from .ge_taddressesaddress_id_response_200_data_type import GETaddressesaddressIdResponse200DataType
from .ge_tadjustments_response_200 import GETadjustmentsResponse200
from .ge_tadjustments_response_200_data_item import GETadjustmentsResponse200DataItem
from .ge_tadjustments_response_200_data_item_attributes import GETadjustmentsResponse200DataItemAttributes
from .ge_tadjustments_response_200_data_item_attributes_metadata import (
    GETadjustmentsResponse200DataItemAttributesMetadata,
)
from .ge_tadjustments_response_200_data_item_links import GETadjustmentsResponse200DataItemLinks
from .ge_tadjustments_response_200_data_item_relationships import GETadjustmentsResponse200DataItemRelationships
from .ge_tadjustments_response_200_data_item_type import GETadjustmentsResponse200DataItemType
from .ge_tadjustmentsadjustment_id_response_200 import GETadjustmentsadjustmentIdResponse200
from .ge_tadjustmentsadjustment_id_response_200_data import GETadjustmentsadjustmentIdResponse200Data
from .ge_tadjustmentsadjustment_id_response_200_data_attributes import (
    GETadjustmentsadjustmentIdResponse200DataAttributes,
)
from .ge_tadjustmentsadjustment_id_response_200_data_attributes_metadata import (
    GETadjustmentsadjustmentIdResponse200DataAttributesMetadata,
)
from .ge_tadjustmentsadjustment_id_response_200_data_links import GETadjustmentsadjustmentIdResponse200DataLinks
from .ge_tadjustmentsadjustment_id_response_200_data_relationships import (
    GETadjustmentsadjustmentIdResponse200DataRelationships,
)
from .ge_tadjustmentsadjustment_id_response_200_data_type import GETadjustmentsadjustmentIdResponse200DataType
from .ge_tadyen_gateways_response_200 import GETadyenGatewaysResponse200
from .ge_tadyen_gateways_response_200_data_item import GETadyenGatewaysResponse200DataItem
from .ge_tadyen_gateways_response_200_data_item_attributes import GETadyenGatewaysResponse200DataItemAttributes
from .ge_tadyen_gateways_response_200_data_item_attributes_metadata import (
    GETadyenGatewaysResponse200DataItemAttributesMetadata,
)
from .ge_tadyen_gateways_response_200_data_item_links import GETadyenGatewaysResponse200DataItemLinks
from .ge_tadyen_gateways_response_200_data_item_relationships import GETadyenGatewaysResponse200DataItemRelationships
from .ge_tadyen_gateways_response_200_data_item_relationships_adyen_payments import (
    GETadyenGatewaysResponse200DataItemRelationshipsAdyenPayments,
)
from .ge_tadyen_gateways_response_200_data_item_relationships_adyen_payments_data import (
    GETadyenGatewaysResponse200DataItemRelationshipsAdyenPaymentsData,
)
from .ge_tadyen_gateways_response_200_data_item_relationships_adyen_payments_data_type import (
    GETadyenGatewaysResponse200DataItemRelationshipsAdyenPaymentsDataType,
)
from .ge_tadyen_gateways_response_200_data_item_relationships_adyen_payments_links import (
    GETadyenGatewaysResponse200DataItemRelationshipsAdyenPaymentsLinks,
)
from .ge_tadyen_gateways_response_200_data_item_relationships_payment_methods import (
    GETadyenGatewaysResponse200DataItemRelationshipsPaymentMethods,
)
from .ge_tadyen_gateways_response_200_data_item_relationships_payment_methods_data import (
    GETadyenGatewaysResponse200DataItemRelationshipsPaymentMethodsData,
)
from .ge_tadyen_gateways_response_200_data_item_relationships_payment_methods_data_type import (
    GETadyenGatewaysResponse200DataItemRelationshipsPaymentMethodsDataType,
)
from .ge_tadyen_gateways_response_200_data_item_relationships_payment_methods_links import (
    GETadyenGatewaysResponse200DataItemRelationshipsPaymentMethodsLinks,
)
from .ge_tadyen_gateways_response_200_data_item_type import GETadyenGatewaysResponse200DataItemType
from .ge_tadyen_gatewaysadyen_gateway_id_response_200 import GETadyenGatewaysadyenGatewayIdResponse200
from .ge_tadyen_gatewaysadyen_gateway_id_response_200_data import GETadyenGatewaysadyenGatewayIdResponse200Data
from .ge_tadyen_gatewaysadyen_gateway_id_response_200_data_attributes import (
    GETadyenGatewaysadyenGatewayIdResponse200DataAttributes,
)
from .ge_tadyen_gatewaysadyen_gateway_id_response_200_data_attributes_metadata import (
    GETadyenGatewaysadyenGatewayIdResponse200DataAttributesMetadata,
)
from .ge_tadyen_gatewaysadyen_gateway_id_response_200_data_links import (
    GETadyenGatewaysadyenGatewayIdResponse200DataLinks,
)
from .ge_tadyen_gatewaysadyen_gateway_id_response_200_data_relationships import (
    GETadyenGatewaysadyenGatewayIdResponse200DataRelationships,
)
from .ge_tadyen_gatewaysadyen_gateway_id_response_200_data_relationships_adyen_payments import (
    GETadyenGatewaysadyenGatewayIdResponse200DataRelationshipsAdyenPayments,
)
from .ge_tadyen_gatewaysadyen_gateway_id_response_200_data_relationships_adyen_payments_data import (
    GETadyenGatewaysadyenGatewayIdResponse200DataRelationshipsAdyenPaymentsData,
)
from .ge_tadyen_gatewaysadyen_gateway_id_response_200_data_relationships_adyen_payments_data_type import (
    GETadyenGatewaysadyenGatewayIdResponse200DataRelationshipsAdyenPaymentsDataType,
)
from .ge_tadyen_gatewaysadyen_gateway_id_response_200_data_relationships_adyen_payments_links import (
    GETadyenGatewaysadyenGatewayIdResponse200DataRelationshipsAdyenPaymentsLinks,
)
from .ge_tadyen_gatewaysadyen_gateway_id_response_200_data_relationships_payment_methods import (
    GETadyenGatewaysadyenGatewayIdResponse200DataRelationshipsPaymentMethods,
)
from .ge_tadyen_gatewaysadyen_gateway_id_response_200_data_relationships_payment_methods_data import (
    GETadyenGatewaysadyenGatewayIdResponse200DataRelationshipsPaymentMethodsData,
)
from .ge_tadyen_gatewaysadyen_gateway_id_response_200_data_relationships_payment_methods_data_type import (
    GETadyenGatewaysadyenGatewayIdResponse200DataRelationshipsPaymentMethodsDataType,
)
from .ge_tadyen_gatewaysadyen_gateway_id_response_200_data_relationships_payment_methods_links import (
    GETadyenGatewaysadyenGatewayIdResponse200DataRelationshipsPaymentMethodsLinks,
)
from .ge_tadyen_gatewaysadyen_gateway_id_response_200_data_type import GETadyenGatewaysadyenGatewayIdResponse200DataType
from .ge_tadyen_payments_response_200 import GETadyenPaymentsResponse200
from .ge_tadyen_payments_response_200_data_item import GETadyenPaymentsResponse200DataItem
from .ge_tadyen_payments_response_200_data_item_attributes import GETadyenPaymentsResponse200DataItemAttributes
from .ge_tadyen_payments_response_200_data_item_attributes_metadata import (
    GETadyenPaymentsResponse200DataItemAttributesMetadata,
)
from .ge_tadyen_payments_response_200_data_item_attributes_payment_methods import (
    GETadyenPaymentsResponse200DataItemAttributesPaymentMethods,
)
from .ge_tadyen_payments_response_200_data_item_attributes_payment_request_data import (
    GETadyenPaymentsResponse200DataItemAttributesPaymentRequestData,
)
from .ge_tadyen_payments_response_200_data_item_attributes_payment_request_details import (
    GETadyenPaymentsResponse200DataItemAttributesPaymentRequestDetails,
)
from .ge_tadyen_payments_response_200_data_item_attributes_payment_response import (
    GETadyenPaymentsResponse200DataItemAttributesPaymentResponse,
)
from .ge_tadyen_payments_response_200_data_item_links import GETadyenPaymentsResponse200DataItemLinks
from .ge_tadyen_payments_response_200_data_item_relationships import GETadyenPaymentsResponse200DataItemRelationships
from .ge_tadyen_payments_response_200_data_item_relationships_order import (
    GETadyenPaymentsResponse200DataItemRelationshipsOrder,
)
from .ge_tadyen_payments_response_200_data_item_relationships_order_data import (
    GETadyenPaymentsResponse200DataItemRelationshipsOrderData,
)
from .ge_tadyen_payments_response_200_data_item_relationships_order_data_type import (
    GETadyenPaymentsResponse200DataItemRelationshipsOrderDataType,
)
from .ge_tadyen_payments_response_200_data_item_relationships_order_links import (
    GETadyenPaymentsResponse200DataItemRelationshipsOrderLinks,
)
from .ge_tadyen_payments_response_200_data_item_relationships_payment_gateway import (
    GETadyenPaymentsResponse200DataItemRelationshipsPaymentGateway,
)
from .ge_tadyen_payments_response_200_data_item_relationships_payment_gateway_data import (
    GETadyenPaymentsResponse200DataItemRelationshipsPaymentGatewayData,
)
from .ge_tadyen_payments_response_200_data_item_relationships_payment_gateway_data_type import (
    GETadyenPaymentsResponse200DataItemRelationshipsPaymentGatewayDataType,
)
from .ge_tadyen_payments_response_200_data_item_relationships_payment_gateway_links import (
    GETadyenPaymentsResponse200DataItemRelationshipsPaymentGatewayLinks,
)
from .ge_tadyen_payments_response_200_data_item_type import GETadyenPaymentsResponse200DataItemType
from .ge_tadyen_paymentsadyen_payment_id_response_200 import GETadyenPaymentsadyenPaymentIdResponse200
from .ge_tadyen_paymentsadyen_payment_id_response_200_data import GETadyenPaymentsadyenPaymentIdResponse200Data
from .ge_tadyen_paymentsadyen_payment_id_response_200_data_attributes import (
    GETadyenPaymentsadyenPaymentIdResponse200DataAttributes,
)
from .ge_tadyen_paymentsadyen_payment_id_response_200_data_attributes_metadata import (
    GETadyenPaymentsadyenPaymentIdResponse200DataAttributesMetadata,
)
from .ge_tadyen_paymentsadyen_payment_id_response_200_data_attributes_payment_methods import (
    GETadyenPaymentsadyenPaymentIdResponse200DataAttributesPaymentMethods,
)
from .ge_tadyen_paymentsadyen_payment_id_response_200_data_attributes_payment_request_data import (
    GETadyenPaymentsadyenPaymentIdResponse200DataAttributesPaymentRequestData,
)
from .ge_tadyen_paymentsadyen_payment_id_response_200_data_attributes_payment_request_details import (
    GETadyenPaymentsadyenPaymentIdResponse200DataAttributesPaymentRequestDetails,
)
from .ge_tadyen_paymentsadyen_payment_id_response_200_data_attributes_payment_response import (
    GETadyenPaymentsadyenPaymentIdResponse200DataAttributesPaymentResponse,
)
from .ge_tadyen_paymentsadyen_payment_id_response_200_data_links import (
    GETadyenPaymentsadyenPaymentIdResponse200DataLinks,
)
from .ge_tadyen_paymentsadyen_payment_id_response_200_data_relationships import (
    GETadyenPaymentsadyenPaymentIdResponse200DataRelationships,
)
from .ge_tadyen_paymentsadyen_payment_id_response_200_data_relationships_order import (
    GETadyenPaymentsadyenPaymentIdResponse200DataRelationshipsOrder,
)
from .ge_tadyen_paymentsadyen_payment_id_response_200_data_relationships_order_data import (
    GETadyenPaymentsadyenPaymentIdResponse200DataRelationshipsOrderData,
)
from .ge_tadyen_paymentsadyen_payment_id_response_200_data_relationships_order_data_type import (
    GETadyenPaymentsadyenPaymentIdResponse200DataRelationshipsOrderDataType,
)
from .ge_tadyen_paymentsadyen_payment_id_response_200_data_relationships_order_links import (
    GETadyenPaymentsadyenPaymentIdResponse200DataRelationshipsOrderLinks,
)
from .ge_tadyen_paymentsadyen_payment_id_response_200_data_relationships_payment_gateway import (
    GETadyenPaymentsadyenPaymentIdResponse200DataRelationshipsPaymentGateway,
)
from .ge_tadyen_paymentsadyen_payment_id_response_200_data_relationships_payment_gateway_data import (
    GETadyenPaymentsadyenPaymentIdResponse200DataRelationshipsPaymentGatewayData,
)
from .ge_tadyen_paymentsadyen_payment_id_response_200_data_relationships_payment_gateway_data_type import (
    GETadyenPaymentsadyenPaymentIdResponse200DataRelationshipsPaymentGatewayDataType,
)
from .ge_tadyen_paymentsadyen_payment_id_response_200_data_relationships_payment_gateway_links import (
    GETadyenPaymentsadyenPaymentIdResponse200DataRelationshipsPaymentGatewayLinks,
)
from .ge_tadyen_paymentsadyen_payment_id_response_200_data_type import GETadyenPaymentsadyenPaymentIdResponse200DataType
from .ge_tapplicationapplication_id_response_200 import GETapplicationapplicationIdResponse200
from .ge_tapplicationapplication_id_response_200_data import GETapplicationapplicationIdResponse200Data
from .ge_tapplicationapplication_id_response_200_data_attributes import (
    GETapplicationapplicationIdResponse200DataAttributes,
)
from .ge_tapplicationapplication_id_response_200_data_attributes_metadata import (
    GETapplicationapplicationIdResponse200DataAttributesMetadata,
)
from .ge_tapplicationapplication_id_response_200_data_links import GETapplicationapplicationIdResponse200DataLinks
from .ge_tapplicationapplication_id_response_200_data_relationships import (
    GETapplicationapplicationIdResponse200DataRelationships,
)
from .ge_tapplicationapplication_id_response_200_data_type import GETapplicationapplicationIdResponse200DataType
from .ge_tattachments_response_200 import GETattachmentsResponse200
from .ge_tattachments_response_200_data_item import GETattachmentsResponse200DataItem
from .ge_tattachments_response_200_data_item_attributes import GETattachmentsResponse200DataItemAttributes
from .ge_tattachments_response_200_data_item_attributes_metadata import (
    GETattachmentsResponse200DataItemAttributesMetadata,
)
from .ge_tattachments_response_200_data_item_links import GETattachmentsResponse200DataItemLinks
from .ge_tattachments_response_200_data_item_relationships import GETattachmentsResponse200DataItemRelationships
from .ge_tattachments_response_200_data_item_relationships_attachable import (
    GETattachmentsResponse200DataItemRelationshipsAttachable,
)
from .ge_tattachments_response_200_data_item_relationships_attachable_data import (
    GETattachmentsResponse200DataItemRelationshipsAttachableData,
)
from .ge_tattachments_response_200_data_item_relationships_attachable_data_type import (
    GETattachmentsResponse200DataItemRelationshipsAttachableDataType,
)
from .ge_tattachments_response_200_data_item_relationships_attachable_links import (
    GETattachmentsResponse200DataItemRelationshipsAttachableLinks,
)
from .ge_tattachments_response_200_data_item_type import GETattachmentsResponse200DataItemType
from .ge_tattachmentsattachment_id_response_200 import GETattachmentsattachmentIdResponse200
from .ge_tattachmentsattachment_id_response_200_data import GETattachmentsattachmentIdResponse200Data
from .ge_tattachmentsattachment_id_response_200_data_attributes import (
    GETattachmentsattachmentIdResponse200DataAttributes,
)
from .ge_tattachmentsattachment_id_response_200_data_attributes_metadata import (
    GETattachmentsattachmentIdResponse200DataAttributesMetadata,
)
from .ge_tattachmentsattachment_id_response_200_data_links import GETattachmentsattachmentIdResponse200DataLinks
from .ge_tattachmentsattachment_id_response_200_data_relationships import (
    GETattachmentsattachmentIdResponse200DataRelationships,
)
from .ge_tattachmentsattachment_id_response_200_data_relationships_attachable import (
    GETattachmentsattachmentIdResponse200DataRelationshipsAttachable,
)
from .ge_tattachmentsattachment_id_response_200_data_relationships_attachable_data import (
    GETattachmentsattachmentIdResponse200DataRelationshipsAttachableData,
)
from .ge_tattachmentsattachment_id_response_200_data_relationships_attachable_data_type import (
    GETattachmentsattachmentIdResponse200DataRelationshipsAttachableDataType,
)
from .ge_tattachmentsattachment_id_response_200_data_relationships_attachable_links import (
    GETattachmentsattachmentIdResponse200DataRelationshipsAttachableLinks,
)
from .ge_tattachmentsattachment_id_response_200_data_type import GETattachmentsattachmentIdResponse200DataType
from .ge_tauthorizations_response_200 import GETauthorizationsResponse200
from .ge_tauthorizations_response_200_data_item import GETauthorizationsResponse200DataItem
from .ge_tauthorizations_response_200_data_item_attributes import GETauthorizationsResponse200DataItemAttributes
from .ge_tauthorizations_response_200_data_item_attributes_metadata import (
    GETauthorizationsResponse200DataItemAttributesMetadata,
)
from .ge_tauthorizations_response_200_data_item_links import GETauthorizationsResponse200DataItemLinks
from .ge_tauthorizations_response_200_data_item_relationships import GETauthorizationsResponse200DataItemRelationships
from .ge_tauthorizations_response_200_data_item_relationships_captures import (
    GETauthorizationsResponse200DataItemRelationshipsCaptures,
)
from .ge_tauthorizations_response_200_data_item_relationships_captures_data import (
    GETauthorizationsResponse200DataItemRelationshipsCapturesData,
)
from .ge_tauthorizations_response_200_data_item_relationships_captures_data_type import (
    GETauthorizationsResponse200DataItemRelationshipsCapturesDataType,
)
from .ge_tauthorizations_response_200_data_item_relationships_captures_links import (
    GETauthorizationsResponse200DataItemRelationshipsCapturesLinks,
)
from .ge_tauthorizations_response_200_data_item_relationships_order import (
    GETauthorizationsResponse200DataItemRelationshipsOrder,
)
from .ge_tauthorizations_response_200_data_item_relationships_order_data import (
    GETauthorizationsResponse200DataItemRelationshipsOrderData,
)
from .ge_tauthorizations_response_200_data_item_relationships_order_data_type import (
    GETauthorizationsResponse200DataItemRelationshipsOrderDataType,
)
from .ge_tauthorizations_response_200_data_item_relationships_order_links import (
    GETauthorizationsResponse200DataItemRelationshipsOrderLinks,
)
from .ge_tauthorizations_response_200_data_item_relationships_voids import (
    GETauthorizationsResponse200DataItemRelationshipsVoids,
)
from .ge_tauthorizations_response_200_data_item_relationships_voids_data import (
    GETauthorizationsResponse200DataItemRelationshipsVoidsData,
)
from .ge_tauthorizations_response_200_data_item_relationships_voids_data_type import (
    GETauthorizationsResponse200DataItemRelationshipsVoidsDataType,
)
from .ge_tauthorizations_response_200_data_item_relationships_voids_links import (
    GETauthorizationsResponse200DataItemRelationshipsVoidsLinks,
)
from .ge_tauthorizations_response_200_data_item_type import GETauthorizationsResponse200DataItemType
from .ge_tauthorizationsauthorization_id_response_200 import GETauthorizationsauthorizationIdResponse200
from .ge_tauthorizationsauthorization_id_response_200_data import GETauthorizationsauthorizationIdResponse200Data
from .ge_tauthorizationsauthorization_id_response_200_data_attributes import (
    GETauthorizationsauthorizationIdResponse200DataAttributes,
)
from .ge_tauthorizationsauthorization_id_response_200_data_attributes_metadata import (
    GETauthorizationsauthorizationIdResponse200DataAttributesMetadata,
)
from .ge_tauthorizationsauthorization_id_response_200_data_links import (
    GETauthorizationsauthorizationIdResponse200DataLinks,
)
from .ge_tauthorizationsauthorization_id_response_200_data_relationships import (
    GETauthorizationsauthorizationIdResponse200DataRelationships,
)
from .ge_tauthorizationsauthorization_id_response_200_data_relationships_captures import (
    GETauthorizationsauthorizationIdResponse200DataRelationshipsCaptures,
)
from .ge_tauthorizationsauthorization_id_response_200_data_relationships_captures_data import (
    GETauthorizationsauthorizationIdResponse200DataRelationshipsCapturesData,
)
from .ge_tauthorizationsauthorization_id_response_200_data_relationships_captures_data_type import (
    GETauthorizationsauthorizationIdResponse200DataRelationshipsCapturesDataType,
)
from .ge_tauthorizationsauthorization_id_response_200_data_relationships_captures_links import (
    GETauthorizationsauthorizationIdResponse200DataRelationshipsCapturesLinks,
)
from .ge_tauthorizationsauthorization_id_response_200_data_relationships_order import (
    GETauthorizationsauthorizationIdResponse200DataRelationshipsOrder,
)
from .ge_tauthorizationsauthorization_id_response_200_data_relationships_order_data import (
    GETauthorizationsauthorizationIdResponse200DataRelationshipsOrderData,
)
from .ge_tauthorizationsauthorization_id_response_200_data_relationships_order_data_type import (
    GETauthorizationsauthorizationIdResponse200DataRelationshipsOrderDataType,
)
from .ge_tauthorizationsauthorization_id_response_200_data_relationships_order_links import (
    GETauthorizationsauthorizationIdResponse200DataRelationshipsOrderLinks,
)
from .ge_tauthorizationsauthorization_id_response_200_data_relationships_voids import (
    GETauthorizationsauthorizationIdResponse200DataRelationshipsVoids,
)
from .ge_tauthorizationsauthorization_id_response_200_data_relationships_voids_data import (
    GETauthorizationsauthorizationIdResponse200DataRelationshipsVoidsData,
)
from .ge_tauthorizationsauthorization_id_response_200_data_relationships_voids_data_type import (
    GETauthorizationsauthorizationIdResponse200DataRelationshipsVoidsDataType,
)
from .ge_tauthorizationsauthorization_id_response_200_data_relationships_voids_links import (
    GETauthorizationsauthorizationIdResponse200DataRelationshipsVoidsLinks,
)
from .ge_tauthorizationsauthorization_id_response_200_data_type import (
    GETauthorizationsauthorizationIdResponse200DataType,
)
from .ge_tavalara_accounts_response_200 import GETavalaraAccountsResponse200
from .ge_tavalara_accounts_response_200_data_item import GETavalaraAccountsResponse200DataItem
from .ge_tavalara_accounts_response_200_data_item_attributes import GETavalaraAccountsResponse200DataItemAttributes
from .ge_tavalara_accounts_response_200_data_item_attributes_metadata import (
    GETavalaraAccountsResponse200DataItemAttributesMetadata,
)
from .ge_tavalara_accounts_response_200_data_item_links import GETavalaraAccountsResponse200DataItemLinks
from .ge_tavalara_accounts_response_200_data_item_relationships import (
    GETavalaraAccountsResponse200DataItemRelationships,
)
from .ge_tavalara_accounts_response_200_data_item_relationships_attachments import (
    GETavalaraAccountsResponse200DataItemRelationshipsAttachments,
)
from .ge_tavalara_accounts_response_200_data_item_relationships_attachments_data import (
    GETavalaraAccountsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tavalara_accounts_response_200_data_item_relationships_attachments_data_type import (
    GETavalaraAccountsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tavalara_accounts_response_200_data_item_relationships_attachments_links import (
    GETavalaraAccountsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tavalara_accounts_response_200_data_item_relationships_markets import (
    GETavalaraAccountsResponse200DataItemRelationshipsMarkets,
)
from .ge_tavalara_accounts_response_200_data_item_relationships_markets_data import (
    GETavalaraAccountsResponse200DataItemRelationshipsMarketsData,
)
from .ge_tavalara_accounts_response_200_data_item_relationships_markets_data_type import (
    GETavalaraAccountsResponse200DataItemRelationshipsMarketsDataType,
)
from .ge_tavalara_accounts_response_200_data_item_relationships_markets_links import (
    GETavalaraAccountsResponse200DataItemRelationshipsMarketsLinks,
)
from .ge_tavalara_accounts_response_200_data_item_relationships_tax_categories import (
    GETavalaraAccountsResponse200DataItemRelationshipsTaxCategories,
)
from .ge_tavalara_accounts_response_200_data_item_relationships_tax_categories_data import (
    GETavalaraAccountsResponse200DataItemRelationshipsTaxCategoriesData,
)
from .ge_tavalara_accounts_response_200_data_item_relationships_tax_categories_data_type import (
    GETavalaraAccountsResponse200DataItemRelationshipsTaxCategoriesDataType,
)
from .ge_tavalara_accounts_response_200_data_item_relationships_tax_categories_links import (
    GETavalaraAccountsResponse200DataItemRelationshipsTaxCategoriesLinks,
)
from .ge_tavalara_accounts_response_200_data_item_type import GETavalaraAccountsResponse200DataItemType
from .ge_tavalara_accountsavalara_account_id_response_200 import GETavalaraAccountsavalaraAccountIdResponse200
from .ge_tavalara_accountsavalara_account_id_response_200_data import GETavalaraAccountsavalaraAccountIdResponse200Data
from .ge_tavalara_accountsavalara_account_id_response_200_data_attributes import (
    GETavalaraAccountsavalaraAccountIdResponse200DataAttributes,
)
from .ge_tavalara_accountsavalara_account_id_response_200_data_attributes_metadata import (
    GETavalaraAccountsavalaraAccountIdResponse200DataAttributesMetadata,
)
from .ge_tavalara_accountsavalara_account_id_response_200_data_links import (
    GETavalaraAccountsavalaraAccountIdResponse200DataLinks,
)
from .ge_tavalara_accountsavalara_account_id_response_200_data_relationships import (
    GETavalaraAccountsavalaraAccountIdResponse200DataRelationships,
)
from .ge_tavalara_accountsavalara_account_id_response_200_data_relationships_attachments import (
    GETavalaraAccountsavalaraAccountIdResponse200DataRelationshipsAttachments,
)
from .ge_tavalara_accountsavalara_account_id_response_200_data_relationships_attachments_data import (
    GETavalaraAccountsavalaraAccountIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tavalara_accountsavalara_account_id_response_200_data_relationships_attachments_data_type import (
    GETavalaraAccountsavalaraAccountIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tavalara_accountsavalara_account_id_response_200_data_relationships_attachments_links import (
    GETavalaraAccountsavalaraAccountIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tavalara_accountsavalara_account_id_response_200_data_relationships_markets import (
    GETavalaraAccountsavalaraAccountIdResponse200DataRelationshipsMarkets,
)
from .ge_tavalara_accountsavalara_account_id_response_200_data_relationships_markets_data import (
    GETavalaraAccountsavalaraAccountIdResponse200DataRelationshipsMarketsData,
)
from .ge_tavalara_accountsavalara_account_id_response_200_data_relationships_markets_data_type import (
    GETavalaraAccountsavalaraAccountIdResponse200DataRelationshipsMarketsDataType,
)
from .ge_tavalara_accountsavalara_account_id_response_200_data_relationships_markets_links import (
    GETavalaraAccountsavalaraAccountIdResponse200DataRelationshipsMarketsLinks,
)
from .ge_tavalara_accountsavalara_account_id_response_200_data_relationships_tax_categories import (
    GETavalaraAccountsavalaraAccountIdResponse200DataRelationshipsTaxCategories,
)
from .ge_tavalara_accountsavalara_account_id_response_200_data_relationships_tax_categories_data import (
    GETavalaraAccountsavalaraAccountIdResponse200DataRelationshipsTaxCategoriesData,
)
from .ge_tavalara_accountsavalara_account_id_response_200_data_relationships_tax_categories_data_type import (
    GETavalaraAccountsavalaraAccountIdResponse200DataRelationshipsTaxCategoriesDataType,
)
from .ge_tavalara_accountsavalara_account_id_response_200_data_relationships_tax_categories_links import (
    GETavalaraAccountsavalaraAccountIdResponse200DataRelationshipsTaxCategoriesLinks,
)
from .ge_tavalara_accountsavalara_account_id_response_200_data_type import (
    GETavalaraAccountsavalaraAccountIdResponse200DataType,
)
from .ge_tbilling_info_validation_rules_response_200 import GETbillingInfoValidationRulesResponse200
from .ge_tbilling_info_validation_rules_response_200_data_item import GETbillingInfoValidationRulesResponse200DataItem
from .ge_tbilling_info_validation_rules_response_200_data_item_attributes import (
    GETbillingInfoValidationRulesResponse200DataItemAttributes,
)
from .ge_tbilling_info_validation_rules_response_200_data_item_attributes_metadata import (
    GETbillingInfoValidationRulesResponse200DataItemAttributesMetadata,
)
from .ge_tbilling_info_validation_rules_response_200_data_item_links import (
    GETbillingInfoValidationRulesResponse200DataItemLinks,
)
from .ge_tbilling_info_validation_rules_response_200_data_item_relationships import (
    GETbillingInfoValidationRulesResponse200DataItemRelationships,
)
from .ge_tbilling_info_validation_rules_response_200_data_item_relationships_market import (
    GETbillingInfoValidationRulesResponse200DataItemRelationshipsMarket,
)
from .ge_tbilling_info_validation_rules_response_200_data_item_relationships_market_data import (
    GETbillingInfoValidationRulesResponse200DataItemRelationshipsMarketData,
)
from .ge_tbilling_info_validation_rules_response_200_data_item_relationships_market_data_type import (
    GETbillingInfoValidationRulesResponse200DataItemRelationshipsMarketDataType,
)
from .ge_tbilling_info_validation_rules_response_200_data_item_relationships_market_links import (
    GETbillingInfoValidationRulesResponse200DataItemRelationshipsMarketLinks,
)
from .ge_tbilling_info_validation_rules_response_200_data_item_type import (
    GETbillingInfoValidationRulesResponse200DataItemType,
)
from .ge_tbilling_info_validation_rulesbilling_info_validation_rule_id_response_200 import (
    GETbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200,
)
from .ge_tbilling_info_validation_rulesbilling_info_validation_rule_id_response_200_data import (
    GETbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200Data,
)
from .ge_tbilling_info_validation_rulesbilling_info_validation_rule_id_response_200_data_attributes import (
    GETbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataAttributes,
)
from .ge_tbilling_info_validation_rulesbilling_info_validation_rule_id_response_200_data_attributes_metadata import (
    GETbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataAttributesMetadata,
)
from .ge_tbilling_info_validation_rulesbilling_info_validation_rule_id_response_200_data_links import (
    GETbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataLinks,
)
from .ge_tbilling_info_validation_rulesbilling_info_validation_rule_id_response_200_data_relationships import (
    GETbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataRelationships,
)
from .ge_tbilling_info_validation_rulesbilling_info_validation_rule_id_response_200_data_relationships_market import (
    GETbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataRelationshipsMarket,
)
from .ge_tbilling_info_validation_rulesbilling_info_validation_rule_id_response_200_data_relationships_market_data import (
    GETbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataRelationshipsMarketData,
)
from .ge_tbilling_info_validation_rulesbilling_info_validation_rule_id_response_200_data_relationships_market_data_type import (
    GETbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataRelationshipsMarketDataType,
)
from .ge_tbilling_info_validation_rulesbilling_info_validation_rule_id_response_200_data_relationships_market_links import (
    GETbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataRelationshipsMarketLinks,
)
from .ge_tbilling_info_validation_rulesbilling_info_validation_rule_id_response_200_data_type import (
    GETbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataType,
)
from .ge_tbing_geocoders_response_200 import GETbingGeocodersResponse200
from .ge_tbing_geocoders_response_200_data_item import GETbingGeocodersResponse200DataItem
from .ge_tbing_geocoders_response_200_data_item_attributes import GETbingGeocodersResponse200DataItemAttributes
from .ge_tbing_geocoders_response_200_data_item_attributes_metadata import (
    GETbingGeocodersResponse200DataItemAttributesMetadata,
)
from .ge_tbing_geocoders_response_200_data_item_links import GETbingGeocodersResponse200DataItemLinks
from .ge_tbing_geocoders_response_200_data_item_relationships import GETbingGeocodersResponse200DataItemRelationships
from .ge_tbing_geocoders_response_200_data_item_relationships_addresses import (
    GETbingGeocodersResponse200DataItemRelationshipsAddresses,
)
from .ge_tbing_geocoders_response_200_data_item_relationships_addresses_data import (
    GETbingGeocodersResponse200DataItemRelationshipsAddressesData,
)
from .ge_tbing_geocoders_response_200_data_item_relationships_addresses_data_type import (
    GETbingGeocodersResponse200DataItemRelationshipsAddressesDataType,
)
from .ge_tbing_geocoders_response_200_data_item_relationships_addresses_links import (
    GETbingGeocodersResponse200DataItemRelationshipsAddressesLinks,
)
from .ge_tbing_geocoders_response_200_data_item_relationships_attachments import (
    GETbingGeocodersResponse200DataItemRelationshipsAttachments,
)
from .ge_tbing_geocoders_response_200_data_item_relationships_attachments_data import (
    GETbingGeocodersResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tbing_geocoders_response_200_data_item_relationships_attachments_data_type import (
    GETbingGeocodersResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tbing_geocoders_response_200_data_item_relationships_attachments_links import (
    GETbingGeocodersResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tbing_geocoders_response_200_data_item_type import GETbingGeocodersResponse200DataItemType
from .ge_tbing_geocodersbing_geocoder_id_response_200 import GETbingGeocodersbingGeocoderIdResponse200
from .ge_tbing_geocodersbing_geocoder_id_response_200_data import GETbingGeocodersbingGeocoderIdResponse200Data
from .ge_tbing_geocodersbing_geocoder_id_response_200_data_attributes import (
    GETbingGeocodersbingGeocoderIdResponse200DataAttributes,
)
from .ge_tbing_geocodersbing_geocoder_id_response_200_data_attributes_metadata import (
    GETbingGeocodersbingGeocoderIdResponse200DataAttributesMetadata,
)
from .ge_tbing_geocodersbing_geocoder_id_response_200_data_links import (
    GETbingGeocodersbingGeocoderIdResponse200DataLinks,
)
from .ge_tbing_geocodersbing_geocoder_id_response_200_data_relationships import (
    GETbingGeocodersbingGeocoderIdResponse200DataRelationships,
)
from .ge_tbing_geocodersbing_geocoder_id_response_200_data_relationships_addresses import (
    GETbingGeocodersbingGeocoderIdResponse200DataRelationshipsAddresses,
)
from .ge_tbing_geocodersbing_geocoder_id_response_200_data_relationships_addresses_data import (
    GETbingGeocodersbingGeocoderIdResponse200DataRelationshipsAddressesData,
)
from .ge_tbing_geocodersbing_geocoder_id_response_200_data_relationships_addresses_data_type import (
    GETbingGeocodersbingGeocoderIdResponse200DataRelationshipsAddressesDataType,
)
from .ge_tbing_geocodersbing_geocoder_id_response_200_data_relationships_addresses_links import (
    GETbingGeocodersbingGeocoderIdResponse200DataRelationshipsAddressesLinks,
)
from .ge_tbing_geocodersbing_geocoder_id_response_200_data_relationships_attachments import (
    GETbingGeocodersbingGeocoderIdResponse200DataRelationshipsAttachments,
)
from .ge_tbing_geocodersbing_geocoder_id_response_200_data_relationships_attachments_data import (
    GETbingGeocodersbingGeocoderIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tbing_geocodersbing_geocoder_id_response_200_data_relationships_attachments_data_type import (
    GETbingGeocodersbingGeocoderIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tbing_geocodersbing_geocoder_id_response_200_data_relationships_attachments_links import (
    GETbingGeocodersbingGeocoderIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tbing_geocodersbing_geocoder_id_response_200_data_type import GETbingGeocodersbingGeocoderIdResponse200DataType
from .ge_tbraintree_gateways_response_200 import GETbraintreeGatewaysResponse200
from .ge_tbraintree_gateways_response_200_data_item import GETbraintreeGatewaysResponse200DataItem
from .ge_tbraintree_gateways_response_200_data_item_attributes import GETbraintreeGatewaysResponse200DataItemAttributes
from .ge_tbraintree_gateways_response_200_data_item_attributes_metadata import (
    GETbraintreeGatewaysResponse200DataItemAttributesMetadata,
)
from .ge_tbraintree_gateways_response_200_data_item_links import GETbraintreeGatewaysResponse200DataItemLinks
from .ge_tbraintree_gateways_response_200_data_item_relationships import (
    GETbraintreeGatewaysResponse200DataItemRelationships,
)
from .ge_tbraintree_gateways_response_200_data_item_relationships_braintree_payments import (
    GETbraintreeGatewaysResponse200DataItemRelationshipsBraintreePayments,
)
from .ge_tbraintree_gateways_response_200_data_item_relationships_braintree_payments_data import (
    GETbraintreeGatewaysResponse200DataItemRelationshipsBraintreePaymentsData,
)
from .ge_tbraintree_gateways_response_200_data_item_relationships_braintree_payments_data_type import (
    GETbraintreeGatewaysResponse200DataItemRelationshipsBraintreePaymentsDataType,
)
from .ge_tbraintree_gateways_response_200_data_item_relationships_braintree_payments_links import (
    GETbraintreeGatewaysResponse200DataItemRelationshipsBraintreePaymentsLinks,
)
from .ge_tbraintree_gateways_response_200_data_item_relationships_payment_methods import (
    GETbraintreeGatewaysResponse200DataItemRelationshipsPaymentMethods,
)
from .ge_tbraintree_gateways_response_200_data_item_relationships_payment_methods_data import (
    GETbraintreeGatewaysResponse200DataItemRelationshipsPaymentMethodsData,
)
from .ge_tbraintree_gateways_response_200_data_item_relationships_payment_methods_data_type import (
    GETbraintreeGatewaysResponse200DataItemRelationshipsPaymentMethodsDataType,
)
from .ge_tbraintree_gateways_response_200_data_item_relationships_payment_methods_links import (
    GETbraintreeGatewaysResponse200DataItemRelationshipsPaymentMethodsLinks,
)
from .ge_tbraintree_gateways_response_200_data_item_type import GETbraintreeGatewaysResponse200DataItemType
from .ge_tbraintree_gatewaysbraintree_gateway_id_response_200 import GETbraintreeGatewaysbraintreeGatewayIdResponse200
from .ge_tbraintree_gatewaysbraintree_gateway_id_response_200_data import (
    GETbraintreeGatewaysbraintreeGatewayIdResponse200Data,
)
from .ge_tbraintree_gatewaysbraintree_gateway_id_response_200_data_attributes import (
    GETbraintreeGatewaysbraintreeGatewayIdResponse200DataAttributes,
)
from .ge_tbraintree_gatewaysbraintree_gateway_id_response_200_data_attributes_metadata import (
    GETbraintreeGatewaysbraintreeGatewayIdResponse200DataAttributesMetadata,
)
from .ge_tbraintree_gatewaysbraintree_gateway_id_response_200_data_links import (
    GETbraintreeGatewaysbraintreeGatewayIdResponse200DataLinks,
)
from .ge_tbraintree_gatewaysbraintree_gateway_id_response_200_data_relationships import (
    GETbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationships,
)
from .ge_tbraintree_gatewaysbraintree_gateway_id_response_200_data_relationships_braintree_payments import (
    GETbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsBraintreePayments,
)
from .ge_tbraintree_gatewaysbraintree_gateway_id_response_200_data_relationships_braintree_payments_data import (
    GETbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsBraintreePaymentsData,
)
from .ge_tbraintree_gatewaysbraintree_gateway_id_response_200_data_relationships_braintree_payments_data_type import (
    GETbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsBraintreePaymentsDataType,
)
from .ge_tbraintree_gatewaysbraintree_gateway_id_response_200_data_relationships_braintree_payments_links import (
    GETbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsBraintreePaymentsLinks,
)
from .ge_tbraintree_gatewaysbraintree_gateway_id_response_200_data_relationships_payment_methods import (
    GETbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsPaymentMethods,
)
from .ge_tbraintree_gatewaysbraintree_gateway_id_response_200_data_relationships_payment_methods_data import (
    GETbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsPaymentMethodsData,
)
from .ge_tbraintree_gatewaysbraintree_gateway_id_response_200_data_relationships_payment_methods_data_type import (
    GETbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsPaymentMethodsDataType,
)
from .ge_tbraintree_gatewaysbraintree_gateway_id_response_200_data_relationships_payment_methods_links import (
    GETbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsPaymentMethodsLinks,
)
from .ge_tbraintree_gatewaysbraintree_gateway_id_response_200_data_type import (
    GETbraintreeGatewaysbraintreeGatewayIdResponse200DataType,
)
from .ge_tbraintree_payments_response_200 import GETbraintreePaymentsResponse200
from .ge_tbraintree_payments_response_200_data_item import GETbraintreePaymentsResponse200DataItem
from .ge_tbraintree_payments_response_200_data_item_attributes import GETbraintreePaymentsResponse200DataItemAttributes
from .ge_tbraintree_payments_response_200_data_item_attributes_metadata import (
    GETbraintreePaymentsResponse200DataItemAttributesMetadata,
)
from .ge_tbraintree_payments_response_200_data_item_attributes_options import (
    GETbraintreePaymentsResponse200DataItemAttributesOptions,
)
from .ge_tbraintree_payments_response_200_data_item_links import GETbraintreePaymentsResponse200DataItemLinks
from .ge_tbraintree_payments_response_200_data_item_relationships import (
    GETbraintreePaymentsResponse200DataItemRelationships,
)
from .ge_tbraintree_payments_response_200_data_item_relationships_order import (
    GETbraintreePaymentsResponse200DataItemRelationshipsOrder,
)
from .ge_tbraintree_payments_response_200_data_item_relationships_order_data import (
    GETbraintreePaymentsResponse200DataItemRelationshipsOrderData,
)
from .ge_tbraintree_payments_response_200_data_item_relationships_order_data_type import (
    GETbraintreePaymentsResponse200DataItemRelationshipsOrderDataType,
)
from .ge_tbraintree_payments_response_200_data_item_relationships_order_links import (
    GETbraintreePaymentsResponse200DataItemRelationshipsOrderLinks,
)
from .ge_tbraintree_payments_response_200_data_item_relationships_payment_gateway import (
    GETbraintreePaymentsResponse200DataItemRelationshipsPaymentGateway,
)
from .ge_tbraintree_payments_response_200_data_item_relationships_payment_gateway_data import (
    GETbraintreePaymentsResponse200DataItemRelationshipsPaymentGatewayData,
)
from .ge_tbraintree_payments_response_200_data_item_relationships_payment_gateway_data_type import (
    GETbraintreePaymentsResponse200DataItemRelationshipsPaymentGatewayDataType,
)
from .ge_tbraintree_payments_response_200_data_item_relationships_payment_gateway_links import (
    GETbraintreePaymentsResponse200DataItemRelationshipsPaymentGatewayLinks,
)
from .ge_tbraintree_payments_response_200_data_item_type import GETbraintreePaymentsResponse200DataItemType
from .ge_tbraintree_paymentsbraintree_payment_id_response_200 import GETbraintreePaymentsbraintreePaymentIdResponse200
from .ge_tbraintree_paymentsbraintree_payment_id_response_200_data import (
    GETbraintreePaymentsbraintreePaymentIdResponse200Data,
)
from .ge_tbraintree_paymentsbraintree_payment_id_response_200_data_attributes import (
    GETbraintreePaymentsbraintreePaymentIdResponse200DataAttributes,
)
from .ge_tbraintree_paymentsbraintree_payment_id_response_200_data_attributes_metadata import (
    GETbraintreePaymentsbraintreePaymentIdResponse200DataAttributesMetadata,
)
from .ge_tbraintree_paymentsbraintree_payment_id_response_200_data_attributes_options import (
    GETbraintreePaymentsbraintreePaymentIdResponse200DataAttributesOptions,
)
from .ge_tbraintree_paymentsbraintree_payment_id_response_200_data_links import (
    GETbraintreePaymentsbraintreePaymentIdResponse200DataLinks,
)
from .ge_tbraintree_paymentsbraintree_payment_id_response_200_data_relationships import (
    GETbraintreePaymentsbraintreePaymentIdResponse200DataRelationships,
)
from .ge_tbraintree_paymentsbraintree_payment_id_response_200_data_relationships_order import (
    GETbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsOrder,
)
from .ge_tbraintree_paymentsbraintree_payment_id_response_200_data_relationships_order_data import (
    GETbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsOrderData,
)
from .ge_tbraintree_paymentsbraintree_payment_id_response_200_data_relationships_order_data_type import (
    GETbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsOrderDataType,
)
from .ge_tbraintree_paymentsbraintree_payment_id_response_200_data_relationships_order_links import (
    GETbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsOrderLinks,
)
from .ge_tbraintree_paymentsbraintree_payment_id_response_200_data_relationships_payment_gateway import (
    GETbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsPaymentGateway,
)
from .ge_tbraintree_paymentsbraintree_payment_id_response_200_data_relationships_payment_gateway_data import (
    GETbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsPaymentGatewayData,
)
from .ge_tbraintree_paymentsbraintree_payment_id_response_200_data_relationships_payment_gateway_data_type import (
    GETbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsPaymentGatewayDataType,
)
from .ge_tbraintree_paymentsbraintree_payment_id_response_200_data_relationships_payment_gateway_links import (
    GETbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsPaymentGatewayLinks,
)
from .ge_tbraintree_paymentsbraintree_payment_id_response_200_data_type import (
    GETbraintreePaymentsbraintreePaymentIdResponse200DataType,
)
from .ge_tbundles_response_200 import GETbundlesResponse200
from .ge_tbundles_response_200_data_item import GETbundlesResponse200DataItem
from .ge_tbundles_response_200_data_item_attributes import GETbundlesResponse200DataItemAttributes
from .ge_tbundles_response_200_data_item_attributes_metadata import GETbundlesResponse200DataItemAttributesMetadata
from .ge_tbundles_response_200_data_item_links import GETbundlesResponse200DataItemLinks
from .ge_tbundles_response_200_data_item_relationships import GETbundlesResponse200DataItemRelationships
from .ge_tbundles_response_200_data_item_relationships_attachments import (
    GETbundlesResponse200DataItemRelationshipsAttachments,
)
from .ge_tbundles_response_200_data_item_relationships_attachments_data import (
    GETbundlesResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tbundles_response_200_data_item_relationships_attachments_data_type import (
    GETbundlesResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tbundles_response_200_data_item_relationships_attachments_links import (
    GETbundlesResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tbundles_response_200_data_item_relationships_market import GETbundlesResponse200DataItemRelationshipsMarket
from .ge_tbundles_response_200_data_item_relationships_market_data import (
    GETbundlesResponse200DataItemRelationshipsMarketData,
)
from .ge_tbundles_response_200_data_item_relationships_market_data_type import (
    GETbundlesResponse200DataItemRelationshipsMarketDataType,
)
from .ge_tbundles_response_200_data_item_relationships_market_links import (
    GETbundlesResponse200DataItemRelationshipsMarketLinks,
)
from .ge_tbundles_response_200_data_item_relationships_sku_list import GETbundlesResponse200DataItemRelationshipsSkuList
from .ge_tbundles_response_200_data_item_relationships_sku_list_data import (
    GETbundlesResponse200DataItemRelationshipsSkuListData,
)
from .ge_tbundles_response_200_data_item_relationships_sku_list_data_type import (
    GETbundlesResponse200DataItemRelationshipsSkuListDataType,
)
from .ge_tbundles_response_200_data_item_relationships_sku_list_links import (
    GETbundlesResponse200DataItemRelationshipsSkuListLinks,
)
from .ge_tbundles_response_200_data_item_relationships_skus import GETbundlesResponse200DataItemRelationshipsSkus
from .ge_tbundles_response_200_data_item_relationships_skus_data import (
    GETbundlesResponse200DataItemRelationshipsSkusData,
)
from .ge_tbundles_response_200_data_item_relationships_skus_data_type import (
    GETbundlesResponse200DataItemRelationshipsSkusDataType,
)
from .ge_tbundles_response_200_data_item_relationships_skus_links import (
    GETbundlesResponse200DataItemRelationshipsSkusLinks,
)
from .ge_tbundles_response_200_data_item_type import GETbundlesResponse200DataItemType
from .ge_tbundlesbundle_id_response_200 import GETbundlesbundleIdResponse200
from .ge_tbundlesbundle_id_response_200_data import GETbundlesbundleIdResponse200Data
from .ge_tbundlesbundle_id_response_200_data_attributes import GETbundlesbundleIdResponse200DataAttributes
from .ge_tbundlesbundle_id_response_200_data_attributes_metadata import (
    GETbundlesbundleIdResponse200DataAttributesMetadata,
)
from .ge_tbundlesbundle_id_response_200_data_links import GETbundlesbundleIdResponse200DataLinks
from .ge_tbundlesbundle_id_response_200_data_relationships import GETbundlesbundleIdResponse200DataRelationships
from .ge_tbundlesbundle_id_response_200_data_relationships_attachments import (
    GETbundlesbundleIdResponse200DataRelationshipsAttachments,
)
from .ge_tbundlesbundle_id_response_200_data_relationships_attachments_data import (
    GETbundlesbundleIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tbundlesbundle_id_response_200_data_relationships_attachments_data_type import (
    GETbundlesbundleIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tbundlesbundle_id_response_200_data_relationships_attachments_links import (
    GETbundlesbundleIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tbundlesbundle_id_response_200_data_relationships_market import (
    GETbundlesbundleIdResponse200DataRelationshipsMarket,
)
from .ge_tbundlesbundle_id_response_200_data_relationships_market_data import (
    GETbundlesbundleIdResponse200DataRelationshipsMarketData,
)
from .ge_tbundlesbundle_id_response_200_data_relationships_market_data_type import (
    GETbundlesbundleIdResponse200DataRelationshipsMarketDataType,
)
from .ge_tbundlesbundle_id_response_200_data_relationships_market_links import (
    GETbundlesbundleIdResponse200DataRelationshipsMarketLinks,
)
from .ge_tbundlesbundle_id_response_200_data_relationships_sku_list import (
    GETbundlesbundleIdResponse200DataRelationshipsSkuList,
)
from .ge_tbundlesbundle_id_response_200_data_relationships_sku_list_data import (
    GETbundlesbundleIdResponse200DataRelationshipsSkuListData,
)
from .ge_tbundlesbundle_id_response_200_data_relationships_sku_list_data_type import (
    GETbundlesbundleIdResponse200DataRelationshipsSkuListDataType,
)
from .ge_tbundlesbundle_id_response_200_data_relationships_sku_list_links import (
    GETbundlesbundleIdResponse200DataRelationshipsSkuListLinks,
)
from .ge_tbundlesbundle_id_response_200_data_relationships_skus import (
    GETbundlesbundleIdResponse200DataRelationshipsSkus,
)
from .ge_tbundlesbundle_id_response_200_data_relationships_skus_data import (
    GETbundlesbundleIdResponse200DataRelationshipsSkusData,
)
from .ge_tbundlesbundle_id_response_200_data_relationships_skus_data_type import (
    GETbundlesbundleIdResponse200DataRelationshipsSkusDataType,
)
from .ge_tbundlesbundle_id_response_200_data_relationships_skus_links import (
    GETbundlesbundleIdResponse200DataRelationshipsSkusLinks,
)
from .ge_tbundlesbundle_id_response_200_data_type import GETbundlesbundleIdResponse200DataType
from .ge_tcaptures_response_200 import GETcapturesResponse200
from .ge_tcaptures_response_200_data_item import GETcapturesResponse200DataItem
from .ge_tcaptures_response_200_data_item_attributes import GETcapturesResponse200DataItemAttributes
from .ge_tcaptures_response_200_data_item_attributes_metadata import GETcapturesResponse200DataItemAttributesMetadata
from .ge_tcaptures_response_200_data_item_links import GETcapturesResponse200DataItemLinks
from .ge_tcaptures_response_200_data_item_relationships import GETcapturesResponse200DataItemRelationships
from .ge_tcaptures_response_200_data_item_relationships_order import GETcapturesResponse200DataItemRelationshipsOrder
from .ge_tcaptures_response_200_data_item_relationships_order_data import (
    GETcapturesResponse200DataItemRelationshipsOrderData,
)
from .ge_tcaptures_response_200_data_item_relationships_order_data_type import (
    GETcapturesResponse200DataItemRelationshipsOrderDataType,
)
from .ge_tcaptures_response_200_data_item_relationships_order_links import (
    GETcapturesResponse200DataItemRelationshipsOrderLinks,
)
from .ge_tcaptures_response_200_data_item_relationships_reference_authorization import (
    GETcapturesResponse200DataItemRelationshipsReferenceAuthorization,
)
from .ge_tcaptures_response_200_data_item_relationships_reference_authorization_data import (
    GETcapturesResponse200DataItemRelationshipsReferenceAuthorizationData,
)
from .ge_tcaptures_response_200_data_item_relationships_reference_authorization_data_type import (
    GETcapturesResponse200DataItemRelationshipsReferenceAuthorizationDataType,
)
from .ge_tcaptures_response_200_data_item_relationships_reference_authorization_links import (
    GETcapturesResponse200DataItemRelationshipsReferenceAuthorizationLinks,
)
from .ge_tcaptures_response_200_data_item_relationships_refunds import (
    GETcapturesResponse200DataItemRelationshipsRefunds,
)
from .ge_tcaptures_response_200_data_item_relationships_refunds_data import (
    GETcapturesResponse200DataItemRelationshipsRefundsData,
)
from .ge_tcaptures_response_200_data_item_relationships_refunds_data_type import (
    GETcapturesResponse200DataItemRelationshipsRefundsDataType,
)
from .ge_tcaptures_response_200_data_item_relationships_refunds_links import (
    GETcapturesResponse200DataItemRelationshipsRefundsLinks,
)
from .ge_tcaptures_response_200_data_item_type import GETcapturesResponse200DataItemType
from .ge_tcapturescapture_id_response_200 import GETcapturescaptureIdResponse200
from .ge_tcapturescapture_id_response_200_data import GETcapturescaptureIdResponse200Data
from .ge_tcapturescapture_id_response_200_data_attributes import GETcapturescaptureIdResponse200DataAttributes
from .ge_tcapturescapture_id_response_200_data_attributes_metadata import (
    GETcapturescaptureIdResponse200DataAttributesMetadata,
)
from .ge_tcapturescapture_id_response_200_data_links import GETcapturescaptureIdResponse200DataLinks
from .ge_tcapturescapture_id_response_200_data_relationships import GETcapturescaptureIdResponse200DataRelationships
from .ge_tcapturescapture_id_response_200_data_relationships_order import (
    GETcapturescaptureIdResponse200DataRelationshipsOrder,
)
from .ge_tcapturescapture_id_response_200_data_relationships_order_data import (
    GETcapturescaptureIdResponse200DataRelationshipsOrderData,
)
from .ge_tcapturescapture_id_response_200_data_relationships_order_data_type import (
    GETcapturescaptureIdResponse200DataRelationshipsOrderDataType,
)
from .ge_tcapturescapture_id_response_200_data_relationships_order_links import (
    GETcapturescaptureIdResponse200DataRelationshipsOrderLinks,
)
from .ge_tcapturescapture_id_response_200_data_relationships_reference_authorization import (
    GETcapturescaptureIdResponse200DataRelationshipsReferenceAuthorization,
)
from .ge_tcapturescapture_id_response_200_data_relationships_reference_authorization_data import (
    GETcapturescaptureIdResponse200DataRelationshipsReferenceAuthorizationData,
)
from .ge_tcapturescapture_id_response_200_data_relationships_reference_authorization_data_type import (
    GETcapturescaptureIdResponse200DataRelationshipsReferenceAuthorizationDataType,
)
from .ge_tcapturescapture_id_response_200_data_relationships_reference_authorization_links import (
    GETcapturescaptureIdResponse200DataRelationshipsReferenceAuthorizationLinks,
)
from .ge_tcapturescapture_id_response_200_data_relationships_refunds import (
    GETcapturescaptureIdResponse200DataRelationshipsRefunds,
)
from .ge_tcapturescapture_id_response_200_data_relationships_refunds_data import (
    GETcapturescaptureIdResponse200DataRelationshipsRefundsData,
)
from .ge_tcapturescapture_id_response_200_data_relationships_refunds_data_type import (
    GETcapturescaptureIdResponse200DataRelationshipsRefundsDataType,
)
from .ge_tcapturescapture_id_response_200_data_relationships_refunds_links import (
    GETcapturescaptureIdResponse200DataRelationshipsRefundsLinks,
)
from .ge_tcapturescapture_id_response_200_data_type import GETcapturescaptureIdResponse200DataType
from .ge_tcarrier_accounts_response_200 import GETcarrierAccountsResponse200
from .ge_tcarrier_accounts_response_200_data_item import GETcarrierAccountsResponse200DataItem
from .ge_tcarrier_accounts_response_200_data_item_attributes import GETcarrierAccountsResponse200DataItemAttributes
from .ge_tcarrier_accounts_response_200_data_item_attributes_metadata import (
    GETcarrierAccountsResponse200DataItemAttributesMetadata,
)
from .ge_tcarrier_accounts_response_200_data_item_links import GETcarrierAccountsResponse200DataItemLinks
from .ge_tcarrier_accounts_response_200_data_item_relationships import (
    GETcarrierAccountsResponse200DataItemRelationships,
)
from .ge_tcarrier_accounts_response_200_data_item_relationships_attachments import (
    GETcarrierAccountsResponse200DataItemRelationshipsAttachments,
)
from .ge_tcarrier_accounts_response_200_data_item_relationships_attachments_data import (
    GETcarrierAccountsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tcarrier_accounts_response_200_data_item_relationships_attachments_data_type import (
    GETcarrierAccountsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tcarrier_accounts_response_200_data_item_relationships_attachments_links import (
    GETcarrierAccountsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tcarrier_accounts_response_200_data_item_relationships_market import (
    GETcarrierAccountsResponse200DataItemRelationshipsMarket,
)
from .ge_tcarrier_accounts_response_200_data_item_relationships_market_data import (
    GETcarrierAccountsResponse200DataItemRelationshipsMarketData,
)
from .ge_tcarrier_accounts_response_200_data_item_relationships_market_data_type import (
    GETcarrierAccountsResponse200DataItemRelationshipsMarketDataType,
)
from .ge_tcarrier_accounts_response_200_data_item_relationships_market_links import (
    GETcarrierAccountsResponse200DataItemRelationshipsMarketLinks,
)
from .ge_tcarrier_accounts_response_200_data_item_type import GETcarrierAccountsResponse200DataItemType
from .ge_tcarrier_accountscarrier_account_id_response_200 import GETcarrierAccountscarrierAccountIdResponse200
from .ge_tcarrier_accountscarrier_account_id_response_200_data import GETcarrierAccountscarrierAccountIdResponse200Data
from .ge_tcarrier_accountscarrier_account_id_response_200_data_attributes import (
    GETcarrierAccountscarrierAccountIdResponse200DataAttributes,
)
from .ge_tcarrier_accountscarrier_account_id_response_200_data_attributes_metadata import (
    GETcarrierAccountscarrierAccountIdResponse200DataAttributesMetadata,
)
from .ge_tcarrier_accountscarrier_account_id_response_200_data_links import (
    GETcarrierAccountscarrierAccountIdResponse200DataLinks,
)
from .ge_tcarrier_accountscarrier_account_id_response_200_data_relationships import (
    GETcarrierAccountscarrierAccountIdResponse200DataRelationships,
)
from .ge_tcarrier_accountscarrier_account_id_response_200_data_relationships_attachments import (
    GETcarrierAccountscarrierAccountIdResponse200DataRelationshipsAttachments,
)
from .ge_tcarrier_accountscarrier_account_id_response_200_data_relationships_attachments_data import (
    GETcarrierAccountscarrierAccountIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tcarrier_accountscarrier_account_id_response_200_data_relationships_attachments_data_type import (
    GETcarrierAccountscarrierAccountIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tcarrier_accountscarrier_account_id_response_200_data_relationships_attachments_links import (
    GETcarrierAccountscarrierAccountIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tcarrier_accountscarrier_account_id_response_200_data_relationships_market import (
    GETcarrierAccountscarrierAccountIdResponse200DataRelationshipsMarket,
)
from .ge_tcarrier_accountscarrier_account_id_response_200_data_relationships_market_data import (
    GETcarrierAccountscarrierAccountIdResponse200DataRelationshipsMarketData,
)
from .ge_tcarrier_accountscarrier_account_id_response_200_data_relationships_market_data_type import (
    GETcarrierAccountscarrierAccountIdResponse200DataRelationshipsMarketDataType,
)
from .ge_tcarrier_accountscarrier_account_id_response_200_data_relationships_market_links import (
    GETcarrierAccountscarrierAccountIdResponse200DataRelationshipsMarketLinks,
)
from .ge_tcarrier_accountscarrier_account_id_response_200_data_type import (
    GETcarrierAccountscarrierAccountIdResponse200DataType,
)
from .ge_tcheckout_com_gateways_response_200 import GETcheckoutComGatewaysResponse200
from .ge_tcheckout_com_gateways_response_200_data_item import GETcheckoutComGatewaysResponse200DataItem
from .ge_tcheckout_com_gateways_response_200_data_item_attributes import (
    GETcheckoutComGatewaysResponse200DataItemAttributes,
)
from .ge_tcheckout_com_gateways_response_200_data_item_attributes_metadata import (
    GETcheckoutComGatewaysResponse200DataItemAttributesMetadata,
)
from .ge_tcheckout_com_gateways_response_200_data_item_links import GETcheckoutComGatewaysResponse200DataItemLinks
from .ge_tcheckout_com_gateways_response_200_data_item_relationships import (
    GETcheckoutComGatewaysResponse200DataItemRelationships,
)
from .ge_tcheckout_com_gateways_response_200_data_item_relationships_checkout_com_payments import (
    GETcheckoutComGatewaysResponse200DataItemRelationshipsCheckoutComPayments,
)
from .ge_tcheckout_com_gateways_response_200_data_item_relationships_checkout_com_payments_data import (
    GETcheckoutComGatewaysResponse200DataItemRelationshipsCheckoutComPaymentsData,
)
from .ge_tcheckout_com_gateways_response_200_data_item_relationships_checkout_com_payments_data_type import (
    GETcheckoutComGatewaysResponse200DataItemRelationshipsCheckoutComPaymentsDataType,
)
from .ge_tcheckout_com_gateways_response_200_data_item_relationships_checkout_com_payments_links import (
    GETcheckoutComGatewaysResponse200DataItemRelationshipsCheckoutComPaymentsLinks,
)
from .ge_tcheckout_com_gateways_response_200_data_item_relationships_payment_methods import (
    GETcheckoutComGatewaysResponse200DataItemRelationshipsPaymentMethods,
)
from .ge_tcheckout_com_gateways_response_200_data_item_relationships_payment_methods_data import (
    GETcheckoutComGatewaysResponse200DataItemRelationshipsPaymentMethodsData,
)
from .ge_tcheckout_com_gateways_response_200_data_item_relationships_payment_methods_data_type import (
    GETcheckoutComGatewaysResponse200DataItemRelationshipsPaymentMethodsDataType,
)
from .ge_tcheckout_com_gateways_response_200_data_item_relationships_payment_methods_links import (
    GETcheckoutComGatewaysResponse200DataItemRelationshipsPaymentMethodsLinks,
)
from .ge_tcheckout_com_gateways_response_200_data_item_type import GETcheckoutComGatewaysResponse200DataItemType
from .ge_tcheckout_com_gatewayscheckout_com_gateway_id_response_200 import (
    GETcheckoutComGatewayscheckoutComGatewayIdResponse200,
)
from .ge_tcheckout_com_gatewayscheckout_com_gateway_id_response_200_data import (
    GETcheckoutComGatewayscheckoutComGatewayIdResponse200Data,
)
from .ge_tcheckout_com_gatewayscheckout_com_gateway_id_response_200_data_attributes import (
    GETcheckoutComGatewayscheckoutComGatewayIdResponse200DataAttributes,
)
from .ge_tcheckout_com_gatewayscheckout_com_gateway_id_response_200_data_attributes_metadata import (
    GETcheckoutComGatewayscheckoutComGatewayIdResponse200DataAttributesMetadata,
)
from .ge_tcheckout_com_gatewayscheckout_com_gateway_id_response_200_data_links import (
    GETcheckoutComGatewayscheckoutComGatewayIdResponse200DataLinks,
)
from .ge_tcheckout_com_gatewayscheckout_com_gateway_id_response_200_data_relationships import (
    GETcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationships,
)
from .ge_tcheckout_com_gatewayscheckout_com_gateway_id_response_200_data_relationships_checkout_com_payments import (
    GETcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsCheckoutComPayments,
)
from .ge_tcheckout_com_gatewayscheckout_com_gateway_id_response_200_data_relationships_checkout_com_payments_data import (
    GETcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsCheckoutComPaymentsData,
)
from .ge_tcheckout_com_gatewayscheckout_com_gateway_id_response_200_data_relationships_checkout_com_payments_data_type import (
    GETcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsCheckoutComPaymentsDataType,
)
from .ge_tcheckout_com_gatewayscheckout_com_gateway_id_response_200_data_relationships_checkout_com_payments_links import (
    GETcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsCheckoutComPaymentsLinks,
)
from .ge_tcheckout_com_gatewayscheckout_com_gateway_id_response_200_data_relationships_payment_methods import (
    GETcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsPaymentMethods,
)
from .ge_tcheckout_com_gatewayscheckout_com_gateway_id_response_200_data_relationships_payment_methods_data import (
    GETcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsPaymentMethodsData,
)
from .ge_tcheckout_com_gatewayscheckout_com_gateway_id_response_200_data_relationships_payment_methods_data_type import (
    GETcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsPaymentMethodsDataType,
)
from .ge_tcheckout_com_gatewayscheckout_com_gateway_id_response_200_data_relationships_payment_methods_links import (
    GETcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsPaymentMethodsLinks,
)
from .ge_tcheckout_com_gatewayscheckout_com_gateway_id_response_200_data_type import (
    GETcheckoutComGatewayscheckoutComGatewayIdResponse200DataType,
)
from .ge_tcheckout_com_payments_response_200 import GETcheckoutComPaymentsResponse200
from .ge_tcheckout_com_payments_response_200_data_item import GETcheckoutComPaymentsResponse200DataItem
from .ge_tcheckout_com_payments_response_200_data_item_attributes import (
    GETcheckoutComPaymentsResponse200DataItemAttributes,
)
from .ge_tcheckout_com_payments_response_200_data_item_attributes_metadata import (
    GETcheckoutComPaymentsResponse200DataItemAttributesMetadata,
)
from .ge_tcheckout_com_payments_response_200_data_item_attributes_payment_response import (
    GETcheckoutComPaymentsResponse200DataItemAttributesPaymentResponse,
)
from .ge_tcheckout_com_payments_response_200_data_item_links import GETcheckoutComPaymentsResponse200DataItemLinks
from .ge_tcheckout_com_payments_response_200_data_item_relationships import (
    GETcheckoutComPaymentsResponse200DataItemRelationships,
)
from .ge_tcheckout_com_payments_response_200_data_item_relationships_order import (
    GETcheckoutComPaymentsResponse200DataItemRelationshipsOrder,
)
from .ge_tcheckout_com_payments_response_200_data_item_relationships_order_data import (
    GETcheckoutComPaymentsResponse200DataItemRelationshipsOrderData,
)
from .ge_tcheckout_com_payments_response_200_data_item_relationships_order_data_type import (
    GETcheckoutComPaymentsResponse200DataItemRelationshipsOrderDataType,
)
from .ge_tcheckout_com_payments_response_200_data_item_relationships_order_links import (
    GETcheckoutComPaymentsResponse200DataItemRelationshipsOrderLinks,
)
from .ge_tcheckout_com_payments_response_200_data_item_relationships_payment_gateway import (
    GETcheckoutComPaymentsResponse200DataItemRelationshipsPaymentGateway,
)
from .ge_tcheckout_com_payments_response_200_data_item_relationships_payment_gateway_data import (
    GETcheckoutComPaymentsResponse200DataItemRelationshipsPaymentGatewayData,
)
from .ge_tcheckout_com_payments_response_200_data_item_relationships_payment_gateway_data_type import (
    GETcheckoutComPaymentsResponse200DataItemRelationshipsPaymentGatewayDataType,
)
from .ge_tcheckout_com_payments_response_200_data_item_relationships_payment_gateway_links import (
    GETcheckoutComPaymentsResponse200DataItemRelationshipsPaymentGatewayLinks,
)
from .ge_tcheckout_com_payments_response_200_data_item_type import GETcheckoutComPaymentsResponse200DataItemType
from .ge_tcheckout_com_paymentscheckout_com_payment_id_response_200 import (
    GETcheckoutComPaymentscheckoutComPaymentIdResponse200,
)
from .ge_tcheckout_com_paymentscheckout_com_payment_id_response_200_data import (
    GETcheckoutComPaymentscheckoutComPaymentIdResponse200Data,
)
from .ge_tcheckout_com_paymentscheckout_com_payment_id_response_200_data_attributes import (
    GETcheckoutComPaymentscheckoutComPaymentIdResponse200DataAttributes,
)
from .ge_tcheckout_com_paymentscheckout_com_payment_id_response_200_data_attributes_metadata import (
    GETcheckoutComPaymentscheckoutComPaymentIdResponse200DataAttributesMetadata,
)
from .ge_tcheckout_com_paymentscheckout_com_payment_id_response_200_data_attributes_payment_response import (
    GETcheckoutComPaymentscheckoutComPaymentIdResponse200DataAttributesPaymentResponse,
)
from .ge_tcheckout_com_paymentscheckout_com_payment_id_response_200_data_links import (
    GETcheckoutComPaymentscheckoutComPaymentIdResponse200DataLinks,
)
from .ge_tcheckout_com_paymentscheckout_com_payment_id_response_200_data_relationships import (
    GETcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationships,
)
from .ge_tcheckout_com_paymentscheckout_com_payment_id_response_200_data_relationships_order import (
    GETcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsOrder,
)
from .ge_tcheckout_com_paymentscheckout_com_payment_id_response_200_data_relationships_order_data import (
    GETcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsOrderData,
)
from .ge_tcheckout_com_paymentscheckout_com_payment_id_response_200_data_relationships_order_data_type import (
    GETcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsOrderDataType,
)
from .ge_tcheckout_com_paymentscheckout_com_payment_id_response_200_data_relationships_order_links import (
    GETcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsOrderLinks,
)
from .ge_tcheckout_com_paymentscheckout_com_payment_id_response_200_data_relationships_payment_gateway import (
    GETcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsPaymentGateway,
)
from .ge_tcheckout_com_paymentscheckout_com_payment_id_response_200_data_relationships_payment_gateway_data import (
    GETcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsPaymentGatewayData,
)
from .ge_tcheckout_com_paymentscheckout_com_payment_id_response_200_data_relationships_payment_gateway_data_type import (
    GETcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsPaymentGatewayDataType,
)
from .ge_tcheckout_com_paymentscheckout_com_payment_id_response_200_data_relationships_payment_gateway_links import (
    GETcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsPaymentGatewayLinks,
)
from .ge_tcheckout_com_paymentscheckout_com_payment_id_response_200_data_type import (
    GETcheckoutComPaymentscheckoutComPaymentIdResponse200DataType,
)
from .ge_tcleanups_response_200 import GETcleanupsResponse200
from .ge_tcleanups_response_200_data_item import GETcleanupsResponse200DataItem
from .ge_tcleanups_response_200_data_item_attributes import GETcleanupsResponse200DataItemAttributes
from .ge_tcleanups_response_200_data_item_attributes_errors_log import GETcleanupsResponse200DataItemAttributesErrorsLog
from .ge_tcleanups_response_200_data_item_attributes_filters import GETcleanupsResponse200DataItemAttributesFilters
from .ge_tcleanups_response_200_data_item_attributes_metadata import GETcleanupsResponse200DataItemAttributesMetadata
from .ge_tcleanups_response_200_data_item_links import GETcleanupsResponse200DataItemLinks
from .ge_tcleanups_response_200_data_item_relationships import GETcleanupsResponse200DataItemRelationships
from .ge_tcleanups_response_200_data_item_relationships_events import GETcleanupsResponse200DataItemRelationshipsEvents
from .ge_tcleanups_response_200_data_item_relationships_events_data import (
    GETcleanupsResponse200DataItemRelationshipsEventsData,
)
from .ge_tcleanups_response_200_data_item_relationships_events_data_type import (
    GETcleanupsResponse200DataItemRelationshipsEventsDataType,
)
from .ge_tcleanups_response_200_data_item_relationships_events_links import (
    GETcleanupsResponse200DataItemRelationshipsEventsLinks,
)
from .ge_tcleanups_response_200_data_item_type import GETcleanupsResponse200DataItemType
from .ge_tcleanupscleanup_id_response_200 import GETcleanupscleanupIdResponse200
from .ge_tcleanupscleanup_id_response_200_data import GETcleanupscleanupIdResponse200Data
from .ge_tcleanupscleanup_id_response_200_data_attributes import GETcleanupscleanupIdResponse200DataAttributes
from .ge_tcleanupscleanup_id_response_200_data_attributes_errors_log import (
    GETcleanupscleanupIdResponse200DataAttributesErrorsLog,
)
from .ge_tcleanupscleanup_id_response_200_data_attributes_filters import (
    GETcleanupscleanupIdResponse200DataAttributesFilters,
)
from .ge_tcleanupscleanup_id_response_200_data_attributes_metadata import (
    GETcleanupscleanupIdResponse200DataAttributesMetadata,
)
from .ge_tcleanupscleanup_id_response_200_data_links import GETcleanupscleanupIdResponse200DataLinks
from .ge_tcleanupscleanup_id_response_200_data_relationships import GETcleanupscleanupIdResponse200DataRelationships
from .ge_tcleanupscleanup_id_response_200_data_relationships_events import (
    GETcleanupscleanupIdResponse200DataRelationshipsEvents,
)
from .ge_tcleanupscleanup_id_response_200_data_relationships_events_data import (
    GETcleanupscleanupIdResponse200DataRelationshipsEventsData,
)
from .ge_tcleanupscleanup_id_response_200_data_relationships_events_data_type import (
    GETcleanupscleanupIdResponse200DataRelationshipsEventsDataType,
)
from .ge_tcleanupscleanup_id_response_200_data_relationships_events_links import (
    GETcleanupscleanupIdResponse200DataRelationshipsEventsLinks,
)
from .ge_tcleanupscleanup_id_response_200_data_type import GETcleanupscleanupIdResponse200DataType
from .ge_tcoupon_codes_promotion_rules_response_200 import GETcouponCodesPromotionRulesResponse200
from .ge_tcoupon_codes_promotion_rules_response_200_data_item import GETcouponCodesPromotionRulesResponse200DataItem
from .ge_tcoupon_codes_promotion_rules_response_200_data_item_attributes import (
    GETcouponCodesPromotionRulesResponse200DataItemAttributes,
)
from .ge_tcoupon_codes_promotion_rules_response_200_data_item_attributes_metadata import (
    GETcouponCodesPromotionRulesResponse200DataItemAttributesMetadata,
)
from .ge_tcoupon_codes_promotion_rules_response_200_data_item_links import (
    GETcouponCodesPromotionRulesResponse200DataItemLinks,
)
from .ge_tcoupon_codes_promotion_rules_response_200_data_item_relationships import (
    GETcouponCodesPromotionRulesResponse200DataItemRelationships,
)
from .ge_tcoupon_codes_promotion_rules_response_200_data_item_relationships_coupons import (
    GETcouponCodesPromotionRulesResponse200DataItemRelationshipsCoupons,
)
from .ge_tcoupon_codes_promotion_rules_response_200_data_item_relationships_coupons_data import (
    GETcouponCodesPromotionRulesResponse200DataItemRelationshipsCouponsData,
)
from .ge_tcoupon_codes_promotion_rules_response_200_data_item_relationships_coupons_data_type import (
    GETcouponCodesPromotionRulesResponse200DataItemRelationshipsCouponsDataType,
)
from .ge_tcoupon_codes_promotion_rules_response_200_data_item_relationships_coupons_links import (
    GETcouponCodesPromotionRulesResponse200DataItemRelationshipsCouponsLinks,
)
from .ge_tcoupon_codes_promotion_rules_response_200_data_item_relationships_promotion import (
    GETcouponCodesPromotionRulesResponse200DataItemRelationshipsPromotion,
)
from .ge_tcoupon_codes_promotion_rules_response_200_data_item_relationships_promotion_data import (
    GETcouponCodesPromotionRulesResponse200DataItemRelationshipsPromotionData,
)
from .ge_tcoupon_codes_promotion_rules_response_200_data_item_relationships_promotion_data_type import (
    GETcouponCodesPromotionRulesResponse200DataItemRelationshipsPromotionDataType,
)
from .ge_tcoupon_codes_promotion_rules_response_200_data_item_relationships_promotion_links import (
    GETcouponCodesPromotionRulesResponse200DataItemRelationshipsPromotionLinks,
)
from .ge_tcoupon_codes_promotion_rules_response_200_data_item_type import (
    GETcouponCodesPromotionRulesResponse200DataItemType,
)
from .ge_tcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200 import (
    GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200,
)
from .ge_tcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200_data import (
    GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200Data,
)
from .ge_tcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200_data_attributes import (
    GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataAttributes,
)
from .ge_tcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200_data_attributes_metadata import (
    GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataAttributesMetadata,
)
from .ge_tcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200_data_links import (
    GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataLinks,
)
from .ge_tcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200_data_relationships import (
    GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationships,
)
from .ge_tcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200_data_relationships_coupons import (
    GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsCoupons,
)
from .ge_tcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200_data_relationships_coupons_data import (
    GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsCouponsData,
)
from .ge_tcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200_data_relationships_coupons_data_type import (
    GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsCouponsDataType,
)
from .ge_tcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200_data_relationships_coupons_links import (
    GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsCouponsLinks,
)
from .ge_tcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200_data_relationships_promotion import (
    GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsPromotion,
)
from .ge_tcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200_data_relationships_promotion_data import (
    GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsPromotionData,
)
from .ge_tcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200_data_relationships_promotion_data_type import (
    GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsPromotionDataType,
)
from .ge_tcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200_data_relationships_promotion_links import (
    GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsPromotionLinks,
)
from .ge_tcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200_data_type import (
    GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataType,
)
from .ge_tcoupon_recipients_response_200 import GETcouponRecipientsResponse200
from .ge_tcoupon_recipients_response_200_data_item import GETcouponRecipientsResponse200DataItem
from .ge_tcoupon_recipients_response_200_data_item_attributes import GETcouponRecipientsResponse200DataItemAttributes
from .ge_tcoupon_recipients_response_200_data_item_attributes_metadata import (
    GETcouponRecipientsResponse200DataItemAttributesMetadata,
)
from .ge_tcoupon_recipients_response_200_data_item_links import GETcouponRecipientsResponse200DataItemLinks
from .ge_tcoupon_recipients_response_200_data_item_relationships import (
    GETcouponRecipientsResponse200DataItemRelationships,
)
from .ge_tcoupon_recipients_response_200_data_item_relationships_attachments import (
    GETcouponRecipientsResponse200DataItemRelationshipsAttachments,
)
from .ge_tcoupon_recipients_response_200_data_item_relationships_attachments_data import (
    GETcouponRecipientsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tcoupon_recipients_response_200_data_item_relationships_attachments_data_type import (
    GETcouponRecipientsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tcoupon_recipients_response_200_data_item_relationships_attachments_links import (
    GETcouponRecipientsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tcoupon_recipients_response_200_data_item_relationships_customer import (
    GETcouponRecipientsResponse200DataItemRelationshipsCustomer,
)
from .ge_tcoupon_recipients_response_200_data_item_relationships_customer_data import (
    GETcouponRecipientsResponse200DataItemRelationshipsCustomerData,
)
from .ge_tcoupon_recipients_response_200_data_item_relationships_customer_data_type import (
    GETcouponRecipientsResponse200DataItemRelationshipsCustomerDataType,
)
from .ge_tcoupon_recipients_response_200_data_item_relationships_customer_links import (
    GETcouponRecipientsResponse200DataItemRelationshipsCustomerLinks,
)
from .ge_tcoupon_recipients_response_200_data_item_type import GETcouponRecipientsResponse200DataItemType
from .ge_tcoupon_recipientscoupon_recipient_id_response_200 import GETcouponRecipientscouponRecipientIdResponse200
from .ge_tcoupon_recipientscoupon_recipient_id_response_200_data import (
    GETcouponRecipientscouponRecipientIdResponse200Data,
)
from .ge_tcoupon_recipientscoupon_recipient_id_response_200_data_attributes import (
    GETcouponRecipientscouponRecipientIdResponse200DataAttributes,
)
from .ge_tcoupon_recipientscoupon_recipient_id_response_200_data_attributes_metadata import (
    GETcouponRecipientscouponRecipientIdResponse200DataAttributesMetadata,
)
from .ge_tcoupon_recipientscoupon_recipient_id_response_200_data_links import (
    GETcouponRecipientscouponRecipientIdResponse200DataLinks,
)
from .ge_tcoupon_recipientscoupon_recipient_id_response_200_data_relationships import (
    GETcouponRecipientscouponRecipientIdResponse200DataRelationships,
)
from .ge_tcoupon_recipientscoupon_recipient_id_response_200_data_relationships_attachments import (
    GETcouponRecipientscouponRecipientIdResponse200DataRelationshipsAttachments,
)
from .ge_tcoupon_recipientscoupon_recipient_id_response_200_data_relationships_attachments_data import (
    GETcouponRecipientscouponRecipientIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tcoupon_recipientscoupon_recipient_id_response_200_data_relationships_attachments_data_type import (
    GETcouponRecipientscouponRecipientIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tcoupon_recipientscoupon_recipient_id_response_200_data_relationships_attachments_links import (
    GETcouponRecipientscouponRecipientIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tcoupon_recipientscoupon_recipient_id_response_200_data_relationships_customer import (
    GETcouponRecipientscouponRecipientIdResponse200DataRelationshipsCustomer,
)
from .ge_tcoupon_recipientscoupon_recipient_id_response_200_data_relationships_customer_data import (
    GETcouponRecipientscouponRecipientIdResponse200DataRelationshipsCustomerData,
)
from .ge_tcoupon_recipientscoupon_recipient_id_response_200_data_relationships_customer_data_type import (
    GETcouponRecipientscouponRecipientIdResponse200DataRelationshipsCustomerDataType,
)
from .ge_tcoupon_recipientscoupon_recipient_id_response_200_data_relationships_customer_links import (
    GETcouponRecipientscouponRecipientIdResponse200DataRelationshipsCustomerLinks,
)
from .ge_tcoupon_recipientscoupon_recipient_id_response_200_data_type import (
    GETcouponRecipientscouponRecipientIdResponse200DataType,
)
from .ge_tcoupons_response_200 import GETcouponsResponse200
from .ge_tcoupons_response_200_data_item import GETcouponsResponse200DataItem
from .ge_tcoupons_response_200_data_item_attributes import GETcouponsResponse200DataItemAttributes
from .ge_tcoupons_response_200_data_item_attributes_metadata import GETcouponsResponse200DataItemAttributesMetadata
from .ge_tcoupons_response_200_data_item_links import GETcouponsResponse200DataItemLinks
from .ge_tcoupons_response_200_data_item_relationships import GETcouponsResponse200DataItemRelationships
from .ge_tcoupons_response_200_data_item_relationships_promotion_rule import (
    GETcouponsResponse200DataItemRelationshipsPromotionRule,
)
from .ge_tcoupons_response_200_data_item_relationships_promotion_rule_data import (
    GETcouponsResponse200DataItemRelationshipsPromotionRuleData,
)
from .ge_tcoupons_response_200_data_item_relationships_promotion_rule_data_type import (
    GETcouponsResponse200DataItemRelationshipsPromotionRuleDataType,
)
from .ge_tcoupons_response_200_data_item_relationships_promotion_rule_links import (
    GETcouponsResponse200DataItemRelationshipsPromotionRuleLinks,
)
from .ge_tcoupons_response_200_data_item_type import GETcouponsResponse200DataItemType
from .ge_tcouponscoupon_id_response_200 import GETcouponscouponIdResponse200
from .ge_tcouponscoupon_id_response_200_data import GETcouponscouponIdResponse200Data
from .ge_tcouponscoupon_id_response_200_data_attributes import GETcouponscouponIdResponse200DataAttributes
from .ge_tcouponscoupon_id_response_200_data_attributes_metadata import (
    GETcouponscouponIdResponse200DataAttributesMetadata,
)
from .ge_tcouponscoupon_id_response_200_data_links import GETcouponscouponIdResponse200DataLinks
from .ge_tcouponscoupon_id_response_200_data_relationships import GETcouponscouponIdResponse200DataRelationships
from .ge_tcouponscoupon_id_response_200_data_relationships_promotion_rule import (
    GETcouponscouponIdResponse200DataRelationshipsPromotionRule,
)
from .ge_tcouponscoupon_id_response_200_data_relationships_promotion_rule_data import (
    GETcouponscouponIdResponse200DataRelationshipsPromotionRuleData,
)
from .ge_tcouponscoupon_id_response_200_data_relationships_promotion_rule_data_type import (
    GETcouponscouponIdResponse200DataRelationshipsPromotionRuleDataType,
)
from .ge_tcouponscoupon_id_response_200_data_relationships_promotion_rule_links import (
    GETcouponscouponIdResponse200DataRelationshipsPromotionRuleLinks,
)
from .ge_tcouponscoupon_id_response_200_data_type import GETcouponscouponIdResponse200DataType
from .ge_tcustomer_addresses_response_200 import GETcustomerAddressesResponse200
from .ge_tcustomer_addresses_response_200_data_item import GETcustomerAddressesResponse200DataItem
from .ge_tcustomer_addresses_response_200_data_item_attributes import GETcustomerAddressesResponse200DataItemAttributes
from .ge_tcustomer_addresses_response_200_data_item_attributes_metadata import (
    GETcustomerAddressesResponse200DataItemAttributesMetadata,
)
from .ge_tcustomer_addresses_response_200_data_item_links import GETcustomerAddressesResponse200DataItemLinks
from .ge_tcustomer_addresses_response_200_data_item_relationships import (
    GETcustomerAddressesResponse200DataItemRelationships,
)
from .ge_tcustomer_addresses_response_200_data_item_relationships_address import (
    GETcustomerAddressesResponse200DataItemRelationshipsAddress,
)
from .ge_tcustomer_addresses_response_200_data_item_relationships_address_data import (
    GETcustomerAddressesResponse200DataItemRelationshipsAddressData,
)
from .ge_tcustomer_addresses_response_200_data_item_relationships_address_data_type import (
    GETcustomerAddressesResponse200DataItemRelationshipsAddressDataType,
)
from .ge_tcustomer_addresses_response_200_data_item_relationships_address_links import (
    GETcustomerAddressesResponse200DataItemRelationshipsAddressLinks,
)
from .ge_tcustomer_addresses_response_200_data_item_relationships_customer import (
    GETcustomerAddressesResponse200DataItemRelationshipsCustomer,
)
from .ge_tcustomer_addresses_response_200_data_item_relationships_customer_data import (
    GETcustomerAddressesResponse200DataItemRelationshipsCustomerData,
)
from .ge_tcustomer_addresses_response_200_data_item_relationships_customer_data_type import (
    GETcustomerAddressesResponse200DataItemRelationshipsCustomerDataType,
)
from .ge_tcustomer_addresses_response_200_data_item_relationships_customer_links import (
    GETcustomerAddressesResponse200DataItemRelationshipsCustomerLinks,
)
from .ge_tcustomer_addresses_response_200_data_item_relationships_events import (
    GETcustomerAddressesResponse200DataItemRelationshipsEvents,
)
from .ge_tcustomer_addresses_response_200_data_item_relationships_events_data import (
    GETcustomerAddressesResponse200DataItemRelationshipsEventsData,
)
from .ge_tcustomer_addresses_response_200_data_item_relationships_events_data_type import (
    GETcustomerAddressesResponse200DataItemRelationshipsEventsDataType,
)
from .ge_tcustomer_addresses_response_200_data_item_relationships_events_links import (
    GETcustomerAddressesResponse200DataItemRelationshipsEventsLinks,
)
from .ge_tcustomer_addresses_response_200_data_item_type import GETcustomerAddressesResponse200DataItemType
from .ge_tcustomer_addressescustomer_address_id_response_200 import GETcustomerAddressescustomerAddressIdResponse200
from .ge_tcustomer_addressescustomer_address_id_response_200_data import (
    GETcustomerAddressescustomerAddressIdResponse200Data,
)
from .ge_tcustomer_addressescustomer_address_id_response_200_data_attributes import (
    GETcustomerAddressescustomerAddressIdResponse200DataAttributes,
)
from .ge_tcustomer_addressescustomer_address_id_response_200_data_attributes_metadata import (
    GETcustomerAddressescustomerAddressIdResponse200DataAttributesMetadata,
)
from .ge_tcustomer_addressescustomer_address_id_response_200_data_links import (
    GETcustomerAddressescustomerAddressIdResponse200DataLinks,
)
from .ge_tcustomer_addressescustomer_address_id_response_200_data_relationships import (
    GETcustomerAddressescustomerAddressIdResponse200DataRelationships,
)
from .ge_tcustomer_addressescustomer_address_id_response_200_data_relationships_address import (
    GETcustomerAddressescustomerAddressIdResponse200DataRelationshipsAddress,
)
from .ge_tcustomer_addressescustomer_address_id_response_200_data_relationships_address_data import (
    GETcustomerAddressescustomerAddressIdResponse200DataRelationshipsAddressData,
)
from .ge_tcustomer_addressescustomer_address_id_response_200_data_relationships_address_data_type import (
    GETcustomerAddressescustomerAddressIdResponse200DataRelationshipsAddressDataType,
)
from .ge_tcustomer_addressescustomer_address_id_response_200_data_relationships_address_links import (
    GETcustomerAddressescustomerAddressIdResponse200DataRelationshipsAddressLinks,
)
from .ge_tcustomer_addressescustomer_address_id_response_200_data_relationships_customer import (
    GETcustomerAddressescustomerAddressIdResponse200DataRelationshipsCustomer,
)
from .ge_tcustomer_addressescustomer_address_id_response_200_data_relationships_customer_data import (
    GETcustomerAddressescustomerAddressIdResponse200DataRelationshipsCustomerData,
)
from .ge_tcustomer_addressescustomer_address_id_response_200_data_relationships_customer_data_type import (
    GETcustomerAddressescustomerAddressIdResponse200DataRelationshipsCustomerDataType,
)
from .ge_tcustomer_addressescustomer_address_id_response_200_data_relationships_customer_links import (
    GETcustomerAddressescustomerAddressIdResponse200DataRelationshipsCustomerLinks,
)
from .ge_tcustomer_addressescustomer_address_id_response_200_data_relationships_events import (
    GETcustomerAddressescustomerAddressIdResponse200DataRelationshipsEvents,
)
from .ge_tcustomer_addressescustomer_address_id_response_200_data_relationships_events_data import (
    GETcustomerAddressescustomerAddressIdResponse200DataRelationshipsEventsData,
)
from .ge_tcustomer_addressescustomer_address_id_response_200_data_relationships_events_data_type import (
    GETcustomerAddressescustomerAddressIdResponse200DataRelationshipsEventsDataType,
)
from .ge_tcustomer_addressescustomer_address_id_response_200_data_relationships_events_links import (
    GETcustomerAddressescustomerAddressIdResponse200DataRelationshipsEventsLinks,
)
from .ge_tcustomer_addressescustomer_address_id_response_200_data_type import (
    GETcustomerAddressescustomerAddressIdResponse200DataType,
)
from .ge_tcustomer_groups_response_200 import GETcustomerGroupsResponse200
from .ge_tcustomer_groups_response_200_data_item import GETcustomerGroupsResponse200DataItem
from .ge_tcustomer_groups_response_200_data_item_attributes import GETcustomerGroupsResponse200DataItemAttributes
from .ge_tcustomer_groups_response_200_data_item_attributes_metadata import (
    GETcustomerGroupsResponse200DataItemAttributesMetadata,
)
from .ge_tcustomer_groups_response_200_data_item_links import GETcustomerGroupsResponse200DataItemLinks
from .ge_tcustomer_groups_response_200_data_item_relationships import GETcustomerGroupsResponse200DataItemRelationships
from .ge_tcustomer_groups_response_200_data_item_relationships_attachments import (
    GETcustomerGroupsResponse200DataItemRelationshipsAttachments,
)
from .ge_tcustomer_groups_response_200_data_item_relationships_attachments_data import (
    GETcustomerGroupsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tcustomer_groups_response_200_data_item_relationships_attachments_data_type import (
    GETcustomerGroupsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tcustomer_groups_response_200_data_item_relationships_attachments_links import (
    GETcustomerGroupsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tcustomer_groups_response_200_data_item_relationships_customers import (
    GETcustomerGroupsResponse200DataItemRelationshipsCustomers,
)
from .ge_tcustomer_groups_response_200_data_item_relationships_customers_data import (
    GETcustomerGroupsResponse200DataItemRelationshipsCustomersData,
)
from .ge_tcustomer_groups_response_200_data_item_relationships_customers_data_type import (
    GETcustomerGroupsResponse200DataItemRelationshipsCustomersDataType,
)
from .ge_tcustomer_groups_response_200_data_item_relationships_customers_links import (
    GETcustomerGroupsResponse200DataItemRelationshipsCustomersLinks,
)
from .ge_tcustomer_groups_response_200_data_item_relationships_markets import (
    GETcustomerGroupsResponse200DataItemRelationshipsMarkets,
)
from .ge_tcustomer_groups_response_200_data_item_relationships_markets_data import (
    GETcustomerGroupsResponse200DataItemRelationshipsMarketsData,
)
from .ge_tcustomer_groups_response_200_data_item_relationships_markets_data_type import (
    GETcustomerGroupsResponse200DataItemRelationshipsMarketsDataType,
)
from .ge_tcustomer_groups_response_200_data_item_relationships_markets_links import (
    GETcustomerGroupsResponse200DataItemRelationshipsMarketsLinks,
)
from .ge_tcustomer_groups_response_200_data_item_type import GETcustomerGroupsResponse200DataItemType
from .ge_tcustomer_groupscustomer_group_id_response_200 import GETcustomerGroupscustomerGroupIdResponse200
from .ge_tcustomer_groupscustomer_group_id_response_200_data import GETcustomerGroupscustomerGroupIdResponse200Data
from .ge_tcustomer_groupscustomer_group_id_response_200_data_attributes import (
    GETcustomerGroupscustomerGroupIdResponse200DataAttributes,
)
from .ge_tcustomer_groupscustomer_group_id_response_200_data_attributes_metadata import (
    GETcustomerGroupscustomerGroupIdResponse200DataAttributesMetadata,
)
from .ge_tcustomer_groupscustomer_group_id_response_200_data_links import (
    GETcustomerGroupscustomerGroupIdResponse200DataLinks,
)
from .ge_tcustomer_groupscustomer_group_id_response_200_data_relationships import (
    GETcustomerGroupscustomerGroupIdResponse200DataRelationships,
)
from .ge_tcustomer_groupscustomer_group_id_response_200_data_relationships_attachments import (
    GETcustomerGroupscustomerGroupIdResponse200DataRelationshipsAttachments,
)
from .ge_tcustomer_groupscustomer_group_id_response_200_data_relationships_attachments_data import (
    GETcustomerGroupscustomerGroupIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tcustomer_groupscustomer_group_id_response_200_data_relationships_attachments_data_type import (
    GETcustomerGroupscustomerGroupIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tcustomer_groupscustomer_group_id_response_200_data_relationships_attachments_links import (
    GETcustomerGroupscustomerGroupIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tcustomer_groupscustomer_group_id_response_200_data_relationships_customers import (
    GETcustomerGroupscustomerGroupIdResponse200DataRelationshipsCustomers,
)
from .ge_tcustomer_groupscustomer_group_id_response_200_data_relationships_customers_data import (
    GETcustomerGroupscustomerGroupIdResponse200DataRelationshipsCustomersData,
)
from .ge_tcustomer_groupscustomer_group_id_response_200_data_relationships_customers_data_type import (
    GETcustomerGroupscustomerGroupIdResponse200DataRelationshipsCustomersDataType,
)
from .ge_tcustomer_groupscustomer_group_id_response_200_data_relationships_customers_links import (
    GETcustomerGroupscustomerGroupIdResponse200DataRelationshipsCustomersLinks,
)
from .ge_tcustomer_groupscustomer_group_id_response_200_data_relationships_markets import (
    GETcustomerGroupscustomerGroupIdResponse200DataRelationshipsMarkets,
)
from .ge_tcustomer_groupscustomer_group_id_response_200_data_relationships_markets_data import (
    GETcustomerGroupscustomerGroupIdResponse200DataRelationshipsMarketsData,
)
from .ge_tcustomer_groupscustomer_group_id_response_200_data_relationships_markets_data_type import (
    GETcustomerGroupscustomerGroupIdResponse200DataRelationshipsMarketsDataType,
)
from .ge_tcustomer_groupscustomer_group_id_response_200_data_relationships_markets_links import (
    GETcustomerGroupscustomerGroupIdResponse200DataRelationshipsMarketsLinks,
)
from .ge_tcustomer_groupscustomer_group_id_response_200_data_type import (
    GETcustomerGroupscustomerGroupIdResponse200DataType,
)
from .ge_tcustomer_password_resets_response_200 import GETcustomerPasswordResetsResponse200
from .ge_tcustomer_password_resets_response_200_data_item import GETcustomerPasswordResetsResponse200DataItem
from .ge_tcustomer_password_resets_response_200_data_item_attributes import (
    GETcustomerPasswordResetsResponse200DataItemAttributes,
)
from .ge_tcustomer_password_resets_response_200_data_item_attributes_metadata import (
    GETcustomerPasswordResetsResponse200DataItemAttributesMetadata,
)
from .ge_tcustomer_password_resets_response_200_data_item_links import GETcustomerPasswordResetsResponse200DataItemLinks
from .ge_tcustomer_password_resets_response_200_data_item_relationships import (
    GETcustomerPasswordResetsResponse200DataItemRelationships,
)
from .ge_tcustomer_password_resets_response_200_data_item_relationships_customer import (
    GETcustomerPasswordResetsResponse200DataItemRelationshipsCustomer,
)
from .ge_tcustomer_password_resets_response_200_data_item_relationships_customer_data import (
    GETcustomerPasswordResetsResponse200DataItemRelationshipsCustomerData,
)
from .ge_tcustomer_password_resets_response_200_data_item_relationships_customer_data_type import (
    GETcustomerPasswordResetsResponse200DataItemRelationshipsCustomerDataType,
)
from .ge_tcustomer_password_resets_response_200_data_item_relationships_customer_links import (
    GETcustomerPasswordResetsResponse200DataItemRelationshipsCustomerLinks,
)
from .ge_tcustomer_password_resets_response_200_data_item_relationships_events import (
    GETcustomerPasswordResetsResponse200DataItemRelationshipsEvents,
)
from .ge_tcustomer_password_resets_response_200_data_item_relationships_events_data import (
    GETcustomerPasswordResetsResponse200DataItemRelationshipsEventsData,
)
from .ge_tcustomer_password_resets_response_200_data_item_relationships_events_data_type import (
    GETcustomerPasswordResetsResponse200DataItemRelationshipsEventsDataType,
)
from .ge_tcustomer_password_resets_response_200_data_item_relationships_events_links import (
    GETcustomerPasswordResetsResponse200DataItemRelationshipsEventsLinks,
)
from .ge_tcustomer_password_resets_response_200_data_item_type import GETcustomerPasswordResetsResponse200DataItemType
from .ge_tcustomer_password_resetscustomer_password_reset_id_response_200 import (
    GETcustomerPasswordResetscustomerPasswordResetIdResponse200,
)
from .ge_tcustomer_password_resetscustomer_password_reset_id_response_200_data import (
    GETcustomerPasswordResetscustomerPasswordResetIdResponse200Data,
)
from .ge_tcustomer_password_resetscustomer_password_reset_id_response_200_data_attributes import (
    GETcustomerPasswordResetscustomerPasswordResetIdResponse200DataAttributes,
)
from .ge_tcustomer_password_resetscustomer_password_reset_id_response_200_data_attributes_metadata import (
    GETcustomerPasswordResetscustomerPasswordResetIdResponse200DataAttributesMetadata,
)
from .ge_tcustomer_password_resetscustomer_password_reset_id_response_200_data_links import (
    GETcustomerPasswordResetscustomerPasswordResetIdResponse200DataLinks,
)
from .ge_tcustomer_password_resetscustomer_password_reset_id_response_200_data_relationships import (
    GETcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationships,
)
from .ge_tcustomer_password_resetscustomer_password_reset_id_response_200_data_relationships_customer import (
    GETcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsCustomer,
)
from .ge_tcustomer_password_resetscustomer_password_reset_id_response_200_data_relationships_customer_data import (
    GETcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsCustomerData,
)
from .ge_tcustomer_password_resetscustomer_password_reset_id_response_200_data_relationships_customer_data_type import (
    GETcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsCustomerDataType,
)
from .ge_tcustomer_password_resetscustomer_password_reset_id_response_200_data_relationships_customer_links import (
    GETcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsCustomerLinks,
)
from .ge_tcustomer_password_resetscustomer_password_reset_id_response_200_data_relationships_events import (
    GETcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsEvents,
)
from .ge_tcustomer_password_resetscustomer_password_reset_id_response_200_data_relationships_events_data import (
    GETcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsEventsData,
)
from .ge_tcustomer_password_resetscustomer_password_reset_id_response_200_data_relationships_events_data_type import (
    GETcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsEventsDataType,
)
from .ge_tcustomer_password_resetscustomer_password_reset_id_response_200_data_relationships_events_links import (
    GETcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsEventsLinks,
)
from .ge_tcustomer_password_resetscustomer_password_reset_id_response_200_data_type import (
    GETcustomerPasswordResetscustomerPasswordResetIdResponse200DataType,
)
from .ge_tcustomer_payment_sources_response_200 import GETcustomerPaymentSourcesResponse200
from .ge_tcustomer_payment_sources_response_200_data_item import GETcustomerPaymentSourcesResponse200DataItem
from .ge_tcustomer_payment_sources_response_200_data_item_attributes import (
    GETcustomerPaymentSourcesResponse200DataItemAttributes,
)
from .ge_tcustomer_payment_sources_response_200_data_item_attributes_metadata import (
    GETcustomerPaymentSourcesResponse200DataItemAttributesMetadata,
)
from .ge_tcustomer_payment_sources_response_200_data_item_links import GETcustomerPaymentSourcesResponse200DataItemLinks
from .ge_tcustomer_payment_sources_response_200_data_item_relationships import (
    GETcustomerPaymentSourcesResponse200DataItemRelationships,
)
from .ge_tcustomer_payment_sources_response_200_data_item_relationships_customer import (
    GETcustomerPaymentSourcesResponse200DataItemRelationshipsCustomer,
)
from .ge_tcustomer_payment_sources_response_200_data_item_relationships_customer_data import (
    GETcustomerPaymentSourcesResponse200DataItemRelationshipsCustomerData,
)
from .ge_tcustomer_payment_sources_response_200_data_item_relationships_customer_data_type import (
    GETcustomerPaymentSourcesResponse200DataItemRelationshipsCustomerDataType,
)
from .ge_tcustomer_payment_sources_response_200_data_item_relationships_customer_links import (
    GETcustomerPaymentSourcesResponse200DataItemRelationshipsCustomerLinks,
)
from .ge_tcustomer_payment_sources_response_200_data_item_relationships_payment_source import (
    GETcustomerPaymentSourcesResponse200DataItemRelationshipsPaymentSource,
)
from .ge_tcustomer_payment_sources_response_200_data_item_relationships_payment_source_data import (
    GETcustomerPaymentSourcesResponse200DataItemRelationshipsPaymentSourceData,
)
from .ge_tcustomer_payment_sources_response_200_data_item_relationships_payment_source_data_type import (
    GETcustomerPaymentSourcesResponse200DataItemRelationshipsPaymentSourceDataType,
)
from .ge_tcustomer_payment_sources_response_200_data_item_relationships_payment_source_links import (
    GETcustomerPaymentSourcesResponse200DataItemRelationshipsPaymentSourceLinks,
)
from .ge_tcustomer_payment_sources_response_200_data_item_type import GETcustomerPaymentSourcesResponse200DataItemType
from .ge_tcustomer_payment_sourcescustomer_payment_source_id_response_200 import (
    GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200,
)
from .ge_tcustomer_payment_sourcescustomer_payment_source_id_response_200_data import (
    GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200Data,
)
from .ge_tcustomer_payment_sourcescustomer_payment_source_id_response_200_data_attributes import (
    GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataAttributes,
)
from .ge_tcustomer_payment_sourcescustomer_payment_source_id_response_200_data_attributes_metadata import (
    GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataAttributesMetadata,
)
from .ge_tcustomer_payment_sourcescustomer_payment_source_id_response_200_data_links import (
    GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataLinks,
)
from .ge_tcustomer_payment_sourcescustomer_payment_source_id_response_200_data_relationships import (
    GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationships,
)
from .ge_tcustomer_payment_sourcescustomer_payment_source_id_response_200_data_relationships_customer import (
    GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsCustomer,
)
from .ge_tcustomer_payment_sourcescustomer_payment_source_id_response_200_data_relationships_customer_data import (
    GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsCustomerData,
)
from .ge_tcustomer_payment_sourcescustomer_payment_source_id_response_200_data_relationships_customer_data_type import (
    GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsCustomerDataType,
)
from .ge_tcustomer_payment_sourcescustomer_payment_source_id_response_200_data_relationships_customer_links import (
    GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsCustomerLinks,
)
from .ge_tcustomer_payment_sourcescustomer_payment_source_id_response_200_data_relationships_payment_source import (
    GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsPaymentSource,
)
from .ge_tcustomer_payment_sourcescustomer_payment_source_id_response_200_data_relationships_payment_source_data import (
    GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsPaymentSourceData,
)
from .ge_tcustomer_payment_sourcescustomer_payment_source_id_response_200_data_relationships_payment_source_data_type import (
    GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsPaymentSourceDataType,
)
from .ge_tcustomer_payment_sourcescustomer_payment_source_id_response_200_data_relationships_payment_source_links import (
    GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsPaymentSourceLinks,
)
from .ge_tcustomer_payment_sourcescustomer_payment_source_id_response_200_data_type import (
    GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataType,
)
from .ge_tcustomer_subscriptions_response_200 import GETcustomerSubscriptionsResponse200
from .ge_tcustomer_subscriptions_response_200_data_item import GETcustomerSubscriptionsResponse200DataItem
from .ge_tcustomer_subscriptions_response_200_data_item_attributes import (
    GETcustomerSubscriptionsResponse200DataItemAttributes,
)
from .ge_tcustomer_subscriptions_response_200_data_item_attributes_metadata import (
    GETcustomerSubscriptionsResponse200DataItemAttributesMetadata,
)
from .ge_tcustomer_subscriptions_response_200_data_item_links import GETcustomerSubscriptionsResponse200DataItemLinks
from .ge_tcustomer_subscriptions_response_200_data_item_relationships import (
    GETcustomerSubscriptionsResponse200DataItemRelationships,
)
from .ge_tcustomer_subscriptions_response_200_data_item_relationships_customer import (
    GETcustomerSubscriptionsResponse200DataItemRelationshipsCustomer,
)
from .ge_tcustomer_subscriptions_response_200_data_item_relationships_customer_data import (
    GETcustomerSubscriptionsResponse200DataItemRelationshipsCustomerData,
)
from .ge_tcustomer_subscriptions_response_200_data_item_relationships_customer_data_type import (
    GETcustomerSubscriptionsResponse200DataItemRelationshipsCustomerDataType,
)
from .ge_tcustomer_subscriptions_response_200_data_item_relationships_customer_links import (
    GETcustomerSubscriptionsResponse200DataItemRelationshipsCustomerLinks,
)
from .ge_tcustomer_subscriptions_response_200_data_item_relationships_events import (
    GETcustomerSubscriptionsResponse200DataItemRelationshipsEvents,
)
from .ge_tcustomer_subscriptions_response_200_data_item_relationships_events_data import (
    GETcustomerSubscriptionsResponse200DataItemRelationshipsEventsData,
)
from .ge_tcustomer_subscriptions_response_200_data_item_relationships_events_data_type import (
    GETcustomerSubscriptionsResponse200DataItemRelationshipsEventsDataType,
)
from .ge_tcustomer_subscriptions_response_200_data_item_relationships_events_links import (
    GETcustomerSubscriptionsResponse200DataItemRelationshipsEventsLinks,
)
from .ge_tcustomer_subscriptions_response_200_data_item_type import GETcustomerSubscriptionsResponse200DataItemType
from .ge_tcustomer_subscriptionscustomer_subscription_id_response_200 import (
    GETcustomerSubscriptionscustomerSubscriptionIdResponse200,
)
from .ge_tcustomer_subscriptionscustomer_subscription_id_response_200_data import (
    GETcustomerSubscriptionscustomerSubscriptionIdResponse200Data,
)
from .ge_tcustomer_subscriptionscustomer_subscription_id_response_200_data_attributes import (
    GETcustomerSubscriptionscustomerSubscriptionIdResponse200DataAttributes,
)
from .ge_tcustomer_subscriptionscustomer_subscription_id_response_200_data_attributes_metadata import (
    GETcustomerSubscriptionscustomerSubscriptionIdResponse200DataAttributesMetadata,
)
from .ge_tcustomer_subscriptionscustomer_subscription_id_response_200_data_links import (
    GETcustomerSubscriptionscustomerSubscriptionIdResponse200DataLinks,
)
from .ge_tcustomer_subscriptionscustomer_subscription_id_response_200_data_relationships import (
    GETcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationships,
)
from .ge_tcustomer_subscriptionscustomer_subscription_id_response_200_data_relationships_customer import (
    GETcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsCustomer,
)
from .ge_tcustomer_subscriptionscustomer_subscription_id_response_200_data_relationships_customer_data import (
    GETcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsCustomerData,
)
from .ge_tcustomer_subscriptionscustomer_subscription_id_response_200_data_relationships_customer_data_type import (
    GETcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsCustomerDataType,
)
from .ge_tcustomer_subscriptionscustomer_subscription_id_response_200_data_relationships_customer_links import (
    GETcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsCustomerLinks,
)
from .ge_tcustomer_subscriptionscustomer_subscription_id_response_200_data_relationships_events import (
    GETcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsEvents,
)
from .ge_tcustomer_subscriptionscustomer_subscription_id_response_200_data_relationships_events_data import (
    GETcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsEventsData,
)
from .ge_tcustomer_subscriptionscustomer_subscription_id_response_200_data_relationships_events_data_type import (
    GETcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsEventsDataType,
)
from .ge_tcustomer_subscriptionscustomer_subscription_id_response_200_data_relationships_events_links import (
    GETcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsEventsLinks,
)
from .ge_tcustomer_subscriptionscustomer_subscription_id_response_200_data_type import (
    GETcustomerSubscriptionscustomerSubscriptionIdResponse200DataType,
)
from .ge_tcustomers_response_200 import GETcustomersResponse200
from .ge_tcustomers_response_200_data_item import GETcustomersResponse200DataItem
from .ge_tcustomers_response_200_data_item_attributes import GETcustomersResponse200DataItemAttributes
from .ge_tcustomers_response_200_data_item_attributes_metadata import GETcustomersResponse200DataItemAttributesMetadata
from .ge_tcustomers_response_200_data_item_links import GETcustomersResponse200DataItemLinks
from .ge_tcustomers_response_200_data_item_relationships import GETcustomersResponse200DataItemRelationships
from .ge_tcustomers_response_200_data_item_relationships_attachments import (
    GETcustomersResponse200DataItemRelationshipsAttachments,
)
from .ge_tcustomers_response_200_data_item_relationships_attachments_data import (
    GETcustomersResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tcustomers_response_200_data_item_relationships_attachments_data_type import (
    GETcustomersResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tcustomers_response_200_data_item_relationships_attachments_links import (
    GETcustomersResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tcustomers_response_200_data_item_relationships_customer_addresses import (
    GETcustomersResponse200DataItemRelationshipsCustomerAddresses,
)
from .ge_tcustomers_response_200_data_item_relationships_customer_addresses_data import (
    GETcustomersResponse200DataItemRelationshipsCustomerAddressesData,
)
from .ge_tcustomers_response_200_data_item_relationships_customer_addresses_data_type import (
    GETcustomersResponse200DataItemRelationshipsCustomerAddressesDataType,
)
from .ge_tcustomers_response_200_data_item_relationships_customer_addresses_links import (
    GETcustomersResponse200DataItemRelationshipsCustomerAddressesLinks,
)
from .ge_tcustomers_response_200_data_item_relationships_customer_group import (
    GETcustomersResponse200DataItemRelationshipsCustomerGroup,
)
from .ge_tcustomers_response_200_data_item_relationships_customer_group_data import (
    GETcustomersResponse200DataItemRelationshipsCustomerGroupData,
)
from .ge_tcustomers_response_200_data_item_relationships_customer_group_data_type import (
    GETcustomersResponse200DataItemRelationshipsCustomerGroupDataType,
)
from .ge_tcustomers_response_200_data_item_relationships_customer_group_links import (
    GETcustomersResponse200DataItemRelationshipsCustomerGroupLinks,
)
from .ge_tcustomers_response_200_data_item_relationships_customer_payment_sources import (
    GETcustomersResponse200DataItemRelationshipsCustomerPaymentSources,
)
from .ge_tcustomers_response_200_data_item_relationships_customer_payment_sources_data import (
    GETcustomersResponse200DataItemRelationshipsCustomerPaymentSourcesData,
)
from .ge_tcustomers_response_200_data_item_relationships_customer_payment_sources_data_type import (
    GETcustomersResponse200DataItemRelationshipsCustomerPaymentSourcesDataType,
)
from .ge_tcustomers_response_200_data_item_relationships_customer_payment_sources_links import (
    GETcustomersResponse200DataItemRelationshipsCustomerPaymentSourcesLinks,
)
from .ge_tcustomers_response_200_data_item_relationships_customer_subscriptions import (
    GETcustomersResponse200DataItemRelationshipsCustomerSubscriptions,
)
from .ge_tcustomers_response_200_data_item_relationships_customer_subscriptions_data import (
    GETcustomersResponse200DataItemRelationshipsCustomerSubscriptionsData,
)
from .ge_tcustomers_response_200_data_item_relationships_customer_subscriptions_data_type import (
    GETcustomersResponse200DataItemRelationshipsCustomerSubscriptionsDataType,
)
from .ge_tcustomers_response_200_data_item_relationships_customer_subscriptions_links import (
    GETcustomersResponse200DataItemRelationshipsCustomerSubscriptionsLinks,
)
from .ge_tcustomers_response_200_data_item_relationships_events import (
    GETcustomersResponse200DataItemRelationshipsEvents,
)
from .ge_tcustomers_response_200_data_item_relationships_events_data import (
    GETcustomersResponse200DataItemRelationshipsEventsData,
)
from .ge_tcustomers_response_200_data_item_relationships_events_data_type import (
    GETcustomersResponse200DataItemRelationshipsEventsDataType,
)
from .ge_tcustomers_response_200_data_item_relationships_events_links import (
    GETcustomersResponse200DataItemRelationshipsEventsLinks,
)
from .ge_tcustomers_response_200_data_item_relationships_order_subscriptions import (
    GETcustomersResponse200DataItemRelationshipsOrderSubscriptions,
)
from .ge_tcustomers_response_200_data_item_relationships_order_subscriptions_data import (
    GETcustomersResponse200DataItemRelationshipsOrderSubscriptionsData,
)
from .ge_tcustomers_response_200_data_item_relationships_order_subscriptions_data_type import (
    GETcustomersResponse200DataItemRelationshipsOrderSubscriptionsDataType,
)
from .ge_tcustomers_response_200_data_item_relationships_order_subscriptions_links import (
    GETcustomersResponse200DataItemRelationshipsOrderSubscriptionsLinks,
)
from .ge_tcustomers_response_200_data_item_relationships_orders import (
    GETcustomersResponse200DataItemRelationshipsOrders,
)
from .ge_tcustomers_response_200_data_item_relationships_orders_data import (
    GETcustomersResponse200DataItemRelationshipsOrdersData,
)
from .ge_tcustomers_response_200_data_item_relationships_orders_data_type import (
    GETcustomersResponse200DataItemRelationshipsOrdersDataType,
)
from .ge_tcustomers_response_200_data_item_relationships_orders_links import (
    GETcustomersResponse200DataItemRelationshipsOrdersLinks,
)
from .ge_tcustomers_response_200_data_item_relationships_returns import (
    GETcustomersResponse200DataItemRelationshipsReturns,
)
from .ge_tcustomers_response_200_data_item_relationships_returns_data import (
    GETcustomersResponse200DataItemRelationshipsReturnsData,
)
from .ge_tcustomers_response_200_data_item_relationships_returns_data_type import (
    GETcustomersResponse200DataItemRelationshipsReturnsDataType,
)
from .ge_tcustomers_response_200_data_item_relationships_returns_links import (
    GETcustomersResponse200DataItemRelationshipsReturnsLinks,
)
from .ge_tcustomers_response_200_data_item_relationships_sku_lists import (
    GETcustomersResponse200DataItemRelationshipsSkuLists,
)
from .ge_tcustomers_response_200_data_item_relationships_sku_lists_data import (
    GETcustomersResponse200DataItemRelationshipsSkuListsData,
)
from .ge_tcustomers_response_200_data_item_relationships_sku_lists_data_type import (
    GETcustomersResponse200DataItemRelationshipsSkuListsDataType,
)
from .ge_tcustomers_response_200_data_item_relationships_sku_lists_links import (
    GETcustomersResponse200DataItemRelationshipsSkuListsLinks,
)
from .ge_tcustomers_response_200_data_item_type import GETcustomersResponse200DataItemType
from .ge_tcustomerscustomer_id_response_200 import GETcustomerscustomerIdResponse200
from .ge_tcustomerscustomer_id_response_200_data import GETcustomerscustomerIdResponse200Data
from .ge_tcustomerscustomer_id_response_200_data_attributes import GETcustomerscustomerIdResponse200DataAttributes
from .ge_tcustomerscustomer_id_response_200_data_attributes_metadata import (
    GETcustomerscustomerIdResponse200DataAttributesMetadata,
)
from .ge_tcustomerscustomer_id_response_200_data_links import GETcustomerscustomerIdResponse200DataLinks
from .ge_tcustomerscustomer_id_response_200_data_relationships import GETcustomerscustomerIdResponse200DataRelationships
from .ge_tcustomerscustomer_id_response_200_data_relationships_attachments import (
    GETcustomerscustomerIdResponse200DataRelationshipsAttachments,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_attachments_data import (
    GETcustomerscustomerIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_attachments_data_type import (
    GETcustomerscustomerIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_attachments_links import (
    GETcustomerscustomerIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_customer_addresses import (
    GETcustomerscustomerIdResponse200DataRelationshipsCustomerAddresses,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_customer_addresses_data import (
    GETcustomerscustomerIdResponse200DataRelationshipsCustomerAddressesData,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_customer_addresses_data_type import (
    GETcustomerscustomerIdResponse200DataRelationshipsCustomerAddressesDataType,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_customer_addresses_links import (
    GETcustomerscustomerIdResponse200DataRelationshipsCustomerAddressesLinks,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_customer_group import (
    GETcustomerscustomerIdResponse200DataRelationshipsCustomerGroup,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_customer_group_data import (
    GETcustomerscustomerIdResponse200DataRelationshipsCustomerGroupData,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_customer_group_data_type import (
    GETcustomerscustomerIdResponse200DataRelationshipsCustomerGroupDataType,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_customer_group_links import (
    GETcustomerscustomerIdResponse200DataRelationshipsCustomerGroupLinks,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_customer_payment_sources import (
    GETcustomerscustomerIdResponse200DataRelationshipsCustomerPaymentSources,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_customer_payment_sources_data import (
    GETcustomerscustomerIdResponse200DataRelationshipsCustomerPaymentSourcesData,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_customer_payment_sources_data_type import (
    GETcustomerscustomerIdResponse200DataRelationshipsCustomerPaymentSourcesDataType,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_customer_payment_sources_links import (
    GETcustomerscustomerIdResponse200DataRelationshipsCustomerPaymentSourcesLinks,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_customer_subscriptions import (
    GETcustomerscustomerIdResponse200DataRelationshipsCustomerSubscriptions,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_customer_subscriptions_data import (
    GETcustomerscustomerIdResponse200DataRelationshipsCustomerSubscriptionsData,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_customer_subscriptions_data_type import (
    GETcustomerscustomerIdResponse200DataRelationshipsCustomerSubscriptionsDataType,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_customer_subscriptions_links import (
    GETcustomerscustomerIdResponse200DataRelationshipsCustomerSubscriptionsLinks,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_events import (
    GETcustomerscustomerIdResponse200DataRelationshipsEvents,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_events_data import (
    GETcustomerscustomerIdResponse200DataRelationshipsEventsData,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_events_data_type import (
    GETcustomerscustomerIdResponse200DataRelationshipsEventsDataType,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_events_links import (
    GETcustomerscustomerIdResponse200DataRelationshipsEventsLinks,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_order_subscriptions import (
    GETcustomerscustomerIdResponse200DataRelationshipsOrderSubscriptions,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_order_subscriptions_data import (
    GETcustomerscustomerIdResponse200DataRelationshipsOrderSubscriptionsData,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_order_subscriptions_data_type import (
    GETcustomerscustomerIdResponse200DataRelationshipsOrderSubscriptionsDataType,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_order_subscriptions_links import (
    GETcustomerscustomerIdResponse200DataRelationshipsOrderSubscriptionsLinks,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_orders import (
    GETcustomerscustomerIdResponse200DataRelationshipsOrders,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_orders_data import (
    GETcustomerscustomerIdResponse200DataRelationshipsOrdersData,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_orders_data_type import (
    GETcustomerscustomerIdResponse200DataRelationshipsOrdersDataType,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_orders_links import (
    GETcustomerscustomerIdResponse200DataRelationshipsOrdersLinks,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_returns import (
    GETcustomerscustomerIdResponse200DataRelationshipsReturns,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_returns_data import (
    GETcustomerscustomerIdResponse200DataRelationshipsReturnsData,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_returns_data_type import (
    GETcustomerscustomerIdResponse200DataRelationshipsReturnsDataType,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_returns_links import (
    GETcustomerscustomerIdResponse200DataRelationshipsReturnsLinks,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_sku_lists import (
    GETcustomerscustomerIdResponse200DataRelationshipsSkuLists,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_sku_lists_data import (
    GETcustomerscustomerIdResponse200DataRelationshipsSkuListsData,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_sku_lists_data_type import (
    GETcustomerscustomerIdResponse200DataRelationshipsSkuListsDataType,
)
from .ge_tcustomerscustomer_id_response_200_data_relationships_sku_lists_links import (
    GETcustomerscustomerIdResponse200DataRelationshipsSkuListsLinks,
)
from .ge_tcustomerscustomer_id_response_200_data_type import GETcustomerscustomerIdResponse200DataType
from .ge_tdelivery_lead_times_response_200 import GETdeliveryLeadTimesResponse200
from .ge_tdelivery_lead_times_response_200_data_item import GETdeliveryLeadTimesResponse200DataItem
from .ge_tdelivery_lead_times_response_200_data_item_attributes import GETdeliveryLeadTimesResponse200DataItemAttributes
from .ge_tdelivery_lead_times_response_200_data_item_attributes_metadata import (
    GETdeliveryLeadTimesResponse200DataItemAttributesMetadata,
)
from .ge_tdelivery_lead_times_response_200_data_item_links import GETdeliveryLeadTimesResponse200DataItemLinks
from .ge_tdelivery_lead_times_response_200_data_item_relationships import (
    GETdeliveryLeadTimesResponse200DataItemRelationships,
)
from .ge_tdelivery_lead_times_response_200_data_item_relationships_attachments import (
    GETdeliveryLeadTimesResponse200DataItemRelationshipsAttachments,
)
from .ge_tdelivery_lead_times_response_200_data_item_relationships_attachments_data import (
    GETdeliveryLeadTimesResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tdelivery_lead_times_response_200_data_item_relationships_attachments_data_type import (
    GETdeliveryLeadTimesResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tdelivery_lead_times_response_200_data_item_relationships_attachments_links import (
    GETdeliveryLeadTimesResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tdelivery_lead_times_response_200_data_item_relationships_shipping_method import (
    GETdeliveryLeadTimesResponse200DataItemRelationshipsShippingMethod,
)
from .ge_tdelivery_lead_times_response_200_data_item_relationships_shipping_method_data import (
    GETdeliveryLeadTimesResponse200DataItemRelationshipsShippingMethodData,
)
from .ge_tdelivery_lead_times_response_200_data_item_relationships_shipping_method_data_type import (
    GETdeliveryLeadTimesResponse200DataItemRelationshipsShippingMethodDataType,
)
from .ge_tdelivery_lead_times_response_200_data_item_relationships_shipping_method_links import (
    GETdeliveryLeadTimesResponse200DataItemRelationshipsShippingMethodLinks,
)
from .ge_tdelivery_lead_times_response_200_data_item_relationships_stock_location import (
    GETdeliveryLeadTimesResponse200DataItemRelationshipsStockLocation,
)
from .ge_tdelivery_lead_times_response_200_data_item_relationships_stock_location_data import (
    GETdeliveryLeadTimesResponse200DataItemRelationshipsStockLocationData,
)
from .ge_tdelivery_lead_times_response_200_data_item_relationships_stock_location_data_type import (
    GETdeliveryLeadTimesResponse200DataItemRelationshipsStockLocationDataType,
)
from .ge_tdelivery_lead_times_response_200_data_item_relationships_stock_location_links import (
    GETdeliveryLeadTimesResponse200DataItemRelationshipsStockLocationLinks,
)
from .ge_tdelivery_lead_times_response_200_data_item_type import GETdeliveryLeadTimesResponse200DataItemType
from .ge_tdelivery_lead_timesdelivery_lead_time_id_response_200 import GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200
from .ge_tdelivery_lead_timesdelivery_lead_time_id_response_200_data import (
    GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200Data,
)
from .ge_tdelivery_lead_timesdelivery_lead_time_id_response_200_data_attributes import (
    GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataAttributes,
)
from .ge_tdelivery_lead_timesdelivery_lead_time_id_response_200_data_attributes_metadata import (
    GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataAttributesMetadata,
)
from .ge_tdelivery_lead_timesdelivery_lead_time_id_response_200_data_links import (
    GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataLinks,
)
from .ge_tdelivery_lead_timesdelivery_lead_time_id_response_200_data_relationships import (
    GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationships,
)
from .ge_tdelivery_lead_timesdelivery_lead_time_id_response_200_data_relationships_attachments import (
    GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsAttachments,
)
from .ge_tdelivery_lead_timesdelivery_lead_time_id_response_200_data_relationships_attachments_data import (
    GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tdelivery_lead_timesdelivery_lead_time_id_response_200_data_relationships_attachments_data_type import (
    GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tdelivery_lead_timesdelivery_lead_time_id_response_200_data_relationships_attachments_links import (
    GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tdelivery_lead_timesdelivery_lead_time_id_response_200_data_relationships_shipping_method import (
    GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsShippingMethod,
)
from .ge_tdelivery_lead_timesdelivery_lead_time_id_response_200_data_relationships_shipping_method_data import (
    GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsShippingMethodData,
)
from .ge_tdelivery_lead_timesdelivery_lead_time_id_response_200_data_relationships_shipping_method_data_type import (
    GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsShippingMethodDataType,
)
from .ge_tdelivery_lead_timesdelivery_lead_time_id_response_200_data_relationships_shipping_method_links import (
    GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsShippingMethodLinks,
)
from .ge_tdelivery_lead_timesdelivery_lead_time_id_response_200_data_relationships_stock_location import (
    GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsStockLocation,
)
from .ge_tdelivery_lead_timesdelivery_lead_time_id_response_200_data_relationships_stock_location_data import (
    GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsStockLocationData,
)
from .ge_tdelivery_lead_timesdelivery_lead_time_id_response_200_data_relationships_stock_location_data_type import (
    GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsStockLocationDataType,
)
from .ge_tdelivery_lead_timesdelivery_lead_time_id_response_200_data_relationships_stock_location_links import (
    GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsStockLocationLinks,
)
from .ge_tdelivery_lead_timesdelivery_lead_time_id_response_200_data_type import (
    GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataType,
)
from .ge_tevent_callbacks_response_200 import GETeventCallbacksResponse200
from .ge_tevent_callbacks_response_200_data_item import GETeventCallbacksResponse200DataItem
from .ge_tevent_callbacks_response_200_data_item_attributes import GETeventCallbacksResponse200DataItemAttributes
from .ge_tevent_callbacks_response_200_data_item_attributes_metadata import (
    GETeventCallbacksResponse200DataItemAttributesMetadata,
)
from .ge_tevent_callbacks_response_200_data_item_attributes_payload import (
    GETeventCallbacksResponse200DataItemAttributesPayload,
)
from .ge_tevent_callbacks_response_200_data_item_links import GETeventCallbacksResponse200DataItemLinks
from .ge_tevent_callbacks_response_200_data_item_relationships import GETeventCallbacksResponse200DataItemRelationships
from .ge_tevent_callbacks_response_200_data_item_relationships_webhook import (
    GETeventCallbacksResponse200DataItemRelationshipsWebhook,
)
from .ge_tevent_callbacks_response_200_data_item_relationships_webhook_data import (
    GETeventCallbacksResponse200DataItemRelationshipsWebhookData,
)
from .ge_tevent_callbacks_response_200_data_item_relationships_webhook_data_type import (
    GETeventCallbacksResponse200DataItemRelationshipsWebhookDataType,
)
from .ge_tevent_callbacks_response_200_data_item_relationships_webhook_links import (
    GETeventCallbacksResponse200DataItemRelationshipsWebhookLinks,
)
from .ge_tevent_callbacks_response_200_data_item_type import GETeventCallbacksResponse200DataItemType
from .ge_tevent_callbacksevent_callback_id_response_200 import GETeventCallbackseventCallbackIdResponse200
from .ge_tevent_callbacksevent_callback_id_response_200_data import GETeventCallbackseventCallbackIdResponse200Data
from .ge_tevent_callbacksevent_callback_id_response_200_data_attributes import (
    GETeventCallbackseventCallbackIdResponse200DataAttributes,
)
from .ge_tevent_callbacksevent_callback_id_response_200_data_attributes_metadata import (
    GETeventCallbackseventCallbackIdResponse200DataAttributesMetadata,
)
from .ge_tevent_callbacksevent_callback_id_response_200_data_attributes_payload import (
    GETeventCallbackseventCallbackIdResponse200DataAttributesPayload,
)
from .ge_tevent_callbacksevent_callback_id_response_200_data_links import (
    GETeventCallbackseventCallbackIdResponse200DataLinks,
)
from .ge_tevent_callbacksevent_callback_id_response_200_data_relationships import (
    GETeventCallbackseventCallbackIdResponse200DataRelationships,
)
from .ge_tevent_callbacksevent_callback_id_response_200_data_relationships_webhook import (
    GETeventCallbackseventCallbackIdResponse200DataRelationshipsWebhook,
)
from .ge_tevent_callbacksevent_callback_id_response_200_data_relationships_webhook_data import (
    GETeventCallbackseventCallbackIdResponse200DataRelationshipsWebhookData,
)
from .ge_tevent_callbacksevent_callback_id_response_200_data_relationships_webhook_data_type import (
    GETeventCallbackseventCallbackIdResponse200DataRelationshipsWebhookDataType,
)
from .ge_tevent_callbacksevent_callback_id_response_200_data_relationships_webhook_links import (
    GETeventCallbackseventCallbackIdResponse200DataRelationshipsWebhookLinks,
)
from .ge_tevent_callbacksevent_callback_id_response_200_data_type import (
    GETeventCallbackseventCallbackIdResponse200DataType,
)
from .ge_tevents_response_200 import GETeventsResponse200
from .ge_tevents_response_200_data_item import GETeventsResponse200DataItem
from .ge_tevents_response_200_data_item_attributes import GETeventsResponse200DataItemAttributes
from .ge_tevents_response_200_data_item_attributes_metadata import GETeventsResponse200DataItemAttributesMetadata
from .ge_tevents_response_200_data_item_links import GETeventsResponse200DataItemLinks
from .ge_tevents_response_200_data_item_relationships import GETeventsResponse200DataItemRelationships
from .ge_tevents_response_200_data_item_relationships_last_event_callbacks import (
    GETeventsResponse200DataItemRelationshipsLastEventCallbacks,
)
from .ge_tevents_response_200_data_item_relationships_last_event_callbacks_data import (
    GETeventsResponse200DataItemRelationshipsLastEventCallbacksData,
)
from .ge_tevents_response_200_data_item_relationships_last_event_callbacks_data_type import (
    GETeventsResponse200DataItemRelationshipsLastEventCallbacksDataType,
)
from .ge_tevents_response_200_data_item_relationships_last_event_callbacks_links import (
    GETeventsResponse200DataItemRelationshipsLastEventCallbacksLinks,
)
from .ge_tevents_response_200_data_item_relationships_webhooks import GETeventsResponse200DataItemRelationshipsWebhooks
from .ge_tevents_response_200_data_item_relationships_webhooks_data import (
    GETeventsResponse200DataItemRelationshipsWebhooksData,
)
from .ge_tevents_response_200_data_item_relationships_webhooks_data_type import (
    GETeventsResponse200DataItemRelationshipsWebhooksDataType,
)
from .ge_tevents_response_200_data_item_relationships_webhooks_links import (
    GETeventsResponse200DataItemRelationshipsWebhooksLinks,
)
from .ge_tevents_response_200_data_item_type import GETeventsResponse200DataItemType
from .ge_teventsevent_id_response_200 import GETeventseventIdResponse200
from .ge_teventsevent_id_response_200_data import GETeventseventIdResponse200Data
from .ge_teventsevent_id_response_200_data_attributes import GETeventseventIdResponse200DataAttributes
from .ge_teventsevent_id_response_200_data_attributes_metadata import GETeventseventIdResponse200DataAttributesMetadata
from .ge_teventsevent_id_response_200_data_links import GETeventseventIdResponse200DataLinks
from .ge_teventsevent_id_response_200_data_relationships import GETeventseventIdResponse200DataRelationships
from .ge_teventsevent_id_response_200_data_relationships_last_event_callbacks import (
    GETeventseventIdResponse200DataRelationshipsLastEventCallbacks,
)
from .ge_teventsevent_id_response_200_data_relationships_last_event_callbacks_data import (
    GETeventseventIdResponse200DataRelationshipsLastEventCallbacksData,
)
from .ge_teventsevent_id_response_200_data_relationships_last_event_callbacks_data_type import (
    GETeventseventIdResponse200DataRelationshipsLastEventCallbacksDataType,
)
from .ge_teventsevent_id_response_200_data_relationships_last_event_callbacks_links import (
    GETeventseventIdResponse200DataRelationshipsLastEventCallbacksLinks,
)
from .ge_teventsevent_id_response_200_data_relationships_webhooks import (
    GETeventseventIdResponse200DataRelationshipsWebhooks,
)
from .ge_teventsevent_id_response_200_data_relationships_webhooks_data import (
    GETeventseventIdResponse200DataRelationshipsWebhooksData,
)
from .ge_teventsevent_id_response_200_data_relationships_webhooks_data_type import (
    GETeventseventIdResponse200DataRelationshipsWebhooksDataType,
)
from .ge_teventsevent_id_response_200_data_relationships_webhooks_links import (
    GETeventseventIdResponse200DataRelationshipsWebhooksLinks,
)
from .ge_teventsevent_id_response_200_data_type import GETeventseventIdResponse200DataType
from .ge_texports_response_200 import GETexportsResponse200
from .ge_texports_response_200_data_item import GETexportsResponse200DataItem
from .ge_texports_response_200_data_item_attributes import GETexportsResponse200DataItemAttributes
from .ge_texports_response_200_data_item_attributes_filters import GETexportsResponse200DataItemAttributesFilters
from .ge_texports_response_200_data_item_attributes_metadata import GETexportsResponse200DataItemAttributesMetadata
from .ge_texports_response_200_data_item_links import GETexportsResponse200DataItemLinks
from .ge_texports_response_200_data_item_relationships import GETexportsResponse200DataItemRelationships
from .ge_texports_response_200_data_item_relationships_events import GETexportsResponse200DataItemRelationshipsEvents
from .ge_texports_response_200_data_item_relationships_events_data import (
    GETexportsResponse200DataItemRelationshipsEventsData,
)
from .ge_texports_response_200_data_item_relationships_events_data_type import (
    GETexportsResponse200DataItemRelationshipsEventsDataType,
)
from .ge_texports_response_200_data_item_relationships_events_links import (
    GETexportsResponse200DataItemRelationshipsEventsLinks,
)
from .ge_texports_response_200_data_item_type import GETexportsResponse200DataItemType
from .ge_texportsexport_id_response_200 import GETexportsexportIdResponse200
from .ge_texportsexport_id_response_200_data import GETexportsexportIdResponse200Data
from .ge_texportsexport_id_response_200_data_attributes import GETexportsexportIdResponse200DataAttributes
from .ge_texportsexport_id_response_200_data_attributes_filters import (
    GETexportsexportIdResponse200DataAttributesFilters,
)
from .ge_texportsexport_id_response_200_data_attributes_metadata import (
    GETexportsexportIdResponse200DataAttributesMetadata,
)
from .ge_texportsexport_id_response_200_data_links import GETexportsexportIdResponse200DataLinks
from .ge_texportsexport_id_response_200_data_relationships import GETexportsexportIdResponse200DataRelationships
from .ge_texportsexport_id_response_200_data_relationships_events import (
    GETexportsexportIdResponse200DataRelationshipsEvents,
)
from .ge_texportsexport_id_response_200_data_relationships_events_data import (
    GETexportsexportIdResponse200DataRelationshipsEventsData,
)
from .ge_texportsexport_id_response_200_data_relationships_events_data_type import (
    GETexportsexportIdResponse200DataRelationshipsEventsDataType,
)
from .ge_texportsexport_id_response_200_data_relationships_events_links import (
    GETexportsexportIdResponse200DataRelationshipsEventsLinks,
)
from .ge_texportsexport_id_response_200_data_type import GETexportsexportIdResponse200DataType
from .ge_texternal_gateways_response_200 import GETexternalGatewaysResponse200
from .ge_texternal_gateways_response_200_data_item import GETexternalGatewaysResponse200DataItem
from .ge_texternal_gateways_response_200_data_item_attributes import GETexternalGatewaysResponse200DataItemAttributes
from .ge_texternal_gateways_response_200_data_item_attributes_metadata import (
    GETexternalGatewaysResponse200DataItemAttributesMetadata,
)
from .ge_texternal_gateways_response_200_data_item_links import GETexternalGatewaysResponse200DataItemLinks
from .ge_texternal_gateways_response_200_data_item_relationships import (
    GETexternalGatewaysResponse200DataItemRelationships,
)
from .ge_texternal_gateways_response_200_data_item_relationships_external_payments import (
    GETexternalGatewaysResponse200DataItemRelationshipsExternalPayments,
)
from .ge_texternal_gateways_response_200_data_item_relationships_external_payments_data import (
    GETexternalGatewaysResponse200DataItemRelationshipsExternalPaymentsData,
)
from .ge_texternal_gateways_response_200_data_item_relationships_external_payments_data_type import (
    GETexternalGatewaysResponse200DataItemRelationshipsExternalPaymentsDataType,
)
from .ge_texternal_gateways_response_200_data_item_relationships_external_payments_links import (
    GETexternalGatewaysResponse200DataItemRelationshipsExternalPaymentsLinks,
)
from .ge_texternal_gateways_response_200_data_item_relationships_payment_methods import (
    GETexternalGatewaysResponse200DataItemRelationshipsPaymentMethods,
)
from .ge_texternal_gateways_response_200_data_item_relationships_payment_methods_data import (
    GETexternalGatewaysResponse200DataItemRelationshipsPaymentMethodsData,
)
from .ge_texternal_gateways_response_200_data_item_relationships_payment_methods_data_type import (
    GETexternalGatewaysResponse200DataItemRelationshipsPaymentMethodsDataType,
)
from .ge_texternal_gateways_response_200_data_item_relationships_payment_methods_links import (
    GETexternalGatewaysResponse200DataItemRelationshipsPaymentMethodsLinks,
)
from .ge_texternal_gateways_response_200_data_item_type import GETexternalGatewaysResponse200DataItemType
from .ge_texternal_gatewaysexternal_gateway_id_response_200 import GETexternalGatewaysexternalGatewayIdResponse200
from .ge_texternal_gatewaysexternal_gateway_id_response_200_data import (
    GETexternalGatewaysexternalGatewayIdResponse200Data,
)
from .ge_texternal_gatewaysexternal_gateway_id_response_200_data_attributes import (
    GETexternalGatewaysexternalGatewayIdResponse200DataAttributes,
)
from .ge_texternal_gatewaysexternal_gateway_id_response_200_data_attributes_metadata import (
    GETexternalGatewaysexternalGatewayIdResponse200DataAttributesMetadata,
)
from .ge_texternal_gatewaysexternal_gateway_id_response_200_data_links import (
    GETexternalGatewaysexternalGatewayIdResponse200DataLinks,
)
from .ge_texternal_gatewaysexternal_gateway_id_response_200_data_relationships import (
    GETexternalGatewaysexternalGatewayIdResponse200DataRelationships,
)
from .ge_texternal_gatewaysexternal_gateway_id_response_200_data_relationships_external_payments import (
    GETexternalGatewaysexternalGatewayIdResponse200DataRelationshipsExternalPayments,
)
from .ge_texternal_gatewaysexternal_gateway_id_response_200_data_relationships_external_payments_data import (
    GETexternalGatewaysexternalGatewayIdResponse200DataRelationshipsExternalPaymentsData,
)
from .ge_texternal_gatewaysexternal_gateway_id_response_200_data_relationships_external_payments_data_type import (
    GETexternalGatewaysexternalGatewayIdResponse200DataRelationshipsExternalPaymentsDataType,
)
from .ge_texternal_gatewaysexternal_gateway_id_response_200_data_relationships_external_payments_links import (
    GETexternalGatewaysexternalGatewayIdResponse200DataRelationshipsExternalPaymentsLinks,
)
from .ge_texternal_gatewaysexternal_gateway_id_response_200_data_relationships_payment_methods import (
    GETexternalGatewaysexternalGatewayIdResponse200DataRelationshipsPaymentMethods,
)
from .ge_texternal_gatewaysexternal_gateway_id_response_200_data_relationships_payment_methods_data import (
    GETexternalGatewaysexternalGatewayIdResponse200DataRelationshipsPaymentMethodsData,
)
from .ge_texternal_gatewaysexternal_gateway_id_response_200_data_relationships_payment_methods_data_type import (
    GETexternalGatewaysexternalGatewayIdResponse200DataRelationshipsPaymentMethodsDataType,
)
from .ge_texternal_gatewaysexternal_gateway_id_response_200_data_relationships_payment_methods_links import (
    GETexternalGatewaysexternalGatewayIdResponse200DataRelationshipsPaymentMethodsLinks,
)
from .ge_texternal_gatewaysexternal_gateway_id_response_200_data_type import (
    GETexternalGatewaysexternalGatewayIdResponse200DataType,
)
from .ge_texternal_payments_response_200 import GETexternalPaymentsResponse200
from .ge_texternal_payments_response_200_data_item import GETexternalPaymentsResponse200DataItem
from .ge_texternal_payments_response_200_data_item_attributes import GETexternalPaymentsResponse200DataItemAttributes
from .ge_texternal_payments_response_200_data_item_attributes_metadata import (
    GETexternalPaymentsResponse200DataItemAttributesMetadata,
)
from .ge_texternal_payments_response_200_data_item_attributes_options import (
    GETexternalPaymentsResponse200DataItemAttributesOptions,
)
from .ge_texternal_payments_response_200_data_item_links import GETexternalPaymentsResponse200DataItemLinks
from .ge_texternal_payments_response_200_data_item_relationships import (
    GETexternalPaymentsResponse200DataItemRelationships,
)
from .ge_texternal_payments_response_200_data_item_relationships_order import (
    GETexternalPaymentsResponse200DataItemRelationshipsOrder,
)
from .ge_texternal_payments_response_200_data_item_relationships_order_data import (
    GETexternalPaymentsResponse200DataItemRelationshipsOrderData,
)
from .ge_texternal_payments_response_200_data_item_relationships_order_data_type import (
    GETexternalPaymentsResponse200DataItemRelationshipsOrderDataType,
)
from .ge_texternal_payments_response_200_data_item_relationships_order_links import (
    GETexternalPaymentsResponse200DataItemRelationshipsOrderLinks,
)
from .ge_texternal_payments_response_200_data_item_relationships_payment_gateway import (
    GETexternalPaymentsResponse200DataItemRelationshipsPaymentGateway,
)
from .ge_texternal_payments_response_200_data_item_relationships_payment_gateway_data import (
    GETexternalPaymentsResponse200DataItemRelationshipsPaymentGatewayData,
)
from .ge_texternal_payments_response_200_data_item_relationships_payment_gateway_data_type import (
    GETexternalPaymentsResponse200DataItemRelationshipsPaymentGatewayDataType,
)
from .ge_texternal_payments_response_200_data_item_relationships_payment_gateway_links import (
    GETexternalPaymentsResponse200DataItemRelationshipsPaymentGatewayLinks,
)
from .ge_texternal_payments_response_200_data_item_relationships_wallet import (
    GETexternalPaymentsResponse200DataItemRelationshipsWallet,
)
from .ge_texternal_payments_response_200_data_item_relationships_wallet_data import (
    GETexternalPaymentsResponse200DataItemRelationshipsWalletData,
)
from .ge_texternal_payments_response_200_data_item_relationships_wallet_data_type import (
    GETexternalPaymentsResponse200DataItemRelationshipsWalletDataType,
)
from .ge_texternal_payments_response_200_data_item_relationships_wallet_links import (
    GETexternalPaymentsResponse200DataItemRelationshipsWalletLinks,
)
from .ge_texternal_payments_response_200_data_item_type import GETexternalPaymentsResponse200DataItemType
from .ge_texternal_paymentsexternal_payment_id_response_200 import GETexternalPaymentsexternalPaymentIdResponse200
from .ge_texternal_paymentsexternal_payment_id_response_200_data import (
    GETexternalPaymentsexternalPaymentIdResponse200Data,
)
from .ge_texternal_paymentsexternal_payment_id_response_200_data_attributes import (
    GETexternalPaymentsexternalPaymentIdResponse200DataAttributes,
)
from .ge_texternal_paymentsexternal_payment_id_response_200_data_attributes_metadata import (
    GETexternalPaymentsexternalPaymentIdResponse200DataAttributesMetadata,
)
from .ge_texternal_paymentsexternal_payment_id_response_200_data_attributes_options import (
    GETexternalPaymentsexternalPaymentIdResponse200DataAttributesOptions,
)
from .ge_texternal_paymentsexternal_payment_id_response_200_data_links import (
    GETexternalPaymentsexternalPaymentIdResponse200DataLinks,
)
from .ge_texternal_paymentsexternal_payment_id_response_200_data_relationships import (
    GETexternalPaymentsexternalPaymentIdResponse200DataRelationships,
)
from .ge_texternal_paymentsexternal_payment_id_response_200_data_relationships_order import (
    GETexternalPaymentsexternalPaymentIdResponse200DataRelationshipsOrder,
)
from .ge_texternal_paymentsexternal_payment_id_response_200_data_relationships_order_data import (
    GETexternalPaymentsexternalPaymentIdResponse200DataRelationshipsOrderData,
)
from .ge_texternal_paymentsexternal_payment_id_response_200_data_relationships_order_data_type import (
    GETexternalPaymentsexternalPaymentIdResponse200DataRelationshipsOrderDataType,
)
from .ge_texternal_paymentsexternal_payment_id_response_200_data_relationships_order_links import (
    GETexternalPaymentsexternalPaymentIdResponse200DataRelationshipsOrderLinks,
)
from .ge_texternal_paymentsexternal_payment_id_response_200_data_relationships_payment_gateway import (
    GETexternalPaymentsexternalPaymentIdResponse200DataRelationshipsPaymentGateway,
)
from .ge_texternal_paymentsexternal_payment_id_response_200_data_relationships_payment_gateway_data import (
    GETexternalPaymentsexternalPaymentIdResponse200DataRelationshipsPaymentGatewayData,
)
from .ge_texternal_paymentsexternal_payment_id_response_200_data_relationships_payment_gateway_data_type import (
    GETexternalPaymentsexternalPaymentIdResponse200DataRelationshipsPaymentGatewayDataType,
)
from .ge_texternal_paymentsexternal_payment_id_response_200_data_relationships_payment_gateway_links import (
    GETexternalPaymentsexternalPaymentIdResponse200DataRelationshipsPaymentGatewayLinks,
)
from .ge_texternal_paymentsexternal_payment_id_response_200_data_relationships_wallet import (
    GETexternalPaymentsexternalPaymentIdResponse200DataRelationshipsWallet,
)
from .ge_texternal_paymentsexternal_payment_id_response_200_data_relationships_wallet_data import (
    GETexternalPaymentsexternalPaymentIdResponse200DataRelationshipsWalletData,
)
from .ge_texternal_paymentsexternal_payment_id_response_200_data_relationships_wallet_data_type import (
    GETexternalPaymentsexternalPaymentIdResponse200DataRelationshipsWalletDataType,
)
from .ge_texternal_paymentsexternal_payment_id_response_200_data_relationships_wallet_links import (
    GETexternalPaymentsexternalPaymentIdResponse200DataRelationshipsWalletLinks,
)
from .ge_texternal_paymentsexternal_payment_id_response_200_data_type import (
    GETexternalPaymentsexternalPaymentIdResponse200DataType,
)
from .ge_texternal_promotions_response_200 import GETexternalPromotionsResponse200
from .ge_texternal_promotions_response_200_data_item import GETexternalPromotionsResponse200DataItem
from .ge_texternal_promotions_response_200_data_item_attributes import (
    GETexternalPromotionsResponse200DataItemAttributes,
)
from .ge_texternal_promotions_response_200_data_item_attributes_metadata import (
    GETexternalPromotionsResponse200DataItemAttributesMetadata,
)
from .ge_texternal_promotions_response_200_data_item_links import GETexternalPromotionsResponse200DataItemLinks
from .ge_texternal_promotions_response_200_data_item_relationships import (
    GETexternalPromotionsResponse200DataItemRelationships,
)
from .ge_texternal_promotions_response_200_data_item_relationships_attachments import (
    GETexternalPromotionsResponse200DataItemRelationshipsAttachments,
)
from .ge_texternal_promotions_response_200_data_item_relationships_attachments_data import (
    GETexternalPromotionsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_texternal_promotions_response_200_data_item_relationships_attachments_data_type import (
    GETexternalPromotionsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_texternal_promotions_response_200_data_item_relationships_attachments_links import (
    GETexternalPromotionsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_texternal_promotions_response_200_data_item_relationships_coupon_codes_promotion_rule import (
    GETexternalPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRule,
)
from .ge_texternal_promotions_response_200_data_item_relationships_coupon_codes_promotion_rule_data import (
    GETexternalPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleData,
)
from .ge_texternal_promotions_response_200_data_item_relationships_coupon_codes_promotion_rule_data_type import (
    GETexternalPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleDataType,
)
from .ge_texternal_promotions_response_200_data_item_relationships_coupon_codes_promotion_rule_links import (
    GETexternalPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleLinks,
)
from .ge_texternal_promotions_response_200_data_item_relationships_market import (
    GETexternalPromotionsResponse200DataItemRelationshipsMarket,
)
from .ge_texternal_promotions_response_200_data_item_relationships_market_data import (
    GETexternalPromotionsResponse200DataItemRelationshipsMarketData,
)
from .ge_texternal_promotions_response_200_data_item_relationships_market_data_type import (
    GETexternalPromotionsResponse200DataItemRelationshipsMarketDataType,
)
from .ge_texternal_promotions_response_200_data_item_relationships_market_links import (
    GETexternalPromotionsResponse200DataItemRelationshipsMarketLinks,
)
from .ge_texternal_promotions_response_200_data_item_relationships_order_amount_promotion_rule import (
    GETexternalPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRule,
)
from .ge_texternal_promotions_response_200_data_item_relationships_order_amount_promotion_rule_data import (
    GETexternalPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleData,
)
from .ge_texternal_promotions_response_200_data_item_relationships_order_amount_promotion_rule_data_type import (
    GETexternalPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleDataType,
)
from .ge_texternal_promotions_response_200_data_item_relationships_order_amount_promotion_rule_links import (
    GETexternalPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleLinks,
)
from .ge_texternal_promotions_response_200_data_item_relationships_promotion_rules import (
    GETexternalPromotionsResponse200DataItemRelationshipsPromotionRules,
)
from .ge_texternal_promotions_response_200_data_item_relationships_promotion_rules_data import (
    GETexternalPromotionsResponse200DataItemRelationshipsPromotionRulesData,
)
from .ge_texternal_promotions_response_200_data_item_relationships_promotion_rules_data_type import (
    GETexternalPromotionsResponse200DataItemRelationshipsPromotionRulesDataType,
)
from .ge_texternal_promotions_response_200_data_item_relationships_promotion_rules_links import (
    GETexternalPromotionsResponse200DataItemRelationshipsPromotionRulesLinks,
)
from .ge_texternal_promotions_response_200_data_item_relationships_sku_list_promotion_rule import (
    GETexternalPromotionsResponse200DataItemRelationshipsSkuListPromotionRule,
)
from .ge_texternal_promotions_response_200_data_item_relationships_sku_list_promotion_rule_data import (
    GETexternalPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleData,
)
from .ge_texternal_promotions_response_200_data_item_relationships_sku_list_promotion_rule_data_type import (
    GETexternalPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleDataType,
)
from .ge_texternal_promotions_response_200_data_item_relationships_sku_list_promotion_rule_links import (
    GETexternalPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleLinks,
)
from .ge_texternal_promotions_response_200_data_item_type import GETexternalPromotionsResponse200DataItemType
from .ge_texternal_promotionsexternal_promotion_id_response_200 import (
    GETexternalPromotionsexternalPromotionIdResponse200,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data import (
    GETexternalPromotionsexternalPromotionIdResponse200Data,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_attributes import (
    GETexternalPromotionsexternalPromotionIdResponse200DataAttributes,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_attributes_metadata import (
    GETexternalPromotionsexternalPromotionIdResponse200DataAttributesMetadata,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_links import (
    GETexternalPromotionsexternalPromotionIdResponse200DataLinks,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_relationships import (
    GETexternalPromotionsexternalPromotionIdResponse200DataRelationships,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_relationships_attachments import (
    GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsAttachments,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_relationships_attachments_data import (
    GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_relationships_attachments_data_type import (
    GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_relationships_attachments_links import (
    GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule import (
    GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsCouponCodesPromotionRule,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_data import (
    GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleData,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_data_type import (
    GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleDataType,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_links import (
    GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleLinks,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_relationships_market import (
    GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsMarket,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_relationships_market_data import (
    GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsMarketData,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_relationships_market_data_type import (
    GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsMarketDataType,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_relationships_market_links import (
    GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsMarketLinks,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_relationships_order_amount_promotion_rule import (
    GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsOrderAmountPromotionRule,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_relationships_order_amount_promotion_rule_data import (
    GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleData,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_relationships_order_amount_promotion_rule_data_type import (
    GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleDataType,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_relationships_order_amount_promotion_rule_links import (
    GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleLinks,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_relationships_promotion_rules import (
    GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsPromotionRules,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_relationships_promotion_rules_data import (
    GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsPromotionRulesData,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_relationships_promotion_rules_data_type import (
    GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsPromotionRulesDataType,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_relationships_promotion_rules_links import (
    GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsPromotionRulesLinks,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_relationships_sku_list_promotion_rule import (
    GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsSkuListPromotionRule,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_relationships_sku_list_promotion_rule_data import (
    GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsSkuListPromotionRuleData,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_relationships_sku_list_promotion_rule_data_type import (
    GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsSkuListPromotionRuleDataType,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_relationships_sku_list_promotion_rule_links import (
    GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsSkuListPromotionRuleLinks,
)
from .ge_texternal_promotionsexternal_promotion_id_response_200_data_type import (
    GETexternalPromotionsexternalPromotionIdResponse200DataType,
)
from .ge_texternal_tax_calculators_response_200 import GETexternalTaxCalculatorsResponse200
from .ge_texternal_tax_calculators_response_200_data_item import GETexternalTaxCalculatorsResponse200DataItem
from .ge_texternal_tax_calculators_response_200_data_item_attributes import (
    GETexternalTaxCalculatorsResponse200DataItemAttributes,
)
from .ge_texternal_tax_calculators_response_200_data_item_attributes_metadata import (
    GETexternalTaxCalculatorsResponse200DataItemAttributesMetadata,
)
from .ge_texternal_tax_calculators_response_200_data_item_links import GETexternalTaxCalculatorsResponse200DataItemLinks
from .ge_texternal_tax_calculators_response_200_data_item_relationships import (
    GETexternalTaxCalculatorsResponse200DataItemRelationships,
)
from .ge_texternal_tax_calculators_response_200_data_item_relationships_attachments import (
    GETexternalTaxCalculatorsResponse200DataItemRelationshipsAttachments,
)
from .ge_texternal_tax_calculators_response_200_data_item_relationships_attachments_data import (
    GETexternalTaxCalculatorsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_texternal_tax_calculators_response_200_data_item_relationships_attachments_data_type import (
    GETexternalTaxCalculatorsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_texternal_tax_calculators_response_200_data_item_relationships_attachments_links import (
    GETexternalTaxCalculatorsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_texternal_tax_calculators_response_200_data_item_relationships_markets import (
    GETexternalTaxCalculatorsResponse200DataItemRelationshipsMarkets,
)
from .ge_texternal_tax_calculators_response_200_data_item_relationships_markets_data import (
    GETexternalTaxCalculatorsResponse200DataItemRelationshipsMarketsData,
)
from .ge_texternal_tax_calculators_response_200_data_item_relationships_markets_data_type import (
    GETexternalTaxCalculatorsResponse200DataItemRelationshipsMarketsDataType,
)
from .ge_texternal_tax_calculators_response_200_data_item_relationships_markets_links import (
    GETexternalTaxCalculatorsResponse200DataItemRelationshipsMarketsLinks,
)
from .ge_texternal_tax_calculators_response_200_data_item_type import GETexternalTaxCalculatorsResponse200DataItemType
from .ge_texternal_tax_calculatorsexternal_tax_calculator_id_response_200 import (
    GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200,
)
from .ge_texternal_tax_calculatorsexternal_tax_calculator_id_response_200_data import (
    GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200Data,
)
from .ge_texternal_tax_calculatorsexternal_tax_calculator_id_response_200_data_attributes import (
    GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataAttributes,
)
from .ge_texternal_tax_calculatorsexternal_tax_calculator_id_response_200_data_attributes_metadata import (
    GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataAttributesMetadata,
)
from .ge_texternal_tax_calculatorsexternal_tax_calculator_id_response_200_data_links import (
    GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataLinks,
)
from .ge_texternal_tax_calculatorsexternal_tax_calculator_id_response_200_data_relationships import (
    GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationships,
)
from .ge_texternal_tax_calculatorsexternal_tax_calculator_id_response_200_data_relationships_attachments import (
    GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsAttachments,
)
from .ge_texternal_tax_calculatorsexternal_tax_calculator_id_response_200_data_relationships_attachments_data import (
    GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_texternal_tax_calculatorsexternal_tax_calculator_id_response_200_data_relationships_attachments_data_type import (
    GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_texternal_tax_calculatorsexternal_tax_calculator_id_response_200_data_relationships_attachments_links import (
    GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_texternal_tax_calculatorsexternal_tax_calculator_id_response_200_data_relationships_markets import (
    GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsMarkets,
)
from .ge_texternal_tax_calculatorsexternal_tax_calculator_id_response_200_data_relationships_markets_data import (
    GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsMarketsData,
)
from .ge_texternal_tax_calculatorsexternal_tax_calculator_id_response_200_data_relationships_markets_data_type import (
    GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsMarketsDataType,
)
from .ge_texternal_tax_calculatorsexternal_tax_calculator_id_response_200_data_relationships_markets_links import (
    GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsMarketsLinks,
)
from .ge_texternal_tax_calculatorsexternal_tax_calculator_id_response_200_data_type import (
    GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataType,
)
from .ge_tfixed_amount_promotions_response_200 import GETfixedAmountPromotionsResponse200
from .ge_tfixed_amount_promotions_response_200_data_item import GETfixedAmountPromotionsResponse200DataItem
from .ge_tfixed_amount_promotions_response_200_data_item_attributes import (
    GETfixedAmountPromotionsResponse200DataItemAttributes,
)
from .ge_tfixed_amount_promotions_response_200_data_item_attributes_metadata import (
    GETfixedAmountPromotionsResponse200DataItemAttributesMetadata,
)
from .ge_tfixed_amount_promotions_response_200_data_item_links import GETfixedAmountPromotionsResponse200DataItemLinks
from .ge_tfixed_amount_promotions_response_200_data_item_relationships import (
    GETfixedAmountPromotionsResponse200DataItemRelationships,
)
from .ge_tfixed_amount_promotions_response_200_data_item_relationships_attachments import (
    GETfixedAmountPromotionsResponse200DataItemRelationshipsAttachments,
)
from .ge_tfixed_amount_promotions_response_200_data_item_relationships_attachments_data import (
    GETfixedAmountPromotionsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tfixed_amount_promotions_response_200_data_item_relationships_attachments_data_type import (
    GETfixedAmountPromotionsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tfixed_amount_promotions_response_200_data_item_relationships_attachments_links import (
    GETfixedAmountPromotionsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tfixed_amount_promotions_response_200_data_item_relationships_coupon_codes_promotion_rule import (
    GETfixedAmountPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRule,
)
from .ge_tfixed_amount_promotions_response_200_data_item_relationships_coupon_codes_promotion_rule_data import (
    GETfixedAmountPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleData,
)
from .ge_tfixed_amount_promotions_response_200_data_item_relationships_coupon_codes_promotion_rule_data_type import (
    GETfixedAmountPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleDataType,
)
from .ge_tfixed_amount_promotions_response_200_data_item_relationships_coupon_codes_promotion_rule_links import (
    GETfixedAmountPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleLinks,
)
from .ge_tfixed_amount_promotions_response_200_data_item_relationships_market import (
    GETfixedAmountPromotionsResponse200DataItemRelationshipsMarket,
)
from .ge_tfixed_amount_promotions_response_200_data_item_relationships_market_data import (
    GETfixedAmountPromotionsResponse200DataItemRelationshipsMarketData,
)
from .ge_tfixed_amount_promotions_response_200_data_item_relationships_market_data_type import (
    GETfixedAmountPromotionsResponse200DataItemRelationshipsMarketDataType,
)
from .ge_tfixed_amount_promotions_response_200_data_item_relationships_market_links import (
    GETfixedAmountPromotionsResponse200DataItemRelationshipsMarketLinks,
)
from .ge_tfixed_amount_promotions_response_200_data_item_relationships_order_amount_promotion_rule import (
    GETfixedAmountPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRule,
)
from .ge_tfixed_amount_promotions_response_200_data_item_relationships_order_amount_promotion_rule_data import (
    GETfixedAmountPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleData,
)
from .ge_tfixed_amount_promotions_response_200_data_item_relationships_order_amount_promotion_rule_data_type import (
    GETfixedAmountPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleDataType,
)
from .ge_tfixed_amount_promotions_response_200_data_item_relationships_order_amount_promotion_rule_links import (
    GETfixedAmountPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleLinks,
)
from .ge_tfixed_amount_promotions_response_200_data_item_relationships_promotion_rules import (
    GETfixedAmountPromotionsResponse200DataItemRelationshipsPromotionRules,
)
from .ge_tfixed_amount_promotions_response_200_data_item_relationships_promotion_rules_data import (
    GETfixedAmountPromotionsResponse200DataItemRelationshipsPromotionRulesData,
)
from .ge_tfixed_amount_promotions_response_200_data_item_relationships_promotion_rules_data_type import (
    GETfixedAmountPromotionsResponse200DataItemRelationshipsPromotionRulesDataType,
)
from .ge_tfixed_amount_promotions_response_200_data_item_relationships_promotion_rules_links import (
    GETfixedAmountPromotionsResponse200DataItemRelationshipsPromotionRulesLinks,
)
from .ge_tfixed_amount_promotions_response_200_data_item_relationships_sku_list_promotion_rule import (
    GETfixedAmountPromotionsResponse200DataItemRelationshipsSkuListPromotionRule,
)
from .ge_tfixed_amount_promotions_response_200_data_item_relationships_sku_list_promotion_rule_data import (
    GETfixedAmountPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleData,
)
from .ge_tfixed_amount_promotions_response_200_data_item_relationships_sku_list_promotion_rule_data_type import (
    GETfixedAmountPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleDataType,
)
from .ge_tfixed_amount_promotions_response_200_data_item_relationships_sku_list_promotion_rule_links import (
    GETfixedAmountPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleLinks,
)
from .ge_tfixed_amount_promotions_response_200_data_item_type import GETfixedAmountPromotionsResponse200DataItemType
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200 import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200Data,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_attributes import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataAttributes,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_attributes_metadata import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataAttributesMetadata,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_links import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataLinks,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationships,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_attachments import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsAttachments,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_attachments_data import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_attachments_data_type import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_attachments_links import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRule,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_data import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleData,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_data_type import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleDataType,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_links import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleLinks,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_market import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsMarket,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_market_data import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsMarketData,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_market_data_type import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsMarketDataType,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_market_links import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsMarketLinks,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_order_amount_promotion_rule import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRule,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_order_amount_promotion_rule_data import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleData,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_order_amount_promotion_rule_data_type import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleDataType,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_order_amount_promotion_rule_links import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleLinks,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_promotion_rules import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsPromotionRules,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_promotion_rules_data import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsPromotionRulesData,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_promotion_rules_data_type import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsPromotionRulesDataType,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_promotion_rules_links import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsPromotionRulesLinks,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_sku_list_promotion_rule import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsSkuListPromotionRule,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_sku_list_promotion_rule_data import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsSkuListPromotionRuleData,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_sku_list_promotion_rule_data_type import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsSkuListPromotionRuleDataType,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_sku_list_promotion_rule_links import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsSkuListPromotionRuleLinks,
)
from .ge_tfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_type import (
    GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataType,
)
from .ge_tfixed_price_promotions_response_200 import GETfixedPricePromotionsResponse200
from .ge_tfixed_price_promotions_response_200_data_item import GETfixedPricePromotionsResponse200DataItem
from .ge_tfixed_price_promotions_response_200_data_item_attributes import (
    GETfixedPricePromotionsResponse200DataItemAttributes,
)
from .ge_tfixed_price_promotions_response_200_data_item_attributes_metadata import (
    GETfixedPricePromotionsResponse200DataItemAttributesMetadata,
)
from .ge_tfixed_price_promotions_response_200_data_item_links import GETfixedPricePromotionsResponse200DataItemLinks
from .ge_tfixed_price_promotions_response_200_data_item_relationships import (
    GETfixedPricePromotionsResponse200DataItemRelationships,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_attachments import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsAttachments,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_attachments_data import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_attachments_data_type import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_attachments_links import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_coupon_codes_promotion_rule import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsCouponCodesPromotionRule,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_coupon_codes_promotion_rule_data import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleData,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_coupon_codes_promotion_rule_data_type import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleDataType,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_coupon_codes_promotion_rule_links import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleLinks,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_market import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsMarket,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_market_data import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsMarketData,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_market_data_type import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsMarketDataType,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_market_links import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsMarketLinks,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_order_amount_promotion_rule import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsOrderAmountPromotionRule,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_order_amount_promotion_rule_data import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleData,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_order_amount_promotion_rule_data_type import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleDataType,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_order_amount_promotion_rule_links import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleLinks,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_promotion_rules import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsPromotionRules,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_promotion_rules_data import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsPromotionRulesData,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_promotion_rules_data_type import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsPromotionRulesDataType,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_promotion_rules_links import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsPromotionRulesLinks,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_sku_list import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsSkuList,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_sku_list_data import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsSkuListData,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_sku_list_data_type import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsSkuListDataType,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_sku_list_links import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsSkuListLinks,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_sku_list_promotion_rule import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsSkuListPromotionRule,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_sku_list_promotion_rule_data import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsSkuListPromotionRuleData,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_sku_list_promotion_rule_data_type import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsSkuListPromotionRuleDataType,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_sku_list_promotion_rule_links import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsSkuListPromotionRuleLinks,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_skus import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsSkus,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_skus_data import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsSkusData,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_skus_data_type import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsSkusDataType,
)
from .ge_tfixed_price_promotions_response_200_data_item_relationships_skus_links import (
    GETfixedPricePromotionsResponse200DataItemRelationshipsSkusLinks,
)
from .ge_tfixed_price_promotions_response_200_data_item_type import GETfixedPricePromotionsResponse200DataItemType
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200 import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200Data,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_attributes import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataAttributes,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_attributes_metadata import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataAttributesMetadata,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_links import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataLinks,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationships,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_attachments import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsAttachments,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_attachments_data import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_attachments_data_type import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_attachments_links import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsCouponCodesPromotionRule,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_data import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleData,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_data_type import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleDataType,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_links import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleLinks,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_market import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsMarket,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_market_data import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsMarketData,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_market_data_type import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsMarketDataType,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_market_links import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsMarketLinks,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_order_amount_promotion_rule import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsOrderAmountPromotionRule,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_order_amount_promotion_rule_data import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleData,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_order_amount_promotion_rule_data_type import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleDataType,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_order_amount_promotion_rule_links import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleLinks,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_promotion_rules import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsPromotionRules,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_promotion_rules_data import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsPromotionRulesData,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_promotion_rules_data_type import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsPromotionRulesDataType,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_promotion_rules_links import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsPromotionRulesLinks,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_sku_list import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuList,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_sku_list_data import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuListData,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_sku_list_data_type import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuListDataType,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_sku_list_links import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuListLinks,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_sku_list_promotion_rule import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuListPromotionRule,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_sku_list_promotion_rule_data import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuListPromotionRuleData,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_sku_list_promotion_rule_data_type import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuListPromotionRuleDataType,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_sku_list_promotion_rule_links import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuListPromotionRuleLinks,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_skus import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkus,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_skus_data import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkusData,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_skus_data_type import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkusDataType,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_skus_links import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkusLinks,
)
from .ge_tfixed_price_promotionsfixed_price_promotion_id_response_200_data_type import (
    GETfixedPricePromotionsfixedPricePromotionIdResponse200DataType,
)
from .ge_tfree_gift_promotions_response_200 import GETfreeGiftPromotionsResponse200
from .ge_tfree_gift_promotions_response_200_data_item import GETfreeGiftPromotionsResponse200DataItem
from .ge_tfree_gift_promotions_response_200_data_item_attributes import (
    GETfreeGiftPromotionsResponse200DataItemAttributes,
)
from .ge_tfree_gift_promotions_response_200_data_item_attributes_metadata import (
    GETfreeGiftPromotionsResponse200DataItemAttributesMetadata,
)
from .ge_tfree_gift_promotions_response_200_data_item_links import GETfreeGiftPromotionsResponse200DataItemLinks
from .ge_tfree_gift_promotions_response_200_data_item_relationships import (
    GETfreeGiftPromotionsResponse200DataItemRelationships,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_attachments import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsAttachments,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_attachments_data import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_attachments_data_type import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_attachments_links import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_coupon_codes_promotion_rule import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRule,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_coupon_codes_promotion_rule_data import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleData,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_coupon_codes_promotion_rule_data_type import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleDataType,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_coupon_codes_promotion_rule_links import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleLinks,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_market import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsMarket,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_market_data import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsMarketData,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_market_data_type import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsMarketDataType,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_market_links import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsMarketLinks,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_order_amount_promotion_rule import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRule,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_order_amount_promotion_rule_data import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleData,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_order_amount_promotion_rule_data_type import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleDataType,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_order_amount_promotion_rule_links import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleLinks,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_promotion_rules import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsPromotionRules,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_promotion_rules_data import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsPromotionRulesData,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_promotion_rules_data_type import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsPromotionRulesDataType,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_promotion_rules_links import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsPromotionRulesLinks,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_sku_list import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsSkuList,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_sku_list_data import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsSkuListData,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_sku_list_data_type import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsSkuListDataType,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_sku_list_links import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsSkuListLinks,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_sku_list_promotion_rule import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsSkuListPromotionRule,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_sku_list_promotion_rule_data import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleData,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_sku_list_promotion_rule_data_type import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleDataType,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_sku_list_promotion_rule_links import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleLinks,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_skus import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsSkus,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_skus_data import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsSkusData,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_skus_data_type import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsSkusDataType,
)
from .ge_tfree_gift_promotions_response_200_data_item_relationships_skus_links import (
    GETfreeGiftPromotionsResponse200DataItemRelationshipsSkusLinks,
)
from .ge_tfree_gift_promotions_response_200_data_item_type import GETfreeGiftPromotionsResponse200DataItemType
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200 import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200Data,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_attributes import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataAttributes,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_attributes_metadata import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataAttributesMetadata,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_links import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataLinks,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationships,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_attachments import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsAttachments,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_attachments_data import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_attachments_data_type import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_attachments_links import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsCouponCodesPromotionRule,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_data import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleData,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_data_type import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleDataType,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_links import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleLinks,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_market import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsMarket,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_market_data import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsMarketData,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_market_data_type import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsMarketDataType,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_market_links import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsMarketLinks,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_order_amount_promotion_rule import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsOrderAmountPromotionRule,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_order_amount_promotion_rule_data import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleData,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_order_amount_promotion_rule_data_type import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleDataType,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_order_amount_promotion_rule_links import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleLinks,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_promotion_rules import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsPromotionRules,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_promotion_rules_data import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsPromotionRulesData,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_promotion_rules_data_type import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsPromotionRulesDataType,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_promotion_rules_links import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsPromotionRulesLinks,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_sku_list import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuList,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_sku_list_data import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuListData,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_sku_list_data_type import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuListDataType,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_sku_list_links import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuListLinks,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_sku_list_promotion_rule import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuListPromotionRule,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_sku_list_promotion_rule_data import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuListPromotionRuleData,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_sku_list_promotion_rule_data_type import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuListPromotionRuleDataType,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_sku_list_promotion_rule_links import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuListPromotionRuleLinks,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_skus import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkus,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_skus_data import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkusData,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_skus_data_type import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkusDataType,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_skus_links import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkusLinks,
)
from .ge_tfree_gift_promotionsfree_gift_promotion_id_response_200_data_type import (
    GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataType,
)
from .ge_tfree_shipping_promotions_response_200 import GETfreeShippingPromotionsResponse200
from .ge_tfree_shipping_promotions_response_200_data_item import GETfreeShippingPromotionsResponse200DataItem
from .ge_tfree_shipping_promotions_response_200_data_item_attributes import (
    GETfreeShippingPromotionsResponse200DataItemAttributes,
)
from .ge_tfree_shipping_promotions_response_200_data_item_attributes_metadata import (
    GETfreeShippingPromotionsResponse200DataItemAttributesMetadata,
)
from .ge_tfree_shipping_promotions_response_200_data_item_links import GETfreeShippingPromotionsResponse200DataItemLinks
from .ge_tfree_shipping_promotions_response_200_data_item_relationships import (
    GETfreeShippingPromotionsResponse200DataItemRelationships,
)
from .ge_tfree_shipping_promotions_response_200_data_item_relationships_attachments import (
    GETfreeShippingPromotionsResponse200DataItemRelationshipsAttachments,
)
from .ge_tfree_shipping_promotions_response_200_data_item_relationships_attachments_data import (
    GETfreeShippingPromotionsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tfree_shipping_promotions_response_200_data_item_relationships_attachments_data_type import (
    GETfreeShippingPromotionsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tfree_shipping_promotions_response_200_data_item_relationships_attachments_links import (
    GETfreeShippingPromotionsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tfree_shipping_promotions_response_200_data_item_relationships_coupon_codes_promotion_rule import (
    GETfreeShippingPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRule,
)
from .ge_tfree_shipping_promotions_response_200_data_item_relationships_coupon_codes_promotion_rule_data import (
    GETfreeShippingPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleData,
)
from .ge_tfree_shipping_promotions_response_200_data_item_relationships_coupon_codes_promotion_rule_data_type import (
    GETfreeShippingPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleDataType,
)
from .ge_tfree_shipping_promotions_response_200_data_item_relationships_coupon_codes_promotion_rule_links import (
    GETfreeShippingPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleLinks,
)
from .ge_tfree_shipping_promotions_response_200_data_item_relationships_market import (
    GETfreeShippingPromotionsResponse200DataItemRelationshipsMarket,
)
from .ge_tfree_shipping_promotions_response_200_data_item_relationships_market_data import (
    GETfreeShippingPromotionsResponse200DataItemRelationshipsMarketData,
)
from .ge_tfree_shipping_promotions_response_200_data_item_relationships_market_data_type import (
    GETfreeShippingPromotionsResponse200DataItemRelationshipsMarketDataType,
)
from .ge_tfree_shipping_promotions_response_200_data_item_relationships_market_links import (
    GETfreeShippingPromotionsResponse200DataItemRelationshipsMarketLinks,
)
from .ge_tfree_shipping_promotions_response_200_data_item_relationships_order_amount_promotion_rule import (
    GETfreeShippingPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRule,
)
from .ge_tfree_shipping_promotions_response_200_data_item_relationships_order_amount_promotion_rule_data import (
    GETfreeShippingPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleData,
)
from .ge_tfree_shipping_promotions_response_200_data_item_relationships_order_amount_promotion_rule_data_type import (
    GETfreeShippingPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleDataType,
)
from .ge_tfree_shipping_promotions_response_200_data_item_relationships_order_amount_promotion_rule_links import (
    GETfreeShippingPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleLinks,
)
from .ge_tfree_shipping_promotions_response_200_data_item_relationships_promotion_rules import (
    GETfreeShippingPromotionsResponse200DataItemRelationshipsPromotionRules,
)
from .ge_tfree_shipping_promotions_response_200_data_item_relationships_promotion_rules_data import (
    GETfreeShippingPromotionsResponse200DataItemRelationshipsPromotionRulesData,
)
from .ge_tfree_shipping_promotions_response_200_data_item_relationships_promotion_rules_data_type import (
    GETfreeShippingPromotionsResponse200DataItemRelationshipsPromotionRulesDataType,
)
from .ge_tfree_shipping_promotions_response_200_data_item_relationships_promotion_rules_links import (
    GETfreeShippingPromotionsResponse200DataItemRelationshipsPromotionRulesLinks,
)
from .ge_tfree_shipping_promotions_response_200_data_item_relationships_sku_list_promotion_rule import (
    GETfreeShippingPromotionsResponse200DataItemRelationshipsSkuListPromotionRule,
)
from .ge_tfree_shipping_promotions_response_200_data_item_relationships_sku_list_promotion_rule_data import (
    GETfreeShippingPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleData,
)
from .ge_tfree_shipping_promotions_response_200_data_item_relationships_sku_list_promotion_rule_data_type import (
    GETfreeShippingPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleDataType,
)
from .ge_tfree_shipping_promotions_response_200_data_item_relationships_sku_list_promotion_rule_links import (
    GETfreeShippingPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleLinks,
)
from .ge_tfree_shipping_promotions_response_200_data_item_type import GETfreeShippingPromotionsResponse200DataItemType
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200 import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200Data,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_attributes import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataAttributes,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_attributes_metadata import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataAttributesMetadata,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_links import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataLinks,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationships,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_attachments import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsAttachments,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_attachments_data import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_attachments_data_type import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_attachments_links import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsCouponCodesPromotionRule,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_data import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleData,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_data_type import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleDataType,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_links import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleLinks,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_market import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsMarket,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_market_data import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsMarketData,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_market_data_type import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsMarketDataType,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_market_links import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsMarketLinks,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_order_amount_promotion_rule import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsOrderAmountPromotionRule,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_order_amount_promotion_rule_data import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleData,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_order_amount_promotion_rule_data_type import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleDataType,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_order_amount_promotion_rule_links import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleLinks,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_promotion_rules import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsPromotionRules,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_promotion_rules_data import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsPromotionRulesData,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_promotion_rules_data_type import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsPromotionRulesDataType,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_promotion_rules_links import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsPromotionRulesLinks,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_sku_list_promotion_rule import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsSkuListPromotionRule,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_sku_list_promotion_rule_data import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsSkuListPromotionRuleData,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_sku_list_promotion_rule_data_type import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsSkuListPromotionRuleDataType,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_sku_list_promotion_rule_links import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsSkuListPromotionRuleLinks,
)
from .ge_tfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_type import (
    GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataType,
)
from .ge_tgeocoders_response_200 import GETgeocodersResponse200
from .ge_tgeocoders_response_200_data_item import GETgeocodersResponse200DataItem
from .ge_tgeocoders_response_200_data_item_attributes import GETgeocodersResponse200DataItemAttributes
from .ge_tgeocoders_response_200_data_item_attributes_metadata import GETgeocodersResponse200DataItemAttributesMetadata
from .ge_tgeocoders_response_200_data_item_links import GETgeocodersResponse200DataItemLinks
from .ge_tgeocoders_response_200_data_item_relationships import GETgeocodersResponse200DataItemRelationships
from .ge_tgeocoders_response_200_data_item_relationships_addresses import (
    GETgeocodersResponse200DataItemRelationshipsAddresses,
)
from .ge_tgeocoders_response_200_data_item_relationships_addresses_data import (
    GETgeocodersResponse200DataItemRelationshipsAddressesData,
)
from .ge_tgeocoders_response_200_data_item_relationships_addresses_data_type import (
    GETgeocodersResponse200DataItemRelationshipsAddressesDataType,
)
from .ge_tgeocoders_response_200_data_item_relationships_addresses_links import (
    GETgeocodersResponse200DataItemRelationshipsAddressesLinks,
)
from .ge_tgeocoders_response_200_data_item_relationships_attachments import (
    GETgeocodersResponse200DataItemRelationshipsAttachments,
)
from .ge_tgeocoders_response_200_data_item_relationships_attachments_data import (
    GETgeocodersResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tgeocoders_response_200_data_item_relationships_attachments_data_type import (
    GETgeocodersResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tgeocoders_response_200_data_item_relationships_attachments_links import (
    GETgeocodersResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tgeocoders_response_200_data_item_type import GETgeocodersResponse200DataItemType
from .ge_tgeocodersgeocoder_id_response_200 import GETgeocodersgeocoderIdResponse200
from .ge_tgeocodersgeocoder_id_response_200_data import GETgeocodersgeocoderIdResponse200Data
from .ge_tgeocodersgeocoder_id_response_200_data_attributes import GETgeocodersgeocoderIdResponse200DataAttributes
from .ge_tgeocodersgeocoder_id_response_200_data_attributes_metadata import (
    GETgeocodersgeocoderIdResponse200DataAttributesMetadata,
)
from .ge_tgeocodersgeocoder_id_response_200_data_links import GETgeocodersgeocoderIdResponse200DataLinks
from .ge_tgeocodersgeocoder_id_response_200_data_relationships import GETgeocodersgeocoderIdResponse200DataRelationships
from .ge_tgeocodersgeocoder_id_response_200_data_relationships_addresses import (
    GETgeocodersgeocoderIdResponse200DataRelationshipsAddresses,
)
from .ge_tgeocodersgeocoder_id_response_200_data_relationships_addresses_data import (
    GETgeocodersgeocoderIdResponse200DataRelationshipsAddressesData,
)
from .ge_tgeocodersgeocoder_id_response_200_data_relationships_addresses_data_type import (
    GETgeocodersgeocoderIdResponse200DataRelationshipsAddressesDataType,
)
from .ge_tgeocodersgeocoder_id_response_200_data_relationships_addresses_links import (
    GETgeocodersgeocoderIdResponse200DataRelationshipsAddressesLinks,
)
from .ge_tgeocodersgeocoder_id_response_200_data_relationships_attachments import (
    GETgeocodersgeocoderIdResponse200DataRelationshipsAttachments,
)
from .ge_tgeocodersgeocoder_id_response_200_data_relationships_attachments_data import (
    GETgeocodersgeocoderIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tgeocodersgeocoder_id_response_200_data_relationships_attachments_data_type import (
    GETgeocodersgeocoderIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tgeocodersgeocoder_id_response_200_data_relationships_attachments_links import (
    GETgeocodersgeocoderIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tgeocodersgeocoder_id_response_200_data_type import GETgeocodersgeocoderIdResponse200DataType
from .ge_tgift_card_recipients_response_200 import GETgiftCardRecipientsResponse200
from .ge_tgift_card_recipients_response_200_data_item import GETgiftCardRecipientsResponse200DataItem
from .ge_tgift_card_recipients_response_200_data_item_attributes import (
    GETgiftCardRecipientsResponse200DataItemAttributes,
)
from .ge_tgift_card_recipients_response_200_data_item_attributes_metadata import (
    GETgiftCardRecipientsResponse200DataItemAttributesMetadata,
)
from .ge_tgift_card_recipients_response_200_data_item_links import GETgiftCardRecipientsResponse200DataItemLinks
from .ge_tgift_card_recipients_response_200_data_item_relationships import (
    GETgiftCardRecipientsResponse200DataItemRelationships,
)
from .ge_tgift_card_recipients_response_200_data_item_relationships_attachments import (
    GETgiftCardRecipientsResponse200DataItemRelationshipsAttachments,
)
from .ge_tgift_card_recipients_response_200_data_item_relationships_attachments_data import (
    GETgiftCardRecipientsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tgift_card_recipients_response_200_data_item_relationships_attachments_data_type import (
    GETgiftCardRecipientsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tgift_card_recipients_response_200_data_item_relationships_attachments_links import (
    GETgiftCardRecipientsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tgift_card_recipients_response_200_data_item_relationships_customer import (
    GETgiftCardRecipientsResponse200DataItemRelationshipsCustomer,
)
from .ge_tgift_card_recipients_response_200_data_item_relationships_customer_data import (
    GETgiftCardRecipientsResponse200DataItemRelationshipsCustomerData,
)
from .ge_tgift_card_recipients_response_200_data_item_relationships_customer_data_type import (
    GETgiftCardRecipientsResponse200DataItemRelationshipsCustomerDataType,
)
from .ge_tgift_card_recipients_response_200_data_item_relationships_customer_links import (
    GETgiftCardRecipientsResponse200DataItemRelationshipsCustomerLinks,
)
from .ge_tgift_card_recipients_response_200_data_item_type import GETgiftCardRecipientsResponse200DataItemType
from .ge_tgift_card_recipientsgift_card_recipient_id_response_200 import (
    GETgiftCardRecipientsgiftCardRecipientIdResponse200,
)
from .ge_tgift_card_recipientsgift_card_recipient_id_response_200_data import (
    GETgiftCardRecipientsgiftCardRecipientIdResponse200Data,
)
from .ge_tgift_card_recipientsgift_card_recipient_id_response_200_data_attributes import (
    GETgiftCardRecipientsgiftCardRecipientIdResponse200DataAttributes,
)
from .ge_tgift_card_recipientsgift_card_recipient_id_response_200_data_attributes_metadata import (
    GETgiftCardRecipientsgiftCardRecipientIdResponse200DataAttributesMetadata,
)
from .ge_tgift_card_recipientsgift_card_recipient_id_response_200_data_links import (
    GETgiftCardRecipientsgiftCardRecipientIdResponse200DataLinks,
)
from .ge_tgift_card_recipientsgift_card_recipient_id_response_200_data_relationships import (
    GETgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationships,
)
from .ge_tgift_card_recipientsgift_card_recipient_id_response_200_data_relationships_attachments import (
    GETgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsAttachments,
)
from .ge_tgift_card_recipientsgift_card_recipient_id_response_200_data_relationships_attachments_data import (
    GETgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tgift_card_recipientsgift_card_recipient_id_response_200_data_relationships_attachments_data_type import (
    GETgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tgift_card_recipientsgift_card_recipient_id_response_200_data_relationships_attachments_links import (
    GETgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tgift_card_recipientsgift_card_recipient_id_response_200_data_relationships_customer import (
    GETgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsCustomer,
)
from .ge_tgift_card_recipientsgift_card_recipient_id_response_200_data_relationships_customer_data import (
    GETgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsCustomerData,
)
from .ge_tgift_card_recipientsgift_card_recipient_id_response_200_data_relationships_customer_data_type import (
    GETgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsCustomerDataType,
)
from .ge_tgift_card_recipientsgift_card_recipient_id_response_200_data_relationships_customer_links import (
    GETgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsCustomerLinks,
)
from .ge_tgift_card_recipientsgift_card_recipient_id_response_200_data_type import (
    GETgiftCardRecipientsgiftCardRecipientIdResponse200DataType,
)
from .ge_tgift_cards_response_200 import GETgiftCardsResponse200
from .ge_tgift_cards_response_200_data_item import GETgiftCardsResponse200DataItem
from .ge_tgift_cards_response_200_data_item_attributes import GETgiftCardsResponse200DataItemAttributes
from .ge_tgift_cards_response_200_data_item_attributes_balance_log_item import (
    GETgiftCardsResponse200DataItemAttributesBalanceLogItem,
)
from .ge_tgift_cards_response_200_data_item_attributes_metadata import GETgiftCardsResponse200DataItemAttributesMetadata
from .ge_tgift_cards_response_200_data_item_links import GETgiftCardsResponse200DataItemLinks
from .ge_tgift_cards_response_200_data_item_relationships import GETgiftCardsResponse200DataItemRelationships
from .ge_tgift_cards_response_200_data_item_relationships_attachments import (
    GETgiftCardsResponse200DataItemRelationshipsAttachments,
)
from .ge_tgift_cards_response_200_data_item_relationships_attachments_data import (
    GETgiftCardsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tgift_cards_response_200_data_item_relationships_attachments_data_type import (
    GETgiftCardsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tgift_cards_response_200_data_item_relationships_attachments_links import (
    GETgiftCardsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tgift_cards_response_200_data_item_relationships_events import (
    GETgiftCardsResponse200DataItemRelationshipsEvents,
)
from .ge_tgift_cards_response_200_data_item_relationships_events_data import (
    GETgiftCardsResponse200DataItemRelationshipsEventsData,
)
from .ge_tgift_cards_response_200_data_item_relationships_events_data_type import (
    GETgiftCardsResponse200DataItemRelationshipsEventsDataType,
)
from .ge_tgift_cards_response_200_data_item_relationships_events_links import (
    GETgiftCardsResponse200DataItemRelationshipsEventsLinks,
)
from .ge_tgift_cards_response_200_data_item_relationships_gift_card_recipient import (
    GETgiftCardsResponse200DataItemRelationshipsGiftCardRecipient,
)
from .ge_tgift_cards_response_200_data_item_relationships_gift_card_recipient_data import (
    GETgiftCardsResponse200DataItemRelationshipsGiftCardRecipientData,
)
from .ge_tgift_cards_response_200_data_item_relationships_gift_card_recipient_data_type import (
    GETgiftCardsResponse200DataItemRelationshipsGiftCardRecipientDataType,
)
from .ge_tgift_cards_response_200_data_item_relationships_gift_card_recipient_links import (
    GETgiftCardsResponse200DataItemRelationshipsGiftCardRecipientLinks,
)
from .ge_tgift_cards_response_200_data_item_relationships_market import (
    GETgiftCardsResponse200DataItemRelationshipsMarket,
)
from .ge_tgift_cards_response_200_data_item_relationships_market_data import (
    GETgiftCardsResponse200DataItemRelationshipsMarketData,
)
from .ge_tgift_cards_response_200_data_item_relationships_market_data_type import (
    GETgiftCardsResponse200DataItemRelationshipsMarketDataType,
)
from .ge_tgift_cards_response_200_data_item_relationships_market_links import (
    GETgiftCardsResponse200DataItemRelationshipsMarketLinks,
)
from .ge_tgift_cards_response_200_data_item_type import GETgiftCardsResponse200DataItemType
from .ge_tgift_cardsgift_card_id_response_200 import GETgiftCardsgiftCardIdResponse200
from .ge_tgift_cardsgift_card_id_response_200_data import GETgiftCardsgiftCardIdResponse200Data
from .ge_tgift_cardsgift_card_id_response_200_data_attributes import GETgiftCardsgiftCardIdResponse200DataAttributes
from .ge_tgift_cardsgift_card_id_response_200_data_attributes_balance_log_item import (
    GETgiftCardsgiftCardIdResponse200DataAttributesBalanceLogItem,
)
from .ge_tgift_cardsgift_card_id_response_200_data_attributes_metadata import (
    GETgiftCardsgiftCardIdResponse200DataAttributesMetadata,
)
from .ge_tgift_cardsgift_card_id_response_200_data_links import GETgiftCardsgiftCardIdResponse200DataLinks
from .ge_tgift_cardsgift_card_id_response_200_data_relationships import (
    GETgiftCardsgiftCardIdResponse200DataRelationships,
)
from .ge_tgift_cardsgift_card_id_response_200_data_relationships_attachments import (
    GETgiftCardsgiftCardIdResponse200DataRelationshipsAttachments,
)
from .ge_tgift_cardsgift_card_id_response_200_data_relationships_attachments_data import (
    GETgiftCardsgiftCardIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tgift_cardsgift_card_id_response_200_data_relationships_attachments_data_type import (
    GETgiftCardsgiftCardIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tgift_cardsgift_card_id_response_200_data_relationships_attachments_links import (
    GETgiftCardsgiftCardIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tgift_cardsgift_card_id_response_200_data_relationships_events import (
    GETgiftCardsgiftCardIdResponse200DataRelationshipsEvents,
)
from .ge_tgift_cardsgift_card_id_response_200_data_relationships_events_data import (
    GETgiftCardsgiftCardIdResponse200DataRelationshipsEventsData,
)
from .ge_tgift_cardsgift_card_id_response_200_data_relationships_events_data_type import (
    GETgiftCardsgiftCardIdResponse200DataRelationshipsEventsDataType,
)
from .ge_tgift_cardsgift_card_id_response_200_data_relationships_events_links import (
    GETgiftCardsgiftCardIdResponse200DataRelationshipsEventsLinks,
)
from .ge_tgift_cardsgift_card_id_response_200_data_relationships_gift_card_recipient import (
    GETgiftCardsgiftCardIdResponse200DataRelationshipsGiftCardRecipient,
)
from .ge_tgift_cardsgift_card_id_response_200_data_relationships_gift_card_recipient_data import (
    GETgiftCardsgiftCardIdResponse200DataRelationshipsGiftCardRecipientData,
)
from .ge_tgift_cardsgift_card_id_response_200_data_relationships_gift_card_recipient_data_type import (
    GETgiftCardsgiftCardIdResponse200DataRelationshipsGiftCardRecipientDataType,
)
from .ge_tgift_cardsgift_card_id_response_200_data_relationships_gift_card_recipient_links import (
    GETgiftCardsgiftCardIdResponse200DataRelationshipsGiftCardRecipientLinks,
)
from .ge_tgift_cardsgift_card_id_response_200_data_relationships_market import (
    GETgiftCardsgiftCardIdResponse200DataRelationshipsMarket,
)
from .ge_tgift_cardsgift_card_id_response_200_data_relationships_market_data import (
    GETgiftCardsgiftCardIdResponse200DataRelationshipsMarketData,
)
from .ge_tgift_cardsgift_card_id_response_200_data_relationships_market_data_type import (
    GETgiftCardsgiftCardIdResponse200DataRelationshipsMarketDataType,
)
from .ge_tgift_cardsgift_card_id_response_200_data_relationships_market_links import (
    GETgiftCardsgiftCardIdResponse200DataRelationshipsMarketLinks,
)
from .ge_tgift_cardsgift_card_id_response_200_data_type import GETgiftCardsgiftCardIdResponse200DataType
from .ge_tgoogle_geocoders_response_200 import GETgoogleGeocodersResponse200
from .ge_tgoogle_geocoders_response_200_data_item import GETgoogleGeocodersResponse200DataItem
from .ge_tgoogle_geocoders_response_200_data_item_attributes import GETgoogleGeocodersResponse200DataItemAttributes
from .ge_tgoogle_geocoders_response_200_data_item_attributes_metadata import (
    GETgoogleGeocodersResponse200DataItemAttributesMetadata,
)
from .ge_tgoogle_geocoders_response_200_data_item_links import GETgoogleGeocodersResponse200DataItemLinks
from .ge_tgoogle_geocoders_response_200_data_item_relationships import (
    GETgoogleGeocodersResponse200DataItemRelationships,
)
from .ge_tgoogle_geocoders_response_200_data_item_relationships_addresses import (
    GETgoogleGeocodersResponse200DataItemRelationshipsAddresses,
)
from .ge_tgoogle_geocoders_response_200_data_item_relationships_addresses_data import (
    GETgoogleGeocodersResponse200DataItemRelationshipsAddressesData,
)
from .ge_tgoogle_geocoders_response_200_data_item_relationships_addresses_data_type import (
    GETgoogleGeocodersResponse200DataItemRelationshipsAddressesDataType,
)
from .ge_tgoogle_geocoders_response_200_data_item_relationships_addresses_links import (
    GETgoogleGeocodersResponse200DataItemRelationshipsAddressesLinks,
)
from .ge_tgoogle_geocoders_response_200_data_item_relationships_attachments import (
    GETgoogleGeocodersResponse200DataItemRelationshipsAttachments,
)
from .ge_tgoogle_geocoders_response_200_data_item_relationships_attachments_data import (
    GETgoogleGeocodersResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tgoogle_geocoders_response_200_data_item_relationships_attachments_data_type import (
    GETgoogleGeocodersResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tgoogle_geocoders_response_200_data_item_relationships_attachments_links import (
    GETgoogleGeocodersResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tgoogle_geocoders_response_200_data_item_type import GETgoogleGeocodersResponse200DataItemType
from .ge_tgoogle_geocodersgoogle_geocoder_id_response_200 import GETgoogleGeocodersgoogleGeocoderIdResponse200
from .ge_tgoogle_geocodersgoogle_geocoder_id_response_200_data import GETgoogleGeocodersgoogleGeocoderIdResponse200Data
from .ge_tgoogle_geocodersgoogle_geocoder_id_response_200_data_attributes import (
    GETgoogleGeocodersgoogleGeocoderIdResponse200DataAttributes,
)
from .ge_tgoogle_geocodersgoogle_geocoder_id_response_200_data_attributes_metadata import (
    GETgoogleGeocodersgoogleGeocoderIdResponse200DataAttributesMetadata,
)
from .ge_tgoogle_geocodersgoogle_geocoder_id_response_200_data_links import (
    GETgoogleGeocodersgoogleGeocoderIdResponse200DataLinks,
)
from .ge_tgoogle_geocodersgoogle_geocoder_id_response_200_data_relationships import (
    GETgoogleGeocodersgoogleGeocoderIdResponse200DataRelationships,
)
from .ge_tgoogle_geocodersgoogle_geocoder_id_response_200_data_relationships_addresses import (
    GETgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAddresses,
)
from .ge_tgoogle_geocodersgoogle_geocoder_id_response_200_data_relationships_addresses_data import (
    GETgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAddressesData,
)
from .ge_tgoogle_geocodersgoogle_geocoder_id_response_200_data_relationships_addresses_data_type import (
    GETgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAddressesDataType,
)
from .ge_tgoogle_geocodersgoogle_geocoder_id_response_200_data_relationships_addresses_links import (
    GETgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAddressesLinks,
)
from .ge_tgoogle_geocodersgoogle_geocoder_id_response_200_data_relationships_attachments import (
    GETgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAttachments,
)
from .ge_tgoogle_geocodersgoogle_geocoder_id_response_200_data_relationships_attachments_data import (
    GETgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tgoogle_geocodersgoogle_geocoder_id_response_200_data_relationships_attachments_data_type import (
    GETgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tgoogle_geocodersgoogle_geocoder_id_response_200_data_relationships_attachments_links import (
    GETgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tgoogle_geocodersgoogle_geocoder_id_response_200_data_type import (
    GETgoogleGeocodersgoogleGeocoderIdResponse200DataType,
)
from .ge_timports_response_200 import GETimportsResponse200
from .ge_timports_response_200_data_item import GETimportsResponse200DataItem
from .ge_timports_response_200_data_item_attributes import GETimportsResponse200DataItemAttributes
from .ge_timports_response_200_data_item_attributes_errors_log import GETimportsResponse200DataItemAttributesErrorsLog
from .ge_timports_response_200_data_item_attributes_inputs_item import GETimportsResponse200DataItemAttributesInputsItem
from .ge_timports_response_200_data_item_attributes_metadata import GETimportsResponse200DataItemAttributesMetadata
from .ge_timports_response_200_data_item_attributes_warnings_log import (
    GETimportsResponse200DataItemAttributesWarningsLog,
)
from .ge_timports_response_200_data_item_links import GETimportsResponse200DataItemLinks
from .ge_timports_response_200_data_item_relationships import GETimportsResponse200DataItemRelationships
from .ge_timports_response_200_data_item_relationships_events import GETimportsResponse200DataItemRelationshipsEvents
from .ge_timports_response_200_data_item_relationships_events_data import (
    GETimportsResponse200DataItemRelationshipsEventsData,
)
from .ge_timports_response_200_data_item_relationships_events_data_type import (
    GETimportsResponse200DataItemRelationshipsEventsDataType,
)
from .ge_timports_response_200_data_item_relationships_events_links import (
    GETimportsResponse200DataItemRelationshipsEventsLinks,
)
from .ge_timports_response_200_data_item_type import GETimportsResponse200DataItemType
from .ge_timportsimport_id_response_200 import GETimportsimportIdResponse200
from .ge_timportsimport_id_response_200_data import GETimportsimportIdResponse200Data
from .ge_timportsimport_id_response_200_data_attributes import GETimportsimportIdResponse200DataAttributes
from .ge_timportsimport_id_response_200_data_attributes_errors_log import (
    GETimportsimportIdResponse200DataAttributesErrorsLog,
)
from .ge_timportsimport_id_response_200_data_attributes_inputs_item import (
    GETimportsimportIdResponse200DataAttributesInputsItem,
)
from .ge_timportsimport_id_response_200_data_attributes_metadata import (
    GETimportsimportIdResponse200DataAttributesMetadata,
)
from .ge_timportsimport_id_response_200_data_attributes_warnings_log import (
    GETimportsimportIdResponse200DataAttributesWarningsLog,
)
from .ge_timportsimport_id_response_200_data_links import GETimportsimportIdResponse200DataLinks
from .ge_timportsimport_id_response_200_data_relationships import GETimportsimportIdResponse200DataRelationships
from .ge_timportsimport_id_response_200_data_relationships_events import (
    GETimportsimportIdResponse200DataRelationshipsEvents,
)
from .ge_timportsimport_id_response_200_data_relationships_events_data import (
    GETimportsimportIdResponse200DataRelationshipsEventsData,
)
from .ge_timportsimport_id_response_200_data_relationships_events_data_type import (
    GETimportsimportIdResponse200DataRelationshipsEventsDataType,
)
from .ge_timportsimport_id_response_200_data_relationships_events_links import (
    GETimportsimportIdResponse200DataRelationshipsEventsLinks,
)
from .ge_timportsimport_id_response_200_data_type import GETimportsimportIdResponse200DataType
from .ge_tin_stock_subscriptions_response_200 import GETinStockSubscriptionsResponse200
from .ge_tin_stock_subscriptions_response_200_data_item import GETinStockSubscriptionsResponse200DataItem
from .ge_tin_stock_subscriptions_response_200_data_item_attributes import (
    GETinStockSubscriptionsResponse200DataItemAttributes,
)
from .ge_tin_stock_subscriptions_response_200_data_item_attributes_metadata import (
    GETinStockSubscriptionsResponse200DataItemAttributesMetadata,
)
from .ge_tin_stock_subscriptions_response_200_data_item_links import GETinStockSubscriptionsResponse200DataItemLinks
from .ge_tin_stock_subscriptions_response_200_data_item_relationships import (
    GETinStockSubscriptionsResponse200DataItemRelationships,
)
from .ge_tin_stock_subscriptions_response_200_data_item_relationships_customer import (
    GETinStockSubscriptionsResponse200DataItemRelationshipsCustomer,
)
from .ge_tin_stock_subscriptions_response_200_data_item_relationships_customer_data import (
    GETinStockSubscriptionsResponse200DataItemRelationshipsCustomerData,
)
from .ge_tin_stock_subscriptions_response_200_data_item_relationships_customer_data_type import (
    GETinStockSubscriptionsResponse200DataItemRelationshipsCustomerDataType,
)
from .ge_tin_stock_subscriptions_response_200_data_item_relationships_customer_links import (
    GETinStockSubscriptionsResponse200DataItemRelationshipsCustomerLinks,
)
from .ge_tin_stock_subscriptions_response_200_data_item_relationships_events import (
    GETinStockSubscriptionsResponse200DataItemRelationshipsEvents,
)
from .ge_tin_stock_subscriptions_response_200_data_item_relationships_events_data import (
    GETinStockSubscriptionsResponse200DataItemRelationshipsEventsData,
)
from .ge_tin_stock_subscriptions_response_200_data_item_relationships_events_data_type import (
    GETinStockSubscriptionsResponse200DataItemRelationshipsEventsDataType,
)
from .ge_tin_stock_subscriptions_response_200_data_item_relationships_events_links import (
    GETinStockSubscriptionsResponse200DataItemRelationshipsEventsLinks,
)
from .ge_tin_stock_subscriptions_response_200_data_item_relationships_market import (
    GETinStockSubscriptionsResponse200DataItemRelationshipsMarket,
)
from .ge_tin_stock_subscriptions_response_200_data_item_relationships_market_data import (
    GETinStockSubscriptionsResponse200DataItemRelationshipsMarketData,
)
from .ge_tin_stock_subscriptions_response_200_data_item_relationships_market_data_type import (
    GETinStockSubscriptionsResponse200DataItemRelationshipsMarketDataType,
)
from .ge_tin_stock_subscriptions_response_200_data_item_relationships_market_links import (
    GETinStockSubscriptionsResponse200DataItemRelationshipsMarketLinks,
)
from .ge_tin_stock_subscriptions_response_200_data_item_relationships_sku import (
    GETinStockSubscriptionsResponse200DataItemRelationshipsSku,
)
from .ge_tin_stock_subscriptions_response_200_data_item_relationships_sku_data import (
    GETinStockSubscriptionsResponse200DataItemRelationshipsSkuData,
)
from .ge_tin_stock_subscriptions_response_200_data_item_relationships_sku_data_type import (
    GETinStockSubscriptionsResponse200DataItemRelationshipsSkuDataType,
)
from .ge_tin_stock_subscriptions_response_200_data_item_relationships_sku_links import (
    GETinStockSubscriptionsResponse200DataItemRelationshipsSkuLinks,
)
from .ge_tin_stock_subscriptions_response_200_data_item_type import GETinStockSubscriptionsResponse200DataItemType
from .ge_tin_stock_subscriptionsin_stock_subscription_id_response_200 import (
    GETinStockSubscriptionsinStockSubscriptionIdResponse200,
)
from .ge_tin_stock_subscriptionsin_stock_subscription_id_response_200_data import (
    GETinStockSubscriptionsinStockSubscriptionIdResponse200Data,
)
from .ge_tin_stock_subscriptionsin_stock_subscription_id_response_200_data_attributes import (
    GETinStockSubscriptionsinStockSubscriptionIdResponse200DataAttributes,
)
from .ge_tin_stock_subscriptionsin_stock_subscription_id_response_200_data_attributes_metadata import (
    GETinStockSubscriptionsinStockSubscriptionIdResponse200DataAttributesMetadata,
)
from .ge_tin_stock_subscriptionsin_stock_subscription_id_response_200_data_links import (
    GETinStockSubscriptionsinStockSubscriptionIdResponse200DataLinks,
)
from .ge_tin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships import (
    GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationships,
)
from .ge_tin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_customer import (
    GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsCustomer,
)
from .ge_tin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_customer_data import (
    GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsCustomerData,
)
from .ge_tin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_customer_data_type import (
    GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsCustomerDataType,
)
from .ge_tin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_customer_links import (
    GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsCustomerLinks,
)
from .ge_tin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_events import (
    GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsEvents,
)
from .ge_tin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_events_data import (
    GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsEventsData,
)
from .ge_tin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_events_data_type import (
    GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsEventsDataType,
)
from .ge_tin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_events_links import (
    GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsEventsLinks,
)
from .ge_tin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_market import (
    GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsMarket,
)
from .ge_tin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_market_data import (
    GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsMarketData,
)
from .ge_tin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_market_data_type import (
    GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsMarketDataType,
)
from .ge_tin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_market_links import (
    GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsMarketLinks,
)
from .ge_tin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_sku import (
    GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsSku,
)
from .ge_tin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_sku_data import (
    GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsSkuData,
)
from .ge_tin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_sku_data_type import (
    GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsSkuDataType,
)
from .ge_tin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_sku_links import (
    GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsSkuLinks,
)
from .ge_tin_stock_subscriptionsin_stock_subscription_id_response_200_data_type import (
    GETinStockSubscriptionsinStockSubscriptionIdResponse200DataType,
)
from .ge_tinventory_models_response_200 import GETinventoryModelsResponse200
from .ge_tinventory_models_response_200_data_item import GETinventoryModelsResponse200DataItem
from .ge_tinventory_models_response_200_data_item_attributes import GETinventoryModelsResponse200DataItemAttributes
from .ge_tinventory_models_response_200_data_item_attributes_metadata import (
    GETinventoryModelsResponse200DataItemAttributesMetadata,
)
from .ge_tinventory_models_response_200_data_item_links import GETinventoryModelsResponse200DataItemLinks
from .ge_tinventory_models_response_200_data_item_relationships import (
    GETinventoryModelsResponse200DataItemRelationships,
)
from .ge_tinventory_models_response_200_data_item_relationships_attachments import (
    GETinventoryModelsResponse200DataItemRelationshipsAttachments,
)
from .ge_tinventory_models_response_200_data_item_relationships_attachments_data import (
    GETinventoryModelsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tinventory_models_response_200_data_item_relationships_attachments_data_type import (
    GETinventoryModelsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tinventory_models_response_200_data_item_relationships_attachments_links import (
    GETinventoryModelsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tinventory_models_response_200_data_item_relationships_inventory_return_locations import (
    GETinventoryModelsResponse200DataItemRelationshipsInventoryReturnLocations,
)
from .ge_tinventory_models_response_200_data_item_relationships_inventory_return_locations_data import (
    GETinventoryModelsResponse200DataItemRelationshipsInventoryReturnLocationsData,
)
from .ge_tinventory_models_response_200_data_item_relationships_inventory_return_locations_data_type import (
    GETinventoryModelsResponse200DataItemRelationshipsInventoryReturnLocationsDataType,
)
from .ge_tinventory_models_response_200_data_item_relationships_inventory_return_locations_links import (
    GETinventoryModelsResponse200DataItemRelationshipsInventoryReturnLocationsLinks,
)
from .ge_tinventory_models_response_200_data_item_relationships_inventory_stock_locations import (
    GETinventoryModelsResponse200DataItemRelationshipsInventoryStockLocations,
)
from .ge_tinventory_models_response_200_data_item_relationships_inventory_stock_locations_data import (
    GETinventoryModelsResponse200DataItemRelationshipsInventoryStockLocationsData,
)
from .ge_tinventory_models_response_200_data_item_relationships_inventory_stock_locations_data_type import (
    GETinventoryModelsResponse200DataItemRelationshipsInventoryStockLocationsDataType,
)
from .ge_tinventory_models_response_200_data_item_relationships_inventory_stock_locations_links import (
    GETinventoryModelsResponse200DataItemRelationshipsInventoryStockLocationsLinks,
)
from .ge_tinventory_models_response_200_data_item_type import GETinventoryModelsResponse200DataItemType
from .ge_tinventory_modelsinventory_model_id_response_200 import GETinventoryModelsinventoryModelIdResponse200
from .ge_tinventory_modelsinventory_model_id_response_200_data import GETinventoryModelsinventoryModelIdResponse200Data
from .ge_tinventory_modelsinventory_model_id_response_200_data_attributes import (
    GETinventoryModelsinventoryModelIdResponse200DataAttributes,
)
from .ge_tinventory_modelsinventory_model_id_response_200_data_attributes_metadata import (
    GETinventoryModelsinventoryModelIdResponse200DataAttributesMetadata,
)
from .ge_tinventory_modelsinventory_model_id_response_200_data_links import (
    GETinventoryModelsinventoryModelIdResponse200DataLinks,
)
from .ge_tinventory_modelsinventory_model_id_response_200_data_relationships import (
    GETinventoryModelsinventoryModelIdResponse200DataRelationships,
)
from .ge_tinventory_modelsinventory_model_id_response_200_data_relationships_attachments import (
    GETinventoryModelsinventoryModelIdResponse200DataRelationshipsAttachments,
)
from .ge_tinventory_modelsinventory_model_id_response_200_data_relationships_attachments_data import (
    GETinventoryModelsinventoryModelIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tinventory_modelsinventory_model_id_response_200_data_relationships_attachments_data_type import (
    GETinventoryModelsinventoryModelIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tinventory_modelsinventory_model_id_response_200_data_relationships_attachments_links import (
    GETinventoryModelsinventoryModelIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tinventory_modelsinventory_model_id_response_200_data_relationships_inventory_return_locations import (
    GETinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryReturnLocations,
)
from .ge_tinventory_modelsinventory_model_id_response_200_data_relationships_inventory_return_locations_data import (
    GETinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryReturnLocationsData,
)
from .ge_tinventory_modelsinventory_model_id_response_200_data_relationships_inventory_return_locations_data_type import (
    GETinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryReturnLocationsDataType,
)
from .ge_tinventory_modelsinventory_model_id_response_200_data_relationships_inventory_return_locations_links import (
    GETinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryReturnLocationsLinks,
)
from .ge_tinventory_modelsinventory_model_id_response_200_data_relationships_inventory_stock_locations import (
    GETinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryStockLocations,
)
from .ge_tinventory_modelsinventory_model_id_response_200_data_relationships_inventory_stock_locations_data import (
    GETinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryStockLocationsData,
)
from .ge_tinventory_modelsinventory_model_id_response_200_data_relationships_inventory_stock_locations_data_type import (
    GETinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryStockLocationsDataType,
)
from .ge_tinventory_modelsinventory_model_id_response_200_data_relationships_inventory_stock_locations_links import (
    GETinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryStockLocationsLinks,
)
from .ge_tinventory_modelsinventory_model_id_response_200_data_type import (
    GETinventoryModelsinventoryModelIdResponse200DataType,
)
from .ge_tinventory_return_locations_response_200 import GETinventoryReturnLocationsResponse200
from .ge_tinventory_return_locations_response_200_data_item import GETinventoryReturnLocationsResponse200DataItem
from .ge_tinventory_return_locations_response_200_data_item_attributes import (
    GETinventoryReturnLocationsResponse200DataItemAttributes,
)
from .ge_tinventory_return_locations_response_200_data_item_attributes_metadata import (
    GETinventoryReturnLocationsResponse200DataItemAttributesMetadata,
)
from .ge_tinventory_return_locations_response_200_data_item_links import (
    GETinventoryReturnLocationsResponse200DataItemLinks,
)
from .ge_tinventory_return_locations_response_200_data_item_relationships import (
    GETinventoryReturnLocationsResponse200DataItemRelationships,
)
from .ge_tinventory_return_locations_response_200_data_item_relationships_inventory_model import (
    GETinventoryReturnLocationsResponse200DataItemRelationshipsInventoryModel,
)
from .ge_tinventory_return_locations_response_200_data_item_relationships_inventory_model_data import (
    GETinventoryReturnLocationsResponse200DataItemRelationshipsInventoryModelData,
)
from .ge_tinventory_return_locations_response_200_data_item_relationships_inventory_model_data_type import (
    GETinventoryReturnLocationsResponse200DataItemRelationshipsInventoryModelDataType,
)
from .ge_tinventory_return_locations_response_200_data_item_relationships_inventory_model_links import (
    GETinventoryReturnLocationsResponse200DataItemRelationshipsInventoryModelLinks,
)
from .ge_tinventory_return_locations_response_200_data_item_relationships_stock_location import (
    GETinventoryReturnLocationsResponse200DataItemRelationshipsStockLocation,
)
from .ge_tinventory_return_locations_response_200_data_item_relationships_stock_location_data import (
    GETinventoryReturnLocationsResponse200DataItemRelationshipsStockLocationData,
)
from .ge_tinventory_return_locations_response_200_data_item_relationships_stock_location_data_type import (
    GETinventoryReturnLocationsResponse200DataItemRelationshipsStockLocationDataType,
)
from .ge_tinventory_return_locations_response_200_data_item_relationships_stock_location_links import (
    GETinventoryReturnLocationsResponse200DataItemRelationshipsStockLocationLinks,
)
from .ge_tinventory_return_locations_response_200_data_item_type import (
    GETinventoryReturnLocationsResponse200DataItemType,
)
from .ge_tinventory_return_locationsinventory_return_location_id_response_200 import (
    GETinventoryReturnLocationsinventoryReturnLocationIdResponse200,
)
from .ge_tinventory_return_locationsinventory_return_location_id_response_200_data import (
    GETinventoryReturnLocationsinventoryReturnLocationIdResponse200Data,
)
from .ge_tinventory_return_locationsinventory_return_location_id_response_200_data_attributes import (
    GETinventoryReturnLocationsinventoryReturnLocationIdResponse200DataAttributes,
)
from .ge_tinventory_return_locationsinventory_return_location_id_response_200_data_attributes_metadata import (
    GETinventoryReturnLocationsinventoryReturnLocationIdResponse200DataAttributesMetadata,
)
from .ge_tinventory_return_locationsinventory_return_location_id_response_200_data_links import (
    GETinventoryReturnLocationsinventoryReturnLocationIdResponse200DataLinks,
)
from .ge_tinventory_return_locationsinventory_return_location_id_response_200_data_relationships import (
    GETinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationships,
)
from .ge_tinventory_return_locationsinventory_return_location_id_response_200_data_relationships_inventory_model import (
    GETinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsInventoryModel,
)
from .ge_tinventory_return_locationsinventory_return_location_id_response_200_data_relationships_inventory_model_data import (
    GETinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsInventoryModelData,
)
from .ge_tinventory_return_locationsinventory_return_location_id_response_200_data_relationships_inventory_model_data_type import (
    GETinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsInventoryModelDataType,
)
from .ge_tinventory_return_locationsinventory_return_location_id_response_200_data_relationships_inventory_model_links import (
    GETinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsInventoryModelLinks,
)
from .ge_tinventory_return_locationsinventory_return_location_id_response_200_data_relationships_stock_location import (
    GETinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsStockLocation,
)
from .ge_tinventory_return_locationsinventory_return_location_id_response_200_data_relationships_stock_location_data import (
    GETinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsStockLocationData,
)
from .ge_tinventory_return_locationsinventory_return_location_id_response_200_data_relationships_stock_location_data_type import (
    GETinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsStockLocationDataType,
)
from .ge_tinventory_return_locationsinventory_return_location_id_response_200_data_relationships_stock_location_links import (
    GETinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsStockLocationLinks,
)
from .ge_tinventory_return_locationsinventory_return_location_id_response_200_data_type import (
    GETinventoryReturnLocationsinventoryReturnLocationIdResponse200DataType,
)
from .ge_tinventory_stock_locations_response_200 import GETinventoryStockLocationsResponse200
from .ge_tinventory_stock_locations_response_200_data_item import GETinventoryStockLocationsResponse200DataItem
from .ge_tinventory_stock_locations_response_200_data_item_attributes import (
    GETinventoryStockLocationsResponse200DataItemAttributes,
)
from .ge_tinventory_stock_locations_response_200_data_item_attributes_metadata import (
    GETinventoryStockLocationsResponse200DataItemAttributesMetadata,
)
from .ge_tinventory_stock_locations_response_200_data_item_links import (
    GETinventoryStockLocationsResponse200DataItemLinks,
)
from .ge_tinventory_stock_locations_response_200_data_item_relationships import (
    GETinventoryStockLocationsResponse200DataItemRelationships,
)
from .ge_tinventory_stock_locations_response_200_data_item_relationships_inventory_model import (
    GETinventoryStockLocationsResponse200DataItemRelationshipsInventoryModel,
)
from .ge_tinventory_stock_locations_response_200_data_item_relationships_inventory_model_data import (
    GETinventoryStockLocationsResponse200DataItemRelationshipsInventoryModelData,
)
from .ge_tinventory_stock_locations_response_200_data_item_relationships_inventory_model_data_type import (
    GETinventoryStockLocationsResponse200DataItemRelationshipsInventoryModelDataType,
)
from .ge_tinventory_stock_locations_response_200_data_item_relationships_inventory_model_links import (
    GETinventoryStockLocationsResponse200DataItemRelationshipsInventoryModelLinks,
)
from .ge_tinventory_stock_locations_response_200_data_item_relationships_stock_location import (
    GETinventoryStockLocationsResponse200DataItemRelationshipsStockLocation,
)
from .ge_tinventory_stock_locations_response_200_data_item_relationships_stock_location_data import (
    GETinventoryStockLocationsResponse200DataItemRelationshipsStockLocationData,
)
from .ge_tinventory_stock_locations_response_200_data_item_relationships_stock_location_data_type import (
    GETinventoryStockLocationsResponse200DataItemRelationshipsStockLocationDataType,
)
from .ge_tinventory_stock_locations_response_200_data_item_relationships_stock_location_links import (
    GETinventoryStockLocationsResponse200DataItemRelationshipsStockLocationLinks,
)
from .ge_tinventory_stock_locations_response_200_data_item_type import GETinventoryStockLocationsResponse200DataItemType
from .ge_tinventory_stock_locationsinventory_stock_location_id_response_200 import (
    GETinventoryStockLocationsinventoryStockLocationIdResponse200,
)
from .ge_tinventory_stock_locationsinventory_stock_location_id_response_200_data import (
    GETinventoryStockLocationsinventoryStockLocationIdResponse200Data,
)
from .ge_tinventory_stock_locationsinventory_stock_location_id_response_200_data_attributes import (
    GETinventoryStockLocationsinventoryStockLocationIdResponse200DataAttributes,
)
from .ge_tinventory_stock_locationsinventory_stock_location_id_response_200_data_attributes_metadata import (
    GETinventoryStockLocationsinventoryStockLocationIdResponse200DataAttributesMetadata,
)
from .ge_tinventory_stock_locationsinventory_stock_location_id_response_200_data_links import (
    GETinventoryStockLocationsinventoryStockLocationIdResponse200DataLinks,
)
from .ge_tinventory_stock_locationsinventory_stock_location_id_response_200_data_relationships import (
    GETinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationships,
)
from .ge_tinventory_stock_locationsinventory_stock_location_id_response_200_data_relationships_inventory_model import (
    GETinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsInventoryModel,
)
from .ge_tinventory_stock_locationsinventory_stock_location_id_response_200_data_relationships_inventory_model_data import (
    GETinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsInventoryModelData,
)
from .ge_tinventory_stock_locationsinventory_stock_location_id_response_200_data_relationships_inventory_model_data_type import (
    GETinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsInventoryModelDataType,
)
from .ge_tinventory_stock_locationsinventory_stock_location_id_response_200_data_relationships_inventory_model_links import (
    GETinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsInventoryModelLinks,
)
from .ge_tinventory_stock_locationsinventory_stock_location_id_response_200_data_relationships_stock_location import (
    GETinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsStockLocation,
)
from .ge_tinventory_stock_locationsinventory_stock_location_id_response_200_data_relationships_stock_location_data import (
    GETinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsStockLocationData,
)
from .ge_tinventory_stock_locationsinventory_stock_location_id_response_200_data_relationships_stock_location_data_type import (
    GETinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsStockLocationDataType,
)
from .ge_tinventory_stock_locationsinventory_stock_location_id_response_200_data_relationships_stock_location_links import (
    GETinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsStockLocationLinks,
)
from .ge_tinventory_stock_locationsinventory_stock_location_id_response_200_data_type import (
    GETinventoryStockLocationsinventoryStockLocationIdResponse200DataType,
)
from .ge_tklarna_gateways_response_200 import GETklarnaGatewaysResponse200
from .ge_tklarna_gateways_response_200_data_item import GETklarnaGatewaysResponse200DataItem
from .ge_tklarna_gateways_response_200_data_item_attributes import GETklarnaGatewaysResponse200DataItemAttributes
from .ge_tklarna_gateways_response_200_data_item_attributes_metadata import (
    GETklarnaGatewaysResponse200DataItemAttributesMetadata,
)
from .ge_tklarna_gateways_response_200_data_item_links import GETklarnaGatewaysResponse200DataItemLinks
from .ge_tklarna_gateways_response_200_data_item_relationships import GETklarnaGatewaysResponse200DataItemRelationships
from .ge_tklarna_gateways_response_200_data_item_relationships_klarna_payments import (
    GETklarnaGatewaysResponse200DataItemRelationshipsKlarnaPayments,
)
from .ge_tklarna_gateways_response_200_data_item_relationships_klarna_payments_data import (
    GETklarnaGatewaysResponse200DataItemRelationshipsKlarnaPaymentsData,
)
from .ge_tklarna_gateways_response_200_data_item_relationships_klarna_payments_data_type import (
    GETklarnaGatewaysResponse200DataItemRelationshipsKlarnaPaymentsDataType,
)
from .ge_tklarna_gateways_response_200_data_item_relationships_klarna_payments_links import (
    GETklarnaGatewaysResponse200DataItemRelationshipsKlarnaPaymentsLinks,
)
from .ge_tklarna_gateways_response_200_data_item_relationships_payment_methods import (
    GETklarnaGatewaysResponse200DataItemRelationshipsPaymentMethods,
)
from .ge_tklarna_gateways_response_200_data_item_relationships_payment_methods_data import (
    GETklarnaGatewaysResponse200DataItemRelationshipsPaymentMethodsData,
)
from .ge_tklarna_gateways_response_200_data_item_relationships_payment_methods_data_type import (
    GETklarnaGatewaysResponse200DataItemRelationshipsPaymentMethodsDataType,
)
from .ge_tklarna_gateways_response_200_data_item_relationships_payment_methods_links import (
    GETklarnaGatewaysResponse200DataItemRelationshipsPaymentMethodsLinks,
)
from .ge_tklarna_gateways_response_200_data_item_type import GETklarnaGatewaysResponse200DataItemType
from .ge_tklarna_gatewaysklarna_gateway_id_response_200 import GETklarnaGatewaysklarnaGatewayIdResponse200
from .ge_tklarna_gatewaysklarna_gateway_id_response_200_data import GETklarnaGatewaysklarnaGatewayIdResponse200Data
from .ge_tklarna_gatewaysklarna_gateway_id_response_200_data_attributes import (
    GETklarnaGatewaysklarnaGatewayIdResponse200DataAttributes,
)
from .ge_tklarna_gatewaysklarna_gateway_id_response_200_data_attributes_metadata import (
    GETklarnaGatewaysklarnaGatewayIdResponse200DataAttributesMetadata,
)
from .ge_tklarna_gatewaysklarna_gateway_id_response_200_data_links import (
    GETklarnaGatewaysklarnaGatewayIdResponse200DataLinks,
)
from .ge_tklarna_gatewaysklarna_gateway_id_response_200_data_relationships import (
    GETklarnaGatewaysklarnaGatewayIdResponse200DataRelationships,
)
from .ge_tklarna_gatewaysklarna_gateway_id_response_200_data_relationships_klarna_payments import (
    GETklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsKlarnaPayments,
)
from .ge_tklarna_gatewaysklarna_gateway_id_response_200_data_relationships_klarna_payments_data import (
    GETklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsKlarnaPaymentsData,
)
from .ge_tklarna_gatewaysklarna_gateway_id_response_200_data_relationships_klarna_payments_data_type import (
    GETklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsKlarnaPaymentsDataType,
)
from .ge_tklarna_gatewaysklarna_gateway_id_response_200_data_relationships_klarna_payments_links import (
    GETklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsKlarnaPaymentsLinks,
)
from .ge_tklarna_gatewaysklarna_gateway_id_response_200_data_relationships_payment_methods import (
    GETklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsPaymentMethods,
)
from .ge_tklarna_gatewaysklarna_gateway_id_response_200_data_relationships_payment_methods_data import (
    GETklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsPaymentMethodsData,
)
from .ge_tklarna_gatewaysklarna_gateway_id_response_200_data_relationships_payment_methods_data_type import (
    GETklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsPaymentMethodsDataType,
)
from .ge_tklarna_gatewaysklarna_gateway_id_response_200_data_relationships_payment_methods_links import (
    GETklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsPaymentMethodsLinks,
)
from .ge_tklarna_gatewaysklarna_gateway_id_response_200_data_type import (
    GETklarnaGatewaysklarnaGatewayIdResponse200DataType,
)
from .ge_tklarna_payments_response_200 import GETklarnaPaymentsResponse200
from .ge_tklarna_payments_response_200_data_item import GETklarnaPaymentsResponse200DataItem
from .ge_tklarna_payments_response_200_data_item_attributes import GETklarnaPaymentsResponse200DataItemAttributes
from .ge_tklarna_payments_response_200_data_item_attributes_metadata import (
    GETklarnaPaymentsResponse200DataItemAttributesMetadata,
)
from .ge_tklarna_payments_response_200_data_item_attributes_payment_methods_item import (
    GETklarnaPaymentsResponse200DataItemAttributesPaymentMethodsItem,
)
from .ge_tklarna_payments_response_200_data_item_links import GETklarnaPaymentsResponse200DataItemLinks
from .ge_tklarna_payments_response_200_data_item_relationships import GETklarnaPaymentsResponse200DataItemRelationships
from .ge_tklarna_payments_response_200_data_item_relationships_order import (
    GETklarnaPaymentsResponse200DataItemRelationshipsOrder,
)
from .ge_tklarna_payments_response_200_data_item_relationships_order_data import (
    GETklarnaPaymentsResponse200DataItemRelationshipsOrderData,
)
from .ge_tklarna_payments_response_200_data_item_relationships_order_data_type import (
    GETklarnaPaymentsResponse200DataItemRelationshipsOrderDataType,
)
from .ge_tklarna_payments_response_200_data_item_relationships_order_links import (
    GETklarnaPaymentsResponse200DataItemRelationshipsOrderLinks,
)
from .ge_tklarna_payments_response_200_data_item_relationships_payment_gateway import (
    GETklarnaPaymentsResponse200DataItemRelationshipsPaymentGateway,
)
from .ge_tklarna_payments_response_200_data_item_relationships_payment_gateway_data import (
    GETklarnaPaymentsResponse200DataItemRelationshipsPaymentGatewayData,
)
from .ge_tklarna_payments_response_200_data_item_relationships_payment_gateway_data_type import (
    GETklarnaPaymentsResponse200DataItemRelationshipsPaymentGatewayDataType,
)
from .ge_tklarna_payments_response_200_data_item_relationships_payment_gateway_links import (
    GETklarnaPaymentsResponse200DataItemRelationshipsPaymentGatewayLinks,
)
from .ge_tklarna_payments_response_200_data_item_type import GETklarnaPaymentsResponse200DataItemType
from .ge_tklarna_paymentsklarna_payment_id_response_200 import GETklarnaPaymentsklarnaPaymentIdResponse200
from .ge_tklarna_paymentsklarna_payment_id_response_200_data import GETklarnaPaymentsklarnaPaymentIdResponse200Data
from .ge_tklarna_paymentsklarna_payment_id_response_200_data_attributes import (
    GETklarnaPaymentsklarnaPaymentIdResponse200DataAttributes,
)
from .ge_tklarna_paymentsklarna_payment_id_response_200_data_attributes_metadata import (
    GETklarnaPaymentsklarnaPaymentIdResponse200DataAttributesMetadata,
)
from .ge_tklarna_paymentsklarna_payment_id_response_200_data_attributes_payment_methods_item import (
    GETklarnaPaymentsklarnaPaymentIdResponse200DataAttributesPaymentMethodsItem,
)
from .ge_tklarna_paymentsklarna_payment_id_response_200_data_links import (
    GETklarnaPaymentsklarnaPaymentIdResponse200DataLinks,
)
from .ge_tklarna_paymentsklarna_payment_id_response_200_data_relationships import (
    GETklarnaPaymentsklarnaPaymentIdResponse200DataRelationships,
)
from .ge_tklarna_paymentsklarna_payment_id_response_200_data_relationships_order import (
    GETklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsOrder,
)
from .ge_tklarna_paymentsklarna_payment_id_response_200_data_relationships_order_data import (
    GETklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsOrderData,
)
from .ge_tklarna_paymentsklarna_payment_id_response_200_data_relationships_order_data_type import (
    GETklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsOrderDataType,
)
from .ge_tklarna_paymentsklarna_payment_id_response_200_data_relationships_order_links import (
    GETklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsOrderLinks,
)
from .ge_tklarna_paymentsklarna_payment_id_response_200_data_relationships_payment_gateway import (
    GETklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsPaymentGateway,
)
from .ge_tklarna_paymentsklarna_payment_id_response_200_data_relationships_payment_gateway_data import (
    GETklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsPaymentGatewayData,
)
from .ge_tklarna_paymentsklarna_payment_id_response_200_data_relationships_payment_gateway_data_type import (
    GETklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsPaymentGatewayDataType,
)
from .ge_tklarna_paymentsklarna_payment_id_response_200_data_relationships_payment_gateway_links import (
    GETklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsPaymentGatewayLinks,
)
from .ge_tklarna_paymentsklarna_payment_id_response_200_data_type import (
    GETklarnaPaymentsklarnaPaymentIdResponse200DataType,
)
from .ge_tline_item_options_response_200 import GETlineItemOptionsResponse200
from .ge_tline_item_options_response_200_data_item import GETlineItemOptionsResponse200DataItem
from .ge_tline_item_options_response_200_data_item_attributes import GETlineItemOptionsResponse200DataItemAttributes
from .ge_tline_item_options_response_200_data_item_attributes_metadata import (
    GETlineItemOptionsResponse200DataItemAttributesMetadata,
)
from .ge_tline_item_options_response_200_data_item_attributes_options import (
    GETlineItemOptionsResponse200DataItemAttributesOptions,
)
from .ge_tline_item_options_response_200_data_item_links import GETlineItemOptionsResponse200DataItemLinks
from .ge_tline_item_options_response_200_data_item_relationships import (
    GETlineItemOptionsResponse200DataItemRelationships,
)
from .ge_tline_item_options_response_200_data_item_relationships_line_item import (
    GETlineItemOptionsResponse200DataItemRelationshipsLineItem,
)
from .ge_tline_item_options_response_200_data_item_relationships_line_item_data import (
    GETlineItemOptionsResponse200DataItemRelationshipsLineItemData,
)
from .ge_tline_item_options_response_200_data_item_relationships_line_item_data_type import (
    GETlineItemOptionsResponse200DataItemRelationshipsLineItemDataType,
)
from .ge_tline_item_options_response_200_data_item_relationships_line_item_links import (
    GETlineItemOptionsResponse200DataItemRelationshipsLineItemLinks,
)
from .ge_tline_item_options_response_200_data_item_relationships_sku_option import (
    GETlineItemOptionsResponse200DataItemRelationshipsSkuOption,
)
from .ge_tline_item_options_response_200_data_item_relationships_sku_option_data import (
    GETlineItemOptionsResponse200DataItemRelationshipsSkuOptionData,
)
from .ge_tline_item_options_response_200_data_item_relationships_sku_option_data_type import (
    GETlineItemOptionsResponse200DataItemRelationshipsSkuOptionDataType,
)
from .ge_tline_item_options_response_200_data_item_relationships_sku_option_links import (
    GETlineItemOptionsResponse200DataItemRelationshipsSkuOptionLinks,
)
from .ge_tline_item_options_response_200_data_item_type import GETlineItemOptionsResponse200DataItemType
from .ge_tline_item_optionsline_item_option_id_response_200 import GETlineItemOptionslineItemOptionIdResponse200
from .ge_tline_item_optionsline_item_option_id_response_200_data import (
    GETlineItemOptionslineItemOptionIdResponse200Data,
)
from .ge_tline_item_optionsline_item_option_id_response_200_data_attributes import (
    GETlineItemOptionslineItemOptionIdResponse200DataAttributes,
)
from .ge_tline_item_optionsline_item_option_id_response_200_data_attributes_metadata import (
    GETlineItemOptionslineItemOptionIdResponse200DataAttributesMetadata,
)
from .ge_tline_item_optionsline_item_option_id_response_200_data_attributes_options import (
    GETlineItemOptionslineItemOptionIdResponse200DataAttributesOptions,
)
from .ge_tline_item_optionsline_item_option_id_response_200_data_links import (
    GETlineItemOptionslineItemOptionIdResponse200DataLinks,
)
from .ge_tline_item_optionsline_item_option_id_response_200_data_relationships import (
    GETlineItemOptionslineItemOptionIdResponse200DataRelationships,
)
from .ge_tline_item_optionsline_item_option_id_response_200_data_relationships_line_item import (
    GETlineItemOptionslineItemOptionIdResponse200DataRelationshipsLineItem,
)
from .ge_tline_item_optionsline_item_option_id_response_200_data_relationships_line_item_data import (
    GETlineItemOptionslineItemOptionIdResponse200DataRelationshipsLineItemData,
)
from .ge_tline_item_optionsline_item_option_id_response_200_data_relationships_line_item_data_type import (
    GETlineItemOptionslineItemOptionIdResponse200DataRelationshipsLineItemDataType,
)
from .ge_tline_item_optionsline_item_option_id_response_200_data_relationships_line_item_links import (
    GETlineItemOptionslineItemOptionIdResponse200DataRelationshipsLineItemLinks,
)
from .ge_tline_item_optionsline_item_option_id_response_200_data_relationships_sku_option import (
    GETlineItemOptionslineItemOptionIdResponse200DataRelationshipsSkuOption,
)
from .ge_tline_item_optionsline_item_option_id_response_200_data_relationships_sku_option_data import (
    GETlineItemOptionslineItemOptionIdResponse200DataRelationshipsSkuOptionData,
)
from .ge_tline_item_optionsline_item_option_id_response_200_data_relationships_sku_option_data_type import (
    GETlineItemOptionslineItemOptionIdResponse200DataRelationshipsSkuOptionDataType,
)
from .ge_tline_item_optionsline_item_option_id_response_200_data_relationships_sku_option_links import (
    GETlineItemOptionslineItemOptionIdResponse200DataRelationshipsSkuOptionLinks,
)
from .ge_tline_item_optionsline_item_option_id_response_200_data_type import (
    GETlineItemOptionslineItemOptionIdResponse200DataType,
)
from .ge_tline_items_response_200 import GETlineItemsResponse200
from .ge_tline_items_response_200_data_item import GETlineItemsResponse200DataItem
from .ge_tline_items_response_200_data_item_attributes import GETlineItemsResponse200DataItemAttributes
from .ge_tline_items_response_200_data_item_attributes_discount_breakdown import (
    GETlineItemsResponse200DataItemAttributesDiscountBreakdown,
)
from .ge_tline_items_response_200_data_item_attributes_metadata import GETlineItemsResponse200DataItemAttributesMetadata
from .ge_tline_items_response_200_data_item_attributes_tax_breakdown import (
    GETlineItemsResponse200DataItemAttributesTaxBreakdown,
)
from .ge_tline_items_response_200_data_item_links import GETlineItemsResponse200DataItemLinks
from .ge_tline_items_response_200_data_item_relationships import GETlineItemsResponse200DataItemRelationships
from .ge_tline_items_response_200_data_item_relationships_item import GETlineItemsResponse200DataItemRelationshipsItem
from .ge_tline_items_response_200_data_item_relationships_item_data import (
    GETlineItemsResponse200DataItemRelationshipsItemData,
)
from .ge_tline_items_response_200_data_item_relationships_item_data_type import (
    GETlineItemsResponse200DataItemRelationshipsItemDataType,
)
from .ge_tline_items_response_200_data_item_relationships_item_links import (
    GETlineItemsResponse200DataItemRelationshipsItemLinks,
)
from .ge_tline_items_response_200_data_item_relationships_line_item_options import (
    GETlineItemsResponse200DataItemRelationshipsLineItemOptions,
)
from .ge_tline_items_response_200_data_item_relationships_line_item_options_data import (
    GETlineItemsResponse200DataItemRelationshipsLineItemOptionsData,
)
from .ge_tline_items_response_200_data_item_relationships_line_item_options_data_type import (
    GETlineItemsResponse200DataItemRelationshipsLineItemOptionsDataType,
)
from .ge_tline_items_response_200_data_item_relationships_line_item_options_links import (
    GETlineItemsResponse200DataItemRelationshipsLineItemOptionsLinks,
)
from .ge_tline_items_response_200_data_item_relationships_order import GETlineItemsResponse200DataItemRelationshipsOrder
from .ge_tline_items_response_200_data_item_relationships_order_data import (
    GETlineItemsResponse200DataItemRelationshipsOrderData,
)
from .ge_tline_items_response_200_data_item_relationships_order_data_type import (
    GETlineItemsResponse200DataItemRelationshipsOrderDataType,
)
from .ge_tline_items_response_200_data_item_relationships_order_links import (
    GETlineItemsResponse200DataItemRelationshipsOrderLinks,
)
from .ge_tline_items_response_200_data_item_relationships_shipment_line_items import (
    GETlineItemsResponse200DataItemRelationshipsShipmentLineItems,
)
from .ge_tline_items_response_200_data_item_relationships_shipment_line_items_data import (
    GETlineItemsResponse200DataItemRelationshipsShipmentLineItemsData,
)
from .ge_tline_items_response_200_data_item_relationships_shipment_line_items_data_type import (
    GETlineItemsResponse200DataItemRelationshipsShipmentLineItemsDataType,
)
from .ge_tline_items_response_200_data_item_relationships_shipment_line_items_links import (
    GETlineItemsResponse200DataItemRelationshipsShipmentLineItemsLinks,
)
from .ge_tline_items_response_200_data_item_relationships_stock_line_items import (
    GETlineItemsResponse200DataItemRelationshipsStockLineItems,
)
from .ge_tline_items_response_200_data_item_relationships_stock_line_items_data import (
    GETlineItemsResponse200DataItemRelationshipsStockLineItemsData,
)
from .ge_tline_items_response_200_data_item_relationships_stock_line_items_data_type import (
    GETlineItemsResponse200DataItemRelationshipsStockLineItemsDataType,
)
from .ge_tline_items_response_200_data_item_relationships_stock_line_items_links import (
    GETlineItemsResponse200DataItemRelationshipsStockLineItemsLinks,
)
from .ge_tline_items_response_200_data_item_relationships_stock_transfers import (
    GETlineItemsResponse200DataItemRelationshipsStockTransfers,
)
from .ge_tline_items_response_200_data_item_relationships_stock_transfers_data import (
    GETlineItemsResponse200DataItemRelationshipsStockTransfersData,
)
from .ge_tline_items_response_200_data_item_relationships_stock_transfers_data_type import (
    GETlineItemsResponse200DataItemRelationshipsStockTransfersDataType,
)
from .ge_tline_items_response_200_data_item_relationships_stock_transfers_links import (
    GETlineItemsResponse200DataItemRelationshipsStockTransfersLinks,
)
from .ge_tline_items_response_200_data_item_type import GETlineItemsResponse200DataItemType
from .ge_tline_itemsline_item_id_response_200 import GETlineItemslineItemIdResponse200
from .ge_tline_itemsline_item_id_response_200_data import GETlineItemslineItemIdResponse200Data
from .ge_tline_itemsline_item_id_response_200_data_attributes import GETlineItemslineItemIdResponse200DataAttributes
from .ge_tline_itemsline_item_id_response_200_data_attributes_discount_breakdown import (
    GETlineItemslineItemIdResponse200DataAttributesDiscountBreakdown,
)
from .ge_tline_itemsline_item_id_response_200_data_attributes_metadata import (
    GETlineItemslineItemIdResponse200DataAttributesMetadata,
)
from .ge_tline_itemsline_item_id_response_200_data_attributes_tax_breakdown import (
    GETlineItemslineItemIdResponse200DataAttributesTaxBreakdown,
)
from .ge_tline_itemsline_item_id_response_200_data_links import GETlineItemslineItemIdResponse200DataLinks
from .ge_tline_itemsline_item_id_response_200_data_relationships import (
    GETlineItemslineItemIdResponse200DataRelationships,
)
from .ge_tline_itemsline_item_id_response_200_data_relationships_item import (
    GETlineItemslineItemIdResponse200DataRelationshipsItem,
)
from .ge_tline_itemsline_item_id_response_200_data_relationships_item_data import (
    GETlineItemslineItemIdResponse200DataRelationshipsItemData,
)
from .ge_tline_itemsline_item_id_response_200_data_relationships_item_data_type import (
    GETlineItemslineItemIdResponse200DataRelationshipsItemDataType,
)
from .ge_tline_itemsline_item_id_response_200_data_relationships_item_links import (
    GETlineItemslineItemIdResponse200DataRelationshipsItemLinks,
)
from .ge_tline_itemsline_item_id_response_200_data_relationships_line_item_options import (
    GETlineItemslineItemIdResponse200DataRelationshipsLineItemOptions,
)
from .ge_tline_itemsline_item_id_response_200_data_relationships_line_item_options_data import (
    GETlineItemslineItemIdResponse200DataRelationshipsLineItemOptionsData,
)
from .ge_tline_itemsline_item_id_response_200_data_relationships_line_item_options_data_type import (
    GETlineItemslineItemIdResponse200DataRelationshipsLineItemOptionsDataType,
)
from .ge_tline_itemsline_item_id_response_200_data_relationships_line_item_options_links import (
    GETlineItemslineItemIdResponse200DataRelationshipsLineItemOptionsLinks,
)
from .ge_tline_itemsline_item_id_response_200_data_relationships_order import (
    GETlineItemslineItemIdResponse200DataRelationshipsOrder,
)
from .ge_tline_itemsline_item_id_response_200_data_relationships_order_data import (
    GETlineItemslineItemIdResponse200DataRelationshipsOrderData,
)
from .ge_tline_itemsline_item_id_response_200_data_relationships_order_data_type import (
    GETlineItemslineItemIdResponse200DataRelationshipsOrderDataType,
)
from .ge_tline_itemsline_item_id_response_200_data_relationships_order_links import (
    GETlineItemslineItemIdResponse200DataRelationshipsOrderLinks,
)
from .ge_tline_itemsline_item_id_response_200_data_relationships_shipment_line_items import (
    GETlineItemslineItemIdResponse200DataRelationshipsShipmentLineItems,
)
from .ge_tline_itemsline_item_id_response_200_data_relationships_shipment_line_items_data import (
    GETlineItemslineItemIdResponse200DataRelationshipsShipmentLineItemsData,
)
from .ge_tline_itemsline_item_id_response_200_data_relationships_shipment_line_items_data_type import (
    GETlineItemslineItemIdResponse200DataRelationshipsShipmentLineItemsDataType,
)
from .ge_tline_itemsline_item_id_response_200_data_relationships_shipment_line_items_links import (
    GETlineItemslineItemIdResponse200DataRelationshipsShipmentLineItemsLinks,
)
from .ge_tline_itemsline_item_id_response_200_data_relationships_stock_line_items import (
    GETlineItemslineItemIdResponse200DataRelationshipsStockLineItems,
)
from .ge_tline_itemsline_item_id_response_200_data_relationships_stock_line_items_data import (
    GETlineItemslineItemIdResponse200DataRelationshipsStockLineItemsData,
)
from .ge_tline_itemsline_item_id_response_200_data_relationships_stock_line_items_data_type import (
    GETlineItemslineItemIdResponse200DataRelationshipsStockLineItemsDataType,
)
from .ge_tline_itemsline_item_id_response_200_data_relationships_stock_line_items_links import (
    GETlineItemslineItemIdResponse200DataRelationshipsStockLineItemsLinks,
)
from .ge_tline_itemsline_item_id_response_200_data_relationships_stock_transfers import (
    GETlineItemslineItemIdResponse200DataRelationshipsStockTransfers,
)
from .ge_tline_itemsline_item_id_response_200_data_relationships_stock_transfers_data import (
    GETlineItemslineItemIdResponse200DataRelationshipsStockTransfersData,
)
from .ge_tline_itemsline_item_id_response_200_data_relationships_stock_transfers_data_type import (
    GETlineItemslineItemIdResponse200DataRelationshipsStockTransfersDataType,
)
from .ge_tline_itemsline_item_id_response_200_data_relationships_stock_transfers_links import (
    GETlineItemslineItemIdResponse200DataRelationshipsStockTransfersLinks,
)
from .ge_tline_itemsline_item_id_response_200_data_type import GETlineItemslineItemIdResponse200DataType
from .ge_tmanual_gateways_response_200 import GETmanualGatewaysResponse200
from .ge_tmanual_gateways_response_200_data_item import GETmanualGatewaysResponse200DataItem
from .ge_tmanual_gateways_response_200_data_item_attributes import GETmanualGatewaysResponse200DataItemAttributes
from .ge_tmanual_gateways_response_200_data_item_attributes_metadata import (
    GETmanualGatewaysResponse200DataItemAttributesMetadata,
)
from .ge_tmanual_gateways_response_200_data_item_links import GETmanualGatewaysResponse200DataItemLinks
from .ge_tmanual_gateways_response_200_data_item_relationships import GETmanualGatewaysResponse200DataItemRelationships
from .ge_tmanual_gateways_response_200_data_item_relationships_payment_methods import (
    GETmanualGatewaysResponse200DataItemRelationshipsPaymentMethods,
)
from .ge_tmanual_gateways_response_200_data_item_relationships_payment_methods_data import (
    GETmanualGatewaysResponse200DataItemRelationshipsPaymentMethodsData,
)
from .ge_tmanual_gateways_response_200_data_item_relationships_payment_methods_data_type import (
    GETmanualGatewaysResponse200DataItemRelationshipsPaymentMethodsDataType,
)
from .ge_tmanual_gateways_response_200_data_item_relationships_payment_methods_links import (
    GETmanualGatewaysResponse200DataItemRelationshipsPaymentMethodsLinks,
)
from .ge_tmanual_gateways_response_200_data_item_type import GETmanualGatewaysResponse200DataItemType
from .ge_tmanual_gatewaysmanual_gateway_id_response_200 import GETmanualGatewaysmanualGatewayIdResponse200
from .ge_tmanual_gatewaysmanual_gateway_id_response_200_data import GETmanualGatewaysmanualGatewayIdResponse200Data
from .ge_tmanual_gatewaysmanual_gateway_id_response_200_data_attributes import (
    GETmanualGatewaysmanualGatewayIdResponse200DataAttributes,
)
from .ge_tmanual_gatewaysmanual_gateway_id_response_200_data_attributes_metadata import (
    GETmanualGatewaysmanualGatewayIdResponse200DataAttributesMetadata,
)
from .ge_tmanual_gatewaysmanual_gateway_id_response_200_data_links import (
    GETmanualGatewaysmanualGatewayIdResponse200DataLinks,
)
from .ge_tmanual_gatewaysmanual_gateway_id_response_200_data_relationships import (
    GETmanualGatewaysmanualGatewayIdResponse200DataRelationships,
)
from .ge_tmanual_gatewaysmanual_gateway_id_response_200_data_relationships_payment_methods import (
    GETmanualGatewaysmanualGatewayIdResponse200DataRelationshipsPaymentMethods,
)
from .ge_tmanual_gatewaysmanual_gateway_id_response_200_data_relationships_payment_methods_data import (
    GETmanualGatewaysmanualGatewayIdResponse200DataRelationshipsPaymentMethodsData,
)
from .ge_tmanual_gatewaysmanual_gateway_id_response_200_data_relationships_payment_methods_data_type import (
    GETmanualGatewaysmanualGatewayIdResponse200DataRelationshipsPaymentMethodsDataType,
)
from .ge_tmanual_gatewaysmanual_gateway_id_response_200_data_relationships_payment_methods_links import (
    GETmanualGatewaysmanualGatewayIdResponse200DataRelationshipsPaymentMethodsLinks,
)
from .ge_tmanual_gatewaysmanual_gateway_id_response_200_data_type import (
    GETmanualGatewaysmanualGatewayIdResponse200DataType,
)
from .ge_tmanual_tax_calculators_response_200 import GETmanualTaxCalculatorsResponse200
from .ge_tmanual_tax_calculators_response_200_data_item import GETmanualTaxCalculatorsResponse200DataItem
from .ge_tmanual_tax_calculators_response_200_data_item_attributes import (
    GETmanualTaxCalculatorsResponse200DataItemAttributes,
)
from .ge_tmanual_tax_calculators_response_200_data_item_attributes_metadata import (
    GETmanualTaxCalculatorsResponse200DataItemAttributesMetadata,
)
from .ge_tmanual_tax_calculators_response_200_data_item_links import GETmanualTaxCalculatorsResponse200DataItemLinks
from .ge_tmanual_tax_calculators_response_200_data_item_relationships import (
    GETmanualTaxCalculatorsResponse200DataItemRelationships,
)
from .ge_tmanual_tax_calculators_response_200_data_item_relationships_attachments import (
    GETmanualTaxCalculatorsResponse200DataItemRelationshipsAttachments,
)
from .ge_tmanual_tax_calculators_response_200_data_item_relationships_attachments_data import (
    GETmanualTaxCalculatorsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tmanual_tax_calculators_response_200_data_item_relationships_attachments_data_type import (
    GETmanualTaxCalculatorsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tmanual_tax_calculators_response_200_data_item_relationships_attachments_links import (
    GETmanualTaxCalculatorsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tmanual_tax_calculators_response_200_data_item_relationships_markets import (
    GETmanualTaxCalculatorsResponse200DataItemRelationshipsMarkets,
)
from .ge_tmanual_tax_calculators_response_200_data_item_relationships_markets_data import (
    GETmanualTaxCalculatorsResponse200DataItemRelationshipsMarketsData,
)
from .ge_tmanual_tax_calculators_response_200_data_item_relationships_markets_data_type import (
    GETmanualTaxCalculatorsResponse200DataItemRelationshipsMarketsDataType,
)
from .ge_tmanual_tax_calculators_response_200_data_item_relationships_markets_links import (
    GETmanualTaxCalculatorsResponse200DataItemRelationshipsMarketsLinks,
)
from .ge_tmanual_tax_calculators_response_200_data_item_relationships_tax_rules import (
    GETmanualTaxCalculatorsResponse200DataItemRelationshipsTaxRules,
)
from .ge_tmanual_tax_calculators_response_200_data_item_relationships_tax_rules_data import (
    GETmanualTaxCalculatorsResponse200DataItemRelationshipsTaxRulesData,
)
from .ge_tmanual_tax_calculators_response_200_data_item_relationships_tax_rules_data_type import (
    GETmanualTaxCalculatorsResponse200DataItemRelationshipsTaxRulesDataType,
)
from .ge_tmanual_tax_calculators_response_200_data_item_relationships_tax_rules_links import (
    GETmanualTaxCalculatorsResponse200DataItemRelationshipsTaxRulesLinks,
)
from .ge_tmanual_tax_calculators_response_200_data_item_type import GETmanualTaxCalculatorsResponse200DataItemType
from .ge_tmanual_tax_calculatorsmanual_tax_calculator_id_response_200 import (
    GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200,
)
from .ge_tmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data import (
    GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200Data,
)
from .ge_tmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_attributes import (
    GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataAttributes,
)
from .ge_tmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_attributes_metadata import (
    GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataAttributesMetadata,
)
from .ge_tmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_links import (
    GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataLinks,
)
from .ge_tmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_relationships import (
    GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationships,
)
from .ge_tmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_relationships_attachments import (
    GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsAttachments,
)
from .ge_tmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_relationships_attachments_data import (
    GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_relationships_attachments_data_type import (
    GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_relationships_attachments_links import (
    GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_relationships_markets import (
    GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsMarkets,
)
from .ge_tmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_relationships_markets_data import (
    GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsMarketsData,
)
from .ge_tmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_relationships_markets_data_type import (
    GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsMarketsDataType,
)
from .ge_tmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_relationships_markets_links import (
    GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsMarketsLinks,
)
from .ge_tmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_relationships_tax_rules import (
    GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsTaxRules,
)
from .ge_tmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_relationships_tax_rules_data import (
    GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsTaxRulesData,
)
from .ge_tmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_relationships_tax_rules_data_type import (
    GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsTaxRulesDataType,
)
from .ge_tmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_relationships_tax_rules_links import (
    GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsTaxRulesLinks,
)
from .ge_tmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_type import (
    GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataType,
)
from .ge_tmarkets_response_200 import GETmarketsResponse200
from .ge_tmarkets_response_200_data_item import GETmarketsResponse200DataItem
from .ge_tmarkets_response_200_data_item_attributes import GETmarketsResponse200DataItemAttributes
from .ge_tmarkets_response_200_data_item_attributes_metadata import GETmarketsResponse200DataItemAttributesMetadata
from .ge_tmarkets_response_200_data_item_links import GETmarketsResponse200DataItemLinks
from .ge_tmarkets_response_200_data_item_relationships import GETmarketsResponse200DataItemRelationships
from .ge_tmarkets_response_200_data_item_relationships_attachments import (
    GETmarketsResponse200DataItemRelationshipsAttachments,
)
from .ge_tmarkets_response_200_data_item_relationships_attachments_data import (
    GETmarketsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tmarkets_response_200_data_item_relationships_attachments_data_type import (
    GETmarketsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tmarkets_response_200_data_item_relationships_attachments_links import (
    GETmarketsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tmarkets_response_200_data_item_relationships_customer_group import (
    GETmarketsResponse200DataItemRelationshipsCustomerGroup,
)
from .ge_tmarkets_response_200_data_item_relationships_customer_group_data import (
    GETmarketsResponse200DataItemRelationshipsCustomerGroupData,
)
from .ge_tmarkets_response_200_data_item_relationships_customer_group_data_type import (
    GETmarketsResponse200DataItemRelationshipsCustomerGroupDataType,
)
from .ge_tmarkets_response_200_data_item_relationships_customer_group_links import (
    GETmarketsResponse200DataItemRelationshipsCustomerGroupLinks,
)
from .ge_tmarkets_response_200_data_item_relationships_inventory_model import (
    GETmarketsResponse200DataItemRelationshipsInventoryModel,
)
from .ge_tmarkets_response_200_data_item_relationships_inventory_model_data import (
    GETmarketsResponse200DataItemRelationshipsInventoryModelData,
)
from .ge_tmarkets_response_200_data_item_relationships_inventory_model_data_type import (
    GETmarketsResponse200DataItemRelationshipsInventoryModelDataType,
)
from .ge_tmarkets_response_200_data_item_relationships_inventory_model_links import (
    GETmarketsResponse200DataItemRelationshipsInventoryModelLinks,
)
from .ge_tmarkets_response_200_data_item_relationships_merchant import (
    GETmarketsResponse200DataItemRelationshipsMerchant,
)
from .ge_tmarkets_response_200_data_item_relationships_merchant_data import (
    GETmarketsResponse200DataItemRelationshipsMerchantData,
)
from .ge_tmarkets_response_200_data_item_relationships_merchant_data_type import (
    GETmarketsResponse200DataItemRelationshipsMerchantDataType,
)
from .ge_tmarkets_response_200_data_item_relationships_merchant_links import (
    GETmarketsResponse200DataItemRelationshipsMerchantLinks,
)
from .ge_tmarkets_response_200_data_item_relationships_price_list import (
    GETmarketsResponse200DataItemRelationshipsPriceList,
)
from .ge_tmarkets_response_200_data_item_relationships_price_list_data import (
    GETmarketsResponse200DataItemRelationshipsPriceListData,
)
from .ge_tmarkets_response_200_data_item_relationships_price_list_data_type import (
    GETmarketsResponse200DataItemRelationshipsPriceListDataType,
)
from .ge_tmarkets_response_200_data_item_relationships_price_list_links import (
    GETmarketsResponse200DataItemRelationshipsPriceListLinks,
)
from .ge_tmarkets_response_200_data_item_relationships_tax_calculator import (
    GETmarketsResponse200DataItemRelationshipsTaxCalculator,
)
from .ge_tmarkets_response_200_data_item_relationships_tax_calculator_data import (
    GETmarketsResponse200DataItemRelationshipsTaxCalculatorData,
)
from .ge_tmarkets_response_200_data_item_relationships_tax_calculator_data_type import (
    GETmarketsResponse200DataItemRelationshipsTaxCalculatorDataType,
)
from .ge_tmarkets_response_200_data_item_relationships_tax_calculator_links import (
    GETmarketsResponse200DataItemRelationshipsTaxCalculatorLinks,
)
from .ge_tmarkets_response_200_data_item_type import GETmarketsResponse200DataItemType
from .ge_tmarketsmarket_id_response_200 import GETmarketsmarketIdResponse200
from .ge_tmarketsmarket_id_response_200_data import GETmarketsmarketIdResponse200Data
from .ge_tmarketsmarket_id_response_200_data_attributes import GETmarketsmarketIdResponse200DataAttributes
from .ge_tmarketsmarket_id_response_200_data_attributes_metadata import (
    GETmarketsmarketIdResponse200DataAttributesMetadata,
)
from .ge_tmarketsmarket_id_response_200_data_links import GETmarketsmarketIdResponse200DataLinks
from .ge_tmarketsmarket_id_response_200_data_relationships import GETmarketsmarketIdResponse200DataRelationships
from .ge_tmarketsmarket_id_response_200_data_relationships_attachments import (
    GETmarketsmarketIdResponse200DataRelationshipsAttachments,
)
from .ge_tmarketsmarket_id_response_200_data_relationships_attachments_data import (
    GETmarketsmarketIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tmarketsmarket_id_response_200_data_relationships_attachments_data_type import (
    GETmarketsmarketIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tmarketsmarket_id_response_200_data_relationships_attachments_links import (
    GETmarketsmarketIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tmarketsmarket_id_response_200_data_relationships_customer_group import (
    GETmarketsmarketIdResponse200DataRelationshipsCustomerGroup,
)
from .ge_tmarketsmarket_id_response_200_data_relationships_customer_group_data import (
    GETmarketsmarketIdResponse200DataRelationshipsCustomerGroupData,
)
from .ge_tmarketsmarket_id_response_200_data_relationships_customer_group_data_type import (
    GETmarketsmarketIdResponse200DataRelationshipsCustomerGroupDataType,
)
from .ge_tmarketsmarket_id_response_200_data_relationships_customer_group_links import (
    GETmarketsmarketIdResponse200DataRelationshipsCustomerGroupLinks,
)
from .ge_tmarketsmarket_id_response_200_data_relationships_inventory_model import (
    GETmarketsmarketIdResponse200DataRelationshipsInventoryModel,
)
from .ge_tmarketsmarket_id_response_200_data_relationships_inventory_model_data import (
    GETmarketsmarketIdResponse200DataRelationshipsInventoryModelData,
)
from .ge_tmarketsmarket_id_response_200_data_relationships_inventory_model_data_type import (
    GETmarketsmarketIdResponse200DataRelationshipsInventoryModelDataType,
)
from .ge_tmarketsmarket_id_response_200_data_relationships_inventory_model_links import (
    GETmarketsmarketIdResponse200DataRelationshipsInventoryModelLinks,
)
from .ge_tmarketsmarket_id_response_200_data_relationships_merchant import (
    GETmarketsmarketIdResponse200DataRelationshipsMerchant,
)
from .ge_tmarketsmarket_id_response_200_data_relationships_merchant_data import (
    GETmarketsmarketIdResponse200DataRelationshipsMerchantData,
)
from .ge_tmarketsmarket_id_response_200_data_relationships_merchant_data_type import (
    GETmarketsmarketIdResponse200DataRelationshipsMerchantDataType,
)
from .ge_tmarketsmarket_id_response_200_data_relationships_merchant_links import (
    GETmarketsmarketIdResponse200DataRelationshipsMerchantLinks,
)
from .ge_tmarketsmarket_id_response_200_data_relationships_price_list import (
    GETmarketsmarketIdResponse200DataRelationshipsPriceList,
)
from .ge_tmarketsmarket_id_response_200_data_relationships_price_list_data import (
    GETmarketsmarketIdResponse200DataRelationshipsPriceListData,
)
from .ge_tmarketsmarket_id_response_200_data_relationships_price_list_data_type import (
    GETmarketsmarketIdResponse200DataRelationshipsPriceListDataType,
)
from .ge_tmarketsmarket_id_response_200_data_relationships_price_list_links import (
    GETmarketsmarketIdResponse200DataRelationshipsPriceListLinks,
)
from .ge_tmarketsmarket_id_response_200_data_relationships_tax_calculator import (
    GETmarketsmarketIdResponse200DataRelationshipsTaxCalculator,
)
from .ge_tmarketsmarket_id_response_200_data_relationships_tax_calculator_data import (
    GETmarketsmarketIdResponse200DataRelationshipsTaxCalculatorData,
)
from .ge_tmarketsmarket_id_response_200_data_relationships_tax_calculator_data_type import (
    GETmarketsmarketIdResponse200DataRelationshipsTaxCalculatorDataType,
)
from .ge_tmarketsmarket_id_response_200_data_relationships_tax_calculator_links import (
    GETmarketsmarketIdResponse200DataRelationshipsTaxCalculatorLinks,
)
from .ge_tmarketsmarket_id_response_200_data_type import GETmarketsmarketIdResponse200DataType
from .ge_tmerchants_response_200 import GETmerchantsResponse200
from .ge_tmerchants_response_200_data_item import GETmerchantsResponse200DataItem
from .ge_tmerchants_response_200_data_item_attributes import GETmerchantsResponse200DataItemAttributes
from .ge_tmerchants_response_200_data_item_attributes_metadata import GETmerchantsResponse200DataItemAttributesMetadata
from .ge_tmerchants_response_200_data_item_links import GETmerchantsResponse200DataItemLinks
from .ge_tmerchants_response_200_data_item_relationships import GETmerchantsResponse200DataItemRelationships
from .ge_tmerchants_response_200_data_item_relationships_address import (
    GETmerchantsResponse200DataItemRelationshipsAddress,
)
from .ge_tmerchants_response_200_data_item_relationships_address_data import (
    GETmerchantsResponse200DataItemRelationshipsAddressData,
)
from .ge_tmerchants_response_200_data_item_relationships_address_data_type import (
    GETmerchantsResponse200DataItemRelationshipsAddressDataType,
)
from .ge_tmerchants_response_200_data_item_relationships_address_links import (
    GETmerchantsResponse200DataItemRelationshipsAddressLinks,
)
from .ge_tmerchants_response_200_data_item_relationships_attachments import (
    GETmerchantsResponse200DataItemRelationshipsAttachments,
)
from .ge_tmerchants_response_200_data_item_relationships_attachments_data import (
    GETmerchantsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tmerchants_response_200_data_item_relationships_attachments_data_type import (
    GETmerchantsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tmerchants_response_200_data_item_relationships_attachments_links import (
    GETmerchantsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tmerchants_response_200_data_item_type import GETmerchantsResponse200DataItemType
from .ge_tmerchantsmerchant_id_response_200 import GETmerchantsmerchantIdResponse200
from .ge_tmerchantsmerchant_id_response_200_data import GETmerchantsmerchantIdResponse200Data
from .ge_tmerchantsmerchant_id_response_200_data_attributes import GETmerchantsmerchantIdResponse200DataAttributes
from .ge_tmerchantsmerchant_id_response_200_data_attributes_metadata import (
    GETmerchantsmerchantIdResponse200DataAttributesMetadata,
)
from .ge_tmerchantsmerchant_id_response_200_data_links import GETmerchantsmerchantIdResponse200DataLinks
from .ge_tmerchantsmerchant_id_response_200_data_relationships import GETmerchantsmerchantIdResponse200DataRelationships
from .ge_tmerchantsmerchant_id_response_200_data_relationships_address import (
    GETmerchantsmerchantIdResponse200DataRelationshipsAddress,
)
from .ge_tmerchantsmerchant_id_response_200_data_relationships_address_data import (
    GETmerchantsmerchantIdResponse200DataRelationshipsAddressData,
)
from .ge_tmerchantsmerchant_id_response_200_data_relationships_address_data_type import (
    GETmerchantsmerchantIdResponse200DataRelationshipsAddressDataType,
)
from .ge_tmerchantsmerchant_id_response_200_data_relationships_address_links import (
    GETmerchantsmerchantIdResponse200DataRelationshipsAddressLinks,
)
from .ge_tmerchantsmerchant_id_response_200_data_relationships_attachments import (
    GETmerchantsmerchantIdResponse200DataRelationshipsAttachments,
)
from .ge_tmerchantsmerchant_id_response_200_data_relationships_attachments_data import (
    GETmerchantsmerchantIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tmerchantsmerchant_id_response_200_data_relationships_attachments_data_type import (
    GETmerchantsmerchantIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tmerchantsmerchant_id_response_200_data_relationships_attachments_links import (
    GETmerchantsmerchantIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tmerchantsmerchant_id_response_200_data_type import GETmerchantsmerchantIdResponse200DataType
from .ge_torder_amount_promotion_rules_response_200 import GETorderAmountPromotionRulesResponse200
from .ge_torder_amount_promotion_rules_response_200_data_item import GETorderAmountPromotionRulesResponse200DataItem
from .ge_torder_amount_promotion_rules_response_200_data_item_attributes import (
    GETorderAmountPromotionRulesResponse200DataItemAttributes,
)
from .ge_torder_amount_promotion_rules_response_200_data_item_attributes_metadata import (
    GETorderAmountPromotionRulesResponse200DataItemAttributesMetadata,
)
from .ge_torder_amount_promotion_rules_response_200_data_item_links import (
    GETorderAmountPromotionRulesResponse200DataItemLinks,
)
from .ge_torder_amount_promotion_rules_response_200_data_item_relationships import (
    GETorderAmountPromotionRulesResponse200DataItemRelationships,
)
from .ge_torder_amount_promotion_rules_response_200_data_item_relationships_promotion import (
    GETorderAmountPromotionRulesResponse200DataItemRelationshipsPromotion,
)
from .ge_torder_amount_promotion_rules_response_200_data_item_relationships_promotion_data import (
    GETorderAmountPromotionRulesResponse200DataItemRelationshipsPromotionData,
)
from .ge_torder_amount_promotion_rules_response_200_data_item_relationships_promotion_data_type import (
    GETorderAmountPromotionRulesResponse200DataItemRelationshipsPromotionDataType,
)
from .ge_torder_amount_promotion_rules_response_200_data_item_relationships_promotion_links import (
    GETorderAmountPromotionRulesResponse200DataItemRelationshipsPromotionLinks,
)
from .ge_torder_amount_promotion_rules_response_200_data_item_type import (
    GETorderAmountPromotionRulesResponse200DataItemType,
)
from .ge_torder_amount_promotion_rulesorder_amount_promotion_rule_id_response_200 import (
    GETorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200,
)
from .ge_torder_amount_promotion_rulesorder_amount_promotion_rule_id_response_200_data import (
    GETorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200Data,
)
from .ge_torder_amount_promotion_rulesorder_amount_promotion_rule_id_response_200_data_attributes import (
    GETorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataAttributes,
)
from .ge_torder_amount_promotion_rulesorder_amount_promotion_rule_id_response_200_data_attributes_metadata import (
    GETorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataAttributesMetadata,
)
from .ge_torder_amount_promotion_rulesorder_amount_promotion_rule_id_response_200_data_links import (
    GETorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataLinks,
)
from .ge_torder_amount_promotion_rulesorder_amount_promotion_rule_id_response_200_data_relationships import (
    GETorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataRelationships,
)
from .ge_torder_amount_promotion_rulesorder_amount_promotion_rule_id_response_200_data_relationships_promotion import (
    GETorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataRelationshipsPromotion,
)
from .ge_torder_amount_promotion_rulesorder_amount_promotion_rule_id_response_200_data_relationships_promotion_data import (
    GETorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataRelationshipsPromotionData,
)
from .ge_torder_amount_promotion_rulesorder_amount_promotion_rule_id_response_200_data_relationships_promotion_data_type import (
    GETorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataRelationshipsPromotionDataType,
)
from .ge_torder_amount_promotion_rulesorder_amount_promotion_rule_id_response_200_data_relationships_promotion_links import (
    GETorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataRelationshipsPromotionLinks,
)
from .ge_torder_amount_promotion_rulesorder_amount_promotion_rule_id_response_200_data_type import (
    GETorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataType,
)
from .ge_torder_copies_response_200 import GETorderCopiesResponse200
from .ge_torder_copies_response_200_data_item import GETorderCopiesResponse200DataItem
from .ge_torder_copies_response_200_data_item_attributes import GETorderCopiesResponse200DataItemAttributes
from .ge_torder_copies_response_200_data_item_attributes_errors_log import (
    GETorderCopiesResponse200DataItemAttributesErrorsLog,
)
from .ge_torder_copies_response_200_data_item_attributes_metadata import (
    GETorderCopiesResponse200DataItemAttributesMetadata,
)
from .ge_torder_copies_response_200_data_item_links import GETorderCopiesResponse200DataItemLinks
from .ge_torder_copies_response_200_data_item_relationships import GETorderCopiesResponse200DataItemRelationships
from .ge_torder_copies_response_200_data_item_relationships_events import (
    GETorderCopiesResponse200DataItemRelationshipsEvents,
)
from .ge_torder_copies_response_200_data_item_relationships_events_data import (
    GETorderCopiesResponse200DataItemRelationshipsEventsData,
)
from .ge_torder_copies_response_200_data_item_relationships_events_data_type import (
    GETorderCopiesResponse200DataItemRelationshipsEventsDataType,
)
from .ge_torder_copies_response_200_data_item_relationships_events_links import (
    GETorderCopiesResponse200DataItemRelationshipsEventsLinks,
)
from .ge_torder_copies_response_200_data_item_relationships_order_subscription import (
    GETorderCopiesResponse200DataItemRelationshipsOrderSubscription,
)
from .ge_torder_copies_response_200_data_item_relationships_order_subscription_data import (
    GETorderCopiesResponse200DataItemRelationshipsOrderSubscriptionData,
)
from .ge_torder_copies_response_200_data_item_relationships_order_subscription_data_type import (
    GETorderCopiesResponse200DataItemRelationshipsOrderSubscriptionDataType,
)
from .ge_torder_copies_response_200_data_item_relationships_order_subscription_links import (
    GETorderCopiesResponse200DataItemRelationshipsOrderSubscriptionLinks,
)
from .ge_torder_copies_response_200_data_item_relationships_source_order import (
    GETorderCopiesResponse200DataItemRelationshipsSourceOrder,
)
from .ge_torder_copies_response_200_data_item_relationships_source_order_data import (
    GETorderCopiesResponse200DataItemRelationshipsSourceOrderData,
)
from .ge_torder_copies_response_200_data_item_relationships_source_order_data_type import (
    GETorderCopiesResponse200DataItemRelationshipsSourceOrderDataType,
)
from .ge_torder_copies_response_200_data_item_relationships_source_order_links import (
    GETorderCopiesResponse200DataItemRelationshipsSourceOrderLinks,
)
from .ge_torder_copies_response_200_data_item_relationships_target_order import (
    GETorderCopiesResponse200DataItemRelationshipsTargetOrder,
)
from .ge_torder_copies_response_200_data_item_relationships_target_order_data import (
    GETorderCopiesResponse200DataItemRelationshipsTargetOrderData,
)
from .ge_torder_copies_response_200_data_item_relationships_target_order_data_type import (
    GETorderCopiesResponse200DataItemRelationshipsTargetOrderDataType,
)
from .ge_torder_copies_response_200_data_item_relationships_target_order_links import (
    GETorderCopiesResponse200DataItemRelationshipsTargetOrderLinks,
)
from .ge_torder_copies_response_200_data_item_type import GETorderCopiesResponse200DataItemType
from .ge_torder_copiesorder_copy_id_response_200 import GETorderCopiesorderCopyIdResponse200
from .ge_torder_copiesorder_copy_id_response_200_data import GETorderCopiesorderCopyIdResponse200Data
from .ge_torder_copiesorder_copy_id_response_200_data_attributes import (
    GETorderCopiesorderCopyIdResponse200DataAttributes,
)
from .ge_torder_copiesorder_copy_id_response_200_data_attributes_errors_log import (
    GETorderCopiesorderCopyIdResponse200DataAttributesErrorsLog,
)
from .ge_torder_copiesorder_copy_id_response_200_data_attributes_metadata import (
    GETorderCopiesorderCopyIdResponse200DataAttributesMetadata,
)
from .ge_torder_copiesorder_copy_id_response_200_data_links import GETorderCopiesorderCopyIdResponse200DataLinks
from .ge_torder_copiesorder_copy_id_response_200_data_relationships import (
    GETorderCopiesorderCopyIdResponse200DataRelationships,
)
from .ge_torder_copiesorder_copy_id_response_200_data_relationships_events import (
    GETorderCopiesorderCopyIdResponse200DataRelationshipsEvents,
)
from .ge_torder_copiesorder_copy_id_response_200_data_relationships_events_data import (
    GETorderCopiesorderCopyIdResponse200DataRelationshipsEventsData,
)
from .ge_torder_copiesorder_copy_id_response_200_data_relationships_events_data_type import (
    GETorderCopiesorderCopyIdResponse200DataRelationshipsEventsDataType,
)
from .ge_torder_copiesorder_copy_id_response_200_data_relationships_events_links import (
    GETorderCopiesorderCopyIdResponse200DataRelationshipsEventsLinks,
)
from .ge_torder_copiesorder_copy_id_response_200_data_relationships_order_subscription import (
    GETorderCopiesorderCopyIdResponse200DataRelationshipsOrderSubscription,
)
from .ge_torder_copiesorder_copy_id_response_200_data_relationships_order_subscription_data import (
    GETorderCopiesorderCopyIdResponse200DataRelationshipsOrderSubscriptionData,
)
from .ge_torder_copiesorder_copy_id_response_200_data_relationships_order_subscription_data_type import (
    GETorderCopiesorderCopyIdResponse200DataRelationshipsOrderSubscriptionDataType,
)
from .ge_torder_copiesorder_copy_id_response_200_data_relationships_order_subscription_links import (
    GETorderCopiesorderCopyIdResponse200DataRelationshipsOrderSubscriptionLinks,
)
from .ge_torder_copiesorder_copy_id_response_200_data_relationships_source_order import (
    GETorderCopiesorderCopyIdResponse200DataRelationshipsSourceOrder,
)
from .ge_torder_copiesorder_copy_id_response_200_data_relationships_source_order_data import (
    GETorderCopiesorderCopyIdResponse200DataRelationshipsSourceOrderData,
)
from .ge_torder_copiesorder_copy_id_response_200_data_relationships_source_order_data_type import (
    GETorderCopiesorderCopyIdResponse200DataRelationshipsSourceOrderDataType,
)
from .ge_torder_copiesorder_copy_id_response_200_data_relationships_source_order_links import (
    GETorderCopiesorderCopyIdResponse200DataRelationshipsSourceOrderLinks,
)
from .ge_torder_copiesorder_copy_id_response_200_data_relationships_target_order import (
    GETorderCopiesorderCopyIdResponse200DataRelationshipsTargetOrder,
)
from .ge_torder_copiesorder_copy_id_response_200_data_relationships_target_order_data import (
    GETorderCopiesorderCopyIdResponse200DataRelationshipsTargetOrderData,
)
from .ge_torder_copiesorder_copy_id_response_200_data_relationships_target_order_data_type import (
    GETorderCopiesorderCopyIdResponse200DataRelationshipsTargetOrderDataType,
)
from .ge_torder_copiesorder_copy_id_response_200_data_relationships_target_order_links import (
    GETorderCopiesorderCopyIdResponse200DataRelationshipsTargetOrderLinks,
)
from .ge_torder_copiesorder_copy_id_response_200_data_type import GETorderCopiesorderCopyIdResponse200DataType
from .ge_torder_subscriptions_response_200 import GETorderSubscriptionsResponse200
from .ge_torder_subscriptions_response_200_data_item import GETorderSubscriptionsResponse200DataItem
from .ge_torder_subscriptions_response_200_data_item_attributes import (
    GETorderSubscriptionsResponse200DataItemAttributes,
)
from .ge_torder_subscriptions_response_200_data_item_attributes_metadata import (
    GETorderSubscriptionsResponse200DataItemAttributesMetadata,
)
from .ge_torder_subscriptions_response_200_data_item_attributes_options import (
    GETorderSubscriptionsResponse200DataItemAttributesOptions,
)
from .ge_torder_subscriptions_response_200_data_item_links import GETorderSubscriptionsResponse200DataItemLinks
from .ge_torder_subscriptions_response_200_data_item_relationships import (
    GETorderSubscriptionsResponse200DataItemRelationships,
)
from .ge_torder_subscriptions_response_200_data_item_relationships_customer import (
    GETorderSubscriptionsResponse200DataItemRelationshipsCustomer,
)
from .ge_torder_subscriptions_response_200_data_item_relationships_customer_data import (
    GETorderSubscriptionsResponse200DataItemRelationshipsCustomerData,
)
from .ge_torder_subscriptions_response_200_data_item_relationships_customer_data_type import (
    GETorderSubscriptionsResponse200DataItemRelationshipsCustomerDataType,
)
from .ge_torder_subscriptions_response_200_data_item_relationships_customer_links import (
    GETorderSubscriptionsResponse200DataItemRelationshipsCustomerLinks,
)
from .ge_torder_subscriptions_response_200_data_item_relationships_events import (
    GETorderSubscriptionsResponse200DataItemRelationshipsEvents,
)
from .ge_torder_subscriptions_response_200_data_item_relationships_events_data import (
    GETorderSubscriptionsResponse200DataItemRelationshipsEventsData,
)
from .ge_torder_subscriptions_response_200_data_item_relationships_events_data_type import (
    GETorderSubscriptionsResponse200DataItemRelationshipsEventsDataType,
)
from .ge_torder_subscriptions_response_200_data_item_relationships_events_links import (
    GETorderSubscriptionsResponse200DataItemRelationshipsEventsLinks,
)
from .ge_torder_subscriptions_response_200_data_item_relationships_market import (
    GETorderSubscriptionsResponse200DataItemRelationshipsMarket,
)
from .ge_torder_subscriptions_response_200_data_item_relationships_market_data import (
    GETorderSubscriptionsResponse200DataItemRelationshipsMarketData,
)
from .ge_torder_subscriptions_response_200_data_item_relationships_market_data_type import (
    GETorderSubscriptionsResponse200DataItemRelationshipsMarketDataType,
)
from .ge_torder_subscriptions_response_200_data_item_relationships_market_links import (
    GETorderSubscriptionsResponse200DataItemRelationshipsMarketLinks,
)
from .ge_torder_subscriptions_response_200_data_item_relationships_order_copies import (
    GETorderSubscriptionsResponse200DataItemRelationshipsOrderCopies,
)
from .ge_torder_subscriptions_response_200_data_item_relationships_order_copies_data import (
    GETorderSubscriptionsResponse200DataItemRelationshipsOrderCopiesData,
)
from .ge_torder_subscriptions_response_200_data_item_relationships_order_copies_data_type import (
    GETorderSubscriptionsResponse200DataItemRelationshipsOrderCopiesDataType,
)
from .ge_torder_subscriptions_response_200_data_item_relationships_order_copies_links import (
    GETorderSubscriptionsResponse200DataItemRelationshipsOrderCopiesLinks,
)
from .ge_torder_subscriptions_response_200_data_item_relationships_orders import (
    GETorderSubscriptionsResponse200DataItemRelationshipsOrders,
)
from .ge_torder_subscriptions_response_200_data_item_relationships_orders_data import (
    GETorderSubscriptionsResponse200DataItemRelationshipsOrdersData,
)
from .ge_torder_subscriptions_response_200_data_item_relationships_orders_data_type import (
    GETorderSubscriptionsResponse200DataItemRelationshipsOrdersDataType,
)
from .ge_torder_subscriptions_response_200_data_item_relationships_orders_links import (
    GETorderSubscriptionsResponse200DataItemRelationshipsOrdersLinks,
)
from .ge_torder_subscriptions_response_200_data_item_relationships_source_order import (
    GETorderSubscriptionsResponse200DataItemRelationshipsSourceOrder,
)
from .ge_torder_subscriptions_response_200_data_item_relationships_source_order_data import (
    GETorderSubscriptionsResponse200DataItemRelationshipsSourceOrderData,
)
from .ge_torder_subscriptions_response_200_data_item_relationships_source_order_data_type import (
    GETorderSubscriptionsResponse200DataItemRelationshipsSourceOrderDataType,
)
from .ge_torder_subscriptions_response_200_data_item_relationships_source_order_links import (
    GETorderSubscriptionsResponse200DataItemRelationshipsSourceOrderLinks,
)
from .ge_torder_subscriptions_response_200_data_item_type import GETorderSubscriptionsResponse200DataItemType
from .ge_torder_subscriptionsorder_subscription_id_response_200 import (
    GETorderSubscriptionsorderSubscriptionIdResponse200,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data import (
    GETorderSubscriptionsorderSubscriptionIdResponse200Data,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_attributes import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataAttributes,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_attributes_metadata import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataAttributesMetadata,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_attributes_options import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataAttributesOptions,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_links import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataLinks,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_relationships import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationships,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_relationships_customer import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsCustomer,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_relationships_customer_data import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsCustomerData,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_relationships_customer_data_type import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsCustomerDataType,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_relationships_customer_links import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsCustomerLinks,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_relationships_events import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsEvents,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_relationships_events_data import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsEventsData,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_relationships_events_data_type import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsEventsDataType,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_relationships_events_links import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsEventsLinks,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_relationships_market import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsMarket,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_relationships_market_data import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsMarketData,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_relationships_market_data_type import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsMarketDataType,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_relationships_market_links import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsMarketLinks,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_relationships_order_copies import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrderCopies,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_relationships_order_copies_data import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrderCopiesData,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_relationships_order_copies_data_type import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrderCopiesDataType,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_relationships_order_copies_links import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrderCopiesLinks,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_relationships_orders import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrders,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_relationships_orders_data import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrdersData,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_relationships_orders_data_type import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrdersDataType,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_relationships_orders_links import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrdersLinks,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_relationships_source_order import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsSourceOrder,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_relationships_source_order_data import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsSourceOrderData,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_relationships_source_order_data_type import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsSourceOrderDataType,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_relationships_source_order_links import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsSourceOrderLinks,
)
from .ge_torder_subscriptionsorder_subscription_id_response_200_data_type import (
    GETorderSubscriptionsorderSubscriptionIdResponse200DataType,
)
from .ge_torder_validation_rules_response_200 import GETorderValidationRulesResponse200
from .ge_torder_validation_rules_response_200_data_item import GETorderValidationRulesResponse200DataItem
from .ge_torder_validation_rules_response_200_data_item_attributes import (
    GETorderValidationRulesResponse200DataItemAttributes,
)
from .ge_torder_validation_rules_response_200_data_item_attributes_metadata import (
    GETorderValidationRulesResponse200DataItemAttributesMetadata,
)
from .ge_torder_validation_rules_response_200_data_item_links import GETorderValidationRulesResponse200DataItemLinks
from .ge_torder_validation_rules_response_200_data_item_relationships import (
    GETorderValidationRulesResponse200DataItemRelationships,
)
from .ge_torder_validation_rules_response_200_data_item_relationships_market import (
    GETorderValidationRulesResponse200DataItemRelationshipsMarket,
)
from .ge_torder_validation_rules_response_200_data_item_relationships_market_data import (
    GETorderValidationRulesResponse200DataItemRelationshipsMarketData,
)
from .ge_torder_validation_rules_response_200_data_item_relationships_market_data_type import (
    GETorderValidationRulesResponse200DataItemRelationshipsMarketDataType,
)
from .ge_torder_validation_rules_response_200_data_item_relationships_market_links import (
    GETorderValidationRulesResponse200DataItemRelationshipsMarketLinks,
)
from .ge_torder_validation_rules_response_200_data_item_type import GETorderValidationRulesResponse200DataItemType
from .ge_torder_validation_rulesorder_validation_rule_id_response_200 import (
    GETorderValidationRulesorderValidationRuleIdResponse200,
)
from .ge_torder_validation_rulesorder_validation_rule_id_response_200_data import (
    GETorderValidationRulesorderValidationRuleIdResponse200Data,
)
from .ge_torder_validation_rulesorder_validation_rule_id_response_200_data_attributes import (
    GETorderValidationRulesorderValidationRuleIdResponse200DataAttributes,
)
from .ge_torder_validation_rulesorder_validation_rule_id_response_200_data_attributes_metadata import (
    GETorderValidationRulesorderValidationRuleIdResponse200DataAttributesMetadata,
)
from .ge_torder_validation_rulesorder_validation_rule_id_response_200_data_links import (
    GETorderValidationRulesorderValidationRuleIdResponse200DataLinks,
)
from .ge_torder_validation_rulesorder_validation_rule_id_response_200_data_relationships import (
    GETorderValidationRulesorderValidationRuleIdResponse200DataRelationships,
)
from .ge_torder_validation_rulesorder_validation_rule_id_response_200_data_relationships_market import (
    GETorderValidationRulesorderValidationRuleIdResponse200DataRelationshipsMarket,
)
from .ge_torder_validation_rulesorder_validation_rule_id_response_200_data_relationships_market_data import (
    GETorderValidationRulesorderValidationRuleIdResponse200DataRelationshipsMarketData,
)
from .ge_torder_validation_rulesorder_validation_rule_id_response_200_data_relationships_market_data_type import (
    GETorderValidationRulesorderValidationRuleIdResponse200DataRelationshipsMarketDataType,
)
from .ge_torder_validation_rulesorder_validation_rule_id_response_200_data_relationships_market_links import (
    GETorderValidationRulesorderValidationRuleIdResponse200DataRelationshipsMarketLinks,
)
from .ge_torder_validation_rulesorder_validation_rule_id_response_200_data_type import (
    GETorderValidationRulesorderValidationRuleIdResponse200DataType,
)
from .ge_torders_response_200 import GETordersResponse200
from .ge_torders_response_200_data_item import GETordersResponse200DataItem
from .ge_torders_response_200_data_item_attributes import GETordersResponse200DataItemAttributes
from .ge_torders_response_200_data_item_attributes_metadata import GETordersResponse200DataItemAttributesMetadata
from .ge_torders_response_200_data_item_attributes_payment_source_details import (
    GETordersResponse200DataItemAttributesPaymentSourceDetails,
)
from .ge_torders_response_200_data_item_links import GETordersResponse200DataItemLinks
from .ge_torders_response_200_data_item_relationships import GETordersResponse200DataItemRelationships
from .ge_torders_response_200_data_item_relationships_attachments import (
    GETordersResponse200DataItemRelationshipsAttachments,
)
from .ge_torders_response_200_data_item_relationships_attachments_data import (
    GETordersResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_torders_response_200_data_item_relationships_attachments_data_type import (
    GETordersResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_torders_response_200_data_item_relationships_attachments_links import (
    GETordersResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_torders_response_200_data_item_relationships_authorizations import (
    GETordersResponse200DataItemRelationshipsAuthorizations,
)
from .ge_torders_response_200_data_item_relationships_authorizations_data import (
    GETordersResponse200DataItemRelationshipsAuthorizationsData,
)
from .ge_torders_response_200_data_item_relationships_authorizations_data_type import (
    GETordersResponse200DataItemRelationshipsAuthorizationsDataType,
)
from .ge_torders_response_200_data_item_relationships_authorizations_links import (
    GETordersResponse200DataItemRelationshipsAuthorizationsLinks,
)
from .ge_torders_response_200_data_item_relationships_available_customer_payment_sources import (
    GETordersResponse200DataItemRelationshipsAvailableCustomerPaymentSources,
)
from .ge_torders_response_200_data_item_relationships_available_customer_payment_sources_data import (
    GETordersResponse200DataItemRelationshipsAvailableCustomerPaymentSourcesData,
)
from .ge_torders_response_200_data_item_relationships_available_customer_payment_sources_data_type import (
    GETordersResponse200DataItemRelationshipsAvailableCustomerPaymentSourcesDataType,
)
from .ge_torders_response_200_data_item_relationships_available_customer_payment_sources_links import (
    GETordersResponse200DataItemRelationshipsAvailableCustomerPaymentSourcesLinks,
)
from .ge_torders_response_200_data_item_relationships_available_free_bundles import (
    GETordersResponse200DataItemRelationshipsAvailableFreeBundles,
)
from .ge_torders_response_200_data_item_relationships_available_free_bundles_data import (
    GETordersResponse200DataItemRelationshipsAvailableFreeBundlesData,
)
from .ge_torders_response_200_data_item_relationships_available_free_bundles_data_type import (
    GETordersResponse200DataItemRelationshipsAvailableFreeBundlesDataType,
)
from .ge_torders_response_200_data_item_relationships_available_free_bundles_links import (
    GETordersResponse200DataItemRelationshipsAvailableFreeBundlesLinks,
)
from .ge_torders_response_200_data_item_relationships_available_free_skus import (
    GETordersResponse200DataItemRelationshipsAvailableFreeSkus,
)
from .ge_torders_response_200_data_item_relationships_available_free_skus_data import (
    GETordersResponse200DataItemRelationshipsAvailableFreeSkusData,
)
from .ge_torders_response_200_data_item_relationships_available_free_skus_data_type import (
    GETordersResponse200DataItemRelationshipsAvailableFreeSkusDataType,
)
from .ge_torders_response_200_data_item_relationships_available_free_skus_links import (
    GETordersResponse200DataItemRelationshipsAvailableFreeSkusLinks,
)
from .ge_torders_response_200_data_item_relationships_available_payment_methods import (
    GETordersResponse200DataItemRelationshipsAvailablePaymentMethods,
)
from .ge_torders_response_200_data_item_relationships_available_payment_methods_data import (
    GETordersResponse200DataItemRelationshipsAvailablePaymentMethodsData,
)
from .ge_torders_response_200_data_item_relationships_available_payment_methods_data_type import (
    GETordersResponse200DataItemRelationshipsAvailablePaymentMethodsDataType,
)
from .ge_torders_response_200_data_item_relationships_available_payment_methods_links import (
    GETordersResponse200DataItemRelationshipsAvailablePaymentMethodsLinks,
)
from .ge_torders_response_200_data_item_relationships_billing_address import (
    GETordersResponse200DataItemRelationshipsBillingAddress,
)
from .ge_torders_response_200_data_item_relationships_billing_address_data import (
    GETordersResponse200DataItemRelationshipsBillingAddressData,
)
from .ge_torders_response_200_data_item_relationships_billing_address_data_type import (
    GETordersResponse200DataItemRelationshipsBillingAddressDataType,
)
from .ge_torders_response_200_data_item_relationships_billing_address_links import (
    GETordersResponse200DataItemRelationshipsBillingAddressLinks,
)
from .ge_torders_response_200_data_item_relationships_captures import GETordersResponse200DataItemRelationshipsCaptures
from .ge_torders_response_200_data_item_relationships_captures_data import (
    GETordersResponse200DataItemRelationshipsCapturesData,
)
from .ge_torders_response_200_data_item_relationships_captures_data_type import (
    GETordersResponse200DataItemRelationshipsCapturesDataType,
)
from .ge_torders_response_200_data_item_relationships_captures_links import (
    GETordersResponse200DataItemRelationshipsCapturesLinks,
)
from .ge_torders_response_200_data_item_relationships_customer import GETordersResponse200DataItemRelationshipsCustomer
from .ge_torders_response_200_data_item_relationships_customer_data import (
    GETordersResponse200DataItemRelationshipsCustomerData,
)
from .ge_torders_response_200_data_item_relationships_customer_data_type import (
    GETordersResponse200DataItemRelationshipsCustomerDataType,
)
from .ge_torders_response_200_data_item_relationships_customer_links import (
    GETordersResponse200DataItemRelationshipsCustomerLinks,
)
from .ge_torders_response_200_data_item_relationships_events import GETordersResponse200DataItemRelationshipsEvents
from .ge_torders_response_200_data_item_relationships_events_data import (
    GETordersResponse200DataItemRelationshipsEventsData,
)
from .ge_torders_response_200_data_item_relationships_events_data_type import (
    GETordersResponse200DataItemRelationshipsEventsDataType,
)
from .ge_torders_response_200_data_item_relationships_events_links import (
    GETordersResponse200DataItemRelationshipsEventsLinks,
)
from .ge_torders_response_200_data_item_relationships_line_items import (
    GETordersResponse200DataItemRelationshipsLineItems,
)
from .ge_torders_response_200_data_item_relationships_line_items_data import (
    GETordersResponse200DataItemRelationshipsLineItemsData,
)
from .ge_torders_response_200_data_item_relationships_line_items_data_type import (
    GETordersResponse200DataItemRelationshipsLineItemsDataType,
)
from .ge_torders_response_200_data_item_relationships_line_items_links import (
    GETordersResponse200DataItemRelationshipsLineItemsLinks,
)
from .ge_torders_response_200_data_item_relationships_market import GETordersResponse200DataItemRelationshipsMarket
from .ge_torders_response_200_data_item_relationships_market_data import (
    GETordersResponse200DataItemRelationshipsMarketData,
)
from .ge_torders_response_200_data_item_relationships_market_data_type import (
    GETordersResponse200DataItemRelationshipsMarketDataType,
)
from .ge_torders_response_200_data_item_relationships_market_links import (
    GETordersResponse200DataItemRelationshipsMarketLinks,
)
from .ge_torders_response_200_data_item_relationships_order_copies import (
    GETordersResponse200DataItemRelationshipsOrderCopies,
)
from .ge_torders_response_200_data_item_relationships_order_copies_data import (
    GETordersResponse200DataItemRelationshipsOrderCopiesData,
)
from .ge_torders_response_200_data_item_relationships_order_copies_data_type import (
    GETordersResponse200DataItemRelationshipsOrderCopiesDataType,
)
from .ge_torders_response_200_data_item_relationships_order_copies_links import (
    GETordersResponse200DataItemRelationshipsOrderCopiesLinks,
)
from .ge_torders_response_200_data_item_relationships_order_subscriptions import (
    GETordersResponse200DataItemRelationshipsOrderSubscriptions,
)
from .ge_torders_response_200_data_item_relationships_order_subscriptions_data import (
    GETordersResponse200DataItemRelationshipsOrderSubscriptionsData,
)
from .ge_torders_response_200_data_item_relationships_order_subscriptions_data_type import (
    GETordersResponse200DataItemRelationshipsOrderSubscriptionsDataType,
)
from .ge_torders_response_200_data_item_relationships_order_subscriptions_links import (
    GETordersResponse200DataItemRelationshipsOrderSubscriptionsLinks,
)
from .ge_torders_response_200_data_item_relationships_payment_method import (
    GETordersResponse200DataItemRelationshipsPaymentMethod,
)
from .ge_torders_response_200_data_item_relationships_payment_method_data import (
    GETordersResponse200DataItemRelationshipsPaymentMethodData,
)
from .ge_torders_response_200_data_item_relationships_payment_method_data_type import (
    GETordersResponse200DataItemRelationshipsPaymentMethodDataType,
)
from .ge_torders_response_200_data_item_relationships_payment_method_links import (
    GETordersResponse200DataItemRelationshipsPaymentMethodLinks,
)
from .ge_torders_response_200_data_item_relationships_payment_source import (
    GETordersResponse200DataItemRelationshipsPaymentSource,
)
from .ge_torders_response_200_data_item_relationships_payment_source_data import (
    GETordersResponse200DataItemRelationshipsPaymentSourceData,
)
from .ge_torders_response_200_data_item_relationships_payment_source_data_type import (
    GETordersResponse200DataItemRelationshipsPaymentSourceDataType,
)
from .ge_torders_response_200_data_item_relationships_payment_source_links import (
    GETordersResponse200DataItemRelationshipsPaymentSourceLinks,
)
from .ge_torders_response_200_data_item_relationships_refunds import GETordersResponse200DataItemRelationshipsRefunds
from .ge_torders_response_200_data_item_relationships_refunds_data import (
    GETordersResponse200DataItemRelationshipsRefundsData,
)
from .ge_torders_response_200_data_item_relationships_refunds_data_type import (
    GETordersResponse200DataItemRelationshipsRefundsDataType,
)
from .ge_torders_response_200_data_item_relationships_refunds_links import (
    GETordersResponse200DataItemRelationshipsRefundsLinks,
)
from .ge_torders_response_200_data_item_relationships_shipments import (
    GETordersResponse200DataItemRelationshipsShipments,
)
from .ge_torders_response_200_data_item_relationships_shipments_data import (
    GETordersResponse200DataItemRelationshipsShipmentsData,
)
from .ge_torders_response_200_data_item_relationships_shipments_data_type import (
    GETordersResponse200DataItemRelationshipsShipmentsDataType,
)
from .ge_torders_response_200_data_item_relationships_shipments_links import (
    GETordersResponse200DataItemRelationshipsShipmentsLinks,
)
from .ge_torders_response_200_data_item_relationships_shipping_address import (
    GETordersResponse200DataItemRelationshipsShippingAddress,
)
from .ge_torders_response_200_data_item_relationships_shipping_address_data import (
    GETordersResponse200DataItemRelationshipsShippingAddressData,
)
from .ge_torders_response_200_data_item_relationships_shipping_address_data_type import (
    GETordersResponse200DataItemRelationshipsShippingAddressDataType,
)
from .ge_torders_response_200_data_item_relationships_shipping_address_links import (
    GETordersResponse200DataItemRelationshipsShippingAddressLinks,
)
from .ge_torders_response_200_data_item_relationships_transactions import (
    GETordersResponse200DataItemRelationshipsTransactions,
)
from .ge_torders_response_200_data_item_relationships_transactions_data import (
    GETordersResponse200DataItemRelationshipsTransactionsData,
)
from .ge_torders_response_200_data_item_relationships_transactions_data_type import (
    GETordersResponse200DataItemRelationshipsTransactionsDataType,
)
from .ge_torders_response_200_data_item_relationships_transactions_links import (
    GETordersResponse200DataItemRelationshipsTransactionsLinks,
)
from .ge_torders_response_200_data_item_relationships_voids import GETordersResponse200DataItemRelationshipsVoids
from .ge_torders_response_200_data_item_relationships_voids_data import (
    GETordersResponse200DataItemRelationshipsVoidsData,
)
from .ge_torders_response_200_data_item_relationships_voids_data_type import (
    GETordersResponse200DataItemRelationshipsVoidsDataType,
)
from .ge_torders_response_200_data_item_relationships_voids_links import (
    GETordersResponse200DataItemRelationshipsVoidsLinks,
)
from .ge_torders_response_200_data_item_type import GETordersResponse200DataItemType
from .ge_tordersorder_id_response_200 import GETordersorderIdResponse200
from .ge_tordersorder_id_response_200_data import GETordersorderIdResponse200Data
from .ge_tordersorder_id_response_200_data_attributes import GETordersorderIdResponse200DataAttributes
from .ge_tordersorder_id_response_200_data_attributes_metadata import GETordersorderIdResponse200DataAttributesMetadata
from .ge_tordersorder_id_response_200_data_attributes_payment_source_details import (
    GETordersorderIdResponse200DataAttributesPaymentSourceDetails,
)
from .ge_tordersorder_id_response_200_data_links import GETordersorderIdResponse200DataLinks
from .ge_tordersorder_id_response_200_data_relationships import GETordersorderIdResponse200DataRelationships
from .ge_tordersorder_id_response_200_data_relationships_attachments import (
    GETordersorderIdResponse200DataRelationshipsAttachments,
)
from .ge_tordersorder_id_response_200_data_relationships_attachments_data import (
    GETordersorderIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tordersorder_id_response_200_data_relationships_attachments_data_type import (
    GETordersorderIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tordersorder_id_response_200_data_relationships_attachments_links import (
    GETordersorderIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tordersorder_id_response_200_data_relationships_authorizations import (
    GETordersorderIdResponse200DataRelationshipsAuthorizations,
)
from .ge_tordersorder_id_response_200_data_relationships_authorizations_data import (
    GETordersorderIdResponse200DataRelationshipsAuthorizationsData,
)
from .ge_tordersorder_id_response_200_data_relationships_authorizations_data_type import (
    GETordersorderIdResponse200DataRelationshipsAuthorizationsDataType,
)
from .ge_tordersorder_id_response_200_data_relationships_authorizations_links import (
    GETordersorderIdResponse200DataRelationshipsAuthorizationsLinks,
)
from .ge_tordersorder_id_response_200_data_relationships_available_customer_payment_sources import (
    GETordersorderIdResponse200DataRelationshipsAvailableCustomerPaymentSources,
)
from .ge_tordersorder_id_response_200_data_relationships_available_customer_payment_sources_data import (
    GETordersorderIdResponse200DataRelationshipsAvailableCustomerPaymentSourcesData,
)
from .ge_tordersorder_id_response_200_data_relationships_available_customer_payment_sources_data_type import (
    GETordersorderIdResponse200DataRelationshipsAvailableCustomerPaymentSourcesDataType,
)
from .ge_tordersorder_id_response_200_data_relationships_available_customer_payment_sources_links import (
    GETordersorderIdResponse200DataRelationshipsAvailableCustomerPaymentSourcesLinks,
)
from .ge_tordersorder_id_response_200_data_relationships_available_free_bundles import (
    GETordersorderIdResponse200DataRelationshipsAvailableFreeBundles,
)
from .ge_tordersorder_id_response_200_data_relationships_available_free_bundles_data import (
    GETordersorderIdResponse200DataRelationshipsAvailableFreeBundlesData,
)
from .ge_tordersorder_id_response_200_data_relationships_available_free_bundles_data_type import (
    GETordersorderIdResponse200DataRelationshipsAvailableFreeBundlesDataType,
)
from .ge_tordersorder_id_response_200_data_relationships_available_free_bundles_links import (
    GETordersorderIdResponse200DataRelationshipsAvailableFreeBundlesLinks,
)
from .ge_tordersorder_id_response_200_data_relationships_available_free_skus import (
    GETordersorderIdResponse200DataRelationshipsAvailableFreeSkus,
)
from .ge_tordersorder_id_response_200_data_relationships_available_free_skus_data import (
    GETordersorderIdResponse200DataRelationshipsAvailableFreeSkusData,
)
from .ge_tordersorder_id_response_200_data_relationships_available_free_skus_data_type import (
    GETordersorderIdResponse200DataRelationshipsAvailableFreeSkusDataType,
)
from .ge_tordersorder_id_response_200_data_relationships_available_free_skus_links import (
    GETordersorderIdResponse200DataRelationshipsAvailableFreeSkusLinks,
)
from .ge_tordersorder_id_response_200_data_relationships_available_payment_methods import (
    GETordersorderIdResponse200DataRelationshipsAvailablePaymentMethods,
)
from .ge_tordersorder_id_response_200_data_relationships_available_payment_methods_data import (
    GETordersorderIdResponse200DataRelationshipsAvailablePaymentMethodsData,
)
from .ge_tordersorder_id_response_200_data_relationships_available_payment_methods_data_type import (
    GETordersorderIdResponse200DataRelationshipsAvailablePaymentMethodsDataType,
)
from .ge_tordersorder_id_response_200_data_relationships_available_payment_methods_links import (
    GETordersorderIdResponse200DataRelationshipsAvailablePaymentMethodsLinks,
)
from .ge_tordersorder_id_response_200_data_relationships_billing_address import (
    GETordersorderIdResponse200DataRelationshipsBillingAddress,
)
from .ge_tordersorder_id_response_200_data_relationships_billing_address_data import (
    GETordersorderIdResponse200DataRelationshipsBillingAddressData,
)
from .ge_tordersorder_id_response_200_data_relationships_billing_address_data_type import (
    GETordersorderIdResponse200DataRelationshipsBillingAddressDataType,
)
from .ge_tordersorder_id_response_200_data_relationships_billing_address_links import (
    GETordersorderIdResponse200DataRelationshipsBillingAddressLinks,
)
from .ge_tordersorder_id_response_200_data_relationships_captures import (
    GETordersorderIdResponse200DataRelationshipsCaptures,
)
from .ge_tordersorder_id_response_200_data_relationships_captures_data import (
    GETordersorderIdResponse200DataRelationshipsCapturesData,
)
from .ge_tordersorder_id_response_200_data_relationships_captures_data_type import (
    GETordersorderIdResponse200DataRelationshipsCapturesDataType,
)
from .ge_tordersorder_id_response_200_data_relationships_captures_links import (
    GETordersorderIdResponse200DataRelationshipsCapturesLinks,
)
from .ge_tordersorder_id_response_200_data_relationships_customer import (
    GETordersorderIdResponse200DataRelationshipsCustomer,
)
from .ge_tordersorder_id_response_200_data_relationships_customer_data import (
    GETordersorderIdResponse200DataRelationshipsCustomerData,
)
from .ge_tordersorder_id_response_200_data_relationships_customer_data_type import (
    GETordersorderIdResponse200DataRelationshipsCustomerDataType,
)
from .ge_tordersorder_id_response_200_data_relationships_customer_links import (
    GETordersorderIdResponse200DataRelationshipsCustomerLinks,
)
from .ge_tordersorder_id_response_200_data_relationships_events import (
    GETordersorderIdResponse200DataRelationshipsEvents,
)
from .ge_tordersorder_id_response_200_data_relationships_events_data import (
    GETordersorderIdResponse200DataRelationshipsEventsData,
)
from .ge_tordersorder_id_response_200_data_relationships_events_data_type import (
    GETordersorderIdResponse200DataRelationshipsEventsDataType,
)
from .ge_tordersorder_id_response_200_data_relationships_events_links import (
    GETordersorderIdResponse200DataRelationshipsEventsLinks,
)
from .ge_tordersorder_id_response_200_data_relationships_line_items import (
    GETordersorderIdResponse200DataRelationshipsLineItems,
)
from .ge_tordersorder_id_response_200_data_relationships_line_items_data import (
    GETordersorderIdResponse200DataRelationshipsLineItemsData,
)
from .ge_tordersorder_id_response_200_data_relationships_line_items_data_type import (
    GETordersorderIdResponse200DataRelationshipsLineItemsDataType,
)
from .ge_tordersorder_id_response_200_data_relationships_line_items_links import (
    GETordersorderIdResponse200DataRelationshipsLineItemsLinks,
)
from .ge_tordersorder_id_response_200_data_relationships_market import (
    GETordersorderIdResponse200DataRelationshipsMarket,
)
from .ge_tordersorder_id_response_200_data_relationships_market_data import (
    GETordersorderIdResponse200DataRelationshipsMarketData,
)
from .ge_tordersorder_id_response_200_data_relationships_market_data_type import (
    GETordersorderIdResponse200DataRelationshipsMarketDataType,
)
from .ge_tordersorder_id_response_200_data_relationships_market_links import (
    GETordersorderIdResponse200DataRelationshipsMarketLinks,
)
from .ge_tordersorder_id_response_200_data_relationships_order_copies import (
    GETordersorderIdResponse200DataRelationshipsOrderCopies,
)
from .ge_tordersorder_id_response_200_data_relationships_order_copies_data import (
    GETordersorderIdResponse200DataRelationshipsOrderCopiesData,
)
from .ge_tordersorder_id_response_200_data_relationships_order_copies_data_type import (
    GETordersorderIdResponse200DataRelationshipsOrderCopiesDataType,
)
from .ge_tordersorder_id_response_200_data_relationships_order_copies_links import (
    GETordersorderIdResponse200DataRelationshipsOrderCopiesLinks,
)
from .ge_tordersorder_id_response_200_data_relationships_order_subscriptions import (
    GETordersorderIdResponse200DataRelationshipsOrderSubscriptions,
)
from .ge_tordersorder_id_response_200_data_relationships_order_subscriptions_data import (
    GETordersorderIdResponse200DataRelationshipsOrderSubscriptionsData,
)
from .ge_tordersorder_id_response_200_data_relationships_order_subscriptions_data_type import (
    GETordersorderIdResponse200DataRelationshipsOrderSubscriptionsDataType,
)
from .ge_tordersorder_id_response_200_data_relationships_order_subscriptions_links import (
    GETordersorderIdResponse200DataRelationshipsOrderSubscriptionsLinks,
)
from .ge_tordersorder_id_response_200_data_relationships_payment_method import (
    GETordersorderIdResponse200DataRelationshipsPaymentMethod,
)
from .ge_tordersorder_id_response_200_data_relationships_payment_method_data import (
    GETordersorderIdResponse200DataRelationshipsPaymentMethodData,
)
from .ge_tordersorder_id_response_200_data_relationships_payment_method_data_type import (
    GETordersorderIdResponse200DataRelationshipsPaymentMethodDataType,
)
from .ge_tordersorder_id_response_200_data_relationships_payment_method_links import (
    GETordersorderIdResponse200DataRelationshipsPaymentMethodLinks,
)
from .ge_tordersorder_id_response_200_data_relationships_payment_source import (
    GETordersorderIdResponse200DataRelationshipsPaymentSource,
)
from .ge_tordersorder_id_response_200_data_relationships_payment_source_data import (
    GETordersorderIdResponse200DataRelationshipsPaymentSourceData,
)
from .ge_tordersorder_id_response_200_data_relationships_payment_source_data_type import (
    GETordersorderIdResponse200DataRelationshipsPaymentSourceDataType,
)
from .ge_tordersorder_id_response_200_data_relationships_payment_source_links import (
    GETordersorderIdResponse200DataRelationshipsPaymentSourceLinks,
)
from .ge_tordersorder_id_response_200_data_relationships_refunds import (
    GETordersorderIdResponse200DataRelationshipsRefunds,
)
from .ge_tordersorder_id_response_200_data_relationships_refunds_data import (
    GETordersorderIdResponse200DataRelationshipsRefundsData,
)
from .ge_tordersorder_id_response_200_data_relationships_refunds_data_type import (
    GETordersorderIdResponse200DataRelationshipsRefundsDataType,
)
from .ge_tordersorder_id_response_200_data_relationships_refunds_links import (
    GETordersorderIdResponse200DataRelationshipsRefundsLinks,
)
from .ge_tordersorder_id_response_200_data_relationships_shipments import (
    GETordersorderIdResponse200DataRelationshipsShipments,
)
from .ge_tordersorder_id_response_200_data_relationships_shipments_data import (
    GETordersorderIdResponse200DataRelationshipsShipmentsData,
)
from .ge_tordersorder_id_response_200_data_relationships_shipments_data_type import (
    GETordersorderIdResponse200DataRelationshipsShipmentsDataType,
)
from .ge_tordersorder_id_response_200_data_relationships_shipments_links import (
    GETordersorderIdResponse200DataRelationshipsShipmentsLinks,
)
from .ge_tordersorder_id_response_200_data_relationships_shipping_address import (
    GETordersorderIdResponse200DataRelationshipsShippingAddress,
)
from .ge_tordersorder_id_response_200_data_relationships_shipping_address_data import (
    GETordersorderIdResponse200DataRelationshipsShippingAddressData,
)
from .ge_tordersorder_id_response_200_data_relationships_shipping_address_data_type import (
    GETordersorderIdResponse200DataRelationshipsShippingAddressDataType,
)
from .ge_tordersorder_id_response_200_data_relationships_shipping_address_links import (
    GETordersorderIdResponse200DataRelationshipsShippingAddressLinks,
)
from .ge_tordersorder_id_response_200_data_relationships_transactions import (
    GETordersorderIdResponse200DataRelationshipsTransactions,
)
from .ge_tordersorder_id_response_200_data_relationships_transactions_data import (
    GETordersorderIdResponse200DataRelationshipsTransactionsData,
)
from .ge_tordersorder_id_response_200_data_relationships_transactions_data_type import (
    GETordersorderIdResponse200DataRelationshipsTransactionsDataType,
)
from .ge_tordersorder_id_response_200_data_relationships_transactions_links import (
    GETordersorderIdResponse200DataRelationshipsTransactionsLinks,
)
from .ge_tordersorder_id_response_200_data_relationships_voids import GETordersorderIdResponse200DataRelationshipsVoids
from .ge_tordersorder_id_response_200_data_relationships_voids_data import (
    GETordersorderIdResponse200DataRelationshipsVoidsData,
)
from .ge_tordersorder_id_response_200_data_relationships_voids_data_type import (
    GETordersorderIdResponse200DataRelationshipsVoidsDataType,
)
from .ge_tordersorder_id_response_200_data_relationships_voids_links import (
    GETordersorderIdResponse200DataRelationshipsVoidsLinks,
)
from .ge_tordersorder_id_response_200_data_type import GETordersorderIdResponse200DataType
from .ge_torganizationorganization_id_response_200 import GETorganizationorganizationIdResponse200
from .ge_torganizationorganization_id_response_200_data import GETorganizationorganizationIdResponse200Data
from .ge_torganizationorganization_id_response_200_data_attributes import (
    GETorganizationorganizationIdResponse200DataAttributes,
)
from .ge_torganizationorganization_id_response_200_data_attributes_metadata import (
    GETorganizationorganizationIdResponse200DataAttributesMetadata,
)
from .ge_torganizationorganization_id_response_200_data_links import GETorganizationorganizationIdResponse200DataLinks
from .ge_torganizationorganization_id_response_200_data_relationships import (
    GETorganizationorganizationIdResponse200DataRelationships,
)
from .ge_torganizationorganization_id_response_200_data_type import GETorganizationorganizationIdResponse200DataType
from .ge_tpackages_response_200 import GETpackagesResponse200
from .ge_tpackages_response_200_data_item import GETpackagesResponse200DataItem
from .ge_tpackages_response_200_data_item_attributes import GETpackagesResponse200DataItemAttributes
from .ge_tpackages_response_200_data_item_attributes_metadata import GETpackagesResponse200DataItemAttributesMetadata
from .ge_tpackages_response_200_data_item_links import GETpackagesResponse200DataItemLinks
from .ge_tpackages_response_200_data_item_relationships import GETpackagesResponse200DataItemRelationships
from .ge_tpackages_response_200_data_item_relationships_attachments import (
    GETpackagesResponse200DataItemRelationshipsAttachments,
)
from .ge_tpackages_response_200_data_item_relationships_attachments_data import (
    GETpackagesResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tpackages_response_200_data_item_relationships_attachments_data_type import (
    GETpackagesResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tpackages_response_200_data_item_relationships_attachments_links import (
    GETpackagesResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tpackages_response_200_data_item_relationships_parcels import (
    GETpackagesResponse200DataItemRelationshipsParcels,
)
from .ge_tpackages_response_200_data_item_relationships_parcels_data import (
    GETpackagesResponse200DataItemRelationshipsParcelsData,
)
from .ge_tpackages_response_200_data_item_relationships_parcels_data_type import (
    GETpackagesResponse200DataItemRelationshipsParcelsDataType,
)
from .ge_tpackages_response_200_data_item_relationships_parcels_links import (
    GETpackagesResponse200DataItemRelationshipsParcelsLinks,
)
from .ge_tpackages_response_200_data_item_relationships_stock_location import (
    GETpackagesResponse200DataItemRelationshipsStockLocation,
)
from .ge_tpackages_response_200_data_item_relationships_stock_location_data import (
    GETpackagesResponse200DataItemRelationshipsStockLocationData,
)
from .ge_tpackages_response_200_data_item_relationships_stock_location_data_type import (
    GETpackagesResponse200DataItemRelationshipsStockLocationDataType,
)
from .ge_tpackages_response_200_data_item_relationships_stock_location_links import (
    GETpackagesResponse200DataItemRelationshipsStockLocationLinks,
)
from .ge_tpackages_response_200_data_item_type import GETpackagesResponse200DataItemType
from .ge_tpackagespackage_id_response_200 import GETpackagespackageIdResponse200
from .ge_tpackagespackage_id_response_200_data import GETpackagespackageIdResponse200Data
from .ge_tpackagespackage_id_response_200_data_attributes import GETpackagespackageIdResponse200DataAttributes
from .ge_tpackagespackage_id_response_200_data_attributes_metadata import (
    GETpackagespackageIdResponse200DataAttributesMetadata,
)
from .ge_tpackagespackage_id_response_200_data_links import GETpackagespackageIdResponse200DataLinks
from .ge_tpackagespackage_id_response_200_data_relationships import GETpackagespackageIdResponse200DataRelationships
from .ge_tpackagespackage_id_response_200_data_relationships_attachments import (
    GETpackagespackageIdResponse200DataRelationshipsAttachments,
)
from .ge_tpackagespackage_id_response_200_data_relationships_attachments_data import (
    GETpackagespackageIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tpackagespackage_id_response_200_data_relationships_attachments_data_type import (
    GETpackagespackageIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tpackagespackage_id_response_200_data_relationships_attachments_links import (
    GETpackagespackageIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tpackagespackage_id_response_200_data_relationships_parcels import (
    GETpackagespackageIdResponse200DataRelationshipsParcels,
)
from .ge_tpackagespackage_id_response_200_data_relationships_parcels_data import (
    GETpackagespackageIdResponse200DataRelationshipsParcelsData,
)
from .ge_tpackagespackage_id_response_200_data_relationships_parcels_data_type import (
    GETpackagespackageIdResponse200DataRelationshipsParcelsDataType,
)
from .ge_tpackagespackage_id_response_200_data_relationships_parcels_links import (
    GETpackagespackageIdResponse200DataRelationshipsParcelsLinks,
)
from .ge_tpackagespackage_id_response_200_data_relationships_stock_location import (
    GETpackagespackageIdResponse200DataRelationshipsStockLocation,
)
from .ge_tpackagespackage_id_response_200_data_relationships_stock_location_data import (
    GETpackagespackageIdResponse200DataRelationshipsStockLocationData,
)
from .ge_tpackagespackage_id_response_200_data_relationships_stock_location_data_type import (
    GETpackagespackageIdResponse200DataRelationshipsStockLocationDataType,
)
from .ge_tpackagespackage_id_response_200_data_relationships_stock_location_links import (
    GETpackagespackageIdResponse200DataRelationshipsStockLocationLinks,
)
from .ge_tpackagespackage_id_response_200_data_type import GETpackagespackageIdResponse200DataType
from .ge_tparcel_line_items_response_200 import GETparcelLineItemsResponse200
from .ge_tparcel_line_items_response_200_data_item import GETparcelLineItemsResponse200DataItem
from .ge_tparcel_line_items_response_200_data_item_attributes import GETparcelLineItemsResponse200DataItemAttributes
from .ge_tparcel_line_items_response_200_data_item_attributes_metadata import (
    GETparcelLineItemsResponse200DataItemAttributesMetadata,
)
from .ge_tparcel_line_items_response_200_data_item_links import GETparcelLineItemsResponse200DataItemLinks
from .ge_tparcel_line_items_response_200_data_item_relationships import (
    GETparcelLineItemsResponse200DataItemRelationships,
)
from .ge_tparcel_line_items_response_200_data_item_relationships_parcel import (
    GETparcelLineItemsResponse200DataItemRelationshipsParcel,
)
from .ge_tparcel_line_items_response_200_data_item_relationships_parcel_data import (
    GETparcelLineItemsResponse200DataItemRelationshipsParcelData,
)
from .ge_tparcel_line_items_response_200_data_item_relationships_parcel_data_type import (
    GETparcelLineItemsResponse200DataItemRelationshipsParcelDataType,
)
from .ge_tparcel_line_items_response_200_data_item_relationships_parcel_links import (
    GETparcelLineItemsResponse200DataItemRelationshipsParcelLinks,
)
from .ge_tparcel_line_items_response_200_data_item_relationships_shipment_line_item import (
    GETparcelLineItemsResponse200DataItemRelationshipsShipmentLineItem,
)
from .ge_tparcel_line_items_response_200_data_item_relationships_shipment_line_item_data import (
    GETparcelLineItemsResponse200DataItemRelationshipsShipmentLineItemData,
)
from .ge_tparcel_line_items_response_200_data_item_relationships_shipment_line_item_data_type import (
    GETparcelLineItemsResponse200DataItemRelationshipsShipmentLineItemDataType,
)
from .ge_tparcel_line_items_response_200_data_item_relationships_shipment_line_item_links import (
    GETparcelLineItemsResponse200DataItemRelationshipsShipmentLineItemLinks,
)
from .ge_tparcel_line_items_response_200_data_item_relationships_stock_line_item import (
    GETparcelLineItemsResponse200DataItemRelationshipsStockLineItem,
)
from .ge_tparcel_line_items_response_200_data_item_relationships_stock_line_item_data import (
    GETparcelLineItemsResponse200DataItemRelationshipsStockLineItemData,
)
from .ge_tparcel_line_items_response_200_data_item_relationships_stock_line_item_data_type import (
    GETparcelLineItemsResponse200DataItemRelationshipsStockLineItemDataType,
)
from .ge_tparcel_line_items_response_200_data_item_relationships_stock_line_item_links import (
    GETparcelLineItemsResponse200DataItemRelationshipsStockLineItemLinks,
)
from .ge_tparcel_line_items_response_200_data_item_type import GETparcelLineItemsResponse200DataItemType
from .ge_tparcel_line_itemsparcel_line_item_id_response_200 import GETparcelLineItemsparcelLineItemIdResponse200
from .ge_tparcel_line_itemsparcel_line_item_id_response_200_data import (
    GETparcelLineItemsparcelLineItemIdResponse200Data,
)
from .ge_tparcel_line_itemsparcel_line_item_id_response_200_data_attributes import (
    GETparcelLineItemsparcelLineItemIdResponse200DataAttributes,
)
from .ge_tparcel_line_itemsparcel_line_item_id_response_200_data_attributes_metadata import (
    GETparcelLineItemsparcelLineItemIdResponse200DataAttributesMetadata,
)
from .ge_tparcel_line_itemsparcel_line_item_id_response_200_data_links import (
    GETparcelLineItemsparcelLineItemIdResponse200DataLinks,
)
from .ge_tparcel_line_itemsparcel_line_item_id_response_200_data_relationships import (
    GETparcelLineItemsparcelLineItemIdResponse200DataRelationships,
)
from .ge_tparcel_line_itemsparcel_line_item_id_response_200_data_relationships_parcel import (
    GETparcelLineItemsparcelLineItemIdResponse200DataRelationshipsParcel,
)
from .ge_tparcel_line_itemsparcel_line_item_id_response_200_data_relationships_parcel_data import (
    GETparcelLineItemsparcelLineItemIdResponse200DataRelationshipsParcelData,
)
from .ge_tparcel_line_itemsparcel_line_item_id_response_200_data_relationships_parcel_data_type import (
    GETparcelLineItemsparcelLineItemIdResponse200DataRelationshipsParcelDataType,
)
from .ge_tparcel_line_itemsparcel_line_item_id_response_200_data_relationships_parcel_links import (
    GETparcelLineItemsparcelLineItemIdResponse200DataRelationshipsParcelLinks,
)
from .ge_tparcel_line_itemsparcel_line_item_id_response_200_data_relationships_shipment_line_item import (
    GETparcelLineItemsparcelLineItemIdResponse200DataRelationshipsShipmentLineItem,
)
from .ge_tparcel_line_itemsparcel_line_item_id_response_200_data_relationships_shipment_line_item_data import (
    GETparcelLineItemsparcelLineItemIdResponse200DataRelationshipsShipmentLineItemData,
)
from .ge_tparcel_line_itemsparcel_line_item_id_response_200_data_relationships_shipment_line_item_data_type import (
    GETparcelLineItemsparcelLineItemIdResponse200DataRelationshipsShipmentLineItemDataType,
)
from .ge_tparcel_line_itemsparcel_line_item_id_response_200_data_relationships_shipment_line_item_links import (
    GETparcelLineItemsparcelLineItemIdResponse200DataRelationshipsShipmentLineItemLinks,
)
from .ge_tparcel_line_itemsparcel_line_item_id_response_200_data_relationships_stock_line_item import (
    GETparcelLineItemsparcelLineItemIdResponse200DataRelationshipsStockLineItem,
)
from .ge_tparcel_line_itemsparcel_line_item_id_response_200_data_relationships_stock_line_item_data import (
    GETparcelLineItemsparcelLineItemIdResponse200DataRelationshipsStockLineItemData,
)
from .ge_tparcel_line_itemsparcel_line_item_id_response_200_data_relationships_stock_line_item_data_type import (
    GETparcelLineItemsparcelLineItemIdResponse200DataRelationshipsStockLineItemDataType,
)
from .ge_tparcel_line_itemsparcel_line_item_id_response_200_data_relationships_stock_line_item_links import (
    GETparcelLineItemsparcelLineItemIdResponse200DataRelationshipsStockLineItemLinks,
)
from .ge_tparcel_line_itemsparcel_line_item_id_response_200_data_type import (
    GETparcelLineItemsparcelLineItemIdResponse200DataType,
)
from .ge_tparcels_response_200 import GETparcelsResponse200
from .ge_tparcels_response_200_data_item import GETparcelsResponse200DataItem
from .ge_tparcels_response_200_data_item_attributes import GETparcelsResponse200DataItemAttributes
from .ge_tparcels_response_200_data_item_attributes_metadata import GETparcelsResponse200DataItemAttributesMetadata
from .ge_tparcels_response_200_data_item_links import GETparcelsResponse200DataItemLinks
from .ge_tparcels_response_200_data_item_relationships import GETparcelsResponse200DataItemRelationships
from .ge_tparcels_response_200_data_item_relationships_attachments import (
    GETparcelsResponse200DataItemRelationshipsAttachments,
)
from .ge_tparcels_response_200_data_item_relationships_attachments_data import (
    GETparcelsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tparcels_response_200_data_item_relationships_attachments_data_type import (
    GETparcelsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tparcels_response_200_data_item_relationships_attachments_links import (
    GETparcelsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tparcels_response_200_data_item_relationships_events import GETparcelsResponse200DataItemRelationshipsEvents
from .ge_tparcels_response_200_data_item_relationships_events_data import (
    GETparcelsResponse200DataItemRelationshipsEventsData,
)
from .ge_tparcels_response_200_data_item_relationships_events_data_type import (
    GETparcelsResponse200DataItemRelationshipsEventsDataType,
)
from .ge_tparcels_response_200_data_item_relationships_events_links import (
    GETparcelsResponse200DataItemRelationshipsEventsLinks,
)
from .ge_tparcels_response_200_data_item_relationships_package import GETparcelsResponse200DataItemRelationshipsPackage
from .ge_tparcels_response_200_data_item_relationships_package_data import (
    GETparcelsResponse200DataItemRelationshipsPackageData,
)
from .ge_tparcels_response_200_data_item_relationships_package_data_type import (
    GETparcelsResponse200DataItemRelationshipsPackageDataType,
)
from .ge_tparcels_response_200_data_item_relationships_package_links import (
    GETparcelsResponse200DataItemRelationshipsPackageLinks,
)
from .ge_tparcels_response_200_data_item_relationships_parcel_line_items import (
    GETparcelsResponse200DataItemRelationshipsParcelLineItems,
)
from .ge_tparcels_response_200_data_item_relationships_parcel_line_items_data import (
    GETparcelsResponse200DataItemRelationshipsParcelLineItemsData,
)
from .ge_tparcels_response_200_data_item_relationships_parcel_line_items_data_type import (
    GETparcelsResponse200DataItemRelationshipsParcelLineItemsDataType,
)
from .ge_tparcels_response_200_data_item_relationships_parcel_line_items_links import (
    GETparcelsResponse200DataItemRelationshipsParcelLineItemsLinks,
)
from .ge_tparcels_response_200_data_item_relationships_shipment import (
    GETparcelsResponse200DataItemRelationshipsShipment,
)
from .ge_tparcels_response_200_data_item_relationships_shipment_data import (
    GETparcelsResponse200DataItemRelationshipsShipmentData,
)
from .ge_tparcels_response_200_data_item_relationships_shipment_data_type import (
    GETparcelsResponse200DataItemRelationshipsShipmentDataType,
)
from .ge_tparcels_response_200_data_item_relationships_shipment_links import (
    GETparcelsResponse200DataItemRelationshipsShipmentLinks,
)
from .ge_tparcels_response_200_data_item_type import GETparcelsResponse200DataItemType
from .ge_tparcelsparcel_id_response_200 import GETparcelsparcelIdResponse200
from .ge_tparcelsparcel_id_response_200_data import GETparcelsparcelIdResponse200Data
from .ge_tparcelsparcel_id_response_200_data_attributes import GETparcelsparcelIdResponse200DataAttributes
from .ge_tparcelsparcel_id_response_200_data_attributes_metadata import (
    GETparcelsparcelIdResponse200DataAttributesMetadata,
)
from .ge_tparcelsparcel_id_response_200_data_links import GETparcelsparcelIdResponse200DataLinks
from .ge_tparcelsparcel_id_response_200_data_relationships import GETparcelsparcelIdResponse200DataRelationships
from .ge_tparcelsparcel_id_response_200_data_relationships_attachments import (
    GETparcelsparcelIdResponse200DataRelationshipsAttachments,
)
from .ge_tparcelsparcel_id_response_200_data_relationships_attachments_data import (
    GETparcelsparcelIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tparcelsparcel_id_response_200_data_relationships_attachments_data_type import (
    GETparcelsparcelIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tparcelsparcel_id_response_200_data_relationships_attachments_links import (
    GETparcelsparcelIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tparcelsparcel_id_response_200_data_relationships_events import (
    GETparcelsparcelIdResponse200DataRelationshipsEvents,
)
from .ge_tparcelsparcel_id_response_200_data_relationships_events_data import (
    GETparcelsparcelIdResponse200DataRelationshipsEventsData,
)
from .ge_tparcelsparcel_id_response_200_data_relationships_events_data_type import (
    GETparcelsparcelIdResponse200DataRelationshipsEventsDataType,
)
from .ge_tparcelsparcel_id_response_200_data_relationships_events_links import (
    GETparcelsparcelIdResponse200DataRelationshipsEventsLinks,
)
from .ge_tparcelsparcel_id_response_200_data_relationships_package import (
    GETparcelsparcelIdResponse200DataRelationshipsPackage,
)
from .ge_tparcelsparcel_id_response_200_data_relationships_package_data import (
    GETparcelsparcelIdResponse200DataRelationshipsPackageData,
)
from .ge_tparcelsparcel_id_response_200_data_relationships_package_data_type import (
    GETparcelsparcelIdResponse200DataRelationshipsPackageDataType,
)
from .ge_tparcelsparcel_id_response_200_data_relationships_package_links import (
    GETparcelsparcelIdResponse200DataRelationshipsPackageLinks,
)
from .ge_tparcelsparcel_id_response_200_data_relationships_parcel_line_items import (
    GETparcelsparcelIdResponse200DataRelationshipsParcelLineItems,
)
from .ge_tparcelsparcel_id_response_200_data_relationships_parcel_line_items_data import (
    GETparcelsparcelIdResponse200DataRelationshipsParcelLineItemsData,
)
from .ge_tparcelsparcel_id_response_200_data_relationships_parcel_line_items_data_type import (
    GETparcelsparcelIdResponse200DataRelationshipsParcelLineItemsDataType,
)
from .ge_tparcelsparcel_id_response_200_data_relationships_parcel_line_items_links import (
    GETparcelsparcelIdResponse200DataRelationshipsParcelLineItemsLinks,
)
from .ge_tparcelsparcel_id_response_200_data_relationships_shipment import (
    GETparcelsparcelIdResponse200DataRelationshipsShipment,
)
from .ge_tparcelsparcel_id_response_200_data_relationships_shipment_data import (
    GETparcelsparcelIdResponse200DataRelationshipsShipmentData,
)
from .ge_tparcelsparcel_id_response_200_data_relationships_shipment_data_type import (
    GETparcelsparcelIdResponse200DataRelationshipsShipmentDataType,
)
from .ge_tparcelsparcel_id_response_200_data_relationships_shipment_links import (
    GETparcelsparcelIdResponse200DataRelationshipsShipmentLinks,
)
from .ge_tparcelsparcel_id_response_200_data_type import GETparcelsparcelIdResponse200DataType
from .ge_tpayment_gateways_response_200 import GETpaymentGatewaysResponse200
from .ge_tpayment_gateways_response_200_data_item import GETpaymentGatewaysResponse200DataItem
from .ge_tpayment_gateways_response_200_data_item_attributes import GETpaymentGatewaysResponse200DataItemAttributes
from .ge_tpayment_gateways_response_200_data_item_attributes_metadata import (
    GETpaymentGatewaysResponse200DataItemAttributesMetadata,
)
from .ge_tpayment_gateways_response_200_data_item_links import GETpaymentGatewaysResponse200DataItemLinks
from .ge_tpayment_gateways_response_200_data_item_relationships import (
    GETpaymentGatewaysResponse200DataItemRelationships,
)
from .ge_tpayment_gateways_response_200_data_item_relationships_payment_methods import (
    GETpaymentGatewaysResponse200DataItemRelationshipsPaymentMethods,
)
from .ge_tpayment_gateways_response_200_data_item_relationships_payment_methods_data import (
    GETpaymentGatewaysResponse200DataItemRelationshipsPaymentMethodsData,
)
from .ge_tpayment_gateways_response_200_data_item_relationships_payment_methods_data_type import (
    GETpaymentGatewaysResponse200DataItemRelationshipsPaymentMethodsDataType,
)
from .ge_tpayment_gateways_response_200_data_item_relationships_payment_methods_links import (
    GETpaymentGatewaysResponse200DataItemRelationshipsPaymentMethodsLinks,
)
from .ge_tpayment_gateways_response_200_data_item_type import GETpaymentGatewaysResponse200DataItemType
from .ge_tpayment_gatewayspayment_gateway_id_response_200 import GETpaymentGatewayspaymentGatewayIdResponse200
from .ge_tpayment_gatewayspayment_gateway_id_response_200_data import GETpaymentGatewayspaymentGatewayIdResponse200Data
from .ge_tpayment_gatewayspayment_gateway_id_response_200_data_attributes import (
    GETpaymentGatewayspaymentGatewayIdResponse200DataAttributes,
)
from .ge_tpayment_gatewayspayment_gateway_id_response_200_data_attributes_metadata import (
    GETpaymentGatewayspaymentGatewayIdResponse200DataAttributesMetadata,
)
from .ge_tpayment_gatewayspayment_gateway_id_response_200_data_links import (
    GETpaymentGatewayspaymentGatewayIdResponse200DataLinks,
)
from .ge_tpayment_gatewayspayment_gateway_id_response_200_data_relationships import (
    GETpaymentGatewayspaymentGatewayIdResponse200DataRelationships,
)
from .ge_tpayment_gatewayspayment_gateway_id_response_200_data_relationships_payment_methods import (
    GETpaymentGatewayspaymentGatewayIdResponse200DataRelationshipsPaymentMethods,
)
from .ge_tpayment_gatewayspayment_gateway_id_response_200_data_relationships_payment_methods_data import (
    GETpaymentGatewayspaymentGatewayIdResponse200DataRelationshipsPaymentMethodsData,
)
from .ge_tpayment_gatewayspayment_gateway_id_response_200_data_relationships_payment_methods_data_type import (
    GETpaymentGatewayspaymentGatewayIdResponse200DataRelationshipsPaymentMethodsDataType,
)
from .ge_tpayment_gatewayspayment_gateway_id_response_200_data_relationships_payment_methods_links import (
    GETpaymentGatewayspaymentGatewayIdResponse200DataRelationshipsPaymentMethodsLinks,
)
from .ge_tpayment_gatewayspayment_gateway_id_response_200_data_type import (
    GETpaymentGatewayspaymentGatewayIdResponse200DataType,
)
from .ge_tpayment_methods_response_200 import GETpaymentMethodsResponse200
from .ge_tpayment_methods_response_200_data_item import GETpaymentMethodsResponse200DataItem
from .ge_tpayment_methods_response_200_data_item_attributes import GETpaymentMethodsResponse200DataItemAttributes
from .ge_tpayment_methods_response_200_data_item_attributes_metadata import (
    GETpaymentMethodsResponse200DataItemAttributesMetadata,
)
from .ge_tpayment_methods_response_200_data_item_links import GETpaymentMethodsResponse200DataItemLinks
from .ge_tpayment_methods_response_200_data_item_relationships import GETpaymentMethodsResponse200DataItemRelationships
from .ge_tpayment_methods_response_200_data_item_relationships_attachments import (
    GETpaymentMethodsResponse200DataItemRelationshipsAttachments,
)
from .ge_tpayment_methods_response_200_data_item_relationships_attachments_data import (
    GETpaymentMethodsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tpayment_methods_response_200_data_item_relationships_attachments_data_type import (
    GETpaymentMethodsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tpayment_methods_response_200_data_item_relationships_attachments_links import (
    GETpaymentMethodsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tpayment_methods_response_200_data_item_relationships_market import (
    GETpaymentMethodsResponse200DataItemRelationshipsMarket,
)
from .ge_tpayment_methods_response_200_data_item_relationships_market_data import (
    GETpaymentMethodsResponse200DataItemRelationshipsMarketData,
)
from .ge_tpayment_methods_response_200_data_item_relationships_market_data_type import (
    GETpaymentMethodsResponse200DataItemRelationshipsMarketDataType,
)
from .ge_tpayment_methods_response_200_data_item_relationships_market_links import (
    GETpaymentMethodsResponse200DataItemRelationshipsMarketLinks,
)
from .ge_tpayment_methods_response_200_data_item_relationships_payment_gateway import (
    GETpaymentMethodsResponse200DataItemRelationshipsPaymentGateway,
)
from .ge_tpayment_methods_response_200_data_item_relationships_payment_gateway_data import (
    GETpaymentMethodsResponse200DataItemRelationshipsPaymentGatewayData,
)
from .ge_tpayment_methods_response_200_data_item_relationships_payment_gateway_data_type import (
    GETpaymentMethodsResponse200DataItemRelationshipsPaymentGatewayDataType,
)
from .ge_tpayment_methods_response_200_data_item_relationships_payment_gateway_links import (
    GETpaymentMethodsResponse200DataItemRelationshipsPaymentGatewayLinks,
)
from .ge_tpayment_methods_response_200_data_item_type import GETpaymentMethodsResponse200DataItemType
from .ge_tpayment_methodspayment_method_id_response_200 import GETpaymentMethodspaymentMethodIdResponse200
from .ge_tpayment_methodspayment_method_id_response_200_data import GETpaymentMethodspaymentMethodIdResponse200Data
from .ge_tpayment_methodspayment_method_id_response_200_data_attributes import (
    GETpaymentMethodspaymentMethodIdResponse200DataAttributes,
)
from .ge_tpayment_methodspayment_method_id_response_200_data_attributes_metadata import (
    GETpaymentMethodspaymentMethodIdResponse200DataAttributesMetadata,
)
from .ge_tpayment_methodspayment_method_id_response_200_data_links import (
    GETpaymentMethodspaymentMethodIdResponse200DataLinks,
)
from .ge_tpayment_methodspayment_method_id_response_200_data_relationships import (
    GETpaymentMethodspaymentMethodIdResponse200DataRelationships,
)
from .ge_tpayment_methodspayment_method_id_response_200_data_relationships_attachments import (
    GETpaymentMethodspaymentMethodIdResponse200DataRelationshipsAttachments,
)
from .ge_tpayment_methodspayment_method_id_response_200_data_relationships_attachments_data import (
    GETpaymentMethodspaymentMethodIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tpayment_methodspayment_method_id_response_200_data_relationships_attachments_data_type import (
    GETpaymentMethodspaymentMethodIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tpayment_methodspayment_method_id_response_200_data_relationships_attachments_links import (
    GETpaymentMethodspaymentMethodIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tpayment_methodspayment_method_id_response_200_data_relationships_market import (
    GETpaymentMethodspaymentMethodIdResponse200DataRelationshipsMarket,
)
from .ge_tpayment_methodspayment_method_id_response_200_data_relationships_market_data import (
    GETpaymentMethodspaymentMethodIdResponse200DataRelationshipsMarketData,
)
from .ge_tpayment_methodspayment_method_id_response_200_data_relationships_market_data_type import (
    GETpaymentMethodspaymentMethodIdResponse200DataRelationshipsMarketDataType,
)
from .ge_tpayment_methodspayment_method_id_response_200_data_relationships_market_links import (
    GETpaymentMethodspaymentMethodIdResponse200DataRelationshipsMarketLinks,
)
from .ge_tpayment_methodspayment_method_id_response_200_data_relationships_payment_gateway import (
    GETpaymentMethodspaymentMethodIdResponse200DataRelationshipsPaymentGateway,
)
from .ge_tpayment_methodspayment_method_id_response_200_data_relationships_payment_gateway_data import (
    GETpaymentMethodspaymentMethodIdResponse200DataRelationshipsPaymentGatewayData,
)
from .ge_tpayment_methodspayment_method_id_response_200_data_relationships_payment_gateway_data_type import (
    GETpaymentMethodspaymentMethodIdResponse200DataRelationshipsPaymentGatewayDataType,
)
from .ge_tpayment_methodspayment_method_id_response_200_data_relationships_payment_gateway_links import (
    GETpaymentMethodspaymentMethodIdResponse200DataRelationshipsPaymentGatewayLinks,
)
from .ge_tpayment_methodspayment_method_id_response_200_data_type import (
    GETpaymentMethodspaymentMethodIdResponse200DataType,
)
from .ge_tpaypal_gateways_response_200 import GETpaypalGatewaysResponse200
from .ge_tpaypal_gateways_response_200_data_item import GETpaypalGatewaysResponse200DataItem
from .ge_tpaypal_gateways_response_200_data_item_attributes import GETpaypalGatewaysResponse200DataItemAttributes
from .ge_tpaypal_gateways_response_200_data_item_attributes_metadata import (
    GETpaypalGatewaysResponse200DataItemAttributesMetadata,
)
from .ge_tpaypal_gateways_response_200_data_item_links import GETpaypalGatewaysResponse200DataItemLinks
from .ge_tpaypal_gateways_response_200_data_item_relationships import GETpaypalGatewaysResponse200DataItemRelationships
from .ge_tpaypal_gateways_response_200_data_item_relationships_payment_methods import (
    GETpaypalGatewaysResponse200DataItemRelationshipsPaymentMethods,
)
from .ge_tpaypal_gateways_response_200_data_item_relationships_payment_methods_data import (
    GETpaypalGatewaysResponse200DataItemRelationshipsPaymentMethodsData,
)
from .ge_tpaypal_gateways_response_200_data_item_relationships_payment_methods_data_type import (
    GETpaypalGatewaysResponse200DataItemRelationshipsPaymentMethodsDataType,
)
from .ge_tpaypal_gateways_response_200_data_item_relationships_payment_methods_links import (
    GETpaypalGatewaysResponse200DataItemRelationshipsPaymentMethodsLinks,
)
from .ge_tpaypal_gateways_response_200_data_item_relationships_paypal_payments import (
    GETpaypalGatewaysResponse200DataItemRelationshipsPaypalPayments,
)
from .ge_tpaypal_gateways_response_200_data_item_relationships_paypal_payments_data import (
    GETpaypalGatewaysResponse200DataItemRelationshipsPaypalPaymentsData,
)
from .ge_tpaypal_gateways_response_200_data_item_relationships_paypal_payments_data_type import (
    GETpaypalGatewaysResponse200DataItemRelationshipsPaypalPaymentsDataType,
)
from .ge_tpaypal_gateways_response_200_data_item_relationships_paypal_payments_links import (
    GETpaypalGatewaysResponse200DataItemRelationshipsPaypalPaymentsLinks,
)
from .ge_tpaypal_gateways_response_200_data_item_type import GETpaypalGatewaysResponse200DataItemType
from .ge_tpaypal_gatewayspaypal_gateway_id_response_200 import GETpaypalGatewayspaypalGatewayIdResponse200
from .ge_tpaypal_gatewayspaypal_gateway_id_response_200_data import GETpaypalGatewayspaypalGatewayIdResponse200Data
from .ge_tpaypal_gatewayspaypal_gateway_id_response_200_data_attributes import (
    GETpaypalGatewayspaypalGatewayIdResponse200DataAttributes,
)
from .ge_tpaypal_gatewayspaypal_gateway_id_response_200_data_attributes_metadata import (
    GETpaypalGatewayspaypalGatewayIdResponse200DataAttributesMetadata,
)
from .ge_tpaypal_gatewayspaypal_gateway_id_response_200_data_links import (
    GETpaypalGatewayspaypalGatewayIdResponse200DataLinks,
)
from .ge_tpaypal_gatewayspaypal_gateway_id_response_200_data_relationships import (
    GETpaypalGatewayspaypalGatewayIdResponse200DataRelationships,
)
from .ge_tpaypal_gatewayspaypal_gateway_id_response_200_data_relationships_payment_methods import (
    GETpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaymentMethods,
)
from .ge_tpaypal_gatewayspaypal_gateway_id_response_200_data_relationships_payment_methods_data import (
    GETpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaymentMethodsData,
)
from .ge_tpaypal_gatewayspaypal_gateway_id_response_200_data_relationships_payment_methods_data_type import (
    GETpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaymentMethodsDataType,
)
from .ge_tpaypal_gatewayspaypal_gateway_id_response_200_data_relationships_payment_methods_links import (
    GETpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaymentMethodsLinks,
)
from .ge_tpaypal_gatewayspaypal_gateway_id_response_200_data_relationships_paypal_payments import (
    GETpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaypalPayments,
)
from .ge_tpaypal_gatewayspaypal_gateway_id_response_200_data_relationships_paypal_payments_data import (
    GETpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaypalPaymentsData,
)
from .ge_tpaypal_gatewayspaypal_gateway_id_response_200_data_relationships_paypal_payments_data_type import (
    GETpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaypalPaymentsDataType,
)
from .ge_tpaypal_gatewayspaypal_gateway_id_response_200_data_relationships_paypal_payments_links import (
    GETpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaypalPaymentsLinks,
)
from .ge_tpaypal_gatewayspaypal_gateway_id_response_200_data_type import (
    GETpaypalGatewayspaypalGatewayIdResponse200DataType,
)
from .ge_tpaypal_payments_response_200 import GETpaypalPaymentsResponse200
from .ge_tpaypal_payments_response_200_data_item import GETpaypalPaymentsResponse200DataItem
from .ge_tpaypal_payments_response_200_data_item_attributes import GETpaypalPaymentsResponse200DataItemAttributes
from .ge_tpaypal_payments_response_200_data_item_attributes_metadata import (
    GETpaypalPaymentsResponse200DataItemAttributesMetadata,
)
from .ge_tpaypal_payments_response_200_data_item_links import GETpaypalPaymentsResponse200DataItemLinks
from .ge_tpaypal_payments_response_200_data_item_relationships import GETpaypalPaymentsResponse200DataItemRelationships
from .ge_tpaypal_payments_response_200_data_item_relationships_order import (
    GETpaypalPaymentsResponse200DataItemRelationshipsOrder,
)
from .ge_tpaypal_payments_response_200_data_item_relationships_order_data import (
    GETpaypalPaymentsResponse200DataItemRelationshipsOrderData,
)
from .ge_tpaypal_payments_response_200_data_item_relationships_order_data_type import (
    GETpaypalPaymentsResponse200DataItemRelationshipsOrderDataType,
)
from .ge_tpaypal_payments_response_200_data_item_relationships_order_links import (
    GETpaypalPaymentsResponse200DataItemRelationshipsOrderLinks,
)
from .ge_tpaypal_payments_response_200_data_item_relationships_payment_gateway import (
    GETpaypalPaymentsResponse200DataItemRelationshipsPaymentGateway,
)
from .ge_tpaypal_payments_response_200_data_item_relationships_payment_gateway_data import (
    GETpaypalPaymentsResponse200DataItemRelationshipsPaymentGatewayData,
)
from .ge_tpaypal_payments_response_200_data_item_relationships_payment_gateway_data_type import (
    GETpaypalPaymentsResponse200DataItemRelationshipsPaymentGatewayDataType,
)
from .ge_tpaypal_payments_response_200_data_item_relationships_payment_gateway_links import (
    GETpaypalPaymentsResponse200DataItemRelationshipsPaymentGatewayLinks,
)
from .ge_tpaypal_payments_response_200_data_item_type import GETpaypalPaymentsResponse200DataItemType
from .ge_tpaypal_paymentspaypal_payment_id_response_200 import GETpaypalPaymentspaypalPaymentIdResponse200
from .ge_tpaypal_paymentspaypal_payment_id_response_200_data import GETpaypalPaymentspaypalPaymentIdResponse200Data
from .ge_tpaypal_paymentspaypal_payment_id_response_200_data_attributes import (
    GETpaypalPaymentspaypalPaymentIdResponse200DataAttributes,
)
from .ge_tpaypal_paymentspaypal_payment_id_response_200_data_attributes_metadata import (
    GETpaypalPaymentspaypalPaymentIdResponse200DataAttributesMetadata,
)
from .ge_tpaypal_paymentspaypal_payment_id_response_200_data_links import (
    GETpaypalPaymentspaypalPaymentIdResponse200DataLinks,
)
from .ge_tpaypal_paymentspaypal_payment_id_response_200_data_relationships import (
    GETpaypalPaymentspaypalPaymentIdResponse200DataRelationships,
)
from .ge_tpaypal_paymentspaypal_payment_id_response_200_data_relationships_order import (
    GETpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsOrder,
)
from .ge_tpaypal_paymentspaypal_payment_id_response_200_data_relationships_order_data import (
    GETpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsOrderData,
)
from .ge_tpaypal_paymentspaypal_payment_id_response_200_data_relationships_order_data_type import (
    GETpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsOrderDataType,
)
from .ge_tpaypal_paymentspaypal_payment_id_response_200_data_relationships_order_links import (
    GETpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsOrderLinks,
)
from .ge_tpaypal_paymentspaypal_payment_id_response_200_data_relationships_payment_gateway import (
    GETpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsPaymentGateway,
)
from .ge_tpaypal_paymentspaypal_payment_id_response_200_data_relationships_payment_gateway_data import (
    GETpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsPaymentGatewayData,
)
from .ge_tpaypal_paymentspaypal_payment_id_response_200_data_relationships_payment_gateway_data_type import (
    GETpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsPaymentGatewayDataType,
)
from .ge_tpaypal_paymentspaypal_payment_id_response_200_data_relationships_payment_gateway_links import (
    GETpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsPaymentGatewayLinks,
)
from .ge_tpaypal_paymentspaypal_payment_id_response_200_data_type import (
    GETpaypalPaymentspaypalPaymentIdResponse200DataType,
)
from .ge_tpercentage_discount_promotions_response_200 import GETpercentageDiscountPromotionsResponse200
from .ge_tpercentage_discount_promotions_response_200_data_item import (
    GETpercentageDiscountPromotionsResponse200DataItem,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_attributes import (
    GETpercentageDiscountPromotionsResponse200DataItemAttributes,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_attributes_metadata import (
    GETpercentageDiscountPromotionsResponse200DataItemAttributesMetadata,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_links import (
    GETpercentageDiscountPromotionsResponse200DataItemLinks,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationships,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_attachments import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsAttachments,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_attachments_data import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_attachments_data_type import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_attachments_links import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_coupon_codes_promotion_rule import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRule,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_coupon_codes_promotion_rule_data import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleData,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_coupon_codes_promotion_rule_data_type import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleDataType,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_coupon_codes_promotion_rule_links import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleLinks,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_market import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsMarket,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_market_data import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsMarketData,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_market_data_type import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsMarketDataType,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_market_links import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsMarketLinks,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_order_amount_promotion_rule import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRule,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_order_amount_promotion_rule_data import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleData,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_order_amount_promotion_rule_data_type import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleDataType,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_order_amount_promotion_rule_links import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleLinks,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_promotion_rules import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsPromotionRules,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_promotion_rules_data import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsPromotionRulesData,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_promotion_rules_data_type import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsPromotionRulesDataType,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_promotion_rules_links import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsPromotionRulesLinks,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_sku_list import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsSkuList,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_sku_list_data import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsSkuListData,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_sku_list_data_type import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsSkuListDataType,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_sku_list_links import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsSkuListLinks,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_sku_list_promotion_rule import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsSkuListPromotionRule,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_sku_list_promotion_rule_data import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleData,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_sku_list_promotion_rule_data_type import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleDataType,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_sku_list_promotion_rule_links import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleLinks,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_skus import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsSkus,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_skus_data import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsSkusData,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_skus_data_type import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsSkusDataType,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_relationships_skus_links import (
    GETpercentageDiscountPromotionsResponse200DataItemRelationshipsSkusLinks,
)
from .ge_tpercentage_discount_promotions_response_200_data_item_type import (
    GETpercentageDiscountPromotionsResponse200DataItemType,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200 import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200Data,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_attributes import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataAttributes,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_attributes_metadata import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataAttributesMetadata,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_links import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataLinks,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationships,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_attachments import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsAttachments,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_attachments_data import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_attachments_data_type import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_attachments_links import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRule,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_data import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleData,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_data_type import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleDataType,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_links import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleLinks,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_market import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsMarket,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_market_data import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsMarketData,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_market_data_type import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsMarketDataType,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_market_links import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsMarketLinks,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_order_amount_promotion_rule import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRule,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_order_amount_promotion_rule_data import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleData,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_order_amount_promotion_rule_data_type import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleDataType,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_order_amount_promotion_rule_links import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleLinks,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_promotion_rules import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsPromotionRules,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_promotion_rules_data import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsPromotionRulesData,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_promotion_rules_data_type import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsPromotionRulesDataType,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_promotion_rules_links import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsPromotionRulesLinks,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_sku_list import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuList,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_sku_list_data import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuListData,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_sku_list_data_type import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuListDataType,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_sku_list_links import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuListLinks,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_sku_list_promotion_rule import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuListPromotionRule,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_sku_list_promotion_rule_data import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuListPromotionRuleData,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_sku_list_promotion_rule_data_type import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuListPromotionRuleDataType,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_sku_list_promotion_rule_links import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuListPromotionRuleLinks,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_skus import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkus,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_skus_data import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkusData,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_skus_data_type import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkusDataType,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_skus_links import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkusLinks,
)
from .ge_tpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_type import (
    GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataType,
)
from .ge_tprice_lists_response_200 import GETpriceListsResponse200
from .ge_tprice_lists_response_200_data_item import GETpriceListsResponse200DataItem
from .ge_tprice_lists_response_200_data_item_attributes import GETpriceListsResponse200DataItemAttributes
from .ge_tprice_lists_response_200_data_item_attributes_metadata import (
    GETpriceListsResponse200DataItemAttributesMetadata,
)
from .ge_tprice_lists_response_200_data_item_links import GETpriceListsResponse200DataItemLinks
from .ge_tprice_lists_response_200_data_item_relationships import GETpriceListsResponse200DataItemRelationships
from .ge_tprice_lists_response_200_data_item_relationships_attachments import (
    GETpriceListsResponse200DataItemRelationshipsAttachments,
)
from .ge_tprice_lists_response_200_data_item_relationships_attachments_data import (
    GETpriceListsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tprice_lists_response_200_data_item_relationships_attachments_data_type import (
    GETpriceListsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tprice_lists_response_200_data_item_relationships_attachments_links import (
    GETpriceListsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tprice_lists_response_200_data_item_relationships_prices import (
    GETpriceListsResponse200DataItemRelationshipsPrices,
)
from .ge_tprice_lists_response_200_data_item_relationships_prices_data import (
    GETpriceListsResponse200DataItemRelationshipsPricesData,
)
from .ge_tprice_lists_response_200_data_item_relationships_prices_data_type import (
    GETpriceListsResponse200DataItemRelationshipsPricesDataType,
)
from .ge_tprice_lists_response_200_data_item_relationships_prices_links import (
    GETpriceListsResponse200DataItemRelationshipsPricesLinks,
)
from .ge_tprice_lists_response_200_data_item_type import GETpriceListsResponse200DataItemType
from .ge_tprice_listsprice_list_id_response_200 import GETpriceListspriceListIdResponse200
from .ge_tprice_listsprice_list_id_response_200_data import GETpriceListspriceListIdResponse200Data
from .ge_tprice_listsprice_list_id_response_200_data_attributes import GETpriceListspriceListIdResponse200DataAttributes
from .ge_tprice_listsprice_list_id_response_200_data_attributes_metadata import (
    GETpriceListspriceListIdResponse200DataAttributesMetadata,
)
from .ge_tprice_listsprice_list_id_response_200_data_links import GETpriceListspriceListIdResponse200DataLinks
from .ge_tprice_listsprice_list_id_response_200_data_relationships import (
    GETpriceListspriceListIdResponse200DataRelationships,
)
from .ge_tprice_listsprice_list_id_response_200_data_relationships_attachments import (
    GETpriceListspriceListIdResponse200DataRelationshipsAttachments,
)
from .ge_tprice_listsprice_list_id_response_200_data_relationships_attachments_data import (
    GETpriceListspriceListIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tprice_listsprice_list_id_response_200_data_relationships_attachments_data_type import (
    GETpriceListspriceListIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tprice_listsprice_list_id_response_200_data_relationships_attachments_links import (
    GETpriceListspriceListIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tprice_listsprice_list_id_response_200_data_relationships_prices import (
    GETpriceListspriceListIdResponse200DataRelationshipsPrices,
)
from .ge_tprice_listsprice_list_id_response_200_data_relationships_prices_data import (
    GETpriceListspriceListIdResponse200DataRelationshipsPricesData,
)
from .ge_tprice_listsprice_list_id_response_200_data_relationships_prices_data_type import (
    GETpriceListspriceListIdResponse200DataRelationshipsPricesDataType,
)
from .ge_tprice_listsprice_list_id_response_200_data_relationships_prices_links import (
    GETpriceListspriceListIdResponse200DataRelationshipsPricesLinks,
)
from .ge_tprice_listsprice_list_id_response_200_data_type import GETpriceListspriceListIdResponse200DataType
from .ge_tprice_tiers_response_200 import GETpriceTiersResponse200
from .ge_tprice_tiers_response_200_data_item import GETpriceTiersResponse200DataItem
from .ge_tprice_tiers_response_200_data_item_attributes import GETpriceTiersResponse200DataItemAttributes
from .ge_tprice_tiers_response_200_data_item_attributes_metadata import (
    GETpriceTiersResponse200DataItemAttributesMetadata,
)
from .ge_tprice_tiers_response_200_data_item_links import GETpriceTiersResponse200DataItemLinks
from .ge_tprice_tiers_response_200_data_item_relationships import GETpriceTiersResponse200DataItemRelationships
from .ge_tprice_tiers_response_200_data_item_relationships_attachments import (
    GETpriceTiersResponse200DataItemRelationshipsAttachments,
)
from .ge_tprice_tiers_response_200_data_item_relationships_attachments_data import (
    GETpriceTiersResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tprice_tiers_response_200_data_item_relationships_attachments_data_type import (
    GETpriceTiersResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tprice_tiers_response_200_data_item_relationships_attachments_links import (
    GETpriceTiersResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tprice_tiers_response_200_data_item_relationships_price import (
    GETpriceTiersResponse200DataItemRelationshipsPrice,
)
from .ge_tprice_tiers_response_200_data_item_relationships_price_data import (
    GETpriceTiersResponse200DataItemRelationshipsPriceData,
)
from .ge_tprice_tiers_response_200_data_item_relationships_price_data_type import (
    GETpriceTiersResponse200DataItemRelationshipsPriceDataType,
)
from .ge_tprice_tiers_response_200_data_item_relationships_price_links import (
    GETpriceTiersResponse200DataItemRelationshipsPriceLinks,
)
from .ge_tprice_tiers_response_200_data_item_type import GETpriceTiersResponse200DataItemType
from .ge_tprice_tiersprice_tier_id_response_200 import GETpriceTierspriceTierIdResponse200
from .ge_tprice_tiersprice_tier_id_response_200_data import GETpriceTierspriceTierIdResponse200Data
from .ge_tprice_tiersprice_tier_id_response_200_data_attributes import GETpriceTierspriceTierIdResponse200DataAttributes
from .ge_tprice_tiersprice_tier_id_response_200_data_attributes_metadata import (
    GETpriceTierspriceTierIdResponse200DataAttributesMetadata,
)
from .ge_tprice_tiersprice_tier_id_response_200_data_links import GETpriceTierspriceTierIdResponse200DataLinks
from .ge_tprice_tiersprice_tier_id_response_200_data_relationships import (
    GETpriceTierspriceTierIdResponse200DataRelationships,
)
from .ge_tprice_tiersprice_tier_id_response_200_data_relationships_attachments import (
    GETpriceTierspriceTierIdResponse200DataRelationshipsAttachments,
)
from .ge_tprice_tiersprice_tier_id_response_200_data_relationships_attachments_data import (
    GETpriceTierspriceTierIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tprice_tiersprice_tier_id_response_200_data_relationships_attachments_data_type import (
    GETpriceTierspriceTierIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tprice_tiersprice_tier_id_response_200_data_relationships_attachments_links import (
    GETpriceTierspriceTierIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tprice_tiersprice_tier_id_response_200_data_relationships_price import (
    GETpriceTierspriceTierIdResponse200DataRelationshipsPrice,
)
from .ge_tprice_tiersprice_tier_id_response_200_data_relationships_price_data import (
    GETpriceTierspriceTierIdResponse200DataRelationshipsPriceData,
)
from .ge_tprice_tiersprice_tier_id_response_200_data_relationships_price_data_type import (
    GETpriceTierspriceTierIdResponse200DataRelationshipsPriceDataType,
)
from .ge_tprice_tiersprice_tier_id_response_200_data_relationships_price_links import (
    GETpriceTierspriceTierIdResponse200DataRelationshipsPriceLinks,
)
from .ge_tprice_tiersprice_tier_id_response_200_data_type import GETpriceTierspriceTierIdResponse200DataType
from .ge_tprice_volume_tiers_response_200 import GETpriceVolumeTiersResponse200
from .ge_tprice_volume_tiers_response_200_data_item import GETpriceVolumeTiersResponse200DataItem
from .ge_tprice_volume_tiers_response_200_data_item_attributes import GETpriceVolumeTiersResponse200DataItemAttributes
from .ge_tprice_volume_tiers_response_200_data_item_attributes_metadata import (
    GETpriceVolumeTiersResponse200DataItemAttributesMetadata,
)
from .ge_tprice_volume_tiers_response_200_data_item_links import GETpriceVolumeTiersResponse200DataItemLinks
from .ge_tprice_volume_tiers_response_200_data_item_relationships import (
    GETpriceVolumeTiersResponse200DataItemRelationships,
)
from .ge_tprice_volume_tiers_response_200_data_item_relationships_attachments import (
    GETpriceVolumeTiersResponse200DataItemRelationshipsAttachments,
)
from .ge_tprice_volume_tiers_response_200_data_item_relationships_attachments_data import (
    GETpriceVolumeTiersResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tprice_volume_tiers_response_200_data_item_relationships_attachments_data_type import (
    GETpriceVolumeTiersResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tprice_volume_tiers_response_200_data_item_relationships_attachments_links import (
    GETpriceVolumeTiersResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tprice_volume_tiers_response_200_data_item_relationships_price import (
    GETpriceVolumeTiersResponse200DataItemRelationshipsPrice,
)
from .ge_tprice_volume_tiers_response_200_data_item_relationships_price_data import (
    GETpriceVolumeTiersResponse200DataItemRelationshipsPriceData,
)
from .ge_tprice_volume_tiers_response_200_data_item_relationships_price_data_type import (
    GETpriceVolumeTiersResponse200DataItemRelationshipsPriceDataType,
)
from .ge_tprice_volume_tiers_response_200_data_item_relationships_price_links import (
    GETpriceVolumeTiersResponse200DataItemRelationshipsPriceLinks,
)
from .ge_tprice_volume_tiers_response_200_data_item_type import GETpriceVolumeTiersResponse200DataItemType
from .ge_tprice_volume_tiersprice_volume_tier_id_response_200 import GETpriceVolumeTierspriceVolumeTierIdResponse200
from .ge_tprice_volume_tiersprice_volume_tier_id_response_200_data import (
    GETpriceVolumeTierspriceVolumeTierIdResponse200Data,
)
from .ge_tprice_volume_tiersprice_volume_tier_id_response_200_data_attributes import (
    GETpriceVolumeTierspriceVolumeTierIdResponse200DataAttributes,
)
from .ge_tprice_volume_tiersprice_volume_tier_id_response_200_data_attributes_metadata import (
    GETpriceVolumeTierspriceVolumeTierIdResponse200DataAttributesMetadata,
)
from .ge_tprice_volume_tiersprice_volume_tier_id_response_200_data_links import (
    GETpriceVolumeTierspriceVolumeTierIdResponse200DataLinks,
)
from .ge_tprice_volume_tiersprice_volume_tier_id_response_200_data_relationships import (
    GETpriceVolumeTierspriceVolumeTierIdResponse200DataRelationships,
)
from .ge_tprice_volume_tiersprice_volume_tier_id_response_200_data_relationships_attachments import (
    GETpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsAttachments,
)
from .ge_tprice_volume_tiersprice_volume_tier_id_response_200_data_relationships_attachments_data import (
    GETpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tprice_volume_tiersprice_volume_tier_id_response_200_data_relationships_attachments_data_type import (
    GETpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tprice_volume_tiersprice_volume_tier_id_response_200_data_relationships_attachments_links import (
    GETpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tprice_volume_tiersprice_volume_tier_id_response_200_data_relationships_price import (
    GETpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsPrice,
)
from .ge_tprice_volume_tiersprice_volume_tier_id_response_200_data_relationships_price_data import (
    GETpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsPriceData,
)
from .ge_tprice_volume_tiersprice_volume_tier_id_response_200_data_relationships_price_data_type import (
    GETpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsPriceDataType,
)
from .ge_tprice_volume_tiersprice_volume_tier_id_response_200_data_relationships_price_links import (
    GETpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsPriceLinks,
)
from .ge_tprice_volume_tiersprice_volume_tier_id_response_200_data_type import (
    GETpriceVolumeTierspriceVolumeTierIdResponse200DataType,
)
from .ge_tprices_response_200 import GETpricesResponse200
from .ge_tprices_response_200_data_item import GETpricesResponse200DataItem
from .ge_tprices_response_200_data_item_attributes import GETpricesResponse200DataItemAttributes
from .ge_tprices_response_200_data_item_attributes_metadata import GETpricesResponse200DataItemAttributesMetadata
from .ge_tprices_response_200_data_item_links import GETpricesResponse200DataItemLinks
from .ge_tprices_response_200_data_item_relationships import GETpricesResponse200DataItemRelationships
from .ge_tprices_response_200_data_item_relationships_attachments import (
    GETpricesResponse200DataItemRelationshipsAttachments,
)
from .ge_tprices_response_200_data_item_relationships_attachments_data import (
    GETpricesResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tprices_response_200_data_item_relationships_attachments_data_type import (
    GETpricesResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tprices_response_200_data_item_relationships_attachments_links import (
    GETpricesResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tprices_response_200_data_item_relationships_price_list import (
    GETpricesResponse200DataItemRelationshipsPriceList,
)
from .ge_tprices_response_200_data_item_relationships_price_list_data import (
    GETpricesResponse200DataItemRelationshipsPriceListData,
)
from .ge_tprices_response_200_data_item_relationships_price_list_data_type import (
    GETpricesResponse200DataItemRelationshipsPriceListDataType,
)
from .ge_tprices_response_200_data_item_relationships_price_list_links import (
    GETpricesResponse200DataItemRelationshipsPriceListLinks,
)
from .ge_tprices_response_200_data_item_relationships_price_tiers import (
    GETpricesResponse200DataItemRelationshipsPriceTiers,
)
from .ge_tprices_response_200_data_item_relationships_price_tiers_data import (
    GETpricesResponse200DataItemRelationshipsPriceTiersData,
)
from .ge_tprices_response_200_data_item_relationships_price_tiers_data_type import (
    GETpricesResponse200DataItemRelationshipsPriceTiersDataType,
)
from .ge_tprices_response_200_data_item_relationships_price_tiers_links import (
    GETpricesResponse200DataItemRelationshipsPriceTiersLinks,
)
from .ge_tprices_response_200_data_item_relationships_price_volume_tiers import (
    GETpricesResponse200DataItemRelationshipsPriceVolumeTiers,
)
from .ge_tprices_response_200_data_item_relationships_price_volume_tiers_data import (
    GETpricesResponse200DataItemRelationshipsPriceVolumeTiersData,
)
from .ge_tprices_response_200_data_item_relationships_price_volume_tiers_data_type import (
    GETpricesResponse200DataItemRelationshipsPriceVolumeTiersDataType,
)
from .ge_tprices_response_200_data_item_relationships_price_volume_tiers_links import (
    GETpricesResponse200DataItemRelationshipsPriceVolumeTiersLinks,
)
from .ge_tprices_response_200_data_item_relationships_sku import GETpricesResponse200DataItemRelationshipsSku
from .ge_tprices_response_200_data_item_relationships_sku_data import GETpricesResponse200DataItemRelationshipsSkuData
from .ge_tprices_response_200_data_item_relationships_sku_data_type import (
    GETpricesResponse200DataItemRelationshipsSkuDataType,
)
from .ge_tprices_response_200_data_item_relationships_sku_links import GETpricesResponse200DataItemRelationshipsSkuLinks
from .ge_tprices_response_200_data_item_type import GETpricesResponse200DataItemType
from .ge_tpricesprice_id_response_200 import GETpricespriceIdResponse200
from .ge_tpricesprice_id_response_200_data import GETpricespriceIdResponse200Data
from .ge_tpricesprice_id_response_200_data_attributes import GETpricespriceIdResponse200DataAttributes
from .ge_tpricesprice_id_response_200_data_attributes_metadata import GETpricespriceIdResponse200DataAttributesMetadata
from .ge_tpricesprice_id_response_200_data_links import GETpricespriceIdResponse200DataLinks
from .ge_tpricesprice_id_response_200_data_relationships import GETpricespriceIdResponse200DataRelationships
from .ge_tpricesprice_id_response_200_data_relationships_attachments import (
    GETpricespriceIdResponse200DataRelationshipsAttachments,
)
from .ge_tpricesprice_id_response_200_data_relationships_attachments_data import (
    GETpricespriceIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tpricesprice_id_response_200_data_relationships_attachments_data_type import (
    GETpricespriceIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tpricesprice_id_response_200_data_relationships_attachments_links import (
    GETpricespriceIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tpricesprice_id_response_200_data_relationships_price_list import (
    GETpricespriceIdResponse200DataRelationshipsPriceList,
)
from .ge_tpricesprice_id_response_200_data_relationships_price_list_data import (
    GETpricespriceIdResponse200DataRelationshipsPriceListData,
)
from .ge_tpricesprice_id_response_200_data_relationships_price_list_data_type import (
    GETpricespriceIdResponse200DataRelationshipsPriceListDataType,
)
from .ge_tpricesprice_id_response_200_data_relationships_price_list_links import (
    GETpricespriceIdResponse200DataRelationshipsPriceListLinks,
)
from .ge_tpricesprice_id_response_200_data_relationships_price_tiers import (
    GETpricespriceIdResponse200DataRelationshipsPriceTiers,
)
from .ge_tpricesprice_id_response_200_data_relationships_price_tiers_data import (
    GETpricespriceIdResponse200DataRelationshipsPriceTiersData,
)
from .ge_tpricesprice_id_response_200_data_relationships_price_tiers_data_type import (
    GETpricespriceIdResponse200DataRelationshipsPriceTiersDataType,
)
from .ge_tpricesprice_id_response_200_data_relationships_price_tiers_links import (
    GETpricespriceIdResponse200DataRelationshipsPriceTiersLinks,
)
from .ge_tpricesprice_id_response_200_data_relationships_price_volume_tiers import (
    GETpricespriceIdResponse200DataRelationshipsPriceVolumeTiers,
)
from .ge_tpricesprice_id_response_200_data_relationships_price_volume_tiers_data import (
    GETpricespriceIdResponse200DataRelationshipsPriceVolumeTiersData,
)
from .ge_tpricesprice_id_response_200_data_relationships_price_volume_tiers_data_type import (
    GETpricespriceIdResponse200DataRelationshipsPriceVolumeTiersDataType,
)
from .ge_tpricesprice_id_response_200_data_relationships_price_volume_tiers_links import (
    GETpricespriceIdResponse200DataRelationshipsPriceVolumeTiersLinks,
)
from .ge_tpricesprice_id_response_200_data_relationships_sku import GETpricespriceIdResponse200DataRelationshipsSku
from .ge_tpricesprice_id_response_200_data_relationships_sku_data import (
    GETpricespriceIdResponse200DataRelationshipsSkuData,
)
from .ge_tpricesprice_id_response_200_data_relationships_sku_data_type import (
    GETpricespriceIdResponse200DataRelationshipsSkuDataType,
)
from .ge_tpricesprice_id_response_200_data_relationships_sku_links import (
    GETpricespriceIdResponse200DataRelationshipsSkuLinks,
)
from .ge_tpricesprice_id_response_200_data_type import GETpricespriceIdResponse200DataType
from .ge_tpromotion_rules_response_200 import GETpromotionRulesResponse200
from .ge_tpromotion_rules_response_200_data_item import GETpromotionRulesResponse200DataItem
from .ge_tpromotion_rules_response_200_data_item_attributes import GETpromotionRulesResponse200DataItemAttributes
from .ge_tpromotion_rules_response_200_data_item_attributes_metadata import (
    GETpromotionRulesResponse200DataItemAttributesMetadata,
)
from .ge_tpromotion_rules_response_200_data_item_links import GETpromotionRulesResponse200DataItemLinks
from .ge_tpromotion_rules_response_200_data_item_relationships import GETpromotionRulesResponse200DataItemRelationships
from .ge_tpromotion_rules_response_200_data_item_relationships_promotion import (
    GETpromotionRulesResponse200DataItemRelationshipsPromotion,
)
from .ge_tpromotion_rules_response_200_data_item_relationships_promotion_data import (
    GETpromotionRulesResponse200DataItemRelationshipsPromotionData,
)
from .ge_tpromotion_rules_response_200_data_item_relationships_promotion_data_type import (
    GETpromotionRulesResponse200DataItemRelationshipsPromotionDataType,
)
from .ge_tpromotion_rules_response_200_data_item_relationships_promotion_links import (
    GETpromotionRulesResponse200DataItemRelationshipsPromotionLinks,
)
from .ge_tpromotion_rules_response_200_data_item_type import GETpromotionRulesResponse200DataItemType
from .ge_tpromotion_rulespromotion_rule_id_response_200 import GETpromotionRulespromotionRuleIdResponse200
from .ge_tpromotion_rulespromotion_rule_id_response_200_data import GETpromotionRulespromotionRuleIdResponse200Data
from .ge_tpromotion_rulespromotion_rule_id_response_200_data_attributes import (
    GETpromotionRulespromotionRuleIdResponse200DataAttributes,
)
from .ge_tpromotion_rulespromotion_rule_id_response_200_data_attributes_metadata import (
    GETpromotionRulespromotionRuleIdResponse200DataAttributesMetadata,
)
from .ge_tpromotion_rulespromotion_rule_id_response_200_data_links import (
    GETpromotionRulespromotionRuleIdResponse200DataLinks,
)
from .ge_tpromotion_rulespromotion_rule_id_response_200_data_relationships import (
    GETpromotionRulespromotionRuleIdResponse200DataRelationships,
)
from .ge_tpromotion_rulespromotion_rule_id_response_200_data_relationships_promotion import (
    GETpromotionRulespromotionRuleIdResponse200DataRelationshipsPromotion,
)
from .ge_tpromotion_rulespromotion_rule_id_response_200_data_relationships_promotion_data import (
    GETpromotionRulespromotionRuleIdResponse200DataRelationshipsPromotionData,
)
from .ge_tpromotion_rulespromotion_rule_id_response_200_data_relationships_promotion_data_type import (
    GETpromotionRulespromotionRuleIdResponse200DataRelationshipsPromotionDataType,
)
from .ge_tpromotion_rulespromotion_rule_id_response_200_data_relationships_promotion_links import (
    GETpromotionRulespromotionRuleIdResponse200DataRelationshipsPromotionLinks,
)
from .ge_tpromotion_rulespromotion_rule_id_response_200_data_type import (
    GETpromotionRulespromotionRuleIdResponse200DataType,
)
from .ge_tpromotions_response_200 import GETpromotionsResponse200
from .ge_tpromotions_response_200_data_item import GETpromotionsResponse200DataItem
from .ge_tpromotions_response_200_data_item_attributes import GETpromotionsResponse200DataItemAttributes
from .ge_tpromotions_response_200_data_item_attributes_metadata import (
    GETpromotionsResponse200DataItemAttributesMetadata,
)
from .ge_tpromotions_response_200_data_item_links import GETpromotionsResponse200DataItemLinks
from .ge_tpromotions_response_200_data_item_relationships import GETpromotionsResponse200DataItemRelationships
from .ge_tpromotions_response_200_data_item_relationships_attachments import (
    GETpromotionsResponse200DataItemRelationshipsAttachments,
)
from .ge_tpromotions_response_200_data_item_relationships_attachments_data import (
    GETpromotionsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tpromotions_response_200_data_item_relationships_attachments_data_type import (
    GETpromotionsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tpromotions_response_200_data_item_relationships_attachments_links import (
    GETpromotionsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tpromotions_response_200_data_item_relationships_coupon_codes_promotion_rule import (
    GETpromotionsResponse200DataItemRelationshipsCouponCodesPromotionRule,
)
from .ge_tpromotions_response_200_data_item_relationships_coupon_codes_promotion_rule_data import (
    GETpromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleData,
)
from .ge_tpromotions_response_200_data_item_relationships_coupon_codes_promotion_rule_data_type import (
    GETpromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleDataType,
)
from .ge_tpromotions_response_200_data_item_relationships_coupon_codes_promotion_rule_links import (
    GETpromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleLinks,
)
from .ge_tpromotions_response_200_data_item_relationships_market import (
    GETpromotionsResponse200DataItemRelationshipsMarket,
)
from .ge_tpromotions_response_200_data_item_relationships_market_data import (
    GETpromotionsResponse200DataItemRelationshipsMarketData,
)
from .ge_tpromotions_response_200_data_item_relationships_market_data_type import (
    GETpromotionsResponse200DataItemRelationshipsMarketDataType,
)
from .ge_tpromotions_response_200_data_item_relationships_market_links import (
    GETpromotionsResponse200DataItemRelationshipsMarketLinks,
)
from .ge_tpromotions_response_200_data_item_relationships_order_amount_promotion_rule import (
    GETpromotionsResponse200DataItemRelationshipsOrderAmountPromotionRule,
)
from .ge_tpromotions_response_200_data_item_relationships_order_amount_promotion_rule_data import (
    GETpromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleData,
)
from .ge_tpromotions_response_200_data_item_relationships_order_amount_promotion_rule_data_type import (
    GETpromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleDataType,
)
from .ge_tpromotions_response_200_data_item_relationships_order_amount_promotion_rule_links import (
    GETpromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleLinks,
)
from .ge_tpromotions_response_200_data_item_relationships_promotion_rules import (
    GETpromotionsResponse200DataItemRelationshipsPromotionRules,
)
from .ge_tpromotions_response_200_data_item_relationships_promotion_rules_data import (
    GETpromotionsResponse200DataItemRelationshipsPromotionRulesData,
)
from .ge_tpromotions_response_200_data_item_relationships_promotion_rules_data_type import (
    GETpromotionsResponse200DataItemRelationshipsPromotionRulesDataType,
)
from .ge_tpromotions_response_200_data_item_relationships_promotion_rules_links import (
    GETpromotionsResponse200DataItemRelationshipsPromotionRulesLinks,
)
from .ge_tpromotions_response_200_data_item_relationships_sku_list_promotion_rule import (
    GETpromotionsResponse200DataItemRelationshipsSkuListPromotionRule,
)
from .ge_tpromotions_response_200_data_item_relationships_sku_list_promotion_rule_data import (
    GETpromotionsResponse200DataItemRelationshipsSkuListPromotionRuleData,
)
from .ge_tpromotions_response_200_data_item_relationships_sku_list_promotion_rule_data_type import (
    GETpromotionsResponse200DataItemRelationshipsSkuListPromotionRuleDataType,
)
from .ge_tpromotions_response_200_data_item_relationships_sku_list_promotion_rule_links import (
    GETpromotionsResponse200DataItemRelationshipsSkuListPromotionRuleLinks,
)
from .ge_tpromotions_response_200_data_item_type import GETpromotionsResponse200DataItemType
from .ge_tpromotionspromotion_id_response_200 import GETpromotionspromotionIdResponse200
from .ge_tpromotionspromotion_id_response_200_data import GETpromotionspromotionIdResponse200Data
from .ge_tpromotionspromotion_id_response_200_data_attributes import GETpromotionspromotionIdResponse200DataAttributes
from .ge_tpromotionspromotion_id_response_200_data_attributes_metadata import (
    GETpromotionspromotionIdResponse200DataAttributesMetadata,
)
from .ge_tpromotionspromotion_id_response_200_data_links import GETpromotionspromotionIdResponse200DataLinks
from .ge_tpromotionspromotion_id_response_200_data_relationships import (
    GETpromotionspromotionIdResponse200DataRelationships,
)
from .ge_tpromotionspromotion_id_response_200_data_relationships_attachments import (
    GETpromotionspromotionIdResponse200DataRelationshipsAttachments,
)
from .ge_tpromotionspromotion_id_response_200_data_relationships_attachments_data import (
    GETpromotionspromotionIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tpromotionspromotion_id_response_200_data_relationships_attachments_data_type import (
    GETpromotionspromotionIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tpromotionspromotion_id_response_200_data_relationships_attachments_links import (
    GETpromotionspromotionIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tpromotionspromotion_id_response_200_data_relationships_coupon_codes_promotion_rule import (
    GETpromotionspromotionIdResponse200DataRelationshipsCouponCodesPromotionRule,
)
from .ge_tpromotionspromotion_id_response_200_data_relationships_coupon_codes_promotion_rule_data import (
    GETpromotionspromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleData,
)
from .ge_tpromotionspromotion_id_response_200_data_relationships_coupon_codes_promotion_rule_data_type import (
    GETpromotionspromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleDataType,
)
from .ge_tpromotionspromotion_id_response_200_data_relationships_coupon_codes_promotion_rule_links import (
    GETpromotionspromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleLinks,
)
from .ge_tpromotionspromotion_id_response_200_data_relationships_market import (
    GETpromotionspromotionIdResponse200DataRelationshipsMarket,
)
from .ge_tpromotionspromotion_id_response_200_data_relationships_market_data import (
    GETpromotionspromotionIdResponse200DataRelationshipsMarketData,
)
from .ge_tpromotionspromotion_id_response_200_data_relationships_market_data_type import (
    GETpromotionspromotionIdResponse200DataRelationshipsMarketDataType,
)
from .ge_tpromotionspromotion_id_response_200_data_relationships_market_links import (
    GETpromotionspromotionIdResponse200DataRelationshipsMarketLinks,
)
from .ge_tpromotionspromotion_id_response_200_data_relationships_order_amount_promotion_rule import (
    GETpromotionspromotionIdResponse200DataRelationshipsOrderAmountPromotionRule,
)
from .ge_tpromotionspromotion_id_response_200_data_relationships_order_amount_promotion_rule_data import (
    GETpromotionspromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleData,
)
from .ge_tpromotionspromotion_id_response_200_data_relationships_order_amount_promotion_rule_data_type import (
    GETpromotionspromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleDataType,
)
from .ge_tpromotionspromotion_id_response_200_data_relationships_order_amount_promotion_rule_links import (
    GETpromotionspromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleLinks,
)
from .ge_tpromotionspromotion_id_response_200_data_relationships_promotion_rules import (
    GETpromotionspromotionIdResponse200DataRelationshipsPromotionRules,
)
from .ge_tpromotionspromotion_id_response_200_data_relationships_promotion_rules_data import (
    GETpromotionspromotionIdResponse200DataRelationshipsPromotionRulesData,
)
from .ge_tpromotionspromotion_id_response_200_data_relationships_promotion_rules_data_type import (
    GETpromotionspromotionIdResponse200DataRelationshipsPromotionRulesDataType,
)
from .ge_tpromotionspromotion_id_response_200_data_relationships_promotion_rules_links import (
    GETpromotionspromotionIdResponse200DataRelationshipsPromotionRulesLinks,
)
from .ge_tpromotionspromotion_id_response_200_data_relationships_sku_list_promotion_rule import (
    GETpromotionspromotionIdResponse200DataRelationshipsSkuListPromotionRule,
)
from .ge_tpromotionspromotion_id_response_200_data_relationships_sku_list_promotion_rule_data import (
    GETpromotionspromotionIdResponse200DataRelationshipsSkuListPromotionRuleData,
)
from .ge_tpromotionspromotion_id_response_200_data_relationships_sku_list_promotion_rule_data_type import (
    GETpromotionspromotionIdResponse200DataRelationshipsSkuListPromotionRuleDataType,
)
from .ge_tpromotionspromotion_id_response_200_data_relationships_sku_list_promotion_rule_links import (
    GETpromotionspromotionIdResponse200DataRelationshipsSkuListPromotionRuleLinks,
)
from .ge_tpromotionspromotion_id_response_200_data_type import GETpromotionspromotionIdResponse200DataType
from .ge_trefunds_response_200 import GETrefundsResponse200
from .ge_trefunds_response_200_data_item import GETrefundsResponse200DataItem
from .ge_trefunds_response_200_data_item_attributes import GETrefundsResponse200DataItemAttributes
from .ge_trefunds_response_200_data_item_attributes_metadata import GETrefundsResponse200DataItemAttributesMetadata
from .ge_trefunds_response_200_data_item_links import GETrefundsResponse200DataItemLinks
from .ge_trefunds_response_200_data_item_relationships import GETrefundsResponse200DataItemRelationships
from .ge_trefunds_response_200_data_item_relationships_events import GETrefundsResponse200DataItemRelationshipsEvents
from .ge_trefunds_response_200_data_item_relationships_events_data import (
    GETrefundsResponse200DataItemRelationshipsEventsData,
)
from .ge_trefunds_response_200_data_item_relationships_events_data_type import (
    GETrefundsResponse200DataItemRelationshipsEventsDataType,
)
from .ge_trefunds_response_200_data_item_relationships_events_links import (
    GETrefundsResponse200DataItemRelationshipsEventsLinks,
)
from .ge_trefunds_response_200_data_item_relationships_order import GETrefundsResponse200DataItemRelationshipsOrder
from .ge_trefunds_response_200_data_item_relationships_order_data import (
    GETrefundsResponse200DataItemRelationshipsOrderData,
)
from .ge_trefunds_response_200_data_item_relationships_order_data_type import (
    GETrefundsResponse200DataItemRelationshipsOrderDataType,
)
from .ge_trefunds_response_200_data_item_relationships_order_links import (
    GETrefundsResponse200DataItemRelationshipsOrderLinks,
)
from .ge_trefunds_response_200_data_item_relationships_reference_capture import (
    GETrefundsResponse200DataItemRelationshipsReferenceCapture,
)
from .ge_trefunds_response_200_data_item_relationships_reference_capture_data import (
    GETrefundsResponse200DataItemRelationshipsReferenceCaptureData,
)
from .ge_trefunds_response_200_data_item_relationships_reference_capture_data_type import (
    GETrefundsResponse200DataItemRelationshipsReferenceCaptureDataType,
)
from .ge_trefunds_response_200_data_item_relationships_reference_capture_links import (
    GETrefundsResponse200DataItemRelationshipsReferenceCaptureLinks,
)
from .ge_trefunds_response_200_data_item_type import GETrefundsResponse200DataItemType
from .ge_trefundsrefund_id_response_200 import GETrefundsrefundIdResponse200
from .ge_trefundsrefund_id_response_200_data import GETrefundsrefundIdResponse200Data
from .ge_trefundsrefund_id_response_200_data_attributes import GETrefundsrefundIdResponse200DataAttributes
from .ge_trefundsrefund_id_response_200_data_attributes_metadata import (
    GETrefundsrefundIdResponse200DataAttributesMetadata,
)
from .ge_trefundsrefund_id_response_200_data_links import GETrefundsrefundIdResponse200DataLinks
from .ge_trefundsrefund_id_response_200_data_relationships import GETrefundsrefundIdResponse200DataRelationships
from .ge_trefundsrefund_id_response_200_data_relationships_events import (
    GETrefundsrefundIdResponse200DataRelationshipsEvents,
)
from .ge_trefundsrefund_id_response_200_data_relationships_events_data import (
    GETrefundsrefundIdResponse200DataRelationshipsEventsData,
)
from .ge_trefundsrefund_id_response_200_data_relationships_events_data_type import (
    GETrefundsrefundIdResponse200DataRelationshipsEventsDataType,
)
from .ge_trefundsrefund_id_response_200_data_relationships_events_links import (
    GETrefundsrefundIdResponse200DataRelationshipsEventsLinks,
)
from .ge_trefundsrefund_id_response_200_data_relationships_order import (
    GETrefundsrefundIdResponse200DataRelationshipsOrder,
)
from .ge_trefundsrefund_id_response_200_data_relationships_order_data import (
    GETrefundsrefundIdResponse200DataRelationshipsOrderData,
)
from .ge_trefundsrefund_id_response_200_data_relationships_order_data_type import (
    GETrefundsrefundIdResponse200DataRelationshipsOrderDataType,
)
from .ge_trefundsrefund_id_response_200_data_relationships_order_links import (
    GETrefundsrefundIdResponse200DataRelationshipsOrderLinks,
)
from .ge_trefundsrefund_id_response_200_data_relationships_reference_capture import (
    GETrefundsrefundIdResponse200DataRelationshipsReferenceCapture,
)
from .ge_trefundsrefund_id_response_200_data_relationships_reference_capture_data import (
    GETrefundsrefundIdResponse200DataRelationshipsReferenceCaptureData,
)
from .ge_trefundsrefund_id_response_200_data_relationships_reference_capture_data_type import (
    GETrefundsrefundIdResponse200DataRelationshipsReferenceCaptureDataType,
)
from .ge_trefundsrefund_id_response_200_data_relationships_reference_capture_links import (
    GETrefundsrefundIdResponse200DataRelationshipsReferenceCaptureLinks,
)
from .ge_trefundsrefund_id_response_200_data_type import GETrefundsrefundIdResponse200DataType
from .ge_treturn_line_items_response_200 import GETreturnLineItemsResponse200
from .ge_treturn_line_items_response_200_data_item import GETreturnLineItemsResponse200DataItem
from .ge_treturn_line_items_response_200_data_item_attributes import GETreturnLineItemsResponse200DataItemAttributes
from .ge_treturn_line_items_response_200_data_item_attributes_metadata import (
    GETreturnLineItemsResponse200DataItemAttributesMetadata,
)
from .ge_treturn_line_items_response_200_data_item_attributes_return_reason import (
    GETreturnLineItemsResponse200DataItemAttributesReturnReason,
)
from .ge_treturn_line_items_response_200_data_item_links import GETreturnLineItemsResponse200DataItemLinks
from .ge_treturn_line_items_response_200_data_item_relationships import (
    GETreturnLineItemsResponse200DataItemRelationships,
)
from .ge_treturn_line_items_response_200_data_item_relationships_line_item import (
    GETreturnLineItemsResponse200DataItemRelationshipsLineItem,
)
from .ge_treturn_line_items_response_200_data_item_relationships_line_item_data import (
    GETreturnLineItemsResponse200DataItemRelationshipsLineItemData,
)
from .ge_treturn_line_items_response_200_data_item_relationships_line_item_data_type import (
    GETreturnLineItemsResponse200DataItemRelationshipsLineItemDataType,
)
from .ge_treturn_line_items_response_200_data_item_relationships_line_item_links import (
    GETreturnLineItemsResponse200DataItemRelationshipsLineItemLinks,
)
from .ge_treturn_line_items_response_200_data_item_relationships_return import (
    GETreturnLineItemsResponse200DataItemRelationshipsReturn,
)
from .ge_treturn_line_items_response_200_data_item_relationships_return_data import (
    GETreturnLineItemsResponse200DataItemRelationshipsReturnData,
)
from .ge_treturn_line_items_response_200_data_item_relationships_return_data_type import (
    GETreturnLineItemsResponse200DataItemRelationshipsReturnDataType,
)
from .ge_treturn_line_items_response_200_data_item_relationships_return_links import (
    GETreturnLineItemsResponse200DataItemRelationshipsReturnLinks,
)
from .ge_treturn_line_items_response_200_data_item_type import GETreturnLineItemsResponse200DataItemType
from .ge_treturn_line_itemsreturn_line_item_id_response_200 import GETreturnLineItemsreturnLineItemIdResponse200
from .ge_treturn_line_itemsreturn_line_item_id_response_200_data import (
    GETreturnLineItemsreturnLineItemIdResponse200Data,
)
from .ge_treturn_line_itemsreturn_line_item_id_response_200_data_attributes import (
    GETreturnLineItemsreturnLineItemIdResponse200DataAttributes,
)
from .ge_treturn_line_itemsreturn_line_item_id_response_200_data_attributes_metadata import (
    GETreturnLineItemsreturnLineItemIdResponse200DataAttributesMetadata,
)
from .ge_treturn_line_itemsreturn_line_item_id_response_200_data_attributes_return_reason import (
    GETreturnLineItemsreturnLineItemIdResponse200DataAttributesReturnReason,
)
from .ge_treturn_line_itemsreturn_line_item_id_response_200_data_links import (
    GETreturnLineItemsreturnLineItemIdResponse200DataLinks,
)
from .ge_treturn_line_itemsreturn_line_item_id_response_200_data_relationships import (
    GETreturnLineItemsreturnLineItemIdResponse200DataRelationships,
)
from .ge_treturn_line_itemsreturn_line_item_id_response_200_data_relationships_line_item import (
    GETreturnLineItemsreturnLineItemIdResponse200DataRelationshipsLineItem,
)
from .ge_treturn_line_itemsreturn_line_item_id_response_200_data_relationships_line_item_data import (
    GETreturnLineItemsreturnLineItemIdResponse200DataRelationshipsLineItemData,
)
from .ge_treturn_line_itemsreturn_line_item_id_response_200_data_relationships_line_item_data_type import (
    GETreturnLineItemsreturnLineItemIdResponse200DataRelationshipsLineItemDataType,
)
from .ge_treturn_line_itemsreturn_line_item_id_response_200_data_relationships_line_item_links import (
    GETreturnLineItemsreturnLineItemIdResponse200DataRelationshipsLineItemLinks,
)
from .ge_treturn_line_itemsreturn_line_item_id_response_200_data_relationships_return import (
    GETreturnLineItemsreturnLineItemIdResponse200DataRelationshipsReturn,
)
from .ge_treturn_line_itemsreturn_line_item_id_response_200_data_relationships_return_data import (
    GETreturnLineItemsreturnLineItemIdResponse200DataRelationshipsReturnData,
)
from .ge_treturn_line_itemsreturn_line_item_id_response_200_data_relationships_return_data_type import (
    GETreturnLineItemsreturnLineItemIdResponse200DataRelationshipsReturnDataType,
)
from .ge_treturn_line_itemsreturn_line_item_id_response_200_data_relationships_return_links import (
    GETreturnLineItemsreturnLineItemIdResponse200DataRelationshipsReturnLinks,
)
from .ge_treturn_line_itemsreturn_line_item_id_response_200_data_type import (
    GETreturnLineItemsreturnLineItemIdResponse200DataType,
)
from .ge_treturns_response_200 import GETreturnsResponse200
from .ge_treturns_response_200_data_item import GETreturnsResponse200DataItem
from .ge_treturns_response_200_data_item_attributes import GETreturnsResponse200DataItemAttributes
from .ge_treturns_response_200_data_item_attributes_metadata import GETreturnsResponse200DataItemAttributesMetadata
from .ge_treturns_response_200_data_item_links import GETreturnsResponse200DataItemLinks
from .ge_treturns_response_200_data_item_relationships import GETreturnsResponse200DataItemRelationships
from .ge_treturns_response_200_data_item_relationships_attachments import (
    GETreturnsResponse200DataItemRelationshipsAttachments,
)
from .ge_treturns_response_200_data_item_relationships_attachments_data import (
    GETreturnsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_treturns_response_200_data_item_relationships_attachments_data_type import (
    GETreturnsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_treturns_response_200_data_item_relationships_attachments_links import (
    GETreturnsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_treturns_response_200_data_item_relationships_customer import (
    GETreturnsResponse200DataItemRelationshipsCustomer,
)
from .ge_treturns_response_200_data_item_relationships_customer_data import (
    GETreturnsResponse200DataItemRelationshipsCustomerData,
)
from .ge_treturns_response_200_data_item_relationships_customer_data_type import (
    GETreturnsResponse200DataItemRelationshipsCustomerDataType,
)
from .ge_treturns_response_200_data_item_relationships_customer_links import (
    GETreturnsResponse200DataItemRelationshipsCustomerLinks,
)
from .ge_treturns_response_200_data_item_relationships_destination_address import (
    GETreturnsResponse200DataItemRelationshipsDestinationAddress,
)
from .ge_treturns_response_200_data_item_relationships_destination_address_data import (
    GETreturnsResponse200DataItemRelationshipsDestinationAddressData,
)
from .ge_treturns_response_200_data_item_relationships_destination_address_data_type import (
    GETreturnsResponse200DataItemRelationshipsDestinationAddressDataType,
)
from .ge_treturns_response_200_data_item_relationships_destination_address_links import (
    GETreturnsResponse200DataItemRelationshipsDestinationAddressLinks,
)
from .ge_treturns_response_200_data_item_relationships_events import GETreturnsResponse200DataItemRelationshipsEvents
from .ge_treturns_response_200_data_item_relationships_events_data import (
    GETreturnsResponse200DataItemRelationshipsEventsData,
)
from .ge_treturns_response_200_data_item_relationships_events_data_type import (
    GETreturnsResponse200DataItemRelationshipsEventsDataType,
)
from .ge_treturns_response_200_data_item_relationships_events_links import (
    GETreturnsResponse200DataItemRelationshipsEventsLinks,
)
from .ge_treturns_response_200_data_item_relationships_order import GETreturnsResponse200DataItemRelationshipsOrder
from .ge_treturns_response_200_data_item_relationships_order_data import (
    GETreturnsResponse200DataItemRelationshipsOrderData,
)
from .ge_treturns_response_200_data_item_relationships_order_data_type import (
    GETreturnsResponse200DataItemRelationshipsOrderDataType,
)
from .ge_treturns_response_200_data_item_relationships_order_links import (
    GETreturnsResponse200DataItemRelationshipsOrderLinks,
)
from .ge_treturns_response_200_data_item_relationships_origin_address import (
    GETreturnsResponse200DataItemRelationshipsOriginAddress,
)
from .ge_treturns_response_200_data_item_relationships_origin_address_data import (
    GETreturnsResponse200DataItemRelationshipsOriginAddressData,
)
from .ge_treturns_response_200_data_item_relationships_origin_address_data_type import (
    GETreturnsResponse200DataItemRelationshipsOriginAddressDataType,
)
from .ge_treturns_response_200_data_item_relationships_origin_address_links import (
    GETreturnsResponse200DataItemRelationshipsOriginAddressLinks,
)
from .ge_treturns_response_200_data_item_relationships_return_line_items import (
    GETreturnsResponse200DataItemRelationshipsReturnLineItems,
)
from .ge_treturns_response_200_data_item_relationships_return_line_items_data import (
    GETreturnsResponse200DataItemRelationshipsReturnLineItemsData,
)
from .ge_treturns_response_200_data_item_relationships_return_line_items_data_type import (
    GETreturnsResponse200DataItemRelationshipsReturnLineItemsDataType,
)
from .ge_treturns_response_200_data_item_relationships_return_line_items_links import (
    GETreturnsResponse200DataItemRelationshipsReturnLineItemsLinks,
)
from .ge_treturns_response_200_data_item_relationships_stock_location import (
    GETreturnsResponse200DataItemRelationshipsStockLocation,
)
from .ge_treturns_response_200_data_item_relationships_stock_location_data import (
    GETreturnsResponse200DataItemRelationshipsStockLocationData,
)
from .ge_treturns_response_200_data_item_relationships_stock_location_data_type import (
    GETreturnsResponse200DataItemRelationshipsStockLocationDataType,
)
from .ge_treturns_response_200_data_item_relationships_stock_location_links import (
    GETreturnsResponse200DataItemRelationshipsStockLocationLinks,
)
from .ge_treturns_response_200_data_item_type import GETreturnsResponse200DataItemType
from .ge_treturnsreturn_id_response_200 import GETreturnsreturnIdResponse200
from .ge_treturnsreturn_id_response_200_data import GETreturnsreturnIdResponse200Data
from .ge_treturnsreturn_id_response_200_data_attributes import GETreturnsreturnIdResponse200DataAttributes
from .ge_treturnsreturn_id_response_200_data_attributes_metadata import (
    GETreturnsreturnIdResponse200DataAttributesMetadata,
)
from .ge_treturnsreturn_id_response_200_data_links import GETreturnsreturnIdResponse200DataLinks
from .ge_treturnsreturn_id_response_200_data_relationships import GETreturnsreturnIdResponse200DataRelationships
from .ge_treturnsreturn_id_response_200_data_relationships_attachments import (
    GETreturnsreturnIdResponse200DataRelationshipsAttachments,
)
from .ge_treturnsreturn_id_response_200_data_relationships_attachments_data import (
    GETreturnsreturnIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_treturnsreturn_id_response_200_data_relationships_attachments_data_type import (
    GETreturnsreturnIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_treturnsreturn_id_response_200_data_relationships_attachments_links import (
    GETreturnsreturnIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_treturnsreturn_id_response_200_data_relationships_customer import (
    GETreturnsreturnIdResponse200DataRelationshipsCustomer,
)
from .ge_treturnsreturn_id_response_200_data_relationships_customer_data import (
    GETreturnsreturnIdResponse200DataRelationshipsCustomerData,
)
from .ge_treturnsreturn_id_response_200_data_relationships_customer_data_type import (
    GETreturnsreturnIdResponse200DataRelationshipsCustomerDataType,
)
from .ge_treturnsreturn_id_response_200_data_relationships_customer_links import (
    GETreturnsreturnIdResponse200DataRelationshipsCustomerLinks,
)
from .ge_treturnsreturn_id_response_200_data_relationships_destination_address import (
    GETreturnsreturnIdResponse200DataRelationshipsDestinationAddress,
)
from .ge_treturnsreturn_id_response_200_data_relationships_destination_address_data import (
    GETreturnsreturnIdResponse200DataRelationshipsDestinationAddressData,
)
from .ge_treturnsreturn_id_response_200_data_relationships_destination_address_data_type import (
    GETreturnsreturnIdResponse200DataRelationshipsDestinationAddressDataType,
)
from .ge_treturnsreturn_id_response_200_data_relationships_destination_address_links import (
    GETreturnsreturnIdResponse200DataRelationshipsDestinationAddressLinks,
)
from .ge_treturnsreturn_id_response_200_data_relationships_events import (
    GETreturnsreturnIdResponse200DataRelationshipsEvents,
)
from .ge_treturnsreturn_id_response_200_data_relationships_events_data import (
    GETreturnsreturnIdResponse200DataRelationshipsEventsData,
)
from .ge_treturnsreturn_id_response_200_data_relationships_events_data_type import (
    GETreturnsreturnIdResponse200DataRelationshipsEventsDataType,
)
from .ge_treturnsreturn_id_response_200_data_relationships_events_links import (
    GETreturnsreturnIdResponse200DataRelationshipsEventsLinks,
)
from .ge_treturnsreturn_id_response_200_data_relationships_order import (
    GETreturnsreturnIdResponse200DataRelationshipsOrder,
)
from .ge_treturnsreturn_id_response_200_data_relationships_order_data import (
    GETreturnsreturnIdResponse200DataRelationshipsOrderData,
)
from .ge_treturnsreturn_id_response_200_data_relationships_order_data_type import (
    GETreturnsreturnIdResponse200DataRelationshipsOrderDataType,
)
from .ge_treturnsreturn_id_response_200_data_relationships_order_links import (
    GETreturnsreturnIdResponse200DataRelationshipsOrderLinks,
)
from .ge_treturnsreturn_id_response_200_data_relationships_origin_address import (
    GETreturnsreturnIdResponse200DataRelationshipsOriginAddress,
)
from .ge_treturnsreturn_id_response_200_data_relationships_origin_address_data import (
    GETreturnsreturnIdResponse200DataRelationshipsOriginAddressData,
)
from .ge_treturnsreturn_id_response_200_data_relationships_origin_address_data_type import (
    GETreturnsreturnIdResponse200DataRelationshipsOriginAddressDataType,
)
from .ge_treturnsreturn_id_response_200_data_relationships_origin_address_links import (
    GETreturnsreturnIdResponse200DataRelationshipsOriginAddressLinks,
)
from .ge_treturnsreturn_id_response_200_data_relationships_return_line_items import (
    GETreturnsreturnIdResponse200DataRelationshipsReturnLineItems,
)
from .ge_treturnsreturn_id_response_200_data_relationships_return_line_items_data import (
    GETreturnsreturnIdResponse200DataRelationshipsReturnLineItemsData,
)
from .ge_treturnsreturn_id_response_200_data_relationships_return_line_items_data_type import (
    GETreturnsreturnIdResponse200DataRelationshipsReturnLineItemsDataType,
)
from .ge_treturnsreturn_id_response_200_data_relationships_return_line_items_links import (
    GETreturnsreturnIdResponse200DataRelationshipsReturnLineItemsLinks,
)
from .ge_treturnsreturn_id_response_200_data_relationships_stock_location import (
    GETreturnsreturnIdResponse200DataRelationshipsStockLocation,
)
from .ge_treturnsreturn_id_response_200_data_relationships_stock_location_data import (
    GETreturnsreturnIdResponse200DataRelationshipsStockLocationData,
)
from .ge_treturnsreturn_id_response_200_data_relationships_stock_location_data_type import (
    GETreturnsreturnIdResponse200DataRelationshipsStockLocationDataType,
)
from .ge_treturnsreturn_id_response_200_data_relationships_stock_location_links import (
    GETreturnsreturnIdResponse200DataRelationshipsStockLocationLinks,
)
from .ge_treturnsreturn_id_response_200_data_type import GETreturnsreturnIdResponse200DataType
from .ge_tshipments_response_200 import GETshipmentsResponse200
from .ge_tshipments_response_200_data_item import GETshipmentsResponse200DataItem
from .ge_tshipments_response_200_data_item_attributes import GETshipmentsResponse200DataItemAttributes
from .ge_tshipments_response_200_data_item_attributes_get_rates_errors_item import (
    GETshipmentsResponse200DataItemAttributesGetRatesErrorsItem,
)
from .ge_tshipments_response_200_data_item_attributes_metadata import GETshipmentsResponse200DataItemAttributesMetadata
from .ge_tshipments_response_200_data_item_attributes_rates_item import (
    GETshipmentsResponse200DataItemAttributesRatesItem,
)
from .ge_tshipments_response_200_data_item_links import GETshipmentsResponse200DataItemLinks
from .ge_tshipments_response_200_data_item_relationships import GETshipmentsResponse200DataItemRelationships
from .ge_tshipments_response_200_data_item_relationships_attachments import (
    GETshipmentsResponse200DataItemRelationshipsAttachments,
)
from .ge_tshipments_response_200_data_item_relationships_attachments_data import (
    GETshipmentsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tshipments_response_200_data_item_relationships_attachments_data_type import (
    GETshipmentsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tshipments_response_200_data_item_relationships_attachments_links import (
    GETshipmentsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tshipments_response_200_data_item_relationships_available_shipping_methods import (
    GETshipmentsResponse200DataItemRelationshipsAvailableShippingMethods,
)
from .ge_tshipments_response_200_data_item_relationships_available_shipping_methods_data import (
    GETshipmentsResponse200DataItemRelationshipsAvailableShippingMethodsData,
)
from .ge_tshipments_response_200_data_item_relationships_available_shipping_methods_data_type import (
    GETshipmentsResponse200DataItemRelationshipsAvailableShippingMethodsDataType,
)
from .ge_tshipments_response_200_data_item_relationships_available_shipping_methods_links import (
    GETshipmentsResponse200DataItemRelationshipsAvailableShippingMethodsLinks,
)
from .ge_tshipments_response_200_data_item_relationships_carrier_accounts import (
    GETshipmentsResponse200DataItemRelationshipsCarrierAccounts,
)
from .ge_tshipments_response_200_data_item_relationships_carrier_accounts_data import (
    GETshipmentsResponse200DataItemRelationshipsCarrierAccountsData,
)
from .ge_tshipments_response_200_data_item_relationships_carrier_accounts_data_type import (
    GETshipmentsResponse200DataItemRelationshipsCarrierAccountsDataType,
)
from .ge_tshipments_response_200_data_item_relationships_carrier_accounts_links import (
    GETshipmentsResponse200DataItemRelationshipsCarrierAccountsLinks,
)
from .ge_tshipments_response_200_data_item_relationships_delivery_lead_time import (
    GETshipmentsResponse200DataItemRelationshipsDeliveryLeadTime,
)
from .ge_tshipments_response_200_data_item_relationships_delivery_lead_time_data import (
    GETshipmentsResponse200DataItemRelationshipsDeliveryLeadTimeData,
)
from .ge_tshipments_response_200_data_item_relationships_delivery_lead_time_data_type import (
    GETshipmentsResponse200DataItemRelationshipsDeliveryLeadTimeDataType,
)
from .ge_tshipments_response_200_data_item_relationships_delivery_lead_time_links import (
    GETshipmentsResponse200DataItemRelationshipsDeliveryLeadTimeLinks,
)
from .ge_tshipments_response_200_data_item_relationships_events import (
    GETshipmentsResponse200DataItemRelationshipsEvents,
)
from .ge_tshipments_response_200_data_item_relationships_events_data import (
    GETshipmentsResponse200DataItemRelationshipsEventsData,
)
from .ge_tshipments_response_200_data_item_relationships_events_data_type import (
    GETshipmentsResponse200DataItemRelationshipsEventsDataType,
)
from .ge_tshipments_response_200_data_item_relationships_events_links import (
    GETshipmentsResponse200DataItemRelationshipsEventsLinks,
)
from .ge_tshipments_response_200_data_item_relationships_order import GETshipmentsResponse200DataItemRelationshipsOrder
from .ge_tshipments_response_200_data_item_relationships_order_data import (
    GETshipmentsResponse200DataItemRelationshipsOrderData,
)
from .ge_tshipments_response_200_data_item_relationships_order_data_type import (
    GETshipmentsResponse200DataItemRelationshipsOrderDataType,
)
from .ge_tshipments_response_200_data_item_relationships_order_links import (
    GETshipmentsResponse200DataItemRelationshipsOrderLinks,
)
from .ge_tshipments_response_200_data_item_relationships_origin_address import (
    GETshipmentsResponse200DataItemRelationshipsOriginAddress,
)
from .ge_tshipments_response_200_data_item_relationships_origin_address_data import (
    GETshipmentsResponse200DataItemRelationshipsOriginAddressData,
)
from .ge_tshipments_response_200_data_item_relationships_origin_address_data_type import (
    GETshipmentsResponse200DataItemRelationshipsOriginAddressDataType,
)
from .ge_tshipments_response_200_data_item_relationships_origin_address_links import (
    GETshipmentsResponse200DataItemRelationshipsOriginAddressLinks,
)
from .ge_tshipments_response_200_data_item_relationships_parcels import (
    GETshipmentsResponse200DataItemRelationshipsParcels,
)
from .ge_tshipments_response_200_data_item_relationships_parcels_data import (
    GETshipmentsResponse200DataItemRelationshipsParcelsData,
)
from .ge_tshipments_response_200_data_item_relationships_parcels_data_type import (
    GETshipmentsResponse200DataItemRelationshipsParcelsDataType,
)
from .ge_tshipments_response_200_data_item_relationships_parcels_links import (
    GETshipmentsResponse200DataItemRelationshipsParcelsLinks,
)
from .ge_tshipments_response_200_data_item_relationships_shipment_line_items import (
    GETshipmentsResponse200DataItemRelationshipsShipmentLineItems,
)
from .ge_tshipments_response_200_data_item_relationships_shipment_line_items_data import (
    GETshipmentsResponse200DataItemRelationshipsShipmentLineItemsData,
)
from .ge_tshipments_response_200_data_item_relationships_shipment_line_items_data_type import (
    GETshipmentsResponse200DataItemRelationshipsShipmentLineItemsDataType,
)
from .ge_tshipments_response_200_data_item_relationships_shipment_line_items_links import (
    GETshipmentsResponse200DataItemRelationshipsShipmentLineItemsLinks,
)
from .ge_tshipments_response_200_data_item_relationships_shipping_address import (
    GETshipmentsResponse200DataItemRelationshipsShippingAddress,
)
from .ge_tshipments_response_200_data_item_relationships_shipping_address_data import (
    GETshipmentsResponse200DataItemRelationshipsShippingAddressData,
)
from .ge_tshipments_response_200_data_item_relationships_shipping_address_data_type import (
    GETshipmentsResponse200DataItemRelationshipsShippingAddressDataType,
)
from .ge_tshipments_response_200_data_item_relationships_shipping_address_links import (
    GETshipmentsResponse200DataItemRelationshipsShippingAddressLinks,
)
from .ge_tshipments_response_200_data_item_relationships_shipping_category import (
    GETshipmentsResponse200DataItemRelationshipsShippingCategory,
)
from .ge_tshipments_response_200_data_item_relationships_shipping_category_data import (
    GETshipmentsResponse200DataItemRelationshipsShippingCategoryData,
)
from .ge_tshipments_response_200_data_item_relationships_shipping_category_data_type import (
    GETshipmentsResponse200DataItemRelationshipsShippingCategoryDataType,
)
from .ge_tshipments_response_200_data_item_relationships_shipping_category_links import (
    GETshipmentsResponse200DataItemRelationshipsShippingCategoryLinks,
)
from .ge_tshipments_response_200_data_item_relationships_shipping_method import (
    GETshipmentsResponse200DataItemRelationshipsShippingMethod,
)
from .ge_tshipments_response_200_data_item_relationships_shipping_method_data import (
    GETshipmentsResponse200DataItemRelationshipsShippingMethodData,
)
from .ge_tshipments_response_200_data_item_relationships_shipping_method_data_type import (
    GETshipmentsResponse200DataItemRelationshipsShippingMethodDataType,
)
from .ge_tshipments_response_200_data_item_relationships_shipping_method_links import (
    GETshipmentsResponse200DataItemRelationshipsShippingMethodLinks,
)
from .ge_tshipments_response_200_data_item_relationships_stock_line_items import (
    GETshipmentsResponse200DataItemRelationshipsStockLineItems,
)
from .ge_tshipments_response_200_data_item_relationships_stock_line_items_data import (
    GETshipmentsResponse200DataItemRelationshipsStockLineItemsData,
)
from .ge_tshipments_response_200_data_item_relationships_stock_line_items_data_type import (
    GETshipmentsResponse200DataItemRelationshipsStockLineItemsDataType,
)
from .ge_tshipments_response_200_data_item_relationships_stock_line_items_links import (
    GETshipmentsResponse200DataItemRelationshipsStockLineItemsLinks,
)
from .ge_tshipments_response_200_data_item_relationships_stock_location import (
    GETshipmentsResponse200DataItemRelationshipsStockLocation,
)
from .ge_tshipments_response_200_data_item_relationships_stock_location_data import (
    GETshipmentsResponse200DataItemRelationshipsStockLocationData,
)
from .ge_tshipments_response_200_data_item_relationships_stock_location_data_type import (
    GETshipmentsResponse200DataItemRelationshipsStockLocationDataType,
)
from .ge_tshipments_response_200_data_item_relationships_stock_location_links import (
    GETshipmentsResponse200DataItemRelationshipsStockLocationLinks,
)
from .ge_tshipments_response_200_data_item_relationships_stock_transfers import (
    GETshipmentsResponse200DataItemRelationshipsStockTransfers,
)
from .ge_tshipments_response_200_data_item_relationships_stock_transfers_data import (
    GETshipmentsResponse200DataItemRelationshipsStockTransfersData,
)
from .ge_tshipments_response_200_data_item_relationships_stock_transfers_data_type import (
    GETshipmentsResponse200DataItemRelationshipsStockTransfersDataType,
)
from .ge_tshipments_response_200_data_item_relationships_stock_transfers_links import (
    GETshipmentsResponse200DataItemRelationshipsStockTransfersLinks,
)
from .ge_tshipments_response_200_data_item_type import GETshipmentsResponse200DataItemType
from .ge_tshipmentsshipment_id_response_200 import GETshipmentsshipmentIdResponse200
from .ge_tshipmentsshipment_id_response_200_data import GETshipmentsshipmentIdResponse200Data
from .ge_tshipmentsshipment_id_response_200_data_attributes import GETshipmentsshipmentIdResponse200DataAttributes
from .ge_tshipmentsshipment_id_response_200_data_attributes_get_rates_errors_item import (
    GETshipmentsshipmentIdResponse200DataAttributesGetRatesErrorsItem,
)
from .ge_tshipmentsshipment_id_response_200_data_attributes_metadata import (
    GETshipmentsshipmentIdResponse200DataAttributesMetadata,
)
from .ge_tshipmentsshipment_id_response_200_data_attributes_rates_item import (
    GETshipmentsshipmentIdResponse200DataAttributesRatesItem,
)
from .ge_tshipmentsshipment_id_response_200_data_links import GETshipmentsshipmentIdResponse200DataLinks
from .ge_tshipmentsshipment_id_response_200_data_relationships import GETshipmentsshipmentIdResponse200DataRelationships
from .ge_tshipmentsshipment_id_response_200_data_relationships_attachments import (
    GETshipmentsshipmentIdResponse200DataRelationshipsAttachments,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_attachments_data import (
    GETshipmentsshipmentIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_attachments_data_type import (
    GETshipmentsshipmentIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_attachments_links import (
    GETshipmentsshipmentIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_available_shipping_methods import (
    GETshipmentsshipmentIdResponse200DataRelationshipsAvailableShippingMethods,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_available_shipping_methods_data import (
    GETshipmentsshipmentIdResponse200DataRelationshipsAvailableShippingMethodsData,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_available_shipping_methods_data_type import (
    GETshipmentsshipmentIdResponse200DataRelationshipsAvailableShippingMethodsDataType,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_available_shipping_methods_links import (
    GETshipmentsshipmentIdResponse200DataRelationshipsAvailableShippingMethodsLinks,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_carrier_accounts import (
    GETshipmentsshipmentIdResponse200DataRelationshipsCarrierAccounts,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_carrier_accounts_data import (
    GETshipmentsshipmentIdResponse200DataRelationshipsCarrierAccountsData,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_carrier_accounts_data_type import (
    GETshipmentsshipmentIdResponse200DataRelationshipsCarrierAccountsDataType,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_carrier_accounts_links import (
    GETshipmentsshipmentIdResponse200DataRelationshipsCarrierAccountsLinks,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_delivery_lead_time import (
    GETshipmentsshipmentIdResponse200DataRelationshipsDeliveryLeadTime,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_delivery_lead_time_data import (
    GETshipmentsshipmentIdResponse200DataRelationshipsDeliveryLeadTimeData,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_delivery_lead_time_data_type import (
    GETshipmentsshipmentIdResponse200DataRelationshipsDeliveryLeadTimeDataType,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_delivery_lead_time_links import (
    GETshipmentsshipmentIdResponse200DataRelationshipsDeliveryLeadTimeLinks,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_events import (
    GETshipmentsshipmentIdResponse200DataRelationshipsEvents,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_events_data import (
    GETshipmentsshipmentIdResponse200DataRelationshipsEventsData,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_events_data_type import (
    GETshipmentsshipmentIdResponse200DataRelationshipsEventsDataType,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_events_links import (
    GETshipmentsshipmentIdResponse200DataRelationshipsEventsLinks,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_order import (
    GETshipmentsshipmentIdResponse200DataRelationshipsOrder,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_order_data import (
    GETshipmentsshipmentIdResponse200DataRelationshipsOrderData,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_order_data_type import (
    GETshipmentsshipmentIdResponse200DataRelationshipsOrderDataType,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_order_links import (
    GETshipmentsshipmentIdResponse200DataRelationshipsOrderLinks,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_origin_address import (
    GETshipmentsshipmentIdResponse200DataRelationshipsOriginAddress,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_origin_address_data import (
    GETshipmentsshipmentIdResponse200DataRelationshipsOriginAddressData,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_origin_address_data_type import (
    GETshipmentsshipmentIdResponse200DataRelationshipsOriginAddressDataType,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_origin_address_links import (
    GETshipmentsshipmentIdResponse200DataRelationshipsOriginAddressLinks,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_parcels import (
    GETshipmentsshipmentIdResponse200DataRelationshipsParcels,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_parcels_data import (
    GETshipmentsshipmentIdResponse200DataRelationshipsParcelsData,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_parcels_data_type import (
    GETshipmentsshipmentIdResponse200DataRelationshipsParcelsDataType,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_parcels_links import (
    GETshipmentsshipmentIdResponse200DataRelationshipsParcelsLinks,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_shipment_line_items import (
    GETshipmentsshipmentIdResponse200DataRelationshipsShipmentLineItems,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_shipment_line_items_data import (
    GETshipmentsshipmentIdResponse200DataRelationshipsShipmentLineItemsData,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_shipment_line_items_data_type import (
    GETshipmentsshipmentIdResponse200DataRelationshipsShipmentLineItemsDataType,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_shipment_line_items_links import (
    GETshipmentsshipmentIdResponse200DataRelationshipsShipmentLineItemsLinks,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_shipping_address import (
    GETshipmentsshipmentIdResponse200DataRelationshipsShippingAddress,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_shipping_address_data import (
    GETshipmentsshipmentIdResponse200DataRelationshipsShippingAddressData,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_shipping_address_data_type import (
    GETshipmentsshipmentIdResponse200DataRelationshipsShippingAddressDataType,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_shipping_address_links import (
    GETshipmentsshipmentIdResponse200DataRelationshipsShippingAddressLinks,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_shipping_category import (
    GETshipmentsshipmentIdResponse200DataRelationshipsShippingCategory,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_shipping_category_data import (
    GETshipmentsshipmentIdResponse200DataRelationshipsShippingCategoryData,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_shipping_category_data_type import (
    GETshipmentsshipmentIdResponse200DataRelationshipsShippingCategoryDataType,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_shipping_category_links import (
    GETshipmentsshipmentIdResponse200DataRelationshipsShippingCategoryLinks,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_shipping_method import (
    GETshipmentsshipmentIdResponse200DataRelationshipsShippingMethod,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_shipping_method_data import (
    GETshipmentsshipmentIdResponse200DataRelationshipsShippingMethodData,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_shipping_method_data_type import (
    GETshipmentsshipmentIdResponse200DataRelationshipsShippingMethodDataType,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_shipping_method_links import (
    GETshipmentsshipmentIdResponse200DataRelationshipsShippingMethodLinks,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_stock_line_items import (
    GETshipmentsshipmentIdResponse200DataRelationshipsStockLineItems,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_stock_line_items_data import (
    GETshipmentsshipmentIdResponse200DataRelationshipsStockLineItemsData,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_stock_line_items_data_type import (
    GETshipmentsshipmentIdResponse200DataRelationshipsStockLineItemsDataType,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_stock_line_items_links import (
    GETshipmentsshipmentIdResponse200DataRelationshipsStockLineItemsLinks,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_stock_location import (
    GETshipmentsshipmentIdResponse200DataRelationshipsStockLocation,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_stock_location_data import (
    GETshipmentsshipmentIdResponse200DataRelationshipsStockLocationData,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_stock_location_data_type import (
    GETshipmentsshipmentIdResponse200DataRelationshipsStockLocationDataType,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_stock_location_links import (
    GETshipmentsshipmentIdResponse200DataRelationshipsStockLocationLinks,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_stock_transfers import (
    GETshipmentsshipmentIdResponse200DataRelationshipsStockTransfers,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_stock_transfers_data import (
    GETshipmentsshipmentIdResponse200DataRelationshipsStockTransfersData,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_stock_transfers_data_type import (
    GETshipmentsshipmentIdResponse200DataRelationshipsStockTransfersDataType,
)
from .ge_tshipmentsshipment_id_response_200_data_relationships_stock_transfers_links import (
    GETshipmentsshipmentIdResponse200DataRelationshipsStockTransfersLinks,
)
from .ge_tshipmentsshipment_id_response_200_data_type import GETshipmentsshipmentIdResponse200DataType
from .ge_tshipping_categories_response_200 import GETshippingCategoriesResponse200
from .ge_tshipping_categories_response_200_data_item import GETshippingCategoriesResponse200DataItem
from .ge_tshipping_categories_response_200_data_item_attributes import (
    GETshippingCategoriesResponse200DataItemAttributes,
)
from .ge_tshipping_categories_response_200_data_item_attributes_metadata import (
    GETshippingCategoriesResponse200DataItemAttributesMetadata,
)
from .ge_tshipping_categories_response_200_data_item_links import GETshippingCategoriesResponse200DataItemLinks
from .ge_tshipping_categories_response_200_data_item_relationships import (
    GETshippingCategoriesResponse200DataItemRelationships,
)
from .ge_tshipping_categories_response_200_data_item_relationships_attachments import (
    GETshippingCategoriesResponse200DataItemRelationshipsAttachments,
)
from .ge_tshipping_categories_response_200_data_item_relationships_attachments_data import (
    GETshippingCategoriesResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tshipping_categories_response_200_data_item_relationships_attachments_data_type import (
    GETshippingCategoriesResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tshipping_categories_response_200_data_item_relationships_attachments_links import (
    GETshippingCategoriesResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tshipping_categories_response_200_data_item_relationships_skus import (
    GETshippingCategoriesResponse200DataItemRelationshipsSkus,
)
from .ge_tshipping_categories_response_200_data_item_relationships_skus_data import (
    GETshippingCategoriesResponse200DataItemRelationshipsSkusData,
)
from .ge_tshipping_categories_response_200_data_item_relationships_skus_data_type import (
    GETshippingCategoriesResponse200DataItemRelationshipsSkusDataType,
)
from .ge_tshipping_categories_response_200_data_item_relationships_skus_links import (
    GETshippingCategoriesResponse200DataItemRelationshipsSkusLinks,
)
from .ge_tshipping_categories_response_200_data_item_type import GETshippingCategoriesResponse200DataItemType
from .ge_tshipping_categoriesshipping_category_id_response_200 import GETshippingCategoriesshippingCategoryIdResponse200
from .ge_tshipping_categoriesshipping_category_id_response_200_data import (
    GETshippingCategoriesshippingCategoryIdResponse200Data,
)
from .ge_tshipping_categoriesshipping_category_id_response_200_data_attributes import (
    GETshippingCategoriesshippingCategoryIdResponse200DataAttributes,
)
from .ge_tshipping_categoriesshipping_category_id_response_200_data_attributes_metadata import (
    GETshippingCategoriesshippingCategoryIdResponse200DataAttributesMetadata,
)
from .ge_tshipping_categoriesshipping_category_id_response_200_data_links import (
    GETshippingCategoriesshippingCategoryIdResponse200DataLinks,
)
from .ge_tshipping_categoriesshipping_category_id_response_200_data_relationships import (
    GETshippingCategoriesshippingCategoryIdResponse200DataRelationships,
)
from .ge_tshipping_categoriesshipping_category_id_response_200_data_relationships_attachments import (
    GETshippingCategoriesshippingCategoryIdResponse200DataRelationshipsAttachments,
)
from .ge_tshipping_categoriesshipping_category_id_response_200_data_relationships_attachments_data import (
    GETshippingCategoriesshippingCategoryIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tshipping_categoriesshipping_category_id_response_200_data_relationships_attachments_data_type import (
    GETshippingCategoriesshippingCategoryIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tshipping_categoriesshipping_category_id_response_200_data_relationships_attachments_links import (
    GETshippingCategoriesshippingCategoryIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tshipping_categoriesshipping_category_id_response_200_data_relationships_skus import (
    GETshippingCategoriesshippingCategoryIdResponse200DataRelationshipsSkus,
)
from .ge_tshipping_categoriesshipping_category_id_response_200_data_relationships_skus_data import (
    GETshippingCategoriesshippingCategoryIdResponse200DataRelationshipsSkusData,
)
from .ge_tshipping_categoriesshipping_category_id_response_200_data_relationships_skus_data_type import (
    GETshippingCategoriesshippingCategoryIdResponse200DataRelationshipsSkusDataType,
)
from .ge_tshipping_categoriesshipping_category_id_response_200_data_relationships_skus_links import (
    GETshippingCategoriesshippingCategoryIdResponse200DataRelationshipsSkusLinks,
)
from .ge_tshipping_categoriesshipping_category_id_response_200_data_type import (
    GETshippingCategoriesshippingCategoryIdResponse200DataType,
)
from .ge_tshipping_method_tiers_response_200 import GETshippingMethodTiersResponse200
from .ge_tshipping_method_tiers_response_200_data_item import GETshippingMethodTiersResponse200DataItem
from .ge_tshipping_method_tiers_response_200_data_item_attributes import (
    GETshippingMethodTiersResponse200DataItemAttributes,
)
from .ge_tshipping_method_tiers_response_200_data_item_attributes_metadata import (
    GETshippingMethodTiersResponse200DataItemAttributesMetadata,
)
from .ge_tshipping_method_tiers_response_200_data_item_links import GETshippingMethodTiersResponse200DataItemLinks
from .ge_tshipping_method_tiers_response_200_data_item_relationships import (
    GETshippingMethodTiersResponse200DataItemRelationships,
)
from .ge_tshipping_method_tiers_response_200_data_item_relationships_attachments import (
    GETshippingMethodTiersResponse200DataItemRelationshipsAttachments,
)
from .ge_tshipping_method_tiers_response_200_data_item_relationships_attachments_data import (
    GETshippingMethodTiersResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tshipping_method_tiers_response_200_data_item_relationships_attachments_data_type import (
    GETshippingMethodTiersResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tshipping_method_tiers_response_200_data_item_relationships_attachments_links import (
    GETshippingMethodTiersResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tshipping_method_tiers_response_200_data_item_relationships_shipping_method import (
    GETshippingMethodTiersResponse200DataItemRelationshipsShippingMethod,
)
from .ge_tshipping_method_tiers_response_200_data_item_relationships_shipping_method_data import (
    GETshippingMethodTiersResponse200DataItemRelationshipsShippingMethodData,
)
from .ge_tshipping_method_tiers_response_200_data_item_relationships_shipping_method_data_type import (
    GETshippingMethodTiersResponse200DataItemRelationshipsShippingMethodDataType,
)
from .ge_tshipping_method_tiers_response_200_data_item_relationships_shipping_method_links import (
    GETshippingMethodTiersResponse200DataItemRelationshipsShippingMethodLinks,
)
from .ge_tshipping_method_tiers_response_200_data_item_type import GETshippingMethodTiersResponse200DataItemType
from .ge_tshipping_method_tiersshipping_method_tier_id_response_200 import (
    GETshippingMethodTiersshippingMethodTierIdResponse200,
)
from .ge_tshipping_method_tiersshipping_method_tier_id_response_200_data import (
    GETshippingMethodTiersshippingMethodTierIdResponse200Data,
)
from .ge_tshipping_method_tiersshipping_method_tier_id_response_200_data_attributes import (
    GETshippingMethodTiersshippingMethodTierIdResponse200DataAttributes,
)
from .ge_tshipping_method_tiersshipping_method_tier_id_response_200_data_attributes_metadata import (
    GETshippingMethodTiersshippingMethodTierIdResponse200DataAttributesMetadata,
)
from .ge_tshipping_method_tiersshipping_method_tier_id_response_200_data_links import (
    GETshippingMethodTiersshippingMethodTierIdResponse200DataLinks,
)
from .ge_tshipping_method_tiersshipping_method_tier_id_response_200_data_relationships import (
    GETshippingMethodTiersshippingMethodTierIdResponse200DataRelationships,
)
from .ge_tshipping_method_tiersshipping_method_tier_id_response_200_data_relationships_attachments import (
    GETshippingMethodTiersshippingMethodTierIdResponse200DataRelationshipsAttachments,
)
from .ge_tshipping_method_tiersshipping_method_tier_id_response_200_data_relationships_attachments_data import (
    GETshippingMethodTiersshippingMethodTierIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tshipping_method_tiersshipping_method_tier_id_response_200_data_relationships_attachments_data_type import (
    GETshippingMethodTiersshippingMethodTierIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tshipping_method_tiersshipping_method_tier_id_response_200_data_relationships_attachments_links import (
    GETshippingMethodTiersshippingMethodTierIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tshipping_method_tiersshipping_method_tier_id_response_200_data_relationships_shipping_method import (
    GETshippingMethodTiersshippingMethodTierIdResponse200DataRelationshipsShippingMethod,
)
from .ge_tshipping_method_tiersshipping_method_tier_id_response_200_data_relationships_shipping_method_data import (
    GETshippingMethodTiersshippingMethodTierIdResponse200DataRelationshipsShippingMethodData,
)
from .ge_tshipping_method_tiersshipping_method_tier_id_response_200_data_relationships_shipping_method_data_type import (
    GETshippingMethodTiersshippingMethodTierIdResponse200DataRelationshipsShippingMethodDataType,
)
from .ge_tshipping_method_tiersshipping_method_tier_id_response_200_data_relationships_shipping_method_links import (
    GETshippingMethodTiersshippingMethodTierIdResponse200DataRelationshipsShippingMethodLinks,
)
from .ge_tshipping_method_tiersshipping_method_tier_id_response_200_data_type import (
    GETshippingMethodTiersshippingMethodTierIdResponse200DataType,
)
from .ge_tshipping_methods_response_200 import GETshippingMethodsResponse200
from .ge_tshipping_methods_response_200_data_item import GETshippingMethodsResponse200DataItem
from .ge_tshipping_methods_response_200_data_item_attributes import GETshippingMethodsResponse200DataItemAttributes
from .ge_tshipping_methods_response_200_data_item_attributes_metadata import (
    GETshippingMethodsResponse200DataItemAttributesMetadata,
)
from .ge_tshipping_methods_response_200_data_item_links import GETshippingMethodsResponse200DataItemLinks
from .ge_tshipping_methods_response_200_data_item_relationships import (
    GETshippingMethodsResponse200DataItemRelationships,
)
from .ge_tshipping_methods_response_200_data_item_relationships_attachments import (
    GETshippingMethodsResponse200DataItemRelationshipsAttachments,
)
from .ge_tshipping_methods_response_200_data_item_relationships_attachments_data import (
    GETshippingMethodsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tshipping_methods_response_200_data_item_relationships_attachments_data_type import (
    GETshippingMethodsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tshipping_methods_response_200_data_item_relationships_attachments_links import (
    GETshippingMethodsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tshipping_methods_response_200_data_item_relationships_delivery_lead_time_for_shipment import (
    GETshippingMethodsResponse200DataItemRelationshipsDeliveryLeadTimeForShipment,
)
from .ge_tshipping_methods_response_200_data_item_relationships_delivery_lead_time_for_shipment_data import (
    GETshippingMethodsResponse200DataItemRelationshipsDeliveryLeadTimeForShipmentData,
)
from .ge_tshipping_methods_response_200_data_item_relationships_delivery_lead_time_for_shipment_data_type import (
    GETshippingMethodsResponse200DataItemRelationshipsDeliveryLeadTimeForShipmentDataType,
)
from .ge_tshipping_methods_response_200_data_item_relationships_delivery_lead_time_for_shipment_links import (
    GETshippingMethodsResponse200DataItemRelationshipsDeliveryLeadTimeForShipmentLinks,
)
from .ge_tshipping_methods_response_200_data_item_relationships_market import (
    GETshippingMethodsResponse200DataItemRelationshipsMarket,
)
from .ge_tshipping_methods_response_200_data_item_relationships_market_data import (
    GETshippingMethodsResponse200DataItemRelationshipsMarketData,
)
from .ge_tshipping_methods_response_200_data_item_relationships_market_data_type import (
    GETshippingMethodsResponse200DataItemRelationshipsMarketDataType,
)
from .ge_tshipping_methods_response_200_data_item_relationships_market_links import (
    GETshippingMethodsResponse200DataItemRelationshipsMarketLinks,
)
from .ge_tshipping_methods_response_200_data_item_relationships_shipping_category import (
    GETshippingMethodsResponse200DataItemRelationshipsShippingCategory,
)
from .ge_tshipping_methods_response_200_data_item_relationships_shipping_category_data import (
    GETshippingMethodsResponse200DataItemRelationshipsShippingCategoryData,
)
from .ge_tshipping_methods_response_200_data_item_relationships_shipping_category_data_type import (
    GETshippingMethodsResponse200DataItemRelationshipsShippingCategoryDataType,
)
from .ge_tshipping_methods_response_200_data_item_relationships_shipping_category_links import (
    GETshippingMethodsResponse200DataItemRelationshipsShippingCategoryLinks,
)
from .ge_tshipping_methods_response_200_data_item_relationships_shipping_method_tiers import (
    GETshippingMethodsResponse200DataItemRelationshipsShippingMethodTiers,
)
from .ge_tshipping_methods_response_200_data_item_relationships_shipping_method_tiers_data import (
    GETshippingMethodsResponse200DataItemRelationshipsShippingMethodTiersData,
)
from .ge_tshipping_methods_response_200_data_item_relationships_shipping_method_tiers_data_type import (
    GETshippingMethodsResponse200DataItemRelationshipsShippingMethodTiersDataType,
)
from .ge_tshipping_methods_response_200_data_item_relationships_shipping_method_tiers_links import (
    GETshippingMethodsResponse200DataItemRelationshipsShippingMethodTiersLinks,
)
from .ge_tshipping_methods_response_200_data_item_relationships_shipping_weight_tiers import (
    GETshippingMethodsResponse200DataItemRelationshipsShippingWeightTiers,
)
from .ge_tshipping_methods_response_200_data_item_relationships_shipping_weight_tiers_data import (
    GETshippingMethodsResponse200DataItemRelationshipsShippingWeightTiersData,
)
from .ge_tshipping_methods_response_200_data_item_relationships_shipping_weight_tiers_data_type import (
    GETshippingMethodsResponse200DataItemRelationshipsShippingWeightTiersDataType,
)
from .ge_tshipping_methods_response_200_data_item_relationships_shipping_weight_tiers_links import (
    GETshippingMethodsResponse200DataItemRelationshipsShippingWeightTiersLinks,
)
from .ge_tshipping_methods_response_200_data_item_relationships_shipping_zone import (
    GETshippingMethodsResponse200DataItemRelationshipsShippingZone,
)
from .ge_tshipping_methods_response_200_data_item_relationships_shipping_zone_data import (
    GETshippingMethodsResponse200DataItemRelationshipsShippingZoneData,
)
from .ge_tshipping_methods_response_200_data_item_relationships_shipping_zone_data_type import (
    GETshippingMethodsResponse200DataItemRelationshipsShippingZoneDataType,
)
from .ge_tshipping_methods_response_200_data_item_relationships_shipping_zone_links import (
    GETshippingMethodsResponse200DataItemRelationshipsShippingZoneLinks,
)
from .ge_tshipping_methods_response_200_data_item_relationships_stock_location import (
    GETshippingMethodsResponse200DataItemRelationshipsStockLocation,
)
from .ge_tshipping_methods_response_200_data_item_relationships_stock_location_data import (
    GETshippingMethodsResponse200DataItemRelationshipsStockLocationData,
)
from .ge_tshipping_methods_response_200_data_item_relationships_stock_location_data_type import (
    GETshippingMethodsResponse200DataItemRelationshipsStockLocationDataType,
)
from .ge_tshipping_methods_response_200_data_item_relationships_stock_location_links import (
    GETshippingMethodsResponse200DataItemRelationshipsStockLocationLinks,
)
from .ge_tshipping_methods_response_200_data_item_type import GETshippingMethodsResponse200DataItemType
from .ge_tshipping_methodsshipping_method_id_response_200 import GETshippingMethodsshippingMethodIdResponse200
from .ge_tshipping_methodsshipping_method_id_response_200_data import GETshippingMethodsshippingMethodIdResponse200Data
from .ge_tshipping_methodsshipping_method_id_response_200_data_attributes import (
    GETshippingMethodsshippingMethodIdResponse200DataAttributes,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_attributes_metadata import (
    GETshippingMethodsshippingMethodIdResponse200DataAttributesMetadata,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_links import (
    GETshippingMethodsshippingMethodIdResponse200DataLinks,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationships,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_attachments import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsAttachments,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_attachments_data import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_attachments_data_type import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_attachments_links import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_delivery_lead_time_for_shipment import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsDeliveryLeadTimeForShipment,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_delivery_lead_time_for_shipment_data import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsDeliveryLeadTimeForShipmentData,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_delivery_lead_time_for_shipment_data_type import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsDeliveryLeadTimeForShipmentDataType,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_delivery_lead_time_for_shipment_links import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsDeliveryLeadTimeForShipmentLinks,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_market import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsMarket,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_market_data import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsMarketData,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_market_data_type import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsMarketDataType,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_market_links import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsMarketLinks,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_shipping_category import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingCategory,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_shipping_category_data import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingCategoryData,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_shipping_category_data_type import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingCategoryDataType,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_shipping_category_links import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingCategoryLinks,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_shipping_method_tiers import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingMethodTiers,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_shipping_method_tiers_data import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingMethodTiersData,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_shipping_method_tiers_data_type import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingMethodTiersDataType,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_shipping_method_tiers_links import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingMethodTiersLinks,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_shipping_weight_tiers import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingWeightTiers,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_shipping_weight_tiers_data import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingWeightTiersData,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_shipping_weight_tiers_data_type import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingWeightTiersDataType,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_shipping_weight_tiers_links import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingWeightTiersLinks,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_shipping_zone import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingZone,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_shipping_zone_data import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingZoneData,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_shipping_zone_data_type import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingZoneDataType,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_shipping_zone_links import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingZoneLinks,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_stock_location import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsStockLocation,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_stock_location_data import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsStockLocationData,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_stock_location_data_type import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsStockLocationDataType,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_relationships_stock_location_links import (
    GETshippingMethodsshippingMethodIdResponse200DataRelationshipsStockLocationLinks,
)
from .ge_tshipping_methodsshipping_method_id_response_200_data_type import (
    GETshippingMethodsshippingMethodIdResponse200DataType,
)
from .ge_tshipping_weight_tiers_response_200 import GETshippingWeightTiersResponse200
from .ge_tshipping_weight_tiers_response_200_data_item import GETshippingWeightTiersResponse200DataItem
from .ge_tshipping_weight_tiers_response_200_data_item_attributes import (
    GETshippingWeightTiersResponse200DataItemAttributes,
)
from .ge_tshipping_weight_tiers_response_200_data_item_attributes_metadata import (
    GETshippingWeightTiersResponse200DataItemAttributesMetadata,
)
from .ge_tshipping_weight_tiers_response_200_data_item_links import GETshippingWeightTiersResponse200DataItemLinks
from .ge_tshipping_weight_tiers_response_200_data_item_relationships import (
    GETshippingWeightTiersResponse200DataItemRelationships,
)
from .ge_tshipping_weight_tiers_response_200_data_item_relationships_attachments import (
    GETshippingWeightTiersResponse200DataItemRelationshipsAttachments,
)
from .ge_tshipping_weight_tiers_response_200_data_item_relationships_attachments_data import (
    GETshippingWeightTiersResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tshipping_weight_tiers_response_200_data_item_relationships_attachments_data_type import (
    GETshippingWeightTiersResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tshipping_weight_tiers_response_200_data_item_relationships_attachments_links import (
    GETshippingWeightTiersResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tshipping_weight_tiers_response_200_data_item_relationships_shipping_method import (
    GETshippingWeightTiersResponse200DataItemRelationshipsShippingMethod,
)
from .ge_tshipping_weight_tiers_response_200_data_item_relationships_shipping_method_data import (
    GETshippingWeightTiersResponse200DataItemRelationshipsShippingMethodData,
)
from .ge_tshipping_weight_tiers_response_200_data_item_relationships_shipping_method_data_type import (
    GETshippingWeightTiersResponse200DataItemRelationshipsShippingMethodDataType,
)
from .ge_tshipping_weight_tiers_response_200_data_item_relationships_shipping_method_links import (
    GETshippingWeightTiersResponse200DataItemRelationshipsShippingMethodLinks,
)
from .ge_tshipping_weight_tiers_response_200_data_item_type import GETshippingWeightTiersResponse200DataItemType
from .ge_tshipping_weight_tiersshipping_weight_tier_id_response_200 import (
    GETshippingWeightTiersshippingWeightTierIdResponse200,
)
from .ge_tshipping_weight_tiersshipping_weight_tier_id_response_200_data import (
    GETshippingWeightTiersshippingWeightTierIdResponse200Data,
)
from .ge_tshipping_weight_tiersshipping_weight_tier_id_response_200_data_attributes import (
    GETshippingWeightTiersshippingWeightTierIdResponse200DataAttributes,
)
from .ge_tshipping_weight_tiersshipping_weight_tier_id_response_200_data_attributes_metadata import (
    GETshippingWeightTiersshippingWeightTierIdResponse200DataAttributesMetadata,
)
from .ge_tshipping_weight_tiersshipping_weight_tier_id_response_200_data_links import (
    GETshippingWeightTiersshippingWeightTierIdResponse200DataLinks,
)
from .ge_tshipping_weight_tiersshipping_weight_tier_id_response_200_data_relationships import (
    GETshippingWeightTiersshippingWeightTierIdResponse200DataRelationships,
)
from .ge_tshipping_weight_tiersshipping_weight_tier_id_response_200_data_relationships_attachments import (
    GETshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsAttachments,
)
from .ge_tshipping_weight_tiersshipping_weight_tier_id_response_200_data_relationships_attachments_data import (
    GETshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tshipping_weight_tiersshipping_weight_tier_id_response_200_data_relationships_attachments_data_type import (
    GETshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tshipping_weight_tiersshipping_weight_tier_id_response_200_data_relationships_attachments_links import (
    GETshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tshipping_weight_tiersshipping_weight_tier_id_response_200_data_relationships_shipping_method import (
    GETshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsShippingMethod,
)
from .ge_tshipping_weight_tiersshipping_weight_tier_id_response_200_data_relationships_shipping_method_data import (
    GETshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsShippingMethodData,
)
from .ge_tshipping_weight_tiersshipping_weight_tier_id_response_200_data_relationships_shipping_method_data_type import (
    GETshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsShippingMethodDataType,
)
from .ge_tshipping_weight_tiersshipping_weight_tier_id_response_200_data_relationships_shipping_method_links import (
    GETshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsShippingMethodLinks,
)
from .ge_tshipping_weight_tiersshipping_weight_tier_id_response_200_data_type import (
    GETshippingWeightTiersshippingWeightTierIdResponse200DataType,
)
from .ge_tshipping_zones_response_200 import GETshippingZonesResponse200
from .ge_tshipping_zones_response_200_data_item import GETshippingZonesResponse200DataItem
from .ge_tshipping_zones_response_200_data_item_attributes import GETshippingZonesResponse200DataItemAttributes
from .ge_tshipping_zones_response_200_data_item_attributes_metadata import (
    GETshippingZonesResponse200DataItemAttributesMetadata,
)
from .ge_tshipping_zones_response_200_data_item_links import GETshippingZonesResponse200DataItemLinks
from .ge_tshipping_zones_response_200_data_item_relationships import GETshippingZonesResponse200DataItemRelationships
from .ge_tshipping_zones_response_200_data_item_relationships_attachments import (
    GETshippingZonesResponse200DataItemRelationshipsAttachments,
)
from .ge_tshipping_zones_response_200_data_item_relationships_attachments_data import (
    GETshippingZonesResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tshipping_zones_response_200_data_item_relationships_attachments_data_type import (
    GETshippingZonesResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tshipping_zones_response_200_data_item_relationships_attachments_links import (
    GETshippingZonesResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tshipping_zones_response_200_data_item_type import GETshippingZonesResponse200DataItemType
from .ge_tshipping_zonesshipping_zone_id_response_200 import GETshippingZonesshippingZoneIdResponse200
from .ge_tshipping_zonesshipping_zone_id_response_200_data import GETshippingZonesshippingZoneIdResponse200Data
from .ge_tshipping_zonesshipping_zone_id_response_200_data_attributes import (
    GETshippingZonesshippingZoneIdResponse200DataAttributes,
)
from .ge_tshipping_zonesshipping_zone_id_response_200_data_attributes_metadata import (
    GETshippingZonesshippingZoneIdResponse200DataAttributesMetadata,
)
from .ge_tshipping_zonesshipping_zone_id_response_200_data_links import (
    GETshippingZonesshippingZoneIdResponse200DataLinks,
)
from .ge_tshipping_zonesshipping_zone_id_response_200_data_relationships import (
    GETshippingZonesshippingZoneIdResponse200DataRelationships,
)
from .ge_tshipping_zonesshipping_zone_id_response_200_data_relationships_attachments import (
    GETshippingZonesshippingZoneIdResponse200DataRelationshipsAttachments,
)
from .ge_tshipping_zonesshipping_zone_id_response_200_data_relationships_attachments_data import (
    GETshippingZonesshippingZoneIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tshipping_zonesshipping_zone_id_response_200_data_relationships_attachments_data_type import (
    GETshippingZonesshippingZoneIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tshipping_zonesshipping_zone_id_response_200_data_relationships_attachments_links import (
    GETshippingZonesshippingZoneIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tshipping_zonesshipping_zone_id_response_200_data_type import GETshippingZonesshippingZoneIdResponse200DataType
from .ge_tsku_list_items_response_200 import GETskuListItemsResponse200
from .ge_tsku_list_items_response_200_data_item import GETskuListItemsResponse200DataItem
from .ge_tsku_list_items_response_200_data_item_attributes import GETskuListItemsResponse200DataItemAttributes
from .ge_tsku_list_items_response_200_data_item_attributes_metadata import (
    GETskuListItemsResponse200DataItemAttributesMetadata,
)
from .ge_tsku_list_items_response_200_data_item_links import GETskuListItemsResponse200DataItemLinks
from .ge_tsku_list_items_response_200_data_item_relationships import GETskuListItemsResponse200DataItemRelationships
from .ge_tsku_list_items_response_200_data_item_relationships_sku import (
    GETskuListItemsResponse200DataItemRelationshipsSku,
)
from .ge_tsku_list_items_response_200_data_item_relationships_sku_data import (
    GETskuListItemsResponse200DataItemRelationshipsSkuData,
)
from .ge_tsku_list_items_response_200_data_item_relationships_sku_data_type import (
    GETskuListItemsResponse200DataItemRelationshipsSkuDataType,
)
from .ge_tsku_list_items_response_200_data_item_relationships_sku_links import (
    GETskuListItemsResponse200DataItemRelationshipsSkuLinks,
)
from .ge_tsku_list_items_response_200_data_item_relationships_sku_list import (
    GETskuListItemsResponse200DataItemRelationshipsSkuList,
)
from .ge_tsku_list_items_response_200_data_item_relationships_sku_list_data import (
    GETskuListItemsResponse200DataItemRelationshipsSkuListData,
)
from .ge_tsku_list_items_response_200_data_item_relationships_sku_list_data_type import (
    GETskuListItemsResponse200DataItemRelationshipsSkuListDataType,
)
from .ge_tsku_list_items_response_200_data_item_relationships_sku_list_links import (
    GETskuListItemsResponse200DataItemRelationshipsSkuListLinks,
)
from .ge_tsku_list_items_response_200_data_item_type import GETskuListItemsResponse200DataItemType
from .ge_tsku_list_itemssku_list_item_id_response_200 import GETskuListItemsskuListItemIdResponse200
from .ge_tsku_list_itemssku_list_item_id_response_200_data import GETskuListItemsskuListItemIdResponse200Data
from .ge_tsku_list_itemssku_list_item_id_response_200_data_attributes import (
    GETskuListItemsskuListItemIdResponse200DataAttributes,
)
from .ge_tsku_list_itemssku_list_item_id_response_200_data_attributes_metadata import (
    GETskuListItemsskuListItemIdResponse200DataAttributesMetadata,
)
from .ge_tsku_list_itemssku_list_item_id_response_200_data_links import GETskuListItemsskuListItemIdResponse200DataLinks
from .ge_tsku_list_itemssku_list_item_id_response_200_data_relationships import (
    GETskuListItemsskuListItemIdResponse200DataRelationships,
)
from .ge_tsku_list_itemssku_list_item_id_response_200_data_relationships_sku import (
    GETskuListItemsskuListItemIdResponse200DataRelationshipsSku,
)
from .ge_tsku_list_itemssku_list_item_id_response_200_data_relationships_sku_data import (
    GETskuListItemsskuListItemIdResponse200DataRelationshipsSkuData,
)
from .ge_tsku_list_itemssku_list_item_id_response_200_data_relationships_sku_data_type import (
    GETskuListItemsskuListItemIdResponse200DataRelationshipsSkuDataType,
)
from .ge_tsku_list_itemssku_list_item_id_response_200_data_relationships_sku_links import (
    GETskuListItemsskuListItemIdResponse200DataRelationshipsSkuLinks,
)
from .ge_tsku_list_itemssku_list_item_id_response_200_data_relationships_sku_list import (
    GETskuListItemsskuListItemIdResponse200DataRelationshipsSkuList,
)
from .ge_tsku_list_itemssku_list_item_id_response_200_data_relationships_sku_list_data import (
    GETskuListItemsskuListItemIdResponse200DataRelationshipsSkuListData,
)
from .ge_tsku_list_itemssku_list_item_id_response_200_data_relationships_sku_list_data_type import (
    GETskuListItemsskuListItemIdResponse200DataRelationshipsSkuListDataType,
)
from .ge_tsku_list_itemssku_list_item_id_response_200_data_relationships_sku_list_links import (
    GETskuListItemsskuListItemIdResponse200DataRelationshipsSkuListLinks,
)
from .ge_tsku_list_itemssku_list_item_id_response_200_data_type import GETskuListItemsskuListItemIdResponse200DataType
from .ge_tsku_list_promotion_rules_response_200 import GETskuListPromotionRulesResponse200
from .ge_tsku_list_promotion_rules_response_200_data_item import GETskuListPromotionRulesResponse200DataItem
from .ge_tsku_list_promotion_rules_response_200_data_item_attributes import (
    GETskuListPromotionRulesResponse200DataItemAttributes,
)
from .ge_tsku_list_promotion_rules_response_200_data_item_attributes_metadata import (
    GETskuListPromotionRulesResponse200DataItemAttributesMetadata,
)
from .ge_tsku_list_promotion_rules_response_200_data_item_links import GETskuListPromotionRulesResponse200DataItemLinks
from .ge_tsku_list_promotion_rules_response_200_data_item_relationships import (
    GETskuListPromotionRulesResponse200DataItemRelationships,
)
from .ge_tsku_list_promotion_rules_response_200_data_item_relationships_promotion import (
    GETskuListPromotionRulesResponse200DataItemRelationshipsPromotion,
)
from .ge_tsku_list_promotion_rules_response_200_data_item_relationships_promotion_data import (
    GETskuListPromotionRulesResponse200DataItemRelationshipsPromotionData,
)
from .ge_tsku_list_promotion_rules_response_200_data_item_relationships_promotion_data_type import (
    GETskuListPromotionRulesResponse200DataItemRelationshipsPromotionDataType,
)
from .ge_tsku_list_promotion_rules_response_200_data_item_relationships_promotion_links import (
    GETskuListPromotionRulesResponse200DataItemRelationshipsPromotionLinks,
)
from .ge_tsku_list_promotion_rules_response_200_data_item_relationships_sku_list import (
    GETskuListPromotionRulesResponse200DataItemRelationshipsSkuList,
)
from .ge_tsku_list_promotion_rules_response_200_data_item_relationships_sku_list_data import (
    GETskuListPromotionRulesResponse200DataItemRelationshipsSkuListData,
)
from .ge_tsku_list_promotion_rules_response_200_data_item_relationships_sku_list_data_type import (
    GETskuListPromotionRulesResponse200DataItemRelationshipsSkuListDataType,
)
from .ge_tsku_list_promotion_rules_response_200_data_item_relationships_sku_list_links import (
    GETskuListPromotionRulesResponse200DataItemRelationshipsSkuListLinks,
)
from .ge_tsku_list_promotion_rules_response_200_data_item_relationships_skus import (
    GETskuListPromotionRulesResponse200DataItemRelationshipsSkus,
)
from .ge_tsku_list_promotion_rules_response_200_data_item_relationships_skus_data import (
    GETskuListPromotionRulesResponse200DataItemRelationshipsSkusData,
)
from .ge_tsku_list_promotion_rules_response_200_data_item_relationships_skus_data_type import (
    GETskuListPromotionRulesResponse200DataItemRelationshipsSkusDataType,
)
from .ge_tsku_list_promotion_rules_response_200_data_item_relationships_skus_links import (
    GETskuListPromotionRulesResponse200DataItemRelationshipsSkusLinks,
)
from .ge_tsku_list_promotion_rules_response_200_data_item_type import GETskuListPromotionRulesResponse200DataItemType
from .ge_tsku_list_promotion_rulessku_list_promotion_rule_id_response_200 import (
    GETskuListPromotionRulesskuListPromotionRuleIdResponse200,
)
from .ge_tsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data import (
    GETskuListPromotionRulesskuListPromotionRuleIdResponse200Data,
)
from .ge_tsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_attributes import (
    GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataAttributes,
)
from .ge_tsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_attributes_metadata import (
    GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataAttributesMetadata,
)
from .ge_tsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_links import (
    GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataLinks,
)
from .ge_tsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_relationships import (
    GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationships,
)
from .ge_tsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_relationships_promotion import (
    GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsPromotion,
)
from .ge_tsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_relationships_promotion_data import (
    GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsPromotionData,
)
from .ge_tsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_relationships_promotion_data_type import (
    GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsPromotionDataType,
)
from .ge_tsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_relationships_promotion_links import (
    GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsPromotionLinks,
)
from .ge_tsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_relationships_sku_list import (
    GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkuList,
)
from .ge_tsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_relationships_sku_list_data import (
    GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkuListData,
)
from .ge_tsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_relationships_sku_list_data_type import (
    GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkuListDataType,
)
from .ge_tsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_relationships_sku_list_links import (
    GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkuListLinks,
)
from .ge_tsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_relationships_skus import (
    GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkus,
)
from .ge_tsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_relationships_skus_data import (
    GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkusData,
)
from .ge_tsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_relationships_skus_data_type import (
    GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkusDataType,
)
from .ge_tsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_relationships_skus_links import (
    GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkusLinks,
)
from .ge_tsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_type import (
    GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataType,
)
from .ge_tsku_lists_response_200 import GETskuListsResponse200
from .ge_tsku_lists_response_200_data_item import GETskuListsResponse200DataItem
from .ge_tsku_lists_response_200_data_item_attributes import GETskuListsResponse200DataItemAttributes
from .ge_tsku_lists_response_200_data_item_attributes_metadata import GETskuListsResponse200DataItemAttributesMetadata
from .ge_tsku_lists_response_200_data_item_links import GETskuListsResponse200DataItemLinks
from .ge_tsku_lists_response_200_data_item_relationships import GETskuListsResponse200DataItemRelationships
from .ge_tsku_lists_response_200_data_item_relationships_attachments import (
    GETskuListsResponse200DataItemRelationshipsAttachments,
)
from .ge_tsku_lists_response_200_data_item_relationships_attachments_data import (
    GETskuListsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tsku_lists_response_200_data_item_relationships_attachments_data_type import (
    GETskuListsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tsku_lists_response_200_data_item_relationships_attachments_links import (
    GETskuListsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tsku_lists_response_200_data_item_relationships_bundles import (
    GETskuListsResponse200DataItemRelationshipsBundles,
)
from .ge_tsku_lists_response_200_data_item_relationships_bundles_data import (
    GETskuListsResponse200DataItemRelationshipsBundlesData,
)
from .ge_tsku_lists_response_200_data_item_relationships_bundles_data_type import (
    GETskuListsResponse200DataItemRelationshipsBundlesDataType,
)
from .ge_tsku_lists_response_200_data_item_relationships_bundles_links import (
    GETskuListsResponse200DataItemRelationshipsBundlesLinks,
)
from .ge_tsku_lists_response_200_data_item_relationships_customer import (
    GETskuListsResponse200DataItemRelationshipsCustomer,
)
from .ge_tsku_lists_response_200_data_item_relationships_customer_data import (
    GETskuListsResponse200DataItemRelationshipsCustomerData,
)
from .ge_tsku_lists_response_200_data_item_relationships_customer_data_type import (
    GETskuListsResponse200DataItemRelationshipsCustomerDataType,
)
from .ge_tsku_lists_response_200_data_item_relationships_customer_links import (
    GETskuListsResponse200DataItemRelationshipsCustomerLinks,
)
from .ge_tsku_lists_response_200_data_item_relationships_sku_list_items import (
    GETskuListsResponse200DataItemRelationshipsSkuListItems,
)
from .ge_tsku_lists_response_200_data_item_relationships_sku_list_items_data import (
    GETskuListsResponse200DataItemRelationshipsSkuListItemsData,
)
from .ge_tsku_lists_response_200_data_item_relationships_sku_list_items_data_type import (
    GETskuListsResponse200DataItemRelationshipsSkuListItemsDataType,
)
from .ge_tsku_lists_response_200_data_item_relationships_sku_list_items_links import (
    GETskuListsResponse200DataItemRelationshipsSkuListItemsLinks,
)
from .ge_tsku_lists_response_200_data_item_relationships_skus import GETskuListsResponse200DataItemRelationshipsSkus
from .ge_tsku_lists_response_200_data_item_relationships_skus_data import (
    GETskuListsResponse200DataItemRelationshipsSkusData,
)
from .ge_tsku_lists_response_200_data_item_relationships_skus_data_type import (
    GETskuListsResponse200DataItemRelationshipsSkusDataType,
)
from .ge_tsku_lists_response_200_data_item_relationships_skus_links import (
    GETskuListsResponse200DataItemRelationshipsSkusLinks,
)
from .ge_tsku_lists_response_200_data_item_type import GETskuListsResponse200DataItemType
from .ge_tsku_listssku_list_id_response_200 import GETskuListsskuListIdResponse200
from .ge_tsku_listssku_list_id_response_200_data import GETskuListsskuListIdResponse200Data
from .ge_tsku_listssku_list_id_response_200_data_attributes import GETskuListsskuListIdResponse200DataAttributes
from .ge_tsku_listssku_list_id_response_200_data_attributes_metadata import (
    GETskuListsskuListIdResponse200DataAttributesMetadata,
)
from .ge_tsku_listssku_list_id_response_200_data_links import GETskuListsskuListIdResponse200DataLinks
from .ge_tsku_listssku_list_id_response_200_data_relationships import GETskuListsskuListIdResponse200DataRelationships
from .ge_tsku_listssku_list_id_response_200_data_relationships_attachments import (
    GETskuListsskuListIdResponse200DataRelationshipsAttachments,
)
from .ge_tsku_listssku_list_id_response_200_data_relationships_attachments_data import (
    GETskuListsskuListIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tsku_listssku_list_id_response_200_data_relationships_attachments_data_type import (
    GETskuListsskuListIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tsku_listssku_list_id_response_200_data_relationships_attachments_links import (
    GETskuListsskuListIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tsku_listssku_list_id_response_200_data_relationships_bundles import (
    GETskuListsskuListIdResponse200DataRelationshipsBundles,
)
from .ge_tsku_listssku_list_id_response_200_data_relationships_bundles_data import (
    GETskuListsskuListIdResponse200DataRelationshipsBundlesData,
)
from .ge_tsku_listssku_list_id_response_200_data_relationships_bundles_data_type import (
    GETskuListsskuListIdResponse200DataRelationshipsBundlesDataType,
)
from .ge_tsku_listssku_list_id_response_200_data_relationships_bundles_links import (
    GETskuListsskuListIdResponse200DataRelationshipsBundlesLinks,
)
from .ge_tsku_listssku_list_id_response_200_data_relationships_customer import (
    GETskuListsskuListIdResponse200DataRelationshipsCustomer,
)
from .ge_tsku_listssku_list_id_response_200_data_relationships_customer_data import (
    GETskuListsskuListIdResponse200DataRelationshipsCustomerData,
)
from .ge_tsku_listssku_list_id_response_200_data_relationships_customer_data_type import (
    GETskuListsskuListIdResponse200DataRelationshipsCustomerDataType,
)
from .ge_tsku_listssku_list_id_response_200_data_relationships_customer_links import (
    GETskuListsskuListIdResponse200DataRelationshipsCustomerLinks,
)
from .ge_tsku_listssku_list_id_response_200_data_relationships_sku_list_items import (
    GETskuListsskuListIdResponse200DataRelationshipsSkuListItems,
)
from .ge_tsku_listssku_list_id_response_200_data_relationships_sku_list_items_data import (
    GETskuListsskuListIdResponse200DataRelationshipsSkuListItemsData,
)
from .ge_tsku_listssku_list_id_response_200_data_relationships_sku_list_items_data_type import (
    GETskuListsskuListIdResponse200DataRelationshipsSkuListItemsDataType,
)
from .ge_tsku_listssku_list_id_response_200_data_relationships_sku_list_items_links import (
    GETskuListsskuListIdResponse200DataRelationshipsSkuListItemsLinks,
)
from .ge_tsku_listssku_list_id_response_200_data_relationships_skus import (
    GETskuListsskuListIdResponse200DataRelationshipsSkus,
)
from .ge_tsku_listssku_list_id_response_200_data_relationships_skus_data import (
    GETskuListsskuListIdResponse200DataRelationshipsSkusData,
)
from .ge_tsku_listssku_list_id_response_200_data_relationships_skus_data_type import (
    GETskuListsskuListIdResponse200DataRelationshipsSkusDataType,
)
from .ge_tsku_listssku_list_id_response_200_data_relationships_skus_links import (
    GETskuListsskuListIdResponse200DataRelationshipsSkusLinks,
)
from .ge_tsku_listssku_list_id_response_200_data_type import GETskuListsskuListIdResponse200DataType
from .ge_tsku_options_response_200 import GETskuOptionsResponse200
from .ge_tsku_options_response_200_data_item import GETskuOptionsResponse200DataItem
from .ge_tsku_options_response_200_data_item_attributes import GETskuOptionsResponse200DataItemAttributes
from .ge_tsku_options_response_200_data_item_attributes_metadata import (
    GETskuOptionsResponse200DataItemAttributesMetadata,
)
from .ge_tsku_options_response_200_data_item_links import GETskuOptionsResponse200DataItemLinks
from .ge_tsku_options_response_200_data_item_relationships import GETskuOptionsResponse200DataItemRelationships
from .ge_tsku_options_response_200_data_item_relationships_attachments import (
    GETskuOptionsResponse200DataItemRelationshipsAttachments,
)
from .ge_tsku_options_response_200_data_item_relationships_attachments_data import (
    GETskuOptionsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tsku_options_response_200_data_item_relationships_attachments_data_type import (
    GETskuOptionsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tsku_options_response_200_data_item_relationships_attachments_links import (
    GETskuOptionsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tsku_options_response_200_data_item_relationships_market import (
    GETskuOptionsResponse200DataItemRelationshipsMarket,
)
from .ge_tsku_options_response_200_data_item_relationships_market_data import (
    GETskuOptionsResponse200DataItemRelationshipsMarketData,
)
from .ge_tsku_options_response_200_data_item_relationships_market_data_type import (
    GETskuOptionsResponse200DataItemRelationshipsMarketDataType,
)
from .ge_tsku_options_response_200_data_item_relationships_market_links import (
    GETskuOptionsResponse200DataItemRelationshipsMarketLinks,
)
from .ge_tsku_options_response_200_data_item_type import GETskuOptionsResponse200DataItemType
from .ge_tsku_optionssku_option_id_response_200 import GETskuOptionsskuOptionIdResponse200
from .ge_tsku_optionssku_option_id_response_200_data import GETskuOptionsskuOptionIdResponse200Data
from .ge_tsku_optionssku_option_id_response_200_data_attributes import GETskuOptionsskuOptionIdResponse200DataAttributes
from .ge_tsku_optionssku_option_id_response_200_data_attributes_metadata import (
    GETskuOptionsskuOptionIdResponse200DataAttributesMetadata,
)
from .ge_tsku_optionssku_option_id_response_200_data_links import GETskuOptionsskuOptionIdResponse200DataLinks
from .ge_tsku_optionssku_option_id_response_200_data_relationships import (
    GETskuOptionsskuOptionIdResponse200DataRelationships,
)
from .ge_tsku_optionssku_option_id_response_200_data_relationships_attachments import (
    GETskuOptionsskuOptionIdResponse200DataRelationshipsAttachments,
)
from .ge_tsku_optionssku_option_id_response_200_data_relationships_attachments_data import (
    GETskuOptionsskuOptionIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tsku_optionssku_option_id_response_200_data_relationships_attachments_data_type import (
    GETskuOptionsskuOptionIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tsku_optionssku_option_id_response_200_data_relationships_attachments_links import (
    GETskuOptionsskuOptionIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tsku_optionssku_option_id_response_200_data_relationships_market import (
    GETskuOptionsskuOptionIdResponse200DataRelationshipsMarket,
)
from .ge_tsku_optionssku_option_id_response_200_data_relationships_market_data import (
    GETskuOptionsskuOptionIdResponse200DataRelationshipsMarketData,
)
from .ge_tsku_optionssku_option_id_response_200_data_relationships_market_data_type import (
    GETskuOptionsskuOptionIdResponse200DataRelationshipsMarketDataType,
)
from .ge_tsku_optionssku_option_id_response_200_data_relationships_market_links import (
    GETskuOptionsskuOptionIdResponse200DataRelationshipsMarketLinks,
)
from .ge_tsku_optionssku_option_id_response_200_data_type import GETskuOptionsskuOptionIdResponse200DataType
from .ge_tskus_response_200 import GETskusResponse200
from .ge_tskus_response_200_data_item import GETskusResponse200DataItem
from .ge_tskus_response_200_data_item_attributes import GETskusResponse200DataItemAttributes
from .ge_tskus_response_200_data_item_attributes_inventory import GETskusResponse200DataItemAttributesInventory
from .ge_tskus_response_200_data_item_attributes_metadata import GETskusResponse200DataItemAttributesMetadata
from .ge_tskus_response_200_data_item_links import GETskusResponse200DataItemLinks
from .ge_tskus_response_200_data_item_relationships import GETskusResponse200DataItemRelationships
from .ge_tskus_response_200_data_item_relationships_attachments import (
    GETskusResponse200DataItemRelationshipsAttachments,
)
from .ge_tskus_response_200_data_item_relationships_attachments_data import (
    GETskusResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tskus_response_200_data_item_relationships_attachments_data_type import (
    GETskusResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tskus_response_200_data_item_relationships_attachments_links import (
    GETskusResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tskus_response_200_data_item_relationships_delivery_lead_times import (
    GETskusResponse200DataItemRelationshipsDeliveryLeadTimes,
)
from .ge_tskus_response_200_data_item_relationships_delivery_lead_times_data import (
    GETskusResponse200DataItemRelationshipsDeliveryLeadTimesData,
)
from .ge_tskus_response_200_data_item_relationships_delivery_lead_times_data_type import (
    GETskusResponse200DataItemRelationshipsDeliveryLeadTimesDataType,
)
from .ge_tskus_response_200_data_item_relationships_delivery_lead_times_links import (
    GETskusResponse200DataItemRelationshipsDeliveryLeadTimesLinks,
)
from .ge_tskus_response_200_data_item_relationships_prices import GETskusResponse200DataItemRelationshipsPrices
from .ge_tskus_response_200_data_item_relationships_prices_data import GETskusResponse200DataItemRelationshipsPricesData
from .ge_tskus_response_200_data_item_relationships_prices_data_type import (
    GETskusResponse200DataItemRelationshipsPricesDataType,
)
from .ge_tskus_response_200_data_item_relationships_prices_links import (
    GETskusResponse200DataItemRelationshipsPricesLinks,
)
from .ge_tskus_response_200_data_item_relationships_shipping_category import (
    GETskusResponse200DataItemRelationshipsShippingCategory,
)
from .ge_tskus_response_200_data_item_relationships_shipping_category_data import (
    GETskusResponse200DataItemRelationshipsShippingCategoryData,
)
from .ge_tskus_response_200_data_item_relationships_shipping_category_data_type import (
    GETskusResponse200DataItemRelationshipsShippingCategoryDataType,
)
from .ge_tskus_response_200_data_item_relationships_shipping_category_links import (
    GETskusResponse200DataItemRelationshipsShippingCategoryLinks,
)
from .ge_tskus_response_200_data_item_relationships_sku_options import GETskusResponse200DataItemRelationshipsSkuOptions
from .ge_tskus_response_200_data_item_relationships_sku_options_data import (
    GETskusResponse200DataItemRelationshipsSkuOptionsData,
)
from .ge_tskus_response_200_data_item_relationships_sku_options_data_type import (
    GETskusResponse200DataItemRelationshipsSkuOptionsDataType,
)
from .ge_tskus_response_200_data_item_relationships_sku_options_links import (
    GETskusResponse200DataItemRelationshipsSkuOptionsLinks,
)
from .ge_tskus_response_200_data_item_relationships_stock_items import GETskusResponse200DataItemRelationshipsStockItems
from .ge_tskus_response_200_data_item_relationships_stock_items_data import (
    GETskusResponse200DataItemRelationshipsStockItemsData,
)
from .ge_tskus_response_200_data_item_relationships_stock_items_data_type import (
    GETskusResponse200DataItemRelationshipsStockItemsDataType,
)
from .ge_tskus_response_200_data_item_relationships_stock_items_links import (
    GETskusResponse200DataItemRelationshipsStockItemsLinks,
)
from .ge_tskus_response_200_data_item_type import GETskusResponse200DataItemType
from .ge_tskussku_id_response_200 import GETskusskuIdResponse200
from .ge_tskussku_id_response_200_data import GETskusskuIdResponse200Data
from .ge_tskussku_id_response_200_data_attributes import GETskusskuIdResponse200DataAttributes
from .ge_tskussku_id_response_200_data_attributes_inventory import GETskusskuIdResponse200DataAttributesInventory
from .ge_tskussku_id_response_200_data_attributes_metadata import GETskusskuIdResponse200DataAttributesMetadata
from .ge_tskussku_id_response_200_data_links import GETskusskuIdResponse200DataLinks
from .ge_tskussku_id_response_200_data_relationships import GETskusskuIdResponse200DataRelationships
from .ge_tskussku_id_response_200_data_relationships_attachments import (
    GETskusskuIdResponse200DataRelationshipsAttachments,
)
from .ge_tskussku_id_response_200_data_relationships_attachments_data import (
    GETskusskuIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tskussku_id_response_200_data_relationships_attachments_data_type import (
    GETskusskuIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tskussku_id_response_200_data_relationships_attachments_links import (
    GETskusskuIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tskussku_id_response_200_data_relationships_delivery_lead_times import (
    GETskusskuIdResponse200DataRelationshipsDeliveryLeadTimes,
)
from .ge_tskussku_id_response_200_data_relationships_delivery_lead_times_data import (
    GETskusskuIdResponse200DataRelationshipsDeliveryLeadTimesData,
)
from .ge_tskussku_id_response_200_data_relationships_delivery_lead_times_data_type import (
    GETskusskuIdResponse200DataRelationshipsDeliveryLeadTimesDataType,
)
from .ge_tskussku_id_response_200_data_relationships_delivery_lead_times_links import (
    GETskusskuIdResponse200DataRelationshipsDeliveryLeadTimesLinks,
)
from .ge_tskussku_id_response_200_data_relationships_prices import GETskusskuIdResponse200DataRelationshipsPrices
from .ge_tskussku_id_response_200_data_relationships_prices_data import (
    GETskusskuIdResponse200DataRelationshipsPricesData,
)
from .ge_tskussku_id_response_200_data_relationships_prices_data_type import (
    GETskusskuIdResponse200DataRelationshipsPricesDataType,
)
from .ge_tskussku_id_response_200_data_relationships_prices_links import (
    GETskusskuIdResponse200DataRelationshipsPricesLinks,
)
from .ge_tskussku_id_response_200_data_relationships_shipping_category import (
    GETskusskuIdResponse200DataRelationshipsShippingCategory,
)
from .ge_tskussku_id_response_200_data_relationships_shipping_category_data import (
    GETskusskuIdResponse200DataRelationshipsShippingCategoryData,
)
from .ge_tskussku_id_response_200_data_relationships_shipping_category_data_type import (
    GETskusskuIdResponse200DataRelationshipsShippingCategoryDataType,
)
from .ge_tskussku_id_response_200_data_relationships_shipping_category_links import (
    GETskusskuIdResponse200DataRelationshipsShippingCategoryLinks,
)
from .ge_tskussku_id_response_200_data_relationships_sku_options import (
    GETskusskuIdResponse200DataRelationshipsSkuOptions,
)
from .ge_tskussku_id_response_200_data_relationships_sku_options_data import (
    GETskusskuIdResponse200DataRelationshipsSkuOptionsData,
)
from .ge_tskussku_id_response_200_data_relationships_sku_options_data_type import (
    GETskusskuIdResponse200DataRelationshipsSkuOptionsDataType,
)
from .ge_tskussku_id_response_200_data_relationships_sku_options_links import (
    GETskusskuIdResponse200DataRelationshipsSkuOptionsLinks,
)
from .ge_tskussku_id_response_200_data_relationships_stock_items import (
    GETskusskuIdResponse200DataRelationshipsStockItems,
)
from .ge_tskussku_id_response_200_data_relationships_stock_items_data import (
    GETskusskuIdResponse200DataRelationshipsStockItemsData,
)
from .ge_tskussku_id_response_200_data_relationships_stock_items_data_type import (
    GETskusskuIdResponse200DataRelationshipsStockItemsDataType,
)
from .ge_tskussku_id_response_200_data_relationships_stock_items_links import (
    GETskusskuIdResponse200DataRelationshipsStockItemsLinks,
)
from .ge_tskussku_id_response_200_data_type import GETskusskuIdResponse200DataType
from .ge_tstock_items_response_200 import GETstockItemsResponse200
from .ge_tstock_items_response_200_data_item import GETstockItemsResponse200DataItem
from .ge_tstock_items_response_200_data_item_attributes import GETstockItemsResponse200DataItemAttributes
from .ge_tstock_items_response_200_data_item_attributes_metadata import (
    GETstockItemsResponse200DataItemAttributesMetadata,
)
from .ge_tstock_items_response_200_data_item_links import GETstockItemsResponse200DataItemLinks
from .ge_tstock_items_response_200_data_item_relationships import GETstockItemsResponse200DataItemRelationships
from .ge_tstock_items_response_200_data_item_relationships_attachments import (
    GETstockItemsResponse200DataItemRelationshipsAttachments,
)
from .ge_tstock_items_response_200_data_item_relationships_attachments_data import (
    GETstockItemsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tstock_items_response_200_data_item_relationships_attachments_data_type import (
    GETstockItemsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tstock_items_response_200_data_item_relationships_attachments_links import (
    GETstockItemsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tstock_items_response_200_data_item_relationships_sku import GETstockItemsResponse200DataItemRelationshipsSku
from .ge_tstock_items_response_200_data_item_relationships_sku_data import (
    GETstockItemsResponse200DataItemRelationshipsSkuData,
)
from .ge_tstock_items_response_200_data_item_relationships_sku_data_type import (
    GETstockItemsResponse200DataItemRelationshipsSkuDataType,
)
from .ge_tstock_items_response_200_data_item_relationships_sku_links import (
    GETstockItemsResponse200DataItemRelationshipsSkuLinks,
)
from .ge_tstock_items_response_200_data_item_relationships_stock_location import (
    GETstockItemsResponse200DataItemRelationshipsStockLocation,
)
from .ge_tstock_items_response_200_data_item_relationships_stock_location_data import (
    GETstockItemsResponse200DataItemRelationshipsStockLocationData,
)
from .ge_tstock_items_response_200_data_item_relationships_stock_location_data_type import (
    GETstockItemsResponse200DataItemRelationshipsStockLocationDataType,
)
from .ge_tstock_items_response_200_data_item_relationships_stock_location_links import (
    GETstockItemsResponse200DataItemRelationshipsStockLocationLinks,
)
from .ge_tstock_items_response_200_data_item_type import GETstockItemsResponse200DataItemType
from .ge_tstock_itemsstock_item_id_response_200 import GETstockItemsstockItemIdResponse200
from .ge_tstock_itemsstock_item_id_response_200_data import GETstockItemsstockItemIdResponse200Data
from .ge_tstock_itemsstock_item_id_response_200_data_attributes import GETstockItemsstockItemIdResponse200DataAttributes
from .ge_tstock_itemsstock_item_id_response_200_data_attributes_metadata import (
    GETstockItemsstockItemIdResponse200DataAttributesMetadata,
)
from .ge_tstock_itemsstock_item_id_response_200_data_links import GETstockItemsstockItemIdResponse200DataLinks
from .ge_tstock_itemsstock_item_id_response_200_data_relationships import (
    GETstockItemsstockItemIdResponse200DataRelationships,
)
from .ge_tstock_itemsstock_item_id_response_200_data_relationships_attachments import (
    GETstockItemsstockItemIdResponse200DataRelationshipsAttachments,
)
from .ge_tstock_itemsstock_item_id_response_200_data_relationships_attachments_data import (
    GETstockItemsstockItemIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tstock_itemsstock_item_id_response_200_data_relationships_attachments_data_type import (
    GETstockItemsstockItemIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tstock_itemsstock_item_id_response_200_data_relationships_attachments_links import (
    GETstockItemsstockItemIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tstock_itemsstock_item_id_response_200_data_relationships_sku import (
    GETstockItemsstockItemIdResponse200DataRelationshipsSku,
)
from .ge_tstock_itemsstock_item_id_response_200_data_relationships_sku_data import (
    GETstockItemsstockItemIdResponse200DataRelationshipsSkuData,
)
from .ge_tstock_itemsstock_item_id_response_200_data_relationships_sku_data_type import (
    GETstockItemsstockItemIdResponse200DataRelationshipsSkuDataType,
)
from .ge_tstock_itemsstock_item_id_response_200_data_relationships_sku_links import (
    GETstockItemsstockItemIdResponse200DataRelationshipsSkuLinks,
)
from .ge_tstock_itemsstock_item_id_response_200_data_relationships_stock_location import (
    GETstockItemsstockItemIdResponse200DataRelationshipsStockLocation,
)
from .ge_tstock_itemsstock_item_id_response_200_data_relationships_stock_location_data import (
    GETstockItemsstockItemIdResponse200DataRelationshipsStockLocationData,
)
from .ge_tstock_itemsstock_item_id_response_200_data_relationships_stock_location_data_type import (
    GETstockItemsstockItemIdResponse200DataRelationshipsStockLocationDataType,
)
from .ge_tstock_itemsstock_item_id_response_200_data_relationships_stock_location_links import (
    GETstockItemsstockItemIdResponse200DataRelationshipsStockLocationLinks,
)
from .ge_tstock_itemsstock_item_id_response_200_data_type import GETstockItemsstockItemIdResponse200DataType
from .ge_tstock_line_items_response_200 import GETstockLineItemsResponse200
from .ge_tstock_line_items_response_200_data_item import GETstockLineItemsResponse200DataItem
from .ge_tstock_line_items_response_200_data_item_attributes import GETstockLineItemsResponse200DataItemAttributes
from .ge_tstock_line_items_response_200_data_item_attributes_metadata import (
    GETstockLineItemsResponse200DataItemAttributesMetadata,
)
from .ge_tstock_line_items_response_200_data_item_links import GETstockLineItemsResponse200DataItemLinks
from .ge_tstock_line_items_response_200_data_item_relationships import GETstockLineItemsResponse200DataItemRelationships
from .ge_tstock_line_items_response_200_data_item_relationships_line_item import (
    GETstockLineItemsResponse200DataItemRelationshipsLineItem,
)
from .ge_tstock_line_items_response_200_data_item_relationships_line_item_data import (
    GETstockLineItemsResponse200DataItemRelationshipsLineItemData,
)
from .ge_tstock_line_items_response_200_data_item_relationships_line_item_data_type import (
    GETstockLineItemsResponse200DataItemRelationshipsLineItemDataType,
)
from .ge_tstock_line_items_response_200_data_item_relationships_line_item_links import (
    GETstockLineItemsResponse200DataItemRelationshipsLineItemLinks,
)
from .ge_tstock_line_items_response_200_data_item_relationships_shipment import (
    GETstockLineItemsResponse200DataItemRelationshipsShipment,
)
from .ge_tstock_line_items_response_200_data_item_relationships_shipment_data import (
    GETstockLineItemsResponse200DataItemRelationshipsShipmentData,
)
from .ge_tstock_line_items_response_200_data_item_relationships_shipment_data_type import (
    GETstockLineItemsResponse200DataItemRelationshipsShipmentDataType,
)
from .ge_tstock_line_items_response_200_data_item_relationships_shipment_links import (
    GETstockLineItemsResponse200DataItemRelationshipsShipmentLinks,
)
from .ge_tstock_line_items_response_200_data_item_relationships_stock_item import (
    GETstockLineItemsResponse200DataItemRelationshipsStockItem,
)
from .ge_tstock_line_items_response_200_data_item_relationships_stock_item_data import (
    GETstockLineItemsResponse200DataItemRelationshipsStockItemData,
)
from .ge_tstock_line_items_response_200_data_item_relationships_stock_item_data_type import (
    GETstockLineItemsResponse200DataItemRelationshipsStockItemDataType,
)
from .ge_tstock_line_items_response_200_data_item_relationships_stock_item_links import (
    GETstockLineItemsResponse200DataItemRelationshipsStockItemLinks,
)
from .ge_tstock_line_items_response_200_data_item_type import GETstockLineItemsResponse200DataItemType
from .ge_tstock_line_itemsstock_line_item_id_response_200 import GETstockLineItemsstockLineItemIdResponse200
from .ge_tstock_line_itemsstock_line_item_id_response_200_data import GETstockLineItemsstockLineItemIdResponse200Data
from .ge_tstock_line_itemsstock_line_item_id_response_200_data_attributes import (
    GETstockLineItemsstockLineItemIdResponse200DataAttributes,
)
from .ge_tstock_line_itemsstock_line_item_id_response_200_data_attributes_metadata import (
    GETstockLineItemsstockLineItemIdResponse200DataAttributesMetadata,
)
from .ge_tstock_line_itemsstock_line_item_id_response_200_data_links import (
    GETstockLineItemsstockLineItemIdResponse200DataLinks,
)
from .ge_tstock_line_itemsstock_line_item_id_response_200_data_relationships import (
    GETstockLineItemsstockLineItemIdResponse200DataRelationships,
)
from .ge_tstock_line_itemsstock_line_item_id_response_200_data_relationships_line_item import (
    GETstockLineItemsstockLineItemIdResponse200DataRelationshipsLineItem,
)
from .ge_tstock_line_itemsstock_line_item_id_response_200_data_relationships_line_item_data import (
    GETstockLineItemsstockLineItemIdResponse200DataRelationshipsLineItemData,
)
from .ge_tstock_line_itemsstock_line_item_id_response_200_data_relationships_line_item_data_type import (
    GETstockLineItemsstockLineItemIdResponse200DataRelationshipsLineItemDataType,
)
from .ge_tstock_line_itemsstock_line_item_id_response_200_data_relationships_line_item_links import (
    GETstockLineItemsstockLineItemIdResponse200DataRelationshipsLineItemLinks,
)
from .ge_tstock_line_itemsstock_line_item_id_response_200_data_relationships_shipment import (
    GETstockLineItemsstockLineItemIdResponse200DataRelationshipsShipment,
)
from .ge_tstock_line_itemsstock_line_item_id_response_200_data_relationships_shipment_data import (
    GETstockLineItemsstockLineItemIdResponse200DataRelationshipsShipmentData,
)
from .ge_tstock_line_itemsstock_line_item_id_response_200_data_relationships_shipment_data_type import (
    GETstockLineItemsstockLineItemIdResponse200DataRelationshipsShipmentDataType,
)
from .ge_tstock_line_itemsstock_line_item_id_response_200_data_relationships_shipment_links import (
    GETstockLineItemsstockLineItemIdResponse200DataRelationshipsShipmentLinks,
)
from .ge_tstock_line_itemsstock_line_item_id_response_200_data_relationships_stock_item import (
    GETstockLineItemsstockLineItemIdResponse200DataRelationshipsStockItem,
)
from .ge_tstock_line_itemsstock_line_item_id_response_200_data_relationships_stock_item_data import (
    GETstockLineItemsstockLineItemIdResponse200DataRelationshipsStockItemData,
)
from .ge_tstock_line_itemsstock_line_item_id_response_200_data_relationships_stock_item_data_type import (
    GETstockLineItemsstockLineItemIdResponse200DataRelationshipsStockItemDataType,
)
from .ge_tstock_line_itemsstock_line_item_id_response_200_data_relationships_stock_item_links import (
    GETstockLineItemsstockLineItemIdResponse200DataRelationshipsStockItemLinks,
)
from .ge_tstock_line_itemsstock_line_item_id_response_200_data_type import (
    GETstockLineItemsstockLineItemIdResponse200DataType,
)
from .ge_tstock_locations_response_200 import GETstockLocationsResponse200
from .ge_tstock_locations_response_200_data_item import GETstockLocationsResponse200DataItem
from .ge_tstock_locations_response_200_data_item_attributes import GETstockLocationsResponse200DataItemAttributes
from .ge_tstock_locations_response_200_data_item_attributes_metadata import (
    GETstockLocationsResponse200DataItemAttributesMetadata,
)
from .ge_tstock_locations_response_200_data_item_links import GETstockLocationsResponse200DataItemLinks
from .ge_tstock_locations_response_200_data_item_relationships import GETstockLocationsResponse200DataItemRelationships
from .ge_tstock_locations_response_200_data_item_relationships_address import (
    GETstockLocationsResponse200DataItemRelationshipsAddress,
)
from .ge_tstock_locations_response_200_data_item_relationships_address_data import (
    GETstockLocationsResponse200DataItemRelationshipsAddressData,
)
from .ge_tstock_locations_response_200_data_item_relationships_address_data_type import (
    GETstockLocationsResponse200DataItemRelationshipsAddressDataType,
)
from .ge_tstock_locations_response_200_data_item_relationships_address_links import (
    GETstockLocationsResponse200DataItemRelationshipsAddressLinks,
)
from .ge_tstock_locations_response_200_data_item_relationships_attachments import (
    GETstockLocationsResponse200DataItemRelationshipsAttachments,
)
from .ge_tstock_locations_response_200_data_item_relationships_attachments_data import (
    GETstockLocationsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_tstock_locations_response_200_data_item_relationships_attachments_data_type import (
    GETstockLocationsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_tstock_locations_response_200_data_item_relationships_attachments_links import (
    GETstockLocationsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_tstock_locations_response_200_data_item_relationships_inventory_return_locations import (
    GETstockLocationsResponse200DataItemRelationshipsInventoryReturnLocations,
)
from .ge_tstock_locations_response_200_data_item_relationships_inventory_return_locations_data import (
    GETstockLocationsResponse200DataItemRelationshipsInventoryReturnLocationsData,
)
from .ge_tstock_locations_response_200_data_item_relationships_inventory_return_locations_data_type import (
    GETstockLocationsResponse200DataItemRelationshipsInventoryReturnLocationsDataType,
)
from .ge_tstock_locations_response_200_data_item_relationships_inventory_return_locations_links import (
    GETstockLocationsResponse200DataItemRelationshipsInventoryReturnLocationsLinks,
)
from .ge_tstock_locations_response_200_data_item_relationships_inventory_stock_locations import (
    GETstockLocationsResponse200DataItemRelationshipsInventoryStockLocations,
)
from .ge_tstock_locations_response_200_data_item_relationships_inventory_stock_locations_data import (
    GETstockLocationsResponse200DataItemRelationshipsInventoryStockLocationsData,
)
from .ge_tstock_locations_response_200_data_item_relationships_inventory_stock_locations_data_type import (
    GETstockLocationsResponse200DataItemRelationshipsInventoryStockLocationsDataType,
)
from .ge_tstock_locations_response_200_data_item_relationships_inventory_stock_locations_links import (
    GETstockLocationsResponse200DataItemRelationshipsInventoryStockLocationsLinks,
)
from .ge_tstock_locations_response_200_data_item_relationships_stock_items import (
    GETstockLocationsResponse200DataItemRelationshipsStockItems,
)
from .ge_tstock_locations_response_200_data_item_relationships_stock_items_data import (
    GETstockLocationsResponse200DataItemRelationshipsStockItemsData,
)
from .ge_tstock_locations_response_200_data_item_relationships_stock_items_data_type import (
    GETstockLocationsResponse200DataItemRelationshipsStockItemsDataType,
)
from .ge_tstock_locations_response_200_data_item_relationships_stock_items_links import (
    GETstockLocationsResponse200DataItemRelationshipsStockItemsLinks,
)
from .ge_tstock_locations_response_200_data_item_relationships_stock_transfers import (
    GETstockLocationsResponse200DataItemRelationshipsStockTransfers,
)
from .ge_tstock_locations_response_200_data_item_relationships_stock_transfers_data import (
    GETstockLocationsResponse200DataItemRelationshipsStockTransfersData,
)
from .ge_tstock_locations_response_200_data_item_relationships_stock_transfers_data_type import (
    GETstockLocationsResponse200DataItemRelationshipsStockTransfersDataType,
)
from .ge_tstock_locations_response_200_data_item_relationships_stock_transfers_links import (
    GETstockLocationsResponse200DataItemRelationshipsStockTransfersLinks,
)
from .ge_tstock_locations_response_200_data_item_type import GETstockLocationsResponse200DataItemType
from .ge_tstock_locationsstock_location_id_response_200 import GETstockLocationsstockLocationIdResponse200
from .ge_tstock_locationsstock_location_id_response_200_data import GETstockLocationsstockLocationIdResponse200Data
from .ge_tstock_locationsstock_location_id_response_200_data_attributes import (
    GETstockLocationsstockLocationIdResponse200DataAttributes,
)
from .ge_tstock_locationsstock_location_id_response_200_data_attributes_metadata import (
    GETstockLocationsstockLocationIdResponse200DataAttributesMetadata,
)
from .ge_tstock_locationsstock_location_id_response_200_data_links import (
    GETstockLocationsstockLocationIdResponse200DataLinks,
)
from .ge_tstock_locationsstock_location_id_response_200_data_relationships import (
    GETstockLocationsstockLocationIdResponse200DataRelationships,
)
from .ge_tstock_locationsstock_location_id_response_200_data_relationships_address import (
    GETstockLocationsstockLocationIdResponse200DataRelationshipsAddress,
)
from .ge_tstock_locationsstock_location_id_response_200_data_relationships_address_data import (
    GETstockLocationsstockLocationIdResponse200DataRelationshipsAddressData,
)
from .ge_tstock_locationsstock_location_id_response_200_data_relationships_address_data_type import (
    GETstockLocationsstockLocationIdResponse200DataRelationshipsAddressDataType,
)
from .ge_tstock_locationsstock_location_id_response_200_data_relationships_address_links import (
    GETstockLocationsstockLocationIdResponse200DataRelationshipsAddressLinks,
)
from .ge_tstock_locationsstock_location_id_response_200_data_relationships_attachments import (
    GETstockLocationsstockLocationIdResponse200DataRelationshipsAttachments,
)
from .ge_tstock_locationsstock_location_id_response_200_data_relationships_attachments_data import (
    GETstockLocationsstockLocationIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_tstock_locationsstock_location_id_response_200_data_relationships_attachments_data_type import (
    GETstockLocationsstockLocationIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_tstock_locationsstock_location_id_response_200_data_relationships_attachments_links import (
    GETstockLocationsstockLocationIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_tstock_locationsstock_location_id_response_200_data_relationships_inventory_return_locations import (
    GETstockLocationsstockLocationIdResponse200DataRelationshipsInventoryReturnLocations,
)
from .ge_tstock_locationsstock_location_id_response_200_data_relationships_inventory_return_locations_data import (
    GETstockLocationsstockLocationIdResponse200DataRelationshipsInventoryReturnLocationsData,
)
from .ge_tstock_locationsstock_location_id_response_200_data_relationships_inventory_return_locations_data_type import (
    GETstockLocationsstockLocationIdResponse200DataRelationshipsInventoryReturnLocationsDataType,
)
from .ge_tstock_locationsstock_location_id_response_200_data_relationships_inventory_return_locations_links import (
    GETstockLocationsstockLocationIdResponse200DataRelationshipsInventoryReturnLocationsLinks,
)
from .ge_tstock_locationsstock_location_id_response_200_data_relationships_inventory_stock_locations import (
    GETstockLocationsstockLocationIdResponse200DataRelationshipsInventoryStockLocations,
)
from .ge_tstock_locationsstock_location_id_response_200_data_relationships_inventory_stock_locations_data import (
    GETstockLocationsstockLocationIdResponse200DataRelationshipsInventoryStockLocationsData,
)
from .ge_tstock_locationsstock_location_id_response_200_data_relationships_inventory_stock_locations_data_type import (
    GETstockLocationsstockLocationIdResponse200DataRelationshipsInventoryStockLocationsDataType,
)
from .ge_tstock_locationsstock_location_id_response_200_data_relationships_inventory_stock_locations_links import (
    GETstockLocationsstockLocationIdResponse200DataRelationshipsInventoryStockLocationsLinks,
)
from .ge_tstock_locationsstock_location_id_response_200_data_relationships_stock_items import (
    GETstockLocationsstockLocationIdResponse200DataRelationshipsStockItems,
)
from .ge_tstock_locationsstock_location_id_response_200_data_relationships_stock_items_data import (
    GETstockLocationsstockLocationIdResponse200DataRelationshipsStockItemsData,
)
from .ge_tstock_locationsstock_location_id_response_200_data_relationships_stock_items_data_type import (
    GETstockLocationsstockLocationIdResponse200DataRelationshipsStockItemsDataType,
)
from .ge_tstock_locationsstock_location_id_response_200_data_relationships_stock_items_links import (
    GETstockLocationsstockLocationIdResponse200DataRelationshipsStockItemsLinks,
)
from .ge_tstock_locationsstock_location_id_response_200_data_relationships_stock_transfers import (
    GETstockLocationsstockLocationIdResponse200DataRelationshipsStockTransfers,
)
from .ge_tstock_locationsstock_location_id_response_200_data_relationships_stock_transfers_data import (
    GETstockLocationsstockLocationIdResponse200DataRelationshipsStockTransfersData,
)
from .ge_tstock_locationsstock_location_id_response_200_data_relationships_stock_transfers_data_type import (
    GETstockLocationsstockLocationIdResponse200DataRelationshipsStockTransfersDataType,
)
from .ge_tstock_locationsstock_location_id_response_200_data_relationships_stock_transfers_links import (
    GETstockLocationsstockLocationIdResponse200DataRelationshipsStockTransfersLinks,
)
from .ge_tstock_locationsstock_location_id_response_200_data_type import (
    GETstockLocationsstockLocationIdResponse200DataType,
)
from .ge_tstock_transfers_response_200 import GETstockTransfersResponse200
from .ge_tstock_transfers_response_200_data_item import GETstockTransfersResponse200DataItem
from .ge_tstock_transfers_response_200_data_item_attributes import GETstockTransfersResponse200DataItemAttributes
from .ge_tstock_transfers_response_200_data_item_attributes_metadata import (
    GETstockTransfersResponse200DataItemAttributesMetadata,
)
from .ge_tstock_transfers_response_200_data_item_links import GETstockTransfersResponse200DataItemLinks
from .ge_tstock_transfers_response_200_data_item_relationships import GETstockTransfersResponse200DataItemRelationships
from .ge_tstock_transfers_response_200_data_item_relationships_destination_stock_location import (
    GETstockTransfersResponse200DataItemRelationshipsDestinationStockLocation,
)
from .ge_tstock_transfers_response_200_data_item_relationships_destination_stock_location_data import (
    GETstockTransfersResponse200DataItemRelationshipsDestinationStockLocationData,
)
from .ge_tstock_transfers_response_200_data_item_relationships_destination_stock_location_data_type import (
    GETstockTransfersResponse200DataItemRelationshipsDestinationStockLocationDataType,
)
from .ge_tstock_transfers_response_200_data_item_relationships_destination_stock_location_links import (
    GETstockTransfersResponse200DataItemRelationshipsDestinationStockLocationLinks,
)
from .ge_tstock_transfers_response_200_data_item_relationships_events import (
    GETstockTransfersResponse200DataItemRelationshipsEvents,
)
from .ge_tstock_transfers_response_200_data_item_relationships_events_data import (
    GETstockTransfersResponse200DataItemRelationshipsEventsData,
)
from .ge_tstock_transfers_response_200_data_item_relationships_events_data_type import (
    GETstockTransfersResponse200DataItemRelationshipsEventsDataType,
)
from .ge_tstock_transfers_response_200_data_item_relationships_events_links import (
    GETstockTransfersResponse200DataItemRelationshipsEventsLinks,
)
from .ge_tstock_transfers_response_200_data_item_relationships_line_item import (
    GETstockTransfersResponse200DataItemRelationshipsLineItem,
)
from .ge_tstock_transfers_response_200_data_item_relationships_line_item_data import (
    GETstockTransfersResponse200DataItemRelationshipsLineItemData,
)
from .ge_tstock_transfers_response_200_data_item_relationships_line_item_data_type import (
    GETstockTransfersResponse200DataItemRelationshipsLineItemDataType,
)
from .ge_tstock_transfers_response_200_data_item_relationships_line_item_links import (
    GETstockTransfersResponse200DataItemRelationshipsLineItemLinks,
)
from .ge_tstock_transfers_response_200_data_item_relationships_origin_stock_location import (
    GETstockTransfersResponse200DataItemRelationshipsOriginStockLocation,
)
from .ge_tstock_transfers_response_200_data_item_relationships_origin_stock_location_data import (
    GETstockTransfersResponse200DataItemRelationshipsOriginStockLocationData,
)
from .ge_tstock_transfers_response_200_data_item_relationships_origin_stock_location_data_type import (
    GETstockTransfersResponse200DataItemRelationshipsOriginStockLocationDataType,
)
from .ge_tstock_transfers_response_200_data_item_relationships_origin_stock_location_links import (
    GETstockTransfersResponse200DataItemRelationshipsOriginStockLocationLinks,
)
from .ge_tstock_transfers_response_200_data_item_relationships_shipment import (
    GETstockTransfersResponse200DataItemRelationshipsShipment,
)
from .ge_tstock_transfers_response_200_data_item_relationships_shipment_data import (
    GETstockTransfersResponse200DataItemRelationshipsShipmentData,
)
from .ge_tstock_transfers_response_200_data_item_relationships_shipment_data_type import (
    GETstockTransfersResponse200DataItemRelationshipsShipmentDataType,
)
from .ge_tstock_transfers_response_200_data_item_relationships_shipment_links import (
    GETstockTransfersResponse200DataItemRelationshipsShipmentLinks,
)
from .ge_tstock_transfers_response_200_data_item_relationships_sku import (
    GETstockTransfersResponse200DataItemRelationshipsSku,
)
from .ge_tstock_transfers_response_200_data_item_relationships_sku_data import (
    GETstockTransfersResponse200DataItemRelationshipsSkuData,
)
from .ge_tstock_transfers_response_200_data_item_relationships_sku_data_type import (
    GETstockTransfersResponse200DataItemRelationshipsSkuDataType,
)
from .ge_tstock_transfers_response_200_data_item_relationships_sku_links import (
    GETstockTransfersResponse200DataItemRelationshipsSkuLinks,
)
from .ge_tstock_transfers_response_200_data_item_type import GETstockTransfersResponse200DataItemType
from .ge_tstock_transfersstock_transfer_id_response_200 import GETstockTransfersstockTransferIdResponse200
from .ge_tstock_transfersstock_transfer_id_response_200_data import GETstockTransfersstockTransferIdResponse200Data
from .ge_tstock_transfersstock_transfer_id_response_200_data_attributes import (
    GETstockTransfersstockTransferIdResponse200DataAttributes,
)
from .ge_tstock_transfersstock_transfer_id_response_200_data_attributes_metadata import (
    GETstockTransfersstockTransferIdResponse200DataAttributesMetadata,
)
from .ge_tstock_transfersstock_transfer_id_response_200_data_links import (
    GETstockTransfersstockTransferIdResponse200DataLinks,
)
from .ge_tstock_transfersstock_transfer_id_response_200_data_relationships import (
    GETstockTransfersstockTransferIdResponse200DataRelationships,
)
from .ge_tstock_transfersstock_transfer_id_response_200_data_relationships_destination_stock_location import (
    GETstockTransfersstockTransferIdResponse200DataRelationshipsDestinationStockLocation,
)
from .ge_tstock_transfersstock_transfer_id_response_200_data_relationships_destination_stock_location_data import (
    GETstockTransfersstockTransferIdResponse200DataRelationshipsDestinationStockLocationData,
)
from .ge_tstock_transfersstock_transfer_id_response_200_data_relationships_destination_stock_location_data_type import (
    GETstockTransfersstockTransferIdResponse200DataRelationshipsDestinationStockLocationDataType,
)
from .ge_tstock_transfersstock_transfer_id_response_200_data_relationships_destination_stock_location_links import (
    GETstockTransfersstockTransferIdResponse200DataRelationshipsDestinationStockLocationLinks,
)
from .ge_tstock_transfersstock_transfer_id_response_200_data_relationships_events import (
    GETstockTransfersstockTransferIdResponse200DataRelationshipsEvents,
)
from .ge_tstock_transfersstock_transfer_id_response_200_data_relationships_events_data import (
    GETstockTransfersstockTransferIdResponse200DataRelationshipsEventsData,
)
from .ge_tstock_transfersstock_transfer_id_response_200_data_relationships_events_data_type import (
    GETstockTransfersstockTransferIdResponse200DataRelationshipsEventsDataType,
)
from .ge_tstock_transfersstock_transfer_id_response_200_data_relationships_events_links import (
    GETstockTransfersstockTransferIdResponse200DataRelationshipsEventsLinks,
)
from .ge_tstock_transfersstock_transfer_id_response_200_data_relationships_line_item import (
    GETstockTransfersstockTransferIdResponse200DataRelationshipsLineItem,
)
from .ge_tstock_transfersstock_transfer_id_response_200_data_relationships_line_item_data import (
    GETstockTransfersstockTransferIdResponse200DataRelationshipsLineItemData,
)
from .ge_tstock_transfersstock_transfer_id_response_200_data_relationships_line_item_data_type import (
    GETstockTransfersstockTransferIdResponse200DataRelationshipsLineItemDataType,
)
from .ge_tstock_transfersstock_transfer_id_response_200_data_relationships_line_item_links import (
    GETstockTransfersstockTransferIdResponse200DataRelationshipsLineItemLinks,
)
from .ge_tstock_transfersstock_transfer_id_response_200_data_relationships_origin_stock_location import (
    GETstockTransfersstockTransferIdResponse200DataRelationshipsOriginStockLocation,
)
from .ge_tstock_transfersstock_transfer_id_response_200_data_relationships_origin_stock_location_data import (
    GETstockTransfersstockTransferIdResponse200DataRelationshipsOriginStockLocationData,
)
from .ge_tstock_transfersstock_transfer_id_response_200_data_relationships_origin_stock_location_data_type import (
    GETstockTransfersstockTransferIdResponse200DataRelationshipsOriginStockLocationDataType,
)
from .ge_tstock_transfersstock_transfer_id_response_200_data_relationships_origin_stock_location_links import (
    GETstockTransfersstockTransferIdResponse200DataRelationshipsOriginStockLocationLinks,
)
from .ge_tstock_transfersstock_transfer_id_response_200_data_relationships_shipment import (
    GETstockTransfersstockTransferIdResponse200DataRelationshipsShipment,
)
from .ge_tstock_transfersstock_transfer_id_response_200_data_relationships_shipment_data import (
    GETstockTransfersstockTransferIdResponse200DataRelationshipsShipmentData,
)
from .ge_tstock_transfersstock_transfer_id_response_200_data_relationships_shipment_data_type import (
    GETstockTransfersstockTransferIdResponse200DataRelationshipsShipmentDataType,
)
from .ge_tstock_transfersstock_transfer_id_response_200_data_relationships_shipment_links import (
    GETstockTransfersstockTransferIdResponse200DataRelationshipsShipmentLinks,
)
from .ge_tstock_transfersstock_transfer_id_response_200_data_relationships_sku import (
    GETstockTransfersstockTransferIdResponse200DataRelationshipsSku,
)
from .ge_tstock_transfersstock_transfer_id_response_200_data_relationships_sku_data import (
    GETstockTransfersstockTransferIdResponse200DataRelationshipsSkuData,
)
from .ge_tstock_transfersstock_transfer_id_response_200_data_relationships_sku_data_type import (
    GETstockTransfersstockTransferIdResponse200DataRelationshipsSkuDataType,
)
from .ge_tstock_transfersstock_transfer_id_response_200_data_relationships_sku_links import (
    GETstockTransfersstockTransferIdResponse200DataRelationshipsSkuLinks,
)
from .ge_tstock_transfersstock_transfer_id_response_200_data_type import (
    GETstockTransfersstockTransferIdResponse200DataType,
)
from .ge_tstripe_gateways_response_200 import GETstripeGatewaysResponse200
from .ge_tstripe_gateways_response_200_data_item import GETstripeGatewaysResponse200DataItem
from .ge_tstripe_gateways_response_200_data_item_attributes import GETstripeGatewaysResponse200DataItemAttributes
from .ge_tstripe_gateways_response_200_data_item_attributes_metadata import (
    GETstripeGatewaysResponse200DataItemAttributesMetadata,
)
from .ge_tstripe_gateways_response_200_data_item_links import GETstripeGatewaysResponse200DataItemLinks
from .ge_tstripe_gateways_response_200_data_item_relationships import GETstripeGatewaysResponse200DataItemRelationships
from .ge_tstripe_gateways_response_200_data_item_relationships_payment_methods import (
    GETstripeGatewaysResponse200DataItemRelationshipsPaymentMethods,
)
from .ge_tstripe_gateways_response_200_data_item_relationships_payment_methods_data import (
    GETstripeGatewaysResponse200DataItemRelationshipsPaymentMethodsData,
)
from .ge_tstripe_gateways_response_200_data_item_relationships_payment_methods_data_type import (
    GETstripeGatewaysResponse200DataItemRelationshipsPaymentMethodsDataType,
)
from .ge_tstripe_gateways_response_200_data_item_relationships_payment_methods_links import (
    GETstripeGatewaysResponse200DataItemRelationshipsPaymentMethodsLinks,
)
from .ge_tstripe_gateways_response_200_data_item_relationships_stripe_payments import (
    GETstripeGatewaysResponse200DataItemRelationshipsStripePayments,
)
from .ge_tstripe_gateways_response_200_data_item_relationships_stripe_payments_data import (
    GETstripeGatewaysResponse200DataItemRelationshipsStripePaymentsData,
)
from .ge_tstripe_gateways_response_200_data_item_relationships_stripe_payments_data_type import (
    GETstripeGatewaysResponse200DataItemRelationshipsStripePaymentsDataType,
)
from .ge_tstripe_gateways_response_200_data_item_relationships_stripe_payments_links import (
    GETstripeGatewaysResponse200DataItemRelationshipsStripePaymentsLinks,
)
from .ge_tstripe_gateways_response_200_data_item_type import GETstripeGatewaysResponse200DataItemType
from .ge_tstripe_gatewaysstripe_gateway_id_response_200 import GETstripeGatewaysstripeGatewayIdResponse200
from .ge_tstripe_gatewaysstripe_gateway_id_response_200_data import GETstripeGatewaysstripeGatewayIdResponse200Data
from .ge_tstripe_gatewaysstripe_gateway_id_response_200_data_attributes import (
    GETstripeGatewaysstripeGatewayIdResponse200DataAttributes,
)
from .ge_tstripe_gatewaysstripe_gateway_id_response_200_data_attributes_metadata import (
    GETstripeGatewaysstripeGatewayIdResponse200DataAttributesMetadata,
)
from .ge_tstripe_gatewaysstripe_gateway_id_response_200_data_links import (
    GETstripeGatewaysstripeGatewayIdResponse200DataLinks,
)
from .ge_tstripe_gatewaysstripe_gateway_id_response_200_data_relationships import (
    GETstripeGatewaysstripeGatewayIdResponse200DataRelationships,
)
from .ge_tstripe_gatewaysstripe_gateway_id_response_200_data_relationships_payment_methods import (
    GETstripeGatewaysstripeGatewayIdResponse200DataRelationshipsPaymentMethods,
)
from .ge_tstripe_gatewaysstripe_gateway_id_response_200_data_relationships_payment_methods_data import (
    GETstripeGatewaysstripeGatewayIdResponse200DataRelationshipsPaymentMethodsData,
)
from .ge_tstripe_gatewaysstripe_gateway_id_response_200_data_relationships_payment_methods_data_type import (
    GETstripeGatewaysstripeGatewayIdResponse200DataRelationshipsPaymentMethodsDataType,
)
from .ge_tstripe_gatewaysstripe_gateway_id_response_200_data_relationships_payment_methods_links import (
    GETstripeGatewaysstripeGatewayIdResponse200DataRelationshipsPaymentMethodsLinks,
)
from .ge_tstripe_gatewaysstripe_gateway_id_response_200_data_relationships_stripe_payments import (
    GETstripeGatewaysstripeGatewayIdResponse200DataRelationshipsStripePayments,
)
from .ge_tstripe_gatewaysstripe_gateway_id_response_200_data_relationships_stripe_payments_data import (
    GETstripeGatewaysstripeGatewayIdResponse200DataRelationshipsStripePaymentsData,
)
from .ge_tstripe_gatewaysstripe_gateway_id_response_200_data_relationships_stripe_payments_data_type import (
    GETstripeGatewaysstripeGatewayIdResponse200DataRelationshipsStripePaymentsDataType,
)
from .ge_tstripe_gatewaysstripe_gateway_id_response_200_data_relationships_stripe_payments_links import (
    GETstripeGatewaysstripeGatewayIdResponse200DataRelationshipsStripePaymentsLinks,
)
from .ge_tstripe_gatewaysstripe_gateway_id_response_200_data_type import (
    GETstripeGatewaysstripeGatewayIdResponse200DataType,
)
from .ge_tstripe_payments_response_200 import GETstripePaymentsResponse200
from .ge_tstripe_payments_response_200_data_item import GETstripePaymentsResponse200DataItem
from .ge_tstripe_payments_response_200_data_item_attributes import GETstripePaymentsResponse200DataItemAttributes
from .ge_tstripe_payments_response_200_data_item_attributes_metadata import (
    GETstripePaymentsResponse200DataItemAttributesMetadata,
)
from .ge_tstripe_payments_response_200_data_item_attributes_options import (
    GETstripePaymentsResponse200DataItemAttributesOptions,
)
from .ge_tstripe_payments_response_200_data_item_attributes_payment_method import (
    GETstripePaymentsResponse200DataItemAttributesPaymentMethod,
)
from .ge_tstripe_payments_response_200_data_item_links import GETstripePaymentsResponse200DataItemLinks
from .ge_tstripe_payments_response_200_data_item_relationships import GETstripePaymentsResponse200DataItemRelationships
from .ge_tstripe_payments_response_200_data_item_relationships_order import (
    GETstripePaymentsResponse200DataItemRelationshipsOrder,
)
from .ge_tstripe_payments_response_200_data_item_relationships_order_data import (
    GETstripePaymentsResponse200DataItemRelationshipsOrderData,
)
from .ge_tstripe_payments_response_200_data_item_relationships_order_data_type import (
    GETstripePaymentsResponse200DataItemRelationshipsOrderDataType,
)
from .ge_tstripe_payments_response_200_data_item_relationships_order_links import (
    GETstripePaymentsResponse200DataItemRelationshipsOrderLinks,
)
from .ge_tstripe_payments_response_200_data_item_relationships_payment_gateway import (
    GETstripePaymentsResponse200DataItemRelationshipsPaymentGateway,
)
from .ge_tstripe_payments_response_200_data_item_relationships_payment_gateway_data import (
    GETstripePaymentsResponse200DataItemRelationshipsPaymentGatewayData,
)
from .ge_tstripe_payments_response_200_data_item_relationships_payment_gateway_data_type import (
    GETstripePaymentsResponse200DataItemRelationshipsPaymentGatewayDataType,
)
from .ge_tstripe_payments_response_200_data_item_relationships_payment_gateway_links import (
    GETstripePaymentsResponse200DataItemRelationshipsPaymentGatewayLinks,
)
from .ge_tstripe_payments_response_200_data_item_type import GETstripePaymentsResponse200DataItemType
from .ge_tstripe_paymentsstripe_payment_id_response_200 import GETstripePaymentsstripePaymentIdResponse200
from .ge_tstripe_paymentsstripe_payment_id_response_200_data import GETstripePaymentsstripePaymentIdResponse200Data
from .ge_tstripe_paymentsstripe_payment_id_response_200_data_attributes import (
    GETstripePaymentsstripePaymentIdResponse200DataAttributes,
)
from .ge_tstripe_paymentsstripe_payment_id_response_200_data_attributes_metadata import (
    GETstripePaymentsstripePaymentIdResponse200DataAttributesMetadata,
)
from .ge_tstripe_paymentsstripe_payment_id_response_200_data_attributes_options import (
    GETstripePaymentsstripePaymentIdResponse200DataAttributesOptions,
)
from .ge_tstripe_paymentsstripe_payment_id_response_200_data_attributes_payment_method import (
    GETstripePaymentsstripePaymentIdResponse200DataAttributesPaymentMethod,
)
from .ge_tstripe_paymentsstripe_payment_id_response_200_data_links import (
    GETstripePaymentsstripePaymentIdResponse200DataLinks,
)
from .ge_tstripe_paymentsstripe_payment_id_response_200_data_relationships import (
    GETstripePaymentsstripePaymentIdResponse200DataRelationships,
)
from .ge_tstripe_paymentsstripe_payment_id_response_200_data_relationships_order import (
    GETstripePaymentsstripePaymentIdResponse200DataRelationshipsOrder,
)
from .ge_tstripe_paymentsstripe_payment_id_response_200_data_relationships_order_data import (
    GETstripePaymentsstripePaymentIdResponse200DataRelationshipsOrderData,
)
from .ge_tstripe_paymentsstripe_payment_id_response_200_data_relationships_order_data_type import (
    GETstripePaymentsstripePaymentIdResponse200DataRelationshipsOrderDataType,
)
from .ge_tstripe_paymentsstripe_payment_id_response_200_data_relationships_order_links import (
    GETstripePaymentsstripePaymentIdResponse200DataRelationshipsOrderLinks,
)
from .ge_tstripe_paymentsstripe_payment_id_response_200_data_relationships_payment_gateway import (
    GETstripePaymentsstripePaymentIdResponse200DataRelationshipsPaymentGateway,
)
from .ge_tstripe_paymentsstripe_payment_id_response_200_data_relationships_payment_gateway_data import (
    GETstripePaymentsstripePaymentIdResponse200DataRelationshipsPaymentGatewayData,
)
from .ge_tstripe_paymentsstripe_payment_id_response_200_data_relationships_payment_gateway_data_type import (
    GETstripePaymentsstripePaymentIdResponse200DataRelationshipsPaymentGatewayDataType,
)
from .ge_tstripe_paymentsstripe_payment_id_response_200_data_relationships_payment_gateway_links import (
    GETstripePaymentsstripePaymentIdResponse200DataRelationshipsPaymentGatewayLinks,
)
from .ge_tstripe_paymentsstripe_payment_id_response_200_data_type import (
    GETstripePaymentsstripePaymentIdResponse200DataType,
)
from .ge_ttax_calculators_response_200 import GETtaxCalculatorsResponse200
from .ge_ttax_calculators_response_200_data_item import GETtaxCalculatorsResponse200DataItem
from .ge_ttax_calculators_response_200_data_item_attributes import GETtaxCalculatorsResponse200DataItemAttributes
from .ge_ttax_calculators_response_200_data_item_attributes_metadata import (
    GETtaxCalculatorsResponse200DataItemAttributesMetadata,
)
from .ge_ttax_calculators_response_200_data_item_links import GETtaxCalculatorsResponse200DataItemLinks
from .ge_ttax_calculators_response_200_data_item_relationships import GETtaxCalculatorsResponse200DataItemRelationships
from .ge_ttax_calculators_response_200_data_item_relationships_attachments import (
    GETtaxCalculatorsResponse200DataItemRelationshipsAttachments,
)
from .ge_ttax_calculators_response_200_data_item_relationships_attachments_data import (
    GETtaxCalculatorsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_ttax_calculators_response_200_data_item_relationships_attachments_data_type import (
    GETtaxCalculatorsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_ttax_calculators_response_200_data_item_relationships_attachments_links import (
    GETtaxCalculatorsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_ttax_calculators_response_200_data_item_relationships_markets import (
    GETtaxCalculatorsResponse200DataItemRelationshipsMarkets,
)
from .ge_ttax_calculators_response_200_data_item_relationships_markets_data import (
    GETtaxCalculatorsResponse200DataItemRelationshipsMarketsData,
)
from .ge_ttax_calculators_response_200_data_item_relationships_markets_data_type import (
    GETtaxCalculatorsResponse200DataItemRelationshipsMarketsDataType,
)
from .ge_ttax_calculators_response_200_data_item_relationships_markets_links import (
    GETtaxCalculatorsResponse200DataItemRelationshipsMarketsLinks,
)
from .ge_ttax_calculators_response_200_data_item_type import GETtaxCalculatorsResponse200DataItemType
from .ge_ttax_calculatorstax_calculator_id_response_200 import GETtaxCalculatorstaxCalculatorIdResponse200
from .ge_ttax_calculatorstax_calculator_id_response_200_data import GETtaxCalculatorstaxCalculatorIdResponse200Data
from .ge_ttax_calculatorstax_calculator_id_response_200_data_attributes import (
    GETtaxCalculatorstaxCalculatorIdResponse200DataAttributes,
)
from .ge_ttax_calculatorstax_calculator_id_response_200_data_attributes_metadata import (
    GETtaxCalculatorstaxCalculatorIdResponse200DataAttributesMetadata,
)
from .ge_ttax_calculatorstax_calculator_id_response_200_data_links import (
    GETtaxCalculatorstaxCalculatorIdResponse200DataLinks,
)
from .ge_ttax_calculatorstax_calculator_id_response_200_data_relationships import (
    GETtaxCalculatorstaxCalculatorIdResponse200DataRelationships,
)
from .ge_ttax_calculatorstax_calculator_id_response_200_data_relationships_attachments import (
    GETtaxCalculatorstaxCalculatorIdResponse200DataRelationshipsAttachments,
)
from .ge_ttax_calculatorstax_calculator_id_response_200_data_relationships_attachments_data import (
    GETtaxCalculatorstaxCalculatorIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_ttax_calculatorstax_calculator_id_response_200_data_relationships_attachments_data_type import (
    GETtaxCalculatorstaxCalculatorIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_ttax_calculatorstax_calculator_id_response_200_data_relationships_attachments_links import (
    GETtaxCalculatorstaxCalculatorIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_ttax_calculatorstax_calculator_id_response_200_data_relationships_markets import (
    GETtaxCalculatorstaxCalculatorIdResponse200DataRelationshipsMarkets,
)
from .ge_ttax_calculatorstax_calculator_id_response_200_data_relationships_markets_data import (
    GETtaxCalculatorstaxCalculatorIdResponse200DataRelationshipsMarketsData,
)
from .ge_ttax_calculatorstax_calculator_id_response_200_data_relationships_markets_data_type import (
    GETtaxCalculatorstaxCalculatorIdResponse200DataRelationshipsMarketsDataType,
)
from .ge_ttax_calculatorstax_calculator_id_response_200_data_relationships_markets_links import (
    GETtaxCalculatorstaxCalculatorIdResponse200DataRelationshipsMarketsLinks,
)
from .ge_ttax_calculatorstax_calculator_id_response_200_data_type import (
    GETtaxCalculatorstaxCalculatorIdResponse200DataType,
)
from .ge_ttax_categories_response_200 import GETtaxCategoriesResponse200
from .ge_ttax_categories_response_200_data_item import GETtaxCategoriesResponse200DataItem
from .ge_ttax_categories_response_200_data_item_attributes import GETtaxCategoriesResponse200DataItemAttributes
from .ge_ttax_categories_response_200_data_item_attributes_metadata import (
    GETtaxCategoriesResponse200DataItemAttributesMetadata,
)
from .ge_ttax_categories_response_200_data_item_links import GETtaxCategoriesResponse200DataItemLinks
from .ge_ttax_categories_response_200_data_item_relationships import GETtaxCategoriesResponse200DataItemRelationships
from .ge_ttax_categories_response_200_data_item_relationships_attachments import (
    GETtaxCategoriesResponse200DataItemRelationshipsAttachments,
)
from .ge_ttax_categories_response_200_data_item_relationships_attachments_data import (
    GETtaxCategoriesResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_ttax_categories_response_200_data_item_relationships_attachments_data_type import (
    GETtaxCategoriesResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_ttax_categories_response_200_data_item_relationships_attachments_links import (
    GETtaxCategoriesResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_ttax_categories_response_200_data_item_relationships_sku import (
    GETtaxCategoriesResponse200DataItemRelationshipsSku,
)
from .ge_ttax_categories_response_200_data_item_relationships_sku_data import (
    GETtaxCategoriesResponse200DataItemRelationshipsSkuData,
)
from .ge_ttax_categories_response_200_data_item_relationships_sku_data_type import (
    GETtaxCategoriesResponse200DataItemRelationshipsSkuDataType,
)
from .ge_ttax_categories_response_200_data_item_relationships_sku_links import (
    GETtaxCategoriesResponse200DataItemRelationshipsSkuLinks,
)
from .ge_ttax_categories_response_200_data_item_relationships_tax_calculator import (
    GETtaxCategoriesResponse200DataItemRelationshipsTaxCalculator,
)
from .ge_ttax_categories_response_200_data_item_relationships_tax_calculator_data import (
    GETtaxCategoriesResponse200DataItemRelationshipsTaxCalculatorData,
)
from .ge_ttax_categories_response_200_data_item_relationships_tax_calculator_data_type import (
    GETtaxCategoriesResponse200DataItemRelationshipsTaxCalculatorDataType,
)
from .ge_ttax_categories_response_200_data_item_relationships_tax_calculator_links import (
    GETtaxCategoriesResponse200DataItemRelationshipsTaxCalculatorLinks,
)
from .ge_ttax_categories_response_200_data_item_type import GETtaxCategoriesResponse200DataItemType
from .ge_ttax_categoriestax_category_id_response_200 import GETtaxCategoriestaxCategoryIdResponse200
from .ge_ttax_categoriestax_category_id_response_200_data import GETtaxCategoriestaxCategoryIdResponse200Data
from .ge_ttax_categoriestax_category_id_response_200_data_attributes import (
    GETtaxCategoriestaxCategoryIdResponse200DataAttributes,
)
from .ge_ttax_categoriestax_category_id_response_200_data_attributes_metadata import (
    GETtaxCategoriestaxCategoryIdResponse200DataAttributesMetadata,
)
from .ge_ttax_categoriestax_category_id_response_200_data_links import GETtaxCategoriestaxCategoryIdResponse200DataLinks
from .ge_ttax_categoriestax_category_id_response_200_data_relationships import (
    GETtaxCategoriestaxCategoryIdResponse200DataRelationships,
)
from .ge_ttax_categoriestax_category_id_response_200_data_relationships_attachments import (
    GETtaxCategoriestaxCategoryIdResponse200DataRelationshipsAttachments,
)
from .ge_ttax_categoriestax_category_id_response_200_data_relationships_attachments_data import (
    GETtaxCategoriestaxCategoryIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_ttax_categoriestax_category_id_response_200_data_relationships_attachments_data_type import (
    GETtaxCategoriestaxCategoryIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_ttax_categoriestax_category_id_response_200_data_relationships_attachments_links import (
    GETtaxCategoriestaxCategoryIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_ttax_categoriestax_category_id_response_200_data_relationships_sku import (
    GETtaxCategoriestaxCategoryIdResponse200DataRelationshipsSku,
)
from .ge_ttax_categoriestax_category_id_response_200_data_relationships_sku_data import (
    GETtaxCategoriestaxCategoryIdResponse200DataRelationshipsSkuData,
)
from .ge_ttax_categoriestax_category_id_response_200_data_relationships_sku_data_type import (
    GETtaxCategoriestaxCategoryIdResponse200DataRelationshipsSkuDataType,
)
from .ge_ttax_categoriestax_category_id_response_200_data_relationships_sku_links import (
    GETtaxCategoriestaxCategoryIdResponse200DataRelationshipsSkuLinks,
)
from .ge_ttax_categoriestax_category_id_response_200_data_relationships_tax_calculator import (
    GETtaxCategoriestaxCategoryIdResponse200DataRelationshipsTaxCalculator,
)
from .ge_ttax_categoriestax_category_id_response_200_data_relationships_tax_calculator_data import (
    GETtaxCategoriestaxCategoryIdResponse200DataRelationshipsTaxCalculatorData,
)
from .ge_ttax_categoriestax_category_id_response_200_data_relationships_tax_calculator_data_type import (
    GETtaxCategoriestaxCategoryIdResponse200DataRelationshipsTaxCalculatorDataType,
)
from .ge_ttax_categoriestax_category_id_response_200_data_relationships_tax_calculator_links import (
    GETtaxCategoriestaxCategoryIdResponse200DataRelationshipsTaxCalculatorLinks,
)
from .ge_ttax_categoriestax_category_id_response_200_data_type import GETtaxCategoriestaxCategoryIdResponse200DataType
from .ge_ttax_rules_response_200 import GETtaxRulesResponse200
from .ge_ttax_rules_response_200_data_item import GETtaxRulesResponse200DataItem
from .ge_ttax_rules_response_200_data_item_attributes import GETtaxRulesResponse200DataItemAttributes
from .ge_ttax_rules_response_200_data_item_attributes_breakdown import GETtaxRulesResponse200DataItemAttributesBreakdown
from .ge_ttax_rules_response_200_data_item_attributes_metadata import GETtaxRulesResponse200DataItemAttributesMetadata
from .ge_ttax_rules_response_200_data_item_links import GETtaxRulesResponse200DataItemLinks
from .ge_ttax_rules_response_200_data_item_relationships import GETtaxRulesResponse200DataItemRelationships
from .ge_ttax_rules_response_200_data_item_relationships_manual_tax_calculator import (
    GETtaxRulesResponse200DataItemRelationshipsManualTaxCalculator,
)
from .ge_ttax_rules_response_200_data_item_relationships_manual_tax_calculator_data import (
    GETtaxRulesResponse200DataItemRelationshipsManualTaxCalculatorData,
)
from .ge_ttax_rules_response_200_data_item_relationships_manual_tax_calculator_data_type import (
    GETtaxRulesResponse200DataItemRelationshipsManualTaxCalculatorDataType,
)
from .ge_ttax_rules_response_200_data_item_relationships_manual_tax_calculator_links import (
    GETtaxRulesResponse200DataItemRelationshipsManualTaxCalculatorLinks,
)
from .ge_ttax_rules_response_200_data_item_type import GETtaxRulesResponse200DataItemType
from .ge_ttax_rulestax_rule_id_response_200 import GETtaxRulestaxRuleIdResponse200
from .ge_ttax_rulestax_rule_id_response_200_data import GETtaxRulestaxRuleIdResponse200Data
from .ge_ttax_rulestax_rule_id_response_200_data_attributes import GETtaxRulestaxRuleIdResponse200DataAttributes
from .ge_ttax_rulestax_rule_id_response_200_data_attributes_breakdown import (
    GETtaxRulestaxRuleIdResponse200DataAttributesBreakdown,
)
from .ge_ttax_rulestax_rule_id_response_200_data_attributes_metadata import (
    GETtaxRulestaxRuleIdResponse200DataAttributesMetadata,
)
from .ge_ttax_rulestax_rule_id_response_200_data_links import GETtaxRulestaxRuleIdResponse200DataLinks
from .ge_ttax_rulestax_rule_id_response_200_data_relationships import GETtaxRulestaxRuleIdResponse200DataRelationships
from .ge_ttax_rulestax_rule_id_response_200_data_relationships_manual_tax_calculator import (
    GETtaxRulestaxRuleIdResponse200DataRelationshipsManualTaxCalculator,
)
from .ge_ttax_rulestax_rule_id_response_200_data_relationships_manual_tax_calculator_data import (
    GETtaxRulestaxRuleIdResponse200DataRelationshipsManualTaxCalculatorData,
)
from .ge_ttax_rulestax_rule_id_response_200_data_relationships_manual_tax_calculator_data_type import (
    GETtaxRulestaxRuleIdResponse200DataRelationshipsManualTaxCalculatorDataType,
)
from .ge_ttax_rulestax_rule_id_response_200_data_relationships_manual_tax_calculator_links import (
    GETtaxRulestaxRuleIdResponse200DataRelationshipsManualTaxCalculatorLinks,
)
from .ge_ttax_rulestax_rule_id_response_200_data_type import GETtaxRulestaxRuleIdResponse200DataType
from .ge_ttaxjar_accounts_response_200 import GETtaxjarAccountsResponse200
from .ge_ttaxjar_accounts_response_200_data_item import GETtaxjarAccountsResponse200DataItem
from .ge_ttaxjar_accounts_response_200_data_item_attributes import GETtaxjarAccountsResponse200DataItemAttributes
from .ge_ttaxjar_accounts_response_200_data_item_attributes_metadata import (
    GETtaxjarAccountsResponse200DataItemAttributesMetadata,
)
from .ge_ttaxjar_accounts_response_200_data_item_links import GETtaxjarAccountsResponse200DataItemLinks
from .ge_ttaxjar_accounts_response_200_data_item_relationships import GETtaxjarAccountsResponse200DataItemRelationships
from .ge_ttaxjar_accounts_response_200_data_item_relationships_attachments import (
    GETtaxjarAccountsResponse200DataItemRelationshipsAttachments,
)
from .ge_ttaxjar_accounts_response_200_data_item_relationships_attachments_data import (
    GETtaxjarAccountsResponse200DataItemRelationshipsAttachmentsData,
)
from .ge_ttaxjar_accounts_response_200_data_item_relationships_attachments_data_type import (
    GETtaxjarAccountsResponse200DataItemRelationshipsAttachmentsDataType,
)
from .ge_ttaxjar_accounts_response_200_data_item_relationships_attachments_links import (
    GETtaxjarAccountsResponse200DataItemRelationshipsAttachmentsLinks,
)
from .ge_ttaxjar_accounts_response_200_data_item_relationships_markets import (
    GETtaxjarAccountsResponse200DataItemRelationshipsMarkets,
)
from .ge_ttaxjar_accounts_response_200_data_item_relationships_markets_data import (
    GETtaxjarAccountsResponse200DataItemRelationshipsMarketsData,
)
from .ge_ttaxjar_accounts_response_200_data_item_relationships_markets_data_type import (
    GETtaxjarAccountsResponse200DataItemRelationshipsMarketsDataType,
)
from .ge_ttaxjar_accounts_response_200_data_item_relationships_markets_links import (
    GETtaxjarAccountsResponse200DataItemRelationshipsMarketsLinks,
)
from .ge_ttaxjar_accounts_response_200_data_item_relationships_tax_categories import (
    GETtaxjarAccountsResponse200DataItemRelationshipsTaxCategories,
)
from .ge_ttaxjar_accounts_response_200_data_item_relationships_tax_categories_data import (
    GETtaxjarAccountsResponse200DataItemRelationshipsTaxCategoriesData,
)
from .ge_ttaxjar_accounts_response_200_data_item_relationships_tax_categories_data_type import (
    GETtaxjarAccountsResponse200DataItemRelationshipsTaxCategoriesDataType,
)
from .ge_ttaxjar_accounts_response_200_data_item_relationships_tax_categories_links import (
    GETtaxjarAccountsResponse200DataItemRelationshipsTaxCategoriesLinks,
)
from .ge_ttaxjar_accounts_response_200_data_item_type import GETtaxjarAccountsResponse200DataItemType
from .ge_ttaxjar_accountstaxjar_account_id_response_200 import GETtaxjarAccountstaxjarAccountIdResponse200
from .ge_ttaxjar_accountstaxjar_account_id_response_200_data import GETtaxjarAccountstaxjarAccountIdResponse200Data
from .ge_ttaxjar_accountstaxjar_account_id_response_200_data_attributes import (
    GETtaxjarAccountstaxjarAccountIdResponse200DataAttributes,
)
from .ge_ttaxjar_accountstaxjar_account_id_response_200_data_attributes_metadata import (
    GETtaxjarAccountstaxjarAccountIdResponse200DataAttributesMetadata,
)
from .ge_ttaxjar_accountstaxjar_account_id_response_200_data_links import (
    GETtaxjarAccountstaxjarAccountIdResponse200DataLinks,
)
from .ge_ttaxjar_accountstaxjar_account_id_response_200_data_relationships import (
    GETtaxjarAccountstaxjarAccountIdResponse200DataRelationships,
)
from .ge_ttaxjar_accountstaxjar_account_id_response_200_data_relationships_attachments import (
    GETtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsAttachments,
)
from .ge_ttaxjar_accountstaxjar_account_id_response_200_data_relationships_attachments_data import (
    GETtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsAttachmentsData,
)
from .ge_ttaxjar_accountstaxjar_account_id_response_200_data_relationships_attachments_data_type import (
    GETtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsAttachmentsDataType,
)
from .ge_ttaxjar_accountstaxjar_account_id_response_200_data_relationships_attachments_links import (
    GETtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsAttachmentsLinks,
)
from .ge_ttaxjar_accountstaxjar_account_id_response_200_data_relationships_markets import (
    GETtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsMarkets,
)
from .ge_ttaxjar_accountstaxjar_account_id_response_200_data_relationships_markets_data import (
    GETtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsMarketsData,
)
from .ge_ttaxjar_accountstaxjar_account_id_response_200_data_relationships_markets_data_type import (
    GETtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsMarketsDataType,
)
from .ge_ttaxjar_accountstaxjar_account_id_response_200_data_relationships_markets_links import (
    GETtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsMarketsLinks,
)
from .ge_ttaxjar_accountstaxjar_account_id_response_200_data_relationships_tax_categories import (
    GETtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsTaxCategories,
)
from .ge_ttaxjar_accountstaxjar_account_id_response_200_data_relationships_tax_categories_data import (
    GETtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsTaxCategoriesData,
)
from .ge_ttaxjar_accountstaxjar_account_id_response_200_data_relationships_tax_categories_data_type import (
    GETtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsTaxCategoriesDataType,
)
from .ge_ttaxjar_accountstaxjar_account_id_response_200_data_relationships_tax_categories_links import (
    GETtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsTaxCategoriesLinks,
)
from .ge_ttaxjar_accountstaxjar_account_id_response_200_data_type import (
    GETtaxjarAccountstaxjarAccountIdResponse200DataType,
)
from .ge_ttransactions_response_200 import GETtransactionsResponse200
from .ge_ttransactions_response_200_data_item import GETtransactionsResponse200DataItem
from .ge_ttransactions_response_200_data_item_attributes import GETtransactionsResponse200DataItemAttributes
from .ge_ttransactions_response_200_data_item_attributes_metadata import (
    GETtransactionsResponse200DataItemAttributesMetadata,
)
from .ge_ttransactions_response_200_data_item_links import GETtransactionsResponse200DataItemLinks
from .ge_ttransactions_response_200_data_item_relationships import GETtransactionsResponse200DataItemRelationships
from .ge_ttransactions_response_200_data_item_relationships_order import (
    GETtransactionsResponse200DataItemRelationshipsOrder,
)
from .ge_ttransactions_response_200_data_item_relationships_order_data import (
    GETtransactionsResponse200DataItemRelationshipsOrderData,
)
from .ge_ttransactions_response_200_data_item_relationships_order_data_type import (
    GETtransactionsResponse200DataItemRelationshipsOrderDataType,
)
from .ge_ttransactions_response_200_data_item_relationships_order_links import (
    GETtransactionsResponse200DataItemRelationshipsOrderLinks,
)
from .ge_ttransactions_response_200_data_item_type import GETtransactionsResponse200DataItemType
from .ge_ttransactionstransaction_id_response_200 import GETtransactionstransactionIdResponse200
from .ge_ttransactionstransaction_id_response_200_data import GETtransactionstransactionIdResponse200Data
from .ge_ttransactionstransaction_id_response_200_data_attributes import (
    GETtransactionstransactionIdResponse200DataAttributes,
)
from .ge_ttransactionstransaction_id_response_200_data_attributes_metadata import (
    GETtransactionstransactionIdResponse200DataAttributesMetadata,
)
from .ge_ttransactionstransaction_id_response_200_data_links import GETtransactionstransactionIdResponse200DataLinks
from .ge_ttransactionstransaction_id_response_200_data_relationships import (
    GETtransactionstransactionIdResponse200DataRelationships,
)
from .ge_ttransactionstransaction_id_response_200_data_relationships_order import (
    GETtransactionstransactionIdResponse200DataRelationshipsOrder,
)
from .ge_ttransactionstransaction_id_response_200_data_relationships_order_data import (
    GETtransactionstransactionIdResponse200DataRelationshipsOrderData,
)
from .ge_ttransactionstransaction_id_response_200_data_relationships_order_data_type import (
    GETtransactionstransactionIdResponse200DataRelationshipsOrderDataType,
)
from .ge_ttransactionstransaction_id_response_200_data_relationships_order_links import (
    GETtransactionstransactionIdResponse200DataRelationshipsOrderLinks,
)
from .ge_ttransactionstransaction_id_response_200_data_type import GETtransactionstransactionIdResponse200DataType
from .ge_tvoids_response_200 import GETvoidsResponse200
from .ge_tvoids_response_200_data_item import GETvoidsResponse200DataItem
from .ge_tvoids_response_200_data_item_attributes import GETvoidsResponse200DataItemAttributes
from .ge_tvoids_response_200_data_item_attributes_metadata import GETvoidsResponse200DataItemAttributesMetadata
from .ge_tvoids_response_200_data_item_links import GETvoidsResponse200DataItemLinks
from .ge_tvoids_response_200_data_item_relationships import GETvoidsResponse200DataItemRelationships
from .ge_tvoids_response_200_data_item_relationships_order import GETvoidsResponse200DataItemRelationshipsOrder
from .ge_tvoids_response_200_data_item_relationships_order_data import GETvoidsResponse200DataItemRelationshipsOrderData
from .ge_tvoids_response_200_data_item_relationships_order_data_type import (
    GETvoidsResponse200DataItemRelationshipsOrderDataType,
)
from .ge_tvoids_response_200_data_item_relationships_order_links import (
    GETvoidsResponse200DataItemRelationshipsOrderLinks,
)
from .ge_tvoids_response_200_data_item_relationships_reference_authorization import (
    GETvoidsResponse200DataItemRelationshipsReferenceAuthorization,
)
from .ge_tvoids_response_200_data_item_relationships_reference_authorization_data import (
    GETvoidsResponse200DataItemRelationshipsReferenceAuthorizationData,
)
from .ge_tvoids_response_200_data_item_relationships_reference_authorization_data_type import (
    GETvoidsResponse200DataItemRelationshipsReferenceAuthorizationDataType,
)
from .ge_tvoids_response_200_data_item_relationships_reference_authorization_links import (
    GETvoidsResponse200DataItemRelationshipsReferenceAuthorizationLinks,
)
from .ge_tvoids_response_200_data_item_type import GETvoidsResponse200DataItemType
from .ge_tvoidsvoid_id_response_200 import GETvoidsvoidIdResponse200
from .ge_tvoidsvoid_id_response_200_data import GETvoidsvoidIdResponse200Data
from .ge_tvoidsvoid_id_response_200_data_attributes import GETvoidsvoidIdResponse200DataAttributes
from .ge_tvoidsvoid_id_response_200_data_attributes_metadata import GETvoidsvoidIdResponse200DataAttributesMetadata
from .ge_tvoidsvoid_id_response_200_data_links import GETvoidsvoidIdResponse200DataLinks
from .ge_tvoidsvoid_id_response_200_data_relationships import GETvoidsvoidIdResponse200DataRelationships
from .ge_tvoidsvoid_id_response_200_data_relationships_order import GETvoidsvoidIdResponse200DataRelationshipsOrder
from .ge_tvoidsvoid_id_response_200_data_relationships_order_data import (
    GETvoidsvoidIdResponse200DataRelationshipsOrderData,
)
from .ge_tvoidsvoid_id_response_200_data_relationships_order_data_type import (
    GETvoidsvoidIdResponse200DataRelationshipsOrderDataType,
)
from .ge_tvoidsvoid_id_response_200_data_relationships_order_links import (
    GETvoidsvoidIdResponse200DataRelationshipsOrderLinks,
)
from .ge_tvoidsvoid_id_response_200_data_relationships_reference_authorization import (
    GETvoidsvoidIdResponse200DataRelationshipsReferenceAuthorization,
)
from .ge_tvoidsvoid_id_response_200_data_relationships_reference_authorization_data import (
    GETvoidsvoidIdResponse200DataRelationshipsReferenceAuthorizationData,
)
from .ge_tvoidsvoid_id_response_200_data_relationships_reference_authorization_data_type import (
    GETvoidsvoidIdResponse200DataRelationshipsReferenceAuthorizationDataType,
)
from .ge_tvoidsvoid_id_response_200_data_relationships_reference_authorization_links import (
    GETvoidsvoidIdResponse200DataRelationshipsReferenceAuthorizationLinks,
)
from .ge_tvoidsvoid_id_response_200_data_type import GETvoidsvoidIdResponse200DataType
from .ge_twebhooks_response_200 import GETwebhooksResponse200
from .ge_twebhooks_response_200_data_item import GETwebhooksResponse200DataItem
from .ge_twebhooks_response_200_data_item_attributes import GETwebhooksResponse200DataItemAttributes
from .ge_twebhooks_response_200_data_item_attributes_metadata import GETwebhooksResponse200DataItemAttributesMetadata
from .ge_twebhooks_response_200_data_item_links import GETwebhooksResponse200DataItemLinks
from .ge_twebhooks_response_200_data_item_relationships import GETwebhooksResponse200DataItemRelationships
from .ge_twebhooks_response_200_data_item_relationships_last_event_callbacks import (
    GETwebhooksResponse200DataItemRelationshipsLastEventCallbacks,
)
from .ge_twebhooks_response_200_data_item_relationships_last_event_callbacks_data import (
    GETwebhooksResponse200DataItemRelationshipsLastEventCallbacksData,
)
from .ge_twebhooks_response_200_data_item_relationships_last_event_callbacks_data_type import (
    GETwebhooksResponse200DataItemRelationshipsLastEventCallbacksDataType,
)
from .ge_twebhooks_response_200_data_item_relationships_last_event_callbacks_links import (
    GETwebhooksResponse200DataItemRelationshipsLastEventCallbacksLinks,
)
from .ge_twebhooks_response_200_data_item_type import GETwebhooksResponse200DataItemType
from .ge_twebhookswebhook_id_response_200 import GETwebhookswebhookIdResponse200
from .ge_twebhookswebhook_id_response_200_data import GETwebhookswebhookIdResponse200Data
from .ge_twebhookswebhook_id_response_200_data_attributes import GETwebhookswebhookIdResponse200DataAttributes
from .ge_twebhookswebhook_id_response_200_data_attributes_metadata import (
    GETwebhookswebhookIdResponse200DataAttributesMetadata,
)
from .ge_twebhookswebhook_id_response_200_data_links import GETwebhookswebhookIdResponse200DataLinks
from .ge_twebhookswebhook_id_response_200_data_relationships import GETwebhookswebhookIdResponse200DataRelationships
from .ge_twebhookswebhook_id_response_200_data_relationships_last_event_callbacks import (
    GETwebhookswebhookIdResponse200DataRelationshipsLastEventCallbacks,
)
from .ge_twebhookswebhook_id_response_200_data_relationships_last_event_callbacks_data import (
    GETwebhookswebhookIdResponse200DataRelationshipsLastEventCallbacksData,
)
from .ge_twebhookswebhook_id_response_200_data_relationships_last_event_callbacks_data_type import (
    GETwebhookswebhookIdResponse200DataRelationshipsLastEventCallbacksDataType,
)
from .ge_twebhookswebhook_id_response_200_data_relationships_last_event_callbacks_links import (
    GETwebhookswebhookIdResponse200DataRelationshipsLastEventCallbacksLinks,
)
from .ge_twebhookswebhook_id_response_200_data_type import GETwebhookswebhookIdResponse200DataType
from .ge_twire_transfers_response_200 import GETwireTransfersResponse200
from .ge_twire_transfers_response_200_data_item import GETwireTransfersResponse200DataItem
from .ge_twire_transfers_response_200_data_item_attributes import GETwireTransfersResponse200DataItemAttributes
from .ge_twire_transfers_response_200_data_item_attributes_metadata import (
    GETwireTransfersResponse200DataItemAttributesMetadata,
)
from .ge_twire_transfers_response_200_data_item_links import GETwireTransfersResponse200DataItemLinks
from .ge_twire_transfers_response_200_data_item_relationships import GETwireTransfersResponse200DataItemRelationships
from .ge_twire_transfers_response_200_data_item_relationships_order import (
    GETwireTransfersResponse200DataItemRelationshipsOrder,
)
from .ge_twire_transfers_response_200_data_item_relationships_order_data import (
    GETwireTransfersResponse200DataItemRelationshipsOrderData,
)
from .ge_twire_transfers_response_200_data_item_relationships_order_data_type import (
    GETwireTransfersResponse200DataItemRelationshipsOrderDataType,
)
from .ge_twire_transfers_response_200_data_item_relationships_order_links import (
    GETwireTransfersResponse200DataItemRelationshipsOrderLinks,
)
from .ge_twire_transfers_response_200_data_item_type import GETwireTransfersResponse200DataItemType
from .ge_twire_transferswire_transfer_id_response_200 import GETwireTransferswireTransferIdResponse200
from .ge_twire_transferswire_transfer_id_response_200_data import GETwireTransferswireTransferIdResponse200Data
from .ge_twire_transferswire_transfer_id_response_200_data_attributes import (
    GETwireTransferswireTransferIdResponse200DataAttributes,
)
from .ge_twire_transferswire_transfer_id_response_200_data_attributes_metadata import (
    GETwireTransferswireTransferIdResponse200DataAttributesMetadata,
)
from .ge_twire_transferswire_transfer_id_response_200_data_links import (
    GETwireTransferswireTransferIdResponse200DataLinks,
)
from .ge_twire_transferswire_transfer_id_response_200_data_relationships import (
    GETwireTransferswireTransferIdResponse200DataRelationships,
)
from .ge_twire_transferswire_transfer_id_response_200_data_relationships_order import (
    GETwireTransferswireTransferIdResponse200DataRelationshipsOrder,
)
from .ge_twire_transferswire_transfer_id_response_200_data_relationships_order_data import (
    GETwireTransferswireTransferIdResponse200DataRelationshipsOrderData,
)
from .ge_twire_transferswire_transfer_id_response_200_data_relationships_order_data_type import (
    GETwireTransferswireTransferIdResponse200DataRelationshipsOrderDataType,
)
from .ge_twire_transferswire_transfer_id_response_200_data_relationships_order_links import (
    GETwireTransferswireTransferIdResponse200DataRelationshipsOrderLinks,
)
from .ge_twire_transferswire_transfer_id_response_200_data_type import GETwireTransferswireTransferIdResponse200DataType
from .geocoder import Geocoder
from .geocoder_data import GeocoderData
from .geocoder_data_attributes import GeocoderDataAttributes
from .geocoder_data_attributes_metadata import GeocoderDataAttributesMetadata
from .geocoder_data_relationships import GeocoderDataRelationships
from .geocoder_data_relationships_addresses import GeocoderDataRelationshipsAddresses
from .geocoder_data_relationships_addresses_data import GeocoderDataRelationshipsAddressesData
from .geocoder_data_relationships_addresses_data_type import GeocoderDataRelationshipsAddressesDataType
from .geocoder_data_relationships_attachments import GeocoderDataRelationshipsAttachments
from .geocoder_data_relationships_attachments_data import GeocoderDataRelationshipsAttachmentsData
from .geocoder_data_relationships_attachments_data_type import GeocoderDataRelationshipsAttachmentsDataType
from .geocoder_data_type import GeocoderDataType
from .gift_card import GiftCard
from .gift_card_create import GiftCardCreate
from .gift_card_create_data import GiftCardCreateData
from .gift_card_create_data_attributes import GiftCardCreateDataAttributes
from .gift_card_create_data_attributes_metadata import GiftCardCreateDataAttributesMetadata
from .gift_card_create_data_relationships import GiftCardCreateDataRelationships
from .gift_card_create_data_relationships_gift_card_recipient import GiftCardCreateDataRelationshipsGiftCardRecipient
from .gift_card_create_data_relationships_gift_card_recipient_data import (
    GiftCardCreateDataRelationshipsGiftCardRecipientData,
)
from .gift_card_create_data_relationships_gift_card_recipient_data_type import (
    GiftCardCreateDataRelationshipsGiftCardRecipientDataType,
)
from .gift_card_create_data_relationships_market import GiftCardCreateDataRelationshipsMarket
from .gift_card_create_data_relationships_market_data import GiftCardCreateDataRelationshipsMarketData
from .gift_card_create_data_relationships_market_data_type import GiftCardCreateDataRelationshipsMarketDataType
from .gift_card_create_data_type import GiftCardCreateDataType
from .gift_card_data import GiftCardData
from .gift_card_data_attributes import GiftCardDataAttributes
from .gift_card_data_attributes_balance_log_item import GiftCardDataAttributesBalanceLogItem
from .gift_card_data_attributes_metadata import GiftCardDataAttributesMetadata
from .gift_card_data_relationships import GiftCardDataRelationships
from .gift_card_data_relationships_attachments import GiftCardDataRelationshipsAttachments
from .gift_card_data_relationships_attachments_data import GiftCardDataRelationshipsAttachmentsData
from .gift_card_data_relationships_attachments_data_type import GiftCardDataRelationshipsAttachmentsDataType
from .gift_card_data_relationships_events import GiftCardDataRelationshipsEvents
from .gift_card_data_relationships_events_data import GiftCardDataRelationshipsEventsData
from .gift_card_data_relationships_events_data_type import GiftCardDataRelationshipsEventsDataType
from .gift_card_data_relationships_gift_card_recipient import GiftCardDataRelationshipsGiftCardRecipient
from .gift_card_data_relationships_gift_card_recipient_data import GiftCardDataRelationshipsGiftCardRecipientData
from .gift_card_data_relationships_gift_card_recipient_data_type import (
    GiftCardDataRelationshipsGiftCardRecipientDataType,
)
from .gift_card_data_relationships_market import GiftCardDataRelationshipsMarket
from .gift_card_data_relationships_market_data import GiftCardDataRelationshipsMarketData
from .gift_card_data_relationships_market_data_type import GiftCardDataRelationshipsMarketDataType
from .gift_card_data_type import GiftCardDataType
from .gift_card_recipient import GiftCardRecipient
from .gift_card_recipient_create import GiftCardRecipientCreate
from .gift_card_recipient_create_data import GiftCardRecipientCreateData
from .gift_card_recipient_create_data_attributes import GiftCardRecipientCreateDataAttributes
from .gift_card_recipient_create_data_attributes_metadata import GiftCardRecipientCreateDataAttributesMetadata
from .gift_card_recipient_create_data_relationships import GiftCardRecipientCreateDataRelationships
from .gift_card_recipient_create_data_relationships_customer import GiftCardRecipientCreateDataRelationshipsCustomer
from .gift_card_recipient_create_data_relationships_customer_data import (
    GiftCardRecipientCreateDataRelationshipsCustomerData,
)
from .gift_card_recipient_create_data_relationships_customer_data_type import (
    GiftCardRecipientCreateDataRelationshipsCustomerDataType,
)
from .gift_card_recipient_create_data_type import GiftCardRecipientCreateDataType
from .gift_card_recipient_data import GiftCardRecipientData
from .gift_card_recipient_data_attributes import GiftCardRecipientDataAttributes
from .gift_card_recipient_data_attributes_metadata import GiftCardRecipientDataAttributesMetadata
from .gift_card_recipient_data_relationships import GiftCardRecipientDataRelationships
from .gift_card_recipient_data_relationships_attachments import GiftCardRecipientDataRelationshipsAttachments
from .gift_card_recipient_data_relationships_attachments_data import GiftCardRecipientDataRelationshipsAttachmentsData
from .gift_card_recipient_data_relationships_attachments_data_type import (
    GiftCardRecipientDataRelationshipsAttachmentsDataType,
)
from .gift_card_recipient_data_relationships_customer import GiftCardRecipientDataRelationshipsCustomer
from .gift_card_recipient_data_relationships_customer_data import GiftCardRecipientDataRelationshipsCustomerData
from .gift_card_recipient_data_relationships_customer_data_type import (
    GiftCardRecipientDataRelationshipsCustomerDataType,
)
from .gift_card_recipient_data_type import GiftCardRecipientDataType
from .gift_card_recipient_update import GiftCardRecipientUpdate
from .gift_card_recipient_update_data import GiftCardRecipientUpdateData
from .gift_card_recipient_update_data_attributes import GiftCardRecipientUpdateDataAttributes
from .gift_card_recipient_update_data_attributes_metadata import GiftCardRecipientUpdateDataAttributesMetadata
from .gift_card_recipient_update_data_relationships import GiftCardRecipientUpdateDataRelationships
from .gift_card_recipient_update_data_relationships_customer import GiftCardRecipientUpdateDataRelationshipsCustomer
from .gift_card_recipient_update_data_relationships_customer_data import (
    GiftCardRecipientUpdateDataRelationshipsCustomerData,
)
from .gift_card_recipient_update_data_relationships_customer_data_type import (
    GiftCardRecipientUpdateDataRelationshipsCustomerDataType,
)
from .gift_card_recipient_update_data_type import GiftCardRecipientUpdateDataType
from .gift_card_update import GiftCardUpdate
from .gift_card_update_data import GiftCardUpdateData
from .gift_card_update_data_attributes import GiftCardUpdateDataAttributes
from .gift_card_update_data_attributes_metadata import GiftCardUpdateDataAttributesMetadata
from .gift_card_update_data_relationships import GiftCardUpdateDataRelationships
from .gift_card_update_data_relationships_gift_card_recipient import GiftCardUpdateDataRelationshipsGiftCardRecipient
from .gift_card_update_data_relationships_gift_card_recipient_data import (
    GiftCardUpdateDataRelationshipsGiftCardRecipientData,
)
from .gift_card_update_data_relationships_gift_card_recipient_data_type import (
    GiftCardUpdateDataRelationshipsGiftCardRecipientDataType,
)
from .gift_card_update_data_relationships_market import GiftCardUpdateDataRelationshipsMarket
from .gift_card_update_data_relationships_market_data import GiftCardUpdateDataRelationshipsMarketData
from .gift_card_update_data_relationships_market_data_type import GiftCardUpdateDataRelationshipsMarketDataType
from .gift_card_update_data_type import GiftCardUpdateDataType
from .google_geocoder import GoogleGeocoder
from .google_geocoder_create import GoogleGeocoderCreate
from .google_geocoder_create_data import GoogleGeocoderCreateData
from .google_geocoder_create_data_attributes import GoogleGeocoderCreateDataAttributes
from .google_geocoder_create_data_attributes_metadata import GoogleGeocoderCreateDataAttributesMetadata
from .google_geocoder_create_data_relationships import GoogleGeocoderCreateDataRelationships
from .google_geocoder_create_data_type import GoogleGeocoderCreateDataType
from .google_geocoder_data import GoogleGeocoderData
from .google_geocoder_data_attributes import GoogleGeocoderDataAttributes
from .google_geocoder_data_attributes_metadata import GoogleGeocoderDataAttributesMetadata
from .google_geocoder_data_relationships import GoogleGeocoderDataRelationships
from .google_geocoder_data_relationships_addresses import GoogleGeocoderDataRelationshipsAddresses
from .google_geocoder_data_relationships_addresses_data import GoogleGeocoderDataRelationshipsAddressesData
from .google_geocoder_data_relationships_addresses_data_type import GoogleGeocoderDataRelationshipsAddressesDataType
from .google_geocoder_data_relationships_attachments import GoogleGeocoderDataRelationshipsAttachments
from .google_geocoder_data_relationships_attachments_data import GoogleGeocoderDataRelationshipsAttachmentsData
from .google_geocoder_data_relationships_attachments_data_type import GoogleGeocoderDataRelationshipsAttachmentsDataType
from .google_geocoder_data_type import GoogleGeocoderDataType
from .google_geocoder_update import GoogleGeocoderUpdate
from .google_geocoder_update_data import GoogleGeocoderUpdateData
from .google_geocoder_update_data_attributes import GoogleGeocoderUpdateDataAttributes
from .google_geocoder_update_data_attributes_metadata import GoogleGeocoderUpdateDataAttributesMetadata
from .google_geocoder_update_data_relationships import GoogleGeocoderUpdateDataRelationships
from .google_geocoder_update_data_type import GoogleGeocoderUpdateDataType
from .import_ import Import
from .import_create import ImportCreate
from .import_create_data import ImportCreateData
from .import_create_data_attributes import ImportCreateDataAttributes
from .import_create_data_attributes_inputs_item import ImportCreateDataAttributesInputsItem
from .import_create_data_attributes_metadata import ImportCreateDataAttributesMetadata
from .import_create_data_relationships import ImportCreateDataRelationships
from .import_create_data_type import ImportCreateDataType
from .import_data import ImportData
from .import_data_attributes import ImportDataAttributes
from .import_data_attributes_errors_log import ImportDataAttributesErrorsLog
from .import_data_attributes_inputs_item import ImportDataAttributesInputsItem
from .import_data_attributes_metadata import ImportDataAttributesMetadata
from .import_data_attributes_warnings_log import ImportDataAttributesWarningsLog
from .import_data_relationships import ImportDataRelationships
from .import_data_relationships_events import ImportDataRelationshipsEvents
from .import_data_relationships_events_data import ImportDataRelationshipsEventsData
from .import_data_relationships_events_data_type import ImportDataRelationshipsEventsDataType
from .import_data_type import ImportDataType
from .in_stock_subscription import InStockSubscription
from .in_stock_subscription_create import InStockSubscriptionCreate
from .in_stock_subscription_create_data import InStockSubscriptionCreateData
from .in_stock_subscription_create_data_attributes import InStockSubscriptionCreateDataAttributes
from .in_stock_subscription_create_data_attributes_metadata import InStockSubscriptionCreateDataAttributesMetadata
from .in_stock_subscription_create_data_relationships import InStockSubscriptionCreateDataRelationships
from .in_stock_subscription_create_data_relationships_customer import InStockSubscriptionCreateDataRelationshipsCustomer
from .in_stock_subscription_create_data_relationships_customer_data import (
    InStockSubscriptionCreateDataRelationshipsCustomerData,
)
from .in_stock_subscription_create_data_relationships_customer_data_type import (
    InStockSubscriptionCreateDataRelationshipsCustomerDataType,
)
from .in_stock_subscription_create_data_relationships_market import InStockSubscriptionCreateDataRelationshipsMarket
from .in_stock_subscription_create_data_relationships_market_data import (
    InStockSubscriptionCreateDataRelationshipsMarketData,
)
from .in_stock_subscription_create_data_relationships_market_data_type import (
    InStockSubscriptionCreateDataRelationshipsMarketDataType,
)
from .in_stock_subscription_create_data_relationships_sku import InStockSubscriptionCreateDataRelationshipsSku
from .in_stock_subscription_create_data_relationships_sku_data import InStockSubscriptionCreateDataRelationshipsSkuData
from .in_stock_subscription_create_data_relationships_sku_data_type import (
    InStockSubscriptionCreateDataRelationshipsSkuDataType,
)
from .in_stock_subscription_create_data_type import InStockSubscriptionCreateDataType
from .in_stock_subscription_data import InStockSubscriptionData
from .in_stock_subscription_data_attributes import InStockSubscriptionDataAttributes
from .in_stock_subscription_data_attributes_metadata import InStockSubscriptionDataAttributesMetadata
from .in_stock_subscription_data_relationships import InStockSubscriptionDataRelationships
from .in_stock_subscription_data_relationships_customer import InStockSubscriptionDataRelationshipsCustomer
from .in_stock_subscription_data_relationships_customer_data import InStockSubscriptionDataRelationshipsCustomerData
from .in_stock_subscription_data_relationships_customer_data_type import (
    InStockSubscriptionDataRelationshipsCustomerDataType,
)
from .in_stock_subscription_data_relationships_events import InStockSubscriptionDataRelationshipsEvents
from .in_stock_subscription_data_relationships_events_data import InStockSubscriptionDataRelationshipsEventsData
from .in_stock_subscription_data_relationships_events_data_type import (
    InStockSubscriptionDataRelationshipsEventsDataType,
)
from .in_stock_subscription_data_relationships_market import InStockSubscriptionDataRelationshipsMarket
from .in_stock_subscription_data_relationships_market_data import InStockSubscriptionDataRelationshipsMarketData
from .in_stock_subscription_data_relationships_market_data_type import (
    InStockSubscriptionDataRelationshipsMarketDataType,
)
from .in_stock_subscription_data_relationships_sku import InStockSubscriptionDataRelationshipsSku
from .in_stock_subscription_data_relationships_sku_data import InStockSubscriptionDataRelationshipsSkuData
from .in_stock_subscription_data_relationships_sku_data_type import InStockSubscriptionDataRelationshipsSkuDataType
from .in_stock_subscription_data_type import InStockSubscriptionDataType
from .in_stock_subscription_update import InStockSubscriptionUpdate
from .in_stock_subscription_update_data import InStockSubscriptionUpdateData
from .in_stock_subscription_update_data_attributes import InStockSubscriptionUpdateDataAttributes
from .in_stock_subscription_update_data_attributes_metadata import InStockSubscriptionUpdateDataAttributesMetadata
from .in_stock_subscription_update_data_relationships import InStockSubscriptionUpdateDataRelationships
from .in_stock_subscription_update_data_relationships_customer import InStockSubscriptionUpdateDataRelationshipsCustomer
from .in_stock_subscription_update_data_relationships_customer_data import (
    InStockSubscriptionUpdateDataRelationshipsCustomerData,
)
from .in_stock_subscription_update_data_relationships_customer_data_type import (
    InStockSubscriptionUpdateDataRelationshipsCustomerDataType,
)
from .in_stock_subscription_update_data_relationships_market import InStockSubscriptionUpdateDataRelationshipsMarket
from .in_stock_subscription_update_data_relationships_market_data import (
    InStockSubscriptionUpdateDataRelationshipsMarketData,
)
from .in_stock_subscription_update_data_relationships_market_data_type import (
    InStockSubscriptionUpdateDataRelationshipsMarketDataType,
)
from .in_stock_subscription_update_data_relationships_sku import InStockSubscriptionUpdateDataRelationshipsSku
from .in_stock_subscription_update_data_relationships_sku_data import InStockSubscriptionUpdateDataRelationshipsSkuData
from .in_stock_subscription_update_data_relationships_sku_data_type import (
    InStockSubscriptionUpdateDataRelationshipsSkuDataType,
)
from .in_stock_subscription_update_data_type import InStockSubscriptionUpdateDataType
from .inventory_model import InventoryModel
from .inventory_model_create import InventoryModelCreate
from .inventory_model_create_data import InventoryModelCreateData
from .inventory_model_create_data_attributes import InventoryModelCreateDataAttributes
from .inventory_model_create_data_attributes_metadata import InventoryModelCreateDataAttributesMetadata
from .inventory_model_create_data_relationships import InventoryModelCreateDataRelationships
from .inventory_model_create_data_type import InventoryModelCreateDataType
from .inventory_model_data import InventoryModelData
from .inventory_model_data_attributes import InventoryModelDataAttributes
from .inventory_model_data_attributes_metadata import InventoryModelDataAttributesMetadata
from .inventory_model_data_relationships import InventoryModelDataRelationships
from .inventory_model_data_relationships_attachments import InventoryModelDataRelationshipsAttachments
from .inventory_model_data_relationships_attachments_data import InventoryModelDataRelationshipsAttachmentsData
from .inventory_model_data_relationships_attachments_data_type import InventoryModelDataRelationshipsAttachmentsDataType
from .inventory_model_data_relationships_inventory_return_locations import (
    InventoryModelDataRelationshipsInventoryReturnLocations,
)
from .inventory_model_data_relationships_inventory_return_locations_data import (
    InventoryModelDataRelationshipsInventoryReturnLocationsData,
)
from .inventory_model_data_relationships_inventory_return_locations_data_type import (
    InventoryModelDataRelationshipsInventoryReturnLocationsDataType,
)
from .inventory_model_data_relationships_inventory_stock_locations import (
    InventoryModelDataRelationshipsInventoryStockLocations,
)
from .inventory_model_data_relationships_inventory_stock_locations_data import (
    InventoryModelDataRelationshipsInventoryStockLocationsData,
)
from .inventory_model_data_relationships_inventory_stock_locations_data_type import (
    InventoryModelDataRelationshipsInventoryStockLocationsDataType,
)
from .inventory_model_data_type import InventoryModelDataType
from .inventory_model_update import InventoryModelUpdate
from .inventory_model_update_data import InventoryModelUpdateData
from .inventory_model_update_data_attributes import InventoryModelUpdateDataAttributes
from .inventory_model_update_data_attributes_metadata import InventoryModelUpdateDataAttributesMetadata
from .inventory_model_update_data_relationships import InventoryModelUpdateDataRelationships
from .inventory_model_update_data_type import InventoryModelUpdateDataType
from .inventory_return_location import InventoryReturnLocation
from .inventory_return_location_create import InventoryReturnLocationCreate
from .inventory_return_location_create_data import InventoryReturnLocationCreateData
from .inventory_return_location_create_data_attributes import InventoryReturnLocationCreateDataAttributes
from .inventory_return_location_create_data_attributes_metadata import (
    InventoryReturnLocationCreateDataAttributesMetadata,
)
from .inventory_return_location_create_data_relationships import InventoryReturnLocationCreateDataRelationships
from .inventory_return_location_create_data_relationships_inventory_model import (
    InventoryReturnLocationCreateDataRelationshipsInventoryModel,
)
from .inventory_return_location_create_data_relationships_inventory_model_data import (
    InventoryReturnLocationCreateDataRelationshipsInventoryModelData,
)
from .inventory_return_location_create_data_relationships_inventory_model_data_type import (
    InventoryReturnLocationCreateDataRelationshipsInventoryModelDataType,
)
from .inventory_return_location_create_data_relationships_stock_location import (
    InventoryReturnLocationCreateDataRelationshipsStockLocation,
)
from .inventory_return_location_create_data_relationships_stock_location_data import (
    InventoryReturnLocationCreateDataRelationshipsStockLocationData,
)
from .inventory_return_location_create_data_relationships_stock_location_data_type import (
    InventoryReturnLocationCreateDataRelationshipsStockLocationDataType,
)
from .inventory_return_location_create_data_type import InventoryReturnLocationCreateDataType
from .inventory_return_location_data import InventoryReturnLocationData
from .inventory_return_location_data_attributes import InventoryReturnLocationDataAttributes
from .inventory_return_location_data_attributes_metadata import InventoryReturnLocationDataAttributesMetadata
from .inventory_return_location_data_relationships import InventoryReturnLocationDataRelationships
from .inventory_return_location_data_relationships_inventory_model import (
    InventoryReturnLocationDataRelationshipsInventoryModel,
)
from .inventory_return_location_data_relationships_inventory_model_data import (
    InventoryReturnLocationDataRelationshipsInventoryModelData,
)
from .inventory_return_location_data_relationships_inventory_model_data_type import (
    InventoryReturnLocationDataRelationshipsInventoryModelDataType,
)
from .inventory_return_location_data_relationships_stock_location import (
    InventoryReturnLocationDataRelationshipsStockLocation,
)
from .inventory_return_location_data_relationships_stock_location_data import (
    InventoryReturnLocationDataRelationshipsStockLocationData,
)
from .inventory_return_location_data_relationships_stock_location_data_type import (
    InventoryReturnLocationDataRelationshipsStockLocationDataType,
)
from .inventory_return_location_data_type import InventoryReturnLocationDataType
from .inventory_return_location_update import InventoryReturnLocationUpdate
from .inventory_return_location_update_data import InventoryReturnLocationUpdateData
from .inventory_return_location_update_data_attributes import InventoryReturnLocationUpdateDataAttributes
from .inventory_return_location_update_data_attributes_metadata import (
    InventoryReturnLocationUpdateDataAttributesMetadata,
)
from .inventory_return_location_update_data_relationships import InventoryReturnLocationUpdateDataRelationships
from .inventory_return_location_update_data_relationships_inventory_model import (
    InventoryReturnLocationUpdateDataRelationshipsInventoryModel,
)
from .inventory_return_location_update_data_relationships_inventory_model_data import (
    InventoryReturnLocationUpdateDataRelationshipsInventoryModelData,
)
from .inventory_return_location_update_data_relationships_inventory_model_data_type import (
    InventoryReturnLocationUpdateDataRelationshipsInventoryModelDataType,
)
from .inventory_return_location_update_data_relationships_stock_location import (
    InventoryReturnLocationUpdateDataRelationshipsStockLocation,
)
from .inventory_return_location_update_data_relationships_stock_location_data import (
    InventoryReturnLocationUpdateDataRelationshipsStockLocationData,
)
from .inventory_return_location_update_data_relationships_stock_location_data_type import (
    InventoryReturnLocationUpdateDataRelationshipsStockLocationDataType,
)
from .inventory_return_location_update_data_type import InventoryReturnLocationUpdateDataType
from .inventory_stock_location import InventoryStockLocation
from .inventory_stock_location_create import InventoryStockLocationCreate
from .inventory_stock_location_create_data import InventoryStockLocationCreateData
from .inventory_stock_location_create_data_attributes import InventoryStockLocationCreateDataAttributes
from .inventory_stock_location_create_data_attributes_metadata import InventoryStockLocationCreateDataAttributesMetadata
from .inventory_stock_location_create_data_relationships import InventoryStockLocationCreateDataRelationships
from .inventory_stock_location_create_data_relationships_inventory_model import (
    InventoryStockLocationCreateDataRelationshipsInventoryModel,
)
from .inventory_stock_location_create_data_relationships_inventory_model_data import (
    InventoryStockLocationCreateDataRelationshipsInventoryModelData,
)
from .inventory_stock_location_create_data_relationships_inventory_model_data_type import (
    InventoryStockLocationCreateDataRelationshipsInventoryModelDataType,
)
from .inventory_stock_location_create_data_relationships_stock_location import (
    InventoryStockLocationCreateDataRelationshipsStockLocation,
)
from .inventory_stock_location_create_data_relationships_stock_location_data import (
    InventoryStockLocationCreateDataRelationshipsStockLocationData,
)
from .inventory_stock_location_create_data_relationships_stock_location_data_type import (
    InventoryStockLocationCreateDataRelationshipsStockLocationDataType,
)
from .inventory_stock_location_create_data_type import InventoryStockLocationCreateDataType
from .inventory_stock_location_data import InventoryStockLocationData
from .inventory_stock_location_data_attributes import InventoryStockLocationDataAttributes
from .inventory_stock_location_data_attributes_metadata import InventoryStockLocationDataAttributesMetadata
from .inventory_stock_location_data_relationships import InventoryStockLocationDataRelationships
from .inventory_stock_location_data_relationships_inventory_model import (
    InventoryStockLocationDataRelationshipsInventoryModel,
)
from .inventory_stock_location_data_relationships_inventory_model_data import (
    InventoryStockLocationDataRelationshipsInventoryModelData,
)
from .inventory_stock_location_data_relationships_inventory_model_data_type import (
    InventoryStockLocationDataRelationshipsInventoryModelDataType,
)
from .inventory_stock_location_data_relationships_stock_location import (
    InventoryStockLocationDataRelationshipsStockLocation,
)
from .inventory_stock_location_data_relationships_stock_location_data import (
    InventoryStockLocationDataRelationshipsStockLocationData,
)
from .inventory_stock_location_data_relationships_stock_location_data_type import (
    InventoryStockLocationDataRelationshipsStockLocationDataType,
)
from .inventory_stock_location_data_type import InventoryStockLocationDataType
from .inventory_stock_location_update import InventoryStockLocationUpdate
from .inventory_stock_location_update_data import InventoryStockLocationUpdateData
from .inventory_stock_location_update_data_attributes import InventoryStockLocationUpdateDataAttributes
from .inventory_stock_location_update_data_attributes_metadata import InventoryStockLocationUpdateDataAttributesMetadata
from .inventory_stock_location_update_data_relationships import InventoryStockLocationUpdateDataRelationships
from .inventory_stock_location_update_data_relationships_inventory_model import (
    InventoryStockLocationUpdateDataRelationshipsInventoryModel,
)
from .inventory_stock_location_update_data_relationships_inventory_model_data import (
    InventoryStockLocationUpdateDataRelationshipsInventoryModelData,
)
from .inventory_stock_location_update_data_relationships_inventory_model_data_type import (
    InventoryStockLocationUpdateDataRelationshipsInventoryModelDataType,
)
from .inventory_stock_location_update_data_relationships_stock_location import (
    InventoryStockLocationUpdateDataRelationshipsStockLocation,
)
from .inventory_stock_location_update_data_relationships_stock_location_data import (
    InventoryStockLocationUpdateDataRelationshipsStockLocationData,
)
from .inventory_stock_location_update_data_relationships_stock_location_data_type import (
    InventoryStockLocationUpdateDataRelationshipsStockLocationDataType,
)
from .inventory_stock_location_update_data_type import InventoryStockLocationUpdateDataType
from .klarna_gateway import KlarnaGateway
from .klarna_gateway_create import KlarnaGatewayCreate
from .klarna_gateway_create_data import KlarnaGatewayCreateData
from .klarna_gateway_create_data_attributes import KlarnaGatewayCreateDataAttributes
from .klarna_gateway_create_data_attributes_metadata import KlarnaGatewayCreateDataAttributesMetadata
from .klarna_gateway_create_data_relationships import KlarnaGatewayCreateDataRelationships
from .klarna_gateway_create_data_relationships_klarna_payments import KlarnaGatewayCreateDataRelationshipsKlarnaPayments
from .klarna_gateway_create_data_relationships_klarna_payments_data import (
    KlarnaGatewayCreateDataRelationshipsKlarnaPaymentsData,
)
from .klarna_gateway_create_data_relationships_klarna_payments_data_type import (
    KlarnaGatewayCreateDataRelationshipsKlarnaPaymentsDataType,
)
from .klarna_gateway_create_data_type import KlarnaGatewayCreateDataType
from .klarna_gateway_data import KlarnaGatewayData
from .klarna_gateway_data_attributes import KlarnaGatewayDataAttributes
from .klarna_gateway_data_attributes_metadata import KlarnaGatewayDataAttributesMetadata
from .klarna_gateway_data_relationships import KlarnaGatewayDataRelationships
from .klarna_gateway_data_relationships_klarna_payments import KlarnaGatewayDataRelationshipsKlarnaPayments
from .klarna_gateway_data_relationships_klarna_payments_data import KlarnaGatewayDataRelationshipsKlarnaPaymentsData
from .klarna_gateway_data_relationships_klarna_payments_data_type import (
    KlarnaGatewayDataRelationshipsKlarnaPaymentsDataType,
)
from .klarna_gateway_data_relationships_payment_methods import KlarnaGatewayDataRelationshipsPaymentMethods
from .klarna_gateway_data_relationships_payment_methods_data import KlarnaGatewayDataRelationshipsPaymentMethodsData
from .klarna_gateway_data_relationships_payment_methods_data_type import (
    KlarnaGatewayDataRelationshipsPaymentMethodsDataType,
)
from .klarna_gateway_data_type import KlarnaGatewayDataType
from .klarna_gateway_update import KlarnaGatewayUpdate
from .klarna_gateway_update_data import KlarnaGatewayUpdateData
from .klarna_gateway_update_data_attributes import KlarnaGatewayUpdateDataAttributes
from .klarna_gateway_update_data_attributes_metadata import KlarnaGatewayUpdateDataAttributesMetadata
from .klarna_gateway_update_data_relationships import KlarnaGatewayUpdateDataRelationships
from .klarna_gateway_update_data_relationships_klarna_payments import KlarnaGatewayUpdateDataRelationshipsKlarnaPayments
from .klarna_gateway_update_data_relationships_klarna_payments_data import (
    KlarnaGatewayUpdateDataRelationshipsKlarnaPaymentsData,
)
from .klarna_gateway_update_data_relationships_klarna_payments_data_type import (
    KlarnaGatewayUpdateDataRelationshipsKlarnaPaymentsDataType,
)
from .klarna_gateway_update_data_type import KlarnaGatewayUpdateDataType
from .klarna_payment import KlarnaPayment
from .klarna_payment_create import KlarnaPaymentCreate
from .klarna_payment_create_data import KlarnaPaymentCreateData
from .klarna_payment_create_data_attributes import KlarnaPaymentCreateDataAttributes
from .klarna_payment_create_data_attributes_metadata import KlarnaPaymentCreateDataAttributesMetadata
from .klarna_payment_create_data_relationships import KlarnaPaymentCreateDataRelationships
from .klarna_payment_create_data_relationships_order import KlarnaPaymentCreateDataRelationshipsOrder
from .klarna_payment_create_data_relationships_order_data import KlarnaPaymentCreateDataRelationshipsOrderData
from .klarna_payment_create_data_relationships_order_data_type import KlarnaPaymentCreateDataRelationshipsOrderDataType
from .klarna_payment_create_data_type import KlarnaPaymentCreateDataType
from .klarna_payment_data import KlarnaPaymentData
from .klarna_payment_data_attributes import KlarnaPaymentDataAttributes
from .klarna_payment_data_attributes_metadata import KlarnaPaymentDataAttributesMetadata
from .klarna_payment_data_attributes_payment_methods_item import KlarnaPaymentDataAttributesPaymentMethodsItem
from .klarna_payment_data_relationships import KlarnaPaymentDataRelationships
from .klarna_payment_data_relationships_order import KlarnaPaymentDataRelationshipsOrder
from .klarna_payment_data_relationships_order_data import KlarnaPaymentDataRelationshipsOrderData
from .klarna_payment_data_relationships_order_data_type import KlarnaPaymentDataRelationshipsOrderDataType
from .klarna_payment_data_relationships_payment_gateway import KlarnaPaymentDataRelationshipsPaymentGateway
from .klarna_payment_data_relationships_payment_gateway_data import KlarnaPaymentDataRelationshipsPaymentGatewayData
from .klarna_payment_data_relationships_payment_gateway_data_type import (
    KlarnaPaymentDataRelationshipsPaymentGatewayDataType,
)
from .klarna_payment_data_type import KlarnaPaymentDataType
from .klarna_payment_update import KlarnaPaymentUpdate
from .klarna_payment_update_data import KlarnaPaymentUpdateData
from .klarna_payment_update_data_attributes import KlarnaPaymentUpdateDataAttributes
from .klarna_payment_update_data_attributes_metadata import KlarnaPaymentUpdateDataAttributesMetadata
from .klarna_payment_update_data_relationships import KlarnaPaymentUpdateDataRelationships
from .klarna_payment_update_data_relationships_order import KlarnaPaymentUpdateDataRelationshipsOrder
from .klarna_payment_update_data_relationships_order_data import KlarnaPaymentUpdateDataRelationshipsOrderData
from .klarna_payment_update_data_relationships_order_data_type import KlarnaPaymentUpdateDataRelationshipsOrderDataType
from .klarna_payment_update_data_type import KlarnaPaymentUpdateDataType
from .line_item import LineItem
from .line_item_create import LineItemCreate
from .line_item_create_data import LineItemCreateData
from .line_item_create_data_attributes import LineItemCreateDataAttributes
from .line_item_create_data_attributes_metadata import LineItemCreateDataAttributesMetadata
from .line_item_create_data_relationships import LineItemCreateDataRelationships
from .line_item_create_data_relationships_order import LineItemCreateDataRelationshipsOrder
from .line_item_create_data_relationships_order_data import LineItemCreateDataRelationshipsOrderData
from .line_item_create_data_relationships_order_data_type import LineItemCreateDataRelationshipsOrderDataType
from .line_item_create_data_type import LineItemCreateDataType
from .line_item_data import LineItemData
from .line_item_data_attributes import LineItemDataAttributes
from .line_item_data_attributes_discount_breakdown import LineItemDataAttributesDiscountBreakdown
from .line_item_data_attributes_metadata import LineItemDataAttributesMetadata
from .line_item_data_attributes_tax_breakdown import LineItemDataAttributesTaxBreakdown
from .line_item_data_relationships import LineItemDataRelationships
from .line_item_data_relationships_line_item_options import LineItemDataRelationshipsLineItemOptions
from .line_item_data_relationships_line_item_options_data import LineItemDataRelationshipsLineItemOptionsData
from .line_item_data_relationships_line_item_options_data_type import LineItemDataRelationshipsLineItemOptionsDataType
from .line_item_data_relationships_order import LineItemDataRelationshipsOrder
from .line_item_data_relationships_order_data import LineItemDataRelationshipsOrderData
from .line_item_data_relationships_order_data_type import LineItemDataRelationshipsOrderDataType
from .line_item_data_relationships_shipment_line_items import LineItemDataRelationshipsShipmentLineItems
from .line_item_data_relationships_shipment_line_items_data import LineItemDataRelationshipsShipmentLineItemsData
from .line_item_data_relationships_shipment_line_items_data_type import (
    LineItemDataRelationshipsShipmentLineItemsDataType,
)
from .line_item_data_relationships_stock_line_items import LineItemDataRelationshipsStockLineItems
from .line_item_data_relationships_stock_line_items_data import LineItemDataRelationshipsStockLineItemsData
from .line_item_data_relationships_stock_line_items_data_type import LineItemDataRelationshipsStockLineItemsDataType
from .line_item_data_relationships_stock_transfers import LineItemDataRelationshipsStockTransfers
from .line_item_data_relationships_stock_transfers_data import LineItemDataRelationshipsStockTransfersData
from .line_item_data_relationships_stock_transfers_data_type import LineItemDataRelationshipsStockTransfersDataType
from .line_item_data_type import LineItemDataType
from .line_item_option import LineItemOption
from .line_item_option_create import LineItemOptionCreate
from .line_item_option_create_data import LineItemOptionCreateData
from .line_item_option_create_data_attributes import LineItemOptionCreateDataAttributes
from .line_item_option_create_data_attributes_metadata import LineItemOptionCreateDataAttributesMetadata
from .line_item_option_create_data_attributes_options import LineItemOptionCreateDataAttributesOptions
from .line_item_option_create_data_relationships import LineItemOptionCreateDataRelationships
from .line_item_option_create_data_relationships_line_item import LineItemOptionCreateDataRelationshipsLineItem
from .line_item_option_create_data_relationships_line_item_data import LineItemOptionCreateDataRelationshipsLineItemData
from .line_item_option_create_data_relationships_line_item_data_type import (
    LineItemOptionCreateDataRelationshipsLineItemDataType,
)
from .line_item_option_create_data_relationships_sku_option import LineItemOptionCreateDataRelationshipsSkuOption
from .line_item_option_create_data_relationships_sku_option_data import (
    LineItemOptionCreateDataRelationshipsSkuOptionData,
)
from .line_item_option_create_data_relationships_sku_option_data_type import (
    LineItemOptionCreateDataRelationshipsSkuOptionDataType,
)
from .line_item_option_create_data_type import LineItemOptionCreateDataType
from .line_item_option_data import LineItemOptionData
from .line_item_option_data_attributes import LineItemOptionDataAttributes
from .line_item_option_data_attributes_metadata import LineItemOptionDataAttributesMetadata
from .line_item_option_data_attributes_options import LineItemOptionDataAttributesOptions
from .line_item_option_data_relationships import LineItemOptionDataRelationships
from .line_item_option_data_relationships_line_item import LineItemOptionDataRelationshipsLineItem
from .line_item_option_data_relationships_line_item_data import LineItemOptionDataRelationshipsLineItemData
from .line_item_option_data_relationships_line_item_data_type import LineItemOptionDataRelationshipsLineItemDataType
from .line_item_option_data_relationships_sku_option import LineItemOptionDataRelationshipsSkuOption
from .line_item_option_data_relationships_sku_option_data import LineItemOptionDataRelationshipsSkuOptionData
from .line_item_option_data_relationships_sku_option_data_type import LineItemOptionDataRelationshipsSkuOptionDataType
from .line_item_option_data_type import LineItemOptionDataType
from .line_item_option_update import LineItemOptionUpdate
from .line_item_option_update_data import LineItemOptionUpdateData
from .line_item_option_update_data_attributes import LineItemOptionUpdateDataAttributes
from .line_item_option_update_data_attributes_metadata import LineItemOptionUpdateDataAttributesMetadata
from .line_item_option_update_data_attributes_options import LineItemOptionUpdateDataAttributesOptions
from .line_item_option_update_data_relationships import LineItemOptionUpdateDataRelationships
from .line_item_option_update_data_relationships_sku_option import LineItemOptionUpdateDataRelationshipsSkuOption
from .line_item_option_update_data_relationships_sku_option_data import (
    LineItemOptionUpdateDataRelationshipsSkuOptionData,
)
from .line_item_option_update_data_relationships_sku_option_data_type import (
    LineItemOptionUpdateDataRelationshipsSkuOptionDataType,
)
from .line_item_option_update_data_type import LineItemOptionUpdateDataType
from .line_item_update import LineItemUpdate
from .line_item_update_data import LineItemUpdateData
from .line_item_update_data_attributes import LineItemUpdateDataAttributes
from .line_item_update_data_attributes_metadata import LineItemUpdateDataAttributesMetadata
from .line_item_update_data_relationships import LineItemUpdateDataRelationships
from .line_item_update_data_type import LineItemUpdateDataType
from .manual_gateway import ManualGateway
from .manual_gateway_create import ManualGatewayCreate
from .manual_gateway_create_data import ManualGatewayCreateData
from .manual_gateway_create_data_attributes import ManualGatewayCreateDataAttributes
from .manual_gateway_create_data_attributes_metadata import ManualGatewayCreateDataAttributesMetadata
from .manual_gateway_create_data_relationships import ManualGatewayCreateDataRelationships
from .manual_gateway_create_data_type import ManualGatewayCreateDataType
from .manual_gateway_data import ManualGatewayData
from .manual_gateway_data_attributes import ManualGatewayDataAttributes
from .manual_gateway_data_attributes_metadata import ManualGatewayDataAttributesMetadata
from .manual_gateway_data_relationships import ManualGatewayDataRelationships
from .manual_gateway_data_relationships_payment_methods import ManualGatewayDataRelationshipsPaymentMethods
from .manual_gateway_data_relationships_payment_methods_data import ManualGatewayDataRelationshipsPaymentMethodsData
from .manual_gateway_data_relationships_payment_methods_data_type import (
    ManualGatewayDataRelationshipsPaymentMethodsDataType,
)
from .manual_gateway_data_type import ManualGatewayDataType
from .manual_gateway_update import ManualGatewayUpdate
from .manual_gateway_update_data import ManualGatewayUpdateData
from .manual_gateway_update_data_attributes import ManualGatewayUpdateDataAttributes
from .manual_gateway_update_data_attributes_metadata import ManualGatewayUpdateDataAttributesMetadata
from .manual_gateway_update_data_relationships import ManualGatewayUpdateDataRelationships
from .manual_gateway_update_data_type import ManualGatewayUpdateDataType
from .manual_tax_calculator import ManualTaxCalculator
from .manual_tax_calculator_create import ManualTaxCalculatorCreate
from .manual_tax_calculator_create_data import ManualTaxCalculatorCreateData
from .manual_tax_calculator_create_data_attributes import ManualTaxCalculatorCreateDataAttributes
from .manual_tax_calculator_create_data_attributes_metadata import ManualTaxCalculatorCreateDataAttributesMetadata
from .manual_tax_calculator_create_data_relationships import ManualTaxCalculatorCreateDataRelationships
from .manual_tax_calculator_create_data_relationships_tax_rules import (
    ManualTaxCalculatorCreateDataRelationshipsTaxRules,
)
from .manual_tax_calculator_create_data_relationships_tax_rules_data import (
    ManualTaxCalculatorCreateDataRelationshipsTaxRulesData,
)
from .manual_tax_calculator_create_data_relationships_tax_rules_data_type import (
    ManualTaxCalculatorCreateDataRelationshipsTaxRulesDataType,
)
from .manual_tax_calculator_create_data_type import ManualTaxCalculatorCreateDataType
from .manual_tax_calculator_data import ManualTaxCalculatorData
from .manual_tax_calculator_data_attributes import ManualTaxCalculatorDataAttributes
from .manual_tax_calculator_data_attributes_metadata import ManualTaxCalculatorDataAttributesMetadata
from .manual_tax_calculator_data_relationships import ManualTaxCalculatorDataRelationships
from .manual_tax_calculator_data_relationships_attachments import ManualTaxCalculatorDataRelationshipsAttachments
from .manual_tax_calculator_data_relationships_attachments_data import (
    ManualTaxCalculatorDataRelationshipsAttachmentsData,
)
from .manual_tax_calculator_data_relationships_attachments_data_type import (
    ManualTaxCalculatorDataRelationshipsAttachmentsDataType,
)
from .manual_tax_calculator_data_relationships_markets import ManualTaxCalculatorDataRelationshipsMarkets
from .manual_tax_calculator_data_relationships_markets_data import ManualTaxCalculatorDataRelationshipsMarketsData
from .manual_tax_calculator_data_relationships_markets_data_type import (
    ManualTaxCalculatorDataRelationshipsMarketsDataType,
)
from .manual_tax_calculator_data_relationships_tax_rules import ManualTaxCalculatorDataRelationshipsTaxRules
from .manual_tax_calculator_data_relationships_tax_rules_data import ManualTaxCalculatorDataRelationshipsTaxRulesData
from .manual_tax_calculator_data_relationships_tax_rules_data_type import (
    ManualTaxCalculatorDataRelationshipsTaxRulesDataType,
)
from .manual_tax_calculator_data_type import ManualTaxCalculatorDataType
from .manual_tax_calculator_update import ManualTaxCalculatorUpdate
from .manual_tax_calculator_update_data import ManualTaxCalculatorUpdateData
from .manual_tax_calculator_update_data_attributes import ManualTaxCalculatorUpdateDataAttributes
from .manual_tax_calculator_update_data_attributes_metadata import ManualTaxCalculatorUpdateDataAttributesMetadata
from .manual_tax_calculator_update_data_relationships import ManualTaxCalculatorUpdateDataRelationships
from .manual_tax_calculator_update_data_relationships_tax_rules import (
    ManualTaxCalculatorUpdateDataRelationshipsTaxRules,
)
from .manual_tax_calculator_update_data_relationships_tax_rules_data import (
    ManualTaxCalculatorUpdateDataRelationshipsTaxRulesData,
)
from .manual_tax_calculator_update_data_relationships_tax_rules_data_type import (
    ManualTaxCalculatorUpdateDataRelationshipsTaxRulesDataType,
)
from .manual_tax_calculator_update_data_type import ManualTaxCalculatorUpdateDataType
from .market import Market
from .market_create import MarketCreate
from .market_create_data import MarketCreateData
from .market_create_data_attributes import MarketCreateDataAttributes
from .market_create_data_attributes_metadata import MarketCreateDataAttributesMetadata
from .market_create_data_relationships import MarketCreateDataRelationships
from .market_create_data_relationships_customer_group import MarketCreateDataRelationshipsCustomerGroup
from .market_create_data_relationships_customer_group_data import MarketCreateDataRelationshipsCustomerGroupData
from .market_create_data_relationships_customer_group_data_type import (
    MarketCreateDataRelationshipsCustomerGroupDataType,
)
from .market_create_data_relationships_inventory_model import MarketCreateDataRelationshipsInventoryModel
from .market_create_data_relationships_inventory_model_data import MarketCreateDataRelationshipsInventoryModelData
from .market_create_data_relationships_inventory_model_data_type import (
    MarketCreateDataRelationshipsInventoryModelDataType,
)
from .market_create_data_relationships_merchant import MarketCreateDataRelationshipsMerchant
from .market_create_data_relationships_merchant_data import MarketCreateDataRelationshipsMerchantData
from .market_create_data_relationships_merchant_data_type import MarketCreateDataRelationshipsMerchantDataType
from .market_create_data_relationships_price_list import MarketCreateDataRelationshipsPriceList
from .market_create_data_relationships_price_list_data import MarketCreateDataRelationshipsPriceListData
from .market_create_data_relationships_price_list_data_type import MarketCreateDataRelationshipsPriceListDataType
from .market_create_data_relationships_tax_calculator import MarketCreateDataRelationshipsTaxCalculator
from .market_create_data_relationships_tax_calculator_data import MarketCreateDataRelationshipsTaxCalculatorData
from .market_create_data_relationships_tax_calculator_data_type import (
    MarketCreateDataRelationshipsTaxCalculatorDataType,
)
from .market_create_data_type import MarketCreateDataType
from .market_data import MarketData
from .market_data_attributes import MarketDataAttributes
from .market_data_attributes_metadata import MarketDataAttributesMetadata
from .market_data_relationships import MarketDataRelationships
from .market_data_relationships_attachments import MarketDataRelationshipsAttachments
from .market_data_relationships_attachments_data import MarketDataRelationshipsAttachmentsData
from .market_data_relationships_attachments_data_type import MarketDataRelationshipsAttachmentsDataType
from .market_data_relationships_customer_group import MarketDataRelationshipsCustomerGroup
from .market_data_relationships_customer_group_data import MarketDataRelationshipsCustomerGroupData
from .market_data_relationships_customer_group_data_type import MarketDataRelationshipsCustomerGroupDataType
from .market_data_relationships_inventory_model import MarketDataRelationshipsInventoryModel
from .market_data_relationships_inventory_model_data import MarketDataRelationshipsInventoryModelData
from .market_data_relationships_inventory_model_data_type import MarketDataRelationshipsInventoryModelDataType
from .market_data_relationships_merchant import MarketDataRelationshipsMerchant
from .market_data_relationships_merchant_data import MarketDataRelationshipsMerchantData
from .market_data_relationships_merchant_data_type import MarketDataRelationshipsMerchantDataType
from .market_data_relationships_price_list import MarketDataRelationshipsPriceList
from .market_data_relationships_price_list_data import MarketDataRelationshipsPriceListData
from .market_data_relationships_price_list_data_type import MarketDataRelationshipsPriceListDataType
from .market_data_relationships_tax_calculator import MarketDataRelationshipsTaxCalculator
from .market_data_relationships_tax_calculator_data import MarketDataRelationshipsTaxCalculatorData
from .market_data_relationships_tax_calculator_data_type import MarketDataRelationshipsTaxCalculatorDataType
from .market_data_type import MarketDataType
from .market_update import MarketUpdate
from .market_update_data import MarketUpdateData
from .market_update_data_attributes import MarketUpdateDataAttributes
from .market_update_data_attributes_metadata import MarketUpdateDataAttributesMetadata
from .market_update_data_relationships import MarketUpdateDataRelationships
from .market_update_data_relationships_customer_group import MarketUpdateDataRelationshipsCustomerGroup
from .market_update_data_relationships_customer_group_data import MarketUpdateDataRelationshipsCustomerGroupData
from .market_update_data_relationships_customer_group_data_type import (
    MarketUpdateDataRelationshipsCustomerGroupDataType,
)
from .market_update_data_relationships_inventory_model import MarketUpdateDataRelationshipsInventoryModel
from .market_update_data_relationships_inventory_model_data import MarketUpdateDataRelationshipsInventoryModelData
from .market_update_data_relationships_inventory_model_data_type import (
    MarketUpdateDataRelationshipsInventoryModelDataType,
)
from .market_update_data_relationships_merchant import MarketUpdateDataRelationshipsMerchant
from .market_update_data_relationships_merchant_data import MarketUpdateDataRelationshipsMerchantData
from .market_update_data_relationships_merchant_data_type import MarketUpdateDataRelationshipsMerchantDataType
from .market_update_data_relationships_price_list import MarketUpdateDataRelationshipsPriceList
from .market_update_data_relationships_price_list_data import MarketUpdateDataRelationshipsPriceListData
from .market_update_data_relationships_price_list_data_type import MarketUpdateDataRelationshipsPriceListDataType
from .market_update_data_relationships_tax_calculator import MarketUpdateDataRelationshipsTaxCalculator
from .market_update_data_relationships_tax_calculator_data import MarketUpdateDataRelationshipsTaxCalculatorData
from .market_update_data_relationships_tax_calculator_data_type import (
    MarketUpdateDataRelationshipsTaxCalculatorDataType,
)
from .market_update_data_type import MarketUpdateDataType
from .merchant import Merchant
from .merchant_create import MerchantCreate
from .merchant_create_data import MerchantCreateData
from .merchant_create_data_attributes import MerchantCreateDataAttributes
from .merchant_create_data_attributes_metadata import MerchantCreateDataAttributesMetadata
from .merchant_create_data_relationships import MerchantCreateDataRelationships
from .merchant_create_data_relationships_address import MerchantCreateDataRelationshipsAddress
from .merchant_create_data_relationships_address_data import MerchantCreateDataRelationshipsAddressData
from .merchant_create_data_relationships_address_data_type import MerchantCreateDataRelationshipsAddressDataType
from .merchant_create_data_type import MerchantCreateDataType
from .merchant_data import MerchantData
from .merchant_data_attributes import MerchantDataAttributes
from .merchant_data_attributes_metadata import MerchantDataAttributesMetadata
from .merchant_data_relationships import MerchantDataRelationships
from .merchant_data_relationships_address import MerchantDataRelationshipsAddress
from .merchant_data_relationships_address_data import MerchantDataRelationshipsAddressData
from .merchant_data_relationships_address_data_type import MerchantDataRelationshipsAddressDataType
from .merchant_data_relationships_attachments import MerchantDataRelationshipsAttachments
from .merchant_data_relationships_attachments_data import MerchantDataRelationshipsAttachmentsData
from .merchant_data_relationships_attachments_data_type import MerchantDataRelationshipsAttachmentsDataType
from .merchant_data_type import MerchantDataType
from .merchant_update import MerchantUpdate
from .merchant_update_data import MerchantUpdateData
from .merchant_update_data_attributes import MerchantUpdateDataAttributes
from .merchant_update_data_attributes_metadata import MerchantUpdateDataAttributesMetadata
from .merchant_update_data_relationships import MerchantUpdateDataRelationships
from .merchant_update_data_relationships_address import MerchantUpdateDataRelationshipsAddress
from .merchant_update_data_relationships_address_data import MerchantUpdateDataRelationshipsAddressData
from .merchant_update_data_relationships_address_data_type import MerchantUpdateDataRelationshipsAddressDataType
from .merchant_update_data_type import MerchantUpdateDataType
from .order import Order
from .order_amount_promotion_rule import OrderAmountPromotionRule
from .order_amount_promotion_rule_create import OrderAmountPromotionRuleCreate
from .order_amount_promotion_rule_create_data import OrderAmountPromotionRuleCreateData
from .order_amount_promotion_rule_create_data_attributes import OrderAmountPromotionRuleCreateDataAttributes
from .order_amount_promotion_rule_create_data_attributes_metadata import (
    OrderAmountPromotionRuleCreateDataAttributesMetadata,
)
from .order_amount_promotion_rule_create_data_relationships import OrderAmountPromotionRuleCreateDataRelationships
from .order_amount_promotion_rule_create_data_type import OrderAmountPromotionRuleCreateDataType
from .order_amount_promotion_rule_data import OrderAmountPromotionRuleData
from .order_amount_promotion_rule_data_attributes import OrderAmountPromotionRuleDataAttributes
from .order_amount_promotion_rule_data_attributes_metadata import OrderAmountPromotionRuleDataAttributesMetadata
from .order_amount_promotion_rule_data_relationships import OrderAmountPromotionRuleDataRelationships
from .order_amount_promotion_rule_data_type import OrderAmountPromotionRuleDataType
from .order_amount_promotion_rule_update import OrderAmountPromotionRuleUpdate
from .order_amount_promotion_rule_update_data import OrderAmountPromotionRuleUpdateData
from .order_amount_promotion_rule_update_data_attributes import OrderAmountPromotionRuleUpdateDataAttributes
from .order_amount_promotion_rule_update_data_attributes_metadata import (
    OrderAmountPromotionRuleUpdateDataAttributesMetadata,
)
from .order_amount_promotion_rule_update_data_relationships import OrderAmountPromotionRuleUpdateDataRelationships
from .order_amount_promotion_rule_update_data_type import OrderAmountPromotionRuleUpdateDataType
from .order_copy import OrderCopy
from .order_copy_create import OrderCopyCreate
from .order_copy_create_data import OrderCopyCreateData
from .order_copy_create_data_attributes import OrderCopyCreateDataAttributes
from .order_copy_create_data_attributes_metadata import OrderCopyCreateDataAttributesMetadata
from .order_copy_create_data_relationships import OrderCopyCreateDataRelationships
from .order_copy_create_data_relationships_source_order import OrderCopyCreateDataRelationshipsSourceOrder
from .order_copy_create_data_relationships_source_order_data import OrderCopyCreateDataRelationshipsSourceOrderData
from .order_copy_create_data_relationships_source_order_data_type import (
    OrderCopyCreateDataRelationshipsSourceOrderDataType,
)
from .order_copy_create_data_type import OrderCopyCreateDataType
from .order_copy_data import OrderCopyData
from .order_copy_data_attributes import OrderCopyDataAttributes
from .order_copy_data_attributes_errors_log import OrderCopyDataAttributesErrorsLog
from .order_copy_data_attributes_metadata import OrderCopyDataAttributesMetadata
from .order_copy_data_relationships import OrderCopyDataRelationships
from .order_copy_data_relationships_events import OrderCopyDataRelationshipsEvents
from .order_copy_data_relationships_events_data import OrderCopyDataRelationshipsEventsData
from .order_copy_data_relationships_events_data_type import OrderCopyDataRelationshipsEventsDataType
from .order_copy_data_relationships_order_subscription import OrderCopyDataRelationshipsOrderSubscription
from .order_copy_data_relationships_order_subscription_data import OrderCopyDataRelationshipsOrderSubscriptionData
from .order_copy_data_relationships_order_subscription_data_type import (
    OrderCopyDataRelationshipsOrderSubscriptionDataType,
)
from .order_copy_data_relationships_source_order import OrderCopyDataRelationshipsSourceOrder
from .order_copy_data_relationships_source_order_data import OrderCopyDataRelationshipsSourceOrderData
from .order_copy_data_relationships_source_order_data_type import OrderCopyDataRelationshipsSourceOrderDataType
from .order_copy_data_relationships_target_order import OrderCopyDataRelationshipsTargetOrder
from .order_copy_data_relationships_target_order_data import OrderCopyDataRelationshipsTargetOrderData
from .order_copy_data_relationships_target_order_data_type import OrderCopyDataRelationshipsTargetOrderDataType
from .order_copy_data_type import OrderCopyDataType
from .order_create import OrderCreate
from .order_create_data import OrderCreateData
from .order_create_data_attributes import OrderCreateDataAttributes
from .order_create_data_attributes_metadata import OrderCreateDataAttributesMetadata
from .order_create_data_relationships import OrderCreateDataRelationships
from .order_create_data_relationships_billing_address import OrderCreateDataRelationshipsBillingAddress
from .order_create_data_relationships_billing_address_data import OrderCreateDataRelationshipsBillingAddressData
from .order_create_data_relationships_billing_address_data_type import (
    OrderCreateDataRelationshipsBillingAddressDataType,
)
from .order_create_data_relationships_customer import OrderCreateDataRelationshipsCustomer
from .order_create_data_relationships_customer_data import OrderCreateDataRelationshipsCustomerData
from .order_create_data_relationships_customer_data_type import OrderCreateDataRelationshipsCustomerDataType
from .order_create_data_relationships_market import OrderCreateDataRelationshipsMarket
from .order_create_data_relationships_market_data import OrderCreateDataRelationshipsMarketData
from .order_create_data_relationships_market_data_type import OrderCreateDataRelationshipsMarketDataType
from .order_create_data_relationships_payment_method import OrderCreateDataRelationshipsPaymentMethod
from .order_create_data_relationships_payment_method_data import OrderCreateDataRelationshipsPaymentMethodData
from .order_create_data_relationships_payment_method_data_type import OrderCreateDataRelationshipsPaymentMethodDataType
from .order_create_data_relationships_shipping_address import OrderCreateDataRelationshipsShippingAddress
from .order_create_data_relationships_shipping_address_data import OrderCreateDataRelationshipsShippingAddressData
from .order_create_data_relationships_shipping_address_data_type import (
    OrderCreateDataRelationshipsShippingAddressDataType,
)
from .order_create_data_type import OrderCreateDataType
from .order_data import OrderData
from .order_data_attributes import OrderDataAttributes
from .order_data_attributes_metadata import OrderDataAttributesMetadata
from .order_data_attributes_payment_source_details import OrderDataAttributesPaymentSourceDetails
from .order_data_relationships import OrderDataRelationships
from .order_data_relationships_attachments import OrderDataRelationshipsAttachments
from .order_data_relationships_attachments_data import OrderDataRelationshipsAttachmentsData
from .order_data_relationships_attachments_data_type import OrderDataRelationshipsAttachmentsDataType
from .order_data_relationships_authorizations import OrderDataRelationshipsAuthorizations
from .order_data_relationships_authorizations_data import OrderDataRelationshipsAuthorizationsData
from .order_data_relationships_authorizations_data_type import OrderDataRelationshipsAuthorizationsDataType
from .order_data_relationships_available_customer_payment_sources import (
    OrderDataRelationshipsAvailableCustomerPaymentSources,
)
from .order_data_relationships_available_customer_payment_sources_data import (
    OrderDataRelationshipsAvailableCustomerPaymentSourcesData,
)
from .order_data_relationships_available_customer_payment_sources_data_type import (
    OrderDataRelationshipsAvailableCustomerPaymentSourcesDataType,
)
from .order_data_relationships_available_free_bundles import OrderDataRelationshipsAvailableFreeBundles
from .order_data_relationships_available_free_bundles_data import OrderDataRelationshipsAvailableFreeBundlesData
from .order_data_relationships_available_free_bundles_data_type import (
    OrderDataRelationshipsAvailableFreeBundlesDataType,
)
from .order_data_relationships_available_free_skus import OrderDataRelationshipsAvailableFreeSkus
from .order_data_relationships_available_free_skus_data import OrderDataRelationshipsAvailableFreeSkusData
from .order_data_relationships_available_free_skus_data_type import OrderDataRelationshipsAvailableFreeSkusDataType
from .order_data_relationships_available_payment_methods import OrderDataRelationshipsAvailablePaymentMethods
from .order_data_relationships_available_payment_methods_data import OrderDataRelationshipsAvailablePaymentMethodsData
from .order_data_relationships_available_payment_methods_data_type import (
    OrderDataRelationshipsAvailablePaymentMethodsDataType,
)
from .order_data_relationships_billing_address import OrderDataRelationshipsBillingAddress
from .order_data_relationships_billing_address_data import OrderDataRelationshipsBillingAddressData
from .order_data_relationships_billing_address_data_type import OrderDataRelationshipsBillingAddressDataType
from .order_data_relationships_captures import OrderDataRelationshipsCaptures
from .order_data_relationships_captures_data import OrderDataRelationshipsCapturesData
from .order_data_relationships_captures_data_type import OrderDataRelationshipsCapturesDataType
from .order_data_relationships_customer import OrderDataRelationshipsCustomer
from .order_data_relationships_customer_data import OrderDataRelationshipsCustomerData
from .order_data_relationships_customer_data_type import OrderDataRelationshipsCustomerDataType
from .order_data_relationships_events import OrderDataRelationshipsEvents
from .order_data_relationships_events_data import OrderDataRelationshipsEventsData
from .order_data_relationships_events_data_type import OrderDataRelationshipsEventsDataType
from .order_data_relationships_line_items import OrderDataRelationshipsLineItems
from .order_data_relationships_line_items_data import OrderDataRelationshipsLineItemsData
from .order_data_relationships_line_items_data_type import OrderDataRelationshipsLineItemsDataType
from .order_data_relationships_market import OrderDataRelationshipsMarket
from .order_data_relationships_market_data import OrderDataRelationshipsMarketData
from .order_data_relationships_market_data_type import OrderDataRelationshipsMarketDataType
from .order_data_relationships_order_copies import OrderDataRelationshipsOrderCopies
from .order_data_relationships_order_copies_data import OrderDataRelationshipsOrderCopiesData
from .order_data_relationships_order_copies_data_type import OrderDataRelationshipsOrderCopiesDataType
from .order_data_relationships_order_subscriptions import OrderDataRelationshipsOrderSubscriptions
from .order_data_relationships_order_subscriptions_data import OrderDataRelationshipsOrderSubscriptionsData
from .order_data_relationships_order_subscriptions_data_type import OrderDataRelationshipsOrderSubscriptionsDataType
from .order_data_relationships_payment_method import OrderDataRelationshipsPaymentMethod
from .order_data_relationships_payment_method_data import OrderDataRelationshipsPaymentMethodData
from .order_data_relationships_payment_method_data_type import OrderDataRelationshipsPaymentMethodDataType
from .order_data_relationships_refunds import OrderDataRelationshipsRefunds
from .order_data_relationships_refunds_data import OrderDataRelationshipsRefundsData
from .order_data_relationships_refunds_data_type import OrderDataRelationshipsRefundsDataType
from .order_data_relationships_shipments import OrderDataRelationshipsShipments
from .order_data_relationships_shipments_data import OrderDataRelationshipsShipmentsData
from .order_data_relationships_shipments_data_type import OrderDataRelationshipsShipmentsDataType
from .order_data_relationships_shipping_address import OrderDataRelationshipsShippingAddress
from .order_data_relationships_shipping_address_data import OrderDataRelationshipsShippingAddressData
from .order_data_relationships_shipping_address_data_type import OrderDataRelationshipsShippingAddressDataType
from .order_data_relationships_voids import OrderDataRelationshipsVoids
from .order_data_relationships_voids_data import OrderDataRelationshipsVoidsData
from .order_data_relationships_voids_data_type import OrderDataRelationshipsVoidsDataType
from .order_data_type import OrderDataType
from .order_subscription import OrderSubscription
from .order_subscription_create import OrderSubscriptionCreate
from .order_subscription_create_data import OrderSubscriptionCreateData
from .order_subscription_create_data_attributes import OrderSubscriptionCreateDataAttributes
from .order_subscription_create_data_attributes_metadata import OrderSubscriptionCreateDataAttributesMetadata
from .order_subscription_create_data_attributes_options import OrderSubscriptionCreateDataAttributesOptions
from .order_subscription_create_data_relationships import OrderSubscriptionCreateDataRelationships
from .order_subscription_create_data_relationships_market import OrderSubscriptionCreateDataRelationshipsMarket
from .order_subscription_create_data_relationships_market_data import OrderSubscriptionCreateDataRelationshipsMarketData
from .order_subscription_create_data_relationships_market_data_type import (
    OrderSubscriptionCreateDataRelationshipsMarketDataType,
)
from .order_subscription_create_data_relationships_source_order import (
    OrderSubscriptionCreateDataRelationshipsSourceOrder,
)
from .order_subscription_create_data_relationships_source_order_data import (
    OrderSubscriptionCreateDataRelationshipsSourceOrderData,
)
from .order_subscription_create_data_relationships_source_order_data_type import (
    OrderSubscriptionCreateDataRelationshipsSourceOrderDataType,
)
from .order_subscription_create_data_type import OrderSubscriptionCreateDataType
from .order_subscription_data import OrderSubscriptionData
from .order_subscription_data_attributes import OrderSubscriptionDataAttributes
from .order_subscription_data_attributes_metadata import OrderSubscriptionDataAttributesMetadata
from .order_subscription_data_attributes_options import OrderSubscriptionDataAttributesOptions
from .order_subscription_data_relationships import OrderSubscriptionDataRelationships
from .order_subscription_data_relationships_customer import OrderSubscriptionDataRelationshipsCustomer
from .order_subscription_data_relationships_customer_data import OrderSubscriptionDataRelationshipsCustomerData
from .order_subscription_data_relationships_customer_data_type import OrderSubscriptionDataRelationshipsCustomerDataType
from .order_subscription_data_relationships_events import OrderSubscriptionDataRelationshipsEvents
from .order_subscription_data_relationships_events_data import OrderSubscriptionDataRelationshipsEventsData
from .order_subscription_data_relationships_events_data_type import OrderSubscriptionDataRelationshipsEventsDataType
from .order_subscription_data_relationships_market import OrderSubscriptionDataRelationshipsMarket
from .order_subscription_data_relationships_market_data import OrderSubscriptionDataRelationshipsMarketData
from .order_subscription_data_relationships_market_data_type import OrderSubscriptionDataRelationshipsMarketDataType
from .order_subscription_data_relationships_order_copies import OrderSubscriptionDataRelationshipsOrderCopies
from .order_subscription_data_relationships_order_copies_data import OrderSubscriptionDataRelationshipsOrderCopiesData
from .order_subscription_data_relationships_order_copies_data_type import (
    OrderSubscriptionDataRelationshipsOrderCopiesDataType,
)
from .order_subscription_data_relationships_orders import OrderSubscriptionDataRelationshipsOrders
from .order_subscription_data_relationships_orders_data import OrderSubscriptionDataRelationshipsOrdersData
from .order_subscription_data_relationships_orders_data_type import OrderSubscriptionDataRelationshipsOrdersDataType
from .order_subscription_data_relationships_source_order import OrderSubscriptionDataRelationshipsSourceOrder
from .order_subscription_data_relationships_source_order_data import OrderSubscriptionDataRelationshipsSourceOrderData
from .order_subscription_data_relationships_source_order_data_type import (
    OrderSubscriptionDataRelationshipsSourceOrderDataType,
)
from .order_subscription_data_type import OrderSubscriptionDataType
from .order_subscription_update import OrderSubscriptionUpdate
from .order_subscription_update_data import OrderSubscriptionUpdateData
from .order_subscription_update_data_attributes import OrderSubscriptionUpdateDataAttributes
from .order_subscription_update_data_attributes_metadata import OrderSubscriptionUpdateDataAttributesMetadata
from .order_subscription_update_data_relationships import OrderSubscriptionUpdateDataRelationships
from .order_subscription_update_data_type import OrderSubscriptionUpdateDataType
from .order_update import OrderUpdate
from .order_update_data import OrderUpdateData
from .order_update_data_attributes import OrderUpdateDataAttributes
from .order_update_data_attributes_metadata import OrderUpdateDataAttributesMetadata
from .order_update_data_relationships import OrderUpdateDataRelationships
from .order_update_data_relationships_billing_address import OrderUpdateDataRelationshipsBillingAddress
from .order_update_data_relationships_billing_address_data import OrderUpdateDataRelationshipsBillingAddressData
from .order_update_data_relationships_billing_address_data_type import (
    OrderUpdateDataRelationshipsBillingAddressDataType,
)
from .order_update_data_relationships_customer import OrderUpdateDataRelationshipsCustomer
from .order_update_data_relationships_customer_data import OrderUpdateDataRelationshipsCustomerData
from .order_update_data_relationships_customer_data_type import OrderUpdateDataRelationshipsCustomerDataType
from .order_update_data_relationships_market import OrderUpdateDataRelationshipsMarket
from .order_update_data_relationships_market_data import OrderUpdateDataRelationshipsMarketData
from .order_update_data_relationships_market_data_type import OrderUpdateDataRelationshipsMarketDataType
from .order_update_data_relationships_payment_method import OrderUpdateDataRelationshipsPaymentMethod
from .order_update_data_relationships_payment_method_data import OrderUpdateDataRelationshipsPaymentMethodData
from .order_update_data_relationships_payment_method_data_type import OrderUpdateDataRelationshipsPaymentMethodDataType
from .order_update_data_relationships_shipping_address import OrderUpdateDataRelationshipsShippingAddress
from .order_update_data_relationships_shipping_address_data import OrderUpdateDataRelationshipsShippingAddressData
from .order_update_data_relationships_shipping_address_data_type import (
    OrderUpdateDataRelationshipsShippingAddressDataType,
)
from .order_update_data_type import OrderUpdateDataType
from .order_validation_rule import OrderValidationRule
from .order_validation_rule_data import OrderValidationRuleData
from .order_validation_rule_data_attributes import OrderValidationRuleDataAttributes
from .order_validation_rule_data_attributes_metadata import OrderValidationRuleDataAttributesMetadata
from .order_validation_rule_data_relationships import OrderValidationRuleDataRelationships
from .order_validation_rule_data_relationships_market import OrderValidationRuleDataRelationshipsMarket
from .order_validation_rule_data_relationships_market_data import OrderValidationRuleDataRelationshipsMarketData
from .order_validation_rule_data_relationships_market_data_type import (
    OrderValidationRuleDataRelationshipsMarketDataType,
)
from .order_validation_rule_data_type import OrderValidationRuleDataType
from .organization import Organization
from .organization_data import OrganizationData
from .organization_data_attributes import OrganizationDataAttributes
from .organization_data_attributes_metadata import OrganizationDataAttributesMetadata
from .organization_data_relationships import OrganizationDataRelationships
from .organization_data_type import OrganizationDataType
from .package import Package
from .package_create import PackageCreate
from .package_create_data import PackageCreateData
from .package_create_data_attributes import PackageCreateDataAttributes
from .package_create_data_attributes_metadata import PackageCreateDataAttributesMetadata
from .package_create_data_relationships import PackageCreateDataRelationships
from .package_create_data_relationships_stock_location import PackageCreateDataRelationshipsStockLocation
from .package_create_data_relationships_stock_location_data import PackageCreateDataRelationshipsStockLocationData
from .package_create_data_relationships_stock_location_data_type import (
    PackageCreateDataRelationshipsStockLocationDataType,
)
from .package_create_data_type import PackageCreateDataType
from .package_data import PackageData
from .package_data_attributes import PackageDataAttributes
from .package_data_attributes_metadata import PackageDataAttributesMetadata
from .package_data_relationships import PackageDataRelationships
from .package_data_relationships_attachments import PackageDataRelationshipsAttachments
from .package_data_relationships_attachments_data import PackageDataRelationshipsAttachmentsData
from .package_data_relationships_attachments_data_type import PackageDataRelationshipsAttachmentsDataType
from .package_data_relationships_parcels import PackageDataRelationshipsParcels
from .package_data_relationships_parcels_data import PackageDataRelationshipsParcelsData
from .package_data_relationships_parcels_data_type import PackageDataRelationshipsParcelsDataType
from .package_data_relationships_stock_location import PackageDataRelationshipsStockLocation
from .package_data_relationships_stock_location_data import PackageDataRelationshipsStockLocationData
from .package_data_relationships_stock_location_data_type import PackageDataRelationshipsStockLocationDataType
from .package_data_type import PackageDataType
from .package_update import PackageUpdate
from .package_update_data import PackageUpdateData
from .package_update_data_attributes import PackageUpdateDataAttributes
from .package_update_data_attributes_metadata import PackageUpdateDataAttributesMetadata
from .package_update_data_relationships import PackageUpdateDataRelationships
from .package_update_data_relationships_stock_location import PackageUpdateDataRelationshipsStockLocation
from .package_update_data_relationships_stock_location_data import PackageUpdateDataRelationshipsStockLocationData
from .package_update_data_relationships_stock_location_data_type import (
    PackageUpdateDataRelationshipsStockLocationDataType,
)
from .package_update_data_type import PackageUpdateDataType
from .parcel import Parcel
from .parcel_create import ParcelCreate
from .parcel_create_data import ParcelCreateData
from .parcel_create_data_attributes import ParcelCreateDataAttributes
from .parcel_create_data_attributes_metadata import ParcelCreateDataAttributesMetadata
from .parcel_create_data_relationships import ParcelCreateDataRelationships
from .parcel_create_data_relationships_package import ParcelCreateDataRelationshipsPackage
from .parcel_create_data_relationships_package_data import ParcelCreateDataRelationshipsPackageData
from .parcel_create_data_relationships_package_data_type import ParcelCreateDataRelationshipsPackageDataType
from .parcel_create_data_relationships_shipment import ParcelCreateDataRelationshipsShipment
from .parcel_create_data_relationships_shipment_data import ParcelCreateDataRelationshipsShipmentData
from .parcel_create_data_relationships_shipment_data_type import ParcelCreateDataRelationshipsShipmentDataType
from .parcel_create_data_type import ParcelCreateDataType
from .parcel_data import ParcelData
from .parcel_data_attributes import ParcelDataAttributes
from .parcel_data_attributes_metadata import ParcelDataAttributesMetadata
from .parcel_data_relationships import ParcelDataRelationships
from .parcel_data_relationships_attachments import ParcelDataRelationshipsAttachments
from .parcel_data_relationships_attachments_data import ParcelDataRelationshipsAttachmentsData
from .parcel_data_relationships_attachments_data_type import ParcelDataRelationshipsAttachmentsDataType
from .parcel_data_relationships_events import ParcelDataRelationshipsEvents
from .parcel_data_relationships_events_data import ParcelDataRelationshipsEventsData
from .parcel_data_relationships_events_data_type import ParcelDataRelationshipsEventsDataType
from .parcel_data_relationships_package import ParcelDataRelationshipsPackage
from .parcel_data_relationships_package_data import ParcelDataRelationshipsPackageData
from .parcel_data_relationships_package_data_type import ParcelDataRelationshipsPackageDataType
from .parcel_data_relationships_parcel_line_items import ParcelDataRelationshipsParcelLineItems
from .parcel_data_relationships_parcel_line_items_data import ParcelDataRelationshipsParcelLineItemsData
from .parcel_data_relationships_parcel_line_items_data_type import ParcelDataRelationshipsParcelLineItemsDataType
from .parcel_data_relationships_shipment import ParcelDataRelationshipsShipment
from .parcel_data_relationships_shipment_data import ParcelDataRelationshipsShipmentData
from .parcel_data_relationships_shipment_data_type import ParcelDataRelationshipsShipmentDataType
from .parcel_data_type import ParcelDataType
from .parcel_line_item import ParcelLineItem
from .parcel_line_item_create import ParcelLineItemCreate
from .parcel_line_item_create_data import ParcelLineItemCreateData
from .parcel_line_item_create_data_attributes import ParcelLineItemCreateDataAttributes
from .parcel_line_item_create_data_attributes_metadata import ParcelLineItemCreateDataAttributesMetadata
from .parcel_line_item_create_data_relationships import ParcelLineItemCreateDataRelationships
from .parcel_line_item_create_data_relationships_parcel import ParcelLineItemCreateDataRelationshipsParcel
from .parcel_line_item_create_data_relationships_parcel_data import ParcelLineItemCreateDataRelationshipsParcelData
from .parcel_line_item_create_data_relationships_parcel_data_type import (
    ParcelLineItemCreateDataRelationshipsParcelDataType,
)
from .parcel_line_item_create_data_relationships_shipment_line_item import (
    ParcelLineItemCreateDataRelationshipsShipmentLineItem,
)
from .parcel_line_item_create_data_relationships_shipment_line_item_data import (
    ParcelLineItemCreateDataRelationshipsShipmentLineItemData,
)
from .parcel_line_item_create_data_relationships_shipment_line_item_data_type import (
    ParcelLineItemCreateDataRelationshipsShipmentLineItemDataType,
)
from .parcel_line_item_create_data_relationships_stock_line_item import (
    ParcelLineItemCreateDataRelationshipsStockLineItem,
)
from .parcel_line_item_create_data_relationships_stock_line_item_data import (
    ParcelLineItemCreateDataRelationshipsStockLineItemData,
)
from .parcel_line_item_create_data_relationships_stock_line_item_data_type import (
    ParcelLineItemCreateDataRelationshipsStockLineItemDataType,
)
from .parcel_line_item_create_data_type import ParcelLineItemCreateDataType
from .parcel_line_item_data import ParcelLineItemData
from .parcel_line_item_data_attributes import ParcelLineItemDataAttributes
from .parcel_line_item_data_attributes_metadata import ParcelLineItemDataAttributesMetadata
from .parcel_line_item_data_relationships import ParcelLineItemDataRelationships
from .parcel_line_item_data_relationships_parcel import ParcelLineItemDataRelationshipsParcel
from .parcel_line_item_data_relationships_parcel_data import ParcelLineItemDataRelationshipsParcelData
from .parcel_line_item_data_relationships_parcel_data_type import ParcelLineItemDataRelationshipsParcelDataType
from .parcel_line_item_data_relationships_shipment_line_item import ParcelLineItemDataRelationshipsShipmentLineItem
from .parcel_line_item_data_relationships_shipment_line_item_data import (
    ParcelLineItemDataRelationshipsShipmentLineItemData,
)
from .parcel_line_item_data_relationships_shipment_line_item_data_type import (
    ParcelLineItemDataRelationshipsShipmentLineItemDataType,
)
from .parcel_line_item_data_relationships_stock_line_item import ParcelLineItemDataRelationshipsStockLineItem
from .parcel_line_item_data_relationships_stock_line_item_data import ParcelLineItemDataRelationshipsStockLineItemData
from .parcel_line_item_data_relationships_stock_line_item_data_type import (
    ParcelLineItemDataRelationshipsStockLineItemDataType,
)
from .parcel_line_item_data_type import ParcelLineItemDataType
from .parcel_line_item_update import ParcelLineItemUpdate
from .parcel_line_item_update_data import ParcelLineItemUpdateData
from .parcel_line_item_update_data_attributes import ParcelLineItemUpdateDataAttributes
from .parcel_line_item_update_data_attributes_metadata import ParcelLineItemUpdateDataAttributesMetadata
from .parcel_line_item_update_data_relationships import ParcelLineItemUpdateDataRelationships
from .parcel_line_item_update_data_type import ParcelLineItemUpdateDataType
from .parcel_update import ParcelUpdate
from .parcel_update_data import ParcelUpdateData
from .parcel_update_data_attributes import ParcelUpdateDataAttributes
from .parcel_update_data_attributes_metadata import ParcelUpdateDataAttributesMetadata
from .parcel_update_data_relationships import ParcelUpdateDataRelationships
from .parcel_update_data_relationships_package import ParcelUpdateDataRelationshipsPackage
from .parcel_update_data_relationships_package_data import ParcelUpdateDataRelationshipsPackageData
from .parcel_update_data_relationships_package_data_type import ParcelUpdateDataRelationshipsPackageDataType
from .parcel_update_data_relationships_shipment import ParcelUpdateDataRelationshipsShipment
from .parcel_update_data_relationships_shipment_data import ParcelUpdateDataRelationshipsShipmentData
from .parcel_update_data_relationships_shipment_data_type import ParcelUpdateDataRelationshipsShipmentDataType
from .parcel_update_data_type import ParcelUpdateDataType
from .patc_haddressesaddress_id_response_200 import PATCHaddressesaddressIdResponse200
from .patc_haddressesaddress_id_response_200_data import PATCHaddressesaddressIdResponse200Data
from .patc_haddressesaddress_id_response_200_data_attributes import PATCHaddressesaddressIdResponse200DataAttributes
from .patc_haddressesaddress_id_response_200_data_attributes_metadata import (
    PATCHaddressesaddressIdResponse200DataAttributesMetadata,
)
from .patc_haddressesaddress_id_response_200_data_links import PATCHaddressesaddressIdResponse200DataLinks
from .patc_haddressesaddress_id_response_200_data_relationships import (
    PATCHaddressesaddressIdResponse200DataRelationships,
)
from .patc_haddressesaddress_id_response_200_data_relationships_geocoder import (
    PATCHaddressesaddressIdResponse200DataRelationshipsGeocoder,
)
from .patc_haddressesaddress_id_response_200_data_relationships_geocoder_data import (
    PATCHaddressesaddressIdResponse200DataRelationshipsGeocoderData,
)
from .patc_haddressesaddress_id_response_200_data_relationships_geocoder_data_type import (
    PATCHaddressesaddressIdResponse200DataRelationshipsGeocoderDataType,
)
from .patc_haddressesaddress_id_response_200_data_relationships_geocoder_links import (
    PATCHaddressesaddressIdResponse200DataRelationshipsGeocoderLinks,
)
from .patc_haddressesaddress_id_response_200_data_type import PATCHaddressesaddressIdResponse200DataType
from .patc_hadjustmentsadjustment_id_response_200 import PATCHadjustmentsadjustmentIdResponse200
from .patc_hadjustmentsadjustment_id_response_200_data import PATCHadjustmentsadjustmentIdResponse200Data
from .patc_hadjustmentsadjustment_id_response_200_data_attributes import (
    PATCHadjustmentsadjustmentIdResponse200DataAttributes,
)
from .patc_hadjustmentsadjustment_id_response_200_data_attributes_metadata import (
    PATCHadjustmentsadjustmentIdResponse200DataAttributesMetadata,
)
from .patc_hadjustmentsadjustment_id_response_200_data_links import PATCHadjustmentsadjustmentIdResponse200DataLinks
from .patc_hadjustmentsadjustment_id_response_200_data_relationships import (
    PATCHadjustmentsadjustmentIdResponse200DataRelationships,
)
from .patc_hadjustmentsadjustment_id_response_200_data_type import PATCHadjustmentsadjustmentIdResponse200DataType
from .patc_hadyen_gatewaysadyen_gateway_id_response_200 import PATCHadyenGatewaysadyenGatewayIdResponse200
from .patc_hadyen_gatewaysadyen_gateway_id_response_200_data import PATCHadyenGatewaysadyenGatewayIdResponse200Data
from .patc_hadyen_gatewaysadyen_gateway_id_response_200_data_attributes import (
    PATCHadyenGatewaysadyenGatewayIdResponse200DataAttributes,
)
from .patc_hadyen_gatewaysadyen_gateway_id_response_200_data_attributes_metadata import (
    PATCHadyenGatewaysadyenGatewayIdResponse200DataAttributesMetadata,
)
from .patc_hadyen_gatewaysadyen_gateway_id_response_200_data_links import (
    PATCHadyenGatewaysadyenGatewayIdResponse200DataLinks,
)
from .patc_hadyen_gatewaysadyen_gateway_id_response_200_data_relationships import (
    PATCHadyenGatewaysadyenGatewayIdResponse200DataRelationships,
)
from .patc_hadyen_gatewaysadyen_gateway_id_response_200_data_relationships_adyen_payments import (
    PATCHadyenGatewaysadyenGatewayIdResponse200DataRelationshipsAdyenPayments,
)
from .patc_hadyen_gatewaysadyen_gateway_id_response_200_data_relationships_adyen_payments_data import (
    PATCHadyenGatewaysadyenGatewayIdResponse200DataRelationshipsAdyenPaymentsData,
)
from .patc_hadyen_gatewaysadyen_gateway_id_response_200_data_relationships_adyen_payments_data_type import (
    PATCHadyenGatewaysadyenGatewayIdResponse200DataRelationshipsAdyenPaymentsDataType,
)
from .patc_hadyen_gatewaysadyen_gateway_id_response_200_data_relationships_adyen_payments_links import (
    PATCHadyenGatewaysadyenGatewayIdResponse200DataRelationshipsAdyenPaymentsLinks,
)
from .patc_hadyen_gatewaysadyen_gateway_id_response_200_data_relationships_payment_methods import (
    PATCHadyenGatewaysadyenGatewayIdResponse200DataRelationshipsPaymentMethods,
)
from .patc_hadyen_gatewaysadyen_gateway_id_response_200_data_relationships_payment_methods_data import (
    PATCHadyenGatewaysadyenGatewayIdResponse200DataRelationshipsPaymentMethodsData,
)
from .patc_hadyen_gatewaysadyen_gateway_id_response_200_data_relationships_payment_methods_data_type import (
    PATCHadyenGatewaysadyenGatewayIdResponse200DataRelationshipsPaymentMethodsDataType,
)
from .patc_hadyen_gatewaysadyen_gateway_id_response_200_data_relationships_payment_methods_links import (
    PATCHadyenGatewaysadyenGatewayIdResponse200DataRelationshipsPaymentMethodsLinks,
)
from .patc_hadyen_gatewaysadyen_gateway_id_response_200_data_type import (
    PATCHadyenGatewaysadyenGatewayIdResponse200DataType,
)
from .patc_hadyen_paymentsadyen_payment_id_response_200 import PATCHadyenPaymentsadyenPaymentIdResponse200
from .patc_hadyen_paymentsadyen_payment_id_response_200_data import PATCHadyenPaymentsadyenPaymentIdResponse200Data
from .patc_hadyen_paymentsadyen_payment_id_response_200_data_attributes import (
    PATCHadyenPaymentsadyenPaymentIdResponse200DataAttributes,
)
from .patc_hadyen_paymentsadyen_payment_id_response_200_data_attributes_metadata import (
    PATCHadyenPaymentsadyenPaymentIdResponse200DataAttributesMetadata,
)
from .patc_hadyen_paymentsadyen_payment_id_response_200_data_attributes_payment_request_data import (
    PATCHadyenPaymentsadyenPaymentIdResponse200DataAttributesPaymentRequestData,
)
from .patc_hadyen_paymentsadyen_payment_id_response_200_data_attributes_payment_request_details import (
    PATCHadyenPaymentsadyenPaymentIdResponse200DataAttributesPaymentRequestDetails,
)
from .patc_hadyen_paymentsadyen_payment_id_response_200_data_attributes_payment_response import (
    PATCHadyenPaymentsadyenPaymentIdResponse200DataAttributesPaymentResponse,
)
from .patc_hadyen_paymentsadyen_payment_id_response_200_data_links import (
    PATCHadyenPaymentsadyenPaymentIdResponse200DataLinks,
)
from .patc_hadyen_paymentsadyen_payment_id_response_200_data_relationships import (
    PATCHadyenPaymentsadyenPaymentIdResponse200DataRelationships,
)
from .patc_hadyen_paymentsadyen_payment_id_response_200_data_relationships_order import (
    PATCHadyenPaymentsadyenPaymentIdResponse200DataRelationshipsOrder,
)
from .patc_hadyen_paymentsadyen_payment_id_response_200_data_relationships_order_data import (
    PATCHadyenPaymentsadyenPaymentIdResponse200DataRelationshipsOrderData,
)
from .patc_hadyen_paymentsadyen_payment_id_response_200_data_relationships_order_data_type import (
    PATCHadyenPaymentsadyenPaymentIdResponse200DataRelationshipsOrderDataType,
)
from .patc_hadyen_paymentsadyen_payment_id_response_200_data_relationships_order_links import (
    PATCHadyenPaymentsadyenPaymentIdResponse200DataRelationshipsOrderLinks,
)
from .patc_hadyen_paymentsadyen_payment_id_response_200_data_relationships_payment_gateway import (
    PATCHadyenPaymentsadyenPaymentIdResponse200DataRelationshipsPaymentGateway,
)
from .patc_hadyen_paymentsadyen_payment_id_response_200_data_relationships_payment_gateway_data import (
    PATCHadyenPaymentsadyenPaymentIdResponse200DataRelationshipsPaymentGatewayData,
)
from .patc_hadyen_paymentsadyen_payment_id_response_200_data_relationships_payment_gateway_data_type import (
    PATCHadyenPaymentsadyenPaymentIdResponse200DataRelationshipsPaymentGatewayDataType,
)
from .patc_hadyen_paymentsadyen_payment_id_response_200_data_relationships_payment_gateway_links import (
    PATCHadyenPaymentsadyenPaymentIdResponse200DataRelationshipsPaymentGatewayLinks,
)
from .patc_hadyen_paymentsadyen_payment_id_response_200_data_type import (
    PATCHadyenPaymentsadyenPaymentIdResponse200DataType,
)
from .patc_hattachmentsattachment_id_response_200 import PATCHattachmentsattachmentIdResponse200
from .patc_hattachmentsattachment_id_response_200_data import PATCHattachmentsattachmentIdResponse200Data
from .patc_hattachmentsattachment_id_response_200_data_attributes import (
    PATCHattachmentsattachmentIdResponse200DataAttributes,
)
from .patc_hattachmentsattachment_id_response_200_data_attributes_metadata import (
    PATCHattachmentsattachmentIdResponse200DataAttributesMetadata,
)
from .patc_hattachmentsattachment_id_response_200_data_links import PATCHattachmentsattachmentIdResponse200DataLinks
from .patc_hattachmentsattachment_id_response_200_data_relationships import (
    PATCHattachmentsattachmentIdResponse200DataRelationships,
)
from .patc_hattachmentsattachment_id_response_200_data_relationships_attachable import (
    PATCHattachmentsattachmentIdResponse200DataRelationshipsAttachable,
)
from .patc_hattachmentsattachment_id_response_200_data_relationships_attachable_data import (
    PATCHattachmentsattachmentIdResponse200DataRelationshipsAttachableData,
)
from .patc_hattachmentsattachment_id_response_200_data_relationships_attachable_data_type import (
    PATCHattachmentsattachmentIdResponse200DataRelationshipsAttachableDataType,
)
from .patc_hattachmentsattachment_id_response_200_data_relationships_attachable_links import (
    PATCHattachmentsattachmentIdResponse200DataRelationshipsAttachableLinks,
)
from .patc_hattachmentsattachment_id_response_200_data_type import PATCHattachmentsattachmentIdResponse200DataType
from .patc_hauthorizationsauthorization_id_response_200 import PATCHauthorizationsauthorizationIdResponse200
from .patc_hauthorizationsauthorization_id_response_200_data import PATCHauthorizationsauthorizationIdResponse200Data
from .patc_hauthorizationsauthorization_id_response_200_data_attributes import (
    PATCHauthorizationsauthorizationIdResponse200DataAttributes,
)
from .patc_hauthorizationsauthorization_id_response_200_data_attributes_metadata import (
    PATCHauthorizationsauthorizationIdResponse200DataAttributesMetadata,
)
from .patc_hauthorizationsauthorization_id_response_200_data_links import (
    PATCHauthorizationsauthorizationIdResponse200DataLinks,
)
from .patc_hauthorizationsauthorization_id_response_200_data_relationships import (
    PATCHauthorizationsauthorizationIdResponse200DataRelationships,
)
from .patc_hauthorizationsauthorization_id_response_200_data_relationships_captures import (
    PATCHauthorizationsauthorizationIdResponse200DataRelationshipsCaptures,
)
from .patc_hauthorizationsauthorization_id_response_200_data_relationships_captures_data import (
    PATCHauthorizationsauthorizationIdResponse200DataRelationshipsCapturesData,
)
from .patc_hauthorizationsauthorization_id_response_200_data_relationships_captures_data_type import (
    PATCHauthorizationsauthorizationIdResponse200DataRelationshipsCapturesDataType,
)
from .patc_hauthorizationsauthorization_id_response_200_data_relationships_captures_links import (
    PATCHauthorizationsauthorizationIdResponse200DataRelationshipsCapturesLinks,
)
from .patc_hauthorizationsauthorization_id_response_200_data_relationships_order import (
    PATCHauthorizationsauthorizationIdResponse200DataRelationshipsOrder,
)
from .patc_hauthorizationsauthorization_id_response_200_data_relationships_order_data import (
    PATCHauthorizationsauthorizationIdResponse200DataRelationshipsOrderData,
)
from .patc_hauthorizationsauthorization_id_response_200_data_relationships_order_data_type import (
    PATCHauthorizationsauthorizationIdResponse200DataRelationshipsOrderDataType,
)
from .patc_hauthorizationsauthorization_id_response_200_data_relationships_order_links import (
    PATCHauthorizationsauthorizationIdResponse200DataRelationshipsOrderLinks,
)
from .patc_hauthorizationsauthorization_id_response_200_data_relationships_voids import (
    PATCHauthorizationsauthorizationIdResponse200DataRelationshipsVoids,
)
from .patc_hauthorizationsauthorization_id_response_200_data_relationships_voids_data import (
    PATCHauthorizationsauthorizationIdResponse200DataRelationshipsVoidsData,
)
from .patc_hauthorizationsauthorization_id_response_200_data_relationships_voids_data_type import (
    PATCHauthorizationsauthorizationIdResponse200DataRelationshipsVoidsDataType,
)
from .patc_hauthorizationsauthorization_id_response_200_data_relationships_voids_links import (
    PATCHauthorizationsauthorizationIdResponse200DataRelationshipsVoidsLinks,
)
from .patc_hauthorizationsauthorization_id_response_200_data_type import (
    PATCHauthorizationsauthorizationIdResponse200DataType,
)
from .patc_havalara_accountsavalara_account_id_response_200 import PATCHavalaraAccountsavalaraAccountIdResponse200
from .patc_havalara_accountsavalara_account_id_response_200_data import (
    PATCHavalaraAccountsavalaraAccountIdResponse200Data,
)
from .patc_havalara_accountsavalara_account_id_response_200_data_attributes import (
    PATCHavalaraAccountsavalaraAccountIdResponse200DataAttributes,
)
from .patc_havalara_accountsavalara_account_id_response_200_data_attributes_metadata import (
    PATCHavalaraAccountsavalaraAccountIdResponse200DataAttributesMetadata,
)
from .patc_havalara_accountsavalara_account_id_response_200_data_links import (
    PATCHavalaraAccountsavalaraAccountIdResponse200DataLinks,
)
from .patc_havalara_accountsavalara_account_id_response_200_data_relationships import (
    PATCHavalaraAccountsavalaraAccountIdResponse200DataRelationships,
)
from .patc_havalara_accountsavalara_account_id_response_200_data_relationships_attachments import (
    PATCHavalaraAccountsavalaraAccountIdResponse200DataRelationshipsAttachments,
)
from .patc_havalara_accountsavalara_account_id_response_200_data_relationships_attachments_data import (
    PATCHavalaraAccountsavalaraAccountIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_havalara_accountsavalara_account_id_response_200_data_relationships_attachments_data_type import (
    PATCHavalaraAccountsavalaraAccountIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_havalara_accountsavalara_account_id_response_200_data_relationships_attachments_links import (
    PATCHavalaraAccountsavalaraAccountIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_havalara_accountsavalara_account_id_response_200_data_relationships_markets import (
    PATCHavalaraAccountsavalaraAccountIdResponse200DataRelationshipsMarkets,
)
from .patc_havalara_accountsavalara_account_id_response_200_data_relationships_markets_data import (
    PATCHavalaraAccountsavalaraAccountIdResponse200DataRelationshipsMarketsData,
)
from .patc_havalara_accountsavalara_account_id_response_200_data_relationships_markets_data_type import (
    PATCHavalaraAccountsavalaraAccountIdResponse200DataRelationshipsMarketsDataType,
)
from .patc_havalara_accountsavalara_account_id_response_200_data_relationships_markets_links import (
    PATCHavalaraAccountsavalaraAccountIdResponse200DataRelationshipsMarketsLinks,
)
from .patc_havalara_accountsavalara_account_id_response_200_data_relationships_tax_categories import (
    PATCHavalaraAccountsavalaraAccountIdResponse200DataRelationshipsTaxCategories,
)
from .patc_havalara_accountsavalara_account_id_response_200_data_relationships_tax_categories_data import (
    PATCHavalaraAccountsavalaraAccountIdResponse200DataRelationshipsTaxCategoriesData,
)
from .patc_havalara_accountsavalara_account_id_response_200_data_relationships_tax_categories_data_type import (
    PATCHavalaraAccountsavalaraAccountIdResponse200DataRelationshipsTaxCategoriesDataType,
)
from .patc_havalara_accountsavalara_account_id_response_200_data_relationships_tax_categories_links import (
    PATCHavalaraAccountsavalaraAccountIdResponse200DataRelationshipsTaxCategoriesLinks,
)
from .patc_havalara_accountsavalara_account_id_response_200_data_type import (
    PATCHavalaraAccountsavalaraAccountIdResponse200DataType,
)
from .patc_hbilling_info_validation_rulesbilling_info_validation_rule_id_response_200 import (
    PATCHbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200,
)
from .patc_hbilling_info_validation_rulesbilling_info_validation_rule_id_response_200_data import (
    PATCHbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200Data,
)
from .patc_hbilling_info_validation_rulesbilling_info_validation_rule_id_response_200_data_attributes import (
    PATCHbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataAttributes,
)
from .patc_hbilling_info_validation_rulesbilling_info_validation_rule_id_response_200_data_attributes_metadata import (
    PATCHbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataAttributesMetadata,
)
from .patc_hbilling_info_validation_rulesbilling_info_validation_rule_id_response_200_data_links import (
    PATCHbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataLinks,
)
from .patc_hbilling_info_validation_rulesbilling_info_validation_rule_id_response_200_data_relationships import (
    PATCHbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataRelationships,
)
from .patc_hbilling_info_validation_rulesbilling_info_validation_rule_id_response_200_data_relationships_market import (
    PATCHbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataRelationshipsMarket,
)
from .patc_hbilling_info_validation_rulesbilling_info_validation_rule_id_response_200_data_relationships_market_data import (
    PATCHbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataRelationshipsMarketData,
)
from .patc_hbilling_info_validation_rulesbilling_info_validation_rule_id_response_200_data_relationships_market_data_type import (
    PATCHbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataRelationshipsMarketDataType,
)
from .patc_hbilling_info_validation_rulesbilling_info_validation_rule_id_response_200_data_relationships_market_links import (
    PATCHbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataRelationshipsMarketLinks,
)
from .patc_hbilling_info_validation_rulesbilling_info_validation_rule_id_response_200_data_type import (
    PATCHbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataType,
)
from .patc_hbing_geocodersbing_geocoder_id_response_200 import PATCHbingGeocodersbingGeocoderIdResponse200
from .patc_hbing_geocodersbing_geocoder_id_response_200_data import PATCHbingGeocodersbingGeocoderIdResponse200Data
from .patc_hbing_geocodersbing_geocoder_id_response_200_data_attributes import (
    PATCHbingGeocodersbingGeocoderIdResponse200DataAttributes,
)
from .patc_hbing_geocodersbing_geocoder_id_response_200_data_attributes_metadata import (
    PATCHbingGeocodersbingGeocoderIdResponse200DataAttributesMetadata,
)
from .patc_hbing_geocodersbing_geocoder_id_response_200_data_links import (
    PATCHbingGeocodersbingGeocoderIdResponse200DataLinks,
)
from .patc_hbing_geocodersbing_geocoder_id_response_200_data_relationships import (
    PATCHbingGeocodersbingGeocoderIdResponse200DataRelationships,
)
from .patc_hbing_geocodersbing_geocoder_id_response_200_data_relationships_addresses import (
    PATCHbingGeocodersbingGeocoderIdResponse200DataRelationshipsAddresses,
)
from .patc_hbing_geocodersbing_geocoder_id_response_200_data_relationships_addresses_data import (
    PATCHbingGeocodersbingGeocoderIdResponse200DataRelationshipsAddressesData,
)
from .patc_hbing_geocodersbing_geocoder_id_response_200_data_relationships_addresses_data_type import (
    PATCHbingGeocodersbingGeocoderIdResponse200DataRelationshipsAddressesDataType,
)
from .patc_hbing_geocodersbing_geocoder_id_response_200_data_relationships_addresses_links import (
    PATCHbingGeocodersbingGeocoderIdResponse200DataRelationshipsAddressesLinks,
)
from .patc_hbing_geocodersbing_geocoder_id_response_200_data_relationships_attachments import (
    PATCHbingGeocodersbingGeocoderIdResponse200DataRelationshipsAttachments,
)
from .patc_hbing_geocodersbing_geocoder_id_response_200_data_relationships_attachments_data import (
    PATCHbingGeocodersbingGeocoderIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hbing_geocodersbing_geocoder_id_response_200_data_relationships_attachments_data_type import (
    PATCHbingGeocodersbingGeocoderIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hbing_geocodersbing_geocoder_id_response_200_data_relationships_attachments_links import (
    PATCHbingGeocodersbingGeocoderIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hbing_geocodersbing_geocoder_id_response_200_data_type import (
    PATCHbingGeocodersbingGeocoderIdResponse200DataType,
)
from .patc_hbraintree_gatewaysbraintree_gateway_id_response_200 import (
    PATCHbraintreeGatewaysbraintreeGatewayIdResponse200,
)
from .patc_hbraintree_gatewaysbraintree_gateway_id_response_200_data import (
    PATCHbraintreeGatewaysbraintreeGatewayIdResponse200Data,
)
from .patc_hbraintree_gatewaysbraintree_gateway_id_response_200_data_attributes import (
    PATCHbraintreeGatewaysbraintreeGatewayIdResponse200DataAttributes,
)
from .patc_hbraintree_gatewaysbraintree_gateway_id_response_200_data_attributes_metadata import (
    PATCHbraintreeGatewaysbraintreeGatewayIdResponse200DataAttributesMetadata,
)
from .patc_hbraintree_gatewaysbraintree_gateway_id_response_200_data_links import (
    PATCHbraintreeGatewaysbraintreeGatewayIdResponse200DataLinks,
)
from .patc_hbraintree_gatewaysbraintree_gateway_id_response_200_data_relationships import (
    PATCHbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationships,
)
from .patc_hbraintree_gatewaysbraintree_gateway_id_response_200_data_relationships_braintree_payments import (
    PATCHbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsBraintreePayments,
)
from .patc_hbraintree_gatewaysbraintree_gateway_id_response_200_data_relationships_braintree_payments_data import (
    PATCHbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsBraintreePaymentsData,
)
from .patc_hbraintree_gatewaysbraintree_gateway_id_response_200_data_relationships_braintree_payments_data_type import (
    PATCHbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsBraintreePaymentsDataType,
)
from .patc_hbraintree_gatewaysbraintree_gateway_id_response_200_data_relationships_braintree_payments_links import (
    PATCHbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsBraintreePaymentsLinks,
)
from .patc_hbraintree_gatewaysbraintree_gateway_id_response_200_data_relationships_payment_methods import (
    PATCHbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsPaymentMethods,
)
from .patc_hbraintree_gatewaysbraintree_gateway_id_response_200_data_relationships_payment_methods_data import (
    PATCHbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsPaymentMethodsData,
)
from .patc_hbraintree_gatewaysbraintree_gateway_id_response_200_data_relationships_payment_methods_data_type import (
    PATCHbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsPaymentMethodsDataType,
)
from .patc_hbraintree_gatewaysbraintree_gateway_id_response_200_data_relationships_payment_methods_links import (
    PATCHbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsPaymentMethodsLinks,
)
from .patc_hbraintree_gatewaysbraintree_gateway_id_response_200_data_type import (
    PATCHbraintreeGatewaysbraintreeGatewayIdResponse200DataType,
)
from .patc_hbraintree_paymentsbraintree_payment_id_response_200 import (
    PATCHbraintreePaymentsbraintreePaymentIdResponse200,
)
from .patc_hbraintree_paymentsbraintree_payment_id_response_200_data import (
    PATCHbraintreePaymentsbraintreePaymentIdResponse200Data,
)
from .patc_hbraintree_paymentsbraintree_payment_id_response_200_data_attributes import (
    PATCHbraintreePaymentsbraintreePaymentIdResponse200DataAttributes,
)
from .patc_hbraintree_paymentsbraintree_payment_id_response_200_data_attributes_metadata import (
    PATCHbraintreePaymentsbraintreePaymentIdResponse200DataAttributesMetadata,
)
from .patc_hbraintree_paymentsbraintree_payment_id_response_200_data_attributes_options import (
    PATCHbraintreePaymentsbraintreePaymentIdResponse200DataAttributesOptions,
)
from .patc_hbraintree_paymentsbraintree_payment_id_response_200_data_links import (
    PATCHbraintreePaymentsbraintreePaymentIdResponse200DataLinks,
)
from .patc_hbraintree_paymentsbraintree_payment_id_response_200_data_relationships import (
    PATCHbraintreePaymentsbraintreePaymentIdResponse200DataRelationships,
)
from .patc_hbraintree_paymentsbraintree_payment_id_response_200_data_relationships_order import (
    PATCHbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsOrder,
)
from .patc_hbraintree_paymentsbraintree_payment_id_response_200_data_relationships_order_data import (
    PATCHbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsOrderData,
)
from .patc_hbraintree_paymentsbraintree_payment_id_response_200_data_relationships_order_data_type import (
    PATCHbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsOrderDataType,
)
from .patc_hbraintree_paymentsbraintree_payment_id_response_200_data_relationships_order_links import (
    PATCHbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsOrderLinks,
)
from .patc_hbraintree_paymentsbraintree_payment_id_response_200_data_relationships_payment_gateway import (
    PATCHbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsPaymentGateway,
)
from .patc_hbraintree_paymentsbraintree_payment_id_response_200_data_relationships_payment_gateway_data import (
    PATCHbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsPaymentGatewayData,
)
from .patc_hbraintree_paymentsbraintree_payment_id_response_200_data_relationships_payment_gateway_data_type import (
    PATCHbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsPaymentGatewayDataType,
)
from .patc_hbraintree_paymentsbraintree_payment_id_response_200_data_relationships_payment_gateway_links import (
    PATCHbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsPaymentGatewayLinks,
)
from .patc_hbraintree_paymentsbraintree_payment_id_response_200_data_type import (
    PATCHbraintreePaymentsbraintreePaymentIdResponse200DataType,
)
from .patc_hbundlesbundle_id_response_200 import PATCHbundlesbundleIdResponse200
from .patc_hbundlesbundle_id_response_200_data import PATCHbundlesbundleIdResponse200Data
from .patc_hbundlesbundle_id_response_200_data_attributes import PATCHbundlesbundleIdResponse200DataAttributes
from .patc_hbundlesbundle_id_response_200_data_attributes_metadata import (
    PATCHbundlesbundleIdResponse200DataAttributesMetadata,
)
from .patc_hbundlesbundle_id_response_200_data_links import PATCHbundlesbundleIdResponse200DataLinks
from .patc_hbundlesbundle_id_response_200_data_relationships import PATCHbundlesbundleIdResponse200DataRelationships
from .patc_hbundlesbundle_id_response_200_data_relationships_attachments import (
    PATCHbundlesbundleIdResponse200DataRelationshipsAttachments,
)
from .patc_hbundlesbundle_id_response_200_data_relationships_attachments_data import (
    PATCHbundlesbundleIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hbundlesbundle_id_response_200_data_relationships_attachments_data_type import (
    PATCHbundlesbundleIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hbundlesbundle_id_response_200_data_relationships_attachments_links import (
    PATCHbundlesbundleIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hbundlesbundle_id_response_200_data_relationships_market import (
    PATCHbundlesbundleIdResponse200DataRelationshipsMarket,
)
from .patc_hbundlesbundle_id_response_200_data_relationships_market_data import (
    PATCHbundlesbundleIdResponse200DataRelationshipsMarketData,
)
from .patc_hbundlesbundle_id_response_200_data_relationships_market_data_type import (
    PATCHbundlesbundleIdResponse200DataRelationshipsMarketDataType,
)
from .patc_hbundlesbundle_id_response_200_data_relationships_market_links import (
    PATCHbundlesbundleIdResponse200DataRelationshipsMarketLinks,
)
from .patc_hbundlesbundle_id_response_200_data_relationships_sku_list import (
    PATCHbundlesbundleIdResponse200DataRelationshipsSkuList,
)
from .patc_hbundlesbundle_id_response_200_data_relationships_sku_list_data import (
    PATCHbundlesbundleIdResponse200DataRelationshipsSkuListData,
)
from .patc_hbundlesbundle_id_response_200_data_relationships_sku_list_data_type import (
    PATCHbundlesbundleIdResponse200DataRelationshipsSkuListDataType,
)
from .patc_hbundlesbundle_id_response_200_data_relationships_sku_list_links import (
    PATCHbundlesbundleIdResponse200DataRelationshipsSkuListLinks,
)
from .patc_hbundlesbundle_id_response_200_data_relationships_skus import (
    PATCHbundlesbundleIdResponse200DataRelationshipsSkus,
)
from .patc_hbundlesbundle_id_response_200_data_relationships_skus_data import (
    PATCHbundlesbundleIdResponse200DataRelationshipsSkusData,
)
from .patc_hbundlesbundle_id_response_200_data_relationships_skus_data_type import (
    PATCHbundlesbundleIdResponse200DataRelationshipsSkusDataType,
)
from .patc_hbundlesbundle_id_response_200_data_relationships_skus_links import (
    PATCHbundlesbundleIdResponse200DataRelationshipsSkusLinks,
)
from .patc_hbundlesbundle_id_response_200_data_type import PATCHbundlesbundleIdResponse200DataType
from .patc_hcapturescapture_id_response_200 import PATCHcapturescaptureIdResponse200
from .patc_hcapturescapture_id_response_200_data import PATCHcapturescaptureIdResponse200Data
from .patc_hcapturescapture_id_response_200_data_attributes import PATCHcapturescaptureIdResponse200DataAttributes
from .patc_hcapturescapture_id_response_200_data_attributes_metadata import (
    PATCHcapturescaptureIdResponse200DataAttributesMetadata,
)
from .patc_hcapturescapture_id_response_200_data_links import PATCHcapturescaptureIdResponse200DataLinks
from .patc_hcapturescapture_id_response_200_data_relationships import PATCHcapturescaptureIdResponse200DataRelationships
from .patc_hcapturescapture_id_response_200_data_relationships_order import (
    PATCHcapturescaptureIdResponse200DataRelationshipsOrder,
)
from .patc_hcapturescapture_id_response_200_data_relationships_order_data import (
    PATCHcapturescaptureIdResponse200DataRelationshipsOrderData,
)
from .patc_hcapturescapture_id_response_200_data_relationships_order_data_type import (
    PATCHcapturescaptureIdResponse200DataRelationshipsOrderDataType,
)
from .patc_hcapturescapture_id_response_200_data_relationships_order_links import (
    PATCHcapturescaptureIdResponse200DataRelationshipsOrderLinks,
)
from .patc_hcapturescapture_id_response_200_data_relationships_reference_authorization import (
    PATCHcapturescaptureIdResponse200DataRelationshipsReferenceAuthorization,
)
from .patc_hcapturescapture_id_response_200_data_relationships_reference_authorization_data import (
    PATCHcapturescaptureIdResponse200DataRelationshipsReferenceAuthorizationData,
)
from .patc_hcapturescapture_id_response_200_data_relationships_reference_authorization_data_type import (
    PATCHcapturescaptureIdResponse200DataRelationshipsReferenceAuthorizationDataType,
)
from .patc_hcapturescapture_id_response_200_data_relationships_reference_authorization_links import (
    PATCHcapturescaptureIdResponse200DataRelationshipsReferenceAuthorizationLinks,
)
from .patc_hcapturescapture_id_response_200_data_relationships_refunds import (
    PATCHcapturescaptureIdResponse200DataRelationshipsRefunds,
)
from .patc_hcapturescapture_id_response_200_data_relationships_refunds_data import (
    PATCHcapturescaptureIdResponse200DataRelationshipsRefundsData,
)
from .patc_hcapturescapture_id_response_200_data_relationships_refunds_data_type import (
    PATCHcapturescaptureIdResponse200DataRelationshipsRefundsDataType,
)
from .patc_hcapturescapture_id_response_200_data_relationships_refunds_links import (
    PATCHcapturescaptureIdResponse200DataRelationshipsRefundsLinks,
)
from .patc_hcapturescapture_id_response_200_data_type import PATCHcapturescaptureIdResponse200DataType
from .patc_hcheckout_com_gatewayscheckout_com_gateway_id_response_200 import (
    PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200,
)
from .patc_hcheckout_com_gatewayscheckout_com_gateway_id_response_200_data import (
    PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200Data,
)
from .patc_hcheckout_com_gatewayscheckout_com_gateway_id_response_200_data_attributes import (
    PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200DataAttributes,
)
from .patc_hcheckout_com_gatewayscheckout_com_gateway_id_response_200_data_attributes_metadata import (
    PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200DataAttributesMetadata,
)
from .patc_hcheckout_com_gatewayscheckout_com_gateway_id_response_200_data_links import (
    PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200DataLinks,
)
from .patc_hcheckout_com_gatewayscheckout_com_gateway_id_response_200_data_relationships import (
    PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationships,
)
from .patc_hcheckout_com_gatewayscheckout_com_gateway_id_response_200_data_relationships_checkout_com_payments import (
    PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsCheckoutComPayments,
)
from .patc_hcheckout_com_gatewayscheckout_com_gateway_id_response_200_data_relationships_checkout_com_payments_data import (
    PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsCheckoutComPaymentsData,
)
from .patc_hcheckout_com_gatewayscheckout_com_gateway_id_response_200_data_relationships_checkout_com_payments_data_type import (
    PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsCheckoutComPaymentsDataType,
)
from .patc_hcheckout_com_gatewayscheckout_com_gateway_id_response_200_data_relationships_checkout_com_payments_links import (
    PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsCheckoutComPaymentsLinks,
)
from .patc_hcheckout_com_gatewayscheckout_com_gateway_id_response_200_data_relationships_payment_methods import (
    PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsPaymentMethods,
)
from .patc_hcheckout_com_gatewayscheckout_com_gateway_id_response_200_data_relationships_payment_methods_data import (
    PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsPaymentMethodsData,
)
from .patc_hcheckout_com_gatewayscheckout_com_gateway_id_response_200_data_relationships_payment_methods_data_type import (
    PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsPaymentMethodsDataType,
)
from .patc_hcheckout_com_gatewayscheckout_com_gateway_id_response_200_data_relationships_payment_methods_links import (
    PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsPaymentMethodsLinks,
)
from .patc_hcheckout_com_gatewayscheckout_com_gateway_id_response_200_data_type import (
    PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200DataType,
)
from .patc_hcheckout_com_paymentscheckout_com_payment_id_response_200 import (
    PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200,
)
from .patc_hcheckout_com_paymentscheckout_com_payment_id_response_200_data import (
    PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200Data,
)
from .patc_hcheckout_com_paymentscheckout_com_payment_id_response_200_data_attributes import (
    PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200DataAttributes,
)
from .patc_hcheckout_com_paymentscheckout_com_payment_id_response_200_data_attributes_metadata import (
    PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200DataAttributesMetadata,
)
from .patc_hcheckout_com_paymentscheckout_com_payment_id_response_200_data_links import (
    PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200DataLinks,
)
from .patc_hcheckout_com_paymentscheckout_com_payment_id_response_200_data_relationships import (
    PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationships,
)
from .patc_hcheckout_com_paymentscheckout_com_payment_id_response_200_data_relationships_order import (
    PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsOrder,
)
from .patc_hcheckout_com_paymentscheckout_com_payment_id_response_200_data_relationships_order_data import (
    PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsOrderData,
)
from .patc_hcheckout_com_paymentscheckout_com_payment_id_response_200_data_relationships_order_data_type import (
    PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsOrderDataType,
)
from .patc_hcheckout_com_paymentscheckout_com_payment_id_response_200_data_relationships_order_links import (
    PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsOrderLinks,
)
from .patc_hcheckout_com_paymentscheckout_com_payment_id_response_200_data_relationships_payment_gateway import (
    PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsPaymentGateway,
)
from .patc_hcheckout_com_paymentscheckout_com_payment_id_response_200_data_relationships_payment_gateway_data import (
    PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsPaymentGatewayData,
)
from .patc_hcheckout_com_paymentscheckout_com_payment_id_response_200_data_relationships_payment_gateway_data_type import (
    PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsPaymentGatewayDataType,
)
from .patc_hcheckout_com_paymentscheckout_com_payment_id_response_200_data_relationships_payment_gateway_links import (
    PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsPaymentGatewayLinks,
)
from .patc_hcheckout_com_paymentscheckout_com_payment_id_response_200_data_type import (
    PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200DataType,
)
from .patc_hcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200 import (
    PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200,
)
from .patc_hcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200_data import (
    PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200Data,
)
from .patc_hcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200_data_attributes import (
    PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataAttributes,
)
from .patc_hcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200_data_attributes_metadata import (
    PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataAttributesMetadata,
)
from .patc_hcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200_data_links import (
    PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataLinks,
)
from .patc_hcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200_data_relationships import (
    PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationships,
)
from .patc_hcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200_data_relationships_coupons import (
    PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsCoupons,
)
from .patc_hcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200_data_relationships_coupons_data import (
    PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsCouponsData,
)
from .patc_hcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200_data_relationships_coupons_data_type import (
    PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsCouponsDataType,
)
from .patc_hcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200_data_relationships_coupons_links import (
    PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsCouponsLinks,
)
from .patc_hcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200_data_relationships_promotion import (
    PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsPromotion,
)
from .patc_hcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200_data_relationships_promotion_data import (
    PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsPromotionData,
)
from .patc_hcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200_data_relationships_promotion_data_type import (
    PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsPromotionDataType,
)
from .patc_hcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200_data_relationships_promotion_links import (
    PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsPromotionLinks,
)
from .patc_hcoupon_codes_promotion_rulescoupon_codes_promotion_rule_id_response_200_data_type import (
    PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataType,
)
from .patc_hcoupon_recipientscoupon_recipient_id_response_200 import PATCHcouponRecipientscouponRecipientIdResponse200
from .patc_hcoupon_recipientscoupon_recipient_id_response_200_data import (
    PATCHcouponRecipientscouponRecipientIdResponse200Data,
)
from .patc_hcoupon_recipientscoupon_recipient_id_response_200_data_attributes import (
    PATCHcouponRecipientscouponRecipientIdResponse200DataAttributes,
)
from .patc_hcoupon_recipientscoupon_recipient_id_response_200_data_attributes_metadata import (
    PATCHcouponRecipientscouponRecipientIdResponse200DataAttributesMetadata,
)
from .patc_hcoupon_recipientscoupon_recipient_id_response_200_data_links import (
    PATCHcouponRecipientscouponRecipientIdResponse200DataLinks,
)
from .patc_hcoupon_recipientscoupon_recipient_id_response_200_data_relationships import (
    PATCHcouponRecipientscouponRecipientIdResponse200DataRelationships,
)
from .patc_hcoupon_recipientscoupon_recipient_id_response_200_data_relationships_attachments import (
    PATCHcouponRecipientscouponRecipientIdResponse200DataRelationshipsAttachments,
)
from .patc_hcoupon_recipientscoupon_recipient_id_response_200_data_relationships_attachments_data import (
    PATCHcouponRecipientscouponRecipientIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hcoupon_recipientscoupon_recipient_id_response_200_data_relationships_attachments_data_type import (
    PATCHcouponRecipientscouponRecipientIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hcoupon_recipientscoupon_recipient_id_response_200_data_relationships_attachments_links import (
    PATCHcouponRecipientscouponRecipientIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hcoupon_recipientscoupon_recipient_id_response_200_data_relationships_customer import (
    PATCHcouponRecipientscouponRecipientIdResponse200DataRelationshipsCustomer,
)
from .patc_hcoupon_recipientscoupon_recipient_id_response_200_data_relationships_customer_data import (
    PATCHcouponRecipientscouponRecipientIdResponse200DataRelationshipsCustomerData,
)
from .patc_hcoupon_recipientscoupon_recipient_id_response_200_data_relationships_customer_data_type import (
    PATCHcouponRecipientscouponRecipientIdResponse200DataRelationshipsCustomerDataType,
)
from .patc_hcoupon_recipientscoupon_recipient_id_response_200_data_relationships_customer_links import (
    PATCHcouponRecipientscouponRecipientIdResponse200DataRelationshipsCustomerLinks,
)
from .patc_hcoupon_recipientscoupon_recipient_id_response_200_data_type import (
    PATCHcouponRecipientscouponRecipientIdResponse200DataType,
)
from .patc_hcouponscoupon_id_response_200 import PATCHcouponscouponIdResponse200
from .patc_hcouponscoupon_id_response_200_data import PATCHcouponscouponIdResponse200Data
from .patc_hcouponscoupon_id_response_200_data_attributes import PATCHcouponscouponIdResponse200DataAttributes
from .patc_hcouponscoupon_id_response_200_data_attributes_metadata import (
    PATCHcouponscouponIdResponse200DataAttributesMetadata,
)
from .patc_hcouponscoupon_id_response_200_data_links import PATCHcouponscouponIdResponse200DataLinks
from .patc_hcouponscoupon_id_response_200_data_relationships import PATCHcouponscouponIdResponse200DataRelationships
from .patc_hcouponscoupon_id_response_200_data_relationships_promotion_rule import (
    PATCHcouponscouponIdResponse200DataRelationshipsPromotionRule,
)
from .patc_hcouponscoupon_id_response_200_data_relationships_promotion_rule_data import (
    PATCHcouponscouponIdResponse200DataRelationshipsPromotionRuleData,
)
from .patc_hcouponscoupon_id_response_200_data_relationships_promotion_rule_data_type import (
    PATCHcouponscouponIdResponse200DataRelationshipsPromotionRuleDataType,
)
from .patc_hcouponscoupon_id_response_200_data_relationships_promotion_rule_links import (
    PATCHcouponscouponIdResponse200DataRelationshipsPromotionRuleLinks,
)
from .patc_hcouponscoupon_id_response_200_data_type import PATCHcouponscouponIdResponse200DataType
from .patc_hcustomer_addressescustomer_address_id_response_200 import PATCHcustomerAddressescustomerAddressIdResponse200
from .patc_hcustomer_addressescustomer_address_id_response_200_data import (
    PATCHcustomerAddressescustomerAddressIdResponse200Data,
)
from .patc_hcustomer_addressescustomer_address_id_response_200_data_attributes import (
    PATCHcustomerAddressescustomerAddressIdResponse200DataAttributes,
)
from .patc_hcustomer_addressescustomer_address_id_response_200_data_attributes_metadata import (
    PATCHcustomerAddressescustomerAddressIdResponse200DataAttributesMetadata,
)
from .patc_hcustomer_addressescustomer_address_id_response_200_data_links import (
    PATCHcustomerAddressescustomerAddressIdResponse200DataLinks,
)
from .patc_hcustomer_addressescustomer_address_id_response_200_data_relationships import (
    PATCHcustomerAddressescustomerAddressIdResponse200DataRelationships,
)
from .patc_hcustomer_addressescustomer_address_id_response_200_data_relationships_address import (
    PATCHcustomerAddressescustomerAddressIdResponse200DataRelationshipsAddress,
)
from .patc_hcustomer_addressescustomer_address_id_response_200_data_relationships_address_data import (
    PATCHcustomerAddressescustomerAddressIdResponse200DataRelationshipsAddressData,
)
from .patc_hcustomer_addressescustomer_address_id_response_200_data_relationships_address_data_type import (
    PATCHcustomerAddressescustomerAddressIdResponse200DataRelationshipsAddressDataType,
)
from .patc_hcustomer_addressescustomer_address_id_response_200_data_relationships_address_links import (
    PATCHcustomerAddressescustomerAddressIdResponse200DataRelationshipsAddressLinks,
)
from .patc_hcustomer_addressescustomer_address_id_response_200_data_relationships_customer import (
    PATCHcustomerAddressescustomerAddressIdResponse200DataRelationshipsCustomer,
)
from .patc_hcustomer_addressescustomer_address_id_response_200_data_relationships_customer_data import (
    PATCHcustomerAddressescustomerAddressIdResponse200DataRelationshipsCustomerData,
)
from .patc_hcustomer_addressescustomer_address_id_response_200_data_relationships_customer_data_type import (
    PATCHcustomerAddressescustomerAddressIdResponse200DataRelationshipsCustomerDataType,
)
from .patc_hcustomer_addressescustomer_address_id_response_200_data_relationships_customer_links import (
    PATCHcustomerAddressescustomerAddressIdResponse200DataRelationshipsCustomerLinks,
)
from .patc_hcustomer_addressescustomer_address_id_response_200_data_relationships_events import (
    PATCHcustomerAddressescustomerAddressIdResponse200DataRelationshipsEvents,
)
from .patc_hcustomer_addressescustomer_address_id_response_200_data_relationships_events_data import (
    PATCHcustomerAddressescustomerAddressIdResponse200DataRelationshipsEventsData,
)
from .patc_hcustomer_addressescustomer_address_id_response_200_data_relationships_events_data_type import (
    PATCHcustomerAddressescustomerAddressIdResponse200DataRelationshipsEventsDataType,
)
from .patc_hcustomer_addressescustomer_address_id_response_200_data_relationships_events_links import (
    PATCHcustomerAddressescustomerAddressIdResponse200DataRelationshipsEventsLinks,
)
from .patc_hcustomer_addressescustomer_address_id_response_200_data_type import (
    PATCHcustomerAddressescustomerAddressIdResponse200DataType,
)
from .patc_hcustomer_groupscustomer_group_id_response_200 import PATCHcustomerGroupscustomerGroupIdResponse200
from .patc_hcustomer_groupscustomer_group_id_response_200_data import PATCHcustomerGroupscustomerGroupIdResponse200Data
from .patc_hcustomer_groupscustomer_group_id_response_200_data_attributes import (
    PATCHcustomerGroupscustomerGroupIdResponse200DataAttributes,
)
from .patc_hcustomer_groupscustomer_group_id_response_200_data_attributes_metadata import (
    PATCHcustomerGroupscustomerGroupIdResponse200DataAttributesMetadata,
)
from .patc_hcustomer_groupscustomer_group_id_response_200_data_links import (
    PATCHcustomerGroupscustomerGroupIdResponse200DataLinks,
)
from .patc_hcustomer_groupscustomer_group_id_response_200_data_relationships import (
    PATCHcustomerGroupscustomerGroupIdResponse200DataRelationships,
)
from .patc_hcustomer_groupscustomer_group_id_response_200_data_relationships_attachments import (
    PATCHcustomerGroupscustomerGroupIdResponse200DataRelationshipsAttachments,
)
from .patc_hcustomer_groupscustomer_group_id_response_200_data_relationships_attachments_data import (
    PATCHcustomerGroupscustomerGroupIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hcustomer_groupscustomer_group_id_response_200_data_relationships_attachments_data_type import (
    PATCHcustomerGroupscustomerGroupIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hcustomer_groupscustomer_group_id_response_200_data_relationships_attachments_links import (
    PATCHcustomerGroupscustomerGroupIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hcustomer_groupscustomer_group_id_response_200_data_relationships_customers import (
    PATCHcustomerGroupscustomerGroupIdResponse200DataRelationshipsCustomers,
)
from .patc_hcustomer_groupscustomer_group_id_response_200_data_relationships_customers_data import (
    PATCHcustomerGroupscustomerGroupIdResponse200DataRelationshipsCustomersData,
)
from .patc_hcustomer_groupscustomer_group_id_response_200_data_relationships_customers_data_type import (
    PATCHcustomerGroupscustomerGroupIdResponse200DataRelationshipsCustomersDataType,
)
from .patc_hcustomer_groupscustomer_group_id_response_200_data_relationships_customers_links import (
    PATCHcustomerGroupscustomerGroupIdResponse200DataRelationshipsCustomersLinks,
)
from .patc_hcustomer_groupscustomer_group_id_response_200_data_relationships_markets import (
    PATCHcustomerGroupscustomerGroupIdResponse200DataRelationshipsMarkets,
)
from .patc_hcustomer_groupscustomer_group_id_response_200_data_relationships_markets_data import (
    PATCHcustomerGroupscustomerGroupIdResponse200DataRelationshipsMarketsData,
)
from .patc_hcustomer_groupscustomer_group_id_response_200_data_relationships_markets_data_type import (
    PATCHcustomerGroupscustomerGroupIdResponse200DataRelationshipsMarketsDataType,
)
from .patc_hcustomer_groupscustomer_group_id_response_200_data_relationships_markets_links import (
    PATCHcustomerGroupscustomerGroupIdResponse200DataRelationshipsMarketsLinks,
)
from .patc_hcustomer_groupscustomer_group_id_response_200_data_type import (
    PATCHcustomerGroupscustomerGroupIdResponse200DataType,
)
from .patc_hcustomer_password_resetscustomer_password_reset_id_response_200 import (
    PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200,
)
from .patc_hcustomer_password_resetscustomer_password_reset_id_response_200_data import (
    PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200Data,
)
from .patc_hcustomer_password_resetscustomer_password_reset_id_response_200_data_attributes import (
    PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200DataAttributes,
)
from .patc_hcustomer_password_resetscustomer_password_reset_id_response_200_data_attributes_metadata import (
    PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200DataAttributesMetadata,
)
from .patc_hcustomer_password_resetscustomer_password_reset_id_response_200_data_links import (
    PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200DataLinks,
)
from .patc_hcustomer_password_resetscustomer_password_reset_id_response_200_data_relationships import (
    PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationships,
)
from .patc_hcustomer_password_resetscustomer_password_reset_id_response_200_data_relationships_customer import (
    PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsCustomer,
)
from .patc_hcustomer_password_resetscustomer_password_reset_id_response_200_data_relationships_customer_data import (
    PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsCustomerData,
)
from .patc_hcustomer_password_resetscustomer_password_reset_id_response_200_data_relationships_customer_data_type import (
    PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsCustomerDataType,
)
from .patc_hcustomer_password_resetscustomer_password_reset_id_response_200_data_relationships_customer_links import (
    PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsCustomerLinks,
)
from .patc_hcustomer_password_resetscustomer_password_reset_id_response_200_data_relationships_events import (
    PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsEvents,
)
from .patc_hcustomer_password_resetscustomer_password_reset_id_response_200_data_relationships_events_data import (
    PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsEventsData,
)
from .patc_hcustomer_password_resetscustomer_password_reset_id_response_200_data_relationships_events_data_type import (
    PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsEventsDataType,
)
from .patc_hcustomer_password_resetscustomer_password_reset_id_response_200_data_relationships_events_links import (
    PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsEventsLinks,
)
from .patc_hcustomer_password_resetscustomer_password_reset_id_response_200_data_type import (
    PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200DataType,
)
from .patc_hcustomer_payment_sourcescustomer_payment_source_id_response_200 import (
    PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200,
)
from .patc_hcustomer_payment_sourcescustomer_payment_source_id_response_200_data import (
    PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200Data,
)
from .patc_hcustomer_payment_sourcescustomer_payment_source_id_response_200_data_attributes import (
    PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataAttributes,
)
from .patc_hcustomer_payment_sourcescustomer_payment_source_id_response_200_data_attributes_metadata import (
    PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataAttributesMetadata,
)
from .patc_hcustomer_payment_sourcescustomer_payment_source_id_response_200_data_links import (
    PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataLinks,
)
from .patc_hcustomer_payment_sourcescustomer_payment_source_id_response_200_data_relationships import (
    PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationships,
)
from .patc_hcustomer_payment_sourcescustomer_payment_source_id_response_200_data_relationships_customer import (
    PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsCustomer,
)
from .patc_hcustomer_payment_sourcescustomer_payment_source_id_response_200_data_relationships_customer_data import (
    PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsCustomerData,
)
from .patc_hcustomer_payment_sourcescustomer_payment_source_id_response_200_data_relationships_customer_data_type import (
    PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsCustomerDataType,
)
from .patc_hcustomer_payment_sourcescustomer_payment_source_id_response_200_data_relationships_customer_links import (
    PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsCustomerLinks,
)
from .patc_hcustomer_payment_sourcescustomer_payment_source_id_response_200_data_relationships_payment_source import (
    PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsPaymentSource,
)
from .patc_hcustomer_payment_sourcescustomer_payment_source_id_response_200_data_relationships_payment_source_data import (
    PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsPaymentSourceData,
)
from .patc_hcustomer_payment_sourcescustomer_payment_source_id_response_200_data_relationships_payment_source_data_type import (
    PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsPaymentSourceDataType,
)
from .patc_hcustomer_payment_sourcescustomer_payment_source_id_response_200_data_relationships_payment_source_links import (
    PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsPaymentSourceLinks,
)
from .patc_hcustomer_payment_sourcescustomer_payment_source_id_response_200_data_type import (
    PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataType,
)
from .patc_hcustomer_subscriptionscustomer_subscription_id_response_200 import (
    PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200,
)
from .patc_hcustomer_subscriptionscustomer_subscription_id_response_200_data import (
    PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200Data,
)
from .patc_hcustomer_subscriptionscustomer_subscription_id_response_200_data_attributes import (
    PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200DataAttributes,
)
from .patc_hcustomer_subscriptionscustomer_subscription_id_response_200_data_attributes_metadata import (
    PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200DataAttributesMetadata,
)
from .patc_hcustomer_subscriptionscustomer_subscription_id_response_200_data_links import (
    PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200DataLinks,
)
from .patc_hcustomer_subscriptionscustomer_subscription_id_response_200_data_relationships import (
    PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationships,
)
from .patc_hcustomer_subscriptionscustomer_subscription_id_response_200_data_relationships_customer import (
    PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsCustomer,
)
from .patc_hcustomer_subscriptionscustomer_subscription_id_response_200_data_relationships_customer_data import (
    PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsCustomerData,
)
from .patc_hcustomer_subscriptionscustomer_subscription_id_response_200_data_relationships_customer_data_type import (
    PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsCustomerDataType,
)
from .patc_hcustomer_subscriptionscustomer_subscription_id_response_200_data_relationships_customer_links import (
    PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsCustomerLinks,
)
from .patc_hcustomer_subscriptionscustomer_subscription_id_response_200_data_relationships_events import (
    PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsEvents,
)
from .patc_hcustomer_subscriptionscustomer_subscription_id_response_200_data_relationships_events_data import (
    PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsEventsData,
)
from .patc_hcustomer_subscriptionscustomer_subscription_id_response_200_data_relationships_events_data_type import (
    PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsEventsDataType,
)
from .patc_hcustomer_subscriptionscustomer_subscription_id_response_200_data_relationships_events_links import (
    PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsEventsLinks,
)
from .patc_hcustomer_subscriptionscustomer_subscription_id_response_200_data_type import (
    PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200DataType,
)
from .patc_hcustomerscustomer_id_response_200 import PATCHcustomerscustomerIdResponse200
from .patc_hcustomerscustomer_id_response_200_data import PATCHcustomerscustomerIdResponse200Data
from .patc_hcustomerscustomer_id_response_200_data_attributes import PATCHcustomerscustomerIdResponse200DataAttributes
from .patc_hcustomerscustomer_id_response_200_data_attributes_metadata import (
    PATCHcustomerscustomerIdResponse200DataAttributesMetadata,
)
from .patc_hcustomerscustomer_id_response_200_data_links import PATCHcustomerscustomerIdResponse200DataLinks
from .patc_hcustomerscustomer_id_response_200_data_relationships import (
    PATCHcustomerscustomerIdResponse200DataRelationships,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_attachments import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsAttachments,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_attachments_data import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_attachments_data_type import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_attachments_links import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_customer_addresses import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerAddresses,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_customer_addresses_data import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerAddressesData,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_customer_addresses_data_type import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerAddressesDataType,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_customer_addresses_links import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerAddressesLinks,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_customer_group import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerGroup,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_customer_group_data import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerGroupData,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_customer_group_data_type import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerGroupDataType,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_customer_group_links import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerGroupLinks,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_customer_payment_sources import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerPaymentSources,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_customer_payment_sources_data import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerPaymentSourcesData,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_customer_payment_sources_data_type import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerPaymentSourcesDataType,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_customer_payment_sources_links import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerPaymentSourcesLinks,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_customer_subscriptions import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerSubscriptions,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_customer_subscriptions_data import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerSubscriptionsData,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_customer_subscriptions_data_type import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerSubscriptionsDataType,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_customer_subscriptions_links import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerSubscriptionsLinks,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_events import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsEvents,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_events_data import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsEventsData,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_events_data_type import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsEventsDataType,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_events_links import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsEventsLinks,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_order_subscriptions import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsOrderSubscriptions,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_order_subscriptions_data import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsOrderSubscriptionsData,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_order_subscriptions_data_type import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsOrderSubscriptionsDataType,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_order_subscriptions_links import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsOrderSubscriptionsLinks,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_orders import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsOrders,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_orders_data import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsOrdersData,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_orders_data_type import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsOrdersDataType,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_orders_links import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsOrdersLinks,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_returns import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsReturns,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_returns_data import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsReturnsData,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_returns_data_type import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsReturnsDataType,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_returns_links import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsReturnsLinks,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_sku_lists import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsSkuLists,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_sku_lists_data import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsSkuListsData,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_sku_lists_data_type import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsSkuListsDataType,
)
from .patc_hcustomerscustomer_id_response_200_data_relationships_sku_lists_links import (
    PATCHcustomerscustomerIdResponse200DataRelationshipsSkuListsLinks,
)
from .patc_hcustomerscustomer_id_response_200_data_type import PATCHcustomerscustomerIdResponse200DataType
from .patc_hdelivery_lead_timesdelivery_lead_time_id_response_200 import (
    PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200,
)
from .patc_hdelivery_lead_timesdelivery_lead_time_id_response_200_data import (
    PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200Data,
)
from .patc_hdelivery_lead_timesdelivery_lead_time_id_response_200_data_attributes import (
    PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataAttributes,
)
from .patc_hdelivery_lead_timesdelivery_lead_time_id_response_200_data_attributes_metadata import (
    PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataAttributesMetadata,
)
from .patc_hdelivery_lead_timesdelivery_lead_time_id_response_200_data_links import (
    PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataLinks,
)
from .patc_hdelivery_lead_timesdelivery_lead_time_id_response_200_data_relationships import (
    PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationships,
)
from .patc_hdelivery_lead_timesdelivery_lead_time_id_response_200_data_relationships_attachments import (
    PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsAttachments,
)
from .patc_hdelivery_lead_timesdelivery_lead_time_id_response_200_data_relationships_attachments_data import (
    PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hdelivery_lead_timesdelivery_lead_time_id_response_200_data_relationships_attachments_data_type import (
    PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hdelivery_lead_timesdelivery_lead_time_id_response_200_data_relationships_attachments_links import (
    PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hdelivery_lead_timesdelivery_lead_time_id_response_200_data_relationships_shipping_method import (
    PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsShippingMethod,
)
from .patc_hdelivery_lead_timesdelivery_lead_time_id_response_200_data_relationships_shipping_method_data import (
    PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsShippingMethodData,
)
from .patc_hdelivery_lead_timesdelivery_lead_time_id_response_200_data_relationships_shipping_method_data_type import (
    PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsShippingMethodDataType,
)
from .patc_hdelivery_lead_timesdelivery_lead_time_id_response_200_data_relationships_shipping_method_links import (
    PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsShippingMethodLinks,
)
from .patc_hdelivery_lead_timesdelivery_lead_time_id_response_200_data_relationships_stock_location import (
    PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsStockLocation,
)
from .patc_hdelivery_lead_timesdelivery_lead_time_id_response_200_data_relationships_stock_location_data import (
    PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsStockLocationData,
)
from .patc_hdelivery_lead_timesdelivery_lead_time_id_response_200_data_relationships_stock_location_data_type import (
    PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsStockLocationDataType,
)
from .patc_hdelivery_lead_timesdelivery_lead_time_id_response_200_data_relationships_stock_location_links import (
    PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsStockLocationLinks,
)
from .patc_hdelivery_lead_timesdelivery_lead_time_id_response_200_data_type import (
    PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataType,
)
from .patc_hexternal_gatewaysexternal_gateway_id_response_200 import PATCHexternalGatewaysexternalGatewayIdResponse200
from .patc_hexternal_gatewaysexternal_gateway_id_response_200_data import (
    PATCHexternalGatewaysexternalGatewayIdResponse200Data,
)
from .patc_hexternal_gatewaysexternal_gateway_id_response_200_data_attributes import (
    PATCHexternalGatewaysexternalGatewayIdResponse200DataAttributes,
)
from .patc_hexternal_gatewaysexternal_gateway_id_response_200_data_attributes_metadata import (
    PATCHexternalGatewaysexternalGatewayIdResponse200DataAttributesMetadata,
)
from .patc_hexternal_gatewaysexternal_gateway_id_response_200_data_links import (
    PATCHexternalGatewaysexternalGatewayIdResponse200DataLinks,
)
from .patc_hexternal_gatewaysexternal_gateway_id_response_200_data_relationships import (
    PATCHexternalGatewaysexternalGatewayIdResponse200DataRelationships,
)
from .patc_hexternal_gatewaysexternal_gateway_id_response_200_data_relationships_external_payments import (
    PATCHexternalGatewaysexternalGatewayIdResponse200DataRelationshipsExternalPayments,
)
from .patc_hexternal_gatewaysexternal_gateway_id_response_200_data_relationships_external_payments_data import (
    PATCHexternalGatewaysexternalGatewayIdResponse200DataRelationshipsExternalPaymentsData,
)
from .patc_hexternal_gatewaysexternal_gateway_id_response_200_data_relationships_external_payments_data_type import (
    PATCHexternalGatewaysexternalGatewayIdResponse200DataRelationshipsExternalPaymentsDataType,
)
from .patc_hexternal_gatewaysexternal_gateway_id_response_200_data_relationships_external_payments_links import (
    PATCHexternalGatewaysexternalGatewayIdResponse200DataRelationshipsExternalPaymentsLinks,
)
from .patc_hexternal_gatewaysexternal_gateway_id_response_200_data_relationships_payment_methods import (
    PATCHexternalGatewaysexternalGatewayIdResponse200DataRelationshipsPaymentMethods,
)
from .patc_hexternal_gatewaysexternal_gateway_id_response_200_data_relationships_payment_methods_data import (
    PATCHexternalGatewaysexternalGatewayIdResponse200DataRelationshipsPaymentMethodsData,
)
from .patc_hexternal_gatewaysexternal_gateway_id_response_200_data_relationships_payment_methods_data_type import (
    PATCHexternalGatewaysexternalGatewayIdResponse200DataRelationshipsPaymentMethodsDataType,
)
from .patc_hexternal_gatewaysexternal_gateway_id_response_200_data_relationships_payment_methods_links import (
    PATCHexternalGatewaysexternalGatewayIdResponse200DataRelationshipsPaymentMethodsLinks,
)
from .patc_hexternal_gatewaysexternal_gateway_id_response_200_data_type import (
    PATCHexternalGatewaysexternalGatewayIdResponse200DataType,
)
from .patc_hexternal_paymentsexternal_payment_id_response_200 import PATCHexternalPaymentsexternalPaymentIdResponse200
from .patc_hexternal_paymentsexternal_payment_id_response_200_data import (
    PATCHexternalPaymentsexternalPaymentIdResponse200Data,
)
from .patc_hexternal_paymentsexternal_payment_id_response_200_data_attributes import (
    PATCHexternalPaymentsexternalPaymentIdResponse200DataAttributes,
)
from .patc_hexternal_paymentsexternal_payment_id_response_200_data_attributes_metadata import (
    PATCHexternalPaymentsexternalPaymentIdResponse200DataAttributesMetadata,
)
from .patc_hexternal_paymentsexternal_payment_id_response_200_data_attributes_options import (
    PATCHexternalPaymentsexternalPaymentIdResponse200DataAttributesOptions,
)
from .patc_hexternal_paymentsexternal_payment_id_response_200_data_links import (
    PATCHexternalPaymentsexternalPaymentIdResponse200DataLinks,
)
from .patc_hexternal_paymentsexternal_payment_id_response_200_data_relationships import (
    PATCHexternalPaymentsexternalPaymentIdResponse200DataRelationships,
)
from .patc_hexternal_paymentsexternal_payment_id_response_200_data_relationships_order import (
    PATCHexternalPaymentsexternalPaymentIdResponse200DataRelationshipsOrder,
)
from .patc_hexternal_paymentsexternal_payment_id_response_200_data_relationships_order_data import (
    PATCHexternalPaymentsexternalPaymentIdResponse200DataRelationshipsOrderData,
)
from .patc_hexternal_paymentsexternal_payment_id_response_200_data_relationships_order_data_type import (
    PATCHexternalPaymentsexternalPaymentIdResponse200DataRelationshipsOrderDataType,
)
from .patc_hexternal_paymentsexternal_payment_id_response_200_data_relationships_order_links import (
    PATCHexternalPaymentsexternalPaymentIdResponse200DataRelationshipsOrderLinks,
)
from .patc_hexternal_paymentsexternal_payment_id_response_200_data_relationships_payment_gateway import (
    PATCHexternalPaymentsexternalPaymentIdResponse200DataRelationshipsPaymentGateway,
)
from .patc_hexternal_paymentsexternal_payment_id_response_200_data_relationships_payment_gateway_data import (
    PATCHexternalPaymentsexternalPaymentIdResponse200DataRelationshipsPaymentGatewayData,
)
from .patc_hexternal_paymentsexternal_payment_id_response_200_data_relationships_payment_gateway_data_type import (
    PATCHexternalPaymentsexternalPaymentIdResponse200DataRelationshipsPaymentGatewayDataType,
)
from .patc_hexternal_paymentsexternal_payment_id_response_200_data_relationships_payment_gateway_links import (
    PATCHexternalPaymentsexternalPaymentIdResponse200DataRelationshipsPaymentGatewayLinks,
)
from .patc_hexternal_paymentsexternal_payment_id_response_200_data_relationships_wallet import (
    PATCHexternalPaymentsexternalPaymentIdResponse200DataRelationshipsWallet,
)
from .patc_hexternal_paymentsexternal_payment_id_response_200_data_relationships_wallet_data import (
    PATCHexternalPaymentsexternalPaymentIdResponse200DataRelationshipsWalletData,
)
from .patc_hexternal_paymentsexternal_payment_id_response_200_data_relationships_wallet_data_type import (
    PATCHexternalPaymentsexternalPaymentIdResponse200DataRelationshipsWalletDataType,
)
from .patc_hexternal_paymentsexternal_payment_id_response_200_data_relationships_wallet_links import (
    PATCHexternalPaymentsexternalPaymentIdResponse200DataRelationshipsWalletLinks,
)
from .patc_hexternal_paymentsexternal_payment_id_response_200_data_type import (
    PATCHexternalPaymentsexternalPaymentIdResponse200DataType,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200 import (
    PATCHexternalPromotionsexternalPromotionIdResponse200,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data import (
    PATCHexternalPromotionsexternalPromotionIdResponse200Data,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_attributes import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataAttributes,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_attributes_metadata import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataAttributesMetadata,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_links import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataLinks,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_relationships import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationships,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_relationships_attachments import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsAttachments,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_relationships_attachments_data import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_relationships_attachments_data_type import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_relationships_attachments_links import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsCouponCodesPromotionRule,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_data import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleData,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_data_type import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleDataType,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_links import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleLinks,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_relationships_market import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsMarket,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_relationships_market_data import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsMarketData,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_relationships_market_data_type import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsMarketDataType,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_relationships_market_links import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsMarketLinks,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_relationships_order_amount_promotion_rule import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsOrderAmountPromotionRule,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_relationships_order_amount_promotion_rule_data import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleData,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_relationships_order_amount_promotion_rule_data_type import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleDataType,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_relationships_order_amount_promotion_rule_links import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleLinks,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_relationships_promotion_rules import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsPromotionRules,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_relationships_promotion_rules_data import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsPromotionRulesData,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_relationships_promotion_rules_data_type import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsPromotionRulesDataType,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_relationships_promotion_rules_links import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsPromotionRulesLinks,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_relationships_sku_list_promotion_rule import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsSkuListPromotionRule,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_relationships_sku_list_promotion_rule_data import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsSkuListPromotionRuleData,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_relationships_sku_list_promotion_rule_data_type import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsSkuListPromotionRuleDataType,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_relationships_sku_list_promotion_rule_links import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsSkuListPromotionRuleLinks,
)
from .patc_hexternal_promotionsexternal_promotion_id_response_200_data_type import (
    PATCHexternalPromotionsexternalPromotionIdResponse200DataType,
)
from .patc_hexternal_tax_calculatorsexternal_tax_calculator_id_response_200 import (
    PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200,
)
from .patc_hexternal_tax_calculatorsexternal_tax_calculator_id_response_200_data import (
    PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200Data,
)
from .patc_hexternal_tax_calculatorsexternal_tax_calculator_id_response_200_data_attributes import (
    PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataAttributes,
)
from .patc_hexternal_tax_calculatorsexternal_tax_calculator_id_response_200_data_attributes_metadata import (
    PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataAttributesMetadata,
)
from .patc_hexternal_tax_calculatorsexternal_tax_calculator_id_response_200_data_links import (
    PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataLinks,
)
from .patc_hexternal_tax_calculatorsexternal_tax_calculator_id_response_200_data_relationships import (
    PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationships,
)
from .patc_hexternal_tax_calculatorsexternal_tax_calculator_id_response_200_data_relationships_attachments import (
    PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsAttachments,
)
from .patc_hexternal_tax_calculatorsexternal_tax_calculator_id_response_200_data_relationships_attachments_data import (
    PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hexternal_tax_calculatorsexternal_tax_calculator_id_response_200_data_relationships_attachments_data_type import (
    PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hexternal_tax_calculatorsexternal_tax_calculator_id_response_200_data_relationships_attachments_links import (
    PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hexternal_tax_calculatorsexternal_tax_calculator_id_response_200_data_relationships_markets import (
    PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsMarkets,
)
from .patc_hexternal_tax_calculatorsexternal_tax_calculator_id_response_200_data_relationships_markets_data import (
    PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsMarketsData,
)
from .patc_hexternal_tax_calculatorsexternal_tax_calculator_id_response_200_data_relationships_markets_data_type import (
    PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsMarketsDataType,
)
from .patc_hexternal_tax_calculatorsexternal_tax_calculator_id_response_200_data_relationships_markets_links import (
    PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsMarketsLinks,
)
from .patc_hexternal_tax_calculatorsexternal_tax_calculator_id_response_200_data_type import (
    PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataType,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200 import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200Data,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_attributes import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataAttributes,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_attributes_metadata import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataAttributesMetadata,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_links import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataLinks,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationships,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_attachments import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsAttachments,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_attachments_data import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_attachments_data_type import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_attachments_links import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRule,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_data import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleData,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_data_type import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleDataType,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_links import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleLinks,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_market import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsMarket,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_market_data import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsMarketData,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_market_data_type import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsMarketDataType,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_market_links import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsMarketLinks,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_order_amount_promotion_rule import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRule,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_order_amount_promotion_rule_data import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleData,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_order_amount_promotion_rule_data_type import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleDataType,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_order_amount_promotion_rule_links import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleLinks,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_promotion_rules import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsPromotionRules,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_promotion_rules_data import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsPromotionRulesData,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_promotion_rules_data_type import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsPromotionRulesDataType,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_promotion_rules_links import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsPromotionRulesLinks,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_sku_list_promotion_rule import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsSkuListPromotionRule,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_sku_list_promotion_rule_data import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsSkuListPromotionRuleData,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_sku_list_promotion_rule_data_type import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsSkuListPromotionRuleDataType,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_relationships_sku_list_promotion_rule_links import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsSkuListPromotionRuleLinks,
)
from .patc_hfixed_amount_promotionsfixed_amount_promotion_id_response_200_data_type import (
    PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataType,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200 import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200Data,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_attributes import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataAttributes,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_attributes_metadata import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataAttributesMetadata,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_links import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataLinks,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationships,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_attachments import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsAttachments,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_attachments_data import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_attachments_data_type import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_attachments_links import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsCouponCodesPromotionRule,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_data import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleData,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_data_type import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleDataType,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_links import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleLinks,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_market import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsMarket,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_market_data import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsMarketData,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_market_data_type import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsMarketDataType,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_market_links import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsMarketLinks,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_order_amount_promotion_rule import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsOrderAmountPromotionRule,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_order_amount_promotion_rule_data import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleData,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_order_amount_promotion_rule_data_type import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleDataType,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_order_amount_promotion_rule_links import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleLinks,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_promotion_rules import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsPromotionRules,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_promotion_rules_data import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsPromotionRulesData,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_promotion_rules_data_type import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsPromotionRulesDataType,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_promotion_rules_links import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsPromotionRulesLinks,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_sku_list import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuList,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_sku_list_data import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuListData,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_sku_list_data_type import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuListDataType,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_sku_list_links import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuListLinks,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_sku_list_promotion_rule import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuListPromotionRule,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_sku_list_promotion_rule_data import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuListPromotionRuleData,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_sku_list_promotion_rule_data_type import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuListPromotionRuleDataType,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_sku_list_promotion_rule_links import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuListPromotionRuleLinks,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_skus import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkus,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_skus_data import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkusData,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_skus_data_type import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkusDataType,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_relationships_skus_links import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkusLinks,
)
from .patc_hfixed_price_promotionsfixed_price_promotion_id_response_200_data_type import (
    PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataType,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200 import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200Data,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_attributes import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataAttributes,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_attributes_metadata import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataAttributesMetadata,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_links import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataLinks,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationships,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_attachments import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsAttachments,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_attachments_data import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_attachments_data_type import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_attachments_links import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsCouponCodesPromotionRule,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_data import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleData,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_data_type import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleDataType,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_links import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleLinks,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_market import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsMarket,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_market_data import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsMarketData,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_market_data_type import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsMarketDataType,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_market_links import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsMarketLinks,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_order_amount_promotion_rule import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsOrderAmountPromotionRule,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_order_amount_promotion_rule_data import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleData,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_order_amount_promotion_rule_data_type import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleDataType,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_order_amount_promotion_rule_links import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleLinks,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_promotion_rules import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsPromotionRules,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_promotion_rules_data import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsPromotionRulesData,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_promotion_rules_data_type import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsPromotionRulesDataType,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_promotion_rules_links import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsPromotionRulesLinks,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_sku_list import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuList,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_sku_list_data import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuListData,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_sku_list_data_type import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuListDataType,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_sku_list_links import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuListLinks,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_sku_list_promotion_rule import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuListPromotionRule,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_sku_list_promotion_rule_data import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuListPromotionRuleData,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_sku_list_promotion_rule_data_type import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuListPromotionRuleDataType,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_sku_list_promotion_rule_links import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuListPromotionRuleLinks,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_skus import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkus,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_skus_data import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkusData,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_skus_data_type import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkusDataType,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_relationships_skus_links import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkusLinks,
)
from .patc_hfree_gift_promotionsfree_gift_promotion_id_response_200_data_type import (
    PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataType,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200 import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200Data,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_attributes import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataAttributes,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_attributes_metadata import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataAttributesMetadata,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_links import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataLinks,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationships,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_attachments import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsAttachments,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_attachments_data import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_attachments_data_type import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_attachments_links import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsCouponCodesPromotionRule,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_data import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleData,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_data_type import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleDataType,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_links import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleLinks,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_market import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsMarket,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_market_data import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsMarketData,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_market_data_type import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsMarketDataType,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_market_links import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsMarketLinks,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_order_amount_promotion_rule import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsOrderAmountPromotionRule,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_order_amount_promotion_rule_data import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleData,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_order_amount_promotion_rule_data_type import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleDataType,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_order_amount_promotion_rule_links import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleLinks,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_promotion_rules import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsPromotionRules,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_promotion_rules_data import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsPromotionRulesData,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_promotion_rules_data_type import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsPromotionRulesDataType,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_promotion_rules_links import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsPromotionRulesLinks,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_sku_list_promotion_rule import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsSkuListPromotionRule,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_sku_list_promotion_rule_data import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsSkuListPromotionRuleData,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_sku_list_promotion_rule_data_type import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsSkuListPromotionRuleDataType,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_relationships_sku_list_promotion_rule_links import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsSkuListPromotionRuleLinks,
)
from .patc_hfree_shipping_promotionsfree_shipping_promotion_id_response_200_data_type import (
    PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataType,
)
from .patc_hgift_card_recipientsgift_card_recipient_id_response_200 import (
    PATCHgiftCardRecipientsgiftCardRecipientIdResponse200,
)
from .patc_hgift_card_recipientsgift_card_recipient_id_response_200_data import (
    PATCHgiftCardRecipientsgiftCardRecipientIdResponse200Data,
)
from .patc_hgift_card_recipientsgift_card_recipient_id_response_200_data_attributes import (
    PATCHgiftCardRecipientsgiftCardRecipientIdResponse200DataAttributes,
)
from .patc_hgift_card_recipientsgift_card_recipient_id_response_200_data_attributes_metadata import (
    PATCHgiftCardRecipientsgiftCardRecipientIdResponse200DataAttributesMetadata,
)
from .patc_hgift_card_recipientsgift_card_recipient_id_response_200_data_links import (
    PATCHgiftCardRecipientsgiftCardRecipientIdResponse200DataLinks,
)
from .patc_hgift_card_recipientsgift_card_recipient_id_response_200_data_relationships import (
    PATCHgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationships,
)
from .patc_hgift_card_recipientsgift_card_recipient_id_response_200_data_relationships_attachments import (
    PATCHgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsAttachments,
)
from .patc_hgift_card_recipientsgift_card_recipient_id_response_200_data_relationships_attachments_data import (
    PATCHgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hgift_card_recipientsgift_card_recipient_id_response_200_data_relationships_attachments_data_type import (
    PATCHgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hgift_card_recipientsgift_card_recipient_id_response_200_data_relationships_attachments_links import (
    PATCHgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hgift_card_recipientsgift_card_recipient_id_response_200_data_relationships_customer import (
    PATCHgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsCustomer,
)
from .patc_hgift_card_recipientsgift_card_recipient_id_response_200_data_relationships_customer_data import (
    PATCHgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsCustomerData,
)
from .patc_hgift_card_recipientsgift_card_recipient_id_response_200_data_relationships_customer_data_type import (
    PATCHgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsCustomerDataType,
)
from .patc_hgift_card_recipientsgift_card_recipient_id_response_200_data_relationships_customer_links import (
    PATCHgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsCustomerLinks,
)
from .patc_hgift_card_recipientsgift_card_recipient_id_response_200_data_type import (
    PATCHgiftCardRecipientsgiftCardRecipientIdResponse200DataType,
)
from .patc_hgift_cardsgift_card_id_response_200 import PATCHgiftCardsgiftCardIdResponse200
from .patc_hgift_cardsgift_card_id_response_200_data import PATCHgiftCardsgiftCardIdResponse200Data
from .patc_hgift_cardsgift_card_id_response_200_data_attributes import PATCHgiftCardsgiftCardIdResponse200DataAttributes
from .patc_hgift_cardsgift_card_id_response_200_data_attributes_metadata import (
    PATCHgiftCardsgiftCardIdResponse200DataAttributesMetadata,
)
from .patc_hgift_cardsgift_card_id_response_200_data_links import PATCHgiftCardsgiftCardIdResponse200DataLinks
from .patc_hgift_cardsgift_card_id_response_200_data_relationships import (
    PATCHgiftCardsgiftCardIdResponse200DataRelationships,
)
from .patc_hgift_cardsgift_card_id_response_200_data_relationships_attachments import (
    PATCHgiftCardsgiftCardIdResponse200DataRelationshipsAttachments,
)
from .patc_hgift_cardsgift_card_id_response_200_data_relationships_attachments_data import (
    PATCHgiftCardsgiftCardIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hgift_cardsgift_card_id_response_200_data_relationships_attachments_data_type import (
    PATCHgiftCardsgiftCardIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hgift_cardsgift_card_id_response_200_data_relationships_attachments_links import (
    PATCHgiftCardsgiftCardIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hgift_cardsgift_card_id_response_200_data_relationships_events import (
    PATCHgiftCardsgiftCardIdResponse200DataRelationshipsEvents,
)
from .patc_hgift_cardsgift_card_id_response_200_data_relationships_events_data import (
    PATCHgiftCardsgiftCardIdResponse200DataRelationshipsEventsData,
)
from .patc_hgift_cardsgift_card_id_response_200_data_relationships_events_data_type import (
    PATCHgiftCardsgiftCardIdResponse200DataRelationshipsEventsDataType,
)
from .patc_hgift_cardsgift_card_id_response_200_data_relationships_events_links import (
    PATCHgiftCardsgiftCardIdResponse200DataRelationshipsEventsLinks,
)
from .patc_hgift_cardsgift_card_id_response_200_data_relationships_gift_card_recipient import (
    PATCHgiftCardsgiftCardIdResponse200DataRelationshipsGiftCardRecipient,
)
from .patc_hgift_cardsgift_card_id_response_200_data_relationships_gift_card_recipient_data import (
    PATCHgiftCardsgiftCardIdResponse200DataRelationshipsGiftCardRecipientData,
)
from .patc_hgift_cardsgift_card_id_response_200_data_relationships_gift_card_recipient_data_type import (
    PATCHgiftCardsgiftCardIdResponse200DataRelationshipsGiftCardRecipientDataType,
)
from .patc_hgift_cardsgift_card_id_response_200_data_relationships_gift_card_recipient_links import (
    PATCHgiftCardsgiftCardIdResponse200DataRelationshipsGiftCardRecipientLinks,
)
from .patc_hgift_cardsgift_card_id_response_200_data_relationships_market import (
    PATCHgiftCardsgiftCardIdResponse200DataRelationshipsMarket,
)
from .patc_hgift_cardsgift_card_id_response_200_data_relationships_market_data import (
    PATCHgiftCardsgiftCardIdResponse200DataRelationshipsMarketData,
)
from .patc_hgift_cardsgift_card_id_response_200_data_relationships_market_data_type import (
    PATCHgiftCardsgiftCardIdResponse200DataRelationshipsMarketDataType,
)
from .patc_hgift_cardsgift_card_id_response_200_data_relationships_market_links import (
    PATCHgiftCardsgiftCardIdResponse200DataRelationshipsMarketLinks,
)
from .patc_hgift_cardsgift_card_id_response_200_data_type import PATCHgiftCardsgiftCardIdResponse200DataType
from .patc_hgoogle_geocodersgoogle_geocoder_id_response_200 import PATCHgoogleGeocodersgoogleGeocoderIdResponse200
from .patc_hgoogle_geocodersgoogle_geocoder_id_response_200_data import (
    PATCHgoogleGeocodersgoogleGeocoderIdResponse200Data,
)
from .patc_hgoogle_geocodersgoogle_geocoder_id_response_200_data_attributes import (
    PATCHgoogleGeocodersgoogleGeocoderIdResponse200DataAttributes,
)
from .patc_hgoogle_geocodersgoogle_geocoder_id_response_200_data_attributes_metadata import (
    PATCHgoogleGeocodersgoogleGeocoderIdResponse200DataAttributesMetadata,
)
from .patc_hgoogle_geocodersgoogle_geocoder_id_response_200_data_links import (
    PATCHgoogleGeocodersgoogleGeocoderIdResponse200DataLinks,
)
from .patc_hgoogle_geocodersgoogle_geocoder_id_response_200_data_relationships import (
    PATCHgoogleGeocodersgoogleGeocoderIdResponse200DataRelationships,
)
from .patc_hgoogle_geocodersgoogle_geocoder_id_response_200_data_relationships_addresses import (
    PATCHgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAddresses,
)
from .patc_hgoogle_geocodersgoogle_geocoder_id_response_200_data_relationships_addresses_data import (
    PATCHgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAddressesData,
)
from .patc_hgoogle_geocodersgoogle_geocoder_id_response_200_data_relationships_addresses_data_type import (
    PATCHgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAddressesDataType,
)
from .patc_hgoogle_geocodersgoogle_geocoder_id_response_200_data_relationships_addresses_links import (
    PATCHgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAddressesLinks,
)
from .patc_hgoogle_geocodersgoogle_geocoder_id_response_200_data_relationships_attachments import (
    PATCHgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAttachments,
)
from .patc_hgoogle_geocodersgoogle_geocoder_id_response_200_data_relationships_attachments_data import (
    PATCHgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hgoogle_geocodersgoogle_geocoder_id_response_200_data_relationships_attachments_data_type import (
    PATCHgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hgoogle_geocodersgoogle_geocoder_id_response_200_data_relationships_attachments_links import (
    PATCHgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hgoogle_geocodersgoogle_geocoder_id_response_200_data_type import (
    PATCHgoogleGeocodersgoogleGeocoderIdResponse200DataType,
)
from .patc_hin_stock_subscriptionsin_stock_subscription_id_response_200 import (
    PATCHinStockSubscriptionsinStockSubscriptionIdResponse200,
)
from .patc_hin_stock_subscriptionsin_stock_subscription_id_response_200_data import (
    PATCHinStockSubscriptionsinStockSubscriptionIdResponse200Data,
)
from .patc_hin_stock_subscriptionsin_stock_subscription_id_response_200_data_attributes import (
    PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataAttributes,
)
from .patc_hin_stock_subscriptionsin_stock_subscription_id_response_200_data_attributes_metadata import (
    PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataAttributesMetadata,
)
from .patc_hin_stock_subscriptionsin_stock_subscription_id_response_200_data_links import (
    PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataLinks,
)
from .patc_hin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships import (
    PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationships,
)
from .patc_hin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_customer import (
    PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsCustomer,
)
from .patc_hin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_customer_data import (
    PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsCustomerData,
)
from .patc_hin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_customer_data_type import (
    PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsCustomerDataType,
)
from .patc_hin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_customer_links import (
    PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsCustomerLinks,
)
from .patc_hin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_events import (
    PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsEvents,
)
from .patc_hin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_events_data import (
    PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsEventsData,
)
from .patc_hin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_events_data_type import (
    PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsEventsDataType,
)
from .patc_hin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_events_links import (
    PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsEventsLinks,
)
from .patc_hin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_market import (
    PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsMarket,
)
from .patc_hin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_market_data import (
    PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsMarketData,
)
from .patc_hin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_market_data_type import (
    PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsMarketDataType,
)
from .patc_hin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_market_links import (
    PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsMarketLinks,
)
from .patc_hin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_sku import (
    PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsSku,
)
from .patc_hin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_sku_data import (
    PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsSkuData,
)
from .patc_hin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_sku_data_type import (
    PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsSkuDataType,
)
from .patc_hin_stock_subscriptionsin_stock_subscription_id_response_200_data_relationships_sku_links import (
    PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsSkuLinks,
)
from .patc_hin_stock_subscriptionsin_stock_subscription_id_response_200_data_type import (
    PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataType,
)
from .patc_hinventory_modelsinventory_model_id_response_200 import PATCHinventoryModelsinventoryModelIdResponse200
from .patc_hinventory_modelsinventory_model_id_response_200_data import (
    PATCHinventoryModelsinventoryModelIdResponse200Data,
)
from .patc_hinventory_modelsinventory_model_id_response_200_data_attributes import (
    PATCHinventoryModelsinventoryModelIdResponse200DataAttributes,
)
from .patc_hinventory_modelsinventory_model_id_response_200_data_attributes_metadata import (
    PATCHinventoryModelsinventoryModelIdResponse200DataAttributesMetadata,
)
from .patc_hinventory_modelsinventory_model_id_response_200_data_links import (
    PATCHinventoryModelsinventoryModelIdResponse200DataLinks,
)
from .patc_hinventory_modelsinventory_model_id_response_200_data_relationships import (
    PATCHinventoryModelsinventoryModelIdResponse200DataRelationships,
)
from .patc_hinventory_modelsinventory_model_id_response_200_data_relationships_attachments import (
    PATCHinventoryModelsinventoryModelIdResponse200DataRelationshipsAttachments,
)
from .patc_hinventory_modelsinventory_model_id_response_200_data_relationships_attachments_data import (
    PATCHinventoryModelsinventoryModelIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hinventory_modelsinventory_model_id_response_200_data_relationships_attachments_data_type import (
    PATCHinventoryModelsinventoryModelIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hinventory_modelsinventory_model_id_response_200_data_relationships_attachments_links import (
    PATCHinventoryModelsinventoryModelIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hinventory_modelsinventory_model_id_response_200_data_relationships_inventory_return_locations import (
    PATCHinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryReturnLocations,
)
from .patc_hinventory_modelsinventory_model_id_response_200_data_relationships_inventory_return_locations_data import (
    PATCHinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryReturnLocationsData,
)
from .patc_hinventory_modelsinventory_model_id_response_200_data_relationships_inventory_return_locations_data_type import (
    PATCHinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryReturnLocationsDataType,
)
from .patc_hinventory_modelsinventory_model_id_response_200_data_relationships_inventory_return_locations_links import (
    PATCHinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryReturnLocationsLinks,
)
from .patc_hinventory_modelsinventory_model_id_response_200_data_relationships_inventory_stock_locations import (
    PATCHinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryStockLocations,
)
from .patc_hinventory_modelsinventory_model_id_response_200_data_relationships_inventory_stock_locations_data import (
    PATCHinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryStockLocationsData,
)
from .patc_hinventory_modelsinventory_model_id_response_200_data_relationships_inventory_stock_locations_data_type import (
    PATCHinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryStockLocationsDataType,
)
from .patc_hinventory_modelsinventory_model_id_response_200_data_relationships_inventory_stock_locations_links import (
    PATCHinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryStockLocationsLinks,
)
from .patc_hinventory_modelsinventory_model_id_response_200_data_type import (
    PATCHinventoryModelsinventoryModelIdResponse200DataType,
)
from .patc_hinventory_return_locationsinventory_return_location_id_response_200 import (
    PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200,
)
from .patc_hinventory_return_locationsinventory_return_location_id_response_200_data import (
    PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200Data,
)
from .patc_hinventory_return_locationsinventory_return_location_id_response_200_data_attributes import (
    PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200DataAttributes,
)
from .patc_hinventory_return_locationsinventory_return_location_id_response_200_data_attributes_metadata import (
    PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200DataAttributesMetadata,
)
from .patc_hinventory_return_locationsinventory_return_location_id_response_200_data_links import (
    PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200DataLinks,
)
from .patc_hinventory_return_locationsinventory_return_location_id_response_200_data_relationships import (
    PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationships,
)
from .patc_hinventory_return_locationsinventory_return_location_id_response_200_data_relationships_inventory_model import (
    PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsInventoryModel,
)
from .patc_hinventory_return_locationsinventory_return_location_id_response_200_data_relationships_inventory_model_data import (
    PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsInventoryModelData,
)
from .patc_hinventory_return_locationsinventory_return_location_id_response_200_data_relationships_inventory_model_data_type import (
    PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsInventoryModelDataType,
)
from .patc_hinventory_return_locationsinventory_return_location_id_response_200_data_relationships_inventory_model_links import (
    PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsInventoryModelLinks,
)
from .patc_hinventory_return_locationsinventory_return_location_id_response_200_data_relationships_stock_location import (
    PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsStockLocation,
)
from .patc_hinventory_return_locationsinventory_return_location_id_response_200_data_relationships_stock_location_data import (
    PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsStockLocationData,
)
from .patc_hinventory_return_locationsinventory_return_location_id_response_200_data_relationships_stock_location_data_type import (
    PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsStockLocationDataType,
)
from .patc_hinventory_return_locationsinventory_return_location_id_response_200_data_relationships_stock_location_links import (
    PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsStockLocationLinks,
)
from .patc_hinventory_return_locationsinventory_return_location_id_response_200_data_type import (
    PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200DataType,
)
from .patc_hinventory_stock_locationsinventory_stock_location_id_response_200 import (
    PATCHinventoryStockLocationsinventoryStockLocationIdResponse200,
)
from .patc_hinventory_stock_locationsinventory_stock_location_id_response_200_data import (
    PATCHinventoryStockLocationsinventoryStockLocationIdResponse200Data,
)
from .patc_hinventory_stock_locationsinventory_stock_location_id_response_200_data_attributes import (
    PATCHinventoryStockLocationsinventoryStockLocationIdResponse200DataAttributes,
)
from .patc_hinventory_stock_locationsinventory_stock_location_id_response_200_data_attributes_metadata import (
    PATCHinventoryStockLocationsinventoryStockLocationIdResponse200DataAttributesMetadata,
)
from .patc_hinventory_stock_locationsinventory_stock_location_id_response_200_data_links import (
    PATCHinventoryStockLocationsinventoryStockLocationIdResponse200DataLinks,
)
from .patc_hinventory_stock_locationsinventory_stock_location_id_response_200_data_relationships import (
    PATCHinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationships,
)
from .patc_hinventory_stock_locationsinventory_stock_location_id_response_200_data_relationships_inventory_model import (
    PATCHinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsInventoryModel,
)
from .patc_hinventory_stock_locationsinventory_stock_location_id_response_200_data_relationships_inventory_model_data import (
    PATCHinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsInventoryModelData,
)
from .patc_hinventory_stock_locationsinventory_stock_location_id_response_200_data_relationships_inventory_model_data_type import (
    PATCHinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsInventoryModelDataType,
)
from .patc_hinventory_stock_locationsinventory_stock_location_id_response_200_data_relationships_inventory_model_links import (
    PATCHinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsInventoryModelLinks,
)
from .patc_hinventory_stock_locationsinventory_stock_location_id_response_200_data_relationships_stock_location import (
    PATCHinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsStockLocation,
)
from .patc_hinventory_stock_locationsinventory_stock_location_id_response_200_data_relationships_stock_location_data import (
    PATCHinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsStockLocationData,
)
from .patc_hinventory_stock_locationsinventory_stock_location_id_response_200_data_relationships_stock_location_data_type import (
    PATCHinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsStockLocationDataType,
)
from .patc_hinventory_stock_locationsinventory_stock_location_id_response_200_data_relationships_stock_location_links import (
    PATCHinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsStockLocationLinks,
)
from .patc_hinventory_stock_locationsinventory_stock_location_id_response_200_data_type import (
    PATCHinventoryStockLocationsinventoryStockLocationIdResponse200DataType,
)
from .patc_hklarna_gatewaysklarna_gateway_id_response_200 import PATCHklarnaGatewaysklarnaGatewayIdResponse200
from .patc_hklarna_gatewaysklarna_gateway_id_response_200_data import PATCHklarnaGatewaysklarnaGatewayIdResponse200Data
from .patc_hklarna_gatewaysklarna_gateway_id_response_200_data_attributes import (
    PATCHklarnaGatewaysklarnaGatewayIdResponse200DataAttributes,
)
from .patc_hklarna_gatewaysklarna_gateway_id_response_200_data_attributes_metadata import (
    PATCHklarnaGatewaysklarnaGatewayIdResponse200DataAttributesMetadata,
)
from .patc_hklarna_gatewaysklarna_gateway_id_response_200_data_links import (
    PATCHklarnaGatewaysklarnaGatewayIdResponse200DataLinks,
)
from .patc_hklarna_gatewaysklarna_gateway_id_response_200_data_relationships import (
    PATCHklarnaGatewaysklarnaGatewayIdResponse200DataRelationships,
)
from .patc_hklarna_gatewaysklarna_gateway_id_response_200_data_relationships_klarna_payments import (
    PATCHklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsKlarnaPayments,
)
from .patc_hklarna_gatewaysklarna_gateway_id_response_200_data_relationships_klarna_payments_data import (
    PATCHklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsKlarnaPaymentsData,
)
from .patc_hklarna_gatewaysklarna_gateway_id_response_200_data_relationships_klarna_payments_data_type import (
    PATCHklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsKlarnaPaymentsDataType,
)
from .patc_hklarna_gatewaysklarna_gateway_id_response_200_data_relationships_klarna_payments_links import (
    PATCHklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsKlarnaPaymentsLinks,
)
from .patc_hklarna_gatewaysklarna_gateway_id_response_200_data_relationships_payment_methods import (
    PATCHklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsPaymentMethods,
)
from .patc_hklarna_gatewaysklarna_gateway_id_response_200_data_relationships_payment_methods_data import (
    PATCHklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsPaymentMethodsData,
)
from .patc_hklarna_gatewaysklarna_gateway_id_response_200_data_relationships_payment_methods_data_type import (
    PATCHklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsPaymentMethodsDataType,
)
from .patc_hklarna_gatewaysklarna_gateway_id_response_200_data_relationships_payment_methods_links import (
    PATCHklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsPaymentMethodsLinks,
)
from .patc_hklarna_gatewaysklarna_gateway_id_response_200_data_type import (
    PATCHklarnaGatewaysklarnaGatewayIdResponse200DataType,
)
from .patc_hklarna_paymentsklarna_payment_id_response_200 import PATCHklarnaPaymentsklarnaPaymentIdResponse200
from .patc_hklarna_paymentsklarna_payment_id_response_200_data import PATCHklarnaPaymentsklarnaPaymentIdResponse200Data
from .patc_hklarna_paymentsklarna_payment_id_response_200_data_attributes import (
    PATCHklarnaPaymentsklarnaPaymentIdResponse200DataAttributes,
)
from .patc_hklarna_paymentsklarna_payment_id_response_200_data_attributes_metadata import (
    PATCHklarnaPaymentsklarnaPaymentIdResponse200DataAttributesMetadata,
)
from .patc_hklarna_paymentsklarna_payment_id_response_200_data_links import (
    PATCHklarnaPaymentsklarnaPaymentIdResponse200DataLinks,
)
from .patc_hklarna_paymentsklarna_payment_id_response_200_data_relationships import (
    PATCHklarnaPaymentsklarnaPaymentIdResponse200DataRelationships,
)
from .patc_hklarna_paymentsklarna_payment_id_response_200_data_relationships_order import (
    PATCHklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsOrder,
)
from .patc_hklarna_paymentsklarna_payment_id_response_200_data_relationships_order_data import (
    PATCHklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsOrderData,
)
from .patc_hklarna_paymentsklarna_payment_id_response_200_data_relationships_order_data_type import (
    PATCHklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsOrderDataType,
)
from .patc_hklarna_paymentsklarna_payment_id_response_200_data_relationships_order_links import (
    PATCHklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsOrderLinks,
)
from .patc_hklarna_paymentsklarna_payment_id_response_200_data_relationships_payment_gateway import (
    PATCHklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsPaymentGateway,
)
from .patc_hklarna_paymentsklarna_payment_id_response_200_data_relationships_payment_gateway_data import (
    PATCHklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsPaymentGatewayData,
)
from .patc_hklarna_paymentsklarna_payment_id_response_200_data_relationships_payment_gateway_data_type import (
    PATCHklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsPaymentGatewayDataType,
)
from .patc_hklarna_paymentsklarna_payment_id_response_200_data_relationships_payment_gateway_links import (
    PATCHklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsPaymentGatewayLinks,
)
from .patc_hklarna_paymentsklarna_payment_id_response_200_data_type import (
    PATCHklarnaPaymentsklarnaPaymentIdResponse200DataType,
)
from .patc_hline_item_optionsline_item_option_id_response_200 import PATCHlineItemOptionslineItemOptionIdResponse200
from .patc_hline_item_optionsline_item_option_id_response_200_data import (
    PATCHlineItemOptionslineItemOptionIdResponse200Data,
)
from .patc_hline_item_optionsline_item_option_id_response_200_data_attributes import (
    PATCHlineItemOptionslineItemOptionIdResponse200DataAttributes,
)
from .patc_hline_item_optionsline_item_option_id_response_200_data_attributes_metadata import (
    PATCHlineItemOptionslineItemOptionIdResponse200DataAttributesMetadata,
)
from .patc_hline_item_optionsline_item_option_id_response_200_data_attributes_options import (
    PATCHlineItemOptionslineItemOptionIdResponse200DataAttributesOptions,
)
from .patc_hline_item_optionsline_item_option_id_response_200_data_links import (
    PATCHlineItemOptionslineItemOptionIdResponse200DataLinks,
)
from .patc_hline_item_optionsline_item_option_id_response_200_data_relationships import (
    PATCHlineItemOptionslineItemOptionIdResponse200DataRelationships,
)
from .patc_hline_item_optionsline_item_option_id_response_200_data_relationships_line_item import (
    PATCHlineItemOptionslineItemOptionIdResponse200DataRelationshipsLineItem,
)
from .patc_hline_item_optionsline_item_option_id_response_200_data_relationships_line_item_data import (
    PATCHlineItemOptionslineItemOptionIdResponse200DataRelationshipsLineItemData,
)
from .patc_hline_item_optionsline_item_option_id_response_200_data_relationships_line_item_data_type import (
    PATCHlineItemOptionslineItemOptionIdResponse200DataRelationshipsLineItemDataType,
)
from .patc_hline_item_optionsline_item_option_id_response_200_data_relationships_line_item_links import (
    PATCHlineItemOptionslineItemOptionIdResponse200DataRelationshipsLineItemLinks,
)
from .patc_hline_item_optionsline_item_option_id_response_200_data_relationships_sku_option import (
    PATCHlineItemOptionslineItemOptionIdResponse200DataRelationshipsSkuOption,
)
from .patc_hline_item_optionsline_item_option_id_response_200_data_relationships_sku_option_data import (
    PATCHlineItemOptionslineItemOptionIdResponse200DataRelationshipsSkuOptionData,
)
from .patc_hline_item_optionsline_item_option_id_response_200_data_relationships_sku_option_data_type import (
    PATCHlineItemOptionslineItemOptionIdResponse200DataRelationshipsSkuOptionDataType,
)
from .patc_hline_item_optionsline_item_option_id_response_200_data_relationships_sku_option_links import (
    PATCHlineItemOptionslineItemOptionIdResponse200DataRelationshipsSkuOptionLinks,
)
from .patc_hline_item_optionsline_item_option_id_response_200_data_type import (
    PATCHlineItemOptionslineItemOptionIdResponse200DataType,
)
from .patc_hline_itemsline_item_id_response_200 import PATCHlineItemslineItemIdResponse200
from .patc_hline_itemsline_item_id_response_200_data import PATCHlineItemslineItemIdResponse200Data
from .patc_hline_itemsline_item_id_response_200_data_attributes import PATCHlineItemslineItemIdResponse200DataAttributes
from .patc_hline_itemsline_item_id_response_200_data_attributes_metadata import (
    PATCHlineItemslineItemIdResponse200DataAttributesMetadata,
)
from .patc_hline_itemsline_item_id_response_200_data_links import PATCHlineItemslineItemIdResponse200DataLinks
from .patc_hline_itemsline_item_id_response_200_data_relationships import (
    PATCHlineItemslineItemIdResponse200DataRelationships,
)
from .patc_hline_itemsline_item_id_response_200_data_relationships_item import (
    PATCHlineItemslineItemIdResponse200DataRelationshipsItem,
)
from .patc_hline_itemsline_item_id_response_200_data_relationships_item_data import (
    PATCHlineItemslineItemIdResponse200DataRelationshipsItemData,
)
from .patc_hline_itemsline_item_id_response_200_data_relationships_item_data_type import (
    PATCHlineItemslineItemIdResponse200DataRelationshipsItemDataType,
)
from .patc_hline_itemsline_item_id_response_200_data_relationships_item_links import (
    PATCHlineItemslineItemIdResponse200DataRelationshipsItemLinks,
)
from .patc_hline_itemsline_item_id_response_200_data_relationships_line_item_options import (
    PATCHlineItemslineItemIdResponse200DataRelationshipsLineItemOptions,
)
from .patc_hline_itemsline_item_id_response_200_data_relationships_line_item_options_data import (
    PATCHlineItemslineItemIdResponse200DataRelationshipsLineItemOptionsData,
)
from .patc_hline_itemsline_item_id_response_200_data_relationships_line_item_options_data_type import (
    PATCHlineItemslineItemIdResponse200DataRelationshipsLineItemOptionsDataType,
)
from .patc_hline_itemsline_item_id_response_200_data_relationships_line_item_options_links import (
    PATCHlineItemslineItemIdResponse200DataRelationshipsLineItemOptionsLinks,
)
from .patc_hline_itemsline_item_id_response_200_data_relationships_order import (
    PATCHlineItemslineItemIdResponse200DataRelationshipsOrder,
)
from .patc_hline_itemsline_item_id_response_200_data_relationships_order_data import (
    PATCHlineItemslineItemIdResponse200DataRelationshipsOrderData,
)
from .patc_hline_itemsline_item_id_response_200_data_relationships_order_data_type import (
    PATCHlineItemslineItemIdResponse200DataRelationshipsOrderDataType,
)
from .patc_hline_itemsline_item_id_response_200_data_relationships_order_links import (
    PATCHlineItemslineItemIdResponse200DataRelationshipsOrderLinks,
)
from .patc_hline_itemsline_item_id_response_200_data_relationships_shipment_line_items import (
    PATCHlineItemslineItemIdResponse200DataRelationshipsShipmentLineItems,
)
from .patc_hline_itemsline_item_id_response_200_data_relationships_shipment_line_items_data import (
    PATCHlineItemslineItemIdResponse200DataRelationshipsShipmentLineItemsData,
)
from .patc_hline_itemsline_item_id_response_200_data_relationships_shipment_line_items_data_type import (
    PATCHlineItemslineItemIdResponse200DataRelationshipsShipmentLineItemsDataType,
)
from .patc_hline_itemsline_item_id_response_200_data_relationships_shipment_line_items_links import (
    PATCHlineItemslineItemIdResponse200DataRelationshipsShipmentLineItemsLinks,
)
from .patc_hline_itemsline_item_id_response_200_data_relationships_stock_line_items import (
    PATCHlineItemslineItemIdResponse200DataRelationshipsStockLineItems,
)
from .patc_hline_itemsline_item_id_response_200_data_relationships_stock_line_items_data import (
    PATCHlineItemslineItemIdResponse200DataRelationshipsStockLineItemsData,
)
from .patc_hline_itemsline_item_id_response_200_data_relationships_stock_line_items_data_type import (
    PATCHlineItemslineItemIdResponse200DataRelationshipsStockLineItemsDataType,
)
from .patc_hline_itemsline_item_id_response_200_data_relationships_stock_line_items_links import (
    PATCHlineItemslineItemIdResponse200DataRelationshipsStockLineItemsLinks,
)
from .patc_hline_itemsline_item_id_response_200_data_relationships_stock_transfers import (
    PATCHlineItemslineItemIdResponse200DataRelationshipsStockTransfers,
)
from .patc_hline_itemsline_item_id_response_200_data_relationships_stock_transfers_data import (
    PATCHlineItemslineItemIdResponse200DataRelationshipsStockTransfersData,
)
from .patc_hline_itemsline_item_id_response_200_data_relationships_stock_transfers_data_type import (
    PATCHlineItemslineItemIdResponse200DataRelationshipsStockTransfersDataType,
)
from .patc_hline_itemsline_item_id_response_200_data_relationships_stock_transfers_links import (
    PATCHlineItemslineItemIdResponse200DataRelationshipsStockTransfersLinks,
)
from .patc_hline_itemsline_item_id_response_200_data_type import PATCHlineItemslineItemIdResponse200DataType
from .patc_hmanual_gatewaysmanual_gateway_id_response_200 import PATCHmanualGatewaysmanualGatewayIdResponse200
from .patc_hmanual_gatewaysmanual_gateway_id_response_200_data import PATCHmanualGatewaysmanualGatewayIdResponse200Data
from .patc_hmanual_gatewaysmanual_gateway_id_response_200_data_attributes import (
    PATCHmanualGatewaysmanualGatewayIdResponse200DataAttributes,
)
from .patc_hmanual_gatewaysmanual_gateway_id_response_200_data_attributes_metadata import (
    PATCHmanualGatewaysmanualGatewayIdResponse200DataAttributesMetadata,
)
from .patc_hmanual_gatewaysmanual_gateway_id_response_200_data_links import (
    PATCHmanualGatewaysmanualGatewayIdResponse200DataLinks,
)
from .patc_hmanual_gatewaysmanual_gateway_id_response_200_data_relationships import (
    PATCHmanualGatewaysmanualGatewayIdResponse200DataRelationships,
)
from .patc_hmanual_gatewaysmanual_gateway_id_response_200_data_relationships_payment_methods import (
    PATCHmanualGatewaysmanualGatewayIdResponse200DataRelationshipsPaymentMethods,
)
from .patc_hmanual_gatewaysmanual_gateway_id_response_200_data_relationships_payment_methods_data import (
    PATCHmanualGatewaysmanualGatewayIdResponse200DataRelationshipsPaymentMethodsData,
)
from .patc_hmanual_gatewaysmanual_gateway_id_response_200_data_relationships_payment_methods_data_type import (
    PATCHmanualGatewaysmanualGatewayIdResponse200DataRelationshipsPaymentMethodsDataType,
)
from .patc_hmanual_gatewaysmanual_gateway_id_response_200_data_relationships_payment_methods_links import (
    PATCHmanualGatewaysmanualGatewayIdResponse200DataRelationshipsPaymentMethodsLinks,
)
from .patc_hmanual_gatewaysmanual_gateway_id_response_200_data_type import (
    PATCHmanualGatewaysmanualGatewayIdResponse200DataType,
)
from .patc_hmanual_tax_calculatorsmanual_tax_calculator_id_response_200 import (
    PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200,
)
from .patc_hmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data import (
    PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200Data,
)
from .patc_hmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_attributes import (
    PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataAttributes,
)
from .patc_hmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_attributes_metadata import (
    PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataAttributesMetadata,
)
from .patc_hmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_links import (
    PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataLinks,
)
from .patc_hmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_relationships import (
    PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationships,
)
from .patc_hmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_relationships_attachments import (
    PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsAttachments,
)
from .patc_hmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_relationships_attachments_data import (
    PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_relationships_attachments_data_type import (
    PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_relationships_attachments_links import (
    PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_relationships_markets import (
    PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsMarkets,
)
from .patc_hmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_relationships_markets_data import (
    PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsMarketsData,
)
from .patc_hmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_relationships_markets_data_type import (
    PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsMarketsDataType,
)
from .patc_hmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_relationships_markets_links import (
    PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsMarketsLinks,
)
from .patc_hmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_relationships_tax_rules import (
    PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsTaxRules,
)
from .patc_hmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_relationships_tax_rules_data import (
    PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsTaxRulesData,
)
from .patc_hmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_relationships_tax_rules_data_type import (
    PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsTaxRulesDataType,
)
from .patc_hmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_relationships_tax_rules_links import (
    PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsTaxRulesLinks,
)
from .patc_hmanual_tax_calculatorsmanual_tax_calculator_id_response_200_data_type import (
    PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataType,
)
from .patc_hmarketsmarket_id_response_200 import PATCHmarketsmarketIdResponse200
from .patc_hmarketsmarket_id_response_200_data import PATCHmarketsmarketIdResponse200Data
from .patc_hmarketsmarket_id_response_200_data_attributes import PATCHmarketsmarketIdResponse200DataAttributes
from .patc_hmarketsmarket_id_response_200_data_attributes_metadata import (
    PATCHmarketsmarketIdResponse200DataAttributesMetadata,
)
from .patc_hmarketsmarket_id_response_200_data_links import PATCHmarketsmarketIdResponse200DataLinks
from .patc_hmarketsmarket_id_response_200_data_relationships import PATCHmarketsmarketIdResponse200DataRelationships
from .patc_hmarketsmarket_id_response_200_data_relationships_attachments import (
    PATCHmarketsmarketIdResponse200DataRelationshipsAttachments,
)
from .patc_hmarketsmarket_id_response_200_data_relationships_attachments_data import (
    PATCHmarketsmarketIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hmarketsmarket_id_response_200_data_relationships_attachments_data_type import (
    PATCHmarketsmarketIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hmarketsmarket_id_response_200_data_relationships_attachments_links import (
    PATCHmarketsmarketIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hmarketsmarket_id_response_200_data_relationships_customer_group import (
    PATCHmarketsmarketIdResponse200DataRelationshipsCustomerGroup,
)
from .patc_hmarketsmarket_id_response_200_data_relationships_customer_group_data import (
    PATCHmarketsmarketIdResponse200DataRelationshipsCustomerGroupData,
)
from .patc_hmarketsmarket_id_response_200_data_relationships_customer_group_data_type import (
    PATCHmarketsmarketIdResponse200DataRelationshipsCustomerGroupDataType,
)
from .patc_hmarketsmarket_id_response_200_data_relationships_customer_group_links import (
    PATCHmarketsmarketIdResponse200DataRelationshipsCustomerGroupLinks,
)
from .patc_hmarketsmarket_id_response_200_data_relationships_inventory_model import (
    PATCHmarketsmarketIdResponse200DataRelationshipsInventoryModel,
)
from .patc_hmarketsmarket_id_response_200_data_relationships_inventory_model_data import (
    PATCHmarketsmarketIdResponse200DataRelationshipsInventoryModelData,
)
from .patc_hmarketsmarket_id_response_200_data_relationships_inventory_model_data_type import (
    PATCHmarketsmarketIdResponse200DataRelationshipsInventoryModelDataType,
)
from .patc_hmarketsmarket_id_response_200_data_relationships_inventory_model_links import (
    PATCHmarketsmarketIdResponse200DataRelationshipsInventoryModelLinks,
)
from .patc_hmarketsmarket_id_response_200_data_relationships_merchant import (
    PATCHmarketsmarketIdResponse200DataRelationshipsMerchant,
)
from .patc_hmarketsmarket_id_response_200_data_relationships_merchant_data import (
    PATCHmarketsmarketIdResponse200DataRelationshipsMerchantData,
)
from .patc_hmarketsmarket_id_response_200_data_relationships_merchant_data_type import (
    PATCHmarketsmarketIdResponse200DataRelationshipsMerchantDataType,
)
from .patc_hmarketsmarket_id_response_200_data_relationships_merchant_links import (
    PATCHmarketsmarketIdResponse200DataRelationshipsMerchantLinks,
)
from .patc_hmarketsmarket_id_response_200_data_relationships_price_list import (
    PATCHmarketsmarketIdResponse200DataRelationshipsPriceList,
)
from .patc_hmarketsmarket_id_response_200_data_relationships_price_list_data import (
    PATCHmarketsmarketIdResponse200DataRelationshipsPriceListData,
)
from .patc_hmarketsmarket_id_response_200_data_relationships_price_list_data_type import (
    PATCHmarketsmarketIdResponse200DataRelationshipsPriceListDataType,
)
from .patc_hmarketsmarket_id_response_200_data_relationships_price_list_links import (
    PATCHmarketsmarketIdResponse200DataRelationshipsPriceListLinks,
)
from .patc_hmarketsmarket_id_response_200_data_relationships_tax_calculator import (
    PATCHmarketsmarketIdResponse200DataRelationshipsTaxCalculator,
)
from .patc_hmarketsmarket_id_response_200_data_relationships_tax_calculator_data import (
    PATCHmarketsmarketIdResponse200DataRelationshipsTaxCalculatorData,
)
from .patc_hmarketsmarket_id_response_200_data_relationships_tax_calculator_data_type import (
    PATCHmarketsmarketIdResponse200DataRelationshipsTaxCalculatorDataType,
)
from .patc_hmarketsmarket_id_response_200_data_relationships_tax_calculator_links import (
    PATCHmarketsmarketIdResponse200DataRelationshipsTaxCalculatorLinks,
)
from .patc_hmarketsmarket_id_response_200_data_type import PATCHmarketsmarketIdResponse200DataType
from .patc_hmerchantsmerchant_id_response_200 import PATCHmerchantsmerchantIdResponse200
from .patc_hmerchantsmerchant_id_response_200_data import PATCHmerchantsmerchantIdResponse200Data
from .patc_hmerchantsmerchant_id_response_200_data_attributes import PATCHmerchantsmerchantIdResponse200DataAttributes
from .patc_hmerchantsmerchant_id_response_200_data_attributes_metadata import (
    PATCHmerchantsmerchantIdResponse200DataAttributesMetadata,
)
from .patc_hmerchantsmerchant_id_response_200_data_links import PATCHmerchantsmerchantIdResponse200DataLinks
from .patc_hmerchantsmerchant_id_response_200_data_relationships import (
    PATCHmerchantsmerchantIdResponse200DataRelationships,
)
from .patc_hmerchantsmerchant_id_response_200_data_relationships_address import (
    PATCHmerchantsmerchantIdResponse200DataRelationshipsAddress,
)
from .patc_hmerchantsmerchant_id_response_200_data_relationships_address_data import (
    PATCHmerchantsmerchantIdResponse200DataRelationshipsAddressData,
)
from .patc_hmerchantsmerchant_id_response_200_data_relationships_address_data_type import (
    PATCHmerchantsmerchantIdResponse200DataRelationshipsAddressDataType,
)
from .patc_hmerchantsmerchant_id_response_200_data_relationships_address_links import (
    PATCHmerchantsmerchantIdResponse200DataRelationshipsAddressLinks,
)
from .patc_hmerchantsmerchant_id_response_200_data_relationships_attachments import (
    PATCHmerchantsmerchantIdResponse200DataRelationshipsAttachments,
)
from .patc_hmerchantsmerchant_id_response_200_data_relationships_attachments_data import (
    PATCHmerchantsmerchantIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hmerchantsmerchant_id_response_200_data_relationships_attachments_data_type import (
    PATCHmerchantsmerchantIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hmerchantsmerchant_id_response_200_data_relationships_attachments_links import (
    PATCHmerchantsmerchantIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hmerchantsmerchant_id_response_200_data_type import PATCHmerchantsmerchantIdResponse200DataType
from .patc_horder_amount_promotion_rulesorder_amount_promotion_rule_id_response_200 import (
    PATCHorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200,
)
from .patc_horder_amount_promotion_rulesorder_amount_promotion_rule_id_response_200_data import (
    PATCHorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200Data,
)
from .patc_horder_amount_promotion_rulesorder_amount_promotion_rule_id_response_200_data_attributes import (
    PATCHorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataAttributes,
)
from .patc_horder_amount_promotion_rulesorder_amount_promotion_rule_id_response_200_data_attributes_metadata import (
    PATCHorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataAttributesMetadata,
)
from .patc_horder_amount_promotion_rulesorder_amount_promotion_rule_id_response_200_data_links import (
    PATCHorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataLinks,
)
from .patc_horder_amount_promotion_rulesorder_amount_promotion_rule_id_response_200_data_relationships import (
    PATCHorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataRelationships,
)
from .patc_horder_amount_promotion_rulesorder_amount_promotion_rule_id_response_200_data_relationships_promotion import (
    PATCHorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataRelationshipsPromotion,
)
from .patc_horder_amount_promotion_rulesorder_amount_promotion_rule_id_response_200_data_relationships_promotion_data import (
    PATCHorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataRelationshipsPromotionData,
)
from .patc_horder_amount_promotion_rulesorder_amount_promotion_rule_id_response_200_data_relationships_promotion_data_type import (
    PATCHorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataRelationshipsPromotionDataType,
)
from .patc_horder_amount_promotion_rulesorder_amount_promotion_rule_id_response_200_data_relationships_promotion_links import (
    PATCHorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataRelationshipsPromotionLinks,
)
from .patc_horder_amount_promotion_rulesorder_amount_promotion_rule_id_response_200_data_type import (
    PATCHorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataType,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200 import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200Data,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_attributes import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataAttributes,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_attributes_metadata import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataAttributesMetadata,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_links import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataLinks,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_relationships import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationships,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_relationships_customer import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsCustomer,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_relationships_customer_data import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsCustomerData,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_relationships_customer_data_type import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsCustomerDataType,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_relationships_customer_links import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsCustomerLinks,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_relationships_events import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsEvents,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_relationships_events_data import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsEventsData,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_relationships_events_data_type import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsEventsDataType,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_relationships_events_links import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsEventsLinks,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_relationships_market import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsMarket,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_relationships_market_data import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsMarketData,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_relationships_market_data_type import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsMarketDataType,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_relationships_market_links import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsMarketLinks,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_relationships_order_copies import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrderCopies,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_relationships_order_copies_data import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrderCopiesData,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_relationships_order_copies_data_type import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrderCopiesDataType,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_relationships_order_copies_links import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrderCopiesLinks,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_relationships_orders import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrders,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_relationships_orders_data import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrdersData,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_relationships_orders_data_type import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrdersDataType,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_relationships_orders_links import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrdersLinks,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_relationships_source_order import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsSourceOrder,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_relationships_source_order_data import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsSourceOrderData,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_relationships_source_order_data_type import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsSourceOrderDataType,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_relationships_source_order_links import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsSourceOrderLinks,
)
from .patc_horder_subscriptionsorder_subscription_id_response_200_data_type import (
    PATCHorderSubscriptionsorderSubscriptionIdResponse200DataType,
)
from .patc_hordersorder_id_response_200 import PATCHordersorderIdResponse200
from .patc_hordersorder_id_response_200_data import PATCHordersorderIdResponse200Data
from .patc_hordersorder_id_response_200_data_attributes import PATCHordersorderIdResponse200DataAttributes
from .patc_hordersorder_id_response_200_data_attributes_metadata import (
    PATCHordersorderIdResponse200DataAttributesMetadata,
)
from .patc_hordersorder_id_response_200_data_links import PATCHordersorderIdResponse200DataLinks
from .patc_hordersorder_id_response_200_data_relationships import PATCHordersorderIdResponse200DataRelationships
from .patc_hordersorder_id_response_200_data_relationships_attachments import (
    PATCHordersorderIdResponse200DataRelationshipsAttachments,
)
from .patc_hordersorder_id_response_200_data_relationships_attachments_data import (
    PATCHordersorderIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hordersorder_id_response_200_data_relationships_attachments_data_type import (
    PATCHordersorderIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hordersorder_id_response_200_data_relationships_attachments_links import (
    PATCHordersorderIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hordersorder_id_response_200_data_relationships_authorizations import (
    PATCHordersorderIdResponse200DataRelationshipsAuthorizations,
)
from .patc_hordersorder_id_response_200_data_relationships_authorizations_data import (
    PATCHordersorderIdResponse200DataRelationshipsAuthorizationsData,
)
from .patc_hordersorder_id_response_200_data_relationships_authorizations_data_type import (
    PATCHordersorderIdResponse200DataRelationshipsAuthorizationsDataType,
)
from .patc_hordersorder_id_response_200_data_relationships_authorizations_links import (
    PATCHordersorderIdResponse200DataRelationshipsAuthorizationsLinks,
)
from .patc_hordersorder_id_response_200_data_relationships_available_customer_payment_sources import (
    PATCHordersorderIdResponse200DataRelationshipsAvailableCustomerPaymentSources,
)
from .patc_hordersorder_id_response_200_data_relationships_available_customer_payment_sources_data import (
    PATCHordersorderIdResponse200DataRelationshipsAvailableCustomerPaymentSourcesData,
)
from .patc_hordersorder_id_response_200_data_relationships_available_customer_payment_sources_data_type import (
    PATCHordersorderIdResponse200DataRelationshipsAvailableCustomerPaymentSourcesDataType,
)
from .patc_hordersorder_id_response_200_data_relationships_available_customer_payment_sources_links import (
    PATCHordersorderIdResponse200DataRelationshipsAvailableCustomerPaymentSourcesLinks,
)
from .patc_hordersorder_id_response_200_data_relationships_available_free_bundles import (
    PATCHordersorderIdResponse200DataRelationshipsAvailableFreeBundles,
)
from .patc_hordersorder_id_response_200_data_relationships_available_free_bundles_data import (
    PATCHordersorderIdResponse200DataRelationshipsAvailableFreeBundlesData,
)
from .patc_hordersorder_id_response_200_data_relationships_available_free_bundles_data_type import (
    PATCHordersorderIdResponse200DataRelationshipsAvailableFreeBundlesDataType,
)
from .patc_hordersorder_id_response_200_data_relationships_available_free_bundles_links import (
    PATCHordersorderIdResponse200DataRelationshipsAvailableFreeBundlesLinks,
)
from .patc_hordersorder_id_response_200_data_relationships_available_free_skus import (
    PATCHordersorderIdResponse200DataRelationshipsAvailableFreeSkus,
)
from .patc_hordersorder_id_response_200_data_relationships_available_free_skus_data import (
    PATCHordersorderIdResponse200DataRelationshipsAvailableFreeSkusData,
)
from .patc_hordersorder_id_response_200_data_relationships_available_free_skus_data_type import (
    PATCHordersorderIdResponse200DataRelationshipsAvailableFreeSkusDataType,
)
from .patc_hordersorder_id_response_200_data_relationships_available_free_skus_links import (
    PATCHordersorderIdResponse200DataRelationshipsAvailableFreeSkusLinks,
)
from .patc_hordersorder_id_response_200_data_relationships_available_payment_methods import (
    PATCHordersorderIdResponse200DataRelationshipsAvailablePaymentMethods,
)
from .patc_hordersorder_id_response_200_data_relationships_available_payment_methods_data import (
    PATCHordersorderIdResponse200DataRelationshipsAvailablePaymentMethodsData,
)
from .patc_hordersorder_id_response_200_data_relationships_available_payment_methods_data_type import (
    PATCHordersorderIdResponse200DataRelationshipsAvailablePaymentMethodsDataType,
)
from .patc_hordersorder_id_response_200_data_relationships_available_payment_methods_links import (
    PATCHordersorderIdResponse200DataRelationshipsAvailablePaymentMethodsLinks,
)
from .patc_hordersorder_id_response_200_data_relationships_billing_address import (
    PATCHordersorderIdResponse200DataRelationshipsBillingAddress,
)
from .patc_hordersorder_id_response_200_data_relationships_billing_address_data import (
    PATCHordersorderIdResponse200DataRelationshipsBillingAddressData,
)
from .patc_hordersorder_id_response_200_data_relationships_billing_address_data_type import (
    PATCHordersorderIdResponse200DataRelationshipsBillingAddressDataType,
)
from .patc_hordersorder_id_response_200_data_relationships_billing_address_links import (
    PATCHordersorderIdResponse200DataRelationshipsBillingAddressLinks,
)
from .patc_hordersorder_id_response_200_data_relationships_captures import (
    PATCHordersorderIdResponse200DataRelationshipsCaptures,
)
from .patc_hordersorder_id_response_200_data_relationships_captures_data import (
    PATCHordersorderIdResponse200DataRelationshipsCapturesData,
)
from .patc_hordersorder_id_response_200_data_relationships_captures_data_type import (
    PATCHordersorderIdResponse200DataRelationshipsCapturesDataType,
)
from .patc_hordersorder_id_response_200_data_relationships_captures_links import (
    PATCHordersorderIdResponse200DataRelationshipsCapturesLinks,
)
from .patc_hordersorder_id_response_200_data_relationships_customer import (
    PATCHordersorderIdResponse200DataRelationshipsCustomer,
)
from .patc_hordersorder_id_response_200_data_relationships_customer_data import (
    PATCHordersorderIdResponse200DataRelationshipsCustomerData,
)
from .patc_hordersorder_id_response_200_data_relationships_customer_data_type import (
    PATCHordersorderIdResponse200DataRelationshipsCustomerDataType,
)
from .patc_hordersorder_id_response_200_data_relationships_customer_links import (
    PATCHordersorderIdResponse200DataRelationshipsCustomerLinks,
)
from .patc_hordersorder_id_response_200_data_relationships_events import (
    PATCHordersorderIdResponse200DataRelationshipsEvents,
)
from .patc_hordersorder_id_response_200_data_relationships_events_data import (
    PATCHordersorderIdResponse200DataRelationshipsEventsData,
)
from .patc_hordersorder_id_response_200_data_relationships_events_data_type import (
    PATCHordersorderIdResponse200DataRelationshipsEventsDataType,
)
from .patc_hordersorder_id_response_200_data_relationships_events_links import (
    PATCHordersorderIdResponse200DataRelationshipsEventsLinks,
)
from .patc_hordersorder_id_response_200_data_relationships_line_items import (
    PATCHordersorderIdResponse200DataRelationshipsLineItems,
)
from .patc_hordersorder_id_response_200_data_relationships_line_items_data import (
    PATCHordersorderIdResponse200DataRelationshipsLineItemsData,
)
from .patc_hordersorder_id_response_200_data_relationships_line_items_data_type import (
    PATCHordersorderIdResponse200DataRelationshipsLineItemsDataType,
)
from .patc_hordersorder_id_response_200_data_relationships_line_items_links import (
    PATCHordersorderIdResponse200DataRelationshipsLineItemsLinks,
)
from .patc_hordersorder_id_response_200_data_relationships_market import (
    PATCHordersorderIdResponse200DataRelationshipsMarket,
)
from .patc_hordersorder_id_response_200_data_relationships_market_data import (
    PATCHordersorderIdResponse200DataRelationshipsMarketData,
)
from .patc_hordersorder_id_response_200_data_relationships_market_data_type import (
    PATCHordersorderIdResponse200DataRelationshipsMarketDataType,
)
from .patc_hordersorder_id_response_200_data_relationships_market_links import (
    PATCHordersorderIdResponse200DataRelationshipsMarketLinks,
)
from .patc_hordersorder_id_response_200_data_relationships_order_copies import (
    PATCHordersorderIdResponse200DataRelationshipsOrderCopies,
)
from .patc_hordersorder_id_response_200_data_relationships_order_copies_data import (
    PATCHordersorderIdResponse200DataRelationshipsOrderCopiesData,
)
from .patc_hordersorder_id_response_200_data_relationships_order_copies_data_type import (
    PATCHordersorderIdResponse200DataRelationshipsOrderCopiesDataType,
)
from .patc_hordersorder_id_response_200_data_relationships_order_copies_links import (
    PATCHordersorderIdResponse200DataRelationshipsOrderCopiesLinks,
)
from .patc_hordersorder_id_response_200_data_relationships_order_subscriptions import (
    PATCHordersorderIdResponse200DataRelationshipsOrderSubscriptions,
)
from .patc_hordersorder_id_response_200_data_relationships_order_subscriptions_data import (
    PATCHordersorderIdResponse200DataRelationshipsOrderSubscriptionsData,
)
from .patc_hordersorder_id_response_200_data_relationships_order_subscriptions_data_type import (
    PATCHordersorderIdResponse200DataRelationshipsOrderSubscriptionsDataType,
)
from .patc_hordersorder_id_response_200_data_relationships_order_subscriptions_links import (
    PATCHordersorderIdResponse200DataRelationshipsOrderSubscriptionsLinks,
)
from .patc_hordersorder_id_response_200_data_relationships_payment_method import (
    PATCHordersorderIdResponse200DataRelationshipsPaymentMethod,
)
from .patc_hordersorder_id_response_200_data_relationships_payment_method_data import (
    PATCHordersorderIdResponse200DataRelationshipsPaymentMethodData,
)
from .patc_hordersorder_id_response_200_data_relationships_payment_method_data_type import (
    PATCHordersorderIdResponse200DataRelationshipsPaymentMethodDataType,
)
from .patc_hordersorder_id_response_200_data_relationships_payment_method_links import (
    PATCHordersorderIdResponse200DataRelationshipsPaymentMethodLinks,
)
from .patc_hordersorder_id_response_200_data_relationships_payment_source import (
    PATCHordersorderIdResponse200DataRelationshipsPaymentSource,
)
from .patc_hordersorder_id_response_200_data_relationships_payment_source_data import (
    PATCHordersorderIdResponse200DataRelationshipsPaymentSourceData,
)
from .patc_hordersorder_id_response_200_data_relationships_payment_source_data_type import (
    PATCHordersorderIdResponse200DataRelationshipsPaymentSourceDataType,
)
from .patc_hordersorder_id_response_200_data_relationships_payment_source_links import (
    PATCHordersorderIdResponse200DataRelationshipsPaymentSourceLinks,
)
from .patc_hordersorder_id_response_200_data_relationships_refunds import (
    PATCHordersorderIdResponse200DataRelationshipsRefunds,
)
from .patc_hordersorder_id_response_200_data_relationships_refunds_data import (
    PATCHordersorderIdResponse200DataRelationshipsRefundsData,
)
from .patc_hordersorder_id_response_200_data_relationships_refunds_data_type import (
    PATCHordersorderIdResponse200DataRelationshipsRefundsDataType,
)
from .patc_hordersorder_id_response_200_data_relationships_refunds_links import (
    PATCHordersorderIdResponse200DataRelationshipsRefundsLinks,
)
from .patc_hordersorder_id_response_200_data_relationships_shipments import (
    PATCHordersorderIdResponse200DataRelationshipsShipments,
)
from .patc_hordersorder_id_response_200_data_relationships_shipments_data import (
    PATCHordersorderIdResponse200DataRelationshipsShipmentsData,
)
from .patc_hordersorder_id_response_200_data_relationships_shipments_data_type import (
    PATCHordersorderIdResponse200DataRelationshipsShipmentsDataType,
)
from .patc_hordersorder_id_response_200_data_relationships_shipments_links import (
    PATCHordersorderIdResponse200DataRelationshipsShipmentsLinks,
)
from .patc_hordersorder_id_response_200_data_relationships_shipping_address import (
    PATCHordersorderIdResponse200DataRelationshipsShippingAddress,
)
from .patc_hordersorder_id_response_200_data_relationships_shipping_address_data import (
    PATCHordersorderIdResponse200DataRelationshipsShippingAddressData,
)
from .patc_hordersorder_id_response_200_data_relationships_shipping_address_data_type import (
    PATCHordersorderIdResponse200DataRelationshipsShippingAddressDataType,
)
from .patc_hordersorder_id_response_200_data_relationships_shipping_address_links import (
    PATCHordersorderIdResponse200DataRelationshipsShippingAddressLinks,
)
from .patc_hordersorder_id_response_200_data_relationships_transactions import (
    PATCHordersorderIdResponse200DataRelationshipsTransactions,
)
from .patc_hordersorder_id_response_200_data_relationships_transactions_data import (
    PATCHordersorderIdResponse200DataRelationshipsTransactionsData,
)
from .patc_hordersorder_id_response_200_data_relationships_transactions_data_type import (
    PATCHordersorderIdResponse200DataRelationshipsTransactionsDataType,
)
from .patc_hordersorder_id_response_200_data_relationships_transactions_links import (
    PATCHordersorderIdResponse200DataRelationshipsTransactionsLinks,
)
from .patc_hordersorder_id_response_200_data_relationships_voids import (
    PATCHordersorderIdResponse200DataRelationshipsVoids,
)
from .patc_hordersorder_id_response_200_data_relationships_voids_data import (
    PATCHordersorderIdResponse200DataRelationshipsVoidsData,
)
from .patc_hordersorder_id_response_200_data_relationships_voids_data_type import (
    PATCHordersorderIdResponse200DataRelationshipsVoidsDataType,
)
from .patc_hordersorder_id_response_200_data_relationships_voids_links import (
    PATCHordersorderIdResponse200DataRelationshipsVoidsLinks,
)
from .patc_hordersorder_id_response_200_data_type import PATCHordersorderIdResponse200DataType
from .patc_hpackagespackage_id_response_200 import PATCHpackagespackageIdResponse200
from .patc_hpackagespackage_id_response_200_data import PATCHpackagespackageIdResponse200Data
from .patc_hpackagespackage_id_response_200_data_attributes import PATCHpackagespackageIdResponse200DataAttributes
from .patc_hpackagespackage_id_response_200_data_attributes_metadata import (
    PATCHpackagespackageIdResponse200DataAttributesMetadata,
)
from .patc_hpackagespackage_id_response_200_data_links import PATCHpackagespackageIdResponse200DataLinks
from .patc_hpackagespackage_id_response_200_data_relationships import PATCHpackagespackageIdResponse200DataRelationships
from .patc_hpackagespackage_id_response_200_data_relationships_attachments import (
    PATCHpackagespackageIdResponse200DataRelationshipsAttachments,
)
from .patc_hpackagespackage_id_response_200_data_relationships_attachments_data import (
    PATCHpackagespackageIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hpackagespackage_id_response_200_data_relationships_attachments_data_type import (
    PATCHpackagespackageIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hpackagespackage_id_response_200_data_relationships_attachments_links import (
    PATCHpackagespackageIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hpackagespackage_id_response_200_data_relationships_parcels import (
    PATCHpackagespackageIdResponse200DataRelationshipsParcels,
)
from .patc_hpackagespackage_id_response_200_data_relationships_parcels_data import (
    PATCHpackagespackageIdResponse200DataRelationshipsParcelsData,
)
from .patc_hpackagespackage_id_response_200_data_relationships_parcels_data_type import (
    PATCHpackagespackageIdResponse200DataRelationshipsParcelsDataType,
)
from .patc_hpackagespackage_id_response_200_data_relationships_parcels_links import (
    PATCHpackagespackageIdResponse200DataRelationshipsParcelsLinks,
)
from .patc_hpackagespackage_id_response_200_data_relationships_stock_location import (
    PATCHpackagespackageIdResponse200DataRelationshipsStockLocation,
)
from .patc_hpackagespackage_id_response_200_data_relationships_stock_location_data import (
    PATCHpackagespackageIdResponse200DataRelationshipsStockLocationData,
)
from .patc_hpackagespackage_id_response_200_data_relationships_stock_location_data_type import (
    PATCHpackagespackageIdResponse200DataRelationshipsStockLocationDataType,
)
from .patc_hpackagespackage_id_response_200_data_relationships_stock_location_links import (
    PATCHpackagespackageIdResponse200DataRelationshipsStockLocationLinks,
)
from .patc_hpackagespackage_id_response_200_data_type import PATCHpackagespackageIdResponse200DataType
from .patc_hparcel_line_itemsparcel_line_item_id_response_200 import PATCHparcelLineItemsparcelLineItemIdResponse200
from .patc_hparcel_line_itemsparcel_line_item_id_response_200_data import (
    PATCHparcelLineItemsparcelLineItemIdResponse200Data,
)
from .patc_hparcel_line_itemsparcel_line_item_id_response_200_data_attributes import (
    PATCHparcelLineItemsparcelLineItemIdResponse200DataAttributes,
)
from .patc_hparcel_line_itemsparcel_line_item_id_response_200_data_attributes_metadata import (
    PATCHparcelLineItemsparcelLineItemIdResponse200DataAttributesMetadata,
)
from .patc_hparcel_line_itemsparcel_line_item_id_response_200_data_links import (
    PATCHparcelLineItemsparcelLineItemIdResponse200DataLinks,
)
from .patc_hparcel_line_itemsparcel_line_item_id_response_200_data_relationships import (
    PATCHparcelLineItemsparcelLineItemIdResponse200DataRelationships,
)
from .patc_hparcel_line_itemsparcel_line_item_id_response_200_data_relationships_parcel import (
    PATCHparcelLineItemsparcelLineItemIdResponse200DataRelationshipsParcel,
)
from .patc_hparcel_line_itemsparcel_line_item_id_response_200_data_relationships_parcel_data import (
    PATCHparcelLineItemsparcelLineItemIdResponse200DataRelationshipsParcelData,
)
from .patc_hparcel_line_itemsparcel_line_item_id_response_200_data_relationships_parcel_data_type import (
    PATCHparcelLineItemsparcelLineItemIdResponse200DataRelationshipsParcelDataType,
)
from .patc_hparcel_line_itemsparcel_line_item_id_response_200_data_relationships_parcel_links import (
    PATCHparcelLineItemsparcelLineItemIdResponse200DataRelationshipsParcelLinks,
)
from .patc_hparcel_line_itemsparcel_line_item_id_response_200_data_relationships_shipment_line_item import (
    PATCHparcelLineItemsparcelLineItemIdResponse200DataRelationshipsShipmentLineItem,
)
from .patc_hparcel_line_itemsparcel_line_item_id_response_200_data_relationships_shipment_line_item_data import (
    PATCHparcelLineItemsparcelLineItemIdResponse200DataRelationshipsShipmentLineItemData,
)
from .patc_hparcel_line_itemsparcel_line_item_id_response_200_data_relationships_shipment_line_item_data_type import (
    PATCHparcelLineItemsparcelLineItemIdResponse200DataRelationshipsShipmentLineItemDataType,
)
from .patc_hparcel_line_itemsparcel_line_item_id_response_200_data_relationships_shipment_line_item_links import (
    PATCHparcelLineItemsparcelLineItemIdResponse200DataRelationshipsShipmentLineItemLinks,
)
from .patc_hparcel_line_itemsparcel_line_item_id_response_200_data_relationships_stock_line_item import (
    PATCHparcelLineItemsparcelLineItemIdResponse200DataRelationshipsStockLineItem,
)
from .patc_hparcel_line_itemsparcel_line_item_id_response_200_data_relationships_stock_line_item_data import (
    PATCHparcelLineItemsparcelLineItemIdResponse200DataRelationshipsStockLineItemData,
)
from .patc_hparcel_line_itemsparcel_line_item_id_response_200_data_relationships_stock_line_item_data_type import (
    PATCHparcelLineItemsparcelLineItemIdResponse200DataRelationshipsStockLineItemDataType,
)
from .patc_hparcel_line_itemsparcel_line_item_id_response_200_data_relationships_stock_line_item_links import (
    PATCHparcelLineItemsparcelLineItemIdResponse200DataRelationshipsStockLineItemLinks,
)
from .patc_hparcel_line_itemsparcel_line_item_id_response_200_data_type import (
    PATCHparcelLineItemsparcelLineItemIdResponse200DataType,
)
from .patc_hparcelsparcel_id_response_200 import PATCHparcelsparcelIdResponse200
from .patc_hparcelsparcel_id_response_200_data import PATCHparcelsparcelIdResponse200Data
from .patc_hparcelsparcel_id_response_200_data_attributes import PATCHparcelsparcelIdResponse200DataAttributes
from .patc_hparcelsparcel_id_response_200_data_attributes_metadata import (
    PATCHparcelsparcelIdResponse200DataAttributesMetadata,
)
from .patc_hparcelsparcel_id_response_200_data_links import PATCHparcelsparcelIdResponse200DataLinks
from .patc_hparcelsparcel_id_response_200_data_relationships import PATCHparcelsparcelIdResponse200DataRelationships
from .patc_hparcelsparcel_id_response_200_data_relationships_attachments import (
    PATCHparcelsparcelIdResponse200DataRelationshipsAttachments,
)
from .patc_hparcelsparcel_id_response_200_data_relationships_attachments_data import (
    PATCHparcelsparcelIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hparcelsparcel_id_response_200_data_relationships_attachments_data_type import (
    PATCHparcelsparcelIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hparcelsparcel_id_response_200_data_relationships_attachments_links import (
    PATCHparcelsparcelIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hparcelsparcel_id_response_200_data_relationships_events import (
    PATCHparcelsparcelIdResponse200DataRelationshipsEvents,
)
from .patc_hparcelsparcel_id_response_200_data_relationships_events_data import (
    PATCHparcelsparcelIdResponse200DataRelationshipsEventsData,
)
from .patc_hparcelsparcel_id_response_200_data_relationships_events_data_type import (
    PATCHparcelsparcelIdResponse200DataRelationshipsEventsDataType,
)
from .patc_hparcelsparcel_id_response_200_data_relationships_events_links import (
    PATCHparcelsparcelIdResponse200DataRelationshipsEventsLinks,
)
from .patc_hparcelsparcel_id_response_200_data_relationships_package import (
    PATCHparcelsparcelIdResponse200DataRelationshipsPackage,
)
from .patc_hparcelsparcel_id_response_200_data_relationships_package_data import (
    PATCHparcelsparcelIdResponse200DataRelationshipsPackageData,
)
from .patc_hparcelsparcel_id_response_200_data_relationships_package_data_type import (
    PATCHparcelsparcelIdResponse200DataRelationshipsPackageDataType,
)
from .patc_hparcelsparcel_id_response_200_data_relationships_package_links import (
    PATCHparcelsparcelIdResponse200DataRelationshipsPackageLinks,
)
from .patc_hparcelsparcel_id_response_200_data_relationships_parcel_line_items import (
    PATCHparcelsparcelIdResponse200DataRelationshipsParcelLineItems,
)
from .patc_hparcelsparcel_id_response_200_data_relationships_parcel_line_items_data import (
    PATCHparcelsparcelIdResponse200DataRelationshipsParcelLineItemsData,
)
from .patc_hparcelsparcel_id_response_200_data_relationships_parcel_line_items_data_type import (
    PATCHparcelsparcelIdResponse200DataRelationshipsParcelLineItemsDataType,
)
from .patc_hparcelsparcel_id_response_200_data_relationships_parcel_line_items_links import (
    PATCHparcelsparcelIdResponse200DataRelationshipsParcelLineItemsLinks,
)
from .patc_hparcelsparcel_id_response_200_data_relationships_shipment import (
    PATCHparcelsparcelIdResponse200DataRelationshipsShipment,
)
from .patc_hparcelsparcel_id_response_200_data_relationships_shipment_data import (
    PATCHparcelsparcelIdResponse200DataRelationshipsShipmentData,
)
from .patc_hparcelsparcel_id_response_200_data_relationships_shipment_data_type import (
    PATCHparcelsparcelIdResponse200DataRelationshipsShipmentDataType,
)
from .patc_hparcelsparcel_id_response_200_data_relationships_shipment_links import (
    PATCHparcelsparcelIdResponse200DataRelationshipsShipmentLinks,
)
from .patc_hparcelsparcel_id_response_200_data_type import PATCHparcelsparcelIdResponse200DataType
from .patc_hpayment_methodspayment_method_id_response_200 import PATCHpaymentMethodspaymentMethodIdResponse200
from .patc_hpayment_methodspayment_method_id_response_200_data import PATCHpaymentMethodspaymentMethodIdResponse200Data
from .patc_hpayment_methodspayment_method_id_response_200_data_attributes import (
    PATCHpaymentMethodspaymentMethodIdResponse200DataAttributes,
)
from .patc_hpayment_methodspayment_method_id_response_200_data_attributes_metadata import (
    PATCHpaymentMethodspaymentMethodIdResponse200DataAttributesMetadata,
)
from .patc_hpayment_methodspayment_method_id_response_200_data_links import (
    PATCHpaymentMethodspaymentMethodIdResponse200DataLinks,
)
from .patc_hpayment_methodspayment_method_id_response_200_data_relationships import (
    PATCHpaymentMethodspaymentMethodIdResponse200DataRelationships,
)
from .patc_hpayment_methodspayment_method_id_response_200_data_relationships_attachments import (
    PATCHpaymentMethodspaymentMethodIdResponse200DataRelationshipsAttachments,
)
from .patc_hpayment_methodspayment_method_id_response_200_data_relationships_attachments_data import (
    PATCHpaymentMethodspaymentMethodIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hpayment_methodspayment_method_id_response_200_data_relationships_attachments_data_type import (
    PATCHpaymentMethodspaymentMethodIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hpayment_methodspayment_method_id_response_200_data_relationships_attachments_links import (
    PATCHpaymentMethodspaymentMethodIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hpayment_methodspayment_method_id_response_200_data_relationships_market import (
    PATCHpaymentMethodspaymentMethodIdResponse200DataRelationshipsMarket,
)
from .patc_hpayment_methodspayment_method_id_response_200_data_relationships_market_data import (
    PATCHpaymentMethodspaymentMethodIdResponse200DataRelationshipsMarketData,
)
from .patc_hpayment_methodspayment_method_id_response_200_data_relationships_market_data_type import (
    PATCHpaymentMethodspaymentMethodIdResponse200DataRelationshipsMarketDataType,
)
from .patc_hpayment_methodspayment_method_id_response_200_data_relationships_market_links import (
    PATCHpaymentMethodspaymentMethodIdResponse200DataRelationshipsMarketLinks,
)
from .patc_hpayment_methodspayment_method_id_response_200_data_relationships_payment_gateway import (
    PATCHpaymentMethodspaymentMethodIdResponse200DataRelationshipsPaymentGateway,
)
from .patc_hpayment_methodspayment_method_id_response_200_data_relationships_payment_gateway_data import (
    PATCHpaymentMethodspaymentMethodIdResponse200DataRelationshipsPaymentGatewayData,
)
from .patc_hpayment_methodspayment_method_id_response_200_data_relationships_payment_gateway_data_type import (
    PATCHpaymentMethodspaymentMethodIdResponse200DataRelationshipsPaymentGatewayDataType,
)
from .patc_hpayment_methodspayment_method_id_response_200_data_relationships_payment_gateway_links import (
    PATCHpaymentMethodspaymentMethodIdResponse200DataRelationshipsPaymentGatewayLinks,
)
from .patc_hpayment_methodspayment_method_id_response_200_data_type import (
    PATCHpaymentMethodspaymentMethodIdResponse200DataType,
)
from .patc_hpaypal_gatewayspaypal_gateway_id_response_200 import PATCHpaypalGatewayspaypalGatewayIdResponse200
from .patc_hpaypal_gatewayspaypal_gateway_id_response_200_data import PATCHpaypalGatewayspaypalGatewayIdResponse200Data
from .patc_hpaypal_gatewayspaypal_gateway_id_response_200_data_attributes import (
    PATCHpaypalGatewayspaypalGatewayIdResponse200DataAttributes,
)
from .patc_hpaypal_gatewayspaypal_gateway_id_response_200_data_attributes_metadata import (
    PATCHpaypalGatewayspaypalGatewayIdResponse200DataAttributesMetadata,
)
from .patc_hpaypal_gatewayspaypal_gateway_id_response_200_data_links import (
    PATCHpaypalGatewayspaypalGatewayIdResponse200DataLinks,
)
from .patc_hpaypal_gatewayspaypal_gateway_id_response_200_data_relationships import (
    PATCHpaypalGatewayspaypalGatewayIdResponse200DataRelationships,
)
from .patc_hpaypal_gatewayspaypal_gateway_id_response_200_data_relationships_payment_methods import (
    PATCHpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaymentMethods,
)
from .patc_hpaypal_gatewayspaypal_gateway_id_response_200_data_relationships_payment_methods_data import (
    PATCHpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaymentMethodsData,
)
from .patc_hpaypal_gatewayspaypal_gateway_id_response_200_data_relationships_payment_methods_data_type import (
    PATCHpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaymentMethodsDataType,
)
from .patc_hpaypal_gatewayspaypal_gateway_id_response_200_data_relationships_payment_methods_links import (
    PATCHpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaymentMethodsLinks,
)
from .patc_hpaypal_gatewayspaypal_gateway_id_response_200_data_relationships_paypal_payments import (
    PATCHpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaypalPayments,
)
from .patc_hpaypal_gatewayspaypal_gateway_id_response_200_data_relationships_paypal_payments_data import (
    PATCHpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaypalPaymentsData,
)
from .patc_hpaypal_gatewayspaypal_gateway_id_response_200_data_relationships_paypal_payments_data_type import (
    PATCHpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaypalPaymentsDataType,
)
from .patc_hpaypal_gatewayspaypal_gateway_id_response_200_data_relationships_paypal_payments_links import (
    PATCHpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaypalPaymentsLinks,
)
from .patc_hpaypal_gatewayspaypal_gateway_id_response_200_data_type import (
    PATCHpaypalGatewayspaypalGatewayIdResponse200DataType,
)
from .patc_hpaypal_paymentspaypal_payment_id_response_200 import PATCHpaypalPaymentspaypalPaymentIdResponse200
from .patc_hpaypal_paymentspaypal_payment_id_response_200_data import PATCHpaypalPaymentspaypalPaymentIdResponse200Data
from .patc_hpaypal_paymentspaypal_payment_id_response_200_data_attributes import (
    PATCHpaypalPaymentspaypalPaymentIdResponse200DataAttributes,
)
from .patc_hpaypal_paymentspaypal_payment_id_response_200_data_attributes_metadata import (
    PATCHpaypalPaymentspaypalPaymentIdResponse200DataAttributesMetadata,
)
from .patc_hpaypal_paymentspaypal_payment_id_response_200_data_links import (
    PATCHpaypalPaymentspaypalPaymentIdResponse200DataLinks,
)
from .patc_hpaypal_paymentspaypal_payment_id_response_200_data_relationships import (
    PATCHpaypalPaymentspaypalPaymentIdResponse200DataRelationships,
)
from .patc_hpaypal_paymentspaypal_payment_id_response_200_data_relationships_order import (
    PATCHpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsOrder,
)
from .patc_hpaypal_paymentspaypal_payment_id_response_200_data_relationships_order_data import (
    PATCHpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsOrderData,
)
from .patc_hpaypal_paymentspaypal_payment_id_response_200_data_relationships_order_data_type import (
    PATCHpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsOrderDataType,
)
from .patc_hpaypal_paymentspaypal_payment_id_response_200_data_relationships_order_links import (
    PATCHpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsOrderLinks,
)
from .patc_hpaypal_paymentspaypal_payment_id_response_200_data_relationships_payment_gateway import (
    PATCHpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsPaymentGateway,
)
from .patc_hpaypal_paymentspaypal_payment_id_response_200_data_relationships_payment_gateway_data import (
    PATCHpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsPaymentGatewayData,
)
from .patc_hpaypal_paymentspaypal_payment_id_response_200_data_relationships_payment_gateway_data_type import (
    PATCHpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsPaymentGatewayDataType,
)
from .patc_hpaypal_paymentspaypal_payment_id_response_200_data_relationships_payment_gateway_links import (
    PATCHpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsPaymentGatewayLinks,
)
from .patc_hpaypal_paymentspaypal_payment_id_response_200_data_type import (
    PATCHpaypalPaymentspaypalPaymentIdResponse200DataType,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200 import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200Data,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_attributes import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataAttributes,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_attributes_metadata import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataAttributesMetadata,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_links import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataLinks,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationships,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_attachments import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsAttachments,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_attachments_data import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_attachments_data_type import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_attachments_links import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRule,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_data import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleData,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_data_type import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleDataType,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_coupon_codes_promotion_rule_links import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleLinks,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_market import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsMarket,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_market_data import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsMarketData,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_market_data_type import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsMarketDataType,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_market_links import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsMarketLinks,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_order_amount_promotion_rule import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRule,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_order_amount_promotion_rule_data import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleData,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_order_amount_promotion_rule_data_type import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleDataType,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_order_amount_promotion_rule_links import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleLinks,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_promotion_rules import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsPromotionRules,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_promotion_rules_data import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsPromotionRulesData,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_promotion_rules_data_type import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsPromotionRulesDataType,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_promotion_rules_links import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsPromotionRulesLinks,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_sku_list import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuList,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_sku_list_data import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuListData,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_sku_list_data_type import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuListDataType,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_sku_list_links import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuListLinks,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_sku_list_promotion_rule import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuListPromotionRule,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_sku_list_promotion_rule_data import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuListPromotionRuleData,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_sku_list_promotion_rule_data_type import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuListPromotionRuleDataType,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_sku_list_promotion_rule_links import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuListPromotionRuleLinks,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_skus import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkus,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_skus_data import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkusData,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_skus_data_type import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkusDataType,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_relationships_skus_links import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkusLinks,
)
from .patc_hpercentage_discount_promotionspercentage_discount_promotion_id_response_200_data_type import (
    PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataType,
)
from .patc_hprice_listsprice_list_id_response_200 import PATCHpriceListspriceListIdResponse200
from .patc_hprice_listsprice_list_id_response_200_data import PATCHpriceListspriceListIdResponse200Data
from .patc_hprice_listsprice_list_id_response_200_data_attributes import (
    PATCHpriceListspriceListIdResponse200DataAttributes,
)
from .patc_hprice_listsprice_list_id_response_200_data_attributes_metadata import (
    PATCHpriceListspriceListIdResponse200DataAttributesMetadata,
)
from .patc_hprice_listsprice_list_id_response_200_data_links import PATCHpriceListspriceListIdResponse200DataLinks
from .patc_hprice_listsprice_list_id_response_200_data_relationships import (
    PATCHpriceListspriceListIdResponse200DataRelationships,
)
from .patc_hprice_listsprice_list_id_response_200_data_relationships_attachments import (
    PATCHpriceListspriceListIdResponse200DataRelationshipsAttachments,
)
from .patc_hprice_listsprice_list_id_response_200_data_relationships_attachments_data import (
    PATCHpriceListspriceListIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hprice_listsprice_list_id_response_200_data_relationships_attachments_data_type import (
    PATCHpriceListspriceListIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hprice_listsprice_list_id_response_200_data_relationships_attachments_links import (
    PATCHpriceListspriceListIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hprice_listsprice_list_id_response_200_data_relationships_prices import (
    PATCHpriceListspriceListIdResponse200DataRelationshipsPrices,
)
from .patc_hprice_listsprice_list_id_response_200_data_relationships_prices_data import (
    PATCHpriceListspriceListIdResponse200DataRelationshipsPricesData,
)
from .patc_hprice_listsprice_list_id_response_200_data_relationships_prices_data_type import (
    PATCHpriceListspriceListIdResponse200DataRelationshipsPricesDataType,
)
from .patc_hprice_listsprice_list_id_response_200_data_relationships_prices_links import (
    PATCHpriceListspriceListIdResponse200DataRelationshipsPricesLinks,
)
from .patc_hprice_listsprice_list_id_response_200_data_type import PATCHpriceListspriceListIdResponse200DataType
from .patc_hprice_volume_tiersprice_volume_tier_id_response_200 import PATCHpriceVolumeTierspriceVolumeTierIdResponse200
from .patc_hprice_volume_tiersprice_volume_tier_id_response_200_data import (
    PATCHpriceVolumeTierspriceVolumeTierIdResponse200Data,
)
from .patc_hprice_volume_tiersprice_volume_tier_id_response_200_data_attributes import (
    PATCHpriceVolumeTierspriceVolumeTierIdResponse200DataAttributes,
)
from .patc_hprice_volume_tiersprice_volume_tier_id_response_200_data_attributes_metadata import (
    PATCHpriceVolumeTierspriceVolumeTierIdResponse200DataAttributesMetadata,
)
from .patc_hprice_volume_tiersprice_volume_tier_id_response_200_data_links import (
    PATCHpriceVolumeTierspriceVolumeTierIdResponse200DataLinks,
)
from .patc_hprice_volume_tiersprice_volume_tier_id_response_200_data_relationships import (
    PATCHpriceVolumeTierspriceVolumeTierIdResponse200DataRelationships,
)
from .patc_hprice_volume_tiersprice_volume_tier_id_response_200_data_relationships_attachments import (
    PATCHpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsAttachments,
)
from .patc_hprice_volume_tiersprice_volume_tier_id_response_200_data_relationships_attachments_data import (
    PATCHpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hprice_volume_tiersprice_volume_tier_id_response_200_data_relationships_attachments_data_type import (
    PATCHpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hprice_volume_tiersprice_volume_tier_id_response_200_data_relationships_attachments_links import (
    PATCHpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hprice_volume_tiersprice_volume_tier_id_response_200_data_relationships_price import (
    PATCHpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsPrice,
)
from .patc_hprice_volume_tiersprice_volume_tier_id_response_200_data_relationships_price_data import (
    PATCHpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsPriceData,
)
from .patc_hprice_volume_tiersprice_volume_tier_id_response_200_data_relationships_price_data_type import (
    PATCHpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsPriceDataType,
)
from .patc_hprice_volume_tiersprice_volume_tier_id_response_200_data_relationships_price_links import (
    PATCHpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsPriceLinks,
)
from .patc_hprice_volume_tiersprice_volume_tier_id_response_200_data_type import (
    PATCHpriceVolumeTierspriceVolumeTierIdResponse200DataType,
)
from .patc_hpricesprice_id_response_200 import PATCHpricespriceIdResponse200
from .patc_hpricesprice_id_response_200_data import PATCHpricespriceIdResponse200Data
from .patc_hpricesprice_id_response_200_data_attributes import PATCHpricespriceIdResponse200DataAttributes
from .patc_hpricesprice_id_response_200_data_attributes_metadata import (
    PATCHpricespriceIdResponse200DataAttributesMetadata,
)
from .patc_hpricesprice_id_response_200_data_links import PATCHpricespriceIdResponse200DataLinks
from .patc_hpricesprice_id_response_200_data_relationships import PATCHpricespriceIdResponse200DataRelationships
from .patc_hpricesprice_id_response_200_data_relationships_attachments import (
    PATCHpricespriceIdResponse200DataRelationshipsAttachments,
)
from .patc_hpricesprice_id_response_200_data_relationships_attachments_data import (
    PATCHpricespriceIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hpricesprice_id_response_200_data_relationships_attachments_data_type import (
    PATCHpricespriceIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hpricesprice_id_response_200_data_relationships_attachments_links import (
    PATCHpricespriceIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hpricesprice_id_response_200_data_relationships_price_list import (
    PATCHpricespriceIdResponse200DataRelationshipsPriceList,
)
from .patc_hpricesprice_id_response_200_data_relationships_price_list_data import (
    PATCHpricespriceIdResponse200DataRelationshipsPriceListData,
)
from .patc_hpricesprice_id_response_200_data_relationships_price_list_data_type import (
    PATCHpricespriceIdResponse200DataRelationshipsPriceListDataType,
)
from .patc_hpricesprice_id_response_200_data_relationships_price_list_links import (
    PATCHpricespriceIdResponse200DataRelationshipsPriceListLinks,
)
from .patc_hpricesprice_id_response_200_data_relationships_price_tiers import (
    PATCHpricespriceIdResponse200DataRelationshipsPriceTiers,
)
from .patc_hpricesprice_id_response_200_data_relationships_price_tiers_data import (
    PATCHpricespriceIdResponse200DataRelationshipsPriceTiersData,
)
from .patc_hpricesprice_id_response_200_data_relationships_price_tiers_data_type import (
    PATCHpricespriceIdResponse200DataRelationshipsPriceTiersDataType,
)
from .patc_hpricesprice_id_response_200_data_relationships_price_tiers_links import (
    PATCHpricespriceIdResponse200DataRelationshipsPriceTiersLinks,
)
from .patc_hpricesprice_id_response_200_data_relationships_price_volume_tiers import (
    PATCHpricespriceIdResponse200DataRelationshipsPriceVolumeTiers,
)
from .patc_hpricesprice_id_response_200_data_relationships_price_volume_tiers_data import (
    PATCHpricespriceIdResponse200DataRelationshipsPriceVolumeTiersData,
)
from .patc_hpricesprice_id_response_200_data_relationships_price_volume_tiers_data_type import (
    PATCHpricespriceIdResponse200DataRelationshipsPriceVolumeTiersDataType,
)
from .patc_hpricesprice_id_response_200_data_relationships_price_volume_tiers_links import (
    PATCHpricespriceIdResponse200DataRelationshipsPriceVolumeTiersLinks,
)
from .patc_hpricesprice_id_response_200_data_relationships_sku import PATCHpricespriceIdResponse200DataRelationshipsSku
from .patc_hpricesprice_id_response_200_data_relationships_sku_data import (
    PATCHpricespriceIdResponse200DataRelationshipsSkuData,
)
from .patc_hpricesprice_id_response_200_data_relationships_sku_data_type import (
    PATCHpricespriceIdResponse200DataRelationshipsSkuDataType,
)
from .patc_hpricesprice_id_response_200_data_relationships_sku_links import (
    PATCHpricespriceIdResponse200DataRelationshipsSkuLinks,
)
from .patc_hpricesprice_id_response_200_data_type import PATCHpricespriceIdResponse200DataType
from .patc_hreturn_line_itemsreturn_line_item_id_response_200 import PATCHreturnLineItemsreturnLineItemIdResponse200
from .patc_hreturn_line_itemsreturn_line_item_id_response_200_data import (
    PATCHreturnLineItemsreturnLineItemIdResponse200Data,
)
from .patc_hreturn_line_itemsreturn_line_item_id_response_200_data_attributes import (
    PATCHreturnLineItemsreturnLineItemIdResponse200DataAttributes,
)
from .patc_hreturn_line_itemsreturn_line_item_id_response_200_data_attributes_metadata import (
    PATCHreturnLineItemsreturnLineItemIdResponse200DataAttributesMetadata,
)
from .patc_hreturn_line_itemsreturn_line_item_id_response_200_data_attributes_return_reason import (
    PATCHreturnLineItemsreturnLineItemIdResponse200DataAttributesReturnReason,
)
from .patc_hreturn_line_itemsreturn_line_item_id_response_200_data_links import (
    PATCHreturnLineItemsreturnLineItemIdResponse200DataLinks,
)
from .patc_hreturn_line_itemsreturn_line_item_id_response_200_data_relationships import (
    PATCHreturnLineItemsreturnLineItemIdResponse200DataRelationships,
)
from .patc_hreturn_line_itemsreturn_line_item_id_response_200_data_relationships_line_item import (
    PATCHreturnLineItemsreturnLineItemIdResponse200DataRelationshipsLineItem,
)
from .patc_hreturn_line_itemsreturn_line_item_id_response_200_data_relationships_line_item_data import (
    PATCHreturnLineItemsreturnLineItemIdResponse200DataRelationshipsLineItemData,
)
from .patc_hreturn_line_itemsreturn_line_item_id_response_200_data_relationships_line_item_data_type import (
    PATCHreturnLineItemsreturnLineItemIdResponse200DataRelationshipsLineItemDataType,
)
from .patc_hreturn_line_itemsreturn_line_item_id_response_200_data_relationships_line_item_links import (
    PATCHreturnLineItemsreturnLineItemIdResponse200DataRelationshipsLineItemLinks,
)
from .patc_hreturn_line_itemsreturn_line_item_id_response_200_data_relationships_return import (
    PATCHreturnLineItemsreturnLineItemIdResponse200DataRelationshipsReturn,
)
from .patc_hreturn_line_itemsreturn_line_item_id_response_200_data_relationships_return_data import (
    PATCHreturnLineItemsreturnLineItemIdResponse200DataRelationshipsReturnData,
)
from .patc_hreturn_line_itemsreturn_line_item_id_response_200_data_relationships_return_data_type import (
    PATCHreturnLineItemsreturnLineItemIdResponse200DataRelationshipsReturnDataType,
)
from .patc_hreturn_line_itemsreturn_line_item_id_response_200_data_relationships_return_links import (
    PATCHreturnLineItemsreturnLineItemIdResponse200DataRelationshipsReturnLinks,
)
from .patc_hreturn_line_itemsreturn_line_item_id_response_200_data_type import (
    PATCHreturnLineItemsreturnLineItemIdResponse200DataType,
)
from .patc_hreturnsreturn_id_response_200 import PATCHreturnsreturnIdResponse200
from .patc_hreturnsreturn_id_response_200_data import PATCHreturnsreturnIdResponse200Data
from .patc_hreturnsreturn_id_response_200_data_attributes import PATCHreturnsreturnIdResponse200DataAttributes
from .patc_hreturnsreturn_id_response_200_data_attributes_metadata import (
    PATCHreturnsreturnIdResponse200DataAttributesMetadata,
)
from .patc_hreturnsreturn_id_response_200_data_links import PATCHreturnsreturnIdResponse200DataLinks
from .patc_hreturnsreturn_id_response_200_data_relationships import PATCHreturnsreturnIdResponse200DataRelationships
from .patc_hreturnsreturn_id_response_200_data_relationships_attachments import (
    PATCHreturnsreturnIdResponse200DataRelationshipsAttachments,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_attachments_data import (
    PATCHreturnsreturnIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_attachments_data_type import (
    PATCHreturnsreturnIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_attachments_links import (
    PATCHreturnsreturnIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_customer import (
    PATCHreturnsreturnIdResponse200DataRelationshipsCustomer,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_customer_data import (
    PATCHreturnsreturnIdResponse200DataRelationshipsCustomerData,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_customer_data_type import (
    PATCHreturnsreturnIdResponse200DataRelationshipsCustomerDataType,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_customer_links import (
    PATCHreturnsreturnIdResponse200DataRelationshipsCustomerLinks,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_destination_address import (
    PATCHreturnsreturnIdResponse200DataRelationshipsDestinationAddress,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_destination_address_data import (
    PATCHreturnsreturnIdResponse200DataRelationshipsDestinationAddressData,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_destination_address_data_type import (
    PATCHreturnsreturnIdResponse200DataRelationshipsDestinationAddressDataType,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_destination_address_links import (
    PATCHreturnsreturnIdResponse200DataRelationshipsDestinationAddressLinks,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_events import (
    PATCHreturnsreturnIdResponse200DataRelationshipsEvents,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_events_data import (
    PATCHreturnsreturnIdResponse200DataRelationshipsEventsData,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_events_data_type import (
    PATCHreturnsreturnIdResponse200DataRelationshipsEventsDataType,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_events_links import (
    PATCHreturnsreturnIdResponse200DataRelationshipsEventsLinks,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_order import (
    PATCHreturnsreturnIdResponse200DataRelationshipsOrder,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_order_data import (
    PATCHreturnsreturnIdResponse200DataRelationshipsOrderData,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_order_data_type import (
    PATCHreturnsreturnIdResponse200DataRelationshipsOrderDataType,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_order_links import (
    PATCHreturnsreturnIdResponse200DataRelationshipsOrderLinks,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_origin_address import (
    PATCHreturnsreturnIdResponse200DataRelationshipsOriginAddress,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_origin_address_data import (
    PATCHreturnsreturnIdResponse200DataRelationshipsOriginAddressData,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_origin_address_data_type import (
    PATCHreturnsreturnIdResponse200DataRelationshipsOriginAddressDataType,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_origin_address_links import (
    PATCHreturnsreturnIdResponse200DataRelationshipsOriginAddressLinks,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_return_line_items import (
    PATCHreturnsreturnIdResponse200DataRelationshipsReturnLineItems,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_return_line_items_data import (
    PATCHreturnsreturnIdResponse200DataRelationshipsReturnLineItemsData,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_return_line_items_data_type import (
    PATCHreturnsreturnIdResponse200DataRelationshipsReturnLineItemsDataType,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_return_line_items_links import (
    PATCHreturnsreturnIdResponse200DataRelationshipsReturnLineItemsLinks,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_stock_location import (
    PATCHreturnsreturnIdResponse200DataRelationshipsStockLocation,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_stock_location_data import (
    PATCHreturnsreturnIdResponse200DataRelationshipsStockLocationData,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_stock_location_data_type import (
    PATCHreturnsreturnIdResponse200DataRelationshipsStockLocationDataType,
)
from .patc_hreturnsreturn_id_response_200_data_relationships_stock_location_links import (
    PATCHreturnsreturnIdResponse200DataRelationshipsStockLocationLinks,
)
from .patc_hreturnsreturn_id_response_200_data_type import PATCHreturnsreturnIdResponse200DataType
from .patc_hshipmentsshipment_id_response_200 import PATCHshipmentsshipmentIdResponse200
from .patc_hshipmentsshipment_id_response_200_data import PATCHshipmentsshipmentIdResponse200Data
from .patc_hshipmentsshipment_id_response_200_data_attributes import PATCHshipmentsshipmentIdResponse200DataAttributes
from .patc_hshipmentsshipment_id_response_200_data_attributes_metadata import (
    PATCHshipmentsshipmentIdResponse200DataAttributesMetadata,
)
from .patc_hshipmentsshipment_id_response_200_data_links import PATCHshipmentsshipmentIdResponse200DataLinks
from .patc_hshipmentsshipment_id_response_200_data_relationships import (
    PATCHshipmentsshipmentIdResponse200DataRelationships,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_attachments import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsAttachments,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_attachments_data import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_attachments_data_type import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_attachments_links import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_available_shipping_methods import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsAvailableShippingMethods,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_available_shipping_methods_data import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsAvailableShippingMethodsData,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_available_shipping_methods_data_type import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsAvailableShippingMethodsDataType,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_available_shipping_methods_links import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsAvailableShippingMethodsLinks,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_carrier_accounts import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsCarrierAccounts,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_carrier_accounts_data import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsCarrierAccountsData,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_carrier_accounts_data_type import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsCarrierAccountsDataType,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_carrier_accounts_links import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsCarrierAccountsLinks,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_delivery_lead_time import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsDeliveryLeadTime,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_delivery_lead_time_data import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsDeliveryLeadTimeData,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_delivery_lead_time_data_type import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsDeliveryLeadTimeDataType,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_delivery_lead_time_links import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsDeliveryLeadTimeLinks,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_events import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsEvents,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_events_data import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsEventsData,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_events_data_type import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsEventsDataType,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_events_links import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsEventsLinks,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_order import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsOrder,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_order_data import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsOrderData,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_order_data_type import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsOrderDataType,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_order_links import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsOrderLinks,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_origin_address import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsOriginAddress,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_origin_address_data import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsOriginAddressData,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_origin_address_data_type import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsOriginAddressDataType,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_origin_address_links import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsOriginAddressLinks,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_parcels import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsParcels,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_parcels_data import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsParcelsData,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_parcels_data_type import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsParcelsDataType,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_parcels_links import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsParcelsLinks,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_shipment_line_items import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsShipmentLineItems,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_shipment_line_items_data import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsShipmentLineItemsData,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_shipment_line_items_data_type import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsShipmentLineItemsDataType,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_shipment_line_items_links import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsShipmentLineItemsLinks,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_shipping_address import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsShippingAddress,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_shipping_address_data import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsShippingAddressData,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_shipping_address_data_type import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsShippingAddressDataType,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_shipping_address_links import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsShippingAddressLinks,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_shipping_category import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsShippingCategory,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_shipping_category_data import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsShippingCategoryData,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_shipping_category_data_type import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsShippingCategoryDataType,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_shipping_category_links import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsShippingCategoryLinks,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_shipping_method import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsShippingMethod,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_shipping_method_data import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsShippingMethodData,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_shipping_method_data_type import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsShippingMethodDataType,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_shipping_method_links import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsShippingMethodLinks,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_stock_line_items import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsStockLineItems,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_stock_line_items_data import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsStockLineItemsData,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_stock_line_items_data_type import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsStockLineItemsDataType,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_stock_line_items_links import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsStockLineItemsLinks,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_stock_location import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsStockLocation,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_stock_location_data import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsStockLocationData,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_stock_location_data_type import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsStockLocationDataType,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_stock_location_links import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsStockLocationLinks,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_stock_transfers import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsStockTransfers,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_stock_transfers_data import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsStockTransfersData,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_stock_transfers_data_type import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsStockTransfersDataType,
)
from .patc_hshipmentsshipment_id_response_200_data_relationships_stock_transfers_links import (
    PATCHshipmentsshipmentIdResponse200DataRelationshipsStockTransfersLinks,
)
from .patc_hshipmentsshipment_id_response_200_data_type import PATCHshipmentsshipmentIdResponse200DataType
from .patc_hshipping_categoriesshipping_category_id_response_200 import (
    PATCHshippingCategoriesshippingCategoryIdResponse200,
)
from .patc_hshipping_categoriesshipping_category_id_response_200_data import (
    PATCHshippingCategoriesshippingCategoryIdResponse200Data,
)
from .patc_hshipping_categoriesshipping_category_id_response_200_data_attributes import (
    PATCHshippingCategoriesshippingCategoryIdResponse200DataAttributes,
)
from .patc_hshipping_categoriesshipping_category_id_response_200_data_attributes_metadata import (
    PATCHshippingCategoriesshippingCategoryIdResponse200DataAttributesMetadata,
)
from .patc_hshipping_categoriesshipping_category_id_response_200_data_links import (
    PATCHshippingCategoriesshippingCategoryIdResponse200DataLinks,
)
from .patc_hshipping_categoriesshipping_category_id_response_200_data_relationships import (
    PATCHshippingCategoriesshippingCategoryIdResponse200DataRelationships,
)
from .patc_hshipping_categoriesshipping_category_id_response_200_data_relationships_attachments import (
    PATCHshippingCategoriesshippingCategoryIdResponse200DataRelationshipsAttachments,
)
from .patc_hshipping_categoriesshipping_category_id_response_200_data_relationships_attachments_data import (
    PATCHshippingCategoriesshippingCategoryIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hshipping_categoriesshipping_category_id_response_200_data_relationships_attachments_data_type import (
    PATCHshippingCategoriesshippingCategoryIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hshipping_categoriesshipping_category_id_response_200_data_relationships_attachments_links import (
    PATCHshippingCategoriesshippingCategoryIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hshipping_categoriesshipping_category_id_response_200_data_relationships_skus import (
    PATCHshippingCategoriesshippingCategoryIdResponse200DataRelationshipsSkus,
)
from .patc_hshipping_categoriesshipping_category_id_response_200_data_relationships_skus_data import (
    PATCHshippingCategoriesshippingCategoryIdResponse200DataRelationshipsSkusData,
)
from .patc_hshipping_categoriesshipping_category_id_response_200_data_relationships_skus_data_type import (
    PATCHshippingCategoriesshippingCategoryIdResponse200DataRelationshipsSkusDataType,
)
from .patc_hshipping_categoriesshipping_category_id_response_200_data_relationships_skus_links import (
    PATCHshippingCategoriesshippingCategoryIdResponse200DataRelationshipsSkusLinks,
)
from .patc_hshipping_categoriesshipping_category_id_response_200_data_type import (
    PATCHshippingCategoriesshippingCategoryIdResponse200DataType,
)
from .patc_hshipping_methodsshipping_method_id_response_200 import PATCHshippingMethodsshippingMethodIdResponse200
from .patc_hshipping_methodsshipping_method_id_response_200_data import (
    PATCHshippingMethodsshippingMethodIdResponse200Data,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_attributes import (
    PATCHshippingMethodsshippingMethodIdResponse200DataAttributes,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_attributes_metadata import (
    PATCHshippingMethodsshippingMethodIdResponse200DataAttributesMetadata,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_links import (
    PATCHshippingMethodsshippingMethodIdResponse200DataLinks,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationships,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_attachments import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsAttachments,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_attachments_data import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_attachments_data_type import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_attachments_links import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_delivery_lead_time_for_shipment import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsDeliveryLeadTimeForShipment,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_delivery_lead_time_for_shipment_data import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsDeliveryLeadTimeForShipmentData,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_delivery_lead_time_for_shipment_data_type import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsDeliveryLeadTimeForShipmentDataType,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_delivery_lead_time_for_shipment_links import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsDeliveryLeadTimeForShipmentLinks,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_market import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsMarket,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_market_data import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsMarketData,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_market_data_type import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsMarketDataType,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_market_links import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsMarketLinks,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_shipping_category import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingCategory,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_shipping_category_data import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingCategoryData,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_shipping_category_data_type import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingCategoryDataType,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_shipping_category_links import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingCategoryLinks,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_shipping_method_tiers import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingMethodTiers,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_shipping_method_tiers_data import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingMethodTiersData,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_shipping_method_tiers_data_type import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingMethodTiersDataType,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_shipping_method_tiers_links import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingMethodTiersLinks,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_shipping_weight_tiers import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingWeightTiers,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_shipping_weight_tiers_data import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingWeightTiersData,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_shipping_weight_tiers_data_type import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingWeightTiersDataType,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_shipping_weight_tiers_links import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingWeightTiersLinks,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_shipping_zone import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingZone,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_shipping_zone_data import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingZoneData,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_shipping_zone_data_type import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingZoneDataType,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_shipping_zone_links import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingZoneLinks,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_stock_location import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsStockLocation,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_stock_location_data import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsStockLocationData,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_stock_location_data_type import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsStockLocationDataType,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_relationships_stock_location_links import (
    PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsStockLocationLinks,
)
from .patc_hshipping_methodsshipping_method_id_response_200_data_type import (
    PATCHshippingMethodsshippingMethodIdResponse200DataType,
)
from .patc_hshipping_weight_tiersshipping_weight_tier_id_response_200 import (
    PATCHshippingWeightTiersshippingWeightTierIdResponse200,
)
from .patc_hshipping_weight_tiersshipping_weight_tier_id_response_200_data import (
    PATCHshippingWeightTiersshippingWeightTierIdResponse200Data,
)
from .patc_hshipping_weight_tiersshipping_weight_tier_id_response_200_data_attributes import (
    PATCHshippingWeightTiersshippingWeightTierIdResponse200DataAttributes,
)
from .patc_hshipping_weight_tiersshipping_weight_tier_id_response_200_data_attributes_metadata import (
    PATCHshippingWeightTiersshippingWeightTierIdResponse200DataAttributesMetadata,
)
from .patc_hshipping_weight_tiersshipping_weight_tier_id_response_200_data_links import (
    PATCHshippingWeightTiersshippingWeightTierIdResponse200DataLinks,
)
from .patc_hshipping_weight_tiersshipping_weight_tier_id_response_200_data_relationships import (
    PATCHshippingWeightTiersshippingWeightTierIdResponse200DataRelationships,
)
from .patc_hshipping_weight_tiersshipping_weight_tier_id_response_200_data_relationships_attachments import (
    PATCHshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsAttachments,
)
from .patc_hshipping_weight_tiersshipping_weight_tier_id_response_200_data_relationships_attachments_data import (
    PATCHshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hshipping_weight_tiersshipping_weight_tier_id_response_200_data_relationships_attachments_data_type import (
    PATCHshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hshipping_weight_tiersshipping_weight_tier_id_response_200_data_relationships_attachments_links import (
    PATCHshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hshipping_weight_tiersshipping_weight_tier_id_response_200_data_relationships_shipping_method import (
    PATCHshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsShippingMethod,
)
from .patc_hshipping_weight_tiersshipping_weight_tier_id_response_200_data_relationships_shipping_method_data import (
    PATCHshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsShippingMethodData,
)
from .patc_hshipping_weight_tiersshipping_weight_tier_id_response_200_data_relationships_shipping_method_data_type import (
    PATCHshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsShippingMethodDataType,
)
from .patc_hshipping_weight_tiersshipping_weight_tier_id_response_200_data_relationships_shipping_method_links import (
    PATCHshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsShippingMethodLinks,
)
from .patc_hshipping_weight_tiersshipping_weight_tier_id_response_200_data_type import (
    PATCHshippingWeightTiersshippingWeightTierIdResponse200DataType,
)
from .patc_hshipping_zonesshipping_zone_id_response_200 import PATCHshippingZonesshippingZoneIdResponse200
from .patc_hshipping_zonesshipping_zone_id_response_200_data import PATCHshippingZonesshippingZoneIdResponse200Data
from .patc_hshipping_zonesshipping_zone_id_response_200_data_attributes import (
    PATCHshippingZonesshippingZoneIdResponse200DataAttributes,
)
from .patc_hshipping_zonesshipping_zone_id_response_200_data_attributes_metadata import (
    PATCHshippingZonesshippingZoneIdResponse200DataAttributesMetadata,
)
from .patc_hshipping_zonesshipping_zone_id_response_200_data_links import (
    PATCHshippingZonesshippingZoneIdResponse200DataLinks,
)
from .patc_hshipping_zonesshipping_zone_id_response_200_data_relationships import (
    PATCHshippingZonesshippingZoneIdResponse200DataRelationships,
)
from .patc_hshipping_zonesshipping_zone_id_response_200_data_relationships_attachments import (
    PATCHshippingZonesshippingZoneIdResponse200DataRelationshipsAttachments,
)
from .patc_hshipping_zonesshipping_zone_id_response_200_data_relationships_attachments_data import (
    PATCHshippingZonesshippingZoneIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hshipping_zonesshipping_zone_id_response_200_data_relationships_attachments_data_type import (
    PATCHshippingZonesshippingZoneIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hshipping_zonesshipping_zone_id_response_200_data_relationships_attachments_links import (
    PATCHshippingZonesshippingZoneIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hshipping_zonesshipping_zone_id_response_200_data_type import (
    PATCHshippingZonesshippingZoneIdResponse200DataType,
)
from .patc_hsku_list_itemssku_list_item_id_response_200 import PATCHskuListItemsskuListItemIdResponse200
from .patc_hsku_list_itemssku_list_item_id_response_200_data import PATCHskuListItemsskuListItemIdResponse200Data
from .patc_hsku_list_itemssku_list_item_id_response_200_data_attributes import (
    PATCHskuListItemsskuListItemIdResponse200DataAttributes,
)
from .patc_hsku_list_itemssku_list_item_id_response_200_data_attributes_metadata import (
    PATCHskuListItemsskuListItemIdResponse200DataAttributesMetadata,
)
from .patc_hsku_list_itemssku_list_item_id_response_200_data_links import (
    PATCHskuListItemsskuListItemIdResponse200DataLinks,
)
from .patc_hsku_list_itemssku_list_item_id_response_200_data_relationships import (
    PATCHskuListItemsskuListItemIdResponse200DataRelationships,
)
from .patc_hsku_list_itemssku_list_item_id_response_200_data_relationships_sku import (
    PATCHskuListItemsskuListItemIdResponse200DataRelationshipsSku,
)
from .patc_hsku_list_itemssku_list_item_id_response_200_data_relationships_sku_data import (
    PATCHskuListItemsskuListItemIdResponse200DataRelationshipsSkuData,
)
from .patc_hsku_list_itemssku_list_item_id_response_200_data_relationships_sku_data_type import (
    PATCHskuListItemsskuListItemIdResponse200DataRelationshipsSkuDataType,
)
from .patc_hsku_list_itemssku_list_item_id_response_200_data_relationships_sku_links import (
    PATCHskuListItemsskuListItemIdResponse200DataRelationshipsSkuLinks,
)
from .patc_hsku_list_itemssku_list_item_id_response_200_data_relationships_sku_list import (
    PATCHskuListItemsskuListItemIdResponse200DataRelationshipsSkuList,
)
from .patc_hsku_list_itemssku_list_item_id_response_200_data_relationships_sku_list_data import (
    PATCHskuListItemsskuListItemIdResponse200DataRelationshipsSkuListData,
)
from .patc_hsku_list_itemssku_list_item_id_response_200_data_relationships_sku_list_data_type import (
    PATCHskuListItemsskuListItemIdResponse200DataRelationshipsSkuListDataType,
)
from .patc_hsku_list_itemssku_list_item_id_response_200_data_relationships_sku_list_links import (
    PATCHskuListItemsskuListItemIdResponse200DataRelationshipsSkuListLinks,
)
from .patc_hsku_list_itemssku_list_item_id_response_200_data_type import (
    PATCHskuListItemsskuListItemIdResponse200DataType,
)
from .patc_hsku_list_promotion_rulessku_list_promotion_rule_id_response_200 import (
    PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200,
)
from .patc_hsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data import (
    PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200Data,
)
from .patc_hsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_attributes import (
    PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataAttributes,
)
from .patc_hsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_attributes_metadata import (
    PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataAttributesMetadata,
)
from .patc_hsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_links import (
    PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataLinks,
)
from .patc_hsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_relationships import (
    PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationships,
)
from .patc_hsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_relationships_promotion import (
    PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsPromotion,
)
from .patc_hsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_relationships_promotion_data import (
    PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsPromotionData,
)
from .patc_hsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_relationships_promotion_data_type import (
    PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsPromotionDataType,
)
from .patc_hsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_relationships_promotion_links import (
    PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsPromotionLinks,
)
from .patc_hsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_relationships_sku_list import (
    PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkuList,
)
from .patc_hsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_relationships_sku_list_data import (
    PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkuListData,
)
from .patc_hsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_relationships_sku_list_data_type import (
    PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkuListDataType,
)
from .patc_hsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_relationships_sku_list_links import (
    PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkuListLinks,
)
from .patc_hsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_relationships_skus import (
    PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkus,
)
from .patc_hsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_relationships_skus_data import (
    PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkusData,
)
from .patc_hsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_relationships_skus_data_type import (
    PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkusDataType,
)
from .patc_hsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_relationships_skus_links import (
    PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkusLinks,
)
from .patc_hsku_list_promotion_rulessku_list_promotion_rule_id_response_200_data_type import (
    PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataType,
)
from .patc_hsku_listssku_list_id_response_200 import PATCHskuListsskuListIdResponse200
from .patc_hsku_listssku_list_id_response_200_data import PATCHskuListsskuListIdResponse200Data
from .patc_hsku_listssku_list_id_response_200_data_attributes import PATCHskuListsskuListIdResponse200DataAttributes
from .patc_hsku_listssku_list_id_response_200_data_attributes_metadata import (
    PATCHskuListsskuListIdResponse200DataAttributesMetadata,
)
from .patc_hsku_listssku_list_id_response_200_data_links import PATCHskuListsskuListIdResponse200DataLinks
from .patc_hsku_listssku_list_id_response_200_data_relationships import (
    PATCHskuListsskuListIdResponse200DataRelationships,
)
from .patc_hsku_listssku_list_id_response_200_data_relationships_attachments import (
    PATCHskuListsskuListIdResponse200DataRelationshipsAttachments,
)
from .patc_hsku_listssku_list_id_response_200_data_relationships_attachments_data import (
    PATCHskuListsskuListIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hsku_listssku_list_id_response_200_data_relationships_attachments_data_type import (
    PATCHskuListsskuListIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hsku_listssku_list_id_response_200_data_relationships_attachments_links import (
    PATCHskuListsskuListIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hsku_listssku_list_id_response_200_data_relationships_bundles import (
    PATCHskuListsskuListIdResponse200DataRelationshipsBundles,
)
from .patc_hsku_listssku_list_id_response_200_data_relationships_bundles_data import (
    PATCHskuListsskuListIdResponse200DataRelationshipsBundlesData,
)
from .patc_hsku_listssku_list_id_response_200_data_relationships_bundles_data_type import (
    PATCHskuListsskuListIdResponse200DataRelationshipsBundlesDataType,
)
from .patc_hsku_listssku_list_id_response_200_data_relationships_bundles_links import (
    PATCHskuListsskuListIdResponse200DataRelationshipsBundlesLinks,
)
from .patc_hsku_listssku_list_id_response_200_data_relationships_customer import (
    PATCHskuListsskuListIdResponse200DataRelationshipsCustomer,
)
from .patc_hsku_listssku_list_id_response_200_data_relationships_customer_data import (
    PATCHskuListsskuListIdResponse200DataRelationshipsCustomerData,
)
from .patc_hsku_listssku_list_id_response_200_data_relationships_customer_data_type import (
    PATCHskuListsskuListIdResponse200DataRelationshipsCustomerDataType,
)
from .patc_hsku_listssku_list_id_response_200_data_relationships_customer_links import (
    PATCHskuListsskuListIdResponse200DataRelationshipsCustomerLinks,
)
from .patc_hsku_listssku_list_id_response_200_data_relationships_sku_list_items import (
    PATCHskuListsskuListIdResponse200DataRelationshipsSkuListItems,
)
from .patc_hsku_listssku_list_id_response_200_data_relationships_sku_list_items_data import (
    PATCHskuListsskuListIdResponse200DataRelationshipsSkuListItemsData,
)
from .patc_hsku_listssku_list_id_response_200_data_relationships_sku_list_items_data_type import (
    PATCHskuListsskuListIdResponse200DataRelationshipsSkuListItemsDataType,
)
from .patc_hsku_listssku_list_id_response_200_data_relationships_sku_list_items_links import (
    PATCHskuListsskuListIdResponse200DataRelationshipsSkuListItemsLinks,
)
from .patc_hsku_listssku_list_id_response_200_data_relationships_skus import (
    PATCHskuListsskuListIdResponse200DataRelationshipsSkus,
)
from .patc_hsku_listssku_list_id_response_200_data_relationships_skus_data import (
    PATCHskuListsskuListIdResponse200DataRelationshipsSkusData,
)
from .patc_hsku_listssku_list_id_response_200_data_relationships_skus_data_type import (
    PATCHskuListsskuListIdResponse200DataRelationshipsSkusDataType,
)
from .patc_hsku_listssku_list_id_response_200_data_relationships_skus_links import (
    PATCHskuListsskuListIdResponse200DataRelationshipsSkusLinks,
)
from .patc_hsku_listssku_list_id_response_200_data_type import PATCHskuListsskuListIdResponse200DataType
from .patc_hsku_optionssku_option_id_response_200 import PATCHskuOptionsskuOptionIdResponse200
from .patc_hsku_optionssku_option_id_response_200_data import PATCHskuOptionsskuOptionIdResponse200Data
from .patc_hsku_optionssku_option_id_response_200_data_attributes import (
    PATCHskuOptionsskuOptionIdResponse200DataAttributes,
)
from .patc_hsku_optionssku_option_id_response_200_data_attributes_metadata import (
    PATCHskuOptionsskuOptionIdResponse200DataAttributesMetadata,
)
from .patc_hsku_optionssku_option_id_response_200_data_links import PATCHskuOptionsskuOptionIdResponse200DataLinks
from .patc_hsku_optionssku_option_id_response_200_data_relationships import (
    PATCHskuOptionsskuOptionIdResponse200DataRelationships,
)
from .patc_hsku_optionssku_option_id_response_200_data_relationships_attachments import (
    PATCHskuOptionsskuOptionIdResponse200DataRelationshipsAttachments,
)
from .patc_hsku_optionssku_option_id_response_200_data_relationships_attachments_data import (
    PATCHskuOptionsskuOptionIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hsku_optionssku_option_id_response_200_data_relationships_attachments_data_type import (
    PATCHskuOptionsskuOptionIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hsku_optionssku_option_id_response_200_data_relationships_attachments_links import (
    PATCHskuOptionsskuOptionIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hsku_optionssku_option_id_response_200_data_relationships_market import (
    PATCHskuOptionsskuOptionIdResponse200DataRelationshipsMarket,
)
from .patc_hsku_optionssku_option_id_response_200_data_relationships_market_data import (
    PATCHskuOptionsskuOptionIdResponse200DataRelationshipsMarketData,
)
from .patc_hsku_optionssku_option_id_response_200_data_relationships_market_data_type import (
    PATCHskuOptionsskuOptionIdResponse200DataRelationshipsMarketDataType,
)
from .patc_hsku_optionssku_option_id_response_200_data_relationships_market_links import (
    PATCHskuOptionsskuOptionIdResponse200DataRelationshipsMarketLinks,
)
from .patc_hsku_optionssku_option_id_response_200_data_type import PATCHskuOptionsskuOptionIdResponse200DataType
from .patc_hskussku_id_response_200 import PATCHskusskuIdResponse200
from .patc_hskussku_id_response_200_data import PATCHskusskuIdResponse200Data
from .patc_hskussku_id_response_200_data_attributes import PATCHskusskuIdResponse200DataAttributes
from .patc_hskussku_id_response_200_data_attributes_metadata import PATCHskusskuIdResponse200DataAttributesMetadata
from .patc_hskussku_id_response_200_data_links import PATCHskusskuIdResponse200DataLinks
from .patc_hskussku_id_response_200_data_relationships import PATCHskusskuIdResponse200DataRelationships
from .patc_hskussku_id_response_200_data_relationships_attachments import (
    PATCHskusskuIdResponse200DataRelationshipsAttachments,
)
from .patc_hskussku_id_response_200_data_relationships_attachments_data import (
    PATCHskusskuIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hskussku_id_response_200_data_relationships_attachments_data_type import (
    PATCHskusskuIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hskussku_id_response_200_data_relationships_attachments_links import (
    PATCHskusskuIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hskussku_id_response_200_data_relationships_delivery_lead_times import (
    PATCHskusskuIdResponse200DataRelationshipsDeliveryLeadTimes,
)
from .patc_hskussku_id_response_200_data_relationships_delivery_lead_times_data import (
    PATCHskusskuIdResponse200DataRelationshipsDeliveryLeadTimesData,
)
from .patc_hskussku_id_response_200_data_relationships_delivery_lead_times_data_type import (
    PATCHskusskuIdResponse200DataRelationshipsDeliveryLeadTimesDataType,
)
from .patc_hskussku_id_response_200_data_relationships_delivery_lead_times_links import (
    PATCHskusskuIdResponse200DataRelationshipsDeliveryLeadTimesLinks,
)
from .patc_hskussku_id_response_200_data_relationships_prices import PATCHskusskuIdResponse200DataRelationshipsPrices
from .patc_hskussku_id_response_200_data_relationships_prices_data import (
    PATCHskusskuIdResponse200DataRelationshipsPricesData,
)
from .patc_hskussku_id_response_200_data_relationships_prices_data_type import (
    PATCHskusskuIdResponse200DataRelationshipsPricesDataType,
)
from .patc_hskussku_id_response_200_data_relationships_prices_links import (
    PATCHskusskuIdResponse200DataRelationshipsPricesLinks,
)
from .patc_hskussku_id_response_200_data_relationships_shipping_category import (
    PATCHskusskuIdResponse200DataRelationshipsShippingCategory,
)
from .patc_hskussku_id_response_200_data_relationships_shipping_category_data import (
    PATCHskusskuIdResponse200DataRelationshipsShippingCategoryData,
)
from .patc_hskussku_id_response_200_data_relationships_shipping_category_data_type import (
    PATCHskusskuIdResponse200DataRelationshipsShippingCategoryDataType,
)
from .patc_hskussku_id_response_200_data_relationships_shipping_category_links import (
    PATCHskusskuIdResponse200DataRelationshipsShippingCategoryLinks,
)
from .patc_hskussku_id_response_200_data_relationships_sku_options import (
    PATCHskusskuIdResponse200DataRelationshipsSkuOptions,
)
from .patc_hskussku_id_response_200_data_relationships_sku_options_data import (
    PATCHskusskuIdResponse200DataRelationshipsSkuOptionsData,
)
from .patc_hskussku_id_response_200_data_relationships_sku_options_data_type import (
    PATCHskusskuIdResponse200DataRelationshipsSkuOptionsDataType,
)
from .patc_hskussku_id_response_200_data_relationships_sku_options_links import (
    PATCHskusskuIdResponse200DataRelationshipsSkuOptionsLinks,
)
from .patc_hskussku_id_response_200_data_relationships_stock_items import (
    PATCHskusskuIdResponse200DataRelationshipsStockItems,
)
from .patc_hskussku_id_response_200_data_relationships_stock_items_data import (
    PATCHskusskuIdResponse200DataRelationshipsStockItemsData,
)
from .patc_hskussku_id_response_200_data_relationships_stock_items_data_type import (
    PATCHskusskuIdResponse200DataRelationshipsStockItemsDataType,
)
from .patc_hskussku_id_response_200_data_relationships_stock_items_links import (
    PATCHskusskuIdResponse200DataRelationshipsStockItemsLinks,
)
from .patc_hskussku_id_response_200_data_type import PATCHskusskuIdResponse200DataType
from .patc_hstock_itemsstock_item_id_response_200 import PATCHstockItemsstockItemIdResponse200
from .patc_hstock_itemsstock_item_id_response_200_data import PATCHstockItemsstockItemIdResponse200Data
from .patc_hstock_itemsstock_item_id_response_200_data_attributes import (
    PATCHstockItemsstockItemIdResponse200DataAttributes,
)
from .patc_hstock_itemsstock_item_id_response_200_data_attributes_metadata import (
    PATCHstockItemsstockItemIdResponse200DataAttributesMetadata,
)
from .patc_hstock_itemsstock_item_id_response_200_data_links import PATCHstockItemsstockItemIdResponse200DataLinks
from .patc_hstock_itemsstock_item_id_response_200_data_relationships import (
    PATCHstockItemsstockItemIdResponse200DataRelationships,
)
from .patc_hstock_itemsstock_item_id_response_200_data_relationships_attachments import (
    PATCHstockItemsstockItemIdResponse200DataRelationshipsAttachments,
)
from .patc_hstock_itemsstock_item_id_response_200_data_relationships_attachments_data import (
    PATCHstockItemsstockItemIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hstock_itemsstock_item_id_response_200_data_relationships_attachments_data_type import (
    PATCHstockItemsstockItemIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hstock_itemsstock_item_id_response_200_data_relationships_attachments_links import (
    PATCHstockItemsstockItemIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hstock_itemsstock_item_id_response_200_data_relationships_sku import (
    PATCHstockItemsstockItemIdResponse200DataRelationshipsSku,
)
from .patc_hstock_itemsstock_item_id_response_200_data_relationships_sku_data import (
    PATCHstockItemsstockItemIdResponse200DataRelationshipsSkuData,
)
from .patc_hstock_itemsstock_item_id_response_200_data_relationships_sku_data_type import (
    PATCHstockItemsstockItemIdResponse200DataRelationshipsSkuDataType,
)
from .patc_hstock_itemsstock_item_id_response_200_data_relationships_sku_links import (
    PATCHstockItemsstockItemIdResponse200DataRelationshipsSkuLinks,
)
from .patc_hstock_itemsstock_item_id_response_200_data_relationships_stock_location import (
    PATCHstockItemsstockItemIdResponse200DataRelationshipsStockLocation,
)
from .patc_hstock_itemsstock_item_id_response_200_data_relationships_stock_location_data import (
    PATCHstockItemsstockItemIdResponse200DataRelationshipsStockLocationData,
)
from .patc_hstock_itemsstock_item_id_response_200_data_relationships_stock_location_data_type import (
    PATCHstockItemsstockItemIdResponse200DataRelationshipsStockLocationDataType,
)
from .patc_hstock_itemsstock_item_id_response_200_data_relationships_stock_location_links import (
    PATCHstockItemsstockItemIdResponse200DataRelationshipsStockLocationLinks,
)
from .patc_hstock_itemsstock_item_id_response_200_data_type import PATCHstockItemsstockItemIdResponse200DataType
from .patc_hstock_locationsstock_location_id_response_200 import PATCHstockLocationsstockLocationIdResponse200
from .patc_hstock_locationsstock_location_id_response_200_data import PATCHstockLocationsstockLocationIdResponse200Data
from .patc_hstock_locationsstock_location_id_response_200_data_attributes import (
    PATCHstockLocationsstockLocationIdResponse200DataAttributes,
)
from .patc_hstock_locationsstock_location_id_response_200_data_attributes_metadata import (
    PATCHstockLocationsstockLocationIdResponse200DataAttributesMetadata,
)
from .patc_hstock_locationsstock_location_id_response_200_data_links import (
    PATCHstockLocationsstockLocationIdResponse200DataLinks,
)
from .patc_hstock_locationsstock_location_id_response_200_data_relationships import (
    PATCHstockLocationsstockLocationIdResponse200DataRelationships,
)
from .patc_hstock_locationsstock_location_id_response_200_data_relationships_address import (
    PATCHstockLocationsstockLocationIdResponse200DataRelationshipsAddress,
)
from .patc_hstock_locationsstock_location_id_response_200_data_relationships_address_data import (
    PATCHstockLocationsstockLocationIdResponse200DataRelationshipsAddressData,
)
from .patc_hstock_locationsstock_location_id_response_200_data_relationships_address_data_type import (
    PATCHstockLocationsstockLocationIdResponse200DataRelationshipsAddressDataType,
)
from .patc_hstock_locationsstock_location_id_response_200_data_relationships_address_links import (
    PATCHstockLocationsstockLocationIdResponse200DataRelationshipsAddressLinks,
)
from .patc_hstock_locationsstock_location_id_response_200_data_relationships_attachments import (
    PATCHstockLocationsstockLocationIdResponse200DataRelationshipsAttachments,
)
from .patc_hstock_locationsstock_location_id_response_200_data_relationships_attachments_data import (
    PATCHstockLocationsstockLocationIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_hstock_locationsstock_location_id_response_200_data_relationships_attachments_data_type import (
    PATCHstockLocationsstockLocationIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_hstock_locationsstock_location_id_response_200_data_relationships_attachments_links import (
    PATCHstockLocationsstockLocationIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_hstock_locationsstock_location_id_response_200_data_relationships_inventory_return_locations import (
    PATCHstockLocationsstockLocationIdResponse200DataRelationshipsInventoryReturnLocations,
)
from .patc_hstock_locationsstock_location_id_response_200_data_relationships_inventory_return_locations_data import (
    PATCHstockLocationsstockLocationIdResponse200DataRelationshipsInventoryReturnLocationsData,
)
from .patc_hstock_locationsstock_location_id_response_200_data_relationships_inventory_return_locations_data_type import (
    PATCHstockLocationsstockLocationIdResponse200DataRelationshipsInventoryReturnLocationsDataType,
)
from .patc_hstock_locationsstock_location_id_response_200_data_relationships_inventory_return_locations_links import (
    PATCHstockLocationsstockLocationIdResponse200DataRelationshipsInventoryReturnLocationsLinks,
)
from .patc_hstock_locationsstock_location_id_response_200_data_relationships_inventory_stock_locations import (
    PATCHstockLocationsstockLocationIdResponse200DataRelationshipsInventoryStockLocations,
)
from .patc_hstock_locationsstock_location_id_response_200_data_relationships_inventory_stock_locations_data import (
    PATCHstockLocationsstockLocationIdResponse200DataRelationshipsInventoryStockLocationsData,
)
from .patc_hstock_locationsstock_location_id_response_200_data_relationships_inventory_stock_locations_data_type import (
    PATCHstockLocationsstockLocationIdResponse200DataRelationshipsInventoryStockLocationsDataType,
)
from .patc_hstock_locationsstock_location_id_response_200_data_relationships_inventory_stock_locations_links import (
    PATCHstockLocationsstockLocationIdResponse200DataRelationshipsInventoryStockLocationsLinks,
)
from .patc_hstock_locationsstock_location_id_response_200_data_relationships_stock_items import (
    PATCHstockLocationsstockLocationIdResponse200DataRelationshipsStockItems,
)
from .patc_hstock_locationsstock_location_id_response_200_data_relationships_stock_items_data import (
    PATCHstockLocationsstockLocationIdResponse200DataRelationshipsStockItemsData,
)
from .patc_hstock_locationsstock_location_id_response_200_data_relationships_stock_items_data_type import (
    PATCHstockLocationsstockLocationIdResponse200DataRelationshipsStockItemsDataType,
)
from .patc_hstock_locationsstock_location_id_response_200_data_relationships_stock_items_links import (
    PATCHstockLocationsstockLocationIdResponse200DataRelationshipsStockItemsLinks,
)
from .patc_hstock_locationsstock_location_id_response_200_data_relationships_stock_transfers import (
    PATCHstockLocationsstockLocationIdResponse200DataRelationshipsStockTransfers,
)
from .patc_hstock_locationsstock_location_id_response_200_data_relationships_stock_transfers_data import (
    PATCHstockLocationsstockLocationIdResponse200DataRelationshipsStockTransfersData,
)
from .patc_hstock_locationsstock_location_id_response_200_data_relationships_stock_transfers_data_type import (
    PATCHstockLocationsstockLocationIdResponse200DataRelationshipsStockTransfersDataType,
)
from .patc_hstock_locationsstock_location_id_response_200_data_relationships_stock_transfers_links import (
    PATCHstockLocationsstockLocationIdResponse200DataRelationshipsStockTransfersLinks,
)
from .patc_hstock_locationsstock_location_id_response_200_data_type import (
    PATCHstockLocationsstockLocationIdResponse200DataType,
)
from .patc_hstock_transfersstock_transfer_id_response_200 import PATCHstockTransfersstockTransferIdResponse200
from .patc_hstock_transfersstock_transfer_id_response_200_data import PATCHstockTransfersstockTransferIdResponse200Data
from .patc_hstock_transfersstock_transfer_id_response_200_data_attributes import (
    PATCHstockTransfersstockTransferIdResponse200DataAttributes,
)
from .patc_hstock_transfersstock_transfer_id_response_200_data_attributes_metadata import (
    PATCHstockTransfersstockTransferIdResponse200DataAttributesMetadata,
)
from .patc_hstock_transfersstock_transfer_id_response_200_data_links import (
    PATCHstockTransfersstockTransferIdResponse200DataLinks,
)
from .patc_hstock_transfersstock_transfer_id_response_200_data_relationships import (
    PATCHstockTransfersstockTransferIdResponse200DataRelationships,
)
from .patc_hstock_transfersstock_transfer_id_response_200_data_relationships_destination_stock_location import (
    PATCHstockTransfersstockTransferIdResponse200DataRelationshipsDestinationStockLocation,
)
from .patc_hstock_transfersstock_transfer_id_response_200_data_relationships_destination_stock_location_data import (
    PATCHstockTransfersstockTransferIdResponse200DataRelationshipsDestinationStockLocationData,
)
from .patc_hstock_transfersstock_transfer_id_response_200_data_relationships_destination_stock_location_data_type import (
    PATCHstockTransfersstockTransferIdResponse200DataRelationshipsDestinationStockLocationDataType,
)
from .patc_hstock_transfersstock_transfer_id_response_200_data_relationships_destination_stock_location_links import (
    PATCHstockTransfersstockTransferIdResponse200DataRelationshipsDestinationStockLocationLinks,
)
from .patc_hstock_transfersstock_transfer_id_response_200_data_relationships_events import (
    PATCHstockTransfersstockTransferIdResponse200DataRelationshipsEvents,
)
from .patc_hstock_transfersstock_transfer_id_response_200_data_relationships_events_data import (
    PATCHstockTransfersstockTransferIdResponse200DataRelationshipsEventsData,
)
from .patc_hstock_transfersstock_transfer_id_response_200_data_relationships_events_data_type import (
    PATCHstockTransfersstockTransferIdResponse200DataRelationshipsEventsDataType,
)
from .patc_hstock_transfersstock_transfer_id_response_200_data_relationships_events_links import (
    PATCHstockTransfersstockTransferIdResponse200DataRelationshipsEventsLinks,
)
from .patc_hstock_transfersstock_transfer_id_response_200_data_relationships_line_item import (
    PATCHstockTransfersstockTransferIdResponse200DataRelationshipsLineItem,
)
from .patc_hstock_transfersstock_transfer_id_response_200_data_relationships_line_item_data import (
    PATCHstockTransfersstockTransferIdResponse200DataRelationshipsLineItemData,
)
from .patc_hstock_transfersstock_transfer_id_response_200_data_relationships_line_item_data_type import (
    PATCHstockTransfersstockTransferIdResponse200DataRelationshipsLineItemDataType,
)
from .patc_hstock_transfersstock_transfer_id_response_200_data_relationships_line_item_links import (
    PATCHstockTransfersstockTransferIdResponse200DataRelationshipsLineItemLinks,
)
from .patc_hstock_transfersstock_transfer_id_response_200_data_relationships_origin_stock_location import (
    PATCHstockTransfersstockTransferIdResponse200DataRelationshipsOriginStockLocation,
)
from .patc_hstock_transfersstock_transfer_id_response_200_data_relationships_origin_stock_location_data import (
    PATCHstockTransfersstockTransferIdResponse200DataRelationshipsOriginStockLocationData,
)
from .patc_hstock_transfersstock_transfer_id_response_200_data_relationships_origin_stock_location_data_type import (
    PATCHstockTransfersstockTransferIdResponse200DataRelationshipsOriginStockLocationDataType,
)
from .patc_hstock_transfersstock_transfer_id_response_200_data_relationships_origin_stock_location_links import (
    PATCHstockTransfersstockTransferIdResponse200DataRelationshipsOriginStockLocationLinks,
)
from .patc_hstock_transfersstock_transfer_id_response_200_data_relationships_shipment import (
    PATCHstockTransfersstockTransferIdResponse200DataRelationshipsShipment,
)
from .patc_hstock_transfersstock_transfer_id_response_200_data_relationships_shipment_data import (
    PATCHstockTransfersstockTransferIdResponse200DataRelationshipsShipmentData,
)
from .patc_hstock_transfersstock_transfer_id_response_200_data_relationships_shipment_data_type import (
    PATCHstockTransfersstockTransferIdResponse200DataRelationshipsShipmentDataType,
)
from .patc_hstock_transfersstock_transfer_id_response_200_data_relationships_shipment_links import (
    PATCHstockTransfersstockTransferIdResponse200DataRelationshipsShipmentLinks,
)
from .patc_hstock_transfersstock_transfer_id_response_200_data_relationships_sku import (
    PATCHstockTransfersstockTransferIdResponse200DataRelationshipsSku,
)
from .patc_hstock_transfersstock_transfer_id_response_200_data_relationships_sku_data import (
    PATCHstockTransfersstockTransferIdResponse200DataRelationshipsSkuData,
)
from .patc_hstock_transfersstock_transfer_id_response_200_data_relationships_sku_data_type import (
    PATCHstockTransfersstockTransferIdResponse200DataRelationshipsSkuDataType,
)
from .patc_hstock_transfersstock_transfer_id_response_200_data_relationships_sku_links import (
    PATCHstockTransfersstockTransferIdResponse200DataRelationshipsSkuLinks,
)
from .patc_hstock_transfersstock_transfer_id_response_200_data_type import (
    PATCHstockTransfersstockTransferIdResponse200DataType,
)
from .patc_hstripe_gatewaysstripe_gateway_id_response_200 import PATCHstripeGatewaysstripeGatewayIdResponse200
from .patc_hstripe_gatewaysstripe_gateway_id_response_200_data import PATCHstripeGatewaysstripeGatewayIdResponse200Data
from .patc_hstripe_gatewaysstripe_gateway_id_response_200_data_attributes import (
    PATCHstripeGatewaysstripeGatewayIdResponse200DataAttributes,
)
from .patc_hstripe_gatewaysstripe_gateway_id_response_200_data_attributes_metadata import (
    PATCHstripeGatewaysstripeGatewayIdResponse200DataAttributesMetadata,
)
from .patc_hstripe_gatewaysstripe_gateway_id_response_200_data_links import (
    PATCHstripeGatewaysstripeGatewayIdResponse200DataLinks,
)
from .patc_hstripe_gatewaysstripe_gateway_id_response_200_data_relationships import (
    PATCHstripeGatewaysstripeGatewayIdResponse200DataRelationships,
)
from .patc_hstripe_gatewaysstripe_gateway_id_response_200_data_relationships_payment_methods import (
    PATCHstripeGatewaysstripeGatewayIdResponse200DataRelationshipsPaymentMethods,
)
from .patc_hstripe_gatewaysstripe_gateway_id_response_200_data_relationships_payment_methods_data import (
    PATCHstripeGatewaysstripeGatewayIdResponse200DataRelationshipsPaymentMethodsData,
)
from .patc_hstripe_gatewaysstripe_gateway_id_response_200_data_relationships_payment_methods_data_type import (
    PATCHstripeGatewaysstripeGatewayIdResponse200DataRelationshipsPaymentMethodsDataType,
)
from .patc_hstripe_gatewaysstripe_gateway_id_response_200_data_relationships_payment_methods_links import (
    PATCHstripeGatewaysstripeGatewayIdResponse200DataRelationshipsPaymentMethodsLinks,
)
from .patc_hstripe_gatewaysstripe_gateway_id_response_200_data_relationships_stripe_payments import (
    PATCHstripeGatewaysstripeGatewayIdResponse200DataRelationshipsStripePayments,
)
from .patc_hstripe_gatewaysstripe_gateway_id_response_200_data_relationships_stripe_payments_data import (
    PATCHstripeGatewaysstripeGatewayIdResponse200DataRelationshipsStripePaymentsData,
)
from .patc_hstripe_gatewaysstripe_gateway_id_response_200_data_relationships_stripe_payments_data_type import (
    PATCHstripeGatewaysstripeGatewayIdResponse200DataRelationshipsStripePaymentsDataType,
)
from .patc_hstripe_gatewaysstripe_gateway_id_response_200_data_relationships_stripe_payments_links import (
    PATCHstripeGatewaysstripeGatewayIdResponse200DataRelationshipsStripePaymentsLinks,
)
from .patc_hstripe_gatewaysstripe_gateway_id_response_200_data_type import (
    PATCHstripeGatewaysstripeGatewayIdResponse200DataType,
)
from .patc_hstripe_paymentsstripe_payment_id_response_200 import PATCHstripePaymentsstripePaymentIdResponse200
from .patc_hstripe_paymentsstripe_payment_id_response_200_data import PATCHstripePaymentsstripePaymentIdResponse200Data
from .patc_hstripe_paymentsstripe_payment_id_response_200_data_attributes import (
    PATCHstripePaymentsstripePaymentIdResponse200DataAttributes,
)
from .patc_hstripe_paymentsstripe_payment_id_response_200_data_attributes_metadata import (
    PATCHstripePaymentsstripePaymentIdResponse200DataAttributesMetadata,
)
from .patc_hstripe_paymentsstripe_payment_id_response_200_data_attributes_options import (
    PATCHstripePaymentsstripePaymentIdResponse200DataAttributesOptions,
)
from .patc_hstripe_paymentsstripe_payment_id_response_200_data_links import (
    PATCHstripePaymentsstripePaymentIdResponse200DataLinks,
)
from .patc_hstripe_paymentsstripe_payment_id_response_200_data_relationships import (
    PATCHstripePaymentsstripePaymentIdResponse200DataRelationships,
)
from .patc_hstripe_paymentsstripe_payment_id_response_200_data_relationships_order import (
    PATCHstripePaymentsstripePaymentIdResponse200DataRelationshipsOrder,
)
from .patc_hstripe_paymentsstripe_payment_id_response_200_data_relationships_order_data import (
    PATCHstripePaymentsstripePaymentIdResponse200DataRelationshipsOrderData,
)
from .patc_hstripe_paymentsstripe_payment_id_response_200_data_relationships_order_data_type import (
    PATCHstripePaymentsstripePaymentIdResponse200DataRelationshipsOrderDataType,
)
from .patc_hstripe_paymentsstripe_payment_id_response_200_data_relationships_order_links import (
    PATCHstripePaymentsstripePaymentIdResponse200DataRelationshipsOrderLinks,
)
from .patc_hstripe_paymentsstripe_payment_id_response_200_data_relationships_payment_gateway import (
    PATCHstripePaymentsstripePaymentIdResponse200DataRelationshipsPaymentGateway,
)
from .patc_hstripe_paymentsstripe_payment_id_response_200_data_relationships_payment_gateway_data import (
    PATCHstripePaymentsstripePaymentIdResponse200DataRelationshipsPaymentGatewayData,
)
from .patc_hstripe_paymentsstripe_payment_id_response_200_data_relationships_payment_gateway_data_type import (
    PATCHstripePaymentsstripePaymentIdResponse200DataRelationshipsPaymentGatewayDataType,
)
from .patc_hstripe_paymentsstripe_payment_id_response_200_data_relationships_payment_gateway_links import (
    PATCHstripePaymentsstripePaymentIdResponse200DataRelationshipsPaymentGatewayLinks,
)
from .patc_hstripe_paymentsstripe_payment_id_response_200_data_type import (
    PATCHstripePaymentsstripePaymentIdResponse200DataType,
)
from .patc_htax_categoriestax_category_id_response_200 import PATCHtaxCategoriestaxCategoryIdResponse200
from .patc_htax_categoriestax_category_id_response_200_data import PATCHtaxCategoriestaxCategoryIdResponse200Data
from .patc_htax_categoriestax_category_id_response_200_data_attributes import (
    PATCHtaxCategoriestaxCategoryIdResponse200DataAttributes,
)
from .patc_htax_categoriestax_category_id_response_200_data_attributes_metadata import (
    PATCHtaxCategoriestaxCategoryIdResponse200DataAttributesMetadata,
)
from .patc_htax_categoriestax_category_id_response_200_data_links import (
    PATCHtaxCategoriestaxCategoryIdResponse200DataLinks,
)
from .patc_htax_categoriestax_category_id_response_200_data_relationships import (
    PATCHtaxCategoriestaxCategoryIdResponse200DataRelationships,
)
from .patc_htax_categoriestax_category_id_response_200_data_relationships_attachments import (
    PATCHtaxCategoriestaxCategoryIdResponse200DataRelationshipsAttachments,
)
from .patc_htax_categoriestax_category_id_response_200_data_relationships_attachments_data import (
    PATCHtaxCategoriestaxCategoryIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_htax_categoriestax_category_id_response_200_data_relationships_attachments_data_type import (
    PATCHtaxCategoriestaxCategoryIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_htax_categoriestax_category_id_response_200_data_relationships_attachments_links import (
    PATCHtaxCategoriestaxCategoryIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_htax_categoriestax_category_id_response_200_data_relationships_sku import (
    PATCHtaxCategoriestaxCategoryIdResponse200DataRelationshipsSku,
)
from .patc_htax_categoriestax_category_id_response_200_data_relationships_sku_data import (
    PATCHtaxCategoriestaxCategoryIdResponse200DataRelationshipsSkuData,
)
from .patc_htax_categoriestax_category_id_response_200_data_relationships_sku_data_type import (
    PATCHtaxCategoriestaxCategoryIdResponse200DataRelationshipsSkuDataType,
)
from .patc_htax_categoriestax_category_id_response_200_data_relationships_sku_links import (
    PATCHtaxCategoriestaxCategoryIdResponse200DataRelationshipsSkuLinks,
)
from .patc_htax_categoriestax_category_id_response_200_data_relationships_tax_calculator import (
    PATCHtaxCategoriestaxCategoryIdResponse200DataRelationshipsTaxCalculator,
)
from .patc_htax_categoriestax_category_id_response_200_data_relationships_tax_calculator_data import (
    PATCHtaxCategoriestaxCategoryIdResponse200DataRelationshipsTaxCalculatorData,
)
from .patc_htax_categoriestax_category_id_response_200_data_relationships_tax_calculator_data_type import (
    PATCHtaxCategoriestaxCategoryIdResponse200DataRelationshipsTaxCalculatorDataType,
)
from .patc_htax_categoriestax_category_id_response_200_data_relationships_tax_calculator_links import (
    PATCHtaxCategoriestaxCategoryIdResponse200DataRelationshipsTaxCalculatorLinks,
)
from .patc_htax_categoriestax_category_id_response_200_data_type import (
    PATCHtaxCategoriestaxCategoryIdResponse200DataType,
)
from .patc_htax_rulestax_rule_id_response_200 import PATCHtaxRulestaxRuleIdResponse200
from .patc_htax_rulestax_rule_id_response_200_data import PATCHtaxRulestaxRuleIdResponse200Data
from .patc_htax_rulestax_rule_id_response_200_data_attributes import PATCHtaxRulestaxRuleIdResponse200DataAttributes
from .patc_htax_rulestax_rule_id_response_200_data_attributes_metadata import (
    PATCHtaxRulestaxRuleIdResponse200DataAttributesMetadata,
)
from .patc_htax_rulestax_rule_id_response_200_data_links import PATCHtaxRulestaxRuleIdResponse200DataLinks
from .patc_htax_rulestax_rule_id_response_200_data_relationships import (
    PATCHtaxRulestaxRuleIdResponse200DataRelationships,
)
from .patc_htax_rulestax_rule_id_response_200_data_relationships_manual_tax_calculator import (
    PATCHtaxRulestaxRuleIdResponse200DataRelationshipsManualTaxCalculator,
)
from .patc_htax_rulestax_rule_id_response_200_data_relationships_manual_tax_calculator_data import (
    PATCHtaxRulestaxRuleIdResponse200DataRelationshipsManualTaxCalculatorData,
)
from .patc_htax_rulestax_rule_id_response_200_data_relationships_manual_tax_calculator_data_type import (
    PATCHtaxRulestaxRuleIdResponse200DataRelationshipsManualTaxCalculatorDataType,
)
from .patc_htax_rulestax_rule_id_response_200_data_relationships_manual_tax_calculator_links import (
    PATCHtaxRulestaxRuleIdResponse200DataRelationshipsManualTaxCalculatorLinks,
)
from .patc_htax_rulestax_rule_id_response_200_data_type import PATCHtaxRulestaxRuleIdResponse200DataType
from .patc_htaxjar_accountstaxjar_account_id_response_200 import PATCHtaxjarAccountstaxjarAccountIdResponse200
from .patc_htaxjar_accountstaxjar_account_id_response_200_data import PATCHtaxjarAccountstaxjarAccountIdResponse200Data
from .patc_htaxjar_accountstaxjar_account_id_response_200_data_attributes import (
    PATCHtaxjarAccountstaxjarAccountIdResponse200DataAttributes,
)
from .patc_htaxjar_accountstaxjar_account_id_response_200_data_attributes_metadata import (
    PATCHtaxjarAccountstaxjarAccountIdResponse200DataAttributesMetadata,
)
from .patc_htaxjar_accountstaxjar_account_id_response_200_data_links import (
    PATCHtaxjarAccountstaxjarAccountIdResponse200DataLinks,
)
from .patc_htaxjar_accountstaxjar_account_id_response_200_data_relationships import (
    PATCHtaxjarAccountstaxjarAccountIdResponse200DataRelationships,
)
from .patc_htaxjar_accountstaxjar_account_id_response_200_data_relationships_attachments import (
    PATCHtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsAttachments,
)
from .patc_htaxjar_accountstaxjar_account_id_response_200_data_relationships_attachments_data import (
    PATCHtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsAttachmentsData,
)
from .patc_htaxjar_accountstaxjar_account_id_response_200_data_relationships_attachments_data_type import (
    PATCHtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsAttachmentsDataType,
)
from .patc_htaxjar_accountstaxjar_account_id_response_200_data_relationships_attachments_links import (
    PATCHtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsAttachmentsLinks,
)
from .patc_htaxjar_accountstaxjar_account_id_response_200_data_relationships_markets import (
    PATCHtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsMarkets,
)
from .patc_htaxjar_accountstaxjar_account_id_response_200_data_relationships_markets_data import (
    PATCHtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsMarketsData,
)
from .patc_htaxjar_accountstaxjar_account_id_response_200_data_relationships_markets_data_type import (
    PATCHtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsMarketsDataType,
)
from .patc_htaxjar_accountstaxjar_account_id_response_200_data_relationships_markets_links import (
    PATCHtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsMarketsLinks,
)
from .patc_htaxjar_accountstaxjar_account_id_response_200_data_relationships_tax_categories import (
    PATCHtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsTaxCategories,
)
from .patc_htaxjar_accountstaxjar_account_id_response_200_data_relationships_tax_categories_data import (
    PATCHtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsTaxCategoriesData,
)
from .patc_htaxjar_accountstaxjar_account_id_response_200_data_relationships_tax_categories_data_type import (
    PATCHtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsTaxCategoriesDataType,
)
from .patc_htaxjar_accountstaxjar_account_id_response_200_data_relationships_tax_categories_links import (
    PATCHtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsTaxCategoriesLinks,
)
from .patc_htaxjar_accountstaxjar_account_id_response_200_data_type import (
    PATCHtaxjarAccountstaxjarAccountIdResponse200DataType,
)
from .patc_hwebhookswebhook_id_response_200 import PATCHwebhookswebhookIdResponse200
from .patc_hwebhookswebhook_id_response_200_data import PATCHwebhookswebhookIdResponse200Data
from .patc_hwebhookswebhook_id_response_200_data_attributes import PATCHwebhookswebhookIdResponse200DataAttributes
from .patc_hwebhookswebhook_id_response_200_data_attributes_metadata import (
    PATCHwebhookswebhookIdResponse200DataAttributesMetadata,
)
from .patc_hwebhookswebhook_id_response_200_data_links import PATCHwebhookswebhookIdResponse200DataLinks
from .patc_hwebhookswebhook_id_response_200_data_relationships import PATCHwebhookswebhookIdResponse200DataRelationships
from .patc_hwebhookswebhook_id_response_200_data_relationships_last_event_callbacks import (
    PATCHwebhookswebhookIdResponse200DataRelationshipsLastEventCallbacks,
)
from .patc_hwebhookswebhook_id_response_200_data_relationships_last_event_callbacks_data import (
    PATCHwebhookswebhookIdResponse200DataRelationshipsLastEventCallbacksData,
)
from .patc_hwebhookswebhook_id_response_200_data_relationships_last_event_callbacks_data_type import (
    PATCHwebhookswebhookIdResponse200DataRelationshipsLastEventCallbacksDataType,
)
from .patc_hwebhookswebhook_id_response_200_data_relationships_last_event_callbacks_links import (
    PATCHwebhookswebhookIdResponse200DataRelationshipsLastEventCallbacksLinks,
)
from .patc_hwebhookswebhook_id_response_200_data_type import PATCHwebhookswebhookIdResponse200DataType
from .patc_hwire_transferswire_transfer_id_response_200 import PATCHwireTransferswireTransferIdResponse200
from .patc_hwire_transferswire_transfer_id_response_200_data import PATCHwireTransferswireTransferIdResponse200Data
from .patc_hwire_transferswire_transfer_id_response_200_data_attributes import (
    PATCHwireTransferswireTransferIdResponse200DataAttributes,
)
from .patc_hwire_transferswire_transfer_id_response_200_data_attributes_metadata import (
    PATCHwireTransferswireTransferIdResponse200DataAttributesMetadata,
)
from .patc_hwire_transferswire_transfer_id_response_200_data_links import (
    PATCHwireTransferswireTransferIdResponse200DataLinks,
)
from .patc_hwire_transferswire_transfer_id_response_200_data_relationships import (
    PATCHwireTransferswireTransferIdResponse200DataRelationships,
)
from .patc_hwire_transferswire_transfer_id_response_200_data_relationships_order import (
    PATCHwireTransferswireTransferIdResponse200DataRelationshipsOrder,
)
from .patc_hwire_transferswire_transfer_id_response_200_data_relationships_order_data import (
    PATCHwireTransferswireTransferIdResponse200DataRelationshipsOrderData,
)
from .patc_hwire_transferswire_transfer_id_response_200_data_relationships_order_data_type import (
    PATCHwireTransferswireTransferIdResponse200DataRelationshipsOrderDataType,
)
from .patc_hwire_transferswire_transfer_id_response_200_data_relationships_order_links import (
    PATCHwireTransferswireTransferIdResponse200DataRelationshipsOrderLinks,
)
from .patc_hwire_transferswire_transfer_id_response_200_data_type import (
    PATCHwireTransferswireTransferIdResponse200DataType,
)
from .payment_gateway import PaymentGateway
from .payment_gateway_data import PaymentGatewayData
from .payment_gateway_data_attributes import PaymentGatewayDataAttributes
from .payment_gateway_data_attributes_metadata import PaymentGatewayDataAttributesMetadata
from .payment_gateway_data_relationships import PaymentGatewayDataRelationships
from .payment_gateway_data_relationships_payment_methods import PaymentGatewayDataRelationshipsPaymentMethods
from .payment_gateway_data_relationships_payment_methods_data import PaymentGatewayDataRelationshipsPaymentMethodsData
from .payment_gateway_data_relationships_payment_methods_data_type import (
    PaymentGatewayDataRelationshipsPaymentMethodsDataType,
)
from .payment_gateway_data_type import PaymentGatewayDataType
from .payment_method import PaymentMethod
from .payment_method_create import PaymentMethodCreate
from .payment_method_create_data import PaymentMethodCreateData
from .payment_method_create_data_attributes import PaymentMethodCreateDataAttributes
from .payment_method_create_data_attributes_metadata import PaymentMethodCreateDataAttributesMetadata
from .payment_method_create_data_relationships import PaymentMethodCreateDataRelationships
from .payment_method_create_data_relationships_market import PaymentMethodCreateDataRelationshipsMarket
from .payment_method_create_data_relationships_market_data import PaymentMethodCreateDataRelationshipsMarketData
from .payment_method_create_data_relationships_market_data_type import (
    PaymentMethodCreateDataRelationshipsMarketDataType,
)
from .payment_method_create_data_relationships_payment_gateway import PaymentMethodCreateDataRelationshipsPaymentGateway
from .payment_method_create_data_relationships_payment_gateway_data import (
    PaymentMethodCreateDataRelationshipsPaymentGatewayData,
)
from .payment_method_create_data_relationships_payment_gateway_data_type import (
    PaymentMethodCreateDataRelationshipsPaymentGatewayDataType,
)
from .payment_method_create_data_type import PaymentMethodCreateDataType
from .payment_method_data import PaymentMethodData
from .payment_method_data_attributes import PaymentMethodDataAttributes
from .payment_method_data_attributes_metadata import PaymentMethodDataAttributesMetadata
from .payment_method_data_relationships import PaymentMethodDataRelationships
from .payment_method_data_relationships_attachments import PaymentMethodDataRelationshipsAttachments
from .payment_method_data_relationships_attachments_data import PaymentMethodDataRelationshipsAttachmentsData
from .payment_method_data_relationships_attachments_data_type import PaymentMethodDataRelationshipsAttachmentsDataType
from .payment_method_data_relationships_market import PaymentMethodDataRelationshipsMarket
from .payment_method_data_relationships_market_data import PaymentMethodDataRelationshipsMarketData
from .payment_method_data_relationships_market_data_type import PaymentMethodDataRelationshipsMarketDataType
from .payment_method_data_relationships_payment_gateway import PaymentMethodDataRelationshipsPaymentGateway
from .payment_method_data_relationships_payment_gateway_data import PaymentMethodDataRelationshipsPaymentGatewayData
from .payment_method_data_relationships_payment_gateway_data_type import (
    PaymentMethodDataRelationshipsPaymentGatewayDataType,
)
from .payment_method_data_type import PaymentMethodDataType
from .payment_method_update import PaymentMethodUpdate
from .payment_method_update_data import PaymentMethodUpdateData
from .payment_method_update_data_attributes import PaymentMethodUpdateDataAttributes
from .payment_method_update_data_attributes_metadata import PaymentMethodUpdateDataAttributesMetadata
from .payment_method_update_data_relationships import PaymentMethodUpdateDataRelationships
from .payment_method_update_data_relationships_market import PaymentMethodUpdateDataRelationshipsMarket
from .payment_method_update_data_relationships_market_data import PaymentMethodUpdateDataRelationshipsMarketData
from .payment_method_update_data_relationships_market_data_type import (
    PaymentMethodUpdateDataRelationshipsMarketDataType,
)
from .payment_method_update_data_relationships_payment_gateway import PaymentMethodUpdateDataRelationshipsPaymentGateway
from .payment_method_update_data_relationships_payment_gateway_data import (
    PaymentMethodUpdateDataRelationshipsPaymentGatewayData,
)
from .payment_method_update_data_relationships_payment_gateway_data_type import (
    PaymentMethodUpdateDataRelationshipsPaymentGatewayDataType,
)
from .payment_method_update_data_type import PaymentMethodUpdateDataType
from .paypal_gateway import PaypalGateway
from .paypal_gateway_create import PaypalGatewayCreate
from .paypal_gateway_create_data import PaypalGatewayCreateData
from .paypal_gateway_create_data_attributes import PaypalGatewayCreateDataAttributes
from .paypal_gateway_create_data_attributes_metadata import PaypalGatewayCreateDataAttributesMetadata
from .paypal_gateway_create_data_relationships import PaypalGatewayCreateDataRelationships
from .paypal_gateway_create_data_type import PaypalGatewayCreateDataType
from .paypal_gateway_data import PaypalGatewayData
from .paypal_gateway_data_attributes import PaypalGatewayDataAttributes
from .paypal_gateway_data_attributes_metadata import PaypalGatewayDataAttributesMetadata
from .paypal_gateway_data_relationships import PaypalGatewayDataRelationships
from .paypal_gateway_data_relationships_payment_methods import PaypalGatewayDataRelationshipsPaymentMethods
from .paypal_gateway_data_relationships_payment_methods_data import PaypalGatewayDataRelationshipsPaymentMethodsData
from .paypal_gateway_data_relationships_payment_methods_data_type import (
    PaypalGatewayDataRelationshipsPaymentMethodsDataType,
)
from .paypal_gateway_data_relationships_paypal_payments import PaypalGatewayDataRelationshipsPaypalPayments
from .paypal_gateway_data_relationships_paypal_payments_data import PaypalGatewayDataRelationshipsPaypalPaymentsData
from .paypal_gateway_data_relationships_paypal_payments_data_type import (
    PaypalGatewayDataRelationshipsPaypalPaymentsDataType,
)
from .paypal_gateway_data_type import PaypalGatewayDataType
from .paypal_gateway_update import PaypalGatewayUpdate
from .paypal_gateway_update_data import PaypalGatewayUpdateData
from .paypal_gateway_update_data_attributes import PaypalGatewayUpdateDataAttributes
from .paypal_gateway_update_data_attributes_metadata import PaypalGatewayUpdateDataAttributesMetadata
from .paypal_gateway_update_data_relationships import PaypalGatewayUpdateDataRelationships
from .paypal_gateway_update_data_type import PaypalGatewayUpdateDataType
from .paypal_payment import PaypalPayment
from .paypal_payment_create import PaypalPaymentCreate
from .paypal_payment_create_data import PaypalPaymentCreateData
from .paypal_payment_create_data_attributes import PaypalPaymentCreateDataAttributes
from .paypal_payment_create_data_attributes_metadata import PaypalPaymentCreateDataAttributesMetadata
from .paypal_payment_create_data_relationships import PaypalPaymentCreateDataRelationships
from .paypal_payment_create_data_relationships_order import PaypalPaymentCreateDataRelationshipsOrder
from .paypal_payment_create_data_relationships_order_data import PaypalPaymentCreateDataRelationshipsOrderData
from .paypal_payment_create_data_relationships_order_data_type import PaypalPaymentCreateDataRelationshipsOrderDataType
from .paypal_payment_create_data_type import PaypalPaymentCreateDataType
from .paypal_payment_data import PaypalPaymentData
from .paypal_payment_data_attributes import PaypalPaymentDataAttributes
from .paypal_payment_data_attributes_metadata import PaypalPaymentDataAttributesMetadata
from .paypal_payment_data_relationships import PaypalPaymentDataRelationships
from .paypal_payment_data_relationships_order import PaypalPaymentDataRelationshipsOrder
from .paypal_payment_data_relationships_order_data import PaypalPaymentDataRelationshipsOrderData
from .paypal_payment_data_relationships_order_data_type import PaypalPaymentDataRelationshipsOrderDataType
from .paypal_payment_data_relationships_payment_gateway import PaypalPaymentDataRelationshipsPaymentGateway
from .paypal_payment_data_relationships_payment_gateway_data import PaypalPaymentDataRelationshipsPaymentGatewayData
from .paypal_payment_data_relationships_payment_gateway_data_type import (
    PaypalPaymentDataRelationshipsPaymentGatewayDataType,
)
from .paypal_payment_data_type import PaypalPaymentDataType
from .paypal_payment_update import PaypalPaymentUpdate
from .paypal_payment_update_data import PaypalPaymentUpdateData
from .paypal_payment_update_data_attributes import PaypalPaymentUpdateDataAttributes
from .paypal_payment_update_data_attributes_metadata import PaypalPaymentUpdateDataAttributesMetadata
from .paypal_payment_update_data_relationships import PaypalPaymentUpdateDataRelationships
from .paypal_payment_update_data_relationships_order import PaypalPaymentUpdateDataRelationshipsOrder
from .paypal_payment_update_data_relationships_order_data import PaypalPaymentUpdateDataRelationshipsOrderData
from .paypal_payment_update_data_relationships_order_data_type import PaypalPaymentUpdateDataRelationshipsOrderDataType
from .paypal_payment_update_data_type import PaypalPaymentUpdateDataType
from .percentage_discount_promotion import PercentageDiscountPromotion
from .percentage_discount_promotion_create import PercentageDiscountPromotionCreate
from .percentage_discount_promotion_create_data import PercentageDiscountPromotionCreateData
from .percentage_discount_promotion_create_data_attributes import PercentageDiscountPromotionCreateDataAttributes
from .percentage_discount_promotion_create_data_attributes_metadata import (
    PercentageDiscountPromotionCreateDataAttributesMetadata,
)
from .percentage_discount_promotion_create_data_relationships import PercentageDiscountPromotionCreateDataRelationships
from .percentage_discount_promotion_create_data_relationships_coupon_codes_promotion_rule import (
    PercentageDiscountPromotionCreateDataRelationshipsCouponCodesPromotionRule,
)
from .percentage_discount_promotion_create_data_relationships_coupon_codes_promotion_rule_data import (
    PercentageDiscountPromotionCreateDataRelationshipsCouponCodesPromotionRuleData,
)
from .percentage_discount_promotion_create_data_relationships_coupon_codes_promotion_rule_data_type import (
    PercentageDiscountPromotionCreateDataRelationshipsCouponCodesPromotionRuleDataType,
)
from .percentage_discount_promotion_create_data_relationships_market import (
    PercentageDiscountPromotionCreateDataRelationshipsMarket,
)
from .percentage_discount_promotion_create_data_relationships_market_data import (
    PercentageDiscountPromotionCreateDataRelationshipsMarketData,
)
from .percentage_discount_promotion_create_data_relationships_market_data_type import (
    PercentageDiscountPromotionCreateDataRelationshipsMarketDataType,
)
from .percentage_discount_promotion_create_data_relationships_order_amount_promotion_rule import (
    PercentageDiscountPromotionCreateDataRelationshipsOrderAmountPromotionRule,
)
from .percentage_discount_promotion_create_data_relationships_order_amount_promotion_rule_data import (
    PercentageDiscountPromotionCreateDataRelationshipsOrderAmountPromotionRuleData,
)
from .percentage_discount_promotion_create_data_relationships_order_amount_promotion_rule_data_type import (
    PercentageDiscountPromotionCreateDataRelationshipsOrderAmountPromotionRuleDataType,
)
from .percentage_discount_promotion_create_data_relationships_promotion_rules import (
    PercentageDiscountPromotionCreateDataRelationshipsPromotionRules,
)
from .percentage_discount_promotion_create_data_relationships_promotion_rules_data import (
    PercentageDiscountPromotionCreateDataRelationshipsPromotionRulesData,
)
from .percentage_discount_promotion_create_data_relationships_promotion_rules_data_type import (
    PercentageDiscountPromotionCreateDataRelationshipsPromotionRulesDataType,
)
from .percentage_discount_promotion_create_data_relationships_sku_list import (
    PercentageDiscountPromotionCreateDataRelationshipsSkuList,
)
from .percentage_discount_promotion_create_data_relationships_sku_list_data import (
    PercentageDiscountPromotionCreateDataRelationshipsSkuListData,
)
from .percentage_discount_promotion_create_data_relationships_sku_list_data_type import (
    PercentageDiscountPromotionCreateDataRelationshipsSkuListDataType,
)
from .percentage_discount_promotion_create_data_relationships_sku_list_promotion_rule import (
    PercentageDiscountPromotionCreateDataRelationshipsSkuListPromotionRule,
)
from .percentage_discount_promotion_create_data_relationships_sku_list_promotion_rule_data import (
    PercentageDiscountPromotionCreateDataRelationshipsSkuListPromotionRuleData,
)
from .percentage_discount_promotion_create_data_relationships_sku_list_promotion_rule_data_type import (
    PercentageDiscountPromotionCreateDataRelationshipsSkuListPromotionRuleDataType,
)
from .percentage_discount_promotion_create_data_type import PercentageDiscountPromotionCreateDataType
from .percentage_discount_promotion_data import PercentageDiscountPromotionData
from .percentage_discount_promotion_data_attributes import PercentageDiscountPromotionDataAttributes
from .percentage_discount_promotion_data_attributes_metadata import PercentageDiscountPromotionDataAttributesMetadata
from .percentage_discount_promotion_data_relationships import PercentageDiscountPromotionDataRelationships
from .percentage_discount_promotion_data_relationships_attachments import (
    PercentageDiscountPromotionDataRelationshipsAttachments,
)
from .percentage_discount_promotion_data_relationships_attachments_data import (
    PercentageDiscountPromotionDataRelationshipsAttachmentsData,
)
from .percentage_discount_promotion_data_relationships_attachments_data_type import (
    PercentageDiscountPromotionDataRelationshipsAttachmentsDataType,
)
from .percentage_discount_promotion_data_relationships_coupon_codes_promotion_rule import (
    PercentageDiscountPromotionDataRelationshipsCouponCodesPromotionRule,
)
from .percentage_discount_promotion_data_relationships_coupon_codes_promotion_rule_data import (
    PercentageDiscountPromotionDataRelationshipsCouponCodesPromotionRuleData,
)
from .percentage_discount_promotion_data_relationships_coupon_codes_promotion_rule_data_type import (
    PercentageDiscountPromotionDataRelationshipsCouponCodesPromotionRuleDataType,
)
from .percentage_discount_promotion_data_relationships_market import PercentageDiscountPromotionDataRelationshipsMarket
from .percentage_discount_promotion_data_relationships_market_data import (
    PercentageDiscountPromotionDataRelationshipsMarketData,
)
from .percentage_discount_promotion_data_relationships_market_data_type import (
    PercentageDiscountPromotionDataRelationshipsMarketDataType,
)
from .percentage_discount_promotion_data_relationships_order_amount_promotion_rule import (
    PercentageDiscountPromotionDataRelationshipsOrderAmountPromotionRule,
)
from .percentage_discount_promotion_data_relationships_order_amount_promotion_rule_data import (
    PercentageDiscountPromotionDataRelationshipsOrderAmountPromotionRuleData,
)
from .percentage_discount_promotion_data_relationships_order_amount_promotion_rule_data_type import (
    PercentageDiscountPromotionDataRelationshipsOrderAmountPromotionRuleDataType,
)
from .percentage_discount_promotion_data_relationships_promotion_rules import (
    PercentageDiscountPromotionDataRelationshipsPromotionRules,
)
from .percentage_discount_promotion_data_relationships_promotion_rules_data import (
    PercentageDiscountPromotionDataRelationshipsPromotionRulesData,
)
from .percentage_discount_promotion_data_relationships_promotion_rules_data_type import (
    PercentageDiscountPromotionDataRelationshipsPromotionRulesDataType,
)
from .percentage_discount_promotion_data_relationships_sku_list import (
    PercentageDiscountPromotionDataRelationshipsSkuList,
)
from .percentage_discount_promotion_data_relationships_sku_list_data import (
    PercentageDiscountPromotionDataRelationshipsSkuListData,
)
from .percentage_discount_promotion_data_relationships_sku_list_data_type import (
    PercentageDiscountPromotionDataRelationshipsSkuListDataType,
)
from .percentage_discount_promotion_data_relationships_sku_list_promotion_rule import (
    PercentageDiscountPromotionDataRelationshipsSkuListPromotionRule,
)
from .percentage_discount_promotion_data_relationships_sku_list_promotion_rule_data import (
    PercentageDiscountPromotionDataRelationshipsSkuListPromotionRuleData,
)
from .percentage_discount_promotion_data_relationships_sku_list_promotion_rule_data_type import (
    PercentageDiscountPromotionDataRelationshipsSkuListPromotionRuleDataType,
)
from .percentage_discount_promotion_data_relationships_skus import PercentageDiscountPromotionDataRelationshipsSkus
from .percentage_discount_promotion_data_relationships_skus_data import (
    PercentageDiscountPromotionDataRelationshipsSkusData,
)
from .percentage_discount_promotion_data_relationships_skus_data_type import (
    PercentageDiscountPromotionDataRelationshipsSkusDataType,
)
from .percentage_discount_promotion_data_type import PercentageDiscountPromotionDataType
from .percentage_discount_promotion_update import PercentageDiscountPromotionUpdate
from .percentage_discount_promotion_update_data import PercentageDiscountPromotionUpdateData
from .percentage_discount_promotion_update_data_attributes import PercentageDiscountPromotionUpdateDataAttributes
from .percentage_discount_promotion_update_data_attributes_metadata import (
    PercentageDiscountPromotionUpdateDataAttributesMetadata,
)
from .percentage_discount_promotion_update_data_relationships import PercentageDiscountPromotionUpdateDataRelationships
from .percentage_discount_promotion_update_data_relationships_coupon_codes_promotion_rule import (
    PercentageDiscountPromotionUpdateDataRelationshipsCouponCodesPromotionRule,
)
from .percentage_discount_promotion_update_data_relationships_coupon_codes_promotion_rule_data import (
    PercentageDiscountPromotionUpdateDataRelationshipsCouponCodesPromotionRuleData,
)
from .percentage_discount_promotion_update_data_relationships_coupon_codes_promotion_rule_data_type import (
    PercentageDiscountPromotionUpdateDataRelationshipsCouponCodesPromotionRuleDataType,
)
from .percentage_discount_promotion_update_data_relationships_market import (
    PercentageDiscountPromotionUpdateDataRelationshipsMarket,
)
from .percentage_discount_promotion_update_data_relationships_market_data import (
    PercentageDiscountPromotionUpdateDataRelationshipsMarketData,
)
from .percentage_discount_promotion_update_data_relationships_market_data_type import (
    PercentageDiscountPromotionUpdateDataRelationshipsMarketDataType,
)
from .percentage_discount_promotion_update_data_relationships_order_amount_promotion_rule import (
    PercentageDiscountPromotionUpdateDataRelationshipsOrderAmountPromotionRule,
)
from .percentage_discount_promotion_update_data_relationships_order_amount_promotion_rule_data import (
    PercentageDiscountPromotionUpdateDataRelationshipsOrderAmountPromotionRuleData,
)
from .percentage_discount_promotion_update_data_relationships_order_amount_promotion_rule_data_type import (
    PercentageDiscountPromotionUpdateDataRelationshipsOrderAmountPromotionRuleDataType,
)
from .percentage_discount_promotion_update_data_relationships_promotion_rules import (
    PercentageDiscountPromotionUpdateDataRelationshipsPromotionRules,
)
from .percentage_discount_promotion_update_data_relationships_promotion_rules_data import (
    PercentageDiscountPromotionUpdateDataRelationshipsPromotionRulesData,
)
from .percentage_discount_promotion_update_data_relationships_promotion_rules_data_type import (
    PercentageDiscountPromotionUpdateDataRelationshipsPromotionRulesDataType,
)
from .percentage_discount_promotion_update_data_relationships_sku_list import (
    PercentageDiscountPromotionUpdateDataRelationshipsSkuList,
)
from .percentage_discount_promotion_update_data_relationships_sku_list_data import (
    PercentageDiscountPromotionUpdateDataRelationshipsSkuListData,
)
from .percentage_discount_promotion_update_data_relationships_sku_list_data_type import (
    PercentageDiscountPromotionUpdateDataRelationshipsSkuListDataType,
)
from .percentage_discount_promotion_update_data_relationships_sku_list_promotion_rule import (
    PercentageDiscountPromotionUpdateDataRelationshipsSkuListPromotionRule,
)
from .percentage_discount_promotion_update_data_relationships_sku_list_promotion_rule_data import (
    PercentageDiscountPromotionUpdateDataRelationshipsSkuListPromotionRuleData,
)
from .percentage_discount_promotion_update_data_relationships_sku_list_promotion_rule_data_type import (
    PercentageDiscountPromotionUpdateDataRelationshipsSkuListPromotionRuleDataType,
)
from .percentage_discount_promotion_update_data_type import PercentageDiscountPromotionUpdateDataType
from .pos_taddresses_response_201 import POSTaddressesResponse201
from .pos_taddresses_response_201_data import POSTaddressesResponse201Data
from .pos_taddresses_response_201_data_attributes import POSTaddressesResponse201DataAttributes
from .pos_taddresses_response_201_data_attributes_metadata import POSTaddressesResponse201DataAttributesMetadata
from .pos_taddresses_response_201_data_links import POSTaddressesResponse201DataLinks
from .pos_taddresses_response_201_data_relationships import POSTaddressesResponse201DataRelationships
from .pos_taddresses_response_201_data_relationships_geocoder import POSTaddressesResponse201DataRelationshipsGeocoder
from .pos_taddresses_response_201_data_relationships_geocoder_data import (
    POSTaddressesResponse201DataRelationshipsGeocoderData,
)
from .pos_taddresses_response_201_data_relationships_geocoder_data_type import (
    POSTaddressesResponse201DataRelationshipsGeocoderDataType,
)
from .pos_taddresses_response_201_data_relationships_geocoder_links import (
    POSTaddressesResponse201DataRelationshipsGeocoderLinks,
)
from .pos_taddresses_response_201_data_type import POSTaddressesResponse201DataType
from .pos_tadjustments_response_201 import POSTadjustmentsResponse201
from .pos_tadjustments_response_201_data import POSTadjustmentsResponse201Data
from .pos_tadjustments_response_201_data_attributes import POSTadjustmentsResponse201DataAttributes
from .pos_tadjustments_response_201_data_attributes_metadata import POSTadjustmentsResponse201DataAttributesMetadata
from .pos_tadjustments_response_201_data_links import POSTadjustmentsResponse201DataLinks
from .pos_tadjustments_response_201_data_relationships import POSTadjustmentsResponse201DataRelationships
from .pos_tadjustments_response_201_data_type import POSTadjustmentsResponse201DataType
from .pos_tadyen_gateways_response_201 import POSTadyenGatewaysResponse201
from .pos_tadyen_gateways_response_201_data import POSTadyenGatewaysResponse201Data
from .pos_tadyen_gateways_response_201_data_attributes import POSTadyenGatewaysResponse201DataAttributes
from .pos_tadyen_gateways_response_201_data_attributes_metadata import (
    POSTadyenGatewaysResponse201DataAttributesMetadata,
)
from .pos_tadyen_gateways_response_201_data_links import POSTadyenGatewaysResponse201DataLinks
from .pos_tadyen_gateways_response_201_data_relationships import POSTadyenGatewaysResponse201DataRelationships
from .pos_tadyen_gateways_response_201_data_relationships_adyen_payments import (
    POSTadyenGatewaysResponse201DataRelationshipsAdyenPayments,
)
from .pos_tadyen_gateways_response_201_data_relationships_adyen_payments_data import (
    POSTadyenGatewaysResponse201DataRelationshipsAdyenPaymentsData,
)
from .pos_tadyen_gateways_response_201_data_relationships_adyen_payments_data_type import (
    POSTadyenGatewaysResponse201DataRelationshipsAdyenPaymentsDataType,
)
from .pos_tadyen_gateways_response_201_data_relationships_adyen_payments_links import (
    POSTadyenGatewaysResponse201DataRelationshipsAdyenPaymentsLinks,
)
from .pos_tadyen_gateways_response_201_data_relationships_payment_methods import (
    POSTadyenGatewaysResponse201DataRelationshipsPaymentMethods,
)
from .pos_tadyen_gateways_response_201_data_relationships_payment_methods_data import (
    POSTadyenGatewaysResponse201DataRelationshipsPaymentMethodsData,
)
from .pos_tadyen_gateways_response_201_data_relationships_payment_methods_data_type import (
    POSTadyenGatewaysResponse201DataRelationshipsPaymentMethodsDataType,
)
from .pos_tadyen_gateways_response_201_data_relationships_payment_methods_links import (
    POSTadyenGatewaysResponse201DataRelationshipsPaymentMethodsLinks,
)
from .pos_tadyen_gateways_response_201_data_type import POSTadyenGatewaysResponse201DataType
from .pos_tadyen_payments_response_201 import POSTadyenPaymentsResponse201
from .pos_tadyen_payments_response_201_data import POSTadyenPaymentsResponse201Data
from .pos_tadyen_payments_response_201_data_attributes import POSTadyenPaymentsResponse201DataAttributes
from .pos_tadyen_payments_response_201_data_attributes_metadata import (
    POSTadyenPaymentsResponse201DataAttributesMetadata,
)
from .pos_tadyen_payments_response_201_data_links import POSTadyenPaymentsResponse201DataLinks
from .pos_tadyen_payments_response_201_data_relationships import POSTadyenPaymentsResponse201DataRelationships
from .pos_tadyen_payments_response_201_data_relationships_order import (
    POSTadyenPaymentsResponse201DataRelationshipsOrder,
)
from .pos_tadyen_payments_response_201_data_relationships_order_data import (
    POSTadyenPaymentsResponse201DataRelationshipsOrderData,
)
from .pos_tadyen_payments_response_201_data_relationships_order_data_type import (
    POSTadyenPaymentsResponse201DataRelationshipsOrderDataType,
)
from .pos_tadyen_payments_response_201_data_relationships_order_links import (
    POSTadyenPaymentsResponse201DataRelationshipsOrderLinks,
)
from .pos_tadyen_payments_response_201_data_relationships_payment_gateway import (
    POSTadyenPaymentsResponse201DataRelationshipsPaymentGateway,
)
from .pos_tadyen_payments_response_201_data_relationships_payment_gateway_data import (
    POSTadyenPaymentsResponse201DataRelationshipsPaymentGatewayData,
)
from .pos_tadyen_payments_response_201_data_relationships_payment_gateway_data_type import (
    POSTadyenPaymentsResponse201DataRelationshipsPaymentGatewayDataType,
)
from .pos_tadyen_payments_response_201_data_relationships_payment_gateway_links import (
    POSTadyenPaymentsResponse201DataRelationshipsPaymentGatewayLinks,
)
from .pos_tadyen_payments_response_201_data_type import POSTadyenPaymentsResponse201DataType
from .pos_tattachments_response_201 import POSTattachmentsResponse201
from .pos_tattachments_response_201_data import POSTattachmentsResponse201Data
from .pos_tattachments_response_201_data_attributes import POSTattachmentsResponse201DataAttributes
from .pos_tattachments_response_201_data_attributes_metadata import POSTattachmentsResponse201DataAttributesMetadata
from .pos_tattachments_response_201_data_links import POSTattachmentsResponse201DataLinks
from .pos_tattachments_response_201_data_relationships import POSTattachmentsResponse201DataRelationships
from .pos_tattachments_response_201_data_relationships_attachable import (
    POSTattachmentsResponse201DataRelationshipsAttachable,
)
from .pos_tattachments_response_201_data_relationships_attachable_data import (
    POSTattachmentsResponse201DataRelationshipsAttachableData,
)
from .pos_tattachments_response_201_data_relationships_attachable_data_type import (
    POSTattachmentsResponse201DataRelationshipsAttachableDataType,
)
from .pos_tattachments_response_201_data_relationships_attachable_links import (
    POSTattachmentsResponse201DataRelationshipsAttachableLinks,
)
from .pos_tattachments_response_201_data_type import POSTattachmentsResponse201DataType
from .pos_tavalara_accounts_response_201 import POSTavalaraAccountsResponse201
from .pos_tavalara_accounts_response_201_data import POSTavalaraAccountsResponse201Data
from .pos_tavalara_accounts_response_201_data_attributes import POSTavalaraAccountsResponse201DataAttributes
from .pos_tavalara_accounts_response_201_data_attributes_metadata import (
    POSTavalaraAccountsResponse201DataAttributesMetadata,
)
from .pos_tavalara_accounts_response_201_data_links import POSTavalaraAccountsResponse201DataLinks
from .pos_tavalara_accounts_response_201_data_relationships import POSTavalaraAccountsResponse201DataRelationships
from .pos_tavalara_accounts_response_201_data_relationships_attachments import (
    POSTavalaraAccountsResponse201DataRelationshipsAttachments,
)
from .pos_tavalara_accounts_response_201_data_relationships_attachments_data import (
    POSTavalaraAccountsResponse201DataRelationshipsAttachmentsData,
)
from .pos_tavalara_accounts_response_201_data_relationships_attachments_data_type import (
    POSTavalaraAccountsResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tavalara_accounts_response_201_data_relationships_attachments_links import (
    POSTavalaraAccountsResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tavalara_accounts_response_201_data_relationships_markets import (
    POSTavalaraAccountsResponse201DataRelationshipsMarkets,
)
from .pos_tavalara_accounts_response_201_data_relationships_markets_data import (
    POSTavalaraAccountsResponse201DataRelationshipsMarketsData,
)
from .pos_tavalara_accounts_response_201_data_relationships_markets_data_type import (
    POSTavalaraAccountsResponse201DataRelationshipsMarketsDataType,
)
from .pos_tavalara_accounts_response_201_data_relationships_markets_links import (
    POSTavalaraAccountsResponse201DataRelationshipsMarketsLinks,
)
from .pos_tavalara_accounts_response_201_data_relationships_tax_categories import (
    POSTavalaraAccountsResponse201DataRelationshipsTaxCategories,
)
from .pos_tavalara_accounts_response_201_data_relationships_tax_categories_data import (
    POSTavalaraAccountsResponse201DataRelationshipsTaxCategoriesData,
)
from .pos_tavalara_accounts_response_201_data_relationships_tax_categories_data_type import (
    POSTavalaraAccountsResponse201DataRelationshipsTaxCategoriesDataType,
)
from .pos_tavalara_accounts_response_201_data_relationships_tax_categories_links import (
    POSTavalaraAccountsResponse201DataRelationshipsTaxCategoriesLinks,
)
from .pos_tavalara_accounts_response_201_data_type import POSTavalaraAccountsResponse201DataType
from .pos_tbilling_info_validation_rules_response_201 import POSTbillingInfoValidationRulesResponse201
from .pos_tbilling_info_validation_rules_response_201_data import POSTbillingInfoValidationRulesResponse201Data
from .pos_tbilling_info_validation_rules_response_201_data_attributes import (
    POSTbillingInfoValidationRulesResponse201DataAttributes,
)
from .pos_tbilling_info_validation_rules_response_201_data_attributes_metadata import (
    POSTbillingInfoValidationRulesResponse201DataAttributesMetadata,
)
from .pos_tbilling_info_validation_rules_response_201_data_links import (
    POSTbillingInfoValidationRulesResponse201DataLinks,
)
from .pos_tbilling_info_validation_rules_response_201_data_relationships import (
    POSTbillingInfoValidationRulesResponse201DataRelationships,
)
from .pos_tbilling_info_validation_rules_response_201_data_relationships_market import (
    POSTbillingInfoValidationRulesResponse201DataRelationshipsMarket,
)
from .pos_tbilling_info_validation_rules_response_201_data_relationships_market_data import (
    POSTbillingInfoValidationRulesResponse201DataRelationshipsMarketData,
)
from .pos_tbilling_info_validation_rules_response_201_data_relationships_market_data_type import (
    POSTbillingInfoValidationRulesResponse201DataRelationshipsMarketDataType,
)
from .pos_tbilling_info_validation_rules_response_201_data_relationships_market_links import (
    POSTbillingInfoValidationRulesResponse201DataRelationshipsMarketLinks,
)
from .pos_tbilling_info_validation_rules_response_201_data_type import POSTbillingInfoValidationRulesResponse201DataType
from .pos_tbing_geocoders_response_201 import POSTbingGeocodersResponse201
from .pos_tbing_geocoders_response_201_data import POSTbingGeocodersResponse201Data
from .pos_tbing_geocoders_response_201_data_attributes import POSTbingGeocodersResponse201DataAttributes
from .pos_tbing_geocoders_response_201_data_attributes_metadata import (
    POSTbingGeocodersResponse201DataAttributesMetadata,
)
from .pos_tbing_geocoders_response_201_data_links import POSTbingGeocodersResponse201DataLinks
from .pos_tbing_geocoders_response_201_data_relationships import POSTbingGeocodersResponse201DataRelationships
from .pos_tbing_geocoders_response_201_data_relationships_addresses import (
    POSTbingGeocodersResponse201DataRelationshipsAddresses,
)
from .pos_tbing_geocoders_response_201_data_relationships_addresses_data import (
    POSTbingGeocodersResponse201DataRelationshipsAddressesData,
)
from .pos_tbing_geocoders_response_201_data_relationships_addresses_data_type import (
    POSTbingGeocodersResponse201DataRelationshipsAddressesDataType,
)
from .pos_tbing_geocoders_response_201_data_relationships_addresses_links import (
    POSTbingGeocodersResponse201DataRelationshipsAddressesLinks,
)
from .pos_tbing_geocoders_response_201_data_relationships_attachments import (
    POSTbingGeocodersResponse201DataRelationshipsAttachments,
)
from .pos_tbing_geocoders_response_201_data_relationships_attachments_data import (
    POSTbingGeocodersResponse201DataRelationshipsAttachmentsData,
)
from .pos_tbing_geocoders_response_201_data_relationships_attachments_data_type import (
    POSTbingGeocodersResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tbing_geocoders_response_201_data_relationships_attachments_links import (
    POSTbingGeocodersResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tbing_geocoders_response_201_data_type import POSTbingGeocodersResponse201DataType
from .pos_tbraintree_gateways_response_201 import POSTbraintreeGatewaysResponse201
from .pos_tbraintree_gateways_response_201_data import POSTbraintreeGatewaysResponse201Data
from .pos_tbraintree_gateways_response_201_data_attributes import POSTbraintreeGatewaysResponse201DataAttributes
from .pos_tbraintree_gateways_response_201_data_attributes_metadata import (
    POSTbraintreeGatewaysResponse201DataAttributesMetadata,
)
from .pos_tbraintree_gateways_response_201_data_links import POSTbraintreeGatewaysResponse201DataLinks
from .pos_tbraintree_gateways_response_201_data_relationships import POSTbraintreeGatewaysResponse201DataRelationships
from .pos_tbraintree_gateways_response_201_data_relationships_braintree_payments import (
    POSTbraintreeGatewaysResponse201DataRelationshipsBraintreePayments,
)
from .pos_tbraintree_gateways_response_201_data_relationships_braintree_payments_data import (
    POSTbraintreeGatewaysResponse201DataRelationshipsBraintreePaymentsData,
)
from .pos_tbraintree_gateways_response_201_data_relationships_braintree_payments_data_type import (
    POSTbraintreeGatewaysResponse201DataRelationshipsBraintreePaymentsDataType,
)
from .pos_tbraintree_gateways_response_201_data_relationships_braintree_payments_links import (
    POSTbraintreeGatewaysResponse201DataRelationshipsBraintreePaymentsLinks,
)
from .pos_tbraintree_gateways_response_201_data_relationships_payment_methods import (
    POSTbraintreeGatewaysResponse201DataRelationshipsPaymentMethods,
)
from .pos_tbraintree_gateways_response_201_data_relationships_payment_methods_data import (
    POSTbraintreeGatewaysResponse201DataRelationshipsPaymentMethodsData,
)
from .pos_tbraintree_gateways_response_201_data_relationships_payment_methods_data_type import (
    POSTbraintreeGatewaysResponse201DataRelationshipsPaymentMethodsDataType,
)
from .pos_tbraintree_gateways_response_201_data_relationships_payment_methods_links import (
    POSTbraintreeGatewaysResponse201DataRelationshipsPaymentMethodsLinks,
)
from .pos_tbraintree_gateways_response_201_data_type import POSTbraintreeGatewaysResponse201DataType
from .pos_tbraintree_payments_response_201 import POSTbraintreePaymentsResponse201
from .pos_tbraintree_payments_response_201_data import POSTbraintreePaymentsResponse201Data
from .pos_tbraintree_payments_response_201_data_attributes import POSTbraintreePaymentsResponse201DataAttributes
from .pos_tbraintree_payments_response_201_data_attributes_metadata import (
    POSTbraintreePaymentsResponse201DataAttributesMetadata,
)
from .pos_tbraintree_payments_response_201_data_attributes_options import (
    POSTbraintreePaymentsResponse201DataAttributesOptions,
)
from .pos_tbraintree_payments_response_201_data_links import POSTbraintreePaymentsResponse201DataLinks
from .pos_tbraintree_payments_response_201_data_relationships import POSTbraintreePaymentsResponse201DataRelationships
from .pos_tbraintree_payments_response_201_data_relationships_order import (
    POSTbraintreePaymentsResponse201DataRelationshipsOrder,
)
from .pos_tbraintree_payments_response_201_data_relationships_order_data import (
    POSTbraintreePaymentsResponse201DataRelationshipsOrderData,
)
from .pos_tbraintree_payments_response_201_data_relationships_order_data_type import (
    POSTbraintreePaymentsResponse201DataRelationshipsOrderDataType,
)
from .pos_tbraintree_payments_response_201_data_relationships_order_links import (
    POSTbraintreePaymentsResponse201DataRelationshipsOrderLinks,
)
from .pos_tbraintree_payments_response_201_data_relationships_payment_gateway import (
    POSTbraintreePaymentsResponse201DataRelationshipsPaymentGateway,
)
from .pos_tbraintree_payments_response_201_data_relationships_payment_gateway_data import (
    POSTbraintreePaymentsResponse201DataRelationshipsPaymentGatewayData,
)
from .pos_tbraintree_payments_response_201_data_relationships_payment_gateway_data_type import (
    POSTbraintreePaymentsResponse201DataRelationshipsPaymentGatewayDataType,
)
from .pos_tbraintree_payments_response_201_data_relationships_payment_gateway_links import (
    POSTbraintreePaymentsResponse201DataRelationshipsPaymentGatewayLinks,
)
from .pos_tbraintree_payments_response_201_data_type import POSTbraintreePaymentsResponse201DataType
from .pos_tbundles_response_201 import POSTbundlesResponse201
from .pos_tbundles_response_201_data import POSTbundlesResponse201Data
from .pos_tbundles_response_201_data_attributes import POSTbundlesResponse201DataAttributes
from .pos_tbundles_response_201_data_attributes_metadata import POSTbundlesResponse201DataAttributesMetadata
from .pos_tbundles_response_201_data_links import POSTbundlesResponse201DataLinks
from .pos_tbundles_response_201_data_relationships import POSTbundlesResponse201DataRelationships
from .pos_tbundles_response_201_data_relationships_attachments import POSTbundlesResponse201DataRelationshipsAttachments
from .pos_tbundles_response_201_data_relationships_attachments_data import (
    POSTbundlesResponse201DataRelationshipsAttachmentsData,
)
from .pos_tbundles_response_201_data_relationships_attachments_data_type import (
    POSTbundlesResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tbundles_response_201_data_relationships_attachments_links import (
    POSTbundlesResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tbundles_response_201_data_relationships_market import POSTbundlesResponse201DataRelationshipsMarket
from .pos_tbundles_response_201_data_relationships_market_data import POSTbundlesResponse201DataRelationshipsMarketData
from .pos_tbundles_response_201_data_relationships_market_data_type import (
    POSTbundlesResponse201DataRelationshipsMarketDataType,
)
from .pos_tbundles_response_201_data_relationships_market_links import (
    POSTbundlesResponse201DataRelationshipsMarketLinks,
)
from .pos_tbundles_response_201_data_relationships_sku_list import POSTbundlesResponse201DataRelationshipsSkuList
from .pos_tbundles_response_201_data_relationships_sku_list_data import (
    POSTbundlesResponse201DataRelationshipsSkuListData,
)
from .pos_tbundles_response_201_data_relationships_sku_list_data_type import (
    POSTbundlesResponse201DataRelationshipsSkuListDataType,
)
from .pos_tbundles_response_201_data_relationships_sku_list_links import (
    POSTbundlesResponse201DataRelationshipsSkuListLinks,
)
from .pos_tbundles_response_201_data_relationships_skus import POSTbundlesResponse201DataRelationshipsSkus
from .pos_tbundles_response_201_data_relationships_skus_data import POSTbundlesResponse201DataRelationshipsSkusData
from .pos_tbundles_response_201_data_relationships_skus_data_type import (
    POSTbundlesResponse201DataRelationshipsSkusDataType,
)
from .pos_tbundles_response_201_data_relationships_skus_links import POSTbundlesResponse201DataRelationshipsSkusLinks
from .pos_tbundles_response_201_data_type import POSTbundlesResponse201DataType
from .pos_tcheckout_com_gateways_response_201 import POSTcheckoutComGatewaysResponse201
from .pos_tcheckout_com_gateways_response_201_data import POSTcheckoutComGatewaysResponse201Data
from .pos_tcheckout_com_gateways_response_201_data_attributes import POSTcheckoutComGatewaysResponse201DataAttributes
from .pos_tcheckout_com_gateways_response_201_data_attributes_metadata import (
    POSTcheckoutComGatewaysResponse201DataAttributesMetadata,
)
from .pos_tcheckout_com_gateways_response_201_data_links import POSTcheckoutComGatewaysResponse201DataLinks
from .pos_tcheckout_com_gateways_response_201_data_relationships import (
    POSTcheckoutComGatewaysResponse201DataRelationships,
)
from .pos_tcheckout_com_gateways_response_201_data_relationships_checkout_com_payments import (
    POSTcheckoutComGatewaysResponse201DataRelationshipsCheckoutComPayments,
)
from .pos_tcheckout_com_gateways_response_201_data_relationships_checkout_com_payments_data import (
    POSTcheckoutComGatewaysResponse201DataRelationshipsCheckoutComPaymentsData,
)
from .pos_tcheckout_com_gateways_response_201_data_relationships_checkout_com_payments_data_type import (
    POSTcheckoutComGatewaysResponse201DataRelationshipsCheckoutComPaymentsDataType,
)
from .pos_tcheckout_com_gateways_response_201_data_relationships_checkout_com_payments_links import (
    POSTcheckoutComGatewaysResponse201DataRelationshipsCheckoutComPaymentsLinks,
)
from .pos_tcheckout_com_gateways_response_201_data_relationships_payment_methods import (
    POSTcheckoutComGatewaysResponse201DataRelationshipsPaymentMethods,
)
from .pos_tcheckout_com_gateways_response_201_data_relationships_payment_methods_data import (
    POSTcheckoutComGatewaysResponse201DataRelationshipsPaymentMethodsData,
)
from .pos_tcheckout_com_gateways_response_201_data_relationships_payment_methods_data_type import (
    POSTcheckoutComGatewaysResponse201DataRelationshipsPaymentMethodsDataType,
)
from .pos_tcheckout_com_gateways_response_201_data_relationships_payment_methods_links import (
    POSTcheckoutComGatewaysResponse201DataRelationshipsPaymentMethodsLinks,
)
from .pos_tcheckout_com_gateways_response_201_data_type import POSTcheckoutComGatewaysResponse201DataType
from .pos_tcheckout_com_payments_response_201 import POSTcheckoutComPaymentsResponse201
from .pos_tcheckout_com_payments_response_201_data import POSTcheckoutComPaymentsResponse201Data
from .pos_tcheckout_com_payments_response_201_data_attributes import POSTcheckoutComPaymentsResponse201DataAttributes
from .pos_tcheckout_com_payments_response_201_data_attributes_metadata import (
    POSTcheckoutComPaymentsResponse201DataAttributesMetadata,
)
from .pos_tcheckout_com_payments_response_201_data_links import POSTcheckoutComPaymentsResponse201DataLinks
from .pos_tcheckout_com_payments_response_201_data_relationships import (
    POSTcheckoutComPaymentsResponse201DataRelationships,
)
from .pos_tcheckout_com_payments_response_201_data_relationships_order import (
    POSTcheckoutComPaymentsResponse201DataRelationshipsOrder,
)
from .pos_tcheckout_com_payments_response_201_data_relationships_order_data import (
    POSTcheckoutComPaymentsResponse201DataRelationshipsOrderData,
)
from .pos_tcheckout_com_payments_response_201_data_relationships_order_data_type import (
    POSTcheckoutComPaymentsResponse201DataRelationshipsOrderDataType,
)
from .pos_tcheckout_com_payments_response_201_data_relationships_order_links import (
    POSTcheckoutComPaymentsResponse201DataRelationshipsOrderLinks,
)
from .pos_tcheckout_com_payments_response_201_data_relationships_payment_gateway import (
    POSTcheckoutComPaymentsResponse201DataRelationshipsPaymentGateway,
)
from .pos_tcheckout_com_payments_response_201_data_relationships_payment_gateway_data import (
    POSTcheckoutComPaymentsResponse201DataRelationshipsPaymentGatewayData,
)
from .pos_tcheckout_com_payments_response_201_data_relationships_payment_gateway_data_type import (
    POSTcheckoutComPaymentsResponse201DataRelationshipsPaymentGatewayDataType,
)
from .pos_tcheckout_com_payments_response_201_data_relationships_payment_gateway_links import (
    POSTcheckoutComPaymentsResponse201DataRelationshipsPaymentGatewayLinks,
)
from .pos_tcheckout_com_payments_response_201_data_type import POSTcheckoutComPaymentsResponse201DataType
from .pos_tcleanups_response_201 import POSTcleanupsResponse201
from .pos_tcleanups_response_201_data import POSTcleanupsResponse201Data
from .pos_tcleanups_response_201_data_attributes import POSTcleanupsResponse201DataAttributes
from .pos_tcleanups_response_201_data_attributes_filters import POSTcleanupsResponse201DataAttributesFilters
from .pos_tcleanups_response_201_data_attributes_metadata import POSTcleanupsResponse201DataAttributesMetadata
from .pos_tcleanups_response_201_data_links import POSTcleanupsResponse201DataLinks
from .pos_tcleanups_response_201_data_relationships import POSTcleanupsResponse201DataRelationships
from .pos_tcleanups_response_201_data_relationships_events import POSTcleanupsResponse201DataRelationshipsEvents
from .pos_tcleanups_response_201_data_relationships_events_data import (
    POSTcleanupsResponse201DataRelationshipsEventsData,
)
from .pos_tcleanups_response_201_data_relationships_events_data_type import (
    POSTcleanupsResponse201DataRelationshipsEventsDataType,
)
from .pos_tcleanups_response_201_data_relationships_events_links import (
    POSTcleanupsResponse201DataRelationshipsEventsLinks,
)
from .pos_tcleanups_response_201_data_type import POSTcleanupsResponse201DataType
from .pos_tcoupon_codes_promotion_rules_response_201 import POSTcouponCodesPromotionRulesResponse201
from .pos_tcoupon_codes_promotion_rules_response_201_data import POSTcouponCodesPromotionRulesResponse201Data
from .pos_tcoupon_codes_promotion_rules_response_201_data_attributes import (
    POSTcouponCodesPromotionRulesResponse201DataAttributes,
)
from .pos_tcoupon_codes_promotion_rules_response_201_data_attributes_metadata import (
    POSTcouponCodesPromotionRulesResponse201DataAttributesMetadata,
)
from .pos_tcoupon_codes_promotion_rules_response_201_data_links import POSTcouponCodesPromotionRulesResponse201DataLinks
from .pos_tcoupon_codes_promotion_rules_response_201_data_relationships import (
    POSTcouponCodesPromotionRulesResponse201DataRelationships,
)
from .pos_tcoupon_codes_promotion_rules_response_201_data_relationships_coupons import (
    POSTcouponCodesPromotionRulesResponse201DataRelationshipsCoupons,
)
from .pos_tcoupon_codes_promotion_rules_response_201_data_relationships_coupons_data import (
    POSTcouponCodesPromotionRulesResponse201DataRelationshipsCouponsData,
)
from .pos_tcoupon_codes_promotion_rules_response_201_data_relationships_coupons_data_type import (
    POSTcouponCodesPromotionRulesResponse201DataRelationshipsCouponsDataType,
)
from .pos_tcoupon_codes_promotion_rules_response_201_data_relationships_coupons_links import (
    POSTcouponCodesPromotionRulesResponse201DataRelationshipsCouponsLinks,
)
from .pos_tcoupon_codes_promotion_rules_response_201_data_relationships_promotion import (
    POSTcouponCodesPromotionRulesResponse201DataRelationshipsPromotion,
)
from .pos_tcoupon_codes_promotion_rules_response_201_data_relationships_promotion_data import (
    POSTcouponCodesPromotionRulesResponse201DataRelationshipsPromotionData,
)
from .pos_tcoupon_codes_promotion_rules_response_201_data_relationships_promotion_data_type import (
    POSTcouponCodesPromotionRulesResponse201DataRelationshipsPromotionDataType,
)
from .pos_tcoupon_codes_promotion_rules_response_201_data_relationships_promotion_links import (
    POSTcouponCodesPromotionRulesResponse201DataRelationshipsPromotionLinks,
)
from .pos_tcoupon_codes_promotion_rules_response_201_data_type import POSTcouponCodesPromotionRulesResponse201DataType
from .pos_tcoupon_recipients_response_201 import POSTcouponRecipientsResponse201
from .pos_tcoupon_recipients_response_201_data import POSTcouponRecipientsResponse201Data
from .pos_tcoupon_recipients_response_201_data_attributes import POSTcouponRecipientsResponse201DataAttributes
from .pos_tcoupon_recipients_response_201_data_attributes_metadata import (
    POSTcouponRecipientsResponse201DataAttributesMetadata,
)
from .pos_tcoupon_recipients_response_201_data_links import POSTcouponRecipientsResponse201DataLinks
from .pos_tcoupon_recipients_response_201_data_relationships import POSTcouponRecipientsResponse201DataRelationships
from .pos_tcoupon_recipients_response_201_data_relationships_attachments import (
    POSTcouponRecipientsResponse201DataRelationshipsAttachments,
)
from .pos_tcoupon_recipients_response_201_data_relationships_attachments_data import (
    POSTcouponRecipientsResponse201DataRelationshipsAttachmentsData,
)
from .pos_tcoupon_recipients_response_201_data_relationships_attachments_data_type import (
    POSTcouponRecipientsResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tcoupon_recipients_response_201_data_relationships_attachments_links import (
    POSTcouponRecipientsResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tcoupon_recipients_response_201_data_relationships_customer import (
    POSTcouponRecipientsResponse201DataRelationshipsCustomer,
)
from .pos_tcoupon_recipients_response_201_data_relationships_customer_data import (
    POSTcouponRecipientsResponse201DataRelationshipsCustomerData,
)
from .pos_tcoupon_recipients_response_201_data_relationships_customer_data_type import (
    POSTcouponRecipientsResponse201DataRelationshipsCustomerDataType,
)
from .pos_tcoupon_recipients_response_201_data_relationships_customer_links import (
    POSTcouponRecipientsResponse201DataRelationshipsCustomerLinks,
)
from .pos_tcoupon_recipients_response_201_data_type import POSTcouponRecipientsResponse201DataType
from .pos_tcoupons_response_201 import POSTcouponsResponse201
from .pos_tcoupons_response_201_data import POSTcouponsResponse201Data
from .pos_tcoupons_response_201_data_attributes import POSTcouponsResponse201DataAttributes
from .pos_tcoupons_response_201_data_attributes_metadata import POSTcouponsResponse201DataAttributesMetadata
from .pos_tcoupons_response_201_data_links import POSTcouponsResponse201DataLinks
from .pos_tcoupons_response_201_data_relationships import POSTcouponsResponse201DataRelationships
from .pos_tcoupons_response_201_data_relationships_promotion_rule import (
    POSTcouponsResponse201DataRelationshipsPromotionRule,
)
from .pos_tcoupons_response_201_data_relationships_promotion_rule_data import (
    POSTcouponsResponse201DataRelationshipsPromotionRuleData,
)
from .pos_tcoupons_response_201_data_relationships_promotion_rule_data_type import (
    POSTcouponsResponse201DataRelationshipsPromotionRuleDataType,
)
from .pos_tcoupons_response_201_data_relationships_promotion_rule_links import (
    POSTcouponsResponse201DataRelationshipsPromotionRuleLinks,
)
from .pos_tcoupons_response_201_data_type import POSTcouponsResponse201DataType
from .pos_tcustomer_addresses_response_201 import POSTcustomerAddressesResponse201
from .pos_tcustomer_addresses_response_201_data import POSTcustomerAddressesResponse201Data
from .pos_tcustomer_addresses_response_201_data_attributes import POSTcustomerAddressesResponse201DataAttributes
from .pos_tcustomer_addresses_response_201_data_attributes_metadata import (
    POSTcustomerAddressesResponse201DataAttributesMetadata,
)
from .pos_tcustomer_addresses_response_201_data_links import POSTcustomerAddressesResponse201DataLinks
from .pos_tcustomer_addresses_response_201_data_relationships import POSTcustomerAddressesResponse201DataRelationships
from .pos_tcustomer_addresses_response_201_data_relationships_address import (
    POSTcustomerAddressesResponse201DataRelationshipsAddress,
)
from .pos_tcustomer_addresses_response_201_data_relationships_address_data import (
    POSTcustomerAddressesResponse201DataRelationshipsAddressData,
)
from .pos_tcustomer_addresses_response_201_data_relationships_address_data_type import (
    POSTcustomerAddressesResponse201DataRelationshipsAddressDataType,
)
from .pos_tcustomer_addresses_response_201_data_relationships_address_links import (
    POSTcustomerAddressesResponse201DataRelationshipsAddressLinks,
)
from .pos_tcustomer_addresses_response_201_data_relationships_customer import (
    POSTcustomerAddressesResponse201DataRelationshipsCustomer,
)
from .pos_tcustomer_addresses_response_201_data_relationships_customer_data import (
    POSTcustomerAddressesResponse201DataRelationshipsCustomerData,
)
from .pos_tcustomer_addresses_response_201_data_relationships_customer_data_type import (
    POSTcustomerAddressesResponse201DataRelationshipsCustomerDataType,
)
from .pos_tcustomer_addresses_response_201_data_relationships_customer_links import (
    POSTcustomerAddressesResponse201DataRelationshipsCustomerLinks,
)
from .pos_tcustomer_addresses_response_201_data_relationships_events import (
    POSTcustomerAddressesResponse201DataRelationshipsEvents,
)
from .pos_tcustomer_addresses_response_201_data_relationships_events_data import (
    POSTcustomerAddressesResponse201DataRelationshipsEventsData,
)
from .pos_tcustomer_addresses_response_201_data_relationships_events_data_type import (
    POSTcustomerAddressesResponse201DataRelationshipsEventsDataType,
)
from .pos_tcustomer_addresses_response_201_data_relationships_events_links import (
    POSTcustomerAddressesResponse201DataRelationshipsEventsLinks,
)
from .pos_tcustomer_addresses_response_201_data_type import POSTcustomerAddressesResponse201DataType
from .pos_tcustomer_groups_response_201 import POSTcustomerGroupsResponse201
from .pos_tcustomer_groups_response_201_data import POSTcustomerGroupsResponse201Data
from .pos_tcustomer_groups_response_201_data_attributes import POSTcustomerGroupsResponse201DataAttributes
from .pos_tcustomer_groups_response_201_data_attributes_metadata import (
    POSTcustomerGroupsResponse201DataAttributesMetadata,
)
from .pos_tcustomer_groups_response_201_data_links import POSTcustomerGroupsResponse201DataLinks
from .pos_tcustomer_groups_response_201_data_relationships import POSTcustomerGroupsResponse201DataRelationships
from .pos_tcustomer_groups_response_201_data_relationships_attachments import (
    POSTcustomerGroupsResponse201DataRelationshipsAttachments,
)
from .pos_tcustomer_groups_response_201_data_relationships_attachments_data import (
    POSTcustomerGroupsResponse201DataRelationshipsAttachmentsData,
)
from .pos_tcustomer_groups_response_201_data_relationships_attachments_data_type import (
    POSTcustomerGroupsResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tcustomer_groups_response_201_data_relationships_attachments_links import (
    POSTcustomerGroupsResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tcustomer_groups_response_201_data_relationships_customers import (
    POSTcustomerGroupsResponse201DataRelationshipsCustomers,
)
from .pos_tcustomer_groups_response_201_data_relationships_customers_data import (
    POSTcustomerGroupsResponse201DataRelationshipsCustomersData,
)
from .pos_tcustomer_groups_response_201_data_relationships_customers_data_type import (
    POSTcustomerGroupsResponse201DataRelationshipsCustomersDataType,
)
from .pos_tcustomer_groups_response_201_data_relationships_customers_links import (
    POSTcustomerGroupsResponse201DataRelationshipsCustomersLinks,
)
from .pos_tcustomer_groups_response_201_data_relationships_markets import (
    POSTcustomerGroupsResponse201DataRelationshipsMarkets,
)
from .pos_tcustomer_groups_response_201_data_relationships_markets_data import (
    POSTcustomerGroupsResponse201DataRelationshipsMarketsData,
)
from .pos_tcustomer_groups_response_201_data_relationships_markets_data_type import (
    POSTcustomerGroupsResponse201DataRelationshipsMarketsDataType,
)
from .pos_tcustomer_groups_response_201_data_relationships_markets_links import (
    POSTcustomerGroupsResponse201DataRelationshipsMarketsLinks,
)
from .pos_tcustomer_groups_response_201_data_type import POSTcustomerGroupsResponse201DataType
from .pos_tcustomer_password_resets_response_201 import POSTcustomerPasswordResetsResponse201
from .pos_tcustomer_password_resets_response_201_data import POSTcustomerPasswordResetsResponse201Data
from .pos_tcustomer_password_resets_response_201_data_attributes import (
    POSTcustomerPasswordResetsResponse201DataAttributes,
)
from .pos_tcustomer_password_resets_response_201_data_attributes_metadata import (
    POSTcustomerPasswordResetsResponse201DataAttributesMetadata,
)
from .pos_tcustomer_password_resets_response_201_data_links import POSTcustomerPasswordResetsResponse201DataLinks
from .pos_tcustomer_password_resets_response_201_data_relationships import (
    POSTcustomerPasswordResetsResponse201DataRelationships,
)
from .pos_tcustomer_password_resets_response_201_data_relationships_customer import (
    POSTcustomerPasswordResetsResponse201DataRelationshipsCustomer,
)
from .pos_tcustomer_password_resets_response_201_data_relationships_customer_data import (
    POSTcustomerPasswordResetsResponse201DataRelationshipsCustomerData,
)
from .pos_tcustomer_password_resets_response_201_data_relationships_customer_data_type import (
    POSTcustomerPasswordResetsResponse201DataRelationshipsCustomerDataType,
)
from .pos_tcustomer_password_resets_response_201_data_relationships_customer_links import (
    POSTcustomerPasswordResetsResponse201DataRelationshipsCustomerLinks,
)
from .pos_tcustomer_password_resets_response_201_data_relationships_events import (
    POSTcustomerPasswordResetsResponse201DataRelationshipsEvents,
)
from .pos_tcustomer_password_resets_response_201_data_relationships_events_data import (
    POSTcustomerPasswordResetsResponse201DataRelationshipsEventsData,
)
from .pos_tcustomer_password_resets_response_201_data_relationships_events_data_type import (
    POSTcustomerPasswordResetsResponse201DataRelationshipsEventsDataType,
)
from .pos_tcustomer_password_resets_response_201_data_relationships_events_links import (
    POSTcustomerPasswordResetsResponse201DataRelationshipsEventsLinks,
)
from .pos_tcustomer_password_resets_response_201_data_type import POSTcustomerPasswordResetsResponse201DataType
from .pos_tcustomer_payment_sources_response_201 import POSTcustomerPaymentSourcesResponse201
from .pos_tcustomer_payment_sources_response_201_data import POSTcustomerPaymentSourcesResponse201Data
from .pos_tcustomer_payment_sources_response_201_data_attributes import (
    POSTcustomerPaymentSourcesResponse201DataAttributes,
)
from .pos_tcustomer_payment_sources_response_201_data_attributes_metadata import (
    POSTcustomerPaymentSourcesResponse201DataAttributesMetadata,
)
from .pos_tcustomer_payment_sources_response_201_data_links import POSTcustomerPaymentSourcesResponse201DataLinks
from .pos_tcustomer_payment_sources_response_201_data_relationships import (
    POSTcustomerPaymentSourcesResponse201DataRelationships,
)
from .pos_tcustomer_payment_sources_response_201_data_relationships_customer import (
    POSTcustomerPaymentSourcesResponse201DataRelationshipsCustomer,
)
from .pos_tcustomer_payment_sources_response_201_data_relationships_customer_data import (
    POSTcustomerPaymentSourcesResponse201DataRelationshipsCustomerData,
)
from .pos_tcustomer_payment_sources_response_201_data_relationships_customer_data_type import (
    POSTcustomerPaymentSourcesResponse201DataRelationshipsCustomerDataType,
)
from .pos_tcustomer_payment_sources_response_201_data_relationships_customer_links import (
    POSTcustomerPaymentSourcesResponse201DataRelationshipsCustomerLinks,
)
from .pos_tcustomer_payment_sources_response_201_data_relationships_payment_source import (
    POSTcustomerPaymentSourcesResponse201DataRelationshipsPaymentSource,
)
from .pos_tcustomer_payment_sources_response_201_data_relationships_payment_source_data import (
    POSTcustomerPaymentSourcesResponse201DataRelationshipsPaymentSourceData,
)
from .pos_tcustomer_payment_sources_response_201_data_relationships_payment_source_data_type import (
    POSTcustomerPaymentSourcesResponse201DataRelationshipsPaymentSourceDataType,
)
from .pos_tcustomer_payment_sources_response_201_data_relationships_payment_source_links import (
    POSTcustomerPaymentSourcesResponse201DataRelationshipsPaymentSourceLinks,
)
from .pos_tcustomer_payment_sources_response_201_data_type import POSTcustomerPaymentSourcesResponse201DataType
from .pos_tcustomer_subscriptions_response_201 import POSTcustomerSubscriptionsResponse201
from .pos_tcustomer_subscriptions_response_201_data import POSTcustomerSubscriptionsResponse201Data
from .pos_tcustomer_subscriptions_response_201_data_attributes import POSTcustomerSubscriptionsResponse201DataAttributes
from .pos_tcustomer_subscriptions_response_201_data_attributes_metadata import (
    POSTcustomerSubscriptionsResponse201DataAttributesMetadata,
)
from .pos_tcustomer_subscriptions_response_201_data_links import POSTcustomerSubscriptionsResponse201DataLinks
from .pos_tcustomer_subscriptions_response_201_data_relationships import (
    POSTcustomerSubscriptionsResponse201DataRelationships,
)
from .pos_tcustomer_subscriptions_response_201_data_relationships_customer import (
    POSTcustomerSubscriptionsResponse201DataRelationshipsCustomer,
)
from .pos_tcustomer_subscriptions_response_201_data_relationships_customer_data import (
    POSTcustomerSubscriptionsResponse201DataRelationshipsCustomerData,
)
from .pos_tcustomer_subscriptions_response_201_data_relationships_customer_data_type import (
    POSTcustomerSubscriptionsResponse201DataRelationshipsCustomerDataType,
)
from .pos_tcustomer_subscriptions_response_201_data_relationships_customer_links import (
    POSTcustomerSubscriptionsResponse201DataRelationshipsCustomerLinks,
)
from .pos_tcustomer_subscriptions_response_201_data_relationships_events import (
    POSTcustomerSubscriptionsResponse201DataRelationshipsEvents,
)
from .pos_tcustomer_subscriptions_response_201_data_relationships_events_data import (
    POSTcustomerSubscriptionsResponse201DataRelationshipsEventsData,
)
from .pos_tcustomer_subscriptions_response_201_data_relationships_events_data_type import (
    POSTcustomerSubscriptionsResponse201DataRelationshipsEventsDataType,
)
from .pos_tcustomer_subscriptions_response_201_data_relationships_events_links import (
    POSTcustomerSubscriptionsResponse201DataRelationshipsEventsLinks,
)
from .pos_tcustomer_subscriptions_response_201_data_type import POSTcustomerSubscriptionsResponse201DataType
from .pos_tcustomers_response_201 import POSTcustomersResponse201
from .pos_tcustomers_response_201_data import POSTcustomersResponse201Data
from .pos_tcustomers_response_201_data_attributes import POSTcustomersResponse201DataAttributes
from .pos_tcustomers_response_201_data_attributes_metadata import POSTcustomersResponse201DataAttributesMetadata
from .pos_tcustomers_response_201_data_links import POSTcustomersResponse201DataLinks
from .pos_tcustomers_response_201_data_relationships import POSTcustomersResponse201DataRelationships
from .pos_tcustomers_response_201_data_relationships_attachments import (
    POSTcustomersResponse201DataRelationshipsAttachments,
)
from .pos_tcustomers_response_201_data_relationships_attachments_data import (
    POSTcustomersResponse201DataRelationshipsAttachmentsData,
)
from .pos_tcustomers_response_201_data_relationships_attachments_data_type import (
    POSTcustomersResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tcustomers_response_201_data_relationships_attachments_links import (
    POSTcustomersResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tcustomers_response_201_data_relationships_customer_addresses import (
    POSTcustomersResponse201DataRelationshipsCustomerAddresses,
)
from .pos_tcustomers_response_201_data_relationships_customer_addresses_data import (
    POSTcustomersResponse201DataRelationshipsCustomerAddressesData,
)
from .pos_tcustomers_response_201_data_relationships_customer_addresses_data_type import (
    POSTcustomersResponse201DataRelationshipsCustomerAddressesDataType,
)
from .pos_tcustomers_response_201_data_relationships_customer_addresses_links import (
    POSTcustomersResponse201DataRelationshipsCustomerAddressesLinks,
)
from .pos_tcustomers_response_201_data_relationships_customer_group import (
    POSTcustomersResponse201DataRelationshipsCustomerGroup,
)
from .pos_tcustomers_response_201_data_relationships_customer_group_data import (
    POSTcustomersResponse201DataRelationshipsCustomerGroupData,
)
from .pos_tcustomers_response_201_data_relationships_customer_group_data_type import (
    POSTcustomersResponse201DataRelationshipsCustomerGroupDataType,
)
from .pos_tcustomers_response_201_data_relationships_customer_group_links import (
    POSTcustomersResponse201DataRelationshipsCustomerGroupLinks,
)
from .pos_tcustomers_response_201_data_relationships_customer_payment_sources import (
    POSTcustomersResponse201DataRelationshipsCustomerPaymentSources,
)
from .pos_tcustomers_response_201_data_relationships_customer_payment_sources_data import (
    POSTcustomersResponse201DataRelationshipsCustomerPaymentSourcesData,
)
from .pos_tcustomers_response_201_data_relationships_customer_payment_sources_data_type import (
    POSTcustomersResponse201DataRelationshipsCustomerPaymentSourcesDataType,
)
from .pos_tcustomers_response_201_data_relationships_customer_payment_sources_links import (
    POSTcustomersResponse201DataRelationshipsCustomerPaymentSourcesLinks,
)
from .pos_tcustomers_response_201_data_relationships_customer_subscriptions import (
    POSTcustomersResponse201DataRelationshipsCustomerSubscriptions,
)
from .pos_tcustomers_response_201_data_relationships_customer_subscriptions_data import (
    POSTcustomersResponse201DataRelationshipsCustomerSubscriptionsData,
)
from .pos_tcustomers_response_201_data_relationships_customer_subscriptions_data_type import (
    POSTcustomersResponse201DataRelationshipsCustomerSubscriptionsDataType,
)
from .pos_tcustomers_response_201_data_relationships_customer_subscriptions_links import (
    POSTcustomersResponse201DataRelationshipsCustomerSubscriptionsLinks,
)
from .pos_tcustomers_response_201_data_relationships_events import POSTcustomersResponse201DataRelationshipsEvents
from .pos_tcustomers_response_201_data_relationships_events_data import (
    POSTcustomersResponse201DataRelationshipsEventsData,
)
from .pos_tcustomers_response_201_data_relationships_events_data_type import (
    POSTcustomersResponse201DataRelationshipsEventsDataType,
)
from .pos_tcustomers_response_201_data_relationships_events_links import (
    POSTcustomersResponse201DataRelationshipsEventsLinks,
)
from .pos_tcustomers_response_201_data_relationships_order_subscriptions import (
    POSTcustomersResponse201DataRelationshipsOrderSubscriptions,
)
from .pos_tcustomers_response_201_data_relationships_order_subscriptions_data import (
    POSTcustomersResponse201DataRelationshipsOrderSubscriptionsData,
)
from .pos_tcustomers_response_201_data_relationships_order_subscriptions_data_type import (
    POSTcustomersResponse201DataRelationshipsOrderSubscriptionsDataType,
)
from .pos_tcustomers_response_201_data_relationships_order_subscriptions_links import (
    POSTcustomersResponse201DataRelationshipsOrderSubscriptionsLinks,
)
from .pos_tcustomers_response_201_data_relationships_orders import POSTcustomersResponse201DataRelationshipsOrders
from .pos_tcustomers_response_201_data_relationships_orders_data import (
    POSTcustomersResponse201DataRelationshipsOrdersData,
)
from .pos_tcustomers_response_201_data_relationships_orders_data_type import (
    POSTcustomersResponse201DataRelationshipsOrdersDataType,
)
from .pos_tcustomers_response_201_data_relationships_orders_links import (
    POSTcustomersResponse201DataRelationshipsOrdersLinks,
)
from .pos_tcustomers_response_201_data_relationships_returns import POSTcustomersResponse201DataRelationshipsReturns
from .pos_tcustomers_response_201_data_relationships_returns_data import (
    POSTcustomersResponse201DataRelationshipsReturnsData,
)
from .pos_tcustomers_response_201_data_relationships_returns_data_type import (
    POSTcustomersResponse201DataRelationshipsReturnsDataType,
)
from .pos_tcustomers_response_201_data_relationships_returns_links import (
    POSTcustomersResponse201DataRelationshipsReturnsLinks,
)
from .pos_tcustomers_response_201_data_relationships_sku_lists import POSTcustomersResponse201DataRelationshipsSkuLists
from .pos_tcustomers_response_201_data_relationships_sku_lists_data import (
    POSTcustomersResponse201DataRelationshipsSkuListsData,
)
from .pos_tcustomers_response_201_data_relationships_sku_lists_data_type import (
    POSTcustomersResponse201DataRelationshipsSkuListsDataType,
)
from .pos_tcustomers_response_201_data_relationships_sku_lists_links import (
    POSTcustomersResponse201DataRelationshipsSkuListsLinks,
)
from .pos_tcustomers_response_201_data_type import POSTcustomersResponse201DataType
from .pos_tdelivery_lead_times_response_201 import POSTdeliveryLeadTimesResponse201
from .pos_tdelivery_lead_times_response_201_data import POSTdeliveryLeadTimesResponse201Data
from .pos_tdelivery_lead_times_response_201_data_attributes import POSTdeliveryLeadTimesResponse201DataAttributes
from .pos_tdelivery_lead_times_response_201_data_attributes_metadata import (
    POSTdeliveryLeadTimesResponse201DataAttributesMetadata,
)
from .pos_tdelivery_lead_times_response_201_data_links import POSTdeliveryLeadTimesResponse201DataLinks
from .pos_tdelivery_lead_times_response_201_data_relationships import POSTdeliveryLeadTimesResponse201DataRelationships
from .pos_tdelivery_lead_times_response_201_data_relationships_attachments import (
    POSTdeliveryLeadTimesResponse201DataRelationshipsAttachments,
)
from .pos_tdelivery_lead_times_response_201_data_relationships_attachments_data import (
    POSTdeliveryLeadTimesResponse201DataRelationshipsAttachmentsData,
)
from .pos_tdelivery_lead_times_response_201_data_relationships_attachments_data_type import (
    POSTdeliveryLeadTimesResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tdelivery_lead_times_response_201_data_relationships_attachments_links import (
    POSTdeliveryLeadTimesResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tdelivery_lead_times_response_201_data_relationships_shipping_method import (
    POSTdeliveryLeadTimesResponse201DataRelationshipsShippingMethod,
)
from .pos_tdelivery_lead_times_response_201_data_relationships_shipping_method_data import (
    POSTdeliveryLeadTimesResponse201DataRelationshipsShippingMethodData,
)
from .pos_tdelivery_lead_times_response_201_data_relationships_shipping_method_data_type import (
    POSTdeliveryLeadTimesResponse201DataRelationshipsShippingMethodDataType,
)
from .pos_tdelivery_lead_times_response_201_data_relationships_shipping_method_links import (
    POSTdeliveryLeadTimesResponse201DataRelationshipsShippingMethodLinks,
)
from .pos_tdelivery_lead_times_response_201_data_relationships_stock_location import (
    POSTdeliveryLeadTimesResponse201DataRelationshipsStockLocation,
)
from .pos_tdelivery_lead_times_response_201_data_relationships_stock_location_data import (
    POSTdeliveryLeadTimesResponse201DataRelationshipsStockLocationData,
)
from .pos_tdelivery_lead_times_response_201_data_relationships_stock_location_data_type import (
    POSTdeliveryLeadTimesResponse201DataRelationshipsStockLocationDataType,
)
from .pos_tdelivery_lead_times_response_201_data_relationships_stock_location_links import (
    POSTdeliveryLeadTimesResponse201DataRelationshipsStockLocationLinks,
)
from .pos_tdelivery_lead_times_response_201_data_type import POSTdeliveryLeadTimesResponse201DataType
from .pos_texports_response_201 import POSTexportsResponse201
from .pos_texports_response_201_data import POSTexportsResponse201Data
from .pos_texports_response_201_data_attributes import POSTexportsResponse201DataAttributes
from .pos_texports_response_201_data_attributes_filters import POSTexportsResponse201DataAttributesFilters
from .pos_texports_response_201_data_attributes_metadata import POSTexportsResponse201DataAttributesMetadata
from .pos_texports_response_201_data_links import POSTexportsResponse201DataLinks
from .pos_texports_response_201_data_relationships import POSTexportsResponse201DataRelationships
from .pos_texports_response_201_data_relationships_events import POSTexportsResponse201DataRelationshipsEvents
from .pos_texports_response_201_data_relationships_events_data import POSTexportsResponse201DataRelationshipsEventsData
from .pos_texports_response_201_data_relationships_events_data_type import (
    POSTexportsResponse201DataRelationshipsEventsDataType,
)
from .pos_texports_response_201_data_relationships_events_links import (
    POSTexportsResponse201DataRelationshipsEventsLinks,
)
from .pos_texports_response_201_data_type import POSTexportsResponse201DataType
from .pos_texternal_gateways_response_201 import POSTexternalGatewaysResponse201
from .pos_texternal_gateways_response_201_data import POSTexternalGatewaysResponse201Data
from .pos_texternal_gateways_response_201_data_attributes import POSTexternalGatewaysResponse201DataAttributes
from .pos_texternal_gateways_response_201_data_attributes_metadata import (
    POSTexternalGatewaysResponse201DataAttributesMetadata,
)
from .pos_texternal_gateways_response_201_data_links import POSTexternalGatewaysResponse201DataLinks
from .pos_texternal_gateways_response_201_data_relationships import POSTexternalGatewaysResponse201DataRelationships
from .pos_texternal_gateways_response_201_data_relationships_external_payments import (
    POSTexternalGatewaysResponse201DataRelationshipsExternalPayments,
)
from .pos_texternal_gateways_response_201_data_relationships_external_payments_data import (
    POSTexternalGatewaysResponse201DataRelationshipsExternalPaymentsData,
)
from .pos_texternal_gateways_response_201_data_relationships_external_payments_data_type import (
    POSTexternalGatewaysResponse201DataRelationshipsExternalPaymentsDataType,
)
from .pos_texternal_gateways_response_201_data_relationships_external_payments_links import (
    POSTexternalGatewaysResponse201DataRelationshipsExternalPaymentsLinks,
)
from .pos_texternal_gateways_response_201_data_relationships_payment_methods import (
    POSTexternalGatewaysResponse201DataRelationshipsPaymentMethods,
)
from .pos_texternal_gateways_response_201_data_relationships_payment_methods_data import (
    POSTexternalGatewaysResponse201DataRelationshipsPaymentMethodsData,
)
from .pos_texternal_gateways_response_201_data_relationships_payment_methods_data_type import (
    POSTexternalGatewaysResponse201DataRelationshipsPaymentMethodsDataType,
)
from .pos_texternal_gateways_response_201_data_relationships_payment_methods_links import (
    POSTexternalGatewaysResponse201DataRelationshipsPaymentMethodsLinks,
)
from .pos_texternal_gateways_response_201_data_type import POSTexternalGatewaysResponse201DataType
from .pos_texternal_payments_response_201 import POSTexternalPaymentsResponse201
from .pos_texternal_payments_response_201_data import POSTexternalPaymentsResponse201Data
from .pos_texternal_payments_response_201_data_attributes import POSTexternalPaymentsResponse201DataAttributes
from .pos_texternal_payments_response_201_data_attributes_metadata import (
    POSTexternalPaymentsResponse201DataAttributesMetadata,
)
from .pos_texternal_payments_response_201_data_attributes_options import (
    POSTexternalPaymentsResponse201DataAttributesOptions,
)
from .pos_texternal_payments_response_201_data_links import POSTexternalPaymentsResponse201DataLinks
from .pos_texternal_payments_response_201_data_relationships import POSTexternalPaymentsResponse201DataRelationships
from .pos_texternal_payments_response_201_data_relationships_order import (
    POSTexternalPaymentsResponse201DataRelationshipsOrder,
)
from .pos_texternal_payments_response_201_data_relationships_order_data import (
    POSTexternalPaymentsResponse201DataRelationshipsOrderData,
)
from .pos_texternal_payments_response_201_data_relationships_order_data_type import (
    POSTexternalPaymentsResponse201DataRelationshipsOrderDataType,
)
from .pos_texternal_payments_response_201_data_relationships_order_links import (
    POSTexternalPaymentsResponse201DataRelationshipsOrderLinks,
)
from .pos_texternal_payments_response_201_data_relationships_payment_gateway import (
    POSTexternalPaymentsResponse201DataRelationshipsPaymentGateway,
)
from .pos_texternal_payments_response_201_data_relationships_payment_gateway_data import (
    POSTexternalPaymentsResponse201DataRelationshipsPaymentGatewayData,
)
from .pos_texternal_payments_response_201_data_relationships_payment_gateway_data_type import (
    POSTexternalPaymentsResponse201DataRelationshipsPaymentGatewayDataType,
)
from .pos_texternal_payments_response_201_data_relationships_payment_gateway_links import (
    POSTexternalPaymentsResponse201DataRelationshipsPaymentGatewayLinks,
)
from .pos_texternal_payments_response_201_data_relationships_wallet import (
    POSTexternalPaymentsResponse201DataRelationshipsWallet,
)
from .pos_texternal_payments_response_201_data_relationships_wallet_data import (
    POSTexternalPaymentsResponse201DataRelationshipsWalletData,
)
from .pos_texternal_payments_response_201_data_relationships_wallet_data_type import (
    POSTexternalPaymentsResponse201DataRelationshipsWalletDataType,
)
from .pos_texternal_payments_response_201_data_relationships_wallet_links import (
    POSTexternalPaymentsResponse201DataRelationshipsWalletLinks,
)
from .pos_texternal_payments_response_201_data_type import POSTexternalPaymentsResponse201DataType
from .pos_texternal_promotions_response_201 import POSTexternalPromotionsResponse201
from .pos_texternal_promotions_response_201_data import POSTexternalPromotionsResponse201Data
from .pos_texternal_promotions_response_201_data_attributes import POSTexternalPromotionsResponse201DataAttributes
from .pos_texternal_promotions_response_201_data_attributes_metadata import (
    POSTexternalPromotionsResponse201DataAttributesMetadata,
)
from .pos_texternal_promotions_response_201_data_links import POSTexternalPromotionsResponse201DataLinks
from .pos_texternal_promotions_response_201_data_relationships import POSTexternalPromotionsResponse201DataRelationships
from .pos_texternal_promotions_response_201_data_relationships_attachments import (
    POSTexternalPromotionsResponse201DataRelationshipsAttachments,
)
from .pos_texternal_promotions_response_201_data_relationships_attachments_data import (
    POSTexternalPromotionsResponse201DataRelationshipsAttachmentsData,
)
from .pos_texternal_promotions_response_201_data_relationships_attachments_data_type import (
    POSTexternalPromotionsResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_texternal_promotions_response_201_data_relationships_attachments_links import (
    POSTexternalPromotionsResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_texternal_promotions_response_201_data_relationships_coupon_codes_promotion_rule import (
    POSTexternalPromotionsResponse201DataRelationshipsCouponCodesPromotionRule,
)
from .pos_texternal_promotions_response_201_data_relationships_coupon_codes_promotion_rule_data import (
    POSTexternalPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleData,
)
from .pos_texternal_promotions_response_201_data_relationships_coupon_codes_promotion_rule_data_type import (
    POSTexternalPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleDataType,
)
from .pos_texternal_promotions_response_201_data_relationships_coupon_codes_promotion_rule_links import (
    POSTexternalPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleLinks,
)
from .pos_texternal_promotions_response_201_data_relationships_market import (
    POSTexternalPromotionsResponse201DataRelationshipsMarket,
)
from .pos_texternal_promotions_response_201_data_relationships_market_data import (
    POSTexternalPromotionsResponse201DataRelationshipsMarketData,
)
from .pos_texternal_promotions_response_201_data_relationships_market_data_type import (
    POSTexternalPromotionsResponse201DataRelationshipsMarketDataType,
)
from .pos_texternal_promotions_response_201_data_relationships_market_links import (
    POSTexternalPromotionsResponse201DataRelationshipsMarketLinks,
)
from .pos_texternal_promotions_response_201_data_relationships_order_amount_promotion_rule import (
    POSTexternalPromotionsResponse201DataRelationshipsOrderAmountPromotionRule,
)
from .pos_texternal_promotions_response_201_data_relationships_order_amount_promotion_rule_data import (
    POSTexternalPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleData,
)
from .pos_texternal_promotions_response_201_data_relationships_order_amount_promotion_rule_data_type import (
    POSTexternalPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleDataType,
)
from .pos_texternal_promotions_response_201_data_relationships_order_amount_promotion_rule_links import (
    POSTexternalPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleLinks,
)
from .pos_texternal_promotions_response_201_data_relationships_promotion_rules import (
    POSTexternalPromotionsResponse201DataRelationshipsPromotionRules,
)
from .pos_texternal_promotions_response_201_data_relationships_promotion_rules_data import (
    POSTexternalPromotionsResponse201DataRelationshipsPromotionRulesData,
)
from .pos_texternal_promotions_response_201_data_relationships_promotion_rules_data_type import (
    POSTexternalPromotionsResponse201DataRelationshipsPromotionRulesDataType,
)
from .pos_texternal_promotions_response_201_data_relationships_promotion_rules_links import (
    POSTexternalPromotionsResponse201DataRelationshipsPromotionRulesLinks,
)
from .pos_texternal_promotions_response_201_data_relationships_sku_list_promotion_rule import (
    POSTexternalPromotionsResponse201DataRelationshipsSkuListPromotionRule,
)
from .pos_texternal_promotions_response_201_data_relationships_sku_list_promotion_rule_data import (
    POSTexternalPromotionsResponse201DataRelationshipsSkuListPromotionRuleData,
)
from .pos_texternal_promotions_response_201_data_relationships_sku_list_promotion_rule_data_type import (
    POSTexternalPromotionsResponse201DataRelationshipsSkuListPromotionRuleDataType,
)
from .pos_texternal_promotions_response_201_data_relationships_sku_list_promotion_rule_links import (
    POSTexternalPromotionsResponse201DataRelationshipsSkuListPromotionRuleLinks,
)
from .pos_texternal_promotions_response_201_data_type import POSTexternalPromotionsResponse201DataType
from .pos_texternal_tax_calculators_response_201 import POSTexternalTaxCalculatorsResponse201
from .pos_texternal_tax_calculators_response_201_data import POSTexternalTaxCalculatorsResponse201Data
from .pos_texternal_tax_calculators_response_201_data_attributes import (
    POSTexternalTaxCalculatorsResponse201DataAttributes,
)
from .pos_texternal_tax_calculators_response_201_data_attributes_metadata import (
    POSTexternalTaxCalculatorsResponse201DataAttributesMetadata,
)
from .pos_texternal_tax_calculators_response_201_data_links import POSTexternalTaxCalculatorsResponse201DataLinks
from .pos_texternal_tax_calculators_response_201_data_relationships import (
    POSTexternalTaxCalculatorsResponse201DataRelationships,
)
from .pos_texternal_tax_calculators_response_201_data_relationships_attachments import (
    POSTexternalTaxCalculatorsResponse201DataRelationshipsAttachments,
)
from .pos_texternal_tax_calculators_response_201_data_relationships_attachments_data import (
    POSTexternalTaxCalculatorsResponse201DataRelationshipsAttachmentsData,
)
from .pos_texternal_tax_calculators_response_201_data_relationships_attachments_data_type import (
    POSTexternalTaxCalculatorsResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_texternal_tax_calculators_response_201_data_relationships_attachments_links import (
    POSTexternalTaxCalculatorsResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_texternal_tax_calculators_response_201_data_relationships_markets import (
    POSTexternalTaxCalculatorsResponse201DataRelationshipsMarkets,
)
from .pos_texternal_tax_calculators_response_201_data_relationships_markets_data import (
    POSTexternalTaxCalculatorsResponse201DataRelationshipsMarketsData,
)
from .pos_texternal_tax_calculators_response_201_data_relationships_markets_data_type import (
    POSTexternalTaxCalculatorsResponse201DataRelationshipsMarketsDataType,
)
from .pos_texternal_tax_calculators_response_201_data_relationships_markets_links import (
    POSTexternalTaxCalculatorsResponse201DataRelationshipsMarketsLinks,
)
from .pos_texternal_tax_calculators_response_201_data_type import POSTexternalTaxCalculatorsResponse201DataType
from .pos_tfixed_amount_promotions_response_201 import POSTfixedAmountPromotionsResponse201
from .pos_tfixed_amount_promotions_response_201_data import POSTfixedAmountPromotionsResponse201Data
from .pos_tfixed_amount_promotions_response_201_data_attributes import (
    POSTfixedAmountPromotionsResponse201DataAttributes,
)
from .pos_tfixed_amount_promotions_response_201_data_attributes_metadata import (
    POSTfixedAmountPromotionsResponse201DataAttributesMetadata,
)
from .pos_tfixed_amount_promotions_response_201_data_links import POSTfixedAmountPromotionsResponse201DataLinks
from .pos_tfixed_amount_promotions_response_201_data_relationships import (
    POSTfixedAmountPromotionsResponse201DataRelationships,
)
from .pos_tfixed_amount_promotions_response_201_data_relationships_attachments import (
    POSTfixedAmountPromotionsResponse201DataRelationshipsAttachments,
)
from .pos_tfixed_amount_promotions_response_201_data_relationships_attachments_data import (
    POSTfixedAmountPromotionsResponse201DataRelationshipsAttachmentsData,
)
from .pos_tfixed_amount_promotions_response_201_data_relationships_attachments_data_type import (
    POSTfixedAmountPromotionsResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tfixed_amount_promotions_response_201_data_relationships_attachments_links import (
    POSTfixedAmountPromotionsResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tfixed_amount_promotions_response_201_data_relationships_coupon_codes_promotion_rule import (
    POSTfixedAmountPromotionsResponse201DataRelationshipsCouponCodesPromotionRule,
)
from .pos_tfixed_amount_promotions_response_201_data_relationships_coupon_codes_promotion_rule_data import (
    POSTfixedAmountPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleData,
)
from .pos_tfixed_amount_promotions_response_201_data_relationships_coupon_codes_promotion_rule_data_type import (
    POSTfixedAmountPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleDataType,
)
from .pos_tfixed_amount_promotions_response_201_data_relationships_coupon_codes_promotion_rule_links import (
    POSTfixedAmountPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleLinks,
)
from .pos_tfixed_amount_promotions_response_201_data_relationships_market import (
    POSTfixedAmountPromotionsResponse201DataRelationshipsMarket,
)
from .pos_tfixed_amount_promotions_response_201_data_relationships_market_data import (
    POSTfixedAmountPromotionsResponse201DataRelationshipsMarketData,
)
from .pos_tfixed_amount_promotions_response_201_data_relationships_market_data_type import (
    POSTfixedAmountPromotionsResponse201DataRelationshipsMarketDataType,
)
from .pos_tfixed_amount_promotions_response_201_data_relationships_market_links import (
    POSTfixedAmountPromotionsResponse201DataRelationshipsMarketLinks,
)
from .pos_tfixed_amount_promotions_response_201_data_relationships_order_amount_promotion_rule import (
    POSTfixedAmountPromotionsResponse201DataRelationshipsOrderAmountPromotionRule,
)
from .pos_tfixed_amount_promotions_response_201_data_relationships_order_amount_promotion_rule_data import (
    POSTfixedAmountPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleData,
)
from .pos_tfixed_amount_promotions_response_201_data_relationships_order_amount_promotion_rule_data_type import (
    POSTfixedAmountPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleDataType,
)
from .pos_tfixed_amount_promotions_response_201_data_relationships_order_amount_promotion_rule_links import (
    POSTfixedAmountPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleLinks,
)
from .pos_tfixed_amount_promotions_response_201_data_relationships_promotion_rules import (
    POSTfixedAmountPromotionsResponse201DataRelationshipsPromotionRules,
)
from .pos_tfixed_amount_promotions_response_201_data_relationships_promotion_rules_data import (
    POSTfixedAmountPromotionsResponse201DataRelationshipsPromotionRulesData,
)
from .pos_tfixed_amount_promotions_response_201_data_relationships_promotion_rules_data_type import (
    POSTfixedAmountPromotionsResponse201DataRelationshipsPromotionRulesDataType,
)
from .pos_tfixed_amount_promotions_response_201_data_relationships_promotion_rules_links import (
    POSTfixedAmountPromotionsResponse201DataRelationshipsPromotionRulesLinks,
)
from .pos_tfixed_amount_promotions_response_201_data_relationships_sku_list_promotion_rule import (
    POSTfixedAmountPromotionsResponse201DataRelationshipsSkuListPromotionRule,
)
from .pos_tfixed_amount_promotions_response_201_data_relationships_sku_list_promotion_rule_data import (
    POSTfixedAmountPromotionsResponse201DataRelationshipsSkuListPromotionRuleData,
)
from .pos_tfixed_amount_promotions_response_201_data_relationships_sku_list_promotion_rule_data_type import (
    POSTfixedAmountPromotionsResponse201DataRelationshipsSkuListPromotionRuleDataType,
)
from .pos_tfixed_amount_promotions_response_201_data_relationships_sku_list_promotion_rule_links import (
    POSTfixedAmountPromotionsResponse201DataRelationshipsSkuListPromotionRuleLinks,
)
from .pos_tfixed_amount_promotions_response_201_data_type import POSTfixedAmountPromotionsResponse201DataType
from .pos_tfixed_price_promotions_response_201 import POSTfixedPricePromotionsResponse201
from .pos_tfixed_price_promotions_response_201_data import POSTfixedPricePromotionsResponse201Data
from .pos_tfixed_price_promotions_response_201_data_attributes import POSTfixedPricePromotionsResponse201DataAttributes
from .pos_tfixed_price_promotions_response_201_data_attributes_metadata import (
    POSTfixedPricePromotionsResponse201DataAttributesMetadata,
)
from .pos_tfixed_price_promotions_response_201_data_links import POSTfixedPricePromotionsResponse201DataLinks
from .pos_tfixed_price_promotions_response_201_data_relationships import (
    POSTfixedPricePromotionsResponse201DataRelationships,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_attachments import (
    POSTfixedPricePromotionsResponse201DataRelationshipsAttachments,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_attachments_data import (
    POSTfixedPricePromotionsResponse201DataRelationshipsAttachmentsData,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_attachments_data_type import (
    POSTfixedPricePromotionsResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_attachments_links import (
    POSTfixedPricePromotionsResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_coupon_codes_promotion_rule import (
    POSTfixedPricePromotionsResponse201DataRelationshipsCouponCodesPromotionRule,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_coupon_codes_promotion_rule_data import (
    POSTfixedPricePromotionsResponse201DataRelationshipsCouponCodesPromotionRuleData,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_coupon_codes_promotion_rule_data_type import (
    POSTfixedPricePromotionsResponse201DataRelationshipsCouponCodesPromotionRuleDataType,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_coupon_codes_promotion_rule_links import (
    POSTfixedPricePromotionsResponse201DataRelationshipsCouponCodesPromotionRuleLinks,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_market import (
    POSTfixedPricePromotionsResponse201DataRelationshipsMarket,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_market_data import (
    POSTfixedPricePromotionsResponse201DataRelationshipsMarketData,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_market_data_type import (
    POSTfixedPricePromotionsResponse201DataRelationshipsMarketDataType,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_market_links import (
    POSTfixedPricePromotionsResponse201DataRelationshipsMarketLinks,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_order_amount_promotion_rule import (
    POSTfixedPricePromotionsResponse201DataRelationshipsOrderAmountPromotionRule,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_order_amount_promotion_rule_data import (
    POSTfixedPricePromotionsResponse201DataRelationshipsOrderAmountPromotionRuleData,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_order_amount_promotion_rule_data_type import (
    POSTfixedPricePromotionsResponse201DataRelationshipsOrderAmountPromotionRuleDataType,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_order_amount_promotion_rule_links import (
    POSTfixedPricePromotionsResponse201DataRelationshipsOrderAmountPromotionRuleLinks,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_promotion_rules import (
    POSTfixedPricePromotionsResponse201DataRelationshipsPromotionRules,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_promotion_rules_data import (
    POSTfixedPricePromotionsResponse201DataRelationshipsPromotionRulesData,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_promotion_rules_data_type import (
    POSTfixedPricePromotionsResponse201DataRelationshipsPromotionRulesDataType,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_promotion_rules_links import (
    POSTfixedPricePromotionsResponse201DataRelationshipsPromotionRulesLinks,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_sku_list import (
    POSTfixedPricePromotionsResponse201DataRelationshipsSkuList,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_sku_list_data import (
    POSTfixedPricePromotionsResponse201DataRelationshipsSkuListData,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_sku_list_data_type import (
    POSTfixedPricePromotionsResponse201DataRelationshipsSkuListDataType,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_sku_list_links import (
    POSTfixedPricePromotionsResponse201DataRelationshipsSkuListLinks,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_sku_list_promotion_rule import (
    POSTfixedPricePromotionsResponse201DataRelationshipsSkuListPromotionRule,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_sku_list_promotion_rule_data import (
    POSTfixedPricePromotionsResponse201DataRelationshipsSkuListPromotionRuleData,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_sku_list_promotion_rule_data_type import (
    POSTfixedPricePromotionsResponse201DataRelationshipsSkuListPromotionRuleDataType,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_sku_list_promotion_rule_links import (
    POSTfixedPricePromotionsResponse201DataRelationshipsSkuListPromotionRuleLinks,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_skus import (
    POSTfixedPricePromotionsResponse201DataRelationshipsSkus,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_skus_data import (
    POSTfixedPricePromotionsResponse201DataRelationshipsSkusData,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_skus_data_type import (
    POSTfixedPricePromotionsResponse201DataRelationshipsSkusDataType,
)
from .pos_tfixed_price_promotions_response_201_data_relationships_skus_links import (
    POSTfixedPricePromotionsResponse201DataRelationshipsSkusLinks,
)
from .pos_tfixed_price_promotions_response_201_data_type import POSTfixedPricePromotionsResponse201DataType
from .pos_tfree_gift_promotions_response_201 import POSTfreeGiftPromotionsResponse201
from .pos_tfree_gift_promotions_response_201_data import POSTfreeGiftPromotionsResponse201Data
from .pos_tfree_gift_promotions_response_201_data_attributes import POSTfreeGiftPromotionsResponse201DataAttributes
from .pos_tfree_gift_promotions_response_201_data_attributes_metadata import (
    POSTfreeGiftPromotionsResponse201DataAttributesMetadata,
)
from .pos_tfree_gift_promotions_response_201_data_links import POSTfreeGiftPromotionsResponse201DataLinks
from .pos_tfree_gift_promotions_response_201_data_relationships import (
    POSTfreeGiftPromotionsResponse201DataRelationships,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_attachments import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsAttachments,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_attachments_data import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsAttachmentsData,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_attachments_data_type import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_attachments_links import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_coupon_codes_promotion_rule import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsCouponCodesPromotionRule,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_coupon_codes_promotion_rule_data import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleData,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_coupon_codes_promotion_rule_data_type import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleDataType,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_coupon_codes_promotion_rule_links import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleLinks,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_market import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsMarket,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_market_data import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsMarketData,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_market_data_type import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsMarketDataType,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_market_links import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsMarketLinks,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_order_amount_promotion_rule import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsOrderAmountPromotionRule,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_order_amount_promotion_rule_data import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleData,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_order_amount_promotion_rule_data_type import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleDataType,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_order_amount_promotion_rule_links import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleLinks,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_promotion_rules import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsPromotionRules,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_promotion_rules_data import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsPromotionRulesData,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_promotion_rules_data_type import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsPromotionRulesDataType,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_promotion_rules_links import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsPromotionRulesLinks,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_sku_list import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsSkuList,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_sku_list_data import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsSkuListData,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_sku_list_data_type import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsSkuListDataType,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_sku_list_links import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsSkuListLinks,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_sku_list_promotion_rule import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsSkuListPromotionRule,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_sku_list_promotion_rule_data import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsSkuListPromotionRuleData,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_sku_list_promotion_rule_data_type import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsSkuListPromotionRuleDataType,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_sku_list_promotion_rule_links import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsSkuListPromotionRuleLinks,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_skus import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsSkus,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_skus_data import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsSkusData,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_skus_data_type import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsSkusDataType,
)
from .pos_tfree_gift_promotions_response_201_data_relationships_skus_links import (
    POSTfreeGiftPromotionsResponse201DataRelationshipsSkusLinks,
)
from .pos_tfree_gift_promotions_response_201_data_type import POSTfreeGiftPromotionsResponse201DataType
from .pos_tfree_shipping_promotions_response_201 import POSTfreeShippingPromotionsResponse201
from .pos_tfree_shipping_promotions_response_201_data import POSTfreeShippingPromotionsResponse201Data
from .pos_tfree_shipping_promotions_response_201_data_attributes import (
    POSTfreeShippingPromotionsResponse201DataAttributes,
)
from .pos_tfree_shipping_promotions_response_201_data_attributes_metadata import (
    POSTfreeShippingPromotionsResponse201DataAttributesMetadata,
)
from .pos_tfree_shipping_promotions_response_201_data_links import POSTfreeShippingPromotionsResponse201DataLinks
from .pos_tfree_shipping_promotions_response_201_data_relationships import (
    POSTfreeShippingPromotionsResponse201DataRelationships,
)
from .pos_tfree_shipping_promotions_response_201_data_relationships_attachments import (
    POSTfreeShippingPromotionsResponse201DataRelationshipsAttachments,
)
from .pos_tfree_shipping_promotions_response_201_data_relationships_attachments_data import (
    POSTfreeShippingPromotionsResponse201DataRelationshipsAttachmentsData,
)
from .pos_tfree_shipping_promotions_response_201_data_relationships_attachments_data_type import (
    POSTfreeShippingPromotionsResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tfree_shipping_promotions_response_201_data_relationships_attachments_links import (
    POSTfreeShippingPromotionsResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tfree_shipping_promotions_response_201_data_relationships_coupon_codes_promotion_rule import (
    POSTfreeShippingPromotionsResponse201DataRelationshipsCouponCodesPromotionRule,
)
from .pos_tfree_shipping_promotions_response_201_data_relationships_coupon_codes_promotion_rule_data import (
    POSTfreeShippingPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleData,
)
from .pos_tfree_shipping_promotions_response_201_data_relationships_coupon_codes_promotion_rule_data_type import (
    POSTfreeShippingPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleDataType,
)
from .pos_tfree_shipping_promotions_response_201_data_relationships_coupon_codes_promotion_rule_links import (
    POSTfreeShippingPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleLinks,
)
from .pos_tfree_shipping_promotions_response_201_data_relationships_market import (
    POSTfreeShippingPromotionsResponse201DataRelationshipsMarket,
)
from .pos_tfree_shipping_promotions_response_201_data_relationships_market_data import (
    POSTfreeShippingPromotionsResponse201DataRelationshipsMarketData,
)
from .pos_tfree_shipping_promotions_response_201_data_relationships_market_data_type import (
    POSTfreeShippingPromotionsResponse201DataRelationshipsMarketDataType,
)
from .pos_tfree_shipping_promotions_response_201_data_relationships_market_links import (
    POSTfreeShippingPromotionsResponse201DataRelationshipsMarketLinks,
)
from .pos_tfree_shipping_promotions_response_201_data_relationships_order_amount_promotion_rule import (
    POSTfreeShippingPromotionsResponse201DataRelationshipsOrderAmountPromotionRule,
)
from .pos_tfree_shipping_promotions_response_201_data_relationships_order_amount_promotion_rule_data import (
    POSTfreeShippingPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleData,
)
from .pos_tfree_shipping_promotions_response_201_data_relationships_order_amount_promotion_rule_data_type import (
    POSTfreeShippingPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleDataType,
)
from .pos_tfree_shipping_promotions_response_201_data_relationships_order_amount_promotion_rule_links import (
    POSTfreeShippingPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleLinks,
)
from .pos_tfree_shipping_promotions_response_201_data_relationships_promotion_rules import (
    POSTfreeShippingPromotionsResponse201DataRelationshipsPromotionRules,
)
from .pos_tfree_shipping_promotions_response_201_data_relationships_promotion_rules_data import (
    POSTfreeShippingPromotionsResponse201DataRelationshipsPromotionRulesData,
)
from .pos_tfree_shipping_promotions_response_201_data_relationships_promotion_rules_data_type import (
    POSTfreeShippingPromotionsResponse201DataRelationshipsPromotionRulesDataType,
)
from .pos_tfree_shipping_promotions_response_201_data_relationships_promotion_rules_links import (
    POSTfreeShippingPromotionsResponse201DataRelationshipsPromotionRulesLinks,
)
from .pos_tfree_shipping_promotions_response_201_data_relationships_sku_list_promotion_rule import (
    POSTfreeShippingPromotionsResponse201DataRelationshipsSkuListPromotionRule,
)
from .pos_tfree_shipping_promotions_response_201_data_relationships_sku_list_promotion_rule_data import (
    POSTfreeShippingPromotionsResponse201DataRelationshipsSkuListPromotionRuleData,
)
from .pos_tfree_shipping_promotions_response_201_data_relationships_sku_list_promotion_rule_data_type import (
    POSTfreeShippingPromotionsResponse201DataRelationshipsSkuListPromotionRuleDataType,
)
from .pos_tfree_shipping_promotions_response_201_data_relationships_sku_list_promotion_rule_links import (
    POSTfreeShippingPromotionsResponse201DataRelationshipsSkuListPromotionRuleLinks,
)
from .pos_tfree_shipping_promotions_response_201_data_type import POSTfreeShippingPromotionsResponse201DataType
from .pos_tgift_card_recipients_response_201 import POSTgiftCardRecipientsResponse201
from .pos_tgift_card_recipients_response_201_data import POSTgiftCardRecipientsResponse201Data
from .pos_tgift_card_recipients_response_201_data_attributes import POSTgiftCardRecipientsResponse201DataAttributes
from .pos_tgift_card_recipients_response_201_data_attributes_metadata import (
    POSTgiftCardRecipientsResponse201DataAttributesMetadata,
)
from .pos_tgift_card_recipients_response_201_data_links import POSTgiftCardRecipientsResponse201DataLinks
from .pos_tgift_card_recipients_response_201_data_relationships import (
    POSTgiftCardRecipientsResponse201DataRelationships,
)
from .pos_tgift_card_recipients_response_201_data_relationships_attachments import (
    POSTgiftCardRecipientsResponse201DataRelationshipsAttachments,
)
from .pos_tgift_card_recipients_response_201_data_relationships_attachments_data import (
    POSTgiftCardRecipientsResponse201DataRelationshipsAttachmentsData,
)
from .pos_tgift_card_recipients_response_201_data_relationships_attachments_data_type import (
    POSTgiftCardRecipientsResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tgift_card_recipients_response_201_data_relationships_attachments_links import (
    POSTgiftCardRecipientsResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tgift_card_recipients_response_201_data_relationships_customer import (
    POSTgiftCardRecipientsResponse201DataRelationshipsCustomer,
)
from .pos_tgift_card_recipients_response_201_data_relationships_customer_data import (
    POSTgiftCardRecipientsResponse201DataRelationshipsCustomerData,
)
from .pos_tgift_card_recipients_response_201_data_relationships_customer_data_type import (
    POSTgiftCardRecipientsResponse201DataRelationshipsCustomerDataType,
)
from .pos_tgift_card_recipients_response_201_data_relationships_customer_links import (
    POSTgiftCardRecipientsResponse201DataRelationshipsCustomerLinks,
)
from .pos_tgift_card_recipients_response_201_data_type import POSTgiftCardRecipientsResponse201DataType
from .pos_tgift_cards_response_201 import POSTgiftCardsResponse201
from .pos_tgift_cards_response_201_data import POSTgiftCardsResponse201Data
from .pos_tgift_cards_response_201_data_attributes import POSTgiftCardsResponse201DataAttributes
from .pos_tgift_cards_response_201_data_attributes_metadata import POSTgiftCardsResponse201DataAttributesMetadata
from .pos_tgift_cards_response_201_data_links import POSTgiftCardsResponse201DataLinks
from .pos_tgift_cards_response_201_data_relationships import POSTgiftCardsResponse201DataRelationships
from .pos_tgift_cards_response_201_data_relationships_attachments import (
    POSTgiftCardsResponse201DataRelationshipsAttachments,
)
from .pos_tgift_cards_response_201_data_relationships_attachments_data import (
    POSTgiftCardsResponse201DataRelationshipsAttachmentsData,
)
from .pos_tgift_cards_response_201_data_relationships_attachments_data_type import (
    POSTgiftCardsResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tgift_cards_response_201_data_relationships_attachments_links import (
    POSTgiftCardsResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tgift_cards_response_201_data_relationships_events import POSTgiftCardsResponse201DataRelationshipsEvents
from .pos_tgift_cards_response_201_data_relationships_events_data import (
    POSTgiftCardsResponse201DataRelationshipsEventsData,
)
from .pos_tgift_cards_response_201_data_relationships_events_data_type import (
    POSTgiftCardsResponse201DataRelationshipsEventsDataType,
)
from .pos_tgift_cards_response_201_data_relationships_events_links import (
    POSTgiftCardsResponse201DataRelationshipsEventsLinks,
)
from .pos_tgift_cards_response_201_data_relationships_gift_card_recipient import (
    POSTgiftCardsResponse201DataRelationshipsGiftCardRecipient,
)
from .pos_tgift_cards_response_201_data_relationships_gift_card_recipient_data import (
    POSTgiftCardsResponse201DataRelationshipsGiftCardRecipientData,
)
from .pos_tgift_cards_response_201_data_relationships_gift_card_recipient_data_type import (
    POSTgiftCardsResponse201DataRelationshipsGiftCardRecipientDataType,
)
from .pos_tgift_cards_response_201_data_relationships_gift_card_recipient_links import (
    POSTgiftCardsResponse201DataRelationshipsGiftCardRecipientLinks,
)
from .pos_tgift_cards_response_201_data_relationships_market import POSTgiftCardsResponse201DataRelationshipsMarket
from .pos_tgift_cards_response_201_data_relationships_market_data import (
    POSTgiftCardsResponse201DataRelationshipsMarketData,
)
from .pos_tgift_cards_response_201_data_relationships_market_data_type import (
    POSTgiftCardsResponse201DataRelationshipsMarketDataType,
)
from .pos_tgift_cards_response_201_data_relationships_market_links import (
    POSTgiftCardsResponse201DataRelationshipsMarketLinks,
)
from .pos_tgift_cards_response_201_data_type import POSTgiftCardsResponse201DataType
from .pos_tgoogle_geocoders_response_201 import POSTgoogleGeocodersResponse201
from .pos_tgoogle_geocoders_response_201_data import POSTgoogleGeocodersResponse201Data
from .pos_tgoogle_geocoders_response_201_data_attributes import POSTgoogleGeocodersResponse201DataAttributes
from .pos_tgoogle_geocoders_response_201_data_attributes_metadata import (
    POSTgoogleGeocodersResponse201DataAttributesMetadata,
)
from .pos_tgoogle_geocoders_response_201_data_links import POSTgoogleGeocodersResponse201DataLinks
from .pos_tgoogle_geocoders_response_201_data_relationships import POSTgoogleGeocodersResponse201DataRelationships
from .pos_tgoogle_geocoders_response_201_data_relationships_addresses import (
    POSTgoogleGeocodersResponse201DataRelationshipsAddresses,
)
from .pos_tgoogle_geocoders_response_201_data_relationships_addresses_data import (
    POSTgoogleGeocodersResponse201DataRelationshipsAddressesData,
)
from .pos_tgoogle_geocoders_response_201_data_relationships_addresses_data_type import (
    POSTgoogleGeocodersResponse201DataRelationshipsAddressesDataType,
)
from .pos_tgoogle_geocoders_response_201_data_relationships_addresses_links import (
    POSTgoogleGeocodersResponse201DataRelationshipsAddressesLinks,
)
from .pos_tgoogle_geocoders_response_201_data_relationships_attachments import (
    POSTgoogleGeocodersResponse201DataRelationshipsAttachments,
)
from .pos_tgoogle_geocoders_response_201_data_relationships_attachments_data import (
    POSTgoogleGeocodersResponse201DataRelationshipsAttachmentsData,
)
from .pos_tgoogle_geocoders_response_201_data_relationships_attachments_data_type import (
    POSTgoogleGeocodersResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tgoogle_geocoders_response_201_data_relationships_attachments_links import (
    POSTgoogleGeocodersResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tgoogle_geocoders_response_201_data_type import POSTgoogleGeocodersResponse201DataType
from .pos_timports_response_201 import POSTimportsResponse201
from .pos_timports_response_201_data import POSTimportsResponse201Data
from .pos_timports_response_201_data_attributes import POSTimportsResponse201DataAttributes
from .pos_timports_response_201_data_attributes_inputs_item import POSTimportsResponse201DataAttributesInputsItem
from .pos_timports_response_201_data_attributes_metadata import POSTimportsResponse201DataAttributesMetadata
from .pos_timports_response_201_data_links import POSTimportsResponse201DataLinks
from .pos_timports_response_201_data_relationships import POSTimportsResponse201DataRelationships
from .pos_timports_response_201_data_relationships_events import POSTimportsResponse201DataRelationshipsEvents
from .pos_timports_response_201_data_relationships_events_data import POSTimportsResponse201DataRelationshipsEventsData
from .pos_timports_response_201_data_relationships_events_data_type import (
    POSTimportsResponse201DataRelationshipsEventsDataType,
)
from .pos_timports_response_201_data_relationships_events_links import (
    POSTimportsResponse201DataRelationshipsEventsLinks,
)
from .pos_timports_response_201_data_type import POSTimportsResponse201DataType
from .pos_tin_stock_subscriptions_response_201 import POSTinStockSubscriptionsResponse201
from .pos_tin_stock_subscriptions_response_201_data import POSTinStockSubscriptionsResponse201Data
from .pos_tin_stock_subscriptions_response_201_data_attributes import POSTinStockSubscriptionsResponse201DataAttributes
from .pos_tin_stock_subscriptions_response_201_data_attributes_metadata import (
    POSTinStockSubscriptionsResponse201DataAttributesMetadata,
)
from .pos_tin_stock_subscriptions_response_201_data_links import POSTinStockSubscriptionsResponse201DataLinks
from .pos_tin_stock_subscriptions_response_201_data_relationships import (
    POSTinStockSubscriptionsResponse201DataRelationships,
)
from .pos_tin_stock_subscriptions_response_201_data_relationships_customer import (
    POSTinStockSubscriptionsResponse201DataRelationshipsCustomer,
)
from .pos_tin_stock_subscriptions_response_201_data_relationships_customer_data import (
    POSTinStockSubscriptionsResponse201DataRelationshipsCustomerData,
)
from .pos_tin_stock_subscriptions_response_201_data_relationships_customer_data_type import (
    POSTinStockSubscriptionsResponse201DataRelationshipsCustomerDataType,
)
from .pos_tin_stock_subscriptions_response_201_data_relationships_customer_links import (
    POSTinStockSubscriptionsResponse201DataRelationshipsCustomerLinks,
)
from .pos_tin_stock_subscriptions_response_201_data_relationships_events import (
    POSTinStockSubscriptionsResponse201DataRelationshipsEvents,
)
from .pos_tin_stock_subscriptions_response_201_data_relationships_events_data import (
    POSTinStockSubscriptionsResponse201DataRelationshipsEventsData,
)
from .pos_tin_stock_subscriptions_response_201_data_relationships_events_data_type import (
    POSTinStockSubscriptionsResponse201DataRelationshipsEventsDataType,
)
from .pos_tin_stock_subscriptions_response_201_data_relationships_events_links import (
    POSTinStockSubscriptionsResponse201DataRelationshipsEventsLinks,
)
from .pos_tin_stock_subscriptions_response_201_data_relationships_market import (
    POSTinStockSubscriptionsResponse201DataRelationshipsMarket,
)
from .pos_tin_stock_subscriptions_response_201_data_relationships_market_data import (
    POSTinStockSubscriptionsResponse201DataRelationshipsMarketData,
)
from .pos_tin_stock_subscriptions_response_201_data_relationships_market_data_type import (
    POSTinStockSubscriptionsResponse201DataRelationshipsMarketDataType,
)
from .pos_tin_stock_subscriptions_response_201_data_relationships_market_links import (
    POSTinStockSubscriptionsResponse201DataRelationshipsMarketLinks,
)
from .pos_tin_stock_subscriptions_response_201_data_relationships_sku import (
    POSTinStockSubscriptionsResponse201DataRelationshipsSku,
)
from .pos_tin_stock_subscriptions_response_201_data_relationships_sku_data import (
    POSTinStockSubscriptionsResponse201DataRelationshipsSkuData,
)
from .pos_tin_stock_subscriptions_response_201_data_relationships_sku_data_type import (
    POSTinStockSubscriptionsResponse201DataRelationshipsSkuDataType,
)
from .pos_tin_stock_subscriptions_response_201_data_relationships_sku_links import (
    POSTinStockSubscriptionsResponse201DataRelationshipsSkuLinks,
)
from .pos_tin_stock_subscriptions_response_201_data_type import POSTinStockSubscriptionsResponse201DataType
from .pos_tinventory_models_response_201 import POSTinventoryModelsResponse201
from .pos_tinventory_models_response_201_data import POSTinventoryModelsResponse201Data
from .pos_tinventory_models_response_201_data_attributes import POSTinventoryModelsResponse201DataAttributes
from .pos_tinventory_models_response_201_data_attributes_metadata import (
    POSTinventoryModelsResponse201DataAttributesMetadata,
)
from .pos_tinventory_models_response_201_data_links import POSTinventoryModelsResponse201DataLinks
from .pos_tinventory_models_response_201_data_relationships import POSTinventoryModelsResponse201DataRelationships
from .pos_tinventory_models_response_201_data_relationships_attachments import (
    POSTinventoryModelsResponse201DataRelationshipsAttachments,
)
from .pos_tinventory_models_response_201_data_relationships_attachments_data import (
    POSTinventoryModelsResponse201DataRelationshipsAttachmentsData,
)
from .pos_tinventory_models_response_201_data_relationships_attachments_data_type import (
    POSTinventoryModelsResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tinventory_models_response_201_data_relationships_attachments_links import (
    POSTinventoryModelsResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tinventory_models_response_201_data_relationships_inventory_return_locations import (
    POSTinventoryModelsResponse201DataRelationshipsInventoryReturnLocations,
)
from .pos_tinventory_models_response_201_data_relationships_inventory_return_locations_data import (
    POSTinventoryModelsResponse201DataRelationshipsInventoryReturnLocationsData,
)
from .pos_tinventory_models_response_201_data_relationships_inventory_return_locations_data_type import (
    POSTinventoryModelsResponse201DataRelationshipsInventoryReturnLocationsDataType,
)
from .pos_tinventory_models_response_201_data_relationships_inventory_return_locations_links import (
    POSTinventoryModelsResponse201DataRelationshipsInventoryReturnLocationsLinks,
)
from .pos_tinventory_models_response_201_data_relationships_inventory_stock_locations import (
    POSTinventoryModelsResponse201DataRelationshipsInventoryStockLocations,
)
from .pos_tinventory_models_response_201_data_relationships_inventory_stock_locations_data import (
    POSTinventoryModelsResponse201DataRelationshipsInventoryStockLocationsData,
)
from .pos_tinventory_models_response_201_data_relationships_inventory_stock_locations_data_type import (
    POSTinventoryModelsResponse201DataRelationshipsInventoryStockLocationsDataType,
)
from .pos_tinventory_models_response_201_data_relationships_inventory_stock_locations_links import (
    POSTinventoryModelsResponse201DataRelationshipsInventoryStockLocationsLinks,
)
from .pos_tinventory_models_response_201_data_type import POSTinventoryModelsResponse201DataType
from .pos_tinventory_return_locations_response_201 import POSTinventoryReturnLocationsResponse201
from .pos_tinventory_return_locations_response_201_data import POSTinventoryReturnLocationsResponse201Data
from .pos_tinventory_return_locations_response_201_data_attributes import (
    POSTinventoryReturnLocationsResponse201DataAttributes,
)
from .pos_tinventory_return_locations_response_201_data_attributes_metadata import (
    POSTinventoryReturnLocationsResponse201DataAttributesMetadata,
)
from .pos_tinventory_return_locations_response_201_data_links import POSTinventoryReturnLocationsResponse201DataLinks
from .pos_tinventory_return_locations_response_201_data_relationships import (
    POSTinventoryReturnLocationsResponse201DataRelationships,
)
from .pos_tinventory_return_locations_response_201_data_relationships_inventory_model import (
    POSTinventoryReturnLocationsResponse201DataRelationshipsInventoryModel,
)
from .pos_tinventory_return_locations_response_201_data_relationships_inventory_model_data import (
    POSTinventoryReturnLocationsResponse201DataRelationshipsInventoryModelData,
)
from .pos_tinventory_return_locations_response_201_data_relationships_inventory_model_data_type import (
    POSTinventoryReturnLocationsResponse201DataRelationshipsInventoryModelDataType,
)
from .pos_tinventory_return_locations_response_201_data_relationships_inventory_model_links import (
    POSTinventoryReturnLocationsResponse201DataRelationshipsInventoryModelLinks,
)
from .pos_tinventory_return_locations_response_201_data_relationships_stock_location import (
    POSTinventoryReturnLocationsResponse201DataRelationshipsStockLocation,
)
from .pos_tinventory_return_locations_response_201_data_relationships_stock_location_data import (
    POSTinventoryReturnLocationsResponse201DataRelationshipsStockLocationData,
)
from .pos_tinventory_return_locations_response_201_data_relationships_stock_location_data_type import (
    POSTinventoryReturnLocationsResponse201DataRelationshipsStockLocationDataType,
)
from .pos_tinventory_return_locations_response_201_data_relationships_stock_location_links import (
    POSTinventoryReturnLocationsResponse201DataRelationshipsStockLocationLinks,
)
from .pos_tinventory_return_locations_response_201_data_type import POSTinventoryReturnLocationsResponse201DataType
from .pos_tinventory_stock_locations_response_201 import POSTinventoryStockLocationsResponse201
from .pos_tinventory_stock_locations_response_201_data import POSTinventoryStockLocationsResponse201Data
from .pos_tinventory_stock_locations_response_201_data_attributes import (
    POSTinventoryStockLocationsResponse201DataAttributes,
)
from .pos_tinventory_stock_locations_response_201_data_attributes_metadata import (
    POSTinventoryStockLocationsResponse201DataAttributesMetadata,
)
from .pos_tinventory_stock_locations_response_201_data_links import POSTinventoryStockLocationsResponse201DataLinks
from .pos_tinventory_stock_locations_response_201_data_relationships import (
    POSTinventoryStockLocationsResponse201DataRelationships,
)
from .pos_tinventory_stock_locations_response_201_data_relationships_inventory_model import (
    POSTinventoryStockLocationsResponse201DataRelationshipsInventoryModel,
)
from .pos_tinventory_stock_locations_response_201_data_relationships_inventory_model_data import (
    POSTinventoryStockLocationsResponse201DataRelationshipsInventoryModelData,
)
from .pos_tinventory_stock_locations_response_201_data_relationships_inventory_model_data_type import (
    POSTinventoryStockLocationsResponse201DataRelationshipsInventoryModelDataType,
)
from .pos_tinventory_stock_locations_response_201_data_relationships_inventory_model_links import (
    POSTinventoryStockLocationsResponse201DataRelationshipsInventoryModelLinks,
)
from .pos_tinventory_stock_locations_response_201_data_relationships_stock_location import (
    POSTinventoryStockLocationsResponse201DataRelationshipsStockLocation,
)
from .pos_tinventory_stock_locations_response_201_data_relationships_stock_location_data import (
    POSTinventoryStockLocationsResponse201DataRelationshipsStockLocationData,
)
from .pos_tinventory_stock_locations_response_201_data_relationships_stock_location_data_type import (
    POSTinventoryStockLocationsResponse201DataRelationshipsStockLocationDataType,
)
from .pos_tinventory_stock_locations_response_201_data_relationships_stock_location_links import (
    POSTinventoryStockLocationsResponse201DataRelationshipsStockLocationLinks,
)
from .pos_tinventory_stock_locations_response_201_data_type import POSTinventoryStockLocationsResponse201DataType
from .pos_tklarna_gateways_response_201 import POSTklarnaGatewaysResponse201
from .pos_tklarna_gateways_response_201_data import POSTklarnaGatewaysResponse201Data
from .pos_tklarna_gateways_response_201_data_attributes import POSTklarnaGatewaysResponse201DataAttributes
from .pos_tklarna_gateways_response_201_data_attributes_metadata import (
    POSTklarnaGatewaysResponse201DataAttributesMetadata,
)
from .pos_tklarna_gateways_response_201_data_links import POSTklarnaGatewaysResponse201DataLinks
from .pos_tklarna_gateways_response_201_data_relationships import POSTklarnaGatewaysResponse201DataRelationships
from .pos_tklarna_gateways_response_201_data_relationships_klarna_payments import (
    POSTklarnaGatewaysResponse201DataRelationshipsKlarnaPayments,
)
from .pos_tklarna_gateways_response_201_data_relationships_klarna_payments_data import (
    POSTklarnaGatewaysResponse201DataRelationshipsKlarnaPaymentsData,
)
from .pos_tklarna_gateways_response_201_data_relationships_klarna_payments_data_type import (
    POSTklarnaGatewaysResponse201DataRelationshipsKlarnaPaymentsDataType,
)
from .pos_tklarna_gateways_response_201_data_relationships_klarna_payments_links import (
    POSTklarnaGatewaysResponse201DataRelationshipsKlarnaPaymentsLinks,
)
from .pos_tklarna_gateways_response_201_data_relationships_payment_methods import (
    POSTklarnaGatewaysResponse201DataRelationshipsPaymentMethods,
)
from .pos_tklarna_gateways_response_201_data_relationships_payment_methods_data import (
    POSTklarnaGatewaysResponse201DataRelationshipsPaymentMethodsData,
)
from .pos_tklarna_gateways_response_201_data_relationships_payment_methods_data_type import (
    POSTklarnaGatewaysResponse201DataRelationshipsPaymentMethodsDataType,
)
from .pos_tklarna_gateways_response_201_data_relationships_payment_methods_links import (
    POSTklarnaGatewaysResponse201DataRelationshipsPaymentMethodsLinks,
)
from .pos_tklarna_gateways_response_201_data_type import POSTklarnaGatewaysResponse201DataType
from .pos_tklarna_payments_response_201 import POSTklarnaPaymentsResponse201
from .pos_tklarna_payments_response_201_data import POSTklarnaPaymentsResponse201Data
from .pos_tklarna_payments_response_201_data_attributes import POSTklarnaPaymentsResponse201DataAttributes
from .pos_tklarna_payments_response_201_data_attributes_metadata import (
    POSTklarnaPaymentsResponse201DataAttributesMetadata,
)
from .pos_tklarna_payments_response_201_data_links import POSTklarnaPaymentsResponse201DataLinks
from .pos_tklarna_payments_response_201_data_relationships import POSTklarnaPaymentsResponse201DataRelationships
from .pos_tklarna_payments_response_201_data_relationships_order import (
    POSTklarnaPaymentsResponse201DataRelationshipsOrder,
)
from .pos_tklarna_payments_response_201_data_relationships_order_data import (
    POSTklarnaPaymentsResponse201DataRelationshipsOrderData,
)
from .pos_tklarna_payments_response_201_data_relationships_order_data_type import (
    POSTklarnaPaymentsResponse201DataRelationshipsOrderDataType,
)
from .pos_tklarna_payments_response_201_data_relationships_order_links import (
    POSTklarnaPaymentsResponse201DataRelationshipsOrderLinks,
)
from .pos_tklarna_payments_response_201_data_relationships_payment_gateway import (
    POSTklarnaPaymentsResponse201DataRelationshipsPaymentGateway,
)
from .pos_tklarna_payments_response_201_data_relationships_payment_gateway_data import (
    POSTklarnaPaymentsResponse201DataRelationshipsPaymentGatewayData,
)
from .pos_tklarna_payments_response_201_data_relationships_payment_gateway_data_type import (
    POSTklarnaPaymentsResponse201DataRelationshipsPaymentGatewayDataType,
)
from .pos_tklarna_payments_response_201_data_relationships_payment_gateway_links import (
    POSTklarnaPaymentsResponse201DataRelationshipsPaymentGatewayLinks,
)
from .pos_tklarna_payments_response_201_data_type import POSTklarnaPaymentsResponse201DataType
from .pos_tline_item_options_response_201 import POSTlineItemOptionsResponse201
from .pos_tline_item_options_response_201_data import POSTlineItemOptionsResponse201Data
from .pos_tline_item_options_response_201_data_attributes import POSTlineItemOptionsResponse201DataAttributes
from .pos_tline_item_options_response_201_data_attributes_metadata import (
    POSTlineItemOptionsResponse201DataAttributesMetadata,
)
from .pos_tline_item_options_response_201_data_attributes_options import (
    POSTlineItemOptionsResponse201DataAttributesOptions,
)
from .pos_tline_item_options_response_201_data_links import POSTlineItemOptionsResponse201DataLinks
from .pos_tline_item_options_response_201_data_relationships import POSTlineItemOptionsResponse201DataRelationships
from .pos_tline_item_options_response_201_data_relationships_line_item import (
    POSTlineItemOptionsResponse201DataRelationshipsLineItem,
)
from .pos_tline_item_options_response_201_data_relationships_line_item_data import (
    POSTlineItemOptionsResponse201DataRelationshipsLineItemData,
)
from .pos_tline_item_options_response_201_data_relationships_line_item_data_type import (
    POSTlineItemOptionsResponse201DataRelationshipsLineItemDataType,
)
from .pos_tline_item_options_response_201_data_relationships_line_item_links import (
    POSTlineItemOptionsResponse201DataRelationshipsLineItemLinks,
)
from .pos_tline_item_options_response_201_data_relationships_sku_option import (
    POSTlineItemOptionsResponse201DataRelationshipsSkuOption,
)
from .pos_tline_item_options_response_201_data_relationships_sku_option_data import (
    POSTlineItemOptionsResponse201DataRelationshipsSkuOptionData,
)
from .pos_tline_item_options_response_201_data_relationships_sku_option_data_type import (
    POSTlineItemOptionsResponse201DataRelationshipsSkuOptionDataType,
)
from .pos_tline_item_options_response_201_data_relationships_sku_option_links import (
    POSTlineItemOptionsResponse201DataRelationshipsSkuOptionLinks,
)
from .pos_tline_item_options_response_201_data_type import POSTlineItemOptionsResponse201DataType
from .pos_tline_items_response_201 import POSTlineItemsResponse201
from .pos_tline_items_response_201_data import POSTlineItemsResponse201Data
from .pos_tline_items_response_201_data_attributes import POSTlineItemsResponse201DataAttributes
from .pos_tline_items_response_201_data_attributes_metadata import POSTlineItemsResponse201DataAttributesMetadata
from .pos_tline_items_response_201_data_links import POSTlineItemsResponse201DataLinks
from .pos_tline_items_response_201_data_relationships import POSTlineItemsResponse201DataRelationships
from .pos_tline_items_response_201_data_relationships_item import POSTlineItemsResponse201DataRelationshipsItem
from .pos_tline_items_response_201_data_relationships_item_data import POSTlineItemsResponse201DataRelationshipsItemData
from .pos_tline_items_response_201_data_relationships_item_data_type import (
    POSTlineItemsResponse201DataRelationshipsItemDataType,
)
from .pos_tline_items_response_201_data_relationships_item_links import (
    POSTlineItemsResponse201DataRelationshipsItemLinks,
)
from .pos_tline_items_response_201_data_relationships_line_item_options import (
    POSTlineItemsResponse201DataRelationshipsLineItemOptions,
)
from .pos_tline_items_response_201_data_relationships_line_item_options_data import (
    POSTlineItemsResponse201DataRelationshipsLineItemOptionsData,
)
from .pos_tline_items_response_201_data_relationships_line_item_options_data_type import (
    POSTlineItemsResponse201DataRelationshipsLineItemOptionsDataType,
)
from .pos_tline_items_response_201_data_relationships_line_item_options_links import (
    POSTlineItemsResponse201DataRelationshipsLineItemOptionsLinks,
)
from .pos_tline_items_response_201_data_relationships_order import POSTlineItemsResponse201DataRelationshipsOrder
from .pos_tline_items_response_201_data_relationships_order_data import (
    POSTlineItemsResponse201DataRelationshipsOrderData,
)
from .pos_tline_items_response_201_data_relationships_order_data_type import (
    POSTlineItemsResponse201DataRelationshipsOrderDataType,
)
from .pos_tline_items_response_201_data_relationships_order_links import (
    POSTlineItemsResponse201DataRelationshipsOrderLinks,
)
from .pos_tline_items_response_201_data_relationships_shipment_line_items import (
    POSTlineItemsResponse201DataRelationshipsShipmentLineItems,
)
from .pos_tline_items_response_201_data_relationships_shipment_line_items_data import (
    POSTlineItemsResponse201DataRelationshipsShipmentLineItemsData,
)
from .pos_tline_items_response_201_data_relationships_shipment_line_items_data_type import (
    POSTlineItemsResponse201DataRelationshipsShipmentLineItemsDataType,
)
from .pos_tline_items_response_201_data_relationships_shipment_line_items_links import (
    POSTlineItemsResponse201DataRelationshipsShipmentLineItemsLinks,
)
from .pos_tline_items_response_201_data_relationships_stock_line_items import (
    POSTlineItemsResponse201DataRelationshipsStockLineItems,
)
from .pos_tline_items_response_201_data_relationships_stock_line_items_data import (
    POSTlineItemsResponse201DataRelationshipsStockLineItemsData,
)
from .pos_tline_items_response_201_data_relationships_stock_line_items_data_type import (
    POSTlineItemsResponse201DataRelationshipsStockLineItemsDataType,
)
from .pos_tline_items_response_201_data_relationships_stock_line_items_links import (
    POSTlineItemsResponse201DataRelationshipsStockLineItemsLinks,
)
from .pos_tline_items_response_201_data_relationships_stock_transfers import (
    POSTlineItemsResponse201DataRelationshipsStockTransfers,
)
from .pos_tline_items_response_201_data_relationships_stock_transfers_data import (
    POSTlineItemsResponse201DataRelationshipsStockTransfersData,
)
from .pos_tline_items_response_201_data_relationships_stock_transfers_data_type import (
    POSTlineItemsResponse201DataRelationshipsStockTransfersDataType,
)
from .pos_tline_items_response_201_data_relationships_stock_transfers_links import (
    POSTlineItemsResponse201DataRelationshipsStockTransfersLinks,
)
from .pos_tline_items_response_201_data_type import POSTlineItemsResponse201DataType
from .pos_tmanual_gateways_response_201 import POSTmanualGatewaysResponse201
from .pos_tmanual_gateways_response_201_data import POSTmanualGatewaysResponse201Data
from .pos_tmanual_gateways_response_201_data_attributes import POSTmanualGatewaysResponse201DataAttributes
from .pos_tmanual_gateways_response_201_data_attributes_metadata import (
    POSTmanualGatewaysResponse201DataAttributesMetadata,
)
from .pos_tmanual_gateways_response_201_data_links import POSTmanualGatewaysResponse201DataLinks
from .pos_tmanual_gateways_response_201_data_relationships import POSTmanualGatewaysResponse201DataRelationships
from .pos_tmanual_gateways_response_201_data_relationships_payment_methods import (
    POSTmanualGatewaysResponse201DataRelationshipsPaymentMethods,
)
from .pos_tmanual_gateways_response_201_data_relationships_payment_methods_data import (
    POSTmanualGatewaysResponse201DataRelationshipsPaymentMethodsData,
)
from .pos_tmanual_gateways_response_201_data_relationships_payment_methods_data_type import (
    POSTmanualGatewaysResponse201DataRelationshipsPaymentMethodsDataType,
)
from .pos_tmanual_gateways_response_201_data_relationships_payment_methods_links import (
    POSTmanualGatewaysResponse201DataRelationshipsPaymentMethodsLinks,
)
from .pos_tmanual_gateways_response_201_data_type import POSTmanualGatewaysResponse201DataType
from .pos_tmanual_tax_calculators_response_201 import POSTmanualTaxCalculatorsResponse201
from .pos_tmanual_tax_calculators_response_201_data import POSTmanualTaxCalculatorsResponse201Data
from .pos_tmanual_tax_calculators_response_201_data_attributes import POSTmanualTaxCalculatorsResponse201DataAttributes
from .pos_tmanual_tax_calculators_response_201_data_attributes_metadata import (
    POSTmanualTaxCalculatorsResponse201DataAttributesMetadata,
)
from .pos_tmanual_tax_calculators_response_201_data_links import POSTmanualTaxCalculatorsResponse201DataLinks
from .pos_tmanual_tax_calculators_response_201_data_relationships import (
    POSTmanualTaxCalculatorsResponse201DataRelationships,
)
from .pos_tmanual_tax_calculators_response_201_data_relationships_attachments import (
    POSTmanualTaxCalculatorsResponse201DataRelationshipsAttachments,
)
from .pos_tmanual_tax_calculators_response_201_data_relationships_attachments_data import (
    POSTmanualTaxCalculatorsResponse201DataRelationshipsAttachmentsData,
)
from .pos_tmanual_tax_calculators_response_201_data_relationships_attachments_data_type import (
    POSTmanualTaxCalculatorsResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tmanual_tax_calculators_response_201_data_relationships_attachments_links import (
    POSTmanualTaxCalculatorsResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tmanual_tax_calculators_response_201_data_relationships_markets import (
    POSTmanualTaxCalculatorsResponse201DataRelationshipsMarkets,
)
from .pos_tmanual_tax_calculators_response_201_data_relationships_markets_data import (
    POSTmanualTaxCalculatorsResponse201DataRelationshipsMarketsData,
)
from .pos_tmanual_tax_calculators_response_201_data_relationships_markets_data_type import (
    POSTmanualTaxCalculatorsResponse201DataRelationshipsMarketsDataType,
)
from .pos_tmanual_tax_calculators_response_201_data_relationships_markets_links import (
    POSTmanualTaxCalculatorsResponse201DataRelationshipsMarketsLinks,
)
from .pos_tmanual_tax_calculators_response_201_data_relationships_tax_rules import (
    POSTmanualTaxCalculatorsResponse201DataRelationshipsTaxRules,
)
from .pos_tmanual_tax_calculators_response_201_data_relationships_tax_rules_data import (
    POSTmanualTaxCalculatorsResponse201DataRelationshipsTaxRulesData,
)
from .pos_tmanual_tax_calculators_response_201_data_relationships_tax_rules_data_type import (
    POSTmanualTaxCalculatorsResponse201DataRelationshipsTaxRulesDataType,
)
from .pos_tmanual_tax_calculators_response_201_data_relationships_tax_rules_links import (
    POSTmanualTaxCalculatorsResponse201DataRelationshipsTaxRulesLinks,
)
from .pos_tmanual_tax_calculators_response_201_data_type import POSTmanualTaxCalculatorsResponse201DataType
from .pos_tmarkets_response_201 import POSTmarketsResponse201
from .pos_tmarkets_response_201_data import POSTmarketsResponse201Data
from .pos_tmarkets_response_201_data_attributes import POSTmarketsResponse201DataAttributes
from .pos_tmarkets_response_201_data_attributes_metadata import POSTmarketsResponse201DataAttributesMetadata
from .pos_tmarkets_response_201_data_links import POSTmarketsResponse201DataLinks
from .pos_tmarkets_response_201_data_relationships import POSTmarketsResponse201DataRelationships
from .pos_tmarkets_response_201_data_relationships_attachments import POSTmarketsResponse201DataRelationshipsAttachments
from .pos_tmarkets_response_201_data_relationships_attachments_data import (
    POSTmarketsResponse201DataRelationshipsAttachmentsData,
)
from .pos_tmarkets_response_201_data_relationships_attachments_data_type import (
    POSTmarketsResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tmarkets_response_201_data_relationships_attachments_links import (
    POSTmarketsResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tmarkets_response_201_data_relationships_customer_group import (
    POSTmarketsResponse201DataRelationshipsCustomerGroup,
)
from .pos_tmarkets_response_201_data_relationships_customer_group_data import (
    POSTmarketsResponse201DataRelationshipsCustomerGroupData,
)
from .pos_tmarkets_response_201_data_relationships_customer_group_data_type import (
    POSTmarketsResponse201DataRelationshipsCustomerGroupDataType,
)
from .pos_tmarkets_response_201_data_relationships_customer_group_links import (
    POSTmarketsResponse201DataRelationshipsCustomerGroupLinks,
)
from .pos_tmarkets_response_201_data_relationships_inventory_model import (
    POSTmarketsResponse201DataRelationshipsInventoryModel,
)
from .pos_tmarkets_response_201_data_relationships_inventory_model_data import (
    POSTmarketsResponse201DataRelationshipsInventoryModelData,
)
from .pos_tmarkets_response_201_data_relationships_inventory_model_data_type import (
    POSTmarketsResponse201DataRelationshipsInventoryModelDataType,
)
from .pos_tmarkets_response_201_data_relationships_inventory_model_links import (
    POSTmarketsResponse201DataRelationshipsInventoryModelLinks,
)
from .pos_tmarkets_response_201_data_relationships_merchant import POSTmarketsResponse201DataRelationshipsMerchant
from .pos_tmarkets_response_201_data_relationships_merchant_data import (
    POSTmarketsResponse201DataRelationshipsMerchantData,
)
from .pos_tmarkets_response_201_data_relationships_merchant_data_type import (
    POSTmarketsResponse201DataRelationshipsMerchantDataType,
)
from .pos_tmarkets_response_201_data_relationships_merchant_links import (
    POSTmarketsResponse201DataRelationshipsMerchantLinks,
)
from .pos_tmarkets_response_201_data_relationships_price_list import POSTmarketsResponse201DataRelationshipsPriceList
from .pos_tmarkets_response_201_data_relationships_price_list_data import (
    POSTmarketsResponse201DataRelationshipsPriceListData,
)
from .pos_tmarkets_response_201_data_relationships_price_list_data_type import (
    POSTmarketsResponse201DataRelationshipsPriceListDataType,
)
from .pos_tmarkets_response_201_data_relationships_price_list_links import (
    POSTmarketsResponse201DataRelationshipsPriceListLinks,
)
from .pos_tmarkets_response_201_data_relationships_tax_calculator import (
    POSTmarketsResponse201DataRelationshipsTaxCalculator,
)
from .pos_tmarkets_response_201_data_relationships_tax_calculator_data import (
    POSTmarketsResponse201DataRelationshipsTaxCalculatorData,
)
from .pos_tmarkets_response_201_data_relationships_tax_calculator_data_type import (
    POSTmarketsResponse201DataRelationshipsTaxCalculatorDataType,
)
from .pos_tmarkets_response_201_data_relationships_tax_calculator_links import (
    POSTmarketsResponse201DataRelationshipsTaxCalculatorLinks,
)
from .pos_tmarkets_response_201_data_type import POSTmarketsResponse201DataType
from .pos_tmerchants_response_201 import POSTmerchantsResponse201
from .pos_tmerchants_response_201_data import POSTmerchantsResponse201Data
from .pos_tmerchants_response_201_data_attributes import POSTmerchantsResponse201DataAttributes
from .pos_tmerchants_response_201_data_attributes_metadata import POSTmerchantsResponse201DataAttributesMetadata
from .pos_tmerchants_response_201_data_links import POSTmerchantsResponse201DataLinks
from .pos_tmerchants_response_201_data_relationships import POSTmerchantsResponse201DataRelationships
from .pos_tmerchants_response_201_data_relationships_address import POSTmerchantsResponse201DataRelationshipsAddress
from .pos_tmerchants_response_201_data_relationships_address_data import (
    POSTmerchantsResponse201DataRelationshipsAddressData,
)
from .pos_tmerchants_response_201_data_relationships_address_data_type import (
    POSTmerchantsResponse201DataRelationshipsAddressDataType,
)
from .pos_tmerchants_response_201_data_relationships_address_links import (
    POSTmerchantsResponse201DataRelationshipsAddressLinks,
)
from .pos_tmerchants_response_201_data_relationships_attachments import (
    POSTmerchantsResponse201DataRelationshipsAttachments,
)
from .pos_tmerchants_response_201_data_relationships_attachments_data import (
    POSTmerchantsResponse201DataRelationshipsAttachmentsData,
)
from .pos_tmerchants_response_201_data_relationships_attachments_data_type import (
    POSTmerchantsResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tmerchants_response_201_data_relationships_attachments_links import (
    POSTmerchantsResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tmerchants_response_201_data_type import POSTmerchantsResponse201DataType
from .pos_torder_amount_promotion_rules_response_201 import POSTorderAmountPromotionRulesResponse201
from .pos_torder_amount_promotion_rules_response_201_data import POSTorderAmountPromotionRulesResponse201Data
from .pos_torder_amount_promotion_rules_response_201_data_attributes import (
    POSTorderAmountPromotionRulesResponse201DataAttributes,
)
from .pos_torder_amount_promotion_rules_response_201_data_attributes_metadata import (
    POSTorderAmountPromotionRulesResponse201DataAttributesMetadata,
)
from .pos_torder_amount_promotion_rules_response_201_data_links import POSTorderAmountPromotionRulesResponse201DataLinks
from .pos_torder_amount_promotion_rules_response_201_data_relationships import (
    POSTorderAmountPromotionRulesResponse201DataRelationships,
)
from .pos_torder_amount_promotion_rules_response_201_data_relationships_promotion import (
    POSTorderAmountPromotionRulesResponse201DataRelationshipsPromotion,
)
from .pos_torder_amount_promotion_rules_response_201_data_relationships_promotion_data import (
    POSTorderAmountPromotionRulesResponse201DataRelationshipsPromotionData,
)
from .pos_torder_amount_promotion_rules_response_201_data_relationships_promotion_data_type import (
    POSTorderAmountPromotionRulesResponse201DataRelationshipsPromotionDataType,
)
from .pos_torder_amount_promotion_rules_response_201_data_relationships_promotion_links import (
    POSTorderAmountPromotionRulesResponse201DataRelationshipsPromotionLinks,
)
from .pos_torder_amount_promotion_rules_response_201_data_type import POSTorderAmountPromotionRulesResponse201DataType
from .pos_torder_copies_response_201 import POSTorderCopiesResponse201
from .pos_torder_copies_response_201_data import POSTorderCopiesResponse201Data
from .pos_torder_copies_response_201_data_attributes import POSTorderCopiesResponse201DataAttributes
from .pos_torder_copies_response_201_data_attributes_metadata import POSTorderCopiesResponse201DataAttributesMetadata
from .pos_torder_copies_response_201_data_links import POSTorderCopiesResponse201DataLinks
from .pos_torder_copies_response_201_data_relationships import POSTorderCopiesResponse201DataRelationships
from .pos_torder_copies_response_201_data_relationships_events import POSTorderCopiesResponse201DataRelationshipsEvents
from .pos_torder_copies_response_201_data_relationships_events_data import (
    POSTorderCopiesResponse201DataRelationshipsEventsData,
)
from .pos_torder_copies_response_201_data_relationships_events_data_type import (
    POSTorderCopiesResponse201DataRelationshipsEventsDataType,
)
from .pos_torder_copies_response_201_data_relationships_events_links import (
    POSTorderCopiesResponse201DataRelationshipsEventsLinks,
)
from .pos_torder_copies_response_201_data_relationships_order_subscription import (
    POSTorderCopiesResponse201DataRelationshipsOrderSubscription,
)
from .pos_torder_copies_response_201_data_relationships_order_subscription_data import (
    POSTorderCopiesResponse201DataRelationshipsOrderSubscriptionData,
)
from .pos_torder_copies_response_201_data_relationships_order_subscription_data_type import (
    POSTorderCopiesResponse201DataRelationshipsOrderSubscriptionDataType,
)
from .pos_torder_copies_response_201_data_relationships_order_subscription_links import (
    POSTorderCopiesResponse201DataRelationshipsOrderSubscriptionLinks,
)
from .pos_torder_copies_response_201_data_relationships_source_order import (
    POSTorderCopiesResponse201DataRelationshipsSourceOrder,
)
from .pos_torder_copies_response_201_data_relationships_source_order_data import (
    POSTorderCopiesResponse201DataRelationshipsSourceOrderData,
)
from .pos_torder_copies_response_201_data_relationships_source_order_data_type import (
    POSTorderCopiesResponse201DataRelationshipsSourceOrderDataType,
)
from .pos_torder_copies_response_201_data_relationships_source_order_links import (
    POSTorderCopiesResponse201DataRelationshipsSourceOrderLinks,
)
from .pos_torder_copies_response_201_data_relationships_target_order import (
    POSTorderCopiesResponse201DataRelationshipsTargetOrder,
)
from .pos_torder_copies_response_201_data_relationships_target_order_data import (
    POSTorderCopiesResponse201DataRelationshipsTargetOrderData,
)
from .pos_torder_copies_response_201_data_relationships_target_order_data_type import (
    POSTorderCopiesResponse201DataRelationshipsTargetOrderDataType,
)
from .pos_torder_copies_response_201_data_relationships_target_order_links import (
    POSTorderCopiesResponse201DataRelationshipsTargetOrderLinks,
)
from .pos_torder_copies_response_201_data_type import POSTorderCopiesResponse201DataType
from .pos_torder_subscriptions_response_201 import POSTorderSubscriptionsResponse201
from .pos_torder_subscriptions_response_201_data import POSTorderSubscriptionsResponse201Data
from .pos_torder_subscriptions_response_201_data_attributes import POSTorderSubscriptionsResponse201DataAttributes
from .pos_torder_subscriptions_response_201_data_attributes_metadata import (
    POSTorderSubscriptionsResponse201DataAttributesMetadata,
)
from .pos_torder_subscriptions_response_201_data_attributes_options import (
    POSTorderSubscriptionsResponse201DataAttributesOptions,
)
from .pos_torder_subscriptions_response_201_data_links import POSTorderSubscriptionsResponse201DataLinks
from .pos_torder_subscriptions_response_201_data_relationships import POSTorderSubscriptionsResponse201DataRelationships
from .pos_torder_subscriptions_response_201_data_relationships_customer import (
    POSTorderSubscriptionsResponse201DataRelationshipsCustomer,
)
from .pos_torder_subscriptions_response_201_data_relationships_customer_data import (
    POSTorderSubscriptionsResponse201DataRelationshipsCustomerData,
)
from .pos_torder_subscriptions_response_201_data_relationships_customer_data_type import (
    POSTorderSubscriptionsResponse201DataRelationshipsCustomerDataType,
)
from .pos_torder_subscriptions_response_201_data_relationships_customer_links import (
    POSTorderSubscriptionsResponse201DataRelationshipsCustomerLinks,
)
from .pos_torder_subscriptions_response_201_data_relationships_events import (
    POSTorderSubscriptionsResponse201DataRelationshipsEvents,
)
from .pos_torder_subscriptions_response_201_data_relationships_events_data import (
    POSTorderSubscriptionsResponse201DataRelationshipsEventsData,
)
from .pos_torder_subscriptions_response_201_data_relationships_events_data_type import (
    POSTorderSubscriptionsResponse201DataRelationshipsEventsDataType,
)
from .pos_torder_subscriptions_response_201_data_relationships_events_links import (
    POSTorderSubscriptionsResponse201DataRelationshipsEventsLinks,
)
from .pos_torder_subscriptions_response_201_data_relationships_market import (
    POSTorderSubscriptionsResponse201DataRelationshipsMarket,
)
from .pos_torder_subscriptions_response_201_data_relationships_market_data import (
    POSTorderSubscriptionsResponse201DataRelationshipsMarketData,
)
from .pos_torder_subscriptions_response_201_data_relationships_market_data_type import (
    POSTorderSubscriptionsResponse201DataRelationshipsMarketDataType,
)
from .pos_torder_subscriptions_response_201_data_relationships_market_links import (
    POSTorderSubscriptionsResponse201DataRelationshipsMarketLinks,
)
from .pos_torder_subscriptions_response_201_data_relationships_order_copies import (
    POSTorderSubscriptionsResponse201DataRelationshipsOrderCopies,
)
from .pos_torder_subscriptions_response_201_data_relationships_order_copies_data import (
    POSTorderSubscriptionsResponse201DataRelationshipsOrderCopiesData,
)
from .pos_torder_subscriptions_response_201_data_relationships_order_copies_data_type import (
    POSTorderSubscriptionsResponse201DataRelationshipsOrderCopiesDataType,
)
from .pos_torder_subscriptions_response_201_data_relationships_order_copies_links import (
    POSTorderSubscriptionsResponse201DataRelationshipsOrderCopiesLinks,
)
from .pos_torder_subscriptions_response_201_data_relationships_orders import (
    POSTorderSubscriptionsResponse201DataRelationshipsOrders,
)
from .pos_torder_subscriptions_response_201_data_relationships_orders_data import (
    POSTorderSubscriptionsResponse201DataRelationshipsOrdersData,
)
from .pos_torder_subscriptions_response_201_data_relationships_orders_data_type import (
    POSTorderSubscriptionsResponse201DataRelationshipsOrdersDataType,
)
from .pos_torder_subscriptions_response_201_data_relationships_orders_links import (
    POSTorderSubscriptionsResponse201DataRelationshipsOrdersLinks,
)
from .pos_torder_subscriptions_response_201_data_relationships_source_order import (
    POSTorderSubscriptionsResponse201DataRelationshipsSourceOrder,
)
from .pos_torder_subscriptions_response_201_data_relationships_source_order_data import (
    POSTorderSubscriptionsResponse201DataRelationshipsSourceOrderData,
)
from .pos_torder_subscriptions_response_201_data_relationships_source_order_data_type import (
    POSTorderSubscriptionsResponse201DataRelationshipsSourceOrderDataType,
)
from .pos_torder_subscriptions_response_201_data_relationships_source_order_links import (
    POSTorderSubscriptionsResponse201DataRelationshipsSourceOrderLinks,
)
from .pos_torder_subscriptions_response_201_data_type import POSTorderSubscriptionsResponse201DataType
from .pos_torders_response_201 import POSTordersResponse201
from .pos_torders_response_201_data import POSTordersResponse201Data
from .pos_torders_response_201_data_attributes import POSTordersResponse201DataAttributes
from .pos_torders_response_201_data_attributes_metadata import POSTordersResponse201DataAttributesMetadata
from .pos_torders_response_201_data_links import POSTordersResponse201DataLinks
from .pos_torders_response_201_data_relationships import POSTordersResponse201DataRelationships
from .pos_torders_response_201_data_relationships_attachments import POSTordersResponse201DataRelationshipsAttachments
from .pos_torders_response_201_data_relationships_attachments_data import (
    POSTordersResponse201DataRelationshipsAttachmentsData,
)
from .pos_torders_response_201_data_relationships_attachments_data_type import (
    POSTordersResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_torders_response_201_data_relationships_attachments_links import (
    POSTordersResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_torders_response_201_data_relationships_authorizations import (
    POSTordersResponse201DataRelationshipsAuthorizations,
)
from .pos_torders_response_201_data_relationships_authorizations_data import (
    POSTordersResponse201DataRelationshipsAuthorizationsData,
)
from .pos_torders_response_201_data_relationships_authorizations_data_type import (
    POSTordersResponse201DataRelationshipsAuthorizationsDataType,
)
from .pos_torders_response_201_data_relationships_authorizations_links import (
    POSTordersResponse201DataRelationshipsAuthorizationsLinks,
)
from .pos_torders_response_201_data_relationships_available_customer_payment_sources import (
    POSTordersResponse201DataRelationshipsAvailableCustomerPaymentSources,
)
from .pos_torders_response_201_data_relationships_available_customer_payment_sources_data import (
    POSTordersResponse201DataRelationshipsAvailableCustomerPaymentSourcesData,
)
from .pos_torders_response_201_data_relationships_available_customer_payment_sources_data_type import (
    POSTordersResponse201DataRelationshipsAvailableCustomerPaymentSourcesDataType,
)
from .pos_torders_response_201_data_relationships_available_customer_payment_sources_links import (
    POSTordersResponse201DataRelationshipsAvailableCustomerPaymentSourcesLinks,
)
from .pos_torders_response_201_data_relationships_available_free_bundles import (
    POSTordersResponse201DataRelationshipsAvailableFreeBundles,
)
from .pos_torders_response_201_data_relationships_available_free_bundles_data import (
    POSTordersResponse201DataRelationshipsAvailableFreeBundlesData,
)
from .pos_torders_response_201_data_relationships_available_free_bundles_data_type import (
    POSTordersResponse201DataRelationshipsAvailableFreeBundlesDataType,
)
from .pos_torders_response_201_data_relationships_available_free_bundles_links import (
    POSTordersResponse201DataRelationshipsAvailableFreeBundlesLinks,
)
from .pos_torders_response_201_data_relationships_available_free_skus import (
    POSTordersResponse201DataRelationshipsAvailableFreeSkus,
)
from .pos_torders_response_201_data_relationships_available_free_skus_data import (
    POSTordersResponse201DataRelationshipsAvailableFreeSkusData,
)
from .pos_torders_response_201_data_relationships_available_free_skus_data_type import (
    POSTordersResponse201DataRelationshipsAvailableFreeSkusDataType,
)
from .pos_torders_response_201_data_relationships_available_free_skus_links import (
    POSTordersResponse201DataRelationshipsAvailableFreeSkusLinks,
)
from .pos_torders_response_201_data_relationships_available_payment_methods import (
    POSTordersResponse201DataRelationshipsAvailablePaymentMethods,
)
from .pos_torders_response_201_data_relationships_available_payment_methods_data import (
    POSTordersResponse201DataRelationshipsAvailablePaymentMethodsData,
)
from .pos_torders_response_201_data_relationships_available_payment_methods_data_type import (
    POSTordersResponse201DataRelationshipsAvailablePaymentMethodsDataType,
)
from .pos_torders_response_201_data_relationships_available_payment_methods_links import (
    POSTordersResponse201DataRelationshipsAvailablePaymentMethodsLinks,
)
from .pos_torders_response_201_data_relationships_billing_address import (
    POSTordersResponse201DataRelationshipsBillingAddress,
)
from .pos_torders_response_201_data_relationships_billing_address_data import (
    POSTordersResponse201DataRelationshipsBillingAddressData,
)
from .pos_torders_response_201_data_relationships_billing_address_data_type import (
    POSTordersResponse201DataRelationshipsBillingAddressDataType,
)
from .pos_torders_response_201_data_relationships_billing_address_links import (
    POSTordersResponse201DataRelationshipsBillingAddressLinks,
)
from .pos_torders_response_201_data_relationships_captures import POSTordersResponse201DataRelationshipsCaptures
from .pos_torders_response_201_data_relationships_captures_data import (
    POSTordersResponse201DataRelationshipsCapturesData,
)
from .pos_torders_response_201_data_relationships_captures_data_type import (
    POSTordersResponse201DataRelationshipsCapturesDataType,
)
from .pos_torders_response_201_data_relationships_captures_links import (
    POSTordersResponse201DataRelationshipsCapturesLinks,
)
from .pos_torders_response_201_data_relationships_customer import POSTordersResponse201DataRelationshipsCustomer
from .pos_torders_response_201_data_relationships_customer_data import (
    POSTordersResponse201DataRelationshipsCustomerData,
)
from .pos_torders_response_201_data_relationships_customer_data_type import (
    POSTordersResponse201DataRelationshipsCustomerDataType,
)
from .pos_torders_response_201_data_relationships_customer_links import (
    POSTordersResponse201DataRelationshipsCustomerLinks,
)
from .pos_torders_response_201_data_relationships_events import POSTordersResponse201DataRelationshipsEvents
from .pos_torders_response_201_data_relationships_events_data import POSTordersResponse201DataRelationshipsEventsData
from .pos_torders_response_201_data_relationships_events_data_type import (
    POSTordersResponse201DataRelationshipsEventsDataType,
)
from .pos_torders_response_201_data_relationships_events_links import POSTordersResponse201DataRelationshipsEventsLinks
from .pos_torders_response_201_data_relationships_line_items import POSTordersResponse201DataRelationshipsLineItems
from .pos_torders_response_201_data_relationships_line_items_data import (
    POSTordersResponse201DataRelationshipsLineItemsData,
)
from .pos_torders_response_201_data_relationships_line_items_data_type import (
    POSTordersResponse201DataRelationshipsLineItemsDataType,
)
from .pos_torders_response_201_data_relationships_line_items_links import (
    POSTordersResponse201DataRelationshipsLineItemsLinks,
)
from .pos_torders_response_201_data_relationships_market import POSTordersResponse201DataRelationshipsMarket
from .pos_torders_response_201_data_relationships_market_data import POSTordersResponse201DataRelationshipsMarketData
from .pos_torders_response_201_data_relationships_market_data_type import (
    POSTordersResponse201DataRelationshipsMarketDataType,
)
from .pos_torders_response_201_data_relationships_market_links import POSTordersResponse201DataRelationshipsMarketLinks
from .pos_torders_response_201_data_relationships_order_copies import POSTordersResponse201DataRelationshipsOrderCopies
from .pos_torders_response_201_data_relationships_order_copies_data import (
    POSTordersResponse201DataRelationshipsOrderCopiesData,
)
from .pos_torders_response_201_data_relationships_order_copies_data_type import (
    POSTordersResponse201DataRelationshipsOrderCopiesDataType,
)
from .pos_torders_response_201_data_relationships_order_copies_links import (
    POSTordersResponse201DataRelationshipsOrderCopiesLinks,
)
from .pos_torders_response_201_data_relationships_order_subscriptions import (
    POSTordersResponse201DataRelationshipsOrderSubscriptions,
)
from .pos_torders_response_201_data_relationships_order_subscriptions_data import (
    POSTordersResponse201DataRelationshipsOrderSubscriptionsData,
)
from .pos_torders_response_201_data_relationships_order_subscriptions_data_type import (
    POSTordersResponse201DataRelationshipsOrderSubscriptionsDataType,
)
from .pos_torders_response_201_data_relationships_order_subscriptions_links import (
    POSTordersResponse201DataRelationshipsOrderSubscriptionsLinks,
)
from .pos_torders_response_201_data_relationships_payment_method import (
    POSTordersResponse201DataRelationshipsPaymentMethod,
)
from .pos_torders_response_201_data_relationships_payment_method_data import (
    POSTordersResponse201DataRelationshipsPaymentMethodData,
)
from .pos_torders_response_201_data_relationships_payment_method_data_type import (
    POSTordersResponse201DataRelationshipsPaymentMethodDataType,
)
from .pos_torders_response_201_data_relationships_payment_method_links import (
    POSTordersResponse201DataRelationshipsPaymentMethodLinks,
)
from .pos_torders_response_201_data_relationships_payment_source import (
    POSTordersResponse201DataRelationshipsPaymentSource,
)
from .pos_torders_response_201_data_relationships_payment_source_data import (
    POSTordersResponse201DataRelationshipsPaymentSourceData,
)
from .pos_torders_response_201_data_relationships_payment_source_data_type import (
    POSTordersResponse201DataRelationshipsPaymentSourceDataType,
)
from .pos_torders_response_201_data_relationships_payment_source_links import (
    POSTordersResponse201DataRelationshipsPaymentSourceLinks,
)
from .pos_torders_response_201_data_relationships_refunds import POSTordersResponse201DataRelationshipsRefunds
from .pos_torders_response_201_data_relationships_refunds_data import POSTordersResponse201DataRelationshipsRefundsData
from .pos_torders_response_201_data_relationships_refunds_data_type import (
    POSTordersResponse201DataRelationshipsRefundsDataType,
)
from .pos_torders_response_201_data_relationships_refunds_links import (
    POSTordersResponse201DataRelationshipsRefundsLinks,
)
from .pos_torders_response_201_data_relationships_shipments import POSTordersResponse201DataRelationshipsShipments
from .pos_torders_response_201_data_relationships_shipments_data import (
    POSTordersResponse201DataRelationshipsShipmentsData,
)
from .pos_torders_response_201_data_relationships_shipments_data_type import (
    POSTordersResponse201DataRelationshipsShipmentsDataType,
)
from .pos_torders_response_201_data_relationships_shipments_links import (
    POSTordersResponse201DataRelationshipsShipmentsLinks,
)
from .pos_torders_response_201_data_relationships_shipping_address import (
    POSTordersResponse201DataRelationshipsShippingAddress,
)
from .pos_torders_response_201_data_relationships_shipping_address_data import (
    POSTordersResponse201DataRelationshipsShippingAddressData,
)
from .pos_torders_response_201_data_relationships_shipping_address_data_type import (
    POSTordersResponse201DataRelationshipsShippingAddressDataType,
)
from .pos_torders_response_201_data_relationships_shipping_address_links import (
    POSTordersResponse201DataRelationshipsShippingAddressLinks,
)
from .pos_torders_response_201_data_relationships_transactions import POSTordersResponse201DataRelationshipsTransactions
from .pos_torders_response_201_data_relationships_transactions_data import (
    POSTordersResponse201DataRelationshipsTransactionsData,
)
from .pos_torders_response_201_data_relationships_transactions_data_type import (
    POSTordersResponse201DataRelationshipsTransactionsDataType,
)
from .pos_torders_response_201_data_relationships_transactions_links import (
    POSTordersResponse201DataRelationshipsTransactionsLinks,
)
from .pos_torders_response_201_data_relationships_voids import POSTordersResponse201DataRelationshipsVoids
from .pos_torders_response_201_data_relationships_voids_data import POSTordersResponse201DataRelationshipsVoidsData
from .pos_torders_response_201_data_relationships_voids_data_type import (
    POSTordersResponse201DataRelationshipsVoidsDataType,
)
from .pos_torders_response_201_data_relationships_voids_links import POSTordersResponse201DataRelationshipsVoidsLinks
from .pos_torders_response_201_data_type import POSTordersResponse201DataType
from .pos_tpackages_response_201 import POSTpackagesResponse201
from .pos_tpackages_response_201_data import POSTpackagesResponse201Data
from .pos_tpackages_response_201_data_attributes import POSTpackagesResponse201DataAttributes
from .pos_tpackages_response_201_data_attributes_metadata import POSTpackagesResponse201DataAttributesMetadata
from .pos_tpackages_response_201_data_links import POSTpackagesResponse201DataLinks
from .pos_tpackages_response_201_data_relationships import POSTpackagesResponse201DataRelationships
from .pos_tpackages_response_201_data_relationships_attachments import (
    POSTpackagesResponse201DataRelationshipsAttachments,
)
from .pos_tpackages_response_201_data_relationships_attachments_data import (
    POSTpackagesResponse201DataRelationshipsAttachmentsData,
)
from .pos_tpackages_response_201_data_relationships_attachments_data_type import (
    POSTpackagesResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tpackages_response_201_data_relationships_attachments_links import (
    POSTpackagesResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tpackages_response_201_data_relationships_parcels import POSTpackagesResponse201DataRelationshipsParcels
from .pos_tpackages_response_201_data_relationships_parcels_data import (
    POSTpackagesResponse201DataRelationshipsParcelsData,
)
from .pos_tpackages_response_201_data_relationships_parcels_data_type import (
    POSTpackagesResponse201DataRelationshipsParcelsDataType,
)
from .pos_tpackages_response_201_data_relationships_parcels_links import (
    POSTpackagesResponse201DataRelationshipsParcelsLinks,
)
from .pos_tpackages_response_201_data_relationships_stock_location import (
    POSTpackagesResponse201DataRelationshipsStockLocation,
)
from .pos_tpackages_response_201_data_relationships_stock_location_data import (
    POSTpackagesResponse201DataRelationshipsStockLocationData,
)
from .pos_tpackages_response_201_data_relationships_stock_location_data_type import (
    POSTpackagesResponse201DataRelationshipsStockLocationDataType,
)
from .pos_tpackages_response_201_data_relationships_stock_location_links import (
    POSTpackagesResponse201DataRelationshipsStockLocationLinks,
)
from .pos_tpackages_response_201_data_type import POSTpackagesResponse201DataType
from .pos_tparcel_line_items_response_201 import POSTparcelLineItemsResponse201
from .pos_tparcel_line_items_response_201_data import POSTparcelLineItemsResponse201Data
from .pos_tparcel_line_items_response_201_data_attributes import POSTparcelLineItemsResponse201DataAttributes
from .pos_tparcel_line_items_response_201_data_attributes_metadata import (
    POSTparcelLineItemsResponse201DataAttributesMetadata,
)
from .pos_tparcel_line_items_response_201_data_links import POSTparcelLineItemsResponse201DataLinks
from .pos_tparcel_line_items_response_201_data_relationships import POSTparcelLineItemsResponse201DataRelationships
from .pos_tparcel_line_items_response_201_data_relationships_parcel import (
    POSTparcelLineItemsResponse201DataRelationshipsParcel,
)
from .pos_tparcel_line_items_response_201_data_relationships_parcel_data import (
    POSTparcelLineItemsResponse201DataRelationshipsParcelData,
)
from .pos_tparcel_line_items_response_201_data_relationships_parcel_data_type import (
    POSTparcelLineItemsResponse201DataRelationshipsParcelDataType,
)
from .pos_tparcel_line_items_response_201_data_relationships_parcel_links import (
    POSTparcelLineItemsResponse201DataRelationshipsParcelLinks,
)
from .pos_tparcel_line_items_response_201_data_relationships_shipment_line_item import (
    POSTparcelLineItemsResponse201DataRelationshipsShipmentLineItem,
)
from .pos_tparcel_line_items_response_201_data_relationships_shipment_line_item_data import (
    POSTparcelLineItemsResponse201DataRelationshipsShipmentLineItemData,
)
from .pos_tparcel_line_items_response_201_data_relationships_shipment_line_item_data_type import (
    POSTparcelLineItemsResponse201DataRelationshipsShipmentLineItemDataType,
)
from .pos_tparcel_line_items_response_201_data_relationships_shipment_line_item_links import (
    POSTparcelLineItemsResponse201DataRelationshipsShipmentLineItemLinks,
)
from .pos_tparcel_line_items_response_201_data_relationships_stock_line_item import (
    POSTparcelLineItemsResponse201DataRelationshipsStockLineItem,
)
from .pos_tparcel_line_items_response_201_data_relationships_stock_line_item_data import (
    POSTparcelLineItemsResponse201DataRelationshipsStockLineItemData,
)
from .pos_tparcel_line_items_response_201_data_relationships_stock_line_item_data_type import (
    POSTparcelLineItemsResponse201DataRelationshipsStockLineItemDataType,
)
from .pos_tparcel_line_items_response_201_data_relationships_stock_line_item_links import (
    POSTparcelLineItemsResponse201DataRelationshipsStockLineItemLinks,
)
from .pos_tparcel_line_items_response_201_data_type import POSTparcelLineItemsResponse201DataType
from .pos_tparcels_response_201 import POSTparcelsResponse201
from .pos_tparcels_response_201_data import POSTparcelsResponse201Data
from .pos_tparcels_response_201_data_attributes import POSTparcelsResponse201DataAttributes
from .pos_tparcels_response_201_data_attributes_metadata import POSTparcelsResponse201DataAttributesMetadata
from .pos_tparcels_response_201_data_links import POSTparcelsResponse201DataLinks
from .pos_tparcels_response_201_data_relationships import POSTparcelsResponse201DataRelationships
from .pos_tparcels_response_201_data_relationships_attachments import POSTparcelsResponse201DataRelationshipsAttachments
from .pos_tparcels_response_201_data_relationships_attachments_data import (
    POSTparcelsResponse201DataRelationshipsAttachmentsData,
)
from .pos_tparcels_response_201_data_relationships_attachments_data_type import (
    POSTparcelsResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tparcels_response_201_data_relationships_attachments_links import (
    POSTparcelsResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tparcels_response_201_data_relationships_events import POSTparcelsResponse201DataRelationshipsEvents
from .pos_tparcels_response_201_data_relationships_events_data import POSTparcelsResponse201DataRelationshipsEventsData
from .pos_tparcels_response_201_data_relationships_events_data_type import (
    POSTparcelsResponse201DataRelationshipsEventsDataType,
)
from .pos_tparcels_response_201_data_relationships_events_links import (
    POSTparcelsResponse201DataRelationshipsEventsLinks,
)
from .pos_tparcels_response_201_data_relationships_package import POSTparcelsResponse201DataRelationshipsPackage
from .pos_tparcels_response_201_data_relationships_package_data import (
    POSTparcelsResponse201DataRelationshipsPackageData,
)
from .pos_tparcels_response_201_data_relationships_package_data_type import (
    POSTparcelsResponse201DataRelationshipsPackageDataType,
)
from .pos_tparcels_response_201_data_relationships_package_links import (
    POSTparcelsResponse201DataRelationshipsPackageLinks,
)
from .pos_tparcels_response_201_data_relationships_parcel_line_items import (
    POSTparcelsResponse201DataRelationshipsParcelLineItems,
)
from .pos_tparcels_response_201_data_relationships_parcel_line_items_data import (
    POSTparcelsResponse201DataRelationshipsParcelLineItemsData,
)
from .pos_tparcels_response_201_data_relationships_parcel_line_items_data_type import (
    POSTparcelsResponse201DataRelationshipsParcelLineItemsDataType,
)
from .pos_tparcels_response_201_data_relationships_parcel_line_items_links import (
    POSTparcelsResponse201DataRelationshipsParcelLineItemsLinks,
)
from .pos_tparcels_response_201_data_relationships_shipment import POSTparcelsResponse201DataRelationshipsShipment
from .pos_tparcels_response_201_data_relationships_shipment_data import (
    POSTparcelsResponse201DataRelationshipsShipmentData,
)
from .pos_tparcels_response_201_data_relationships_shipment_data_type import (
    POSTparcelsResponse201DataRelationshipsShipmentDataType,
)
from .pos_tparcels_response_201_data_relationships_shipment_links import (
    POSTparcelsResponse201DataRelationshipsShipmentLinks,
)
from .pos_tparcels_response_201_data_type import POSTparcelsResponse201DataType
from .pos_tpayment_methods_response_201 import POSTpaymentMethodsResponse201
from .pos_tpayment_methods_response_201_data import POSTpaymentMethodsResponse201Data
from .pos_tpayment_methods_response_201_data_attributes import POSTpaymentMethodsResponse201DataAttributes
from .pos_tpayment_methods_response_201_data_attributes_metadata import (
    POSTpaymentMethodsResponse201DataAttributesMetadata,
)
from .pos_tpayment_methods_response_201_data_links import POSTpaymentMethodsResponse201DataLinks
from .pos_tpayment_methods_response_201_data_relationships import POSTpaymentMethodsResponse201DataRelationships
from .pos_tpayment_methods_response_201_data_relationships_attachments import (
    POSTpaymentMethodsResponse201DataRelationshipsAttachments,
)
from .pos_tpayment_methods_response_201_data_relationships_attachments_data import (
    POSTpaymentMethodsResponse201DataRelationshipsAttachmentsData,
)
from .pos_tpayment_methods_response_201_data_relationships_attachments_data_type import (
    POSTpaymentMethodsResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tpayment_methods_response_201_data_relationships_attachments_links import (
    POSTpaymentMethodsResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tpayment_methods_response_201_data_relationships_market import (
    POSTpaymentMethodsResponse201DataRelationshipsMarket,
)
from .pos_tpayment_methods_response_201_data_relationships_market_data import (
    POSTpaymentMethodsResponse201DataRelationshipsMarketData,
)
from .pos_tpayment_methods_response_201_data_relationships_market_data_type import (
    POSTpaymentMethodsResponse201DataRelationshipsMarketDataType,
)
from .pos_tpayment_methods_response_201_data_relationships_market_links import (
    POSTpaymentMethodsResponse201DataRelationshipsMarketLinks,
)
from .pos_tpayment_methods_response_201_data_relationships_payment_gateway import (
    POSTpaymentMethodsResponse201DataRelationshipsPaymentGateway,
)
from .pos_tpayment_methods_response_201_data_relationships_payment_gateway_data import (
    POSTpaymentMethodsResponse201DataRelationshipsPaymentGatewayData,
)
from .pos_tpayment_methods_response_201_data_relationships_payment_gateway_data_type import (
    POSTpaymentMethodsResponse201DataRelationshipsPaymentGatewayDataType,
)
from .pos_tpayment_methods_response_201_data_relationships_payment_gateway_links import (
    POSTpaymentMethodsResponse201DataRelationshipsPaymentGatewayLinks,
)
from .pos_tpayment_methods_response_201_data_type import POSTpaymentMethodsResponse201DataType
from .pos_tpaypal_gateways_response_201 import POSTpaypalGatewaysResponse201
from .pos_tpaypal_gateways_response_201_data import POSTpaypalGatewaysResponse201Data
from .pos_tpaypal_gateways_response_201_data_attributes import POSTpaypalGatewaysResponse201DataAttributes
from .pos_tpaypal_gateways_response_201_data_attributes_metadata import (
    POSTpaypalGatewaysResponse201DataAttributesMetadata,
)
from .pos_tpaypal_gateways_response_201_data_links import POSTpaypalGatewaysResponse201DataLinks
from .pos_tpaypal_gateways_response_201_data_relationships import POSTpaypalGatewaysResponse201DataRelationships
from .pos_tpaypal_gateways_response_201_data_relationships_payment_methods import (
    POSTpaypalGatewaysResponse201DataRelationshipsPaymentMethods,
)
from .pos_tpaypal_gateways_response_201_data_relationships_payment_methods_data import (
    POSTpaypalGatewaysResponse201DataRelationshipsPaymentMethodsData,
)
from .pos_tpaypal_gateways_response_201_data_relationships_payment_methods_data_type import (
    POSTpaypalGatewaysResponse201DataRelationshipsPaymentMethodsDataType,
)
from .pos_tpaypal_gateways_response_201_data_relationships_payment_methods_links import (
    POSTpaypalGatewaysResponse201DataRelationshipsPaymentMethodsLinks,
)
from .pos_tpaypal_gateways_response_201_data_relationships_paypal_payments import (
    POSTpaypalGatewaysResponse201DataRelationshipsPaypalPayments,
)
from .pos_tpaypal_gateways_response_201_data_relationships_paypal_payments_data import (
    POSTpaypalGatewaysResponse201DataRelationshipsPaypalPaymentsData,
)
from .pos_tpaypal_gateways_response_201_data_relationships_paypal_payments_data_type import (
    POSTpaypalGatewaysResponse201DataRelationshipsPaypalPaymentsDataType,
)
from .pos_tpaypal_gateways_response_201_data_relationships_paypal_payments_links import (
    POSTpaypalGatewaysResponse201DataRelationshipsPaypalPaymentsLinks,
)
from .pos_tpaypal_gateways_response_201_data_type import POSTpaypalGatewaysResponse201DataType
from .pos_tpaypal_payments_response_201 import POSTpaypalPaymentsResponse201
from .pos_tpaypal_payments_response_201_data import POSTpaypalPaymentsResponse201Data
from .pos_tpaypal_payments_response_201_data_attributes import POSTpaypalPaymentsResponse201DataAttributes
from .pos_tpaypal_payments_response_201_data_attributes_metadata import (
    POSTpaypalPaymentsResponse201DataAttributesMetadata,
)
from .pos_tpaypal_payments_response_201_data_links import POSTpaypalPaymentsResponse201DataLinks
from .pos_tpaypal_payments_response_201_data_relationships import POSTpaypalPaymentsResponse201DataRelationships
from .pos_tpaypal_payments_response_201_data_relationships_order import (
    POSTpaypalPaymentsResponse201DataRelationshipsOrder,
)
from .pos_tpaypal_payments_response_201_data_relationships_order_data import (
    POSTpaypalPaymentsResponse201DataRelationshipsOrderData,
)
from .pos_tpaypal_payments_response_201_data_relationships_order_data_type import (
    POSTpaypalPaymentsResponse201DataRelationshipsOrderDataType,
)
from .pos_tpaypal_payments_response_201_data_relationships_order_links import (
    POSTpaypalPaymentsResponse201DataRelationshipsOrderLinks,
)
from .pos_tpaypal_payments_response_201_data_relationships_payment_gateway import (
    POSTpaypalPaymentsResponse201DataRelationshipsPaymentGateway,
)
from .pos_tpaypal_payments_response_201_data_relationships_payment_gateway_data import (
    POSTpaypalPaymentsResponse201DataRelationshipsPaymentGatewayData,
)
from .pos_tpaypal_payments_response_201_data_relationships_payment_gateway_data_type import (
    POSTpaypalPaymentsResponse201DataRelationshipsPaymentGatewayDataType,
)
from .pos_tpaypal_payments_response_201_data_relationships_payment_gateway_links import (
    POSTpaypalPaymentsResponse201DataRelationshipsPaymentGatewayLinks,
)
from .pos_tpaypal_payments_response_201_data_type import POSTpaypalPaymentsResponse201DataType
from .pos_tpercentage_discount_promotions_response_201 import POSTpercentageDiscountPromotionsResponse201
from .pos_tpercentage_discount_promotions_response_201_data import POSTpercentageDiscountPromotionsResponse201Data
from .pos_tpercentage_discount_promotions_response_201_data_attributes import (
    POSTpercentageDiscountPromotionsResponse201DataAttributes,
)
from .pos_tpercentage_discount_promotions_response_201_data_attributes_metadata import (
    POSTpercentageDiscountPromotionsResponse201DataAttributesMetadata,
)
from .pos_tpercentage_discount_promotions_response_201_data_links import (
    POSTpercentageDiscountPromotionsResponse201DataLinks,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships import (
    POSTpercentageDiscountPromotionsResponse201DataRelationships,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_attachments import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsAttachments,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_attachments_data import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsAttachmentsData,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_attachments_data_type import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_attachments_links import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_coupon_codes_promotion_rule import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsCouponCodesPromotionRule,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_coupon_codes_promotion_rule_data import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleData,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_coupon_codes_promotion_rule_data_type import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleDataType,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_coupon_codes_promotion_rule_links import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleLinks,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_market import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsMarket,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_market_data import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsMarketData,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_market_data_type import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsMarketDataType,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_market_links import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsMarketLinks,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_order_amount_promotion_rule import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsOrderAmountPromotionRule,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_order_amount_promotion_rule_data import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleData,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_order_amount_promotion_rule_data_type import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleDataType,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_order_amount_promotion_rule_links import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleLinks,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_promotion_rules import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsPromotionRules,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_promotion_rules_data import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsPromotionRulesData,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_promotion_rules_data_type import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsPromotionRulesDataType,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_promotion_rules_links import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsPromotionRulesLinks,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_sku_list import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsSkuList,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_sku_list_data import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsSkuListData,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_sku_list_data_type import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsSkuListDataType,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_sku_list_links import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsSkuListLinks,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_sku_list_promotion_rule import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsSkuListPromotionRule,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_sku_list_promotion_rule_data import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsSkuListPromotionRuleData,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_sku_list_promotion_rule_data_type import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsSkuListPromotionRuleDataType,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_sku_list_promotion_rule_links import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsSkuListPromotionRuleLinks,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_skus import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsSkus,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_skus_data import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsSkusData,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_skus_data_type import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsSkusDataType,
)
from .pos_tpercentage_discount_promotions_response_201_data_relationships_skus_links import (
    POSTpercentageDiscountPromotionsResponse201DataRelationshipsSkusLinks,
)
from .pos_tpercentage_discount_promotions_response_201_data_type import (
    POSTpercentageDiscountPromotionsResponse201DataType,
)
from .pos_tprice_lists_response_201 import POSTpriceListsResponse201
from .pos_tprice_lists_response_201_data import POSTpriceListsResponse201Data
from .pos_tprice_lists_response_201_data_attributes import POSTpriceListsResponse201DataAttributes
from .pos_tprice_lists_response_201_data_attributes_metadata import POSTpriceListsResponse201DataAttributesMetadata
from .pos_tprice_lists_response_201_data_links import POSTpriceListsResponse201DataLinks
from .pos_tprice_lists_response_201_data_relationships import POSTpriceListsResponse201DataRelationships
from .pos_tprice_lists_response_201_data_relationships_attachments import (
    POSTpriceListsResponse201DataRelationshipsAttachments,
)
from .pos_tprice_lists_response_201_data_relationships_attachments_data import (
    POSTpriceListsResponse201DataRelationshipsAttachmentsData,
)
from .pos_tprice_lists_response_201_data_relationships_attachments_data_type import (
    POSTpriceListsResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tprice_lists_response_201_data_relationships_attachments_links import (
    POSTpriceListsResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tprice_lists_response_201_data_relationships_prices import POSTpriceListsResponse201DataRelationshipsPrices
from .pos_tprice_lists_response_201_data_relationships_prices_data import (
    POSTpriceListsResponse201DataRelationshipsPricesData,
)
from .pos_tprice_lists_response_201_data_relationships_prices_data_type import (
    POSTpriceListsResponse201DataRelationshipsPricesDataType,
)
from .pos_tprice_lists_response_201_data_relationships_prices_links import (
    POSTpriceListsResponse201DataRelationshipsPricesLinks,
)
from .pos_tprice_lists_response_201_data_type import POSTpriceListsResponse201DataType
from .pos_tprice_volume_tiers_response_201 import POSTpriceVolumeTiersResponse201
from .pos_tprice_volume_tiers_response_201_data import POSTpriceVolumeTiersResponse201Data
from .pos_tprice_volume_tiers_response_201_data_attributes import POSTpriceVolumeTiersResponse201DataAttributes
from .pos_tprice_volume_tiers_response_201_data_attributes_metadata import (
    POSTpriceVolumeTiersResponse201DataAttributesMetadata,
)
from .pos_tprice_volume_tiers_response_201_data_links import POSTpriceVolumeTiersResponse201DataLinks
from .pos_tprice_volume_tiers_response_201_data_relationships import POSTpriceVolumeTiersResponse201DataRelationships
from .pos_tprice_volume_tiers_response_201_data_relationships_attachments import (
    POSTpriceVolumeTiersResponse201DataRelationshipsAttachments,
)
from .pos_tprice_volume_tiers_response_201_data_relationships_attachments_data import (
    POSTpriceVolumeTiersResponse201DataRelationshipsAttachmentsData,
)
from .pos_tprice_volume_tiers_response_201_data_relationships_attachments_data_type import (
    POSTpriceVolumeTiersResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tprice_volume_tiers_response_201_data_relationships_attachments_links import (
    POSTpriceVolumeTiersResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tprice_volume_tiers_response_201_data_relationships_price import (
    POSTpriceVolumeTiersResponse201DataRelationshipsPrice,
)
from .pos_tprice_volume_tiers_response_201_data_relationships_price_data import (
    POSTpriceVolumeTiersResponse201DataRelationshipsPriceData,
)
from .pos_tprice_volume_tiers_response_201_data_relationships_price_data_type import (
    POSTpriceVolumeTiersResponse201DataRelationshipsPriceDataType,
)
from .pos_tprice_volume_tiers_response_201_data_relationships_price_links import (
    POSTpriceVolumeTiersResponse201DataRelationshipsPriceLinks,
)
from .pos_tprice_volume_tiers_response_201_data_type import POSTpriceVolumeTiersResponse201DataType
from .pos_tprices_response_201 import POSTpricesResponse201
from .pos_tprices_response_201_data import POSTpricesResponse201Data
from .pos_tprices_response_201_data_attributes import POSTpricesResponse201DataAttributes
from .pos_tprices_response_201_data_attributes_metadata import POSTpricesResponse201DataAttributesMetadata
from .pos_tprices_response_201_data_links import POSTpricesResponse201DataLinks
from .pos_tprices_response_201_data_relationships import POSTpricesResponse201DataRelationships
from .pos_tprices_response_201_data_relationships_attachments import POSTpricesResponse201DataRelationshipsAttachments
from .pos_tprices_response_201_data_relationships_attachments_data import (
    POSTpricesResponse201DataRelationshipsAttachmentsData,
)
from .pos_tprices_response_201_data_relationships_attachments_data_type import (
    POSTpricesResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tprices_response_201_data_relationships_attachments_links import (
    POSTpricesResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tprices_response_201_data_relationships_price_list import POSTpricesResponse201DataRelationshipsPriceList
from .pos_tprices_response_201_data_relationships_price_list_data import (
    POSTpricesResponse201DataRelationshipsPriceListData,
)
from .pos_tprices_response_201_data_relationships_price_list_data_type import (
    POSTpricesResponse201DataRelationshipsPriceListDataType,
)
from .pos_tprices_response_201_data_relationships_price_list_links import (
    POSTpricesResponse201DataRelationshipsPriceListLinks,
)
from .pos_tprices_response_201_data_relationships_price_tiers import POSTpricesResponse201DataRelationshipsPriceTiers
from .pos_tprices_response_201_data_relationships_price_tiers_data import (
    POSTpricesResponse201DataRelationshipsPriceTiersData,
)
from .pos_tprices_response_201_data_relationships_price_tiers_data_type import (
    POSTpricesResponse201DataRelationshipsPriceTiersDataType,
)
from .pos_tprices_response_201_data_relationships_price_tiers_links import (
    POSTpricesResponse201DataRelationshipsPriceTiersLinks,
)
from .pos_tprices_response_201_data_relationships_price_volume_tiers import (
    POSTpricesResponse201DataRelationshipsPriceVolumeTiers,
)
from .pos_tprices_response_201_data_relationships_price_volume_tiers_data import (
    POSTpricesResponse201DataRelationshipsPriceVolumeTiersData,
)
from .pos_tprices_response_201_data_relationships_price_volume_tiers_data_type import (
    POSTpricesResponse201DataRelationshipsPriceVolumeTiersDataType,
)
from .pos_tprices_response_201_data_relationships_price_volume_tiers_links import (
    POSTpricesResponse201DataRelationshipsPriceVolumeTiersLinks,
)
from .pos_tprices_response_201_data_relationships_sku import POSTpricesResponse201DataRelationshipsSku
from .pos_tprices_response_201_data_relationships_sku_data import POSTpricesResponse201DataRelationshipsSkuData
from .pos_tprices_response_201_data_relationships_sku_data_type import POSTpricesResponse201DataRelationshipsSkuDataType
from .pos_tprices_response_201_data_relationships_sku_links import POSTpricesResponse201DataRelationshipsSkuLinks
from .pos_tprices_response_201_data_type import POSTpricesResponse201DataType
from .pos_treturn_line_items_response_201 import POSTreturnLineItemsResponse201
from .pos_treturn_line_items_response_201_data import POSTreturnLineItemsResponse201Data
from .pos_treturn_line_items_response_201_data_attributes import POSTreturnLineItemsResponse201DataAttributes
from .pos_treturn_line_items_response_201_data_attributes_metadata import (
    POSTreturnLineItemsResponse201DataAttributesMetadata,
)
from .pos_treturn_line_items_response_201_data_attributes_return_reason import (
    POSTreturnLineItemsResponse201DataAttributesReturnReason,
)
from .pos_treturn_line_items_response_201_data_links import POSTreturnLineItemsResponse201DataLinks
from .pos_treturn_line_items_response_201_data_relationships import POSTreturnLineItemsResponse201DataRelationships
from .pos_treturn_line_items_response_201_data_relationships_line_item import (
    POSTreturnLineItemsResponse201DataRelationshipsLineItem,
)
from .pos_treturn_line_items_response_201_data_relationships_line_item_data import (
    POSTreturnLineItemsResponse201DataRelationshipsLineItemData,
)
from .pos_treturn_line_items_response_201_data_relationships_line_item_data_type import (
    POSTreturnLineItemsResponse201DataRelationshipsLineItemDataType,
)
from .pos_treturn_line_items_response_201_data_relationships_line_item_links import (
    POSTreturnLineItemsResponse201DataRelationshipsLineItemLinks,
)
from .pos_treturn_line_items_response_201_data_relationships_return import (
    POSTreturnLineItemsResponse201DataRelationshipsReturn,
)
from .pos_treturn_line_items_response_201_data_relationships_return_data import (
    POSTreturnLineItemsResponse201DataRelationshipsReturnData,
)
from .pos_treturn_line_items_response_201_data_relationships_return_data_type import (
    POSTreturnLineItemsResponse201DataRelationshipsReturnDataType,
)
from .pos_treturn_line_items_response_201_data_relationships_return_links import (
    POSTreturnLineItemsResponse201DataRelationshipsReturnLinks,
)
from .pos_treturn_line_items_response_201_data_type import POSTreturnLineItemsResponse201DataType
from .pos_treturns_response_201 import POSTreturnsResponse201
from .pos_treturns_response_201_data import POSTreturnsResponse201Data
from .pos_treturns_response_201_data_attributes import POSTreturnsResponse201DataAttributes
from .pos_treturns_response_201_data_attributes_metadata import POSTreturnsResponse201DataAttributesMetadata
from .pos_treturns_response_201_data_links import POSTreturnsResponse201DataLinks
from .pos_treturns_response_201_data_relationships import POSTreturnsResponse201DataRelationships
from .pos_treturns_response_201_data_relationships_attachments import POSTreturnsResponse201DataRelationshipsAttachments
from .pos_treturns_response_201_data_relationships_attachments_data import (
    POSTreturnsResponse201DataRelationshipsAttachmentsData,
)
from .pos_treturns_response_201_data_relationships_attachments_data_type import (
    POSTreturnsResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_treturns_response_201_data_relationships_attachments_links import (
    POSTreturnsResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_treturns_response_201_data_relationships_customer import POSTreturnsResponse201DataRelationshipsCustomer
from .pos_treturns_response_201_data_relationships_customer_data import (
    POSTreturnsResponse201DataRelationshipsCustomerData,
)
from .pos_treturns_response_201_data_relationships_customer_data_type import (
    POSTreturnsResponse201DataRelationshipsCustomerDataType,
)
from .pos_treturns_response_201_data_relationships_customer_links import (
    POSTreturnsResponse201DataRelationshipsCustomerLinks,
)
from .pos_treturns_response_201_data_relationships_destination_address import (
    POSTreturnsResponse201DataRelationshipsDestinationAddress,
)
from .pos_treturns_response_201_data_relationships_destination_address_data import (
    POSTreturnsResponse201DataRelationshipsDestinationAddressData,
)
from .pos_treturns_response_201_data_relationships_destination_address_data_type import (
    POSTreturnsResponse201DataRelationshipsDestinationAddressDataType,
)
from .pos_treturns_response_201_data_relationships_destination_address_links import (
    POSTreturnsResponse201DataRelationshipsDestinationAddressLinks,
)
from .pos_treturns_response_201_data_relationships_events import POSTreturnsResponse201DataRelationshipsEvents
from .pos_treturns_response_201_data_relationships_events_data import POSTreturnsResponse201DataRelationshipsEventsData
from .pos_treturns_response_201_data_relationships_events_data_type import (
    POSTreturnsResponse201DataRelationshipsEventsDataType,
)
from .pos_treturns_response_201_data_relationships_events_links import (
    POSTreturnsResponse201DataRelationshipsEventsLinks,
)
from .pos_treturns_response_201_data_relationships_order import POSTreturnsResponse201DataRelationshipsOrder
from .pos_treturns_response_201_data_relationships_order_data import POSTreturnsResponse201DataRelationshipsOrderData
from .pos_treturns_response_201_data_relationships_order_data_type import (
    POSTreturnsResponse201DataRelationshipsOrderDataType,
)
from .pos_treturns_response_201_data_relationships_order_links import POSTreturnsResponse201DataRelationshipsOrderLinks
from .pos_treturns_response_201_data_relationships_origin_address import (
    POSTreturnsResponse201DataRelationshipsOriginAddress,
)
from .pos_treturns_response_201_data_relationships_origin_address_data import (
    POSTreturnsResponse201DataRelationshipsOriginAddressData,
)
from .pos_treturns_response_201_data_relationships_origin_address_data_type import (
    POSTreturnsResponse201DataRelationshipsOriginAddressDataType,
)
from .pos_treturns_response_201_data_relationships_origin_address_links import (
    POSTreturnsResponse201DataRelationshipsOriginAddressLinks,
)
from .pos_treturns_response_201_data_relationships_return_line_items import (
    POSTreturnsResponse201DataRelationshipsReturnLineItems,
)
from .pos_treturns_response_201_data_relationships_return_line_items_data import (
    POSTreturnsResponse201DataRelationshipsReturnLineItemsData,
)
from .pos_treturns_response_201_data_relationships_return_line_items_data_type import (
    POSTreturnsResponse201DataRelationshipsReturnLineItemsDataType,
)
from .pos_treturns_response_201_data_relationships_return_line_items_links import (
    POSTreturnsResponse201DataRelationshipsReturnLineItemsLinks,
)
from .pos_treturns_response_201_data_relationships_stock_location import (
    POSTreturnsResponse201DataRelationshipsStockLocation,
)
from .pos_treturns_response_201_data_relationships_stock_location_data import (
    POSTreturnsResponse201DataRelationshipsStockLocationData,
)
from .pos_treturns_response_201_data_relationships_stock_location_data_type import (
    POSTreturnsResponse201DataRelationshipsStockLocationDataType,
)
from .pos_treturns_response_201_data_relationships_stock_location_links import (
    POSTreturnsResponse201DataRelationshipsStockLocationLinks,
)
from .pos_treturns_response_201_data_type import POSTreturnsResponse201DataType
from .pos_tshipping_categories_response_201 import POSTshippingCategoriesResponse201
from .pos_tshipping_categories_response_201_data import POSTshippingCategoriesResponse201Data
from .pos_tshipping_categories_response_201_data_attributes import POSTshippingCategoriesResponse201DataAttributes
from .pos_tshipping_categories_response_201_data_attributes_metadata import (
    POSTshippingCategoriesResponse201DataAttributesMetadata,
)
from .pos_tshipping_categories_response_201_data_links import POSTshippingCategoriesResponse201DataLinks
from .pos_tshipping_categories_response_201_data_relationships import POSTshippingCategoriesResponse201DataRelationships
from .pos_tshipping_categories_response_201_data_relationships_attachments import (
    POSTshippingCategoriesResponse201DataRelationshipsAttachments,
)
from .pos_tshipping_categories_response_201_data_relationships_attachments_data import (
    POSTshippingCategoriesResponse201DataRelationshipsAttachmentsData,
)
from .pos_tshipping_categories_response_201_data_relationships_attachments_data_type import (
    POSTshippingCategoriesResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tshipping_categories_response_201_data_relationships_attachments_links import (
    POSTshippingCategoriesResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tshipping_categories_response_201_data_relationships_skus import (
    POSTshippingCategoriesResponse201DataRelationshipsSkus,
)
from .pos_tshipping_categories_response_201_data_relationships_skus_data import (
    POSTshippingCategoriesResponse201DataRelationshipsSkusData,
)
from .pos_tshipping_categories_response_201_data_relationships_skus_data_type import (
    POSTshippingCategoriesResponse201DataRelationshipsSkusDataType,
)
from .pos_tshipping_categories_response_201_data_relationships_skus_links import (
    POSTshippingCategoriesResponse201DataRelationshipsSkusLinks,
)
from .pos_tshipping_categories_response_201_data_type import POSTshippingCategoriesResponse201DataType
from .pos_tshipping_methods_response_201 import POSTshippingMethodsResponse201
from .pos_tshipping_methods_response_201_data import POSTshippingMethodsResponse201Data
from .pos_tshipping_methods_response_201_data_attributes import POSTshippingMethodsResponse201DataAttributes
from .pos_tshipping_methods_response_201_data_attributes_metadata import (
    POSTshippingMethodsResponse201DataAttributesMetadata,
)
from .pos_tshipping_methods_response_201_data_links import POSTshippingMethodsResponse201DataLinks
from .pos_tshipping_methods_response_201_data_relationships import POSTshippingMethodsResponse201DataRelationships
from .pos_tshipping_methods_response_201_data_relationships_attachments import (
    POSTshippingMethodsResponse201DataRelationshipsAttachments,
)
from .pos_tshipping_methods_response_201_data_relationships_attachments_data import (
    POSTshippingMethodsResponse201DataRelationshipsAttachmentsData,
)
from .pos_tshipping_methods_response_201_data_relationships_attachments_data_type import (
    POSTshippingMethodsResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tshipping_methods_response_201_data_relationships_attachments_links import (
    POSTshippingMethodsResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tshipping_methods_response_201_data_relationships_delivery_lead_time_for_shipment import (
    POSTshippingMethodsResponse201DataRelationshipsDeliveryLeadTimeForShipment,
)
from .pos_tshipping_methods_response_201_data_relationships_delivery_lead_time_for_shipment_data import (
    POSTshippingMethodsResponse201DataRelationshipsDeliveryLeadTimeForShipmentData,
)
from .pos_tshipping_methods_response_201_data_relationships_delivery_lead_time_for_shipment_data_type import (
    POSTshippingMethodsResponse201DataRelationshipsDeliveryLeadTimeForShipmentDataType,
)
from .pos_tshipping_methods_response_201_data_relationships_delivery_lead_time_for_shipment_links import (
    POSTshippingMethodsResponse201DataRelationshipsDeliveryLeadTimeForShipmentLinks,
)
from .pos_tshipping_methods_response_201_data_relationships_market import (
    POSTshippingMethodsResponse201DataRelationshipsMarket,
)
from .pos_tshipping_methods_response_201_data_relationships_market_data import (
    POSTshippingMethodsResponse201DataRelationshipsMarketData,
)
from .pos_tshipping_methods_response_201_data_relationships_market_data_type import (
    POSTshippingMethodsResponse201DataRelationshipsMarketDataType,
)
from .pos_tshipping_methods_response_201_data_relationships_market_links import (
    POSTshippingMethodsResponse201DataRelationshipsMarketLinks,
)
from .pos_tshipping_methods_response_201_data_relationships_shipping_category import (
    POSTshippingMethodsResponse201DataRelationshipsShippingCategory,
)
from .pos_tshipping_methods_response_201_data_relationships_shipping_category_data import (
    POSTshippingMethodsResponse201DataRelationshipsShippingCategoryData,
)
from .pos_tshipping_methods_response_201_data_relationships_shipping_category_data_type import (
    POSTshippingMethodsResponse201DataRelationshipsShippingCategoryDataType,
)
from .pos_tshipping_methods_response_201_data_relationships_shipping_category_links import (
    POSTshippingMethodsResponse201DataRelationshipsShippingCategoryLinks,
)
from .pos_tshipping_methods_response_201_data_relationships_shipping_method_tiers import (
    POSTshippingMethodsResponse201DataRelationshipsShippingMethodTiers,
)
from .pos_tshipping_methods_response_201_data_relationships_shipping_method_tiers_data import (
    POSTshippingMethodsResponse201DataRelationshipsShippingMethodTiersData,
)
from .pos_tshipping_methods_response_201_data_relationships_shipping_method_tiers_data_type import (
    POSTshippingMethodsResponse201DataRelationshipsShippingMethodTiersDataType,
)
from .pos_tshipping_methods_response_201_data_relationships_shipping_method_tiers_links import (
    POSTshippingMethodsResponse201DataRelationshipsShippingMethodTiersLinks,
)
from .pos_tshipping_methods_response_201_data_relationships_shipping_weight_tiers import (
    POSTshippingMethodsResponse201DataRelationshipsShippingWeightTiers,
)
from .pos_tshipping_methods_response_201_data_relationships_shipping_weight_tiers_data import (
    POSTshippingMethodsResponse201DataRelationshipsShippingWeightTiersData,
)
from .pos_tshipping_methods_response_201_data_relationships_shipping_weight_tiers_data_type import (
    POSTshippingMethodsResponse201DataRelationshipsShippingWeightTiersDataType,
)
from .pos_tshipping_methods_response_201_data_relationships_shipping_weight_tiers_links import (
    POSTshippingMethodsResponse201DataRelationshipsShippingWeightTiersLinks,
)
from .pos_tshipping_methods_response_201_data_relationships_shipping_zone import (
    POSTshippingMethodsResponse201DataRelationshipsShippingZone,
)
from .pos_tshipping_methods_response_201_data_relationships_shipping_zone_data import (
    POSTshippingMethodsResponse201DataRelationshipsShippingZoneData,
)
from .pos_tshipping_methods_response_201_data_relationships_shipping_zone_data_type import (
    POSTshippingMethodsResponse201DataRelationshipsShippingZoneDataType,
)
from .pos_tshipping_methods_response_201_data_relationships_shipping_zone_links import (
    POSTshippingMethodsResponse201DataRelationshipsShippingZoneLinks,
)
from .pos_tshipping_methods_response_201_data_relationships_stock_location import (
    POSTshippingMethodsResponse201DataRelationshipsStockLocation,
)
from .pos_tshipping_methods_response_201_data_relationships_stock_location_data import (
    POSTshippingMethodsResponse201DataRelationshipsStockLocationData,
)
from .pos_tshipping_methods_response_201_data_relationships_stock_location_data_type import (
    POSTshippingMethodsResponse201DataRelationshipsStockLocationDataType,
)
from .pos_tshipping_methods_response_201_data_relationships_stock_location_links import (
    POSTshippingMethodsResponse201DataRelationshipsStockLocationLinks,
)
from .pos_tshipping_methods_response_201_data_type import POSTshippingMethodsResponse201DataType
from .pos_tshipping_weight_tiers_response_201 import POSTshippingWeightTiersResponse201
from .pos_tshipping_weight_tiers_response_201_data import POSTshippingWeightTiersResponse201Data
from .pos_tshipping_weight_tiers_response_201_data_attributes import POSTshippingWeightTiersResponse201DataAttributes
from .pos_tshipping_weight_tiers_response_201_data_attributes_metadata import (
    POSTshippingWeightTiersResponse201DataAttributesMetadata,
)
from .pos_tshipping_weight_tiers_response_201_data_links import POSTshippingWeightTiersResponse201DataLinks
from .pos_tshipping_weight_tiers_response_201_data_relationships import (
    POSTshippingWeightTiersResponse201DataRelationships,
)
from .pos_tshipping_weight_tiers_response_201_data_relationships_attachments import (
    POSTshippingWeightTiersResponse201DataRelationshipsAttachments,
)
from .pos_tshipping_weight_tiers_response_201_data_relationships_attachments_data import (
    POSTshippingWeightTiersResponse201DataRelationshipsAttachmentsData,
)
from .pos_tshipping_weight_tiers_response_201_data_relationships_attachments_data_type import (
    POSTshippingWeightTiersResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tshipping_weight_tiers_response_201_data_relationships_attachments_links import (
    POSTshippingWeightTiersResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tshipping_weight_tiers_response_201_data_relationships_shipping_method import (
    POSTshippingWeightTiersResponse201DataRelationshipsShippingMethod,
)
from .pos_tshipping_weight_tiers_response_201_data_relationships_shipping_method_data import (
    POSTshippingWeightTiersResponse201DataRelationshipsShippingMethodData,
)
from .pos_tshipping_weight_tiers_response_201_data_relationships_shipping_method_data_type import (
    POSTshippingWeightTiersResponse201DataRelationshipsShippingMethodDataType,
)
from .pos_tshipping_weight_tiers_response_201_data_relationships_shipping_method_links import (
    POSTshippingWeightTiersResponse201DataRelationshipsShippingMethodLinks,
)
from .pos_tshipping_weight_tiers_response_201_data_type import POSTshippingWeightTiersResponse201DataType
from .pos_tshipping_zones_response_201 import POSTshippingZonesResponse201
from .pos_tshipping_zones_response_201_data import POSTshippingZonesResponse201Data
from .pos_tshipping_zones_response_201_data_attributes import POSTshippingZonesResponse201DataAttributes
from .pos_tshipping_zones_response_201_data_attributes_metadata import (
    POSTshippingZonesResponse201DataAttributesMetadata,
)
from .pos_tshipping_zones_response_201_data_links import POSTshippingZonesResponse201DataLinks
from .pos_tshipping_zones_response_201_data_relationships import POSTshippingZonesResponse201DataRelationships
from .pos_tshipping_zones_response_201_data_relationships_attachments import (
    POSTshippingZonesResponse201DataRelationshipsAttachments,
)
from .pos_tshipping_zones_response_201_data_relationships_attachments_data import (
    POSTshippingZonesResponse201DataRelationshipsAttachmentsData,
)
from .pos_tshipping_zones_response_201_data_relationships_attachments_data_type import (
    POSTshippingZonesResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tshipping_zones_response_201_data_relationships_attachments_links import (
    POSTshippingZonesResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tshipping_zones_response_201_data_type import POSTshippingZonesResponse201DataType
from .pos_tsku_list_items_response_201 import POSTskuListItemsResponse201
from .pos_tsku_list_items_response_201_data import POSTskuListItemsResponse201Data
from .pos_tsku_list_items_response_201_data_attributes import POSTskuListItemsResponse201DataAttributes
from .pos_tsku_list_items_response_201_data_attributes_metadata import POSTskuListItemsResponse201DataAttributesMetadata
from .pos_tsku_list_items_response_201_data_links import POSTskuListItemsResponse201DataLinks
from .pos_tsku_list_items_response_201_data_relationships import POSTskuListItemsResponse201DataRelationships
from .pos_tsku_list_items_response_201_data_relationships_sku import POSTskuListItemsResponse201DataRelationshipsSku
from .pos_tsku_list_items_response_201_data_relationships_sku_data import (
    POSTskuListItemsResponse201DataRelationshipsSkuData,
)
from .pos_tsku_list_items_response_201_data_relationships_sku_data_type import (
    POSTskuListItemsResponse201DataRelationshipsSkuDataType,
)
from .pos_tsku_list_items_response_201_data_relationships_sku_links import (
    POSTskuListItemsResponse201DataRelationshipsSkuLinks,
)
from .pos_tsku_list_items_response_201_data_relationships_sku_list import (
    POSTskuListItemsResponse201DataRelationshipsSkuList,
)
from .pos_tsku_list_items_response_201_data_relationships_sku_list_data import (
    POSTskuListItemsResponse201DataRelationshipsSkuListData,
)
from .pos_tsku_list_items_response_201_data_relationships_sku_list_data_type import (
    POSTskuListItemsResponse201DataRelationshipsSkuListDataType,
)
from .pos_tsku_list_items_response_201_data_relationships_sku_list_links import (
    POSTskuListItemsResponse201DataRelationshipsSkuListLinks,
)
from .pos_tsku_list_items_response_201_data_type import POSTskuListItemsResponse201DataType
from .pos_tsku_list_promotion_rules_response_201 import POSTskuListPromotionRulesResponse201
from .pos_tsku_list_promotion_rules_response_201_data import POSTskuListPromotionRulesResponse201Data
from .pos_tsku_list_promotion_rules_response_201_data_attributes import (
    POSTskuListPromotionRulesResponse201DataAttributes,
)
from .pos_tsku_list_promotion_rules_response_201_data_attributes_metadata import (
    POSTskuListPromotionRulesResponse201DataAttributesMetadata,
)
from .pos_tsku_list_promotion_rules_response_201_data_links import POSTskuListPromotionRulesResponse201DataLinks
from .pos_tsku_list_promotion_rules_response_201_data_relationships import (
    POSTskuListPromotionRulesResponse201DataRelationships,
)
from .pos_tsku_list_promotion_rules_response_201_data_relationships_promotion import (
    POSTskuListPromotionRulesResponse201DataRelationshipsPromotion,
)
from .pos_tsku_list_promotion_rules_response_201_data_relationships_promotion_data import (
    POSTskuListPromotionRulesResponse201DataRelationshipsPromotionData,
)
from .pos_tsku_list_promotion_rules_response_201_data_relationships_promotion_data_type import (
    POSTskuListPromotionRulesResponse201DataRelationshipsPromotionDataType,
)
from .pos_tsku_list_promotion_rules_response_201_data_relationships_promotion_links import (
    POSTskuListPromotionRulesResponse201DataRelationshipsPromotionLinks,
)
from .pos_tsku_list_promotion_rules_response_201_data_relationships_sku_list import (
    POSTskuListPromotionRulesResponse201DataRelationshipsSkuList,
)
from .pos_tsku_list_promotion_rules_response_201_data_relationships_sku_list_data import (
    POSTskuListPromotionRulesResponse201DataRelationshipsSkuListData,
)
from .pos_tsku_list_promotion_rules_response_201_data_relationships_sku_list_data_type import (
    POSTskuListPromotionRulesResponse201DataRelationshipsSkuListDataType,
)
from .pos_tsku_list_promotion_rules_response_201_data_relationships_sku_list_links import (
    POSTskuListPromotionRulesResponse201DataRelationshipsSkuListLinks,
)
from .pos_tsku_list_promotion_rules_response_201_data_relationships_skus import (
    POSTskuListPromotionRulesResponse201DataRelationshipsSkus,
)
from .pos_tsku_list_promotion_rules_response_201_data_relationships_skus_data import (
    POSTskuListPromotionRulesResponse201DataRelationshipsSkusData,
)
from .pos_tsku_list_promotion_rules_response_201_data_relationships_skus_data_type import (
    POSTskuListPromotionRulesResponse201DataRelationshipsSkusDataType,
)
from .pos_tsku_list_promotion_rules_response_201_data_relationships_skus_links import (
    POSTskuListPromotionRulesResponse201DataRelationshipsSkusLinks,
)
from .pos_tsku_list_promotion_rules_response_201_data_type import POSTskuListPromotionRulesResponse201DataType
from .pos_tsku_lists_response_201 import POSTskuListsResponse201
from .pos_tsku_lists_response_201_data import POSTskuListsResponse201Data
from .pos_tsku_lists_response_201_data_attributes import POSTskuListsResponse201DataAttributes
from .pos_tsku_lists_response_201_data_attributes_metadata import POSTskuListsResponse201DataAttributesMetadata
from .pos_tsku_lists_response_201_data_links import POSTskuListsResponse201DataLinks
from .pos_tsku_lists_response_201_data_relationships import POSTskuListsResponse201DataRelationships
from .pos_tsku_lists_response_201_data_relationships_attachments import (
    POSTskuListsResponse201DataRelationshipsAttachments,
)
from .pos_tsku_lists_response_201_data_relationships_attachments_data import (
    POSTskuListsResponse201DataRelationshipsAttachmentsData,
)
from .pos_tsku_lists_response_201_data_relationships_attachments_data_type import (
    POSTskuListsResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tsku_lists_response_201_data_relationships_attachments_links import (
    POSTskuListsResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tsku_lists_response_201_data_relationships_bundles import POSTskuListsResponse201DataRelationshipsBundles
from .pos_tsku_lists_response_201_data_relationships_bundles_data import (
    POSTskuListsResponse201DataRelationshipsBundlesData,
)
from .pos_tsku_lists_response_201_data_relationships_bundles_data_type import (
    POSTskuListsResponse201DataRelationshipsBundlesDataType,
)
from .pos_tsku_lists_response_201_data_relationships_bundles_links import (
    POSTskuListsResponse201DataRelationshipsBundlesLinks,
)
from .pos_tsku_lists_response_201_data_relationships_customer import POSTskuListsResponse201DataRelationshipsCustomer
from .pos_tsku_lists_response_201_data_relationships_customer_data import (
    POSTskuListsResponse201DataRelationshipsCustomerData,
)
from .pos_tsku_lists_response_201_data_relationships_customer_data_type import (
    POSTskuListsResponse201DataRelationshipsCustomerDataType,
)
from .pos_tsku_lists_response_201_data_relationships_customer_links import (
    POSTskuListsResponse201DataRelationshipsCustomerLinks,
)
from .pos_tsku_lists_response_201_data_relationships_sku_list_items import (
    POSTskuListsResponse201DataRelationshipsSkuListItems,
)
from .pos_tsku_lists_response_201_data_relationships_sku_list_items_data import (
    POSTskuListsResponse201DataRelationshipsSkuListItemsData,
)
from .pos_tsku_lists_response_201_data_relationships_sku_list_items_data_type import (
    POSTskuListsResponse201DataRelationshipsSkuListItemsDataType,
)
from .pos_tsku_lists_response_201_data_relationships_sku_list_items_links import (
    POSTskuListsResponse201DataRelationshipsSkuListItemsLinks,
)
from .pos_tsku_lists_response_201_data_relationships_skus import POSTskuListsResponse201DataRelationshipsSkus
from .pos_tsku_lists_response_201_data_relationships_skus_data import POSTskuListsResponse201DataRelationshipsSkusData
from .pos_tsku_lists_response_201_data_relationships_skus_data_type import (
    POSTskuListsResponse201DataRelationshipsSkusDataType,
)
from .pos_tsku_lists_response_201_data_relationships_skus_links import POSTskuListsResponse201DataRelationshipsSkusLinks
from .pos_tsku_lists_response_201_data_type import POSTskuListsResponse201DataType
from .pos_tsku_options_response_201 import POSTskuOptionsResponse201
from .pos_tsku_options_response_201_data import POSTskuOptionsResponse201Data
from .pos_tsku_options_response_201_data_attributes import POSTskuOptionsResponse201DataAttributes
from .pos_tsku_options_response_201_data_attributes_metadata import POSTskuOptionsResponse201DataAttributesMetadata
from .pos_tsku_options_response_201_data_links import POSTskuOptionsResponse201DataLinks
from .pos_tsku_options_response_201_data_relationships import POSTskuOptionsResponse201DataRelationships
from .pos_tsku_options_response_201_data_relationships_attachments import (
    POSTskuOptionsResponse201DataRelationshipsAttachments,
)
from .pos_tsku_options_response_201_data_relationships_attachments_data import (
    POSTskuOptionsResponse201DataRelationshipsAttachmentsData,
)
from .pos_tsku_options_response_201_data_relationships_attachments_data_type import (
    POSTskuOptionsResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tsku_options_response_201_data_relationships_attachments_links import (
    POSTskuOptionsResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tsku_options_response_201_data_relationships_market import POSTskuOptionsResponse201DataRelationshipsMarket
from .pos_tsku_options_response_201_data_relationships_market_data import (
    POSTskuOptionsResponse201DataRelationshipsMarketData,
)
from .pos_tsku_options_response_201_data_relationships_market_data_type import (
    POSTskuOptionsResponse201DataRelationshipsMarketDataType,
)
from .pos_tsku_options_response_201_data_relationships_market_links import (
    POSTskuOptionsResponse201DataRelationshipsMarketLinks,
)
from .pos_tsku_options_response_201_data_type import POSTskuOptionsResponse201DataType
from .pos_tskus_response_201 import POSTskusResponse201
from .pos_tskus_response_201_data import POSTskusResponse201Data
from .pos_tskus_response_201_data_attributes import POSTskusResponse201DataAttributes
from .pos_tskus_response_201_data_attributes_metadata import POSTskusResponse201DataAttributesMetadata
from .pos_tskus_response_201_data_links import POSTskusResponse201DataLinks
from .pos_tskus_response_201_data_relationships import POSTskusResponse201DataRelationships
from .pos_tskus_response_201_data_relationships_attachments import POSTskusResponse201DataRelationshipsAttachments
from .pos_tskus_response_201_data_relationships_attachments_data import (
    POSTskusResponse201DataRelationshipsAttachmentsData,
)
from .pos_tskus_response_201_data_relationships_attachments_data_type import (
    POSTskusResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tskus_response_201_data_relationships_attachments_links import (
    POSTskusResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tskus_response_201_data_relationships_delivery_lead_times import (
    POSTskusResponse201DataRelationshipsDeliveryLeadTimes,
)
from .pos_tskus_response_201_data_relationships_delivery_lead_times_data import (
    POSTskusResponse201DataRelationshipsDeliveryLeadTimesData,
)
from .pos_tskus_response_201_data_relationships_delivery_lead_times_data_type import (
    POSTskusResponse201DataRelationshipsDeliveryLeadTimesDataType,
)
from .pos_tskus_response_201_data_relationships_delivery_lead_times_links import (
    POSTskusResponse201DataRelationshipsDeliveryLeadTimesLinks,
)
from .pos_tskus_response_201_data_relationships_prices import POSTskusResponse201DataRelationshipsPrices
from .pos_tskus_response_201_data_relationships_prices_data import POSTskusResponse201DataRelationshipsPricesData
from .pos_tskus_response_201_data_relationships_prices_data_type import (
    POSTskusResponse201DataRelationshipsPricesDataType,
)
from .pos_tskus_response_201_data_relationships_prices_links import POSTskusResponse201DataRelationshipsPricesLinks
from .pos_tskus_response_201_data_relationships_shipping_category import (
    POSTskusResponse201DataRelationshipsShippingCategory,
)
from .pos_tskus_response_201_data_relationships_shipping_category_data import (
    POSTskusResponse201DataRelationshipsShippingCategoryData,
)
from .pos_tskus_response_201_data_relationships_shipping_category_data_type import (
    POSTskusResponse201DataRelationshipsShippingCategoryDataType,
)
from .pos_tskus_response_201_data_relationships_shipping_category_links import (
    POSTskusResponse201DataRelationshipsShippingCategoryLinks,
)
from .pos_tskus_response_201_data_relationships_sku_options import POSTskusResponse201DataRelationshipsSkuOptions
from .pos_tskus_response_201_data_relationships_sku_options_data import (
    POSTskusResponse201DataRelationshipsSkuOptionsData,
)
from .pos_tskus_response_201_data_relationships_sku_options_data_type import (
    POSTskusResponse201DataRelationshipsSkuOptionsDataType,
)
from .pos_tskus_response_201_data_relationships_sku_options_links import (
    POSTskusResponse201DataRelationshipsSkuOptionsLinks,
)
from .pos_tskus_response_201_data_relationships_stock_items import POSTskusResponse201DataRelationshipsStockItems
from .pos_tskus_response_201_data_relationships_stock_items_data import (
    POSTskusResponse201DataRelationshipsStockItemsData,
)
from .pos_tskus_response_201_data_relationships_stock_items_data_type import (
    POSTskusResponse201DataRelationshipsStockItemsDataType,
)
from .pos_tskus_response_201_data_relationships_stock_items_links import (
    POSTskusResponse201DataRelationshipsStockItemsLinks,
)
from .pos_tskus_response_201_data_type import POSTskusResponse201DataType
from .pos_tstock_items_response_201 import POSTstockItemsResponse201
from .pos_tstock_items_response_201_data import POSTstockItemsResponse201Data
from .pos_tstock_items_response_201_data_attributes import POSTstockItemsResponse201DataAttributes
from .pos_tstock_items_response_201_data_attributes_metadata import POSTstockItemsResponse201DataAttributesMetadata
from .pos_tstock_items_response_201_data_links import POSTstockItemsResponse201DataLinks
from .pos_tstock_items_response_201_data_relationships import POSTstockItemsResponse201DataRelationships
from .pos_tstock_items_response_201_data_relationships_attachments import (
    POSTstockItemsResponse201DataRelationshipsAttachments,
)
from .pos_tstock_items_response_201_data_relationships_attachments_data import (
    POSTstockItemsResponse201DataRelationshipsAttachmentsData,
)
from .pos_tstock_items_response_201_data_relationships_attachments_data_type import (
    POSTstockItemsResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tstock_items_response_201_data_relationships_attachments_links import (
    POSTstockItemsResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tstock_items_response_201_data_relationships_sku import POSTstockItemsResponse201DataRelationshipsSku
from .pos_tstock_items_response_201_data_relationships_sku_data import POSTstockItemsResponse201DataRelationshipsSkuData
from .pos_tstock_items_response_201_data_relationships_sku_data_type import (
    POSTstockItemsResponse201DataRelationshipsSkuDataType,
)
from .pos_tstock_items_response_201_data_relationships_sku_links import (
    POSTstockItemsResponse201DataRelationshipsSkuLinks,
)
from .pos_tstock_items_response_201_data_relationships_stock_location import (
    POSTstockItemsResponse201DataRelationshipsStockLocation,
)
from .pos_tstock_items_response_201_data_relationships_stock_location_data import (
    POSTstockItemsResponse201DataRelationshipsStockLocationData,
)
from .pos_tstock_items_response_201_data_relationships_stock_location_data_type import (
    POSTstockItemsResponse201DataRelationshipsStockLocationDataType,
)
from .pos_tstock_items_response_201_data_relationships_stock_location_links import (
    POSTstockItemsResponse201DataRelationshipsStockLocationLinks,
)
from .pos_tstock_items_response_201_data_type import POSTstockItemsResponse201DataType
from .pos_tstock_locations_response_201 import POSTstockLocationsResponse201
from .pos_tstock_locations_response_201_data import POSTstockLocationsResponse201Data
from .pos_tstock_locations_response_201_data_attributes import POSTstockLocationsResponse201DataAttributes
from .pos_tstock_locations_response_201_data_attributes_metadata import (
    POSTstockLocationsResponse201DataAttributesMetadata,
)
from .pos_tstock_locations_response_201_data_links import POSTstockLocationsResponse201DataLinks
from .pos_tstock_locations_response_201_data_relationships import POSTstockLocationsResponse201DataRelationships
from .pos_tstock_locations_response_201_data_relationships_address import (
    POSTstockLocationsResponse201DataRelationshipsAddress,
)
from .pos_tstock_locations_response_201_data_relationships_address_data import (
    POSTstockLocationsResponse201DataRelationshipsAddressData,
)
from .pos_tstock_locations_response_201_data_relationships_address_data_type import (
    POSTstockLocationsResponse201DataRelationshipsAddressDataType,
)
from .pos_tstock_locations_response_201_data_relationships_address_links import (
    POSTstockLocationsResponse201DataRelationshipsAddressLinks,
)
from .pos_tstock_locations_response_201_data_relationships_attachments import (
    POSTstockLocationsResponse201DataRelationshipsAttachments,
)
from .pos_tstock_locations_response_201_data_relationships_attachments_data import (
    POSTstockLocationsResponse201DataRelationshipsAttachmentsData,
)
from .pos_tstock_locations_response_201_data_relationships_attachments_data_type import (
    POSTstockLocationsResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_tstock_locations_response_201_data_relationships_attachments_links import (
    POSTstockLocationsResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_tstock_locations_response_201_data_relationships_inventory_return_locations import (
    POSTstockLocationsResponse201DataRelationshipsInventoryReturnLocations,
)
from .pos_tstock_locations_response_201_data_relationships_inventory_return_locations_data import (
    POSTstockLocationsResponse201DataRelationshipsInventoryReturnLocationsData,
)
from .pos_tstock_locations_response_201_data_relationships_inventory_return_locations_data_type import (
    POSTstockLocationsResponse201DataRelationshipsInventoryReturnLocationsDataType,
)
from .pos_tstock_locations_response_201_data_relationships_inventory_return_locations_links import (
    POSTstockLocationsResponse201DataRelationshipsInventoryReturnLocationsLinks,
)
from .pos_tstock_locations_response_201_data_relationships_inventory_stock_locations import (
    POSTstockLocationsResponse201DataRelationshipsInventoryStockLocations,
)
from .pos_tstock_locations_response_201_data_relationships_inventory_stock_locations_data import (
    POSTstockLocationsResponse201DataRelationshipsInventoryStockLocationsData,
)
from .pos_tstock_locations_response_201_data_relationships_inventory_stock_locations_data_type import (
    POSTstockLocationsResponse201DataRelationshipsInventoryStockLocationsDataType,
)
from .pos_tstock_locations_response_201_data_relationships_inventory_stock_locations_links import (
    POSTstockLocationsResponse201DataRelationshipsInventoryStockLocationsLinks,
)
from .pos_tstock_locations_response_201_data_relationships_stock_items import (
    POSTstockLocationsResponse201DataRelationshipsStockItems,
)
from .pos_tstock_locations_response_201_data_relationships_stock_items_data import (
    POSTstockLocationsResponse201DataRelationshipsStockItemsData,
)
from .pos_tstock_locations_response_201_data_relationships_stock_items_data_type import (
    POSTstockLocationsResponse201DataRelationshipsStockItemsDataType,
)
from .pos_tstock_locations_response_201_data_relationships_stock_items_links import (
    POSTstockLocationsResponse201DataRelationshipsStockItemsLinks,
)
from .pos_tstock_locations_response_201_data_relationships_stock_transfers import (
    POSTstockLocationsResponse201DataRelationshipsStockTransfers,
)
from .pos_tstock_locations_response_201_data_relationships_stock_transfers_data import (
    POSTstockLocationsResponse201DataRelationshipsStockTransfersData,
)
from .pos_tstock_locations_response_201_data_relationships_stock_transfers_data_type import (
    POSTstockLocationsResponse201DataRelationshipsStockTransfersDataType,
)
from .pos_tstock_locations_response_201_data_relationships_stock_transfers_links import (
    POSTstockLocationsResponse201DataRelationshipsStockTransfersLinks,
)
from .pos_tstock_locations_response_201_data_type import POSTstockLocationsResponse201DataType
from .pos_tstock_transfers_response_201 import POSTstockTransfersResponse201
from .pos_tstock_transfers_response_201_data import POSTstockTransfersResponse201Data
from .pos_tstock_transfers_response_201_data_attributes import POSTstockTransfersResponse201DataAttributes
from .pos_tstock_transfers_response_201_data_attributes_metadata import (
    POSTstockTransfersResponse201DataAttributesMetadata,
)
from .pos_tstock_transfers_response_201_data_links import POSTstockTransfersResponse201DataLinks
from .pos_tstock_transfers_response_201_data_relationships import POSTstockTransfersResponse201DataRelationships
from .pos_tstock_transfers_response_201_data_relationships_destination_stock_location import (
    POSTstockTransfersResponse201DataRelationshipsDestinationStockLocation,
)
from .pos_tstock_transfers_response_201_data_relationships_destination_stock_location_data import (
    POSTstockTransfersResponse201DataRelationshipsDestinationStockLocationData,
)
from .pos_tstock_transfers_response_201_data_relationships_destination_stock_location_data_type import (
    POSTstockTransfersResponse201DataRelationshipsDestinationStockLocationDataType,
)
from .pos_tstock_transfers_response_201_data_relationships_destination_stock_location_links import (
    POSTstockTransfersResponse201DataRelationshipsDestinationStockLocationLinks,
)
from .pos_tstock_transfers_response_201_data_relationships_events import (
    POSTstockTransfersResponse201DataRelationshipsEvents,
)
from .pos_tstock_transfers_response_201_data_relationships_events_data import (
    POSTstockTransfersResponse201DataRelationshipsEventsData,
)
from .pos_tstock_transfers_response_201_data_relationships_events_data_type import (
    POSTstockTransfersResponse201DataRelationshipsEventsDataType,
)
from .pos_tstock_transfers_response_201_data_relationships_events_links import (
    POSTstockTransfersResponse201DataRelationshipsEventsLinks,
)
from .pos_tstock_transfers_response_201_data_relationships_line_item import (
    POSTstockTransfersResponse201DataRelationshipsLineItem,
)
from .pos_tstock_transfers_response_201_data_relationships_line_item_data import (
    POSTstockTransfersResponse201DataRelationshipsLineItemData,
)
from .pos_tstock_transfers_response_201_data_relationships_line_item_data_type import (
    POSTstockTransfersResponse201DataRelationshipsLineItemDataType,
)
from .pos_tstock_transfers_response_201_data_relationships_line_item_links import (
    POSTstockTransfersResponse201DataRelationshipsLineItemLinks,
)
from .pos_tstock_transfers_response_201_data_relationships_origin_stock_location import (
    POSTstockTransfersResponse201DataRelationshipsOriginStockLocation,
)
from .pos_tstock_transfers_response_201_data_relationships_origin_stock_location_data import (
    POSTstockTransfersResponse201DataRelationshipsOriginStockLocationData,
)
from .pos_tstock_transfers_response_201_data_relationships_origin_stock_location_data_type import (
    POSTstockTransfersResponse201DataRelationshipsOriginStockLocationDataType,
)
from .pos_tstock_transfers_response_201_data_relationships_origin_stock_location_links import (
    POSTstockTransfersResponse201DataRelationshipsOriginStockLocationLinks,
)
from .pos_tstock_transfers_response_201_data_relationships_shipment import (
    POSTstockTransfersResponse201DataRelationshipsShipment,
)
from .pos_tstock_transfers_response_201_data_relationships_shipment_data import (
    POSTstockTransfersResponse201DataRelationshipsShipmentData,
)
from .pos_tstock_transfers_response_201_data_relationships_shipment_data_type import (
    POSTstockTransfersResponse201DataRelationshipsShipmentDataType,
)
from .pos_tstock_transfers_response_201_data_relationships_shipment_links import (
    POSTstockTransfersResponse201DataRelationshipsShipmentLinks,
)
from .pos_tstock_transfers_response_201_data_relationships_sku import POSTstockTransfersResponse201DataRelationshipsSku
from .pos_tstock_transfers_response_201_data_relationships_sku_data import (
    POSTstockTransfersResponse201DataRelationshipsSkuData,
)
from .pos_tstock_transfers_response_201_data_relationships_sku_data_type import (
    POSTstockTransfersResponse201DataRelationshipsSkuDataType,
)
from .pos_tstock_transfers_response_201_data_relationships_sku_links import (
    POSTstockTransfersResponse201DataRelationshipsSkuLinks,
)
from .pos_tstock_transfers_response_201_data_type import POSTstockTransfersResponse201DataType
from .pos_tstripe_gateways_response_201 import POSTstripeGatewaysResponse201
from .pos_tstripe_gateways_response_201_data import POSTstripeGatewaysResponse201Data
from .pos_tstripe_gateways_response_201_data_attributes import POSTstripeGatewaysResponse201DataAttributes
from .pos_tstripe_gateways_response_201_data_attributes_metadata import (
    POSTstripeGatewaysResponse201DataAttributesMetadata,
)
from .pos_tstripe_gateways_response_201_data_links import POSTstripeGatewaysResponse201DataLinks
from .pos_tstripe_gateways_response_201_data_relationships import POSTstripeGatewaysResponse201DataRelationships
from .pos_tstripe_gateways_response_201_data_relationships_payment_methods import (
    POSTstripeGatewaysResponse201DataRelationshipsPaymentMethods,
)
from .pos_tstripe_gateways_response_201_data_relationships_payment_methods_data import (
    POSTstripeGatewaysResponse201DataRelationshipsPaymentMethodsData,
)
from .pos_tstripe_gateways_response_201_data_relationships_payment_methods_data_type import (
    POSTstripeGatewaysResponse201DataRelationshipsPaymentMethodsDataType,
)
from .pos_tstripe_gateways_response_201_data_relationships_payment_methods_links import (
    POSTstripeGatewaysResponse201DataRelationshipsPaymentMethodsLinks,
)
from .pos_tstripe_gateways_response_201_data_relationships_stripe_payments import (
    POSTstripeGatewaysResponse201DataRelationshipsStripePayments,
)
from .pos_tstripe_gateways_response_201_data_relationships_stripe_payments_data import (
    POSTstripeGatewaysResponse201DataRelationshipsStripePaymentsData,
)
from .pos_tstripe_gateways_response_201_data_relationships_stripe_payments_data_type import (
    POSTstripeGatewaysResponse201DataRelationshipsStripePaymentsDataType,
)
from .pos_tstripe_gateways_response_201_data_relationships_stripe_payments_links import (
    POSTstripeGatewaysResponse201DataRelationshipsStripePaymentsLinks,
)
from .pos_tstripe_gateways_response_201_data_type import POSTstripeGatewaysResponse201DataType
from .pos_tstripe_payments_response_201 import POSTstripePaymentsResponse201
from .pos_tstripe_payments_response_201_data import POSTstripePaymentsResponse201Data
from .pos_tstripe_payments_response_201_data_attributes import POSTstripePaymentsResponse201DataAttributes
from .pos_tstripe_payments_response_201_data_attributes_metadata import (
    POSTstripePaymentsResponse201DataAttributesMetadata,
)
from .pos_tstripe_payments_response_201_data_attributes_options import (
    POSTstripePaymentsResponse201DataAttributesOptions,
)
from .pos_tstripe_payments_response_201_data_links import POSTstripePaymentsResponse201DataLinks
from .pos_tstripe_payments_response_201_data_relationships import POSTstripePaymentsResponse201DataRelationships
from .pos_tstripe_payments_response_201_data_relationships_order import (
    POSTstripePaymentsResponse201DataRelationshipsOrder,
)
from .pos_tstripe_payments_response_201_data_relationships_order_data import (
    POSTstripePaymentsResponse201DataRelationshipsOrderData,
)
from .pos_tstripe_payments_response_201_data_relationships_order_data_type import (
    POSTstripePaymentsResponse201DataRelationshipsOrderDataType,
)
from .pos_tstripe_payments_response_201_data_relationships_order_links import (
    POSTstripePaymentsResponse201DataRelationshipsOrderLinks,
)
from .pos_tstripe_payments_response_201_data_relationships_payment_gateway import (
    POSTstripePaymentsResponse201DataRelationshipsPaymentGateway,
)
from .pos_tstripe_payments_response_201_data_relationships_payment_gateway_data import (
    POSTstripePaymentsResponse201DataRelationshipsPaymentGatewayData,
)
from .pos_tstripe_payments_response_201_data_relationships_payment_gateway_data_type import (
    POSTstripePaymentsResponse201DataRelationshipsPaymentGatewayDataType,
)
from .pos_tstripe_payments_response_201_data_relationships_payment_gateway_links import (
    POSTstripePaymentsResponse201DataRelationshipsPaymentGatewayLinks,
)
from .pos_tstripe_payments_response_201_data_type import POSTstripePaymentsResponse201DataType
from .pos_ttax_categories_response_201 import POSTtaxCategoriesResponse201
from .pos_ttax_categories_response_201_data import POSTtaxCategoriesResponse201Data
from .pos_ttax_categories_response_201_data_attributes import POSTtaxCategoriesResponse201DataAttributes
from .pos_ttax_categories_response_201_data_attributes_metadata import (
    POSTtaxCategoriesResponse201DataAttributesMetadata,
)
from .pos_ttax_categories_response_201_data_links import POSTtaxCategoriesResponse201DataLinks
from .pos_ttax_categories_response_201_data_relationships import POSTtaxCategoriesResponse201DataRelationships
from .pos_ttax_categories_response_201_data_relationships_attachments import (
    POSTtaxCategoriesResponse201DataRelationshipsAttachments,
)
from .pos_ttax_categories_response_201_data_relationships_attachments_data import (
    POSTtaxCategoriesResponse201DataRelationshipsAttachmentsData,
)
from .pos_ttax_categories_response_201_data_relationships_attachments_data_type import (
    POSTtaxCategoriesResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_ttax_categories_response_201_data_relationships_attachments_links import (
    POSTtaxCategoriesResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_ttax_categories_response_201_data_relationships_sku import POSTtaxCategoriesResponse201DataRelationshipsSku
from .pos_ttax_categories_response_201_data_relationships_sku_data import (
    POSTtaxCategoriesResponse201DataRelationshipsSkuData,
)
from .pos_ttax_categories_response_201_data_relationships_sku_data_type import (
    POSTtaxCategoriesResponse201DataRelationshipsSkuDataType,
)
from .pos_ttax_categories_response_201_data_relationships_sku_links import (
    POSTtaxCategoriesResponse201DataRelationshipsSkuLinks,
)
from .pos_ttax_categories_response_201_data_relationships_tax_calculator import (
    POSTtaxCategoriesResponse201DataRelationshipsTaxCalculator,
)
from .pos_ttax_categories_response_201_data_relationships_tax_calculator_data import (
    POSTtaxCategoriesResponse201DataRelationshipsTaxCalculatorData,
)
from .pos_ttax_categories_response_201_data_relationships_tax_calculator_data_type import (
    POSTtaxCategoriesResponse201DataRelationshipsTaxCalculatorDataType,
)
from .pos_ttax_categories_response_201_data_relationships_tax_calculator_links import (
    POSTtaxCategoriesResponse201DataRelationshipsTaxCalculatorLinks,
)
from .pos_ttax_categories_response_201_data_type import POSTtaxCategoriesResponse201DataType
from .pos_ttax_rules_response_201 import POSTtaxRulesResponse201
from .pos_ttax_rules_response_201_data import POSTtaxRulesResponse201Data
from .pos_ttax_rules_response_201_data_attributes import POSTtaxRulesResponse201DataAttributes
from .pos_ttax_rules_response_201_data_attributes_metadata import POSTtaxRulesResponse201DataAttributesMetadata
from .pos_ttax_rules_response_201_data_links import POSTtaxRulesResponse201DataLinks
from .pos_ttax_rules_response_201_data_relationships import POSTtaxRulesResponse201DataRelationships
from .pos_ttax_rules_response_201_data_relationships_manual_tax_calculator import (
    POSTtaxRulesResponse201DataRelationshipsManualTaxCalculator,
)
from .pos_ttax_rules_response_201_data_relationships_manual_tax_calculator_data import (
    POSTtaxRulesResponse201DataRelationshipsManualTaxCalculatorData,
)
from .pos_ttax_rules_response_201_data_relationships_manual_tax_calculator_data_type import (
    POSTtaxRulesResponse201DataRelationshipsManualTaxCalculatorDataType,
)
from .pos_ttax_rules_response_201_data_relationships_manual_tax_calculator_links import (
    POSTtaxRulesResponse201DataRelationshipsManualTaxCalculatorLinks,
)
from .pos_ttax_rules_response_201_data_type import POSTtaxRulesResponse201DataType
from .pos_ttaxjar_accounts_response_201 import POSTtaxjarAccountsResponse201
from .pos_ttaxjar_accounts_response_201_data import POSTtaxjarAccountsResponse201Data
from .pos_ttaxjar_accounts_response_201_data_attributes import POSTtaxjarAccountsResponse201DataAttributes
from .pos_ttaxjar_accounts_response_201_data_attributes_metadata import (
    POSTtaxjarAccountsResponse201DataAttributesMetadata,
)
from .pos_ttaxjar_accounts_response_201_data_links import POSTtaxjarAccountsResponse201DataLinks
from .pos_ttaxjar_accounts_response_201_data_relationships import POSTtaxjarAccountsResponse201DataRelationships
from .pos_ttaxjar_accounts_response_201_data_relationships_attachments import (
    POSTtaxjarAccountsResponse201DataRelationshipsAttachments,
)
from .pos_ttaxjar_accounts_response_201_data_relationships_attachments_data import (
    POSTtaxjarAccountsResponse201DataRelationshipsAttachmentsData,
)
from .pos_ttaxjar_accounts_response_201_data_relationships_attachments_data_type import (
    POSTtaxjarAccountsResponse201DataRelationshipsAttachmentsDataType,
)
from .pos_ttaxjar_accounts_response_201_data_relationships_attachments_links import (
    POSTtaxjarAccountsResponse201DataRelationshipsAttachmentsLinks,
)
from .pos_ttaxjar_accounts_response_201_data_relationships_markets import (
    POSTtaxjarAccountsResponse201DataRelationshipsMarkets,
)
from .pos_ttaxjar_accounts_response_201_data_relationships_markets_data import (
    POSTtaxjarAccountsResponse201DataRelationshipsMarketsData,
)
from .pos_ttaxjar_accounts_response_201_data_relationships_markets_data_type import (
    POSTtaxjarAccountsResponse201DataRelationshipsMarketsDataType,
)
from .pos_ttaxjar_accounts_response_201_data_relationships_markets_links import (
    POSTtaxjarAccountsResponse201DataRelationshipsMarketsLinks,
)
from .pos_ttaxjar_accounts_response_201_data_relationships_tax_categories import (
    POSTtaxjarAccountsResponse201DataRelationshipsTaxCategories,
)
from .pos_ttaxjar_accounts_response_201_data_relationships_tax_categories_data import (
    POSTtaxjarAccountsResponse201DataRelationshipsTaxCategoriesData,
)
from .pos_ttaxjar_accounts_response_201_data_relationships_tax_categories_data_type import (
    POSTtaxjarAccountsResponse201DataRelationshipsTaxCategoriesDataType,
)
from .pos_ttaxjar_accounts_response_201_data_relationships_tax_categories_links import (
    POSTtaxjarAccountsResponse201DataRelationshipsTaxCategoriesLinks,
)
from .pos_ttaxjar_accounts_response_201_data_type import POSTtaxjarAccountsResponse201DataType
from .pos_twebhooks_response_201 import POSTwebhooksResponse201
from .pos_twebhooks_response_201_data import POSTwebhooksResponse201Data
from .pos_twebhooks_response_201_data_attributes import POSTwebhooksResponse201DataAttributes
from .pos_twebhooks_response_201_data_attributes_metadata import POSTwebhooksResponse201DataAttributesMetadata
from .pos_twebhooks_response_201_data_links import POSTwebhooksResponse201DataLinks
from .pos_twebhooks_response_201_data_relationships import POSTwebhooksResponse201DataRelationships
from .pos_twebhooks_response_201_data_relationships_last_event_callbacks import (
    POSTwebhooksResponse201DataRelationshipsLastEventCallbacks,
)
from .pos_twebhooks_response_201_data_relationships_last_event_callbacks_data import (
    POSTwebhooksResponse201DataRelationshipsLastEventCallbacksData,
)
from .pos_twebhooks_response_201_data_relationships_last_event_callbacks_data_type import (
    POSTwebhooksResponse201DataRelationshipsLastEventCallbacksDataType,
)
from .pos_twebhooks_response_201_data_relationships_last_event_callbacks_links import (
    POSTwebhooksResponse201DataRelationshipsLastEventCallbacksLinks,
)
from .pos_twebhooks_response_201_data_type import POSTwebhooksResponse201DataType
from .pos_twire_transfers_response_201 import POSTwireTransfersResponse201
from .pos_twire_transfers_response_201_data import POSTwireTransfersResponse201Data
from .pos_twire_transfers_response_201_data_attributes import POSTwireTransfersResponse201DataAttributes
from .pos_twire_transfers_response_201_data_attributes_metadata import (
    POSTwireTransfersResponse201DataAttributesMetadata,
)
from .pos_twire_transfers_response_201_data_links import POSTwireTransfersResponse201DataLinks
from .pos_twire_transfers_response_201_data_relationships import POSTwireTransfersResponse201DataRelationships
from .pos_twire_transfers_response_201_data_relationships_order import (
    POSTwireTransfersResponse201DataRelationshipsOrder,
)
from .pos_twire_transfers_response_201_data_relationships_order_data import (
    POSTwireTransfersResponse201DataRelationshipsOrderData,
)
from .pos_twire_transfers_response_201_data_relationships_order_data_type import (
    POSTwireTransfersResponse201DataRelationshipsOrderDataType,
)
from .pos_twire_transfers_response_201_data_relationships_order_links import (
    POSTwireTransfersResponse201DataRelationshipsOrderLinks,
)
from .pos_twire_transfers_response_201_data_type import POSTwireTransfersResponse201DataType
from .price import Price
from .price_create import PriceCreate
from .price_create_data import PriceCreateData
from .price_create_data_attributes import PriceCreateDataAttributes
from .price_create_data_attributes_metadata import PriceCreateDataAttributesMetadata
from .price_create_data_relationships import PriceCreateDataRelationships
from .price_create_data_relationships_price_list import PriceCreateDataRelationshipsPriceList
from .price_create_data_relationships_price_list_data import PriceCreateDataRelationshipsPriceListData
from .price_create_data_relationships_price_list_data_type import PriceCreateDataRelationshipsPriceListDataType
from .price_create_data_relationships_price_tiers import PriceCreateDataRelationshipsPriceTiers
from .price_create_data_relationships_price_tiers_data import PriceCreateDataRelationshipsPriceTiersData
from .price_create_data_relationships_price_tiers_data_type import PriceCreateDataRelationshipsPriceTiersDataType
from .price_create_data_relationships_sku import PriceCreateDataRelationshipsSku
from .price_create_data_relationships_sku_data import PriceCreateDataRelationshipsSkuData
from .price_create_data_relationships_sku_data_type import PriceCreateDataRelationshipsSkuDataType
from .price_create_data_type import PriceCreateDataType
from .price_data import PriceData
from .price_data_attributes import PriceDataAttributes
from .price_data_attributes_metadata import PriceDataAttributesMetadata
from .price_data_relationships import PriceDataRelationships
from .price_data_relationships_attachments import PriceDataRelationshipsAttachments
from .price_data_relationships_attachments_data import PriceDataRelationshipsAttachmentsData
from .price_data_relationships_attachments_data_type import PriceDataRelationshipsAttachmentsDataType
from .price_data_relationships_price_list import PriceDataRelationshipsPriceList
from .price_data_relationships_price_list_data import PriceDataRelationshipsPriceListData
from .price_data_relationships_price_list_data_type import PriceDataRelationshipsPriceListDataType
from .price_data_relationships_price_tiers import PriceDataRelationshipsPriceTiers
from .price_data_relationships_price_tiers_data import PriceDataRelationshipsPriceTiersData
from .price_data_relationships_price_tiers_data_type import PriceDataRelationshipsPriceTiersDataType
from .price_data_relationships_price_volume_tiers import PriceDataRelationshipsPriceVolumeTiers
from .price_data_relationships_price_volume_tiers_data import PriceDataRelationshipsPriceVolumeTiersData
from .price_data_relationships_price_volume_tiers_data_type import PriceDataRelationshipsPriceVolumeTiersDataType
from .price_data_relationships_sku import PriceDataRelationshipsSku
from .price_data_relationships_sku_data import PriceDataRelationshipsSkuData
from .price_data_relationships_sku_data_type import PriceDataRelationshipsSkuDataType
from .price_data_type import PriceDataType
from .price_list import PriceList
from .price_list_create import PriceListCreate
from .price_list_create_data import PriceListCreateData
from .price_list_create_data_attributes import PriceListCreateDataAttributes
from .price_list_create_data_attributes_metadata import PriceListCreateDataAttributesMetadata
from .price_list_create_data_relationships import PriceListCreateDataRelationships
from .price_list_create_data_type import PriceListCreateDataType
from .price_list_data import PriceListData
from .price_list_data_attributes import PriceListDataAttributes
from .price_list_data_attributes_metadata import PriceListDataAttributesMetadata
from .price_list_data_relationships import PriceListDataRelationships
from .price_list_data_relationships_attachments import PriceListDataRelationshipsAttachments
from .price_list_data_relationships_attachments_data import PriceListDataRelationshipsAttachmentsData
from .price_list_data_relationships_attachments_data_type import PriceListDataRelationshipsAttachmentsDataType
from .price_list_data_relationships_prices import PriceListDataRelationshipsPrices
from .price_list_data_relationships_prices_data import PriceListDataRelationshipsPricesData
from .price_list_data_relationships_prices_data_type import PriceListDataRelationshipsPricesDataType
from .price_list_data_type import PriceListDataType
from .price_list_update import PriceListUpdate
from .price_list_update_data import PriceListUpdateData
from .price_list_update_data_attributes import PriceListUpdateDataAttributes
from .price_list_update_data_attributes_metadata import PriceListUpdateDataAttributesMetadata
from .price_list_update_data_relationships import PriceListUpdateDataRelationships
from .price_list_update_data_type import PriceListUpdateDataType
from .price_tier import PriceTier
from .price_tier_data import PriceTierData
from .price_tier_data_attributes import PriceTierDataAttributes
from .price_tier_data_attributes_metadata import PriceTierDataAttributesMetadata
from .price_tier_data_relationships import PriceTierDataRelationships
from .price_tier_data_relationships_attachments import PriceTierDataRelationshipsAttachments
from .price_tier_data_relationships_attachments_data import PriceTierDataRelationshipsAttachmentsData
from .price_tier_data_relationships_attachments_data_type import PriceTierDataRelationshipsAttachmentsDataType
from .price_tier_data_relationships_price import PriceTierDataRelationshipsPrice
from .price_tier_data_relationships_price_data import PriceTierDataRelationshipsPriceData
from .price_tier_data_relationships_price_data_type import PriceTierDataRelationshipsPriceDataType
from .price_tier_data_type import PriceTierDataType
from .price_update import PriceUpdate
from .price_update_data import PriceUpdateData
from .price_update_data_attributes import PriceUpdateDataAttributes
from .price_update_data_attributes_metadata import PriceUpdateDataAttributesMetadata
from .price_update_data_relationships import PriceUpdateDataRelationships
from .price_update_data_relationships_price_list import PriceUpdateDataRelationshipsPriceList
from .price_update_data_relationships_price_list_data import PriceUpdateDataRelationshipsPriceListData
from .price_update_data_relationships_price_list_data_type import PriceUpdateDataRelationshipsPriceListDataType
from .price_update_data_relationships_price_tiers import PriceUpdateDataRelationshipsPriceTiers
from .price_update_data_relationships_price_tiers_data import PriceUpdateDataRelationshipsPriceTiersData
from .price_update_data_relationships_price_tiers_data_type import PriceUpdateDataRelationshipsPriceTiersDataType
from .price_update_data_relationships_sku import PriceUpdateDataRelationshipsSku
from .price_update_data_relationships_sku_data import PriceUpdateDataRelationshipsSkuData
from .price_update_data_relationships_sku_data_type import PriceUpdateDataRelationshipsSkuDataType
from .price_update_data_type import PriceUpdateDataType
from .price_volume_tier import PriceVolumeTier
from .price_volume_tier_create import PriceVolumeTierCreate
from .price_volume_tier_create_data import PriceVolumeTierCreateData
from .price_volume_tier_create_data_attributes import PriceVolumeTierCreateDataAttributes
from .price_volume_tier_create_data_attributes_metadata import PriceVolumeTierCreateDataAttributesMetadata
from .price_volume_tier_create_data_relationships import PriceVolumeTierCreateDataRelationships
from .price_volume_tier_create_data_relationships_price import PriceVolumeTierCreateDataRelationshipsPrice
from .price_volume_tier_create_data_relationships_price_data import PriceVolumeTierCreateDataRelationshipsPriceData
from .price_volume_tier_create_data_relationships_price_data_type import (
    PriceVolumeTierCreateDataRelationshipsPriceDataType,
)
from .price_volume_tier_create_data_type import PriceVolumeTierCreateDataType
from .price_volume_tier_data import PriceVolumeTierData
from .price_volume_tier_data_attributes import PriceVolumeTierDataAttributes
from .price_volume_tier_data_attributes_metadata import PriceVolumeTierDataAttributesMetadata
from .price_volume_tier_data_relationships import PriceVolumeTierDataRelationships
from .price_volume_tier_data_relationships_attachments import PriceVolumeTierDataRelationshipsAttachments
from .price_volume_tier_data_relationships_attachments_data import PriceVolumeTierDataRelationshipsAttachmentsData
from .price_volume_tier_data_relationships_attachments_data_type import (
    PriceVolumeTierDataRelationshipsAttachmentsDataType,
)
from .price_volume_tier_data_relationships_price import PriceVolumeTierDataRelationshipsPrice
from .price_volume_tier_data_relationships_price_data import PriceVolumeTierDataRelationshipsPriceData
from .price_volume_tier_data_relationships_price_data_type import PriceVolumeTierDataRelationshipsPriceDataType
from .price_volume_tier_data_type import PriceVolumeTierDataType
from .price_volume_tier_update import PriceVolumeTierUpdate
from .price_volume_tier_update_data import PriceVolumeTierUpdateData
from .price_volume_tier_update_data_attributes import PriceVolumeTierUpdateDataAttributes
from .price_volume_tier_update_data_attributes_metadata import PriceVolumeTierUpdateDataAttributesMetadata
from .price_volume_tier_update_data_relationships import PriceVolumeTierUpdateDataRelationships
from .price_volume_tier_update_data_relationships_price import PriceVolumeTierUpdateDataRelationshipsPrice
from .price_volume_tier_update_data_relationships_price_data import PriceVolumeTierUpdateDataRelationshipsPriceData
from .price_volume_tier_update_data_relationships_price_data_type import (
    PriceVolumeTierUpdateDataRelationshipsPriceDataType,
)
from .price_volume_tier_update_data_type import PriceVolumeTierUpdateDataType
from .promotion import Promotion
from .promotion_data import PromotionData
from .promotion_data_attributes import PromotionDataAttributes
from .promotion_data_attributes_metadata import PromotionDataAttributesMetadata
from .promotion_data_relationships import PromotionDataRelationships
from .promotion_data_relationships_attachments import PromotionDataRelationshipsAttachments
from .promotion_data_relationships_attachments_data import PromotionDataRelationshipsAttachmentsData
from .promotion_data_relationships_attachments_data_type import PromotionDataRelationshipsAttachmentsDataType
from .promotion_data_relationships_coupon_codes_promotion_rule import PromotionDataRelationshipsCouponCodesPromotionRule
from .promotion_data_relationships_coupon_codes_promotion_rule_data import (
    PromotionDataRelationshipsCouponCodesPromotionRuleData,
)
from .promotion_data_relationships_coupon_codes_promotion_rule_data_type import (
    PromotionDataRelationshipsCouponCodesPromotionRuleDataType,
)
from .promotion_data_relationships_market import PromotionDataRelationshipsMarket
from .promotion_data_relationships_market_data import PromotionDataRelationshipsMarketData
from .promotion_data_relationships_market_data_type import PromotionDataRelationshipsMarketDataType
from .promotion_data_relationships_order_amount_promotion_rule import PromotionDataRelationshipsOrderAmountPromotionRule
from .promotion_data_relationships_order_amount_promotion_rule_data import (
    PromotionDataRelationshipsOrderAmountPromotionRuleData,
)
from .promotion_data_relationships_order_amount_promotion_rule_data_type import (
    PromotionDataRelationshipsOrderAmountPromotionRuleDataType,
)
from .promotion_data_relationships_promotion_rules import PromotionDataRelationshipsPromotionRules
from .promotion_data_relationships_promotion_rules_data import PromotionDataRelationshipsPromotionRulesData
from .promotion_data_relationships_promotion_rules_data_type import PromotionDataRelationshipsPromotionRulesDataType
from .promotion_data_relationships_sku_list_promotion_rule import PromotionDataRelationshipsSkuListPromotionRule
from .promotion_data_relationships_sku_list_promotion_rule_data import (
    PromotionDataRelationshipsSkuListPromotionRuleData,
)
from .promotion_data_relationships_sku_list_promotion_rule_data_type import (
    PromotionDataRelationshipsSkuListPromotionRuleDataType,
)
from .promotion_data_type import PromotionDataType
from .promotion_rule import PromotionRule
from .promotion_rule_data import PromotionRuleData
from .promotion_rule_data_attributes import PromotionRuleDataAttributes
from .promotion_rule_data_attributes_metadata import PromotionRuleDataAttributesMetadata
from .promotion_rule_data_relationships import PromotionRuleDataRelationships
from .promotion_rule_data_type import PromotionRuleDataType
from .refund import Refund
from .refund_data import RefundData
from .refund_data_attributes import RefundDataAttributes
from .refund_data_attributes_metadata import RefundDataAttributesMetadata
from .refund_data_relationships import RefundDataRelationships
from .refund_data_relationships_events import RefundDataRelationshipsEvents
from .refund_data_relationships_events_data import RefundDataRelationshipsEventsData
from .refund_data_relationships_events_data_type import RefundDataRelationshipsEventsDataType
from .refund_data_relationships_order import RefundDataRelationshipsOrder
from .refund_data_relationships_order_data import RefundDataRelationshipsOrderData
from .refund_data_relationships_order_data_type import RefundDataRelationshipsOrderDataType
from .refund_data_relationships_reference_capture import RefundDataRelationshipsReferenceCapture
from .refund_data_relationships_reference_capture_data import RefundDataRelationshipsReferenceCaptureData
from .refund_data_relationships_reference_capture_data_type import RefundDataRelationshipsReferenceCaptureDataType
from .refund_data_type import RefundDataType
from .return_ import Return
from .return_create import ReturnCreate
from .return_create_data import ReturnCreateData
from .return_create_data_attributes import ReturnCreateDataAttributes
from .return_create_data_attributes_metadata import ReturnCreateDataAttributesMetadata
from .return_create_data_relationships import ReturnCreateDataRelationships
from .return_create_data_relationships_order import ReturnCreateDataRelationshipsOrder
from .return_create_data_relationships_order_data import ReturnCreateDataRelationshipsOrderData
from .return_create_data_relationships_order_data_type import ReturnCreateDataRelationshipsOrderDataType
from .return_create_data_relationships_stock_location import ReturnCreateDataRelationshipsStockLocation
from .return_create_data_relationships_stock_location_data import ReturnCreateDataRelationshipsStockLocationData
from .return_create_data_relationships_stock_location_data_type import (
    ReturnCreateDataRelationshipsStockLocationDataType,
)
from .return_create_data_type import ReturnCreateDataType
from .return_data import ReturnData
from .return_data_attributes import ReturnDataAttributes
from .return_data_attributes_metadata import ReturnDataAttributesMetadata
from .return_data_relationships import ReturnDataRelationships
from .return_data_relationships_attachments import ReturnDataRelationshipsAttachments
from .return_data_relationships_attachments_data import ReturnDataRelationshipsAttachmentsData
from .return_data_relationships_attachments_data_type import ReturnDataRelationshipsAttachmentsDataType
from .return_data_relationships_customer import ReturnDataRelationshipsCustomer
from .return_data_relationships_customer_data import ReturnDataRelationshipsCustomerData
from .return_data_relationships_customer_data_type import ReturnDataRelationshipsCustomerDataType
from .return_data_relationships_destination_address import ReturnDataRelationshipsDestinationAddress
from .return_data_relationships_destination_address_data import ReturnDataRelationshipsDestinationAddressData
from .return_data_relationships_destination_address_data_type import ReturnDataRelationshipsDestinationAddressDataType
from .return_data_relationships_events import ReturnDataRelationshipsEvents
from .return_data_relationships_events_data import ReturnDataRelationshipsEventsData
from .return_data_relationships_events_data_type import ReturnDataRelationshipsEventsDataType
from .return_data_relationships_order import ReturnDataRelationshipsOrder
from .return_data_relationships_order_data import ReturnDataRelationshipsOrderData
from .return_data_relationships_order_data_type import ReturnDataRelationshipsOrderDataType
from .return_data_relationships_origin_address import ReturnDataRelationshipsOriginAddress
from .return_data_relationships_origin_address_data import ReturnDataRelationshipsOriginAddressData
from .return_data_relationships_origin_address_data_type import ReturnDataRelationshipsOriginAddressDataType
from .return_data_relationships_return_line_items import ReturnDataRelationshipsReturnLineItems
from .return_data_relationships_return_line_items_data import ReturnDataRelationshipsReturnLineItemsData
from .return_data_relationships_return_line_items_data_type import ReturnDataRelationshipsReturnLineItemsDataType
from .return_data_relationships_stock_location import ReturnDataRelationshipsStockLocation
from .return_data_relationships_stock_location_data import ReturnDataRelationshipsStockLocationData
from .return_data_relationships_stock_location_data_type import ReturnDataRelationshipsStockLocationDataType
from .return_data_type import ReturnDataType
from .return_line_item import ReturnLineItem
from .return_line_item_create import ReturnLineItemCreate
from .return_line_item_create_data import ReturnLineItemCreateData
from .return_line_item_create_data_attributes import ReturnLineItemCreateDataAttributes
from .return_line_item_create_data_attributes_metadata import ReturnLineItemCreateDataAttributesMetadata
from .return_line_item_create_data_attributes_return_reason import ReturnLineItemCreateDataAttributesReturnReason
from .return_line_item_create_data_relationships import ReturnLineItemCreateDataRelationships
from .return_line_item_create_data_relationships_line_item import ReturnLineItemCreateDataRelationshipsLineItem
from .return_line_item_create_data_relationships_line_item_data import ReturnLineItemCreateDataRelationshipsLineItemData
from .return_line_item_create_data_relationships_line_item_data_type import (
    ReturnLineItemCreateDataRelationshipsLineItemDataType,
)
from .return_line_item_create_data_relationships_return import ReturnLineItemCreateDataRelationshipsReturn
from .return_line_item_create_data_relationships_return_data import ReturnLineItemCreateDataRelationshipsReturnData
from .return_line_item_create_data_relationships_return_data_type import (
    ReturnLineItemCreateDataRelationshipsReturnDataType,
)
from .return_line_item_create_data_type import ReturnLineItemCreateDataType
from .return_line_item_data import ReturnLineItemData
from .return_line_item_data_attributes import ReturnLineItemDataAttributes
from .return_line_item_data_attributes_metadata import ReturnLineItemDataAttributesMetadata
from .return_line_item_data_attributes_return_reason import ReturnLineItemDataAttributesReturnReason
from .return_line_item_data_relationships import ReturnLineItemDataRelationships
from .return_line_item_data_relationships_line_item import ReturnLineItemDataRelationshipsLineItem
from .return_line_item_data_relationships_line_item_data import ReturnLineItemDataRelationshipsLineItemData
from .return_line_item_data_relationships_line_item_data_type import ReturnLineItemDataRelationshipsLineItemDataType
from .return_line_item_data_relationships_return import ReturnLineItemDataRelationshipsReturn
from .return_line_item_data_relationships_return_data import ReturnLineItemDataRelationshipsReturnData
from .return_line_item_data_relationships_return_data_type import ReturnLineItemDataRelationshipsReturnDataType
from .return_line_item_data_type import ReturnLineItemDataType
from .return_line_item_update import ReturnLineItemUpdate
from .return_line_item_update_data import ReturnLineItemUpdateData
from .return_line_item_update_data_attributes import ReturnLineItemUpdateDataAttributes
from .return_line_item_update_data_attributes_metadata import ReturnLineItemUpdateDataAttributesMetadata
from .return_line_item_update_data_attributes_return_reason import ReturnLineItemUpdateDataAttributesReturnReason
from .return_line_item_update_data_relationships import ReturnLineItemUpdateDataRelationships
from .return_line_item_update_data_type import ReturnLineItemUpdateDataType
from .return_update import ReturnUpdate
from .return_update_data import ReturnUpdateData
from .return_update_data_attributes import ReturnUpdateDataAttributes
from .return_update_data_attributes_metadata import ReturnUpdateDataAttributesMetadata
from .return_update_data_relationships import ReturnUpdateDataRelationships
from .return_update_data_relationships_stock_location import ReturnUpdateDataRelationshipsStockLocation
from .return_update_data_relationships_stock_location_data import ReturnUpdateDataRelationshipsStockLocationData
from .return_update_data_relationships_stock_location_data_type import (
    ReturnUpdateDataRelationshipsStockLocationDataType,
)
from .return_update_data_type import ReturnUpdateDataType
from .shipment import Shipment
from .shipment_data import ShipmentData
from .shipment_data_attributes import ShipmentDataAttributes
from .shipment_data_attributes_get_rates_errors_item import ShipmentDataAttributesGetRatesErrorsItem
from .shipment_data_attributes_metadata import ShipmentDataAttributesMetadata
from .shipment_data_attributes_rates_item import ShipmentDataAttributesRatesItem
from .shipment_data_relationships import ShipmentDataRelationships
from .shipment_data_relationships_attachments import ShipmentDataRelationshipsAttachments
from .shipment_data_relationships_attachments_data import ShipmentDataRelationshipsAttachmentsData
from .shipment_data_relationships_attachments_data_type import ShipmentDataRelationshipsAttachmentsDataType
from .shipment_data_relationships_available_shipping_methods import ShipmentDataRelationshipsAvailableShippingMethods
from .shipment_data_relationships_available_shipping_methods_data import (
    ShipmentDataRelationshipsAvailableShippingMethodsData,
)
from .shipment_data_relationships_available_shipping_methods_data_type import (
    ShipmentDataRelationshipsAvailableShippingMethodsDataType,
)
from .shipment_data_relationships_carrier_accounts import ShipmentDataRelationshipsCarrierAccounts
from .shipment_data_relationships_carrier_accounts_data import ShipmentDataRelationshipsCarrierAccountsData
from .shipment_data_relationships_carrier_accounts_data_type import ShipmentDataRelationshipsCarrierAccountsDataType
from .shipment_data_relationships_delivery_lead_time import ShipmentDataRelationshipsDeliveryLeadTime
from .shipment_data_relationships_delivery_lead_time_data import ShipmentDataRelationshipsDeliveryLeadTimeData
from .shipment_data_relationships_delivery_lead_time_data_type import ShipmentDataRelationshipsDeliveryLeadTimeDataType
from .shipment_data_relationships_events import ShipmentDataRelationshipsEvents
from .shipment_data_relationships_events_data import ShipmentDataRelationshipsEventsData
from .shipment_data_relationships_events_data_type import ShipmentDataRelationshipsEventsDataType
from .shipment_data_relationships_order import ShipmentDataRelationshipsOrder
from .shipment_data_relationships_order_data import ShipmentDataRelationshipsOrderData
from .shipment_data_relationships_order_data_type import ShipmentDataRelationshipsOrderDataType
from .shipment_data_relationships_origin_address import ShipmentDataRelationshipsOriginAddress
from .shipment_data_relationships_origin_address_data import ShipmentDataRelationshipsOriginAddressData
from .shipment_data_relationships_origin_address_data_type import ShipmentDataRelationshipsOriginAddressDataType
from .shipment_data_relationships_parcels import ShipmentDataRelationshipsParcels
from .shipment_data_relationships_parcels_data import ShipmentDataRelationshipsParcelsData
from .shipment_data_relationships_parcels_data_type import ShipmentDataRelationshipsParcelsDataType
from .shipment_data_relationships_shipment_line_items import ShipmentDataRelationshipsShipmentLineItems
from .shipment_data_relationships_shipment_line_items_data import ShipmentDataRelationshipsShipmentLineItemsData
from .shipment_data_relationships_shipment_line_items_data_type import (
    ShipmentDataRelationshipsShipmentLineItemsDataType,
)
from .shipment_data_relationships_shipping_address import ShipmentDataRelationshipsShippingAddress
from .shipment_data_relationships_shipping_address_data import ShipmentDataRelationshipsShippingAddressData
from .shipment_data_relationships_shipping_address_data_type import ShipmentDataRelationshipsShippingAddressDataType
from .shipment_data_relationships_shipping_category import ShipmentDataRelationshipsShippingCategory
from .shipment_data_relationships_shipping_category_data import ShipmentDataRelationshipsShippingCategoryData
from .shipment_data_relationships_shipping_category_data_type import ShipmentDataRelationshipsShippingCategoryDataType
from .shipment_data_relationships_shipping_method import ShipmentDataRelationshipsShippingMethod
from .shipment_data_relationships_shipping_method_data import ShipmentDataRelationshipsShippingMethodData
from .shipment_data_relationships_shipping_method_data_type import ShipmentDataRelationshipsShippingMethodDataType
from .shipment_data_relationships_stock_line_items import ShipmentDataRelationshipsStockLineItems
from .shipment_data_relationships_stock_line_items_data import ShipmentDataRelationshipsStockLineItemsData
from .shipment_data_relationships_stock_line_items_data_type import ShipmentDataRelationshipsStockLineItemsDataType
from .shipment_data_relationships_stock_location import ShipmentDataRelationshipsStockLocation
from .shipment_data_relationships_stock_location_data import ShipmentDataRelationshipsStockLocationData
from .shipment_data_relationships_stock_location_data_type import ShipmentDataRelationshipsStockLocationDataType
from .shipment_data_relationships_stock_transfers import ShipmentDataRelationshipsStockTransfers
from .shipment_data_relationships_stock_transfers_data import ShipmentDataRelationshipsStockTransfersData
from .shipment_data_relationships_stock_transfers_data_type import ShipmentDataRelationshipsStockTransfersDataType
from .shipment_data_type import ShipmentDataType
from .shipment_update import ShipmentUpdate
from .shipment_update_data import ShipmentUpdateData
from .shipment_update_data_attributes import ShipmentUpdateDataAttributes
from .shipment_update_data_attributes_metadata import ShipmentUpdateDataAttributesMetadata
from .shipment_update_data_relationships import ShipmentUpdateDataRelationships
from .shipment_update_data_relationships_shipping_method import ShipmentUpdateDataRelationshipsShippingMethod
from .shipment_update_data_relationships_shipping_method_data import ShipmentUpdateDataRelationshipsShippingMethodData
from .shipment_update_data_relationships_shipping_method_data_type import (
    ShipmentUpdateDataRelationshipsShippingMethodDataType,
)
from .shipment_update_data_type import ShipmentUpdateDataType
from .shipping_category import ShippingCategory
from .shipping_category_create import ShippingCategoryCreate
from .shipping_category_create_data import ShippingCategoryCreateData
from .shipping_category_create_data_attributes import ShippingCategoryCreateDataAttributes
from .shipping_category_create_data_attributes_metadata import ShippingCategoryCreateDataAttributesMetadata
from .shipping_category_create_data_relationships import ShippingCategoryCreateDataRelationships
from .shipping_category_create_data_type import ShippingCategoryCreateDataType
from .shipping_category_data import ShippingCategoryData
from .shipping_category_data_attributes import ShippingCategoryDataAttributes
from .shipping_category_data_attributes_metadata import ShippingCategoryDataAttributesMetadata
from .shipping_category_data_relationships import ShippingCategoryDataRelationships
from .shipping_category_data_relationships_attachments import ShippingCategoryDataRelationshipsAttachments
from .shipping_category_data_relationships_attachments_data import ShippingCategoryDataRelationshipsAttachmentsData
from .shipping_category_data_relationships_attachments_data_type import (
    ShippingCategoryDataRelationshipsAttachmentsDataType,
)
from .shipping_category_data_relationships_skus import ShippingCategoryDataRelationshipsSkus
from .shipping_category_data_relationships_skus_data import ShippingCategoryDataRelationshipsSkusData
from .shipping_category_data_relationships_skus_data_type import ShippingCategoryDataRelationshipsSkusDataType
from .shipping_category_data_type import ShippingCategoryDataType
from .shipping_category_update import ShippingCategoryUpdate
from .shipping_category_update_data import ShippingCategoryUpdateData
from .shipping_category_update_data_attributes import ShippingCategoryUpdateDataAttributes
from .shipping_category_update_data_attributes_metadata import ShippingCategoryUpdateDataAttributesMetadata
from .shipping_category_update_data_relationships import ShippingCategoryUpdateDataRelationships
from .shipping_category_update_data_type import ShippingCategoryUpdateDataType
from .shipping_method import ShippingMethod
from .shipping_method_create import ShippingMethodCreate
from .shipping_method_create_data import ShippingMethodCreateData
from .shipping_method_create_data_attributes import ShippingMethodCreateDataAttributes
from .shipping_method_create_data_attributes_metadata import ShippingMethodCreateDataAttributesMetadata
from .shipping_method_create_data_relationships import ShippingMethodCreateDataRelationships
from .shipping_method_create_data_relationships_market import ShippingMethodCreateDataRelationshipsMarket
from .shipping_method_create_data_relationships_market_data import ShippingMethodCreateDataRelationshipsMarketData
from .shipping_method_create_data_relationships_market_data_type import (
    ShippingMethodCreateDataRelationshipsMarketDataType,
)
from .shipping_method_create_data_relationships_shipping_category import (
    ShippingMethodCreateDataRelationshipsShippingCategory,
)
from .shipping_method_create_data_relationships_shipping_category_data import (
    ShippingMethodCreateDataRelationshipsShippingCategoryData,
)
from .shipping_method_create_data_relationships_shipping_category_data_type import (
    ShippingMethodCreateDataRelationshipsShippingCategoryDataType,
)
from .shipping_method_create_data_relationships_shipping_method_tiers import (
    ShippingMethodCreateDataRelationshipsShippingMethodTiers,
)
from .shipping_method_create_data_relationships_shipping_method_tiers_data import (
    ShippingMethodCreateDataRelationshipsShippingMethodTiersData,
)
from .shipping_method_create_data_relationships_shipping_method_tiers_data_type import (
    ShippingMethodCreateDataRelationshipsShippingMethodTiersDataType,
)
from .shipping_method_create_data_relationships_shipping_zone import ShippingMethodCreateDataRelationshipsShippingZone
from .shipping_method_create_data_relationships_shipping_zone_data import (
    ShippingMethodCreateDataRelationshipsShippingZoneData,
)
from .shipping_method_create_data_relationships_shipping_zone_data_type import (
    ShippingMethodCreateDataRelationshipsShippingZoneDataType,
)
from .shipping_method_create_data_relationships_stock_location import ShippingMethodCreateDataRelationshipsStockLocation
from .shipping_method_create_data_relationships_stock_location_data import (
    ShippingMethodCreateDataRelationshipsStockLocationData,
)
from .shipping_method_create_data_relationships_stock_location_data_type import (
    ShippingMethodCreateDataRelationshipsStockLocationDataType,
)
from .shipping_method_create_data_type import ShippingMethodCreateDataType
from .shipping_method_data import ShippingMethodData
from .shipping_method_data_attributes import ShippingMethodDataAttributes
from .shipping_method_data_attributes_metadata import ShippingMethodDataAttributesMetadata
from .shipping_method_data_relationships import ShippingMethodDataRelationships
from .shipping_method_data_relationships_attachments import ShippingMethodDataRelationshipsAttachments
from .shipping_method_data_relationships_attachments_data import ShippingMethodDataRelationshipsAttachmentsData
from .shipping_method_data_relationships_attachments_data_type import ShippingMethodDataRelationshipsAttachmentsDataType
from .shipping_method_data_relationships_delivery_lead_time_for_shipment import (
    ShippingMethodDataRelationshipsDeliveryLeadTimeForShipment,
)
from .shipping_method_data_relationships_delivery_lead_time_for_shipment_data import (
    ShippingMethodDataRelationshipsDeliveryLeadTimeForShipmentData,
)
from .shipping_method_data_relationships_delivery_lead_time_for_shipment_data_type import (
    ShippingMethodDataRelationshipsDeliveryLeadTimeForShipmentDataType,
)
from .shipping_method_data_relationships_market import ShippingMethodDataRelationshipsMarket
from .shipping_method_data_relationships_market_data import ShippingMethodDataRelationshipsMarketData
from .shipping_method_data_relationships_market_data_type import ShippingMethodDataRelationshipsMarketDataType
from .shipping_method_data_relationships_shipping_category import ShippingMethodDataRelationshipsShippingCategory
from .shipping_method_data_relationships_shipping_category_data import (
    ShippingMethodDataRelationshipsShippingCategoryData,
)
from .shipping_method_data_relationships_shipping_category_data_type import (
    ShippingMethodDataRelationshipsShippingCategoryDataType,
)
from .shipping_method_data_relationships_shipping_method_tiers import ShippingMethodDataRelationshipsShippingMethodTiers
from .shipping_method_data_relationships_shipping_method_tiers_data import (
    ShippingMethodDataRelationshipsShippingMethodTiersData,
)
from .shipping_method_data_relationships_shipping_method_tiers_data_type import (
    ShippingMethodDataRelationshipsShippingMethodTiersDataType,
)
from .shipping_method_data_relationships_shipping_weight_tiers import ShippingMethodDataRelationshipsShippingWeightTiers
from .shipping_method_data_relationships_shipping_weight_tiers_data import (
    ShippingMethodDataRelationshipsShippingWeightTiersData,
)
from .shipping_method_data_relationships_shipping_weight_tiers_data_type import (
    ShippingMethodDataRelationshipsShippingWeightTiersDataType,
)
from .shipping_method_data_relationships_shipping_zone import ShippingMethodDataRelationshipsShippingZone
from .shipping_method_data_relationships_shipping_zone_data import ShippingMethodDataRelationshipsShippingZoneData
from .shipping_method_data_relationships_shipping_zone_data_type import (
    ShippingMethodDataRelationshipsShippingZoneDataType,
)
from .shipping_method_data_relationships_stock_location import ShippingMethodDataRelationshipsStockLocation
from .shipping_method_data_relationships_stock_location_data import ShippingMethodDataRelationshipsStockLocationData
from .shipping_method_data_relationships_stock_location_data_type import (
    ShippingMethodDataRelationshipsStockLocationDataType,
)
from .shipping_method_data_type import ShippingMethodDataType
from .shipping_method_tier import ShippingMethodTier
from .shipping_method_tier_data import ShippingMethodTierData
from .shipping_method_tier_data_attributes import ShippingMethodTierDataAttributes
from .shipping_method_tier_data_attributes_metadata import ShippingMethodTierDataAttributesMetadata
from .shipping_method_tier_data_relationships import ShippingMethodTierDataRelationships
from .shipping_method_tier_data_relationships_attachments import ShippingMethodTierDataRelationshipsAttachments
from .shipping_method_tier_data_relationships_attachments_data import ShippingMethodTierDataRelationshipsAttachmentsData
from .shipping_method_tier_data_relationships_attachments_data_type import (
    ShippingMethodTierDataRelationshipsAttachmentsDataType,
)
from .shipping_method_tier_data_relationships_shipping_method import ShippingMethodTierDataRelationshipsShippingMethod
from .shipping_method_tier_data_relationships_shipping_method_data import (
    ShippingMethodTierDataRelationshipsShippingMethodData,
)
from .shipping_method_tier_data_relationships_shipping_method_data_type import (
    ShippingMethodTierDataRelationshipsShippingMethodDataType,
)
from .shipping_method_tier_data_type import ShippingMethodTierDataType
from .shipping_method_update import ShippingMethodUpdate
from .shipping_method_update_data import ShippingMethodUpdateData
from .shipping_method_update_data_attributes import ShippingMethodUpdateDataAttributes
from .shipping_method_update_data_attributes_metadata import ShippingMethodUpdateDataAttributesMetadata
from .shipping_method_update_data_relationships import ShippingMethodUpdateDataRelationships
from .shipping_method_update_data_relationships_market import ShippingMethodUpdateDataRelationshipsMarket
from .shipping_method_update_data_relationships_market_data import ShippingMethodUpdateDataRelationshipsMarketData
from .shipping_method_update_data_relationships_market_data_type import (
    ShippingMethodUpdateDataRelationshipsMarketDataType,
)
from .shipping_method_update_data_relationships_shipping_category import (
    ShippingMethodUpdateDataRelationshipsShippingCategory,
)
from .shipping_method_update_data_relationships_shipping_category_data import (
    ShippingMethodUpdateDataRelationshipsShippingCategoryData,
)
from .shipping_method_update_data_relationships_shipping_category_data_type import (
    ShippingMethodUpdateDataRelationshipsShippingCategoryDataType,
)
from .shipping_method_update_data_relationships_shipping_method_tiers import (
    ShippingMethodUpdateDataRelationshipsShippingMethodTiers,
)
from .shipping_method_update_data_relationships_shipping_method_tiers_data import (
    ShippingMethodUpdateDataRelationshipsShippingMethodTiersData,
)
from .shipping_method_update_data_relationships_shipping_method_tiers_data_type import (
    ShippingMethodUpdateDataRelationshipsShippingMethodTiersDataType,
)
from .shipping_method_update_data_relationships_shipping_zone import ShippingMethodUpdateDataRelationshipsShippingZone
from .shipping_method_update_data_relationships_shipping_zone_data import (
    ShippingMethodUpdateDataRelationshipsShippingZoneData,
)
from .shipping_method_update_data_relationships_shipping_zone_data_type import (
    ShippingMethodUpdateDataRelationshipsShippingZoneDataType,
)
from .shipping_method_update_data_relationships_stock_location import ShippingMethodUpdateDataRelationshipsStockLocation
from .shipping_method_update_data_relationships_stock_location_data import (
    ShippingMethodUpdateDataRelationshipsStockLocationData,
)
from .shipping_method_update_data_relationships_stock_location_data_type import (
    ShippingMethodUpdateDataRelationshipsStockLocationDataType,
)
from .shipping_method_update_data_type import ShippingMethodUpdateDataType
from .shipping_weight_tier import ShippingWeightTier
from .shipping_weight_tier_create import ShippingWeightTierCreate
from .shipping_weight_tier_create_data import ShippingWeightTierCreateData
from .shipping_weight_tier_create_data_attributes import ShippingWeightTierCreateDataAttributes
from .shipping_weight_tier_create_data_attributes_metadata import ShippingWeightTierCreateDataAttributesMetadata
from .shipping_weight_tier_create_data_relationships import ShippingWeightTierCreateDataRelationships
from .shipping_weight_tier_create_data_relationships_shipping_method import (
    ShippingWeightTierCreateDataRelationshipsShippingMethod,
)
from .shipping_weight_tier_create_data_relationships_shipping_method_data import (
    ShippingWeightTierCreateDataRelationshipsShippingMethodData,
)
from .shipping_weight_tier_create_data_relationships_shipping_method_data_type import (
    ShippingWeightTierCreateDataRelationshipsShippingMethodDataType,
)
from .shipping_weight_tier_create_data_type import ShippingWeightTierCreateDataType
from .shipping_weight_tier_data import ShippingWeightTierData
from .shipping_weight_tier_data_attributes import ShippingWeightTierDataAttributes
from .shipping_weight_tier_data_attributes_metadata import ShippingWeightTierDataAttributesMetadata
from .shipping_weight_tier_data_relationships import ShippingWeightTierDataRelationships
from .shipping_weight_tier_data_relationships_attachments import ShippingWeightTierDataRelationshipsAttachments
from .shipping_weight_tier_data_relationships_attachments_data import ShippingWeightTierDataRelationshipsAttachmentsData
from .shipping_weight_tier_data_relationships_attachments_data_type import (
    ShippingWeightTierDataRelationshipsAttachmentsDataType,
)
from .shipping_weight_tier_data_relationships_shipping_method import ShippingWeightTierDataRelationshipsShippingMethod
from .shipping_weight_tier_data_relationships_shipping_method_data import (
    ShippingWeightTierDataRelationshipsShippingMethodData,
)
from .shipping_weight_tier_data_relationships_shipping_method_data_type import (
    ShippingWeightTierDataRelationshipsShippingMethodDataType,
)
from .shipping_weight_tier_data_type import ShippingWeightTierDataType
from .shipping_weight_tier_update import ShippingWeightTierUpdate
from .shipping_weight_tier_update_data import ShippingWeightTierUpdateData
from .shipping_weight_tier_update_data_attributes import ShippingWeightTierUpdateDataAttributes
from .shipping_weight_tier_update_data_attributes_metadata import ShippingWeightTierUpdateDataAttributesMetadata
from .shipping_weight_tier_update_data_relationships import ShippingWeightTierUpdateDataRelationships
from .shipping_weight_tier_update_data_relationships_shipping_method import (
    ShippingWeightTierUpdateDataRelationshipsShippingMethod,
)
from .shipping_weight_tier_update_data_relationships_shipping_method_data import (
    ShippingWeightTierUpdateDataRelationshipsShippingMethodData,
)
from .shipping_weight_tier_update_data_relationships_shipping_method_data_type import (
    ShippingWeightTierUpdateDataRelationshipsShippingMethodDataType,
)
from .shipping_weight_tier_update_data_type import ShippingWeightTierUpdateDataType
from .shipping_zone import ShippingZone
from .shipping_zone_create import ShippingZoneCreate
from .shipping_zone_create_data import ShippingZoneCreateData
from .shipping_zone_create_data_attributes import ShippingZoneCreateDataAttributes
from .shipping_zone_create_data_attributes_metadata import ShippingZoneCreateDataAttributesMetadata
from .shipping_zone_create_data_relationships import ShippingZoneCreateDataRelationships
from .shipping_zone_create_data_type import ShippingZoneCreateDataType
from .shipping_zone_data import ShippingZoneData
from .shipping_zone_data_attributes import ShippingZoneDataAttributes
from .shipping_zone_data_attributes_metadata import ShippingZoneDataAttributesMetadata
from .shipping_zone_data_relationships import ShippingZoneDataRelationships
from .shipping_zone_data_relationships_attachments import ShippingZoneDataRelationshipsAttachments
from .shipping_zone_data_relationships_attachments_data import ShippingZoneDataRelationshipsAttachmentsData
from .shipping_zone_data_relationships_attachments_data_type import ShippingZoneDataRelationshipsAttachmentsDataType
from .shipping_zone_data_type import ShippingZoneDataType
from .shipping_zone_update import ShippingZoneUpdate
from .shipping_zone_update_data import ShippingZoneUpdateData
from .shipping_zone_update_data_attributes import ShippingZoneUpdateDataAttributes
from .shipping_zone_update_data_attributes_metadata import ShippingZoneUpdateDataAttributesMetadata
from .shipping_zone_update_data_relationships import ShippingZoneUpdateDataRelationships
from .shipping_zone_update_data_type import ShippingZoneUpdateDataType
from .sku import Sku
from .sku_create import SkuCreate
from .sku_create_data import SkuCreateData
from .sku_create_data_attributes import SkuCreateDataAttributes
from .sku_create_data_attributes_metadata import SkuCreateDataAttributesMetadata
from .sku_create_data_relationships import SkuCreateDataRelationships
from .sku_create_data_relationships_shipping_category import SkuCreateDataRelationshipsShippingCategory
from .sku_create_data_relationships_shipping_category_data import SkuCreateDataRelationshipsShippingCategoryData
from .sku_create_data_relationships_shipping_category_data_type import (
    SkuCreateDataRelationshipsShippingCategoryDataType,
)
from .sku_create_data_type import SkuCreateDataType
from .sku_data import SkuData
from .sku_data_attributes import SkuDataAttributes
from .sku_data_attributes_inventory import SkuDataAttributesInventory
from .sku_data_attributes_metadata import SkuDataAttributesMetadata
from .sku_data_relationships import SkuDataRelationships
from .sku_data_relationships_attachments import SkuDataRelationshipsAttachments
from .sku_data_relationships_attachments_data import SkuDataRelationshipsAttachmentsData
from .sku_data_relationships_attachments_data_type import SkuDataRelationshipsAttachmentsDataType
from .sku_data_relationships_delivery_lead_times import SkuDataRelationshipsDeliveryLeadTimes
from .sku_data_relationships_delivery_lead_times_data import SkuDataRelationshipsDeliveryLeadTimesData
from .sku_data_relationships_delivery_lead_times_data_type import SkuDataRelationshipsDeliveryLeadTimesDataType
from .sku_data_relationships_prices import SkuDataRelationshipsPrices
from .sku_data_relationships_prices_data import SkuDataRelationshipsPricesData
from .sku_data_relationships_prices_data_type import SkuDataRelationshipsPricesDataType
from .sku_data_relationships_shipping_category import SkuDataRelationshipsShippingCategory
from .sku_data_relationships_shipping_category_data import SkuDataRelationshipsShippingCategoryData
from .sku_data_relationships_shipping_category_data_type import SkuDataRelationshipsShippingCategoryDataType
from .sku_data_relationships_sku_options import SkuDataRelationshipsSkuOptions
from .sku_data_relationships_sku_options_data import SkuDataRelationshipsSkuOptionsData
from .sku_data_relationships_sku_options_data_type import SkuDataRelationshipsSkuOptionsDataType
from .sku_data_relationships_stock_items import SkuDataRelationshipsStockItems
from .sku_data_relationships_stock_items_data import SkuDataRelationshipsStockItemsData
from .sku_data_relationships_stock_items_data_type import SkuDataRelationshipsStockItemsDataType
from .sku_data_type import SkuDataType
from .sku_list import SkuList
from .sku_list_create import SkuListCreate
from .sku_list_create_data import SkuListCreateData
from .sku_list_create_data_attributes import SkuListCreateDataAttributes
from .sku_list_create_data_attributes_metadata import SkuListCreateDataAttributesMetadata
from .sku_list_create_data_relationships import SkuListCreateDataRelationships
from .sku_list_create_data_relationships_customer import SkuListCreateDataRelationshipsCustomer
from .sku_list_create_data_relationships_customer_data import SkuListCreateDataRelationshipsCustomerData
from .sku_list_create_data_relationships_customer_data_type import SkuListCreateDataRelationshipsCustomerDataType
from .sku_list_create_data_type import SkuListCreateDataType
from .sku_list_data import SkuListData
from .sku_list_data_attributes import SkuListDataAttributes
from .sku_list_data_attributes_metadata import SkuListDataAttributesMetadata
from .sku_list_data_relationships import SkuListDataRelationships
from .sku_list_data_relationships_attachments import SkuListDataRelationshipsAttachments
from .sku_list_data_relationships_attachments_data import SkuListDataRelationshipsAttachmentsData
from .sku_list_data_relationships_attachments_data_type import SkuListDataRelationshipsAttachmentsDataType
from .sku_list_data_relationships_bundles import SkuListDataRelationshipsBundles
from .sku_list_data_relationships_bundles_data import SkuListDataRelationshipsBundlesData
from .sku_list_data_relationships_bundles_data_type import SkuListDataRelationshipsBundlesDataType
from .sku_list_data_relationships_customer import SkuListDataRelationshipsCustomer
from .sku_list_data_relationships_customer_data import SkuListDataRelationshipsCustomerData
from .sku_list_data_relationships_customer_data_type import SkuListDataRelationshipsCustomerDataType
from .sku_list_data_relationships_sku_list_items import SkuListDataRelationshipsSkuListItems
from .sku_list_data_relationships_sku_list_items_data import SkuListDataRelationshipsSkuListItemsData
from .sku_list_data_relationships_sku_list_items_data_type import SkuListDataRelationshipsSkuListItemsDataType
from .sku_list_data_relationships_skus import SkuListDataRelationshipsSkus
from .sku_list_data_relationships_skus_data import SkuListDataRelationshipsSkusData
from .sku_list_data_relationships_skus_data_type import SkuListDataRelationshipsSkusDataType
from .sku_list_data_type import SkuListDataType
from .sku_list_item import SkuListItem
from .sku_list_item_create import SkuListItemCreate
from .sku_list_item_create_data import SkuListItemCreateData
from .sku_list_item_create_data_attributes import SkuListItemCreateDataAttributes
from .sku_list_item_create_data_attributes_metadata import SkuListItemCreateDataAttributesMetadata
from .sku_list_item_create_data_relationships import SkuListItemCreateDataRelationships
from .sku_list_item_create_data_relationships_sku import SkuListItemCreateDataRelationshipsSku
from .sku_list_item_create_data_relationships_sku_data import SkuListItemCreateDataRelationshipsSkuData
from .sku_list_item_create_data_relationships_sku_data_type import SkuListItemCreateDataRelationshipsSkuDataType
from .sku_list_item_create_data_relationships_sku_list import SkuListItemCreateDataRelationshipsSkuList
from .sku_list_item_create_data_relationships_sku_list_data import SkuListItemCreateDataRelationshipsSkuListData
from .sku_list_item_create_data_relationships_sku_list_data_type import (
    SkuListItemCreateDataRelationshipsSkuListDataType,
)
from .sku_list_item_create_data_type import SkuListItemCreateDataType
from .sku_list_item_data import SkuListItemData
from .sku_list_item_data_attributes import SkuListItemDataAttributes
from .sku_list_item_data_attributes_metadata import SkuListItemDataAttributesMetadata
from .sku_list_item_data_relationships import SkuListItemDataRelationships
from .sku_list_item_data_relationships_sku import SkuListItemDataRelationshipsSku
from .sku_list_item_data_relationships_sku_data import SkuListItemDataRelationshipsSkuData
from .sku_list_item_data_relationships_sku_data_type import SkuListItemDataRelationshipsSkuDataType
from .sku_list_item_data_relationships_sku_list import SkuListItemDataRelationshipsSkuList
from .sku_list_item_data_relationships_sku_list_data import SkuListItemDataRelationshipsSkuListData
from .sku_list_item_data_relationships_sku_list_data_type import SkuListItemDataRelationshipsSkuListDataType
from .sku_list_item_data_type import SkuListItemDataType
from .sku_list_item_update import SkuListItemUpdate
from .sku_list_item_update_data import SkuListItemUpdateData
from .sku_list_item_update_data_attributes import SkuListItemUpdateDataAttributes
from .sku_list_item_update_data_attributes_metadata import SkuListItemUpdateDataAttributesMetadata
from .sku_list_item_update_data_relationships import SkuListItemUpdateDataRelationships
from .sku_list_item_update_data_type import SkuListItemUpdateDataType
from .sku_list_promotion_rule import SkuListPromotionRule
from .sku_list_promotion_rule_create import SkuListPromotionRuleCreate
from .sku_list_promotion_rule_create_data import SkuListPromotionRuleCreateData
from .sku_list_promotion_rule_create_data_attributes import SkuListPromotionRuleCreateDataAttributes
from .sku_list_promotion_rule_create_data_attributes_metadata import SkuListPromotionRuleCreateDataAttributesMetadata
from .sku_list_promotion_rule_create_data_relationships import SkuListPromotionRuleCreateDataRelationships
from .sku_list_promotion_rule_create_data_relationships_sku_list import (
    SkuListPromotionRuleCreateDataRelationshipsSkuList,
)
from .sku_list_promotion_rule_create_data_relationships_sku_list_data import (
    SkuListPromotionRuleCreateDataRelationshipsSkuListData,
)
from .sku_list_promotion_rule_create_data_relationships_sku_list_data_type import (
    SkuListPromotionRuleCreateDataRelationshipsSkuListDataType,
)
from .sku_list_promotion_rule_create_data_type import SkuListPromotionRuleCreateDataType
from .sku_list_promotion_rule_data import SkuListPromotionRuleData
from .sku_list_promotion_rule_data_attributes import SkuListPromotionRuleDataAttributes
from .sku_list_promotion_rule_data_attributes_metadata import SkuListPromotionRuleDataAttributesMetadata
from .sku_list_promotion_rule_data_relationships import SkuListPromotionRuleDataRelationships
from .sku_list_promotion_rule_data_relationships_sku_list import SkuListPromotionRuleDataRelationshipsSkuList
from .sku_list_promotion_rule_data_relationships_sku_list_data import SkuListPromotionRuleDataRelationshipsSkuListData
from .sku_list_promotion_rule_data_relationships_sku_list_data_type import (
    SkuListPromotionRuleDataRelationshipsSkuListDataType,
)
from .sku_list_promotion_rule_data_relationships_skus import SkuListPromotionRuleDataRelationshipsSkus
from .sku_list_promotion_rule_data_relationships_skus_data import SkuListPromotionRuleDataRelationshipsSkusData
from .sku_list_promotion_rule_data_relationships_skus_data_type import SkuListPromotionRuleDataRelationshipsSkusDataType
from .sku_list_promotion_rule_data_type import SkuListPromotionRuleDataType
from .sku_list_promotion_rule_update import SkuListPromotionRuleUpdate
from .sku_list_promotion_rule_update_data import SkuListPromotionRuleUpdateData
from .sku_list_promotion_rule_update_data_attributes import SkuListPromotionRuleUpdateDataAttributes
from .sku_list_promotion_rule_update_data_attributes_metadata import SkuListPromotionRuleUpdateDataAttributesMetadata
from .sku_list_promotion_rule_update_data_relationships import SkuListPromotionRuleUpdateDataRelationships
from .sku_list_promotion_rule_update_data_relationships_sku_list import (
    SkuListPromotionRuleUpdateDataRelationshipsSkuList,
)
from .sku_list_promotion_rule_update_data_relationships_sku_list_data import (
    SkuListPromotionRuleUpdateDataRelationshipsSkuListData,
)
from .sku_list_promotion_rule_update_data_relationships_sku_list_data_type import (
    SkuListPromotionRuleUpdateDataRelationshipsSkuListDataType,
)
from .sku_list_promotion_rule_update_data_type import SkuListPromotionRuleUpdateDataType
from .sku_list_update import SkuListUpdate
from .sku_list_update_data import SkuListUpdateData
from .sku_list_update_data_attributes import SkuListUpdateDataAttributes
from .sku_list_update_data_attributes_metadata import SkuListUpdateDataAttributesMetadata
from .sku_list_update_data_relationships import SkuListUpdateDataRelationships
from .sku_list_update_data_relationships_customer import SkuListUpdateDataRelationshipsCustomer
from .sku_list_update_data_relationships_customer_data import SkuListUpdateDataRelationshipsCustomerData
from .sku_list_update_data_relationships_customer_data_type import SkuListUpdateDataRelationshipsCustomerDataType
from .sku_list_update_data_type import SkuListUpdateDataType
from .sku_option import SkuOption
from .sku_option_create import SkuOptionCreate
from .sku_option_create_data import SkuOptionCreateData
from .sku_option_create_data_attributes import SkuOptionCreateDataAttributes
from .sku_option_create_data_attributes_metadata import SkuOptionCreateDataAttributesMetadata
from .sku_option_create_data_relationships import SkuOptionCreateDataRelationships
from .sku_option_create_data_relationships_market import SkuOptionCreateDataRelationshipsMarket
from .sku_option_create_data_relationships_market_data import SkuOptionCreateDataRelationshipsMarketData
from .sku_option_create_data_relationships_market_data_type import SkuOptionCreateDataRelationshipsMarketDataType
from .sku_option_create_data_type import SkuOptionCreateDataType
from .sku_option_data import SkuOptionData
from .sku_option_data_attributes import SkuOptionDataAttributes
from .sku_option_data_attributes_metadata import SkuOptionDataAttributesMetadata
from .sku_option_data_relationships import SkuOptionDataRelationships
from .sku_option_data_relationships_attachments import SkuOptionDataRelationshipsAttachments
from .sku_option_data_relationships_attachments_data import SkuOptionDataRelationshipsAttachmentsData
from .sku_option_data_relationships_attachments_data_type import SkuOptionDataRelationshipsAttachmentsDataType
from .sku_option_data_relationships_market import SkuOptionDataRelationshipsMarket
from .sku_option_data_relationships_market_data import SkuOptionDataRelationshipsMarketData
from .sku_option_data_relationships_market_data_type import SkuOptionDataRelationshipsMarketDataType
from .sku_option_data_type import SkuOptionDataType
from .sku_option_update import SkuOptionUpdate
from .sku_option_update_data import SkuOptionUpdateData
from .sku_option_update_data_attributes import SkuOptionUpdateDataAttributes
from .sku_option_update_data_attributes_metadata import SkuOptionUpdateDataAttributesMetadata
from .sku_option_update_data_relationships import SkuOptionUpdateDataRelationships
from .sku_option_update_data_relationships_market import SkuOptionUpdateDataRelationshipsMarket
from .sku_option_update_data_relationships_market_data import SkuOptionUpdateDataRelationshipsMarketData
from .sku_option_update_data_relationships_market_data_type import SkuOptionUpdateDataRelationshipsMarketDataType
from .sku_option_update_data_type import SkuOptionUpdateDataType
from .sku_update import SkuUpdate
from .sku_update_data import SkuUpdateData
from .sku_update_data_attributes import SkuUpdateDataAttributes
from .sku_update_data_attributes_metadata import SkuUpdateDataAttributesMetadata
from .sku_update_data_relationships import SkuUpdateDataRelationships
from .sku_update_data_relationships_shipping_category import SkuUpdateDataRelationshipsShippingCategory
from .sku_update_data_relationships_shipping_category_data import SkuUpdateDataRelationshipsShippingCategoryData
from .sku_update_data_relationships_shipping_category_data_type import (
    SkuUpdateDataRelationshipsShippingCategoryDataType,
)
from .sku_update_data_type import SkuUpdateDataType
from .stock_item import StockItem
from .stock_item_create import StockItemCreate
from .stock_item_create_data import StockItemCreateData
from .stock_item_create_data_attributes import StockItemCreateDataAttributes
from .stock_item_create_data_attributes_metadata import StockItemCreateDataAttributesMetadata
from .stock_item_create_data_relationships import StockItemCreateDataRelationships
from .stock_item_create_data_relationships_sku import StockItemCreateDataRelationshipsSku
from .stock_item_create_data_relationships_sku_data import StockItemCreateDataRelationshipsSkuData
from .stock_item_create_data_relationships_sku_data_type import StockItemCreateDataRelationshipsSkuDataType
from .stock_item_create_data_relationships_stock_location import StockItemCreateDataRelationshipsStockLocation
from .stock_item_create_data_relationships_stock_location_data import StockItemCreateDataRelationshipsStockLocationData
from .stock_item_create_data_relationships_stock_location_data_type import (
    StockItemCreateDataRelationshipsStockLocationDataType,
)
from .stock_item_create_data_type import StockItemCreateDataType
from .stock_item_data import StockItemData
from .stock_item_data_attributes import StockItemDataAttributes
from .stock_item_data_attributes_metadata import StockItemDataAttributesMetadata
from .stock_item_data_relationships import StockItemDataRelationships
from .stock_item_data_relationships_attachments import StockItemDataRelationshipsAttachments
from .stock_item_data_relationships_attachments_data import StockItemDataRelationshipsAttachmentsData
from .stock_item_data_relationships_attachments_data_type import StockItemDataRelationshipsAttachmentsDataType
from .stock_item_data_relationships_sku import StockItemDataRelationshipsSku
from .stock_item_data_relationships_sku_data import StockItemDataRelationshipsSkuData
from .stock_item_data_relationships_sku_data_type import StockItemDataRelationshipsSkuDataType
from .stock_item_data_relationships_stock_location import StockItemDataRelationshipsStockLocation
from .stock_item_data_relationships_stock_location_data import StockItemDataRelationshipsStockLocationData
from .stock_item_data_relationships_stock_location_data_type import StockItemDataRelationshipsStockLocationDataType
from .stock_item_data_type import StockItemDataType
from .stock_item_update import StockItemUpdate
from .stock_item_update_data import StockItemUpdateData
from .stock_item_update_data_attributes import StockItemUpdateDataAttributes
from .stock_item_update_data_attributes_metadata import StockItemUpdateDataAttributesMetadata
from .stock_item_update_data_relationships import StockItemUpdateDataRelationships
from .stock_item_update_data_relationships_sku import StockItemUpdateDataRelationshipsSku
from .stock_item_update_data_relationships_sku_data import StockItemUpdateDataRelationshipsSkuData
from .stock_item_update_data_relationships_sku_data_type import StockItemUpdateDataRelationshipsSkuDataType
from .stock_item_update_data_relationships_stock_location import StockItemUpdateDataRelationshipsStockLocation
from .stock_item_update_data_relationships_stock_location_data import StockItemUpdateDataRelationshipsStockLocationData
from .stock_item_update_data_relationships_stock_location_data_type import (
    StockItemUpdateDataRelationshipsStockLocationDataType,
)
from .stock_item_update_data_type import StockItemUpdateDataType
from .stock_line_item import StockLineItem
from .stock_line_item_data import StockLineItemData
from .stock_line_item_data_attributes import StockLineItemDataAttributes
from .stock_line_item_data_attributes_metadata import StockLineItemDataAttributesMetadata
from .stock_line_item_data_relationships import StockLineItemDataRelationships
from .stock_line_item_data_relationships_line_item import StockLineItemDataRelationshipsLineItem
from .stock_line_item_data_relationships_line_item_data import StockLineItemDataRelationshipsLineItemData
from .stock_line_item_data_relationships_line_item_data_type import StockLineItemDataRelationshipsLineItemDataType
from .stock_line_item_data_relationships_shipment import StockLineItemDataRelationshipsShipment
from .stock_line_item_data_relationships_shipment_data import StockLineItemDataRelationshipsShipmentData
from .stock_line_item_data_relationships_shipment_data_type import StockLineItemDataRelationshipsShipmentDataType
from .stock_line_item_data_relationships_stock_item import StockLineItemDataRelationshipsStockItem
from .stock_line_item_data_relationships_stock_item_data import StockLineItemDataRelationshipsStockItemData
from .stock_line_item_data_relationships_stock_item_data_type import StockLineItemDataRelationshipsStockItemDataType
from .stock_line_item_data_type import StockLineItemDataType
from .stock_location import StockLocation
from .stock_location_create import StockLocationCreate
from .stock_location_create_data import StockLocationCreateData
from .stock_location_create_data_attributes import StockLocationCreateDataAttributes
from .stock_location_create_data_attributes_metadata import StockLocationCreateDataAttributesMetadata
from .stock_location_create_data_relationships import StockLocationCreateDataRelationships
from .stock_location_create_data_relationships_address import StockLocationCreateDataRelationshipsAddress
from .stock_location_create_data_relationships_address_data import StockLocationCreateDataRelationshipsAddressData
from .stock_location_create_data_relationships_address_data_type import (
    StockLocationCreateDataRelationshipsAddressDataType,
)
from .stock_location_create_data_type import StockLocationCreateDataType
from .stock_location_data import StockLocationData
from .stock_location_data_attributes import StockLocationDataAttributes
from .stock_location_data_attributes_metadata import StockLocationDataAttributesMetadata
from .stock_location_data_relationships import StockLocationDataRelationships
from .stock_location_data_relationships_address import StockLocationDataRelationshipsAddress
from .stock_location_data_relationships_address_data import StockLocationDataRelationshipsAddressData
from .stock_location_data_relationships_address_data_type import StockLocationDataRelationshipsAddressDataType
from .stock_location_data_relationships_attachments import StockLocationDataRelationshipsAttachments
from .stock_location_data_relationships_attachments_data import StockLocationDataRelationshipsAttachmentsData
from .stock_location_data_relationships_attachments_data_type import StockLocationDataRelationshipsAttachmentsDataType
from .stock_location_data_relationships_inventory_return_locations import (
    StockLocationDataRelationshipsInventoryReturnLocations,
)
from .stock_location_data_relationships_inventory_return_locations_data import (
    StockLocationDataRelationshipsInventoryReturnLocationsData,
)
from .stock_location_data_relationships_inventory_return_locations_data_type import (
    StockLocationDataRelationshipsInventoryReturnLocationsDataType,
)
from .stock_location_data_relationships_inventory_stock_locations import (
    StockLocationDataRelationshipsInventoryStockLocations,
)
from .stock_location_data_relationships_inventory_stock_locations_data import (
    StockLocationDataRelationshipsInventoryStockLocationsData,
)
from .stock_location_data_relationships_inventory_stock_locations_data_type import (
    StockLocationDataRelationshipsInventoryStockLocationsDataType,
)
from .stock_location_data_relationships_stock_items import StockLocationDataRelationshipsStockItems
from .stock_location_data_relationships_stock_items_data import StockLocationDataRelationshipsStockItemsData
from .stock_location_data_relationships_stock_items_data_type import StockLocationDataRelationshipsStockItemsDataType
from .stock_location_data_relationships_stock_transfers import StockLocationDataRelationshipsStockTransfers
from .stock_location_data_relationships_stock_transfers_data import StockLocationDataRelationshipsStockTransfersData
from .stock_location_data_relationships_stock_transfers_data_type import (
    StockLocationDataRelationshipsStockTransfersDataType,
)
from .stock_location_data_type import StockLocationDataType
from .stock_location_update import StockLocationUpdate
from .stock_location_update_data import StockLocationUpdateData
from .stock_location_update_data_attributes import StockLocationUpdateDataAttributes
from .stock_location_update_data_attributes_metadata import StockLocationUpdateDataAttributesMetadata
from .stock_location_update_data_relationships import StockLocationUpdateDataRelationships
from .stock_location_update_data_relationships_address import StockLocationUpdateDataRelationshipsAddress
from .stock_location_update_data_relationships_address_data import StockLocationUpdateDataRelationshipsAddressData
from .stock_location_update_data_relationships_address_data_type import (
    StockLocationUpdateDataRelationshipsAddressDataType,
)
from .stock_location_update_data_type import StockLocationUpdateDataType
from .stock_transfer import StockTransfer
from .stock_transfer_create import StockTransferCreate
from .stock_transfer_create_data import StockTransferCreateData
from .stock_transfer_create_data_attributes import StockTransferCreateDataAttributes
from .stock_transfer_create_data_attributes_metadata import StockTransferCreateDataAttributesMetadata
from .stock_transfer_create_data_relationships import StockTransferCreateDataRelationships
from .stock_transfer_create_data_relationships_destination_stock_location import (
    StockTransferCreateDataRelationshipsDestinationStockLocation,
)
from .stock_transfer_create_data_relationships_destination_stock_location_data import (
    StockTransferCreateDataRelationshipsDestinationStockLocationData,
)
from .stock_transfer_create_data_relationships_destination_stock_location_data_type import (
    StockTransferCreateDataRelationshipsDestinationStockLocationDataType,
)
from .stock_transfer_create_data_relationships_line_item import StockTransferCreateDataRelationshipsLineItem
from .stock_transfer_create_data_relationships_line_item_data import StockTransferCreateDataRelationshipsLineItemData
from .stock_transfer_create_data_relationships_line_item_data_type import (
    StockTransferCreateDataRelationshipsLineItemDataType,
)
from .stock_transfer_create_data_relationships_origin_stock_location import (
    StockTransferCreateDataRelationshipsOriginStockLocation,
)
from .stock_transfer_create_data_relationships_origin_stock_location_data import (
    StockTransferCreateDataRelationshipsOriginStockLocationData,
)
from .stock_transfer_create_data_relationships_origin_stock_location_data_type import (
    StockTransferCreateDataRelationshipsOriginStockLocationDataType,
)
from .stock_transfer_create_data_relationships_shipment import StockTransferCreateDataRelationshipsShipment
from .stock_transfer_create_data_relationships_shipment_data import StockTransferCreateDataRelationshipsShipmentData
from .stock_transfer_create_data_relationships_shipment_data_type import (
    StockTransferCreateDataRelationshipsShipmentDataType,
)
from .stock_transfer_create_data_relationships_sku import StockTransferCreateDataRelationshipsSku
from .stock_transfer_create_data_relationships_sku_data import StockTransferCreateDataRelationshipsSkuData
from .stock_transfer_create_data_relationships_sku_data_type import StockTransferCreateDataRelationshipsSkuDataType
from .stock_transfer_create_data_type import StockTransferCreateDataType
from .stock_transfer_data import StockTransferData
from .stock_transfer_data_attributes import StockTransferDataAttributes
from .stock_transfer_data_attributes_metadata import StockTransferDataAttributesMetadata
from .stock_transfer_data_relationships import StockTransferDataRelationships
from .stock_transfer_data_relationships_destination_stock_location import (
    StockTransferDataRelationshipsDestinationStockLocation,
)
from .stock_transfer_data_relationships_destination_stock_location_data import (
    StockTransferDataRelationshipsDestinationStockLocationData,
)
from .stock_transfer_data_relationships_destination_stock_location_data_type import (
    StockTransferDataRelationshipsDestinationStockLocationDataType,
)
from .stock_transfer_data_relationships_events import StockTransferDataRelationshipsEvents
from .stock_transfer_data_relationships_events_data import StockTransferDataRelationshipsEventsData
from .stock_transfer_data_relationships_events_data_type import StockTransferDataRelationshipsEventsDataType
from .stock_transfer_data_relationships_line_item import StockTransferDataRelationshipsLineItem
from .stock_transfer_data_relationships_line_item_data import StockTransferDataRelationshipsLineItemData
from .stock_transfer_data_relationships_line_item_data_type import StockTransferDataRelationshipsLineItemDataType
from .stock_transfer_data_relationships_origin_stock_location import StockTransferDataRelationshipsOriginStockLocation
from .stock_transfer_data_relationships_origin_stock_location_data import (
    StockTransferDataRelationshipsOriginStockLocationData,
)
from .stock_transfer_data_relationships_origin_stock_location_data_type import (
    StockTransferDataRelationshipsOriginStockLocationDataType,
)
from .stock_transfer_data_relationships_shipment import StockTransferDataRelationshipsShipment
from .stock_transfer_data_relationships_shipment_data import StockTransferDataRelationshipsShipmentData
from .stock_transfer_data_relationships_shipment_data_type import StockTransferDataRelationshipsShipmentDataType
from .stock_transfer_data_relationships_sku import StockTransferDataRelationshipsSku
from .stock_transfer_data_relationships_sku_data import StockTransferDataRelationshipsSkuData
from .stock_transfer_data_relationships_sku_data_type import StockTransferDataRelationshipsSkuDataType
from .stock_transfer_data_type import StockTransferDataType
from .stock_transfer_update import StockTransferUpdate
from .stock_transfer_update_data import StockTransferUpdateData
from .stock_transfer_update_data_attributes import StockTransferUpdateDataAttributes
from .stock_transfer_update_data_attributes_metadata import StockTransferUpdateDataAttributesMetadata
from .stock_transfer_update_data_relationships import StockTransferUpdateDataRelationships
from .stock_transfer_update_data_relationships_destination_stock_location import (
    StockTransferUpdateDataRelationshipsDestinationStockLocation,
)
from .stock_transfer_update_data_relationships_destination_stock_location_data import (
    StockTransferUpdateDataRelationshipsDestinationStockLocationData,
)
from .stock_transfer_update_data_relationships_destination_stock_location_data_type import (
    StockTransferUpdateDataRelationshipsDestinationStockLocationDataType,
)
from .stock_transfer_update_data_relationships_origin_stock_location import (
    StockTransferUpdateDataRelationshipsOriginStockLocation,
)
from .stock_transfer_update_data_relationships_origin_stock_location_data import (
    StockTransferUpdateDataRelationshipsOriginStockLocationData,
)
from .stock_transfer_update_data_relationships_origin_stock_location_data_type import (
    StockTransferUpdateDataRelationshipsOriginStockLocationDataType,
)
from .stock_transfer_update_data_relationships_sku import StockTransferUpdateDataRelationshipsSku
from .stock_transfer_update_data_relationships_sku_data import StockTransferUpdateDataRelationshipsSkuData
from .stock_transfer_update_data_relationships_sku_data_type import StockTransferUpdateDataRelationshipsSkuDataType
from .stock_transfer_update_data_type import StockTransferUpdateDataType
from .stripe_gateway import StripeGateway
from .stripe_gateway_create import StripeGatewayCreate
from .stripe_gateway_create_data import StripeGatewayCreateData
from .stripe_gateway_create_data_attributes import StripeGatewayCreateDataAttributes
from .stripe_gateway_create_data_attributes_metadata import StripeGatewayCreateDataAttributesMetadata
from .stripe_gateway_create_data_relationships import StripeGatewayCreateDataRelationships
from .stripe_gateway_create_data_type import StripeGatewayCreateDataType
from .stripe_gateway_data import StripeGatewayData
from .stripe_gateway_data_attributes import StripeGatewayDataAttributes
from .stripe_gateway_data_attributes_metadata import StripeGatewayDataAttributesMetadata
from .stripe_gateway_data_relationships import StripeGatewayDataRelationships
from .stripe_gateway_data_relationships_payment_methods import StripeGatewayDataRelationshipsPaymentMethods
from .stripe_gateway_data_relationships_payment_methods_data import StripeGatewayDataRelationshipsPaymentMethodsData
from .stripe_gateway_data_relationships_payment_methods_data_type import (
    StripeGatewayDataRelationshipsPaymentMethodsDataType,
)
from .stripe_gateway_data_relationships_stripe_payments import StripeGatewayDataRelationshipsStripePayments
from .stripe_gateway_data_relationships_stripe_payments_data import StripeGatewayDataRelationshipsStripePaymentsData
from .stripe_gateway_data_relationships_stripe_payments_data_type import (
    StripeGatewayDataRelationshipsStripePaymentsDataType,
)
from .stripe_gateway_data_type import StripeGatewayDataType
from .stripe_gateway_update import StripeGatewayUpdate
from .stripe_gateway_update_data import StripeGatewayUpdateData
from .stripe_gateway_update_data_attributes import StripeGatewayUpdateDataAttributes
from .stripe_gateway_update_data_attributes_metadata import StripeGatewayUpdateDataAttributesMetadata
from .stripe_gateway_update_data_relationships import StripeGatewayUpdateDataRelationships
from .stripe_gateway_update_data_type import StripeGatewayUpdateDataType
from .stripe_payment import StripePayment
from .stripe_payment_create import StripePaymentCreate
from .stripe_payment_create_data import StripePaymentCreateData
from .stripe_payment_create_data_attributes import StripePaymentCreateDataAttributes
from .stripe_payment_create_data_attributes_metadata import StripePaymentCreateDataAttributesMetadata
from .stripe_payment_create_data_attributes_options import StripePaymentCreateDataAttributesOptions
from .stripe_payment_create_data_relationships import StripePaymentCreateDataRelationships
from .stripe_payment_create_data_relationships_order import StripePaymentCreateDataRelationshipsOrder
from .stripe_payment_create_data_relationships_order_data import StripePaymentCreateDataRelationshipsOrderData
from .stripe_payment_create_data_relationships_order_data_type import StripePaymentCreateDataRelationshipsOrderDataType
from .stripe_payment_create_data_type import StripePaymentCreateDataType
from .stripe_payment_data import StripePaymentData
from .stripe_payment_data_attributes import StripePaymentDataAttributes
from .stripe_payment_data_attributes_metadata import StripePaymentDataAttributesMetadata
from .stripe_payment_data_attributes_options import StripePaymentDataAttributesOptions
from .stripe_payment_data_attributes_payment_method import StripePaymentDataAttributesPaymentMethod
from .stripe_payment_data_relationships import StripePaymentDataRelationships
from .stripe_payment_data_relationships_order import StripePaymentDataRelationshipsOrder
from .stripe_payment_data_relationships_order_data import StripePaymentDataRelationshipsOrderData
from .stripe_payment_data_relationships_order_data_type import StripePaymentDataRelationshipsOrderDataType
from .stripe_payment_data_relationships_payment_gateway import StripePaymentDataRelationshipsPaymentGateway
from .stripe_payment_data_relationships_payment_gateway_data import StripePaymentDataRelationshipsPaymentGatewayData
from .stripe_payment_data_relationships_payment_gateway_data_type import (
    StripePaymentDataRelationshipsPaymentGatewayDataType,
)
from .stripe_payment_data_type import StripePaymentDataType
from .stripe_payment_update import StripePaymentUpdate
from .stripe_payment_update_data import StripePaymentUpdateData
from .stripe_payment_update_data_attributes import StripePaymentUpdateDataAttributes
from .stripe_payment_update_data_attributes_metadata import StripePaymentUpdateDataAttributesMetadata
from .stripe_payment_update_data_attributes_options import StripePaymentUpdateDataAttributesOptions
from .stripe_payment_update_data_relationships import StripePaymentUpdateDataRelationships
from .stripe_payment_update_data_relationships_order import StripePaymentUpdateDataRelationshipsOrder
from .stripe_payment_update_data_relationships_order_data import StripePaymentUpdateDataRelationshipsOrderData
from .stripe_payment_update_data_relationships_order_data_type import StripePaymentUpdateDataRelationshipsOrderDataType
from .stripe_payment_update_data_type import StripePaymentUpdateDataType
from .tax_calculator import TaxCalculator
from .tax_calculator_data import TaxCalculatorData
from .tax_calculator_data_attributes import TaxCalculatorDataAttributes
from .tax_calculator_data_attributes_metadata import TaxCalculatorDataAttributesMetadata
from .tax_calculator_data_relationships import TaxCalculatorDataRelationships
from .tax_calculator_data_relationships_attachments import TaxCalculatorDataRelationshipsAttachments
from .tax_calculator_data_relationships_attachments_data import TaxCalculatorDataRelationshipsAttachmentsData
from .tax_calculator_data_relationships_attachments_data_type import TaxCalculatorDataRelationshipsAttachmentsDataType
from .tax_calculator_data_relationships_markets import TaxCalculatorDataRelationshipsMarkets
from .tax_calculator_data_relationships_markets_data import TaxCalculatorDataRelationshipsMarketsData
from .tax_calculator_data_relationships_markets_data_type import TaxCalculatorDataRelationshipsMarketsDataType
from .tax_calculator_data_type import TaxCalculatorDataType
from .tax_category import TaxCategory
from .tax_category_create import TaxCategoryCreate
from .tax_category_create_data import TaxCategoryCreateData
from .tax_category_create_data_attributes import TaxCategoryCreateDataAttributes
from .tax_category_create_data_attributes_metadata import TaxCategoryCreateDataAttributesMetadata
from .tax_category_create_data_relationships import TaxCategoryCreateDataRelationships
from .tax_category_create_data_relationships_sku import TaxCategoryCreateDataRelationshipsSku
from .tax_category_create_data_relationships_sku_data import TaxCategoryCreateDataRelationshipsSkuData
from .tax_category_create_data_relationships_sku_data_type import TaxCategoryCreateDataRelationshipsSkuDataType
from .tax_category_create_data_type import TaxCategoryCreateDataType
from .tax_category_data import TaxCategoryData
from .tax_category_data_attributes import TaxCategoryDataAttributes
from .tax_category_data_attributes_metadata import TaxCategoryDataAttributesMetadata
from .tax_category_data_relationships import TaxCategoryDataRelationships
from .tax_category_data_relationships_attachments import TaxCategoryDataRelationshipsAttachments
from .tax_category_data_relationships_attachments_data import TaxCategoryDataRelationshipsAttachmentsData
from .tax_category_data_relationships_attachments_data_type import TaxCategoryDataRelationshipsAttachmentsDataType
from .tax_category_data_relationships_sku import TaxCategoryDataRelationshipsSku
from .tax_category_data_relationships_sku_data import TaxCategoryDataRelationshipsSkuData
from .tax_category_data_relationships_sku_data_type import TaxCategoryDataRelationshipsSkuDataType
from .tax_category_data_type import TaxCategoryDataType
from .tax_category_update import TaxCategoryUpdate
from .tax_category_update_data import TaxCategoryUpdateData
from .tax_category_update_data_attributes import TaxCategoryUpdateDataAttributes
from .tax_category_update_data_attributes_metadata import TaxCategoryUpdateDataAttributesMetadata
from .tax_category_update_data_relationships import TaxCategoryUpdateDataRelationships
from .tax_category_update_data_relationships_sku import TaxCategoryUpdateDataRelationshipsSku
from .tax_category_update_data_relationships_sku_data import TaxCategoryUpdateDataRelationshipsSkuData
from .tax_category_update_data_relationships_sku_data_type import TaxCategoryUpdateDataRelationshipsSkuDataType
from .tax_category_update_data_type import TaxCategoryUpdateDataType
from .tax_rule import TaxRule
from .tax_rule_create import TaxRuleCreate
from .tax_rule_create_data import TaxRuleCreateData
from .tax_rule_create_data_attributes import TaxRuleCreateDataAttributes
from .tax_rule_create_data_attributes_metadata import TaxRuleCreateDataAttributesMetadata
from .tax_rule_create_data_relationships import TaxRuleCreateDataRelationships
from .tax_rule_create_data_relationships_manual_tax_calculator import TaxRuleCreateDataRelationshipsManualTaxCalculator
from .tax_rule_create_data_relationships_manual_tax_calculator_data import (
    TaxRuleCreateDataRelationshipsManualTaxCalculatorData,
)
from .tax_rule_create_data_relationships_manual_tax_calculator_data_type import (
    TaxRuleCreateDataRelationshipsManualTaxCalculatorDataType,
)
from .tax_rule_create_data_type import TaxRuleCreateDataType
from .tax_rule_data import TaxRuleData
from .tax_rule_data_attributes import TaxRuleDataAttributes
from .tax_rule_data_attributes_breakdown import TaxRuleDataAttributesBreakdown
from .tax_rule_data_attributes_metadata import TaxRuleDataAttributesMetadata
from .tax_rule_data_relationships import TaxRuleDataRelationships
from .tax_rule_data_relationships_manual_tax_calculator import TaxRuleDataRelationshipsManualTaxCalculator
from .tax_rule_data_relationships_manual_tax_calculator_data import TaxRuleDataRelationshipsManualTaxCalculatorData
from .tax_rule_data_relationships_manual_tax_calculator_data_type import (
    TaxRuleDataRelationshipsManualTaxCalculatorDataType,
)
from .tax_rule_data_type import TaxRuleDataType
from .tax_rule_update import TaxRuleUpdate
from .tax_rule_update_data import TaxRuleUpdateData
from .tax_rule_update_data_attributes import TaxRuleUpdateDataAttributes
from .tax_rule_update_data_attributes_metadata import TaxRuleUpdateDataAttributesMetadata
from .tax_rule_update_data_relationships import TaxRuleUpdateDataRelationships
from .tax_rule_update_data_relationships_manual_tax_calculator import TaxRuleUpdateDataRelationshipsManualTaxCalculator
from .tax_rule_update_data_relationships_manual_tax_calculator_data import (
    TaxRuleUpdateDataRelationshipsManualTaxCalculatorData,
)
from .tax_rule_update_data_relationships_manual_tax_calculator_data_type import (
    TaxRuleUpdateDataRelationshipsManualTaxCalculatorDataType,
)
from .tax_rule_update_data_type import TaxRuleUpdateDataType
from .taxjar_account import TaxjarAccount
from .taxjar_account_create import TaxjarAccountCreate
from .taxjar_account_create_data import TaxjarAccountCreateData
from .taxjar_account_create_data_attributes import TaxjarAccountCreateDataAttributes
from .taxjar_account_create_data_attributes_metadata import TaxjarAccountCreateDataAttributesMetadata
from .taxjar_account_create_data_relationships import TaxjarAccountCreateDataRelationships
from .taxjar_account_create_data_relationships_tax_categories import TaxjarAccountCreateDataRelationshipsTaxCategories
from .taxjar_account_create_data_relationships_tax_categories_data import (
    TaxjarAccountCreateDataRelationshipsTaxCategoriesData,
)
from .taxjar_account_create_data_relationships_tax_categories_data_type import (
    TaxjarAccountCreateDataRelationshipsTaxCategoriesDataType,
)
from .taxjar_account_create_data_type import TaxjarAccountCreateDataType
from .taxjar_account_data import TaxjarAccountData
from .taxjar_account_data_attributes import TaxjarAccountDataAttributes
from .taxjar_account_data_attributes_metadata import TaxjarAccountDataAttributesMetadata
from .taxjar_account_data_relationships import TaxjarAccountDataRelationships
from .taxjar_account_data_relationships_attachments import TaxjarAccountDataRelationshipsAttachments
from .taxjar_account_data_relationships_attachments_data import TaxjarAccountDataRelationshipsAttachmentsData
from .taxjar_account_data_relationships_attachments_data_type import TaxjarAccountDataRelationshipsAttachmentsDataType
from .taxjar_account_data_relationships_markets import TaxjarAccountDataRelationshipsMarkets
from .taxjar_account_data_relationships_markets_data import TaxjarAccountDataRelationshipsMarketsData
from .taxjar_account_data_relationships_markets_data_type import TaxjarAccountDataRelationshipsMarketsDataType
from .taxjar_account_data_relationships_tax_categories import TaxjarAccountDataRelationshipsTaxCategories
from .taxjar_account_data_relationships_tax_categories_data import TaxjarAccountDataRelationshipsTaxCategoriesData
from .taxjar_account_data_relationships_tax_categories_data_type import (
    TaxjarAccountDataRelationshipsTaxCategoriesDataType,
)
from .taxjar_account_data_type import TaxjarAccountDataType
from .taxjar_account_update import TaxjarAccountUpdate
from .taxjar_account_update_data import TaxjarAccountUpdateData
from .taxjar_account_update_data_attributes import TaxjarAccountUpdateDataAttributes
from .taxjar_account_update_data_attributes_metadata import TaxjarAccountUpdateDataAttributesMetadata
from .taxjar_account_update_data_relationships import TaxjarAccountUpdateDataRelationships
from .taxjar_account_update_data_relationships_tax_categories import TaxjarAccountUpdateDataRelationshipsTaxCategories
from .taxjar_account_update_data_relationships_tax_categories_data import (
    TaxjarAccountUpdateDataRelationshipsTaxCategoriesData,
)
from .taxjar_account_update_data_relationships_tax_categories_data_type import (
    TaxjarAccountUpdateDataRelationshipsTaxCategoriesDataType,
)
from .taxjar_account_update_data_type import TaxjarAccountUpdateDataType
from .transaction import Transaction
from .transaction_data import TransactionData
from .transaction_data_attributes import TransactionDataAttributes
from .transaction_data_attributes_metadata import TransactionDataAttributesMetadata
from .transaction_data_relationships import TransactionDataRelationships
from .transaction_data_relationships_order import TransactionDataRelationshipsOrder
from .transaction_data_relationships_order_data import TransactionDataRelationshipsOrderData
from .transaction_data_relationships_order_data_type import TransactionDataRelationshipsOrderDataType
from .transaction_data_type import TransactionDataType
from .void import Void
from .void_data import VoidData
from .void_data_attributes import VoidDataAttributes
from .void_data_attributes_metadata import VoidDataAttributesMetadata
from .void_data_relationships import VoidDataRelationships
from .void_data_relationships_order import VoidDataRelationshipsOrder
from .void_data_relationships_order_data import VoidDataRelationshipsOrderData
from .void_data_relationships_order_data_type import VoidDataRelationshipsOrderDataType
from .void_data_relationships_reference_authorization import VoidDataRelationshipsReferenceAuthorization
from .void_data_relationships_reference_authorization_data import VoidDataRelationshipsReferenceAuthorizationData
from .void_data_relationships_reference_authorization_data_type import (
    VoidDataRelationshipsReferenceAuthorizationDataType,
)
from .void_data_type import VoidDataType
from .webhook import Webhook
from .webhook_create import WebhookCreate
from .webhook_create_data import WebhookCreateData
from .webhook_create_data_attributes import WebhookCreateDataAttributes
from .webhook_create_data_attributes_metadata import WebhookCreateDataAttributesMetadata
from .webhook_create_data_relationships import WebhookCreateDataRelationships
from .webhook_create_data_type import WebhookCreateDataType
from .webhook_data import WebhookData
from .webhook_data_attributes import WebhookDataAttributes
from .webhook_data_attributes_metadata import WebhookDataAttributesMetadata
from .webhook_data_relationships import WebhookDataRelationships
from .webhook_data_relationships_last_event_callbacks import WebhookDataRelationshipsLastEventCallbacks
from .webhook_data_relationships_last_event_callbacks_data import WebhookDataRelationshipsLastEventCallbacksData
from .webhook_data_relationships_last_event_callbacks_data_type import (
    WebhookDataRelationshipsLastEventCallbacksDataType,
)
from .webhook_data_type import WebhookDataType
from .webhook_update import WebhookUpdate
from .webhook_update_data import WebhookUpdateData
from .webhook_update_data_attributes import WebhookUpdateDataAttributes
from .webhook_update_data_attributes_metadata import WebhookUpdateDataAttributesMetadata
from .webhook_update_data_relationships import WebhookUpdateDataRelationships
from .webhook_update_data_type import WebhookUpdateDataType
from .wire_transfer import WireTransfer
from .wire_transfer_create import WireTransferCreate
from .wire_transfer_create_data import WireTransferCreateData
from .wire_transfer_create_data_attributes import WireTransferCreateDataAttributes
from .wire_transfer_create_data_attributes_metadata import WireTransferCreateDataAttributesMetadata
from .wire_transfer_create_data_relationships import WireTransferCreateDataRelationships
from .wire_transfer_create_data_relationships_order import WireTransferCreateDataRelationshipsOrder
from .wire_transfer_create_data_relationships_order_data import WireTransferCreateDataRelationshipsOrderData
from .wire_transfer_create_data_relationships_order_data_type import WireTransferCreateDataRelationshipsOrderDataType
from .wire_transfer_create_data_type import WireTransferCreateDataType
from .wire_transfer_data import WireTransferData
from .wire_transfer_data_attributes import WireTransferDataAttributes
from .wire_transfer_data_attributes_metadata import WireTransferDataAttributesMetadata
from .wire_transfer_data_relationships import WireTransferDataRelationships
from .wire_transfer_data_relationships_order import WireTransferDataRelationshipsOrder
from .wire_transfer_data_relationships_order_data import WireTransferDataRelationshipsOrderData
from .wire_transfer_data_relationships_order_data_type import WireTransferDataRelationshipsOrderDataType
from .wire_transfer_data_type import WireTransferDataType
from .wire_transfer_update import WireTransferUpdate
from .wire_transfer_update_data import WireTransferUpdateData
from .wire_transfer_update_data_attributes import WireTransferUpdateDataAttributes
from .wire_transfer_update_data_attributes_metadata import WireTransferUpdateDataAttributesMetadata
from .wire_transfer_update_data_relationships import WireTransferUpdateDataRelationships
from .wire_transfer_update_data_relationships_order import WireTransferUpdateDataRelationshipsOrder
from .wire_transfer_update_data_relationships_order_data import WireTransferUpdateDataRelationshipsOrderData
from .wire_transfer_update_data_relationships_order_data_type import WireTransferUpdateDataRelationshipsOrderDataType
from .wire_transfer_update_data_type import WireTransferUpdateDataType

__all__ = (
    "Address",
    "AddressCreate",
    "AddressCreateData",
    "AddressCreateDataAttributes",
    "AddressCreateDataAttributesMetadata",
    "AddressCreateDataRelationships",
    "AddressCreateDataRelationshipsGeocoder",
    "AddressCreateDataRelationshipsGeocoderData",
    "AddressCreateDataRelationshipsGeocoderDataType",
    "AddressCreateDataType",
    "AddressData",
    "AddressDataAttributes",
    "AddressDataAttributesMetadata",
    "AddressDataRelationships",
    "AddressDataRelationshipsGeocoder",
    "AddressDataRelationshipsGeocoderData",
    "AddressDataRelationshipsGeocoderDataType",
    "AddressDataType",
    "AddressUpdate",
    "AddressUpdateData",
    "AddressUpdateDataAttributes",
    "AddressUpdateDataAttributesMetadata",
    "AddressUpdateDataRelationships",
    "AddressUpdateDataRelationshipsGeocoder",
    "AddressUpdateDataRelationshipsGeocoderData",
    "AddressUpdateDataRelationshipsGeocoderDataType",
    "AddressUpdateDataType",
    "Adjustment",
    "AdjustmentCreate",
    "AdjustmentCreateData",
    "AdjustmentCreateDataAttributes",
    "AdjustmentCreateDataAttributesMetadata",
    "AdjustmentCreateDataRelationships",
    "AdjustmentCreateDataType",
    "AdjustmentData",
    "AdjustmentDataAttributes",
    "AdjustmentDataAttributesMetadata",
    "AdjustmentDataRelationships",
    "AdjustmentDataType",
    "AdjustmentUpdate",
    "AdjustmentUpdateData",
    "AdjustmentUpdateDataAttributes",
    "AdjustmentUpdateDataAttributesMetadata",
    "AdjustmentUpdateDataRelationships",
    "AdjustmentUpdateDataType",
    "AdyenGateway",
    "AdyenGatewayCreate",
    "AdyenGatewayCreateData",
    "AdyenGatewayCreateDataAttributes",
    "AdyenGatewayCreateDataAttributesMetadata",
    "AdyenGatewayCreateDataRelationships",
    "AdyenGatewayCreateDataRelationshipsAdyenPayments",
    "AdyenGatewayCreateDataRelationshipsAdyenPaymentsData",
    "AdyenGatewayCreateDataRelationshipsAdyenPaymentsDataType",
    "AdyenGatewayCreateDataType",
    "AdyenGatewayData",
    "AdyenGatewayDataAttributes",
    "AdyenGatewayDataAttributesMetadata",
    "AdyenGatewayDataRelationships",
    "AdyenGatewayDataRelationshipsAdyenPayments",
    "AdyenGatewayDataRelationshipsAdyenPaymentsData",
    "AdyenGatewayDataRelationshipsAdyenPaymentsDataType",
    "AdyenGatewayDataRelationshipsPaymentMethods",
    "AdyenGatewayDataRelationshipsPaymentMethodsData",
    "AdyenGatewayDataRelationshipsPaymentMethodsDataType",
    "AdyenGatewayDataType",
    "AdyenGatewayUpdate",
    "AdyenGatewayUpdateData",
    "AdyenGatewayUpdateDataAttributes",
    "AdyenGatewayUpdateDataAttributesMetadata",
    "AdyenGatewayUpdateDataRelationships",
    "AdyenGatewayUpdateDataRelationshipsAdyenPayments",
    "AdyenGatewayUpdateDataRelationshipsAdyenPaymentsData",
    "AdyenGatewayUpdateDataRelationshipsAdyenPaymentsDataType",
    "AdyenGatewayUpdateDataType",
    "AdyenPayment",
    "AdyenPaymentCreate",
    "AdyenPaymentCreateData",
    "AdyenPaymentCreateDataAttributes",
    "AdyenPaymentCreateDataAttributesMetadata",
    "AdyenPaymentCreateDataRelationships",
    "AdyenPaymentCreateDataRelationshipsOrder",
    "AdyenPaymentCreateDataRelationshipsOrderData",
    "AdyenPaymentCreateDataRelationshipsOrderDataType",
    "AdyenPaymentCreateDataType",
    "AdyenPaymentData",
    "AdyenPaymentDataAttributes",
    "AdyenPaymentDataAttributesMetadata",
    "AdyenPaymentDataAttributesPaymentMethods",
    "AdyenPaymentDataAttributesPaymentRequestData",
    "AdyenPaymentDataAttributesPaymentRequestDetails",
    "AdyenPaymentDataAttributesPaymentResponse",
    "AdyenPaymentDataRelationships",
    "AdyenPaymentDataRelationshipsOrder",
    "AdyenPaymentDataRelationshipsOrderData",
    "AdyenPaymentDataRelationshipsOrderDataType",
    "AdyenPaymentDataRelationshipsPaymentGateway",
    "AdyenPaymentDataRelationshipsPaymentGatewayData",
    "AdyenPaymentDataRelationshipsPaymentGatewayDataType",
    "AdyenPaymentDataType",
    "AdyenPaymentUpdate",
    "AdyenPaymentUpdateData",
    "AdyenPaymentUpdateDataAttributes",
    "AdyenPaymentUpdateDataAttributesMetadata",
    "AdyenPaymentUpdateDataAttributesPaymentRequestData",
    "AdyenPaymentUpdateDataAttributesPaymentRequestDetails",
    "AdyenPaymentUpdateDataAttributesPaymentResponse",
    "AdyenPaymentUpdateDataRelationships",
    "AdyenPaymentUpdateDataRelationshipsOrder",
    "AdyenPaymentUpdateDataRelationshipsOrderData",
    "AdyenPaymentUpdateDataRelationshipsOrderDataType",
    "AdyenPaymentUpdateDataType",
    "Application",
    "ApplicationData",
    "ApplicationDataAttributes",
    "ApplicationDataAttributesMetadata",
    "ApplicationDataRelationships",
    "ApplicationDataType",
    "Attachment",
    "AttachmentCreate",
    "AttachmentCreateData",
    "AttachmentCreateDataAttributes",
    "AttachmentCreateDataAttributesMetadata",
    "AttachmentCreateDataRelationships",
    "AttachmentCreateDataType",
    "AttachmentData",
    "AttachmentDataAttributes",
    "AttachmentDataAttributesMetadata",
    "AttachmentDataRelationships",
    "AttachmentDataType",
    "AttachmentUpdate",
    "AttachmentUpdateData",
    "AttachmentUpdateDataAttributes",
    "AttachmentUpdateDataAttributesMetadata",
    "AttachmentUpdateDataRelationships",
    "AttachmentUpdateDataType",
    "Authorization",
    "AuthorizationData",
    "AuthorizationDataAttributes",
    "AuthorizationDataAttributesMetadata",
    "AuthorizationDataRelationships",
    "AuthorizationDataRelationshipsCaptures",
    "AuthorizationDataRelationshipsCapturesData",
    "AuthorizationDataRelationshipsCapturesDataType",
    "AuthorizationDataRelationshipsOrder",
    "AuthorizationDataRelationshipsOrderData",
    "AuthorizationDataRelationshipsOrderDataType",
    "AuthorizationDataRelationshipsVoids",
    "AuthorizationDataRelationshipsVoidsData",
    "AuthorizationDataRelationshipsVoidsDataType",
    "AuthorizationDataType",
    "AuthorizationUpdate",
    "AuthorizationUpdateData",
    "AuthorizationUpdateDataAttributes",
    "AuthorizationUpdateDataAttributesMetadata",
    "AuthorizationUpdateDataRelationships",
    "AuthorizationUpdateDataType",
    "AvalaraAccount",
    "AvalaraAccountCreate",
    "AvalaraAccountCreateData",
    "AvalaraAccountCreateDataAttributes",
    "AvalaraAccountCreateDataAttributesMetadata",
    "AvalaraAccountCreateDataRelationships",
    "AvalaraAccountCreateDataRelationshipsTaxCategories",
    "AvalaraAccountCreateDataRelationshipsTaxCategoriesData",
    "AvalaraAccountCreateDataRelationshipsTaxCategoriesDataType",
    "AvalaraAccountCreateDataType",
    "AvalaraAccountData",
    "AvalaraAccountDataAttributes",
    "AvalaraAccountDataAttributesMetadata",
    "AvalaraAccountDataRelationships",
    "AvalaraAccountDataRelationshipsAttachments",
    "AvalaraAccountDataRelationshipsAttachmentsData",
    "AvalaraAccountDataRelationshipsAttachmentsDataType",
    "AvalaraAccountDataRelationshipsMarkets",
    "AvalaraAccountDataRelationshipsMarketsData",
    "AvalaraAccountDataRelationshipsMarketsDataType",
    "AvalaraAccountDataRelationshipsTaxCategories",
    "AvalaraAccountDataRelationshipsTaxCategoriesData",
    "AvalaraAccountDataRelationshipsTaxCategoriesDataType",
    "AvalaraAccountDataType",
    "AvalaraAccountUpdate",
    "AvalaraAccountUpdateData",
    "AvalaraAccountUpdateDataAttributes",
    "AvalaraAccountUpdateDataAttributesMetadata",
    "AvalaraAccountUpdateDataRelationships",
    "AvalaraAccountUpdateDataRelationshipsTaxCategories",
    "AvalaraAccountUpdateDataRelationshipsTaxCategoriesData",
    "AvalaraAccountUpdateDataRelationshipsTaxCategoriesDataType",
    "AvalaraAccountUpdateDataType",
    "BillingInfoValidationRule",
    "BillingInfoValidationRuleCreate",
    "BillingInfoValidationRuleCreateData",
    "BillingInfoValidationRuleCreateDataAttributes",
    "BillingInfoValidationRuleCreateDataAttributesMetadata",
    "BillingInfoValidationRuleCreateDataRelationships",
    "BillingInfoValidationRuleCreateDataRelationshipsMarket",
    "BillingInfoValidationRuleCreateDataRelationshipsMarketData",
    "BillingInfoValidationRuleCreateDataRelationshipsMarketDataType",
    "BillingInfoValidationRuleCreateDataType",
    "BillingInfoValidationRuleData",
    "BillingInfoValidationRuleDataAttributes",
    "BillingInfoValidationRuleDataAttributesMetadata",
    "BillingInfoValidationRuleDataRelationships",
    "BillingInfoValidationRuleDataRelationshipsMarket",
    "BillingInfoValidationRuleDataRelationshipsMarketData",
    "BillingInfoValidationRuleDataRelationshipsMarketDataType",
    "BillingInfoValidationRuleDataType",
    "BillingInfoValidationRuleUpdate",
    "BillingInfoValidationRuleUpdateData",
    "BillingInfoValidationRuleUpdateDataAttributes",
    "BillingInfoValidationRuleUpdateDataAttributesMetadata",
    "BillingInfoValidationRuleUpdateDataRelationships",
    "BillingInfoValidationRuleUpdateDataRelationshipsMarket",
    "BillingInfoValidationRuleUpdateDataRelationshipsMarketData",
    "BillingInfoValidationRuleUpdateDataRelationshipsMarketDataType",
    "BillingInfoValidationRuleUpdateDataType",
    "BingGeocoder",
    "BingGeocoderCreate",
    "BingGeocoderCreateData",
    "BingGeocoderCreateDataAttributes",
    "BingGeocoderCreateDataAttributesMetadata",
    "BingGeocoderCreateDataRelationships",
    "BingGeocoderCreateDataType",
    "BingGeocoderData",
    "BingGeocoderDataAttributes",
    "BingGeocoderDataAttributesMetadata",
    "BingGeocoderDataRelationships",
    "BingGeocoderDataRelationshipsAddresses",
    "BingGeocoderDataRelationshipsAddressesData",
    "BingGeocoderDataRelationshipsAddressesDataType",
    "BingGeocoderDataRelationshipsAttachments",
    "BingGeocoderDataRelationshipsAttachmentsData",
    "BingGeocoderDataRelationshipsAttachmentsDataType",
    "BingGeocoderDataType",
    "BingGeocoderUpdate",
    "BingGeocoderUpdateData",
    "BingGeocoderUpdateDataAttributes",
    "BingGeocoderUpdateDataAttributesMetadata",
    "BingGeocoderUpdateDataRelationships",
    "BingGeocoderUpdateDataType",
    "BraintreeGateway",
    "BraintreeGatewayCreate",
    "BraintreeGatewayCreateData",
    "BraintreeGatewayCreateDataAttributes",
    "BraintreeGatewayCreateDataAttributesMetadata",
    "BraintreeGatewayCreateDataRelationships",
    "BraintreeGatewayCreateDataRelationshipsBraintreePayments",
    "BraintreeGatewayCreateDataRelationshipsBraintreePaymentsData",
    "BraintreeGatewayCreateDataRelationshipsBraintreePaymentsDataType",
    "BraintreeGatewayCreateDataType",
    "BraintreeGatewayData",
    "BraintreeGatewayDataAttributes",
    "BraintreeGatewayDataAttributesMetadata",
    "BraintreeGatewayDataRelationships",
    "BraintreeGatewayDataRelationshipsBraintreePayments",
    "BraintreeGatewayDataRelationshipsBraintreePaymentsData",
    "BraintreeGatewayDataRelationshipsBraintreePaymentsDataType",
    "BraintreeGatewayDataRelationshipsPaymentMethods",
    "BraintreeGatewayDataRelationshipsPaymentMethodsData",
    "BraintreeGatewayDataRelationshipsPaymentMethodsDataType",
    "BraintreeGatewayDataType",
    "BraintreeGatewayUpdate",
    "BraintreeGatewayUpdateData",
    "BraintreeGatewayUpdateDataAttributes",
    "BraintreeGatewayUpdateDataAttributesMetadata",
    "BraintreeGatewayUpdateDataRelationships",
    "BraintreeGatewayUpdateDataRelationshipsBraintreePayments",
    "BraintreeGatewayUpdateDataRelationshipsBraintreePaymentsData",
    "BraintreeGatewayUpdateDataRelationshipsBraintreePaymentsDataType",
    "BraintreeGatewayUpdateDataType",
    "BraintreePayment",
    "BraintreePaymentCreate",
    "BraintreePaymentCreateData",
    "BraintreePaymentCreateDataAttributes",
    "BraintreePaymentCreateDataAttributesMetadata",
    "BraintreePaymentCreateDataAttributesOptions",
    "BraintreePaymentCreateDataRelationships",
    "BraintreePaymentCreateDataRelationshipsOrder",
    "BraintreePaymentCreateDataRelationshipsOrderData",
    "BraintreePaymentCreateDataRelationshipsOrderDataType",
    "BraintreePaymentCreateDataType",
    "BraintreePaymentData",
    "BraintreePaymentDataAttributes",
    "BraintreePaymentDataAttributesMetadata",
    "BraintreePaymentDataAttributesOptions",
    "BraintreePaymentDataRelationships",
    "BraintreePaymentDataRelationshipsOrder",
    "BraintreePaymentDataRelationshipsOrderData",
    "BraintreePaymentDataRelationshipsOrderDataType",
    "BraintreePaymentDataRelationshipsPaymentGateway",
    "BraintreePaymentDataRelationshipsPaymentGatewayData",
    "BraintreePaymentDataRelationshipsPaymentGatewayDataType",
    "BraintreePaymentDataType",
    "BraintreePaymentUpdate",
    "BraintreePaymentUpdateData",
    "BraintreePaymentUpdateDataAttributes",
    "BraintreePaymentUpdateDataAttributesMetadata",
    "BraintreePaymentUpdateDataAttributesOptions",
    "BraintreePaymentUpdateDataRelationships",
    "BraintreePaymentUpdateDataRelationshipsOrder",
    "BraintreePaymentUpdateDataRelationshipsOrderData",
    "BraintreePaymentUpdateDataRelationshipsOrderDataType",
    "BraintreePaymentUpdateDataType",
    "Bundle",
    "BundleCreate",
    "BundleCreateData",
    "BundleCreateDataAttributes",
    "BundleCreateDataAttributesMetadata",
    "BundleCreateDataRelationships",
    "BundleCreateDataRelationshipsMarket",
    "BundleCreateDataRelationshipsMarketData",
    "BundleCreateDataRelationshipsMarketDataType",
    "BundleCreateDataRelationshipsSkuList",
    "BundleCreateDataRelationshipsSkuListData",
    "BundleCreateDataRelationshipsSkuListDataType",
    "BundleCreateDataType",
    "BundleData",
    "BundleDataAttributes",
    "BundleDataAttributesMetadata",
    "BundleDataRelationships",
    "BundleDataRelationshipsAttachments",
    "BundleDataRelationshipsAttachmentsData",
    "BundleDataRelationshipsAttachmentsDataType",
    "BundleDataRelationshipsMarket",
    "BundleDataRelationshipsMarketData",
    "BundleDataRelationshipsMarketDataType",
    "BundleDataRelationshipsSkuList",
    "BundleDataRelationshipsSkuListData",
    "BundleDataRelationshipsSkuListDataType",
    "BundleDataRelationshipsSkus",
    "BundleDataRelationshipsSkusData",
    "BundleDataRelationshipsSkusDataType",
    "BundleDataType",
    "BundleUpdate",
    "BundleUpdateData",
    "BundleUpdateDataAttributes",
    "BundleUpdateDataAttributesMetadata",
    "BundleUpdateDataRelationships",
    "BundleUpdateDataType",
    "Capture",
    "CaptureData",
    "CaptureDataAttributes",
    "CaptureDataAttributesMetadata",
    "CaptureDataRelationships",
    "CaptureDataRelationshipsOrder",
    "CaptureDataRelationshipsOrderData",
    "CaptureDataRelationshipsOrderDataType",
    "CaptureDataRelationshipsReferenceAuthorization",
    "CaptureDataRelationshipsReferenceAuthorizationData",
    "CaptureDataRelationshipsReferenceAuthorizationDataType",
    "CaptureDataRelationshipsRefunds",
    "CaptureDataRelationshipsRefundsData",
    "CaptureDataRelationshipsRefundsDataType",
    "CaptureDataType",
    "CaptureUpdate",
    "CaptureUpdateData",
    "CaptureUpdateDataAttributes",
    "CaptureUpdateDataAttributesMetadata",
    "CaptureUpdateDataRelationships",
    "CaptureUpdateDataType",
    "CarrierAccount",
    "CarrierAccountData",
    "CarrierAccountDataAttributes",
    "CarrierAccountDataAttributesMetadata",
    "CarrierAccountDataRelationships",
    "CarrierAccountDataRelationshipsAttachments",
    "CarrierAccountDataRelationshipsAttachmentsData",
    "CarrierAccountDataRelationshipsAttachmentsDataType",
    "CarrierAccountDataRelationshipsMarket",
    "CarrierAccountDataRelationshipsMarketData",
    "CarrierAccountDataRelationshipsMarketDataType",
    "CarrierAccountDataType",
    "CheckoutComGateway",
    "CheckoutComGatewayCreate",
    "CheckoutComGatewayCreateData",
    "CheckoutComGatewayCreateDataAttributes",
    "CheckoutComGatewayCreateDataAttributesMetadata",
    "CheckoutComGatewayCreateDataRelationships",
    "CheckoutComGatewayCreateDataRelationshipsCheckoutComPayments",
    "CheckoutComGatewayCreateDataRelationshipsCheckoutComPaymentsData",
    "CheckoutComGatewayCreateDataRelationshipsCheckoutComPaymentsDataType",
    "CheckoutComGatewayCreateDataType",
    "CheckoutComGatewayData",
    "CheckoutComGatewayDataAttributes",
    "CheckoutComGatewayDataAttributesMetadata",
    "CheckoutComGatewayDataRelationships",
    "CheckoutComGatewayDataRelationshipsCheckoutComPayments",
    "CheckoutComGatewayDataRelationshipsCheckoutComPaymentsData",
    "CheckoutComGatewayDataRelationshipsCheckoutComPaymentsDataType",
    "CheckoutComGatewayDataRelationshipsPaymentMethods",
    "CheckoutComGatewayDataRelationshipsPaymentMethodsData",
    "CheckoutComGatewayDataRelationshipsPaymentMethodsDataType",
    "CheckoutComGatewayDataType",
    "CheckoutComGatewayUpdate",
    "CheckoutComGatewayUpdateData",
    "CheckoutComGatewayUpdateDataAttributes",
    "CheckoutComGatewayUpdateDataAttributesMetadata",
    "CheckoutComGatewayUpdateDataRelationships",
    "CheckoutComGatewayUpdateDataRelationshipsCheckoutComPayments",
    "CheckoutComGatewayUpdateDataRelationshipsCheckoutComPaymentsData",
    "CheckoutComGatewayUpdateDataRelationshipsCheckoutComPaymentsDataType",
    "CheckoutComGatewayUpdateDataType",
    "CheckoutComPayment",
    "CheckoutComPaymentCreate",
    "CheckoutComPaymentCreateData",
    "CheckoutComPaymentCreateDataAttributes",
    "CheckoutComPaymentCreateDataAttributesMetadata",
    "CheckoutComPaymentCreateDataRelationships",
    "CheckoutComPaymentCreateDataRelationshipsOrder",
    "CheckoutComPaymentCreateDataRelationshipsOrderData",
    "CheckoutComPaymentCreateDataRelationshipsOrderDataType",
    "CheckoutComPaymentCreateDataType",
    "CheckoutComPaymentData",
    "CheckoutComPaymentDataAttributes",
    "CheckoutComPaymentDataAttributesMetadata",
    "CheckoutComPaymentDataAttributesPaymentResponse",
    "CheckoutComPaymentDataRelationships",
    "CheckoutComPaymentDataRelationshipsOrder",
    "CheckoutComPaymentDataRelationshipsOrderData",
    "CheckoutComPaymentDataRelationshipsOrderDataType",
    "CheckoutComPaymentDataRelationshipsPaymentGateway",
    "CheckoutComPaymentDataRelationshipsPaymentGatewayData",
    "CheckoutComPaymentDataRelationshipsPaymentGatewayDataType",
    "CheckoutComPaymentDataType",
    "CheckoutComPaymentUpdate",
    "CheckoutComPaymentUpdateData",
    "CheckoutComPaymentUpdateDataAttributes",
    "CheckoutComPaymentUpdateDataAttributesMetadata",
    "CheckoutComPaymentUpdateDataRelationships",
    "CheckoutComPaymentUpdateDataRelationshipsOrder",
    "CheckoutComPaymentUpdateDataRelationshipsOrderData",
    "CheckoutComPaymentUpdateDataRelationshipsOrderDataType",
    "CheckoutComPaymentUpdateDataType",
    "Cleanup",
    "CleanupCreate",
    "CleanupCreateData",
    "CleanupCreateDataAttributes",
    "CleanupCreateDataAttributesFilters",
    "CleanupCreateDataAttributesMetadata",
    "CleanupCreateDataRelationships",
    "CleanupCreateDataType",
    "CleanupData",
    "CleanupDataAttributes",
    "CleanupDataAttributesErrorsLog",
    "CleanupDataAttributesFilters",
    "CleanupDataAttributesMetadata",
    "CleanupDataRelationships",
    "CleanupDataRelationshipsEvents",
    "CleanupDataRelationshipsEventsData",
    "CleanupDataRelationshipsEventsDataType",
    "CleanupDataType",
    "Coupon",
    "CouponCodesPromotionRule",
    "CouponCodesPromotionRuleCreate",
    "CouponCodesPromotionRuleCreateData",
    "CouponCodesPromotionRuleCreateDataAttributes",
    "CouponCodesPromotionRuleCreateDataAttributesMetadata",
    "CouponCodesPromotionRuleCreateDataRelationships",
    "CouponCodesPromotionRuleCreateDataRelationshipsCoupons",
    "CouponCodesPromotionRuleCreateDataRelationshipsCouponsData",
    "CouponCodesPromotionRuleCreateDataRelationshipsCouponsDataType",
    "CouponCodesPromotionRuleCreateDataType",
    "CouponCodesPromotionRuleData",
    "CouponCodesPromotionRuleDataAttributes",
    "CouponCodesPromotionRuleDataAttributesMetadata",
    "CouponCodesPromotionRuleDataRelationships",
    "CouponCodesPromotionRuleDataRelationshipsCoupons",
    "CouponCodesPromotionRuleDataRelationshipsCouponsData",
    "CouponCodesPromotionRuleDataRelationshipsCouponsDataType",
    "CouponCodesPromotionRuleDataType",
    "CouponCodesPromotionRuleUpdate",
    "CouponCodesPromotionRuleUpdateData",
    "CouponCodesPromotionRuleUpdateDataAttributes",
    "CouponCodesPromotionRuleUpdateDataAttributesMetadata",
    "CouponCodesPromotionRuleUpdateDataRelationships",
    "CouponCodesPromotionRuleUpdateDataRelationshipsCoupons",
    "CouponCodesPromotionRuleUpdateDataRelationshipsCouponsData",
    "CouponCodesPromotionRuleUpdateDataRelationshipsCouponsDataType",
    "CouponCodesPromotionRuleUpdateDataType",
    "CouponCreate",
    "CouponCreateData",
    "CouponCreateDataAttributes",
    "CouponCreateDataAttributesMetadata",
    "CouponCreateDataRelationships",
    "CouponCreateDataRelationshipsPromotionRule",
    "CouponCreateDataRelationshipsPromotionRuleData",
    "CouponCreateDataRelationshipsPromotionRuleDataType",
    "CouponCreateDataType",
    "CouponData",
    "CouponDataAttributes",
    "CouponDataAttributesMetadata",
    "CouponDataRelationships",
    "CouponDataRelationshipsPromotionRule",
    "CouponDataRelationshipsPromotionRuleData",
    "CouponDataRelationshipsPromotionRuleDataType",
    "CouponDataType",
    "CouponRecipient",
    "CouponRecipientCreate",
    "CouponRecipientCreateData",
    "CouponRecipientCreateDataAttributes",
    "CouponRecipientCreateDataAttributesMetadata",
    "CouponRecipientCreateDataRelationships",
    "CouponRecipientCreateDataRelationshipsCustomer",
    "CouponRecipientCreateDataRelationshipsCustomerData",
    "CouponRecipientCreateDataRelationshipsCustomerDataType",
    "CouponRecipientCreateDataType",
    "CouponRecipientData",
    "CouponRecipientDataAttributes",
    "CouponRecipientDataAttributesMetadata",
    "CouponRecipientDataRelationships",
    "CouponRecipientDataRelationshipsAttachments",
    "CouponRecipientDataRelationshipsAttachmentsData",
    "CouponRecipientDataRelationshipsAttachmentsDataType",
    "CouponRecipientDataRelationshipsCustomer",
    "CouponRecipientDataRelationshipsCustomerData",
    "CouponRecipientDataRelationshipsCustomerDataType",
    "CouponRecipientDataType",
    "CouponRecipientUpdate",
    "CouponRecipientUpdateData",
    "CouponRecipientUpdateDataAttributes",
    "CouponRecipientUpdateDataAttributesMetadata",
    "CouponRecipientUpdateDataRelationships",
    "CouponRecipientUpdateDataRelationshipsCustomer",
    "CouponRecipientUpdateDataRelationshipsCustomerData",
    "CouponRecipientUpdateDataRelationshipsCustomerDataType",
    "CouponRecipientUpdateDataType",
    "CouponUpdate",
    "CouponUpdateData",
    "CouponUpdateDataAttributes",
    "CouponUpdateDataAttributesMetadata",
    "CouponUpdateDataRelationships",
    "CouponUpdateDataRelationshipsPromotionRule",
    "CouponUpdateDataRelationshipsPromotionRuleData",
    "CouponUpdateDataRelationshipsPromotionRuleDataType",
    "CouponUpdateDataType",
    "Customer",
    "CustomerAddress",
    "CustomerAddressCreate",
    "CustomerAddressCreateData",
    "CustomerAddressCreateDataAttributes",
    "CustomerAddressCreateDataAttributesMetadata",
    "CustomerAddressCreateDataRelationships",
    "CustomerAddressCreateDataRelationshipsAddress",
    "CustomerAddressCreateDataRelationshipsAddressData",
    "CustomerAddressCreateDataRelationshipsAddressDataType",
    "CustomerAddressCreateDataRelationshipsCustomer",
    "CustomerAddressCreateDataRelationshipsCustomerData",
    "CustomerAddressCreateDataRelationshipsCustomerDataType",
    "CustomerAddressCreateDataType",
    "CustomerAddressData",
    "CustomerAddressDataAttributes",
    "CustomerAddressDataAttributesMetadata",
    "CustomerAddressDataRelationships",
    "CustomerAddressDataRelationshipsAddress",
    "CustomerAddressDataRelationshipsAddressData",
    "CustomerAddressDataRelationshipsAddressDataType",
    "CustomerAddressDataRelationshipsCustomer",
    "CustomerAddressDataRelationshipsCustomerData",
    "CustomerAddressDataRelationshipsCustomerDataType",
    "CustomerAddressDataRelationshipsEvents",
    "CustomerAddressDataRelationshipsEventsData",
    "CustomerAddressDataRelationshipsEventsDataType",
    "CustomerAddressDataType",
    "CustomerAddressUpdate",
    "CustomerAddressUpdateData",
    "CustomerAddressUpdateDataAttributes",
    "CustomerAddressUpdateDataAttributesMetadata",
    "CustomerAddressUpdateDataRelationships",
    "CustomerAddressUpdateDataRelationshipsAddress",
    "CustomerAddressUpdateDataRelationshipsAddressData",
    "CustomerAddressUpdateDataRelationshipsAddressDataType",
    "CustomerAddressUpdateDataRelationshipsCustomer",
    "CustomerAddressUpdateDataRelationshipsCustomerData",
    "CustomerAddressUpdateDataRelationshipsCustomerDataType",
    "CustomerAddressUpdateDataType",
    "CustomerCreate",
    "CustomerCreateData",
    "CustomerCreateDataAttributes",
    "CustomerCreateDataAttributesMetadata",
    "CustomerCreateDataRelationships",
    "CustomerCreateDataRelationshipsCustomerGroup",
    "CustomerCreateDataRelationshipsCustomerGroupData",
    "CustomerCreateDataRelationshipsCustomerGroupDataType",
    "CustomerCreateDataType",
    "CustomerData",
    "CustomerDataAttributes",
    "CustomerDataAttributesMetadata",
    "CustomerDataRelationships",
    "CustomerDataRelationshipsAttachments",
    "CustomerDataRelationshipsAttachmentsData",
    "CustomerDataRelationshipsAttachmentsDataType",
    "CustomerDataRelationshipsCustomerAddresses",
    "CustomerDataRelationshipsCustomerAddressesData",
    "CustomerDataRelationshipsCustomerAddressesDataType",
    "CustomerDataRelationshipsCustomerGroup",
    "CustomerDataRelationshipsCustomerGroupData",
    "CustomerDataRelationshipsCustomerGroupDataType",
    "CustomerDataRelationshipsCustomerPaymentSources",
    "CustomerDataRelationshipsCustomerPaymentSourcesData",
    "CustomerDataRelationshipsCustomerPaymentSourcesDataType",
    "CustomerDataRelationshipsCustomerSubscriptions",
    "CustomerDataRelationshipsCustomerSubscriptionsData",
    "CustomerDataRelationshipsCustomerSubscriptionsDataType",
    "CustomerDataRelationshipsEvents",
    "CustomerDataRelationshipsEventsData",
    "CustomerDataRelationshipsEventsDataType",
    "CustomerDataRelationshipsOrders",
    "CustomerDataRelationshipsOrdersData",
    "CustomerDataRelationshipsOrdersDataType",
    "CustomerDataRelationshipsOrderSubscriptions",
    "CustomerDataRelationshipsOrderSubscriptionsData",
    "CustomerDataRelationshipsOrderSubscriptionsDataType",
    "CustomerDataRelationshipsReturns",
    "CustomerDataRelationshipsReturnsData",
    "CustomerDataRelationshipsReturnsDataType",
    "CustomerDataRelationshipsSkuLists",
    "CustomerDataRelationshipsSkuListsData",
    "CustomerDataRelationshipsSkuListsDataType",
    "CustomerDataType",
    "CustomerGroup",
    "CustomerGroupCreate",
    "CustomerGroupCreateData",
    "CustomerGroupCreateDataAttributes",
    "CustomerGroupCreateDataAttributesMetadata",
    "CustomerGroupCreateDataRelationships",
    "CustomerGroupCreateDataType",
    "CustomerGroupData",
    "CustomerGroupDataAttributes",
    "CustomerGroupDataAttributesMetadata",
    "CustomerGroupDataRelationships",
    "CustomerGroupDataRelationshipsAttachments",
    "CustomerGroupDataRelationshipsAttachmentsData",
    "CustomerGroupDataRelationshipsAttachmentsDataType",
    "CustomerGroupDataRelationshipsCustomers",
    "CustomerGroupDataRelationshipsCustomersData",
    "CustomerGroupDataRelationshipsCustomersDataType",
    "CustomerGroupDataRelationshipsMarkets",
    "CustomerGroupDataRelationshipsMarketsData",
    "CustomerGroupDataRelationshipsMarketsDataType",
    "CustomerGroupDataType",
    "CustomerGroupUpdate",
    "CustomerGroupUpdateData",
    "CustomerGroupUpdateDataAttributes",
    "CustomerGroupUpdateDataAttributesMetadata",
    "CustomerGroupUpdateDataRelationships",
    "CustomerGroupUpdateDataType",
    "CustomerPasswordReset",
    "CustomerPasswordResetCreate",
    "CustomerPasswordResetCreateData",
    "CustomerPasswordResetCreateDataAttributes",
    "CustomerPasswordResetCreateDataAttributesMetadata",
    "CustomerPasswordResetCreateDataRelationships",
    "CustomerPasswordResetCreateDataType",
    "CustomerPasswordResetData",
    "CustomerPasswordResetDataAttributes",
    "CustomerPasswordResetDataAttributesMetadata",
    "CustomerPasswordResetDataRelationships",
    "CustomerPasswordResetDataRelationshipsCustomer",
    "CustomerPasswordResetDataRelationshipsCustomerData",
    "CustomerPasswordResetDataRelationshipsCustomerDataType",
    "CustomerPasswordResetDataRelationshipsEvents",
    "CustomerPasswordResetDataRelationshipsEventsData",
    "CustomerPasswordResetDataRelationshipsEventsDataType",
    "CustomerPasswordResetDataType",
    "CustomerPasswordResetUpdate",
    "CustomerPasswordResetUpdateData",
    "CustomerPasswordResetUpdateDataAttributes",
    "CustomerPasswordResetUpdateDataAttributesMetadata",
    "CustomerPasswordResetUpdateDataRelationships",
    "CustomerPasswordResetUpdateDataType",
    "CustomerPaymentSource",
    "CustomerPaymentSourceCreate",
    "CustomerPaymentSourceCreateData",
    "CustomerPaymentSourceCreateDataAttributes",
    "CustomerPaymentSourceCreateDataAttributesMetadata",
    "CustomerPaymentSourceCreateDataRelationships",
    "CustomerPaymentSourceCreateDataRelationshipsCustomer",
    "CustomerPaymentSourceCreateDataRelationshipsCustomerData",
    "CustomerPaymentSourceCreateDataRelationshipsCustomerDataType",
    "CustomerPaymentSourceCreateDataType",
    "CustomerPaymentSourceData",
    "CustomerPaymentSourceDataAttributes",
    "CustomerPaymentSourceDataAttributesMetadata",
    "CustomerPaymentSourceDataRelationships",
    "CustomerPaymentSourceDataRelationshipsCustomer",
    "CustomerPaymentSourceDataRelationshipsCustomerData",
    "CustomerPaymentSourceDataRelationshipsCustomerDataType",
    "CustomerPaymentSourceDataType",
    "CustomerPaymentSourceUpdate",
    "CustomerPaymentSourceUpdateData",
    "CustomerPaymentSourceUpdateDataAttributes",
    "CustomerPaymentSourceUpdateDataAttributesMetadata",
    "CustomerPaymentSourceUpdateDataRelationships",
    "CustomerPaymentSourceUpdateDataRelationshipsCustomer",
    "CustomerPaymentSourceUpdateDataRelationshipsCustomerData",
    "CustomerPaymentSourceUpdateDataRelationshipsCustomerDataType",
    "CustomerPaymentSourceUpdateDataType",
    "CustomerSubscription",
    "CustomerSubscriptionCreate",
    "CustomerSubscriptionCreateData",
    "CustomerSubscriptionCreateDataAttributes",
    "CustomerSubscriptionCreateDataAttributesMetadata",
    "CustomerSubscriptionCreateDataRelationships",
    "CustomerSubscriptionCreateDataType",
    "CustomerSubscriptionData",
    "CustomerSubscriptionDataAttributes",
    "CustomerSubscriptionDataAttributesMetadata",
    "CustomerSubscriptionDataRelationships",
    "CustomerSubscriptionDataRelationshipsCustomer",
    "CustomerSubscriptionDataRelationshipsCustomerData",
    "CustomerSubscriptionDataRelationshipsCustomerDataType",
    "CustomerSubscriptionDataRelationshipsEvents",
    "CustomerSubscriptionDataRelationshipsEventsData",
    "CustomerSubscriptionDataRelationshipsEventsDataType",
    "CustomerSubscriptionDataType",
    "CustomerSubscriptionUpdate",
    "CustomerSubscriptionUpdateData",
    "CustomerSubscriptionUpdateDataAttributes",
    "CustomerSubscriptionUpdateDataAttributesMetadata",
    "CustomerSubscriptionUpdateDataRelationships",
    "CustomerSubscriptionUpdateDataType",
    "CustomerUpdate",
    "CustomerUpdateData",
    "CustomerUpdateDataAttributes",
    "CustomerUpdateDataAttributesMetadata",
    "CustomerUpdateDataRelationships",
    "CustomerUpdateDataRelationshipsCustomerGroup",
    "CustomerUpdateDataRelationshipsCustomerGroupData",
    "CustomerUpdateDataRelationshipsCustomerGroupDataType",
    "CustomerUpdateDataType",
    "DeliveryLeadTime",
    "DeliveryLeadTimeCreate",
    "DeliveryLeadTimeCreateData",
    "DeliveryLeadTimeCreateDataAttributes",
    "DeliveryLeadTimeCreateDataAttributesMetadata",
    "DeliveryLeadTimeCreateDataRelationships",
    "DeliveryLeadTimeCreateDataRelationshipsShippingMethod",
    "DeliveryLeadTimeCreateDataRelationshipsShippingMethodData",
    "DeliveryLeadTimeCreateDataRelationshipsShippingMethodDataType",
    "DeliveryLeadTimeCreateDataRelationshipsStockLocation",
    "DeliveryLeadTimeCreateDataRelationshipsStockLocationData",
    "DeliveryLeadTimeCreateDataRelationshipsStockLocationDataType",
    "DeliveryLeadTimeCreateDataType",
    "DeliveryLeadTimeData",
    "DeliveryLeadTimeDataAttributes",
    "DeliveryLeadTimeDataAttributesMetadata",
    "DeliveryLeadTimeDataRelationships",
    "DeliveryLeadTimeDataRelationshipsAttachments",
    "DeliveryLeadTimeDataRelationshipsAttachmentsData",
    "DeliveryLeadTimeDataRelationshipsAttachmentsDataType",
    "DeliveryLeadTimeDataRelationshipsShippingMethod",
    "DeliveryLeadTimeDataRelationshipsShippingMethodData",
    "DeliveryLeadTimeDataRelationshipsShippingMethodDataType",
    "DeliveryLeadTimeDataRelationshipsStockLocation",
    "DeliveryLeadTimeDataRelationshipsStockLocationData",
    "DeliveryLeadTimeDataRelationshipsStockLocationDataType",
    "DeliveryLeadTimeDataType",
    "DeliveryLeadTimeUpdate",
    "DeliveryLeadTimeUpdateData",
    "DeliveryLeadTimeUpdateDataAttributes",
    "DeliveryLeadTimeUpdateDataAttributesMetadata",
    "DeliveryLeadTimeUpdateDataRelationships",
    "DeliveryLeadTimeUpdateDataRelationshipsShippingMethod",
    "DeliveryLeadTimeUpdateDataRelationshipsShippingMethodData",
    "DeliveryLeadTimeUpdateDataRelationshipsShippingMethodDataType",
    "DeliveryLeadTimeUpdateDataRelationshipsStockLocation",
    "DeliveryLeadTimeUpdateDataRelationshipsStockLocationData",
    "DeliveryLeadTimeUpdateDataRelationshipsStockLocationDataType",
    "DeliveryLeadTimeUpdateDataType",
    "Event",
    "EventCallback",
    "EventCallbackData",
    "EventCallbackDataAttributes",
    "EventCallbackDataAttributesMetadata",
    "EventCallbackDataAttributesPayload",
    "EventCallbackDataRelationships",
    "EventCallbackDataRelationshipsWebhook",
    "EventCallbackDataRelationshipsWebhookData",
    "EventCallbackDataRelationshipsWebhookDataType",
    "EventCallbackDataType",
    "EventData",
    "EventDataAttributes",
    "EventDataAttributesMetadata",
    "EventDataRelationships",
    "EventDataRelationshipsLastEventCallbacks",
    "EventDataRelationshipsLastEventCallbacksData",
    "EventDataRelationshipsLastEventCallbacksDataType",
    "EventDataRelationshipsWebhooks",
    "EventDataRelationshipsWebhooksData",
    "EventDataRelationshipsWebhooksDataType",
    "EventDataType",
    "Export",
    "ExportCreate",
    "ExportCreateData",
    "ExportCreateDataAttributes",
    "ExportCreateDataAttributesFilters",
    "ExportCreateDataAttributesMetadata",
    "ExportCreateDataRelationships",
    "ExportCreateDataType",
    "ExportData",
    "ExportDataAttributes",
    "ExportDataAttributesFilters",
    "ExportDataAttributesMetadata",
    "ExportDataRelationships",
    "ExportDataRelationshipsEvents",
    "ExportDataRelationshipsEventsData",
    "ExportDataRelationshipsEventsDataType",
    "ExportDataType",
    "ExternalGateway",
    "ExternalGatewayCreate",
    "ExternalGatewayCreateData",
    "ExternalGatewayCreateDataAttributes",
    "ExternalGatewayCreateDataAttributesMetadata",
    "ExternalGatewayCreateDataRelationships",
    "ExternalGatewayCreateDataType",
    "ExternalGatewayData",
    "ExternalGatewayDataAttributes",
    "ExternalGatewayDataAttributesMetadata",
    "ExternalGatewayDataRelationships",
    "ExternalGatewayDataRelationshipsExternalPayments",
    "ExternalGatewayDataRelationshipsExternalPaymentsData",
    "ExternalGatewayDataRelationshipsExternalPaymentsDataType",
    "ExternalGatewayDataRelationshipsPaymentMethods",
    "ExternalGatewayDataRelationshipsPaymentMethodsData",
    "ExternalGatewayDataRelationshipsPaymentMethodsDataType",
    "ExternalGatewayDataType",
    "ExternalGatewayUpdate",
    "ExternalGatewayUpdateData",
    "ExternalGatewayUpdateDataAttributes",
    "ExternalGatewayUpdateDataAttributesMetadata",
    "ExternalGatewayUpdateDataRelationships",
    "ExternalGatewayUpdateDataType",
    "ExternalPayment",
    "ExternalPaymentCreate",
    "ExternalPaymentCreateData",
    "ExternalPaymentCreateDataAttributes",
    "ExternalPaymentCreateDataAttributesMetadata",
    "ExternalPaymentCreateDataAttributesOptions",
    "ExternalPaymentCreateDataRelationships",
    "ExternalPaymentCreateDataRelationshipsOrder",
    "ExternalPaymentCreateDataRelationshipsOrderData",
    "ExternalPaymentCreateDataRelationshipsOrderDataType",
    "ExternalPaymentCreateDataType",
    "ExternalPaymentData",
    "ExternalPaymentDataAttributes",
    "ExternalPaymentDataAttributesMetadata",
    "ExternalPaymentDataAttributesOptions",
    "ExternalPaymentDataRelationships",
    "ExternalPaymentDataRelationshipsOrder",
    "ExternalPaymentDataRelationshipsOrderData",
    "ExternalPaymentDataRelationshipsOrderDataType",
    "ExternalPaymentDataRelationshipsPaymentGateway",
    "ExternalPaymentDataRelationshipsPaymentGatewayData",
    "ExternalPaymentDataRelationshipsPaymentGatewayDataType",
    "ExternalPaymentDataRelationshipsWallet",
    "ExternalPaymentDataRelationshipsWalletData",
    "ExternalPaymentDataRelationshipsWalletDataType",
    "ExternalPaymentDataType",
    "ExternalPaymentUpdate",
    "ExternalPaymentUpdateData",
    "ExternalPaymentUpdateDataAttributes",
    "ExternalPaymentUpdateDataAttributesMetadata",
    "ExternalPaymentUpdateDataAttributesOptions",
    "ExternalPaymentUpdateDataRelationships",
    "ExternalPaymentUpdateDataRelationshipsOrder",
    "ExternalPaymentUpdateDataRelationshipsOrderData",
    "ExternalPaymentUpdateDataRelationshipsOrderDataType",
    "ExternalPaymentUpdateDataType",
    "ExternalPromotion",
    "ExternalPromotionCreate",
    "ExternalPromotionCreateData",
    "ExternalPromotionCreateDataAttributes",
    "ExternalPromotionCreateDataAttributesMetadata",
    "ExternalPromotionCreateDataRelationships",
    "ExternalPromotionCreateDataRelationshipsCouponCodesPromotionRule",
    "ExternalPromotionCreateDataRelationshipsCouponCodesPromotionRuleData",
    "ExternalPromotionCreateDataRelationshipsCouponCodesPromotionRuleDataType",
    "ExternalPromotionCreateDataRelationshipsMarket",
    "ExternalPromotionCreateDataRelationshipsMarketData",
    "ExternalPromotionCreateDataRelationshipsMarketDataType",
    "ExternalPromotionCreateDataRelationshipsOrderAmountPromotionRule",
    "ExternalPromotionCreateDataRelationshipsOrderAmountPromotionRuleData",
    "ExternalPromotionCreateDataRelationshipsOrderAmountPromotionRuleDataType",
    "ExternalPromotionCreateDataRelationshipsPromotionRules",
    "ExternalPromotionCreateDataRelationshipsPromotionRulesData",
    "ExternalPromotionCreateDataRelationshipsPromotionRulesDataType",
    "ExternalPromotionCreateDataRelationshipsSkuListPromotionRule",
    "ExternalPromotionCreateDataRelationshipsSkuListPromotionRuleData",
    "ExternalPromotionCreateDataRelationshipsSkuListPromotionRuleDataType",
    "ExternalPromotionCreateDataType",
    "ExternalPromotionData",
    "ExternalPromotionDataAttributes",
    "ExternalPromotionDataAttributesMetadata",
    "ExternalPromotionDataRelationships",
    "ExternalPromotionDataRelationshipsAttachments",
    "ExternalPromotionDataRelationshipsAttachmentsData",
    "ExternalPromotionDataRelationshipsAttachmentsDataType",
    "ExternalPromotionDataRelationshipsCouponCodesPromotionRule",
    "ExternalPromotionDataRelationshipsCouponCodesPromotionRuleData",
    "ExternalPromotionDataRelationshipsCouponCodesPromotionRuleDataType",
    "ExternalPromotionDataRelationshipsMarket",
    "ExternalPromotionDataRelationshipsMarketData",
    "ExternalPromotionDataRelationshipsMarketDataType",
    "ExternalPromotionDataRelationshipsOrderAmountPromotionRule",
    "ExternalPromotionDataRelationshipsOrderAmountPromotionRuleData",
    "ExternalPromotionDataRelationshipsOrderAmountPromotionRuleDataType",
    "ExternalPromotionDataRelationshipsPromotionRules",
    "ExternalPromotionDataRelationshipsPromotionRulesData",
    "ExternalPromotionDataRelationshipsPromotionRulesDataType",
    "ExternalPromotionDataRelationshipsSkuListPromotionRule",
    "ExternalPromotionDataRelationshipsSkuListPromotionRuleData",
    "ExternalPromotionDataRelationshipsSkuListPromotionRuleDataType",
    "ExternalPromotionDataType",
    "ExternalPromotionUpdate",
    "ExternalPromotionUpdateData",
    "ExternalPromotionUpdateDataAttributes",
    "ExternalPromotionUpdateDataAttributesMetadata",
    "ExternalPromotionUpdateDataRelationships",
    "ExternalPromotionUpdateDataRelationshipsCouponCodesPromotionRule",
    "ExternalPromotionUpdateDataRelationshipsCouponCodesPromotionRuleData",
    "ExternalPromotionUpdateDataRelationshipsCouponCodesPromotionRuleDataType",
    "ExternalPromotionUpdateDataRelationshipsMarket",
    "ExternalPromotionUpdateDataRelationshipsMarketData",
    "ExternalPromotionUpdateDataRelationshipsMarketDataType",
    "ExternalPromotionUpdateDataRelationshipsOrderAmountPromotionRule",
    "ExternalPromotionUpdateDataRelationshipsOrderAmountPromotionRuleData",
    "ExternalPromotionUpdateDataRelationshipsOrderAmountPromotionRuleDataType",
    "ExternalPromotionUpdateDataRelationshipsPromotionRules",
    "ExternalPromotionUpdateDataRelationshipsPromotionRulesData",
    "ExternalPromotionUpdateDataRelationshipsPromotionRulesDataType",
    "ExternalPromotionUpdateDataRelationshipsSkuListPromotionRule",
    "ExternalPromotionUpdateDataRelationshipsSkuListPromotionRuleData",
    "ExternalPromotionUpdateDataRelationshipsSkuListPromotionRuleDataType",
    "ExternalPromotionUpdateDataType",
    "ExternalTaxCalculator",
    "ExternalTaxCalculatorCreate",
    "ExternalTaxCalculatorCreateData",
    "ExternalTaxCalculatorCreateDataAttributes",
    "ExternalTaxCalculatorCreateDataAttributesMetadata",
    "ExternalTaxCalculatorCreateDataRelationships",
    "ExternalTaxCalculatorCreateDataType",
    "ExternalTaxCalculatorData",
    "ExternalTaxCalculatorDataAttributes",
    "ExternalTaxCalculatorDataAttributesMetadata",
    "ExternalTaxCalculatorDataRelationships",
    "ExternalTaxCalculatorDataRelationshipsAttachments",
    "ExternalTaxCalculatorDataRelationshipsAttachmentsData",
    "ExternalTaxCalculatorDataRelationshipsAttachmentsDataType",
    "ExternalTaxCalculatorDataRelationshipsMarkets",
    "ExternalTaxCalculatorDataRelationshipsMarketsData",
    "ExternalTaxCalculatorDataRelationshipsMarketsDataType",
    "ExternalTaxCalculatorDataType",
    "ExternalTaxCalculatorUpdate",
    "ExternalTaxCalculatorUpdateData",
    "ExternalTaxCalculatorUpdateDataAttributes",
    "ExternalTaxCalculatorUpdateDataAttributesMetadata",
    "ExternalTaxCalculatorUpdateDataRelationships",
    "ExternalTaxCalculatorUpdateDataType",
    "FixedAmountPromotion",
    "FixedAmountPromotionCreate",
    "FixedAmountPromotionCreateData",
    "FixedAmountPromotionCreateDataAttributes",
    "FixedAmountPromotionCreateDataAttributesMetadata",
    "FixedAmountPromotionCreateDataRelationships",
    "FixedAmountPromotionCreateDataRelationshipsCouponCodesPromotionRule",
    "FixedAmountPromotionCreateDataRelationshipsCouponCodesPromotionRuleData",
    "FixedAmountPromotionCreateDataRelationshipsCouponCodesPromotionRuleDataType",
    "FixedAmountPromotionCreateDataRelationshipsMarket",
    "FixedAmountPromotionCreateDataRelationshipsMarketData",
    "FixedAmountPromotionCreateDataRelationshipsMarketDataType",
    "FixedAmountPromotionCreateDataRelationshipsOrderAmountPromotionRule",
    "FixedAmountPromotionCreateDataRelationshipsOrderAmountPromotionRuleData",
    "FixedAmountPromotionCreateDataRelationshipsOrderAmountPromotionRuleDataType",
    "FixedAmountPromotionCreateDataRelationshipsPromotionRules",
    "FixedAmountPromotionCreateDataRelationshipsPromotionRulesData",
    "FixedAmountPromotionCreateDataRelationshipsPromotionRulesDataType",
    "FixedAmountPromotionCreateDataRelationshipsSkuListPromotionRule",
    "FixedAmountPromotionCreateDataRelationshipsSkuListPromotionRuleData",
    "FixedAmountPromotionCreateDataRelationshipsSkuListPromotionRuleDataType",
    "FixedAmountPromotionCreateDataType",
    "FixedAmountPromotionData",
    "FixedAmountPromotionDataAttributes",
    "FixedAmountPromotionDataAttributesMetadata",
    "FixedAmountPromotionDataRelationships",
    "FixedAmountPromotionDataRelationshipsAttachments",
    "FixedAmountPromotionDataRelationshipsAttachmentsData",
    "FixedAmountPromotionDataRelationshipsAttachmentsDataType",
    "FixedAmountPromotionDataRelationshipsCouponCodesPromotionRule",
    "FixedAmountPromotionDataRelationshipsCouponCodesPromotionRuleData",
    "FixedAmountPromotionDataRelationshipsCouponCodesPromotionRuleDataType",
    "FixedAmountPromotionDataRelationshipsMarket",
    "FixedAmountPromotionDataRelationshipsMarketData",
    "FixedAmountPromotionDataRelationshipsMarketDataType",
    "FixedAmountPromotionDataRelationshipsOrderAmountPromotionRule",
    "FixedAmountPromotionDataRelationshipsOrderAmountPromotionRuleData",
    "FixedAmountPromotionDataRelationshipsOrderAmountPromotionRuleDataType",
    "FixedAmountPromotionDataRelationshipsPromotionRules",
    "FixedAmountPromotionDataRelationshipsPromotionRulesData",
    "FixedAmountPromotionDataRelationshipsPromotionRulesDataType",
    "FixedAmountPromotionDataRelationshipsSkuListPromotionRule",
    "FixedAmountPromotionDataRelationshipsSkuListPromotionRuleData",
    "FixedAmountPromotionDataRelationshipsSkuListPromotionRuleDataType",
    "FixedAmountPromotionDataType",
    "FixedAmountPromotionUpdate",
    "FixedAmountPromotionUpdateData",
    "FixedAmountPromotionUpdateDataAttributes",
    "FixedAmountPromotionUpdateDataAttributesMetadata",
    "FixedAmountPromotionUpdateDataRelationships",
    "FixedAmountPromotionUpdateDataRelationshipsCouponCodesPromotionRule",
    "FixedAmountPromotionUpdateDataRelationshipsCouponCodesPromotionRuleData",
    "FixedAmountPromotionUpdateDataRelationshipsCouponCodesPromotionRuleDataType",
    "FixedAmountPromotionUpdateDataRelationshipsMarket",
    "FixedAmountPromotionUpdateDataRelationshipsMarketData",
    "FixedAmountPromotionUpdateDataRelationshipsMarketDataType",
    "FixedAmountPromotionUpdateDataRelationshipsOrderAmountPromotionRule",
    "FixedAmountPromotionUpdateDataRelationshipsOrderAmountPromotionRuleData",
    "FixedAmountPromotionUpdateDataRelationshipsOrderAmountPromotionRuleDataType",
    "FixedAmountPromotionUpdateDataRelationshipsPromotionRules",
    "FixedAmountPromotionUpdateDataRelationshipsPromotionRulesData",
    "FixedAmountPromotionUpdateDataRelationshipsPromotionRulesDataType",
    "FixedAmountPromotionUpdateDataRelationshipsSkuListPromotionRule",
    "FixedAmountPromotionUpdateDataRelationshipsSkuListPromotionRuleData",
    "FixedAmountPromotionUpdateDataRelationshipsSkuListPromotionRuleDataType",
    "FixedAmountPromotionUpdateDataType",
    "FixedPricePromotion",
    "FixedPricePromotionCreate",
    "FixedPricePromotionCreateData",
    "FixedPricePromotionCreateDataAttributes",
    "FixedPricePromotionCreateDataAttributesMetadata",
    "FixedPricePromotionCreateDataRelationships",
    "FixedPricePromotionCreateDataRelationshipsCouponCodesPromotionRule",
    "FixedPricePromotionCreateDataRelationshipsCouponCodesPromotionRuleData",
    "FixedPricePromotionCreateDataRelationshipsCouponCodesPromotionRuleDataType",
    "FixedPricePromotionCreateDataRelationshipsMarket",
    "FixedPricePromotionCreateDataRelationshipsMarketData",
    "FixedPricePromotionCreateDataRelationshipsMarketDataType",
    "FixedPricePromotionCreateDataRelationshipsOrderAmountPromotionRule",
    "FixedPricePromotionCreateDataRelationshipsOrderAmountPromotionRuleData",
    "FixedPricePromotionCreateDataRelationshipsOrderAmountPromotionRuleDataType",
    "FixedPricePromotionCreateDataRelationshipsPromotionRules",
    "FixedPricePromotionCreateDataRelationshipsPromotionRulesData",
    "FixedPricePromotionCreateDataRelationshipsPromotionRulesDataType",
    "FixedPricePromotionCreateDataRelationshipsSkuList",
    "FixedPricePromotionCreateDataRelationshipsSkuListData",
    "FixedPricePromotionCreateDataRelationshipsSkuListDataType",
    "FixedPricePromotionCreateDataRelationshipsSkuListPromotionRule",
    "FixedPricePromotionCreateDataRelationshipsSkuListPromotionRuleData",
    "FixedPricePromotionCreateDataRelationshipsSkuListPromotionRuleDataType",
    "FixedPricePromotionCreateDataType",
    "FixedPricePromotionData",
    "FixedPricePromotionDataAttributes",
    "FixedPricePromotionDataAttributesMetadata",
    "FixedPricePromotionDataRelationships",
    "FixedPricePromotionDataRelationshipsAttachments",
    "FixedPricePromotionDataRelationshipsAttachmentsData",
    "FixedPricePromotionDataRelationshipsAttachmentsDataType",
    "FixedPricePromotionDataRelationshipsCouponCodesPromotionRule",
    "FixedPricePromotionDataRelationshipsCouponCodesPromotionRuleData",
    "FixedPricePromotionDataRelationshipsCouponCodesPromotionRuleDataType",
    "FixedPricePromotionDataRelationshipsMarket",
    "FixedPricePromotionDataRelationshipsMarketData",
    "FixedPricePromotionDataRelationshipsMarketDataType",
    "FixedPricePromotionDataRelationshipsOrderAmountPromotionRule",
    "FixedPricePromotionDataRelationshipsOrderAmountPromotionRuleData",
    "FixedPricePromotionDataRelationshipsOrderAmountPromotionRuleDataType",
    "FixedPricePromotionDataRelationshipsPromotionRules",
    "FixedPricePromotionDataRelationshipsPromotionRulesData",
    "FixedPricePromotionDataRelationshipsPromotionRulesDataType",
    "FixedPricePromotionDataRelationshipsSkuList",
    "FixedPricePromotionDataRelationshipsSkuListData",
    "FixedPricePromotionDataRelationshipsSkuListDataType",
    "FixedPricePromotionDataRelationshipsSkuListPromotionRule",
    "FixedPricePromotionDataRelationshipsSkuListPromotionRuleData",
    "FixedPricePromotionDataRelationshipsSkuListPromotionRuleDataType",
    "FixedPricePromotionDataRelationshipsSkus",
    "FixedPricePromotionDataRelationshipsSkusData",
    "FixedPricePromotionDataRelationshipsSkusDataType",
    "FixedPricePromotionDataType",
    "FixedPricePromotionUpdate",
    "FixedPricePromotionUpdateData",
    "FixedPricePromotionUpdateDataAttributes",
    "FixedPricePromotionUpdateDataAttributesMetadata",
    "FixedPricePromotionUpdateDataRelationships",
    "FixedPricePromotionUpdateDataRelationshipsCouponCodesPromotionRule",
    "FixedPricePromotionUpdateDataRelationshipsCouponCodesPromotionRuleData",
    "FixedPricePromotionUpdateDataRelationshipsCouponCodesPromotionRuleDataType",
    "FixedPricePromotionUpdateDataRelationshipsMarket",
    "FixedPricePromotionUpdateDataRelationshipsMarketData",
    "FixedPricePromotionUpdateDataRelationshipsMarketDataType",
    "FixedPricePromotionUpdateDataRelationshipsOrderAmountPromotionRule",
    "FixedPricePromotionUpdateDataRelationshipsOrderAmountPromotionRuleData",
    "FixedPricePromotionUpdateDataRelationshipsOrderAmountPromotionRuleDataType",
    "FixedPricePromotionUpdateDataRelationshipsPromotionRules",
    "FixedPricePromotionUpdateDataRelationshipsPromotionRulesData",
    "FixedPricePromotionUpdateDataRelationshipsPromotionRulesDataType",
    "FixedPricePromotionUpdateDataRelationshipsSkuList",
    "FixedPricePromotionUpdateDataRelationshipsSkuListData",
    "FixedPricePromotionUpdateDataRelationshipsSkuListDataType",
    "FixedPricePromotionUpdateDataRelationshipsSkuListPromotionRule",
    "FixedPricePromotionUpdateDataRelationshipsSkuListPromotionRuleData",
    "FixedPricePromotionUpdateDataRelationshipsSkuListPromotionRuleDataType",
    "FixedPricePromotionUpdateDataType",
    "FreeGiftPromotion",
    "FreeGiftPromotionCreate",
    "FreeGiftPromotionCreateData",
    "FreeGiftPromotionCreateDataAttributes",
    "FreeGiftPromotionCreateDataAttributesMetadata",
    "FreeGiftPromotionCreateDataRelationships",
    "FreeGiftPromotionCreateDataRelationshipsCouponCodesPromotionRule",
    "FreeGiftPromotionCreateDataRelationshipsCouponCodesPromotionRuleData",
    "FreeGiftPromotionCreateDataRelationshipsCouponCodesPromotionRuleDataType",
    "FreeGiftPromotionCreateDataRelationshipsMarket",
    "FreeGiftPromotionCreateDataRelationshipsMarketData",
    "FreeGiftPromotionCreateDataRelationshipsMarketDataType",
    "FreeGiftPromotionCreateDataRelationshipsOrderAmountPromotionRule",
    "FreeGiftPromotionCreateDataRelationshipsOrderAmountPromotionRuleData",
    "FreeGiftPromotionCreateDataRelationshipsOrderAmountPromotionRuleDataType",
    "FreeGiftPromotionCreateDataRelationshipsPromotionRules",
    "FreeGiftPromotionCreateDataRelationshipsPromotionRulesData",
    "FreeGiftPromotionCreateDataRelationshipsPromotionRulesDataType",
    "FreeGiftPromotionCreateDataRelationshipsSkuList",
    "FreeGiftPromotionCreateDataRelationshipsSkuListData",
    "FreeGiftPromotionCreateDataRelationshipsSkuListDataType",
    "FreeGiftPromotionCreateDataRelationshipsSkuListPromotionRule",
    "FreeGiftPromotionCreateDataRelationshipsSkuListPromotionRuleData",
    "FreeGiftPromotionCreateDataRelationshipsSkuListPromotionRuleDataType",
    "FreeGiftPromotionCreateDataType",
    "FreeGiftPromotionData",
    "FreeGiftPromotionDataAttributes",
    "FreeGiftPromotionDataAttributesMetadata",
    "FreeGiftPromotionDataRelationships",
    "FreeGiftPromotionDataRelationshipsAttachments",
    "FreeGiftPromotionDataRelationshipsAttachmentsData",
    "FreeGiftPromotionDataRelationshipsAttachmentsDataType",
    "FreeGiftPromotionDataRelationshipsCouponCodesPromotionRule",
    "FreeGiftPromotionDataRelationshipsCouponCodesPromotionRuleData",
    "FreeGiftPromotionDataRelationshipsCouponCodesPromotionRuleDataType",
    "FreeGiftPromotionDataRelationshipsMarket",
    "FreeGiftPromotionDataRelationshipsMarketData",
    "FreeGiftPromotionDataRelationshipsMarketDataType",
    "FreeGiftPromotionDataRelationshipsOrderAmountPromotionRule",
    "FreeGiftPromotionDataRelationshipsOrderAmountPromotionRuleData",
    "FreeGiftPromotionDataRelationshipsOrderAmountPromotionRuleDataType",
    "FreeGiftPromotionDataRelationshipsPromotionRules",
    "FreeGiftPromotionDataRelationshipsPromotionRulesData",
    "FreeGiftPromotionDataRelationshipsPromotionRulesDataType",
    "FreeGiftPromotionDataRelationshipsSkuList",
    "FreeGiftPromotionDataRelationshipsSkuListData",
    "FreeGiftPromotionDataRelationshipsSkuListDataType",
    "FreeGiftPromotionDataRelationshipsSkuListPromotionRule",
    "FreeGiftPromotionDataRelationshipsSkuListPromotionRuleData",
    "FreeGiftPromotionDataRelationshipsSkuListPromotionRuleDataType",
    "FreeGiftPromotionDataRelationshipsSkus",
    "FreeGiftPromotionDataRelationshipsSkusData",
    "FreeGiftPromotionDataRelationshipsSkusDataType",
    "FreeGiftPromotionDataType",
    "FreeGiftPromotionUpdate",
    "FreeGiftPromotionUpdateData",
    "FreeGiftPromotionUpdateDataAttributes",
    "FreeGiftPromotionUpdateDataAttributesMetadata",
    "FreeGiftPromotionUpdateDataRelationships",
    "FreeGiftPromotionUpdateDataRelationshipsCouponCodesPromotionRule",
    "FreeGiftPromotionUpdateDataRelationshipsCouponCodesPromotionRuleData",
    "FreeGiftPromotionUpdateDataRelationshipsCouponCodesPromotionRuleDataType",
    "FreeGiftPromotionUpdateDataRelationshipsMarket",
    "FreeGiftPromotionUpdateDataRelationshipsMarketData",
    "FreeGiftPromotionUpdateDataRelationshipsMarketDataType",
    "FreeGiftPromotionUpdateDataRelationshipsOrderAmountPromotionRule",
    "FreeGiftPromotionUpdateDataRelationshipsOrderAmountPromotionRuleData",
    "FreeGiftPromotionUpdateDataRelationshipsOrderAmountPromotionRuleDataType",
    "FreeGiftPromotionUpdateDataRelationshipsPromotionRules",
    "FreeGiftPromotionUpdateDataRelationshipsPromotionRulesData",
    "FreeGiftPromotionUpdateDataRelationshipsPromotionRulesDataType",
    "FreeGiftPromotionUpdateDataRelationshipsSkuList",
    "FreeGiftPromotionUpdateDataRelationshipsSkuListData",
    "FreeGiftPromotionUpdateDataRelationshipsSkuListDataType",
    "FreeGiftPromotionUpdateDataRelationshipsSkuListPromotionRule",
    "FreeGiftPromotionUpdateDataRelationshipsSkuListPromotionRuleData",
    "FreeGiftPromotionUpdateDataRelationshipsSkuListPromotionRuleDataType",
    "FreeGiftPromotionUpdateDataType",
    "FreeShippingPromotion",
    "FreeShippingPromotionCreate",
    "FreeShippingPromotionCreateData",
    "FreeShippingPromotionCreateDataAttributes",
    "FreeShippingPromotionCreateDataAttributesMetadata",
    "FreeShippingPromotionCreateDataRelationships",
    "FreeShippingPromotionCreateDataRelationshipsCouponCodesPromotionRule",
    "FreeShippingPromotionCreateDataRelationshipsCouponCodesPromotionRuleData",
    "FreeShippingPromotionCreateDataRelationshipsCouponCodesPromotionRuleDataType",
    "FreeShippingPromotionCreateDataRelationshipsMarket",
    "FreeShippingPromotionCreateDataRelationshipsMarketData",
    "FreeShippingPromotionCreateDataRelationshipsMarketDataType",
    "FreeShippingPromotionCreateDataRelationshipsOrderAmountPromotionRule",
    "FreeShippingPromotionCreateDataRelationshipsOrderAmountPromotionRuleData",
    "FreeShippingPromotionCreateDataRelationshipsOrderAmountPromotionRuleDataType",
    "FreeShippingPromotionCreateDataRelationshipsPromotionRules",
    "FreeShippingPromotionCreateDataRelationshipsPromotionRulesData",
    "FreeShippingPromotionCreateDataRelationshipsPromotionRulesDataType",
    "FreeShippingPromotionCreateDataRelationshipsSkuListPromotionRule",
    "FreeShippingPromotionCreateDataRelationshipsSkuListPromotionRuleData",
    "FreeShippingPromotionCreateDataRelationshipsSkuListPromotionRuleDataType",
    "FreeShippingPromotionCreateDataType",
    "FreeShippingPromotionData",
    "FreeShippingPromotionDataAttributes",
    "FreeShippingPromotionDataAttributesMetadata",
    "FreeShippingPromotionDataRelationships",
    "FreeShippingPromotionDataRelationshipsAttachments",
    "FreeShippingPromotionDataRelationshipsAttachmentsData",
    "FreeShippingPromotionDataRelationshipsAttachmentsDataType",
    "FreeShippingPromotionDataRelationshipsCouponCodesPromotionRule",
    "FreeShippingPromotionDataRelationshipsCouponCodesPromotionRuleData",
    "FreeShippingPromotionDataRelationshipsCouponCodesPromotionRuleDataType",
    "FreeShippingPromotionDataRelationshipsMarket",
    "FreeShippingPromotionDataRelationshipsMarketData",
    "FreeShippingPromotionDataRelationshipsMarketDataType",
    "FreeShippingPromotionDataRelationshipsOrderAmountPromotionRule",
    "FreeShippingPromotionDataRelationshipsOrderAmountPromotionRuleData",
    "FreeShippingPromotionDataRelationshipsOrderAmountPromotionRuleDataType",
    "FreeShippingPromotionDataRelationshipsPromotionRules",
    "FreeShippingPromotionDataRelationshipsPromotionRulesData",
    "FreeShippingPromotionDataRelationshipsPromotionRulesDataType",
    "FreeShippingPromotionDataRelationshipsSkuListPromotionRule",
    "FreeShippingPromotionDataRelationshipsSkuListPromotionRuleData",
    "FreeShippingPromotionDataRelationshipsSkuListPromotionRuleDataType",
    "FreeShippingPromotionDataType",
    "FreeShippingPromotionUpdate",
    "FreeShippingPromotionUpdateData",
    "FreeShippingPromotionUpdateDataAttributes",
    "FreeShippingPromotionUpdateDataAttributesMetadata",
    "FreeShippingPromotionUpdateDataRelationships",
    "FreeShippingPromotionUpdateDataRelationshipsCouponCodesPromotionRule",
    "FreeShippingPromotionUpdateDataRelationshipsCouponCodesPromotionRuleData",
    "FreeShippingPromotionUpdateDataRelationshipsCouponCodesPromotionRuleDataType",
    "FreeShippingPromotionUpdateDataRelationshipsMarket",
    "FreeShippingPromotionUpdateDataRelationshipsMarketData",
    "FreeShippingPromotionUpdateDataRelationshipsMarketDataType",
    "FreeShippingPromotionUpdateDataRelationshipsOrderAmountPromotionRule",
    "FreeShippingPromotionUpdateDataRelationshipsOrderAmountPromotionRuleData",
    "FreeShippingPromotionUpdateDataRelationshipsOrderAmountPromotionRuleDataType",
    "FreeShippingPromotionUpdateDataRelationshipsPromotionRules",
    "FreeShippingPromotionUpdateDataRelationshipsPromotionRulesData",
    "FreeShippingPromotionUpdateDataRelationshipsPromotionRulesDataType",
    "FreeShippingPromotionUpdateDataRelationshipsSkuListPromotionRule",
    "FreeShippingPromotionUpdateDataRelationshipsSkuListPromotionRuleData",
    "FreeShippingPromotionUpdateDataRelationshipsSkuListPromotionRuleDataType",
    "FreeShippingPromotionUpdateDataType",
    "Geocoder",
    "GeocoderData",
    "GeocoderDataAttributes",
    "GeocoderDataAttributesMetadata",
    "GeocoderDataRelationships",
    "GeocoderDataRelationshipsAddresses",
    "GeocoderDataRelationshipsAddressesData",
    "GeocoderDataRelationshipsAddressesDataType",
    "GeocoderDataRelationshipsAttachments",
    "GeocoderDataRelationshipsAttachmentsData",
    "GeocoderDataRelationshipsAttachmentsDataType",
    "GeocoderDataType",
    "GETaddressesaddressIdResponse200",
    "GETaddressesaddressIdResponse200Data",
    "GETaddressesaddressIdResponse200DataAttributes",
    "GETaddressesaddressIdResponse200DataAttributesMetadata",
    "GETaddressesaddressIdResponse200DataLinks",
    "GETaddressesaddressIdResponse200DataRelationships",
    "GETaddressesaddressIdResponse200DataRelationshipsGeocoder",
    "GETaddressesaddressIdResponse200DataRelationshipsGeocoderData",
    "GETaddressesaddressIdResponse200DataRelationshipsGeocoderDataType",
    "GETaddressesaddressIdResponse200DataRelationshipsGeocoderLinks",
    "GETaddressesaddressIdResponse200DataType",
    "GETaddressesResponse200",
    "GETaddressesResponse200DataItem",
    "GETaddressesResponse200DataItemAttributes",
    "GETaddressesResponse200DataItemAttributesMetadata",
    "GETaddressesResponse200DataItemLinks",
    "GETaddressesResponse200DataItemRelationships",
    "GETaddressesResponse200DataItemRelationshipsGeocoder",
    "GETaddressesResponse200DataItemRelationshipsGeocoderData",
    "GETaddressesResponse200DataItemRelationshipsGeocoderDataType",
    "GETaddressesResponse200DataItemRelationshipsGeocoderLinks",
    "GETaddressesResponse200DataItemType",
    "GETadjustmentsadjustmentIdResponse200",
    "GETadjustmentsadjustmentIdResponse200Data",
    "GETadjustmentsadjustmentIdResponse200DataAttributes",
    "GETadjustmentsadjustmentIdResponse200DataAttributesMetadata",
    "GETadjustmentsadjustmentIdResponse200DataLinks",
    "GETadjustmentsadjustmentIdResponse200DataRelationships",
    "GETadjustmentsadjustmentIdResponse200DataType",
    "GETadjustmentsResponse200",
    "GETadjustmentsResponse200DataItem",
    "GETadjustmentsResponse200DataItemAttributes",
    "GETadjustmentsResponse200DataItemAttributesMetadata",
    "GETadjustmentsResponse200DataItemLinks",
    "GETadjustmentsResponse200DataItemRelationships",
    "GETadjustmentsResponse200DataItemType",
    "GETadyenGatewaysadyenGatewayIdResponse200",
    "GETadyenGatewaysadyenGatewayIdResponse200Data",
    "GETadyenGatewaysadyenGatewayIdResponse200DataAttributes",
    "GETadyenGatewaysadyenGatewayIdResponse200DataAttributesMetadata",
    "GETadyenGatewaysadyenGatewayIdResponse200DataLinks",
    "GETadyenGatewaysadyenGatewayIdResponse200DataRelationships",
    "GETadyenGatewaysadyenGatewayIdResponse200DataRelationshipsAdyenPayments",
    "GETadyenGatewaysadyenGatewayIdResponse200DataRelationshipsAdyenPaymentsData",
    "GETadyenGatewaysadyenGatewayIdResponse200DataRelationshipsAdyenPaymentsDataType",
    "GETadyenGatewaysadyenGatewayIdResponse200DataRelationshipsAdyenPaymentsLinks",
    "GETadyenGatewaysadyenGatewayIdResponse200DataRelationshipsPaymentMethods",
    "GETadyenGatewaysadyenGatewayIdResponse200DataRelationshipsPaymentMethodsData",
    "GETadyenGatewaysadyenGatewayIdResponse200DataRelationshipsPaymentMethodsDataType",
    "GETadyenGatewaysadyenGatewayIdResponse200DataRelationshipsPaymentMethodsLinks",
    "GETadyenGatewaysadyenGatewayIdResponse200DataType",
    "GETadyenGatewaysResponse200",
    "GETadyenGatewaysResponse200DataItem",
    "GETadyenGatewaysResponse200DataItemAttributes",
    "GETadyenGatewaysResponse200DataItemAttributesMetadata",
    "GETadyenGatewaysResponse200DataItemLinks",
    "GETadyenGatewaysResponse200DataItemRelationships",
    "GETadyenGatewaysResponse200DataItemRelationshipsAdyenPayments",
    "GETadyenGatewaysResponse200DataItemRelationshipsAdyenPaymentsData",
    "GETadyenGatewaysResponse200DataItemRelationshipsAdyenPaymentsDataType",
    "GETadyenGatewaysResponse200DataItemRelationshipsAdyenPaymentsLinks",
    "GETadyenGatewaysResponse200DataItemRelationshipsPaymentMethods",
    "GETadyenGatewaysResponse200DataItemRelationshipsPaymentMethodsData",
    "GETadyenGatewaysResponse200DataItemRelationshipsPaymentMethodsDataType",
    "GETadyenGatewaysResponse200DataItemRelationshipsPaymentMethodsLinks",
    "GETadyenGatewaysResponse200DataItemType",
    "GETadyenPaymentsadyenPaymentIdResponse200",
    "GETadyenPaymentsadyenPaymentIdResponse200Data",
    "GETadyenPaymentsadyenPaymentIdResponse200DataAttributes",
    "GETadyenPaymentsadyenPaymentIdResponse200DataAttributesMetadata",
    "GETadyenPaymentsadyenPaymentIdResponse200DataAttributesPaymentMethods",
    "GETadyenPaymentsadyenPaymentIdResponse200DataAttributesPaymentRequestData",
    "GETadyenPaymentsadyenPaymentIdResponse200DataAttributesPaymentRequestDetails",
    "GETadyenPaymentsadyenPaymentIdResponse200DataAttributesPaymentResponse",
    "GETadyenPaymentsadyenPaymentIdResponse200DataLinks",
    "GETadyenPaymentsadyenPaymentIdResponse200DataRelationships",
    "GETadyenPaymentsadyenPaymentIdResponse200DataRelationshipsOrder",
    "GETadyenPaymentsadyenPaymentIdResponse200DataRelationshipsOrderData",
    "GETadyenPaymentsadyenPaymentIdResponse200DataRelationshipsOrderDataType",
    "GETadyenPaymentsadyenPaymentIdResponse200DataRelationshipsOrderLinks",
    "GETadyenPaymentsadyenPaymentIdResponse200DataRelationshipsPaymentGateway",
    "GETadyenPaymentsadyenPaymentIdResponse200DataRelationshipsPaymentGatewayData",
    "GETadyenPaymentsadyenPaymentIdResponse200DataRelationshipsPaymentGatewayDataType",
    "GETadyenPaymentsadyenPaymentIdResponse200DataRelationshipsPaymentGatewayLinks",
    "GETadyenPaymentsadyenPaymentIdResponse200DataType",
    "GETadyenPaymentsResponse200",
    "GETadyenPaymentsResponse200DataItem",
    "GETadyenPaymentsResponse200DataItemAttributes",
    "GETadyenPaymentsResponse200DataItemAttributesMetadata",
    "GETadyenPaymentsResponse200DataItemAttributesPaymentMethods",
    "GETadyenPaymentsResponse200DataItemAttributesPaymentRequestData",
    "GETadyenPaymentsResponse200DataItemAttributesPaymentRequestDetails",
    "GETadyenPaymentsResponse200DataItemAttributesPaymentResponse",
    "GETadyenPaymentsResponse200DataItemLinks",
    "GETadyenPaymentsResponse200DataItemRelationships",
    "GETadyenPaymentsResponse200DataItemRelationshipsOrder",
    "GETadyenPaymentsResponse200DataItemRelationshipsOrderData",
    "GETadyenPaymentsResponse200DataItemRelationshipsOrderDataType",
    "GETadyenPaymentsResponse200DataItemRelationshipsOrderLinks",
    "GETadyenPaymentsResponse200DataItemRelationshipsPaymentGateway",
    "GETadyenPaymentsResponse200DataItemRelationshipsPaymentGatewayData",
    "GETadyenPaymentsResponse200DataItemRelationshipsPaymentGatewayDataType",
    "GETadyenPaymentsResponse200DataItemRelationshipsPaymentGatewayLinks",
    "GETadyenPaymentsResponse200DataItemType",
    "GETapplicationapplicationIdResponse200",
    "GETapplicationapplicationIdResponse200Data",
    "GETapplicationapplicationIdResponse200DataAttributes",
    "GETapplicationapplicationIdResponse200DataAttributesMetadata",
    "GETapplicationapplicationIdResponse200DataLinks",
    "GETapplicationapplicationIdResponse200DataRelationships",
    "GETapplicationapplicationIdResponse200DataType",
    "GETattachmentsattachmentIdResponse200",
    "GETattachmentsattachmentIdResponse200Data",
    "GETattachmentsattachmentIdResponse200DataAttributes",
    "GETattachmentsattachmentIdResponse200DataAttributesMetadata",
    "GETattachmentsattachmentIdResponse200DataLinks",
    "GETattachmentsattachmentIdResponse200DataRelationships",
    "GETattachmentsattachmentIdResponse200DataRelationshipsAttachable",
    "GETattachmentsattachmentIdResponse200DataRelationshipsAttachableData",
    "GETattachmentsattachmentIdResponse200DataRelationshipsAttachableDataType",
    "GETattachmentsattachmentIdResponse200DataRelationshipsAttachableLinks",
    "GETattachmentsattachmentIdResponse200DataType",
    "GETattachmentsResponse200",
    "GETattachmentsResponse200DataItem",
    "GETattachmentsResponse200DataItemAttributes",
    "GETattachmentsResponse200DataItemAttributesMetadata",
    "GETattachmentsResponse200DataItemLinks",
    "GETattachmentsResponse200DataItemRelationships",
    "GETattachmentsResponse200DataItemRelationshipsAttachable",
    "GETattachmentsResponse200DataItemRelationshipsAttachableData",
    "GETattachmentsResponse200DataItemRelationshipsAttachableDataType",
    "GETattachmentsResponse200DataItemRelationshipsAttachableLinks",
    "GETattachmentsResponse200DataItemType",
    "GETauthorizationsauthorizationIdResponse200",
    "GETauthorizationsauthorizationIdResponse200Data",
    "GETauthorizationsauthorizationIdResponse200DataAttributes",
    "GETauthorizationsauthorizationIdResponse200DataAttributesMetadata",
    "GETauthorizationsauthorizationIdResponse200DataLinks",
    "GETauthorizationsauthorizationIdResponse200DataRelationships",
    "GETauthorizationsauthorizationIdResponse200DataRelationshipsCaptures",
    "GETauthorizationsauthorizationIdResponse200DataRelationshipsCapturesData",
    "GETauthorizationsauthorizationIdResponse200DataRelationshipsCapturesDataType",
    "GETauthorizationsauthorizationIdResponse200DataRelationshipsCapturesLinks",
    "GETauthorizationsauthorizationIdResponse200DataRelationshipsOrder",
    "GETauthorizationsauthorizationIdResponse200DataRelationshipsOrderData",
    "GETauthorizationsauthorizationIdResponse200DataRelationshipsOrderDataType",
    "GETauthorizationsauthorizationIdResponse200DataRelationshipsOrderLinks",
    "GETauthorizationsauthorizationIdResponse200DataRelationshipsVoids",
    "GETauthorizationsauthorizationIdResponse200DataRelationshipsVoidsData",
    "GETauthorizationsauthorizationIdResponse200DataRelationshipsVoidsDataType",
    "GETauthorizationsauthorizationIdResponse200DataRelationshipsVoidsLinks",
    "GETauthorizationsauthorizationIdResponse200DataType",
    "GETauthorizationsResponse200",
    "GETauthorizationsResponse200DataItem",
    "GETauthorizationsResponse200DataItemAttributes",
    "GETauthorizationsResponse200DataItemAttributesMetadata",
    "GETauthorizationsResponse200DataItemLinks",
    "GETauthorizationsResponse200DataItemRelationships",
    "GETauthorizationsResponse200DataItemRelationshipsCaptures",
    "GETauthorizationsResponse200DataItemRelationshipsCapturesData",
    "GETauthorizationsResponse200DataItemRelationshipsCapturesDataType",
    "GETauthorizationsResponse200DataItemRelationshipsCapturesLinks",
    "GETauthorizationsResponse200DataItemRelationshipsOrder",
    "GETauthorizationsResponse200DataItemRelationshipsOrderData",
    "GETauthorizationsResponse200DataItemRelationshipsOrderDataType",
    "GETauthorizationsResponse200DataItemRelationshipsOrderLinks",
    "GETauthorizationsResponse200DataItemRelationshipsVoids",
    "GETauthorizationsResponse200DataItemRelationshipsVoidsData",
    "GETauthorizationsResponse200DataItemRelationshipsVoidsDataType",
    "GETauthorizationsResponse200DataItemRelationshipsVoidsLinks",
    "GETauthorizationsResponse200DataItemType",
    "GETavalaraAccountsavalaraAccountIdResponse200",
    "GETavalaraAccountsavalaraAccountIdResponse200Data",
    "GETavalaraAccountsavalaraAccountIdResponse200DataAttributes",
    "GETavalaraAccountsavalaraAccountIdResponse200DataAttributesMetadata",
    "GETavalaraAccountsavalaraAccountIdResponse200DataLinks",
    "GETavalaraAccountsavalaraAccountIdResponse200DataRelationships",
    "GETavalaraAccountsavalaraAccountIdResponse200DataRelationshipsAttachments",
    "GETavalaraAccountsavalaraAccountIdResponse200DataRelationshipsAttachmentsData",
    "GETavalaraAccountsavalaraAccountIdResponse200DataRelationshipsAttachmentsDataType",
    "GETavalaraAccountsavalaraAccountIdResponse200DataRelationshipsAttachmentsLinks",
    "GETavalaraAccountsavalaraAccountIdResponse200DataRelationshipsMarkets",
    "GETavalaraAccountsavalaraAccountIdResponse200DataRelationshipsMarketsData",
    "GETavalaraAccountsavalaraAccountIdResponse200DataRelationshipsMarketsDataType",
    "GETavalaraAccountsavalaraAccountIdResponse200DataRelationshipsMarketsLinks",
    "GETavalaraAccountsavalaraAccountIdResponse200DataRelationshipsTaxCategories",
    "GETavalaraAccountsavalaraAccountIdResponse200DataRelationshipsTaxCategoriesData",
    "GETavalaraAccountsavalaraAccountIdResponse200DataRelationshipsTaxCategoriesDataType",
    "GETavalaraAccountsavalaraAccountIdResponse200DataRelationshipsTaxCategoriesLinks",
    "GETavalaraAccountsavalaraAccountIdResponse200DataType",
    "GETavalaraAccountsResponse200",
    "GETavalaraAccountsResponse200DataItem",
    "GETavalaraAccountsResponse200DataItemAttributes",
    "GETavalaraAccountsResponse200DataItemAttributesMetadata",
    "GETavalaraAccountsResponse200DataItemLinks",
    "GETavalaraAccountsResponse200DataItemRelationships",
    "GETavalaraAccountsResponse200DataItemRelationshipsAttachments",
    "GETavalaraAccountsResponse200DataItemRelationshipsAttachmentsData",
    "GETavalaraAccountsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETavalaraAccountsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETavalaraAccountsResponse200DataItemRelationshipsMarkets",
    "GETavalaraAccountsResponse200DataItemRelationshipsMarketsData",
    "GETavalaraAccountsResponse200DataItemRelationshipsMarketsDataType",
    "GETavalaraAccountsResponse200DataItemRelationshipsMarketsLinks",
    "GETavalaraAccountsResponse200DataItemRelationshipsTaxCategories",
    "GETavalaraAccountsResponse200DataItemRelationshipsTaxCategoriesData",
    "GETavalaraAccountsResponse200DataItemRelationshipsTaxCategoriesDataType",
    "GETavalaraAccountsResponse200DataItemRelationshipsTaxCategoriesLinks",
    "GETavalaraAccountsResponse200DataItemType",
    "GETbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200",
    "GETbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200Data",
    "GETbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataAttributes",
    "GETbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataAttributesMetadata",
    "GETbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataLinks",
    "GETbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataRelationships",
    "GETbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataRelationshipsMarket",
    "GETbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataRelationshipsMarketData",
    "GETbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataRelationshipsMarketDataType",
    "GETbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataRelationshipsMarketLinks",
    "GETbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataType",
    "GETbillingInfoValidationRulesResponse200",
    "GETbillingInfoValidationRulesResponse200DataItem",
    "GETbillingInfoValidationRulesResponse200DataItemAttributes",
    "GETbillingInfoValidationRulesResponse200DataItemAttributesMetadata",
    "GETbillingInfoValidationRulesResponse200DataItemLinks",
    "GETbillingInfoValidationRulesResponse200DataItemRelationships",
    "GETbillingInfoValidationRulesResponse200DataItemRelationshipsMarket",
    "GETbillingInfoValidationRulesResponse200DataItemRelationshipsMarketData",
    "GETbillingInfoValidationRulesResponse200DataItemRelationshipsMarketDataType",
    "GETbillingInfoValidationRulesResponse200DataItemRelationshipsMarketLinks",
    "GETbillingInfoValidationRulesResponse200DataItemType",
    "GETbingGeocodersbingGeocoderIdResponse200",
    "GETbingGeocodersbingGeocoderIdResponse200Data",
    "GETbingGeocodersbingGeocoderIdResponse200DataAttributes",
    "GETbingGeocodersbingGeocoderIdResponse200DataAttributesMetadata",
    "GETbingGeocodersbingGeocoderIdResponse200DataLinks",
    "GETbingGeocodersbingGeocoderIdResponse200DataRelationships",
    "GETbingGeocodersbingGeocoderIdResponse200DataRelationshipsAddresses",
    "GETbingGeocodersbingGeocoderIdResponse200DataRelationshipsAddressesData",
    "GETbingGeocodersbingGeocoderIdResponse200DataRelationshipsAddressesDataType",
    "GETbingGeocodersbingGeocoderIdResponse200DataRelationshipsAddressesLinks",
    "GETbingGeocodersbingGeocoderIdResponse200DataRelationshipsAttachments",
    "GETbingGeocodersbingGeocoderIdResponse200DataRelationshipsAttachmentsData",
    "GETbingGeocodersbingGeocoderIdResponse200DataRelationshipsAttachmentsDataType",
    "GETbingGeocodersbingGeocoderIdResponse200DataRelationshipsAttachmentsLinks",
    "GETbingGeocodersbingGeocoderIdResponse200DataType",
    "GETbingGeocodersResponse200",
    "GETbingGeocodersResponse200DataItem",
    "GETbingGeocodersResponse200DataItemAttributes",
    "GETbingGeocodersResponse200DataItemAttributesMetadata",
    "GETbingGeocodersResponse200DataItemLinks",
    "GETbingGeocodersResponse200DataItemRelationships",
    "GETbingGeocodersResponse200DataItemRelationshipsAddresses",
    "GETbingGeocodersResponse200DataItemRelationshipsAddressesData",
    "GETbingGeocodersResponse200DataItemRelationshipsAddressesDataType",
    "GETbingGeocodersResponse200DataItemRelationshipsAddressesLinks",
    "GETbingGeocodersResponse200DataItemRelationshipsAttachments",
    "GETbingGeocodersResponse200DataItemRelationshipsAttachmentsData",
    "GETbingGeocodersResponse200DataItemRelationshipsAttachmentsDataType",
    "GETbingGeocodersResponse200DataItemRelationshipsAttachmentsLinks",
    "GETbingGeocodersResponse200DataItemType",
    "GETbraintreeGatewaysbraintreeGatewayIdResponse200",
    "GETbraintreeGatewaysbraintreeGatewayIdResponse200Data",
    "GETbraintreeGatewaysbraintreeGatewayIdResponse200DataAttributes",
    "GETbraintreeGatewaysbraintreeGatewayIdResponse200DataAttributesMetadata",
    "GETbraintreeGatewaysbraintreeGatewayIdResponse200DataLinks",
    "GETbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationships",
    "GETbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsBraintreePayments",
    "GETbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsBraintreePaymentsData",
    "GETbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsBraintreePaymentsDataType",
    "GETbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsBraintreePaymentsLinks",
    "GETbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsPaymentMethods",
    "GETbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsPaymentMethodsData",
    "GETbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsPaymentMethodsDataType",
    "GETbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsPaymentMethodsLinks",
    "GETbraintreeGatewaysbraintreeGatewayIdResponse200DataType",
    "GETbraintreeGatewaysResponse200",
    "GETbraintreeGatewaysResponse200DataItem",
    "GETbraintreeGatewaysResponse200DataItemAttributes",
    "GETbraintreeGatewaysResponse200DataItemAttributesMetadata",
    "GETbraintreeGatewaysResponse200DataItemLinks",
    "GETbraintreeGatewaysResponse200DataItemRelationships",
    "GETbraintreeGatewaysResponse200DataItemRelationshipsBraintreePayments",
    "GETbraintreeGatewaysResponse200DataItemRelationshipsBraintreePaymentsData",
    "GETbraintreeGatewaysResponse200DataItemRelationshipsBraintreePaymentsDataType",
    "GETbraintreeGatewaysResponse200DataItemRelationshipsBraintreePaymentsLinks",
    "GETbraintreeGatewaysResponse200DataItemRelationshipsPaymentMethods",
    "GETbraintreeGatewaysResponse200DataItemRelationshipsPaymentMethodsData",
    "GETbraintreeGatewaysResponse200DataItemRelationshipsPaymentMethodsDataType",
    "GETbraintreeGatewaysResponse200DataItemRelationshipsPaymentMethodsLinks",
    "GETbraintreeGatewaysResponse200DataItemType",
    "GETbraintreePaymentsbraintreePaymentIdResponse200",
    "GETbraintreePaymentsbraintreePaymentIdResponse200Data",
    "GETbraintreePaymentsbraintreePaymentIdResponse200DataAttributes",
    "GETbraintreePaymentsbraintreePaymentIdResponse200DataAttributesMetadata",
    "GETbraintreePaymentsbraintreePaymentIdResponse200DataAttributesOptions",
    "GETbraintreePaymentsbraintreePaymentIdResponse200DataLinks",
    "GETbraintreePaymentsbraintreePaymentIdResponse200DataRelationships",
    "GETbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsOrder",
    "GETbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsOrderData",
    "GETbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsOrderDataType",
    "GETbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsOrderLinks",
    "GETbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsPaymentGateway",
    "GETbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsPaymentGatewayData",
    "GETbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsPaymentGatewayDataType",
    "GETbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsPaymentGatewayLinks",
    "GETbraintreePaymentsbraintreePaymentIdResponse200DataType",
    "GETbraintreePaymentsResponse200",
    "GETbraintreePaymentsResponse200DataItem",
    "GETbraintreePaymentsResponse200DataItemAttributes",
    "GETbraintreePaymentsResponse200DataItemAttributesMetadata",
    "GETbraintreePaymentsResponse200DataItemAttributesOptions",
    "GETbraintreePaymentsResponse200DataItemLinks",
    "GETbraintreePaymentsResponse200DataItemRelationships",
    "GETbraintreePaymentsResponse200DataItemRelationshipsOrder",
    "GETbraintreePaymentsResponse200DataItemRelationshipsOrderData",
    "GETbraintreePaymentsResponse200DataItemRelationshipsOrderDataType",
    "GETbraintreePaymentsResponse200DataItemRelationshipsOrderLinks",
    "GETbraintreePaymentsResponse200DataItemRelationshipsPaymentGateway",
    "GETbraintreePaymentsResponse200DataItemRelationshipsPaymentGatewayData",
    "GETbraintreePaymentsResponse200DataItemRelationshipsPaymentGatewayDataType",
    "GETbraintreePaymentsResponse200DataItemRelationshipsPaymentGatewayLinks",
    "GETbraintreePaymentsResponse200DataItemType",
    "GETbundlesbundleIdResponse200",
    "GETbundlesbundleIdResponse200Data",
    "GETbundlesbundleIdResponse200DataAttributes",
    "GETbundlesbundleIdResponse200DataAttributesMetadata",
    "GETbundlesbundleIdResponse200DataLinks",
    "GETbundlesbundleIdResponse200DataRelationships",
    "GETbundlesbundleIdResponse200DataRelationshipsAttachments",
    "GETbundlesbundleIdResponse200DataRelationshipsAttachmentsData",
    "GETbundlesbundleIdResponse200DataRelationshipsAttachmentsDataType",
    "GETbundlesbundleIdResponse200DataRelationshipsAttachmentsLinks",
    "GETbundlesbundleIdResponse200DataRelationshipsMarket",
    "GETbundlesbundleIdResponse200DataRelationshipsMarketData",
    "GETbundlesbundleIdResponse200DataRelationshipsMarketDataType",
    "GETbundlesbundleIdResponse200DataRelationshipsMarketLinks",
    "GETbundlesbundleIdResponse200DataRelationshipsSkuList",
    "GETbundlesbundleIdResponse200DataRelationshipsSkuListData",
    "GETbundlesbundleIdResponse200DataRelationshipsSkuListDataType",
    "GETbundlesbundleIdResponse200DataRelationshipsSkuListLinks",
    "GETbundlesbundleIdResponse200DataRelationshipsSkus",
    "GETbundlesbundleIdResponse200DataRelationshipsSkusData",
    "GETbundlesbundleIdResponse200DataRelationshipsSkusDataType",
    "GETbundlesbundleIdResponse200DataRelationshipsSkusLinks",
    "GETbundlesbundleIdResponse200DataType",
    "GETbundlesResponse200",
    "GETbundlesResponse200DataItem",
    "GETbundlesResponse200DataItemAttributes",
    "GETbundlesResponse200DataItemAttributesMetadata",
    "GETbundlesResponse200DataItemLinks",
    "GETbundlesResponse200DataItemRelationships",
    "GETbundlesResponse200DataItemRelationshipsAttachments",
    "GETbundlesResponse200DataItemRelationshipsAttachmentsData",
    "GETbundlesResponse200DataItemRelationshipsAttachmentsDataType",
    "GETbundlesResponse200DataItemRelationshipsAttachmentsLinks",
    "GETbundlesResponse200DataItemRelationshipsMarket",
    "GETbundlesResponse200DataItemRelationshipsMarketData",
    "GETbundlesResponse200DataItemRelationshipsMarketDataType",
    "GETbundlesResponse200DataItemRelationshipsMarketLinks",
    "GETbundlesResponse200DataItemRelationshipsSkuList",
    "GETbundlesResponse200DataItemRelationshipsSkuListData",
    "GETbundlesResponse200DataItemRelationshipsSkuListDataType",
    "GETbundlesResponse200DataItemRelationshipsSkuListLinks",
    "GETbundlesResponse200DataItemRelationshipsSkus",
    "GETbundlesResponse200DataItemRelationshipsSkusData",
    "GETbundlesResponse200DataItemRelationshipsSkusDataType",
    "GETbundlesResponse200DataItemRelationshipsSkusLinks",
    "GETbundlesResponse200DataItemType",
    "GETcapturescaptureIdResponse200",
    "GETcapturescaptureIdResponse200Data",
    "GETcapturescaptureIdResponse200DataAttributes",
    "GETcapturescaptureIdResponse200DataAttributesMetadata",
    "GETcapturescaptureIdResponse200DataLinks",
    "GETcapturescaptureIdResponse200DataRelationships",
    "GETcapturescaptureIdResponse200DataRelationshipsOrder",
    "GETcapturescaptureIdResponse200DataRelationshipsOrderData",
    "GETcapturescaptureIdResponse200DataRelationshipsOrderDataType",
    "GETcapturescaptureIdResponse200DataRelationshipsOrderLinks",
    "GETcapturescaptureIdResponse200DataRelationshipsReferenceAuthorization",
    "GETcapturescaptureIdResponse200DataRelationshipsReferenceAuthorizationData",
    "GETcapturescaptureIdResponse200DataRelationshipsReferenceAuthorizationDataType",
    "GETcapturescaptureIdResponse200DataRelationshipsReferenceAuthorizationLinks",
    "GETcapturescaptureIdResponse200DataRelationshipsRefunds",
    "GETcapturescaptureIdResponse200DataRelationshipsRefundsData",
    "GETcapturescaptureIdResponse200DataRelationshipsRefundsDataType",
    "GETcapturescaptureIdResponse200DataRelationshipsRefundsLinks",
    "GETcapturescaptureIdResponse200DataType",
    "GETcapturesResponse200",
    "GETcapturesResponse200DataItem",
    "GETcapturesResponse200DataItemAttributes",
    "GETcapturesResponse200DataItemAttributesMetadata",
    "GETcapturesResponse200DataItemLinks",
    "GETcapturesResponse200DataItemRelationships",
    "GETcapturesResponse200DataItemRelationshipsOrder",
    "GETcapturesResponse200DataItemRelationshipsOrderData",
    "GETcapturesResponse200DataItemRelationshipsOrderDataType",
    "GETcapturesResponse200DataItemRelationshipsOrderLinks",
    "GETcapturesResponse200DataItemRelationshipsReferenceAuthorization",
    "GETcapturesResponse200DataItemRelationshipsReferenceAuthorizationData",
    "GETcapturesResponse200DataItemRelationshipsReferenceAuthorizationDataType",
    "GETcapturesResponse200DataItemRelationshipsReferenceAuthorizationLinks",
    "GETcapturesResponse200DataItemRelationshipsRefunds",
    "GETcapturesResponse200DataItemRelationshipsRefundsData",
    "GETcapturesResponse200DataItemRelationshipsRefundsDataType",
    "GETcapturesResponse200DataItemRelationshipsRefundsLinks",
    "GETcapturesResponse200DataItemType",
    "GETcarrierAccountscarrierAccountIdResponse200",
    "GETcarrierAccountscarrierAccountIdResponse200Data",
    "GETcarrierAccountscarrierAccountIdResponse200DataAttributes",
    "GETcarrierAccountscarrierAccountIdResponse200DataAttributesMetadata",
    "GETcarrierAccountscarrierAccountIdResponse200DataLinks",
    "GETcarrierAccountscarrierAccountIdResponse200DataRelationships",
    "GETcarrierAccountscarrierAccountIdResponse200DataRelationshipsAttachments",
    "GETcarrierAccountscarrierAccountIdResponse200DataRelationshipsAttachmentsData",
    "GETcarrierAccountscarrierAccountIdResponse200DataRelationshipsAttachmentsDataType",
    "GETcarrierAccountscarrierAccountIdResponse200DataRelationshipsAttachmentsLinks",
    "GETcarrierAccountscarrierAccountIdResponse200DataRelationshipsMarket",
    "GETcarrierAccountscarrierAccountIdResponse200DataRelationshipsMarketData",
    "GETcarrierAccountscarrierAccountIdResponse200DataRelationshipsMarketDataType",
    "GETcarrierAccountscarrierAccountIdResponse200DataRelationshipsMarketLinks",
    "GETcarrierAccountscarrierAccountIdResponse200DataType",
    "GETcarrierAccountsResponse200",
    "GETcarrierAccountsResponse200DataItem",
    "GETcarrierAccountsResponse200DataItemAttributes",
    "GETcarrierAccountsResponse200DataItemAttributesMetadata",
    "GETcarrierAccountsResponse200DataItemLinks",
    "GETcarrierAccountsResponse200DataItemRelationships",
    "GETcarrierAccountsResponse200DataItemRelationshipsAttachments",
    "GETcarrierAccountsResponse200DataItemRelationshipsAttachmentsData",
    "GETcarrierAccountsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETcarrierAccountsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETcarrierAccountsResponse200DataItemRelationshipsMarket",
    "GETcarrierAccountsResponse200DataItemRelationshipsMarketData",
    "GETcarrierAccountsResponse200DataItemRelationshipsMarketDataType",
    "GETcarrierAccountsResponse200DataItemRelationshipsMarketLinks",
    "GETcarrierAccountsResponse200DataItemType",
    "GETcheckoutComGatewayscheckoutComGatewayIdResponse200",
    "GETcheckoutComGatewayscheckoutComGatewayIdResponse200Data",
    "GETcheckoutComGatewayscheckoutComGatewayIdResponse200DataAttributes",
    "GETcheckoutComGatewayscheckoutComGatewayIdResponse200DataAttributesMetadata",
    "GETcheckoutComGatewayscheckoutComGatewayIdResponse200DataLinks",
    "GETcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationships",
    "GETcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsCheckoutComPayments",
    "GETcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsCheckoutComPaymentsData",
    "GETcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsCheckoutComPaymentsDataType",
    "GETcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsCheckoutComPaymentsLinks",
    "GETcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsPaymentMethods",
    "GETcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsPaymentMethodsData",
    "GETcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsPaymentMethodsDataType",
    "GETcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsPaymentMethodsLinks",
    "GETcheckoutComGatewayscheckoutComGatewayIdResponse200DataType",
    "GETcheckoutComGatewaysResponse200",
    "GETcheckoutComGatewaysResponse200DataItem",
    "GETcheckoutComGatewaysResponse200DataItemAttributes",
    "GETcheckoutComGatewaysResponse200DataItemAttributesMetadata",
    "GETcheckoutComGatewaysResponse200DataItemLinks",
    "GETcheckoutComGatewaysResponse200DataItemRelationships",
    "GETcheckoutComGatewaysResponse200DataItemRelationshipsCheckoutComPayments",
    "GETcheckoutComGatewaysResponse200DataItemRelationshipsCheckoutComPaymentsData",
    "GETcheckoutComGatewaysResponse200DataItemRelationshipsCheckoutComPaymentsDataType",
    "GETcheckoutComGatewaysResponse200DataItemRelationshipsCheckoutComPaymentsLinks",
    "GETcheckoutComGatewaysResponse200DataItemRelationshipsPaymentMethods",
    "GETcheckoutComGatewaysResponse200DataItemRelationshipsPaymentMethodsData",
    "GETcheckoutComGatewaysResponse200DataItemRelationshipsPaymentMethodsDataType",
    "GETcheckoutComGatewaysResponse200DataItemRelationshipsPaymentMethodsLinks",
    "GETcheckoutComGatewaysResponse200DataItemType",
    "GETcheckoutComPaymentscheckoutComPaymentIdResponse200",
    "GETcheckoutComPaymentscheckoutComPaymentIdResponse200Data",
    "GETcheckoutComPaymentscheckoutComPaymentIdResponse200DataAttributes",
    "GETcheckoutComPaymentscheckoutComPaymentIdResponse200DataAttributesMetadata",
    "GETcheckoutComPaymentscheckoutComPaymentIdResponse200DataAttributesPaymentResponse",
    "GETcheckoutComPaymentscheckoutComPaymentIdResponse200DataLinks",
    "GETcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationships",
    "GETcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsOrder",
    "GETcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsOrderData",
    "GETcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsOrderDataType",
    "GETcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsOrderLinks",
    "GETcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsPaymentGateway",
    "GETcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsPaymentGatewayData",
    "GETcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsPaymentGatewayDataType",
    "GETcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsPaymentGatewayLinks",
    "GETcheckoutComPaymentscheckoutComPaymentIdResponse200DataType",
    "GETcheckoutComPaymentsResponse200",
    "GETcheckoutComPaymentsResponse200DataItem",
    "GETcheckoutComPaymentsResponse200DataItemAttributes",
    "GETcheckoutComPaymentsResponse200DataItemAttributesMetadata",
    "GETcheckoutComPaymentsResponse200DataItemAttributesPaymentResponse",
    "GETcheckoutComPaymentsResponse200DataItemLinks",
    "GETcheckoutComPaymentsResponse200DataItemRelationships",
    "GETcheckoutComPaymentsResponse200DataItemRelationshipsOrder",
    "GETcheckoutComPaymentsResponse200DataItemRelationshipsOrderData",
    "GETcheckoutComPaymentsResponse200DataItemRelationshipsOrderDataType",
    "GETcheckoutComPaymentsResponse200DataItemRelationshipsOrderLinks",
    "GETcheckoutComPaymentsResponse200DataItemRelationshipsPaymentGateway",
    "GETcheckoutComPaymentsResponse200DataItemRelationshipsPaymentGatewayData",
    "GETcheckoutComPaymentsResponse200DataItemRelationshipsPaymentGatewayDataType",
    "GETcheckoutComPaymentsResponse200DataItemRelationshipsPaymentGatewayLinks",
    "GETcheckoutComPaymentsResponse200DataItemType",
    "GETcleanupscleanupIdResponse200",
    "GETcleanupscleanupIdResponse200Data",
    "GETcleanupscleanupIdResponse200DataAttributes",
    "GETcleanupscleanupIdResponse200DataAttributesErrorsLog",
    "GETcleanupscleanupIdResponse200DataAttributesFilters",
    "GETcleanupscleanupIdResponse200DataAttributesMetadata",
    "GETcleanupscleanupIdResponse200DataLinks",
    "GETcleanupscleanupIdResponse200DataRelationships",
    "GETcleanupscleanupIdResponse200DataRelationshipsEvents",
    "GETcleanupscleanupIdResponse200DataRelationshipsEventsData",
    "GETcleanupscleanupIdResponse200DataRelationshipsEventsDataType",
    "GETcleanupscleanupIdResponse200DataRelationshipsEventsLinks",
    "GETcleanupscleanupIdResponse200DataType",
    "GETcleanupsResponse200",
    "GETcleanupsResponse200DataItem",
    "GETcleanupsResponse200DataItemAttributes",
    "GETcleanupsResponse200DataItemAttributesErrorsLog",
    "GETcleanupsResponse200DataItemAttributesFilters",
    "GETcleanupsResponse200DataItemAttributesMetadata",
    "GETcleanupsResponse200DataItemLinks",
    "GETcleanupsResponse200DataItemRelationships",
    "GETcleanupsResponse200DataItemRelationshipsEvents",
    "GETcleanupsResponse200DataItemRelationshipsEventsData",
    "GETcleanupsResponse200DataItemRelationshipsEventsDataType",
    "GETcleanupsResponse200DataItemRelationshipsEventsLinks",
    "GETcleanupsResponse200DataItemType",
    "GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200",
    "GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200Data",
    "GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataAttributes",
    "GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataAttributesMetadata",
    "GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataLinks",
    "GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationships",
    "GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsCoupons",
    "GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsCouponsData",
    "GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsCouponsDataType",
    "GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsCouponsLinks",
    "GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsPromotion",
    "GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsPromotionData",
    "GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsPromotionDataType",
    "GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsPromotionLinks",
    "GETcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataType",
    "GETcouponCodesPromotionRulesResponse200",
    "GETcouponCodesPromotionRulesResponse200DataItem",
    "GETcouponCodesPromotionRulesResponse200DataItemAttributes",
    "GETcouponCodesPromotionRulesResponse200DataItemAttributesMetadata",
    "GETcouponCodesPromotionRulesResponse200DataItemLinks",
    "GETcouponCodesPromotionRulesResponse200DataItemRelationships",
    "GETcouponCodesPromotionRulesResponse200DataItemRelationshipsCoupons",
    "GETcouponCodesPromotionRulesResponse200DataItemRelationshipsCouponsData",
    "GETcouponCodesPromotionRulesResponse200DataItemRelationshipsCouponsDataType",
    "GETcouponCodesPromotionRulesResponse200DataItemRelationshipsCouponsLinks",
    "GETcouponCodesPromotionRulesResponse200DataItemRelationshipsPromotion",
    "GETcouponCodesPromotionRulesResponse200DataItemRelationshipsPromotionData",
    "GETcouponCodesPromotionRulesResponse200DataItemRelationshipsPromotionDataType",
    "GETcouponCodesPromotionRulesResponse200DataItemRelationshipsPromotionLinks",
    "GETcouponCodesPromotionRulesResponse200DataItemType",
    "GETcouponRecipientscouponRecipientIdResponse200",
    "GETcouponRecipientscouponRecipientIdResponse200Data",
    "GETcouponRecipientscouponRecipientIdResponse200DataAttributes",
    "GETcouponRecipientscouponRecipientIdResponse200DataAttributesMetadata",
    "GETcouponRecipientscouponRecipientIdResponse200DataLinks",
    "GETcouponRecipientscouponRecipientIdResponse200DataRelationships",
    "GETcouponRecipientscouponRecipientIdResponse200DataRelationshipsAttachments",
    "GETcouponRecipientscouponRecipientIdResponse200DataRelationshipsAttachmentsData",
    "GETcouponRecipientscouponRecipientIdResponse200DataRelationshipsAttachmentsDataType",
    "GETcouponRecipientscouponRecipientIdResponse200DataRelationshipsAttachmentsLinks",
    "GETcouponRecipientscouponRecipientIdResponse200DataRelationshipsCustomer",
    "GETcouponRecipientscouponRecipientIdResponse200DataRelationshipsCustomerData",
    "GETcouponRecipientscouponRecipientIdResponse200DataRelationshipsCustomerDataType",
    "GETcouponRecipientscouponRecipientIdResponse200DataRelationshipsCustomerLinks",
    "GETcouponRecipientscouponRecipientIdResponse200DataType",
    "GETcouponRecipientsResponse200",
    "GETcouponRecipientsResponse200DataItem",
    "GETcouponRecipientsResponse200DataItemAttributes",
    "GETcouponRecipientsResponse200DataItemAttributesMetadata",
    "GETcouponRecipientsResponse200DataItemLinks",
    "GETcouponRecipientsResponse200DataItemRelationships",
    "GETcouponRecipientsResponse200DataItemRelationshipsAttachments",
    "GETcouponRecipientsResponse200DataItemRelationshipsAttachmentsData",
    "GETcouponRecipientsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETcouponRecipientsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETcouponRecipientsResponse200DataItemRelationshipsCustomer",
    "GETcouponRecipientsResponse200DataItemRelationshipsCustomerData",
    "GETcouponRecipientsResponse200DataItemRelationshipsCustomerDataType",
    "GETcouponRecipientsResponse200DataItemRelationshipsCustomerLinks",
    "GETcouponRecipientsResponse200DataItemType",
    "GETcouponscouponIdResponse200",
    "GETcouponscouponIdResponse200Data",
    "GETcouponscouponIdResponse200DataAttributes",
    "GETcouponscouponIdResponse200DataAttributesMetadata",
    "GETcouponscouponIdResponse200DataLinks",
    "GETcouponscouponIdResponse200DataRelationships",
    "GETcouponscouponIdResponse200DataRelationshipsPromotionRule",
    "GETcouponscouponIdResponse200DataRelationshipsPromotionRuleData",
    "GETcouponscouponIdResponse200DataRelationshipsPromotionRuleDataType",
    "GETcouponscouponIdResponse200DataRelationshipsPromotionRuleLinks",
    "GETcouponscouponIdResponse200DataType",
    "GETcouponsResponse200",
    "GETcouponsResponse200DataItem",
    "GETcouponsResponse200DataItemAttributes",
    "GETcouponsResponse200DataItemAttributesMetadata",
    "GETcouponsResponse200DataItemLinks",
    "GETcouponsResponse200DataItemRelationships",
    "GETcouponsResponse200DataItemRelationshipsPromotionRule",
    "GETcouponsResponse200DataItemRelationshipsPromotionRuleData",
    "GETcouponsResponse200DataItemRelationshipsPromotionRuleDataType",
    "GETcouponsResponse200DataItemRelationshipsPromotionRuleLinks",
    "GETcouponsResponse200DataItemType",
    "GETcustomerAddressescustomerAddressIdResponse200",
    "GETcustomerAddressescustomerAddressIdResponse200Data",
    "GETcustomerAddressescustomerAddressIdResponse200DataAttributes",
    "GETcustomerAddressescustomerAddressIdResponse200DataAttributesMetadata",
    "GETcustomerAddressescustomerAddressIdResponse200DataLinks",
    "GETcustomerAddressescustomerAddressIdResponse200DataRelationships",
    "GETcustomerAddressescustomerAddressIdResponse200DataRelationshipsAddress",
    "GETcustomerAddressescustomerAddressIdResponse200DataRelationshipsAddressData",
    "GETcustomerAddressescustomerAddressIdResponse200DataRelationshipsAddressDataType",
    "GETcustomerAddressescustomerAddressIdResponse200DataRelationshipsAddressLinks",
    "GETcustomerAddressescustomerAddressIdResponse200DataRelationshipsCustomer",
    "GETcustomerAddressescustomerAddressIdResponse200DataRelationshipsCustomerData",
    "GETcustomerAddressescustomerAddressIdResponse200DataRelationshipsCustomerDataType",
    "GETcustomerAddressescustomerAddressIdResponse200DataRelationshipsCustomerLinks",
    "GETcustomerAddressescustomerAddressIdResponse200DataRelationshipsEvents",
    "GETcustomerAddressescustomerAddressIdResponse200DataRelationshipsEventsData",
    "GETcustomerAddressescustomerAddressIdResponse200DataRelationshipsEventsDataType",
    "GETcustomerAddressescustomerAddressIdResponse200DataRelationshipsEventsLinks",
    "GETcustomerAddressescustomerAddressIdResponse200DataType",
    "GETcustomerAddressesResponse200",
    "GETcustomerAddressesResponse200DataItem",
    "GETcustomerAddressesResponse200DataItemAttributes",
    "GETcustomerAddressesResponse200DataItemAttributesMetadata",
    "GETcustomerAddressesResponse200DataItemLinks",
    "GETcustomerAddressesResponse200DataItemRelationships",
    "GETcustomerAddressesResponse200DataItemRelationshipsAddress",
    "GETcustomerAddressesResponse200DataItemRelationshipsAddressData",
    "GETcustomerAddressesResponse200DataItemRelationshipsAddressDataType",
    "GETcustomerAddressesResponse200DataItemRelationshipsAddressLinks",
    "GETcustomerAddressesResponse200DataItemRelationshipsCustomer",
    "GETcustomerAddressesResponse200DataItemRelationshipsCustomerData",
    "GETcustomerAddressesResponse200DataItemRelationshipsCustomerDataType",
    "GETcustomerAddressesResponse200DataItemRelationshipsCustomerLinks",
    "GETcustomerAddressesResponse200DataItemRelationshipsEvents",
    "GETcustomerAddressesResponse200DataItemRelationshipsEventsData",
    "GETcustomerAddressesResponse200DataItemRelationshipsEventsDataType",
    "GETcustomerAddressesResponse200DataItemRelationshipsEventsLinks",
    "GETcustomerAddressesResponse200DataItemType",
    "GETcustomerGroupscustomerGroupIdResponse200",
    "GETcustomerGroupscustomerGroupIdResponse200Data",
    "GETcustomerGroupscustomerGroupIdResponse200DataAttributes",
    "GETcustomerGroupscustomerGroupIdResponse200DataAttributesMetadata",
    "GETcustomerGroupscustomerGroupIdResponse200DataLinks",
    "GETcustomerGroupscustomerGroupIdResponse200DataRelationships",
    "GETcustomerGroupscustomerGroupIdResponse200DataRelationshipsAttachments",
    "GETcustomerGroupscustomerGroupIdResponse200DataRelationshipsAttachmentsData",
    "GETcustomerGroupscustomerGroupIdResponse200DataRelationshipsAttachmentsDataType",
    "GETcustomerGroupscustomerGroupIdResponse200DataRelationshipsAttachmentsLinks",
    "GETcustomerGroupscustomerGroupIdResponse200DataRelationshipsCustomers",
    "GETcustomerGroupscustomerGroupIdResponse200DataRelationshipsCustomersData",
    "GETcustomerGroupscustomerGroupIdResponse200DataRelationshipsCustomersDataType",
    "GETcustomerGroupscustomerGroupIdResponse200DataRelationshipsCustomersLinks",
    "GETcustomerGroupscustomerGroupIdResponse200DataRelationshipsMarkets",
    "GETcustomerGroupscustomerGroupIdResponse200DataRelationshipsMarketsData",
    "GETcustomerGroupscustomerGroupIdResponse200DataRelationshipsMarketsDataType",
    "GETcustomerGroupscustomerGroupIdResponse200DataRelationshipsMarketsLinks",
    "GETcustomerGroupscustomerGroupIdResponse200DataType",
    "GETcustomerGroupsResponse200",
    "GETcustomerGroupsResponse200DataItem",
    "GETcustomerGroupsResponse200DataItemAttributes",
    "GETcustomerGroupsResponse200DataItemAttributesMetadata",
    "GETcustomerGroupsResponse200DataItemLinks",
    "GETcustomerGroupsResponse200DataItemRelationships",
    "GETcustomerGroupsResponse200DataItemRelationshipsAttachments",
    "GETcustomerGroupsResponse200DataItemRelationshipsAttachmentsData",
    "GETcustomerGroupsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETcustomerGroupsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETcustomerGroupsResponse200DataItemRelationshipsCustomers",
    "GETcustomerGroupsResponse200DataItemRelationshipsCustomersData",
    "GETcustomerGroupsResponse200DataItemRelationshipsCustomersDataType",
    "GETcustomerGroupsResponse200DataItemRelationshipsCustomersLinks",
    "GETcustomerGroupsResponse200DataItemRelationshipsMarkets",
    "GETcustomerGroupsResponse200DataItemRelationshipsMarketsData",
    "GETcustomerGroupsResponse200DataItemRelationshipsMarketsDataType",
    "GETcustomerGroupsResponse200DataItemRelationshipsMarketsLinks",
    "GETcustomerGroupsResponse200DataItemType",
    "GETcustomerPasswordResetscustomerPasswordResetIdResponse200",
    "GETcustomerPasswordResetscustomerPasswordResetIdResponse200Data",
    "GETcustomerPasswordResetscustomerPasswordResetIdResponse200DataAttributes",
    "GETcustomerPasswordResetscustomerPasswordResetIdResponse200DataAttributesMetadata",
    "GETcustomerPasswordResetscustomerPasswordResetIdResponse200DataLinks",
    "GETcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationships",
    "GETcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsCustomer",
    "GETcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsCustomerData",
    "GETcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsCustomerDataType",
    "GETcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsCustomerLinks",
    "GETcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsEvents",
    "GETcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsEventsData",
    "GETcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsEventsDataType",
    "GETcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsEventsLinks",
    "GETcustomerPasswordResetscustomerPasswordResetIdResponse200DataType",
    "GETcustomerPasswordResetsResponse200",
    "GETcustomerPasswordResetsResponse200DataItem",
    "GETcustomerPasswordResetsResponse200DataItemAttributes",
    "GETcustomerPasswordResetsResponse200DataItemAttributesMetadata",
    "GETcustomerPasswordResetsResponse200DataItemLinks",
    "GETcustomerPasswordResetsResponse200DataItemRelationships",
    "GETcustomerPasswordResetsResponse200DataItemRelationshipsCustomer",
    "GETcustomerPasswordResetsResponse200DataItemRelationshipsCustomerData",
    "GETcustomerPasswordResetsResponse200DataItemRelationshipsCustomerDataType",
    "GETcustomerPasswordResetsResponse200DataItemRelationshipsCustomerLinks",
    "GETcustomerPasswordResetsResponse200DataItemRelationshipsEvents",
    "GETcustomerPasswordResetsResponse200DataItemRelationshipsEventsData",
    "GETcustomerPasswordResetsResponse200DataItemRelationshipsEventsDataType",
    "GETcustomerPasswordResetsResponse200DataItemRelationshipsEventsLinks",
    "GETcustomerPasswordResetsResponse200DataItemType",
    "GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200",
    "GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200Data",
    "GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataAttributes",
    "GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataAttributesMetadata",
    "GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataLinks",
    "GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationships",
    "GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsCustomer",
    "GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsCustomerData",
    "GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsCustomerDataType",
    "GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsCustomerLinks",
    "GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsPaymentSource",
    "GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsPaymentSourceData",
    "GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsPaymentSourceDataType",
    "GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsPaymentSourceLinks",
    "GETcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataType",
    "GETcustomerPaymentSourcesResponse200",
    "GETcustomerPaymentSourcesResponse200DataItem",
    "GETcustomerPaymentSourcesResponse200DataItemAttributes",
    "GETcustomerPaymentSourcesResponse200DataItemAttributesMetadata",
    "GETcustomerPaymentSourcesResponse200DataItemLinks",
    "GETcustomerPaymentSourcesResponse200DataItemRelationships",
    "GETcustomerPaymentSourcesResponse200DataItemRelationshipsCustomer",
    "GETcustomerPaymentSourcesResponse200DataItemRelationshipsCustomerData",
    "GETcustomerPaymentSourcesResponse200DataItemRelationshipsCustomerDataType",
    "GETcustomerPaymentSourcesResponse200DataItemRelationshipsCustomerLinks",
    "GETcustomerPaymentSourcesResponse200DataItemRelationshipsPaymentSource",
    "GETcustomerPaymentSourcesResponse200DataItemRelationshipsPaymentSourceData",
    "GETcustomerPaymentSourcesResponse200DataItemRelationshipsPaymentSourceDataType",
    "GETcustomerPaymentSourcesResponse200DataItemRelationshipsPaymentSourceLinks",
    "GETcustomerPaymentSourcesResponse200DataItemType",
    "GETcustomerscustomerIdResponse200",
    "GETcustomerscustomerIdResponse200Data",
    "GETcustomerscustomerIdResponse200DataAttributes",
    "GETcustomerscustomerIdResponse200DataAttributesMetadata",
    "GETcustomerscustomerIdResponse200DataLinks",
    "GETcustomerscustomerIdResponse200DataRelationships",
    "GETcustomerscustomerIdResponse200DataRelationshipsAttachments",
    "GETcustomerscustomerIdResponse200DataRelationshipsAttachmentsData",
    "GETcustomerscustomerIdResponse200DataRelationshipsAttachmentsDataType",
    "GETcustomerscustomerIdResponse200DataRelationshipsAttachmentsLinks",
    "GETcustomerscustomerIdResponse200DataRelationshipsCustomerAddresses",
    "GETcustomerscustomerIdResponse200DataRelationshipsCustomerAddressesData",
    "GETcustomerscustomerIdResponse200DataRelationshipsCustomerAddressesDataType",
    "GETcustomerscustomerIdResponse200DataRelationshipsCustomerAddressesLinks",
    "GETcustomerscustomerIdResponse200DataRelationshipsCustomerGroup",
    "GETcustomerscustomerIdResponse200DataRelationshipsCustomerGroupData",
    "GETcustomerscustomerIdResponse200DataRelationshipsCustomerGroupDataType",
    "GETcustomerscustomerIdResponse200DataRelationshipsCustomerGroupLinks",
    "GETcustomerscustomerIdResponse200DataRelationshipsCustomerPaymentSources",
    "GETcustomerscustomerIdResponse200DataRelationshipsCustomerPaymentSourcesData",
    "GETcustomerscustomerIdResponse200DataRelationshipsCustomerPaymentSourcesDataType",
    "GETcustomerscustomerIdResponse200DataRelationshipsCustomerPaymentSourcesLinks",
    "GETcustomerscustomerIdResponse200DataRelationshipsCustomerSubscriptions",
    "GETcustomerscustomerIdResponse200DataRelationshipsCustomerSubscriptionsData",
    "GETcustomerscustomerIdResponse200DataRelationshipsCustomerSubscriptionsDataType",
    "GETcustomerscustomerIdResponse200DataRelationshipsCustomerSubscriptionsLinks",
    "GETcustomerscustomerIdResponse200DataRelationshipsEvents",
    "GETcustomerscustomerIdResponse200DataRelationshipsEventsData",
    "GETcustomerscustomerIdResponse200DataRelationshipsEventsDataType",
    "GETcustomerscustomerIdResponse200DataRelationshipsEventsLinks",
    "GETcustomerscustomerIdResponse200DataRelationshipsOrders",
    "GETcustomerscustomerIdResponse200DataRelationshipsOrdersData",
    "GETcustomerscustomerIdResponse200DataRelationshipsOrdersDataType",
    "GETcustomerscustomerIdResponse200DataRelationshipsOrdersLinks",
    "GETcustomerscustomerIdResponse200DataRelationshipsOrderSubscriptions",
    "GETcustomerscustomerIdResponse200DataRelationshipsOrderSubscriptionsData",
    "GETcustomerscustomerIdResponse200DataRelationshipsOrderSubscriptionsDataType",
    "GETcustomerscustomerIdResponse200DataRelationshipsOrderSubscriptionsLinks",
    "GETcustomerscustomerIdResponse200DataRelationshipsReturns",
    "GETcustomerscustomerIdResponse200DataRelationshipsReturnsData",
    "GETcustomerscustomerIdResponse200DataRelationshipsReturnsDataType",
    "GETcustomerscustomerIdResponse200DataRelationshipsReturnsLinks",
    "GETcustomerscustomerIdResponse200DataRelationshipsSkuLists",
    "GETcustomerscustomerIdResponse200DataRelationshipsSkuListsData",
    "GETcustomerscustomerIdResponse200DataRelationshipsSkuListsDataType",
    "GETcustomerscustomerIdResponse200DataRelationshipsSkuListsLinks",
    "GETcustomerscustomerIdResponse200DataType",
    "GETcustomersResponse200",
    "GETcustomersResponse200DataItem",
    "GETcustomersResponse200DataItemAttributes",
    "GETcustomersResponse200DataItemAttributesMetadata",
    "GETcustomersResponse200DataItemLinks",
    "GETcustomersResponse200DataItemRelationships",
    "GETcustomersResponse200DataItemRelationshipsAttachments",
    "GETcustomersResponse200DataItemRelationshipsAttachmentsData",
    "GETcustomersResponse200DataItemRelationshipsAttachmentsDataType",
    "GETcustomersResponse200DataItemRelationshipsAttachmentsLinks",
    "GETcustomersResponse200DataItemRelationshipsCustomerAddresses",
    "GETcustomersResponse200DataItemRelationshipsCustomerAddressesData",
    "GETcustomersResponse200DataItemRelationshipsCustomerAddressesDataType",
    "GETcustomersResponse200DataItemRelationshipsCustomerAddressesLinks",
    "GETcustomersResponse200DataItemRelationshipsCustomerGroup",
    "GETcustomersResponse200DataItemRelationshipsCustomerGroupData",
    "GETcustomersResponse200DataItemRelationshipsCustomerGroupDataType",
    "GETcustomersResponse200DataItemRelationshipsCustomerGroupLinks",
    "GETcustomersResponse200DataItemRelationshipsCustomerPaymentSources",
    "GETcustomersResponse200DataItemRelationshipsCustomerPaymentSourcesData",
    "GETcustomersResponse200DataItemRelationshipsCustomerPaymentSourcesDataType",
    "GETcustomersResponse200DataItemRelationshipsCustomerPaymentSourcesLinks",
    "GETcustomersResponse200DataItemRelationshipsCustomerSubscriptions",
    "GETcustomersResponse200DataItemRelationshipsCustomerSubscriptionsData",
    "GETcustomersResponse200DataItemRelationshipsCustomerSubscriptionsDataType",
    "GETcustomersResponse200DataItemRelationshipsCustomerSubscriptionsLinks",
    "GETcustomersResponse200DataItemRelationshipsEvents",
    "GETcustomersResponse200DataItemRelationshipsEventsData",
    "GETcustomersResponse200DataItemRelationshipsEventsDataType",
    "GETcustomersResponse200DataItemRelationshipsEventsLinks",
    "GETcustomersResponse200DataItemRelationshipsOrders",
    "GETcustomersResponse200DataItemRelationshipsOrdersData",
    "GETcustomersResponse200DataItemRelationshipsOrdersDataType",
    "GETcustomersResponse200DataItemRelationshipsOrdersLinks",
    "GETcustomersResponse200DataItemRelationshipsOrderSubscriptions",
    "GETcustomersResponse200DataItemRelationshipsOrderSubscriptionsData",
    "GETcustomersResponse200DataItemRelationshipsOrderSubscriptionsDataType",
    "GETcustomersResponse200DataItemRelationshipsOrderSubscriptionsLinks",
    "GETcustomersResponse200DataItemRelationshipsReturns",
    "GETcustomersResponse200DataItemRelationshipsReturnsData",
    "GETcustomersResponse200DataItemRelationshipsReturnsDataType",
    "GETcustomersResponse200DataItemRelationshipsReturnsLinks",
    "GETcustomersResponse200DataItemRelationshipsSkuLists",
    "GETcustomersResponse200DataItemRelationshipsSkuListsData",
    "GETcustomersResponse200DataItemRelationshipsSkuListsDataType",
    "GETcustomersResponse200DataItemRelationshipsSkuListsLinks",
    "GETcustomersResponse200DataItemType",
    "GETcustomerSubscriptionscustomerSubscriptionIdResponse200",
    "GETcustomerSubscriptionscustomerSubscriptionIdResponse200Data",
    "GETcustomerSubscriptionscustomerSubscriptionIdResponse200DataAttributes",
    "GETcustomerSubscriptionscustomerSubscriptionIdResponse200DataAttributesMetadata",
    "GETcustomerSubscriptionscustomerSubscriptionIdResponse200DataLinks",
    "GETcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationships",
    "GETcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsCustomer",
    "GETcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsCustomerData",
    "GETcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsCustomerDataType",
    "GETcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsCustomerLinks",
    "GETcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsEvents",
    "GETcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsEventsData",
    "GETcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsEventsDataType",
    "GETcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsEventsLinks",
    "GETcustomerSubscriptionscustomerSubscriptionIdResponse200DataType",
    "GETcustomerSubscriptionsResponse200",
    "GETcustomerSubscriptionsResponse200DataItem",
    "GETcustomerSubscriptionsResponse200DataItemAttributes",
    "GETcustomerSubscriptionsResponse200DataItemAttributesMetadata",
    "GETcustomerSubscriptionsResponse200DataItemLinks",
    "GETcustomerSubscriptionsResponse200DataItemRelationships",
    "GETcustomerSubscriptionsResponse200DataItemRelationshipsCustomer",
    "GETcustomerSubscriptionsResponse200DataItemRelationshipsCustomerData",
    "GETcustomerSubscriptionsResponse200DataItemRelationshipsCustomerDataType",
    "GETcustomerSubscriptionsResponse200DataItemRelationshipsCustomerLinks",
    "GETcustomerSubscriptionsResponse200DataItemRelationshipsEvents",
    "GETcustomerSubscriptionsResponse200DataItemRelationshipsEventsData",
    "GETcustomerSubscriptionsResponse200DataItemRelationshipsEventsDataType",
    "GETcustomerSubscriptionsResponse200DataItemRelationshipsEventsLinks",
    "GETcustomerSubscriptionsResponse200DataItemType",
    "GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200",
    "GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200Data",
    "GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataAttributes",
    "GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataAttributesMetadata",
    "GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataLinks",
    "GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationships",
    "GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsAttachments",
    "GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsAttachmentsData",
    "GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsAttachmentsDataType",
    "GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsAttachmentsLinks",
    "GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsShippingMethod",
    "GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsShippingMethodData",
    "GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsShippingMethodDataType",
    "GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsShippingMethodLinks",
    "GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsStockLocation",
    "GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsStockLocationData",
    "GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsStockLocationDataType",
    "GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsStockLocationLinks",
    "GETdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataType",
    "GETdeliveryLeadTimesResponse200",
    "GETdeliveryLeadTimesResponse200DataItem",
    "GETdeliveryLeadTimesResponse200DataItemAttributes",
    "GETdeliveryLeadTimesResponse200DataItemAttributesMetadata",
    "GETdeliveryLeadTimesResponse200DataItemLinks",
    "GETdeliveryLeadTimesResponse200DataItemRelationships",
    "GETdeliveryLeadTimesResponse200DataItemRelationshipsAttachments",
    "GETdeliveryLeadTimesResponse200DataItemRelationshipsAttachmentsData",
    "GETdeliveryLeadTimesResponse200DataItemRelationshipsAttachmentsDataType",
    "GETdeliveryLeadTimesResponse200DataItemRelationshipsAttachmentsLinks",
    "GETdeliveryLeadTimesResponse200DataItemRelationshipsShippingMethod",
    "GETdeliveryLeadTimesResponse200DataItemRelationshipsShippingMethodData",
    "GETdeliveryLeadTimesResponse200DataItemRelationshipsShippingMethodDataType",
    "GETdeliveryLeadTimesResponse200DataItemRelationshipsShippingMethodLinks",
    "GETdeliveryLeadTimesResponse200DataItemRelationshipsStockLocation",
    "GETdeliveryLeadTimesResponse200DataItemRelationshipsStockLocationData",
    "GETdeliveryLeadTimesResponse200DataItemRelationshipsStockLocationDataType",
    "GETdeliveryLeadTimesResponse200DataItemRelationshipsStockLocationLinks",
    "GETdeliveryLeadTimesResponse200DataItemType",
    "GETeventCallbackseventCallbackIdResponse200",
    "GETeventCallbackseventCallbackIdResponse200Data",
    "GETeventCallbackseventCallbackIdResponse200DataAttributes",
    "GETeventCallbackseventCallbackIdResponse200DataAttributesMetadata",
    "GETeventCallbackseventCallbackIdResponse200DataAttributesPayload",
    "GETeventCallbackseventCallbackIdResponse200DataLinks",
    "GETeventCallbackseventCallbackIdResponse200DataRelationships",
    "GETeventCallbackseventCallbackIdResponse200DataRelationshipsWebhook",
    "GETeventCallbackseventCallbackIdResponse200DataRelationshipsWebhookData",
    "GETeventCallbackseventCallbackIdResponse200DataRelationshipsWebhookDataType",
    "GETeventCallbackseventCallbackIdResponse200DataRelationshipsWebhookLinks",
    "GETeventCallbackseventCallbackIdResponse200DataType",
    "GETeventCallbacksResponse200",
    "GETeventCallbacksResponse200DataItem",
    "GETeventCallbacksResponse200DataItemAttributes",
    "GETeventCallbacksResponse200DataItemAttributesMetadata",
    "GETeventCallbacksResponse200DataItemAttributesPayload",
    "GETeventCallbacksResponse200DataItemLinks",
    "GETeventCallbacksResponse200DataItemRelationships",
    "GETeventCallbacksResponse200DataItemRelationshipsWebhook",
    "GETeventCallbacksResponse200DataItemRelationshipsWebhookData",
    "GETeventCallbacksResponse200DataItemRelationshipsWebhookDataType",
    "GETeventCallbacksResponse200DataItemRelationshipsWebhookLinks",
    "GETeventCallbacksResponse200DataItemType",
    "GETeventseventIdResponse200",
    "GETeventseventIdResponse200Data",
    "GETeventseventIdResponse200DataAttributes",
    "GETeventseventIdResponse200DataAttributesMetadata",
    "GETeventseventIdResponse200DataLinks",
    "GETeventseventIdResponse200DataRelationships",
    "GETeventseventIdResponse200DataRelationshipsLastEventCallbacks",
    "GETeventseventIdResponse200DataRelationshipsLastEventCallbacksData",
    "GETeventseventIdResponse200DataRelationshipsLastEventCallbacksDataType",
    "GETeventseventIdResponse200DataRelationshipsLastEventCallbacksLinks",
    "GETeventseventIdResponse200DataRelationshipsWebhooks",
    "GETeventseventIdResponse200DataRelationshipsWebhooksData",
    "GETeventseventIdResponse200DataRelationshipsWebhooksDataType",
    "GETeventseventIdResponse200DataRelationshipsWebhooksLinks",
    "GETeventseventIdResponse200DataType",
    "GETeventsResponse200",
    "GETeventsResponse200DataItem",
    "GETeventsResponse200DataItemAttributes",
    "GETeventsResponse200DataItemAttributesMetadata",
    "GETeventsResponse200DataItemLinks",
    "GETeventsResponse200DataItemRelationships",
    "GETeventsResponse200DataItemRelationshipsLastEventCallbacks",
    "GETeventsResponse200DataItemRelationshipsLastEventCallbacksData",
    "GETeventsResponse200DataItemRelationshipsLastEventCallbacksDataType",
    "GETeventsResponse200DataItemRelationshipsLastEventCallbacksLinks",
    "GETeventsResponse200DataItemRelationshipsWebhooks",
    "GETeventsResponse200DataItemRelationshipsWebhooksData",
    "GETeventsResponse200DataItemRelationshipsWebhooksDataType",
    "GETeventsResponse200DataItemRelationshipsWebhooksLinks",
    "GETeventsResponse200DataItemType",
    "GETexportsexportIdResponse200",
    "GETexportsexportIdResponse200Data",
    "GETexportsexportIdResponse200DataAttributes",
    "GETexportsexportIdResponse200DataAttributesFilters",
    "GETexportsexportIdResponse200DataAttributesMetadata",
    "GETexportsexportIdResponse200DataLinks",
    "GETexportsexportIdResponse200DataRelationships",
    "GETexportsexportIdResponse200DataRelationshipsEvents",
    "GETexportsexportIdResponse200DataRelationshipsEventsData",
    "GETexportsexportIdResponse200DataRelationshipsEventsDataType",
    "GETexportsexportIdResponse200DataRelationshipsEventsLinks",
    "GETexportsexportIdResponse200DataType",
    "GETexportsResponse200",
    "GETexportsResponse200DataItem",
    "GETexportsResponse200DataItemAttributes",
    "GETexportsResponse200DataItemAttributesFilters",
    "GETexportsResponse200DataItemAttributesMetadata",
    "GETexportsResponse200DataItemLinks",
    "GETexportsResponse200DataItemRelationships",
    "GETexportsResponse200DataItemRelationshipsEvents",
    "GETexportsResponse200DataItemRelationshipsEventsData",
    "GETexportsResponse200DataItemRelationshipsEventsDataType",
    "GETexportsResponse200DataItemRelationshipsEventsLinks",
    "GETexportsResponse200DataItemType",
    "GETexternalGatewaysexternalGatewayIdResponse200",
    "GETexternalGatewaysexternalGatewayIdResponse200Data",
    "GETexternalGatewaysexternalGatewayIdResponse200DataAttributes",
    "GETexternalGatewaysexternalGatewayIdResponse200DataAttributesMetadata",
    "GETexternalGatewaysexternalGatewayIdResponse200DataLinks",
    "GETexternalGatewaysexternalGatewayIdResponse200DataRelationships",
    "GETexternalGatewaysexternalGatewayIdResponse200DataRelationshipsExternalPayments",
    "GETexternalGatewaysexternalGatewayIdResponse200DataRelationshipsExternalPaymentsData",
    "GETexternalGatewaysexternalGatewayIdResponse200DataRelationshipsExternalPaymentsDataType",
    "GETexternalGatewaysexternalGatewayIdResponse200DataRelationshipsExternalPaymentsLinks",
    "GETexternalGatewaysexternalGatewayIdResponse200DataRelationshipsPaymentMethods",
    "GETexternalGatewaysexternalGatewayIdResponse200DataRelationshipsPaymentMethodsData",
    "GETexternalGatewaysexternalGatewayIdResponse200DataRelationshipsPaymentMethodsDataType",
    "GETexternalGatewaysexternalGatewayIdResponse200DataRelationshipsPaymentMethodsLinks",
    "GETexternalGatewaysexternalGatewayIdResponse200DataType",
    "GETexternalGatewaysResponse200",
    "GETexternalGatewaysResponse200DataItem",
    "GETexternalGatewaysResponse200DataItemAttributes",
    "GETexternalGatewaysResponse200DataItemAttributesMetadata",
    "GETexternalGatewaysResponse200DataItemLinks",
    "GETexternalGatewaysResponse200DataItemRelationships",
    "GETexternalGatewaysResponse200DataItemRelationshipsExternalPayments",
    "GETexternalGatewaysResponse200DataItemRelationshipsExternalPaymentsData",
    "GETexternalGatewaysResponse200DataItemRelationshipsExternalPaymentsDataType",
    "GETexternalGatewaysResponse200DataItemRelationshipsExternalPaymentsLinks",
    "GETexternalGatewaysResponse200DataItemRelationshipsPaymentMethods",
    "GETexternalGatewaysResponse200DataItemRelationshipsPaymentMethodsData",
    "GETexternalGatewaysResponse200DataItemRelationshipsPaymentMethodsDataType",
    "GETexternalGatewaysResponse200DataItemRelationshipsPaymentMethodsLinks",
    "GETexternalGatewaysResponse200DataItemType",
    "GETexternalPaymentsexternalPaymentIdResponse200",
    "GETexternalPaymentsexternalPaymentIdResponse200Data",
    "GETexternalPaymentsexternalPaymentIdResponse200DataAttributes",
    "GETexternalPaymentsexternalPaymentIdResponse200DataAttributesMetadata",
    "GETexternalPaymentsexternalPaymentIdResponse200DataAttributesOptions",
    "GETexternalPaymentsexternalPaymentIdResponse200DataLinks",
    "GETexternalPaymentsexternalPaymentIdResponse200DataRelationships",
    "GETexternalPaymentsexternalPaymentIdResponse200DataRelationshipsOrder",
    "GETexternalPaymentsexternalPaymentIdResponse200DataRelationshipsOrderData",
    "GETexternalPaymentsexternalPaymentIdResponse200DataRelationshipsOrderDataType",
    "GETexternalPaymentsexternalPaymentIdResponse200DataRelationshipsOrderLinks",
    "GETexternalPaymentsexternalPaymentIdResponse200DataRelationshipsPaymentGateway",
    "GETexternalPaymentsexternalPaymentIdResponse200DataRelationshipsPaymentGatewayData",
    "GETexternalPaymentsexternalPaymentIdResponse200DataRelationshipsPaymentGatewayDataType",
    "GETexternalPaymentsexternalPaymentIdResponse200DataRelationshipsPaymentGatewayLinks",
    "GETexternalPaymentsexternalPaymentIdResponse200DataRelationshipsWallet",
    "GETexternalPaymentsexternalPaymentIdResponse200DataRelationshipsWalletData",
    "GETexternalPaymentsexternalPaymentIdResponse200DataRelationshipsWalletDataType",
    "GETexternalPaymentsexternalPaymentIdResponse200DataRelationshipsWalletLinks",
    "GETexternalPaymentsexternalPaymentIdResponse200DataType",
    "GETexternalPaymentsResponse200",
    "GETexternalPaymentsResponse200DataItem",
    "GETexternalPaymentsResponse200DataItemAttributes",
    "GETexternalPaymentsResponse200DataItemAttributesMetadata",
    "GETexternalPaymentsResponse200DataItemAttributesOptions",
    "GETexternalPaymentsResponse200DataItemLinks",
    "GETexternalPaymentsResponse200DataItemRelationships",
    "GETexternalPaymentsResponse200DataItemRelationshipsOrder",
    "GETexternalPaymentsResponse200DataItemRelationshipsOrderData",
    "GETexternalPaymentsResponse200DataItemRelationshipsOrderDataType",
    "GETexternalPaymentsResponse200DataItemRelationshipsOrderLinks",
    "GETexternalPaymentsResponse200DataItemRelationshipsPaymentGateway",
    "GETexternalPaymentsResponse200DataItemRelationshipsPaymentGatewayData",
    "GETexternalPaymentsResponse200DataItemRelationshipsPaymentGatewayDataType",
    "GETexternalPaymentsResponse200DataItemRelationshipsPaymentGatewayLinks",
    "GETexternalPaymentsResponse200DataItemRelationshipsWallet",
    "GETexternalPaymentsResponse200DataItemRelationshipsWalletData",
    "GETexternalPaymentsResponse200DataItemRelationshipsWalletDataType",
    "GETexternalPaymentsResponse200DataItemRelationshipsWalletLinks",
    "GETexternalPaymentsResponse200DataItemType",
    "GETexternalPromotionsexternalPromotionIdResponse200",
    "GETexternalPromotionsexternalPromotionIdResponse200Data",
    "GETexternalPromotionsexternalPromotionIdResponse200DataAttributes",
    "GETexternalPromotionsexternalPromotionIdResponse200DataAttributesMetadata",
    "GETexternalPromotionsexternalPromotionIdResponse200DataLinks",
    "GETexternalPromotionsexternalPromotionIdResponse200DataRelationships",
    "GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsAttachments",
    "GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsAttachmentsData",
    "GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsAttachmentsDataType",
    "GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsAttachmentsLinks",
    "GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsCouponCodesPromotionRule",
    "GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleData",
    "GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleDataType",
    "GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleLinks",
    "GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsMarket",
    "GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsMarketData",
    "GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsMarketDataType",
    "GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsMarketLinks",
    "GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsOrderAmountPromotionRule",
    "GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleData",
    "GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleDataType",
    "GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleLinks",
    "GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsPromotionRules",
    "GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsPromotionRulesData",
    "GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsPromotionRulesDataType",
    "GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsPromotionRulesLinks",
    "GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsSkuListPromotionRule",
    "GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsSkuListPromotionRuleData",
    "GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsSkuListPromotionRuleDataType",
    "GETexternalPromotionsexternalPromotionIdResponse200DataRelationshipsSkuListPromotionRuleLinks",
    "GETexternalPromotionsexternalPromotionIdResponse200DataType",
    "GETexternalPromotionsResponse200",
    "GETexternalPromotionsResponse200DataItem",
    "GETexternalPromotionsResponse200DataItemAttributes",
    "GETexternalPromotionsResponse200DataItemAttributesMetadata",
    "GETexternalPromotionsResponse200DataItemLinks",
    "GETexternalPromotionsResponse200DataItemRelationships",
    "GETexternalPromotionsResponse200DataItemRelationshipsAttachments",
    "GETexternalPromotionsResponse200DataItemRelationshipsAttachmentsData",
    "GETexternalPromotionsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETexternalPromotionsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETexternalPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRule",
    "GETexternalPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleData",
    "GETexternalPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleDataType",
    "GETexternalPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleLinks",
    "GETexternalPromotionsResponse200DataItemRelationshipsMarket",
    "GETexternalPromotionsResponse200DataItemRelationshipsMarketData",
    "GETexternalPromotionsResponse200DataItemRelationshipsMarketDataType",
    "GETexternalPromotionsResponse200DataItemRelationshipsMarketLinks",
    "GETexternalPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRule",
    "GETexternalPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleData",
    "GETexternalPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleDataType",
    "GETexternalPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleLinks",
    "GETexternalPromotionsResponse200DataItemRelationshipsPromotionRules",
    "GETexternalPromotionsResponse200DataItemRelationshipsPromotionRulesData",
    "GETexternalPromotionsResponse200DataItemRelationshipsPromotionRulesDataType",
    "GETexternalPromotionsResponse200DataItemRelationshipsPromotionRulesLinks",
    "GETexternalPromotionsResponse200DataItemRelationshipsSkuListPromotionRule",
    "GETexternalPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleData",
    "GETexternalPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleDataType",
    "GETexternalPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleLinks",
    "GETexternalPromotionsResponse200DataItemType",
    "GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200",
    "GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200Data",
    "GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataAttributes",
    "GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataAttributesMetadata",
    "GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataLinks",
    "GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationships",
    "GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsAttachments",
    "GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsAttachmentsData",
    "GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsAttachmentsDataType",
    "GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsAttachmentsLinks",
    "GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsMarkets",
    "GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsMarketsData",
    "GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsMarketsDataType",
    "GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsMarketsLinks",
    "GETexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataType",
    "GETexternalTaxCalculatorsResponse200",
    "GETexternalTaxCalculatorsResponse200DataItem",
    "GETexternalTaxCalculatorsResponse200DataItemAttributes",
    "GETexternalTaxCalculatorsResponse200DataItemAttributesMetadata",
    "GETexternalTaxCalculatorsResponse200DataItemLinks",
    "GETexternalTaxCalculatorsResponse200DataItemRelationships",
    "GETexternalTaxCalculatorsResponse200DataItemRelationshipsAttachments",
    "GETexternalTaxCalculatorsResponse200DataItemRelationshipsAttachmentsData",
    "GETexternalTaxCalculatorsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETexternalTaxCalculatorsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETexternalTaxCalculatorsResponse200DataItemRelationshipsMarkets",
    "GETexternalTaxCalculatorsResponse200DataItemRelationshipsMarketsData",
    "GETexternalTaxCalculatorsResponse200DataItemRelationshipsMarketsDataType",
    "GETexternalTaxCalculatorsResponse200DataItemRelationshipsMarketsLinks",
    "GETexternalTaxCalculatorsResponse200DataItemType",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200Data",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataAttributes",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataAttributesMetadata",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataLinks",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationships",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsAttachments",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsAttachmentsData",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsAttachmentsDataType",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsAttachmentsLinks",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRule",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleData",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleDataType",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleLinks",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsMarket",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsMarketData",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsMarketDataType",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsMarketLinks",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRule",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleData",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleDataType",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleLinks",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsPromotionRules",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsPromotionRulesData",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsPromotionRulesDataType",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsPromotionRulesLinks",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsSkuListPromotionRule",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsSkuListPromotionRuleData",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsSkuListPromotionRuleDataType",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsSkuListPromotionRuleLinks",
    "GETfixedAmountPromotionsfixedAmountPromotionIdResponse200DataType",
    "GETfixedAmountPromotionsResponse200",
    "GETfixedAmountPromotionsResponse200DataItem",
    "GETfixedAmountPromotionsResponse200DataItemAttributes",
    "GETfixedAmountPromotionsResponse200DataItemAttributesMetadata",
    "GETfixedAmountPromotionsResponse200DataItemLinks",
    "GETfixedAmountPromotionsResponse200DataItemRelationships",
    "GETfixedAmountPromotionsResponse200DataItemRelationshipsAttachments",
    "GETfixedAmountPromotionsResponse200DataItemRelationshipsAttachmentsData",
    "GETfixedAmountPromotionsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETfixedAmountPromotionsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETfixedAmountPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRule",
    "GETfixedAmountPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleData",
    "GETfixedAmountPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleDataType",
    "GETfixedAmountPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleLinks",
    "GETfixedAmountPromotionsResponse200DataItemRelationshipsMarket",
    "GETfixedAmountPromotionsResponse200DataItemRelationshipsMarketData",
    "GETfixedAmountPromotionsResponse200DataItemRelationshipsMarketDataType",
    "GETfixedAmountPromotionsResponse200DataItemRelationshipsMarketLinks",
    "GETfixedAmountPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRule",
    "GETfixedAmountPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleData",
    "GETfixedAmountPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleDataType",
    "GETfixedAmountPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleLinks",
    "GETfixedAmountPromotionsResponse200DataItemRelationshipsPromotionRules",
    "GETfixedAmountPromotionsResponse200DataItemRelationshipsPromotionRulesData",
    "GETfixedAmountPromotionsResponse200DataItemRelationshipsPromotionRulesDataType",
    "GETfixedAmountPromotionsResponse200DataItemRelationshipsPromotionRulesLinks",
    "GETfixedAmountPromotionsResponse200DataItemRelationshipsSkuListPromotionRule",
    "GETfixedAmountPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleData",
    "GETfixedAmountPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleDataType",
    "GETfixedAmountPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleLinks",
    "GETfixedAmountPromotionsResponse200DataItemType",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200Data",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataAttributes",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataAttributesMetadata",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataLinks",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationships",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsAttachments",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsAttachmentsData",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsAttachmentsDataType",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsAttachmentsLinks",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsCouponCodesPromotionRule",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleData",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleDataType",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleLinks",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsMarket",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsMarketData",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsMarketDataType",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsMarketLinks",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsOrderAmountPromotionRule",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleData",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleDataType",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleLinks",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsPromotionRules",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsPromotionRulesData",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsPromotionRulesDataType",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsPromotionRulesLinks",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuList",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuListData",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuListDataType",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuListLinks",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuListPromotionRule",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuListPromotionRuleData",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuListPromotionRuleDataType",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuListPromotionRuleLinks",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkus",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkusData",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkusDataType",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkusLinks",
    "GETfixedPricePromotionsfixedPricePromotionIdResponse200DataType",
    "GETfixedPricePromotionsResponse200",
    "GETfixedPricePromotionsResponse200DataItem",
    "GETfixedPricePromotionsResponse200DataItemAttributes",
    "GETfixedPricePromotionsResponse200DataItemAttributesMetadata",
    "GETfixedPricePromotionsResponse200DataItemLinks",
    "GETfixedPricePromotionsResponse200DataItemRelationships",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsAttachments",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsAttachmentsData",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsCouponCodesPromotionRule",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleData",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleDataType",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleLinks",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsMarket",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsMarketData",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsMarketDataType",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsMarketLinks",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsOrderAmountPromotionRule",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleData",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleDataType",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleLinks",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsPromotionRules",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsPromotionRulesData",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsPromotionRulesDataType",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsPromotionRulesLinks",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsSkuList",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsSkuListData",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsSkuListDataType",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsSkuListLinks",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsSkuListPromotionRule",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsSkuListPromotionRuleData",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsSkuListPromotionRuleDataType",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsSkuListPromotionRuleLinks",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsSkus",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsSkusData",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsSkusDataType",
    "GETfixedPricePromotionsResponse200DataItemRelationshipsSkusLinks",
    "GETfixedPricePromotionsResponse200DataItemType",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200Data",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataAttributes",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataAttributesMetadata",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataLinks",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationships",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsAttachments",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsAttachmentsData",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsAttachmentsDataType",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsAttachmentsLinks",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsCouponCodesPromotionRule",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleData",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleDataType",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleLinks",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsMarket",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsMarketData",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsMarketDataType",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsMarketLinks",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsOrderAmountPromotionRule",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleData",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleDataType",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleLinks",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsPromotionRules",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsPromotionRulesData",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsPromotionRulesDataType",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsPromotionRulesLinks",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuList",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuListData",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuListDataType",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuListLinks",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuListPromotionRule",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuListPromotionRuleData",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuListPromotionRuleDataType",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuListPromotionRuleLinks",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkus",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkusData",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkusDataType",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkusLinks",
    "GETfreeGiftPromotionsfreeGiftPromotionIdResponse200DataType",
    "GETfreeGiftPromotionsResponse200",
    "GETfreeGiftPromotionsResponse200DataItem",
    "GETfreeGiftPromotionsResponse200DataItemAttributes",
    "GETfreeGiftPromotionsResponse200DataItemAttributesMetadata",
    "GETfreeGiftPromotionsResponse200DataItemLinks",
    "GETfreeGiftPromotionsResponse200DataItemRelationships",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsAttachments",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsAttachmentsData",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRule",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleData",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleDataType",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleLinks",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsMarket",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsMarketData",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsMarketDataType",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsMarketLinks",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRule",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleData",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleDataType",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleLinks",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsPromotionRules",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsPromotionRulesData",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsPromotionRulesDataType",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsPromotionRulesLinks",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsSkuList",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsSkuListData",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsSkuListDataType",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsSkuListLinks",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsSkuListPromotionRule",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleData",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleDataType",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleLinks",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsSkus",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsSkusData",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsSkusDataType",
    "GETfreeGiftPromotionsResponse200DataItemRelationshipsSkusLinks",
    "GETfreeGiftPromotionsResponse200DataItemType",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200Data",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataAttributes",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataAttributesMetadata",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataLinks",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationships",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsAttachments",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsAttachmentsData",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsAttachmentsDataType",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsAttachmentsLinks",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsCouponCodesPromotionRule",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleData",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleDataType",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleLinks",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsMarket",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsMarketData",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsMarketDataType",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsMarketLinks",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsOrderAmountPromotionRule",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleData",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleDataType",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleLinks",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsPromotionRules",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsPromotionRulesData",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsPromotionRulesDataType",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsPromotionRulesLinks",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsSkuListPromotionRule",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsSkuListPromotionRuleData",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsSkuListPromotionRuleDataType",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsSkuListPromotionRuleLinks",
    "GETfreeShippingPromotionsfreeShippingPromotionIdResponse200DataType",
    "GETfreeShippingPromotionsResponse200",
    "GETfreeShippingPromotionsResponse200DataItem",
    "GETfreeShippingPromotionsResponse200DataItemAttributes",
    "GETfreeShippingPromotionsResponse200DataItemAttributesMetadata",
    "GETfreeShippingPromotionsResponse200DataItemLinks",
    "GETfreeShippingPromotionsResponse200DataItemRelationships",
    "GETfreeShippingPromotionsResponse200DataItemRelationshipsAttachments",
    "GETfreeShippingPromotionsResponse200DataItemRelationshipsAttachmentsData",
    "GETfreeShippingPromotionsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETfreeShippingPromotionsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETfreeShippingPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRule",
    "GETfreeShippingPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleData",
    "GETfreeShippingPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleDataType",
    "GETfreeShippingPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleLinks",
    "GETfreeShippingPromotionsResponse200DataItemRelationshipsMarket",
    "GETfreeShippingPromotionsResponse200DataItemRelationshipsMarketData",
    "GETfreeShippingPromotionsResponse200DataItemRelationshipsMarketDataType",
    "GETfreeShippingPromotionsResponse200DataItemRelationshipsMarketLinks",
    "GETfreeShippingPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRule",
    "GETfreeShippingPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleData",
    "GETfreeShippingPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleDataType",
    "GETfreeShippingPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleLinks",
    "GETfreeShippingPromotionsResponse200DataItemRelationshipsPromotionRules",
    "GETfreeShippingPromotionsResponse200DataItemRelationshipsPromotionRulesData",
    "GETfreeShippingPromotionsResponse200DataItemRelationshipsPromotionRulesDataType",
    "GETfreeShippingPromotionsResponse200DataItemRelationshipsPromotionRulesLinks",
    "GETfreeShippingPromotionsResponse200DataItemRelationshipsSkuListPromotionRule",
    "GETfreeShippingPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleData",
    "GETfreeShippingPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleDataType",
    "GETfreeShippingPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleLinks",
    "GETfreeShippingPromotionsResponse200DataItemType",
    "GETgeocodersgeocoderIdResponse200",
    "GETgeocodersgeocoderIdResponse200Data",
    "GETgeocodersgeocoderIdResponse200DataAttributes",
    "GETgeocodersgeocoderIdResponse200DataAttributesMetadata",
    "GETgeocodersgeocoderIdResponse200DataLinks",
    "GETgeocodersgeocoderIdResponse200DataRelationships",
    "GETgeocodersgeocoderIdResponse200DataRelationshipsAddresses",
    "GETgeocodersgeocoderIdResponse200DataRelationshipsAddressesData",
    "GETgeocodersgeocoderIdResponse200DataRelationshipsAddressesDataType",
    "GETgeocodersgeocoderIdResponse200DataRelationshipsAddressesLinks",
    "GETgeocodersgeocoderIdResponse200DataRelationshipsAttachments",
    "GETgeocodersgeocoderIdResponse200DataRelationshipsAttachmentsData",
    "GETgeocodersgeocoderIdResponse200DataRelationshipsAttachmentsDataType",
    "GETgeocodersgeocoderIdResponse200DataRelationshipsAttachmentsLinks",
    "GETgeocodersgeocoderIdResponse200DataType",
    "GETgeocodersResponse200",
    "GETgeocodersResponse200DataItem",
    "GETgeocodersResponse200DataItemAttributes",
    "GETgeocodersResponse200DataItemAttributesMetadata",
    "GETgeocodersResponse200DataItemLinks",
    "GETgeocodersResponse200DataItemRelationships",
    "GETgeocodersResponse200DataItemRelationshipsAddresses",
    "GETgeocodersResponse200DataItemRelationshipsAddressesData",
    "GETgeocodersResponse200DataItemRelationshipsAddressesDataType",
    "GETgeocodersResponse200DataItemRelationshipsAddressesLinks",
    "GETgeocodersResponse200DataItemRelationshipsAttachments",
    "GETgeocodersResponse200DataItemRelationshipsAttachmentsData",
    "GETgeocodersResponse200DataItemRelationshipsAttachmentsDataType",
    "GETgeocodersResponse200DataItemRelationshipsAttachmentsLinks",
    "GETgeocodersResponse200DataItemType",
    "GETgiftCardRecipientsgiftCardRecipientIdResponse200",
    "GETgiftCardRecipientsgiftCardRecipientIdResponse200Data",
    "GETgiftCardRecipientsgiftCardRecipientIdResponse200DataAttributes",
    "GETgiftCardRecipientsgiftCardRecipientIdResponse200DataAttributesMetadata",
    "GETgiftCardRecipientsgiftCardRecipientIdResponse200DataLinks",
    "GETgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationships",
    "GETgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsAttachments",
    "GETgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsAttachmentsData",
    "GETgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsAttachmentsDataType",
    "GETgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsAttachmentsLinks",
    "GETgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsCustomer",
    "GETgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsCustomerData",
    "GETgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsCustomerDataType",
    "GETgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsCustomerLinks",
    "GETgiftCardRecipientsgiftCardRecipientIdResponse200DataType",
    "GETgiftCardRecipientsResponse200",
    "GETgiftCardRecipientsResponse200DataItem",
    "GETgiftCardRecipientsResponse200DataItemAttributes",
    "GETgiftCardRecipientsResponse200DataItemAttributesMetadata",
    "GETgiftCardRecipientsResponse200DataItemLinks",
    "GETgiftCardRecipientsResponse200DataItemRelationships",
    "GETgiftCardRecipientsResponse200DataItemRelationshipsAttachments",
    "GETgiftCardRecipientsResponse200DataItemRelationshipsAttachmentsData",
    "GETgiftCardRecipientsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETgiftCardRecipientsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETgiftCardRecipientsResponse200DataItemRelationshipsCustomer",
    "GETgiftCardRecipientsResponse200DataItemRelationshipsCustomerData",
    "GETgiftCardRecipientsResponse200DataItemRelationshipsCustomerDataType",
    "GETgiftCardRecipientsResponse200DataItemRelationshipsCustomerLinks",
    "GETgiftCardRecipientsResponse200DataItemType",
    "GETgiftCardsgiftCardIdResponse200",
    "GETgiftCardsgiftCardIdResponse200Data",
    "GETgiftCardsgiftCardIdResponse200DataAttributes",
    "GETgiftCardsgiftCardIdResponse200DataAttributesBalanceLogItem",
    "GETgiftCardsgiftCardIdResponse200DataAttributesMetadata",
    "GETgiftCardsgiftCardIdResponse200DataLinks",
    "GETgiftCardsgiftCardIdResponse200DataRelationships",
    "GETgiftCardsgiftCardIdResponse200DataRelationshipsAttachments",
    "GETgiftCardsgiftCardIdResponse200DataRelationshipsAttachmentsData",
    "GETgiftCardsgiftCardIdResponse200DataRelationshipsAttachmentsDataType",
    "GETgiftCardsgiftCardIdResponse200DataRelationshipsAttachmentsLinks",
    "GETgiftCardsgiftCardIdResponse200DataRelationshipsEvents",
    "GETgiftCardsgiftCardIdResponse200DataRelationshipsEventsData",
    "GETgiftCardsgiftCardIdResponse200DataRelationshipsEventsDataType",
    "GETgiftCardsgiftCardIdResponse200DataRelationshipsEventsLinks",
    "GETgiftCardsgiftCardIdResponse200DataRelationshipsGiftCardRecipient",
    "GETgiftCardsgiftCardIdResponse200DataRelationshipsGiftCardRecipientData",
    "GETgiftCardsgiftCardIdResponse200DataRelationshipsGiftCardRecipientDataType",
    "GETgiftCardsgiftCardIdResponse200DataRelationshipsGiftCardRecipientLinks",
    "GETgiftCardsgiftCardIdResponse200DataRelationshipsMarket",
    "GETgiftCardsgiftCardIdResponse200DataRelationshipsMarketData",
    "GETgiftCardsgiftCardIdResponse200DataRelationshipsMarketDataType",
    "GETgiftCardsgiftCardIdResponse200DataRelationshipsMarketLinks",
    "GETgiftCardsgiftCardIdResponse200DataType",
    "GETgiftCardsResponse200",
    "GETgiftCardsResponse200DataItem",
    "GETgiftCardsResponse200DataItemAttributes",
    "GETgiftCardsResponse200DataItemAttributesBalanceLogItem",
    "GETgiftCardsResponse200DataItemAttributesMetadata",
    "GETgiftCardsResponse200DataItemLinks",
    "GETgiftCardsResponse200DataItemRelationships",
    "GETgiftCardsResponse200DataItemRelationshipsAttachments",
    "GETgiftCardsResponse200DataItemRelationshipsAttachmentsData",
    "GETgiftCardsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETgiftCardsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETgiftCardsResponse200DataItemRelationshipsEvents",
    "GETgiftCardsResponse200DataItemRelationshipsEventsData",
    "GETgiftCardsResponse200DataItemRelationshipsEventsDataType",
    "GETgiftCardsResponse200DataItemRelationshipsEventsLinks",
    "GETgiftCardsResponse200DataItemRelationshipsGiftCardRecipient",
    "GETgiftCardsResponse200DataItemRelationshipsGiftCardRecipientData",
    "GETgiftCardsResponse200DataItemRelationshipsGiftCardRecipientDataType",
    "GETgiftCardsResponse200DataItemRelationshipsGiftCardRecipientLinks",
    "GETgiftCardsResponse200DataItemRelationshipsMarket",
    "GETgiftCardsResponse200DataItemRelationshipsMarketData",
    "GETgiftCardsResponse200DataItemRelationshipsMarketDataType",
    "GETgiftCardsResponse200DataItemRelationshipsMarketLinks",
    "GETgiftCardsResponse200DataItemType",
    "GETgoogleGeocodersgoogleGeocoderIdResponse200",
    "GETgoogleGeocodersgoogleGeocoderIdResponse200Data",
    "GETgoogleGeocodersgoogleGeocoderIdResponse200DataAttributes",
    "GETgoogleGeocodersgoogleGeocoderIdResponse200DataAttributesMetadata",
    "GETgoogleGeocodersgoogleGeocoderIdResponse200DataLinks",
    "GETgoogleGeocodersgoogleGeocoderIdResponse200DataRelationships",
    "GETgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAddresses",
    "GETgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAddressesData",
    "GETgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAddressesDataType",
    "GETgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAddressesLinks",
    "GETgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAttachments",
    "GETgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAttachmentsData",
    "GETgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAttachmentsDataType",
    "GETgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAttachmentsLinks",
    "GETgoogleGeocodersgoogleGeocoderIdResponse200DataType",
    "GETgoogleGeocodersResponse200",
    "GETgoogleGeocodersResponse200DataItem",
    "GETgoogleGeocodersResponse200DataItemAttributes",
    "GETgoogleGeocodersResponse200DataItemAttributesMetadata",
    "GETgoogleGeocodersResponse200DataItemLinks",
    "GETgoogleGeocodersResponse200DataItemRelationships",
    "GETgoogleGeocodersResponse200DataItemRelationshipsAddresses",
    "GETgoogleGeocodersResponse200DataItemRelationshipsAddressesData",
    "GETgoogleGeocodersResponse200DataItemRelationshipsAddressesDataType",
    "GETgoogleGeocodersResponse200DataItemRelationshipsAddressesLinks",
    "GETgoogleGeocodersResponse200DataItemRelationshipsAttachments",
    "GETgoogleGeocodersResponse200DataItemRelationshipsAttachmentsData",
    "GETgoogleGeocodersResponse200DataItemRelationshipsAttachmentsDataType",
    "GETgoogleGeocodersResponse200DataItemRelationshipsAttachmentsLinks",
    "GETgoogleGeocodersResponse200DataItemType",
    "GETimportsimportIdResponse200",
    "GETimportsimportIdResponse200Data",
    "GETimportsimportIdResponse200DataAttributes",
    "GETimportsimportIdResponse200DataAttributesErrorsLog",
    "GETimportsimportIdResponse200DataAttributesInputsItem",
    "GETimportsimportIdResponse200DataAttributesMetadata",
    "GETimportsimportIdResponse200DataAttributesWarningsLog",
    "GETimportsimportIdResponse200DataLinks",
    "GETimportsimportIdResponse200DataRelationships",
    "GETimportsimportIdResponse200DataRelationshipsEvents",
    "GETimportsimportIdResponse200DataRelationshipsEventsData",
    "GETimportsimportIdResponse200DataRelationshipsEventsDataType",
    "GETimportsimportIdResponse200DataRelationshipsEventsLinks",
    "GETimportsimportIdResponse200DataType",
    "GETimportsResponse200",
    "GETimportsResponse200DataItem",
    "GETimportsResponse200DataItemAttributes",
    "GETimportsResponse200DataItemAttributesErrorsLog",
    "GETimportsResponse200DataItemAttributesInputsItem",
    "GETimportsResponse200DataItemAttributesMetadata",
    "GETimportsResponse200DataItemAttributesWarningsLog",
    "GETimportsResponse200DataItemLinks",
    "GETimportsResponse200DataItemRelationships",
    "GETimportsResponse200DataItemRelationshipsEvents",
    "GETimportsResponse200DataItemRelationshipsEventsData",
    "GETimportsResponse200DataItemRelationshipsEventsDataType",
    "GETimportsResponse200DataItemRelationshipsEventsLinks",
    "GETimportsResponse200DataItemType",
    "GETinStockSubscriptionsinStockSubscriptionIdResponse200",
    "GETinStockSubscriptionsinStockSubscriptionIdResponse200Data",
    "GETinStockSubscriptionsinStockSubscriptionIdResponse200DataAttributes",
    "GETinStockSubscriptionsinStockSubscriptionIdResponse200DataAttributesMetadata",
    "GETinStockSubscriptionsinStockSubscriptionIdResponse200DataLinks",
    "GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationships",
    "GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsCustomer",
    "GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsCustomerData",
    "GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsCustomerDataType",
    "GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsCustomerLinks",
    "GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsEvents",
    "GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsEventsData",
    "GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsEventsDataType",
    "GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsEventsLinks",
    "GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsMarket",
    "GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsMarketData",
    "GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsMarketDataType",
    "GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsMarketLinks",
    "GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsSku",
    "GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsSkuData",
    "GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsSkuDataType",
    "GETinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsSkuLinks",
    "GETinStockSubscriptionsinStockSubscriptionIdResponse200DataType",
    "GETinStockSubscriptionsResponse200",
    "GETinStockSubscriptionsResponse200DataItem",
    "GETinStockSubscriptionsResponse200DataItemAttributes",
    "GETinStockSubscriptionsResponse200DataItemAttributesMetadata",
    "GETinStockSubscriptionsResponse200DataItemLinks",
    "GETinStockSubscriptionsResponse200DataItemRelationships",
    "GETinStockSubscriptionsResponse200DataItemRelationshipsCustomer",
    "GETinStockSubscriptionsResponse200DataItemRelationshipsCustomerData",
    "GETinStockSubscriptionsResponse200DataItemRelationshipsCustomerDataType",
    "GETinStockSubscriptionsResponse200DataItemRelationshipsCustomerLinks",
    "GETinStockSubscriptionsResponse200DataItemRelationshipsEvents",
    "GETinStockSubscriptionsResponse200DataItemRelationshipsEventsData",
    "GETinStockSubscriptionsResponse200DataItemRelationshipsEventsDataType",
    "GETinStockSubscriptionsResponse200DataItemRelationshipsEventsLinks",
    "GETinStockSubscriptionsResponse200DataItemRelationshipsMarket",
    "GETinStockSubscriptionsResponse200DataItemRelationshipsMarketData",
    "GETinStockSubscriptionsResponse200DataItemRelationshipsMarketDataType",
    "GETinStockSubscriptionsResponse200DataItemRelationshipsMarketLinks",
    "GETinStockSubscriptionsResponse200DataItemRelationshipsSku",
    "GETinStockSubscriptionsResponse200DataItemRelationshipsSkuData",
    "GETinStockSubscriptionsResponse200DataItemRelationshipsSkuDataType",
    "GETinStockSubscriptionsResponse200DataItemRelationshipsSkuLinks",
    "GETinStockSubscriptionsResponse200DataItemType",
    "GETinventoryModelsinventoryModelIdResponse200",
    "GETinventoryModelsinventoryModelIdResponse200Data",
    "GETinventoryModelsinventoryModelIdResponse200DataAttributes",
    "GETinventoryModelsinventoryModelIdResponse200DataAttributesMetadata",
    "GETinventoryModelsinventoryModelIdResponse200DataLinks",
    "GETinventoryModelsinventoryModelIdResponse200DataRelationships",
    "GETinventoryModelsinventoryModelIdResponse200DataRelationshipsAttachments",
    "GETinventoryModelsinventoryModelIdResponse200DataRelationshipsAttachmentsData",
    "GETinventoryModelsinventoryModelIdResponse200DataRelationshipsAttachmentsDataType",
    "GETinventoryModelsinventoryModelIdResponse200DataRelationshipsAttachmentsLinks",
    "GETinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryReturnLocations",
    "GETinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryReturnLocationsData",
    "GETinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryReturnLocationsDataType",
    "GETinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryReturnLocationsLinks",
    "GETinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryStockLocations",
    "GETinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryStockLocationsData",
    "GETinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryStockLocationsDataType",
    "GETinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryStockLocationsLinks",
    "GETinventoryModelsinventoryModelIdResponse200DataType",
    "GETinventoryModelsResponse200",
    "GETinventoryModelsResponse200DataItem",
    "GETinventoryModelsResponse200DataItemAttributes",
    "GETinventoryModelsResponse200DataItemAttributesMetadata",
    "GETinventoryModelsResponse200DataItemLinks",
    "GETinventoryModelsResponse200DataItemRelationships",
    "GETinventoryModelsResponse200DataItemRelationshipsAttachments",
    "GETinventoryModelsResponse200DataItemRelationshipsAttachmentsData",
    "GETinventoryModelsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETinventoryModelsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETinventoryModelsResponse200DataItemRelationshipsInventoryReturnLocations",
    "GETinventoryModelsResponse200DataItemRelationshipsInventoryReturnLocationsData",
    "GETinventoryModelsResponse200DataItemRelationshipsInventoryReturnLocationsDataType",
    "GETinventoryModelsResponse200DataItemRelationshipsInventoryReturnLocationsLinks",
    "GETinventoryModelsResponse200DataItemRelationshipsInventoryStockLocations",
    "GETinventoryModelsResponse200DataItemRelationshipsInventoryStockLocationsData",
    "GETinventoryModelsResponse200DataItemRelationshipsInventoryStockLocationsDataType",
    "GETinventoryModelsResponse200DataItemRelationshipsInventoryStockLocationsLinks",
    "GETinventoryModelsResponse200DataItemType",
    "GETinventoryReturnLocationsinventoryReturnLocationIdResponse200",
    "GETinventoryReturnLocationsinventoryReturnLocationIdResponse200Data",
    "GETinventoryReturnLocationsinventoryReturnLocationIdResponse200DataAttributes",
    "GETinventoryReturnLocationsinventoryReturnLocationIdResponse200DataAttributesMetadata",
    "GETinventoryReturnLocationsinventoryReturnLocationIdResponse200DataLinks",
    "GETinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationships",
    "GETinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsInventoryModel",
    "GETinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsInventoryModelData",
    "GETinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsInventoryModelDataType",
    "GETinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsInventoryModelLinks",
    "GETinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsStockLocation",
    "GETinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsStockLocationData",
    "GETinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsStockLocationDataType",
    "GETinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsStockLocationLinks",
    "GETinventoryReturnLocationsinventoryReturnLocationIdResponse200DataType",
    "GETinventoryReturnLocationsResponse200",
    "GETinventoryReturnLocationsResponse200DataItem",
    "GETinventoryReturnLocationsResponse200DataItemAttributes",
    "GETinventoryReturnLocationsResponse200DataItemAttributesMetadata",
    "GETinventoryReturnLocationsResponse200DataItemLinks",
    "GETinventoryReturnLocationsResponse200DataItemRelationships",
    "GETinventoryReturnLocationsResponse200DataItemRelationshipsInventoryModel",
    "GETinventoryReturnLocationsResponse200DataItemRelationshipsInventoryModelData",
    "GETinventoryReturnLocationsResponse200DataItemRelationshipsInventoryModelDataType",
    "GETinventoryReturnLocationsResponse200DataItemRelationshipsInventoryModelLinks",
    "GETinventoryReturnLocationsResponse200DataItemRelationshipsStockLocation",
    "GETinventoryReturnLocationsResponse200DataItemRelationshipsStockLocationData",
    "GETinventoryReturnLocationsResponse200DataItemRelationshipsStockLocationDataType",
    "GETinventoryReturnLocationsResponse200DataItemRelationshipsStockLocationLinks",
    "GETinventoryReturnLocationsResponse200DataItemType",
    "GETinventoryStockLocationsinventoryStockLocationIdResponse200",
    "GETinventoryStockLocationsinventoryStockLocationIdResponse200Data",
    "GETinventoryStockLocationsinventoryStockLocationIdResponse200DataAttributes",
    "GETinventoryStockLocationsinventoryStockLocationIdResponse200DataAttributesMetadata",
    "GETinventoryStockLocationsinventoryStockLocationIdResponse200DataLinks",
    "GETinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationships",
    "GETinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsInventoryModel",
    "GETinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsInventoryModelData",
    "GETinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsInventoryModelDataType",
    "GETinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsInventoryModelLinks",
    "GETinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsStockLocation",
    "GETinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsStockLocationData",
    "GETinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsStockLocationDataType",
    "GETinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsStockLocationLinks",
    "GETinventoryStockLocationsinventoryStockLocationIdResponse200DataType",
    "GETinventoryStockLocationsResponse200",
    "GETinventoryStockLocationsResponse200DataItem",
    "GETinventoryStockLocationsResponse200DataItemAttributes",
    "GETinventoryStockLocationsResponse200DataItemAttributesMetadata",
    "GETinventoryStockLocationsResponse200DataItemLinks",
    "GETinventoryStockLocationsResponse200DataItemRelationships",
    "GETinventoryStockLocationsResponse200DataItemRelationshipsInventoryModel",
    "GETinventoryStockLocationsResponse200DataItemRelationshipsInventoryModelData",
    "GETinventoryStockLocationsResponse200DataItemRelationshipsInventoryModelDataType",
    "GETinventoryStockLocationsResponse200DataItemRelationshipsInventoryModelLinks",
    "GETinventoryStockLocationsResponse200DataItemRelationshipsStockLocation",
    "GETinventoryStockLocationsResponse200DataItemRelationshipsStockLocationData",
    "GETinventoryStockLocationsResponse200DataItemRelationshipsStockLocationDataType",
    "GETinventoryStockLocationsResponse200DataItemRelationshipsStockLocationLinks",
    "GETinventoryStockLocationsResponse200DataItemType",
    "GETklarnaGatewaysklarnaGatewayIdResponse200",
    "GETklarnaGatewaysklarnaGatewayIdResponse200Data",
    "GETklarnaGatewaysklarnaGatewayIdResponse200DataAttributes",
    "GETklarnaGatewaysklarnaGatewayIdResponse200DataAttributesMetadata",
    "GETklarnaGatewaysklarnaGatewayIdResponse200DataLinks",
    "GETklarnaGatewaysklarnaGatewayIdResponse200DataRelationships",
    "GETklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsKlarnaPayments",
    "GETklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsKlarnaPaymentsData",
    "GETklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsKlarnaPaymentsDataType",
    "GETklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsKlarnaPaymentsLinks",
    "GETklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsPaymentMethods",
    "GETklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsPaymentMethodsData",
    "GETklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsPaymentMethodsDataType",
    "GETklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsPaymentMethodsLinks",
    "GETklarnaGatewaysklarnaGatewayIdResponse200DataType",
    "GETklarnaGatewaysResponse200",
    "GETklarnaGatewaysResponse200DataItem",
    "GETklarnaGatewaysResponse200DataItemAttributes",
    "GETklarnaGatewaysResponse200DataItemAttributesMetadata",
    "GETklarnaGatewaysResponse200DataItemLinks",
    "GETklarnaGatewaysResponse200DataItemRelationships",
    "GETklarnaGatewaysResponse200DataItemRelationshipsKlarnaPayments",
    "GETklarnaGatewaysResponse200DataItemRelationshipsKlarnaPaymentsData",
    "GETklarnaGatewaysResponse200DataItemRelationshipsKlarnaPaymentsDataType",
    "GETklarnaGatewaysResponse200DataItemRelationshipsKlarnaPaymentsLinks",
    "GETklarnaGatewaysResponse200DataItemRelationshipsPaymentMethods",
    "GETklarnaGatewaysResponse200DataItemRelationshipsPaymentMethodsData",
    "GETklarnaGatewaysResponse200DataItemRelationshipsPaymentMethodsDataType",
    "GETklarnaGatewaysResponse200DataItemRelationshipsPaymentMethodsLinks",
    "GETklarnaGatewaysResponse200DataItemType",
    "GETklarnaPaymentsklarnaPaymentIdResponse200",
    "GETklarnaPaymentsklarnaPaymentIdResponse200Data",
    "GETklarnaPaymentsklarnaPaymentIdResponse200DataAttributes",
    "GETklarnaPaymentsklarnaPaymentIdResponse200DataAttributesMetadata",
    "GETklarnaPaymentsklarnaPaymentIdResponse200DataAttributesPaymentMethodsItem",
    "GETklarnaPaymentsklarnaPaymentIdResponse200DataLinks",
    "GETklarnaPaymentsklarnaPaymentIdResponse200DataRelationships",
    "GETklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsOrder",
    "GETklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsOrderData",
    "GETklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsOrderDataType",
    "GETklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsOrderLinks",
    "GETklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsPaymentGateway",
    "GETklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsPaymentGatewayData",
    "GETklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsPaymentGatewayDataType",
    "GETklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsPaymentGatewayLinks",
    "GETklarnaPaymentsklarnaPaymentIdResponse200DataType",
    "GETklarnaPaymentsResponse200",
    "GETklarnaPaymentsResponse200DataItem",
    "GETklarnaPaymentsResponse200DataItemAttributes",
    "GETklarnaPaymentsResponse200DataItemAttributesMetadata",
    "GETklarnaPaymentsResponse200DataItemAttributesPaymentMethodsItem",
    "GETklarnaPaymentsResponse200DataItemLinks",
    "GETklarnaPaymentsResponse200DataItemRelationships",
    "GETklarnaPaymentsResponse200DataItemRelationshipsOrder",
    "GETklarnaPaymentsResponse200DataItemRelationshipsOrderData",
    "GETklarnaPaymentsResponse200DataItemRelationshipsOrderDataType",
    "GETklarnaPaymentsResponse200DataItemRelationshipsOrderLinks",
    "GETklarnaPaymentsResponse200DataItemRelationshipsPaymentGateway",
    "GETklarnaPaymentsResponse200DataItemRelationshipsPaymentGatewayData",
    "GETklarnaPaymentsResponse200DataItemRelationshipsPaymentGatewayDataType",
    "GETklarnaPaymentsResponse200DataItemRelationshipsPaymentGatewayLinks",
    "GETklarnaPaymentsResponse200DataItemType",
    "GETlineItemOptionslineItemOptionIdResponse200",
    "GETlineItemOptionslineItemOptionIdResponse200Data",
    "GETlineItemOptionslineItemOptionIdResponse200DataAttributes",
    "GETlineItemOptionslineItemOptionIdResponse200DataAttributesMetadata",
    "GETlineItemOptionslineItemOptionIdResponse200DataAttributesOptions",
    "GETlineItemOptionslineItemOptionIdResponse200DataLinks",
    "GETlineItemOptionslineItemOptionIdResponse200DataRelationships",
    "GETlineItemOptionslineItemOptionIdResponse200DataRelationshipsLineItem",
    "GETlineItemOptionslineItemOptionIdResponse200DataRelationshipsLineItemData",
    "GETlineItemOptionslineItemOptionIdResponse200DataRelationshipsLineItemDataType",
    "GETlineItemOptionslineItemOptionIdResponse200DataRelationshipsLineItemLinks",
    "GETlineItemOptionslineItemOptionIdResponse200DataRelationshipsSkuOption",
    "GETlineItemOptionslineItemOptionIdResponse200DataRelationshipsSkuOptionData",
    "GETlineItemOptionslineItemOptionIdResponse200DataRelationshipsSkuOptionDataType",
    "GETlineItemOptionslineItemOptionIdResponse200DataRelationshipsSkuOptionLinks",
    "GETlineItemOptionslineItemOptionIdResponse200DataType",
    "GETlineItemOptionsResponse200",
    "GETlineItemOptionsResponse200DataItem",
    "GETlineItemOptionsResponse200DataItemAttributes",
    "GETlineItemOptionsResponse200DataItemAttributesMetadata",
    "GETlineItemOptionsResponse200DataItemAttributesOptions",
    "GETlineItemOptionsResponse200DataItemLinks",
    "GETlineItemOptionsResponse200DataItemRelationships",
    "GETlineItemOptionsResponse200DataItemRelationshipsLineItem",
    "GETlineItemOptionsResponse200DataItemRelationshipsLineItemData",
    "GETlineItemOptionsResponse200DataItemRelationshipsLineItemDataType",
    "GETlineItemOptionsResponse200DataItemRelationshipsLineItemLinks",
    "GETlineItemOptionsResponse200DataItemRelationshipsSkuOption",
    "GETlineItemOptionsResponse200DataItemRelationshipsSkuOptionData",
    "GETlineItemOptionsResponse200DataItemRelationshipsSkuOptionDataType",
    "GETlineItemOptionsResponse200DataItemRelationshipsSkuOptionLinks",
    "GETlineItemOptionsResponse200DataItemType",
    "GETlineItemslineItemIdResponse200",
    "GETlineItemslineItemIdResponse200Data",
    "GETlineItemslineItemIdResponse200DataAttributes",
    "GETlineItemslineItemIdResponse200DataAttributesDiscountBreakdown",
    "GETlineItemslineItemIdResponse200DataAttributesMetadata",
    "GETlineItemslineItemIdResponse200DataAttributesTaxBreakdown",
    "GETlineItemslineItemIdResponse200DataLinks",
    "GETlineItemslineItemIdResponse200DataRelationships",
    "GETlineItemslineItemIdResponse200DataRelationshipsItem",
    "GETlineItemslineItemIdResponse200DataRelationshipsItemData",
    "GETlineItemslineItemIdResponse200DataRelationshipsItemDataType",
    "GETlineItemslineItemIdResponse200DataRelationshipsItemLinks",
    "GETlineItemslineItemIdResponse200DataRelationshipsLineItemOptions",
    "GETlineItemslineItemIdResponse200DataRelationshipsLineItemOptionsData",
    "GETlineItemslineItemIdResponse200DataRelationshipsLineItemOptionsDataType",
    "GETlineItemslineItemIdResponse200DataRelationshipsLineItemOptionsLinks",
    "GETlineItemslineItemIdResponse200DataRelationshipsOrder",
    "GETlineItemslineItemIdResponse200DataRelationshipsOrderData",
    "GETlineItemslineItemIdResponse200DataRelationshipsOrderDataType",
    "GETlineItemslineItemIdResponse200DataRelationshipsOrderLinks",
    "GETlineItemslineItemIdResponse200DataRelationshipsShipmentLineItems",
    "GETlineItemslineItemIdResponse200DataRelationshipsShipmentLineItemsData",
    "GETlineItemslineItemIdResponse200DataRelationshipsShipmentLineItemsDataType",
    "GETlineItemslineItemIdResponse200DataRelationshipsShipmentLineItemsLinks",
    "GETlineItemslineItemIdResponse200DataRelationshipsStockLineItems",
    "GETlineItemslineItemIdResponse200DataRelationshipsStockLineItemsData",
    "GETlineItemslineItemIdResponse200DataRelationshipsStockLineItemsDataType",
    "GETlineItemslineItemIdResponse200DataRelationshipsStockLineItemsLinks",
    "GETlineItemslineItemIdResponse200DataRelationshipsStockTransfers",
    "GETlineItemslineItemIdResponse200DataRelationshipsStockTransfersData",
    "GETlineItemslineItemIdResponse200DataRelationshipsStockTransfersDataType",
    "GETlineItemslineItemIdResponse200DataRelationshipsStockTransfersLinks",
    "GETlineItemslineItemIdResponse200DataType",
    "GETlineItemsResponse200",
    "GETlineItemsResponse200DataItem",
    "GETlineItemsResponse200DataItemAttributes",
    "GETlineItemsResponse200DataItemAttributesDiscountBreakdown",
    "GETlineItemsResponse200DataItemAttributesMetadata",
    "GETlineItemsResponse200DataItemAttributesTaxBreakdown",
    "GETlineItemsResponse200DataItemLinks",
    "GETlineItemsResponse200DataItemRelationships",
    "GETlineItemsResponse200DataItemRelationshipsItem",
    "GETlineItemsResponse200DataItemRelationshipsItemData",
    "GETlineItemsResponse200DataItemRelationshipsItemDataType",
    "GETlineItemsResponse200DataItemRelationshipsItemLinks",
    "GETlineItemsResponse200DataItemRelationshipsLineItemOptions",
    "GETlineItemsResponse200DataItemRelationshipsLineItemOptionsData",
    "GETlineItemsResponse200DataItemRelationshipsLineItemOptionsDataType",
    "GETlineItemsResponse200DataItemRelationshipsLineItemOptionsLinks",
    "GETlineItemsResponse200DataItemRelationshipsOrder",
    "GETlineItemsResponse200DataItemRelationshipsOrderData",
    "GETlineItemsResponse200DataItemRelationshipsOrderDataType",
    "GETlineItemsResponse200DataItemRelationshipsOrderLinks",
    "GETlineItemsResponse200DataItemRelationshipsShipmentLineItems",
    "GETlineItemsResponse200DataItemRelationshipsShipmentLineItemsData",
    "GETlineItemsResponse200DataItemRelationshipsShipmentLineItemsDataType",
    "GETlineItemsResponse200DataItemRelationshipsShipmentLineItemsLinks",
    "GETlineItemsResponse200DataItemRelationshipsStockLineItems",
    "GETlineItemsResponse200DataItemRelationshipsStockLineItemsData",
    "GETlineItemsResponse200DataItemRelationshipsStockLineItemsDataType",
    "GETlineItemsResponse200DataItemRelationshipsStockLineItemsLinks",
    "GETlineItemsResponse200DataItemRelationshipsStockTransfers",
    "GETlineItemsResponse200DataItemRelationshipsStockTransfersData",
    "GETlineItemsResponse200DataItemRelationshipsStockTransfersDataType",
    "GETlineItemsResponse200DataItemRelationshipsStockTransfersLinks",
    "GETlineItemsResponse200DataItemType",
    "GETmanualGatewaysmanualGatewayIdResponse200",
    "GETmanualGatewaysmanualGatewayIdResponse200Data",
    "GETmanualGatewaysmanualGatewayIdResponse200DataAttributes",
    "GETmanualGatewaysmanualGatewayIdResponse200DataAttributesMetadata",
    "GETmanualGatewaysmanualGatewayIdResponse200DataLinks",
    "GETmanualGatewaysmanualGatewayIdResponse200DataRelationships",
    "GETmanualGatewaysmanualGatewayIdResponse200DataRelationshipsPaymentMethods",
    "GETmanualGatewaysmanualGatewayIdResponse200DataRelationshipsPaymentMethodsData",
    "GETmanualGatewaysmanualGatewayIdResponse200DataRelationshipsPaymentMethodsDataType",
    "GETmanualGatewaysmanualGatewayIdResponse200DataRelationshipsPaymentMethodsLinks",
    "GETmanualGatewaysmanualGatewayIdResponse200DataType",
    "GETmanualGatewaysResponse200",
    "GETmanualGatewaysResponse200DataItem",
    "GETmanualGatewaysResponse200DataItemAttributes",
    "GETmanualGatewaysResponse200DataItemAttributesMetadata",
    "GETmanualGatewaysResponse200DataItemLinks",
    "GETmanualGatewaysResponse200DataItemRelationships",
    "GETmanualGatewaysResponse200DataItemRelationshipsPaymentMethods",
    "GETmanualGatewaysResponse200DataItemRelationshipsPaymentMethodsData",
    "GETmanualGatewaysResponse200DataItemRelationshipsPaymentMethodsDataType",
    "GETmanualGatewaysResponse200DataItemRelationshipsPaymentMethodsLinks",
    "GETmanualGatewaysResponse200DataItemType",
    "GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200",
    "GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200Data",
    "GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataAttributes",
    "GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataAttributesMetadata",
    "GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataLinks",
    "GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationships",
    "GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsAttachments",
    "GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsAttachmentsData",
    "GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsAttachmentsDataType",
    "GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsAttachmentsLinks",
    "GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsMarkets",
    "GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsMarketsData",
    "GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsMarketsDataType",
    "GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsMarketsLinks",
    "GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsTaxRules",
    "GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsTaxRulesData",
    "GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsTaxRulesDataType",
    "GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsTaxRulesLinks",
    "GETmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataType",
    "GETmanualTaxCalculatorsResponse200",
    "GETmanualTaxCalculatorsResponse200DataItem",
    "GETmanualTaxCalculatorsResponse200DataItemAttributes",
    "GETmanualTaxCalculatorsResponse200DataItemAttributesMetadata",
    "GETmanualTaxCalculatorsResponse200DataItemLinks",
    "GETmanualTaxCalculatorsResponse200DataItemRelationships",
    "GETmanualTaxCalculatorsResponse200DataItemRelationshipsAttachments",
    "GETmanualTaxCalculatorsResponse200DataItemRelationshipsAttachmentsData",
    "GETmanualTaxCalculatorsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETmanualTaxCalculatorsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETmanualTaxCalculatorsResponse200DataItemRelationshipsMarkets",
    "GETmanualTaxCalculatorsResponse200DataItemRelationshipsMarketsData",
    "GETmanualTaxCalculatorsResponse200DataItemRelationshipsMarketsDataType",
    "GETmanualTaxCalculatorsResponse200DataItemRelationshipsMarketsLinks",
    "GETmanualTaxCalculatorsResponse200DataItemRelationshipsTaxRules",
    "GETmanualTaxCalculatorsResponse200DataItemRelationshipsTaxRulesData",
    "GETmanualTaxCalculatorsResponse200DataItemRelationshipsTaxRulesDataType",
    "GETmanualTaxCalculatorsResponse200DataItemRelationshipsTaxRulesLinks",
    "GETmanualTaxCalculatorsResponse200DataItemType",
    "GETmarketsmarketIdResponse200",
    "GETmarketsmarketIdResponse200Data",
    "GETmarketsmarketIdResponse200DataAttributes",
    "GETmarketsmarketIdResponse200DataAttributesMetadata",
    "GETmarketsmarketIdResponse200DataLinks",
    "GETmarketsmarketIdResponse200DataRelationships",
    "GETmarketsmarketIdResponse200DataRelationshipsAttachments",
    "GETmarketsmarketIdResponse200DataRelationshipsAttachmentsData",
    "GETmarketsmarketIdResponse200DataRelationshipsAttachmentsDataType",
    "GETmarketsmarketIdResponse200DataRelationshipsAttachmentsLinks",
    "GETmarketsmarketIdResponse200DataRelationshipsCustomerGroup",
    "GETmarketsmarketIdResponse200DataRelationshipsCustomerGroupData",
    "GETmarketsmarketIdResponse200DataRelationshipsCustomerGroupDataType",
    "GETmarketsmarketIdResponse200DataRelationshipsCustomerGroupLinks",
    "GETmarketsmarketIdResponse200DataRelationshipsInventoryModel",
    "GETmarketsmarketIdResponse200DataRelationshipsInventoryModelData",
    "GETmarketsmarketIdResponse200DataRelationshipsInventoryModelDataType",
    "GETmarketsmarketIdResponse200DataRelationshipsInventoryModelLinks",
    "GETmarketsmarketIdResponse200DataRelationshipsMerchant",
    "GETmarketsmarketIdResponse200DataRelationshipsMerchantData",
    "GETmarketsmarketIdResponse200DataRelationshipsMerchantDataType",
    "GETmarketsmarketIdResponse200DataRelationshipsMerchantLinks",
    "GETmarketsmarketIdResponse200DataRelationshipsPriceList",
    "GETmarketsmarketIdResponse200DataRelationshipsPriceListData",
    "GETmarketsmarketIdResponse200DataRelationshipsPriceListDataType",
    "GETmarketsmarketIdResponse200DataRelationshipsPriceListLinks",
    "GETmarketsmarketIdResponse200DataRelationshipsTaxCalculator",
    "GETmarketsmarketIdResponse200DataRelationshipsTaxCalculatorData",
    "GETmarketsmarketIdResponse200DataRelationshipsTaxCalculatorDataType",
    "GETmarketsmarketIdResponse200DataRelationshipsTaxCalculatorLinks",
    "GETmarketsmarketIdResponse200DataType",
    "GETmarketsResponse200",
    "GETmarketsResponse200DataItem",
    "GETmarketsResponse200DataItemAttributes",
    "GETmarketsResponse200DataItemAttributesMetadata",
    "GETmarketsResponse200DataItemLinks",
    "GETmarketsResponse200DataItemRelationships",
    "GETmarketsResponse200DataItemRelationshipsAttachments",
    "GETmarketsResponse200DataItemRelationshipsAttachmentsData",
    "GETmarketsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETmarketsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETmarketsResponse200DataItemRelationshipsCustomerGroup",
    "GETmarketsResponse200DataItemRelationshipsCustomerGroupData",
    "GETmarketsResponse200DataItemRelationshipsCustomerGroupDataType",
    "GETmarketsResponse200DataItemRelationshipsCustomerGroupLinks",
    "GETmarketsResponse200DataItemRelationshipsInventoryModel",
    "GETmarketsResponse200DataItemRelationshipsInventoryModelData",
    "GETmarketsResponse200DataItemRelationshipsInventoryModelDataType",
    "GETmarketsResponse200DataItemRelationshipsInventoryModelLinks",
    "GETmarketsResponse200DataItemRelationshipsMerchant",
    "GETmarketsResponse200DataItemRelationshipsMerchantData",
    "GETmarketsResponse200DataItemRelationshipsMerchantDataType",
    "GETmarketsResponse200DataItemRelationshipsMerchantLinks",
    "GETmarketsResponse200DataItemRelationshipsPriceList",
    "GETmarketsResponse200DataItemRelationshipsPriceListData",
    "GETmarketsResponse200DataItemRelationshipsPriceListDataType",
    "GETmarketsResponse200DataItemRelationshipsPriceListLinks",
    "GETmarketsResponse200DataItemRelationshipsTaxCalculator",
    "GETmarketsResponse200DataItemRelationshipsTaxCalculatorData",
    "GETmarketsResponse200DataItemRelationshipsTaxCalculatorDataType",
    "GETmarketsResponse200DataItemRelationshipsTaxCalculatorLinks",
    "GETmarketsResponse200DataItemType",
    "GETmerchantsmerchantIdResponse200",
    "GETmerchantsmerchantIdResponse200Data",
    "GETmerchantsmerchantIdResponse200DataAttributes",
    "GETmerchantsmerchantIdResponse200DataAttributesMetadata",
    "GETmerchantsmerchantIdResponse200DataLinks",
    "GETmerchantsmerchantIdResponse200DataRelationships",
    "GETmerchantsmerchantIdResponse200DataRelationshipsAddress",
    "GETmerchantsmerchantIdResponse200DataRelationshipsAddressData",
    "GETmerchantsmerchantIdResponse200DataRelationshipsAddressDataType",
    "GETmerchantsmerchantIdResponse200DataRelationshipsAddressLinks",
    "GETmerchantsmerchantIdResponse200DataRelationshipsAttachments",
    "GETmerchantsmerchantIdResponse200DataRelationshipsAttachmentsData",
    "GETmerchantsmerchantIdResponse200DataRelationshipsAttachmentsDataType",
    "GETmerchantsmerchantIdResponse200DataRelationshipsAttachmentsLinks",
    "GETmerchantsmerchantIdResponse200DataType",
    "GETmerchantsResponse200",
    "GETmerchantsResponse200DataItem",
    "GETmerchantsResponse200DataItemAttributes",
    "GETmerchantsResponse200DataItemAttributesMetadata",
    "GETmerchantsResponse200DataItemLinks",
    "GETmerchantsResponse200DataItemRelationships",
    "GETmerchantsResponse200DataItemRelationshipsAddress",
    "GETmerchantsResponse200DataItemRelationshipsAddressData",
    "GETmerchantsResponse200DataItemRelationshipsAddressDataType",
    "GETmerchantsResponse200DataItemRelationshipsAddressLinks",
    "GETmerchantsResponse200DataItemRelationshipsAttachments",
    "GETmerchantsResponse200DataItemRelationshipsAttachmentsData",
    "GETmerchantsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETmerchantsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETmerchantsResponse200DataItemType",
    "GETorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200",
    "GETorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200Data",
    "GETorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataAttributes",
    "GETorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataAttributesMetadata",
    "GETorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataLinks",
    "GETorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataRelationships",
    "GETorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataRelationshipsPromotion",
    "GETorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataRelationshipsPromotionData",
    "GETorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataRelationshipsPromotionDataType",
    "GETorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataRelationshipsPromotionLinks",
    "GETorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataType",
    "GETorderAmountPromotionRulesResponse200",
    "GETorderAmountPromotionRulesResponse200DataItem",
    "GETorderAmountPromotionRulesResponse200DataItemAttributes",
    "GETorderAmountPromotionRulesResponse200DataItemAttributesMetadata",
    "GETorderAmountPromotionRulesResponse200DataItemLinks",
    "GETorderAmountPromotionRulesResponse200DataItemRelationships",
    "GETorderAmountPromotionRulesResponse200DataItemRelationshipsPromotion",
    "GETorderAmountPromotionRulesResponse200DataItemRelationshipsPromotionData",
    "GETorderAmountPromotionRulesResponse200DataItemRelationshipsPromotionDataType",
    "GETorderAmountPromotionRulesResponse200DataItemRelationshipsPromotionLinks",
    "GETorderAmountPromotionRulesResponse200DataItemType",
    "GETorderCopiesorderCopyIdResponse200",
    "GETorderCopiesorderCopyIdResponse200Data",
    "GETorderCopiesorderCopyIdResponse200DataAttributes",
    "GETorderCopiesorderCopyIdResponse200DataAttributesErrorsLog",
    "GETorderCopiesorderCopyIdResponse200DataAttributesMetadata",
    "GETorderCopiesorderCopyIdResponse200DataLinks",
    "GETorderCopiesorderCopyIdResponse200DataRelationships",
    "GETorderCopiesorderCopyIdResponse200DataRelationshipsEvents",
    "GETorderCopiesorderCopyIdResponse200DataRelationshipsEventsData",
    "GETorderCopiesorderCopyIdResponse200DataRelationshipsEventsDataType",
    "GETorderCopiesorderCopyIdResponse200DataRelationshipsEventsLinks",
    "GETorderCopiesorderCopyIdResponse200DataRelationshipsOrderSubscription",
    "GETorderCopiesorderCopyIdResponse200DataRelationshipsOrderSubscriptionData",
    "GETorderCopiesorderCopyIdResponse200DataRelationshipsOrderSubscriptionDataType",
    "GETorderCopiesorderCopyIdResponse200DataRelationshipsOrderSubscriptionLinks",
    "GETorderCopiesorderCopyIdResponse200DataRelationshipsSourceOrder",
    "GETorderCopiesorderCopyIdResponse200DataRelationshipsSourceOrderData",
    "GETorderCopiesorderCopyIdResponse200DataRelationshipsSourceOrderDataType",
    "GETorderCopiesorderCopyIdResponse200DataRelationshipsSourceOrderLinks",
    "GETorderCopiesorderCopyIdResponse200DataRelationshipsTargetOrder",
    "GETorderCopiesorderCopyIdResponse200DataRelationshipsTargetOrderData",
    "GETorderCopiesorderCopyIdResponse200DataRelationshipsTargetOrderDataType",
    "GETorderCopiesorderCopyIdResponse200DataRelationshipsTargetOrderLinks",
    "GETorderCopiesorderCopyIdResponse200DataType",
    "GETorderCopiesResponse200",
    "GETorderCopiesResponse200DataItem",
    "GETorderCopiesResponse200DataItemAttributes",
    "GETorderCopiesResponse200DataItemAttributesErrorsLog",
    "GETorderCopiesResponse200DataItemAttributesMetadata",
    "GETorderCopiesResponse200DataItemLinks",
    "GETorderCopiesResponse200DataItemRelationships",
    "GETorderCopiesResponse200DataItemRelationshipsEvents",
    "GETorderCopiesResponse200DataItemRelationshipsEventsData",
    "GETorderCopiesResponse200DataItemRelationshipsEventsDataType",
    "GETorderCopiesResponse200DataItemRelationshipsEventsLinks",
    "GETorderCopiesResponse200DataItemRelationshipsOrderSubscription",
    "GETorderCopiesResponse200DataItemRelationshipsOrderSubscriptionData",
    "GETorderCopiesResponse200DataItemRelationshipsOrderSubscriptionDataType",
    "GETorderCopiesResponse200DataItemRelationshipsOrderSubscriptionLinks",
    "GETorderCopiesResponse200DataItemRelationshipsSourceOrder",
    "GETorderCopiesResponse200DataItemRelationshipsSourceOrderData",
    "GETorderCopiesResponse200DataItemRelationshipsSourceOrderDataType",
    "GETorderCopiesResponse200DataItemRelationshipsSourceOrderLinks",
    "GETorderCopiesResponse200DataItemRelationshipsTargetOrder",
    "GETorderCopiesResponse200DataItemRelationshipsTargetOrderData",
    "GETorderCopiesResponse200DataItemRelationshipsTargetOrderDataType",
    "GETorderCopiesResponse200DataItemRelationshipsTargetOrderLinks",
    "GETorderCopiesResponse200DataItemType",
    "GETordersorderIdResponse200",
    "GETordersorderIdResponse200Data",
    "GETordersorderIdResponse200DataAttributes",
    "GETordersorderIdResponse200DataAttributesMetadata",
    "GETordersorderIdResponse200DataAttributesPaymentSourceDetails",
    "GETordersorderIdResponse200DataLinks",
    "GETordersorderIdResponse200DataRelationships",
    "GETordersorderIdResponse200DataRelationshipsAttachments",
    "GETordersorderIdResponse200DataRelationshipsAttachmentsData",
    "GETordersorderIdResponse200DataRelationshipsAttachmentsDataType",
    "GETordersorderIdResponse200DataRelationshipsAttachmentsLinks",
    "GETordersorderIdResponse200DataRelationshipsAuthorizations",
    "GETordersorderIdResponse200DataRelationshipsAuthorizationsData",
    "GETordersorderIdResponse200DataRelationshipsAuthorizationsDataType",
    "GETordersorderIdResponse200DataRelationshipsAuthorizationsLinks",
    "GETordersorderIdResponse200DataRelationshipsAvailableCustomerPaymentSources",
    "GETordersorderIdResponse200DataRelationshipsAvailableCustomerPaymentSourcesData",
    "GETordersorderIdResponse200DataRelationshipsAvailableCustomerPaymentSourcesDataType",
    "GETordersorderIdResponse200DataRelationshipsAvailableCustomerPaymentSourcesLinks",
    "GETordersorderIdResponse200DataRelationshipsAvailableFreeBundles",
    "GETordersorderIdResponse200DataRelationshipsAvailableFreeBundlesData",
    "GETordersorderIdResponse200DataRelationshipsAvailableFreeBundlesDataType",
    "GETordersorderIdResponse200DataRelationshipsAvailableFreeBundlesLinks",
    "GETordersorderIdResponse200DataRelationshipsAvailableFreeSkus",
    "GETordersorderIdResponse200DataRelationshipsAvailableFreeSkusData",
    "GETordersorderIdResponse200DataRelationshipsAvailableFreeSkusDataType",
    "GETordersorderIdResponse200DataRelationshipsAvailableFreeSkusLinks",
    "GETordersorderIdResponse200DataRelationshipsAvailablePaymentMethods",
    "GETordersorderIdResponse200DataRelationshipsAvailablePaymentMethodsData",
    "GETordersorderIdResponse200DataRelationshipsAvailablePaymentMethodsDataType",
    "GETordersorderIdResponse200DataRelationshipsAvailablePaymentMethodsLinks",
    "GETordersorderIdResponse200DataRelationshipsBillingAddress",
    "GETordersorderIdResponse200DataRelationshipsBillingAddressData",
    "GETordersorderIdResponse200DataRelationshipsBillingAddressDataType",
    "GETordersorderIdResponse200DataRelationshipsBillingAddressLinks",
    "GETordersorderIdResponse200DataRelationshipsCaptures",
    "GETordersorderIdResponse200DataRelationshipsCapturesData",
    "GETordersorderIdResponse200DataRelationshipsCapturesDataType",
    "GETordersorderIdResponse200DataRelationshipsCapturesLinks",
    "GETordersorderIdResponse200DataRelationshipsCustomer",
    "GETordersorderIdResponse200DataRelationshipsCustomerData",
    "GETordersorderIdResponse200DataRelationshipsCustomerDataType",
    "GETordersorderIdResponse200DataRelationshipsCustomerLinks",
    "GETordersorderIdResponse200DataRelationshipsEvents",
    "GETordersorderIdResponse200DataRelationshipsEventsData",
    "GETordersorderIdResponse200DataRelationshipsEventsDataType",
    "GETordersorderIdResponse200DataRelationshipsEventsLinks",
    "GETordersorderIdResponse200DataRelationshipsLineItems",
    "GETordersorderIdResponse200DataRelationshipsLineItemsData",
    "GETordersorderIdResponse200DataRelationshipsLineItemsDataType",
    "GETordersorderIdResponse200DataRelationshipsLineItemsLinks",
    "GETordersorderIdResponse200DataRelationshipsMarket",
    "GETordersorderIdResponse200DataRelationshipsMarketData",
    "GETordersorderIdResponse200DataRelationshipsMarketDataType",
    "GETordersorderIdResponse200DataRelationshipsMarketLinks",
    "GETordersorderIdResponse200DataRelationshipsOrderCopies",
    "GETordersorderIdResponse200DataRelationshipsOrderCopiesData",
    "GETordersorderIdResponse200DataRelationshipsOrderCopiesDataType",
    "GETordersorderIdResponse200DataRelationshipsOrderCopiesLinks",
    "GETordersorderIdResponse200DataRelationshipsOrderSubscriptions",
    "GETordersorderIdResponse200DataRelationshipsOrderSubscriptionsData",
    "GETordersorderIdResponse200DataRelationshipsOrderSubscriptionsDataType",
    "GETordersorderIdResponse200DataRelationshipsOrderSubscriptionsLinks",
    "GETordersorderIdResponse200DataRelationshipsPaymentMethod",
    "GETordersorderIdResponse200DataRelationshipsPaymentMethodData",
    "GETordersorderIdResponse200DataRelationshipsPaymentMethodDataType",
    "GETordersorderIdResponse200DataRelationshipsPaymentMethodLinks",
    "GETordersorderIdResponse200DataRelationshipsPaymentSource",
    "GETordersorderIdResponse200DataRelationshipsPaymentSourceData",
    "GETordersorderIdResponse200DataRelationshipsPaymentSourceDataType",
    "GETordersorderIdResponse200DataRelationshipsPaymentSourceLinks",
    "GETordersorderIdResponse200DataRelationshipsRefunds",
    "GETordersorderIdResponse200DataRelationshipsRefundsData",
    "GETordersorderIdResponse200DataRelationshipsRefundsDataType",
    "GETordersorderIdResponse200DataRelationshipsRefundsLinks",
    "GETordersorderIdResponse200DataRelationshipsShipments",
    "GETordersorderIdResponse200DataRelationshipsShipmentsData",
    "GETordersorderIdResponse200DataRelationshipsShipmentsDataType",
    "GETordersorderIdResponse200DataRelationshipsShipmentsLinks",
    "GETordersorderIdResponse200DataRelationshipsShippingAddress",
    "GETordersorderIdResponse200DataRelationshipsShippingAddressData",
    "GETordersorderIdResponse200DataRelationshipsShippingAddressDataType",
    "GETordersorderIdResponse200DataRelationshipsShippingAddressLinks",
    "GETordersorderIdResponse200DataRelationshipsTransactions",
    "GETordersorderIdResponse200DataRelationshipsTransactionsData",
    "GETordersorderIdResponse200DataRelationshipsTransactionsDataType",
    "GETordersorderIdResponse200DataRelationshipsTransactionsLinks",
    "GETordersorderIdResponse200DataRelationshipsVoids",
    "GETordersorderIdResponse200DataRelationshipsVoidsData",
    "GETordersorderIdResponse200DataRelationshipsVoidsDataType",
    "GETordersorderIdResponse200DataRelationshipsVoidsLinks",
    "GETordersorderIdResponse200DataType",
    "GETordersResponse200",
    "GETordersResponse200DataItem",
    "GETordersResponse200DataItemAttributes",
    "GETordersResponse200DataItemAttributesMetadata",
    "GETordersResponse200DataItemAttributesPaymentSourceDetails",
    "GETordersResponse200DataItemLinks",
    "GETordersResponse200DataItemRelationships",
    "GETordersResponse200DataItemRelationshipsAttachments",
    "GETordersResponse200DataItemRelationshipsAttachmentsData",
    "GETordersResponse200DataItemRelationshipsAttachmentsDataType",
    "GETordersResponse200DataItemRelationshipsAttachmentsLinks",
    "GETordersResponse200DataItemRelationshipsAuthorizations",
    "GETordersResponse200DataItemRelationshipsAuthorizationsData",
    "GETordersResponse200DataItemRelationshipsAuthorizationsDataType",
    "GETordersResponse200DataItemRelationshipsAuthorizationsLinks",
    "GETordersResponse200DataItemRelationshipsAvailableCustomerPaymentSources",
    "GETordersResponse200DataItemRelationshipsAvailableCustomerPaymentSourcesData",
    "GETordersResponse200DataItemRelationshipsAvailableCustomerPaymentSourcesDataType",
    "GETordersResponse200DataItemRelationshipsAvailableCustomerPaymentSourcesLinks",
    "GETordersResponse200DataItemRelationshipsAvailableFreeBundles",
    "GETordersResponse200DataItemRelationshipsAvailableFreeBundlesData",
    "GETordersResponse200DataItemRelationshipsAvailableFreeBundlesDataType",
    "GETordersResponse200DataItemRelationshipsAvailableFreeBundlesLinks",
    "GETordersResponse200DataItemRelationshipsAvailableFreeSkus",
    "GETordersResponse200DataItemRelationshipsAvailableFreeSkusData",
    "GETordersResponse200DataItemRelationshipsAvailableFreeSkusDataType",
    "GETordersResponse200DataItemRelationshipsAvailableFreeSkusLinks",
    "GETordersResponse200DataItemRelationshipsAvailablePaymentMethods",
    "GETordersResponse200DataItemRelationshipsAvailablePaymentMethodsData",
    "GETordersResponse200DataItemRelationshipsAvailablePaymentMethodsDataType",
    "GETordersResponse200DataItemRelationshipsAvailablePaymentMethodsLinks",
    "GETordersResponse200DataItemRelationshipsBillingAddress",
    "GETordersResponse200DataItemRelationshipsBillingAddressData",
    "GETordersResponse200DataItemRelationshipsBillingAddressDataType",
    "GETordersResponse200DataItemRelationshipsBillingAddressLinks",
    "GETordersResponse200DataItemRelationshipsCaptures",
    "GETordersResponse200DataItemRelationshipsCapturesData",
    "GETordersResponse200DataItemRelationshipsCapturesDataType",
    "GETordersResponse200DataItemRelationshipsCapturesLinks",
    "GETordersResponse200DataItemRelationshipsCustomer",
    "GETordersResponse200DataItemRelationshipsCustomerData",
    "GETordersResponse200DataItemRelationshipsCustomerDataType",
    "GETordersResponse200DataItemRelationshipsCustomerLinks",
    "GETordersResponse200DataItemRelationshipsEvents",
    "GETordersResponse200DataItemRelationshipsEventsData",
    "GETordersResponse200DataItemRelationshipsEventsDataType",
    "GETordersResponse200DataItemRelationshipsEventsLinks",
    "GETordersResponse200DataItemRelationshipsLineItems",
    "GETordersResponse200DataItemRelationshipsLineItemsData",
    "GETordersResponse200DataItemRelationshipsLineItemsDataType",
    "GETordersResponse200DataItemRelationshipsLineItemsLinks",
    "GETordersResponse200DataItemRelationshipsMarket",
    "GETordersResponse200DataItemRelationshipsMarketData",
    "GETordersResponse200DataItemRelationshipsMarketDataType",
    "GETordersResponse200DataItemRelationshipsMarketLinks",
    "GETordersResponse200DataItemRelationshipsOrderCopies",
    "GETordersResponse200DataItemRelationshipsOrderCopiesData",
    "GETordersResponse200DataItemRelationshipsOrderCopiesDataType",
    "GETordersResponse200DataItemRelationshipsOrderCopiesLinks",
    "GETordersResponse200DataItemRelationshipsOrderSubscriptions",
    "GETordersResponse200DataItemRelationshipsOrderSubscriptionsData",
    "GETordersResponse200DataItemRelationshipsOrderSubscriptionsDataType",
    "GETordersResponse200DataItemRelationshipsOrderSubscriptionsLinks",
    "GETordersResponse200DataItemRelationshipsPaymentMethod",
    "GETordersResponse200DataItemRelationshipsPaymentMethodData",
    "GETordersResponse200DataItemRelationshipsPaymentMethodDataType",
    "GETordersResponse200DataItemRelationshipsPaymentMethodLinks",
    "GETordersResponse200DataItemRelationshipsPaymentSource",
    "GETordersResponse200DataItemRelationshipsPaymentSourceData",
    "GETordersResponse200DataItemRelationshipsPaymentSourceDataType",
    "GETordersResponse200DataItemRelationshipsPaymentSourceLinks",
    "GETordersResponse200DataItemRelationshipsRefunds",
    "GETordersResponse200DataItemRelationshipsRefundsData",
    "GETordersResponse200DataItemRelationshipsRefundsDataType",
    "GETordersResponse200DataItemRelationshipsRefundsLinks",
    "GETordersResponse200DataItemRelationshipsShipments",
    "GETordersResponse200DataItemRelationshipsShipmentsData",
    "GETordersResponse200DataItemRelationshipsShipmentsDataType",
    "GETordersResponse200DataItemRelationshipsShipmentsLinks",
    "GETordersResponse200DataItemRelationshipsShippingAddress",
    "GETordersResponse200DataItemRelationshipsShippingAddressData",
    "GETordersResponse200DataItemRelationshipsShippingAddressDataType",
    "GETordersResponse200DataItemRelationshipsShippingAddressLinks",
    "GETordersResponse200DataItemRelationshipsTransactions",
    "GETordersResponse200DataItemRelationshipsTransactionsData",
    "GETordersResponse200DataItemRelationshipsTransactionsDataType",
    "GETordersResponse200DataItemRelationshipsTransactionsLinks",
    "GETordersResponse200DataItemRelationshipsVoids",
    "GETordersResponse200DataItemRelationshipsVoidsData",
    "GETordersResponse200DataItemRelationshipsVoidsDataType",
    "GETordersResponse200DataItemRelationshipsVoidsLinks",
    "GETordersResponse200DataItemType",
    "GETorderSubscriptionsorderSubscriptionIdResponse200",
    "GETorderSubscriptionsorderSubscriptionIdResponse200Data",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataAttributes",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataAttributesMetadata",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataAttributesOptions",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataLinks",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationships",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsCustomer",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsCustomerData",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsCustomerDataType",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsCustomerLinks",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsEvents",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsEventsData",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsEventsDataType",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsEventsLinks",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsMarket",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsMarketData",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsMarketDataType",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsMarketLinks",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrderCopies",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrderCopiesData",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrderCopiesDataType",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrderCopiesLinks",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrders",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrdersData",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrdersDataType",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrdersLinks",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsSourceOrder",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsSourceOrderData",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsSourceOrderDataType",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsSourceOrderLinks",
    "GETorderSubscriptionsorderSubscriptionIdResponse200DataType",
    "GETorderSubscriptionsResponse200",
    "GETorderSubscriptionsResponse200DataItem",
    "GETorderSubscriptionsResponse200DataItemAttributes",
    "GETorderSubscriptionsResponse200DataItemAttributesMetadata",
    "GETorderSubscriptionsResponse200DataItemAttributesOptions",
    "GETorderSubscriptionsResponse200DataItemLinks",
    "GETorderSubscriptionsResponse200DataItemRelationships",
    "GETorderSubscriptionsResponse200DataItemRelationshipsCustomer",
    "GETorderSubscriptionsResponse200DataItemRelationshipsCustomerData",
    "GETorderSubscriptionsResponse200DataItemRelationshipsCustomerDataType",
    "GETorderSubscriptionsResponse200DataItemRelationshipsCustomerLinks",
    "GETorderSubscriptionsResponse200DataItemRelationshipsEvents",
    "GETorderSubscriptionsResponse200DataItemRelationshipsEventsData",
    "GETorderSubscriptionsResponse200DataItemRelationshipsEventsDataType",
    "GETorderSubscriptionsResponse200DataItemRelationshipsEventsLinks",
    "GETorderSubscriptionsResponse200DataItemRelationshipsMarket",
    "GETorderSubscriptionsResponse200DataItemRelationshipsMarketData",
    "GETorderSubscriptionsResponse200DataItemRelationshipsMarketDataType",
    "GETorderSubscriptionsResponse200DataItemRelationshipsMarketLinks",
    "GETorderSubscriptionsResponse200DataItemRelationshipsOrderCopies",
    "GETorderSubscriptionsResponse200DataItemRelationshipsOrderCopiesData",
    "GETorderSubscriptionsResponse200DataItemRelationshipsOrderCopiesDataType",
    "GETorderSubscriptionsResponse200DataItemRelationshipsOrderCopiesLinks",
    "GETorderSubscriptionsResponse200DataItemRelationshipsOrders",
    "GETorderSubscriptionsResponse200DataItemRelationshipsOrdersData",
    "GETorderSubscriptionsResponse200DataItemRelationshipsOrdersDataType",
    "GETorderSubscriptionsResponse200DataItemRelationshipsOrdersLinks",
    "GETorderSubscriptionsResponse200DataItemRelationshipsSourceOrder",
    "GETorderSubscriptionsResponse200DataItemRelationshipsSourceOrderData",
    "GETorderSubscriptionsResponse200DataItemRelationshipsSourceOrderDataType",
    "GETorderSubscriptionsResponse200DataItemRelationshipsSourceOrderLinks",
    "GETorderSubscriptionsResponse200DataItemType",
    "GETorderValidationRulesorderValidationRuleIdResponse200",
    "GETorderValidationRulesorderValidationRuleIdResponse200Data",
    "GETorderValidationRulesorderValidationRuleIdResponse200DataAttributes",
    "GETorderValidationRulesorderValidationRuleIdResponse200DataAttributesMetadata",
    "GETorderValidationRulesorderValidationRuleIdResponse200DataLinks",
    "GETorderValidationRulesorderValidationRuleIdResponse200DataRelationships",
    "GETorderValidationRulesorderValidationRuleIdResponse200DataRelationshipsMarket",
    "GETorderValidationRulesorderValidationRuleIdResponse200DataRelationshipsMarketData",
    "GETorderValidationRulesorderValidationRuleIdResponse200DataRelationshipsMarketDataType",
    "GETorderValidationRulesorderValidationRuleIdResponse200DataRelationshipsMarketLinks",
    "GETorderValidationRulesorderValidationRuleIdResponse200DataType",
    "GETorderValidationRulesResponse200",
    "GETorderValidationRulesResponse200DataItem",
    "GETorderValidationRulesResponse200DataItemAttributes",
    "GETorderValidationRulesResponse200DataItemAttributesMetadata",
    "GETorderValidationRulesResponse200DataItemLinks",
    "GETorderValidationRulesResponse200DataItemRelationships",
    "GETorderValidationRulesResponse200DataItemRelationshipsMarket",
    "GETorderValidationRulesResponse200DataItemRelationshipsMarketData",
    "GETorderValidationRulesResponse200DataItemRelationshipsMarketDataType",
    "GETorderValidationRulesResponse200DataItemRelationshipsMarketLinks",
    "GETorderValidationRulesResponse200DataItemType",
    "GETorganizationorganizationIdResponse200",
    "GETorganizationorganizationIdResponse200Data",
    "GETorganizationorganizationIdResponse200DataAttributes",
    "GETorganizationorganizationIdResponse200DataAttributesMetadata",
    "GETorganizationorganizationIdResponse200DataLinks",
    "GETorganizationorganizationIdResponse200DataRelationships",
    "GETorganizationorganizationIdResponse200DataType",
    "GETpackagespackageIdResponse200",
    "GETpackagespackageIdResponse200Data",
    "GETpackagespackageIdResponse200DataAttributes",
    "GETpackagespackageIdResponse200DataAttributesMetadata",
    "GETpackagespackageIdResponse200DataLinks",
    "GETpackagespackageIdResponse200DataRelationships",
    "GETpackagespackageIdResponse200DataRelationshipsAttachments",
    "GETpackagespackageIdResponse200DataRelationshipsAttachmentsData",
    "GETpackagespackageIdResponse200DataRelationshipsAttachmentsDataType",
    "GETpackagespackageIdResponse200DataRelationshipsAttachmentsLinks",
    "GETpackagespackageIdResponse200DataRelationshipsParcels",
    "GETpackagespackageIdResponse200DataRelationshipsParcelsData",
    "GETpackagespackageIdResponse200DataRelationshipsParcelsDataType",
    "GETpackagespackageIdResponse200DataRelationshipsParcelsLinks",
    "GETpackagespackageIdResponse200DataRelationshipsStockLocation",
    "GETpackagespackageIdResponse200DataRelationshipsStockLocationData",
    "GETpackagespackageIdResponse200DataRelationshipsStockLocationDataType",
    "GETpackagespackageIdResponse200DataRelationshipsStockLocationLinks",
    "GETpackagespackageIdResponse200DataType",
    "GETpackagesResponse200",
    "GETpackagesResponse200DataItem",
    "GETpackagesResponse200DataItemAttributes",
    "GETpackagesResponse200DataItemAttributesMetadata",
    "GETpackagesResponse200DataItemLinks",
    "GETpackagesResponse200DataItemRelationships",
    "GETpackagesResponse200DataItemRelationshipsAttachments",
    "GETpackagesResponse200DataItemRelationshipsAttachmentsData",
    "GETpackagesResponse200DataItemRelationshipsAttachmentsDataType",
    "GETpackagesResponse200DataItemRelationshipsAttachmentsLinks",
    "GETpackagesResponse200DataItemRelationshipsParcels",
    "GETpackagesResponse200DataItemRelationshipsParcelsData",
    "GETpackagesResponse200DataItemRelationshipsParcelsDataType",
    "GETpackagesResponse200DataItemRelationshipsParcelsLinks",
    "GETpackagesResponse200DataItemRelationshipsStockLocation",
    "GETpackagesResponse200DataItemRelationshipsStockLocationData",
    "GETpackagesResponse200DataItemRelationshipsStockLocationDataType",
    "GETpackagesResponse200DataItemRelationshipsStockLocationLinks",
    "GETpackagesResponse200DataItemType",
    "GETparcelLineItemsparcelLineItemIdResponse200",
    "GETparcelLineItemsparcelLineItemIdResponse200Data",
    "GETparcelLineItemsparcelLineItemIdResponse200DataAttributes",
    "GETparcelLineItemsparcelLineItemIdResponse200DataAttributesMetadata",
    "GETparcelLineItemsparcelLineItemIdResponse200DataLinks",
    "GETparcelLineItemsparcelLineItemIdResponse200DataRelationships",
    "GETparcelLineItemsparcelLineItemIdResponse200DataRelationshipsParcel",
    "GETparcelLineItemsparcelLineItemIdResponse200DataRelationshipsParcelData",
    "GETparcelLineItemsparcelLineItemIdResponse200DataRelationshipsParcelDataType",
    "GETparcelLineItemsparcelLineItemIdResponse200DataRelationshipsParcelLinks",
    "GETparcelLineItemsparcelLineItemIdResponse200DataRelationshipsShipmentLineItem",
    "GETparcelLineItemsparcelLineItemIdResponse200DataRelationshipsShipmentLineItemData",
    "GETparcelLineItemsparcelLineItemIdResponse200DataRelationshipsShipmentLineItemDataType",
    "GETparcelLineItemsparcelLineItemIdResponse200DataRelationshipsShipmentLineItemLinks",
    "GETparcelLineItemsparcelLineItemIdResponse200DataRelationshipsStockLineItem",
    "GETparcelLineItemsparcelLineItemIdResponse200DataRelationshipsStockLineItemData",
    "GETparcelLineItemsparcelLineItemIdResponse200DataRelationshipsStockLineItemDataType",
    "GETparcelLineItemsparcelLineItemIdResponse200DataRelationshipsStockLineItemLinks",
    "GETparcelLineItemsparcelLineItemIdResponse200DataType",
    "GETparcelLineItemsResponse200",
    "GETparcelLineItemsResponse200DataItem",
    "GETparcelLineItemsResponse200DataItemAttributes",
    "GETparcelLineItemsResponse200DataItemAttributesMetadata",
    "GETparcelLineItemsResponse200DataItemLinks",
    "GETparcelLineItemsResponse200DataItemRelationships",
    "GETparcelLineItemsResponse200DataItemRelationshipsParcel",
    "GETparcelLineItemsResponse200DataItemRelationshipsParcelData",
    "GETparcelLineItemsResponse200DataItemRelationshipsParcelDataType",
    "GETparcelLineItemsResponse200DataItemRelationshipsParcelLinks",
    "GETparcelLineItemsResponse200DataItemRelationshipsShipmentLineItem",
    "GETparcelLineItemsResponse200DataItemRelationshipsShipmentLineItemData",
    "GETparcelLineItemsResponse200DataItemRelationshipsShipmentLineItemDataType",
    "GETparcelLineItemsResponse200DataItemRelationshipsShipmentLineItemLinks",
    "GETparcelLineItemsResponse200DataItemRelationshipsStockLineItem",
    "GETparcelLineItemsResponse200DataItemRelationshipsStockLineItemData",
    "GETparcelLineItemsResponse200DataItemRelationshipsStockLineItemDataType",
    "GETparcelLineItemsResponse200DataItemRelationshipsStockLineItemLinks",
    "GETparcelLineItemsResponse200DataItemType",
    "GETparcelsparcelIdResponse200",
    "GETparcelsparcelIdResponse200Data",
    "GETparcelsparcelIdResponse200DataAttributes",
    "GETparcelsparcelIdResponse200DataAttributesMetadata",
    "GETparcelsparcelIdResponse200DataLinks",
    "GETparcelsparcelIdResponse200DataRelationships",
    "GETparcelsparcelIdResponse200DataRelationshipsAttachments",
    "GETparcelsparcelIdResponse200DataRelationshipsAttachmentsData",
    "GETparcelsparcelIdResponse200DataRelationshipsAttachmentsDataType",
    "GETparcelsparcelIdResponse200DataRelationshipsAttachmentsLinks",
    "GETparcelsparcelIdResponse200DataRelationshipsEvents",
    "GETparcelsparcelIdResponse200DataRelationshipsEventsData",
    "GETparcelsparcelIdResponse200DataRelationshipsEventsDataType",
    "GETparcelsparcelIdResponse200DataRelationshipsEventsLinks",
    "GETparcelsparcelIdResponse200DataRelationshipsPackage",
    "GETparcelsparcelIdResponse200DataRelationshipsPackageData",
    "GETparcelsparcelIdResponse200DataRelationshipsPackageDataType",
    "GETparcelsparcelIdResponse200DataRelationshipsPackageLinks",
    "GETparcelsparcelIdResponse200DataRelationshipsParcelLineItems",
    "GETparcelsparcelIdResponse200DataRelationshipsParcelLineItemsData",
    "GETparcelsparcelIdResponse200DataRelationshipsParcelLineItemsDataType",
    "GETparcelsparcelIdResponse200DataRelationshipsParcelLineItemsLinks",
    "GETparcelsparcelIdResponse200DataRelationshipsShipment",
    "GETparcelsparcelIdResponse200DataRelationshipsShipmentData",
    "GETparcelsparcelIdResponse200DataRelationshipsShipmentDataType",
    "GETparcelsparcelIdResponse200DataRelationshipsShipmentLinks",
    "GETparcelsparcelIdResponse200DataType",
    "GETparcelsResponse200",
    "GETparcelsResponse200DataItem",
    "GETparcelsResponse200DataItemAttributes",
    "GETparcelsResponse200DataItemAttributesMetadata",
    "GETparcelsResponse200DataItemLinks",
    "GETparcelsResponse200DataItemRelationships",
    "GETparcelsResponse200DataItemRelationshipsAttachments",
    "GETparcelsResponse200DataItemRelationshipsAttachmentsData",
    "GETparcelsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETparcelsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETparcelsResponse200DataItemRelationshipsEvents",
    "GETparcelsResponse200DataItemRelationshipsEventsData",
    "GETparcelsResponse200DataItemRelationshipsEventsDataType",
    "GETparcelsResponse200DataItemRelationshipsEventsLinks",
    "GETparcelsResponse200DataItemRelationshipsPackage",
    "GETparcelsResponse200DataItemRelationshipsPackageData",
    "GETparcelsResponse200DataItemRelationshipsPackageDataType",
    "GETparcelsResponse200DataItemRelationshipsPackageLinks",
    "GETparcelsResponse200DataItemRelationshipsParcelLineItems",
    "GETparcelsResponse200DataItemRelationshipsParcelLineItemsData",
    "GETparcelsResponse200DataItemRelationshipsParcelLineItemsDataType",
    "GETparcelsResponse200DataItemRelationshipsParcelLineItemsLinks",
    "GETparcelsResponse200DataItemRelationshipsShipment",
    "GETparcelsResponse200DataItemRelationshipsShipmentData",
    "GETparcelsResponse200DataItemRelationshipsShipmentDataType",
    "GETparcelsResponse200DataItemRelationshipsShipmentLinks",
    "GETparcelsResponse200DataItemType",
    "GETpaymentGatewayspaymentGatewayIdResponse200",
    "GETpaymentGatewayspaymentGatewayIdResponse200Data",
    "GETpaymentGatewayspaymentGatewayIdResponse200DataAttributes",
    "GETpaymentGatewayspaymentGatewayIdResponse200DataAttributesMetadata",
    "GETpaymentGatewayspaymentGatewayIdResponse200DataLinks",
    "GETpaymentGatewayspaymentGatewayIdResponse200DataRelationships",
    "GETpaymentGatewayspaymentGatewayIdResponse200DataRelationshipsPaymentMethods",
    "GETpaymentGatewayspaymentGatewayIdResponse200DataRelationshipsPaymentMethodsData",
    "GETpaymentGatewayspaymentGatewayIdResponse200DataRelationshipsPaymentMethodsDataType",
    "GETpaymentGatewayspaymentGatewayIdResponse200DataRelationshipsPaymentMethodsLinks",
    "GETpaymentGatewayspaymentGatewayIdResponse200DataType",
    "GETpaymentGatewaysResponse200",
    "GETpaymentGatewaysResponse200DataItem",
    "GETpaymentGatewaysResponse200DataItemAttributes",
    "GETpaymentGatewaysResponse200DataItemAttributesMetadata",
    "GETpaymentGatewaysResponse200DataItemLinks",
    "GETpaymentGatewaysResponse200DataItemRelationships",
    "GETpaymentGatewaysResponse200DataItemRelationshipsPaymentMethods",
    "GETpaymentGatewaysResponse200DataItemRelationshipsPaymentMethodsData",
    "GETpaymentGatewaysResponse200DataItemRelationshipsPaymentMethodsDataType",
    "GETpaymentGatewaysResponse200DataItemRelationshipsPaymentMethodsLinks",
    "GETpaymentGatewaysResponse200DataItemType",
    "GETpaymentMethodspaymentMethodIdResponse200",
    "GETpaymentMethodspaymentMethodIdResponse200Data",
    "GETpaymentMethodspaymentMethodIdResponse200DataAttributes",
    "GETpaymentMethodspaymentMethodIdResponse200DataAttributesMetadata",
    "GETpaymentMethodspaymentMethodIdResponse200DataLinks",
    "GETpaymentMethodspaymentMethodIdResponse200DataRelationships",
    "GETpaymentMethodspaymentMethodIdResponse200DataRelationshipsAttachments",
    "GETpaymentMethodspaymentMethodIdResponse200DataRelationshipsAttachmentsData",
    "GETpaymentMethodspaymentMethodIdResponse200DataRelationshipsAttachmentsDataType",
    "GETpaymentMethodspaymentMethodIdResponse200DataRelationshipsAttachmentsLinks",
    "GETpaymentMethodspaymentMethodIdResponse200DataRelationshipsMarket",
    "GETpaymentMethodspaymentMethodIdResponse200DataRelationshipsMarketData",
    "GETpaymentMethodspaymentMethodIdResponse200DataRelationshipsMarketDataType",
    "GETpaymentMethodspaymentMethodIdResponse200DataRelationshipsMarketLinks",
    "GETpaymentMethodspaymentMethodIdResponse200DataRelationshipsPaymentGateway",
    "GETpaymentMethodspaymentMethodIdResponse200DataRelationshipsPaymentGatewayData",
    "GETpaymentMethodspaymentMethodIdResponse200DataRelationshipsPaymentGatewayDataType",
    "GETpaymentMethodspaymentMethodIdResponse200DataRelationshipsPaymentGatewayLinks",
    "GETpaymentMethodspaymentMethodIdResponse200DataType",
    "GETpaymentMethodsResponse200",
    "GETpaymentMethodsResponse200DataItem",
    "GETpaymentMethodsResponse200DataItemAttributes",
    "GETpaymentMethodsResponse200DataItemAttributesMetadata",
    "GETpaymentMethodsResponse200DataItemLinks",
    "GETpaymentMethodsResponse200DataItemRelationships",
    "GETpaymentMethodsResponse200DataItemRelationshipsAttachments",
    "GETpaymentMethodsResponse200DataItemRelationshipsAttachmentsData",
    "GETpaymentMethodsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETpaymentMethodsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETpaymentMethodsResponse200DataItemRelationshipsMarket",
    "GETpaymentMethodsResponse200DataItemRelationshipsMarketData",
    "GETpaymentMethodsResponse200DataItemRelationshipsMarketDataType",
    "GETpaymentMethodsResponse200DataItemRelationshipsMarketLinks",
    "GETpaymentMethodsResponse200DataItemRelationshipsPaymentGateway",
    "GETpaymentMethodsResponse200DataItemRelationshipsPaymentGatewayData",
    "GETpaymentMethodsResponse200DataItemRelationshipsPaymentGatewayDataType",
    "GETpaymentMethodsResponse200DataItemRelationshipsPaymentGatewayLinks",
    "GETpaymentMethodsResponse200DataItemType",
    "GETpaypalGatewayspaypalGatewayIdResponse200",
    "GETpaypalGatewayspaypalGatewayIdResponse200Data",
    "GETpaypalGatewayspaypalGatewayIdResponse200DataAttributes",
    "GETpaypalGatewayspaypalGatewayIdResponse200DataAttributesMetadata",
    "GETpaypalGatewayspaypalGatewayIdResponse200DataLinks",
    "GETpaypalGatewayspaypalGatewayIdResponse200DataRelationships",
    "GETpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaymentMethods",
    "GETpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaymentMethodsData",
    "GETpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaymentMethodsDataType",
    "GETpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaymentMethodsLinks",
    "GETpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaypalPayments",
    "GETpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaypalPaymentsData",
    "GETpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaypalPaymentsDataType",
    "GETpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaypalPaymentsLinks",
    "GETpaypalGatewayspaypalGatewayIdResponse200DataType",
    "GETpaypalGatewaysResponse200",
    "GETpaypalGatewaysResponse200DataItem",
    "GETpaypalGatewaysResponse200DataItemAttributes",
    "GETpaypalGatewaysResponse200DataItemAttributesMetadata",
    "GETpaypalGatewaysResponse200DataItemLinks",
    "GETpaypalGatewaysResponse200DataItemRelationships",
    "GETpaypalGatewaysResponse200DataItemRelationshipsPaymentMethods",
    "GETpaypalGatewaysResponse200DataItemRelationshipsPaymentMethodsData",
    "GETpaypalGatewaysResponse200DataItemRelationshipsPaymentMethodsDataType",
    "GETpaypalGatewaysResponse200DataItemRelationshipsPaymentMethodsLinks",
    "GETpaypalGatewaysResponse200DataItemRelationshipsPaypalPayments",
    "GETpaypalGatewaysResponse200DataItemRelationshipsPaypalPaymentsData",
    "GETpaypalGatewaysResponse200DataItemRelationshipsPaypalPaymentsDataType",
    "GETpaypalGatewaysResponse200DataItemRelationshipsPaypalPaymentsLinks",
    "GETpaypalGatewaysResponse200DataItemType",
    "GETpaypalPaymentspaypalPaymentIdResponse200",
    "GETpaypalPaymentspaypalPaymentIdResponse200Data",
    "GETpaypalPaymentspaypalPaymentIdResponse200DataAttributes",
    "GETpaypalPaymentspaypalPaymentIdResponse200DataAttributesMetadata",
    "GETpaypalPaymentspaypalPaymentIdResponse200DataLinks",
    "GETpaypalPaymentspaypalPaymentIdResponse200DataRelationships",
    "GETpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsOrder",
    "GETpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsOrderData",
    "GETpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsOrderDataType",
    "GETpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsOrderLinks",
    "GETpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsPaymentGateway",
    "GETpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsPaymentGatewayData",
    "GETpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsPaymentGatewayDataType",
    "GETpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsPaymentGatewayLinks",
    "GETpaypalPaymentspaypalPaymentIdResponse200DataType",
    "GETpaypalPaymentsResponse200",
    "GETpaypalPaymentsResponse200DataItem",
    "GETpaypalPaymentsResponse200DataItemAttributes",
    "GETpaypalPaymentsResponse200DataItemAttributesMetadata",
    "GETpaypalPaymentsResponse200DataItemLinks",
    "GETpaypalPaymentsResponse200DataItemRelationships",
    "GETpaypalPaymentsResponse200DataItemRelationshipsOrder",
    "GETpaypalPaymentsResponse200DataItemRelationshipsOrderData",
    "GETpaypalPaymentsResponse200DataItemRelationshipsOrderDataType",
    "GETpaypalPaymentsResponse200DataItemRelationshipsOrderLinks",
    "GETpaypalPaymentsResponse200DataItemRelationshipsPaymentGateway",
    "GETpaypalPaymentsResponse200DataItemRelationshipsPaymentGatewayData",
    "GETpaypalPaymentsResponse200DataItemRelationshipsPaymentGatewayDataType",
    "GETpaypalPaymentsResponse200DataItemRelationshipsPaymentGatewayLinks",
    "GETpaypalPaymentsResponse200DataItemType",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200Data",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataAttributes",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataAttributesMetadata",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataLinks",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationships",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsAttachments",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsAttachmentsData",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsAttachmentsDataType",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsAttachmentsLinks",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRule",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleData",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleDataType",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleLinks",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsMarket",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsMarketData",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsMarketDataType",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsMarketLinks",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRule",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleData",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleDataType",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleLinks",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsPromotionRules",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsPromotionRulesData",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsPromotionRulesDataType",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsPromotionRulesLinks",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuList",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuListData",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuListDataType",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuListLinks",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuListPromotionRule",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuListPromotionRuleData",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuListPromotionRuleDataType",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuListPromotionRuleLinks",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkus",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkusData",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkusDataType",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkusLinks",
    "GETpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataType",
    "GETpercentageDiscountPromotionsResponse200",
    "GETpercentageDiscountPromotionsResponse200DataItem",
    "GETpercentageDiscountPromotionsResponse200DataItemAttributes",
    "GETpercentageDiscountPromotionsResponse200DataItemAttributesMetadata",
    "GETpercentageDiscountPromotionsResponse200DataItemLinks",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationships",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsAttachments",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsAttachmentsData",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRule",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleData",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleDataType",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleLinks",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsMarket",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsMarketData",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsMarketDataType",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsMarketLinks",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRule",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleData",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleDataType",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleLinks",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsPromotionRules",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsPromotionRulesData",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsPromotionRulesDataType",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsPromotionRulesLinks",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsSkuList",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsSkuListData",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsSkuListDataType",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsSkuListLinks",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsSkuListPromotionRule",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleData",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleDataType",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsSkuListPromotionRuleLinks",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsSkus",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsSkusData",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsSkusDataType",
    "GETpercentageDiscountPromotionsResponse200DataItemRelationshipsSkusLinks",
    "GETpercentageDiscountPromotionsResponse200DataItemType",
    "GETpriceListspriceListIdResponse200",
    "GETpriceListspriceListIdResponse200Data",
    "GETpriceListspriceListIdResponse200DataAttributes",
    "GETpriceListspriceListIdResponse200DataAttributesMetadata",
    "GETpriceListspriceListIdResponse200DataLinks",
    "GETpriceListspriceListIdResponse200DataRelationships",
    "GETpriceListspriceListIdResponse200DataRelationshipsAttachments",
    "GETpriceListspriceListIdResponse200DataRelationshipsAttachmentsData",
    "GETpriceListspriceListIdResponse200DataRelationshipsAttachmentsDataType",
    "GETpriceListspriceListIdResponse200DataRelationshipsAttachmentsLinks",
    "GETpriceListspriceListIdResponse200DataRelationshipsPrices",
    "GETpriceListspriceListIdResponse200DataRelationshipsPricesData",
    "GETpriceListspriceListIdResponse200DataRelationshipsPricesDataType",
    "GETpriceListspriceListIdResponse200DataRelationshipsPricesLinks",
    "GETpriceListspriceListIdResponse200DataType",
    "GETpriceListsResponse200",
    "GETpriceListsResponse200DataItem",
    "GETpriceListsResponse200DataItemAttributes",
    "GETpriceListsResponse200DataItemAttributesMetadata",
    "GETpriceListsResponse200DataItemLinks",
    "GETpriceListsResponse200DataItemRelationships",
    "GETpriceListsResponse200DataItemRelationshipsAttachments",
    "GETpriceListsResponse200DataItemRelationshipsAttachmentsData",
    "GETpriceListsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETpriceListsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETpriceListsResponse200DataItemRelationshipsPrices",
    "GETpriceListsResponse200DataItemRelationshipsPricesData",
    "GETpriceListsResponse200DataItemRelationshipsPricesDataType",
    "GETpriceListsResponse200DataItemRelationshipsPricesLinks",
    "GETpriceListsResponse200DataItemType",
    "GETpricespriceIdResponse200",
    "GETpricespriceIdResponse200Data",
    "GETpricespriceIdResponse200DataAttributes",
    "GETpricespriceIdResponse200DataAttributesMetadata",
    "GETpricespriceIdResponse200DataLinks",
    "GETpricespriceIdResponse200DataRelationships",
    "GETpricespriceIdResponse200DataRelationshipsAttachments",
    "GETpricespriceIdResponse200DataRelationshipsAttachmentsData",
    "GETpricespriceIdResponse200DataRelationshipsAttachmentsDataType",
    "GETpricespriceIdResponse200DataRelationshipsAttachmentsLinks",
    "GETpricespriceIdResponse200DataRelationshipsPriceList",
    "GETpricespriceIdResponse200DataRelationshipsPriceListData",
    "GETpricespriceIdResponse200DataRelationshipsPriceListDataType",
    "GETpricespriceIdResponse200DataRelationshipsPriceListLinks",
    "GETpricespriceIdResponse200DataRelationshipsPriceTiers",
    "GETpricespriceIdResponse200DataRelationshipsPriceTiersData",
    "GETpricespriceIdResponse200DataRelationshipsPriceTiersDataType",
    "GETpricespriceIdResponse200DataRelationshipsPriceTiersLinks",
    "GETpricespriceIdResponse200DataRelationshipsPriceVolumeTiers",
    "GETpricespriceIdResponse200DataRelationshipsPriceVolumeTiersData",
    "GETpricespriceIdResponse200DataRelationshipsPriceVolumeTiersDataType",
    "GETpricespriceIdResponse200DataRelationshipsPriceVolumeTiersLinks",
    "GETpricespriceIdResponse200DataRelationshipsSku",
    "GETpricespriceIdResponse200DataRelationshipsSkuData",
    "GETpricespriceIdResponse200DataRelationshipsSkuDataType",
    "GETpricespriceIdResponse200DataRelationshipsSkuLinks",
    "GETpricespriceIdResponse200DataType",
    "GETpricesResponse200",
    "GETpricesResponse200DataItem",
    "GETpricesResponse200DataItemAttributes",
    "GETpricesResponse200DataItemAttributesMetadata",
    "GETpricesResponse200DataItemLinks",
    "GETpricesResponse200DataItemRelationships",
    "GETpricesResponse200DataItemRelationshipsAttachments",
    "GETpricesResponse200DataItemRelationshipsAttachmentsData",
    "GETpricesResponse200DataItemRelationshipsAttachmentsDataType",
    "GETpricesResponse200DataItemRelationshipsAttachmentsLinks",
    "GETpricesResponse200DataItemRelationshipsPriceList",
    "GETpricesResponse200DataItemRelationshipsPriceListData",
    "GETpricesResponse200DataItemRelationshipsPriceListDataType",
    "GETpricesResponse200DataItemRelationshipsPriceListLinks",
    "GETpricesResponse200DataItemRelationshipsPriceTiers",
    "GETpricesResponse200DataItemRelationshipsPriceTiersData",
    "GETpricesResponse200DataItemRelationshipsPriceTiersDataType",
    "GETpricesResponse200DataItemRelationshipsPriceTiersLinks",
    "GETpricesResponse200DataItemRelationshipsPriceVolumeTiers",
    "GETpricesResponse200DataItemRelationshipsPriceVolumeTiersData",
    "GETpricesResponse200DataItemRelationshipsPriceVolumeTiersDataType",
    "GETpricesResponse200DataItemRelationshipsPriceVolumeTiersLinks",
    "GETpricesResponse200DataItemRelationshipsSku",
    "GETpricesResponse200DataItemRelationshipsSkuData",
    "GETpricesResponse200DataItemRelationshipsSkuDataType",
    "GETpricesResponse200DataItemRelationshipsSkuLinks",
    "GETpricesResponse200DataItemType",
    "GETpriceTierspriceTierIdResponse200",
    "GETpriceTierspriceTierIdResponse200Data",
    "GETpriceTierspriceTierIdResponse200DataAttributes",
    "GETpriceTierspriceTierIdResponse200DataAttributesMetadata",
    "GETpriceTierspriceTierIdResponse200DataLinks",
    "GETpriceTierspriceTierIdResponse200DataRelationships",
    "GETpriceTierspriceTierIdResponse200DataRelationshipsAttachments",
    "GETpriceTierspriceTierIdResponse200DataRelationshipsAttachmentsData",
    "GETpriceTierspriceTierIdResponse200DataRelationshipsAttachmentsDataType",
    "GETpriceTierspriceTierIdResponse200DataRelationshipsAttachmentsLinks",
    "GETpriceTierspriceTierIdResponse200DataRelationshipsPrice",
    "GETpriceTierspriceTierIdResponse200DataRelationshipsPriceData",
    "GETpriceTierspriceTierIdResponse200DataRelationshipsPriceDataType",
    "GETpriceTierspriceTierIdResponse200DataRelationshipsPriceLinks",
    "GETpriceTierspriceTierIdResponse200DataType",
    "GETpriceTiersResponse200",
    "GETpriceTiersResponse200DataItem",
    "GETpriceTiersResponse200DataItemAttributes",
    "GETpriceTiersResponse200DataItemAttributesMetadata",
    "GETpriceTiersResponse200DataItemLinks",
    "GETpriceTiersResponse200DataItemRelationships",
    "GETpriceTiersResponse200DataItemRelationshipsAttachments",
    "GETpriceTiersResponse200DataItemRelationshipsAttachmentsData",
    "GETpriceTiersResponse200DataItemRelationshipsAttachmentsDataType",
    "GETpriceTiersResponse200DataItemRelationshipsAttachmentsLinks",
    "GETpriceTiersResponse200DataItemRelationshipsPrice",
    "GETpriceTiersResponse200DataItemRelationshipsPriceData",
    "GETpriceTiersResponse200DataItemRelationshipsPriceDataType",
    "GETpriceTiersResponse200DataItemRelationshipsPriceLinks",
    "GETpriceTiersResponse200DataItemType",
    "GETpriceVolumeTierspriceVolumeTierIdResponse200",
    "GETpriceVolumeTierspriceVolumeTierIdResponse200Data",
    "GETpriceVolumeTierspriceVolumeTierIdResponse200DataAttributes",
    "GETpriceVolumeTierspriceVolumeTierIdResponse200DataAttributesMetadata",
    "GETpriceVolumeTierspriceVolumeTierIdResponse200DataLinks",
    "GETpriceVolumeTierspriceVolumeTierIdResponse200DataRelationships",
    "GETpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsAttachments",
    "GETpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsAttachmentsData",
    "GETpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsAttachmentsDataType",
    "GETpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsAttachmentsLinks",
    "GETpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsPrice",
    "GETpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsPriceData",
    "GETpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsPriceDataType",
    "GETpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsPriceLinks",
    "GETpriceVolumeTierspriceVolumeTierIdResponse200DataType",
    "GETpriceVolumeTiersResponse200",
    "GETpriceVolumeTiersResponse200DataItem",
    "GETpriceVolumeTiersResponse200DataItemAttributes",
    "GETpriceVolumeTiersResponse200DataItemAttributesMetadata",
    "GETpriceVolumeTiersResponse200DataItemLinks",
    "GETpriceVolumeTiersResponse200DataItemRelationships",
    "GETpriceVolumeTiersResponse200DataItemRelationshipsAttachments",
    "GETpriceVolumeTiersResponse200DataItemRelationshipsAttachmentsData",
    "GETpriceVolumeTiersResponse200DataItemRelationshipsAttachmentsDataType",
    "GETpriceVolumeTiersResponse200DataItemRelationshipsAttachmentsLinks",
    "GETpriceVolumeTiersResponse200DataItemRelationshipsPrice",
    "GETpriceVolumeTiersResponse200DataItemRelationshipsPriceData",
    "GETpriceVolumeTiersResponse200DataItemRelationshipsPriceDataType",
    "GETpriceVolumeTiersResponse200DataItemRelationshipsPriceLinks",
    "GETpriceVolumeTiersResponse200DataItemType",
    "GETpromotionRulespromotionRuleIdResponse200",
    "GETpromotionRulespromotionRuleIdResponse200Data",
    "GETpromotionRulespromotionRuleIdResponse200DataAttributes",
    "GETpromotionRulespromotionRuleIdResponse200DataAttributesMetadata",
    "GETpromotionRulespromotionRuleIdResponse200DataLinks",
    "GETpromotionRulespromotionRuleIdResponse200DataRelationships",
    "GETpromotionRulespromotionRuleIdResponse200DataRelationshipsPromotion",
    "GETpromotionRulespromotionRuleIdResponse200DataRelationshipsPromotionData",
    "GETpromotionRulespromotionRuleIdResponse200DataRelationshipsPromotionDataType",
    "GETpromotionRulespromotionRuleIdResponse200DataRelationshipsPromotionLinks",
    "GETpromotionRulespromotionRuleIdResponse200DataType",
    "GETpromotionRulesResponse200",
    "GETpromotionRulesResponse200DataItem",
    "GETpromotionRulesResponse200DataItemAttributes",
    "GETpromotionRulesResponse200DataItemAttributesMetadata",
    "GETpromotionRulesResponse200DataItemLinks",
    "GETpromotionRulesResponse200DataItemRelationships",
    "GETpromotionRulesResponse200DataItemRelationshipsPromotion",
    "GETpromotionRulesResponse200DataItemRelationshipsPromotionData",
    "GETpromotionRulesResponse200DataItemRelationshipsPromotionDataType",
    "GETpromotionRulesResponse200DataItemRelationshipsPromotionLinks",
    "GETpromotionRulesResponse200DataItemType",
    "GETpromotionspromotionIdResponse200",
    "GETpromotionspromotionIdResponse200Data",
    "GETpromotionspromotionIdResponse200DataAttributes",
    "GETpromotionspromotionIdResponse200DataAttributesMetadata",
    "GETpromotionspromotionIdResponse200DataLinks",
    "GETpromotionspromotionIdResponse200DataRelationships",
    "GETpromotionspromotionIdResponse200DataRelationshipsAttachments",
    "GETpromotionspromotionIdResponse200DataRelationshipsAttachmentsData",
    "GETpromotionspromotionIdResponse200DataRelationshipsAttachmentsDataType",
    "GETpromotionspromotionIdResponse200DataRelationshipsAttachmentsLinks",
    "GETpromotionspromotionIdResponse200DataRelationshipsCouponCodesPromotionRule",
    "GETpromotionspromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleData",
    "GETpromotionspromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleDataType",
    "GETpromotionspromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleLinks",
    "GETpromotionspromotionIdResponse200DataRelationshipsMarket",
    "GETpromotionspromotionIdResponse200DataRelationshipsMarketData",
    "GETpromotionspromotionIdResponse200DataRelationshipsMarketDataType",
    "GETpromotionspromotionIdResponse200DataRelationshipsMarketLinks",
    "GETpromotionspromotionIdResponse200DataRelationshipsOrderAmountPromotionRule",
    "GETpromotionspromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleData",
    "GETpromotionspromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleDataType",
    "GETpromotionspromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleLinks",
    "GETpromotionspromotionIdResponse200DataRelationshipsPromotionRules",
    "GETpromotionspromotionIdResponse200DataRelationshipsPromotionRulesData",
    "GETpromotionspromotionIdResponse200DataRelationshipsPromotionRulesDataType",
    "GETpromotionspromotionIdResponse200DataRelationshipsPromotionRulesLinks",
    "GETpromotionspromotionIdResponse200DataRelationshipsSkuListPromotionRule",
    "GETpromotionspromotionIdResponse200DataRelationshipsSkuListPromotionRuleData",
    "GETpromotionspromotionIdResponse200DataRelationshipsSkuListPromotionRuleDataType",
    "GETpromotionspromotionIdResponse200DataRelationshipsSkuListPromotionRuleLinks",
    "GETpromotionspromotionIdResponse200DataType",
    "GETpromotionsResponse200",
    "GETpromotionsResponse200DataItem",
    "GETpromotionsResponse200DataItemAttributes",
    "GETpromotionsResponse200DataItemAttributesMetadata",
    "GETpromotionsResponse200DataItemLinks",
    "GETpromotionsResponse200DataItemRelationships",
    "GETpromotionsResponse200DataItemRelationshipsAttachments",
    "GETpromotionsResponse200DataItemRelationshipsAttachmentsData",
    "GETpromotionsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETpromotionsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETpromotionsResponse200DataItemRelationshipsCouponCodesPromotionRule",
    "GETpromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleData",
    "GETpromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleDataType",
    "GETpromotionsResponse200DataItemRelationshipsCouponCodesPromotionRuleLinks",
    "GETpromotionsResponse200DataItemRelationshipsMarket",
    "GETpromotionsResponse200DataItemRelationshipsMarketData",
    "GETpromotionsResponse200DataItemRelationshipsMarketDataType",
    "GETpromotionsResponse200DataItemRelationshipsMarketLinks",
    "GETpromotionsResponse200DataItemRelationshipsOrderAmountPromotionRule",
    "GETpromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleData",
    "GETpromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleDataType",
    "GETpromotionsResponse200DataItemRelationshipsOrderAmountPromotionRuleLinks",
    "GETpromotionsResponse200DataItemRelationshipsPromotionRules",
    "GETpromotionsResponse200DataItemRelationshipsPromotionRulesData",
    "GETpromotionsResponse200DataItemRelationshipsPromotionRulesDataType",
    "GETpromotionsResponse200DataItemRelationshipsPromotionRulesLinks",
    "GETpromotionsResponse200DataItemRelationshipsSkuListPromotionRule",
    "GETpromotionsResponse200DataItemRelationshipsSkuListPromotionRuleData",
    "GETpromotionsResponse200DataItemRelationshipsSkuListPromotionRuleDataType",
    "GETpromotionsResponse200DataItemRelationshipsSkuListPromotionRuleLinks",
    "GETpromotionsResponse200DataItemType",
    "GETrefundsrefundIdResponse200",
    "GETrefundsrefundIdResponse200Data",
    "GETrefundsrefundIdResponse200DataAttributes",
    "GETrefundsrefundIdResponse200DataAttributesMetadata",
    "GETrefundsrefundIdResponse200DataLinks",
    "GETrefundsrefundIdResponse200DataRelationships",
    "GETrefundsrefundIdResponse200DataRelationshipsEvents",
    "GETrefundsrefundIdResponse200DataRelationshipsEventsData",
    "GETrefundsrefundIdResponse200DataRelationshipsEventsDataType",
    "GETrefundsrefundIdResponse200DataRelationshipsEventsLinks",
    "GETrefundsrefundIdResponse200DataRelationshipsOrder",
    "GETrefundsrefundIdResponse200DataRelationshipsOrderData",
    "GETrefundsrefundIdResponse200DataRelationshipsOrderDataType",
    "GETrefundsrefundIdResponse200DataRelationshipsOrderLinks",
    "GETrefundsrefundIdResponse200DataRelationshipsReferenceCapture",
    "GETrefundsrefundIdResponse200DataRelationshipsReferenceCaptureData",
    "GETrefundsrefundIdResponse200DataRelationshipsReferenceCaptureDataType",
    "GETrefundsrefundIdResponse200DataRelationshipsReferenceCaptureLinks",
    "GETrefundsrefundIdResponse200DataType",
    "GETrefundsResponse200",
    "GETrefundsResponse200DataItem",
    "GETrefundsResponse200DataItemAttributes",
    "GETrefundsResponse200DataItemAttributesMetadata",
    "GETrefundsResponse200DataItemLinks",
    "GETrefundsResponse200DataItemRelationships",
    "GETrefundsResponse200DataItemRelationshipsEvents",
    "GETrefundsResponse200DataItemRelationshipsEventsData",
    "GETrefundsResponse200DataItemRelationshipsEventsDataType",
    "GETrefundsResponse200DataItemRelationshipsEventsLinks",
    "GETrefundsResponse200DataItemRelationshipsOrder",
    "GETrefundsResponse200DataItemRelationshipsOrderData",
    "GETrefundsResponse200DataItemRelationshipsOrderDataType",
    "GETrefundsResponse200DataItemRelationshipsOrderLinks",
    "GETrefundsResponse200DataItemRelationshipsReferenceCapture",
    "GETrefundsResponse200DataItemRelationshipsReferenceCaptureData",
    "GETrefundsResponse200DataItemRelationshipsReferenceCaptureDataType",
    "GETrefundsResponse200DataItemRelationshipsReferenceCaptureLinks",
    "GETrefundsResponse200DataItemType",
    "GETreturnLineItemsResponse200",
    "GETreturnLineItemsResponse200DataItem",
    "GETreturnLineItemsResponse200DataItemAttributes",
    "GETreturnLineItemsResponse200DataItemAttributesMetadata",
    "GETreturnLineItemsResponse200DataItemAttributesReturnReason",
    "GETreturnLineItemsResponse200DataItemLinks",
    "GETreturnLineItemsResponse200DataItemRelationships",
    "GETreturnLineItemsResponse200DataItemRelationshipsLineItem",
    "GETreturnLineItemsResponse200DataItemRelationshipsLineItemData",
    "GETreturnLineItemsResponse200DataItemRelationshipsLineItemDataType",
    "GETreturnLineItemsResponse200DataItemRelationshipsLineItemLinks",
    "GETreturnLineItemsResponse200DataItemRelationshipsReturn",
    "GETreturnLineItemsResponse200DataItemRelationshipsReturnData",
    "GETreturnLineItemsResponse200DataItemRelationshipsReturnDataType",
    "GETreturnLineItemsResponse200DataItemRelationshipsReturnLinks",
    "GETreturnLineItemsResponse200DataItemType",
    "GETreturnLineItemsreturnLineItemIdResponse200",
    "GETreturnLineItemsreturnLineItemIdResponse200Data",
    "GETreturnLineItemsreturnLineItemIdResponse200DataAttributes",
    "GETreturnLineItemsreturnLineItemIdResponse200DataAttributesMetadata",
    "GETreturnLineItemsreturnLineItemIdResponse200DataAttributesReturnReason",
    "GETreturnLineItemsreturnLineItemIdResponse200DataLinks",
    "GETreturnLineItemsreturnLineItemIdResponse200DataRelationships",
    "GETreturnLineItemsreturnLineItemIdResponse200DataRelationshipsLineItem",
    "GETreturnLineItemsreturnLineItemIdResponse200DataRelationshipsLineItemData",
    "GETreturnLineItemsreturnLineItemIdResponse200DataRelationshipsLineItemDataType",
    "GETreturnLineItemsreturnLineItemIdResponse200DataRelationshipsLineItemLinks",
    "GETreturnLineItemsreturnLineItemIdResponse200DataRelationshipsReturn",
    "GETreturnLineItemsreturnLineItemIdResponse200DataRelationshipsReturnData",
    "GETreturnLineItemsreturnLineItemIdResponse200DataRelationshipsReturnDataType",
    "GETreturnLineItemsreturnLineItemIdResponse200DataRelationshipsReturnLinks",
    "GETreturnLineItemsreturnLineItemIdResponse200DataType",
    "GETreturnsResponse200",
    "GETreturnsResponse200DataItem",
    "GETreturnsResponse200DataItemAttributes",
    "GETreturnsResponse200DataItemAttributesMetadata",
    "GETreturnsResponse200DataItemLinks",
    "GETreturnsResponse200DataItemRelationships",
    "GETreturnsResponse200DataItemRelationshipsAttachments",
    "GETreturnsResponse200DataItemRelationshipsAttachmentsData",
    "GETreturnsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETreturnsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETreturnsResponse200DataItemRelationshipsCustomer",
    "GETreturnsResponse200DataItemRelationshipsCustomerData",
    "GETreturnsResponse200DataItemRelationshipsCustomerDataType",
    "GETreturnsResponse200DataItemRelationshipsCustomerLinks",
    "GETreturnsResponse200DataItemRelationshipsDestinationAddress",
    "GETreturnsResponse200DataItemRelationshipsDestinationAddressData",
    "GETreturnsResponse200DataItemRelationshipsDestinationAddressDataType",
    "GETreturnsResponse200DataItemRelationshipsDestinationAddressLinks",
    "GETreturnsResponse200DataItemRelationshipsEvents",
    "GETreturnsResponse200DataItemRelationshipsEventsData",
    "GETreturnsResponse200DataItemRelationshipsEventsDataType",
    "GETreturnsResponse200DataItemRelationshipsEventsLinks",
    "GETreturnsResponse200DataItemRelationshipsOrder",
    "GETreturnsResponse200DataItemRelationshipsOrderData",
    "GETreturnsResponse200DataItemRelationshipsOrderDataType",
    "GETreturnsResponse200DataItemRelationshipsOrderLinks",
    "GETreturnsResponse200DataItemRelationshipsOriginAddress",
    "GETreturnsResponse200DataItemRelationshipsOriginAddressData",
    "GETreturnsResponse200DataItemRelationshipsOriginAddressDataType",
    "GETreturnsResponse200DataItemRelationshipsOriginAddressLinks",
    "GETreturnsResponse200DataItemRelationshipsReturnLineItems",
    "GETreturnsResponse200DataItemRelationshipsReturnLineItemsData",
    "GETreturnsResponse200DataItemRelationshipsReturnLineItemsDataType",
    "GETreturnsResponse200DataItemRelationshipsReturnLineItemsLinks",
    "GETreturnsResponse200DataItemRelationshipsStockLocation",
    "GETreturnsResponse200DataItemRelationshipsStockLocationData",
    "GETreturnsResponse200DataItemRelationshipsStockLocationDataType",
    "GETreturnsResponse200DataItemRelationshipsStockLocationLinks",
    "GETreturnsResponse200DataItemType",
    "GETreturnsreturnIdResponse200",
    "GETreturnsreturnIdResponse200Data",
    "GETreturnsreturnIdResponse200DataAttributes",
    "GETreturnsreturnIdResponse200DataAttributesMetadata",
    "GETreturnsreturnIdResponse200DataLinks",
    "GETreturnsreturnIdResponse200DataRelationships",
    "GETreturnsreturnIdResponse200DataRelationshipsAttachments",
    "GETreturnsreturnIdResponse200DataRelationshipsAttachmentsData",
    "GETreturnsreturnIdResponse200DataRelationshipsAttachmentsDataType",
    "GETreturnsreturnIdResponse200DataRelationshipsAttachmentsLinks",
    "GETreturnsreturnIdResponse200DataRelationshipsCustomer",
    "GETreturnsreturnIdResponse200DataRelationshipsCustomerData",
    "GETreturnsreturnIdResponse200DataRelationshipsCustomerDataType",
    "GETreturnsreturnIdResponse200DataRelationshipsCustomerLinks",
    "GETreturnsreturnIdResponse200DataRelationshipsDestinationAddress",
    "GETreturnsreturnIdResponse200DataRelationshipsDestinationAddressData",
    "GETreturnsreturnIdResponse200DataRelationshipsDestinationAddressDataType",
    "GETreturnsreturnIdResponse200DataRelationshipsDestinationAddressLinks",
    "GETreturnsreturnIdResponse200DataRelationshipsEvents",
    "GETreturnsreturnIdResponse200DataRelationshipsEventsData",
    "GETreturnsreturnIdResponse200DataRelationshipsEventsDataType",
    "GETreturnsreturnIdResponse200DataRelationshipsEventsLinks",
    "GETreturnsreturnIdResponse200DataRelationshipsOrder",
    "GETreturnsreturnIdResponse200DataRelationshipsOrderData",
    "GETreturnsreturnIdResponse200DataRelationshipsOrderDataType",
    "GETreturnsreturnIdResponse200DataRelationshipsOrderLinks",
    "GETreturnsreturnIdResponse200DataRelationshipsOriginAddress",
    "GETreturnsreturnIdResponse200DataRelationshipsOriginAddressData",
    "GETreturnsreturnIdResponse200DataRelationshipsOriginAddressDataType",
    "GETreturnsreturnIdResponse200DataRelationshipsOriginAddressLinks",
    "GETreturnsreturnIdResponse200DataRelationshipsReturnLineItems",
    "GETreturnsreturnIdResponse200DataRelationshipsReturnLineItemsData",
    "GETreturnsreturnIdResponse200DataRelationshipsReturnLineItemsDataType",
    "GETreturnsreturnIdResponse200DataRelationshipsReturnLineItemsLinks",
    "GETreturnsreturnIdResponse200DataRelationshipsStockLocation",
    "GETreturnsreturnIdResponse200DataRelationshipsStockLocationData",
    "GETreturnsreturnIdResponse200DataRelationshipsStockLocationDataType",
    "GETreturnsreturnIdResponse200DataRelationshipsStockLocationLinks",
    "GETreturnsreturnIdResponse200DataType",
    "GETshipmentsResponse200",
    "GETshipmentsResponse200DataItem",
    "GETshipmentsResponse200DataItemAttributes",
    "GETshipmentsResponse200DataItemAttributesGetRatesErrorsItem",
    "GETshipmentsResponse200DataItemAttributesMetadata",
    "GETshipmentsResponse200DataItemAttributesRatesItem",
    "GETshipmentsResponse200DataItemLinks",
    "GETshipmentsResponse200DataItemRelationships",
    "GETshipmentsResponse200DataItemRelationshipsAttachments",
    "GETshipmentsResponse200DataItemRelationshipsAttachmentsData",
    "GETshipmentsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETshipmentsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETshipmentsResponse200DataItemRelationshipsAvailableShippingMethods",
    "GETshipmentsResponse200DataItemRelationshipsAvailableShippingMethodsData",
    "GETshipmentsResponse200DataItemRelationshipsAvailableShippingMethodsDataType",
    "GETshipmentsResponse200DataItemRelationshipsAvailableShippingMethodsLinks",
    "GETshipmentsResponse200DataItemRelationshipsCarrierAccounts",
    "GETshipmentsResponse200DataItemRelationshipsCarrierAccountsData",
    "GETshipmentsResponse200DataItemRelationshipsCarrierAccountsDataType",
    "GETshipmentsResponse200DataItemRelationshipsCarrierAccountsLinks",
    "GETshipmentsResponse200DataItemRelationshipsDeliveryLeadTime",
    "GETshipmentsResponse200DataItemRelationshipsDeliveryLeadTimeData",
    "GETshipmentsResponse200DataItemRelationshipsDeliveryLeadTimeDataType",
    "GETshipmentsResponse200DataItemRelationshipsDeliveryLeadTimeLinks",
    "GETshipmentsResponse200DataItemRelationshipsEvents",
    "GETshipmentsResponse200DataItemRelationshipsEventsData",
    "GETshipmentsResponse200DataItemRelationshipsEventsDataType",
    "GETshipmentsResponse200DataItemRelationshipsEventsLinks",
    "GETshipmentsResponse200DataItemRelationshipsOrder",
    "GETshipmentsResponse200DataItemRelationshipsOrderData",
    "GETshipmentsResponse200DataItemRelationshipsOrderDataType",
    "GETshipmentsResponse200DataItemRelationshipsOrderLinks",
    "GETshipmentsResponse200DataItemRelationshipsOriginAddress",
    "GETshipmentsResponse200DataItemRelationshipsOriginAddressData",
    "GETshipmentsResponse200DataItemRelationshipsOriginAddressDataType",
    "GETshipmentsResponse200DataItemRelationshipsOriginAddressLinks",
    "GETshipmentsResponse200DataItemRelationshipsParcels",
    "GETshipmentsResponse200DataItemRelationshipsParcelsData",
    "GETshipmentsResponse200DataItemRelationshipsParcelsDataType",
    "GETshipmentsResponse200DataItemRelationshipsParcelsLinks",
    "GETshipmentsResponse200DataItemRelationshipsShipmentLineItems",
    "GETshipmentsResponse200DataItemRelationshipsShipmentLineItemsData",
    "GETshipmentsResponse200DataItemRelationshipsShipmentLineItemsDataType",
    "GETshipmentsResponse200DataItemRelationshipsShipmentLineItemsLinks",
    "GETshipmentsResponse200DataItemRelationshipsShippingAddress",
    "GETshipmentsResponse200DataItemRelationshipsShippingAddressData",
    "GETshipmentsResponse200DataItemRelationshipsShippingAddressDataType",
    "GETshipmentsResponse200DataItemRelationshipsShippingAddressLinks",
    "GETshipmentsResponse200DataItemRelationshipsShippingCategory",
    "GETshipmentsResponse200DataItemRelationshipsShippingCategoryData",
    "GETshipmentsResponse200DataItemRelationshipsShippingCategoryDataType",
    "GETshipmentsResponse200DataItemRelationshipsShippingCategoryLinks",
    "GETshipmentsResponse200DataItemRelationshipsShippingMethod",
    "GETshipmentsResponse200DataItemRelationshipsShippingMethodData",
    "GETshipmentsResponse200DataItemRelationshipsShippingMethodDataType",
    "GETshipmentsResponse200DataItemRelationshipsShippingMethodLinks",
    "GETshipmentsResponse200DataItemRelationshipsStockLineItems",
    "GETshipmentsResponse200DataItemRelationshipsStockLineItemsData",
    "GETshipmentsResponse200DataItemRelationshipsStockLineItemsDataType",
    "GETshipmentsResponse200DataItemRelationshipsStockLineItemsLinks",
    "GETshipmentsResponse200DataItemRelationshipsStockLocation",
    "GETshipmentsResponse200DataItemRelationshipsStockLocationData",
    "GETshipmentsResponse200DataItemRelationshipsStockLocationDataType",
    "GETshipmentsResponse200DataItemRelationshipsStockLocationLinks",
    "GETshipmentsResponse200DataItemRelationshipsStockTransfers",
    "GETshipmentsResponse200DataItemRelationshipsStockTransfersData",
    "GETshipmentsResponse200DataItemRelationshipsStockTransfersDataType",
    "GETshipmentsResponse200DataItemRelationshipsStockTransfersLinks",
    "GETshipmentsResponse200DataItemType",
    "GETshipmentsshipmentIdResponse200",
    "GETshipmentsshipmentIdResponse200Data",
    "GETshipmentsshipmentIdResponse200DataAttributes",
    "GETshipmentsshipmentIdResponse200DataAttributesGetRatesErrorsItem",
    "GETshipmentsshipmentIdResponse200DataAttributesMetadata",
    "GETshipmentsshipmentIdResponse200DataAttributesRatesItem",
    "GETshipmentsshipmentIdResponse200DataLinks",
    "GETshipmentsshipmentIdResponse200DataRelationships",
    "GETshipmentsshipmentIdResponse200DataRelationshipsAttachments",
    "GETshipmentsshipmentIdResponse200DataRelationshipsAttachmentsData",
    "GETshipmentsshipmentIdResponse200DataRelationshipsAttachmentsDataType",
    "GETshipmentsshipmentIdResponse200DataRelationshipsAttachmentsLinks",
    "GETshipmentsshipmentIdResponse200DataRelationshipsAvailableShippingMethods",
    "GETshipmentsshipmentIdResponse200DataRelationshipsAvailableShippingMethodsData",
    "GETshipmentsshipmentIdResponse200DataRelationshipsAvailableShippingMethodsDataType",
    "GETshipmentsshipmentIdResponse200DataRelationshipsAvailableShippingMethodsLinks",
    "GETshipmentsshipmentIdResponse200DataRelationshipsCarrierAccounts",
    "GETshipmentsshipmentIdResponse200DataRelationshipsCarrierAccountsData",
    "GETshipmentsshipmentIdResponse200DataRelationshipsCarrierAccountsDataType",
    "GETshipmentsshipmentIdResponse200DataRelationshipsCarrierAccountsLinks",
    "GETshipmentsshipmentIdResponse200DataRelationshipsDeliveryLeadTime",
    "GETshipmentsshipmentIdResponse200DataRelationshipsDeliveryLeadTimeData",
    "GETshipmentsshipmentIdResponse200DataRelationshipsDeliveryLeadTimeDataType",
    "GETshipmentsshipmentIdResponse200DataRelationshipsDeliveryLeadTimeLinks",
    "GETshipmentsshipmentIdResponse200DataRelationshipsEvents",
    "GETshipmentsshipmentIdResponse200DataRelationshipsEventsData",
    "GETshipmentsshipmentIdResponse200DataRelationshipsEventsDataType",
    "GETshipmentsshipmentIdResponse200DataRelationshipsEventsLinks",
    "GETshipmentsshipmentIdResponse200DataRelationshipsOrder",
    "GETshipmentsshipmentIdResponse200DataRelationshipsOrderData",
    "GETshipmentsshipmentIdResponse200DataRelationshipsOrderDataType",
    "GETshipmentsshipmentIdResponse200DataRelationshipsOrderLinks",
    "GETshipmentsshipmentIdResponse200DataRelationshipsOriginAddress",
    "GETshipmentsshipmentIdResponse200DataRelationshipsOriginAddressData",
    "GETshipmentsshipmentIdResponse200DataRelationshipsOriginAddressDataType",
    "GETshipmentsshipmentIdResponse200DataRelationshipsOriginAddressLinks",
    "GETshipmentsshipmentIdResponse200DataRelationshipsParcels",
    "GETshipmentsshipmentIdResponse200DataRelationshipsParcelsData",
    "GETshipmentsshipmentIdResponse200DataRelationshipsParcelsDataType",
    "GETshipmentsshipmentIdResponse200DataRelationshipsParcelsLinks",
    "GETshipmentsshipmentIdResponse200DataRelationshipsShipmentLineItems",
    "GETshipmentsshipmentIdResponse200DataRelationshipsShipmentLineItemsData",
    "GETshipmentsshipmentIdResponse200DataRelationshipsShipmentLineItemsDataType",
    "GETshipmentsshipmentIdResponse200DataRelationshipsShipmentLineItemsLinks",
    "GETshipmentsshipmentIdResponse200DataRelationshipsShippingAddress",
    "GETshipmentsshipmentIdResponse200DataRelationshipsShippingAddressData",
    "GETshipmentsshipmentIdResponse200DataRelationshipsShippingAddressDataType",
    "GETshipmentsshipmentIdResponse200DataRelationshipsShippingAddressLinks",
    "GETshipmentsshipmentIdResponse200DataRelationshipsShippingCategory",
    "GETshipmentsshipmentIdResponse200DataRelationshipsShippingCategoryData",
    "GETshipmentsshipmentIdResponse200DataRelationshipsShippingCategoryDataType",
    "GETshipmentsshipmentIdResponse200DataRelationshipsShippingCategoryLinks",
    "GETshipmentsshipmentIdResponse200DataRelationshipsShippingMethod",
    "GETshipmentsshipmentIdResponse200DataRelationshipsShippingMethodData",
    "GETshipmentsshipmentIdResponse200DataRelationshipsShippingMethodDataType",
    "GETshipmentsshipmentIdResponse200DataRelationshipsShippingMethodLinks",
    "GETshipmentsshipmentIdResponse200DataRelationshipsStockLineItems",
    "GETshipmentsshipmentIdResponse200DataRelationshipsStockLineItemsData",
    "GETshipmentsshipmentIdResponse200DataRelationshipsStockLineItemsDataType",
    "GETshipmentsshipmentIdResponse200DataRelationshipsStockLineItemsLinks",
    "GETshipmentsshipmentIdResponse200DataRelationshipsStockLocation",
    "GETshipmentsshipmentIdResponse200DataRelationshipsStockLocationData",
    "GETshipmentsshipmentIdResponse200DataRelationshipsStockLocationDataType",
    "GETshipmentsshipmentIdResponse200DataRelationshipsStockLocationLinks",
    "GETshipmentsshipmentIdResponse200DataRelationshipsStockTransfers",
    "GETshipmentsshipmentIdResponse200DataRelationshipsStockTransfersData",
    "GETshipmentsshipmentIdResponse200DataRelationshipsStockTransfersDataType",
    "GETshipmentsshipmentIdResponse200DataRelationshipsStockTransfersLinks",
    "GETshipmentsshipmentIdResponse200DataType",
    "GETshippingCategoriesResponse200",
    "GETshippingCategoriesResponse200DataItem",
    "GETshippingCategoriesResponse200DataItemAttributes",
    "GETshippingCategoriesResponse200DataItemAttributesMetadata",
    "GETshippingCategoriesResponse200DataItemLinks",
    "GETshippingCategoriesResponse200DataItemRelationships",
    "GETshippingCategoriesResponse200DataItemRelationshipsAttachments",
    "GETshippingCategoriesResponse200DataItemRelationshipsAttachmentsData",
    "GETshippingCategoriesResponse200DataItemRelationshipsAttachmentsDataType",
    "GETshippingCategoriesResponse200DataItemRelationshipsAttachmentsLinks",
    "GETshippingCategoriesResponse200DataItemRelationshipsSkus",
    "GETshippingCategoriesResponse200DataItemRelationshipsSkusData",
    "GETshippingCategoriesResponse200DataItemRelationshipsSkusDataType",
    "GETshippingCategoriesResponse200DataItemRelationshipsSkusLinks",
    "GETshippingCategoriesResponse200DataItemType",
    "GETshippingCategoriesshippingCategoryIdResponse200",
    "GETshippingCategoriesshippingCategoryIdResponse200Data",
    "GETshippingCategoriesshippingCategoryIdResponse200DataAttributes",
    "GETshippingCategoriesshippingCategoryIdResponse200DataAttributesMetadata",
    "GETshippingCategoriesshippingCategoryIdResponse200DataLinks",
    "GETshippingCategoriesshippingCategoryIdResponse200DataRelationships",
    "GETshippingCategoriesshippingCategoryIdResponse200DataRelationshipsAttachments",
    "GETshippingCategoriesshippingCategoryIdResponse200DataRelationshipsAttachmentsData",
    "GETshippingCategoriesshippingCategoryIdResponse200DataRelationshipsAttachmentsDataType",
    "GETshippingCategoriesshippingCategoryIdResponse200DataRelationshipsAttachmentsLinks",
    "GETshippingCategoriesshippingCategoryIdResponse200DataRelationshipsSkus",
    "GETshippingCategoriesshippingCategoryIdResponse200DataRelationshipsSkusData",
    "GETshippingCategoriesshippingCategoryIdResponse200DataRelationshipsSkusDataType",
    "GETshippingCategoriesshippingCategoryIdResponse200DataRelationshipsSkusLinks",
    "GETshippingCategoriesshippingCategoryIdResponse200DataType",
    "GETshippingMethodsResponse200",
    "GETshippingMethodsResponse200DataItem",
    "GETshippingMethodsResponse200DataItemAttributes",
    "GETshippingMethodsResponse200DataItemAttributesMetadata",
    "GETshippingMethodsResponse200DataItemLinks",
    "GETshippingMethodsResponse200DataItemRelationships",
    "GETshippingMethodsResponse200DataItemRelationshipsAttachments",
    "GETshippingMethodsResponse200DataItemRelationshipsAttachmentsData",
    "GETshippingMethodsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETshippingMethodsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETshippingMethodsResponse200DataItemRelationshipsDeliveryLeadTimeForShipment",
    "GETshippingMethodsResponse200DataItemRelationshipsDeliveryLeadTimeForShipmentData",
    "GETshippingMethodsResponse200DataItemRelationshipsDeliveryLeadTimeForShipmentDataType",
    "GETshippingMethodsResponse200DataItemRelationshipsDeliveryLeadTimeForShipmentLinks",
    "GETshippingMethodsResponse200DataItemRelationshipsMarket",
    "GETshippingMethodsResponse200DataItemRelationshipsMarketData",
    "GETshippingMethodsResponse200DataItemRelationshipsMarketDataType",
    "GETshippingMethodsResponse200DataItemRelationshipsMarketLinks",
    "GETshippingMethodsResponse200DataItemRelationshipsShippingCategory",
    "GETshippingMethodsResponse200DataItemRelationshipsShippingCategoryData",
    "GETshippingMethodsResponse200DataItemRelationshipsShippingCategoryDataType",
    "GETshippingMethodsResponse200DataItemRelationshipsShippingCategoryLinks",
    "GETshippingMethodsResponse200DataItemRelationshipsShippingMethodTiers",
    "GETshippingMethodsResponse200DataItemRelationshipsShippingMethodTiersData",
    "GETshippingMethodsResponse200DataItemRelationshipsShippingMethodTiersDataType",
    "GETshippingMethodsResponse200DataItemRelationshipsShippingMethodTiersLinks",
    "GETshippingMethodsResponse200DataItemRelationshipsShippingWeightTiers",
    "GETshippingMethodsResponse200DataItemRelationshipsShippingWeightTiersData",
    "GETshippingMethodsResponse200DataItemRelationshipsShippingWeightTiersDataType",
    "GETshippingMethodsResponse200DataItemRelationshipsShippingWeightTiersLinks",
    "GETshippingMethodsResponse200DataItemRelationshipsShippingZone",
    "GETshippingMethodsResponse200DataItemRelationshipsShippingZoneData",
    "GETshippingMethodsResponse200DataItemRelationshipsShippingZoneDataType",
    "GETshippingMethodsResponse200DataItemRelationshipsShippingZoneLinks",
    "GETshippingMethodsResponse200DataItemRelationshipsStockLocation",
    "GETshippingMethodsResponse200DataItemRelationshipsStockLocationData",
    "GETshippingMethodsResponse200DataItemRelationshipsStockLocationDataType",
    "GETshippingMethodsResponse200DataItemRelationshipsStockLocationLinks",
    "GETshippingMethodsResponse200DataItemType",
    "GETshippingMethodsshippingMethodIdResponse200",
    "GETshippingMethodsshippingMethodIdResponse200Data",
    "GETshippingMethodsshippingMethodIdResponse200DataAttributes",
    "GETshippingMethodsshippingMethodIdResponse200DataAttributesMetadata",
    "GETshippingMethodsshippingMethodIdResponse200DataLinks",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationships",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsAttachments",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsAttachmentsData",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsAttachmentsDataType",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsAttachmentsLinks",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsDeliveryLeadTimeForShipment",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsDeliveryLeadTimeForShipmentData",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsDeliveryLeadTimeForShipmentDataType",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsDeliveryLeadTimeForShipmentLinks",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsMarket",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsMarketData",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsMarketDataType",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsMarketLinks",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingCategory",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingCategoryData",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingCategoryDataType",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingCategoryLinks",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingMethodTiers",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingMethodTiersData",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingMethodTiersDataType",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingMethodTiersLinks",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingWeightTiers",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingWeightTiersData",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingWeightTiersDataType",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingWeightTiersLinks",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingZone",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingZoneData",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingZoneDataType",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingZoneLinks",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsStockLocation",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsStockLocationData",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsStockLocationDataType",
    "GETshippingMethodsshippingMethodIdResponse200DataRelationshipsStockLocationLinks",
    "GETshippingMethodsshippingMethodIdResponse200DataType",
    "GETshippingMethodTiersResponse200",
    "GETshippingMethodTiersResponse200DataItem",
    "GETshippingMethodTiersResponse200DataItemAttributes",
    "GETshippingMethodTiersResponse200DataItemAttributesMetadata",
    "GETshippingMethodTiersResponse200DataItemLinks",
    "GETshippingMethodTiersResponse200DataItemRelationships",
    "GETshippingMethodTiersResponse200DataItemRelationshipsAttachments",
    "GETshippingMethodTiersResponse200DataItemRelationshipsAttachmentsData",
    "GETshippingMethodTiersResponse200DataItemRelationshipsAttachmentsDataType",
    "GETshippingMethodTiersResponse200DataItemRelationshipsAttachmentsLinks",
    "GETshippingMethodTiersResponse200DataItemRelationshipsShippingMethod",
    "GETshippingMethodTiersResponse200DataItemRelationshipsShippingMethodData",
    "GETshippingMethodTiersResponse200DataItemRelationshipsShippingMethodDataType",
    "GETshippingMethodTiersResponse200DataItemRelationshipsShippingMethodLinks",
    "GETshippingMethodTiersResponse200DataItemType",
    "GETshippingMethodTiersshippingMethodTierIdResponse200",
    "GETshippingMethodTiersshippingMethodTierIdResponse200Data",
    "GETshippingMethodTiersshippingMethodTierIdResponse200DataAttributes",
    "GETshippingMethodTiersshippingMethodTierIdResponse200DataAttributesMetadata",
    "GETshippingMethodTiersshippingMethodTierIdResponse200DataLinks",
    "GETshippingMethodTiersshippingMethodTierIdResponse200DataRelationships",
    "GETshippingMethodTiersshippingMethodTierIdResponse200DataRelationshipsAttachments",
    "GETshippingMethodTiersshippingMethodTierIdResponse200DataRelationshipsAttachmentsData",
    "GETshippingMethodTiersshippingMethodTierIdResponse200DataRelationshipsAttachmentsDataType",
    "GETshippingMethodTiersshippingMethodTierIdResponse200DataRelationshipsAttachmentsLinks",
    "GETshippingMethodTiersshippingMethodTierIdResponse200DataRelationshipsShippingMethod",
    "GETshippingMethodTiersshippingMethodTierIdResponse200DataRelationshipsShippingMethodData",
    "GETshippingMethodTiersshippingMethodTierIdResponse200DataRelationshipsShippingMethodDataType",
    "GETshippingMethodTiersshippingMethodTierIdResponse200DataRelationshipsShippingMethodLinks",
    "GETshippingMethodTiersshippingMethodTierIdResponse200DataType",
    "GETshippingWeightTiersResponse200",
    "GETshippingWeightTiersResponse200DataItem",
    "GETshippingWeightTiersResponse200DataItemAttributes",
    "GETshippingWeightTiersResponse200DataItemAttributesMetadata",
    "GETshippingWeightTiersResponse200DataItemLinks",
    "GETshippingWeightTiersResponse200DataItemRelationships",
    "GETshippingWeightTiersResponse200DataItemRelationshipsAttachments",
    "GETshippingWeightTiersResponse200DataItemRelationshipsAttachmentsData",
    "GETshippingWeightTiersResponse200DataItemRelationshipsAttachmentsDataType",
    "GETshippingWeightTiersResponse200DataItemRelationshipsAttachmentsLinks",
    "GETshippingWeightTiersResponse200DataItemRelationshipsShippingMethod",
    "GETshippingWeightTiersResponse200DataItemRelationshipsShippingMethodData",
    "GETshippingWeightTiersResponse200DataItemRelationshipsShippingMethodDataType",
    "GETshippingWeightTiersResponse200DataItemRelationshipsShippingMethodLinks",
    "GETshippingWeightTiersResponse200DataItemType",
    "GETshippingWeightTiersshippingWeightTierIdResponse200",
    "GETshippingWeightTiersshippingWeightTierIdResponse200Data",
    "GETshippingWeightTiersshippingWeightTierIdResponse200DataAttributes",
    "GETshippingWeightTiersshippingWeightTierIdResponse200DataAttributesMetadata",
    "GETshippingWeightTiersshippingWeightTierIdResponse200DataLinks",
    "GETshippingWeightTiersshippingWeightTierIdResponse200DataRelationships",
    "GETshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsAttachments",
    "GETshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsAttachmentsData",
    "GETshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsAttachmentsDataType",
    "GETshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsAttachmentsLinks",
    "GETshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsShippingMethod",
    "GETshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsShippingMethodData",
    "GETshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsShippingMethodDataType",
    "GETshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsShippingMethodLinks",
    "GETshippingWeightTiersshippingWeightTierIdResponse200DataType",
    "GETshippingZonesResponse200",
    "GETshippingZonesResponse200DataItem",
    "GETshippingZonesResponse200DataItemAttributes",
    "GETshippingZonesResponse200DataItemAttributesMetadata",
    "GETshippingZonesResponse200DataItemLinks",
    "GETshippingZonesResponse200DataItemRelationships",
    "GETshippingZonesResponse200DataItemRelationshipsAttachments",
    "GETshippingZonesResponse200DataItemRelationshipsAttachmentsData",
    "GETshippingZonesResponse200DataItemRelationshipsAttachmentsDataType",
    "GETshippingZonesResponse200DataItemRelationshipsAttachmentsLinks",
    "GETshippingZonesResponse200DataItemType",
    "GETshippingZonesshippingZoneIdResponse200",
    "GETshippingZonesshippingZoneIdResponse200Data",
    "GETshippingZonesshippingZoneIdResponse200DataAttributes",
    "GETshippingZonesshippingZoneIdResponse200DataAttributesMetadata",
    "GETshippingZonesshippingZoneIdResponse200DataLinks",
    "GETshippingZonesshippingZoneIdResponse200DataRelationships",
    "GETshippingZonesshippingZoneIdResponse200DataRelationshipsAttachments",
    "GETshippingZonesshippingZoneIdResponse200DataRelationshipsAttachmentsData",
    "GETshippingZonesshippingZoneIdResponse200DataRelationshipsAttachmentsDataType",
    "GETshippingZonesshippingZoneIdResponse200DataRelationshipsAttachmentsLinks",
    "GETshippingZonesshippingZoneIdResponse200DataType",
    "GETskuListItemsResponse200",
    "GETskuListItemsResponse200DataItem",
    "GETskuListItemsResponse200DataItemAttributes",
    "GETskuListItemsResponse200DataItemAttributesMetadata",
    "GETskuListItemsResponse200DataItemLinks",
    "GETskuListItemsResponse200DataItemRelationships",
    "GETskuListItemsResponse200DataItemRelationshipsSku",
    "GETskuListItemsResponse200DataItemRelationshipsSkuData",
    "GETskuListItemsResponse200DataItemRelationshipsSkuDataType",
    "GETskuListItemsResponse200DataItemRelationshipsSkuLinks",
    "GETskuListItemsResponse200DataItemRelationshipsSkuList",
    "GETskuListItemsResponse200DataItemRelationshipsSkuListData",
    "GETskuListItemsResponse200DataItemRelationshipsSkuListDataType",
    "GETskuListItemsResponse200DataItemRelationshipsSkuListLinks",
    "GETskuListItemsResponse200DataItemType",
    "GETskuListItemsskuListItemIdResponse200",
    "GETskuListItemsskuListItemIdResponse200Data",
    "GETskuListItemsskuListItemIdResponse200DataAttributes",
    "GETskuListItemsskuListItemIdResponse200DataAttributesMetadata",
    "GETskuListItemsskuListItemIdResponse200DataLinks",
    "GETskuListItemsskuListItemIdResponse200DataRelationships",
    "GETskuListItemsskuListItemIdResponse200DataRelationshipsSku",
    "GETskuListItemsskuListItemIdResponse200DataRelationshipsSkuData",
    "GETskuListItemsskuListItemIdResponse200DataRelationshipsSkuDataType",
    "GETskuListItemsskuListItemIdResponse200DataRelationshipsSkuLinks",
    "GETskuListItemsskuListItemIdResponse200DataRelationshipsSkuList",
    "GETskuListItemsskuListItemIdResponse200DataRelationshipsSkuListData",
    "GETskuListItemsskuListItemIdResponse200DataRelationshipsSkuListDataType",
    "GETskuListItemsskuListItemIdResponse200DataRelationshipsSkuListLinks",
    "GETskuListItemsskuListItemIdResponse200DataType",
    "GETskuListPromotionRulesResponse200",
    "GETskuListPromotionRulesResponse200DataItem",
    "GETskuListPromotionRulesResponse200DataItemAttributes",
    "GETskuListPromotionRulesResponse200DataItemAttributesMetadata",
    "GETskuListPromotionRulesResponse200DataItemLinks",
    "GETskuListPromotionRulesResponse200DataItemRelationships",
    "GETskuListPromotionRulesResponse200DataItemRelationshipsPromotion",
    "GETskuListPromotionRulesResponse200DataItemRelationshipsPromotionData",
    "GETskuListPromotionRulesResponse200DataItemRelationshipsPromotionDataType",
    "GETskuListPromotionRulesResponse200DataItemRelationshipsPromotionLinks",
    "GETskuListPromotionRulesResponse200DataItemRelationshipsSkuList",
    "GETskuListPromotionRulesResponse200DataItemRelationshipsSkuListData",
    "GETskuListPromotionRulesResponse200DataItemRelationshipsSkuListDataType",
    "GETskuListPromotionRulesResponse200DataItemRelationshipsSkuListLinks",
    "GETskuListPromotionRulesResponse200DataItemRelationshipsSkus",
    "GETskuListPromotionRulesResponse200DataItemRelationshipsSkusData",
    "GETskuListPromotionRulesResponse200DataItemRelationshipsSkusDataType",
    "GETskuListPromotionRulesResponse200DataItemRelationshipsSkusLinks",
    "GETskuListPromotionRulesResponse200DataItemType",
    "GETskuListPromotionRulesskuListPromotionRuleIdResponse200",
    "GETskuListPromotionRulesskuListPromotionRuleIdResponse200Data",
    "GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataAttributes",
    "GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataAttributesMetadata",
    "GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataLinks",
    "GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationships",
    "GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsPromotion",
    "GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsPromotionData",
    "GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsPromotionDataType",
    "GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsPromotionLinks",
    "GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkuList",
    "GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkuListData",
    "GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkuListDataType",
    "GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkuListLinks",
    "GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkus",
    "GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkusData",
    "GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkusDataType",
    "GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkusLinks",
    "GETskuListPromotionRulesskuListPromotionRuleIdResponse200DataType",
    "GETskuListsResponse200",
    "GETskuListsResponse200DataItem",
    "GETskuListsResponse200DataItemAttributes",
    "GETskuListsResponse200DataItemAttributesMetadata",
    "GETskuListsResponse200DataItemLinks",
    "GETskuListsResponse200DataItemRelationships",
    "GETskuListsResponse200DataItemRelationshipsAttachments",
    "GETskuListsResponse200DataItemRelationshipsAttachmentsData",
    "GETskuListsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETskuListsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETskuListsResponse200DataItemRelationshipsBundles",
    "GETskuListsResponse200DataItemRelationshipsBundlesData",
    "GETskuListsResponse200DataItemRelationshipsBundlesDataType",
    "GETskuListsResponse200DataItemRelationshipsBundlesLinks",
    "GETskuListsResponse200DataItemRelationshipsCustomer",
    "GETskuListsResponse200DataItemRelationshipsCustomerData",
    "GETskuListsResponse200DataItemRelationshipsCustomerDataType",
    "GETskuListsResponse200DataItemRelationshipsCustomerLinks",
    "GETskuListsResponse200DataItemRelationshipsSkuListItems",
    "GETskuListsResponse200DataItemRelationshipsSkuListItemsData",
    "GETskuListsResponse200DataItemRelationshipsSkuListItemsDataType",
    "GETskuListsResponse200DataItemRelationshipsSkuListItemsLinks",
    "GETskuListsResponse200DataItemRelationshipsSkus",
    "GETskuListsResponse200DataItemRelationshipsSkusData",
    "GETskuListsResponse200DataItemRelationshipsSkusDataType",
    "GETskuListsResponse200DataItemRelationshipsSkusLinks",
    "GETskuListsResponse200DataItemType",
    "GETskuListsskuListIdResponse200",
    "GETskuListsskuListIdResponse200Data",
    "GETskuListsskuListIdResponse200DataAttributes",
    "GETskuListsskuListIdResponse200DataAttributesMetadata",
    "GETskuListsskuListIdResponse200DataLinks",
    "GETskuListsskuListIdResponse200DataRelationships",
    "GETskuListsskuListIdResponse200DataRelationshipsAttachments",
    "GETskuListsskuListIdResponse200DataRelationshipsAttachmentsData",
    "GETskuListsskuListIdResponse200DataRelationshipsAttachmentsDataType",
    "GETskuListsskuListIdResponse200DataRelationshipsAttachmentsLinks",
    "GETskuListsskuListIdResponse200DataRelationshipsBundles",
    "GETskuListsskuListIdResponse200DataRelationshipsBundlesData",
    "GETskuListsskuListIdResponse200DataRelationshipsBundlesDataType",
    "GETskuListsskuListIdResponse200DataRelationshipsBundlesLinks",
    "GETskuListsskuListIdResponse200DataRelationshipsCustomer",
    "GETskuListsskuListIdResponse200DataRelationshipsCustomerData",
    "GETskuListsskuListIdResponse200DataRelationshipsCustomerDataType",
    "GETskuListsskuListIdResponse200DataRelationshipsCustomerLinks",
    "GETskuListsskuListIdResponse200DataRelationshipsSkuListItems",
    "GETskuListsskuListIdResponse200DataRelationshipsSkuListItemsData",
    "GETskuListsskuListIdResponse200DataRelationshipsSkuListItemsDataType",
    "GETskuListsskuListIdResponse200DataRelationshipsSkuListItemsLinks",
    "GETskuListsskuListIdResponse200DataRelationshipsSkus",
    "GETskuListsskuListIdResponse200DataRelationshipsSkusData",
    "GETskuListsskuListIdResponse200DataRelationshipsSkusDataType",
    "GETskuListsskuListIdResponse200DataRelationshipsSkusLinks",
    "GETskuListsskuListIdResponse200DataType",
    "GETskuOptionsResponse200",
    "GETskuOptionsResponse200DataItem",
    "GETskuOptionsResponse200DataItemAttributes",
    "GETskuOptionsResponse200DataItemAttributesMetadata",
    "GETskuOptionsResponse200DataItemLinks",
    "GETskuOptionsResponse200DataItemRelationships",
    "GETskuOptionsResponse200DataItemRelationshipsAttachments",
    "GETskuOptionsResponse200DataItemRelationshipsAttachmentsData",
    "GETskuOptionsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETskuOptionsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETskuOptionsResponse200DataItemRelationshipsMarket",
    "GETskuOptionsResponse200DataItemRelationshipsMarketData",
    "GETskuOptionsResponse200DataItemRelationshipsMarketDataType",
    "GETskuOptionsResponse200DataItemRelationshipsMarketLinks",
    "GETskuOptionsResponse200DataItemType",
    "GETskuOptionsskuOptionIdResponse200",
    "GETskuOptionsskuOptionIdResponse200Data",
    "GETskuOptionsskuOptionIdResponse200DataAttributes",
    "GETskuOptionsskuOptionIdResponse200DataAttributesMetadata",
    "GETskuOptionsskuOptionIdResponse200DataLinks",
    "GETskuOptionsskuOptionIdResponse200DataRelationships",
    "GETskuOptionsskuOptionIdResponse200DataRelationshipsAttachments",
    "GETskuOptionsskuOptionIdResponse200DataRelationshipsAttachmentsData",
    "GETskuOptionsskuOptionIdResponse200DataRelationshipsAttachmentsDataType",
    "GETskuOptionsskuOptionIdResponse200DataRelationshipsAttachmentsLinks",
    "GETskuOptionsskuOptionIdResponse200DataRelationshipsMarket",
    "GETskuOptionsskuOptionIdResponse200DataRelationshipsMarketData",
    "GETskuOptionsskuOptionIdResponse200DataRelationshipsMarketDataType",
    "GETskuOptionsskuOptionIdResponse200DataRelationshipsMarketLinks",
    "GETskuOptionsskuOptionIdResponse200DataType",
    "GETskusResponse200",
    "GETskusResponse200DataItem",
    "GETskusResponse200DataItemAttributes",
    "GETskusResponse200DataItemAttributesInventory",
    "GETskusResponse200DataItemAttributesMetadata",
    "GETskusResponse200DataItemLinks",
    "GETskusResponse200DataItemRelationships",
    "GETskusResponse200DataItemRelationshipsAttachments",
    "GETskusResponse200DataItemRelationshipsAttachmentsData",
    "GETskusResponse200DataItemRelationshipsAttachmentsDataType",
    "GETskusResponse200DataItemRelationshipsAttachmentsLinks",
    "GETskusResponse200DataItemRelationshipsDeliveryLeadTimes",
    "GETskusResponse200DataItemRelationshipsDeliveryLeadTimesData",
    "GETskusResponse200DataItemRelationshipsDeliveryLeadTimesDataType",
    "GETskusResponse200DataItemRelationshipsDeliveryLeadTimesLinks",
    "GETskusResponse200DataItemRelationshipsPrices",
    "GETskusResponse200DataItemRelationshipsPricesData",
    "GETskusResponse200DataItemRelationshipsPricesDataType",
    "GETskusResponse200DataItemRelationshipsPricesLinks",
    "GETskusResponse200DataItemRelationshipsShippingCategory",
    "GETskusResponse200DataItemRelationshipsShippingCategoryData",
    "GETskusResponse200DataItemRelationshipsShippingCategoryDataType",
    "GETskusResponse200DataItemRelationshipsShippingCategoryLinks",
    "GETskusResponse200DataItemRelationshipsSkuOptions",
    "GETskusResponse200DataItemRelationshipsSkuOptionsData",
    "GETskusResponse200DataItemRelationshipsSkuOptionsDataType",
    "GETskusResponse200DataItemRelationshipsSkuOptionsLinks",
    "GETskusResponse200DataItemRelationshipsStockItems",
    "GETskusResponse200DataItemRelationshipsStockItemsData",
    "GETskusResponse200DataItemRelationshipsStockItemsDataType",
    "GETskusResponse200DataItemRelationshipsStockItemsLinks",
    "GETskusResponse200DataItemType",
    "GETskusskuIdResponse200",
    "GETskusskuIdResponse200Data",
    "GETskusskuIdResponse200DataAttributes",
    "GETskusskuIdResponse200DataAttributesInventory",
    "GETskusskuIdResponse200DataAttributesMetadata",
    "GETskusskuIdResponse200DataLinks",
    "GETskusskuIdResponse200DataRelationships",
    "GETskusskuIdResponse200DataRelationshipsAttachments",
    "GETskusskuIdResponse200DataRelationshipsAttachmentsData",
    "GETskusskuIdResponse200DataRelationshipsAttachmentsDataType",
    "GETskusskuIdResponse200DataRelationshipsAttachmentsLinks",
    "GETskusskuIdResponse200DataRelationshipsDeliveryLeadTimes",
    "GETskusskuIdResponse200DataRelationshipsDeliveryLeadTimesData",
    "GETskusskuIdResponse200DataRelationshipsDeliveryLeadTimesDataType",
    "GETskusskuIdResponse200DataRelationshipsDeliveryLeadTimesLinks",
    "GETskusskuIdResponse200DataRelationshipsPrices",
    "GETskusskuIdResponse200DataRelationshipsPricesData",
    "GETskusskuIdResponse200DataRelationshipsPricesDataType",
    "GETskusskuIdResponse200DataRelationshipsPricesLinks",
    "GETskusskuIdResponse200DataRelationshipsShippingCategory",
    "GETskusskuIdResponse200DataRelationshipsShippingCategoryData",
    "GETskusskuIdResponse200DataRelationshipsShippingCategoryDataType",
    "GETskusskuIdResponse200DataRelationshipsShippingCategoryLinks",
    "GETskusskuIdResponse200DataRelationshipsSkuOptions",
    "GETskusskuIdResponse200DataRelationshipsSkuOptionsData",
    "GETskusskuIdResponse200DataRelationshipsSkuOptionsDataType",
    "GETskusskuIdResponse200DataRelationshipsSkuOptionsLinks",
    "GETskusskuIdResponse200DataRelationshipsStockItems",
    "GETskusskuIdResponse200DataRelationshipsStockItemsData",
    "GETskusskuIdResponse200DataRelationshipsStockItemsDataType",
    "GETskusskuIdResponse200DataRelationshipsStockItemsLinks",
    "GETskusskuIdResponse200DataType",
    "GETstockItemsResponse200",
    "GETstockItemsResponse200DataItem",
    "GETstockItemsResponse200DataItemAttributes",
    "GETstockItemsResponse200DataItemAttributesMetadata",
    "GETstockItemsResponse200DataItemLinks",
    "GETstockItemsResponse200DataItemRelationships",
    "GETstockItemsResponse200DataItemRelationshipsAttachments",
    "GETstockItemsResponse200DataItemRelationshipsAttachmentsData",
    "GETstockItemsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETstockItemsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETstockItemsResponse200DataItemRelationshipsSku",
    "GETstockItemsResponse200DataItemRelationshipsSkuData",
    "GETstockItemsResponse200DataItemRelationshipsSkuDataType",
    "GETstockItemsResponse200DataItemRelationshipsSkuLinks",
    "GETstockItemsResponse200DataItemRelationshipsStockLocation",
    "GETstockItemsResponse200DataItemRelationshipsStockLocationData",
    "GETstockItemsResponse200DataItemRelationshipsStockLocationDataType",
    "GETstockItemsResponse200DataItemRelationshipsStockLocationLinks",
    "GETstockItemsResponse200DataItemType",
    "GETstockItemsstockItemIdResponse200",
    "GETstockItemsstockItemIdResponse200Data",
    "GETstockItemsstockItemIdResponse200DataAttributes",
    "GETstockItemsstockItemIdResponse200DataAttributesMetadata",
    "GETstockItemsstockItemIdResponse200DataLinks",
    "GETstockItemsstockItemIdResponse200DataRelationships",
    "GETstockItemsstockItemIdResponse200DataRelationshipsAttachments",
    "GETstockItemsstockItemIdResponse200DataRelationshipsAttachmentsData",
    "GETstockItemsstockItemIdResponse200DataRelationshipsAttachmentsDataType",
    "GETstockItemsstockItemIdResponse200DataRelationshipsAttachmentsLinks",
    "GETstockItemsstockItemIdResponse200DataRelationshipsSku",
    "GETstockItemsstockItemIdResponse200DataRelationshipsSkuData",
    "GETstockItemsstockItemIdResponse200DataRelationshipsSkuDataType",
    "GETstockItemsstockItemIdResponse200DataRelationshipsSkuLinks",
    "GETstockItemsstockItemIdResponse200DataRelationshipsStockLocation",
    "GETstockItemsstockItemIdResponse200DataRelationshipsStockLocationData",
    "GETstockItemsstockItemIdResponse200DataRelationshipsStockLocationDataType",
    "GETstockItemsstockItemIdResponse200DataRelationshipsStockLocationLinks",
    "GETstockItemsstockItemIdResponse200DataType",
    "GETstockLineItemsResponse200",
    "GETstockLineItemsResponse200DataItem",
    "GETstockLineItemsResponse200DataItemAttributes",
    "GETstockLineItemsResponse200DataItemAttributesMetadata",
    "GETstockLineItemsResponse200DataItemLinks",
    "GETstockLineItemsResponse200DataItemRelationships",
    "GETstockLineItemsResponse200DataItemRelationshipsLineItem",
    "GETstockLineItemsResponse200DataItemRelationshipsLineItemData",
    "GETstockLineItemsResponse200DataItemRelationshipsLineItemDataType",
    "GETstockLineItemsResponse200DataItemRelationshipsLineItemLinks",
    "GETstockLineItemsResponse200DataItemRelationshipsShipment",
    "GETstockLineItemsResponse200DataItemRelationshipsShipmentData",
    "GETstockLineItemsResponse200DataItemRelationshipsShipmentDataType",
    "GETstockLineItemsResponse200DataItemRelationshipsShipmentLinks",
    "GETstockLineItemsResponse200DataItemRelationshipsStockItem",
    "GETstockLineItemsResponse200DataItemRelationshipsStockItemData",
    "GETstockLineItemsResponse200DataItemRelationshipsStockItemDataType",
    "GETstockLineItemsResponse200DataItemRelationshipsStockItemLinks",
    "GETstockLineItemsResponse200DataItemType",
    "GETstockLineItemsstockLineItemIdResponse200",
    "GETstockLineItemsstockLineItemIdResponse200Data",
    "GETstockLineItemsstockLineItemIdResponse200DataAttributes",
    "GETstockLineItemsstockLineItemIdResponse200DataAttributesMetadata",
    "GETstockLineItemsstockLineItemIdResponse200DataLinks",
    "GETstockLineItemsstockLineItemIdResponse200DataRelationships",
    "GETstockLineItemsstockLineItemIdResponse200DataRelationshipsLineItem",
    "GETstockLineItemsstockLineItemIdResponse200DataRelationshipsLineItemData",
    "GETstockLineItemsstockLineItemIdResponse200DataRelationshipsLineItemDataType",
    "GETstockLineItemsstockLineItemIdResponse200DataRelationshipsLineItemLinks",
    "GETstockLineItemsstockLineItemIdResponse200DataRelationshipsShipment",
    "GETstockLineItemsstockLineItemIdResponse200DataRelationshipsShipmentData",
    "GETstockLineItemsstockLineItemIdResponse200DataRelationshipsShipmentDataType",
    "GETstockLineItemsstockLineItemIdResponse200DataRelationshipsShipmentLinks",
    "GETstockLineItemsstockLineItemIdResponse200DataRelationshipsStockItem",
    "GETstockLineItemsstockLineItemIdResponse200DataRelationshipsStockItemData",
    "GETstockLineItemsstockLineItemIdResponse200DataRelationshipsStockItemDataType",
    "GETstockLineItemsstockLineItemIdResponse200DataRelationshipsStockItemLinks",
    "GETstockLineItemsstockLineItemIdResponse200DataType",
    "GETstockLocationsResponse200",
    "GETstockLocationsResponse200DataItem",
    "GETstockLocationsResponse200DataItemAttributes",
    "GETstockLocationsResponse200DataItemAttributesMetadata",
    "GETstockLocationsResponse200DataItemLinks",
    "GETstockLocationsResponse200DataItemRelationships",
    "GETstockLocationsResponse200DataItemRelationshipsAddress",
    "GETstockLocationsResponse200DataItemRelationshipsAddressData",
    "GETstockLocationsResponse200DataItemRelationshipsAddressDataType",
    "GETstockLocationsResponse200DataItemRelationshipsAddressLinks",
    "GETstockLocationsResponse200DataItemRelationshipsAttachments",
    "GETstockLocationsResponse200DataItemRelationshipsAttachmentsData",
    "GETstockLocationsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETstockLocationsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETstockLocationsResponse200DataItemRelationshipsInventoryReturnLocations",
    "GETstockLocationsResponse200DataItemRelationshipsInventoryReturnLocationsData",
    "GETstockLocationsResponse200DataItemRelationshipsInventoryReturnLocationsDataType",
    "GETstockLocationsResponse200DataItemRelationshipsInventoryReturnLocationsLinks",
    "GETstockLocationsResponse200DataItemRelationshipsInventoryStockLocations",
    "GETstockLocationsResponse200DataItemRelationshipsInventoryStockLocationsData",
    "GETstockLocationsResponse200DataItemRelationshipsInventoryStockLocationsDataType",
    "GETstockLocationsResponse200DataItemRelationshipsInventoryStockLocationsLinks",
    "GETstockLocationsResponse200DataItemRelationshipsStockItems",
    "GETstockLocationsResponse200DataItemRelationshipsStockItemsData",
    "GETstockLocationsResponse200DataItemRelationshipsStockItemsDataType",
    "GETstockLocationsResponse200DataItemRelationshipsStockItemsLinks",
    "GETstockLocationsResponse200DataItemRelationshipsStockTransfers",
    "GETstockLocationsResponse200DataItemRelationshipsStockTransfersData",
    "GETstockLocationsResponse200DataItemRelationshipsStockTransfersDataType",
    "GETstockLocationsResponse200DataItemRelationshipsStockTransfersLinks",
    "GETstockLocationsResponse200DataItemType",
    "GETstockLocationsstockLocationIdResponse200",
    "GETstockLocationsstockLocationIdResponse200Data",
    "GETstockLocationsstockLocationIdResponse200DataAttributes",
    "GETstockLocationsstockLocationIdResponse200DataAttributesMetadata",
    "GETstockLocationsstockLocationIdResponse200DataLinks",
    "GETstockLocationsstockLocationIdResponse200DataRelationships",
    "GETstockLocationsstockLocationIdResponse200DataRelationshipsAddress",
    "GETstockLocationsstockLocationIdResponse200DataRelationshipsAddressData",
    "GETstockLocationsstockLocationIdResponse200DataRelationshipsAddressDataType",
    "GETstockLocationsstockLocationIdResponse200DataRelationshipsAddressLinks",
    "GETstockLocationsstockLocationIdResponse200DataRelationshipsAttachments",
    "GETstockLocationsstockLocationIdResponse200DataRelationshipsAttachmentsData",
    "GETstockLocationsstockLocationIdResponse200DataRelationshipsAttachmentsDataType",
    "GETstockLocationsstockLocationIdResponse200DataRelationshipsAttachmentsLinks",
    "GETstockLocationsstockLocationIdResponse200DataRelationshipsInventoryReturnLocations",
    "GETstockLocationsstockLocationIdResponse200DataRelationshipsInventoryReturnLocationsData",
    "GETstockLocationsstockLocationIdResponse200DataRelationshipsInventoryReturnLocationsDataType",
    "GETstockLocationsstockLocationIdResponse200DataRelationshipsInventoryReturnLocationsLinks",
    "GETstockLocationsstockLocationIdResponse200DataRelationshipsInventoryStockLocations",
    "GETstockLocationsstockLocationIdResponse200DataRelationshipsInventoryStockLocationsData",
    "GETstockLocationsstockLocationIdResponse200DataRelationshipsInventoryStockLocationsDataType",
    "GETstockLocationsstockLocationIdResponse200DataRelationshipsInventoryStockLocationsLinks",
    "GETstockLocationsstockLocationIdResponse200DataRelationshipsStockItems",
    "GETstockLocationsstockLocationIdResponse200DataRelationshipsStockItemsData",
    "GETstockLocationsstockLocationIdResponse200DataRelationshipsStockItemsDataType",
    "GETstockLocationsstockLocationIdResponse200DataRelationshipsStockItemsLinks",
    "GETstockLocationsstockLocationIdResponse200DataRelationshipsStockTransfers",
    "GETstockLocationsstockLocationIdResponse200DataRelationshipsStockTransfersData",
    "GETstockLocationsstockLocationIdResponse200DataRelationshipsStockTransfersDataType",
    "GETstockLocationsstockLocationIdResponse200DataRelationshipsStockTransfersLinks",
    "GETstockLocationsstockLocationIdResponse200DataType",
    "GETstockTransfersResponse200",
    "GETstockTransfersResponse200DataItem",
    "GETstockTransfersResponse200DataItemAttributes",
    "GETstockTransfersResponse200DataItemAttributesMetadata",
    "GETstockTransfersResponse200DataItemLinks",
    "GETstockTransfersResponse200DataItemRelationships",
    "GETstockTransfersResponse200DataItemRelationshipsDestinationStockLocation",
    "GETstockTransfersResponse200DataItemRelationshipsDestinationStockLocationData",
    "GETstockTransfersResponse200DataItemRelationshipsDestinationStockLocationDataType",
    "GETstockTransfersResponse200DataItemRelationshipsDestinationStockLocationLinks",
    "GETstockTransfersResponse200DataItemRelationshipsEvents",
    "GETstockTransfersResponse200DataItemRelationshipsEventsData",
    "GETstockTransfersResponse200DataItemRelationshipsEventsDataType",
    "GETstockTransfersResponse200DataItemRelationshipsEventsLinks",
    "GETstockTransfersResponse200DataItemRelationshipsLineItem",
    "GETstockTransfersResponse200DataItemRelationshipsLineItemData",
    "GETstockTransfersResponse200DataItemRelationshipsLineItemDataType",
    "GETstockTransfersResponse200DataItemRelationshipsLineItemLinks",
    "GETstockTransfersResponse200DataItemRelationshipsOriginStockLocation",
    "GETstockTransfersResponse200DataItemRelationshipsOriginStockLocationData",
    "GETstockTransfersResponse200DataItemRelationshipsOriginStockLocationDataType",
    "GETstockTransfersResponse200DataItemRelationshipsOriginStockLocationLinks",
    "GETstockTransfersResponse200DataItemRelationshipsShipment",
    "GETstockTransfersResponse200DataItemRelationshipsShipmentData",
    "GETstockTransfersResponse200DataItemRelationshipsShipmentDataType",
    "GETstockTransfersResponse200DataItemRelationshipsShipmentLinks",
    "GETstockTransfersResponse200DataItemRelationshipsSku",
    "GETstockTransfersResponse200DataItemRelationshipsSkuData",
    "GETstockTransfersResponse200DataItemRelationshipsSkuDataType",
    "GETstockTransfersResponse200DataItemRelationshipsSkuLinks",
    "GETstockTransfersResponse200DataItemType",
    "GETstockTransfersstockTransferIdResponse200",
    "GETstockTransfersstockTransferIdResponse200Data",
    "GETstockTransfersstockTransferIdResponse200DataAttributes",
    "GETstockTransfersstockTransferIdResponse200DataAttributesMetadata",
    "GETstockTransfersstockTransferIdResponse200DataLinks",
    "GETstockTransfersstockTransferIdResponse200DataRelationships",
    "GETstockTransfersstockTransferIdResponse200DataRelationshipsDestinationStockLocation",
    "GETstockTransfersstockTransferIdResponse200DataRelationshipsDestinationStockLocationData",
    "GETstockTransfersstockTransferIdResponse200DataRelationshipsDestinationStockLocationDataType",
    "GETstockTransfersstockTransferIdResponse200DataRelationshipsDestinationStockLocationLinks",
    "GETstockTransfersstockTransferIdResponse200DataRelationshipsEvents",
    "GETstockTransfersstockTransferIdResponse200DataRelationshipsEventsData",
    "GETstockTransfersstockTransferIdResponse200DataRelationshipsEventsDataType",
    "GETstockTransfersstockTransferIdResponse200DataRelationshipsEventsLinks",
    "GETstockTransfersstockTransferIdResponse200DataRelationshipsLineItem",
    "GETstockTransfersstockTransferIdResponse200DataRelationshipsLineItemData",
    "GETstockTransfersstockTransferIdResponse200DataRelationshipsLineItemDataType",
    "GETstockTransfersstockTransferIdResponse200DataRelationshipsLineItemLinks",
    "GETstockTransfersstockTransferIdResponse200DataRelationshipsOriginStockLocation",
    "GETstockTransfersstockTransferIdResponse200DataRelationshipsOriginStockLocationData",
    "GETstockTransfersstockTransferIdResponse200DataRelationshipsOriginStockLocationDataType",
    "GETstockTransfersstockTransferIdResponse200DataRelationshipsOriginStockLocationLinks",
    "GETstockTransfersstockTransferIdResponse200DataRelationshipsShipment",
    "GETstockTransfersstockTransferIdResponse200DataRelationshipsShipmentData",
    "GETstockTransfersstockTransferIdResponse200DataRelationshipsShipmentDataType",
    "GETstockTransfersstockTransferIdResponse200DataRelationshipsShipmentLinks",
    "GETstockTransfersstockTransferIdResponse200DataRelationshipsSku",
    "GETstockTransfersstockTransferIdResponse200DataRelationshipsSkuData",
    "GETstockTransfersstockTransferIdResponse200DataRelationshipsSkuDataType",
    "GETstockTransfersstockTransferIdResponse200DataRelationshipsSkuLinks",
    "GETstockTransfersstockTransferIdResponse200DataType",
    "GETstripeGatewaysResponse200",
    "GETstripeGatewaysResponse200DataItem",
    "GETstripeGatewaysResponse200DataItemAttributes",
    "GETstripeGatewaysResponse200DataItemAttributesMetadata",
    "GETstripeGatewaysResponse200DataItemLinks",
    "GETstripeGatewaysResponse200DataItemRelationships",
    "GETstripeGatewaysResponse200DataItemRelationshipsPaymentMethods",
    "GETstripeGatewaysResponse200DataItemRelationshipsPaymentMethodsData",
    "GETstripeGatewaysResponse200DataItemRelationshipsPaymentMethodsDataType",
    "GETstripeGatewaysResponse200DataItemRelationshipsPaymentMethodsLinks",
    "GETstripeGatewaysResponse200DataItemRelationshipsStripePayments",
    "GETstripeGatewaysResponse200DataItemRelationshipsStripePaymentsData",
    "GETstripeGatewaysResponse200DataItemRelationshipsStripePaymentsDataType",
    "GETstripeGatewaysResponse200DataItemRelationshipsStripePaymentsLinks",
    "GETstripeGatewaysResponse200DataItemType",
    "GETstripeGatewaysstripeGatewayIdResponse200",
    "GETstripeGatewaysstripeGatewayIdResponse200Data",
    "GETstripeGatewaysstripeGatewayIdResponse200DataAttributes",
    "GETstripeGatewaysstripeGatewayIdResponse200DataAttributesMetadata",
    "GETstripeGatewaysstripeGatewayIdResponse200DataLinks",
    "GETstripeGatewaysstripeGatewayIdResponse200DataRelationships",
    "GETstripeGatewaysstripeGatewayIdResponse200DataRelationshipsPaymentMethods",
    "GETstripeGatewaysstripeGatewayIdResponse200DataRelationshipsPaymentMethodsData",
    "GETstripeGatewaysstripeGatewayIdResponse200DataRelationshipsPaymentMethodsDataType",
    "GETstripeGatewaysstripeGatewayIdResponse200DataRelationshipsPaymentMethodsLinks",
    "GETstripeGatewaysstripeGatewayIdResponse200DataRelationshipsStripePayments",
    "GETstripeGatewaysstripeGatewayIdResponse200DataRelationshipsStripePaymentsData",
    "GETstripeGatewaysstripeGatewayIdResponse200DataRelationshipsStripePaymentsDataType",
    "GETstripeGatewaysstripeGatewayIdResponse200DataRelationshipsStripePaymentsLinks",
    "GETstripeGatewaysstripeGatewayIdResponse200DataType",
    "GETstripePaymentsResponse200",
    "GETstripePaymentsResponse200DataItem",
    "GETstripePaymentsResponse200DataItemAttributes",
    "GETstripePaymentsResponse200DataItemAttributesMetadata",
    "GETstripePaymentsResponse200DataItemAttributesOptions",
    "GETstripePaymentsResponse200DataItemAttributesPaymentMethod",
    "GETstripePaymentsResponse200DataItemLinks",
    "GETstripePaymentsResponse200DataItemRelationships",
    "GETstripePaymentsResponse200DataItemRelationshipsOrder",
    "GETstripePaymentsResponse200DataItemRelationshipsOrderData",
    "GETstripePaymentsResponse200DataItemRelationshipsOrderDataType",
    "GETstripePaymentsResponse200DataItemRelationshipsOrderLinks",
    "GETstripePaymentsResponse200DataItemRelationshipsPaymentGateway",
    "GETstripePaymentsResponse200DataItemRelationshipsPaymentGatewayData",
    "GETstripePaymentsResponse200DataItemRelationshipsPaymentGatewayDataType",
    "GETstripePaymentsResponse200DataItemRelationshipsPaymentGatewayLinks",
    "GETstripePaymentsResponse200DataItemType",
    "GETstripePaymentsstripePaymentIdResponse200",
    "GETstripePaymentsstripePaymentIdResponse200Data",
    "GETstripePaymentsstripePaymentIdResponse200DataAttributes",
    "GETstripePaymentsstripePaymentIdResponse200DataAttributesMetadata",
    "GETstripePaymentsstripePaymentIdResponse200DataAttributesOptions",
    "GETstripePaymentsstripePaymentIdResponse200DataAttributesPaymentMethod",
    "GETstripePaymentsstripePaymentIdResponse200DataLinks",
    "GETstripePaymentsstripePaymentIdResponse200DataRelationships",
    "GETstripePaymentsstripePaymentIdResponse200DataRelationshipsOrder",
    "GETstripePaymentsstripePaymentIdResponse200DataRelationshipsOrderData",
    "GETstripePaymentsstripePaymentIdResponse200DataRelationshipsOrderDataType",
    "GETstripePaymentsstripePaymentIdResponse200DataRelationshipsOrderLinks",
    "GETstripePaymentsstripePaymentIdResponse200DataRelationshipsPaymentGateway",
    "GETstripePaymentsstripePaymentIdResponse200DataRelationshipsPaymentGatewayData",
    "GETstripePaymentsstripePaymentIdResponse200DataRelationshipsPaymentGatewayDataType",
    "GETstripePaymentsstripePaymentIdResponse200DataRelationshipsPaymentGatewayLinks",
    "GETstripePaymentsstripePaymentIdResponse200DataType",
    "GETtaxCalculatorsResponse200",
    "GETtaxCalculatorsResponse200DataItem",
    "GETtaxCalculatorsResponse200DataItemAttributes",
    "GETtaxCalculatorsResponse200DataItemAttributesMetadata",
    "GETtaxCalculatorsResponse200DataItemLinks",
    "GETtaxCalculatorsResponse200DataItemRelationships",
    "GETtaxCalculatorsResponse200DataItemRelationshipsAttachments",
    "GETtaxCalculatorsResponse200DataItemRelationshipsAttachmentsData",
    "GETtaxCalculatorsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETtaxCalculatorsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETtaxCalculatorsResponse200DataItemRelationshipsMarkets",
    "GETtaxCalculatorsResponse200DataItemRelationshipsMarketsData",
    "GETtaxCalculatorsResponse200DataItemRelationshipsMarketsDataType",
    "GETtaxCalculatorsResponse200DataItemRelationshipsMarketsLinks",
    "GETtaxCalculatorsResponse200DataItemType",
    "GETtaxCalculatorstaxCalculatorIdResponse200",
    "GETtaxCalculatorstaxCalculatorIdResponse200Data",
    "GETtaxCalculatorstaxCalculatorIdResponse200DataAttributes",
    "GETtaxCalculatorstaxCalculatorIdResponse200DataAttributesMetadata",
    "GETtaxCalculatorstaxCalculatorIdResponse200DataLinks",
    "GETtaxCalculatorstaxCalculatorIdResponse200DataRelationships",
    "GETtaxCalculatorstaxCalculatorIdResponse200DataRelationshipsAttachments",
    "GETtaxCalculatorstaxCalculatorIdResponse200DataRelationshipsAttachmentsData",
    "GETtaxCalculatorstaxCalculatorIdResponse200DataRelationshipsAttachmentsDataType",
    "GETtaxCalculatorstaxCalculatorIdResponse200DataRelationshipsAttachmentsLinks",
    "GETtaxCalculatorstaxCalculatorIdResponse200DataRelationshipsMarkets",
    "GETtaxCalculatorstaxCalculatorIdResponse200DataRelationshipsMarketsData",
    "GETtaxCalculatorstaxCalculatorIdResponse200DataRelationshipsMarketsDataType",
    "GETtaxCalculatorstaxCalculatorIdResponse200DataRelationshipsMarketsLinks",
    "GETtaxCalculatorstaxCalculatorIdResponse200DataType",
    "GETtaxCategoriesResponse200",
    "GETtaxCategoriesResponse200DataItem",
    "GETtaxCategoriesResponse200DataItemAttributes",
    "GETtaxCategoriesResponse200DataItemAttributesMetadata",
    "GETtaxCategoriesResponse200DataItemLinks",
    "GETtaxCategoriesResponse200DataItemRelationships",
    "GETtaxCategoriesResponse200DataItemRelationshipsAttachments",
    "GETtaxCategoriesResponse200DataItemRelationshipsAttachmentsData",
    "GETtaxCategoriesResponse200DataItemRelationshipsAttachmentsDataType",
    "GETtaxCategoriesResponse200DataItemRelationshipsAttachmentsLinks",
    "GETtaxCategoriesResponse200DataItemRelationshipsSku",
    "GETtaxCategoriesResponse200DataItemRelationshipsSkuData",
    "GETtaxCategoriesResponse200DataItemRelationshipsSkuDataType",
    "GETtaxCategoriesResponse200DataItemRelationshipsSkuLinks",
    "GETtaxCategoriesResponse200DataItemRelationshipsTaxCalculator",
    "GETtaxCategoriesResponse200DataItemRelationshipsTaxCalculatorData",
    "GETtaxCategoriesResponse200DataItemRelationshipsTaxCalculatorDataType",
    "GETtaxCategoriesResponse200DataItemRelationshipsTaxCalculatorLinks",
    "GETtaxCategoriesResponse200DataItemType",
    "GETtaxCategoriestaxCategoryIdResponse200",
    "GETtaxCategoriestaxCategoryIdResponse200Data",
    "GETtaxCategoriestaxCategoryIdResponse200DataAttributes",
    "GETtaxCategoriestaxCategoryIdResponse200DataAttributesMetadata",
    "GETtaxCategoriestaxCategoryIdResponse200DataLinks",
    "GETtaxCategoriestaxCategoryIdResponse200DataRelationships",
    "GETtaxCategoriestaxCategoryIdResponse200DataRelationshipsAttachments",
    "GETtaxCategoriestaxCategoryIdResponse200DataRelationshipsAttachmentsData",
    "GETtaxCategoriestaxCategoryIdResponse200DataRelationshipsAttachmentsDataType",
    "GETtaxCategoriestaxCategoryIdResponse200DataRelationshipsAttachmentsLinks",
    "GETtaxCategoriestaxCategoryIdResponse200DataRelationshipsSku",
    "GETtaxCategoriestaxCategoryIdResponse200DataRelationshipsSkuData",
    "GETtaxCategoriestaxCategoryIdResponse200DataRelationshipsSkuDataType",
    "GETtaxCategoriestaxCategoryIdResponse200DataRelationshipsSkuLinks",
    "GETtaxCategoriestaxCategoryIdResponse200DataRelationshipsTaxCalculator",
    "GETtaxCategoriestaxCategoryIdResponse200DataRelationshipsTaxCalculatorData",
    "GETtaxCategoriestaxCategoryIdResponse200DataRelationshipsTaxCalculatorDataType",
    "GETtaxCategoriestaxCategoryIdResponse200DataRelationshipsTaxCalculatorLinks",
    "GETtaxCategoriestaxCategoryIdResponse200DataType",
    "GETtaxjarAccountsResponse200",
    "GETtaxjarAccountsResponse200DataItem",
    "GETtaxjarAccountsResponse200DataItemAttributes",
    "GETtaxjarAccountsResponse200DataItemAttributesMetadata",
    "GETtaxjarAccountsResponse200DataItemLinks",
    "GETtaxjarAccountsResponse200DataItemRelationships",
    "GETtaxjarAccountsResponse200DataItemRelationshipsAttachments",
    "GETtaxjarAccountsResponse200DataItemRelationshipsAttachmentsData",
    "GETtaxjarAccountsResponse200DataItemRelationshipsAttachmentsDataType",
    "GETtaxjarAccountsResponse200DataItemRelationshipsAttachmentsLinks",
    "GETtaxjarAccountsResponse200DataItemRelationshipsMarkets",
    "GETtaxjarAccountsResponse200DataItemRelationshipsMarketsData",
    "GETtaxjarAccountsResponse200DataItemRelationshipsMarketsDataType",
    "GETtaxjarAccountsResponse200DataItemRelationshipsMarketsLinks",
    "GETtaxjarAccountsResponse200DataItemRelationshipsTaxCategories",
    "GETtaxjarAccountsResponse200DataItemRelationshipsTaxCategoriesData",
    "GETtaxjarAccountsResponse200DataItemRelationshipsTaxCategoriesDataType",
    "GETtaxjarAccountsResponse200DataItemRelationshipsTaxCategoriesLinks",
    "GETtaxjarAccountsResponse200DataItemType",
    "GETtaxjarAccountstaxjarAccountIdResponse200",
    "GETtaxjarAccountstaxjarAccountIdResponse200Data",
    "GETtaxjarAccountstaxjarAccountIdResponse200DataAttributes",
    "GETtaxjarAccountstaxjarAccountIdResponse200DataAttributesMetadata",
    "GETtaxjarAccountstaxjarAccountIdResponse200DataLinks",
    "GETtaxjarAccountstaxjarAccountIdResponse200DataRelationships",
    "GETtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsAttachments",
    "GETtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsAttachmentsData",
    "GETtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsAttachmentsDataType",
    "GETtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsAttachmentsLinks",
    "GETtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsMarkets",
    "GETtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsMarketsData",
    "GETtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsMarketsDataType",
    "GETtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsMarketsLinks",
    "GETtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsTaxCategories",
    "GETtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsTaxCategoriesData",
    "GETtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsTaxCategoriesDataType",
    "GETtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsTaxCategoriesLinks",
    "GETtaxjarAccountstaxjarAccountIdResponse200DataType",
    "GETtaxRulesResponse200",
    "GETtaxRulesResponse200DataItem",
    "GETtaxRulesResponse200DataItemAttributes",
    "GETtaxRulesResponse200DataItemAttributesBreakdown",
    "GETtaxRulesResponse200DataItemAttributesMetadata",
    "GETtaxRulesResponse200DataItemLinks",
    "GETtaxRulesResponse200DataItemRelationships",
    "GETtaxRulesResponse200DataItemRelationshipsManualTaxCalculator",
    "GETtaxRulesResponse200DataItemRelationshipsManualTaxCalculatorData",
    "GETtaxRulesResponse200DataItemRelationshipsManualTaxCalculatorDataType",
    "GETtaxRulesResponse200DataItemRelationshipsManualTaxCalculatorLinks",
    "GETtaxRulesResponse200DataItemType",
    "GETtaxRulestaxRuleIdResponse200",
    "GETtaxRulestaxRuleIdResponse200Data",
    "GETtaxRulestaxRuleIdResponse200DataAttributes",
    "GETtaxRulestaxRuleIdResponse200DataAttributesBreakdown",
    "GETtaxRulestaxRuleIdResponse200DataAttributesMetadata",
    "GETtaxRulestaxRuleIdResponse200DataLinks",
    "GETtaxRulestaxRuleIdResponse200DataRelationships",
    "GETtaxRulestaxRuleIdResponse200DataRelationshipsManualTaxCalculator",
    "GETtaxRulestaxRuleIdResponse200DataRelationshipsManualTaxCalculatorData",
    "GETtaxRulestaxRuleIdResponse200DataRelationshipsManualTaxCalculatorDataType",
    "GETtaxRulestaxRuleIdResponse200DataRelationshipsManualTaxCalculatorLinks",
    "GETtaxRulestaxRuleIdResponse200DataType",
    "GETtransactionsResponse200",
    "GETtransactionsResponse200DataItem",
    "GETtransactionsResponse200DataItemAttributes",
    "GETtransactionsResponse200DataItemAttributesMetadata",
    "GETtransactionsResponse200DataItemLinks",
    "GETtransactionsResponse200DataItemRelationships",
    "GETtransactionsResponse200DataItemRelationshipsOrder",
    "GETtransactionsResponse200DataItemRelationshipsOrderData",
    "GETtransactionsResponse200DataItemRelationshipsOrderDataType",
    "GETtransactionsResponse200DataItemRelationshipsOrderLinks",
    "GETtransactionsResponse200DataItemType",
    "GETtransactionstransactionIdResponse200",
    "GETtransactionstransactionIdResponse200Data",
    "GETtransactionstransactionIdResponse200DataAttributes",
    "GETtransactionstransactionIdResponse200DataAttributesMetadata",
    "GETtransactionstransactionIdResponse200DataLinks",
    "GETtransactionstransactionIdResponse200DataRelationships",
    "GETtransactionstransactionIdResponse200DataRelationshipsOrder",
    "GETtransactionstransactionIdResponse200DataRelationshipsOrderData",
    "GETtransactionstransactionIdResponse200DataRelationshipsOrderDataType",
    "GETtransactionstransactionIdResponse200DataRelationshipsOrderLinks",
    "GETtransactionstransactionIdResponse200DataType",
    "GETvoidsResponse200",
    "GETvoidsResponse200DataItem",
    "GETvoidsResponse200DataItemAttributes",
    "GETvoidsResponse200DataItemAttributesMetadata",
    "GETvoidsResponse200DataItemLinks",
    "GETvoidsResponse200DataItemRelationships",
    "GETvoidsResponse200DataItemRelationshipsOrder",
    "GETvoidsResponse200DataItemRelationshipsOrderData",
    "GETvoidsResponse200DataItemRelationshipsOrderDataType",
    "GETvoidsResponse200DataItemRelationshipsOrderLinks",
    "GETvoidsResponse200DataItemRelationshipsReferenceAuthorization",
    "GETvoidsResponse200DataItemRelationshipsReferenceAuthorizationData",
    "GETvoidsResponse200DataItemRelationshipsReferenceAuthorizationDataType",
    "GETvoidsResponse200DataItemRelationshipsReferenceAuthorizationLinks",
    "GETvoidsResponse200DataItemType",
    "GETvoidsvoidIdResponse200",
    "GETvoidsvoidIdResponse200Data",
    "GETvoidsvoidIdResponse200DataAttributes",
    "GETvoidsvoidIdResponse200DataAttributesMetadata",
    "GETvoidsvoidIdResponse200DataLinks",
    "GETvoidsvoidIdResponse200DataRelationships",
    "GETvoidsvoidIdResponse200DataRelationshipsOrder",
    "GETvoidsvoidIdResponse200DataRelationshipsOrderData",
    "GETvoidsvoidIdResponse200DataRelationshipsOrderDataType",
    "GETvoidsvoidIdResponse200DataRelationshipsOrderLinks",
    "GETvoidsvoidIdResponse200DataRelationshipsReferenceAuthorization",
    "GETvoidsvoidIdResponse200DataRelationshipsReferenceAuthorizationData",
    "GETvoidsvoidIdResponse200DataRelationshipsReferenceAuthorizationDataType",
    "GETvoidsvoidIdResponse200DataRelationshipsReferenceAuthorizationLinks",
    "GETvoidsvoidIdResponse200DataType",
    "GETwebhooksResponse200",
    "GETwebhooksResponse200DataItem",
    "GETwebhooksResponse200DataItemAttributes",
    "GETwebhooksResponse200DataItemAttributesMetadata",
    "GETwebhooksResponse200DataItemLinks",
    "GETwebhooksResponse200DataItemRelationships",
    "GETwebhooksResponse200DataItemRelationshipsLastEventCallbacks",
    "GETwebhooksResponse200DataItemRelationshipsLastEventCallbacksData",
    "GETwebhooksResponse200DataItemRelationshipsLastEventCallbacksDataType",
    "GETwebhooksResponse200DataItemRelationshipsLastEventCallbacksLinks",
    "GETwebhooksResponse200DataItemType",
    "GETwebhookswebhookIdResponse200",
    "GETwebhookswebhookIdResponse200Data",
    "GETwebhookswebhookIdResponse200DataAttributes",
    "GETwebhookswebhookIdResponse200DataAttributesMetadata",
    "GETwebhookswebhookIdResponse200DataLinks",
    "GETwebhookswebhookIdResponse200DataRelationships",
    "GETwebhookswebhookIdResponse200DataRelationshipsLastEventCallbacks",
    "GETwebhookswebhookIdResponse200DataRelationshipsLastEventCallbacksData",
    "GETwebhookswebhookIdResponse200DataRelationshipsLastEventCallbacksDataType",
    "GETwebhookswebhookIdResponse200DataRelationshipsLastEventCallbacksLinks",
    "GETwebhookswebhookIdResponse200DataType",
    "GETwireTransfersResponse200",
    "GETwireTransfersResponse200DataItem",
    "GETwireTransfersResponse200DataItemAttributes",
    "GETwireTransfersResponse200DataItemAttributesMetadata",
    "GETwireTransfersResponse200DataItemLinks",
    "GETwireTransfersResponse200DataItemRelationships",
    "GETwireTransfersResponse200DataItemRelationshipsOrder",
    "GETwireTransfersResponse200DataItemRelationshipsOrderData",
    "GETwireTransfersResponse200DataItemRelationshipsOrderDataType",
    "GETwireTransfersResponse200DataItemRelationshipsOrderLinks",
    "GETwireTransfersResponse200DataItemType",
    "GETwireTransferswireTransferIdResponse200",
    "GETwireTransferswireTransferIdResponse200Data",
    "GETwireTransferswireTransferIdResponse200DataAttributes",
    "GETwireTransferswireTransferIdResponse200DataAttributesMetadata",
    "GETwireTransferswireTransferIdResponse200DataLinks",
    "GETwireTransferswireTransferIdResponse200DataRelationships",
    "GETwireTransferswireTransferIdResponse200DataRelationshipsOrder",
    "GETwireTransferswireTransferIdResponse200DataRelationshipsOrderData",
    "GETwireTransferswireTransferIdResponse200DataRelationshipsOrderDataType",
    "GETwireTransferswireTransferIdResponse200DataRelationshipsOrderLinks",
    "GETwireTransferswireTransferIdResponse200DataType",
    "GiftCard",
    "GiftCardCreate",
    "GiftCardCreateData",
    "GiftCardCreateDataAttributes",
    "GiftCardCreateDataAttributesMetadata",
    "GiftCardCreateDataRelationships",
    "GiftCardCreateDataRelationshipsGiftCardRecipient",
    "GiftCardCreateDataRelationshipsGiftCardRecipientData",
    "GiftCardCreateDataRelationshipsGiftCardRecipientDataType",
    "GiftCardCreateDataRelationshipsMarket",
    "GiftCardCreateDataRelationshipsMarketData",
    "GiftCardCreateDataRelationshipsMarketDataType",
    "GiftCardCreateDataType",
    "GiftCardData",
    "GiftCardDataAttributes",
    "GiftCardDataAttributesBalanceLogItem",
    "GiftCardDataAttributesMetadata",
    "GiftCardDataRelationships",
    "GiftCardDataRelationshipsAttachments",
    "GiftCardDataRelationshipsAttachmentsData",
    "GiftCardDataRelationshipsAttachmentsDataType",
    "GiftCardDataRelationshipsEvents",
    "GiftCardDataRelationshipsEventsData",
    "GiftCardDataRelationshipsEventsDataType",
    "GiftCardDataRelationshipsGiftCardRecipient",
    "GiftCardDataRelationshipsGiftCardRecipientData",
    "GiftCardDataRelationshipsGiftCardRecipientDataType",
    "GiftCardDataRelationshipsMarket",
    "GiftCardDataRelationshipsMarketData",
    "GiftCardDataRelationshipsMarketDataType",
    "GiftCardDataType",
    "GiftCardRecipient",
    "GiftCardRecipientCreate",
    "GiftCardRecipientCreateData",
    "GiftCardRecipientCreateDataAttributes",
    "GiftCardRecipientCreateDataAttributesMetadata",
    "GiftCardRecipientCreateDataRelationships",
    "GiftCardRecipientCreateDataRelationshipsCustomer",
    "GiftCardRecipientCreateDataRelationshipsCustomerData",
    "GiftCardRecipientCreateDataRelationshipsCustomerDataType",
    "GiftCardRecipientCreateDataType",
    "GiftCardRecipientData",
    "GiftCardRecipientDataAttributes",
    "GiftCardRecipientDataAttributesMetadata",
    "GiftCardRecipientDataRelationships",
    "GiftCardRecipientDataRelationshipsAttachments",
    "GiftCardRecipientDataRelationshipsAttachmentsData",
    "GiftCardRecipientDataRelationshipsAttachmentsDataType",
    "GiftCardRecipientDataRelationshipsCustomer",
    "GiftCardRecipientDataRelationshipsCustomerData",
    "GiftCardRecipientDataRelationshipsCustomerDataType",
    "GiftCardRecipientDataType",
    "GiftCardRecipientUpdate",
    "GiftCardRecipientUpdateData",
    "GiftCardRecipientUpdateDataAttributes",
    "GiftCardRecipientUpdateDataAttributesMetadata",
    "GiftCardRecipientUpdateDataRelationships",
    "GiftCardRecipientUpdateDataRelationshipsCustomer",
    "GiftCardRecipientUpdateDataRelationshipsCustomerData",
    "GiftCardRecipientUpdateDataRelationshipsCustomerDataType",
    "GiftCardRecipientUpdateDataType",
    "GiftCardUpdate",
    "GiftCardUpdateData",
    "GiftCardUpdateDataAttributes",
    "GiftCardUpdateDataAttributesMetadata",
    "GiftCardUpdateDataRelationships",
    "GiftCardUpdateDataRelationshipsGiftCardRecipient",
    "GiftCardUpdateDataRelationshipsGiftCardRecipientData",
    "GiftCardUpdateDataRelationshipsGiftCardRecipientDataType",
    "GiftCardUpdateDataRelationshipsMarket",
    "GiftCardUpdateDataRelationshipsMarketData",
    "GiftCardUpdateDataRelationshipsMarketDataType",
    "GiftCardUpdateDataType",
    "GoogleGeocoder",
    "GoogleGeocoderCreate",
    "GoogleGeocoderCreateData",
    "GoogleGeocoderCreateDataAttributes",
    "GoogleGeocoderCreateDataAttributesMetadata",
    "GoogleGeocoderCreateDataRelationships",
    "GoogleGeocoderCreateDataType",
    "GoogleGeocoderData",
    "GoogleGeocoderDataAttributes",
    "GoogleGeocoderDataAttributesMetadata",
    "GoogleGeocoderDataRelationships",
    "GoogleGeocoderDataRelationshipsAddresses",
    "GoogleGeocoderDataRelationshipsAddressesData",
    "GoogleGeocoderDataRelationshipsAddressesDataType",
    "GoogleGeocoderDataRelationshipsAttachments",
    "GoogleGeocoderDataRelationshipsAttachmentsData",
    "GoogleGeocoderDataRelationshipsAttachmentsDataType",
    "GoogleGeocoderDataType",
    "GoogleGeocoderUpdate",
    "GoogleGeocoderUpdateData",
    "GoogleGeocoderUpdateDataAttributes",
    "GoogleGeocoderUpdateDataAttributesMetadata",
    "GoogleGeocoderUpdateDataRelationships",
    "GoogleGeocoderUpdateDataType",
    "Import",
    "ImportCreate",
    "ImportCreateData",
    "ImportCreateDataAttributes",
    "ImportCreateDataAttributesInputsItem",
    "ImportCreateDataAttributesMetadata",
    "ImportCreateDataRelationships",
    "ImportCreateDataType",
    "ImportData",
    "ImportDataAttributes",
    "ImportDataAttributesErrorsLog",
    "ImportDataAttributesInputsItem",
    "ImportDataAttributesMetadata",
    "ImportDataAttributesWarningsLog",
    "ImportDataRelationships",
    "ImportDataRelationshipsEvents",
    "ImportDataRelationshipsEventsData",
    "ImportDataRelationshipsEventsDataType",
    "ImportDataType",
    "InStockSubscription",
    "InStockSubscriptionCreate",
    "InStockSubscriptionCreateData",
    "InStockSubscriptionCreateDataAttributes",
    "InStockSubscriptionCreateDataAttributesMetadata",
    "InStockSubscriptionCreateDataRelationships",
    "InStockSubscriptionCreateDataRelationshipsCustomer",
    "InStockSubscriptionCreateDataRelationshipsCustomerData",
    "InStockSubscriptionCreateDataRelationshipsCustomerDataType",
    "InStockSubscriptionCreateDataRelationshipsMarket",
    "InStockSubscriptionCreateDataRelationshipsMarketData",
    "InStockSubscriptionCreateDataRelationshipsMarketDataType",
    "InStockSubscriptionCreateDataRelationshipsSku",
    "InStockSubscriptionCreateDataRelationshipsSkuData",
    "InStockSubscriptionCreateDataRelationshipsSkuDataType",
    "InStockSubscriptionCreateDataType",
    "InStockSubscriptionData",
    "InStockSubscriptionDataAttributes",
    "InStockSubscriptionDataAttributesMetadata",
    "InStockSubscriptionDataRelationships",
    "InStockSubscriptionDataRelationshipsCustomer",
    "InStockSubscriptionDataRelationshipsCustomerData",
    "InStockSubscriptionDataRelationshipsCustomerDataType",
    "InStockSubscriptionDataRelationshipsEvents",
    "InStockSubscriptionDataRelationshipsEventsData",
    "InStockSubscriptionDataRelationshipsEventsDataType",
    "InStockSubscriptionDataRelationshipsMarket",
    "InStockSubscriptionDataRelationshipsMarketData",
    "InStockSubscriptionDataRelationshipsMarketDataType",
    "InStockSubscriptionDataRelationshipsSku",
    "InStockSubscriptionDataRelationshipsSkuData",
    "InStockSubscriptionDataRelationshipsSkuDataType",
    "InStockSubscriptionDataType",
    "InStockSubscriptionUpdate",
    "InStockSubscriptionUpdateData",
    "InStockSubscriptionUpdateDataAttributes",
    "InStockSubscriptionUpdateDataAttributesMetadata",
    "InStockSubscriptionUpdateDataRelationships",
    "InStockSubscriptionUpdateDataRelationshipsCustomer",
    "InStockSubscriptionUpdateDataRelationshipsCustomerData",
    "InStockSubscriptionUpdateDataRelationshipsCustomerDataType",
    "InStockSubscriptionUpdateDataRelationshipsMarket",
    "InStockSubscriptionUpdateDataRelationshipsMarketData",
    "InStockSubscriptionUpdateDataRelationshipsMarketDataType",
    "InStockSubscriptionUpdateDataRelationshipsSku",
    "InStockSubscriptionUpdateDataRelationshipsSkuData",
    "InStockSubscriptionUpdateDataRelationshipsSkuDataType",
    "InStockSubscriptionUpdateDataType",
    "InventoryModel",
    "InventoryModelCreate",
    "InventoryModelCreateData",
    "InventoryModelCreateDataAttributes",
    "InventoryModelCreateDataAttributesMetadata",
    "InventoryModelCreateDataRelationships",
    "InventoryModelCreateDataType",
    "InventoryModelData",
    "InventoryModelDataAttributes",
    "InventoryModelDataAttributesMetadata",
    "InventoryModelDataRelationships",
    "InventoryModelDataRelationshipsAttachments",
    "InventoryModelDataRelationshipsAttachmentsData",
    "InventoryModelDataRelationshipsAttachmentsDataType",
    "InventoryModelDataRelationshipsInventoryReturnLocations",
    "InventoryModelDataRelationshipsInventoryReturnLocationsData",
    "InventoryModelDataRelationshipsInventoryReturnLocationsDataType",
    "InventoryModelDataRelationshipsInventoryStockLocations",
    "InventoryModelDataRelationshipsInventoryStockLocationsData",
    "InventoryModelDataRelationshipsInventoryStockLocationsDataType",
    "InventoryModelDataType",
    "InventoryModelUpdate",
    "InventoryModelUpdateData",
    "InventoryModelUpdateDataAttributes",
    "InventoryModelUpdateDataAttributesMetadata",
    "InventoryModelUpdateDataRelationships",
    "InventoryModelUpdateDataType",
    "InventoryReturnLocation",
    "InventoryReturnLocationCreate",
    "InventoryReturnLocationCreateData",
    "InventoryReturnLocationCreateDataAttributes",
    "InventoryReturnLocationCreateDataAttributesMetadata",
    "InventoryReturnLocationCreateDataRelationships",
    "InventoryReturnLocationCreateDataRelationshipsInventoryModel",
    "InventoryReturnLocationCreateDataRelationshipsInventoryModelData",
    "InventoryReturnLocationCreateDataRelationshipsInventoryModelDataType",
    "InventoryReturnLocationCreateDataRelationshipsStockLocation",
    "InventoryReturnLocationCreateDataRelationshipsStockLocationData",
    "InventoryReturnLocationCreateDataRelationshipsStockLocationDataType",
    "InventoryReturnLocationCreateDataType",
    "InventoryReturnLocationData",
    "InventoryReturnLocationDataAttributes",
    "InventoryReturnLocationDataAttributesMetadata",
    "InventoryReturnLocationDataRelationships",
    "InventoryReturnLocationDataRelationshipsInventoryModel",
    "InventoryReturnLocationDataRelationshipsInventoryModelData",
    "InventoryReturnLocationDataRelationshipsInventoryModelDataType",
    "InventoryReturnLocationDataRelationshipsStockLocation",
    "InventoryReturnLocationDataRelationshipsStockLocationData",
    "InventoryReturnLocationDataRelationshipsStockLocationDataType",
    "InventoryReturnLocationDataType",
    "InventoryReturnLocationUpdate",
    "InventoryReturnLocationUpdateData",
    "InventoryReturnLocationUpdateDataAttributes",
    "InventoryReturnLocationUpdateDataAttributesMetadata",
    "InventoryReturnLocationUpdateDataRelationships",
    "InventoryReturnLocationUpdateDataRelationshipsInventoryModel",
    "InventoryReturnLocationUpdateDataRelationshipsInventoryModelData",
    "InventoryReturnLocationUpdateDataRelationshipsInventoryModelDataType",
    "InventoryReturnLocationUpdateDataRelationshipsStockLocation",
    "InventoryReturnLocationUpdateDataRelationshipsStockLocationData",
    "InventoryReturnLocationUpdateDataRelationshipsStockLocationDataType",
    "InventoryReturnLocationUpdateDataType",
    "InventoryStockLocation",
    "InventoryStockLocationCreate",
    "InventoryStockLocationCreateData",
    "InventoryStockLocationCreateDataAttributes",
    "InventoryStockLocationCreateDataAttributesMetadata",
    "InventoryStockLocationCreateDataRelationships",
    "InventoryStockLocationCreateDataRelationshipsInventoryModel",
    "InventoryStockLocationCreateDataRelationshipsInventoryModelData",
    "InventoryStockLocationCreateDataRelationshipsInventoryModelDataType",
    "InventoryStockLocationCreateDataRelationshipsStockLocation",
    "InventoryStockLocationCreateDataRelationshipsStockLocationData",
    "InventoryStockLocationCreateDataRelationshipsStockLocationDataType",
    "InventoryStockLocationCreateDataType",
    "InventoryStockLocationData",
    "InventoryStockLocationDataAttributes",
    "InventoryStockLocationDataAttributesMetadata",
    "InventoryStockLocationDataRelationships",
    "InventoryStockLocationDataRelationshipsInventoryModel",
    "InventoryStockLocationDataRelationshipsInventoryModelData",
    "InventoryStockLocationDataRelationshipsInventoryModelDataType",
    "InventoryStockLocationDataRelationshipsStockLocation",
    "InventoryStockLocationDataRelationshipsStockLocationData",
    "InventoryStockLocationDataRelationshipsStockLocationDataType",
    "InventoryStockLocationDataType",
    "InventoryStockLocationUpdate",
    "InventoryStockLocationUpdateData",
    "InventoryStockLocationUpdateDataAttributes",
    "InventoryStockLocationUpdateDataAttributesMetadata",
    "InventoryStockLocationUpdateDataRelationships",
    "InventoryStockLocationUpdateDataRelationshipsInventoryModel",
    "InventoryStockLocationUpdateDataRelationshipsInventoryModelData",
    "InventoryStockLocationUpdateDataRelationshipsInventoryModelDataType",
    "InventoryStockLocationUpdateDataRelationshipsStockLocation",
    "InventoryStockLocationUpdateDataRelationshipsStockLocationData",
    "InventoryStockLocationUpdateDataRelationshipsStockLocationDataType",
    "InventoryStockLocationUpdateDataType",
    "KlarnaGateway",
    "KlarnaGatewayCreate",
    "KlarnaGatewayCreateData",
    "KlarnaGatewayCreateDataAttributes",
    "KlarnaGatewayCreateDataAttributesMetadata",
    "KlarnaGatewayCreateDataRelationships",
    "KlarnaGatewayCreateDataRelationshipsKlarnaPayments",
    "KlarnaGatewayCreateDataRelationshipsKlarnaPaymentsData",
    "KlarnaGatewayCreateDataRelationshipsKlarnaPaymentsDataType",
    "KlarnaGatewayCreateDataType",
    "KlarnaGatewayData",
    "KlarnaGatewayDataAttributes",
    "KlarnaGatewayDataAttributesMetadata",
    "KlarnaGatewayDataRelationships",
    "KlarnaGatewayDataRelationshipsKlarnaPayments",
    "KlarnaGatewayDataRelationshipsKlarnaPaymentsData",
    "KlarnaGatewayDataRelationshipsKlarnaPaymentsDataType",
    "KlarnaGatewayDataRelationshipsPaymentMethods",
    "KlarnaGatewayDataRelationshipsPaymentMethodsData",
    "KlarnaGatewayDataRelationshipsPaymentMethodsDataType",
    "KlarnaGatewayDataType",
    "KlarnaGatewayUpdate",
    "KlarnaGatewayUpdateData",
    "KlarnaGatewayUpdateDataAttributes",
    "KlarnaGatewayUpdateDataAttributesMetadata",
    "KlarnaGatewayUpdateDataRelationships",
    "KlarnaGatewayUpdateDataRelationshipsKlarnaPayments",
    "KlarnaGatewayUpdateDataRelationshipsKlarnaPaymentsData",
    "KlarnaGatewayUpdateDataRelationshipsKlarnaPaymentsDataType",
    "KlarnaGatewayUpdateDataType",
    "KlarnaPayment",
    "KlarnaPaymentCreate",
    "KlarnaPaymentCreateData",
    "KlarnaPaymentCreateDataAttributes",
    "KlarnaPaymentCreateDataAttributesMetadata",
    "KlarnaPaymentCreateDataRelationships",
    "KlarnaPaymentCreateDataRelationshipsOrder",
    "KlarnaPaymentCreateDataRelationshipsOrderData",
    "KlarnaPaymentCreateDataRelationshipsOrderDataType",
    "KlarnaPaymentCreateDataType",
    "KlarnaPaymentData",
    "KlarnaPaymentDataAttributes",
    "KlarnaPaymentDataAttributesMetadata",
    "KlarnaPaymentDataAttributesPaymentMethodsItem",
    "KlarnaPaymentDataRelationships",
    "KlarnaPaymentDataRelationshipsOrder",
    "KlarnaPaymentDataRelationshipsOrderData",
    "KlarnaPaymentDataRelationshipsOrderDataType",
    "KlarnaPaymentDataRelationshipsPaymentGateway",
    "KlarnaPaymentDataRelationshipsPaymentGatewayData",
    "KlarnaPaymentDataRelationshipsPaymentGatewayDataType",
    "KlarnaPaymentDataType",
    "KlarnaPaymentUpdate",
    "KlarnaPaymentUpdateData",
    "KlarnaPaymentUpdateDataAttributes",
    "KlarnaPaymentUpdateDataAttributesMetadata",
    "KlarnaPaymentUpdateDataRelationships",
    "KlarnaPaymentUpdateDataRelationshipsOrder",
    "KlarnaPaymentUpdateDataRelationshipsOrderData",
    "KlarnaPaymentUpdateDataRelationshipsOrderDataType",
    "KlarnaPaymentUpdateDataType",
    "LineItem",
    "LineItemCreate",
    "LineItemCreateData",
    "LineItemCreateDataAttributes",
    "LineItemCreateDataAttributesMetadata",
    "LineItemCreateDataRelationships",
    "LineItemCreateDataRelationshipsOrder",
    "LineItemCreateDataRelationshipsOrderData",
    "LineItemCreateDataRelationshipsOrderDataType",
    "LineItemCreateDataType",
    "LineItemData",
    "LineItemDataAttributes",
    "LineItemDataAttributesDiscountBreakdown",
    "LineItemDataAttributesMetadata",
    "LineItemDataAttributesTaxBreakdown",
    "LineItemDataRelationships",
    "LineItemDataRelationshipsLineItemOptions",
    "LineItemDataRelationshipsLineItemOptionsData",
    "LineItemDataRelationshipsLineItemOptionsDataType",
    "LineItemDataRelationshipsOrder",
    "LineItemDataRelationshipsOrderData",
    "LineItemDataRelationshipsOrderDataType",
    "LineItemDataRelationshipsShipmentLineItems",
    "LineItemDataRelationshipsShipmentLineItemsData",
    "LineItemDataRelationshipsShipmentLineItemsDataType",
    "LineItemDataRelationshipsStockLineItems",
    "LineItemDataRelationshipsStockLineItemsData",
    "LineItemDataRelationshipsStockLineItemsDataType",
    "LineItemDataRelationshipsStockTransfers",
    "LineItemDataRelationshipsStockTransfersData",
    "LineItemDataRelationshipsStockTransfersDataType",
    "LineItemDataType",
    "LineItemOption",
    "LineItemOptionCreate",
    "LineItemOptionCreateData",
    "LineItemOptionCreateDataAttributes",
    "LineItemOptionCreateDataAttributesMetadata",
    "LineItemOptionCreateDataAttributesOptions",
    "LineItemOptionCreateDataRelationships",
    "LineItemOptionCreateDataRelationshipsLineItem",
    "LineItemOptionCreateDataRelationshipsLineItemData",
    "LineItemOptionCreateDataRelationshipsLineItemDataType",
    "LineItemOptionCreateDataRelationshipsSkuOption",
    "LineItemOptionCreateDataRelationshipsSkuOptionData",
    "LineItemOptionCreateDataRelationshipsSkuOptionDataType",
    "LineItemOptionCreateDataType",
    "LineItemOptionData",
    "LineItemOptionDataAttributes",
    "LineItemOptionDataAttributesMetadata",
    "LineItemOptionDataAttributesOptions",
    "LineItemOptionDataRelationships",
    "LineItemOptionDataRelationshipsLineItem",
    "LineItemOptionDataRelationshipsLineItemData",
    "LineItemOptionDataRelationshipsLineItemDataType",
    "LineItemOptionDataRelationshipsSkuOption",
    "LineItemOptionDataRelationshipsSkuOptionData",
    "LineItemOptionDataRelationshipsSkuOptionDataType",
    "LineItemOptionDataType",
    "LineItemOptionUpdate",
    "LineItemOptionUpdateData",
    "LineItemOptionUpdateDataAttributes",
    "LineItemOptionUpdateDataAttributesMetadata",
    "LineItemOptionUpdateDataAttributesOptions",
    "LineItemOptionUpdateDataRelationships",
    "LineItemOptionUpdateDataRelationshipsSkuOption",
    "LineItemOptionUpdateDataRelationshipsSkuOptionData",
    "LineItemOptionUpdateDataRelationshipsSkuOptionDataType",
    "LineItemOptionUpdateDataType",
    "LineItemUpdate",
    "LineItemUpdateData",
    "LineItemUpdateDataAttributes",
    "LineItemUpdateDataAttributesMetadata",
    "LineItemUpdateDataRelationships",
    "LineItemUpdateDataType",
    "ManualGateway",
    "ManualGatewayCreate",
    "ManualGatewayCreateData",
    "ManualGatewayCreateDataAttributes",
    "ManualGatewayCreateDataAttributesMetadata",
    "ManualGatewayCreateDataRelationships",
    "ManualGatewayCreateDataType",
    "ManualGatewayData",
    "ManualGatewayDataAttributes",
    "ManualGatewayDataAttributesMetadata",
    "ManualGatewayDataRelationships",
    "ManualGatewayDataRelationshipsPaymentMethods",
    "ManualGatewayDataRelationshipsPaymentMethodsData",
    "ManualGatewayDataRelationshipsPaymentMethodsDataType",
    "ManualGatewayDataType",
    "ManualGatewayUpdate",
    "ManualGatewayUpdateData",
    "ManualGatewayUpdateDataAttributes",
    "ManualGatewayUpdateDataAttributesMetadata",
    "ManualGatewayUpdateDataRelationships",
    "ManualGatewayUpdateDataType",
    "ManualTaxCalculator",
    "ManualTaxCalculatorCreate",
    "ManualTaxCalculatorCreateData",
    "ManualTaxCalculatorCreateDataAttributes",
    "ManualTaxCalculatorCreateDataAttributesMetadata",
    "ManualTaxCalculatorCreateDataRelationships",
    "ManualTaxCalculatorCreateDataRelationshipsTaxRules",
    "ManualTaxCalculatorCreateDataRelationshipsTaxRulesData",
    "ManualTaxCalculatorCreateDataRelationshipsTaxRulesDataType",
    "ManualTaxCalculatorCreateDataType",
    "ManualTaxCalculatorData",
    "ManualTaxCalculatorDataAttributes",
    "ManualTaxCalculatorDataAttributesMetadata",
    "ManualTaxCalculatorDataRelationships",
    "ManualTaxCalculatorDataRelationshipsAttachments",
    "ManualTaxCalculatorDataRelationshipsAttachmentsData",
    "ManualTaxCalculatorDataRelationshipsAttachmentsDataType",
    "ManualTaxCalculatorDataRelationshipsMarkets",
    "ManualTaxCalculatorDataRelationshipsMarketsData",
    "ManualTaxCalculatorDataRelationshipsMarketsDataType",
    "ManualTaxCalculatorDataRelationshipsTaxRules",
    "ManualTaxCalculatorDataRelationshipsTaxRulesData",
    "ManualTaxCalculatorDataRelationshipsTaxRulesDataType",
    "ManualTaxCalculatorDataType",
    "ManualTaxCalculatorUpdate",
    "ManualTaxCalculatorUpdateData",
    "ManualTaxCalculatorUpdateDataAttributes",
    "ManualTaxCalculatorUpdateDataAttributesMetadata",
    "ManualTaxCalculatorUpdateDataRelationships",
    "ManualTaxCalculatorUpdateDataRelationshipsTaxRules",
    "ManualTaxCalculatorUpdateDataRelationshipsTaxRulesData",
    "ManualTaxCalculatorUpdateDataRelationshipsTaxRulesDataType",
    "ManualTaxCalculatorUpdateDataType",
    "Market",
    "MarketCreate",
    "MarketCreateData",
    "MarketCreateDataAttributes",
    "MarketCreateDataAttributesMetadata",
    "MarketCreateDataRelationships",
    "MarketCreateDataRelationshipsCustomerGroup",
    "MarketCreateDataRelationshipsCustomerGroupData",
    "MarketCreateDataRelationshipsCustomerGroupDataType",
    "MarketCreateDataRelationshipsInventoryModel",
    "MarketCreateDataRelationshipsInventoryModelData",
    "MarketCreateDataRelationshipsInventoryModelDataType",
    "MarketCreateDataRelationshipsMerchant",
    "MarketCreateDataRelationshipsMerchantData",
    "MarketCreateDataRelationshipsMerchantDataType",
    "MarketCreateDataRelationshipsPriceList",
    "MarketCreateDataRelationshipsPriceListData",
    "MarketCreateDataRelationshipsPriceListDataType",
    "MarketCreateDataRelationshipsTaxCalculator",
    "MarketCreateDataRelationshipsTaxCalculatorData",
    "MarketCreateDataRelationshipsTaxCalculatorDataType",
    "MarketCreateDataType",
    "MarketData",
    "MarketDataAttributes",
    "MarketDataAttributesMetadata",
    "MarketDataRelationships",
    "MarketDataRelationshipsAttachments",
    "MarketDataRelationshipsAttachmentsData",
    "MarketDataRelationshipsAttachmentsDataType",
    "MarketDataRelationshipsCustomerGroup",
    "MarketDataRelationshipsCustomerGroupData",
    "MarketDataRelationshipsCustomerGroupDataType",
    "MarketDataRelationshipsInventoryModel",
    "MarketDataRelationshipsInventoryModelData",
    "MarketDataRelationshipsInventoryModelDataType",
    "MarketDataRelationshipsMerchant",
    "MarketDataRelationshipsMerchantData",
    "MarketDataRelationshipsMerchantDataType",
    "MarketDataRelationshipsPriceList",
    "MarketDataRelationshipsPriceListData",
    "MarketDataRelationshipsPriceListDataType",
    "MarketDataRelationshipsTaxCalculator",
    "MarketDataRelationshipsTaxCalculatorData",
    "MarketDataRelationshipsTaxCalculatorDataType",
    "MarketDataType",
    "MarketUpdate",
    "MarketUpdateData",
    "MarketUpdateDataAttributes",
    "MarketUpdateDataAttributesMetadata",
    "MarketUpdateDataRelationships",
    "MarketUpdateDataRelationshipsCustomerGroup",
    "MarketUpdateDataRelationshipsCustomerGroupData",
    "MarketUpdateDataRelationshipsCustomerGroupDataType",
    "MarketUpdateDataRelationshipsInventoryModel",
    "MarketUpdateDataRelationshipsInventoryModelData",
    "MarketUpdateDataRelationshipsInventoryModelDataType",
    "MarketUpdateDataRelationshipsMerchant",
    "MarketUpdateDataRelationshipsMerchantData",
    "MarketUpdateDataRelationshipsMerchantDataType",
    "MarketUpdateDataRelationshipsPriceList",
    "MarketUpdateDataRelationshipsPriceListData",
    "MarketUpdateDataRelationshipsPriceListDataType",
    "MarketUpdateDataRelationshipsTaxCalculator",
    "MarketUpdateDataRelationshipsTaxCalculatorData",
    "MarketUpdateDataRelationshipsTaxCalculatorDataType",
    "MarketUpdateDataType",
    "Merchant",
    "MerchantCreate",
    "MerchantCreateData",
    "MerchantCreateDataAttributes",
    "MerchantCreateDataAttributesMetadata",
    "MerchantCreateDataRelationships",
    "MerchantCreateDataRelationshipsAddress",
    "MerchantCreateDataRelationshipsAddressData",
    "MerchantCreateDataRelationshipsAddressDataType",
    "MerchantCreateDataType",
    "MerchantData",
    "MerchantDataAttributes",
    "MerchantDataAttributesMetadata",
    "MerchantDataRelationships",
    "MerchantDataRelationshipsAddress",
    "MerchantDataRelationshipsAddressData",
    "MerchantDataRelationshipsAddressDataType",
    "MerchantDataRelationshipsAttachments",
    "MerchantDataRelationshipsAttachmentsData",
    "MerchantDataRelationshipsAttachmentsDataType",
    "MerchantDataType",
    "MerchantUpdate",
    "MerchantUpdateData",
    "MerchantUpdateDataAttributes",
    "MerchantUpdateDataAttributesMetadata",
    "MerchantUpdateDataRelationships",
    "MerchantUpdateDataRelationshipsAddress",
    "MerchantUpdateDataRelationshipsAddressData",
    "MerchantUpdateDataRelationshipsAddressDataType",
    "MerchantUpdateDataType",
    "Order",
    "OrderAmountPromotionRule",
    "OrderAmountPromotionRuleCreate",
    "OrderAmountPromotionRuleCreateData",
    "OrderAmountPromotionRuleCreateDataAttributes",
    "OrderAmountPromotionRuleCreateDataAttributesMetadata",
    "OrderAmountPromotionRuleCreateDataRelationships",
    "OrderAmountPromotionRuleCreateDataType",
    "OrderAmountPromotionRuleData",
    "OrderAmountPromotionRuleDataAttributes",
    "OrderAmountPromotionRuleDataAttributesMetadata",
    "OrderAmountPromotionRuleDataRelationships",
    "OrderAmountPromotionRuleDataType",
    "OrderAmountPromotionRuleUpdate",
    "OrderAmountPromotionRuleUpdateData",
    "OrderAmountPromotionRuleUpdateDataAttributes",
    "OrderAmountPromotionRuleUpdateDataAttributesMetadata",
    "OrderAmountPromotionRuleUpdateDataRelationships",
    "OrderAmountPromotionRuleUpdateDataType",
    "OrderCopy",
    "OrderCopyCreate",
    "OrderCopyCreateData",
    "OrderCopyCreateDataAttributes",
    "OrderCopyCreateDataAttributesMetadata",
    "OrderCopyCreateDataRelationships",
    "OrderCopyCreateDataRelationshipsSourceOrder",
    "OrderCopyCreateDataRelationshipsSourceOrderData",
    "OrderCopyCreateDataRelationshipsSourceOrderDataType",
    "OrderCopyCreateDataType",
    "OrderCopyData",
    "OrderCopyDataAttributes",
    "OrderCopyDataAttributesErrorsLog",
    "OrderCopyDataAttributesMetadata",
    "OrderCopyDataRelationships",
    "OrderCopyDataRelationshipsEvents",
    "OrderCopyDataRelationshipsEventsData",
    "OrderCopyDataRelationshipsEventsDataType",
    "OrderCopyDataRelationshipsOrderSubscription",
    "OrderCopyDataRelationshipsOrderSubscriptionData",
    "OrderCopyDataRelationshipsOrderSubscriptionDataType",
    "OrderCopyDataRelationshipsSourceOrder",
    "OrderCopyDataRelationshipsSourceOrderData",
    "OrderCopyDataRelationshipsSourceOrderDataType",
    "OrderCopyDataRelationshipsTargetOrder",
    "OrderCopyDataRelationshipsTargetOrderData",
    "OrderCopyDataRelationshipsTargetOrderDataType",
    "OrderCopyDataType",
    "OrderCreate",
    "OrderCreateData",
    "OrderCreateDataAttributes",
    "OrderCreateDataAttributesMetadata",
    "OrderCreateDataRelationships",
    "OrderCreateDataRelationshipsBillingAddress",
    "OrderCreateDataRelationshipsBillingAddressData",
    "OrderCreateDataRelationshipsBillingAddressDataType",
    "OrderCreateDataRelationshipsCustomer",
    "OrderCreateDataRelationshipsCustomerData",
    "OrderCreateDataRelationshipsCustomerDataType",
    "OrderCreateDataRelationshipsMarket",
    "OrderCreateDataRelationshipsMarketData",
    "OrderCreateDataRelationshipsMarketDataType",
    "OrderCreateDataRelationshipsPaymentMethod",
    "OrderCreateDataRelationshipsPaymentMethodData",
    "OrderCreateDataRelationshipsPaymentMethodDataType",
    "OrderCreateDataRelationshipsShippingAddress",
    "OrderCreateDataRelationshipsShippingAddressData",
    "OrderCreateDataRelationshipsShippingAddressDataType",
    "OrderCreateDataType",
    "OrderData",
    "OrderDataAttributes",
    "OrderDataAttributesMetadata",
    "OrderDataAttributesPaymentSourceDetails",
    "OrderDataRelationships",
    "OrderDataRelationshipsAttachments",
    "OrderDataRelationshipsAttachmentsData",
    "OrderDataRelationshipsAttachmentsDataType",
    "OrderDataRelationshipsAuthorizations",
    "OrderDataRelationshipsAuthorizationsData",
    "OrderDataRelationshipsAuthorizationsDataType",
    "OrderDataRelationshipsAvailableCustomerPaymentSources",
    "OrderDataRelationshipsAvailableCustomerPaymentSourcesData",
    "OrderDataRelationshipsAvailableCustomerPaymentSourcesDataType",
    "OrderDataRelationshipsAvailableFreeBundles",
    "OrderDataRelationshipsAvailableFreeBundlesData",
    "OrderDataRelationshipsAvailableFreeBundlesDataType",
    "OrderDataRelationshipsAvailableFreeSkus",
    "OrderDataRelationshipsAvailableFreeSkusData",
    "OrderDataRelationshipsAvailableFreeSkusDataType",
    "OrderDataRelationshipsAvailablePaymentMethods",
    "OrderDataRelationshipsAvailablePaymentMethodsData",
    "OrderDataRelationshipsAvailablePaymentMethodsDataType",
    "OrderDataRelationshipsBillingAddress",
    "OrderDataRelationshipsBillingAddressData",
    "OrderDataRelationshipsBillingAddressDataType",
    "OrderDataRelationshipsCaptures",
    "OrderDataRelationshipsCapturesData",
    "OrderDataRelationshipsCapturesDataType",
    "OrderDataRelationshipsCustomer",
    "OrderDataRelationshipsCustomerData",
    "OrderDataRelationshipsCustomerDataType",
    "OrderDataRelationshipsEvents",
    "OrderDataRelationshipsEventsData",
    "OrderDataRelationshipsEventsDataType",
    "OrderDataRelationshipsLineItems",
    "OrderDataRelationshipsLineItemsData",
    "OrderDataRelationshipsLineItemsDataType",
    "OrderDataRelationshipsMarket",
    "OrderDataRelationshipsMarketData",
    "OrderDataRelationshipsMarketDataType",
    "OrderDataRelationshipsOrderCopies",
    "OrderDataRelationshipsOrderCopiesData",
    "OrderDataRelationshipsOrderCopiesDataType",
    "OrderDataRelationshipsOrderSubscriptions",
    "OrderDataRelationshipsOrderSubscriptionsData",
    "OrderDataRelationshipsOrderSubscriptionsDataType",
    "OrderDataRelationshipsPaymentMethod",
    "OrderDataRelationshipsPaymentMethodData",
    "OrderDataRelationshipsPaymentMethodDataType",
    "OrderDataRelationshipsRefunds",
    "OrderDataRelationshipsRefundsData",
    "OrderDataRelationshipsRefundsDataType",
    "OrderDataRelationshipsShipments",
    "OrderDataRelationshipsShipmentsData",
    "OrderDataRelationshipsShipmentsDataType",
    "OrderDataRelationshipsShippingAddress",
    "OrderDataRelationshipsShippingAddressData",
    "OrderDataRelationshipsShippingAddressDataType",
    "OrderDataRelationshipsVoids",
    "OrderDataRelationshipsVoidsData",
    "OrderDataRelationshipsVoidsDataType",
    "OrderDataType",
    "OrderSubscription",
    "OrderSubscriptionCreate",
    "OrderSubscriptionCreateData",
    "OrderSubscriptionCreateDataAttributes",
    "OrderSubscriptionCreateDataAttributesMetadata",
    "OrderSubscriptionCreateDataAttributesOptions",
    "OrderSubscriptionCreateDataRelationships",
    "OrderSubscriptionCreateDataRelationshipsMarket",
    "OrderSubscriptionCreateDataRelationshipsMarketData",
    "OrderSubscriptionCreateDataRelationshipsMarketDataType",
    "OrderSubscriptionCreateDataRelationshipsSourceOrder",
    "OrderSubscriptionCreateDataRelationshipsSourceOrderData",
    "OrderSubscriptionCreateDataRelationshipsSourceOrderDataType",
    "OrderSubscriptionCreateDataType",
    "OrderSubscriptionData",
    "OrderSubscriptionDataAttributes",
    "OrderSubscriptionDataAttributesMetadata",
    "OrderSubscriptionDataAttributesOptions",
    "OrderSubscriptionDataRelationships",
    "OrderSubscriptionDataRelationshipsCustomer",
    "OrderSubscriptionDataRelationshipsCustomerData",
    "OrderSubscriptionDataRelationshipsCustomerDataType",
    "OrderSubscriptionDataRelationshipsEvents",
    "OrderSubscriptionDataRelationshipsEventsData",
    "OrderSubscriptionDataRelationshipsEventsDataType",
    "OrderSubscriptionDataRelationshipsMarket",
    "OrderSubscriptionDataRelationshipsMarketData",
    "OrderSubscriptionDataRelationshipsMarketDataType",
    "OrderSubscriptionDataRelationshipsOrderCopies",
    "OrderSubscriptionDataRelationshipsOrderCopiesData",
    "OrderSubscriptionDataRelationshipsOrderCopiesDataType",
    "OrderSubscriptionDataRelationshipsOrders",
    "OrderSubscriptionDataRelationshipsOrdersData",
    "OrderSubscriptionDataRelationshipsOrdersDataType",
    "OrderSubscriptionDataRelationshipsSourceOrder",
    "OrderSubscriptionDataRelationshipsSourceOrderData",
    "OrderSubscriptionDataRelationshipsSourceOrderDataType",
    "OrderSubscriptionDataType",
    "OrderSubscriptionUpdate",
    "OrderSubscriptionUpdateData",
    "OrderSubscriptionUpdateDataAttributes",
    "OrderSubscriptionUpdateDataAttributesMetadata",
    "OrderSubscriptionUpdateDataRelationships",
    "OrderSubscriptionUpdateDataType",
    "OrderUpdate",
    "OrderUpdateData",
    "OrderUpdateDataAttributes",
    "OrderUpdateDataAttributesMetadata",
    "OrderUpdateDataRelationships",
    "OrderUpdateDataRelationshipsBillingAddress",
    "OrderUpdateDataRelationshipsBillingAddressData",
    "OrderUpdateDataRelationshipsBillingAddressDataType",
    "OrderUpdateDataRelationshipsCustomer",
    "OrderUpdateDataRelationshipsCustomerData",
    "OrderUpdateDataRelationshipsCustomerDataType",
    "OrderUpdateDataRelationshipsMarket",
    "OrderUpdateDataRelationshipsMarketData",
    "OrderUpdateDataRelationshipsMarketDataType",
    "OrderUpdateDataRelationshipsPaymentMethod",
    "OrderUpdateDataRelationshipsPaymentMethodData",
    "OrderUpdateDataRelationshipsPaymentMethodDataType",
    "OrderUpdateDataRelationshipsShippingAddress",
    "OrderUpdateDataRelationshipsShippingAddressData",
    "OrderUpdateDataRelationshipsShippingAddressDataType",
    "OrderUpdateDataType",
    "OrderValidationRule",
    "OrderValidationRuleData",
    "OrderValidationRuleDataAttributes",
    "OrderValidationRuleDataAttributesMetadata",
    "OrderValidationRuleDataRelationships",
    "OrderValidationRuleDataRelationshipsMarket",
    "OrderValidationRuleDataRelationshipsMarketData",
    "OrderValidationRuleDataRelationshipsMarketDataType",
    "OrderValidationRuleDataType",
    "Organization",
    "OrganizationData",
    "OrganizationDataAttributes",
    "OrganizationDataAttributesMetadata",
    "OrganizationDataRelationships",
    "OrganizationDataType",
    "Package",
    "PackageCreate",
    "PackageCreateData",
    "PackageCreateDataAttributes",
    "PackageCreateDataAttributesMetadata",
    "PackageCreateDataRelationships",
    "PackageCreateDataRelationshipsStockLocation",
    "PackageCreateDataRelationshipsStockLocationData",
    "PackageCreateDataRelationshipsStockLocationDataType",
    "PackageCreateDataType",
    "PackageData",
    "PackageDataAttributes",
    "PackageDataAttributesMetadata",
    "PackageDataRelationships",
    "PackageDataRelationshipsAttachments",
    "PackageDataRelationshipsAttachmentsData",
    "PackageDataRelationshipsAttachmentsDataType",
    "PackageDataRelationshipsParcels",
    "PackageDataRelationshipsParcelsData",
    "PackageDataRelationshipsParcelsDataType",
    "PackageDataRelationshipsStockLocation",
    "PackageDataRelationshipsStockLocationData",
    "PackageDataRelationshipsStockLocationDataType",
    "PackageDataType",
    "PackageUpdate",
    "PackageUpdateData",
    "PackageUpdateDataAttributes",
    "PackageUpdateDataAttributesMetadata",
    "PackageUpdateDataRelationships",
    "PackageUpdateDataRelationshipsStockLocation",
    "PackageUpdateDataRelationshipsStockLocationData",
    "PackageUpdateDataRelationshipsStockLocationDataType",
    "PackageUpdateDataType",
    "Parcel",
    "ParcelCreate",
    "ParcelCreateData",
    "ParcelCreateDataAttributes",
    "ParcelCreateDataAttributesMetadata",
    "ParcelCreateDataRelationships",
    "ParcelCreateDataRelationshipsPackage",
    "ParcelCreateDataRelationshipsPackageData",
    "ParcelCreateDataRelationshipsPackageDataType",
    "ParcelCreateDataRelationshipsShipment",
    "ParcelCreateDataRelationshipsShipmentData",
    "ParcelCreateDataRelationshipsShipmentDataType",
    "ParcelCreateDataType",
    "ParcelData",
    "ParcelDataAttributes",
    "ParcelDataAttributesMetadata",
    "ParcelDataRelationships",
    "ParcelDataRelationshipsAttachments",
    "ParcelDataRelationshipsAttachmentsData",
    "ParcelDataRelationshipsAttachmentsDataType",
    "ParcelDataRelationshipsEvents",
    "ParcelDataRelationshipsEventsData",
    "ParcelDataRelationshipsEventsDataType",
    "ParcelDataRelationshipsPackage",
    "ParcelDataRelationshipsPackageData",
    "ParcelDataRelationshipsPackageDataType",
    "ParcelDataRelationshipsParcelLineItems",
    "ParcelDataRelationshipsParcelLineItemsData",
    "ParcelDataRelationshipsParcelLineItemsDataType",
    "ParcelDataRelationshipsShipment",
    "ParcelDataRelationshipsShipmentData",
    "ParcelDataRelationshipsShipmentDataType",
    "ParcelDataType",
    "ParcelLineItem",
    "ParcelLineItemCreate",
    "ParcelLineItemCreateData",
    "ParcelLineItemCreateDataAttributes",
    "ParcelLineItemCreateDataAttributesMetadata",
    "ParcelLineItemCreateDataRelationships",
    "ParcelLineItemCreateDataRelationshipsParcel",
    "ParcelLineItemCreateDataRelationshipsParcelData",
    "ParcelLineItemCreateDataRelationshipsParcelDataType",
    "ParcelLineItemCreateDataRelationshipsShipmentLineItem",
    "ParcelLineItemCreateDataRelationshipsShipmentLineItemData",
    "ParcelLineItemCreateDataRelationshipsShipmentLineItemDataType",
    "ParcelLineItemCreateDataRelationshipsStockLineItem",
    "ParcelLineItemCreateDataRelationshipsStockLineItemData",
    "ParcelLineItemCreateDataRelationshipsStockLineItemDataType",
    "ParcelLineItemCreateDataType",
    "ParcelLineItemData",
    "ParcelLineItemDataAttributes",
    "ParcelLineItemDataAttributesMetadata",
    "ParcelLineItemDataRelationships",
    "ParcelLineItemDataRelationshipsParcel",
    "ParcelLineItemDataRelationshipsParcelData",
    "ParcelLineItemDataRelationshipsParcelDataType",
    "ParcelLineItemDataRelationshipsShipmentLineItem",
    "ParcelLineItemDataRelationshipsShipmentLineItemData",
    "ParcelLineItemDataRelationshipsShipmentLineItemDataType",
    "ParcelLineItemDataRelationshipsStockLineItem",
    "ParcelLineItemDataRelationshipsStockLineItemData",
    "ParcelLineItemDataRelationshipsStockLineItemDataType",
    "ParcelLineItemDataType",
    "ParcelLineItemUpdate",
    "ParcelLineItemUpdateData",
    "ParcelLineItemUpdateDataAttributes",
    "ParcelLineItemUpdateDataAttributesMetadata",
    "ParcelLineItemUpdateDataRelationships",
    "ParcelLineItemUpdateDataType",
    "ParcelUpdate",
    "ParcelUpdateData",
    "ParcelUpdateDataAttributes",
    "ParcelUpdateDataAttributesMetadata",
    "ParcelUpdateDataRelationships",
    "ParcelUpdateDataRelationshipsPackage",
    "ParcelUpdateDataRelationshipsPackageData",
    "ParcelUpdateDataRelationshipsPackageDataType",
    "ParcelUpdateDataRelationshipsShipment",
    "ParcelUpdateDataRelationshipsShipmentData",
    "ParcelUpdateDataRelationshipsShipmentDataType",
    "ParcelUpdateDataType",
    "PATCHaddressesaddressIdResponse200",
    "PATCHaddressesaddressIdResponse200Data",
    "PATCHaddressesaddressIdResponse200DataAttributes",
    "PATCHaddressesaddressIdResponse200DataAttributesMetadata",
    "PATCHaddressesaddressIdResponse200DataLinks",
    "PATCHaddressesaddressIdResponse200DataRelationships",
    "PATCHaddressesaddressIdResponse200DataRelationshipsGeocoder",
    "PATCHaddressesaddressIdResponse200DataRelationshipsGeocoderData",
    "PATCHaddressesaddressIdResponse200DataRelationshipsGeocoderDataType",
    "PATCHaddressesaddressIdResponse200DataRelationshipsGeocoderLinks",
    "PATCHaddressesaddressIdResponse200DataType",
    "PATCHadjustmentsadjustmentIdResponse200",
    "PATCHadjustmentsadjustmentIdResponse200Data",
    "PATCHadjustmentsadjustmentIdResponse200DataAttributes",
    "PATCHadjustmentsadjustmentIdResponse200DataAttributesMetadata",
    "PATCHadjustmentsadjustmentIdResponse200DataLinks",
    "PATCHadjustmentsadjustmentIdResponse200DataRelationships",
    "PATCHadjustmentsadjustmentIdResponse200DataType",
    "PATCHadyenGatewaysadyenGatewayIdResponse200",
    "PATCHadyenGatewaysadyenGatewayIdResponse200Data",
    "PATCHadyenGatewaysadyenGatewayIdResponse200DataAttributes",
    "PATCHadyenGatewaysadyenGatewayIdResponse200DataAttributesMetadata",
    "PATCHadyenGatewaysadyenGatewayIdResponse200DataLinks",
    "PATCHadyenGatewaysadyenGatewayIdResponse200DataRelationships",
    "PATCHadyenGatewaysadyenGatewayIdResponse200DataRelationshipsAdyenPayments",
    "PATCHadyenGatewaysadyenGatewayIdResponse200DataRelationshipsAdyenPaymentsData",
    "PATCHadyenGatewaysadyenGatewayIdResponse200DataRelationshipsAdyenPaymentsDataType",
    "PATCHadyenGatewaysadyenGatewayIdResponse200DataRelationshipsAdyenPaymentsLinks",
    "PATCHadyenGatewaysadyenGatewayIdResponse200DataRelationshipsPaymentMethods",
    "PATCHadyenGatewaysadyenGatewayIdResponse200DataRelationshipsPaymentMethodsData",
    "PATCHadyenGatewaysadyenGatewayIdResponse200DataRelationshipsPaymentMethodsDataType",
    "PATCHadyenGatewaysadyenGatewayIdResponse200DataRelationshipsPaymentMethodsLinks",
    "PATCHadyenGatewaysadyenGatewayIdResponse200DataType",
    "PATCHadyenPaymentsadyenPaymentIdResponse200",
    "PATCHadyenPaymentsadyenPaymentIdResponse200Data",
    "PATCHadyenPaymentsadyenPaymentIdResponse200DataAttributes",
    "PATCHadyenPaymentsadyenPaymentIdResponse200DataAttributesMetadata",
    "PATCHadyenPaymentsadyenPaymentIdResponse200DataAttributesPaymentRequestData",
    "PATCHadyenPaymentsadyenPaymentIdResponse200DataAttributesPaymentRequestDetails",
    "PATCHadyenPaymentsadyenPaymentIdResponse200DataAttributesPaymentResponse",
    "PATCHadyenPaymentsadyenPaymentIdResponse200DataLinks",
    "PATCHadyenPaymentsadyenPaymentIdResponse200DataRelationships",
    "PATCHadyenPaymentsadyenPaymentIdResponse200DataRelationshipsOrder",
    "PATCHadyenPaymentsadyenPaymentIdResponse200DataRelationshipsOrderData",
    "PATCHadyenPaymentsadyenPaymentIdResponse200DataRelationshipsOrderDataType",
    "PATCHadyenPaymentsadyenPaymentIdResponse200DataRelationshipsOrderLinks",
    "PATCHadyenPaymentsadyenPaymentIdResponse200DataRelationshipsPaymentGateway",
    "PATCHadyenPaymentsadyenPaymentIdResponse200DataRelationshipsPaymentGatewayData",
    "PATCHadyenPaymentsadyenPaymentIdResponse200DataRelationshipsPaymentGatewayDataType",
    "PATCHadyenPaymentsadyenPaymentIdResponse200DataRelationshipsPaymentGatewayLinks",
    "PATCHadyenPaymentsadyenPaymentIdResponse200DataType",
    "PATCHattachmentsattachmentIdResponse200",
    "PATCHattachmentsattachmentIdResponse200Data",
    "PATCHattachmentsattachmentIdResponse200DataAttributes",
    "PATCHattachmentsattachmentIdResponse200DataAttributesMetadata",
    "PATCHattachmentsattachmentIdResponse200DataLinks",
    "PATCHattachmentsattachmentIdResponse200DataRelationships",
    "PATCHattachmentsattachmentIdResponse200DataRelationshipsAttachable",
    "PATCHattachmentsattachmentIdResponse200DataRelationshipsAttachableData",
    "PATCHattachmentsattachmentIdResponse200DataRelationshipsAttachableDataType",
    "PATCHattachmentsattachmentIdResponse200DataRelationshipsAttachableLinks",
    "PATCHattachmentsattachmentIdResponse200DataType",
    "PATCHauthorizationsauthorizationIdResponse200",
    "PATCHauthorizationsauthorizationIdResponse200Data",
    "PATCHauthorizationsauthorizationIdResponse200DataAttributes",
    "PATCHauthorizationsauthorizationIdResponse200DataAttributesMetadata",
    "PATCHauthorizationsauthorizationIdResponse200DataLinks",
    "PATCHauthorizationsauthorizationIdResponse200DataRelationships",
    "PATCHauthorizationsauthorizationIdResponse200DataRelationshipsCaptures",
    "PATCHauthorizationsauthorizationIdResponse200DataRelationshipsCapturesData",
    "PATCHauthorizationsauthorizationIdResponse200DataRelationshipsCapturesDataType",
    "PATCHauthorizationsauthorizationIdResponse200DataRelationshipsCapturesLinks",
    "PATCHauthorizationsauthorizationIdResponse200DataRelationshipsOrder",
    "PATCHauthorizationsauthorizationIdResponse200DataRelationshipsOrderData",
    "PATCHauthorizationsauthorizationIdResponse200DataRelationshipsOrderDataType",
    "PATCHauthorizationsauthorizationIdResponse200DataRelationshipsOrderLinks",
    "PATCHauthorizationsauthorizationIdResponse200DataRelationshipsVoids",
    "PATCHauthorizationsauthorizationIdResponse200DataRelationshipsVoidsData",
    "PATCHauthorizationsauthorizationIdResponse200DataRelationshipsVoidsDataType",
    "PATCHauthorizationsauthorizationIdResponse200DataRelationshipsVoidsLinks",
    "PATCHauthorizationsauthorizationIdResponse200DataType",
    "PATCHavalaraAccountsavalaraAccountIdResponse200",
    "PATCHavalaraAccountsavalaraAccountIdResponse200Data",
    "PATCHavalaraAccountsavalaraAccountIdResponse200DataAttributes",
    "PATCHavalaraAccountsavalaraAccountIdResponse200DataAttributesMetadata",
    "PATCHavalaraAccountsavalaraAccountIdResponse200DataLinks",
    "PATCHavalaraAccountsavalaraAccountIdResponse200DataRelationships",
    "PATCHavalaraAccountsavalaraAccountIdResponse200DataRelationshipsAttachments",
    "PATCHavalaraAccountsavalaraAccountIdResponse200DataRelationshipsAttachmentsData",
    "PATCHavalaraAccountsavalaraAccountIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHavalaraAccountsavalaraAccountIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHavalaraAccountsavalaraAccountIdResponse200DataRelationshipsMarkets",
    "PATCHavalaraAccountsavalaraAccountIdResponse200DataRelationshipsMarketsData",
    "PATCHavalaraAccountsavalaraAccountIdResponse200DataRelationshipsMarketsDataType",
    "PATCHavalaraAccountsavalaraAccountIdResponse200DataRelationshipsMarketsLinks",
    "PATCHavalaraAccountsavalaraAccountIdResponse200DataRelationshipsTaxCategories",
    "PATCHavalaraAccountsavalaraAccountIdResponse200DataRelationshipsTaxCategoriesData",
    "PATCHavalaraAccountsavalaraAccountIdResponse200DataRelationshipsTaxCategoriesDataType",
    "PATCHavalaraAccountsavalaraAccountIdResponse200DataRelationshipsTaxCategoriesLinks",
    "PATCHavalaraAccountsavalaraAccountIdResponse200DataType",
    "PATCHbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200",
    "PATCHbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200Data",
    "PATCHbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataAttributes",
    "PATCHbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataAttributesMetadata",
    "PATCHbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataLinks",
    "PATCHbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataRelationships",
    "PATCHbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataRelationshipsMarket",
    "PATCHbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataRelationshipsMarketData",
    "PATCHbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataRelationshipsMarketDataType",
    "PATCHbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataRelationshipsMarketLinks",
    "PATCHbillingInfoValidationRulesbillingInfoValidationRuleIdResponse200DataType",
    "PATCHbingGeocodersbingGeocoderIdResponse200",
    "PATCHbingGeocodersbingGeocoderIdResponse200Data",
    "PATCHbingGeocodersbingGeocoderIdResponse200DataAttributes",
    "PATCHbingGeocodersbingGeocoderIdResponse200DataAttributesMetadata",
    "PATCHbingGeocodersbingGeocoderIdResponse200DataLinks",
    "PATCHbingGeocodersbingGeocoderIdResponse200DataRelationships",
    "PATCHbingGeocodersbingGeocoderIdResponse200DataRelationshipsAddresses",
    "PATCHbingGeocodersbingGeocoderIdResponse200DataRelationshipsAddressesData",
    "PATCHbingGeocodersbingGeocoderIdResponse200DataRelationshipsAddressesDataType",
    "PATCHbingGeocodersbingGeocoderIdResponse200DataRelationshipsAddressesLinks",
    "PATCHbingGeocodersbingGeocoderIdResponse200DataRelationshipsAttachments",
    "PATCHbingGeocodersbingGeocoderIdResponse200DataRelationshipsAttachmentsData",
    "PATCHbingGeocodersbingGeocoderIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHbingGeocodersbingGeocoderIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHbingGeocodersbingGeocoderIdResponse200DataType",
    "PATCHbraintreeGatewaysbraintreeGatewayIdResponse200",
    "PATCHbraintreeGatewaysbraintreeGatewayIdResponse200Data",
    "PATCHbraintreeGatewaysbraintreeGatewayIdResponse200DataAttributes",
    "PATCHbraintreeGatewaysbraintreeGatewayIdResponse200DataAttributesMetadata",
    "PATCHbraintreeGatewaysbraintreeGatewayIdResponse200DataLinks",
    "PATCHbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationships",
    "PATCHbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsBraintreePayments",
    "PATCHbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsBraintreePaymentsData",
    "PATCHbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsBraintreePaymentsDataType",
    "PATCHbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsBraintreePaymentsLinks",
    "PATCHbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsPaymentMethods",
    "PATCHbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsPaymentMethodsData",
    "PATCHbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsPaymentMethodsDataType",
    "PATCHbraintreeGatewaysbraintreeGatewayIdResponse200DataRelationshipsPaymentMethodsLinks",
    "PATCHbraintreeGatewaysbraintreeGatewayIdResponse200DataType",
    "PATCHbraintreePaymentsbraintreePaymentIdResponse200",
    "PATCHbraintreePaymentsbraintreePaymentIdResponse200Data",
    "PATCHbraintreePaymentsbraintreePaymentIdResponse200DataAttributes",
    "PATCHbraintreePaymentsbraintreePaymentIdResponse200DataAttributesMetadata",
    "PATCHbraintreePaymentsbraintreePaymentIdResponse200DataAttributesOptions",
    "PATCHbraintreePaymentsbraintreePaymentIdResponse200DataLinks",
    "PATCHbraintreePaymentsbraintreePaymentIdResponse200DataRelationships",
    "PATCHbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsOrder",
    "PATCHbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsOrderData",
    "PATCHbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsOrderDataType",
    "PATCHbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsOrderLinks",
    "PATCHbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsPaymentGateway",
    "PATCHbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsPaymentGatewayData",
    "PATCHbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsPaymentGatewayDataType",
    "PATCHbraintreePaymentsbraintreePaymentIdResponse200DataRelationshipsPaymentGatewayLinks",
    "PATCHbraintreePaymentsbraintreePaymentIdResponse200DataType",
    "PATCHbundlesbundleIdResponse200",
    "PATCHbundlesbundleIdResponse200Data",
    "PATCHbundlesbundleIdResponse200DataAttributes",
    "PATCHbundlesbundleIdResponse200DataAttributesMetadata",
    "PATCHbundlesbundleIdResponse200DataLinks",
    "PATCHbundlesbundleIdResponse200DataRelationships",
    "PATCHbundlesbundleIdResponse200DataRelationshipsAttachments",
    "PATCHbundlesbundleIdResponse200DataRelationshipsAttachmentsData",
    "PATCHbundlesbundleIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHbundlesbundleIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHbundlesbundleIdResponse200DataRelationshipsMarket",
    "PATCHbundlesbundleIdResponse200DataRelationshipsMarketData",
    "PATCHbundlesbundleIdResponse200DataRelationshipsMarketDataType",
    "PATCHbundlesbundleIdResponse200DataRelationshipsMarketLinks",
    "PATCHbundlesbundleIdResponse200DataRelationshipsSkuList",
    "PATCHbundlesbundleIdResponse200DataRelationshipsSkuListData",
    "PATCHbundlesbundleIdResponse200DataRelationshipsSkuListDataType",
    "PATCHbundlesbundleIdResponse200DataRelationshipsSkuListLinks",
    "PATCHbundlesbundleIdResponse200DataRelationshipsSkus",
    "PATCHbundlesbundleIdResponse200DataRelationshipsSkusData",
    "PATCHbundlesbundleIdResponse200DataRelationshipsSkusDataType",
    "PATCHbundlesbundleIdResponse200DataRelationshipsSkusLinks",
    "PATCHbundlesbundleIdResponse200DataType",
    "PATCHcapturescaptureIdResponse200",
    "PATCHcapturescaptureIdResponse200Data",
    "PATCHcapturescaptureIdResponse200DataAttributes",
    "PATCHcapturescaptureIdResponse200DataAttributesMetadata",
    "PATCHcapturescaptureIdResponse200DataLinks",
    "PATCHcapturescaptureIdResponse200DataRelationships",
    "PATCHcapturescaptureIdResponse200DataRelationshipsOrder",
    "PATCHcapturescaptureIdResponse200DataRelationshipsOrderData",
    "PATCHcapturescaptureIdResponse200DataRelationshipsOrderDataType",
    "PATCHcapturescaptureIdResponse200DataRelationshipsOrderLinks",
    "PATCHcapturescaptureIdResponse200DataRelationshipsReferenceAuthorization",
    "PATCHcapturescaptureIdResponse200DataRelationshipsReferenceAuthorizationData",
    "PATCHcapturescaptureIdResponse200DataRelationshipsReferenceAuthorizationDataType",
    "PATCHcapturescaptureIdResponse200DataRelationshipsReferenceAuthorizationLinks",
    "PATCHcapturescaptureIdResponse200DataRelationshipsRefunds",
    "PATCHcapturescaptureIdResponse200DataRelationshipsRefundsData",
    "PATCHcapturescaptureIdResponse200DataRelationshipsRefundsDataType",
    "PATCHcapturescaptureIdResponse200DataRelationshipsRefundsLinks",
    "PATCHcapturescaptureIdResponse200DataType",
    "PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200",
    "PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200Data",
    "PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200DataAttributes",
    "PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200DataAttributesMetadata",
    "PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200DataLinks",
    "PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationships",
    "PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsCheckoutComPayments",
    "PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsCheckoutComPaymentsData",
    "PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsCheckoutComPaymentsDataType",
    "PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsCheckoutComPaymentsLinks",
    "PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsPaymentMethods",
    "PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsPaymentMethodsData",
    "PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsPaymentMethodsDataType",
    "PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200DataRelationshipsPaymentMethodsLinks",
    "PATCHcheckoutComGatewayscheckoutComGatewayIdResponse200DataType",
    "PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200",
    "PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200Data",
    "PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200DataAttributes",
    "PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200DataAttributesMetadata",
    "PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200DataLinks",
    "PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationships",
    "PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsOrder",
    "PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsOrderData",
    "PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsOrderDataType",
    "PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsOrderLinks",
    "PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsPaymentGateway",
    "PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsPaymentGatewayData",
    "PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsPaymentGatewayDataType",
    "PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200DataRelationshipsPaymentGatewayLinks",
    "PATCHcheckoutComPaymentscheckoutComPaymentIdResponse200DataType",
    "PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200",
    "PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200Data",
    "PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataAttributes",
    "PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataAttributesMetadata",
    "PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataLinks",
    "PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationships",
    "PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsCoupons",
    "PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsCouponsData",
    "PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsCouponsDataType",
    "PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsCouponsLinks",
    "PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsPromotion",
    "PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsPromotionData",
    "PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsPromotionDataType",
    "PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataRelationshipsPromotionLinks",
    "PATCHcouponCodesPromotionRulescouponCodesPromotionRuleIdResponse200DataType",
    "PATCHcouponRecipientscouponRecipientIdResponse200",
    "PATCHcouponRecipientscouponRecipientIdResponse200Data",
    "PATCHcouponRecipientscouponRecipientIdResponse200DataAttributes",
    "PATCHcouponRecipientscouponRecipientIdResponse200DataAttributesMetadata",
    "PATCHcouponRecipientscouponRecipientIdResponse200DataLinks",
    "PATCHcouponRecipientscouponRecipientIdResponse200DataRelationships",
    "PATCHcouponRecipientscouponRecipientIdResponse200DataRelationshipsAttachments",
    "PATCHcouponRecipientscouponRecipientIdResponse200DataRelationshipsAttachmentsData",
    "PATCHcouponRecipientscouponRecipientIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHcouponRecipientscouponRecipientIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHcouponRecipientscouponRecipientIdResponse200DataRelationshipsCustomer",
    "PATCHcouponRecipientscouponRecipientIdResponse200DataRelationshipsCustomerData",
    "PATCHcouponRecipientscouponRecipientIdResponse200DataRelationshipsCustomerDataType",
    "PATCHcouponRecipientscouponRecipientIdResponse200DataRelationshipsCustomerLinks",
    "PATCHcouponRecipientscouponRecipientIdResponse200DataType",
    "PATCHcouponscouponIdResponse200",
    "PATCHcouponscouponIdResponse200Data",
    "PATCHcouponscouponIdResponse200DataAttributes",
    "PATCHcouponscouponIdResponse200DataAttributesMetadata",
    "PATCHcouponscouponIdResponse200DataLinks",
    "PATCHcouponscouponIdResponse200DataRelationships",
    "PATCHcouponscouponIdResponse200DataRelationshipsPromotionRule",
    "PATCHcouponscouponIdResponse200DataRelationshipsPromotionRuleData",
    "PATCHcouponscouponIdResponse200DataRelationshipsPromotionRuleDataType",
    "PATCHcouponscouponIdResponse200DataRelationshipsPromotionRuleLinks",
    "PATCHcouponscouponIdResponse200DataType",
    "PATCHcustomerAddressescustomerAddressIdResponse200",
    "PATCHcustomerAddressescustomerAddressIdResponse200Data",
    "PATCHcustomerAddressescustomerAddressIdResponse200DataAttributes",
    "PATCHcustomerAddressescustomerAddressIdResponse200DataAttributesMetadata",
    "PATCHcustomerAddressescustomerAddressIdResponse200DataLinks",
    "PATCHcustomerAddressescustomerAddressIdResponse200DataRelationships",
    "PATCHcustomerAddressescustomerAddressIdResponse200DataRelationshipsAddress",
    "PATCHcustomerAddressescustomerAddressIdResponse200DataRelationshipsAddressData",
    "PATCHcustomerAddressescustomerAddressIdResponse200DataRelationshipsAddressDataType",
    "PATCHcustomerAddressescustomerAddressIdResponse200DataRelationshipsAddressLinks",
    "PATCHcustomerAddressescustomerAddressIdResponse200DataRelationshipsCustomer",
    "PATCHcustomerAddressescustomerAddressIdResponse200DataRelationshipsCustomerData",
    "PATCHcustomerAddressescustomerAddressIdResponse200DataRelationshipsCustomerDataType",
    "PATCHcustomerAddressescustomerAddressIdResponse200DataRelationshipsCustomerLinks",
    "PATCHcustomerAddressescustomerAddressIdResponse200DataRelationshipsEvents",
    "PATCHcustomerAddressescustomerAddressIdResponse200DataRelationshipsEventsData",
    "PATCHcustomerAddressescustomerAddressIdResponse200DataRelationshipsEventsDataType",
    "PATCHcustomerAddressescustomerAddressIdResponse200DataRelationshipsEventsLinks",
    "PATCHcustomerAddressescustomerAddressIdResponse200DataType",
    "PATCHcustomerGroupscustomerGroupIdResponse200",
    "PATCHcustomerGroupscustomerGroupIdResponse200Data",
    "PATCHcustomerGroupscustomerGroupIdResponse200DataAttributes",
    "PATCHcustomerGroupscustomerGroupIdResponse200DataAttributesMetadata",
    "PATCHcustomerGroupscustomerGroupIdResponse200DataLinks",
    "PATCHcustomerGroupscustomerGroupIdResponse200DataRelationships",
    "PATCHcustomerGroupscustomerGroupIdResponse200DataRelationshipsAttachments",
    "PATCHcustomerGroupscustomerGroupIdResponse200DataRelationshipsAttachmentsData",
    "PATCHcustomerGroupscustomerGroupIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHcustomerGroupscustomerGroupIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHcustomerGroupscustomerGroupIdResponse200DataRelationshipsCustomers",
    "PATCHcustomerGroupscustomerGroupIdResponse200DataRelationshipsCustomersData",
    "PATCHcustomerGroupscustomerGroupIdResponse200DataRelationshipsCustomersDataType",
    "PATCHcustomerGroupscustomerGroupIdResponse200DataRelationshipsCustomersLinks",
    "PATCHcustomerGroupscustomerGroupIdResponse200DataRelationshipsMarkets",
    "PATCHcustomerGroupscustomerGroupIdResponse200DataRelationshipsMarketsData",
    "PATCHcustomerGroupscustomerGroupIdResponse200DataRelationshipsMarketsDataType",
    "PATCHcustomerGroupscustomerGroupIdResponse200DataRelationshipsMarketsLinks",
    "PATCHcustomerGroupscustomerGroupIdResponse200DataType",
    "PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200",
    "PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200Data",
    "PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200DataAttributes",
    "PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200DataAttributesMetadata",
    "PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200DataLinks",
    "PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationships",
    "PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsCustomer",
    "PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsCustomerData",
    "PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsCustomerDataType",
    "PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsCustomerLinks",
    "PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsEvents",
    "PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsEventsData",
    "PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsEventsDataType",
    "PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200DataRelationshipsEventsLinks",
    "PATCHcustomerPasswordResetscustomerPasswordResetIdResponse200DataType",
    "PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200",
    "PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200Data",
    "PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataAttributes",
    "PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataAttributesMetadata",
    "PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataLinks",
    "PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationships",
    "PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsCustomer",
    "PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsCustomerData",
    "PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsCustomerDataType",
    "PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsCustomerLinks",
    "PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsPaymentSource",
    "PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsPaymentSourceData",
    "PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsPaymentSourceDataType",
    "PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataRelationshipsPaymentSourceLinks",
    "PATCHcustomerPaymentSourcescustomerPaymentSourceIdResponse200DataType",
    "PATCHcustomerscustomerIdResponse200",
    "PATCHcustomerscustomerIdResponse200Data",
    "PATCHcustomerscustomerIdResponse200DataAttributes",
    "PATCHcustomerscustomerIdResponse200DataAttributesMetadata",
    "PATCHcustomerscustomerIdResponse200DataLinks",
    "PATCHcustomerscustomerIdResponse200DataRelationships",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsAttachments",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsAttachmentsData",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerAddresses",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerAddressesData",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerAddressesDataType",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerAddressesLinks",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerGroup",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerGroupData",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerGroupDataType",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerGroupLinks",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerPaymentSources",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerPaymentSourcesData",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerPaymentSourcesDataType",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerPaymentSourcesLinks",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerSubscriptions",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerSubscriptionsData",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerSubscriptionsDataType",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsCustomerSubscriptionsLinks",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsEvents",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsEventsData",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsEventsDataType",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsEventsLinks",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsOrders",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsOrdersData",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsOrdersDataType",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsOrdersLinks",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsOrderSubscriptions",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsOrderSubscriptionsData",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsOrderSubscriptionsDataType",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsOrderSubscriptionsLinks",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsReturns",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsReturnsData",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsReturnsDataType",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsReturnsLinks",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsSkuLists",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsSkuListsData",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsSkuListsDataType",
    "PATCHcustomerscustomerIdResponse200DataRelationshipsSkuListsLinks",
    "PATCHcustomerscustomerIdResponse200DataType",
    "PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200",
    "PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200Data",
    "PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200DataAttributes",
    "PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200DataAttributesMetadata",
    "PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200DataLinks",
    "PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationships",
    "PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsCustomer",
    "PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsCustomerData",
    "PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsCustomerDataType",
    "PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsCustomerLinks",
    "PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsEvents",
    "PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsEventsData",
    "PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsEventsDataType",
    "PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200DataRelationshipsEventsLinks",
    "PATCHcustomerSubscriptionscustomerSubscriptionIdResponse200DataType",
    "PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200",
    "PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200Data",
    "PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataAttributes",
    "PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataAttributesMetadata",
    "PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataLinks",
    "PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationships",
    "PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsAttachments",
    "PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsAttachmentsData",
    "PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsShippingMethod",
    "PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsShippingMethodData",
    "PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsShippingMethodDataType",
    "PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsShippingMethodLinks",
    "PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsStockLocation",
    "PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsStockLocationData",
    "PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsStockLocationDataType",
    "PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataRelationshipsStockLocationLinks",
    "PATCHdeliveryLeadTimesdeliveryLeadTimeIdResponse200DataType",
    "PATCHexternalGatewaysexternalGatewayIdResponse200",
    "PATCHexternalGatewaysexternalGatewayIdResponse200Data",
    "PATCHexternalGatewaysexternalGatewayIdResponse200DataAttributes",
    "PATCHexternalGatewaysexternalGatewayIdResponse200DataAttributesMetadata",
    "PATCHexternalGatewaysexternalGatewayIdResponse200DataLinks",
    "PATCHexternalGatewaysexternalGatewayIdResponse200DataRelationships",
    "PATCHexternalGatewaysexternalGatewayIdResponse200DataRelationshipsExternalPayments",
    "PATCHexternalGatewaysexternalGatewayIdResponse200DataRelationshipsExternalPaymentsData",
    "PATCHexternalGatewaysexternalGatewayIdResponse200DataRelationshipsExternalPaymentsDataType",
    "PATCHexternalGatewaysexternalGatewayIdResponse200DataRelationshipsExternalPaymentsLinks",
    "PATCHexternalGatewaysexternalGatewayIdResponse200DataRelationshipsPaymentMethods",
    "PATCHexternalGatewaysexternalGatewayIdResponse200DataRelationshipsPaymentMethodsData",
    "PATCHexternalGatewaysexternalGatewayIdResponse200DataRelationshipsPaymentMethodsDataType",
    "PATCHexternalGatewaysexternalGatewayIdResponse200DataRelationshipsPaymentMethodsLinks",
    "PATCHexternalGatewaysexternalGatewayIdResponse200DataType",
    "PATCHexternalPaymentsexternalPaymentIdResponse200",
    "PATCHexternalPaymentsexternalPaymentIdResponse200Data",
    "PATCHexternalPaymentsexternalPaymentIdResponse200DataAttributes",
    "PATCHexternalPaymentsexternalPaymentIdResponse200DataAttributesMetadata",
    "PATCHexternalPaymentsexternalPaymentIdResponse200DataAttributesOptions",
    "PATCHexternalPaymentsexternalPaymentIdResponse200DataLinks",
    "PATCHexternalPaymentsexternalPaymentIdResponse200DataRelationships",
    "PATCHexternalPaymentsexternalPaymentIdResponse200DataRelationshipsOrder",
    "PATCHexternalPaymentsexternalPaymentIdResponse200DataRelationshipsOrderData",
    "PATCHexternalPaymentsexternalPaymentIdResponse200DataRelationshipsOrderDataType",
    "PATCHexternalPaymentsexternalPaymentIdResponse200DataRelationshipsOrderLinks",
    "PATCHexternalPaymentsexternalPaymentIdResponse200DataRelationshipsPaymentGateway",
    "PATCHexternalPaymentsexternalPaymentIdResponse200DataRelationshipsPaymentGatewayData",
    "PATCHexternalPaymentsexternalPaymentIdResponse200DataRelationshipsPaymentGatewayDataType",
    "PATCHexternalPaymentsexternalPaymentIdResponse200DataRelationshipsPaymentGatewayLinks",
    "PATCHexternalPaymentsexternalPaymentIdResponse200DataRelationshipsWallet",
    "PATCHexternalPaymentsexternalPaymentIdResponse200DataRelationshipsWalletData",
    "PATCHexternalPaymentsexternalPaymentIdResponse200DataRelationshipsWalletDataType",
    "PATCHexternalPaymentsexternalPaymentIdResponse200DataRelationshipsWalletLinks",
    "PATCHexternalPaymentsexternalPaymentIdResponse200DataType",
    "PATCHexternalPromotionsexternalPromotionIdResponse200",
    "PATCHexternalPromotionsexternalPromotionIdResponse200Data",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataAttributes",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataAttributesMetadata",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataLinks",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationships",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsAttachments",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsAttachmentsData",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsCouponCodesPromotionRule",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleData",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleDataType",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleLinks",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsMarket",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsMarketData",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsMarketDataType",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsMarketLinks",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsOrderAmountPromotionRule",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleData",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleDataType",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleLinks",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsPromotionRules",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsPromotionRulesData",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsPromotionRulesDataType",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsPromotionRulesLinks",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsSkuListPromotionRule",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsSkuListPromotionRuleData",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsSkuListPromotionRuleDataType",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataRelationshipsSkuListPromotionRuleLinks",
    "PATCHexternalPromotionsexternalPromotionIdResponse200DataType",
    "PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200",
    "PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200Data",
    "PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataAttributes",
    "PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataAttributesMetadata",
    "PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataLinks",
    "PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationships",
    "PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsAttachments",
    "PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsAttachmentsData",
    "PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsMarkets",
    "PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsMarketsData",
    "PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsMarketsDataType",
    "PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataRelationshipsMarketsLinks",
    "PATCHexternalTaxCalculatorsexternalTaxCalculatorIdResponse200DataType",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200Data",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataAttributes",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataAttributesMetadata",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataLinks",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationships",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsAttachments",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsAttachmentsData",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRule",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleData",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleDataType",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleLinks",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsMarket",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsMarketData",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsMarketDataType",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsMarketLinks",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRule",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleData",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleDataType",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleLinks",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsPromotionRules",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsPromotionRulesData",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsPromotionRulesDataType",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsPromotionRulesLinks",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsSkuListPromotionRule",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsSkuListPromotionRuleData",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsSkuListPromotionRuleDataType",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataRelationshipsSkuListPromotionRuleLinks",
    "PATCHfixedAmountPromotionsfixedAmountPromotionIdResponse200DataType",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200Data",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataAttributes",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataAttributesMetadata",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataLinks",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationships",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsAttachments",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsAttachmentsData",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsCouponCodesPromotionRule",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleData",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleDataType",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleLinks",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsMarket",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsMarketData",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsMarketDataType",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsMarketLinks",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsOrderAmountPromotionRule",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleData",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleDataType",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleLinks",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsPromotionRules",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsPromotionRulesData",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsPromotionRulesDataType",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsPromotionRulesLinks",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuList",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuListData",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuListDataType",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuListLinks",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuListPromotionRule",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuListPromotionRuleData",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuListPromotionRuleDataType",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkuListPromotionRuleLinks",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkus",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkusData",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkusDataType",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataRelationshipsSkusLinks",
    "PATCHfixedPricePromotionsfixedPricePromotionIdResponse200DataType",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200Data",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataAttributes",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataAttributesMetadata",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataLinks",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationships",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsAttachments",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsAttachmentsData",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsCouponCodesPromotionRule",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleData",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleDataType",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleLinks",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsMarket",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsMarketData",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsMarketDataType",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsMarketLinks",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsOrderAmountPromotionRule",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleData",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleDataType",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleLinks",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsPromotionRules",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsPromotionRulesData",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsPromotionRulesDataType",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsPromotionRulesLinks",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuList",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuListData",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuListDataType",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuListLinks",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuListPromotionRule",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuListPromotionRuleData",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuListPromotionRuleDataType",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkuListPromotionRuleLinks",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkus",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkusData",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkusDataType",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataRelationshipsSkusLinks",
    "PATCHfreeGiftPromotionsfreeGiftPromotionIdResponse200DataType",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200Data",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataAttributes",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataAttributesMetadata",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataLinks",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationships",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsAttachments",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsAttachmentsData",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsCouponCodesPromotionRule",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleData",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleDataType",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleLinks",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsMarket",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsMarketData",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsMarketDataType",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsMarketLinks",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsOrderAmountPromotionRule",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleData",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleDataType",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleLinks",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsPromotionRules",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsPromotionRulesData",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsPromotionRulesDataType",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsPromotionRulesLinks",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsSkuListPromotionRule",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsSkuListPromotionRuleData",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsSkuListPromotionRuleDataType",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataRelationshipsSkuListPromotionRuleLinks",
    "PATCHfreeShippingPromotionsfreeShippingPromotionIdResponse200DataType",
    "PATCHgiftCardRecipientsgiftCardRecipientIdResponse200",
    "PATCHgiftCardRecipientsgiftCardRecipientIdResponse200Data",
    "PATCHgiftCardRecipientsgiftCardRecipientIdResponse200DataAttributes",
    "PATCHgiftCardRecipientsgiftCardRecipientIdResponse200DataAttributesMetadata",
    "PATCHgiftCardRecipientsgiftCardRecipientIdResponse200DataLinks",
    "PATCHgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationships",
    "PATCHgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsAttachments",
    "PATCHgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsAttachmentsData",
    "PATCHgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsCustomer",
    "PATCHgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsCustomerData",
    "PATCHgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsCustomerDataType",
    "PATCHgiftCardRecipientsgiftCardRecipientIdResponse200DataRelationshipsCustomerLinks",
    "PATCHgiftCardRecipientsgiftCardRecipientIdResponse200DataType",
    "PATCHgiftCardsgiftCardIdResponse200",
    "PATCHgiftCardsgiftCardIdResponse200Data",
    "PATCHgiftCardsgiftCardIdResponse200DataAttributes",
    "PATCHgiftCardsgiftCardIdResponse200DataAttributesMetadata",
    "PATCHgiftCardsgiftCardIdResponse200DataLinks",
    "PATCHgiftCardsgiftCardIdResponse200DataRelationships",
    "PATCHgiftCardsgiftCardIdResponse200DataRelationshipsAttachments",
    "PATCHgiftCardsgiftCardIdResponse200DataRelationshipsAttachmentsData",
    "PATCHgiftCardsgiftCardIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHgiftCardsgiftCardIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHgiftCardsgiftCardIdResponse200DataRelationshipsEvents",
    "PATCHgiftCardsgiftCardIdResponse200DataRelationshipsEventsData",
    "PATCHgiftCardsgiftCardIdResponse200DataRelationshipsEventsDataType",
    "PATCHgiftCardsgiftCardIdResponse200DataRelationshipsEventsLinks",
    "PATCHgiftCardsgiftCardIdResponse200DataRelationshipsGiftCardRecipient",
    "PATCHgiftCardsgiftCardIdResponse200DataRelationshipsGiftCardRecipientData",
    "PATCHgiftCardsgiftCardIdResponse200DataRelationshipsGiftCardRecipientDataType",
    "PATCHgiftCardsgiftCardIdResponse200DataRelationshipsGiftCardRecipientLinks",
    "PATCHgiftCardsgiftCardIdResponse200DataRelationshipsMarket",
    "PATCHgiftCardsgiftCardIdResponse200DataRelationshipsMarketData",
    "PATCHgiftCardsgiftCardIdResponse200DataRelationshipsMarketDataType",
    "PATCHgiftCardsgiftCardIdResponse200DataRelationshipsMarketLinks",
    "PATCHgiftCardsgiftCardIdResponse200DataType",
    "PATCHgoogleGeocodersgoogleGeocoderIdResponse200",
    "PATCHgoogleGeocodersgoogleGeocoderIdResponse200Data",
    "PATCHgoogleGeocodersgoogleGeocoderIdResponse200DataAttributes",
    "PATCHgoogleGeocodersgoogleGeocoderIdResponse200DataAttributesMetadata",
    "PATCHgoogleGeocodersgoogleGeocoderIdResponse200DataLinks",
    "PATCHgoogleGeocodersgoogleGeocoderIdResponse200DataRelationships",
    "PATCHgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAddresses",
    "PATCHgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAddressesData",
    "PATCHgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAddressesDataType",
    "PATCHgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAddressesLinks",
    "PATCHgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAttachments",
    "PATCHgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAttachmentsData",
    "PATCHgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHgoogleGeocodersgoogleGeocoderIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHgoogleGeocodersgoogleGeocoderIdResponse200DataType",
    "PATCHinStockSubscriptionsinStockSubscriptionIdResponse200",
    "PATCHinStockSubscriptionsinStockSubscriptionIdResponse200Data",
    "PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataAttributes",
    "PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataAttributesMetadata",
    "PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataLinks",
    "PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationships",
    "PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsCustomer",
    "PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsCustomerData",
    "PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsCustomerDataType",
    "PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsCustomerLinks",
    "PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsEvents",
    "PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsEventsData",
    "PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsEventsDataType",
    "PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsEventsLinks",
    "PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsMarket",
    "PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsMarketData",
    "PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsMarketDataType",
    "PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsMarketLinks",
    "PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsSku",
    "PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsSkuData",
    "PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsSkuDataType",
    "PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataRelationshipsSkuLinks",
    "PATCHinStockSubscriptionsinStockSubscriptionIdResponse200DataType",
    "PATCHinventoryModelsinventoryModelIdResponse200",
    "PATCHinventoryModelsinventoryModelIdResponse200Data",
    "PATCHinventoryModelsinventoryModelIdResponse200DataAttributes",
    "PATCHinventoryModelsinventoryModelIdResponse200DataAttributesMetadata",
    "PATCHinventoryModelsinventoryModelIdResponse200DataLinks",
    "PATCHinventoryModelsinventoryModelIdResponse200DataRelationships",
    "PATCHinventoryModelsinventoryModelIdResponse200DataRelationshipsAttachments",
    "PATCHinventoryModelsinventoryModelIdResponse200DataRelationshipsAttachmentsData",
    "PATCHinventoryModelsinventoryModelIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHinventoryModelsinventoryModelIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryReturnLocations",
    "PATCHinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryReturnLocationsData",
    "PATCHinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryReturnLocationsDataType",
    "PATCHinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryReturnLocationsLinks",
    "PATCHinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryStockLocations",
    "PATCHinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryStockLocationsData",
    "PATCHinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryStockLocationsDataType",
    "PATCHinventoryModelsinventoryModelIdResponse200DataRelationshipsInventoryStockLocationsLinks",
    "PATCHinventoryModelsinventoryModelIdResponse200DataType",
    "PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200",
    "PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200Data",
    "PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200DataAttributes",
    "PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200DataAttributesMetadata",
    "PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200DataLinks",
    "PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationships",
    "PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsInventoryModel",
    "PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsInventoryModelData",
    "PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsInventoryModelDataType",
    "PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsInventoryModelLinks",
    "PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsStockLocation",
    "PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsStockLocationData",
    "PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsStockLocationDataType",
    "PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200DataRelationshipsStockLocationLinks",
    "PATCHinventoryReturnLocationsinventoryReturnLocationIdResponse200DataType",
    "PATCHinventoryStockLocationsinventoryStockLocationIdResponse200",
    "PATCHinventoryStockLocationsinventoryStockLocationIdResponse200Data",
    "PATCHinventoryStockLocationsinventoryStockLocationIdResponse200DataAttributes",
    "PATCHinventoryStockLocationsinventoryStockLocationIdResponse200DataAttributesMetadata",
    "PATCHinventoryStockLocationsinventoryStockLocationIdResponse200DataLinks",
    "PATCHinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationships",
    "PATCHinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsInventoryModel",
    "PATCHinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsInventoryModelData",
    "PATCHinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsInventoryModelDataType",
    "PATCHinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsInventoryModelLinks",
    "PATCHinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsStockLocation",
    "PATCHinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsStockLocationData",
    "PATCHinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsStockLocationDataType",
    "PATCHinventoryStockLocationsinventoryStockLocationIdResponse200DataRelationshipsStockLocationLinks",
    "PATCHinventoryStockLocationsinventoryStockLocationIdResponse200DataType",
    "PATCHklarnaGatewaysklarnaGatewayIdResponse200",
    "PATCHklarnaGatewaysklarnaGatewayIdResponse200Data",
    "PATCHklarnaGatewaysklarnaGatewayIdResponse200DataAttributes",
    "PATCHklarnaGatewaysklarnaGatewayIdResponse200DataAttributesMetadata",
    "PATCHklarnaGatewaysklarnaGatewayIdResponse200DataLinks",
    "PATCHklarnaGatewaysklarnaGatewayIdResponse200DataRelationships",
    "PATCHklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsKlarnaPayments",
    "PATCHklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsKlarnaPaymentsData",
    "PATCHklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsKlarnaPaymentsDataType",
    "PATCHklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsKlarnaPaymentsLinks",
    "PATCHklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsPaymentMethods",
    "PATCHklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsPaymentMethodsData",
    "PATCHklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsPaymentMethodsDataType",
    "PATCHklarnaGatewaysklarnaGatewayIdResponse200DataRelationshipsPaymentMethodsLinks",
    "PATCHklarnaGatewaysklarnaGatewayIdResponse200DataType",
    "PATCHklarnaPaymentsklarnaPaymentIdResponse200",
    "PATCHklarnaPaymentsklarnaPaymentIdResponse200Data",
    "PATCHklarnaPaymentsklarnaPaymentIdResponse200DataAttributes",
    "PATCHklarnaPaymentsklarnaPaymentIdResponse200DataAttributesMetadata",
    "PATCHklarnaPaymentsklarnaPaymentIdResponse200DataLinks",
    "PATCHklarnaPaymentsklarnaPaymentIdResponse200DataRelationships",
    "PATCHklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsOrder",
    "PATCHklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsOrderData",
    "PATCHklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsOrderDataType",
    "PATCHklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsOrderLinks",
    "PATCHklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsPaymentGateway",
    "PATCHklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsPaymentGatewayData",
    "PATCHklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsPaymentGatewayDataType",
    "PATCHklarnaPaymentsklarnaPaymentIdResponse200DataRelationshipsPaymentGatewayLinks",
    "PATCHklarnaPaymentsklarnaPaymentIdResponse200DataType",
    "PATCHlineItemOptionslineItemOptionIdResponse200",
    "PATCHlineItemOptionslineItemOptionIdResponse200Data",
    "PATCHlineItemOptionslineItemOptionIdResponse200DataAttributes",
    "PATCHlineItemOptionslineItemOptionIdResponse200DataAttributesMetadata",
    "PATCHlineItemOptionslineItemOptionIdResponse200DataAttributesOptions",
    "PATCHlineItemOptionslineItemOptionIdResponse200DataLinks",
    "PATCHlineItemOptionslineItemOptionIdResponse200DataRelationships",
    "PATCHlineItemOptionslineItemOptionIdResponse200DataRelationshipsLineItem",
    "PATCHlineItemOptionslineItemOptionIdResponse200DataRelationshipsLineItemData",
    "PATCHlineItemOptionslineItemOptionIdResponse200DataRelationshipsLineItemDataType",
    "PATCHlineItemOptionslineItemOptionIdResponse200DataRelationshipsLineItemLinks",
    "PATCHlineItemOptionslineItemOptionIdResponse200DataRelationshipsSkuOption",
    "PATCHlineItemOptionslineItemOptionIdResponse200DataRelationshipsSkuOptionData",
    "PATCHlineItemOptionslineItemOptionIdResponse200DataRelationshipsSkuOptionDataType",
    "PATCHlineItemOptionslineItemOptionIdResponse200DataRelationshipsSkuOptionLinks",
    "PATCHlineItemOptionslineItemOptionIdResponse200DataType",
    "PATCHlineItemslineItemIdResponse200",
    "PATCHlineItemslineItemIdResponse200Data",
    "PATCHlineItemslineItemIdResponse200DataAttributes",
    "PATCHlineItemslineItemIdResponse200DataAttributesMetadata",
    "PATCHlineItemslineItemIdResponse200DataLinks",
    "PATCHlineItemslineItemIdResponse200DataRelationships",
    "PATCHlineItemslineItemIdResponse200DataRelationshipsItem",
    "PATCHlineItemslineItemIdResponse200DataRelationshipsItemData",
    "PATCHlineItemslineItemIdResponse200DataRelationshipsItemDataType",
    "PATCHlineItemslineItemIdResponse200DataRelationshipsItemLinks",
    "PATCHlineItemslineItemIdResponse200DataRelationshipsLineItemOptions",
    "PATCHlineItemslineItemIdResponse200DataRelationshipsLineItemOptionsData",
    "PATCHlineItemslineItemIdResponse200DataRelationshipsLineItemOptionsDataType",
    "PATCHlineItemslineItemIdResponse200DataRelationshipsLineItemOptionsLinks",
    "PATCHlineItemslineItemIdResponse200DataRelationshipsOrder",
    "PATCHlineItemslineItemIdResponse200DataRelationshipsOrderData",
    "PATCHlineItemslineItemIdResponse200DataRelationshipsOrderDataType",
    "PATCHlineItemslineItemIdResponse200DataRelationshipsOrderLinks",
    "PATCHlineItemslineItemIdResponse200DataRelationshipsShipmentLineItems",
    "PATCHlineItemslineItemIdResponse200DataRelationshipsShipmentLineItemsData",
    "PATCHlineItemslineItemIdResponse200DataRelationshipsShipmentLineItemsDataType",
    "PATCHlineItemslineItemIdResponse200DataRelationshipsShipmentLineItemsLinks",
    "PATCHlineItemslineItemIdResponse200DataRelationshipsStockLineItems",
    "PATCHlineItemslineItemIdResponse200DataRelationshipsStockLineItemsData",
    "PATCHlineItemslineItemIdResponse200DataRelationshipsStockLineItemsDataType",
    "PATCHlineItemslineItemIdResponse200DataRelationshipsStockLineItemsLinks",
    "PATCHlineItemslineItemIdResponse200DataRelationshipsStockTransfers",
    "PATCHlineItemslineItemIdResponse200DataRelationshipsStockTransfersData",
    "PATCHlineItemslineItemIdResponse200DataRelationshipsStockTransfersDataType",
    "PATCHlineItemslineItemIdResponse200DataRelationshipsStockTransfersLinks",
    "PATCHlineItemslineItemIdResponse200DataType",
    "PATCHmanualGatewaysmanualGatewayIdResponse200",
    "PATCHmanualGatewaysmanualGatewayIdResponse200Data",
    "PATCHmanualGatewaysmanualGatewayIdResponse200DataAttributes",
    "PATCHmanualGatewaysmanualGatewayIdResponse200DataAttributesMetadata",
    "PATCHmanualGatewaysmanualGatewayIdResponse200DataLinks",
    "PATCHmanualGatewaysmanualGatewayIdResponse200DataRelationships",
    "PATCHmanualGatewaysmanualGatewayIdResponse200DataRelationshipsPaymentMethods",
    "PATCHmanualGatewaysmanualGatewayIdResponse200DataRelationshipsPaymentMethodsData",
    "PATCHmanualGatewaysmanualGatewayIdResponse200DataRelationshipsPaymentMethodsDataType",
    "PATCHmanualGatewaysmanualGatewayIdResponse200DataRelationshipsPaymentMethodsLinks",
    "PATCHmanualGatewaysmanualGatewayIdResponse200DataType",
    "PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200",
    "PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200Data",
    "PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataAttributes",
    "PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataAttributesMetadata",
    "PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataLinks",
    "PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationships",
    "PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsAttachments",
    "PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsAttachmentsData",
    "PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsMarkets",
    "PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsMarketsData",
    "PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsMarketsDataType",
    "PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsMarketsLinks",
    "PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsTaxRules",
    "PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsTaxRulesData",
    "PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsTaxRulesDataType",
    "PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataRelationshipsTaxRulesLinks",
    "PATCHmanualTaxCalculatorsmanualTaxCalculatorIdResponse200DataType",
    "PATCHmarketsmarketIdResponse200",
    "PATCHmarketsmarketIdResponse200Data",
    "PATCHmarketsmarketIdResponse200DataAttributes",
    "PATCHmarketsmarketIdResponse200DataAttributesMetadata",
    "PATCHmarketsmarketIdResponse200DataLinks",
    "PATCHmarketsmarketIdResponse200DataRelationships",
    "PATCHmarketsmarketIdResponse200DataRelationshipsAttachments",
    "PATCHmarketsmarketIdResponse200DataRelationshipsAttachmentsData",
    "PATCHmarketsmarketIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHmarketsmarketIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHmarketsmarketIdResponse200DataRelationshipsCustomerGroup",
    "PATCHmarketsmarketIdResponse200DataRelationshipsCustomerGroupData",
    "PATCHmarketsmarketIdResponse200DataRelationshipsCustomerGroupDataType",
    "PATCHmarketsmarketIdResponse200DataRelationshipsCustomerGroupLinks",
    "PATCHmarketsmarketIdResponse200DataRelationshipsInventoryModel",
    "PATCHmarketsmarketIdResponse200DataRelationshipsInventoryModelData",
    "PATCHmarketsmarketIdResponse200DataRelationshipsInventoryModelDataType",
    "PATCHmarketsmarketIdResponse200DataRelationshipsInventoryModelLinks",
    "PATCHmarketsmarketIdResponse200DataRelationshipsMerchant",
    "PATCHmarketsmarketIdResponse200DataRelationshipsMerchantData",
    "PATCHmarketsmarketIdResponse200DataRelationshipsMerchantDataType",
    "PATCHmarketsmarketIdResponse200DataRelationshipsMerchantLinks",
    "PATCHmarketsmarketIdResponse200DataRelationshipsPriceList",
    "PATCHmarketsmarketIdResponse200DataRelationshipsPriceListData",
    "PATCHmarketsmarketIdResponse200DataRelationshipsPriceListDataType",
    "PATCHmarketsmarketIdResponse200DataRelationshipsPriceListLinks",
    "PATCHmarketsmarketIdResponse200DataRelationshipsTaxCalculator",
    "PATCHmarketsmarketIdResponse200DataRelationshipsTaxCalculatorData",
    "PATCHmarketsmarketIdResponse200DataRelationshipsTaxCalculatorDataType",
    "PATCHmarketsmarketIdResponse200DataRelationshipsTaxCalculatorLinks",
    "PATCHmarketsmarketIdResponse200DataType",
    "PATCHmerchantsmerchantIdResponse200",
    "PATCHmerchantsmerchantIdResponse200Data",
    "PATCHmerchantsmerchantIdResponse200DataAttributes",
    "PATCHmerchantsmerchantIdResponse200DataAttributesMetadata",
    "PATCHmerchantsmerchantIdResponse200DataLinks",
    "PATCHmerchantsmerchantIdResponse200DataRelationships",
    "PATCHmerchantsmerchantIdResponse200DataRelationshipsAddress",
    "PATCHmerchantsmerchantIdResponse200DataRelationshipsAddressData",
    "PATCHmerchantsmerchantIdResponse200DataRelationshipsAddressDataType",
    "PATCHmerchantsmerchantIdResponse200DataRelationshipsAddressLinks",
    "PATCHmerchantsmerchantIdResponse200DataRelationshipsAttachments",
    "PATCHmerchantsmerchantIdResponse200DataRelationshipsAttachmentsData",
    "PATCHmerchantsmerchantIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHmerchantsmerchantIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHmerchantsmerchantIdResponse200DataType",
    "PATCHorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200",
    "PATCHorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200Data",
    "PATCHorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataAttributes",
    "PATCHorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataAttributesMetadata",
    "PATCHorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataLinks",
    "PATCHorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataRelationships",
    "PATCHorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataRelationshipsPromotion",
    "PATCHorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataRelationshipsPromotionData",
    "PATCHorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataRelationshipsPromotionDataType",
    "PATCHorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataRelationshipsPromotionLinks",
    "PATCHorderAmountPromotionRulesorderAmountPromotionRuleIdResponse200DataType",
    "PATCHordersorderIdResponse200",
    "PATCHordersorderIdResponse200Data",
    "PATCHordersorderIdResponse200DataAttributes",
    "PATCHordersorderIdResponse200DataAttributesMetadata",
    "PATCHordersorderIdResponse200DataLinks",
    "PATCHordersorderIdResponse200DataRelationships",
    "PATCHordersorderIdResponse200DataRelationshipsAttachments",
    "PATCHordersorderIdResponse200DataRelationshipsAttachmentsData",
    "PATCHordersorderIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHordersorderIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHordersorderIdResponse200DataRelationshipsAuthorizations",
    "PATCHordersorderIdResponse200DataRelationshipsAuthorizationsData",
    "PATCHordersorderIdResponse200DataRelationshipsAuthorizationsDataType",
    "PATCHordersorderIdResponse200DataRelationshipsAuthorizationsLinks",
    "PATCHordersorderIdResponse200DataRelationshipsAvailableCustomerPaymentSources",
    "PATCHordersorderIdResponse200DataRelationshipsAvailableCustomerPaymentSourcesData",
    "PATCHordersorderIdResponse200DataRelationshipsAvailableCustomerPaymentSourcesDataType",
    "PATCHordersorderIdResponse200DataRelationshipsAvailableCustomerPaymentSourcesLinks",
    "PATCHordersorderIdResponse200DataRelationshipsAvailableFreeBundles",
    "PATCHordersorderIdResponse200DataRelationshipsAvailableFreeBundlesData",
    "PATCHordersorderIdResponse200DataRelationshipsAvailableFreeBundlesDataType",
    "PATCHordersorderIdResponse200DataRelationshipsAvailableFreeBundlesLinks",
    "PATCHordersorderIdResponse200DataRelationshipsAvailableFreeSkus",
    "PATCHordersorderIdResponse200DataRelationshipsAvailableFreeSkusData",
    "PATCHordersorderIdResponse200DataRelationshipsAvailableFreeSkusDataType",
    "PATCHordersorderIdResponse200DataRelationshipsAvailableFreeSkusLinks",
    "PATCHordersorderIdResponse200DataRelationshipsAvailablePaymentMethods",
    "PATCHordersorderIdResponse200DataRelationshipsAvailablePaymentMethodsData",
    "PATCHordersorderIdResponse200DataRelationshipsAvailablePaymentMethodsDataType",
    "PATCHordersorderIdResponse200DataRelationshipsAvailablePaymentMethodsLinks",
    "PATCHordersorderIdResponse200DataRelationshipsBillingAddress",
    "PATCHordersorderIdResponse200DataRelationshipsBillingAddressData",
    "PATCHordersorderIdResponse200DataRelationshipsBillingAddressDataType",
    "PATCHordersorderIdResponse200DataRelationshipsBillingAddressLinks",
    "PATCHordersorderIdResponse200DataRelationshipsCaptures",
    "PATCHordersorderIdResponse200DataRelationshipsCapturesData",
    "PATCHordersorderIdResponse200DataRelationshipsCapturesDataType",
    "PATCHordersorderIdResponse200DataRelationshipsCapturesLinks",
    "PATCHordersorderIdResponse200DataRelationshipsCustomer",
    "PATCHordersorderIdResponse200DataRelationshipsCustomerData",
    "PATCHordersorderIdResponse200DataRelationshipsCustomerDataType",
    "PATCHordersorderIdResponse200DataRelationshipsCustomerLinks",
    "PATCHordersorderIdResponse200DataRelationshipsEvents",
    "PATCHordersorderIdResponse200DataRelationshipsEventsData",
    "PATCHordersorderIdResponse200DataRelationshipsEventsDataType",
    "PATCHordersorderIdResponse200DataRelationshipsEventsLinks",
    "PATCHordersorderIdResponse200DataRelationshipsLineItems",
    "PATCHordersorderIdResponse200DataRelationshipsLineItemsData",
    "PATCHordersorderIdResponse200DataRelationshipsLineItemsDataType",
    "PATCHordersorderIdResponse200DataRelationshipsLineItemsLinks",
    "PATCHordersorderIdResponse200DataRelationshipsMarket",
    "PATCHordersorderIdResponse200DataRelationshipsMarketData",
    "PATCHordersorderIdResponse200DataRelationshipsMarketDataType",
    "PATCHordersorderIdResponse200DataRelationshipsMarketLinks",
    "PATCHordersorderIdResponse200DataRelationshipsOrderCopies",
    "PATCHordersorderIdResponse200DataRelationshipsOrderCopiesData",
    "PATCHordersorderIdResponse200DataRelationshipsOrderCopiesDataType",
    "PATCHordersorderIdResponse200DataRelationshipsOrderCopiesLinks",
    "PATCHordersorderIdResponse200DataRelationshipsOrderSubscriptions",
    "PATCHordersorderIdResponse200DataRelationshipsOrderSubscriptionsData",
    "PATCHordersorderIdResponse200DataRelationshipsOrderSubscriptionsDataType",
    "PATCHordersorderIdResponse200DataRelationshipsOrderSubscriptionsLinks",
    "PATCHordersorderIdResponse200DataRelationshipsPaymentMethod",
    "PATCHordersorderIdResponse200DataRelationshipsPaymentMethodData",
    "PATCHordersorderIdResponse200DataRelationshipsPaymentMethodDataType",
    "PATCHordersorderIdResponse200DataRelationshipsPaymentMethodLinks",
    "PATCHordersorderIdResponse200DataRelationshipsPaymentSource",
    "PATCHordersorderIdResponse200DataRelationshipsPaymentSourceData",
    "PATCHordersorderIdResponse200DataRelationshipsPaymentSourceDataType",
    "PATCHordersorderIdResponse200DataRelationshipsPaymentSourceLinks",
    "PATCHordersorderIdResponse200DataRelationshipsRefunds",
    "PATCHordersorderIdResponse200DataRelationshipsRefundsData",
    "PATCHordersorderIdResponse200DataRelationshipsRefundsDataType",
    "PATCHordersorderIdResponse200DataRelationshipsRefundsLinks",
    "PATCHordersorderIdResponse200DataRelationshipsShipments",
    "PATCHordersorderIdResponse200DataRelationshipsShipmentsData",
    "PATCHordersorderIdResponse200DataRelationshipsShipmentsDataType",
    "PATCHordersorderIdResponse200DataRelationshipsShipmentsLinks",
    "PATCHordersorderIdResponse200DataRelationshipsShippingAddress",
    "PATCHordersorderIdResponse200DataRelationshipsShippingAddressData",
    "PATCHordersorderIdResponse200DataRelationshipsShippingAddressDataType",
    "PATCHordersorderIdResponse200DataRelationshipsShippingAddressLinks",
    "PATCHordersorderIdResponse200DataRelationshipsTransactions",
    "PATCHordersorderIdResponse200DataRelationshipsTransactionsData",
    "PATCHordersorderIdResponse200DataRelationshipsTransactionsDataType",
    "PATCHordersorderIdResponse200DataRelationshipsTransactionsLinks",
    "PATCHordersorderIdResponse200DataRelationshipsVoids",
    "PATCHordersorderIdResponse200DataRelationshipsVoidsData",
    "PATCHordersorderIdResponse200DataRelationshipsVoidsDataType",
    "PATCHordersorderIdResponse200DataRelationshipsVoidsLinks",
    "PATCHordersorderIdResponse200DataType",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200Data",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataAttributes",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataAttributesMetadata",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataLinks",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationships",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsCustomer",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsCustomerData",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsCustomerDataType",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsCustomerLinks",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsEvents",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsEventsData",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsEventsDataType",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsEventsLinks",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsMarket",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsMarketData",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsMarketDataType",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsMarketLinks",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrderCopies",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrderCopiesData",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrderCopiesDataType",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrderCopiesLinks",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrders",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrdersData",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrdersDataType",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsOrdersLinks",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsSourceOrder",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsSourceOrderData",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsSourceOrderDataType",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataRelationshipsSourceOrderLinks",
    "PATCHorderSubscriptionsorderSubscriptionIdResponse200DataType",
    "PATCHpackagespackageIdResponse200",
    "PATCHpackagespackageIdResponse200Data",
    "PATCHpackagespackageIdResponse200DataAttributes",
    "PATCHpackagespackageIdResponse200DataAttributesMetadata",
    "PATCHpackagespackageIdResponse200DataLinks",
    "PATCHpackagespackageIdResponse200DataRelationships",
    "PATCHpackagespackageIdResponse200DataRelationshipsAttachments",
    "PATCHpackagespackageIdResponse200DataRelationshipsAttachmentsData",
    "PATCHpackagespackageIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHpackagespackageIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHpackagespackageIdResponse200DataRelationshipsParcels",
    "PATCHpackagespackageIdResponse200DataRelationshipsParcelsData",
    "PATCHpackagespackageIdResponse200DataRelationshipsParcelsDataType",
    "PATCHpackagespackageIdResponse200DataRelationshipsParcelsLinks",
    "PATCHpackagespackageIdResponse200DataRelationshipsStockLocation",
    "PATCHpackagespackageIdResponse200DataRelationshipsStockLocationData",
    "PATCHpackagespackageIdResponse200DataRelationshipsStockLocationDataType",
    "PATCHpackagespackageIdResponse200DataRelationshipsStockLocationLinks",
    "PATCHpackagespackageIdResponse200DataType",
    "PATCHparcelLineItemsparcelLineItemIdResponse200",
    "PATCHparcelLineItemsparcelLineItemIdResponse200Data",
    "PATCHparcelLineItemsparcelLineItemIdResponse200DataAttributes",
    "PATCHparcelLineItemsparcelLineItemIdResponse200DataAttributesMetadata",
    "PATCHparcelLineItemsparcelLineItemIdResponse200DataLinks",
    "PATCHparcelLineItemsparcelLineItemIdResponse200DataRelationships",
    "PATCHparcelLineItemsparcelLineItemIdResponse200DataRelationshipsParcel",
    "PATCHparcelLineItemsparcelLineItemIdResponse200DataRelationshipsParcelData",
    "PATCHparcelLineItemsparcelLineItemIdResponse200DataRelationshipsParcelDataType",
    "PATCHparcelLineItemsparcelLineItemIdResponse200DataRelationshipsParcelLinks",
    "PATCHparcelLineItemsparcelLineItemIdResponse200DataRelationshipsShipmentLineItem",
    "PATCHparcelLineItemsparcelLineItemIdResponse200DataRelationshipsShipmentLineItemData",
    "PATCHparcelLineItemsparcelLineItemIdResponse200DataRelationshipsShipmentLineItemDataType",
    "PATCHparcelLineItemsparcelLineItemIdResponse200DataRelationshipsShipmentLineItemLinks",
    "PATCHparcelLineItemsparcelLineItemIdResponse200DataRelationshipsStockLineItem",
    "PATCHparcelLineItemsparcelLineItemIdResponse200DataRelationshipsStockLineItemData",
    "PATCHparcelLineItemsparcelLineItemIdResponse200DataRelationshipsStockLineItemDataType",
    "PATCHparcelLineItemsparcelLineItemIdResponse200DataRelationshipsStockLineItemLinks",
    "PATCHparcelLineItemsparcelLineItemIdResponse200DataType",
    "PATCHparcelsparcelIdResponse200",
    "PATCHparcelsparcelIdResponse200Data",
    "PATCHparcelsparcelIdResponse200DataAttributes",
    "PATCHparcelsparcelIdResponse200DataAttributesMetadata",
    "PATCHparcelsparcelIdResponse200DataLinks",
    "PATCHparcelsparcelIdResponse200DataRelationships",
    "PATCHparcelsparcelIdResponse200DataRelationshipsAttachments",
    "PATCHparcelsparcelIdResponse200DataRelationshipsAttachmentsData",
    "PATCHparcelsparcelIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHparcelsparcelIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHparcelsparcelIdResponse200DataRelationshipsEvents",
    "PATCHparcelsparcelIdResponse200DataRelationshipsEventsData",
    "PATCHparcelsparcelIdResponse200DataRelationshipsEventsDataType",
    "PATCHparcelsparcelIdResponse200DataRelationshipsEventsLinks",
    "PATCHparcelsparcelIdResponse200DataRelationshipsPackage",
    "PATCHparcelsparcelIdResponse200DataRelationshipsPackageData",
    "PATCHparcelsparcelIdResponse200DataRelationshipsPackageDataType",
    "PATCHparcelsparcelIdResponse200DataRelationshipsPackageLinks",
    "PATCHparcelsparcelIdResponse200DataRelationshipsParcelLineItems",
    "PATCHparcelsparcelIdResponse200DataRelationshipsParcelLineItemsData",
    "PATCHparcelsparcelIdResponse200DataRelationshipsParcelLineItemsDataType",
    "PATCHparcelsparcelIdResponse200DataRelationshipsParcelLineItemsLinks",
    "PATCHparcelsparcelIdResponse200DataRelationshipsShipment",
    "PATCHparcelsparcelIdResponse200DataRelationshipsShipmentData",
    "PATCHparcelsparcelIdResponse200DataRelationshipsShipmentDataType",
    "PATCHparcelsparcelIdResponse200DataRelationshipsShipmentLinks",
    "PATCHparcelsparcelIdResponse200DataType",
    "PATCHpaymentMethodspaymentMethodIdResponse200",
    "PATCHpaymentMethodspaymentMethodIdResponse200Data",
    "PATCHpaymentMethodspaymentMethodIdResponse200DataAttributes",
    "PATCHpaymentMethodspaymentMethodIdResponse200DataAttributesMetadata",
    "PATCHpaymentMethodspaymentMethodIdResponse200DataLinks",
    "PATCHpaymentMethodspaymentMethodIdResponse200DataRelationships",
    "PATCHpaymentMethodspaymentMethodIdResponse200DataRelationshipsAttachments",
    "PATCHpaymentMethodspaymentMethodIdResponse200DataRelationshipsAttachmentsData",
    "PATCHpaymentMethodspaymentMethodIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHpaymentMethodspaymentMethodIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHpaymentMethodspaymentMethodIdResponse200DataRelationshipsMarket",
    "PATCHpaymentMethodspaymentMethodIdResponse200DataRelationshipsMarketData",
    "PATCHpaymentMethodspaymentMethodIdResponse200DataRelationshipsMarketDataType",
    "PATCHpaymentMethodspaymentMethodIdResponse200DataRelationshipsMarketLinks",
    "PATCHpaymentMethodspaymentMethodIdResponse200DataRelationshipsPaymentGateway",
    "PATCHpaymentMethodspaymentMethodIdResponse200DataRelationshipsPaymentGatewayData",
    "PATCHpaymentMethodspaymentMethodIdResponse200DataRelationshipsPaymentGatewayDataType",
    "PATCHpaymentMethodspaymentMethodIdResponse200DataRelationshipsPaymentGatewayLinks",
    "PATCHpaymentMethodspaymentMethodIdResponse200DataType",
    "PATCHpaypalGatewayspaypalGatewayIdResponse200",
    "PATCHpaypalGatewayspaypalGatewayIdResponse200Data",
    "PATCHpaypalGatewayspaypalGatewayIdResponse200DataAttributes",
    "PATCHpaypalGatewayspaypalGatewayIdResponse200DataAttributesMetadata",
    "PATCHpaypalGatewayspaypalGatewayIdResponse200DataLinks",
    "PATCHpaypalGatewayspaypalGatewayIdResponse200DataRelationships",
    "PATCHpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaymentMethods",
    "PATCHpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaymentMethodsData",
    "PATCHpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaymentMethodsDataType",
    "PATCHpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaymentMethodsLinks",
    "PATCHpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaypalPayments",
    "PATCHpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaypalPaymentsData",
    "PATCHpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaypalPaymentsDataType",
    "PATCHpaypalGatewayspaypalGatewayIdResponse200DataRelationshipsPaypalPaymentsLinks",
    "PATCHpaypalGatewayspaypalGatewayIdResponse200DataType",
    "PATCHpaypalPaymentspaypalPaymentIdResponse200",
    "PATCHpaypalPaymentspaypalPaymentIdResponse200Data",
    "PATCHpaypalPaymentspaypalPaymentIdResponse200DataAttributes",
    "PATCHpaypalPaymentspaypalPaymentIdResponse200DataAttributesMetadata",
    "PATCHpaypalPaymentspaypalPaymentIdResponse200DataLinks",
    "PATCHpaypalPaymentspaypalPaymentIdResponse200DataRelationships",
    "PATCHpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsOrder",
    "PATCHpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsOrderData",
    "PATCHpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsOrderDataType",
    "PATCHpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsOrderLinks",
    "PATCHpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsPaymentGateway",
    "PATCHpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsPaymentGatewayData",
    "PATCHpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsPaymentGatewayDataType",
    "PATCHpaypalPaymentspaypalPaymentIdResponse200DataRelationshipsPaymentGatewayLinks",
    "PATCHpaypalPaymentspaypalPaymentIdResponse200DataType",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200Data",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataAttributes",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataAttributesMetadata",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataLinks",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationships",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsAttachments",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsAttachmentsData",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRule",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleData",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleDataType",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsCouponCodesPromotionRuleLinks",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsMarket",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsMarketData",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsMarketDataType",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsMarketLinks",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRule",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleData",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleDataType",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsOrderAmountPromotionRuleLinks",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsPromotionRules",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsPromotionRulesData",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsPromotionRulesDataType",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsPromotionRulesLinks",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuList",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuListData",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuListDataType",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuListLinks",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuListPromotionRule",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuListPromotionRuleData",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuListPromotionRuleDataType",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkuListPromotionRuleLinks",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkus",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkusData",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkusDataType",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataRelationshipsSkusLinks",
    "PATCHpercentageDiscountPromotionspercentageDiscountPromotionIdResponse200DataType",
    "PATCHpriceListspriceListIdResponse200",
    "PATCHpriceListspriceListIdResponse200Data",
    "PATCHpriceListspriceListIdResponse200DataAttributes",
    "PATCHpriceListspriceListIdResponse200DataAttributesMetadata",
    "PATCHpriceListspriceListIdResponse200DataLinks",
    "PATCHpriceListspriceListIdResponse200DataRelationships",
    "PATCHpriceListspriceListIdResponse200DataRelationshipsAttachments",
    "PATCHpriceListspriceListIdResponse200DataRelationshipsAttachmentsData",
    "PATCHpriceListspriceListIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHpriceListspriceListIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHpriceListspriceListIdResponse200DataRelationshipsPrices",
    "PATCHpriceListspriceListIdResponse200DataRelationshipsPricesData",
    "PATCHpriceListspriceListIdResponse200DataRelationshipsPricesDataType",
    "PATCHpriceListspriceListIdResponse200DataRelationshipsPricesLinks",
    "PATCHpriceListspriceListIdResponse200DataType",
    "PATCHpricespriceIdResponse200",
    "PATCHpricespriceIdResponse200Data",
    "PATCHpricespriceIdResponse200DataAttributes",
    "PATCHpricespriceIdResponse200DataAttributesMetadata",
    "PATCHpricespriceIdResponse200DataLinks",
    "PATCHpricespriceIdResponse200DataRelationships",
    "PATCHpricespriceIdResponse200DataRelationshipsAttachments",
    "PATCHpricespriceIdResponse200DataRelationshipsAttachmentsData",
    "PATCHpricespriceIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHpricespriceIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHpricespriceIdResponse200DataRelationshipsPriceList",
    "PATCHpricespriceIdResponse200DataRelationshipsPriceListData",
    "PATCHpricespriceIdResponse200DataRelationshipsPriceListDataType",
    "PATCHpricespriceIdResponse200DataRelationshipsPriceListLinks",
    "PATCHpricespriceIdResponse200DataRelationshipsPriceTiers",
    "PATCHpricespriceIdResponse200DataRelationshipsPriceTiersData",
    "PATCHpricespriceIdResponse200DataRelationshipsPriceTiersDataType",
    "PATCHpricespriceIdResponse200DataRelationshipsPriceTiersLinks",
    "PATCHpricespriceIdResponse200DataRelationshipsPriceVolumeTiers",
    "PATCHpricespriceIdResponse200DataRelationshipsPriceVolumeTiersData",
    "PATCHpricespriceIdResponse200DataRelationshipsPriceVolumeTiersDataType",
    "PATCHpricespriceIdResponse200DataRelationshipsPriceVolumeTiersLinks",
    "PATCHpricespriceIdResponse200DataRelationshipsSku",
    "PATCHpricespriceIdResponse200DataRelationshipsSkuData",
    "PATCHpricespriceIdResponse200DataRelationshipsSkuDataType",
    "PATCHpricespriceIdResponse200DataRelationshipsSkuLinks",
    "PATCHpricespriceIdResponse200DataType",
    "PATCHpriceVolumeTierspriceVolumeTierIdResponse200",
    "PATCHpriceVolumeTierspriceVolumeTierIdResponse200Data",
    "PATCHpriceVolumeTierspriceVolumeTierIdResponse200DataAttributes",
    "PATCHpriceVolumeTierspriceVolumeTierIdResponse200DataAttributesMetadata",
    "PATCHpriceVolumeTierspriceVolumeTierIdResponse200DataLinks",
    "PATCHpriceVolumeTierspriceVolumeTierIdResponse200DataRelationships",
    "PATCHpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsAttachments",
    "PATCHpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsAttachmentsData",
    "PATCHpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsPrice",
    "PATCHpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsPriceData",
    "PATCHpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsPriceDataType",
    "PATCHpriceVolumeTierspriceVolumeTierIdResponse200DataRelationshipsPriceLinks",
    "PATCHpriceVolumeTierspriceVolumeTierIdResponse200DataType",
    "PATCHreturnLineItemsreturnLineItemIdResponse200",
    "PATCHreturnLineItemsreturnLineItemIdResponse200Data",
    "PATCHreturnLineItemsreturnLineItemIdResponse200DataAttributes",
    "PATCHreturnLineItemsreturnLineItemIdResponse200DataAttributesMetadata",
    "PATCHreturnLineItemsreturnLineItemIdResponse200DataAttributesReturnReason",
    "PATCHreturnLineItemsreturnLineItemIdResponse200DataLinks",
    "PATCHreturnLineItemsreturnLineItemIdResponse200DataRelationships",
    "PATCHreturnLineItemsreturnLineItemIdResponse200DataRelationshipsLineItem",
    "PATCHreturnLineItemsreturnLineItemIdResponse200DataRelationshipsLineItemData",
    "PATCHreturnLineItemsreturnLineItemIdResponse200DataRelationshipsLineItemDataType",
    "PATCHreturnLineItemsreturnLineItemIdResponse200DataRelationshipsLineItemLinks",
    "PATCHreturnLineItemsreturnLineItemIdResponse200DataRelationshipsReturn",
    "PATCHreturnLineItemsreturnLineItemIdResponse200DataRelationshipsReturnData",
    "PATCHreturnLineItemsreturnLineItemIdResponse200DataRelationshipsReturnDataType",
    "PATCHreturnLineItemsreturnLineItemIdResponse200DataRelationshipsReturnLinks",
    "PATCHreturnLineItemsreturnLineItemIdResponse200DataType",
    "PATCHreturnsreturnIdResponse200",
    "PATCHreturnsreturnIdResponse200Data",
    "PATCHreturnsreturnIdResponse200DataAttributes",
    "PATCHreturnsreturnIdResponse200DataAttributesMetadata",
    "PATCHreturnsreturnIdResponse200DataLinks",
    "PATCHreturnsreturnIdResponse200DataRelationships",
    "PATCHreturnsreturnIdResponse200DataRelationshipsAttachments",
    "PATCHreturnsreturnIdResponse200DataRelationshipsAttachmentsData",
    "PATCHreturnsreturnIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHreturnsreturnIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHreturnsreturnIdResponse200DataRelationshipsCustomer",
    "PATCHreturnsreturnIdResponse200DataRelationshipsCustomerData",
    "PATCHreturnsreturnIdResponse200DataRelationshipsCustomerDataType",
    "PATCHreturnsreturnIdResponse200DataRelationshipsCustomerLinks",
    "PATCHreturnsreturnIdResponse200DataRelationshipsDestinationAddress",
    "PATCHreturnsreturnIdResponse200DataRelationshipsDestinationAddressData",
    "PATCHreturnsreturnIdResponse200DataRelationshipsDestinationAddressDataType",
    "PATCHreturnsreturnIdResponse200DataRelationshipsDestinationAddressLinks",
    "PATCHreturnsreturnIdResponse200DataRelationshipsEvents",
    "PATCHreturnsreturnIdResponse200DataRelationshipsEventsData",
    "PATCHreturnsreturnIdResponse200DataRelationshipsEventsDataType",
    "PATCHreturnsreturnIdResponse200DataRelationshipsEventsLinks",
    "PATCHreturnsreturnIdResponse200DataRelationshipsOrder",
    "PATCHreturnsreturnIdResponse200DataRelationshipsOrderData",
    "PATCHreturnsreturnIdResponse200DataRelationshipsOrderDataType",
    "PATCHreturnsreturnIdResponse200DataRelationshipsOrderLinks",
    "PATCHreturnsreturnIdResponse200DataRelationshipsOriginAddress",
    "PATCHreturnsreturnIdResponse200DataRelationshipsOriginAddressData",
    "PATCHreturnsreturnIdResponse200DataRelationshipsOriginAddressDataType",
    "PATCHreturnsreturnIdResponse200DataRelationshipsOriginAddressLinks",
    "PATCHreturnsreturnIdResponse200DataRelationshipsReturnLineItems",
    "PATCHreturnsreturnIdResponse200DataRelationshipsReturnLineItemsData",
    "PATCHreturnsreturnIdResponse200DataRelationshipsReturnLineItemsDataType",
    "PATCHreturnsreturnIdResponse200DataRelationshipsReturnLineItemsLinks",
    "PATCHreturnsreturnIdResponse200DataRelationshipsStockLocation",
    "PATCHreturnsreturnIdResponse200DataRelationshipsStockLocationData",
    "PATCHreturnsreturnIdResponse200DataRelationshipsStockLocationDataType",
    "PATCHreturnsreturnIdResponse200DataRelationshipsStockLocationLinks",
    "PATCHreturnsreturnIdResponse200DataType",
    "PATCHshipmentsshipmentIdResponse200",
    "PATCHshipmentsshipmentIdResponse200Data",
    "PATCHshipmentsshipmentIdResponse200DataAttributes",
    "PATCHshipmentsshipmentIdResponse200DataAttributesMetadata",
    "PATCHshipmentsshipmentIdResponse200DataLinks",
    "PATCHshipmentsshipmentIdResponse200DataRelationships",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsAttachments",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsAttachmentsData",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsAvailableShippingMethods",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsAvailableShippingMethodsData",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsAvailableShippingMethodsDataType",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsAvailableShippingMethodsLinks",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsCarrierAccounts",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsCarrierAccountsData",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsCarrierAccountsDataType",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsCarrierAccountsLinks",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsDeliveryLeadTime",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsDeliveryLeadTimeData",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsDeliveryLeadTimeDataType",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsDeliveryLeadTimeLinks",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsEvents",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsEventsData",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsEventsDataType",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsEventsLinks",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsOrder",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsOrderData",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsOrderDataType",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsOrderLinks",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsOriginAddress",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsOriginAddressData",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsOriginAddressDataType",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsOriginAddressLinks",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsParcels",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsParcelsData",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsParcelsDataType",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsParcelsLinks",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsShipmentLineItems",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsShipmentLineItemsData",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsShipmentLineItemsDataType",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsShipmentLineItemsLinks",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsShippingAddress",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsShippingAddressData",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsShippingAddressDataType",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsShippingAddressLinks",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsShippingCategory",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsShippingCategoryData",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsShippingCategoryDataType",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsShippingCategoryLinks",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsShippingMethod",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsShippingMethodData",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsShippingMethodDataType",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsShippingMethodLinks",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsStockLineItems",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsStockLineItemsData",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsStockLineItemsDataType",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsStockLineItemsLinks",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsStockLocation",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsStockLocationData",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsStockLocationDataType",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsStockLocationLinks",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsStockTransfers",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsStockTransfersData",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsStockTransfersDataType",
    "PATCHshipmentsshipmentIdResponse200DataRelationshipsStockTransfersLinks",
    "PATCHshipmentsshipmentIdResponse200DataType",
    "PATCHshippingCategoriesshippingCategoryIdResponse200",
    "PATCHshippingCategoriesshippingCategoryIdResponse200Data",
    "PATCHshippingCategoriesshippingCategoryIdResponse200DataAttributes",
    "PATCHshippingCategoriesshippingCategoryIdResponse200DataAttributesMetadata",
    "PATCHshippingCategoriesshippingCategoryIdResponse200DataLinks",
    "PATCHshippingCategoriesshippingCategoryIdResponse200DataRelationships",
    "PATCHshippingCategoriesshippingCategoryIdResponse200DataRelationshipsAttachments",
    "PATCHshippingCategoriesshippingCategoryIdResponse200DataRelationshipsAttachmentsData",
    "PATCHshippingCategoriesshippingCategoryIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHshippingCategoriesshippingCategoryIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHshippingCategoriesshippingCategoryIdResponse200DataRelationshipsSkus",
    "PATCHshippingCategoriesshippingCategoryIdResponse200DataRelationshipsSkusData",
    "PATCHshippingCategoriesshippingCategoryIdResponse200DataRelationshipsSkusDataType",
    "PATCHshippingCategoriesshippingCategoryIdResponse200DataRelationshipsSkusLinks",
    "PATCHshippingCategoriesshippingCategoryIdResponse200DataType",
    "PATCHshippingMethodsshippingMethodIdResponse200",
    "PATCHshippingMethodsshippingMethodIdResponse200Data",
    "PATCHshippingMethodsshippingMethodIdResponse200DataAttributes",
    "PATCHshippingMethodsshippingMethodIdResponse200DataAttributesMetadata",
    "PATCHshippingMethodsshippingMethodIdResponse200DataLinks",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationships",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsAttachments",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsAttachmentsData",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsDeliveryLeadTimeForShipment",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsDeliveryLeadTimeForShipmentData",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsDeliveryLeadTimeForShipmentDataType",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsDeliveryLeadTimeForShipmentLinks",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsMarket",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsMarketData",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsMarketDataType",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsMarketLinks",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingCategory",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingCategoryData",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingCategoryDataType",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingCategoryLinks",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingMethodTiers",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingMethodTiersData",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingMethodTiersDataType",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingMethodTiersLinks",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingWeightTiers",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingWeightTiersData",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingWeightTiersDataType",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingWeightTiersLinks",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingZone",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingZoneData",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingZoneDataType",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsShippingZoneLinks",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsStockLocation",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsStockLocationData",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsStockLocationDataType",
    "PATCHshippingMethodsshippingMethodIdResponse200DataRelationshipsStockLocationLinks",
    "PATCHshippingMethodsshippingMethodIdResponse200DataType",
    "PATCHshippingWeightTiersshippingWeightTierIdResponse200",
    "PATCHshippingWeightTiersshippingWeightTierIdResponse200Data",
    "PATCHshippingWeightTiersshippingWeightTierIdResponse200DataAttributes",
    "PATCHshippingWeightTiersshippingWeightTierIdResponse200DataAttributesMetadata",
    "PATCHshippingWeightTiersshippingWeightTierIdResponse200DataLinks",
    "PATCHshippingWeightTiersshippingWeightTierIdResponse200DataRelationships",
    "PATCHshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsAttachments",
    "PATCHshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsAttachmentsData",
    "PATCHshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsShippingMethod",
    "PATCHshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsShippingMethodData",
    "PATCHshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsShippingMethodDataType",
    "PATCHshippingWeightTiersshippingWeightTierIdResponse200DataRelationshipsShippingMethodLinks",
    "PATCHshippingWeightTiersshippingWeightTierIdResponse200DataType",
    "PATCHshippingZonesshippingZoneIdResponse200",
    "PATCHshippingZonesshippingZoneIdResponse200Data",
    "PATCHshippingZonesshippingZoneIdResponse200DataAttributes",
    "PATCHshippingZonesshippingZoneIdResponse200DataAttributesMetadata",
    "PATCHshippingZonesshippingZoneIdResponse200DataLinks",
    "PATCHshippingZonesshippingZoneIdResponse200DataRelationships",
    "PATCHshippingZonesshippingZoneIdResponse200DataRelationshipsAttachments",
    "PATCHshippingZonesshippingZoneIdResponse200DataRelationshipsAttachmentsData",
    "PATCHshippingZonesshippingZoneIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHshippingZonesshippingZoneIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHshippingZonesshippingZoneIdResponse200DataType",
    "PATCHskuListItemsskuListItemIdResponse200",
    "PATCHskuListItemsskuListItemIdResponse200Data",
    "PATCHskuListItemsskuListItemIdResponse200DataAttributes",
    "PATCHskuListItemsskuListItemIdResponse200DataAttributesMetadata",
    "PATCHskuListItemsskuListItemIdResponse200DataLinks",
    "PATCHskuListItemsskuListItemIdResponse200DataRelationships",
    "PATCHskuListItemsskuListItemIdResponse200DataRelationshipsSku",
    "PATCHskuListItemsskuListItemIdResponse200DataRelationshipsSkuData",
    "PATCHskuListItemsskuListItemIdResponse200DataRelationshipsSkuDataType",
    "PATCHskuListItemsskuListItemIdResponse200DataRelationshipsSkuLinks",
    "PATCHskuListItemsskuListItemIdResponse200DataRelationshipsSkuList",
    "PATCHskuListItemsskuListItemIdResponse200DataRelationshipsSkuListData",
    "PATCHskuListItemsskuListItemIdResponse200DataRelationshipsSkuListDataType",
    "PATCHskuListItemsskuListItemIdResponse200DataRelationshipsSkuListLinks",
    "PATCHskuListItemsskuListItemIdResponse200DataType",
    "PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200",
    "PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200Data",
    "PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataAttributes",
    "PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataAttributesMetadata",
    "PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataLinks",
    "PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationships",
    "PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsPromotion",
    "PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsPromotionData",
    "PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsPromotionDataType",
    "PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsPromotionLinks",
    "PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkuList",
    "PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkuListData",
    "PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkuListDataType",
    "PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkuListLinks",
    "PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkus",
    "PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkusData",
    "PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkusDataType",
    "PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataRelationshipsSkusLinks",
    "PATCHskuListPromotionRulesskuListPromotionRuleIdResponse200DataType",
    "PATCHskuListsskuListIdResponse200",
    "PATCHskuListsskuListIdResponse200Data",
    "PATCHskuListsskuListIdResponse200DataAttributes",
    "PATCHskuListsskuListIdResponse200DataAttributesMetadata",
    "PATCHskuListsskuListIdResponse200DataLinks",
    "PATCHskuListsskuListIdResponse200DataRelationships",
    "PATCHskuListsskuListIdResponse200DataRelationshipsAttachments",
    "PATCHskuListsskuListIdResponse200DataRelationshipsAttachmentsData",
    "PATCHskuListsskuListIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHskuListsskuListIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHskuListsskuListIdResponse200DataRelationshipsBundles",
    "PATCHskuListsskuListIdResponse200DataRelationshipsBundlesData",
    "PATCHskuListsskuListIdResponse200DataRelationshipsBundlesDataType",
    "PATCHskuListsskuListIdResponse200DataRelationshipsBundlesLinks",
    "PATCHskuListsskuListIdResponse200DataRelationshipsCustomer",
    "PATCHskuListsskuListIdResponse200DataRelationshipsCustomerData",
    "PATCHskuListsskuListIdResponse200DataRelationshipsCustomerDataType",
    "PATCHskuListsskuListIdResponse200DataRelationshipsCustomerLinks",
    "PATCHskuListsskuListIdResponse200DataRelationshipsSkuListItems",
    "PATCHskuListsskuListIdResponse200DataRelationshipsSkuListItemsData",
    "PATCHskuListsskuListIdResponse200DataRelationshipsSkuListItemsDataType",
    "PATCHskuListsskuListIdResponse200DataRelationshipsSkuListItemsLinks",
    "PATCHskuListsskuListIdResponse200DataRelationshipsSkus",
    "PATCHskuListsskuListIdResponse200DataRelationshipsSkusData",
    "PATCHskuListsskuListIdResponse200DataRelationshipsSkusDataType",
    "PATCHskuListsskuListIdResponse200DataRelationshipsSkusLinks",
    "PATCHskuListsskuListIdResponse200DataType",
    "PATCHskuOptionsskuOptionIdResponse200",
    "PATCHskuOptionsskuOptionIdResponse200Data",
    "PATCHskuOptionsskuOptionIdResponse200DataAttributes",
    "PATCHskuOptionsskuOptionIdResponse200DataAttributesMetadata",
    "PATCHskuOptionsskuOptionIdResponse200DataLinks",
    "PATCHskuOptionsskuOptionIdResponse200DataRelationships",
    "PATCHskuOptionsskuOptionIdResponse200DataRelationshipsAttachments",
    "PATCHskuOptionsskuOptionIdResponse200DataRelationshipsAttachmentsData",
    "PATCHskuOptionsskuOptionIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHskuOptionsskuOptionIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHskuOptionsskuOptionIdResponse200DataRelationshipsMarket",
    "PATCHskuOptionsskuOptionIdResponse200DataRelationshipsMarketData",
    "PATCHskuOptionsskuOptionIdResponse200DataRelationshipsMarketDataType",
    "PATCHskuOptionsskuOptionIdResponse200DataRelationshipsMarketLinks",
    "PATCHskuOptionsskuOptionIdResponse200DataType",
    "PATCHskusskuIdResponse200",
    "PATCHskusskuIdResponse200Data",
    "PATCHskusskuIdResponse200DataAttributes",
    "PATCHskusskuIdResponse200DataAttributesMetadata",
    "PATCHskusskuIdResponse200DataLinks",
    "PATCHskusskuIdResponse200DataRelationships",
    "PATCHskusskuIdResponse200DataRelationshipsAttachments",
    "PATCHskusskuIdResponse200DataRelationshipsAttachmentsData",
    "PATCHskusskuIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHskusskuIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHskusskuIdResponse200DataRelationshipsDeliveryLeadTimes",
    "PATCHskusskuIdResponse200DataRelationshipsDeliveryLeadTimesData",
    "PATCHskusskuIdResponse200DataRelationshipsDeliveryLeadTimesDataType",
    "PATCHskusskuIdResponse200DataRelationshipsDeliveryLeadTimesLinks",
    "PATCHskusskuIdResponse200DataRelationshipsPrices",
    "PATCHskusskuIdResponse200DataRelationshipsPricesData",
    "PATCHskusskuIdResponse200DataRelationshipsPricesDataType",
    "PATCHskusskuIdResponse200DataRelationshipsPricesLinks",
    "PATCHskusskuIdResponse200DataRelationshipsShippingCategory",
    "PATCHskusskuIdResponse200DataRelationshipsShippingCategoryData",
    "PATCHskusskuIdResponse200DataRelationshipsShippingCategoryDataType",
    "PATCHskusskuIdResponse200DataRelationshipsShippingCategoryLinks",
    "PATCHskusskuIdResponse200DataRelationshipsSkuOptions",
    "PATCHskusskuIdResponse200DataRelationshipsSkuOptionsData",
    "PATCHskusskuIdResponse200DataRelationshipsSkuOptionsDataType",
    "PATCHskusskuIdResponse200DataRelationshipsSkuOptionsLinks",
    "PATCHskusskuIdResponse200DataRelationshipsStockItems",
    "PATCHskusskuIdResponse200DataRelationshipsStockItemsData",
    "PATCHskusskuIdResponse200DataRelationshipsStockItemsDataType",
    "PATCHskusskuIdResponse200DataRelationshipsStockItemsLinks",
    "PATCHskusskuIdResponse200DataType",
    "PATCHstockItemsstockItemIdResponse200",
    "PATCHstockItemsstockItemIdResponse200Data",
    "PATCHstockItemsstockItemIdResponse200DataAttributes",
    "PATCHstockItemsstockItemIdResponse200DataAttributesMetadata",
    "PATCHstockItemsstockItemIdResponse200DataLinks",
    "PATCHstockItemsstockItemIdResponse200DataRelationships",
    "PATCHstockItemsstockItemIdResponse200DataRelationshipsAttachments",
    "PATCHstockItemsstockItemIdResponse200DataRelationshipsAttachmentsData",
    "PATCHstockItemsstockItemIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHstockItemsstockItemIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHstockItemsstockItemIdResponse200DataRelationshipsSku",
    "PATCHstockItemsstockItemIdResponse200DataRelationshipsSkuData",
    "PATCHstockItemsstockItemIdResponse200DataRelationshipsSkuDataType",
    "PATCHstockItemsstockItemIdResponse200DataRelationshipsSkuLinks",
    "PATCHstockItemsstockItemIdResponse200DataRelationshipsStockLocation",
    "PATCHstockItemsstockItemIdResponse200DataRelationshipsStockLocationData",
    "PATCHstockItemsstockItemIdResponse200DataRelationshipsStockLocationDataType",
    "PATCHstockItemsstockItemIdResponse200DataRelationshipsStockLocationLinks",
    "PATCHstockItemsstockItemIdResponse200DataType",
    "PATCHstockLocationsstockLocationIdResponse200",
    "PATCHstockLocationsstockLocationIdResponse200Data",
    "PATCHstockLocationsstockLocationIdResponse200DataAttributes",
    "PATCHstockLocationsstockLocationIdResponse200DataAttributesMetadata",
    "PATCHstockLocationsstockLocationIdResponse200DataLinks",
    "PATCHstockLocationsstockLocationIdResponse200DataRelationships",
    "PATCHstockLocationsstockLocationIdResponse200DataRelationshipsAddress",
    "PATCHstockLocationsstockLocationIdResponse200DataRelationshipsAddressData",
    "PATCHstockLocationsstockLocationIdResponse200DataRelationshipsAddressDataType",
    "PATCHstockLocationsstockLocationIdResponse200DataRelationshipsAddressLinks",
    "PATCHstockLocationsstockLocationIdResponse200DataRelationshipsAttachments",
    "PATCHstockLocationsstockLocationIdResponse200DataRelationshipsAttachmentsData",
    "PATCHstockLocationsstockLocationIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHstockLocationsstockLocationIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHstockLocationsstockLocationIdResponse200DataRelationshipsInventoryReturnLocations",
    "PATCHstockLocationsstockLocationIdResponse200DataRelationshipsInventoryReturnLocationsData",
    "PATCHstockLocationsstockLocationIdResponse200DataRelationshipsInventoryReturnLocationsDataType",
    "PATCHstockLocationsstockLocationIdResponse200DataRelationshipsInventoryReturnLocationsLinks",
    "PATCHstockLocationsstockLocationIdResponse200DataRelationshipsInventoryStockLocations",
    "PATCHstockLocationsstockLocationIdResponse200DataRelationshipsInventoryStockLocationsData",
    "PATCHstockLocationsstockLocationIdResponse200DataRelationshipsInventoryStockLocationsDataType",
    "PATCHstockLocationsstockLocationIdResponse200DataRelationshipsInventoryStockLocationsLinks",
    "PATCHstockLocationsstockLocationIdResponse200DataRelationshipsStockItems",
    "PATCHstockLocationsstockLocationIdResponse200DataRelationshipsStockItemsData",
    "PATCHstockLocationsstockLocationIdResponse200DataRelationshipsStockItemsDataType",
    "PATCHstockLocationsstockLocationIdResponse200DataRelationshipsStockItemsLinks",
    "PATCHstockLocationsstockLocationIdResponse200DataRelationshipsStockTransfers",
    "PATCHstockLocationsstockLocationIdResponse200DataRelationshipsStockTransfersData",
    "PATCHstockLocationsstockLocationIdResponse200DataRelationshipsStockTransfersDataType",
    "PATCHstockLocationsstockLocationIdResponse200DataRelationshipsStockTransfersLinks",
    "PATCHstockLocationsstockLocationIdResponse200DataType",
    "PATCHstockTransfersstockTransferIdResponse200",
    "PATCHstockTransfersstockTransferIdResponse200Data",
    "PATCHstockTransfersstockTransferIdResponse200DataAttributes",
    "PATCHstockTransfersstockTransferIdResponse200DataAttributesMetadata",
    "PATCHstockTransfersstockTransferIdResponse200DataLinks",
    "PATCHstockTransfersstockTransferIdResponse200DataRelationships",
    "PATCHstockTransfersstockTransferIdResponse200DataRelationshipsDestinationStockLocation",
    "PATCHstockTransfersstockTransferIdResponse200DataRelationshipsDestinationStockLocationData",
    "PATCHstockTransfersstockTransferIdResponse200DataRelationshipsDestinationStockLocationDataType",
    "PATCHstockTransfersstockTransferIdResponse200DataRelationshipsDestinationStockLocationLinks",
    "PATCHstockTransfersstockTransferIdResponse200DataRelationshipsEvents",
    "PATCHstockTransfersstockTransferIdResponse200DataRelationshipsEventsData",
    "PATCHstockTransfersstockTransferIdResponse200DataRelationshipsEventsDataType",
    "PATCHstockTransfersstockTransferIdResponse200DataRelationshipsEventsLinks",
    "PATCHstockTransfersstockTransferIdResponse200DataRelationshipsLineItem",
    "PATCHstockTransfersstockTransferIdResponse200DataRelationshipsLineItemData",
    "PATCHstockTransfersstockTransferIdResponse200DataRelationshipsLineItemDataType",
    "PATCHstockTransfersstockTransferIdResponse200DataRelationshipsLineItemLinks",
    "PATCHstockTransfersstockTransferIdResponse200DataRelationshipsOriginStockLocation",
    "PATCHstockTransfersstockTransferIdResponse200DataRelationshipsOriginStockLocationData",
    "PATCHstockTransfersstockTransferIdResponse200DataRelationshipsOriginStockLocationDataType",
    "PATCHstockTransfersstockTransferIdResponse200DataRelationshipsOriginStockLocationLinks",
    "PATCHstockTransfersstockTransferIdResponse200DataRelationshipsShipment",
    "PATCHstockTransfersstockTransferIdResponse200DataRelationshipsShipmentData",
    "PATCHstockTransfersstockTransferIdResponse200DataRelationshipsShipmentDataType",
    "PATCHstockTransfersstockTransferIdResponse200DataRelationshipsShipmentLinks",
    "PATCHstockTransfersstockTransferIdResponse200DataRelationshipsSku",
    "PATCHstockTransfersstockTransferIdResponse200DataRelationshipsSkuData",
    "PATCHstockTransfersstockTransferIdResponse200DataRelationshipsSkuDataType",
    "PATCHstockTransfersstockTransferIdResponse200DataRelationshipsSkuLinks",
    "PATCHstockTransfersstockTransferIdResponse200DataType",
    "PATCHstripeGatewaysstripeGatewayIdResponse200",
    "PATCHstripeGatewaysstripeGatewayIdResponse200Data",
    "PATCHstripeGatewaysstripeGatewayIdResponse200DataAttributes",
    "PATCHstripeGatewaysstripeGatewayIdResponse200DataAttributesMetadata",
    "PATCHstripeGatewaysstripeGatewayIdResponse200DataLinks",
    "PATCHstripeGatewaysstripeGatewayIdResponse200DataRelationships",
    "PATCHstripeGatewaysstripeGatewayIdResponse200DataRelationshipsPaymentMethods",
    "PATCHstripeGatewaysstripeGatewayIdResponse200DataRelationshipsPaymentMethodsData",
    "PATCHstripeGatewaysstripeGatewayIdResponse200DataRelationshipsPaymentMethodsDataType",
    "PATCHstripeGatewaysstripeGatewayIdResponse200DataRelationshipsPaymentMethodsLinks",
    "PATCHstripeGatewaysstripeGatewayIdResponse200DataRelationshipsStripePayments",
    "PATCHstripeGatewaysstripeGatewayIdResponse200DataRelationshipsStripePaymentsData",
    "PATCHstripeGatewaysstripeGatewayIdResponse200DataRelationshipsStripePaymentsDataType",
    "PATCHstripeGatewaysstripeGatewayIdResponse200DataRelationshipsStripePaymentsLinks",
    "PATCHstripeGatewaysstripeGatewayIdResponse200DataType",
    "PATCHstripePaymentsstripePaymentIdResponse200",
    "PATCHstripePaymentsstripePaymentIdResponse200Data",
    "PATCHstripePaymentsstripePaymentIdResponse200DataAttributes",
    "PATCHstripePaymentsstripePaymentIdResponse200DataAttributesMetadata",
    "PATCHstripePaymentsstripePaymentIdResponse200DataAttributesOptions",
    "PATCHstripePaymentsstripePaymentIdResponse200DataLinks",
    "PATCHstripePaymentsstripePaymentIdResponse200DataRelationships",
    "PATCHstripePaymentsstripePaymentIdResponse200DataRelationshipsOrder",
    "PATCHstripePaymentsstripePaymentIdResponse200DataRelationshipsOrderData",
    "PATCHstripePaymentsstripePaymentIdResponse200DataRelationshipsOrderDataType",
    "PATCHstripePaymentsstripePaymentIdResponse200DataRelationshipsOrderLinks",
    "PATCHstripePaymentsstripePaymentIdResponse200DataRelationshipsPaymentGateway",
    "PATCHstripePaymentsstripePaymentIdResponse200DataRelationshipsPaymentGatewayData",
    "PATCHstripePaymentsstripePaymentIdResponse200DataRelationshipsPaymentGatewayDataType",
    "PATCHstripePaymentsstripePaymentIdResponse200DataRelationshipsPaymentGatewayLinks",
    "PATCHstripePaymentsstripePaymentIdResponse200DataType",
    "PATCHtaxCategoriestaxCategoryIdResponse200",
    "PATCHtaxCategoriestaxCategoryIdResponse200Data",
    "PATCHtaxCategoriestaxCategoryIdResponse200DataAttributes",
    "PATCHtaxCategoriestaxCategoryIdResponse200DataAttributesMetadata",
    "PATCHtaxCategoriestaxCategoryIdResponse200DataLinks",
    "PATCHtaxCategoriestaxCategoryIdResponse200DataRelationships",
    "PATCHtaxCategoriestaxCategoryIdResponse200DataRelationshipsAttachments",
    "PATCHtaxCategoriestaxCategoryIdResponse200DataRelationshipsAttachmentsData",
    "PATCHtaxCategoriestaxCategoryIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHtaxCategoriestaxCategoryIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHtaxCategoriestaxCategoryIdResponse200DataRelationshipsSku",
    "PATCHtaxCategoriestaxCategoryIdResponse200DataRelationshipsSkuData",
    "PATCHtaxCategoriestaxCategoryIdResponse200DataRelationshipsSkuDataType",
    "PATCHtaxCategoriestaxCategoryIdResponse200DataRelationshipsSkuLinks",
    "PATCHtaxCategoriestaxCategoryIdResponse200DataRelationshipsTaxCalculator",
    "PATCHtaxCategoriestaxCategoryIdResponse200DataRelationshipsTaxCalculatorData",
    "PATCHtaxCategoriestaxCategoryIdResponse200DataRelationshipsTaxCalculatorDataType",
    "PATCHtaxCategoriestaxCategoryIdResponse200DataRelationshipsTaxCalculatorLinks",
    "PATCHtaxCategoriestaxCategoryIdResponse200DataType",
    "PATCHtaxjarAccountstaxjarAccountIdResponse200",
    "PATCHtaxjarAccountstaxjarAccountIdResponse200Data",
    "PATCHtaxjarAccountstaxjarAccountIdResponse200DataAttributes",
    "PATCHtaxjarAccountstaxjarAccountIdResponse200DataAttributesMetadata",
    "PATCHtaxjarAccountstaxjarAccountIdResponse200DataLinks",
    "PATCHtaxjarAccountstaxjarAccountIdResponse200DataRelationships",
    "PATCHtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsAttachments",
    "PATCHtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsAttachmentsData",
    "PATCHtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsAttachmentsDataType",
    "PATCHtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsAttachmentsLinks",
    "PATCHtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsMarkets",
    "PATCHtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsMarketsData",
    "PATCHtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsMarketsDataType",
    "PATCHtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsMarketsLinks",
    "PATCHtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsTaxCategories",
    "PATCHtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsTaxCategoriesData",
    "PATCHtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsTaxCategoriesDataType",
    "PATCHtaxjarAccountstaxjarAccountIdResponse200DataRelationshipsTaxCategoriesLinks",
    "PATCHtaxjarAccountstaxjarAccountIdResponse200DataType",
    "PATCHtaxRulestaxRuleIdResponse200",
    "PATCHtaxRulestaxRuleIdResponse200Data",
    "PATCHtaxRulestaxRuleIdResponse200DataAttributes",
    "PATCHtaxRulestaxRuleIdResponse200DataAttributesMetadata",
    "PATCHtaxRulestaxRuleIdResponse200DataLinks",
    "PATCHtaxRulestaxRuleIdResponse200DataRelationships",
    "PATCHtaxRulestaxRuleIdResponse200DataRelationshipsManualTaxCalculator",
    "PATCHtaxRulestaxRuleIdResponse200DataRelationshipsManualTaxCalculatorData",
    "PATCHtaxRulestaxRuleIdResponse200DataRelationshipsManualTaxCalculatorDataType",
    "PATCHtaxRulestaxRuleIdResponse200DataRelationshipsManualTaxCalculatorLinks",
    "PATCHtaxRulestaxRuleIdResponse200DataType",
    "PATCHwebhookswebhookIdResponse200",
    "PATCHwebhookswebhookIdResponse200Data",
    "PATCHwebhookswebhookIdResponse200DataAttributes",
    "PATCHwebhookswebhookIdResponse200DataAttributesMetadata",
    "PATCHwebhookswebhookIdResponse200DataLinks",
    "PATCHwebhookswebhookIdResponse200DataRelationships",
    "PATCHwebhookswebhookIdResponse200DataRelationshipsLastEventCallbacks",
    "PATCHwebhookswebhookIdResponse200DataRelationshipsLastEventCallbacksData",
    "PATCHwebhookswebhookIdResponse200DataRelationshipsLastEventCallbacksDataType",
    "PATCHwebhookswebhookIdResponse200DataRelationshipsLastEventCallbacksLinks",
    "PATCHwebhookswebhookIdResponse200DataType",
    "PATCHwireTransferswireTransferIdResponse200",
    "PATCHwireTransferswireTransferIdResponse200Data",
    "PATCHwireTransferswireTransferIdResponse200DataAttributes",
    "PATCHwireTransferswireTransferIdResponse200DataAttributesMetadata",
    "PATCHwireTransferswireTransferIdResponse200DataLinks",
    "PATCHwireTransferswireTransferIdResponse200DataRelationships",
    "PATCHwireTransferswireTransferIdResponse200DataRelationshipsOrder",
    "PATCHwireTransferswireTransferIdResponse200DataRelationshipsOrderData",
    "PATCHwireTransferswireTransferIdResponse200DataRelationshipsOrderDataType",
    "PATCHwireTransferswireTransferIdResponse200DataRelationshipsOrderLinks",
    "PATCHwireTransferswireTransferIdResponse200DataType",
    "PaymentGateway",
    "PaymentGatewayData",
    "PaymentGatewayDataAttributes",
    "PaymentGatewayDataAttributesMetadata",
    "PaymentGatewayDataRelationships",
    "PaymentGatewayDataRelationshipsPaymentMethods",
    "PaymentGatewayDataRelationshipsPaymentMethodsData",
    "PaymentGatewayDataRelationshipsPaymentMethodsDataType",
    "PaymentGatewayDataType",
    "PaymentMethod",
    "PaymentMethodCreate",
    "PaymentMethodCreateData",
    "PaymentMethodCreateDataAttributes",
    "PaymentMethodCreateDataAttributesMetadata",
    "PaymentMethodCreateDataRelationships",
    "PaymentMethodCreateDataRelationshipsMarket",
    "PaymentMethodCreateDataRelationshipsMarketData",
    "PaymentMethodCreateDataRelationshipsMarketDataType",
    "PaymentMethodCreateDataRelationshipsPaymentGateway",
    "PaymentMethodCreateDataRelationshipsPaymentGatewayData",
    "PaymentMethodCreateDataRelationshipsPaymentGatewayDataType",
    "PaymentMethodCreateDataType",
    "PaymentMethodData",
    "PaymentMethodDataAttributes",
    "PaymentMethodDataAttributesMetadata",
    "PaymentMethodDataRelationships",
    "PaymentMethodDataRelationshipsAttachments",
    "PaymentMethodDataRelationshipsAttachmentsData",
    "PaymentMethodDataRelationshipsAttachmentsDataType",
    "PaymentMethodDataRelationshipsMarket",
    "PaymentMethodDataRelationshipsMarketData",
    "PaymentMethodDataRelationshipsMarketDataType",
    "PaymentMethodDataRelationshipsPaymentGateway",
    "PaymentMethodDataRelationshipsPaymentGatewayData",
    "PaymentMethodDataRelationshipsPaymentGatewayDataType",
    "PaymentMethodDataType",
    "PaymentMethodUpdate",
    "PaymentMethodUpdateData",
    "PaymentMethodUpdateDataAttributes",
    "PaymentMethodUpdateDataAttributesMetadata",
    "PaymentMethodUpdateDataRelationships",
    "PaymentMethodUpdateDataRelationshipsMarket",
    "PaymentMethodUpdateDataRelationshipsMarketData",
    "PaymentMethodUpdateDataRelationshipsMarketDataType",
    "PaymentMethodUpdateDataRelationshipsPaymentGateway",
    "PaymentMethodUpdateDataRelationshipsPaymentGatewayData",
    "PaymentMethodUpdateDataRelationshipsPaymentGatewayDataType",
    "PaymentMethodUpdateDataType",
    "PaypalGateway",
    "PaypalGatewayCreate",
    "PaypalGatewayCreateData",
    "PaypalGatewayCreateDataAttributes",
    "PaypalGatewayCreateDataAttributesMetadata",
    "PaypalGatewayCreateDataRelationships",
    "PaypalGatewayCreateDataType",
    "PaypalGatewayData",
    "PaypalGatewayDataAttributes",
    "PaypalGatewayDataAttributesMetadata",
    "PaypalGatewayDataRelationships",
    "PaypalGatewayDataRelationshipsPaymentMethods",
    "PaypalGatewayDataRelationshipsPaymentMethodsData",
    "PaypalGatewayDataRelationshipsPaymentMethodsDataType",
    "PaypalGatewayDataRelationshipsPaypalPayments",
    "PaypalGatewayDataRelationshipsPaypalPaymentsData",
    "PaypalGatewayDataRelationshipsPaypalPaymentsDataType",
    "PaypalGatewayDataType",
    "PaypalGatewayUpdate",
    "PaypalGatewayUpdateData",
    "PaypalGatewayUpdateDataAttributes",
    "PaypalGatewayUpdateDataAttributesMetadata",
    "PaypalGatewayUpdateDataRelationships",
    "PaypalGatewayUpdateDataType",
    "PaypalPayment",
    "PaypalPaymentCreate",
    "PaypalPaymentCreateData",
    "PaypalPaymentCreateDataAttributes",
    "PaypalPaymentCreateDataAttributesMetadata",
    "PaypalPaymentCreateDataRelationships",
    "PaypalPaymentCreateDataRelationshipsOrder",
    "PaypalPaymentCreateDataRelationshipsOrderData",
    "PaypalPaymentCreateDataRelationshipsOrderDataType",
    "PaypalPaymentCreateDataType",
    "PaypalPaymentData",
    "PaypalPaymentDataAttributes",
    "PaypalPaymentDataAttributesMetadata",
    "PaypalPaymentDataRelationships",
    "PaypalPaymentDataRelationshipsOrder",
    "PaypalPaymentDataRelationshipsOrderData",
    "PaypalPaymentDataRelationshipsOrderDataType",
    "PaypalPaymentDataRelationshipsPaymentGateway",
    "PaypalPaymentDataRelationshipsPaymentGatewayData",
    "PaypalPaymentDataRelationshipsPaymentGatewayDataType",
    "PaypalPaymentDataType",
    "PaypalPaymentUpdate",
    "PaypalPaymentUpdateData",
    "PaypalPaymentUpdateDataAttributes",
    "PaypalPaymentUpdateDataAttributesMetadata",
    "PaypalPaymentUpdateDataRelationships",
    "PaypalPaymentUpdateDataRelationshipsOrder",
    "PaypalPaymentUpdateDataRelationshipsOrderData",
    "PaypalPaymentUpdateDataRelationshipsOrderDataType",
    "PaypalPaymentUpdateDataType",
    "PercentageDiscountPromotion",
    "PercentageDiscountPromotionCreate",
    "PercentageDiscountPromotionCreateData",
    "PercentageDiscountPromotionCreateDataAttributes",
    "PercentageDiscountPromotionCreateDataAttributesMetadata",
    "PercentageDiscountPromotionCreateDataRelationships",
    "PercentageDiscountPromotionCreateDataRelationshipsCouponCodesPromotionRule",
    "PercentageDiscountPromotionCreateDataRelationshipsCouponCodesPromotionRuleData",
    "PercentageDiscountPromotionCreateDataRelationshipsCouponCodesPromotionRuleDataType",
    "PercentageDiscountPromotionCreateDataRelationshipsMarket",
    "PercentageDiscountPromotionCreateDataRelationshipsMarketData",
    "PercentageDiscountPromotionCreateDataRelationshipsMarketDataType",
    "PercentageDiscountPromotionCreateDataRelationshipsOrderAmountPromotionRule",
    "PercentageDiscountPromotionCreateDataRelationshipsOrderAmountPromotionRuleData",
    "PercentageDiscountPromotionCreateDataRelationshipsOrderAmountPromotionRuleDataType",
    "PercentageDiscountPromotionCreateDataRelationshipsPromotionRules",
    "PercentageDiscountPromotionCreateDataRelationshipsPromotionRulesData",
    "PercentageDiscountPromotionCreateDataRelationshipsPromotionRulesDataType",
    "PercentageDiscountPromotionCreateDataRelationshipsSkuList",
    "PercentageDiscountPromotionCreateDataRelationshipsSkuListData",
    "PercentageDiscountPromotionCreateDataRelationshipsSkuListDataType",
    "PercentageDiscountPromotionCreateDataRelationshipsSkuListPromotionRule",
    "PercentageDiscountPromotionCreateDataRelationshipsSkuListPromotionRuleData",
    "PercentageDiscountPromotionCreateDataRelationshipsSkuListPromotionRuleDataType",
    "PercentageDiscountPromotionCreateDataType",
    "PercentageDiscountPromotionData",
    "PercentageDiscountPromotionDataAttributes",
    "PercentageDiscountPromotionDataAttributesMetadata",
    "PercentageDiscountPromotionDataRelationships",
    "PercentageDiscountPromotionDataRelationshipsAttachments",
    "PercentageDiscountPromotionDataRelationshipsAttachmentsData",
    "PercentageDiscountPromotionDataRelationshipsAttachmentsDataType",
    "PercentageDiscountPromotionDataRelationshipsCouponCodesPromotionRule",
    "PercentageDiscountPromotionDataRelationshipsCouponCodesPromotionRuleData",
    "PercentageDiscountPromotionDataRelationshipsCouponCodesPromotionRuleDataType",
    "PercentageDiscountPromotionDataRelationshipsMarket",
    "PercentageDiscountPromotionDataRelationshipsMarketData",
    "PercentageDiscountPromotionDataRelationshipsMarketDataType",
    "PercentageDiscountPromotionDataRelationshipsOrderAmountPromotionRule",
    "PercentageDiscountPromotionDataRelationshipsOrderAmountPromotionRuleData",
    "PercentageDiscountPromotionDataRelationshipsOrderAmountPromotionRuleDataType",
    "PercentageDiscountPromotionDataRelationshipsPromotionRules",
    "PercentageDiscountPromotionDataRelationshipsPromotionRulesData",
    "PercentageDiscountPromotionDataRelationshipsPromotionRulesDataType",
    "PercentageDiscountPromotionDataRelationshipsSkuList",
    "PercentageDiscountPromotionDataRelationshipsSkuListData",
    "PercentageDiscountPromotionDataRelationshipsSkuListDataType",
    "PercentageDiscountPromotionDataRelationshipsSkuListPromotionRule",
    "PercentageDiscountPromotionDataRelationshipsSkuListPromotionRuleData",
    "PercentageDiscountPromotionDataRelationshipsSkuListPromotionRuleDataType",
    "PercentageDiscountPromotionDataRelationshipsSkus",
    "PercentageDiscountPromotionDataRelationshipsSkusData",
    "PercentageDiscountPromotionDataRelationshipsSkusDataType",
    "PercentageDiscountPromotionDataType",
    "PercentageDiscountPromotionUpdate",
    "PercentageDiscountPromotionUpdateData",
    "PercentageDiscountPromotionUpdateDataAttributes",
    "PercentageDiscountPromotionUpdateDataAttributesMetadata",
    "PercentageDiscountPromotionUpdateDataRelationships",
    "PercentageDiscountPromotionUpdateDataRelationshipsCouponCodesPromotionRule",
    "PercentageDiscountPromotionUpdateDataRelationshipsCouponCodesPromotionRuleData",
    "PercentageDiscountPromotionUpdateDataRelationshipsCouponCodesPromotionRuleDataType",
    "PercentageDiscountPromotionUpdateDataRelationshipsMarket",
    "PercentageDiscountPromotionUpdateDataRelationshipsMarketData",
    "PercentageDiscountPromotionUpdateDataRelationshipsMarketDataType",
    "PercentageDiscountPromotionUpdateDataRelationshipsOrderAmountPromotionRule",
    "PercentageDiscountPromotionUpdateDataRelationshipsOrderAmountPromotionRuleData",
    "PercentageDiscountPromotionUpdateDataRelationshipsOrderAmountPromotionRuleDataType",
    "PercentageDiscountPromotionUpdateDataRelationshipsPromotionRules",
    "PercentageDiscountPromotionUpdateDataRelationshipsPromotionRulesData",
    "PercentageDiscountPromotionUpdateDataRelationshipsPromotionRulesDataType",
    "PercentageDiscountPromotionUpdateDataRelationshipsSkuList",
    "PercentageDiscountPromotionUpdateDataRelationshipsSkuListData",
    "PercentageDiscountPromotionUpdateDataRelationshipsSkuListDataType",
    "PercentageDiscountPromotionUpdateDataRelationshipsSkuListPromotionRule",
    "PercentageDiscountPromotionUpdateDataRelationshipsSkuListPromotionRuleData",
    "PercentageDiscountPromotionUpdateDataRelationshipsSkuListPromotionRuleDataType",
    "PercentageDiscountPromotionUpdateDataType",
    "POSTaddressesResponse201",
    "POSTaddressesResponse201Data",
    "POSTaddressesResponse201DataAttributes",
    "POSTaddressesResponse201DataAttributesMetadata",
    "POSTaddressesResponse201DataLinks",
    "POSTaddressesResponse201DataRelationships",
    "POSTaddressesResponse201DataRelationshipsGeocoder",
    "POSTaddressesResponse201DataRelationshipsGeocoderData",
    "POSTaddressesResponse201DataRelationshipsGeocoderDataType",
    "POSTaddressesResponse201DataRelationshipsGeocoderLinks",
    "POSTaddressesResponse201DataType",
    "POSTadjustmentsResponse201",
    "POSTadjustmentsResponse201Data",
    "POSTadjustmentsResponse201DataAttributes",
    "POSTadjustmentsResponse201DataAttributesMetadata",
    "POSTadjustmentsResponse201DataLinks",
    "POSTadjustmentsResponse201DataRelationships",
    "POSTadjustmentsResponse201DataType",
    "POSTadyenGatewaysResponse201",
    "POSTadyenGatewaysResponse201Data",
    "POSTadyenGatewaysResponse201DataAttributes",
    "POSTadyenGatewaysResponse201DataAttributesMetadata",
    "POSTadyenGatewaysResponse201DataLinks",
    "POSTadyenGatewaysResponse201DataRelationships",
    "POSTadyenGatewaysResponse201DataRelationshipsAdyenPayments",
    "POSTadyenGatewaysResponse201DataRelationshipsAdyenPaymentsData",
    "POSTadyenGatewaysResponse201DataRelationshipsAdyenPaymentsDataType",
    "POSTadyenGatewaysResponse201DataRelationshipsAdyenPaymentsLinks",
    "POSTadyenGatewaysResponse201DataRelationshipsPaymentMethods",
    "POSTadyenGatewaysResponse201DataRelationshipsPaymentMethodsData",
    "POSTadyenGatewaysResponse201DataRelationshipsPaymentMethodsDataType",
    "POSTadyenGatewaysResponse201DataRelationshipsPaymentMethodsLinks",
    "POSTadyenGatewaysResponse201DataType",
    "POSTadyenPaymentsResponse201",
    "POSTadyenPaymentsResponse201Data",
    "POSTadyenPaymentsResponse201DataAttributes",
    "POSTadyenPaymentsResponse201DataAttributesMetadata",
    "POSTadyenPaymentsResponse201DataLinks",
    "POSTadyenPaymentsResponse201DataRelationships",
    "POSTadyenPaymentsResponse201DataRelationshipsOrder",
    "POSTadyenPaymentsResponse201DataRelationshipsOrderData",
    "POSTadyenPaymentsResponse201DataRelationshipsOrderDataType",
    "POSTadyenPaymentsResponse201DataRelationshipsOrderLinks",
    "POSTadyenPaymentsResponse201DataRelationshipsPaymentGateway",
    "POSTadyenPaymentsResponse201DataRelationshipsPaymentGatewayData",
    "POSTadyenPaymentsResponse201DataRelationshipsPaymentGatewayDataType",
    "POSTadyenPaymentsResponse201DataRelationshipsPaymentGatewayLinks",
    "POSTadyenPaymentsResponse201DataType",
    "POSTattachmentsResponse201",
    "POSTattachmentsResponse201Data",
    "POSTattachmentsResponse201DataAttributes",
    "POSTattachmentsResponse201DataAttributesMetadata",
    "POSTattachmentsResponse201DataLinks",
    "POSTattachmentsResponse201DataRelationships",
    "POSTattachmentsResponse201DataRelationshipsAttachable",
    "POSTattachmentsResponse201DataRelationshipsAttachableData",
    "POSTattachmentsResponse201DataRelationshipsAttachableDataType",
    "POSTattachmentsResponse201DataRelationshipsAttachableLinks",
    "POSTattachmentsResponse201DataType",
    "POSTavalaraAccountsResponse201",
    "POSTavalaraAccountsResponse201Data",
    "POSTavalaraAccountsResponse201DataAttributes",
    "POSTavalaraAccountsResponse201DataAttributesMetadata",
    "POSTavalaraAccountsResponse201DataLinks",
    "POSTavalaraAccountsResponse201DataRelationships",
    "POSTavalaraAccountsResponse201DataRelationshipsAttachments",
    "POSTavalaraAccountsResponse201DataRelationshipsAttachmentsData",
    "POSTavalaraAccountsResponse201DataRelationshipsAttachmentsDataType",
    "POSTavalaraAccountsResponse201DataRelationshipsAttachmentsLinks",
    "POSTavalaraAccountsResponse201DataRelationshipsMarkets",
    "POSTavalaraAccountsResponse201DataRelationshipsMarketsData",
    "POSTavalaraAccountsResponse201DataRelationshipsMarketsDataType",
    "POSTavalaraAccountsResponse201DataRelationshipsMarketsLinks",
    "POSTavalaraAccountsResponse201DataRelationshipsTaxCategories",
    "POSTavalaraAccountsResponse201DataRelationshipsTaxCategoriesData",
    "POSTavalaraAccountsResponse201DataRelationshipsTaxCategoriesDataType",
    "POSTavalaraAccountsResponse201DataRelationshipsTaxCategoriesLinks",
    "POSTavalaraAccountsResponse201DataType",
    "POSTbillingInfoValidationRulesResponse201",
    "POSTbillingInfoValidationRulesResponse201Data",
    "POSTbillingInfoValidationRulesResponse201DataAttributes",
    "POSTbillingInfoValidationRulesResponse201DataAttributesMetadata",
    "POSTbillingInfoValidationRulesResponse201DataLinks",
    "POSTbillingInfoValidationRulesResponse201DataRelationships",
    "POSTbillingInfoValidationRulesResponse201DataRelationshipsMarket",
    "POSTbillingInfoValidationRulesResponse201DataRelationshipsMarketData",
    "POSTbillingInfoValidationRulesResponse201DataRelationshipsMarketDataType",
    "POSTbillingInfoValidationRulesResponse201DataRelationshipsMarketLinks",
    "POSTbillingInfoValidationRulesResponse201DataType",
    "POSTbingGeocodersResponse201",
    "POSTbingGeocodersResponse201Data",
    "POSTbingGeocodersResponse201DataAttributes",
    "POSTbingGeocodersResponse201DataAttributesMetadata",
    "POSTbingGeocodersResponse201DataLinks",
    "POSTbingGeocodersResponse201DataRelationships",
    "POSTbingGeocodersResponse201DataRelationshipsAddresses",
    "POSTbingGeocodersResponse201DataRelationshipsAddressesData",
    "POSTbingGeocodersResponse201DataRelationshipsAddressesDataType",
    "POSTbingGeocodersResponse201DataRelationshipsAddressesLinks",
    "POSTbingGeocodersResponse201DataRelationshipsAttachments",
    "POSTbingGeocodersResponse201DataRelationshipsAttachmentsData",
    "POSTbingGeocodersResponse201DataRelationshipsAttachmentsDataType",
    "POSTbingGeocodersResponse201DataRelationshipsAttachmentsLinks",
    "POSTbingGeocodersResponse201DataType",
    "POSTbraintreeGatewaysResponse201",
    "POSTbraintreeGatewaysResponse201Data",
    "POSTbraintreeGatewaysResponse201DataAttributes",
    "POSTbraintreeGatewaysResponse201DataAttributesMetadata",
    "POSTbraintreeGatewaysResponse201DataLinks",
    "POSTbraintreeGatewaysResponse201DataRelationships",
    "POSTbraintreeGatewaysResponse201DataRelationshipsBraintreePayments",
    "POSTbraintreeGatewaysResponse201DataRelationshipsBraintreePaymentsData",
    "POSTbraintreeGatewaysResponse201DataRelationshipsBraintreePaymentsDataType",
    "POSTbraintreeGatewaysResponse201DataRelationshipsBraintreePaymentsLinks",
    "POSTbraintreeGatewaysResponse201DataRelationshipsPaymentMethods",
    "POSTbraintreeGatewaysResponse201DataRelationshipsPaymentMethodsData",
    "POSTbraintreeGatewaysResponse201DataRelationshipsPaymentMethodsDataType",
    "POSTbraintreeGatewaysResponse201DataRelationshipsPaymentMethodsLinks",
    "POSTbraintreeGatewaysResponse201DataType",
    "POSTbraintreePaymentsResponse201",
    "POSTbraintreePaymentsResponse201Data",
    "POSTbraintreePaymentsResponse201DataAttributes",
    "POSTbraintreePaymentsResponse201DataAttributesMetadata",
    "POSTbraintreePaymentsResponse201DataAttributesOptions",
    "POSTbraintreePaymentsResponse201DataLinks",
    "POSTbraintreePaymentsResponse201DataRelationships",
    "POSTbraintreePaymentsResponse201DataRelationshipsOrder",
    "POSTbraintreePaymentsResponse201DataRelationshipsOrderData",
    "POSTbraintreePaymentsResponse201DataRelationshipsOrderDataType",
    "POSTbraintreePaymentsResponse201DataRelationshipsOrderLinks",
    "POSTbraintreePaymentsResponse201DataRelationshipsPaymentGateway",
    "POSTbraintreePaymentsResponse201DataRelationshipsPaymentGatewayData",
    "POSTbraintreePaymentsResponse201DataRelationshipsPaymentGatewayDataType",
    "POSTbraintreePaymentsResponse201DataRelationshipsPaymentGatewayLinks",
    "POSTbraintreePaymentsResponse201DataType",
    "POSTbundlesResponse201",
    "POSTbundlesResponse201Data",
    "POSTbundlesResponse201DataAttributes",
    "POSTbundlesResponse201DataAttributesMetadata",
    "POSTbundlesResponse201DataLinks",
    "POSTbundlesResponse201DataRelationships",
    "POSTbundlesResponse201DataRelationshipsAttachments",
    "POSTbundlesResponse201DataRelationshipsAttachmentsData",
    "POSTbundlesResponse201DataRelationshipsAttachmentsDataType",
    "POSTbundlesResponse201DataRelationshipsAttachmentsLinks",
    "POSTbundlesResponse201DataRelationshipsMarket",
    "POSTbundlesResponse201DataRelationshipsMarketData",
    "POSTbundlesResponse201DataRelationshipsMarketDataType",
    "POSTbundlesResponse201DataRelationshipsMarketLinks",
    "POSTbundlesResponse201DataRelationshipsSkuList",
    "POSTbundlesResponse201DataRelationshipsSkuListData",
    "POSTbundlesResponse201DataRelationshipsSkuListDataType",
    "POSTbundlesResponse201DataRelationshipsSkuListLinks",
    "POSTbundlesResponse201DataRelationshipsSkus",
    "POSTbundlesResponse201DataRelationshipsSkusData",
    "POSTbundlesResponse201DataRelationshipsSkusDataType",
    "POSTbundlesResponse201DataRelationshipsSkusLinks",
    "POSTbundlesResponse201DataType",
    "POSTcheckoutComGatewaysResponse201",
    "POSTcheckoutComGatewaysResponse201Data",
    "POSTcheckoutComGatewaysResponse201DataAttributes",
    "POSTcheckoutComGatewaysResponse201DataAttributesMetadata",
    "POSTcheckoutComGatewaysResponse201DataLinks",
    "POSTcheckoutComGatewaysResponse201DataRelationships",
    "POSTcheckoutComGatewaysResponse201DataRelationshipsCheckoutComPayments",
    "POSTcheckoutComGatewaysResponse201DataRelationshipsCheckoutComPaymentsData",
    "POSTcheckoutComGatewaysResponse201DataRelationshipsCheckoutComPaymentsDataType",
    "POSTcheckoutComGatewaysResponse201DataRelationshipsCheckoutComPaymentsLinks",
    "POSTcheckoutComGatewaysResponse201DataRelationshipsPaymentMethods",
    "POSTcheckoutComGatewaysResponse201DataRelationshipsPaymentMethodsData",
    "POSTcheckoutComGatewaysResponse201DataRelationshipsPaymentMethodsDataType",
    "POSTcheckoutComGatewaysResponse201DataRelationshipsPaymentMethodsLinks",
    "POSTcheckoutComGatewaysResponse201DataType",
    "POSTcheckoutComPaymentsResponse201",
    "POSTcheckoutComPaymentsResponse201Data",
    "POSTcheckoutComPaymentsResponse201DataAttributes",
    "POSTcheckoutComPaymentsResponse201DataAttributesMetadata",
    "POSTcheckoutComPaymentsResponse201DataLinks",
    "POSTcheckoutComPaymentsResponse201DataRelationships",
    "POSTcheckoutComPaymentsResponse201DataRelationshipsOrder",
    "POSTcheckoutComPaymentsResponse201DataRelationshipsOrderData",
    "POSTcheckoutComPaymentsResponse201DataRelationshipsOrderDataType",
    "POSTcheckoutComPaymentsResponse201DataRelationshipsOrderLinks",
    "POSTcheckoutComPaymentsResponse201DataRelationshipsPaymentGateway",
    "POSTcheckoutComPaymentsResponse201DataRelationshipsPaymentGatewayData",
    "POSTcheckoutComPaymentsResponse201DataRelationshipsPaymentGatewayDataType",
    "POSTcheckoutComPaymentsResponse201DataRelationshipsPaymentGatewayLinks",
    "POSTcheckoutComPaymentsResponse201DataType",
    "POSTcleanupsResponse201",
    "POSTcleanupsResponse201Data",
    "POSTcleanupsResponse201DataAttributes",
    "POSTcleanupsResponse201DataAttributesFilters",
    "POSTcleanupsResponse201DataAttributesMetadata",
    "POSTcleanupsResponse201DataLinks",
    "POSTcleanupsResponse201DataRelationships",
    "POSTcleanupsResponse201DataRelationshipsEvents",
    "POSTcleanupsResponse201DataRelationshipsEventsData",
    "POSTcleanupsResponse201DataRelationshipsEventsDataType",
    "POSTcleanupsResponse201DataRelationshipsEventsLinks",
    "POSTcleanupsResponse201DataType",
    "POSTcouponCodesPromotionRulesResponse201",
    "POSTcouponCodesPromotionRulesResponse201Data",
    "POSTcouponCodesPromotionRulesResponse201DataAttributes",
    "POSTcouponCodesPromotionRulesResponse201DataAttributesMetadata",
    "POSTcouponCodesPromotionRulesResponse201DataLinks",
    "POSTcouponCodesPromotionRulesResponse201DataRelationships",
    "POSTcouponCodesPromotionRulesResponse201DataRelationshipsCoupons",
    "POSTcouponCodesPromotionRulesResponse201DataRelationshipsCouponsData",
    "POSTcouponCodesPromotionRulesResponse201DataRelationshipsCouponsDataType",
    "POSTcouponCodesPromotionRulesResponse201DataRelationshipsCouponsLinks",
    "POSTcouponCodesPromotionRulesResponse201DataRelationshipsPromotion",
    "POSTcouponCodesPromotionRulesResponse201DataRelationshipsPromotionData",
    "POSTcouponCodesPromotionRulesResponse201DataRelationshipsPromotionDataType",
    "POSTcouponCodesPromotionRulesResponse201DataRelationshipsPromotionLinks",
    "POSTcouponCodesPromotionRulesResponse201DataType",
    "POSTcouponRecipientsResponse201",
    "POSTcouponRecipientsResponse201Data",
    "POSTcouponRecipientsResponse201DataAttributes",
    "POSTcouponRecipientsResponse201DataAttributesMetadata",
    "POSTcouponRecipientsResponse201DataLinks",
    "POSTcouponRecipientsResponse201DataRelationships",
    "POSTcouponRecipientsResponse201DataRelationshipsAttachments",
    "POSTcouponRecipientsResponse201DataRelationshipsAttachmentsData",
    "POSTcouponRecipientsResponse201DataRelationshipsAttachmentsDataType",
    "POSTcouponRecipientsResponse201DataRelationshipsAttachmentsLinks",
    "POSTcouponRecipientsResponse201DataRelationshipsCustomer",
    "POSTcouponRecipientsResponse201DataRelationshipsCustomerData",
    "POSTcouponRecipientsResponse201DataRelationshipsCustomerDataType",
    "POSTcouponRecipientsResponse201DataRelationshipsCustomerLinks",
    "POSTcouponRecipientsResponse201DataType",
    "POSTcouponsResponse201",
    "POSTcouponsResponse201Data",
    "POSTcouponsResponse201DataAttributes",
    "POSTcouponsResponse201DataAttributesMetadata",
    "POSTcouponsResponse201DataLinks",
    "POSTcouponsResponse201DataRelationships",
    "POSTcouponsResponse201DataRelationshipsPromotionRule",
    "POSTcouponsResponse201DataRelationshipsPromotionRuleData",
    "POSTcouponsResponse201DataRelationshipsPromotionRuleDataType",
    "POSTcouponsResponse201DataRelationshipsPromotionRuleLinks",
    "POSTcouponsResponse201DataType",
    "POSTcustomerAddressesResponse201",
    "POSTcustomerAddressesResponse201Data",
    "POSTcustomerAddressesResponse201DataAttributes",
    "POSTcustomerAddressesResponse201DataAttributesMetadata",
    "POSTcustomerAddressesResponse201DataLinks",
    "POSTcustomerAddressesResponse201DataRelationships",
    "POSTcustomerAddressesResponse201DataRelationshipsAddress",
    "POSTcustomerAddressesResponse201DataRelationshipsAddressData",
    "POSTcustomerAddressesResponse201DataRelationshipsAddressDataType",
    "POSTcustomerAddressesResponse201DataRelationshipsAddressLinks",
    "POSTcustomerAddressesResponse201DataRelationshipsCustomer",
    "POSTcustomerAddressesResponse201DataRelationshipsCustomerData",
    "POSTcustomerAddressesResponse201DataRelationshipsCustomerDataType",
    "POSTcustomerAddressesResponse201DataRelationshipsCustomerLinks",
    "POSTcustomerAddressesResponse201DataRelationshipsEvents",
    "POSTcustomerAddressesResponse201DataRelationshipsEventsData",
    "POSTcustomerAddressesResponse201DataRelationshipsEventsDataType",
    "POSTcustomerAddressesResponse201DataRelationshipsEventsLinks",
    "POSTcustomerAddressesResponse201DataType",
    "POSTcustomerGroupsResponse201",
    "POSTcustomerGroupsResponse201Data",
    "POSTcustomerGroupsResponse201DataAttributes",
    "POSTcustomerGroupsResponse201DataAttributesMetadata",
    "POSTcustomerGroupsResponse201DataLinks",
    "POSTcustomerGroupsResponse201DataRelationships",
    "POSTcustomerGroupsResponse201DataRelationshipsAttachments",
    "POSTcustomerGroupsResponse201DataRelationshipsAttachmentsData",
    "POSTcustomerGroupsResponse201DataRelationshipsAttachmentsDataType",
    "POSTcustomerGroupsResponse201DataRelationshipsAttachmentsLinks",
    "POSTcustomerGroupsResponse201DataRelationshipsCustomers",
    "POSTcustomerGroupsResponse201DataRelationshipsCustomersData",
    "POSTcustomerGroupsResponse201DataRelationshipsCustomersDataType",
    "POSTcustomerGroupsResponse201DataRelationshipsCustomersLinks",
    "POSTcustomerGroupsResponse201DataRelationshipsMarkets",
    "POSTcustomerGroupsResponse201DataRelationshipsMarketsData",
    "POSTcustomerGroupsResponse201DataRelationshipsMarketsDataType",
    "POSTcustomerGroupsResponse201DataRelationshipsMarketsLinks",
    "POSTcustomerGroupsResponse201DataType",
    "POSTcustomerPasswordResetsResponse201",
    "POSTcustomerPasswordResetsResponse201Data",
    "POSTcustomerPasswordResetsResponse201DataAttributes",
    "POSTcustomerPasswordResetsResponse201DataAttributesMetadata",
    "POSTcustomerPasswordResetsResponse201DataLinks",
    "POSTcustomerPasswordResetsResponse201DataRelationships",
    "POSTcustomerPasswordResetsResponse201DataRelationshipsCustomer",
    "POSTcustomerPasswordResetsResponse201DataRelationshipsCustomerData",
    "POSTcustomerPasswordResetsResponse201DataRelationshipsCustomerDataType",
    "POSTcustomerPasswordResetsResponse201DataRelationshipsCustomerLinks",
    "POSTcustomerPasswordResetsResponse201DataRelationshipsEvents",
    "POSTcustomerPasswordResetsResponse201DataRelationshipsEventsData",
    "POSTcustomerPasswordResetsResponse201DataRelationshipsEventsDataType",
    "POSTcustomerPasswordResetsResponse201DataRelationshipsEventsLinks",
    "POSTcustomerPasswordResetsResponse201DataType",
    "POSTcustomerPaymentSourcesResponse201",
    "POSTcustomerPaymentSourcesResponse201Data",
    "POSTcustomerPaymentSourcesResponse201DataAttributes",
    "POSTcustomerPaymentSourcesResponse201DataAttributesMetadata",
    "POSTcustomerPaymentSourcesResponse201DataLinks",
    "POSTcustomerPaymentSourcesResponse201DataRelationships",
    "POSTcustomerPaymentSourcesResponse201DataRelationshipsCustomer",
    "POSTcustomerPaymentSourcesResponse201DataRelationshipsCustomerData",
    "POSTcustomerPaymentSourcesResponse201DataRelationshipsCustomerDataType",
    "POSTcustomerPaymentSourcesResponse201DataRelationshipsCustomerLinks",
    "POSTcustomerPaymentSourcesResponse201DataRelationshipsPaymentSource",
    "POSTcustomerPaymentSourcesResponse201DataRelationshipsPaymentSourceData",
    "POSTcustomerPaymentSourcesResponse201DataRelationshipsPaymentSourceDataType",
    "POSTcustomerPaymentSourcesResponse201DataRelationshipsPaymentSourceLinks",
    "POSTcustomerPaymentSourcesResponse201DataType",
    "POSTcustomersResponse201",
    "POSTcustomersResponse201Data",
    "POSTcustomersResponse201DataAttributes",
    "POSTcustomersResponse201DataAttributesMetadata",
    "POSTcustomersResponse201DataLinks",
    "POSTcustomersResponse201DataRelationships",
    "POSTcustomersResponse201DataRelationshipsAttachments",
    "POSTcustomersResponse201DataRelationshipsAttachmentsData",
    "POSTcustomersResponse201DataRelationshipsAttachmentsDataType",
    "POSTcustomersResponse201DataRelationshipsAttachmentsLinks",
    "POSTcustomersResponse201DataRelationshipsCustomerAddresses",
    "POSTcustomersResponse201DataRelationshipsCustomerAddressesData",
    "POSTcustomersResponse201DataRelationshipsCustomerAddressesDataType",
    "POSTcustomersResponse201DataRelationshipsCustomerAddressesLinks",
    "POSTcustomersResponse201DataRelationshipsCustomerGroup",
    "POSTcustomersResponse201DataRelationshipsCustomerGroupData",
    "POSTcustomersResponse201DataRelationshipsCustomerGroupDataType",
    "POSTcustomersResponse201DataRelationshipsCustomerGroupLinks",
    "POSTcustomersResponse201DataRelationshipsCustomerPaymentSources",
    "POSTcustomersResponse201DataRelationshipsCustomerPaymentSourcesData",
    "POSTcustomersResponse201DataRelationshipsCustomerPaymentSourcesDataType",
    "POSTcustomersResponse201DataRelationshipsCustomerPaymentSourcesLinks",
    "POSTcustomersResponse201DataRelationshipsCustomerSubscriptions",
    "POSTcustomersResponse201DataRelationshipsCustomerSubscriptionsData",
    "POSTcustomersResponse201DataRelationshipsCustomerSubscriptionsDataType",
    "POSTcustomersResponse201DataRelationshipsCustomerSubscriptionsLinks",
    "POSTcustomersResponse201DataRelationshipsEvents",
    "POSTcustomersResponse201DataRelationshipsEventsData",
    "POSTcustomersResponse201DataRelationshipsEventsDataType",
    "POSTcustomersResponse201DataRelationshipsEventsLinks",
    "POSTcustomersResponse201DataRelationshipsOrders",
    "POSTcustomersResponse201DataRelationshipsOrdersData",
    "POSTcustomersResponse201DataRelationshipsOrdersDataType",
    "POSTcustomersResponse201DataRelationshipsOrdersLinks",
    "POSTcustomersResponse201DataRelationshipsOrderSubscriptions",
    "POSTcustomersResponse201DataRelationshipsOrderSubscriptionsData",
    "POSTcustomersResponse201DataRelationshipsOrderSubscriptionsDataType",
    "POSTcustomersResponse201DataRelationshipsOrderSubscriptionsLinks",
    "POSTcustomersResponse201DataRelationshipsReturns",
    "POSTcustomersResponse201DataRelationshipsReturnsData",
    "POSTcustomersResponse201DataRelationshipsReturnsDataType",
    "POSTcustomersResponse201DataRelationshipsReturnsLinks",
    "POSTcustomersResponse201DataRelationshipsSkuLists",
    "POSTcustomersResponse201DataRelationshipsSkuListsData",
    "POSTcustomersResponse201DataRelationshipsSkuListsDataType",
    "POSTcustomersResponse201DataRelationshipsSkuListsLinks",
    "POSTcustomersResponse201DataType",
    "POSTcustomerSubscriptionsResponse201",
    "POSTcustomerSubscriptionsResponse201Data",
    "POSTcustomerSubscriptionsResponse201DataAttributes",
    "POSTcustomerSubscriptionsResponse201DataAttributesMetadata",
    "POSTcustomerSubscriptionsResponse201DataLinks",
    "POSTcustomerSubscriptionsResponse201DataRelationships",
    "POSTcustomerSubscriptionsResponse201DataRelationshipsCustomer",
    "POSTcustomerSubscriptionsResponse201DataRelationshipsCustomerData",
    "POSTcustomerSubscriptionsResponse201DataRelationshipsCustomerDataType",
    "POSTcustomerSubscriptionsResponse201DataRelationshipsCustomerLinks",
    "POSTcustomerSubscriptionsResponse201DataRelationshipsEvents",
    "POSTcustomerSubscriptionsResponse201DataRelationshipsEventsData",
    "POSTcustomerSubscriptionsResponse201DataRelationshipsEventsDataType",
    "POSTcustomerSubscriptionsResponse201DataRelationshipsEventsLinks",
    "POSTcustomerSubscriptionsResponse201DataType",
    "POSTdeliveryLeadTimesResponse201",
    "POSTdeliveryLeadTimesResponse201Data",
    "POSTdeliveryLeadTimesResponse201DataAttributes",
    "POSTdeliveryLeadTimesResponse201DataAttributesMetadata",
    "POSTdeliveryLeadTimesResponse201DataLinks",
    "POSTdeliveryLeadTimesResponse201DataRelationships",
    "POSTdeliveryLeadTimesResponse201DataRelationshipsAttachments",
    "POSTdeliveryLeadTimesResponse201DataRelationshipsAttachmentsData",
    "POSTdeliveryLeadTimesResponse201DataRelationshipsAttachmentsDataType",
    "POSTdeliveryLeadTimesResponse201DataRelationshipsAttachmentsLinks",
    "POSTdeliveryLeadTimesResponse201DataRelationshipsShippingMethod",
    "POSTdeliveryLeadTimesResponse201DataRelationshipsShippingMethodData",
    "POSTdeliveryLeadTimesResponse201DataRelationshipsShippingMethodDataType",
    "POSTdeliveryLeadTimesResponse201DataRelationshipsShippingMethodLinks",
    "POSTdeliveryLeadTimesResponse201DataRelationshipsStockLocation",
    "POSTdeliveryLeadTimesResponse201DataRelationshipsStockLocationData",
    "POSTdeliveryLeadTimesResponse201DataRelationshipsStockLocationDataType",
    "POSTdeliveryLeadTimesResponse201DataRelationshipsStockLocationLinks",
    "POSTdeliveryLeadTimesResponse201DataType",
    "POSTexportsResponse201",
    "POSTexportsResponse201Data",
    "POSTexportsResponse201DataAttributes",
    "POSTexportsResponse201DataAttributesFilters",
    "POSTexportsResponse201DataAttributesMetadata",
    "POSTexportsResponse201DataLinks",
    "POSTexportsResponse201DataRelationships",
    "POSTexportsResponse201DataRelationshipsEvents",
    "POSTexportsResponse201DataRelationshipsEventsData",
    "POSTexportsResponse201DataRelationshipsEventsDataType",
    "POSTexportsResponse201DataRelationshipsEventsLinks",
    "POSTexportsResponse201DataType",
    "POSTexternalGatewaysResponse201",
    "POSTexternalGatewaysResponse201Data",
    "POSTexternalGatewaysResponse201DataAttributes",
    "POSTexternalGatewaysResponse201DataAttributesMetadata",
    "POSTexternalGatewaysResponse201DataLinks",
    "POSTexternalGatewaysResponse201DataRelationships",
    "POSTexternalGatewaysResponse201DataRelationshipsExternalPayments",
    "POSTexternalGatewaysResponse201DataRelationshipsExternalPaymentsData",
    "POSTexternalGatewaysResponse201DataRelationshipsExternalPaymentsDataType",
    "POSTexternalGatewaysResponse201DataRelationshipsExternalPaymentsLinks",
    "POSTexternalGatewaysResponse201DataRelationshipsPaymentMethods",
    "POSTexternalGatewaysResponse201DataRelationshipsPaymentMethodsData",
    "POSTexternalGatewaysResponse201DataRelationshipsPaymentMethodsDataType",
    "POSTexternalGatewaysResponse201DataRelationshipsPaymentMethodsLinks",
    "POSTexternalGatewaysResponse201DataType",
    "POSTexternalPaymentsResponse201",
    "POSTexternalPaymentsResponse201Data",
    "POSTexternalPaymentsResponse201DataAttributes",
    "POSTexternalPaymentsResponse201DataAttributesMetadata",
    "POSTexternalPaymentsResponse201DataAttributesOptions",
    "POSTexternalPaymentsResponse201DataLinks",
    "POSTexternalPaymentsResponse201DataRelationships",
    "POSTexternalPaymentsResponse201DataRelationshipsOrder",
    "POSTexternalPaymentsResponse201DataRelationshipsOrderData",
    "POSTexternalPaymentsResponse201DataRelationshipsOrderDataType",
    "POSTexternalPaymentsResponse201DataRelationshipsOrderLinks",
    "POSTexternalPaymentsResponse201DataRelationshipsPaymentGateway",
    "POSTexternalPaymentsResponse201DataRelationshipsPaymentGatewayData",
    "POSTexternalPaymentsResponse201DataRelationshipsPaymentGatewayDataType",
    "POSTexternalPaymentsResponse201DataRelationshipsPaymentGatewayLinks",
    "POSTexternalPaymentsResponse201DataRelationshipsWallet",
    "POSTexternalPaymentsResponse201DataRelationshipsWalletData",
    "POSTexternalPaymentsResponse201DataRelationshipsWalletDataType",
    "POSTexternalPaymentsResponse201DataRelationshipsWalletLinks",
    "POSTexternalPaymentsResponse201DataType",
    "POSTexternalPromotionsResponse201",
    "POSTexternalPromotionsResponse201Data",
    "POSTexternalPromotionsResponse201DataAttributes",
    "POSTexternalPromotionsResponse201DataAttributesMetadata",
    "POSTexternalPromotionsResponse201DataLinks",
    "POSTexternalPromotionsResponse201DataRelationships",
    "POSTexternalPromotionsResponse201DataRelationshipsAttachments",
    "POSTexternalPromotionsResponse201DataRelationshipsAttachmentsData",
    "POSTexternalPromotionsResponse201DataRelationshipsAttachmentsDataType",
    "POSTexternalPromotionsResponse201DataRelationshipsAttachmentsLinks",
    "POSTexternalPromotionsResponse201DataRelationshipsCouponCodesPromotionRule",
    "POSTexternalPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleData",
    "POSTexternalPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleDataType",
    "POSTexternalPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleLinks",
    "POSTexternalPromotionsResponse201DataRelationshipsMarket",
    "POSTexternalPromotionsResponse201DataRelationshipsMarketData",
    "POSTexternalPromotionsResponse201DataRelationshipsMarketDataType",
    "POSTexternalPromotionsResponse201DataRelationshipsMarketLinks",
    "POSTexternalPromotionsResponse201DataRelationshipsOrderAmountPromotionRule",
    "POSTexternalPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleData",
    "POSTexternalPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleDataType",
    "POSTexternalPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleLinks",
    "POSTexternalPromotionsResponse201DataRelationshipsPromotionRules",
    "POSTexternalPromotionsResponse201DataRelationshipsPromotionRulesData",
    "POSTexternalPromotionsResponse201DataRelationshipsPromotionRulesDataType",
    "POSTexternalPromotionsResponse201DataRelationshipsPromotionRulesLinks",
    "POSTexternalPromotionsResponse201DataRelationshipsSkuListPromotionRule",
    "POSTexternalPromotionsResponse201DataRelationshipsSkuListPromotionRuleData",
    "POSTexternalPromotionsResponse201DataRelationshipsSkuListPromotionRuleDataType",
    "POSTexternalPromotionsResponse201DataRelationshipsSkuListPromotionRuleLinks",
    "POSTexternalPromotionsResponse201DataType",
    "POSTexternalTaxCalculatorsResponse201",
    "POSTexternalTaxCalculatorsResponse201Data",
    "POSTexternalTaxCalculatorsResponse201DataAttributes",
    "POSTexternalTaxCalculatorsResponse201DataAttributesMetadata",
    "POSTexternalTaxCalculatorsResponse201DataLinks",
    "POSTexternalTaxCalculatorsResponse201DataRelationships",
    "POSTexternalTaxCalculatorsResponse201DataRelationshipsAttachments",
    "POSTexternalTaxCalculatorsResponse201DataRelationshipsAttachmentsData",
    "POSTexternalTaxCalculatorsResponse201DataRelationshipsAttachmentsDataType",
    "POSTexternalTaxCalculatorsResponse201DataRelationshipsAttachmentsLinks",
    "POSTexternalTaxCalculatorsResponse201DataRelationshipsMarkets",
    "POSTexternalTaxCalculatorsResponse201DataRelationshipsMarketsData",
    "POSTexternalTaxCalculatorsResponse201DataRelationshipsMarketsDataType",
    "POSTexternalTaxCalculatorsResponse201DataRelationshipsMarketsLinks",
    "POSTexternalTaxCalculatorsResponse201DataType",
    "POSTfixedAmountPromotionsResponse201",
    "POSTfixedAmountPromotionsResponse201Data",
    "POSTfixedAmountPromotionsResponse201DataAttributes",
    "POSTfixedAmountPromotionsResponse201DataAttributesMetadata",
    "POSTfixedAmountPromotionsResponse201DataLinks",
    "POSTfixedAmountPromotionsResponse201DataRelationships",
    "POSTfixedAmountPromotionsResponse201DataRelationshipsAttachments",
    "POSTfixedAmountPromotionsResponse201DataRelationshipsAttachmentsData",
    "POSTfixedAmountPromotionsResponse201DataRelationshipsAttachmentsDataType",
    "POSTfixedAmountPromotionsResponse201DataRelationshipsAttachmentsLinks",
    "POSTfixedAmountPromotionsResponse201DataRelationshipsCouponCodesPromotionRule",
    "POSTfixedAmountPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleData",
    "POSTfixedAmountPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleDataType",
    "POSTfixedAmountPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleLinks",
    "POSTfixedAmountPromotionsResponse201DataRelationshipsMarket",
    "POSTfixedAmountPromotionsResponse201DataRelationshipsMarketData",
    "POSTfixedAmountPromotionsResponse201DataRelationshipsMarketDataType",
    "POSTfixedAmountPromotionsResponse201DataRelationshipsMarketLinks",
    "POSTfixedAmountPromotionsResponse201DataRelationshipsOrderAmountPromotionRule",
    "POSTfixedAmountPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleData",
    "POSTfixedAmountPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleDataType",
    "POSTfixedAmountPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleLinks",
    "POSTfixedAmountPromotionsResponse201DataRelationshipsPromotionRules",
    "POSTfixedAmountPromotionsResponse201DataRelationshipsPromotionRulesData",
    "POSTfixedAmountPromotionsResponse201DataRelationshipsPromotionRulesDataType",
    "POSTfixedAmountPromotionsResponse201DataRelationshipsPromotionRulesLinks",
    "POSTfixedAmountPromotionsResponse201DataRelationshipsSkuListPromotionRule",
    "POSTfixedAmountPromotionsResponse201DataRelationshipsSkuListPromotionRuleData",
    "POSTfixedAmountPromotionsResponse201DataRelationshipsSkuListPromotionRuleDataType",
    "POSTfixedAmountPromotionsResponse201DataRelationshipsSkuListPromotionRuleLinks",
    "POSTfixedAmountPromotionsResponse201DataType",
    "POSTfixedPricePromotionsResponse201",
    "POSTfixedPricePromotionsResponse201Data",
    "POSTfixedPricePromotionsResponse201DataAttributes",
    "POSTfixedPricePromotionsResponse201DataAttributesMetadata",
    "POSTfixedPricePromotionsResponse201DataLinks",
    "POSTfixedPricePromotionsResponse201DataRelationships",
    "POSTfixedPricePromotionsResponse201DataRelationshipsAttachments",
    "POSTfixedPricePromotionsResponse201DataRelationshipsAttachmentsData",
    "POSTfixedPricePromotionsResponse201DataRelationshipsAttachmentsDataType",
    "POSTfixedPricePromotionsResponse201DataRelationshipsAttachmentsLinks",
    "POSTfixedPricePromotionsResponse201DataRelationshipsCouponCodesPromotionRule",
    "POSTfixedPricePromotionsResponse201DataRelationshipsCouponCodesPromotionRuleData",
    "POSTfixedPricePromotionsResponse201DataRelationshipsCouponCodesPromotionRuleDataType",
    "POSTfixedPricePromotionsResponse201DataRelationshipsCouponCodesPromotionRuleLinks",
    "POSTfixedPricePromotionsResponse201DataRelationshipsMarket",
    "POSTfixedPricePromotionsResponse201DataRelationshipsMarketData",
    "POSTfixedPricePromotionsResponse201DataRelationshipsMarketDataType",
    "POSTfixedPricePromotionsResponse201DataRelationshipsMarketLinks",
    "POSTfixedPricePromotionsResponse201DataRelationshipsOrderAmountPromotionRule",
    "POSTfixedPricePromotionsResponse201DataRelationshipsOrderAmountPromotionRuleData",
    "POSTfixedPricePromotionsResponse201DataRelationshipsOrderAmountPromotionRuleDataType",
    "POSTfixedPricePromotionsResponse201DataRelationshipsOrderAmountPromotionRuleLinks",
    "POSTfixedPricePromotionsResponse201DataRelationshipsPromotionRules",
    "POSTfixedPricePromotionsResponse201DataRelationshipsPromotionRulesData",
    "POSTfixedPricePromotionsResponse201DataRelationshipsPromotionRulesDataType",
    "POSTfixedPricePromotionsResponse201DataRelationshipsPromotionRulesLinks",
    "POSTfixedPricePromotionsResponse201DataRelationshipsSkuList",
    "POSTfixedPricePromotionsResponse201DataRelationshipsSkuListData",
    "POSTfixedPricePromotionsResponse201DataRelationshipsSkuListDataType",
    "POSTfixedPricePromotionsResponse201DataRelationshipsSkuListLinks",
    "POSTfixedPricePromotionsResponse201DataRelationshipsSkuListPromotionRule",
    "POSTfixedPricePromotionsResponse201DataRelationshipsSkuListPromotionRuleData",
    "POSTfixedPricePromotionsResponse201DataRelationshipsSkuListPromotionRuleDataType",
    "POSTfixedPricePromotionsResponse201DataRelationshipsSkuListPromotionRuleLinks",
    "POSTfixedPricePromotionsResponse201DataRelationshipsSkus",
    "POSTfixedPricePromotionsResponse201DataRelationshipsSkusData",
    "POSTfixedPricePromotionsResponse201DataRelationshipsSkusDataType",
    "POSTfixedPricePromotionsResponse201DataRelationshipsSkusLinks",
    "POSTfixedPricePromotionsResponse201DataType",
    "POSTfreeGiftPromotionsResponse201",
    "POSTfreeGiftPromotionsResponse201Data",
    "POSTfreeGiftPromotionsResponse201DataAttributes",
    "POSTfreeGiftPromotionsResponse201DataAttributesMetadata",
    "POSTfreeGiftPromotionsResponse201DataLinks",
    "POSTfreeGiftPromotionsResponse201DataRelationships",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsAttachments",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsAttachmentsData",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsAttachmentsDataType",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsAttachmentsLinks",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsCouponCodesPromotionRule",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleData",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleDataType",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleLinks",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsMarket",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsMarketData",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsMarketDataType",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsMarketLinks",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsOrderAmountPromotionRule",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleData",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleDataType",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleLinks",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsPromotionRules",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsPromotionRulesData",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsPromotionRulesDataType",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsPromotionRulesLinks",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsSkuList",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsSkuListData",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsSkuListDataType",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsSkuListLinks",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsSkuListPromotionRule",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsSkuListPromotionRuleData",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsSkuListPromotionRuleDataType",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsSkuListPromotionRuleLinks",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsSkus",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsSkusData",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsSkusDataType",
    "POSTfreeGiftPromotionsResponse201DataRelationshipsSkusLinks",
    "POSTfreeGiftPromotionsResponse201DataType",
    "POSTfreeShippingPromotionsResponse201",
    "POSTfreeShippingPromotionsResponse201Data",
    "POSTfreeShippingPromotionsResponse201DataAttributes",
    "POSTfreeShippingPromotionsResponse201DataAttributesMetadata",
    "POSTfreeShippingPromotionsResponse201DataLinks",
    "POSTfreeShippingPromotionsResponse201DataRelationships",
    "POSTfreeShippingPromotionsResponse201DataRelationshipsAttachments",
    "POSTfreeShippingPromotionsResponse201DataRelationshipsAttachmentsData",
    "POSTfreeShippingPromotionsResponse201DataRelationshipsAttachmentsDataType",
    "POSTfreeShippingPromotionsResponse201DataRelationshipsAttachmentsLinks",
    "POSTfreeShippingPromotionsResponse201DataRelationshipsCouponCodesPromotionRule",
    "POSTfreeShippingPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleData",
    "POSTfreeShippingPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleDataType",
    "POSTfreeShippingPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleLinks",
    "POSTfreeShippingPromotionsResponse201DataRelationshipsMarket",
    "POSTfreeShippingPromotionsResponse201DataRelationshipsMarketData",
    "POSTfreeShippingPromotionsResponse201DataRelationshipsMarketDataType",
    "POSTfreeShippingPromotionsResponse201DataRelationshipsMarketLinks",
    "POSTfreeShippingPromotionsResponse201DataRelationshipsOrderAmountPromotionRule",
    "POSTfreeShippingPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleData",
    "POSTfreeShippingPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleDataType",
    "POSTfreeShippingPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleLinks",
    "POSTfreeShippingPromotionsResponse201DataRelationshipsPromotionRules",
    "POSTfreeShippingPromotionsResponse201DataRelationshipsPromotionRulesData",
    "POSTfreeShippingPromotionsResponse201DataRelationshipsPromotionRulesDataType",
    "POSTfreeShippingPromotionsResponse201DataRelationshipsPromotionRulesLinks",
    "POSTfreeShippingPromotionsResponse201DataRelationshipsSkuListPromotionRule",
    "POSTfreeShippingPromotionsResponse201DataRelationshipsSkuListPromotionRuleData",
    "POSTfreeShippingPromotionsResponse201DataRelationshipsSkuListPromotionRuleDataType",
    "POSTfreeShippingPromotionsResponse201DataRelationshipsSkuListPromotionRuleLinks",
    "POSTfreeShippingPromotionsResponse201DataType",
    "POSTgiftCardRecipientsResponse201",
    "POSTgiftCardRecipientsResponse201Data",
    "POSTgiftCardRecipientsResponse201DataAttributes",
    "POSTgiftCardRecipientsResponse201DataAttributesMetadata",
    "POSTgiftCardRecipientsResponse201DataLinks",
    "POSTgiftCardRecipientsResponse201DataRelationships",
    "POSTgiftCardRecipientsResponse201DataRelationshipsAttachments",
    "POSTgiftCardRecipientsResponse201DataRelationshipsAttachmentsData",
    "POSTgiftCardRecipientsResponse201DataRelationshipsAttachmentsDataType",
    "POSTgiftCardRecipientsResponse201DataRelationshipsAttachmentsLinks",
    "POSTgiftCardRecipientsResponse201DataRelationshipsCustomer",
    "POSTgiftCardRecipientsResponse201DataRelationshipsCustomerData",
    "POSTgiftCardRecipientsResponse201DataRelationshipsCustomerDataType",
    "POSTgiftCardRecipientsResponse201DataRelationshipsCustomerLinks",
    "POSTgiftCardRecipientsResponse201DataType",
    "POSTgiftCardsResponse201",
    "POSTgiftCardsResponse201Data",
    "POSTgiftCardsResponse201DataAttributes",
    "POSTgiftCardsResponse201DataAttributesMetadata",
    "POSTgiftCardsResponse201DataLinks",
    "POSTgiftCardsResponse201DataRelationships",
    "POSTgiftCardsResponse201DataRelationshipsAttachments",
    "POSTgiftCardsResponse201DataRelationshipsAttachmentsData",
    "POSTgiftCardsResponse201DataRelationshipsAttachmentsDataType",
    "POSTgiftCardsResponse201DataRelationshipsAttachmentsLinks",
    "POSTgiftCardsResponse201DataRelationshipsEvents",
    "POSTgiftCardsResponse201DataRelationshipsEventsData",
    "POSTgiftCardsResponse201DataRelationshipsEventsDataType",
    "POSTgiftCardsResponse201DataRelationshipsEventsLinks",
    "POSTgiftCardsResponse201DataRelationshipsGiftCardRecipient",
    "POSTgiftCardsResponse201DataRelationshipsGiftCardRecipientData",
    "POSTgiftCardsResponse201DataRelationshipsGiftCardRecipientDataType",
    "POSTgiftCardsResponse201DataRelationshipsGiftCardRecipientLinks",
    "POSTgiftCardsResponse201DataRelationshipsMarket",
    "POSTgiftCardsResponse201DataRelationshipsMarketData",
    "POSTgiftCardsResponse201DataRelationshipsMarketDataType",
    "POSTgiftCardsResponse201DataRelationshipsMarketLinks",
    "POSTgiftCardsResponse201DataType",
    "POSTgoogleGeocodersResponse201",
    "POSTgoogleGeocodersResponse201Data",
    "POSTgoogleGeocodersResponse201DataAttributes",
    "POSTgoogleGeocodersResponse201DataAttributesMetadata",
    "POSTgoogleGeocodersResponse201DataLinks",
    "POSTgoogleGeocodersResponse201DataRelationships",
    "POSTgoogleGeocodersResponse201DataRelationshipsAddresses",
    "POSTgoogleGeocodersResponse201DataRelationshipsAddressesData",
    "POSTgoogleGeocodersResponse201DataRelationshipsAddressesDataType",
    "POSTgoogleGeocodersResponse201DataRelationshipsAddressesLinks",
    "POSTgoogleGeocodersResponse201DataRelationshipsAttachments",
    "POSTgoogleGeocodersResponse201DataRelationshipsAttachmentsData",
    "POSTgoogleGeocodersResponse201DataRelationshipsAttachmentsDataType",
    "POSTgoogleGeocodersResponse201DataRelationshipsAttachmentsLinks",
    "POSTgoogleGeocodersResponse201DataType",
    "POSTimportsResponse201",
    "POSTimportsResponse201Data",
    "POSTimportsResponse201DataAttributes",
    "POSTimportsResponse201DataAttributesInputsItem",
    "POSTimportsResponse201DataAttributesMetadata",
    "POSTimportsResponse201DataLinks",
    "POSTimportsResponse201DataRelationships",
    "POSTimportsResponse201DataRelationshipsEvents",
    "POSTimportsResponse201DataRelationshipsEventsData",
    "POSTimportsResponse201DataRelationshipsEventsDataType",
    "POSTimportsResponse201DataRelationshipsEventsLinks",
    "POSTimportsResponse201DataType",
    "POSTinStockSubscriptionsResponse201",
    "POSTinStockSubscriptionsResponse201Data",
    "POSTinStockSubscriptionsResponse201DataAttributes",
    "POSTinStockSubscriptionsResponse201DataAttributesMetadata",
    "POSTinStockSubscriptionsResponse201DataLinks",
    "POSTinStockSubscriptionsResponse201DataRelationships",
    "POSTinStockSubscriptionsResponse201DataRelationshipsCustomer",
    "POSTinStockSubscriptionsResponse201DataRelationshipsCustomerData",
    "POSTinStockSubscriptionsResponse201DataRelationshipsCustomerDataType",
    "POSTinStockSubscriptionsResponse201DataRelationshipsCustomerLinks",
    "POSTinStockSubscriptionsResponse201DataRelationshipsEvents",
    "POSTinStockSubscriptionsResponse201DataRelationshipsEventsData",
    "POSTinStockSubscriptionsResponse201DataRelationshipsEventsDataType",
    "POSTinStockSubscriptionsResponse201DataRelationshipsEventsLinks",
    "POSTinStockSubscriptionsResponse201DataRelationshipsMarket",
    "POSTinStockSubscriptionsResponse201DataRelationshipsMarketData",
    "POSTinStockSubscriptionsResponse201DataRelationshipsMarketDataType",
    "POSTinStockSubscriptionsResponse201DataRelationshipsMarketLinks",
    "POSTinStockSubscriptionsResponse201DataRelationshipsSku",
    "POSTinStockSubscriptionsResponse201DataRelationshipsSkuData",
    "POSTinStockSubscriptionsResponse201DataRelationshipsSkuDataType",
    "POSTinStockSubscriptionsResponse201DataRelationshipsSkuLinks",
    "POSTinStockSubscriptionsResponse201DataType",
    "POSTinventoryModelsResponse201",
    "POSTinventoryModelsResponse201Data",
    "POSTinventoryModelsResponse201DataAttributes",
    "POSTinventoryModelsResponse201DataAttributesMetadata",
    "POSTinventoryModelsResponse201DataLinks",
    "POSTinventoryModelsResponse201DataRelationships",
    "POSTinventoryModelsResponse201DataRelationshipsAttachments",
    "POSTinventoryModelsResponse201DataRelationshipsAttachmentsData",
    "POSTinventoryModelsResponse201DataRelationshipsAttachmentsDataType",
    "POSTinventoryModelsResponse201DataRelationshipsAttachmentsLinks",
    "POSTinventoryModelsResponse201DataRelationshipsInventoryReturnLocations",
    "POSTinventoryModelsResponse201DataRelationshipsInventoryReturnLocationsData",
    "POSTinventoryModelsResponse201DataRelationshipsInventoryReturnLocationsDataType",
    "POSTinventoryModelsResponse201DataRelationshipsInventoryReturnLocationsLinks",
    "POSTinventoryModelsResponse201DataRelationshipsInventoryStockLocations",
    "POSTinventoryModelsResponse201DataRelationshipsInventoryStockLocationsData",
    "POSTinventoryModelsResponse201DataRelationshipsInventoryStockLocationsDataType",
    "POSTinventoryModelsResponse201DataRelationshipsInventoryStockLocationsLinks",
    "POSTinventoryModelsResponse201DataType",
    "POSTinventoryReturnLocationsResponse201",
    "POSTinventoryReturnLocationsResponse201Data",
    "POSTinventoryReturnLocationsResponse201DataAttributes",
    "POSTinventoryReturnLocationsResponse201DataAttributesMetadata",
    "POSTinventoryReturnLocationsResponse201DataLinks",
    "POSTinventoryReturnLocationsResponse201DataRelationships",
    "POSTinventoryReturnLocationsResponse201DataRelationshipsInventoryModel",
    "POSTinventoryReturnLocationsResponse201DataRelationshipsInventoryModelData",
    "POSTinventoryReturnLocationsResponse201DataRelationshipsInventoryModelDataType",
    "POSTinventoryReturnLocationsResponse201DataRelationshipsInventoryModelLinks",
    "POSTinventoryReturnLocationsResponse201DataRelationshipsStockLocation",
    "POSTinventoryReturnLocationsResponse201DataRelationshipsStockLocationData",
    "POSTinventoryReturnLocationsResponse201DataRelationshipsStockLocationDataType",
    "POSTinventoryReturnLocationsResponse201DataRelationshipsStockLocationLinks",
    "POSTinventoryReturnLocationsResponse201DataType",
    "POSTinventoryStockLocationsResponse201",
    "POSTinventoryStockLocationsResponse201Data",
    "POSTinventoryStockLocationsResponse201DataAttributes",
    "POSTinventoryStockLocationsResponse201DataAttributesMetadata",
    "POSTinventoryStockLocationsResponse201DataLinks",
    "POSTinventoryStockLocationsResponse201DataRelationships",
    "POSTinventoryStockLocationsResponse201DataRelationshipsInventoryModel",
    "POSTinventoryStockLocationsResponse201DataRelationshipsInventoryModelData",
    "POSTinventoryStockLocationsResponse201DataRelationshipsInventoryModelDataType",
    "POSTinventoryStockLocationsResponse201DataRelationshipsInventoryModelLinks",
    "POSTinventoryStockLocationsResponse201DataRelationshipsStockLocation",
    "POSTinventoryStockLocationsResponse201DataRelationshipsStockLocationData",
    "POSTinventoryStockLocationsResponse201DataRelationshipsStockLocationDataType",
    "POSTinventoryStockLocationsResponse201DataRelationshipsStockLocationLinks",
    "POSTinventoryStockLocationsResponse201DataType",
    "POSTklarnaGatewaysResponse201",
    "POSTklarnaGatewaysResponse201Data",
    "POSTklarnaGatewaysResponse201DataAttributes",
    "POSTklarnaGatewaysResponse201DataAttributesMetadata",
    "POSTklarnaGatewaysResponse201DataLinks",
    "POSTklarnaGatewaysResponse201DataRelationships",
    "POSTklarnaGatewaysResponse201DataRelationshipsKlarnaPayments",
    "POSTklarnaGatewaysResponse201DataRelationshipsKlarnaPaymentsData",
    "POSTklarnaGatewaysResponse201DataRelationshipsKlarnaPaymentsDataType",
    "POSTklarnaGatewaysResponse201DataRelationshipsKlarnaPaymentsLinks",
    "POSTklarnaGatewaysResponse201DataRelationshipsPaymentMethods",
    "POSTklarnaGatewaysResponse201DataRelationshipsPaymentMethodsData",
    "POSTklarnaGatewaysResponse201DataRelationshipsPaymentMethodsDataType",
    "POSTklarnaGatewaysResponse201DataRelationshipsPaymentMethodsLinks",
    "POSTklarnaGatewaysResponse201DataType",
    "POSTklarnaPaymentsResponse201",
    "POSTklarnaPaymentsResponse201Data",
    "POSTklarnaPaymentsResponse201DataAttributes",
    "POSTklarnaPaymentsResponse201DataAttributesMetadata",
    "POSTklarnaPaymentsResponse201DataLinks",
    "POSTklarnaPaymentsResponse201DataRelationships",
    "POSTklarnaPaymentsResponse201DataRelationshipsOrder",
    "POSTklarnaPaymentsResponse201DataRelationshipsOrderData",
    "POSTklarnaPaymentsResponse201DataRelationshipsOrderDataType",
    "POSTklarnaPaymentsResponse201DataRelationshipsOrderLinks",
    "POSTklarnaPaymentsResponse201DataRelationshipsPaymentGateway",
    "POSTklarnaPaymentsResponse201DataRelationshipsPaymentGatewayData",
    "POSTklarnaPaymentsResponse201DataRelationshipsPaymentGatewayDataType",
    "POSTklarnaPaymentsResponse201DataRelationshipsPaymentGatewayLinks",
    "POSTklarnaPaymentsResponse201DataType",
    "POSTlineItemOptionsResponse201",
    "POSTlineItemOptionsResponse201Data",
    "POSTlineItemOptionsResponse201DataAttributes",
    "POSTlineItemOptionsResponse201DataAttributesMetadata",
    "POSTlineItemOptionsResponse201DataAttributesOptions",
    "POSTlineItemOptionsResponse201DataLinks",
    "POSTlineItemOptionsResponse201DataRelationships",
    "POSTlineItemOptionsResponse201DataRelationshipsLineItem",
    "POSTlineItemOptionsResponse201DataRelationshipsLineItemData",
    "POSTlineItemOptionsResponse201DataRelationshipsLineItemDataType",
    "POSTlineItemOptionsResponse201DataRelationshipsLineItemLinks",
    "POSTlineItemOptionsResponse201DataRelationshipsSkuOption",
    "POSTlineItemOptionsResponse201DataRelationshipsSkuOptionData",
    "POSTlineItemOptionsResponse201DataRelationshipsSkuOptionDataType",
    "POSTlineItemOptionsResponse201DataRelationshipsSkuOptionLinks",
    "POSTlineItemOptionsResponse201DataType",
    "POSTlineItemsResponse201",
    "POSTlineItemsResponse201Data",
    "POSTlineItemsResponse201DataAttributes",
    "POSTlineItemsResponse201DataAttributesMetadata",
    "POSTlineItemsResponse201DataLinks",
    "POSTlineItemsResponse201DataRelationships",
    "POSTlineItemsResponse201DataRelationshipsItem",
    "POSTlineItemsResponse201DataRelationshipsItemData",
    "POSTlineItemsResponse201DataRelationshipsItemDataType",
    "POSTlineItemsResponse201DataRelationshipsItemLinks",
    "POSTlineItemsResponse201DataRelationshipsLineItemOptions",
    "POSTlineItemsResponse201DataRelationshipsLineItemOptionsData",
    "POSTlineItemsResponse201DataRelationshipsLineItemOptionsDataType",
    "POSTlineItemsResponse201DataRelationshipsLineItemOptionsLinks",
    "POSTlineItemsResponse201DataRelationshipsOrder",
    "POSTlineItemsResponse201DataRelationshipsOrderData",
    "POSTlineItemsResponse201DataRelationshipsOrderDataType",
    "POSTlineItemsResponse201DataRelationshipsOrderLinks",
    "POSTlineItemsResponse201DataRelationshipsShipmentLineItems",
    "POSTlineItemsResponse201DataRelationshipsShipmentLineItemsData",
    "POSTlineItemsResponse201DataRelationshipsShipmentLineItemsDataType",
    "POSTlineItemsResponse201DataRelationshipsShipmentLineItemsLinks",
    "POSTlineItemsResponse201DataRelationshipsStockLineItems",
    "POSTlineItemsResponse201DataRelationshipsStockLineItemsData",
    "POSTlineItemsResponse201DataRelationshipsStockLineItemsDataType",
    "POSTlineItemsResponse201DataRelationshipsStockLineItemsLinks",
    "POSTlineItemsResponse201DataRelationshipsStockTransfers",
    "POSTlineItemsResponse201DataRelationshipsStockTransfersData",
    "POSTlineItemsResponse201DataRelationshipsStockTransfersDataType",
    "POSTlineItemsResponse201DataRelationshipsStockTransfersLinks",
    "POSTlineItemsResponse201DataType",
    "POSTmanualGatewaysResponse201",
    "POSTmanualGatewaysResponse201Data",
    "POSTmanualGatewaysResponse201DataAttributes",
    "POSTmanualGatewaysResponse201DataAttributesMetadata",
    "POSTmanualGatewaysResponse201DataLinks",
    "POSTmanualGatewaysResponse201DataRelationships",
    "POSTmanualGatewaysResponse201DataRelationshipsPaymentMethods",
    "POSTmanualGatewaysResponse201DataRelationshipsPaymentMethodsData",
    "POSTmanualGatewaysResponse201DataRelationshipsPaymentMethodsDataType",
    "POSTmanualGatewaysResponse201DataRelationshipsPaymentMethodsLinks",
    "POSTmanualGatewaysResponse201DataType",
    "POSTmanualTaxCalculatorsResponse201",
    "POSTmanualTaxCalculatorsResponse201Data",
    "POSTmanualTaxCalculatorsResponse201DataAttributes",
    "POSTmanualTaxCalculatorsResponse201DataAttributesMetadata",
    "POSTmanualTaxCalculatorsResponse201DataLinks",
    "POSTmanualTaxCalculatorsResponse201DataRelationships",
    "POSTmanualTaxCalculatorsResponse201DataRelationshipsAttachments",
    "POSTmanualTaxCalculatorsResponse201DataRelationshipsAttachmentsData",
    "POSTmanualTaxCalculatorsResponse201DataRelationshipsAttachmentsDataType",
    "POSTmanualTaxCalculatorsResponse201DataRelationshipsAttachmentsLinks",
    "POSTmanualTaxCalculatorsResponse201DataRelationshipsMarkets",
    "POSTmanualTaxCalculatorsResponse201DataRelationshipsMarketsData",
    "POSTmanualTaxCalculatorsResponse201DataRelationshipsMarketsDataType",
    "POSTmanualTaxCalculatorsResponse201DataRelationshipsMarketsLinks",
    "POSTmanualTaxCalculatorsResponse201DataRelationshipsTaxRules",
    "POSTmanualTaxCalculatorsResponse201DataRelationshipsTaxRulesData",
    "POSTmanualTaxCalculatorsResponse201DataRelationshipsTaxRulesDataType",
    "POSTmanualTaxCalculatorsResponse201DataRelationshipsTaxRulesLinks",
    "POSTmanualTaxCalculatorsResponse201DataType",
    "POSTmarketsResponse201",
    "POSTmarketsResponse201Data",
    "POSTmarketsResponse201DataAttributes",
    "POSTmarketsResponse201DataAttributesMetadata",
    "POSTmarketsResponse201DataLinks",
    "POSTmarketsResponse201DataRelationships",
    "POSTmarketsResponse201DataRelationshipsAttachments",
    "POSTmarketsResponse201DataRelationshipsAttachmentsData",
    "POSTmarketsResponse201DataRelationshipsAttachmentsDataType",
    "POSTmarketsResponse201DataRelationshipsAttachmentsLinks",
    "POSTmarketsResponse201DataRelationshipsCustomerGroup",
    "POSTmarketsResponse201DataRelationshipsCustomerGroupData",
    "POSTmarketsResponse201DataRelationshipsCustomerGroupDataType",
    "POSTmarketsResponse201DataRelationshipsCustomerGroupLinks",
    "POSTmarketsResponse201DataRelationshipsInventoryModel",
    "POSTmarketsResponse201DataRelationshipsInventoryModelData",
    "POSTmarketsResponse201DataRelationshipsInventoryModelDataType",
    "POSTmarketsResponse201DataRelationshipsInventoryModelLinks",
    "POSTmarketsResponse201DataRelationshipsMerchant",
    "POSTmarketsResponse201DataRelationshipsMerchantData",
    "POSTmarketsResponse201DataRelationshipsMerchantDataType",
    "POSTmarketsResponse201DataRelationshipsMerchantLinks",
    "POSTmarketsResponse201DataRelationshipsPriceList",
    "POSTmarketsResponse201DataRelationshipsPriceListData",
    "POSTmarketsResponse201DataRelationshipsPriceListDataType",
    "POSTmarketsResponse201DataRelationshipsPriceListLinks",
    "POSTmarketsResponse201DataRelationshipsTaxCalculator",
    "POSTmarketsResponse201DataRelationshipsTaxCalculatorData",
    "POSTmarketsResponse201DataRelationshipsTaxCalculatorDataType",
    "POSTmarketsResponse201DataRelationshipsTaxCalculatorLinks",
    "POSTmarketsResponse201DataType",
    "POSTmerchantsResponse201",
    "POSTmerchantsResponse201Data",
    "POSTmerchantsResponse201DataAttributes",
    "POSTmerchantsResponse201DataAttributesMetadata",
    "POSTmerchantsResponse201DataLinks",
    "POSTmerchantsResponse201DataRelationships",
    "POSTmerchantsResponse201DataRelationshipsAddress",
    "POSTmerchantsResponse201DataRelationshipsAddressData",
    "POSTmerchantsResponse201DataRelationshipsAddressDataType",
    "POSTmerchantsResponse201DataRelationshipsAddressLinks",
    "POSTmerchantsResponse201DataRelationshipsAttachments",
    "POSTmerchantsResponse201DataRelationshipsAttachmentsData",
    "POSTmerchantsResponse201DataRelationshipsAttachmentsDataType",
    "POSTmerchantsResponse201DataRelationshipsAttachmentsLinks",
    "POSTmerchantsResponse201DataType",
    "POSTorderAmountPromotionRulesResponse201",
    "POSTorderAmountPromotionRulesResponse201Data",
    "POSTorderAmountPromotionRulesResponse201DataAttributes",
    "POSTorderAmountPromotionRulesResponse201DataAttributesMetadata",
    "POSTorderAmountPromotionRulesResponse201DataLinks",
    "POSTorderAmountPromotionRulesResponse201DataRelationships",
    "POSTorderAmountPromotionRulesResponse201DataRelationshipsPromotion",
    "POSTorderAmountPromotionRulesResponse201DataRelationshipsPromotionData",
    "POSTorderAmountPromotionRulesResponse201DataRelationshipsPromotionDataType",
    "POSTorderAmountPromotionRulesResponse201DataRelationshipsPromotionLinks",
    "POSTorderAmountPromotionRulesResponse201DataType",
    "POSTorderCopiesResponse201",
    "POSTorderCopiesResponse201Data",
    "POSTorderCopiesResponse201DataAttributes",
    "POSTorderCopiesResponse201DataAttributesMetadata",
    "POSTorderCopiesResponse201DataLinks",
    "POSTorderCopiesResponse201DataRelationships",
    "POSTorderCopiesResponse201DataRelationshipsEvents",
    "POSTorderCopiesResponse201DataRelationshipsEventsData",
    "POSTorderCopiesResponse201DataRelationshipsEventsDataType",
    "POSTorderCopiesResponse201DataRelationshipsEventsLinks",
    "POSTorderCopiesResponse201DataRelationshipsOrderSubscription",
    "POSTorderCopiesResponse201DataRelationshipsOrderSubscriptionData",
    "POSTorderCopiesResponse201DataRelationshipsOrderSubscriptionDataType",
    "POSTorderCopiesResponse201DataRelationshipsOrderSubscriptionLinks",
    "POSTorderCopiesResponse201DataRelationshipsSourceOrder",
    "POSTorderCopiesResponse201DataRelationshipsSourceOrderData",
    "POSTorderCopiesResponse201DataRelationshipsSourceOrderDataType",
    "POSTorderCopiesResponse201DataRelationshipsSourceOrderLinks",
    "POSTorderCopiesResponse201DataRelationshipsTargetOrder",
    "POSTorderCopiesResponse201DataRelationshipsTargetOrderData",
    "POSTorderCopiesResponse201DataRelationshipsTargetOrderDataType",
    "POSTorderCopiesResponse201DataRelationshipsTargetOrderLinks",
    "POSTorderCopiesResponse201DataType",
    "POSTordersResponse201",
    "POSTordersResponse201Data",
    "POSTordersResponse201DataAttributes",
    "POSTordersResponse201DataAttributesMetadata",
    "POSTordersResponse201DataLinks",
    "POSTordersResponse201DataRelationships",
    "POSTordersResponse201DataRelationshipsAttachments",
    "POSTordersResponse201DataRelationshipsAttachmentsData",
    "POSTordersResponse201DataRelationshipsAttachmentsDataType",
    "POSTordersResponse201DataRelationshipsAttachmentsLinks",
    "POSTordersResponse201DataRelationshipsAuthorizations",
    "POSTordersResponse201DataRelationshipsAuthorizationsData",
    "POSTordersResponse201DataRelationshipsAuthorizationsDataType",
    "POSTordersResponse201DataRelationshipsAuthorizationsLinks",
    "POSTordersResponse201DataRelationshipsAvailableCustomerPaymentSources",
    "POSTordersResponse201DataRelationshipsAvailableCustomerPaymentSourcesData",
    "POSTordersResponse201DataRelationshipsAvailableCustomerPaymentSourcesDataType",
    "POSTordersResponse201DataRelationshipsAvailableCustomerPaymentSourcesLinks",
    "POSTordersResponse201DataRelationshipsAvailableFreeBundles",
    "POSTordersResponse201DataRelationshipsAvailableFreeBundlesData",
    "POSTordersResponse201DataRelationshipsAvailableFreeBundlesDataType",
    "POSTordersResponse201DataRelationshipsAvailableFreeBundlesLinks",
    "POSTordersResponse201DataRelationshipsAvailableFreeSkus",
    "POSTordersResponse201DataRelationshipsAvailableFreeSkusData",
    "POSTordersResponse201DataRelationshipsAvailableFreeSkusDataType",
    "POSTordersResponse201DataRelationshipsAvailableFreeSkusLinks",
    "POSTordersResponse201DataRelationshipsAvailablePaymentMethods",
    "POSTordersResponse201DataRelationshipsAvailablePaymentMethodsData",
    "POSTordersResponse201DataRelationshipsAvailablePaymentMethodsDataType",
    "POSTordersResponse201DataRelationshipsAvailablePaymentMethodsLinks",
    "POSTordersResponse201DataRelationshipsBillingAddress",
    "POSTordersResponse201DataRelationshipsBillingAddressData",
    "POSTordersResponse201DataRelationshipsBillingAddressDataType",
    "POSTordersResponse201DataRelationshipsBillingAddressLinks",
    "POSTordersResponse201DataRelationshipsCaptures",
    "POSTordersResponse201DataRelationshipsCapturesData",
    "POSTordersResponse201DataRelationshipsCapturesDataType",
    "POSTordersResponse201DataRelationshipsCapturesLinks",
    "POSTordersResponse201DataRelationshipsCustomer",
    "POSTordersResponse201DataRelationshipsCustomerData",
    "POSTordersResponse201DataRelationshipsCustomerDataType",
    "POSTordersResponse201DataRelationshipsCustomerLinks",
    "POSTordersResponse201DataRelationshipsEvents",
    "POSTordersResponse201DataRelationshipsEventsData",
    "POSTordersResponse201DataRelationshipsEventsDataType",
    "POSTordersResponse201DataRelationshipsEventsLinks",
    "POSTordersResponse201DataRelationshipsLineItems",
    "POSTordersResponse201DataRelationshipsLineItemsData",
    "POSTordersResponse201DataRelationshipsLineItemsDataType",
    "POSTordersResponse201DataRelationshipsLineItemsLinks",
    "POSTordersResponse201DataRelationshipsMarket",
    "POSTordersResponse201DataRelationshipsMarketData",
    "POSTordersResponse201DataRelationshipsMarketDataType",
    "POSTordersResponse201DataRelationshipsMarketLinks",
    "POSTordersResponse201DataRelationshipsOrderCopies",
    "POSTordersResponse201DataRelationshipsOrderCopiesData",
    "POSTordersResponse201DataRelationshipsOrderCopiesDataType",
    "POSTordersResponse201DataRelationshipsOrderCopiesLinks",
    "POSTordersResponse201DataRelationshipsOrderSubscriptions",
    "POSTordersResponse201DataRelationshipsOrderSubscriptionsData",
    "POSTordersResponse201DataRelationshipsOrderSubscriptionsDataType",
    "POSTordersResponse201DataRelationshipsOrderSubscriptionsLinks",
    "POSTordersResponse201DataRelationshipsPaymentMethod",
    "POSTordersResponse201DataRelationshipsPaymentMethodData",
    "POSTordersResponse201DataRelationshipsPaymentMethodDataType",
    "POSTordersResponse201DataRelationshipsPaymentMethodLinks",
    "POSTordersResponse201DataRelationshipsPaymentSource",
    "POSTordersResponse201DataRelationshipsPaymentSourceData",
    "POSTordersResponse201DataRelationshipsPaymentSourceDataType",
    "POSTordersResponse201DataRelationshipsPaymentSourceLinks",
    "POSTordersResponse201DataRelationshipsRefunds",
    "POSTordersResponse201DataRelationshipsRefundsData",
    "POSTordersResponse201DataRelationshipsRefundsDataType",
    "POSTordersResponse201DataRelationshipsRefundsLinks",
    "POSTordersResponse201DataRelationshipsShipments",
    "POSTordersResponse201DataRelationshipsShipmentsData",
    "POSTordersResponse201DataRelationshipsShipmentsDataType",
    "POSTordersResponse201DataRelationshipsShipmentsLinks",
    "POSTordersResponse201DataRelationshipsShippingAddress",
    "POSTordersResponse201DataRelationshipsShippingAddressData",
    "POSTordersResponse201DataRelationshipsShippingAddressDataType",
    "POSTordersResponse201DataRelationshipsShippingAddressLinks",
    "POSTordersResponse201DataRelationshipsTransactions",
    "POSTordersResponse201DataRelationshipsTransactionsData",
    "POSTordersResponse201DataRelationshipsTransactionsDataType",
    "POSTordersResponse201DataRelationshipsTransactionsLinks",
    "POSTordersResponse201DataRelationshipsVoids",
    "POSTordersResponse201DataRelationshipsVoidsData",
    "POSTordersResponse201DataRelationshipsVoidsDataType",
    "POSTordersResponse201DataRelationshipsVoidsLinks",
    "POSTordersResponse201DataType",
    "POSTorderSubscriptionsResponse201",
    "POSTorderSubscriptionsResponse201Data",
    "POSTorderSubscriptionsResponse201DataAttributes",
    "POSTorderSubscriptionsResponse201DataAttributesMetadata",
    "POSTorderSubscriptionsResponse201DataAttributesOptions",
    "POSTorderSubscriptionsResponse201DataLinks",
    "POSTorderSubscriptionsResponse201DataRelationships",
    "POSTorderSubscriptionsResponse201DataRelationshipsCustomer",
    "POSTorderSubscriptionsResponse201DataRelationshipsCustomerData",
    "POSTorderSubscriptionsResponse201DataRelationshipsCustomerDataType",
    "POSTorderSubscriptionsResponse201DataRelationshipsCustomerLinks",
    "POSTorderSubscriptionsResponse201DataRelationshipsEvents",
    "POSTorderSubscriptionsResponse201DataRelationshipsEventsData",
    "POSTorderSubscriptionsResponse201DataRelationshipsEventsDataType",
    "POSTorderSubscriptionsResponse201DataRelationshipsEventsLinks",
    "POSTorderSubscriptionsResponse201DataRelationshipsMarket",
    "POSTorderSubscriptionsResponse201DataRelationshipsMarketData",
    "POSTorderSubscriptionsResponse201DataRelationshipsMarketDataType",
    "POSTorderSubscriptionsResponse201DataRelationshipsMarketLinks",
    "POSTorderSubscriptionsResponse201DataRelationshipsOrderCopies",
    "POSTorderSubscriptionsResponse201DataRelationshipsOrderCopiesData",
    "POSTorderSubscriptionsResponse201DataRelationshipsOrderCopiesDataType",
    "POSTorderSubscriptionsResponse201DataRelationshipsOrderCopiesLinks",
    "POSTorderSubscriptionsResponse201DataRelationshipsOrders",
    "POSTorderSubscriptionsResponse201DataRelationshipsOrdersData",
    "POSTorderSubscriptionsResponse201DataRelationshipsOrdersDataType",
    "POSTorderSubscriptionsResponse201DataRelationshipsOrdersLinks",
    "POSTorderSubscriptionsResponse201DataRelationshipsSourceOrder",
    "POSTorderSubscriptionsResponse201DataRelationshipsSourceOrderData",
    "POSTorderSubscriptionsResponse201DataRelationshipsSourceOrderDataType",
    "POSTorderSubscriptionsResponse201DataRelationshipsSourceOrderLinks",
    "POSTorderSubscriptionsResponse201DataType",
    "POSTpackagesResponse201",
    "POSTpackagesResponse201Data",
    "POSTpackagesResponse201DataAttributes",
    "POSTpackagesResponse201DataAttributesMetadata",
    "POSTpackagesResponse201DataLinks",
    "POSTpackagesResponse201DataRelationships",
    "POSTpackagesResponse201DataRelationshipsAttachments",
    "POSTpackagesResponse201DataRelationshipsAttachmentsData",
    "POSTpackagesResponse201DataRelationshipsAttachmentsDataType",
    "POSTpackagesResponse201DataRelationshipsAttachmentsLinks",
    "POSTpackagesResponse201DataRelationshipsParcels",
    "POSTpackagesResponse201DataRelationshipsParcelsData",
    "POSTpackagesResponse201DataRelationshipsParcelsDataType",
    "POSTpackagesResponse201DataRelationshipsParcelsLinks",
    "POSTpackagesResponse201DataRelationshipsStockLocation",
    "POSTpackagesResponse201DataRelationshipsStockLocationData",
    "POSTpackagesResponse201DataRelationshipsStockLocationDataType",
    "POSTpackagesResponse201DataRelationshipsStockLocationLinks",
    "POSTpackagesResponse201DataType",
    "POSTparcelLineItemsResponse201",
    "POSTparcelLineItemsResponse201Data",
    "POSTparcelLineItemsResponse201DataAttributes",
    "POSTparcelLineItemsResponse201DataAttributesMetadata",
    "POSTparcelLineItemsResponse201DataLinks",
    "POSTparcelLineItemsResponse201DataRelationships",
    "POSTparcelLineItemsResponse201DataRelationshipsParcel",
    "POSTparcelLineItemsResponse201DataRelationshipsParcelData",
    "POSTparcelLineItemsResponse201DataRelationshipsParcelDataType",
    "POSTparcelLineItemsResponse201DataRelationshipsParcelLinks",
    "POSTparcelLineItemsResponse201DataRelationshipsShipmentLineItem",
    "POSTparcelLineItemsResponse201DataRelationshipsShipmentLineItemData",
    "POSTparcelLineItemsResponse201DataRelationshipsShipmentLineItemDataType",
    "POSTparcelLineItemsResponse201DataRelationshipsShipmentLineItemLinks",
    "POSTparcelLineItemsResponse201DataRelationshipsStockLineItem",
    "POSTparcelLineItemsResponse201DataRelationshipsStockLineItemData",
    "POSTparcelLineItemsResponse201DataRelationshipsStockLineItemDataType",
    "POSTparcelLineItemsResponse201DataRelationshipsStockLineItemLinks",
    "POSTparcelLineItemsResponse201DataType",
    "POSTparcelsResponse201",
    "POSTparcelsResponse201Data",
    "POSTparcelsResponse201DataAttributes",
    "POSTparcelsResponse201DataAttributesMetadata",
    "POSTparcelsResponse201DataLinks",
    "POSTparcelsResponse201DataRelationships",
    "POSTparcelsResponse201DataRelationshipsAttachments",
    "POSTparcelsResponse201DataRelationshipsAttachmentsData",
    "POSTparcelsResponse201DataRelationshipsAttachmentsDataType",
    "POSTparcelsResponse201DataRelationshipsAttachmentsLinks",
    "POSTparcelsResponse201DataRelationshipsEvents",
    "POSTparcelsResponse201DataRelationshipsEventsData",
    "POSTparcelsResponse201DataRelationshipsEventsDataType",
    "POSTparcelsResponse201DataRelationshipsEventsLinks",
    "POSTparcelsResponse201DataRelationshipsPackage",
    "POSTparcelsResponse201DataRelationshipsPackageData",
    "POSTparcelsResponse201DataRelationshipsPackageDataType",
    "POSTparcelsResponse201DataRelationshipsPackageLinks",
    "POSTparcelsResponse201DataRelationshipsParcelLineItems",
    "POSTparcelsResponse201DataRelationshipsParcelLineItemsData",
    "POSTparcelsResponse201DataRelationshipsParcelLineItemsDataType",
    "POSTparcelsResponse201DataRelationshipsParcelLineItemsLinks",
    "POSTparcelsResponse201DataRelationshipsShipment",
    "POSTparcelsResponse201DataRelationshipsShipmentData",
    "POSTparcelsResponse201DataRelationshipsShipmentDataType",
    "POSTparcelsResponse201DataRelationshipsShipmentLinks",
    "POSTparcelsResponse201DataType",
    "POSTpaymentMethodsResponse201",
    "POSTpaymentMethodsResponse201Data",
    "POSTpaymentMethodsResponse201DataAttributes",
    "POSTpaymentMethodsResponse201DataAttributesMetadata",
    "POSTpaymentMethodsResponse201DataLinks",
    "POSTpaymentMethodsResponse201DataRelationships",
    "POSTpaymentMethodsResponse201DataRelationshipsAttachments",
    "POSTpaymentMethodsResponse201DataRelationshipsAttachmentsData",
    "POSTpaymentMethodsResponse201DataRelationshipsAttachmentsDataType",
    "POSTpaymentMethodsResponse201DataRelationshipsAttachmentsLinks",
    "POSTpaymentMethodsResponse201DataRelationshipsMarket",
    "POSTpaymentMethodsResponse201DataRelationshipsMarketData",
    "POSTpaymentMethodsResponse201DataRelationshipsMarketDataType",
    "POSTpaymentMethodsResponse201DataRelationshipsMarketLinks",
    "POSTpaymentMethodsResponse201DataRelationshipsPaymentGateway",
    "POSTpaymentMethodsResponse201DataRelationshipsPaymentGatewayData",
    "POSTpaymentMethodsResponse201DataRelationshipsPaymentGatewayDataType",
    "POSTpaymentMethodsResponse201DataRelationshipsPaymentGatewayLinks",
    "POSTpaymentMethodsResponse201DataType",
    "POSTpaypalGatewaysResponse201",
    "POSTpaypalGatewaysResponse201Data",
    "POSTpaypalGatewaysResponse201DataAttributes",
    "POSTpaypalGatewaysResponse201DataAttributesMetadata",
    "POSTpaypalGatewaysResponse201DataLinks",
    "POSTpaypalGatewaysResponse201DataRelationships",
    "POSTpaypalGatewaysResponse201DataRelationshipsPaymentMethods",
    "POSTpaypalGatewaysResponse201DataRelationshipsPaymentMethodsData",
    "POSTpaypalGatewaysResponse201DataRelationshipsPaymentMethodsDataType",
    "POSTpaypalGatewaysResponse201DataRelationshipsPaymentMethodsLinks",
    "POSTpaypalGatewaysResponse201DataRelationshipsPaypalPayments",
    "POSTpaypalGatewaysResponse201DataRelationshipsPaypalPaymentsData",
    "POSTpaypalGatewaysResponse201DataRelationshipsPaypalPaymentsDataType",
    "POSTpaypalGatewaysResponse201DataRelationshipsPaypalPaymentsLinks",
    "POSTpaypalGatewaysResponse201DataType",
    "POSTpaypalPaymentsResponse201",
    "POSTpaypalPaymentsResponse201Data",
    "POSTpaypalPaymentsResponse201DataAttributes",
    "POSTpaypalPaymentsResponse201DataAttributesMetadata",
    "POSTpaypalPaymentsResponse201DataLinks",
    "POSTpaypalPaymentsResponse201DataRelationships",
    "POSTpaypalPaymentsResponse201DataRelationshipsOrder",
    "POSTpaypalPaymentsResponse201DataRelationshipsOrderData",
    "POSTpaypalPaymentsResponse201DataRelationshipsOrderDataType",
    "POSTpaypalPaymentsResponse201DataRelationshipsOrderLinks",
    "POSTpaypalPaymentsResponse201DataRelationshipsPaymentGateway",
    "POSTpaypalPaymentsResponse201DataRelationshipsPaymentGatewayData",
    "POSTpaypalPaymentsResponse201DataRelationshipsPaymentGatewayDataType",
    "POSTpaypalPaymentsResponse201DataRelationshipsPaymentGatewayLinks",
    "POSTpaypalPaymentsResponse201DataType",
    "POSTpercentageDiscountPromotionsResponse201",
    "POSTpercentageDiscountPromotionsResponse201Data",
    "POSTpercentageDiscountPromotionsResponse201DataAttributes",
    "POSTpercentageDiscountPromotionsResponse201DataAttributesMetadata",
    "POSTpercentageDiscountPromotionsResponse201DataLinks",
    "POSTpercentageDiscountPromotionsResponse201DataRelationships",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsAttachments",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsAttachmentsData",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsAttachmentsDataType",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsAttachmentsLinks",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsCouponCodesPromotionRule",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleData",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleDataType",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsCouponCodesPromotionRuleLinks",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsMarket",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsMarketData",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsMarketDataType",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsMarketLinks",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsOrderAmountPromotionRule",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleData",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleDataType",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsOrderAmountPromotionRuleLinks",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsPromotionRules",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsPromotionRulesData",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsPromotionRulesDataType",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsPromotionRulesLinks",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsSkuList",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsSkuListData",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsSkuListDataType",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsSkuListLinks",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsSkuListPromotionRule",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsSkuListPromotionRuleData",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsSkuListPromotionRuleDataType",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsSkuListPromotionRuleLinks",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsSkus",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsSkusData",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsSkusDataType",
    "POSTpercentageDiscountPromotionsResponse201DataRelationshipsSkusLinks",
    "POSTpercentageDiscountPromotionsResponse201DataType",
    "POSTpriceListsResponse201",
    "POSTpriceListsResponse201Data",
    "POSTpriceListsResponse201DataAttributes",
    "POSTpriceListsResponse201DataAttributesMetadata",
    "POSTpriceListsResponse201DataLinks",
    "POSTpriceListsResponse201DataRelationships",
    "POSTpriceListsResponse201DataRelationshipsAttachments",
    "POSTpriceListsResponse201DataRelationshipsAttachmentsData",
    "POSTpriceListsResponse201DataRelationshipsAttachmentsDataType",
    "POSTpriceListsResponse201DataRelationshipsAttachmentsLinks",
    "POSTpriceListsResponse201DataRelationshipsPrices",
    "POSTpriceListsResponse201DataRelationshipsPricesData",
    "POSTpriceListsResponse201DataRelationshipsPricesDataType",
    "POSTpriceListsResponse201DataRelationshipsPricesLinks",
    "POSTpriceListsResponse201DataType",
    "POSTpricesResponse201",
    "POSTpricesResponse201Data",
    "POSTpricesResponse201DataAttributes",
    "POSTpricesResponse201DataAttributesMetadata",
    "POSTpricesResponse201DataLinks",
    "POSTpricesResponse201DataRelationships",
    "POSTpricesResponse201DataRelationshipsAttachments",
    "POSTpricesResponse201DataRelationshipsAttachmentsData",
    "POSTpricesResponse201DataRelationshipsAttachmentsDataType",
    "POSTpricesResponse201DataRelationshipsAttachmentsLinks",
    "POSTpricesResponse201DataRelationshipsPriceList",
    "POSTpricesResponse201DataRelationshipsPriceListData",
    "POSTpricesResponse201DataRelationshipsPriceListDataType",
    "POSTpricesResponse201DataRelationshipsPriceListLinks",
    "POSTpricesResponse201DataRelationshipsPriceTiers",
    "POSTpricesResponse201DataRelationshipsPriceTiersData",
    "POSTpricesResponse201DataRelationshipsPriceTiersDataType",
    "POSTpricesResponse201DataRelationshipsPriceTiersLinks",
    "POSTpricesResponse201DataRelationshipsPriceVolumeTiers",
    "POSTpricesResponse201DataRelationshipsPriceVolumeTiersData",
    "POSTpricesResponse201DataRelationshipsPriceVolumeTiersDataType",
    "POSTpricesResponse201DataRelationshipsPriceVolumeTiersLinks",
    "POSTpricesResponse201DataRelationshipsSku",
    "POSTpricesResponse201DataRelationshipsSkuData",
    "POSTpricesResponse201DataRelationshipsSkuDataType",
    "POSTpricesResponse201DataRelationshipsSkuLinks",
    "POSTpricesResponse201DataType",
    "POSTpriceVolumeTiersResponse201",
    "POSTpriceVolumeTiersResponse201Data",
    "POSTpriceVolumeTiersResponse201DataAttributes",
    "POSTpriceVolumeTiersResponse201DataAttributesMetadata",
    "POSTpriceVolumeTiersResponse201DataLinks",
    "POSTpriceVolumeTiersResponse201DataRelationships",
    "POSTpriceVolumeTiersResponse201DataRelationshipsAttachments",
    "POSTpriceVolumeTiersResponse201DataRelationshipsAttachmentsData",
    "POSTpriceVolumeTiersResponse201DataRelationshipsAttachmentsDataType",
    "POSTpriceVolumeTiersResponse201DataRelationshipsAttachmentsLinks",
    "POSTpriceVolumeTiersResponse201DataRelationshipsPrice",
    "POSTpriceVolumeTiersResponse201DataRelationshipsPriceData",
    "POSTpriceVolumeTiersResponse201DataRelationshipsPriceDataType",
    "POSTpriceVolumeTiersResponse201DataRelationshipsPriceLinks",
    "POSTpriceVolumeTiersResponse201DataType",
    "POSTreturnLineItemsResponse201",
    "POSTreturnLineItemsResponse201Data",
    "POSTreturnLineItemsResponse201DataAttributes",
    "POSTreturnLineItemsResponse201DataAttributesMetadata",
    "POSTreturnLineItemsResponse201DataAttributesReturnReason",
    "POSTreturnLineItemsResponse201DataLinks",
    "POSTreturnLineItemsResponse201DataRelationships",
    "POSTreturnLineItemsResponse201DataRelationshipsLineItem",
    "POSTreturnLineItemsResponse201DataRelationshipsLineItemData",
    "POSTreturnLineItemsResponse201DataRelationshipsLineItemDataType",
    "POSTreturnLineItemsResponse201DataRelationshipsLineItemLinks",
    "POSTreturnLineItemsResponse201DataRelationshipsReturn",
    "POSTreturnLineItemsResponse201DataRelationshipsReturnData",
    "POSTreturnLineItemsResponse201DataRelationshipsReturnDataType",
    "POSTreturnLineItemsResponse201DataRelationshipsReturnLinks",
    "POSTreturnLineItemsResponse201DataType",
    "POSTreturnsResponse201",
    "POSTreturnsResponse201Data",
    "POSTreturnsResponse201DataAttributes",
    "POSTreturnsResponse201DataAttributesMetadata",
    "POSTreturnsResponse201DataLinks",
    "POSTreturnsResponse201DataRelationships",
    "POSTreturnsResponse201DataRelationshipsAttachments",
    "POSTreturnsResponse201DataRelationshipsAttachmentsData",
    "POSTreturnsResponse201DataRelationshipsAttachmentsDataType",
    "POSTreturnsResponse201DataRelationshipsAttachmentsLinks",
    "POSTreturnsResponse201DataRelationshipsCustomer",
    "POSTreturnsResponse201DataRelationshipsCustomerData",
    "POSTreturnsResponse201DataRelationshipsCustomerDataType",
    "POSTreturnsResponse201DataRelationshipsCustomerLinks",
    "POSTreturnsResponse201DataRelationshipsDestinationAddress",
    "POSTreturnsResponse201DataRelationshipsDestinationAddressData",
    "POSTreturnsResponse201DataRelationshipsDestinationAddressDataType",
    "POSTreturnsResponse201DataRelationshipsDestinationAddressLinks",
    "POSTreturnsResponse201DataRelationshipsEvents",
    "POSTreturnsResponse201DataRelationshipsEventsData",
    "POSTreturnsResponse201DataRelationshipsEventsDataType",
    "POSTreturnsResponse201DataRelationshipsEventsLinks",
    "POSTreturnsResponse201DataRelationshipsOrder",
    "POSTreturnsResponse201DataRelationshipsOrderData",
    "POSTreturnsResponse201DataRelationshipsOrderDataType",
    "POSTreturnsResponse201DataRelationshipsOrderLinks",
    "POSTreturnsResponse201DataRelationshipsOriginAddress",
    "POSTreturnsResponse201DataRelationshipsOriginAddressData",
    "POSTreturnsResponse201DataRelationshipsOriginAddressDataType",
    "POSTreturnsResponse201DataRelationshipsOriginAddressLinks",
    "POSTreturnsResponse201DataRelationshipsReturnLineItems",
    "POSTreturnsResponse201DataRelationshipsReturnLineItemsData",
    "POSTreturnsResponse201DataRelationshipsReturnLineItemsDataType",
    "POSTreturnsResponse201DataRelationshipsReturnLineItemsLinks",
    "POSTreturnsResponse201DataRelationshipsStockLocation",
    "POSTreturnsResponse201DataRelationshipsStockLocationData",
    "POSTreturnsResponse201DataRelationshipsStockLocationDataType",
    "POSTreturnsResponse201DataRelationshipsStockLocationLinks",
    "POSTreturnsResponse201DataType",
    "POSTshippingCategoriesResponse201",
    "POSTshippingCategoriesResponse201Data",
    "POSTshippingCategoriesResponse201DataAttributes",
    "POSTshippingCategoriesResponse201DataAttributesMetadata",
    "POSTshippingCategoriesResponse201DataLinks",
    "POSTshippingCategoriesResponse201DataRelationships",
    "POSTshippingCategoriesResponse201DataRelationshipsAttachments",
    "POSTshippingCategoriesResponse201DataRelationshipsAttachmentsData",
    "POSTshippingCategoriesResponse201DataRelationshipsAttachmentsDataType",
    "POSTshippingCategoriesResponse201DataRelationshipsAttachmentsLinks",
    "POSTshippingCategoriesResponse201DataRelationshipsSkus",
    "POSTshippingCategoriesResponse201DataRelationshipsSkusData",
    "POSTshippingCategoriesResponse201DataRelationshipsSkusDataType",
    "POSTshippingCategoriesResponse201DataRelationshipsSkusLinks",
    "POSTshippingCategoriesResponse201DataType",
    "POSTshippingMethodsResponse201",
    "POSTshippingMethodsResponse201Data",
    "POSTshippingMethodsResponse201DataAttributes",
    "POSTshippingMethodsResponse201DataAttributesMetadata",
    "POSTshippingMethodsResponse201DataLinks",
    "POSTshippingMethodsResponse201DataRelationships",
    "POSTshippingMethodsResponse201DataRelationshipsAttachments",
    "POSTshippingMethodsResponse201DataRelationshipsAttachmentsData",
    "POSTshippingMethodsResponse201DataRelationshipsAttachmentsDataType",
    "POSTshippingMethodsResponse201DataRelationshipsAttachmentsLinks",
    "POSTshippingMethodsResponse201DataRelationshipsDeliveryLeadTimeForShipment",
    "POSTshippingMethodsResponse201DataRelationshipsDeliveryLeadTimeForShipmentData",
    "POSTshippingMethodsResponse201DataRelationshipsDeliveryLeadTimeForShipmentDataType",
    "POSTshippingMethodsResponse201DataRelationshipsDeliveryLeadTimeForShipmentLinks",
    "POSTshippingMethodsResponse201DataRelationshipsMarket",
    "POSTshippingMethodsResponse201DataRelationshipsMarketData",
    "POSTshippingMethodsResponse201DataRelationshipsMarketDataType",
    "POSTshippingMethodsResponse201DataRelationshipsMarketLinks",
    "POSTshippingMethodsResponse201DataRelationshipsShippingCategory",
    "POSTshippingMethodsResponse201DataRelationshipsShippingCategoryData",
    "POSTshippingMethodsResponse201DataRelationshipsShippingCategoryDataType",
    "POSTshippingMethodsResponse201DataRelationshipsShippingCategoryLinks",
    "POSTshippingMethodsResponse201DataRelationshipsShippingMethodTiers",
    "POSTshippingMethodsResponse201DataRelationshipsShippingMethodTiersData",
    "POSTshippingMethodsResponse201DataRelationshipsShippingMethodTiersDataType",
    "POSTshippingMethodsResponse201DataRelationshipsShippingMethodTiersLinks",
    "POSTshippingMethodsResponse201DataRelationshipsShippingWeightTiers",
    "POSTshippingMethodsResponse201DataRelationshipsShippingWeightTiersData",
    "POSTshippingMethodsResponse201DataRelationshipsShippingWeightTiersDataType",
    "POSTshippingMethodsResponse201DataRelationshipsShippingWeightTiersLinks",
    "POSTshippingMethodsResponse201DataRelationshipsShippingZone",
    "POSTshippingMethodsResponse201DataRelationshipsShippingZoneData",
    "POSTshippingMethodsResponse201DataRelationshipsShippingZoneDataType",
    "POSTshippingMethodsResponse201DataRelationshipsShippingZoneLinks",
    "POSTshippingMethodsResponse201DataRelationshipsStockLocation",
    "POSTshippingMethodsResponse201DataRelationshipsStockLocationData",
    "POSTshippingMethodsResponse201DataRelationshipsStockLocationDataType",
    "POSTshippingMethodsResponse201DataRelationshipsStockLocationLinks",
    "POSTshippingMethodsResponse201DataType",
    "POSTshippingWeightTiersResponse201",
    "POSTshippingWeightTiersResponse201Data",
    "POSTshippingWeightTiersResponse201DataAttributes",
    "POSTshippingWeightTiersResponse201DataAttributesMetadata",
    "POSTshippingWeightTiersResponse201DataLinks",
    "POSTshippingWeightTiersResponse201DataRelationships",
    "POSTshippingWeightTiersResponse201DataRelationshipsAttachments",
    "POSTshippingWeightTiersResponse201DataRelationshipsAttachmentsData",
    "POSTshippingWeightTiersResponse201DataRelationshipsAttachmentsDataType",
    "POSTshippingWeightTiersResponse201DataRelationshipsAttachmentsLinks",
    "POSTshippingWeightTiersResponse201DataRelationshipsShippingMethod",
    "POSTshippingWeightTiersResponse201DataRelationshipsShippingMethodData",
    "POSTshippingWeightTiersResponse201DataRelationshipsShippingMethodDataType",
    "POSTshippingWeightTiersResponse201DataRelationshipsShippingMethodLinks",
    "POSTshippingWeightTiersResponse201DataType",
    "POSTshippingZonesResponse201",
    "POSTshippingZonesResponse201Data",
    "POSTshippingZonesResponse201DataAttributes",
    "POSTshippingZonesResponse201DataAttributesMetadata",
    "POSTshippingZonesResponse201DataLinks",
    "POSTshippingZonesResponse201DataRelationships",
    "POSTshippingZonesResponse201DataRelationshipsAttachments",
    "POSTshippingZonesResponse201DataRelationshipsAttachmentsData",
    "POSTshippingZonesResponse201DataRelationshipsAttachmentsDataType",
    "POSTshippingZonesResponse201DataRelationshipsAttachmentsLinks",
    "POSTshippingZonesResponse201DataType",
    "POSTskuListItemsResponse201",
    "POSTskuListItemsResponse201Data",
    "POSTskuListItemsResponse201DataAttributes",
    "POSTskuListItemsResponse201DataAttributesMetadata",
    "POSTskuListItemsResponse201DataLinks",
    "POSTskuListItemsResponse201DataRelationships",
    "POSTskuListItemsResponse201DataRelationshipsSku",
    "POSTskuListItemsResponse201DataRelationshipsSkuData",
    "POSTskuListItemsResponse201DataRelationshipsSkuDataType",
    "POSTskuListItemsResponse201DataRelationshipsSkuLinks",
    "POSTskuListItemsResponse201DataRelationshipsSkuList",
    "POSTskuListItemsResponse201DataRelationshipsSkuListData",
    "POSTskuListItemsResponse201DataRelationshipsSkuListDataType",
    "POSTskuListItemsResponse201DataRelationshipsSkuListLinks",
    "POSTskuListItemsResponse201DataType",
    "POSTskuListPromotionRulesResponse201",
    "POSTskuListPromotionRulesResponse201Data",
    "POSTskuListPromotionRulesResponse201DataAttributes",
    "POSTskuListPromotionRulesResponse201DataAttributesMetadata",
    "POSTskuListPromotionRulesResponse201DataLinks",
    "POSTskuListPromotionRulesResponse201DataRelationships",
    "POSTskuListPromotionRulesResponse201DataRelationshipsPromotion",
    "POSTskuListPromotionRulesResponse201DataRelationshipsPromotionData",
    "POSTskuListPromotionRulesResponse201DataRelationshipsPromotionDataType",
    "POSTskuListPromotionRulesResponse201DataRelationshipsPromotionLinks",
    "POSTskuListPromotionRulesResponse201DataRelationshipsSkuList",
    "POSTskuListPromotionRulesResponse201DataRelationshipsSkuListData",
    "POSTskuListPromotionRulesResponse201DataRelationshipsSkuListDataType",
    "POSTskuListPromotionRulesResponse201DataRelationshipsSkuListLinks",
    "POSTskuListPromotionRulesResponse201DataRelationshipsSkus",
    "POSTskuListPromotionRulesResponse201DataRelationshipsSkusData",
    "POSTskuListPromotionRulesResponse201DataRelationshipsSkusDataType",
    "POSTskuListPromotionRulesResponse201DataRelationshipsSkusLinks",
    "POSTskuListPromotionRulesResponse201DataType",
    "POSTskuListsResponse201",
    "POSTskuListsResponse201Data",
    "POSTskuListsResponse201DataAttributes",
    "POSTskuListsResponse201DataAttributesMetadata",
    "POSTskuListsResponse201DataLinks",
    "POSTskuListsResponse201DataRelationships",
    "POSTskuListsResponse201DataRelationshipsAttachments",
    "POSTskuListsResponse201DataRelationshipsAttachmentsData",
    "POSTskuListsResponse201DataRelationshipsAttachmentsDataType",
    "POSTskuListsResponse201DataRelationshipsAttachmentsLinks",
    "POSTskuListsResponse201DataRelationshipsBundles",
    "POSTskuListsResponse201DataRelationshipsBundlesData",
    "POSTskuListsResponse201DataRelationshipsBundlesDataType",
    "POSTskuListsResponse201DataRelationshipsBundlesLinks",
    "POSTskuListsResponse201DataRelationshipsCustomer",
    "POSTskuListsResponse201DataRelationshipsCustomerData",
    "POSTskuListsResponse201DataRelationshipsCustomerDataType",
    "POSTskuListsResponse201DataRelationshipsCustomerLinks",
    "POSTskuListsResponse201DataRelationshipsSkuListItems",
    "POSTskuListsResponse201DataRelationshipsSkuListItemsData",
    "POSTskuListsResponse201DataRelationshipsSkuListItemsDataType",
    "POSTskuListsResponse201DataRelationshipsSkuListItemsLinks",
    "POSTskuListsResponse201DataRelationshipsSkus",
    "POSTskuListsResponse201DataRelationshipsSkusData",
    "POSTskuListsResponse201DataRelationshipsSkusDataType",
    "POSTskuListsResponse201DataRelationshipsSkusLinks",
    "POSTskuListsResponse201DataType",
    "POSTskuOptionsResponse201",
    "POSTskuOptionsResponse201Data",
    "POSTskuOptionsResponse201DataAttributes",
    "POSTskuOptionsResponse201DataAttributesMetadata",
    "POSTskuOptionsResponse201DataLinks",
    "POSTskuOptionsResponse201DataRelationships",
    "POSTskuOptionsResponse201DataRelationshipsAttachments",
    "POSTskuOptionsResponse201DataRelationshipsAttachmentsData",
    "POSTskuOptionsResponse201DataRelationshipsAttachmentsDataType",
    "POSTskuOptionsResponse201DataRelationshipsAttachmentsLinks",
    "POSTskuOptionsResponse201DataRelationshipsMarket",
    "POSTskuOptionsResponse201DataRelationshipsMarketData",
    "POSTskuOptionsResponse201DataRelationshipsMarketDataType",
    "POSTskuOptionsResponse201DataRelationshipsMarketLinks",
    "POSTskuOptionsResponse201DataType",
    "POSTskusResponse201",
    "POSTskusResponse201Data",
    "POSTskusResponse201DataAttributes",
    "POSTskusResponse201DataAttributesMetadata",
    "POSTskusResponse201DataLinks",
    "POSTskusResponse201DataRelationships",
    "POSTskusResponse201DataRelationshipsAttachments",
    "POSTskusResponse201DataRelationshipsAttachmentsData",
    "POSTskusResponse201DataRelationshipsAttachmentsDataType",
    "POSTskusResponse201DataRelationshipsAttachmentsLinks",
    "POSTskusResponse201DataRelationshipsDeliveryLeadTimes",
    "POSTskusResponse201DataRelationshipsDeliveryLeadTimesData",
    "POSTskusResponse201DataRelationshipsDeliveryLeadTimesDataType",
    "POSTskusResponse201DataRelationshipsDeliveryLeadTimesLinks",
    "POSTskusResponse201DataRelationshipsPrices",
    "POSTskusResponse201DataRelationshipsPricesData",
    "POSTskusResponse201DataRelationshipsPricesDataType",
    "POSTskusResponse201DataRelationshipsPricesLinks",
    "POSTskusResponse201DataRelationshipsShippingCategory",
    "POSTskusResponse201DataRelationshipsShippingCategoryData",
    "POSTskusResponse201DataRelationshipsShippingCategoryDataType",
    "POSTskusResponse201DataRelationshipsShippingCategoryLinks",
    "POSTskusResponse201DataRelationshipsSkuOptions",
    "POSTskusResponse201DataRelationshipsSkuOptionsData",
    "POSTskusResponse201DataRelationshipsSkuOptionsDataType",
    "POSTskusResponse201DataRelationshipsSkuOptionsLinks",
    "POSTskusResponse201DataRelationshipsStockItems",
    "POSTskusResponse201DataRelationshipsStockItemsData",
    "POSTskusResponse201DataRelationshipsStockItemsDataType",
    "POSTskusResponse201DataRelationshipsStockItemsLinks",
    "POSTskusResponse201DataType",
    "POSTstockItemsResponse201",
    "POSTstockItemsResponse201Data",
    "POSTstockItemsResponse201DataAttributes",
    "POSTstockItemsResponse201DataAttributesMetadata",
    "POSTstockItemsResponse201DataLinks",
    "POSTstockItemsResponse201DataRelationships",
    "POSTstockItemsResponse201DataRelationshipsAttachments",
    "POSTstockItemsResponse201DataRelationshipsAttachmentsData",
    "POSTstockItemsResponse201DataRelationshipsAttachmentsDataType",
    "POSTstockItemsResponse201DataRelationshipsAttachmentsLinks",
    "POSTstockItemsResponse201DataRelationshipsSku",
    "POSTstockItemsResponse201DataRelationshipsSkuData",
    "POSTstockItemsResponse201DataRelationshipsSkuDataType",
    "POSTstockItemsResponse201DataRelationshipsSkuLinks",
    "POSTstockItemsResponse201DataRelationshipsStockLocation",
    "POSTstockItemsResponse201DataRelationshipsStockLocationData",
    "POSTstockItemsResponse201DataRelationshipsStockLocationDataType",
    "POSTstockItemsResponse201DataRelationshipsStockLocationLinks",
    "POSTstockItemsResponse201DataType",
    "POSTstockLocationsResponse201",
    "POSTstockLocationsResponse201Data",
    "POSTstockLocationsResponse201DataAttributes",
    "POSTstockLocationsResponse201DataAttributesMetadata",
    "POSTstockLocationsResponse201DataLinks",
    "POSTstockLocationsResponse201DataRelationships",
    "POSTstockLocationsResponse201DataRelationshipsAddress",
    "POSTstockLocationsResponse201DataRelationshipsAddressData",
    "POSTstockLocationsResponse201DataRelationshipsAddressDataType",
    "POSTstockLocationsResponse201DataRelationshipsAddressLinks",
    "POSTstockLocationsResponse201DataRelationshipsAttachments",
    "POSTstockLocationsResponse201DataRelationshipsAttachmentsData",
    "POSTstockLocationsResponse201DataRelationshipsAttachmentsDataType",
    "POSTstockLocationsResponse201DataRelationshipsAttachmentsLinks",
    "POSTstockLocationsResponse201DataRelationshipsInventoryReturnLocations",
    "POSTstockLocationsResponse201DataRelationshipsInventoryReturnLocationsData",
    "POSTstockLocationsResponse201DataRelationshipsInventoryReturnLocationsDataType",
    "POSTstockLocationsResponse201DataRelationshipsInventoryReturnLocationsLinks",
    "POSTstockLocationsResponse201DataRelationshipsInventoryStockLocations",
    "POSTstockLocationsResponse201DataRelationshipsInventoryStockLocationsData",
    "POSTstockLocationsResponse201DataRelationshipsInventoryStockLocationsDataType",
    "POSTstockLocationsResponse201DataRelationshipsInventoryStockLocationsLinks",
    "POSTstockLocationsResponse201DataRelationshipsStockItems",
    "POSTstockLocationsResponse201DataRelationshipsStockItemsData",
    "POSTstockLocationsResponse201DataRelationshipsStockItemsDataType",
    "POSTstockLocationsResponse201DataRelationshipsStockItemsLinks",
    "POSTstockLocationsResponse201DataRelationshipsStockTransfers",
    "POSTstockLocationsResponse201DataRelationshipsStockTransfersData",
    "POSTstockLocationsResponse201DataRelationshipsStockTransfersDataType",
    "POSTstockLocationsResponse201DataRelationshipsStockTransfersLinks",
    "POSTstockLocationsResponse201DataType",
    "POSTstockTransfersResponse201",
    "POSTstockTransfersResponse201Data",
    "POSTstockTransfersResponse201DataAttributes",
    "POSTstockTransfersResponse201DataAttributesMetadata",
    "POSTstockTransfersResponse201DataLinks",
    "POSTstockTransfersResponse201DataRelationships",
    "POSTstockTransfersResponse201DataRelationshipsDestinationStockLocation",
    "POSTstockTransfersResponse201DataRelationshipsDestinationStockLocationData",
    "POSTstockTransfersResponse201DataRelationshipsDestinationStockLocationDataType",
    "POSTstockTransfersResponse201DataRelationshipsDestinationStockLocationLinks",
    "POSTstockTransfersResponse201DataRelationshipsEvents",
    "POSTstockTransfersResponse201DataRelationshipsEventsData",
    "POSTstockTransfersResponse201DataRelationshipsEventsDataType",
    "POSTstockTransfersResponse201DataRelationshipsEventsLinks",
    "POSTstockTransfersResponse201DataRelationshipsLineItem",
    "POSTstockTransfersResponse201DataRelationshipsLineItemData",
    "POSTstockTransfersResponse201DataRelationshipsLineItemDataType",
    "POSTstockTransfersResponse201DataRelationshipsLineItemLinks",
    "POSTstockTransfersResponse201DataRelationshipsOriginStockLocation",
    "POSTstockTransfersResponse201DataRelationshipsOriginStockLocationData",
    "POSTstockTransfersResponse201DataRelationshipsOriginStockLocationDataType",
    "POSTstockTransfersResponse201DataRelationshipsOriginStockLocationLinks",
    "POSTstockTransfersResponse201DataRelationshipsShipment",
    "POSTstockTransfersResponse201DataRelationshipsShipmentData",
    "POSTstockTransfersResponse201DataRelationshipsShipmentDataType",
    "POSTstockTransfersResponse201DataRelationshipsShipmentLinks",
    "POSTstockTransfersResponse201DataRelationshipsSku",
    "POSTstockTransfersResponse201DataRelationshipsSkuData",
    "POSTstockTransfersResponse201DataRelationshipsSkuDataType",
    "POSTstockTransfersResponse201DataRelationshipsSkuLinks",
    "POSTstockTransfersResponse201DataType",
    "POSTstripeGatewaysResponse201",
    "POSTstripeGatewaysResponse201Data",
    "POSTstripeGatewaysResponse201DataAttributes",
    "POSTstripeGatewaysResponse201DataAttributesMetadata",
    "POSTstripeGatewaysResponse201DataLinks",
    "POSTstripeGatewaysResponse201DataRelationships",
    "POSTstripeGatewaysResponse201DataRelationshipsPaymentMethods",
    "POSTstripeGatewaysResponse201DataRelationshipsPaymentMethodsData",
    "POSTstripeGatewaysResponse201DataRelationshipsPaymentMethodsDataType",
    "POSTstripeGatewaysResponse201DataRelationshipsPaymentMethodsLinks",
    "POSTstripeGatewaysResponse201DataRelationshipsStripePayments",
    "POSTstripeGatewaysResponse201DataRelationshipsStripePaymentsData",
    "POSTstripeGatewaysResponse201DataRelationshipsStripePaymentsDataType",
    "POSTstripeGatewaysResponse201DataRelationshipsStripePaymentsLinks",
    "POSTstripeGatewaysResponse201DataType",
    "POSTstripePaymentsResponse201",
    "POSTstripePaymentsResponse201Data",
    "POSTstripePaymentsResponse201DataAttributes",
    "POSTstripePaymentsResponse201DataAttributesMetadata",
    "POSTstripePaymentsResponse201DataAttributesOptions",
    "POSTstripePaymentsResponse201DataLinks",
    "POSTstripePaymentsResponse201DataRelationships",
    "POSTstripePaymentsResponse201DataRelationshipsOrder",
    "POSTstripePaymentsResponse201DataRelationshipsOrderData",
    "POSTstripePaymentsResponse201DataRelationshipsOrderDataType",
    "POSTstripePaymentsResponse201DataRelationshipsOrderLinks",
    "POSTstripePaymentsResponse201DataRelationshipsPaymentGateway",
    "POSTstripePaymentsResponse201DataRelationshipsPaymentGatewayData",
    "POSTstripePaymentsResponse201DataRelationshipsPaymentGatewayDataType",
    "POSTstripePaymentsResponse201DataRelationshipsPaymentGatewayLinks",
    "POSTstripePaymentsResponse201DataType",
    "POSTtaxCategoriesResponse201",
    "POSTtaxCategoriesResponse201Data",
    "POSTtaxCategoriesResponse201DataAttributes",
    "POSTtaxCategoriesResponse201DataAttributesMetadata",
    "POSTtaxCategoriesResponse201DataLinks",
    "POSTtaxCategoriesResponse201DataRelationships",
    "POSTtaxCategoriesResponse201DataRelationshipsAttachments",
    "POSTtaxCategoriesResponse201DataRelationshipsAttachmentsData",
    "POSTtaxCategoriesResponse201DataRelationshipsAttachmentsDataType",
    "POSTtaxCategoriesResponse201DataRelationshipsAttachmentsLinks",
    "POSTtaxCategoriesResponse201DataRelationshipsSku",
    "POSTtaxCategoriesResponse201DataRelationshipsSkuData",
    "POSTtaxCategoriesResponse201DataRelationshipsSkuDataType",
    "POSTtaxCategoriesResponse201DataRelationshipsSkuLinks",
    "POSTtaxCategoriesResponse201DataRelationshipsTaxCalculator",
    "POSTtaxCategoriesResponse201DataRelationshipsTaxCalculatorData",
    "POSTtaxCategoriesResponse201DataRelationshipsTaxCalculatorDataType",
    "POSTtaxCategoriesResponse201DataRelationshipsTaxCalculatorLinks",
    "POSTtaxCategoriesResponse201DataType",
    "POSTtaxjarAccountsResponse201",
    "POSTtaxjarAccountsResponse201Data",
    "POSTtaxjarAccountsResponse201DataAttributes",
    "POSTtaxjarAccountsResponse201DataAttributesMetadata",
    "POSTtaxjarAccountsResponse201DataLinks",
    "POSTtaxjarAccountsResponse201DataRelationships",
    "POSTtaxjarAccountsResponse201DataRelationshipsAttachments",
    "POSTtaxjarAccountsResponse201DataRelationshipsAttachmentsData",
    "POSTtaxjarAccountsResponse201DataRelationshipsAttachmentsDataType",
    "POSTtaxjarAccountsResponse201DataRelationshipsAttachmentsLinks",
    "POSTtaxjarAccountsResponse201DataRelationshipsMarkets",
    "POSTtaxjarAccountsResponse201DataRelationshipsMarketsData",
    "POSTtaxjarAccountsResponse201DataRelationshipsMarketsDataType",
    "POSTtaxjarAccountsResponse201DataRelationshipsMarketsLinks",
    "POSTtaxjarAccountsResponse201DataRelationshipsTaxCategories",
    "POSTtaxjarAccountsResponse201DataRelationshipsTaxCategoriesData",
    "POSTtaxjarAccountsResponse201DataRelationshipsTaxCategoriesDataType",
    "POSTtaxjarAccountsResponse201DataRelationshipsTaxCategoriesLinks",
    "POSTtaxjarAccountsResponse201DataType",
    "POSTtaxRulesResponse201",
    "POSTtaxRulesResponse201Data",
    "POSTtaxRulesResponse201DataAttributes",
    "POSTtaxRulesResponse201DataAttributesMetadata",
    "POSTtaxRulesResponse201DataLinks",
    "POSTtaxRulesResponse201DataRelationships",
    "POSTtaxRulesResponse201DataRelationshipsManualTaxCalculator",
    "POSTtaxRulesResponse201DataRelationshipsManualTaxCalculatorData",
    "POSTtaxRulesResponse201DataRelationshipsManualTaxCalculatorDataType",
    "POSTtaxRulesResponse201DataRelationshipsManualTaxCalculatorLinks",
    "POSTtaxRulesResponse201DataType",
    "POSTwebhooksResponse201",
    "POSTwebhooksResponse201Data",
    "POSTwebhooksResponse201DataAttributes",
    "POSTwebhooksResponse201DataAttributesMetadata",
    "POSTwebhooksResponse201DataLinks",
    "POSTwebhooksResponse201DataRelationships",
    "POSTwebhooksResponse201DataRelationshipsLastEventCallbacks",
    "POSTwebhooksResponse201DataRelationshipsLastEventCallbacksData",
    "POSTwebhooksResponse201DataRelationshipsLastEventCallbacksDataType",
    "POSTwebhooksResponse201DataRelationshipsLastEventCallbacksLinks",
    "POSTwebhooksResponse201DataType",
    "POSTwireTransfersResponse201",
    "POSTwireTransfersResponse201Data",
    "POSTwireTransfersResponse201DataAttributes",
    "POSTwireTransfersResponse201DataAttributesMetadata",
    "POSTwireTransfersResponse201DataLinks",
    "POSTwireTransfersResponse201DataRelationships",
    "POSTwireTransfersResponse201DataRelationshipsOrder",
    "POSTwireTransfersResponse201DataRelationshipsOrderData",
    "POSTwireTransfersResponse201DataRelationshipsOrderDataType",
    "POSTwireTransfersResponse201DataRelationshipsOrderLinks",
    "POSTwireTransfersResponse201DataType",
    "Price",
    "PriceCreate",
    "PriceCreateData",
    "PriceCreateDataAttributes",
    "PriceCreateDataAttributesMetadata",
    "PriceCreateDataRelationships",
    "PriceCreateDataRelationshipsPriceList",
    "PriceCreateDataRelationshipsPriceListData",
    "PriceCreateDataRelationshipsPriceListDataType",
    "PriceCreateDataRelationshipsPriceTiers",
    "PriceCreateDataRelationshipsPriceTiersData",
    "PriceCreateDataRelationshipsPriceTiersDataType",
    "PriceCreateDataRelationshipsSku",
    "PriceCreateDataRelationshipsSkuData",
    "PriceCreateDataRelationshipsSkuDataType",
    "PriceCreateDataType",
    "PriceData",
    "PriceDataAttributes",
    "PriceDataAttributesMetadata",
    "PriceDataRelationships",
    "PriceDataRelationshipsAttachments",
    "PriceDataRelationshipsAttachmentsData",
    "PriceDataRelationshipsAttachmentsDataType",
    "PriceDataRelationshipsPriceList",
    "PriceDataRelationshipsPriceListData",
    "PriceDataRelationshipsPriceListDataType",
    "PriceDataRelationshipsPriceTiers",
    "PriceDataRelationshipsPriceTiersData",
    "PriceDataRelationshipsPriceTiersDataType",
    "PriceDataRelationshipsPriceVolumeTiers",
    "PriceDataRelationshipsPriceVolumeTiersData",
    "PriceDataRelationshipsPriceVolumeTiersDataType",
    "PriceDataRelationshipsSku",
    "PriceDataRelationshipsSkuData",
    "PriceDataRelationshipsSkuDataType",
    "PriceDataType",
    "PriceList",
    "PriceListCreate",
    "PriceListCreateData",
    "PriceListCreateDataAttributes",
    "PriceListCreateDataAttributesMetadata",
    "PriceListCreateDataRelationships",
    "PriceListCreateDataType",
    "PriceListData",
    "PriceListDataAttributes",
    "PriceListDataAttributesMetadata",
    "PriceListDataRelationships",
    "PriceListDataRelationshipsAttachments",
    "PriceListDataRelationshipsAttachmentsData",
    "PriceListDataRelationshipsAttachmentsDataType",
    "PriceListDataRelationshipsPrices",
    "PriceListDataRelationshipsPricesData",
    "PriceListDataRelationshipsPricesDataType",
    "PriceListDataType",
    "PriceListUpdate",
    "PriceListUpdateData",
    "PriceListUpdateDataAttributes",
    "PriceListUpdateDataAttributesMetadata",
    "PriceListUpdateDataRelationships",
    "PriceListUpdateDataType",
    "PriceTier",
    "PriceTierData",
    "PriceTierDataAttributes",
    "PriceTierDataAttributesMetadata",
    "PriceTierDataRelationships",
    "PriceTierDataRelationshipsAttachments",
    "PriceTierDataRelationshipsAttachmentsData",
    "PriceTierDataRelationshipsAttachmentsDataType",
    "PriceTierDataRelationshipsPrice",
    "PriceTierDataRelationshipsPriceData",
    "PriceTierDataRelationshipsPriceDataType",
    "PriceTierDataType",
    "PriceUpdate",
    "PriceUpdateData",
    "PriceUpdateDataAttributes",
    "PriceUpdateDataAttributesMetadata",
    "PriceUpdateDataRelationships",
    "PriceUpdateDataRelationshipsPriceList",
    "PriceUpdateDataRelationshipsPriceListData",
    "PriceUpdateDataRelationshipsPriceListDataType",
    "PriceUpdateDataRelationshipsPriceTiers",
    "PriceUpdateDataRelationshipsPriceTiersData",
    "PriceUpdateDataRelationshipsPriceTiersDataType",
    "PriceUpdateDataRelationshipsSku",
    "PriceUpdateDataRelationshipsSkuData",
    "PriceUpdateDataRelationshipsSkuDataType",
    "PriceUpdateDataType",
    "PriceVolumeTier",
    "PriceVolumeTierCreate",
    "PriceVolumeTierCreateData",
    "PriceVolumeTierCreateDataAttributes",
    "PriceVolumeTierCreateDataAttributesMetadata",
    "PriceVolumeTierCreateDataRelationships",
    "PriceVolumeTierCreateDataRelationshipsPrice",
    "PriceVolumeTierCreateDataRelationshipsPriceData",
    "PriceVolumeTierCreateDataRelationshipsPriceDataType",
    "PriceVolumeTierCreateDataType",
    "PriceVolumeTierData",
    "PriceVolumeTierDataAttributes",
    "PriceVolumeTierDataAttributesMetadata",
    "PriceVolumeTierDataRelationships",
    "PriceVolumeTierDataRelationshipsAttachments",
    "PriceVolumeTierDataRelationshipsAttachmentsData",
    "PriceVolumeTierDataRelationshipsAttachmentsDataType",
    "PriceVolumeTierDataRelationshipsPrice",
    "PriceVolumeTierDataRelationshipsPriceData",
    "PriceVolumeTierDataRelationshipsPriceDataType",
    "PriceVolumeTierDataType",
    "PriceVolumeTierUpdate",
    "PriceVolumeTierUpdateData",
    "PriceVolumeTierUpdateDataAttributes",
    "PriceVolumeTierUpdateDataAttributesMetadata",
    "PriceVolumeTierUpdateDataRelationships",
    "PriceVolumeTierUpdateDataRelationshipsPrice",
    "PriceVolumeTierUpdateDataRelationshipsPriceData",
    "PriceVolumeTierUpdateDataRelationshipsPriceDataType",
    "PriceVolumeTierUpdateDataType",
    "Promotion",
    "PromotionData",
    "PromotionDataAttributes",
    "PromotionDataAttributesMetadata",
    "PromotionDataRelationships",
    "PromotionDataRelationshipsAttachments",
    "PromotionDataRelationshipsAttachmentsData",
    "PromotionDataRelationshipsAttachmentsDataType",
    "PromotionDataRelationshipsCouponCodesPromotionRule",
    "PromotionDataRelationshipsCouponCodesPromotionRuleData",
    "PromotionDataRelationshipsCouponCodesPromotionRuleDataType",
    "PromotionDataRelationshipsMarket",
    "PromotionDataRelationshipsMarketData",
    "PromotionDataRelationshipsMarketDataType",
    "PromotionDataRelationshipsOrderAmountPromotionRule",
    "PromotionDataRelationshipsOrderAmountPromotionRuleData",
    "PromotionDataRelationshipsOrderAmountPromotionRuleDataType",
    "PromotionDataRelationshipsPromotionRules",
    "PromotionDataRelationshipsPromotionRulesData",
    "PromotionDataRelationshipsPromotionRulesDataType",
    "PromotionDataRelationshipsSkuListPromotionRule",
    "PromotionDataRelationshipsSkuListPromotionRuleData",
    "PromotionDataRelationshipsSkuListPromotionRuleDataType",
    "PromotionDataType",
    "PromotionRule",
    "PromotionRuleData",
    "PromotionRuleDataAttributes",
    "PromotionRuleDataAttributesMetadata",
    "PromotionRuleDataRelationships",
    "PromotionRuleDataType",
    "Refund",
    "RefundData",
    "RefundDataAttributes",
    "RefundDataAttributesMetadata",
    "RefundDataRelationships",
    "RefundDataRelationshipsEvents",
    "RefundDataRelationshipsEventsData",
    "RefundDataRelationshipsEventsDataType",
    "RefundDataRelationshipsOrder",
    "RefundDataRelationshipsOrderData",
    "RefundDataRelationshipsOrderDataType",
    "RefundDataRelationshipsReferenceCapture",
    "RefundDataRelationshipsReferenceCaptureData",
    "RefundDataRelationshipsReferenceCaptureDataType",
    "RefundDataType",
    "Return",
    "ReturnCreate",
    "ReturnCreateData",
    "ReturnCreateDataAttributes",
    "ReturnCreateDataAttributesMetadata",
    "ReturnCreateDataRelationships",
    "ReturnCreateDataRelationshipsOrder",
    "ReturnCreateDataRelationshipsOrderData",
    "ReturnCreateDataRelationshipsOrderDataType",
    "ReturnCreateDataRelationshipsStockLocation",
    "ReturnCreateDataRelationshipsStockLocationData",
    "ReturnCreateDataRelationshipsStockLocationDataType",
    "ReturnCreateDataType",
    "ReturnData",
    "ReturnDataAttributes",
    "ReturnDataAttributesMetadata",
    "ReturnDataRelationships",
    "ReturnDataRelationshipsAttachments",
    "ReturnDataRelationshipsAttachmentsData",
    "ReturnDataRelationshipsAttachmentsDataType",
    "ReturnDataRelationshipsCustomer",
    "ReturnDataRelationshipsCustomerData",
    "ReturnDataRelationshipsCustomerDataType",
    "ReturnDataRelationshipsDestinationAddress",
    "ReturnDataRelationshipsDestinationAddressData",
    "ReturnDataRelationshipsDestinationAddressDataType",
    "ReturnDataRelationshipsEvents",
    "ReturnDataRelationshipsEventsData",
    "ReturnDataRelationshipsEventsDataType",
    "ReturnDataRelationshipsOrder",
    "ReturnDataRelationshipsOrderData",
    "ReturnDataRelationshipsOrderDataType",
    "ReturnDataRelationshipsOriginAddress",
    "ReturnDataRelationshipsOriginAddressData",
    "ReturnDataRelationshipsOriginAddressDataType",
    "ReturnDataRelationshipsReturnLineItems",
    "ReturnDataRelationshipsReturnLineItemsData",
    "ReturnDataRelationshipsReturnLineItemsDataType",
    "ReturnDataRelationshipsStockLocation",
    "ReturnDataRelationshipsStockLocationData",
    "ReturnDataRelationshipsStockLocationDataType",
    "ReturnDataType",
    "ReturnLineItem",
    "ReturnLineItemCreate",
    "ReturnLineItemCreateData",
    "ReturnLineItemCreateDataAttributes",
    "ReturnLineItemCreateDataAttributesMetadata",
    "ReturnLineItemCreateDataAttributesReturnReason",
    "ReturnLineItemCreateDataRelationships",
    "ReturnLineItemCreateDataRelationshipsLineItem",
    "ReturnLineItemCreateDataRelationshipsLineItemData",
    "ReturnLineItemCreateDataRelationshipsLineItemDataType",
    "ReturnLineItemCreateDataRelationshipsReturn",
    "ReturnLineItemCreateDataRelationshipsReturnData",
    "ReturnLineItemCreateDataRelationshipsReturnDataType",
    "ReturnLineItemCreateDataType",
    "ReturnLineItemData",
    "ReturnLineItemDataAttributes",
    "ReturnLineItemDataAttributesMetadata",
    "ReturnLineItemDataAttributesReturnReason",
    "ReturnLineItemDataRelationships",
    "ReturnLineItemDataRelationshipsLineItem",
    "ReturnLineItemDataRelationshipsLineItemData",
    "ReturnLineItemDataRelationshipsLineItemDataType",
    "ReturnLineItemDataRelationshipsReturn",
    "ReturnLineItemDataRelationshipsReturnData",
    "ReturnLineItemDataRelationshipsReturnDataType",
    "ReturnLineItemDataType",
    "ReturnLineItemUpdate",
    "ReturnLineItemUpdateData",
    "ReturnLineItemUpdateDataAttributes",
    "ReturnLineItemUpdateDataAttributesMetadata",
    "ReturnLineItemUpdateDataAttributesReturnReason",
    "ReturnLineItemUpdateDataRelationships",
    "ReturnLineItemUpdateDataType",
    "ReturnUpdate",
    "ReturnUpdateData",
    "ReturnUpdateDataAttributes",
    "ReturnUpdateDataAttributesMetadata",
    "ReturnUpdateDataRelationships",
    "ReturnUpdateDataRelationshipsStockLocation",
    "ReturnUpdateDataRelationshipsStockLocationData",
    "ReturnUpdateDataRelationshipsStockLocationDataType",
    "ReturnUpdateDataType",
    "Shipment",
    "ShipmentData",
    "ShipmentDataAttributes",
    "ShipmentDataAttributesGetRatesErrorsItem",
    "ShipmentDataAttributesMetadata",
    "ShipmentDataAttributesRatesItem",
    "ShipmentDataRelationships",
    "ShipmentDataRelationshipsAttachments",
    "ShipmentDataRelationshipsAttachmentsData",
    "ShipmentDataRelationshipsAttachmentsDataType",
    "ShipmentDataRelationshipsAvailableShippingMethods",
    "ShipmentDataRelationshipsAvailableShippingMethodsData",
    "ShipmentDataRelationshipsAvailableShippingMethodsDataType",
    "ShipmentDataRelationshipsCarrierAccounts",
    "ShipmentDataRelationshipsCarrierAccountsData",
    "ShipmentDataRelationshipsCarrierAccountsDataType",
    "ShipmentDataRelationshipsDeliveryLeadTime",
    "ShipmentDataRelationshipsDeliveryLeadTimeData",
    "ShipmentDataRelationshipsDeliveryLeadTimeDataType",
    "ShipmentDataRelationshipsEvents",
    "ShipmentDataRelationshipsEventsData",
    "ShipmentDataRelationshipsEventsDataType",
    "ShipmentDataRelationshipsOrder",
    "ShipmentDataRelationshipsOrderData",
    "ShipmentDataRelationshipsOrderDataType",
    "ShipmentDataRelationshipsOriginAddress",
    "ShipmentDataRelationshipsOriginAddressData",
    "ShipmentDataRelationshipsOriginAddressDataType",
    "ShipmentDataRelationshipsParcels",
    "ShipmentDataRelationshipsParcelsData",
    "ShipmentDataRelationshipsParcelsDataType",
    "ShipmentDataRelationshipsShipmentLineItems",
    "ShipmentDataRelationshipsShipmentLineItemsData",
    "ShipmentDataRelationshipsShipmentLineItemsDataType",
    "ShipmentDataRelationshipsShippingAddress",
    "ShipmentDataRelationshipsShippingAddressData",
    "ShipmentDataRelationshipsShippingAddressDataType",
    "ShipmentDataRelationshipsShippingCategory",
    "ShipmentDataRelationshipsShippingCategoryData",
    "ShipmentDataRelationshipsShippingCategoryDataType",
    "ShipmentDataRelationshipsShippingMethod",
    "ShipmentDataRelationshipsShippingMethodData",
    "ShipmentDataRelationshipsShippingMethodDataType",
    "ShipmentDataRelationshipsStockLineItems",
    "ShipmentDataRelationshipsStockLineItemsData",
    "ShipmentDataRelationshipsStockLineItemsDataType",
    "ShipmentDataRelationshipsStockLocation",
    "ShipmentDataRelationshipsStockLocationData",
    "ShipmentDataRelationshipsStockLocationDataType",
    "ShipmentDataRelationshipsStockTransfers",
    "ShipmentDataRelationshipsStockTransfersData",
    "ShipmentDataRelationshipsStockTransfersDataType",
    "ShipmentDataType",
    "ShipmentUpdate",
    "ShipmentUpdateData",
    "ShipmentUpdateDataAttributes",
    "ShipmentUpdateDataAttributesMetadata",
    "ShipmentUpdateDataRelationships",
    "ShipmentUpdateDataRelationshipsShippingMethod",
    "ShipmentUpdateDataRelationshipsShippingMethodData",
    "ShipmentUpdateDataRelationshipsShippingMethodDataType",
    "ShipmentUpdateDataType",
    "ShippingCategory",
    "ShippingCategoryCreate",
    "ShippingCategoryCreateData",
    "ShippingCategoryCreateDataAttributes",
    "ShippingCategoryCreateDataAttributesMetadata",
    "ShippingCategoryCreateDataRelationships",
    "ShippingCategoryCreateDataType",
    "ShippingCategoryData",
    "ShippingCategoryDataAttributes",
    "ShippingCategoryDataAttributesMetadata",
    "ShippingCategoryDataRelationships",
    "ShippingCategoryDataRelationshipsAttachments",
    "ShippingCategoryDataRelationshipsAttachmentsData",
    "ShippingCategoryDataRelationshipsAttachmentsDataType",
    "ShippingCategoryDataRelationshipsSkus",
    "ShippingCategoryDataRelationshipsSkusData",
    "ShippingCategoryDataRelationshipsSkusDataType",
    "ShippingCategoryDataType",
    "ShippingCategoryUpdate",
    "ShippingCategoryUpdateData",
    "ShippingCategoryUpdateDataAttributes",
    "ShippingCategoryUpdateDataAttributesMetadata",
    "ShippingCategoryUpdateDataRelationships",
    "ShippingCategoryUpdateDataType",
    "ShippingMethod",
    "ShippingMethodCreate",
    "ShippingMethodCreateData",
    "ShippingMethodCreateDataAttributes",
    "ShippingMethodCreateDataAttributesMetadata",
    "ShippingMethodCreateDataRelationships",
    "ShippingMethodCreateDataRelationshipsMarket",
    "ShippingMethodCreateDataRelationshipsMarketData",
    "ShippingMethodCreateDataRelationshipsMarketDataType",
    "ShippingMethodCreateDataRelationshipsShippingCategory",
    "ShippingMethodCreateDataRelationshipsShippingCategoryData",
    "ShippingMethodCreateDataRelationshipsShippingCategoryDataType",
    "ShippingMethodCreateDataRelationshipsShippingMethodTiers",
    "ShippingMethodCreateDataRelationshipsShippingMethodTiersData",
    "ShippingMethodCreateDataRelationshipsShippingMethodTiersDataType",
    "ShippingMethodCreateDataRelationshipsShippingZone",
    "ShippingMethodCreateDataRelationshipsShippingZoneData",
    "ShippingMethodCreateDataRelationshipsShippingZoneDataType",
    "ShippingMethodCreateDataRelationshipsStockLocation",
    "ShippingMethodCreateDataRelationshipsStockLocationData",
    "ShippingMethodCreateDataRelationshipsStockLocationDataType",
    "ShippingMethodCreateDataType",
    "ShippingMethodData",
    "ShippingMethodDataAttributes",
    "ShippingMethodDataAttributesMetadata",
    "ShippingMethodDataRelationships",
    "ShippingMethodDataRelationshipsAttachments",
    "ShippingMethodDataRelationshipsAttachmentsData",
    "ShippingMethodDataRelationshipsAttachmentsDataType",
    "ShippingMethodDataRelationshipsDeliveryLeadTimeForShipment",
    "ShippingMethodDataRelationshipsDeliveryLeadTimeForShipmentData",
    "ShippingMethodDataRelationshipsDeliveryLeadTimeForShipmentDataType",
    "ShippingMethodDataRelationshipsMarket",
    "ShippingMethodDataRelationshipsMarketData",
    "ShippingMethodDataRelationshipsMarketDataType",
    "ShippingMethodDataRelationshipsShippingCategory",
    "ShippingMethodDataRelationshipsShippingCategoryData",
    "ShippingMethodDataRelationshipsShippingCategoryDataType",
    "ShippingMethodDataRelationshipsShippingMethodTiers",
    "ShippingMethodDataRelationshipsShippingMethodTiersData",
    "ShippingMethodDataRelationshipsShippingMethodTiersDataType",
    "ShippingMethodDataRelationshipsShippingWeightTiers",
    "ShippingMethodDataRelationshipsShippingWeightTiersData",
    "ShippingMethodDataRelationshipsShippingWeightTiersDataType",
    "ShippingMethodDataRelationshipsShippingZone",
    "ShippingMethodDataRelationshipsShippingZoneData",
    "ShippingMethodDataRelationshipsShippingZoneDataType",
    "ShippingMethodDataRelationshipsStockLocation",
    "ShippingMethodDataRelationshipsStockLocationData",
    "ShippingMethodDataRelationshipsStockLocationDataType",
    "ShippingMethodDataType",
    "ShippingMethodTier",
    "ShippingMethodTierData",
    "ShippingMethodTierDataAttributes",
    "ShippingMethodTierDataAttributesMetadata",
    "ShippingMethodTierDataRelationships",
    "ShippingMethodTierDataRelationshipsAttachments",
    "ShippingMethodTierDataRelationshipsAttachmentsData",
    "ShippingMethodTierDataRelationshipsAttachmentsDataType",
    "ShippingMethodTierDataRelationshipsShippingMethod",
    "ShippingMethodTierDataRelationshipsShippingMethodData",
    "ShippingMethodTierDataRelationshipsShippingMethodDataType",
    "ShippingMethodTierDataType",
    "ShippingMethodUpdate",
    "ShippingMethodUpdateData",
    "ShippingMethodUpdateDataAttributes",
    "ShippingMethodUpdateDataAttributesMetadata",
    "ShippingMethodUpdateDataRelationships",
    "ShippingMethodUpdateDataRelationshipsMarket",
    "ShippingMethodUpdateDataRelationshipsMarketData",
    "ShippingMethodUpdateDataRelationshipsMarketDataType",
    "ShippingMethodUpdateDataRelationshipsShippingCategory",
    "ShippingMethodUpdateDataRelationshipsShippingCategoryData",
    "ShippingMethodUpdateDataRelationshipsShippingCategoryDataType",
    "ShippingMethodUpdateDataRelationshipsShippingMethodTiers",
    "ShippingMethodUpdateDataRelationshipsShippingMethodTiersData",
    "ShippingMethodUpdateDataRelationshipsShippingMethodTiersDataType",
    "ShippingMethodUpdateDataRelationshipsShippingZone",
    "ShippingMethodUpdateDataRelationshipsShippingZoneData",
    "ShippingMethodUpdateDataRelationshipsShippingZoneDataType",
    "ShippingMethodUpdateDataRelationshipsStockLocation",
    "ShippingMethodUpdateDataRelationshipsStockLocationData",
    "ShippingMethodUpdateDataRelationshipsStockLocationDataType",
    "ShippingMethodUpdateDataType",
    "ShippingWeightTier",
    "ShippingWeightTierCreate",
    "ShippingWeightTierCreateData",
    "ShippingWeightTierCreateDataAttributes",
    "ShippingWeightTierCreateDataAttributesMetadata",
    "ShippingWeightTierCreateDataRelationships",
    "ShippingWeightTierCreateDataRelationshipsShippingMethod",
    "ShippingWeightTierCreateDataRelationshipsShippingMethodData",
    "ShippingWeightTierCreateDataRelationshipsShippingMethodDataType",
    "ShippingWeightTierCreateDataType",
    "ShippingWeightTierData",
    "ShippingWeightTierDataAttributes",
    "ShippingWeightTierDataAttributesMetadata",
    "ShippingWeightTierDataRelationships",
    "ShippingWeightTierDataRelationshipsAttachments",
    "ShippingWeightTierDataRelationshipsAttachmentsData",
    "ShippingWeightTierDataRelationshipsAttachmentsDataType",
    "ShippingWeightTierDataRelationshipsShippingMethod",
    "ShippingWeightTierDataRelationshipsShippingMethodData",
    "ShippingWeightTierDataRelationshipsShippingMethodDataType",
    "ShippingWeightTierDataType",
    "ShippingWeightTierUpdate",
    "ShippingWeightTierUpdateData",
    "ShippingWeightTierUpdateDataAttributes",
    "ShippingWeightTierUpdateDataAttributesMetadata",
    "ShippingWeightTierUpdateDataRelationships",
    "ShippingWeightTierUpdateDataRelationshipsShippingMethod",
    "ShippingWeightTierUpdateDataRelationshipsShippingMethodData",
    "ShippingWeightTierUpdateDataRelationshipsShippingMethodDataType",
    "ShippingWeightTierUpdateDataType",
    "ShippingZone",
    "ShippingZoneCreate",
    "ShippingZoneCreateData",
    "ShippingZoneCreateDataAttributes",
    "ShippingZoneCreateDataAttributesMetadata",
    "ShippingZoneCreateDataRelationships",
    "ShippingZoneCreateDataType",
    "ShippingZoneData",
    "ShippingZoneDataAttributes",
    "ShippingZoneDataAttributesMetadata",
    "ShippingZoneDataRelationships",
    "ShippingZoneDataRelationshipsAttachments",
    "ShippingZoneDataRelationshipsAttachmentsData",
    "ShippingZoneDataRelationshipsAttachmentsDataType",
    "ShippingZoneDataType",
    "ShippingZoneUpdate",
    "ShippingZoneUpdateData",
    "ShippingZoneUpdateDataAttributes",
    "ShippingZoneUpdateDataAttributesMetadata",
    "ShippingZoneUpdateDataRelationships",
    "ShippingZoneUpdateDataType",
    "Sku",
    "SkuCreate",
    "SkuCreateData",
    "SkuCreateDataAttributes",
    "SkuCreateDataAttributesMetadata",
    "SkuCreateDataRelationships",
    "SkuCreateDataRelationshipsShippingCategory",
    "SkuCreateDataRelationshipsShippingCategoryData",
    "SkuCreateDataRelationshipsShippingCategoryDataType",
    "SkuCreateDataType",
    "SkuData",
    "SkuDataAttributes",
    "SkuDataAttributesInventory",
    "SkuDataAttributesMetadata",
    "SkuDataRelationships",
    "SkuDataRelationshipsAttachments",
    "SkuDataRelationshipsAttachmentsData",
    "SkuDataRelationshipsAttachmentsDataType",
    "SkuDataRelationshipsDeliveryLeadTimes",
    "SkuDataRelationshipsDeliveryLeadTimesData",
    "SkuDataRelationshipsDeliveryLeadTimesDataType",
    "SkuDataRelationshipsPrices",
    "SkuDataRelationshipsPricesData",
    "SkuDataRelationshipsPricesDataType",
    "SkuDataRelationshipsShippingCategory",
    "SkuDataRelationshipsShippingCategoryData",
    "SkuDataRelationshipsShippingCategoryDataType",
    "SkuDataRelationshipsSkuOptions",
    "SkuDataRelationshipsSkuOptionsData",
    "SkuDataRelationshipsSkuOptionsDataType",
    "SkuDataRelationshipsStockItems",
    "SkuDataRelationshipsStockItemsData",
    "SkuDataRelationshipsStockItemsDataType",
    "SkuDataType",
    "SkuList",
    "SkuListCreate",
    "SkuListCreateData",
    "SkuListCreateDataAttributes",
    "SkuListCreateDataAttributesMetadata",
    "SkuListCreateDataRelationships",
    "SkuListCreateDataRelationshipsCustomer",
    "SkuListCreateDataRelationshipsCustomerData",
    "SkuListCreateDataRelationshipsCustomerDataType",
    "SkuListCreateDataType",
    "SkuListData",
    "SkuListDataAttributes",
    "SkuListDataAttributesMetadata",
    "SkuListDataRelationships",
    "SkuListDataRelationshipsAttachments",
    "SkuListDataRelationshipsAttachmentsData",
    "SkuListDataRelationshipsAttachmentsDataType",
    "SkuListDataRelationshipsBundles",
    "SkuListDataRelationshipsBundlesData",
    "SkuListDataRelationshipsBundlesDataType",
    "SkuListDataRelationshipsCustomer",
    "SkuListDataRelationshipsCustomerData",
    "SkuListDataRelationshipsCustomerDataType",
    "SkuListDataRelationshipsSkuListItems",
    "SkuListDataRelationshipsSkuListItemsData",
    "SkuListDataRelationshipsSkuListItemsDataType",
    "SkuListDataRelationshipsSkus",
    "SkuListDataRelationshipsSkusData",
    "SkuListDataRelationshipsSkusDataType",
    "SkuListDataType",
    "SkuListItem",
    "SkuListItemCreate",
    "SkuListItemCreateData",
    "SkuListItemCreateDataAttributes",
    "SkuListItemCreateDataAttributesMetadata",
    "SkuListItemCreateDataRelationships",
    "SkuListItemCreateDataRelationshipsSku",
    "SkuListItemCreateDataRelationshipsSkuData",
    "SkuListItemCreateDataRelationshipsSkuDataType",
    "SkuListItemCreateDataRelationshipsSkuList",
    "SkuListItemCreateDataRelationshipsSkuListData",
    "SkuListItemCreateDataRelationshipsSkuListDataType",
    "SkuListItemCreateDataType",
    "SkuListItemData",
    "SkuListItemDataAttributes",
    "SkuListItemDataAttributesMetadata",
    "SkuListItemDataRelationships",
    "SkuListItemDataRelationshipsSku",
    "SkuListItemDataRelationshipsSkuData",
    "SkuListItemDataRelationshipsSkuDataType",
    "SkuListItemDataRelationshipsSkuList",
    "SkuListItemDataRelationshipsSkuListData",
    "SkuListItemDataRelationshipsSkuListDataType",
    "SkuListItemDataType",
    "SkuListItemUpdate",
    "SkuListItemUpdateData",
    "SkuListItemUpdateDataAttributes",
    "SkuListItemUpdateDataAttributesMetadata",
    "SkuListItemUpdateDataRelationships",
    "SkuListItemUpdateDataType",
    "SkuListPromotionRule",
    "SkuListPromotionRuleCreate",
    "SkuListPromotionRuleCreateData",
    "SkuListPromotionRuleCreateDataAttributes",
    "SkuListPromotionRuleCreateDataAttributesMetadata",
    "SkuListPromotionRuleCreateDataRelationships",
    "SkuListPromotionRuleCreateDataRelationshipsSkuList",
    "SkuListPromotionRuleCreateDataRelationshipsSkuListData",
    "SkuListPromotionRuleCreateDataRelationshipsSkuListDataType",
    "SkuListPromotionRuleCreateDataType",
    "SkuListPromotionRuleData",
    "SkuListPromotionRuleDataAttributes",
    "SkuListPromotionRuleDataAttributesMetadata",
    "SkuListPromotionRuleDataRelationships",
    "SkuListPromotionRuleDataRelationshipsSkuList",
    "SkuListPromotionRuleDataRelationshipsSkuListData",
    "SkuListPromotionRuleDataRelationshipsSkuListDataType",
    "SkuListPromotionRuleDataRelationshipsSkus",
    "SkuListPromotionRuleDataRelationshipsSkusData",
    "SkuListPromotionRuleDataRelationshipsSkusDataType",
    "SkuListPromotionRuleDataType",
    "SkuListPromotionRuleUpdate",
    "SkuListPromotionRuleUpdateData",
    "SkuListPromotionRuleUpdateDataAttributes",
    "SkuListPromotionRuleUpdateDataAttributesMetadata",
    "SkuListPromotionRuleUpdateDataRelationships",
    "SkuListPromotionRuleUpdateDataRelationshipsSkuList",
    "SkuListPromotionRuleUpdateDataRelationshipsSkuListData",
    "SkuListPromotionRuleUpdateDataRelationshipsSkuListDataType",
    "SkuListPromotionRuleUpdateDataType",
    "SkuListUpdate",
    "SkuListUpdateData",
    "SkuListUpdateDataAttributes",
    "SkuListUpdateDataAttributesMetadata",
    "SkuListUpdateDataRelationships",
    "SkuListUpdateDataRelationshipsCustomer",
    "SkuListUpdateDataRelationshipsCustomerData",
    "SkuListUpdateDataRelationshipsCustomerDataType",
    "SkuListUpdateDataType",
    "SkuOption",
    "SkuOptionCreate",
    "SkuOptionCreateData",
    "SkuOptionCreateDataAttributes",
    "SkuOptionCreateDataAttributesMetadata",
    "SkuOptionCreateDataRelationships",
    "SkuOptionCreateDataRelationshipsMarket",
    "SkuOptionCreateDataRelationshipsMarketData",
    "SkuOptionCreateDataRelationshipsMarketDataType",
    "SkuOptionCreateDataType",
    "SkuOptionData",
    "SkuOptionDataAttributes",
    "SkuOptionDataAttributesMetadata",
    "SkuOptionDataRelationships",
    "SkuOptionDataRelationshipsAttachments",
    "SkuOptionDataRelationshipsAttachmentsData",
    "SkuOptionDataRelationshipsAttachmentsDataType",
    "SkuOptionDataRelationshipsMarket",
    "SkuOptionDataRelationshipsMarketData",
    "SkuOptionDataRelationshipsMarketDataType",
    "SkuOptionDataType",
    "SkuOptionUpdate",
    "SkuOptionUpdateData",
    "SkuOptionUpdateDataAttributes",
    "SkuOptionUpdateDataAttributesMetadata",
    "SkuOptionUpdateDataRelationships",
    "SkuOptionUpdateDataRelationshipsMarket",
    "SkuOptionUpdateDataRelationshipsMarketData",
    "SkuOptionUpdateDataRelationshipsMarketDataType",
    "SkuOptionUpdateDataType",
    "SkuUpdate",
    "SkuUpdateData",
    "SkuUpdateDataAttributes",
    "SkuUpdateDataAttributesMetadata",
    "SkuUpdateDataRelationships",
    "SkuUpdateDataRelationshipsShippingCategory",
    "SkuUpdateDataRelationshipsShippingCategoryData",
    "SkuUpdateDataRelationshipsShippingCategoryDataType",
    "SkuUpdateDataType",
    "StockItem",
    "StockItemCreate",
    "StockItemCreateData",
    "StockItemCreateDataAttributes",
    "StockItemCreateDataAttributesMetadata",
    "StockItemCreateDataRelationships",
    "StockItemCreateDataRelationshipsSku",
    "StockItemCreateDataRelationshipsSkuData",
    "StockItemCreateDataRelationshipsSkuDataType",
    "StockItemCreateDataRelationshipsStockLocation",
    "StockItemCreateDataRelationshipsStockLocationData",
    "StockItemCreateDataRelationshipsStockLocationDataType",
    "StockItemCreateDataType",
    "StockItemData",
    "StockItemDataAttributes",
    "StockItemDataAttributesMetadata",
    "StockItemDataRelationships",
    "StockItemDataRelationshipsAttachments",
    "StockItemDataRelationshipsAttachmentsData",
    "StockItemDataRelationshipsAttachmentsDataType",
    "StockItemDataRelationshipsSku",
    "StockItemDataRelationshipsSkuData",
    "StockItemDataRelationshipsSkuDataType",
    "StockItemDataRelationshipsStockLocation",
    "StockItemDataRelationshipsStockLocationData",
    "StockItemDataRelationshipsStockLocationDataType",
    "StockItemDataType",
    "StockItemUpdate",
    "StockItemUpdateData",
    "StockItemUpdateDataAttributes",
    "StockItemUpdateDataAttributesMetadata",
    "StockItemUpdateDataRelationships",
    "StockItemUpdateDataRelationshipsSku",
    "StockItemUpdateDataRelationshipsSkuData",
    "StockItemUpdateDataRelationshipsSkuDataType",
    "StockItemUpdateDataRelationshipsStockLocation",
    "StockItemUpdateDataRelationshipsStockLocationData",
    "StockItemUpdateDataRelationshipsStockLocationDataType",
    "StockItemUpdateDataType",
    "StockLineItem",
    "StockLineItemData",
    "StockLineItemDataAttributes",
    "StockLineItemDataAttributesMetadata",
    "StockLineItemDataRelationships",
    "StockLineItemDataRelationshipsLineItem",
    "StockLineItemDataRelationshipsLineItemData",
    "StockLineItemDataRelationshipsLineItemDataType",
    "StockLineItemDataRelationshipsShipment",
    "StockLineItemDataRelationshipsShipmentData",
    "StockLineItemDataRelationshipsShipmentDataType",
    "StockLineItemDataRelationshipsStockItem",
    "StockLineItemDataRelationshipsStockItemData",
    "StockLineItemDataRelationshipsStockItemDataType",
    "StockLineItemDataType",
    "StockLocation",
    "StockLocationCreate",
    "StockLocationCreateData",
    "StockLocationCreateDataAttributes",
    "StockLocationCreateDataAttributesMetadata",
    "StockLocationCreateDataRelationships",
    "StockLocationCreateDataRelationshipsAddress",
    "StockLocationCreateDataRelationshipsAddressData",
    "StockLocationCreateDataRelationshipsAddressDataType",
    "StockLocationCreateDataType",
    "StockLocationData",
    "StockLocationDataAttributes",
    "StockLocationDataAttributesMetadata",
    "StockLocationDataRelationships",
    "StockLocationDataRelationshipsAddress",
    "StockLocationDataRelationshipsAddressData",
    "StockLocationDataRelationshipsAddressDataType",
    "StockLocationDataRelationshipsAttachments",
    "StockLocationDataRelationshipsAttachmentsData",
    "StockLocationDataRelationshipsAttachmentsDataType",
    "StockLocationDataRelationshipsInventoryReturnLocations",
    "StockLocationDataRelationshipsInventoryReturnLocationsData",
    "StockLocationDataRelationshipsInventoryReturnLocationsDataType",
    "StockLocationDataRelationshipsInventoryStockLocations",
    "StockLocationDataRelationshipsInventoryStockLocationsData",
    "StockLocationDataRelationshipsInventoryStockLocationsDataType",
    "StockLocationDataRelationshipsStockItems",
    "StockLocationDataRelationshipsStockItemsData",
    "StockLocationDataRelationshipsStockItemsDataType",
    "StockLocationDataRelationshipsStockTransfers",
    "StockLocationDataRelationshipsStockTransfersData",
    "StockLocationDataRelationshipsStockTransfersDataType",
    "StockLocationDataType",
    "StockLocationUpdate",
    "StockLocationUpdateData",
    "StockLocationUpdateDataAttributes",
    "StockLocationUpdateDataAttributesMetadata",
    "StockLocationUpdateDataRelationships",
    "StockLocationUpdateDataRelationshipsAddress",
    "StockLocationUpdateDataRelationshipsAddressData",
    "StockLocationUpdateDataRelationshipsAddressDataType",
    "StockLocationUpdateDataType",
    "StockTransfer",
    "StockTransferCreate",
    "StockTransferCreateData",
    "StockTransferCreateDataAttributes",
    "StockTransferCreateDataAttributesMetadata",
    "StockTransferCreateDataRelationships",
    "StockTransferCreateDataRelationshipsDestinationStockLocation",
    "StockTransferCreateDataRelationshipsDestinationStockLocationData",
    "StockTransferCreateDataRelationshipsDestinationStockLocationDataType",
    "StockTransferCreateDataRelationshipsLineItem",
    "StockTransferCreateDataRelationshipsLineItemData",
    "StockTransferCreateDataRelationshipsLineItemDataType",
    "StockTransferCreateDataRelationshipsOriginStockLocation",
    "StockTransferCreateDataRelationshipsOriginStockLocationData",
    "StockTransferCreateDataRelationshipsOriginStockLocationDataType",
    "StockTransferCreateDataRelationshipsShipment",
    "StockTransferCreateDataRelationshipsShipmentData",
    "StockTransferCreateDataRelationshipsShipmentDataType",
    "StockTransferCreateDataRelationshipsSku",
    "StockTransferCreateDataRelationshipsSkuData",
    "StockTransferCreateDataRelationshipsSkuDataType",
    "StockTransferCreateDataType",
    "StockTransferData",
    "StockTransferDataAttributes",
    "StockTransferDataAttributesMetadata",
    "StockTransferDataRelationships",
    "StockTransferDataRelationshipsDestinationStockLocation",
    "StockTransferDataRelationshipsDestinationStockLocationData",
    "StockTransferDataRelationshipsDestinationStockLocationDataType",
    "StockTransferDataRelationshipsEvents",
    "StockTransferDataRelationshipsEventsData",
    "StockTransferDataRelationshipsEventsDataType",
    "StockTransferDataRelationshipsLineItem",
    "StockTransferDataRelationshipsLineItemData",
    "StockTransferDataRelationshipsLineItemDataType",
    "StockTransferDataRelationshipsOriginStockLocation",
    "StockTransferDataRelationshipsOriginStockLocationData",
    "StockTransferDataRelationshipsOriginStockLocationDataType",
    "StockTransferDataRelationshipsShipment",
    "StockTransferDataRelationshipsShipmentData",
    "StockTransferDataRelationshipsShipmentDataType",
    "StockTransferDataRelationshipsSku",
    "StockTransferDataRelationshipsSkuData",
    "StockTransferDataRelationshipsSkuDataType",
    "StockTransferDataType",
    "StockTransferUpdate",
    "StockTransferUpdateData",
    "StockTransferUpdateDataAttributes",
    "StockTransferUpdateDataAttributesMetadata",
    "StockTransferUpdateDataRelationships",
    "StockTransferUpdateDataRelationshipsDestinationStockLocation",
    "StockTransferUpdateDataRelationshipsDestinationStockLocationData",
    "StockTransferUpdateDataRelationshipsDestinationStockLocationDataType",
    "StockTransferUpdateDataRelationshipsOriginStockLocation",
    "StockTransferUpdateDataRelationshipsOriginStockLocationData",
    "StockTransferUpdateDataRelationshipsOriginStockLocationDataType",
    "StockTransferUpdateDataRelationshipsSku",
    "StockTransferUpdateDataRelationshipsSkuData",
    "StockTransferUpdateDataRelationshipsSkuDataType",
    "StockTransferUpdateDataType",
    "StripeGateway",
    "StripeGatewayCreate",
    "StripeGatewayCreateData",
    "StripeGatewayCreateDataAttributes",
    "StripeGatewayCreateDataAttributesMetadata",
    "StripeGatewayCreateDataRelationships",
    "StripeGatewayCreateDataType",
    "StripeGatewayData",
    "StripeGatewayDataAttributes",
    "StripeGatewayDataAttributesMetadata",
    "StripeGatewayDataRelationships",
    "StripeGatewayDataRelationshipsPaymentMethods",
    "StripeGatewayDataRelationshipsPaymentMethodsData",
    "StripeGatewayDataRelationshipsPaymentMethodsDataType",
    "StripeGatewayDataRelationshipsStripePayments",
    "StripeGatewayDataRelationshipsStripePaymentsData",
    "StripeGatewayDataRelationshipsStripePaymentsDataType",
    "StripeGatewayDataType",
    "StripeGatewayUpdate",
    "StripeGatewayUpdateData",
    "StripeGatewayUpdateDataAttributes",
    "StripeGatewayUpdateDataAttributesMetadata",
    "StripeGatewayUpdateDataRelationships",
    "StripeGatewayUpdateDataType",
    "StripePayment",
    "StripePaymentCreate",
    "StripePaymentCreateData",
    "StripePaymentCreateDataAttributes",
    "StripePaymentCreateDataAttributesMetadata",
    "StripePaymentCreateDataAttributesOptions",
    "StripePaymentCreateDataRelationships",
    "StripePaymentCreateDataRelationshipsOrder",
    "StripePaymentCreateDataRelationshipsOrderData",
    "StripePaymentCreateDataRelationshipsOrderDataType",
    "StripePaymentCreateDataType",
    "StripePaymentData",
    "StripePaymentDataAttributes",
    "StripePaymentDataAttributesMetadata",
    "StripePaymentDataAttributesOptions",
    "StripePaymentDataAttributesPaymentMethod",
    "StripePaymentDataRelationships",
    "StripePaymentDataRelationshipsOrder",
    "StripePaymentDataRelationshipsOrderData",
    "StripePaymentDataRelationshipsOrderDataType",
    "StripePaymentDataRelationshipsPaymentGateway",
    "StripePaymentDataRelationshipsPaymentGatewayData",
    "StripePaymentDataRelationshipsPaymentGatewayDataType",
    "StripePaymentDataType",
    "StripePaymentUpdate",
    "StripePaymentUpdateData",
    "StripePaymentUpdateDataAttributes",
    "StripePaymentUpdateDataAttributesMetadata",
    "StripePaymentUpdateDataAttributesOptions",
    "StripePaymentUpdateDataRelationships",
    "StripePaymentUpdateDataRelationshipsOrder",
    "StripePaymentUpdateDataRelationshipsOrderData",
    "StripePaymentUpdateDataRelationshipsOrderDataType",
    "StripePaymentUpdateDataType",
    "TaxCalculator",
    "TaxCalculatorData",
    "TaxCalculatorDataAttributes",
    "TaxCalculatorDataAttributesMetadata",
    "TaxCalculatorDataRelationships",
    "TaxCalculatorDataRelationshipsAttachments",
    "TaxCalculatorDataRelationshipsAttachmentsData",
    "TaxCalculatorDataRelationshipsAttachmentsDataType",
    "TaxCalculatorDataRelationshipsMarkets",
    "TaxCalculatorDataRelationshipsMarketsData",
    "TaxCalculatorDataRelationshipsMarketsDataType",
    "TaxCalculatorDataType",
    "TaxCategory",
    "TaxCategoryCreate",
    "TaxCategoryCreateData",
    "TaxCategoryCreateDataAttributes",
    "TaxCategoryCreateDataAttributesMetadata",
    "TaxCategoryCreateDataRelationships",
    "TaxCategoryCreateDataRelationshipsSku",
    "TaxCategoryCreateDataRelationshipsSkuData",
    "TaxCategoryCreateDataRelationshipsSkuDataType",
    "TaxCategoryCreateDataType",
    "TaxCategoryData",
    "TaxCategoryDataAttributes",
    "TaxCategoryDataAttributesMetadata",
    "TaxCategoryDataRelationships",
    "TaxCategoryDataRelationshipsAttachments",
    "TaxCategoryDataRelationshipsAttachmentsData",
    "TaxCategoryDataRelationshipsAttachmentsDataType",
    "TaxCategoryDataRelationshipsSku",
    "TaxCategoryDataRelationshipsSkuData",
    "TaxCategoryDataRelationshipsSkuDataType",
    "TaxCategoryDataType",
    "TaxCategoryUpdate",
    "TaxCategoryUpdateData",
    "TaxCategoryUpdateDataAttributes",
    "TaxCategoryUpdateDataAttributesMetadata",
    "TaxCategoryUpdateDataRelationships",
    "TaxCategoryUpdateDataRelationshipsSku",
    "TaxCategoryUpdateDataRelationshipsSkuData",
    "TaxCategoryUpdateDataRelationshipsSkuDataType",
    "TaxCategoryUpdateDataType",
    "TaxjarAccount",
    "TaxjarAccountCreate",
    "TaxjarAccountCreateData",
    "TaxjarAccountCreateDataAttributes",
    "TaxjarAccountCreateDataAttributesMetadata",
    "TaxjarAccountCreateDataRelationships",
    "TaxjarAccountCreateDataRelationshipsTaxCategories",
    "TaxjarAccountCreateDataRelationshipsTaxCategoriesData",
    "TaxjarAccountCreateDataRelationshipsTaxCategoriesDataType",
    "TaxjarAccountCreateDataType",
    "TaxjarAccountData",
    "TaxjarAccountDataAttributes",
    "TaxjarAccountDataAttributesMetadata",
    "TaxjarAccountDataRelationships",
    "TaxjarAccountDataRelationshipsAttachments",
    "TaxjarAccountDataRelationshipsAttachmentsData",
    "TaxjarAccountDataRelationshipsAttachmentsDataType",
    "TaxjarAccountDataRelationshipsMarkets",
    "TaxjarAccountDataRelationshipsMarketsData",
    "TaxjarAccountDataRelationshipsMarketsDataType",
    "TaxjarAccountDataRelationshipsTaxCategories",
    "TaxjarAccountDataRelationshipsTaxCategoriesData",
    "TaxjarAccountDataRelationshipsTaxCategoriesDataType",
    "TaxjarAccountDataType",
    "TaxjarAccountUpdate",
    "TaxjarAccountUpdateData",
    "TaxjarAccountUpdateDataAttributes",
    "TaxjarAccountUpdateDataAttributesMetadata",
    "TaxjarAccountUpdateDataRelationships",
    "TaxjarAccountUpdateDataRelationshipsTaxCategories",
    "TaxjarAccountUpdateDataRelationshipsTaxCategoriesData",
    "TaxjarAccountUpdateDataRelationshipsTaxCategoriesDataType",
    "TaxjarAccountUpdateDataType",
    "TaxRule",
    "TaxRuleCreate",
    "TaxRuleCreateData",
    "TaxRuleCreateDataAttributes",
    "TaxRuleCreateDataAttributesMetadata",
    "TaxRuleCreateDataRelationships",
    "TaxRuleCreateDataRelationshipsManualTaxCalculator",
    "TaxRuleCreateDataRelationshipsManualTaxCalculatorData",
    "TaxRuleCreateDataRelationshipsManualTaxCalculatorDataType",
    "TaxRuleCreateDataType",
    "TaxRuleData",
    "TaxRuleDataAttributes",
    "TaxRuleDataAttributesBreakdown",
    "TaxRuleDataAttributesMetadata",
    "TaxRuleDataRelationships",
    "TaxRuleDataRelationshipsManualTaxCalculator",
    "TaxRuleDataRelationshipsManualTaxCalculatorData",
    "TaxRuleDataRelationshipsManualTaxCalculatorDataType",
    "TaxRuleDataType",
    "TaxRuleUpdate",
    "TaxRuleUpdateData",
    "TaxRuleUpdateDataAttributes",
    "TaxRuleUpdateDataAttributesMetadata",
    "TaxRuleUpdateDataRelationships",
    "TaxRuleUpdateDataRelationshipsManualTaxCalculator",
    "TaxRuleUpdateDataRelationshipsManualTaxCalculatorData",
    "TaxRuleUpdateDataRelationshipsManualTaxCalculatorDataType",
    "TaxRuleUpdateDataType",
    "Transaction",
    "TransactionData",
    "TransactionDataAttributes",
    "TransactionDataAttributesMetadata",
    "TransactionDataRelationships",
    "TransactionDataRelationshipsOrder",
    "TransactionDataRelationshipsOrderData",
    "TransactionDataRelationshipsOrderDataType",
    "TransactionDataType",
    "Void",
    "VoidData",
    "VoidDataAttributes",
    "VoidDataAttributesMetadata",
    "VoidDataRelationships",
    "VoidDataRelationshipsOrder",
    "VoidDataRelationshipsOrderData",
    "VoidDataRelationshipsOrderDataType",
    "VoidDataRelationshipsReferenceAuthorization",
    "VoidDataRelationshipsReferenceAuthorizationData",
    "VoidDataRelationshipsReferenceAuthorizationDataType",
    "VoidDataType",
    "Webhook",
    "WebhookCreate",
    "WebhookCreateData",
    "WebhookCreateDataAttributes",
    "WebhookCreateDataAttributesMetadata",
    "WebhookCreateDataRelationships",
    "WebhookCreateDataType",
    "WebhookData",
    "WebhookDataAttributes",
    "WebhookDataAttributesMetadata",
    "WebhookDataRelationships",
    "WebhookDataRelationshipsLastEventCallbacks",
    "WebhookDataRelationshipsLastEventCallbacksData",
    "WebhookDataRelationshipsLastEventCallbacksDataType",
    "WebhookDataType",
    "WebhookUpdate",
    "WebhookUpdateData",
    "WebhookUpdateDataAttributes",
    "WebhookUpdateDataAttributesMetadata",
    "WebhookUpdateDataRelationships",
    "WebhookUpdateDataType",
    "WireTransfer",
    "WireTransferCreate",
    "WireTransferCreateData",
    "WireTransferCreateDataAttributes",
    "WireTransferCreateDataAttributesMetadata",
    "WireTransferCreateDataRelationships",
    "WireTransferCreateDataRelationshipsOrder",
    "WireTransferCreateDataRelationshipsOrderData",
    "WireTransferCreateDataRelationshipsOrderDataType",
    "WireTransferCreateDataType",
    "WireTransferData",
    "WireTransferDataAttributes",
    "WireTransferDataAttributesMetadata",
    "WireTransferDataRelationships",
    "WireTransferDataRelationshipsOrder",
    "WireTransferDataRelationshipsOrderData",
    "WireTransferDataRelationshipsOrderDataType",
    "WireTransferDataType",
    "WireTransferUpdate",
    "WireTransferUpdateData",
    "WireTransferUpdateDataAttributes",
    "WireTransferUpdateDataAttributesMetadata",
    "WireTransferUpdateDataRelationships",
    "WireTransferUpdateDataRelationshipsOrder",
    "WireTransferUpdateDataRelationshipsOrderData",
    "WireTransferUpdateDataRelationshipsOrderDataType",
    "WireTransferUpdateDataType",
)
